var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var exclusion;
(function (exclusion) {
    var AttachableAttribute = (function (_super) {
        __extends(AttachableAttribute, _super);
        function AttachableAttribute() {
            _super.call(this);
        }
        return AttachableAttribute;
    }(Attribute));
    var EwsEnumAttribute = (function (_super) {
        __extends(EwsEnumAttribute, _super);
        function EwsEnumAttribute(schemaName) {
            _super.call(this);
            this.schemaName = null;
            this.schemaName = schemaName;
        }
        Object.defineProperty(EwsEnumAttribute.prototype, "SchemaName", {
            get: function () {
                return this.schemaName;
            },
            enumerable: true,
            configurable: true
        });
        return EwsEnumAttribute;
    }(Attribute));
    var RequiredServerVersionAttribute = (function (_super) {
        __extends(RequiredServerVersionAttribute, _super);
        function RequiredServerVersionAttribute(version) {
            _super.call(this);
            this.version = 0;
            this.version = version;
        }
        Object.defineProperty(RequiredServerVersionAttribute.prototype, "Version", {
            get: function () {
                return this.version;
            },
            enumerable: true,
            configurable: true
        });
        return RequiredServerVersionAttribute;
    }(Attribute));
    var SchemaAttribute = (function (_super) {
        __extends(SchemaAttribute, _super);
        function SchemaAttribute() {
            _super.call(this);
        }
        return SchemaAttribute;
    }(Attribute));
    var ServiceObjectDefinitionAttribute = (function (_super) {
        __extends(ServiceObjectDefinitionAttribute, _super);
        function ServiceObjectDefinitionAttribute(xmlElementName) {
            _super.call(this);
            this.xmlElementName = null;
            this.returnedByServer = false;
            this.xmlElementName = xmlElementName;
            this.returnedByServer = true;
        }
        Object.defineProperty(ServiceObjectDefinitionAttribute.prototype, "XmlElementName", {
            get: function () {
                return this.xmlElementName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectDefinitionAttribute.prototype, "ReturnedByServer", {
            get: function () {
                return this.returnedByServer;
            },
            set: function (value) {
                this.returnedByServer = value;
            },
            enumerable: true,
            configurable: true
        });
        return ServiceObjectDefinitionAttribute;
    }(Attribute));
    var ExchangeServiceBase = (function () {
        function ExchangeServiceBase(timeZoneOrRequestedServerVersionOrService, timeZoneOrRequestedServerVersion) {
            this.requestedServerVersion = ExchangeVersion.Exchange2013_SP1;
            this.credentials = null;
            this.useDefaultCredentials = false;
            this.timeout = 100000;
            this.traceEnabled = false;
            this.sendClientLatencies = true;
            this.traceFlags = TraceFlags.All;
            this.traceListener = new EwsTraceListener();
            this.preAuthenticate = false;
            this.userAgent = ExchangeServiceBase.defaultUserAgent;
            this.acceptGzipEncoding = true;
            this.keepAlive = true;
            this.connectionGroupName = null;
            this.clientRequestId = null;
            this.returnClientRequestId = false;
            this.cookieContainer = new CookieContainer();
            this.timeZone = null;
            this.timeZoneDefinition = null;
            this.serverInfo = null;
            this.webProxy = null;
            this.httpHeaders = new Dictionary();
            this.httpResponseHeaders = new Dictionary();
            this.ewsHttpWebRequestFactory = new EwsHttpWebRequestFactory();
            this.OnResponseHeadersCaptured = new NEvent();
            this.OnSerializeCustomSoapHeaders = new NEvent();
            this.SuppressXmlVersionHeader = false;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (timeZoneOrRequestedServerVersionOrService === null || timeZoneOrRequestedServerVersionOrService instanceof TimeZoneInfo)) {
                this.constructor_1(timeZoneOrRequestedServerVersionOrService);
                return;
            }
            if (arguments.length === 1 && (timeZoneOrRequestedServerVersionOrService === null || timeZoneOrRequestedServerVersionOrService.constructor === Number)) {
                this.constructor_2(timeZoneOrRequestedServerVersionOrService);
                return;
            }
            if (arguments.length === 2 && (timeZoneOrRequestedServerVersionOrService === null || timeZoneOrRequestedServerVersionOrService.constructor === Number) && (timeZoneOrRequestedServerVersion === null || timeZoneOrRequestedServerVersion instanceof TimeZoneInfo)) {
                this.constructor_3(timeZoneOrRequestedServerVersionOrService, timeZoneOrRequestedServerVersion);
                return;
            }
            if (arguments.length === 2 && (timeZoneOrRequestedServerVersionOrService === null || timeZoneOrRequestedServerVersionOrService instanceof ExchangeServiceBase) && (timeZoneOrRequestedServerVersion === null || timeZoneOrRequestedServerVersion.constructor === Number)) {
                this.constructor_4(timeZoneOrRequestedServerVersionOrService, timeZoneOrRequestedServerVersion);
                return;
            }
            this.constructor_5(timeZoneOrRequestedServerVersionOrService);
        }
        Object.defineProperty(ExchangeServiceBase.prototype, "CookieContainer", {
            get: function () {
                return this.cookieContainer;
            },
            set: function (value) {
                this.cookieContainer = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "TimeZone", {
            get: function () {
                return this.timeZone;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "TimeZoneDefinition", {
            get: function () {
                if (this.timeZoneDefinition === null) {
                    this.timeZoneDefinition = new TimeZoneDefinition(this.TimeZone);
                }
                return this.timeZoneDefinition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "SendClientLatencies", {
            get: function () {
                return this.sendClientLatencies;
            },
            set: function (value) {
                this.sendClientLatencies = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "TraceEnabled", {
            get: function () {
                return this.traceEnabled;
            },
            set: function (value) {
                this.traceEnabled = value;
                if (this.traceEnabled && this.traceListener === null) {
                    this.traceListener = new EwsTraceListener();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "TraceFlags", {
            get: function () {
                return this.traceFlags;
            },
            set: function (value) {
                this.traceFlags = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "TraceListener", {
            get: function () {
                return this.traceListener;
            },
            set: function (value) {
                this.traceListener = value;
                this.traceEnabled = (value !== null);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "Credentials", {
            get: function () {
                return this.credentials;
            },
            set: function (value) {
                this.credentials = value;
                this.useDefaultCredentials = false;
                this.cookieContainer = new CookieContainer();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "UseDefaultCredentials", {
            get: function () {
                return this.useDefaultCredentials;
            },
            set: function (value) {
                this.useDefaultCredentials = value;
                if (value) {
                    this.credentials = null;
                    this.cookieContainer = new CookieContainer();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "Timeout", {
            get: function () {
                return this.timeout;
            },
            set: function (value) {
                if (value < 1) {
                    throw new ArgumentException(Strings.TimeoutMustBeGreaterThanZero);
                }
                this.timeout = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "PreAuthenticate", {
            get: function () {
                return this.preAuthenticate;
            },
            set: function (value) {
                this.preAuthenticate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "AcceptGzipEncoding", {
            get: function () {
                return this.acceptGzipEncoding;
            },
            set: function (value) {
                this.acceptGzipEncoding = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "RequestedServerVersion", {
            get: function () {
                return this.requestedServerVersion;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "UserAgent", {
            get: function () {
                return this.userAgent;
            },
            set: function (value) {
                this.userAgent = value + " (" + ExchangeServiceBase.defaultUserAgent + ")";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "ServerInfo", {
            get: function () {
                return this.serverInfo;
            },
            set: function (value) {
                this.serverInfo = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "WebProxy", {
            get: function () {
                return this.webProxy;
            },
            set: function (value) {
                this.webProxy = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "KeepAlive", {
            get: function () {
                return this.keepAlive;
            },
            set: function (value) {
                this.keepAlive = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "ConnectionGroupName", {
            get: function () {
                return this.connectionGroupName;
            },
            set: function (value) {
                this.connectionGroupName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "ClientRequestId", {
            get: function () {
                return this.clientRequestId;
            },
            set: function (value) {
                this.clientRequestId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "ReturnClientRequestId", {
            get: function () {
                return this.returnClientRequestId;
            },
            set: function (value) {
                this.returnClientRequestId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "HttpHeaders", {
            get: function () {
                return this.httpHeaders;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "HttpResponseHeaders", {
            get: function () {
                return this.httpResponseHeaders;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase, "SessionKey", {
            get: function () {
                var obj;
                Monitor.Enter(obj = ExchangeServiceBase.lockObj);
                var result;
                try {
                    if (ExchangeServiceBase.binarySecret === null) {
                        var randomNumberGenerator = RandomNumberGenerator.Create();
                        ExchangeServiceBase.binarySecret = new Array(32);
                        for (var _ai = 0; _ai < ExchangeServiceBase.binarySecret.length; ++_ai)
                            ExchangeServiceBase.binarySecret[_ai] = 0;
                        randomNumberGenerator.GetNonZeroBytes(ExchangeServiceBase.binarySecret);
                    }
                    result = ExchangeServiceBase.binarySecret;
                }
                finally {
                    Monitor.Exit(obj);
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServiceBase.prototype, "HttpWebRequestFactory", {
            get: function () {
                return this.ewsHttpWebRequestFactory;
            },
            set: function (value) {
                this.ewsHttpWebRequestFactory = ((value === null) ? new EwsHttpWebRequestFactory() : value);
            },
            enumerable: true,
            configurable: true
        });
        ExchangeServiceBase.prototype.DoOnSerializeCustomSoapHeaders = function (writer) {
            EwsUtilities.Assert(writer !== null, "ExchangeService.DoOnSerializeCustomSoapHeaders", "writer is null");
            if (this.OnSerializeCustomSoapHeaders !== null) {
                this.OnSerializeCustomSoapHeaders(writer);
            }
        };
        ExchangeServiceBase.prototype.PrepareHttpWebRequestForUrl = function (url, acceptGzipEncoding, allowAutoRedirect) {
            if (url.Scheme !== Uri.UriSchemeHttp && url.Scheme !== Uri.UriSchemeHttps) {
                throw new ServiceLocalException(NString.Format(Strings.UnsupportedWebProtocol, url.Scheme));
            }
            var request = this.HttpWebRequestFactory.CreateRequest(url);
            request.PreAuthenticate = this.PreAuthenticate;
            request.Timeout = this.Timeout;
            this.SetContentType(request);
            request.Method = "POST";
            request.UserAgent = this.UserAgent;
            request.AllowAutoRedirect = allowAutoRedirect;
            request.CookieContainer = this.CookieContainer;
            request.KeepAlive = this.keepAlive;
            request.ConnectionGroupName = this.connectionGroupName;
            if (acceptGzipEncoding) {
                request.Headers.Add(HttpRequestHeader.AcceptEncoding, "gzip,deflate");
            }
            if (!NString.IsNullOrEmpty(this.clientRequestId)) {
                request.Headers.Add("client-request-id", this.clientRequestId);
                if (this.returnClientRequestId) {
                    request.Headers.Add("return-client-request-id", "true");
                }
            }
            if (this.webProxy !== null) {
                request.Proxy = this.webProxy;
            }
            if (this.HttpHeaders.Count > 0) {
                EwsUtilities.ForEach(this.HttpHeaders, function (kv) {
                    request.Headers.Add(kv.Key, kv.Value);
                });
            }
            request.UseDefaultCredentials = this.UseDefaultCredentials;
            if (!request.UseDefaultCredentials) {
                var exchangeCredentials = this.Credentials;
                if (exchangeCredentials === null) {
                    throw new ServiceLocalException(Strings.CredentialsRequired);
                }
                exchangeCredentials.PreAuthenticate();
                exchangeCredentials.PrepareWebRequest(request);
            }
            this.httpResponseHeaders.Clear();
            return request;
        };
        ExchangeServiceBase.prototype.SetContentType = function (request) {
            request.ContentType = "text/xml; charset=utf-8";
            request.Accept = "text/xml";
        };
        ExchangeServiceBase.prototype.InternalProcessHttpErrorResponse = function (httpWebResponse, webException, responseHeadersTraceFlag, responseTraceFlag) {
            EwsUtilities.Assert(httpWebResponse.StatusCode !== HttpStatusCode.InternalServerError, "ExchangeServiceBase.InternalProcessHttpErrorResponse", "InternalProcessHttpErrorResponse does not handle 500 ISE errors, the caller is supposed to handle this.");
            this.ProcessHttpResponseHeaders(responseHeadersTraceFlag, httpWebResponse);
            if (httpWebResponse.StatusCode === 456) {
                var statusDescription = httpWebResponse.StatusDescription;
                var uri = null;
                if (Uri.IsWellFormedUriString(statusDescription, UriKind.Absolute)) {
                    uri = new Uri(statusDescription);
                }
                this.TraceMessage(responseTraceFlag, NString.Format("Account is locked. Unlock URL is {0}", uri));
                throw new AccountIsLockedException(NString.Format(Strings.AccountIsLocked, uri), uri, webException);
            }
        };
        ExchangeServiceBase.prototype.ProcessHttpErrorResponse = function (httpWebResponse, webException) {
            throw new NotSupportedException();
        };
        ExchangeServiceBase.prototype.IsTraceEnabledFor = function (traceFlags) {
            return this.TraceEnabled && (this.TraceFlags & traceFlags) !== TraceFlags.None;
        };
        ExchangeServiceBase.prototype.TraceMessage = function (traceType, logEntry) {
            if (this.IsTraceEnabledFor(traceType)) {
                var text = TraceFlags[traceType];
                var traceMessage = EwsUtilities.FormatLogMessage(text, logEntry);
                this.TraceListener.Trace(text, traceMessage);
            }
        };
        ExchangeServiceBase.prototype.TraceXml = function (traceType, stream) {
            if (this.IsTraceEnabledFor(traceType)) {
                var text = TraceFlags[traceType];
                var traceMessage = EwsUtilities.FormatLogMessageWithXmlContent(text, stream);
                this.TraceListener.Trace(text, traceMessage);
            }
        };
        ExchangeServiceBase.prototype.TraceHttpRequestHeaders = function (traceType, request) {
            if (this.IsTraceEnabledFor(traceType)) {
                var text = TraceFlags[traceType];
                var logEntry = EwsUtilities.FormatHttpRequestHeaders(request);
                var traceMessage = EwsUtilities.FormatLogMessage(text, logEntry);
                this.TraceListener.Trace(text, traceMessage);
            }
        };
        ExchangeServiceBase.prototype.ProcessHttpResponseHeaders = function (traceType, response) {
            this.TraceHttpResponseHeaders(traceType, response);
            this.SaveHttpResponseHeaders(response.Headers);
        };
        ExchangeServiceBase.prototype.TraceHttpResponseHeaders = function (traceType, response) {
            if (this.IsTraceEnabledFor(traceType)) {
                var text = TraceFlags[traceType];
                var logEntry = EwsUtilities.FormatHttpResponseHeaders(response);
                var traceMessage = EwsUtilities.FormatLogMessage(text, logEntry);
                this.TraceListener.Trace(text, traceMessage);
            }
        };
        ExchangeServiceBase.prototype.SaveHttpResponseHeaders = function (headers) {
            EwsUtilities.Assert(this.httpResponseHeaders.Count === 0, "ExchangeServiceBase.SaveHttpResponseHeaders", "expect no headers in the dictionary yet.");
            this.httpResponseHeaders.Clear();
            var allKeys = headers.AllKeys;
            for (var i = 0; i < allKeys.length; i = i + 1) {
                var text = allKeys[i];
                this.httpResponseHeaders.Add(text, headers.get_Item(text));
            }
            if (this.OnResponseHeadersCaptured !== null) {
                this.OnResponseHeadersCaptured(headers);
            }
        };
        ExchangeServiceBase.prototype.ConvertUniversalDateTimeStringToLocalDateTime = function (value) {
            if (NString.IsNullOrEmpty(value)) {
                return null;
            }
            var dateTime = DateTime.Parse(value, CultureInfo.InvariantCulture, DateTimeStyles.AdjustToUniversal | DateTimeStyles.AssumeUniversal);
            if (this.TimeZone === TimeZoneInfo.Utc) {
                return new Nullable(dateTime);
            }
            var value2 = EwsUtilities.ConvertTime(dateTime, TimeZoneInfo.Utc, this.TimeZone);
            if (EwsUtilities.IsLocalTimeZone(this.TimeZone)) {
                return new Nullable(new DateTime(value2.Ticks, DateTimeKind.Local));
            }
            return new Nullable(value2);
        };
        ExchangeServiceBase.prototype.ConvertStartDateToUnspecifiedDateTime = function (value) {
            if (NString.IsNullOrEmpty(value)) {
                return null;
            }
            return new Nullable(DateTimeOffset.Parse(value, CultureInfo.InvariantCulture).Date);
        };
        ExchangeServiceBase.prototype.ConvertDateTimeToUniversalDateTimeString = function (value) {
            var IL_45 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        var dateTime;
                        switch (value.Kind) {
                            case DateTimeKind.Unspecified:
                                dateTime = EwsUtilities.ConvertTime(value, this.TimeZone, TimeZoneInfo.Utc);
                                _goto = IL_45;
                                continue _GOTO_LOOP;
                            case DateTimeKind.Local:
                                dateTime = EwsUtilities.ConvertTime(value, TimeZoneInfo.Local, TimeZoneInfo.Utc);
                                _goto = IL_45;
                                continue _GOTO_LOOP;
                        }
                        dateTime = value;
                        _goto = IL_45;
                        continue _GOTO_LOOP;
                    case 1:
                        return dateTime.ToString("yyyy-MM-ddTHH:mm:ss.fffZ", CultureInfo.InvariantCulture);
                }
            }
        };
        ExchangeServiceBase.prototype.SetCustomUserAgent = function (userAgent) {
            this.userAgent = userAgent;
        };
        ExchangeServiceBase.prototype.constructor_0 = function () {
            this.constructor_1(TimeZoneInfo.Local);
        };
        ExchangeServiceBase.prototype.constructor_1 = function (timeZone) {
            this.timeZone = timeZone;
            this.UseDefaultCredentials = true;
        };
        ExchangeServiceBase.prototype.constructor_2 = function (requestedServerVersion) {
            this.constructor_3(requestedServerVersion, TimeZoneInfo.Local);
        };
        ExchangeServiceBase.prototype.constructor_3 = function (requestedServerVersion, timeZone) {
            this.constructor_1(timeZone);
            this.requestedServerVersion = requestedServerVersion;
        };
        ExchangeServiceBase.prototype.constructor_4 = function (service, requestedServerVersion) {
            this.constructor_2(requestedServerVersion);
            this.useDefaultCredentials = service.useDefaultCredentials;
            this.credentials = service.credentials;
            this.traceEnabled = service.traceEnabled;
            this.traceListener = service.traceListener;
            this.traceFlags = service.traceFlags;
            this.timeout = service.timeout;
            this.preAuthenticate = service.preAuthenticate;
            this.userAgent = service.userAgent;
            this.acceptGzipEncoding = service.acceptGzipEncoding;
            this.keepAlive = service.keepAlive;
            this.connectionGroupName = service.connectionGroupName;
            this.timeZone = service.timeZone;
            this.httpHeaders = service.httpHeaders;
            this.ewsHttpWebRequestFactory = service.ewsHttpWebRequestFactory;
        };
        ExchangeServiceBase.prototype.constructor_5 = function (service) {
            this.constructor_4(service, service.RequestedServerVersion);
        };
        ExchangeServiceBase.prototype.Validate = function () {
        };
        ExchangeServiceBase.AccountIsLocked = 456;
        ExchangeServiceBase.lockObj = new any();
        ExchangeServiceBase.binarySecret = null;
        ExchangeServiceBase.defaultUserAgent = "ExchangeServicesClient/" + EwsUtilities.BuildVersion;
        return ExchangeServiceBase;
    }());
    var ComplexProperty = (function () {
        function ComplexProperty() {
            this.xmlNamespace = XmlNamespace.Types;
            this.OnChange = new NEvent();
            _super.call(this);
        }
        Object.defineProperty(ComplexProperty.prototype, "Namespace", {
            get: function () {
                return this.xmlNamespace;
            },
            set: function (value) {
                this.xmlNamespace = value;
            },
            enumerable: true,
            configurable: true
        });
        ComplexProperty.prototype.Changed = function () {
            if (this.OnChange !== null) {
                this.OnChange(this);
            }
        };
        ComplexProperty.prototype.SetFieldValue = function (field, value) {
            var flag;
            if (field[0] === null) {
                flag = (value !== null);
            }
            else {
                flag = (!(field[0] instanceof IComparable) || (((field[0] instanceof IComparable) ? field[0] : null)).CompareTo(value) !== 0);
            }
            if (flag) {
                field[0] = value;
                this.Changed();
            }
        };
        ComplexProperty.prototype.ClearChangeLog = function () {
        };
        ComplexProperty.prototype.ReadAttributesFromXml = function (reader) {
        };
        ComplexProperty.prototype.ReadTextValueFromXml = function (reader) {
        };
        ComplexProperty.prototype.TryReadElementFromXml = function (reader) {
            return false;
        };
        ComplexProperty.prototype.TryReadElementFromXmlToPatch = function (reader) {
            return false;
        };
        ComplexProperty.prototype.WriteAttributesToXml = function (writer) {
        };
        ComplexProperty.prototype.WriteElementsToXml = function (writer) {
        };
        ComplexProperty.prototype.LoadFromXml = function (reader, xmlNamespaceOrXmlElementName, xmlElementName) {
            if (arguments.length === 3 && (reader === null || reader instanceof EwsServiceXmlReader) && (xmlNamespaceOrXmlElementName === null || xmlNamespaceOrXmlElementName.constructor === Number) && (xmlElementName === null || xmlElementName.constructor === String)) {
                this.LoadFromXml_0(reader, xmlNamespaceOrXmlElementName, xmlElementName);
                return;
            }
            this.LoadFromXml_1(reader, xmlNamespaceOrXmlElementName);
        };
        ComplexProperty.prototype.LoadFromXml_0 = function (reader, xmlNamespace, xmlElementName) {
            this.InternalLoadFromXml(reader, xmlNamespace, xmlElementName, this.TryReadElementFromXml);
        };
        ComplexProperty.prototype.UpdateFromXml = function (reader, xmlNamespaceOrXmlElementName, xmlElementName) {
            if (arguments.length === 3 && (reader === null || reader instanceof EwsServiceXmlReader) && (xmlNamespaceOrXmlElementName === null || xmlNamespaceOrXmlElementName.constructor === Number) && (xmlElementName === null || xmlElementName.constructor === String)) {
                this.UpdateFromXml_0(reader, xmlNamespaceOrXmlElementName, xmlElementName);
                return;
            }
            this.UpdateFromXml_1(reader, xmlNamespaceOrXmlElementName);
        };
        ComplexProperty.prototype.UpdateFromXml_0 = function (reader, xmlNamespace, xmlElementName) {
            this.InternalLoadFromXml(reader, xmlNamespace, xmlElementName, this.TryReadElementFromXmlToPatch);
        };
        ComplexProperty.prototype.InternalLoadFromXml = function (reader, xmlNamespace, xmlElementName, readAction) {
            reader.EnsureCurrentNodeIsStartElement(xmlNamespace, xmlElementName);
            this.ReadAttributesFromXml(reader);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    switch (reader.NodeType) {
                        case 1:
                            if (!readAction(reader)) {
                                reader.SkipCurrentElement();
                            }
                            break;
                        case 3:
                            this.ReadTextValueFromXml(reader);
                            break;
                    }
                } while (!reader.IsEndElement(xmlNamespace, xmlElementName));
            }
        };
        ComplexProperty.prototype.LoadFromXml_1 = function (reader, xmlElementName) {
            this.LoadFromXml(reader, this.Namespace, xmlElementName);
        };
        ComplexProperty.prototype.UpdateFromXml_1 = function (reader, xmlElementName) {
            this.UpdateFromXml(reader, this.Namespace, xmlElementName);
        };
        ComplexProperty.prototype.LoadFromJson = function (jsonProperty, service) {
            throw new NotImplementedException();
        };
        ComplexProperty.prototype.WriteToXml = function (writer, xmlNamespaceOrXmlElementName, xmlElementName) {
            if (arguments.length === 3 && (writer === null || writer instanceof EwsServiceXmlWriter) && (xmlNamespaceOrXmlElementName === null || xmlNamespaceOrXmlElementName.constructor === Number) && (xmlElementName === null || xmlElementName.constructor === String)) {
                this.WriteToXml_0(writer, xmlNamespaceOrXmlElementName, xmlElementName);
                return;
            }
            this.WriteToXml_1(writer, xmlNamespaceOrXmlElementName);
        };
        ComplexProperty.prototype.WriteToXml_0 = function (writer, xmlNamespace, xmlElementName) {
            writer.WriteStartElement(xmlNamespace, xmlElementName);
            this.WriteAttributesToXml(writer);
            this.WriteElementsToXml(writer);
            writer.WriteEndElement();
        };
        ComplexProperty.prototype.WriteToXml_1 = function (writer, xmlElementName) {
            this.WriteToXml(writer, this.Namespace, xmlElementName);
        };
        ComplexProperty.prototype.ToJson = function (service) {
            return this.InternalToJson(service);
        };
        ComplexProperty.prototype.InternalToJson = function (service) {
            throw new NotImplementedException();
        };
        ComplexProperty.prototype.Validate = function () {
            this.InternalValidate();
        };
        ComplexProperty.prototype.InternalValidate = function () {
        };
        return ComplexProperty;
    }());
    var ExtractedEntity = (function (_super) {
        __extends(ExtractedEntity, _super);
        function ExtractedEntity() {
            _super.call(this);
            this.Position = 0;
            this.Namespace = XmlNamespace.Types;
        }
        ExtractedEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Position") {
                var value = reader.ReadElementValue();
                if (!NString.IsNullOrEmpty(value)) {
                    this.Position = EwsUtilities.Parse(value);
                }
                return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return ExtractedEntity;
    }(ComplexProperty));
    var AddressEntity = (function (_super) {
        __extends(AddressEntity, _super);
        function AddressEntity() {
            _super.call(this);
            this.Address = null;
        }
        AddressEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Address") {
                this.Address = reader.ReadElementValue();
                return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return AddressEntity;
    }(ExtractedEntity));
    var ComplexPropertyCollection = (function (_super) {
        __extends(ComplexPropertyCollection, _super);
        function ComplexPropertyCollection() {
            _super.call(this);
            this.items = new List();
            this.addedItems = new List();
            this.modifiedItems = new List();
            this.removedItems = new List();
        }
        Object.defineProperty(ComplexPropertyCollection.prototype, "Items", {
            get: function () {
                return this.items;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComplexPropertyCollection.prototype, "AddedItems", {
            get: function () {
                return this.addedItems;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComplexPropertyCollection.prototype, "ModifiedItems", {
            get: function () {
                return this.modifiedItems;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComplexPropertyCollection.prototype, "RemovedItems", {
            get: function () {
                return this.removedItems;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComplexPropertyCollection.prototype, "Count", {
            get: function () {
                return this.items.Count;
            },
            enumerable: true,
            configurable: true
        });
        ComplexPropertyCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.items.get_Item(index);
        };
        ComplexPropertyCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            throw new NotSupportedException();
        };
        ComplexPropertyCollection.prototype.CreateDefaultComplexProperty = function () {
            throw new NotSupportedException();
        };
        ComplexPropertyCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            throw new NotSupportedException();
        };
        ComplexPropertyCollection.prototype.ItemChanged = function (complexProperty) {
            var tComplexProperty = ((complexProperty instanceof TComplexProperty) ? complexProperty : null);
            EwsUtilities.Assert(tComplexProperty !== null, "ComplexPropertyCollection.ItemChanged", NString.Format("ComplexPropertyCollection.ItemChanged: the type of the complexProperty argument ({0}) is not supported.", complexProperty.GetType().Name));
            if (!this.addedItems.Contains(tComplexProperty) && !this.modifiedItems.Contains(tComplexProperty)) {
                this.modifiedItems.Add(tComplexProperty);
                this.Changed();
            }
        };
        ComplexPropertyCollection.prototype.LoadFromXml = function (reader, localElementNameOrXmlNamespace, localElementName) {
            if (arguments.length === 2 && (reader === null || reader instanceof EwsServiceXmlReader) && (localElementNameOrXmlNamespace === null || localElementNameOrXmlNamespace.constructor === String)) {
                this.LoadFromXml_0(reader, localElementNameOrXmlNamespace);
                return;
            }
            this.LoadFromXml_1(reader, localElementNameOrXmlNamespace, localElementName);
        };
        ComplexPropertyCollection.prototype.LoadFromXml_0 = function (reader, localElementName) {
            this.LoadFromXml(reader, XmlNamespace.Types, localElementName);
        };
        ComplexPropertyCollection.prototype.LoadFromXml_1 = function (reader, xmlNamespace, localElementName) {
            reader.EnsureCurrentNodeIsStartElement(xmlNamespace, localElementName);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        var tComplexProperty = this.CreateComplexProperty(reader.LocalName);
                        if (tComplexProperty !== null) {
                            tComplexProperty.LoadFromXml(reader, reader.LocalName);
                            this.InternalAdd(tComplexProperty, true);
                        }
                        else {
                            reader.SkipCurrentElement();
                        }
                    }
                } while (!reader.IsEndElement(xmlNamespace, localElementName));
            }
        };
        ComplexPropertyCollection.prototype.UpdateFromXml = function (reader, xmlNamespace, xmlElementName) {
            reader.EnsureCurrentNodeIsStartElement(xmlNamespace, xmlElementName);
            if (!reader.IsEmptyElement) {
                var num = 0;
                while (true) {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        var tComplexProperty = this.CreateComplexProperty(reader.LocalName);
                        var tComplexProperty2 = this.get_Item(num++);
                        if (tComplexProperty === null || !tComplexProperty.GetType().IsInstanceOfType(tComplexProperty2)) {
                            break;
                        }
                        tComplexProperty2.UpdateFromXml(reader, xmlNamespace, reader.LocalName);
                    }
                    if (reader.IsEndElement(xmlNamespace, xmlElementName)) {
                        return;
                    }
                }
                throw new ServiceLocalException(Strings.PropertyTypeIncompatibleWhenUpdatingCollection);
            }
        };
        ComplexPropertyCollection.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject !== null) {
                    var tComplexProperty = null;
                    if (jsonObject.HasTypeProperty()) {
                        tComplexProperty = this.CreateComplexProperty(jsonObject.ReadTypeString());
                    }
                    else {
                        tComplexProperty = this.CreateDefaultComplexProperty();
                    }
                    if (tComplexProperty !== null) {
                        tComplexProperty.LoadFromJson(jsonObject, service);
                        this.InternalAdd(tComplexProperty, true);
                    }
                }
            }
        };
        ComplexPropertyCollection.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            if (this.Count !== jsonCollection.length) {
                throw new ServiceLocalException(Strings.PropertyCollectionSizeMismatch);
            }
            var num = 0;
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject === null) {
                    throw new ServiceLocalException();
                }
                var tComplexProperty = null;
                if (jsonObject.HasTypeProperty()) {
                    tComplexProperty = this.CreateComplexProperty(jsonObject.ReadTypeString());
                }
                else {
                    tComplexProperty = this.CreateDefaultComplexProperty();
                }
                var tComplexProperty2 = this.get_Item(num++);
                if (tComplexProperty === null || !tComplexProperty.GetType().IsInstanceOfType(tComplexProperty2)) {
                    throw new ServiceLocalException(Strings.PropertyTypeIncompatibleWhenUpdatingCollection);
                }
                tComplexProperty2.LoadFromJson(jsonObject, service);
            }
        };
        ComplexPropertyCollection.prototype.WriteToXml = function (writer, xmlNamespace, xmlElementName) {
            if (this.ShouldWriteToRequest()) {
                _super.prototype.WriteToXml.call(this, writer, xmlNamespace, xmlElementName);
            }
        };
        ComplexPropertyCollection.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = this.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return list.ToArray();
        };
        ComplexPropertyCollection.prototype.ShouldWriteToRequest = function () {
            return this.Count > 0;
        };
        ComplexPropertyCollection.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, this.GetCollectionItemXmlElementName(current));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        ComplexPropertyCollection.prototype.ClearChangeLog = function () {
            this.removedItems.Clear();
            this.addedItems.Clear();
            this.modifiedItems.Clear();
        };
        ComplexPropertyCollection.prototype.RemoveFromChangeLog = function (complexProperty) {
            this.removedItems.Remove(complexProperty);
            this.modifiedItems.Remove(complexProperty);
            this.addedItems.Remove(complexProperty);
        };
        ComplexPropertyCollection.prototype.InternalAdd = function (complexProperty, loading) {
            if (arguments.length === 1 && (complexProperty === null || complexProperty instanceof TComplexProperty)) {
                this.InternalAdd_0(complexProperty);
                return;
            }
            this.InternalAdd_1(complexProperty, loading);
        };
        ComplexPropertyCollection.prototype.InternalAdd_0 = function (complexProperty) {
            this.InternalAdd(complexProperty, false);
        };
        ComplexPropertyCollection.prototype.InternalAdd_1 = function (complexProperty, loading) {
            EwsUtilities.Assert(complexProperty !== null, "ComplexPropertyCollection.InternalAdd", "complexProperty is null");
            if (!this.items.Contains(complexProperty)) {
                this.items.Add(complexProperty);
                if (!loading) {
                    this.removedItems.Remove(complexProperty);
                    this.addedItems.Add(complexProperty);
                }
                complexProperty.OnChange.Add(this.ItemChanged);
                this.Changed();
            }
        };
        ComplexPropertyCollection.prototype.InternalClear = function () {
            while (this.Count > 0) {
                this.InternalRemoveAt(0);
            }
        };
        ComplexPropertyCollection.prototype.InternalRemoveAt = function (index) {
            EwsUtilities.Assert(index >= 0 && index < this.Count, "ComplexPropertyCollection.InternalRemoveAt", "index is out of range.");
            this.InternalRemove(this.items.get_Item(index));
        };
        ComplexPropertyCollection.prototype.InternalRemove = function (complexProperty) {
            EwsUtilities.Assert(complexProperty !== null, "ComplexPropertyCollection.InternalRemove", "complexProperty is null");
            if (this.items.Remove(complexProperty)) {
                complexProperty.OnChange.Remove(this.ItemChanged);
                if (!this.addedItems.Contains(complexProperty)) {
                    this.removedItems.Add(complexProperty);
                }
                else {
                    this.addedItems.Remove(complexProperty);
                }
                this.modifiedItems.Remove(complexProperty);
                this.Changed();
                return true;
            }
            return false;
        };
        ComplexPropertyCollection.prototype.Contains = function (complexProperty) {
            return this.items.Contains(complexProperty);
        };
        ComplexPropertyCollection.prototype.IndexOf = function (complexProperty) {
            return this.items.IndexOf(complexProperty);
        };
        ComplexPropertyCollection.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        ComplexPropertyCollection.prototype.WriteSetUpdateToXml = function (writer, ewsObject, propertyDefinition) {
            if (this.Count === 0) {
                writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
                propertyDefinition.WriteToXml(writer);
                writer.WriteEndElement();
                return true;
            }
            return false;
        };
        ComplexPropertyCollection.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            return false;
        };
        ComplexPropertyCollection.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            if (this.Count === 0) {
                var jsonObject = new JsonObject();
                jsonObject.AddTypeParameter(ewsObject.GetDeleteFieldXmlElementName());
                jsonObject.Add("Path", propertyDefinition.ToJson(service));
                return true;
            }
            return false;
        };
        ComplexPropertyCollection.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            return false;
        };
        return ComplexPropertyCollection;
    }(ComplexProperty));
    var AddressEntityCollection = (function (_super) {
        __extends(AddressEntityCollection, _super);
        function AddressEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        AddressEntityCollection.prototype.constructor_0 = function () {
        };
        AddressEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        AddressEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new AddressEntity();
        };
        AddressEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new AddressEntity();
        };
        AddressEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Address";
        };
        return AddressEntityCollection;
    }(ComplexPropertyCollection));
    var ServiceId = (function (_super) {
        __extends(ServiceId, _super);
        function ServiceId(uniqueId) {
            _super.call(this);
            this.changeKey = null;
            this.uniqueId = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(uniqueId);
        }
        Object.defineProperty(ServiceId.prototype, "IsValid", {
            get: function () {
                return !NString.IsNullOrEmpty(this.uniqueId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceId.prototype, "UniqueId", {
            get: function () {
                return this.uniqueId;
            },
            set: function (value) {
                this.uniqueId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceId.prototype, "ChangeKey", {
            get: function () {
                return this.changeKey;
            },
            set: function (value) {
                this.changeKey = value;
            },
            enumerable: true,
            configurable: true
        });
        ServiceId.prototype.constructor_0 = function () {
        };
        ServiceId.prototype.constructor_1 = function (uniqueId) {
            this.constructor_0();
            EwsUtilities.ValidateParam(uniqueId, "uniqueId");
            this.uniqueId = uniqueId;
        };
        ServiceId.prototype.ReadAttributesFromXml = function (reader) {
            this.uniqueId = reader.ReadAttributeValue("Id");
            this.changeKey = reader.ReadAttributeValue("ChangeKey");
        };
        ServiceId.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Id")) {
                            if (a === "ChangeKey") {
                                this.changeKey = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.uniqueId = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        ServiceId.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Id", this.UniqueId);
            writer.WriteAttributeValue("ChangeKey", this.ChangeKey);
        };
        ServiceId.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetJsonTypeName());
            jsonObject.Add("Id", this.UniqueId);
            jsonObject.Add("ChangeKey", this.ChangeKey);
            return jsonObject;
        };
        ServiceId.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        ServiceId.prototype.GetJsonTypeName = function () {
            return this.GetXmlElementName();
        };
        ServiceId.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, this.GetXmlElementName());
        };
        ServiceId.prototype.Assign = function (source) {
            this.uniqueId = source.UniqueId;
            this.changeKey = source.ChangeKey;
        };
        ServiceId.prototype.SameIdAndChangeKey = function (other) {
            return NObject.GenericEquals(this, other) && ((this.ChangeKey === null && other.ChangeKey === null) || this.ChangeKey === other.ChangeKey);
        };
        ServiceId.prototype.Equals = function (obj) {
            if (NObject.ReferenceEquals(this, obj)) {
                return true;
            }
            var serviceId = ((obj instanceof ServiceId) ? obj : null);
            return serviceId !== null && this.IsValid && serviceId.IsValid && this.UniqueId === serviceId.UniqueId;
        };
        ServiceId.prototype.GetHashCode = function () {
            if (!this.IsValid) {
                return _super.prototype.GetHashCode.call(this);
            }
            return NString.GetHashCode(this.UniqueId);
        };
        ServiceId.prototype.ToString = function () {
            if (this.uniqueId !== null) {
                return this.uniqueId;
            }
            return NString.Empty;
        };
        return ServiceId;
    }(ComplexProperty));
    var ItemId = (function (_super) {
        __extends(ItemId, _super);
        function ItemId(uniqueId) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, uniqueId);
            this.constructor_1(uniqueId);
        }
        ItemId.prototype.constructor_0 = function () {
        };
        ItemId.op_Implicit = function (uniqueId) {
            return new ItemId(uniqueId);
        };
        ItemId.prototype.GetXmlElementName = function () {
            return "ItemId";
        };
        ItemId.prototype.constructor_1 = function (uniqueId) {
        };
        return ItemId;
    }(ServiceId));
    var AppointmentOccurrenceId = (function (_super) {
        __extends(AppointmentOccurrenceId, _super);
        function AppointmentOccurrenceId(recurringMasterUniqueId, occurrenceIndex) {
            _super.call(this, recurringMasterUniqueId);
            this.occurrenceIndex = 0;
            this.OccurrenceIndex = occurrenceIndex;
        }
        Object.defineProperty(AppointmentOccurrenceId.prototype, "OccurrenceIndex", {
            get: function () {
                return this.occurrenceIndex;
            },
            set: function (value) {
                if (value < 1) {
                    throw new ArgumentException(Strings.OccurrenceIndexMustBeGreaterThanZero);
                }
                this.occurrenceIndex = value;
            },
            enumerable: true,
            configurable: true
        });
        AppointmentOccurrenceId.prototype.GetXmlElementName = function () {
            return "OccurrenceItemId";
        };
        AppointmentOccurrenceId.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("RecurringMasterId", this.UniqueId);
            writer.WriteAttributeValue("InstanceIndex", this.OccurrenceIndex);
        };
        AppointmentOccurrenceId.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetXmlElementName());
            jsonObject.Add("RecurringMasterId", this.UniqueId);
            jsonObject.Add("InstanceIndex", this.OccurrenceIndex);
            return jsonObject;
        };
        return AppointmentOccurrenceId;
    }(ItemId));
    var ApprovalRequestData = (function (_super) {
        __extends(ApprovalRequestData, _super);
        function ApprovalRequestData() {
            _super.call(this);
            this.isUndecidedApprovalRequest = false;
            this.approvalDecision = 0;
            this.approvalDecisionMaker = null;
            this.approvalDecisionTime = null;
        }
        Object.defineProperty(ApprovalRequestData.prototype, "IsUndecidedApprovalRequest", {
            get: function () {
                return this.isUndecidedApprovalRequest;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApprovalRequestData.prototype, "ApprovalDecision", {
            get: function () {
                return this.approvalDecision;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApprovalRequestData.prototype, "ApprovalDecisionMaker", {
            get: function () {
                return this.approvalDecisionMaker;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApprovalRequestData.prototype, "ApprovalDecisionTime", {
            get: function () {
                return this.approvalDecisionTime;
            },
            enumerable: true,
            configurable: true
        });
        ApprovalRequestData.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "IsUndecidedApprovalRequest") {
                    this.isUndecidedApprovalRequest = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ApprovalDecision") {
                    this.approvalDecision = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ApprovalDecisionMaker") {
                    this.approvalDecisionMaker = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ApprovalDecisionTime") {
                    this.approvalDecisionTime = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
            }
            return false;
        };
        ApprovalRequestData.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "IsUndecidedApprovalRequest")) {
                            if (!(a === "ApprovalDecision")) {
                                if (!(a === "ApprovalDecisionMaker")) {
                                    if (a === "ApprovalDecisionTime") {
                                        this.approvalDecisionTime = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                                    }
                                }
                                else {
                                    this.approvalDecisionMaker = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.approvalDecision = jsonProperty.ReadAsInt(current);
                            }
                        }
                        else {
                            this.isUndecidedApprovalRequest = jsonProperty.ReadAsBool(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return ApprovalRequestData;
    }(ComplexProperty));
    var RetentionTagBase = (function (_super) {
        __extends(RetentionTagBase, _super);
        function RetentionTagBase(xmlElementName) {
            _super.call(this);
            this.xmlElementName = null;
            this.isExplicit = false;
            this.retentionId = null;
            this.xmlElementName = xmlElementName;
        }
        Object.defineProperty(RetentionTagBase.prototype, "IsExplicit", {
            get: function () {
                return this.isExplicit;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isExplicit
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isExplicit = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RetentionTagBase.prototype, "RetentionId", {
            get: function () {
                return this.retentionId;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.retentionId
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.retentionId = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        RetentionTagBase.prototype.ReadAttributesFromXml = function (reader) {
            this.isExplicit = reader.ReadAttributeValue("IsExplicit");
        };
        RetentionTagBase.prototype.ReadTextValueFromXml = function (reader) {
            this.retentionId = new Guid(reader.ReadValue());
        };
        RetentionTagBase.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "IsExplicit")) {
                            if (a === "Value") {
                                this.retentionId = new Guid(jsonProperty.ReadAsString(current));
                            }
                        }
                        else {
                            this.isExplicit = jsonProperty.ReadAsBool(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        RetentionTagBase.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("IsExplicit", this.isExplicit);
        };
        RetentionTagBase.prototype.WriteElementsToXml = function (writer) {
            if (Guid.op_Inequality(this.retentionId, Guid.Empty)) {
                writer.WriteValue(this.retentionId.ToString(), this.xmlElementName);
            }
        };
        RetentionTagBase.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("IsExplicit", this.isExplicit);
            if (Guid.op_Inequality(this.retentionId, Guid.Empty)) {
                jsonObject.Add("Value", this.retentionId);
            }
            return jsonObject;
        };
        RetentionTagBase.prototype.ToString = function () {
            if (Guid.op_Equality(this.retentionId, Guid.Empty)) {
                return NString.Empty;
            }
            return this.retentionId.ToString();
        };
        return RetentionTagBase;
    }(ComplexProperty));
    var ArchiveTag = (function (_super) {
        __extends(ArchiveTag, _super);
        function ArchiveTag(isExplicit, retentionId) {
            if (arguments.length === 0) {
                _super.call(this, "ArchiveTag");
                this.constructor_0();
                return;
            }
            _super.call(this, "ArchiveTag");
            this.constructor_1(isExplicit, retentionId);
        }
        ArchiveTag.prototype.constructor_0 = function () {
        };
        ArchiveTag.prototype.constructor_1 = function (isExplicit, retentionId) {
            this.constructor_0();
            this.IsExplicit = isExplicit;
            this.RetentionId = retentionId;
        };
        return ArchiveTag;
    }(RetentionTagBase));
    var Attachment = (function (_super) {
        __extends(Attachment, _super);
        function Attachment(ownerOrService) {
            _super.call(this);
            this.owner = null;
            this.id = null;
            this.name = null;
            this.contentType = null;
            this.contentId = null;
            this.contentLocation = null;
            this.size = 0;
            this.lastModifiedTime = null;
            this.isInline = false;
            this.service = null;
            if (arguments.length === 1 && (ownerOrService === null || ownerOrService instanceof Item)) {
                this.constructor_0(ownerOrService);
                return;
            }
            this.constructor_1(ownerOrService);
        }
        Object.defineProperty(Attachment.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.name
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.name = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "ContentType", {
            get: function () {
                return this.contentType;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.contentType
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.contentType = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "ContentId", {
            get: function () {
                return this.contentId;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.contentId
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.contentId = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "ContentLocation", {
            get: function () {
                return this.contentLocation;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.contentLocation
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.contentLocation = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "Size", {
            get: function () {
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "Size");
                return this.size;
            },
            set: function (value) {
                var _this = this;
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "Size");
                (function () {
                    var _p0 = [
                        _this.size
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.size = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "LastModifiedTime", {
            get: function () {
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "LastModifiedTime");
                return this.lastModifiedTime;
            },
            set: function (value) {
                var _this = this;
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "LastModifiedTime");
                (function () {
                    var _p0 = [
                        _this.lastModifiedTime
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.lastModifiedTime = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "IsInline", {
            get: function () {
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "IsInline");
                return this.isInline;
            },
            set: function (value) {
                var _this = this;
                EwsUtilities.ValidatePropertyVersion(this.service, ExchangeVersion.Exchange2010, "IsInline");
                (function () {
                    var _p0 = [
                        _this.isInline
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isInline = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "IsNew", {
            get: function () {
                return NString.IsNullOrEmpty(this.Id);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "Owner", {
            get: function () {
                return this.owner;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attachment.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        Attachment.prototype.constructor_0 = function (owner) {
            this.owner = owner;
            if (owner !== null) {
                this.service = this.owner.Service;
            }
        };
        Attachment.prototype.constructor_1 = function (service) {
            this.service = service;
        };
        Attachment.prototype.ThrowIfThisIsNotNew = function () {
            if (!this.IsNew) {
                throw new InvalidOperationException(Strings.AttachmentCannotBeUpdated);
            }
        };
        Attachment.prototype.SetFieldValue = function (field, value) {
            var _this = this;
            this.ThrowIfThisIsNotNew();
            (function () {
                var _p0 = [
                    field[0]
                ];
                var _r = _super.prototype.SetFieldValue.call(_this, _p0, value);
                field[0] = _p0[0];
                return _r;
            })();
        };
        Attachment.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        Attachment.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "AttachmentId":
                    this.id = reader.ReadAttributeValue("Id");
                    if (this.Owner !== null) {
                        var text = reader.ReadAttributeValue("RootItemChangeKey");
                        if (!NString.IsNullOrEmpty(text)) {
                            this.Owner.RootItemId.ChangeKey = text;
                        }
                    }
                    reader.ReadEndElementIfNecessary(XmlNamespace.Types, "AttachmentId");
                    return true;
                case "Name":
                    this.name = reader.ReadElementValue();
                    return true;
                case "ContentType":
                    this.contentType = reader.ReadElementValue();
                    return true;
                case "ContentId":
                    this.contentId = reader.ReadElementValue();
                    return true;
                case "ContentLocation":
                    this.contentLocation = reader.ReadElementValue();
                    return true;
                case "Size":
                    this.size = reader.ReadElementValue();
                    return true;
                case "LastModifiedTime":
                    this.lastModifiedTime = reader.ReadElementValueAsDateTime().Value;
                    return true;
                case "IsInline":
                    this.isInline = reader.ReadElementValue();
                    return true;
            }
            return false;
        };
        Attachment.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "AttachmentId":
                            this.LoadAttachmentIdFromJson(jsonProperty.ReadAsJsonObject(current));
                            break;
                        case "Name":
                            this.name = jsonProperty.ReadAsString(current);
                            break;
                        case "ContentType":
                            this.contentType = jsonProperty.ReadAsString(current);
                            break;
                        case "ContentId":
                            this.contentId = jsonProperty.ReadAsString(current);
                            break;
                        case "ContentLocation":
                            this.contentLocation = jsonProperty.ReadAsString(current);
                            break;
                        case "Size":
                            this.size = jsonProperty.ReadAsInt(current);
                            break;
                        case "LastModifiedTime":
                            this.lastModifiedTime = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                            break;
                        case "IsInline":
                            this.isInline = jsonProperty.ReadAsBool(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Attachment.prototype.LoadAttachmentIdFromJson = function (jsonObject) {
            this.id = jsonObject.ReadAsString("Id");
            if (this.Owner !== null && jsonObject.ContainsKey("RootItemChangeKey")) {
                var text = jsonObject.ReadAsString("RootItemChangeKey");
                if (!NString.IsNullOrEmpty(text)) {
                    this.Owner.RootItemId.ChangeKey = text;
                }
            }
        };
        Attachment.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Name", this.Name);
            writer.WriteElementValue(XmlNamespace.Types, "ContentType", this.ContentType);
            writer.WriteElementValue(XmlNamespace.Types, "ContentId", this.ContentId);
            writer.WriteElementValue(XmlNamespace.Types, "ContentLocation", this.ContentLocation);
            if (writer.Service.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                writer.WriteElementValue(XmlNamespace.Types, "IsInline", this.IsInline);
            }
        };
        Attachment.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetXmlElementName());
            jsonObject.Add("Name", this.Name);
            jsonObject.Add("ContentType", this.ContentType);
            jsonObject.Add("ContentId", this.ContentId);
            jsonObject.Add("ContentLocation", this.ContentLocation);
            if (service.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                jsonObject.Add("IsInline", this.IsInline);
            }
            return jsonObject;
        };
        Attachment.prototype.InternalLoad = function (bodyType, additionalProperties) {
            this.service.GetAttachment(this, bodyType, additionalProperties);
        };
        Attachment.prototype.Validate = function (attachmentIndex) {
        };
        Attachment.prototype.Load = function () {
            this.InternalLoad(null, null);
        };
        return Attachment;
    }(ComplexProperty));
    var AttachmentCollection = (function (_super) {
        __extends(AttachmentCollection, _super);
        function AttachmentCollection() {
            _super.call(this);
            this.owner = null;
        }
        Object.defineProperty(AttachmentCollection.prototype, "Owner", {
            get: function () {
                return this.owner;
            },
            set: function (value) {
                var item = ((value instanceof Item) ? value : null);
                EwsUtilities.Assert(item !== null, "AttachmentCollection.IOwnedProperty.set_Owner", "value is not a descendant of ItemBase");
                this.owner = item;
            },
            enumerable: true,
            configurable: true
        });
        AttachmentCollection.prototype.AddFileAttachment = function (fileNameOrName, fileNameOrContentStream) {
            if (arguments.length === 1 && (fileNameOrName === null || fileNameOrName.constructor === String)) {
                return this.AddFileAttachment_0(fileNameOrName);
            }
            if (arguments.length === 2 && (fileNameOrName === null || fileNameOrName.constructor === String) && (fileNameOrContentStream === null || fileNameOrContentStream.constructor === String)) {
                return this.AddFileAttachment_1(fileNameOrName, fileNameOrContentStream);
            }
            if (arguments.length === 2 && (fileNameOrName === null || fileNameOrName.constructor === String) && (fileNameOrContentStream === null || fileNameOrContentStream instanceof Stream)) {
                return this.AddFileAttachment_2(fileNameOrName, fileNameOrContentStream);
            }
            return this.AddFileAttachment_3(fileNameOrName, fileNameOrContentStream);
        };
        AttachmentCollection.prototype.AddFileAttachment_0 = function (fileName) {
            return this.AddFileAttachment(Path.GetFileName(fileName), fileName);
        };
        AttachmentCollection.prototype.AddFileAttachment_1 = function (name, fileName) {
            var fileAttachment = new FileAttachment(this.owner);
            fileAttachment.Name = name;
            fileAttachment.FileName = fileName;
            _super.prototype.InternalAdd.call(this, fileAttachment);
            return fileAttachment;
        };
        AttachmentCollection.prototype.AddFileAttachment_2 = function (name, contentStream) {
            var fileAttachment = new FileAttachment(this.owner);
            fileAttachment.Name = name;
            fileAttachment.ContentStream = contentStream;
            _super.prototype.InternalAdd.call(this, fileAttachment);
            return fileAttachment;
        };
        AttachmentCollection.prototype.AddFileAttachment_3 = function (name, content) {
            var fileAttachment = new FileAttachment(this.owner);
            fileAttachment.Name = name;
            fileAttachment.Content = content;
            _super.prototype.InternalAdd.call(this, fileAttachment);
            return fileAttachment;
        };
        AttachmentCollection.prototype.AddItemAttachment = function () {
            if (new Type("TItem").GetCustomAttributes(new Type("AttachableAttribute"), false).length === 0) {
                throw new InvalidOperationException(NString.Format("Items of type {0} are not supported as attachments.", new Type("TItem").Name));
            }
            var itemAttachment = new ItemAttachment(this.owner);
            itemAttachment.Item = EwsUtilities.CreateItemFromItemClass(itemAttachment, new Type("TItem"), true);
            _super.prototype.InternalAdd.call(this, itemAttachment);
            return itemAttachment;
        };
        AttachmentCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
        };
        AttachmentCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        AttachmentCollection.prototype.Remove = function (attachment) {
            EwsUtilities.ValidateParam(attachment, "attachment");
            return _super.prototype.InternalRemove.call(this, attachment);
        };
        AttachmentCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName !== null) {
                if (xmlElementName === "FileAttachment") {
                    return new FileAttachment(this.owner);
                }
                if (xmlElementName === "ItemAttachment") {
                    return new ItemAttachment(this.owner);
                }
            }
            return null;
        };
        AttachmentCollection.prototype.CreateDefaultComplexProperty = function () {
            throw new JsonDeserializationNotImplementedException();
        };
        AttachmentCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            if (complexProperty instanceof FileAttachment) {
                return "FileAttachment";
            }
            return "ItemAttachment";
        };
        AttachmentCollection.prototype.Save = function () {
            var list = new List();
            var enumerator = this.RemovedItems.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (!current.IsNew) {
                        list.Add(current);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (list.Count > 0) {
                this.InternalDeleteAttachments(list);
            }
            list.Clear();
            var enumerator2 = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    if (current2.IsNew) {
                        list.Add(current2);
                    }
                }
            }
            finally {
                if (enumerator2 !== null) {
                    enumerator2.Dispose();
                }
            }
            if (list.Count > 0) {
                if (this.owner.IsAttachment) {
                    this.InternalCreateAttachments(this.owner.ParentAttachment.Id, list);
                }
                else {
                    this.InternalCreateAttachments(this.owner.Id.UniqueId, list);
                }
            }
            var enumerator3 = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    var itemAttachment = ((current3 instanceof ItemAttachment) ? current3 : null);
                    if (itemAttachment !== null && itemAttachment.Item !== null) {
                        itemAttachment.Item.Attachments.Save();
                        itemAttachment.Item.ClearChangeLog();
                    }
                }
            }
            finally {
                if (enumerator3 !== null) {
                    enumerator3.Dispose();
                }
            }
            _super.prototype.ClearChangeLog.call(this);
        };
        AttachmentCollection.prototype.HasUnprocessedChanges = function () {
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.IsNew) {
                        var result = true;
                        return result;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            var enumerator2 = this.RemovedItems.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    if (!current2.IsNew) {
                        var result = true;
                        return result;
                    }
                }
            }
            finally {
                enumerator2.Dispose();
            }
            var enumerator3 = Enumerable.OfType(this).GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    if (current3.Item !== null && current3.Item.Attachments.HasUnprocessedChanges()) {
                        var result = true;
                        return result;
                    }
                }
            }
            finally {
                if (enumerator3 !== null) {
                    enumerator3.Dispose();
                }
            }
            return false;
        };
        AttachmentCollection.prototype.ClearChangeLog = function () {
        };
        AttachmentCollection.prototype.Validate = function () {
            var flag = false;
            for (var i = 0; i < this.AddedItems.Count; i = i + 1) {
                var attachment = this.AddedItems.get_Item(i);
                if (attachment.IsNew) {
                    if (this.owner.IsNew && this.owner.Service.RequestedServerVersion >= ExchangeVersion.Exchange2010_SP2) {
                        var fileAttachment = ((attachment instanceof FileAttachment) ? attachment : null);
                        if (fileAttachment !== null && fileAttachment.IsContactPhoto) {
                            if (flag) {
                                throw new ServiceValidationException(Strings.MultipleContactPhotosInAttachment);
                            }
                            flag = true;
                        }
                    }
                    attachment.Validate(i);
                }
            }
        };
        AttachmentCollection.prototype.InternalDeleteAttachments = function (attachments) {
            var serviceResponseCollection = this.owner.Service.DeleteAttachments(attachments);
            var enumerator = serviceResponseCollection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.Result !== ServiceResult.Error) {
                        _super.prototype.RemoveFromChangeLog.call(this, current.Attachment);
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            if (serviceResponseCollection.OverallResult === ServiceResult.Error) {
                throw new DeleteAttachmentException(serviceResponseCollection, Strings.AtLeastOneAttachmentCouldNotBeDeleted);
            }
        };
        AttachmentCollection.prototype.InternalCreateAttachments = function (parentItemId, attachments) {
            var serviceResponseCollection = this.owner.Service.CreateAttachments(parentItemId, attachments);
            var enumerator = serviceResponseCollection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.Result !== ServiceResult.Error) {
                        _super.prototype.RemoveFromChangeLog.call(this, current.Attachment);
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            if (serviceResponseCollection.OverallResult === ServiceResult.Error) {
                throw new CreateAttachmentException(serviceResponseCollection, Strings.AttachmentCreationFailed);
            }
        };
        return AttachmentCollection;
    }(ComplexPropertyCollection));
    var EmailAddress = (function (_super) {
        __extends(EmailAddress, _super);
        function EmailAddress(smtpAddressOrNameOrMailbox, smtpAddressOrAddress, routingType, mailboxType, itemId) {
            _super.call(this);
            this.name = null;
            this.address = null;
            this.routingType = null;
            this.mailboxType = null;
            this.id = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String)) {
                this.constructor_1(smtpAddressOrNameOrMailbox);
                return;
            }
            if (arguments.length === 2 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String)) {
                this.constructor_2(smtpAddressOrNameOrMailbox, smtpAddressOrAddress);
                return;
            }
            if (arguments.length === 3 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String) && (routingType === null || routingType.constructor === String)) {
                this.constructor_3(smtpAddressOrNameOrMailbox, smtpAddressOrAddress, routingType);
                return;
            }
            if (arguments.length === 4 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String) && (routingType === null || routingType.constructor === String) && (mailboxType === null || mailboxType.constructor === Number)) {
                this.constructor_4(smtpAddressOrNameOrMailbox, smtpAddressOrAddress, routingType, mailboxType);
                return;
            }
            if (arguments.length === 5 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String) && (routingType === null || routingType.constructor === String) && (mailboxType === null || mailboxType.constructor === Number) && (itemId === null || itemId instanceof ItemId)) {
                this.constructor_5(smtpAddressOrNameOrMailbox, smtpAddressOrAddress, routingType, mailboxType, itemId);
                return;
            }
            this.constructor_6(smtpAddressOrNameOrMailbox);
        }
        Object.defineProperty(EmailAddress.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.name
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.name = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailAddress.prototype, "Address", {
            get: function () {
                return this.address;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.address
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.address = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailAddress.prototype, "RoutingType", {
            get: function () {
                return this.routingType;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.routingType
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.routingType = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailAddress.prototype, "MailboxType", {
            get: function () {
                return this.mailboxType;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.mailboxType
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.mailboxType = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailAddress.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.id
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.id = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        EmailAddress.prototype.constructor_0 = function () {
        };
        EmailAddress.prototype.constructor_1 = function (smtpAddress) {
            this.constructor_0();
            this.address = smtpAddress;
        };
        EmailAddress.prototype.constructor_2 = function (name, smtpAddress) {
            this.constructor_1(smtpAddress);
            this.name = name;
        };
        EmailAddress.prototype.constructor_3 = function (name, address, routingType) {
            this.constructor_2(name, address);
            this.routingType = routingType;
        };
        EmailAddress.prototype.constructor_4 = function (name, address, routingType, mailboxType) {
            this.constructor_3(name, address, routingType);
            this.mailboxType = new Nullable(mailboxType);
        };
        EmailAddress.prototype.constructor_5 = function (name, address, routingType, mailboxType, itemId) {
            this.constructor_3(name, address, routingType);
            this.mailboxType = new Nullable(mailboxType);
            this.id = itemId;
        };
        EmailAddress.prototype.constructor_6 = function (mailbox) {
            this.constructor_0();
            EwsUtilities.ValidateParam(mailbox, "mailbox");
            this.Name = mailbox.Name;
            this.Address = mailbox.Address;
            this.RoutingType = mailbox.RoutingType;
            this.MailboxType = mailbox.MailboxType;
            this.Id = mailbox.Id;
        };
        EmailAddress.op_Implicit = function (smtpAddress) {
            return new EmailAddress(smtpAddress);
        };
        EmailAddress.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Name") {
                    this.name = reader.ReadElementValue();
                    return true;
                }
                if (localName === "EmailAddress") {
                    this.address = reader.ReadElementValue();
                    return true;
                }
                if (localName === "RoutingType") {
                    this.routingType = reader.ReadElementValue();
                    return true;
                }
                if (localName === "MailboxType") {
                    this.mailboxType = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "ItemId") {
                    this.id = new ItemId();
                    this.id.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        EmailAddress.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Name")) {
                            if (!(a === "EmailAddress")) {
                                if (!(a === "RoutingType")) {
                                    if (!(a === "MailboxType")) {
                                        if (a === "ItemId") {
                                            this.id = new ItemId();
                                            this.id.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                        }
                                    }
                                    else {
                                        this.mailboxType = new Nullable(jsonProperty.ReadEnumValue(current));
                                    }
                                }
                                else {
                                    this.routingType = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.address = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.name = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        EmailAddress.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Name", this.Name);
            writer.WriteElementValue(XmlNamespace.Types, "EmailAddress", this.Address);
            writer.WriteElementValue(XmlNamespace.Types, "RoutingType", this.RoutingType);
            writer.WriteElementValue(XmlNamespace.Types, "MailboxType", this.MailboxType);
            if (this.Id !== null) {
                this.Id.WriteToXml(writer, "ItemId");
            }
        };
        EmailAddress.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Name", this.Name);
            jsonObject.Add("EmailAddress", this.Address);
            jsonObject.Add("RoutingType", this.RoutingType);
            jsonObject.Add("MailboxType", this.MailboxType);
            if (this.Id !== null) {
                jsonObject.Add("ItemId", this.Id.InternalToJson(service));
            }
            return jsonObject;
        };
        EmailAddress.prototype.GetSearchString = function () {
            return this.Address;
        };
        EmailAddress.prototype.ToString = function () {
            if (NString.IsNullOrEmpty(this.Address)) {
                return NString.Empty;
            }
            var text;
            if (!NString.IsNullOrEmpty(this.RoutingType)) {
                text = this.RoutingType + ":" + this.Address;
            }
            else {
                text = this.Address;
            }
            if (!NString.IsNullOrEmpty(this.Name)) {
                return this.Name + " <" + text + ">";
            }
            return text;
        };
        EmailAddress.SmtpRoutingType = "SMTP";
        return EmailAddress;
    }(ComplexProperty));
    var Attendee = (function (_super) {
        __extends(Attendee, _super);
        function Attendee(smtpAddressOrNameOrMailbox, smtpAddress, routingType) {
            _super.call(this);
            this.responseType = null;
            this.lastResponseTime = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String)) {
                this.constructor_1(smtpAddressOrNameOrMailbox);
                return;
            }
            if (arguments.length === 2 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddress === null || smtpAddress.constructor === String)) {
                this.constructor_2(smtpAddressOrNameOrMailbox, smtpAddress);
                return;
            }
            if (arguments.length === 3 && (smtpAddressOrNameOrMailbox === null || smtpAddressOrNameOrMailbox.constructor === String) && (smtpAddress === null || smtpAddress.constructor === String) && (routingType === null || routingType.constructor === String)) {
                this.constructor_3(smtpAddressOrNameOrMailbox, smtpAddress, routingType);
                return;
            }
            this.constructor_4(smtpAddressOrNameOrMailbox);
        }
        Object.defineProperty(Attendee.prototype, "ResponseType", {
            get: function () {
                return this.responseType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Attendee.prototype, "LastResponseTime", {
            get: function () {
                return this.lastResponseTime;
            },
            enumerable: true,
            configurable: true
        });
        Attendee.prototype.constructor_0 = function () {
        };
        Attendee.prototype.constructor_1 = function (smtpAddress) {
            EwsUtilities.ValidateParam(smtpAddress, "smtpAddress");
        };
        Attendee.prototype.constructor_2 = function (name, smtpAddress) {
        };
        Attendee.prototype.constructor_3 = function (name, smtpAddress, routingType) {
        };
        Attendee.prototype.constructor_4 = function (mailbox) {
        };
        Attendee.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Mailbox") {
                    this.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "ResponseType") {
                    this.responseType = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "LastResponseTime") {
                    this.lastResponseTime = reader.ReadElementValueAsDateTime();
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        Attendee.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(this.Namespace, "Mailbox");
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteEndElement();
        };
        return Attendee;
    }(EmailAddress));
    var AttendeeCollection = (function (_super) {
        __extends(AttendeeCollection, _super);
        function AttendeeCollection() {
            _super.call(this);
        }
        AttendeeCollection.prototype.Add = function (attendeeOrSmtpAddressOrName, smtpAddress) {
            if (arguments.length === 1 && (attendeeOrSmtpAddressOrName === null || attendeeOrSmtpAddressOrName instanceof Attendee)) {
                this.Add_0(attendeeOrSmtpAddressOrName);
                return;
            }
            if (arguments.length === 1 && (attendeeOrSmtpAddressOrName === null || attendeeOrSmtpAddressOrName.constructor === String)) {
                this.Add_1(attendeeOrSmtpAddressOrName);
                return;
            }
            this.Add_2(attendeeOrSmtpAddressOrName, smtpAddress);
        };
        AttendeeCollection.prototype.Add_0 = function (attendee) {
            _super.prototype.InternalAdd.call(this, attendee);
        };
        AttendeeCollection.prototype.Add_1 = function (smtpAddress) {
            var attendee = new Attendee(smtpAddress);
            _super.prototype.InternalAdd.call(this, attendee);
            return attendee;
        };
        AttendeeCollection.prototype.Add_2 = function (name, smtpAddress) {
            var attendee = new Attendee(name, smtpAddress);
            _super.prototype.InternalAdd.call(this, attendee);
            return attendee;
        };
        AttendeeCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
        };
        AttendeeCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        AttendeeCollection.prototype.Remove = function (attendee) {
            EwsUtilities.ValidateParam(attendee, "attendee");
            return _super.prototype.InternalRemove.call(this, attendee);
        };
        AttendeeCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === "Attendee") {
                return new Attendee();
            }
            return null;
        };
        AttendeeCollection.prototype.CreateDefaultComplexProperty = function () {
            return new Attendee();
        };
        AttendeeCollection.prototype.GetCollectionItemXmlElementName = function (attendee) {
            return "Attendee";
        };
        return AttendeeCollection;
    }(ComplexPropertyCollection));
    var ByteArrayArray = (function (_super) {
        __extends(ByteArrayArray, _super);
        function ByteArrayArray() {
            _super.call(this);
            this.content = new List();
        }
        Object.defineProperty(ByteArrayArray.prototype, "Content", {
            get: function () {
                return this.content.ToArray();
            },
            enumerable: true,
            configurable: true
        });
        ByteArrayArray.prototype.TryReadElementFromXml = function (reader) {
            if (reader.LocalName === "Base64Binary") {
                this.content.Add(reader.ReadBase64ElementValue());
                return true;
            }
            return false;
        };
        ByteArrayArray.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                this.content.Add(Convert.FromBase64String(((obj instanceof string) ? obj : null)));
            }
        };
        ByteArrayArray.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        ByteArrayArray.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.content.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, "Base64Binary");
                    writer.WriteBase64ElementValue(current);
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        ByteArrayArray.prototype.InternalToJson = function (service) {
            var list = new List(this.content.Count);
            var enumerator = this.content.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(Convert.ToBase64String(current));
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list.ToArray();
        };
        ByteArrayArray.ItemXmlElementName = "Base64Binary";
        return ByteArrayArray;
    }(ComplexProperty));
    var ChangeHighlights = (function (_super) {
        __extends(ChangeHighlights, _super);
        function ChangeHighlights() {
            _super.call(this);
            this.hasLocationChanged = false;
            this.location = null;
            this.hasStartTimeChanged = false;
            this.start = null;
            this.hasEndTimeChanged = false;
            this.end = null;
        }
        Object.defineProperty(ChangeHighlights.prototype, "HasLocationChanged", {
            get: function () {
                return this.hasLocationChanged;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeHighlights.prototype, "Location", {
            get: function () {
                return this.location;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeHighlights.prototype, "HasStartTimeChanged", {
            get: function () {
                return this.hasStartTimeChanged;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeHighlights.prototype, "Start", {
            get: function () {
                return this.start;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeHighlights.prototype, "HasEndTimeChanged", {
            get: function () {
                return this.hasEndTimeChanged;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeHighlights.prototype, "End", {
            get: function () {
                return this.end;
            },
            enumerable: true,
            configurable: true
        });
        ChangeHighlights.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "HasLocationChanged":
                    this.hasLocationChanged = reader.ReadElementValue();
                    return true;
                case "Location":
                    this.location = reader.ReadElementValue();
                    return true;
                case "HasStartTimeChanged":
                    this.hasStartTimeChanged = reader.ReadElementValue();
                    return true;
                case "Start":
                    this.start = reader.ReadElementValueAsDateTime().Value;
                    return true;
                case "HasEndTimeChanged":
                    this.hasEndTimeChanged = reader.ReadElementValue();
                    return true;
                case "End":
                    this.end = reader.ReadElementValueAsDateTime().Value;
                    return true;
            }
            return false;
        };
        ChangeHighlights.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "HasLocationChanged":
                            this.hasLocationChanged = jsonProperty.ReadAsBool(current);
                            break;
                        case "Location":
                            this.location = jsonProperty.ReadAsString(current);
                            break;
                        case "HasStartTimeChanged":
                            this.hasStartTimeChanged = jsonProperty.ReadAsBool(current);
                            break;
                        case "Start":
                            this.start = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                            break;
                        case "HasEndTimeChanged":
                            this.hasEndTimeChanged = jsonProperty.ReadAsBool(current);
                            break;
                        case "End":
                            this.end = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return ChangeHighlights;
    }(ComplexProperty));
    var ClientApp = (function (_super) {
        __extends(ClientApp, _super);
        function ClientApp() {
            _super.call(this);
            this.Manifest = null;
            this.Metadata = null;
            this.Namespace = XmlNamespace.Types;
        }
        ClientApp.ReadToXmlDocument = function (reader) {
            var memoryStream = new MemoryStream();
            var result;
            try {
                reader.ReadBase64ElementValue(memoryStream);
                memoryStream.Position = 0;
                var safeXmlDocument = new SafeXmlDocument();
                safeXmlDocument.Load(memoryStream);
                result = safeXmlDocument;
            }
            finally {
                if (memoryStream !== null) {
                    memoryStream.Dispose();
                }
            }
            return result;
        };
        ClientApp.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Manifest") {
                    this.Manifest = ClientApp.ReadToXmlDocument(reader);
                    return true;
                }
                if (localName === "Metadata") {
                    this.Metadata = new ClientAppMetadata();
                    this.Metadata.LoadFromXml(reader, XmlNamespace.Types, "Metadata");
                    return true;
                }
            }
            return false;
        };
        return ClientApp;
    }(ComplexProperty));
    var ClientAppMetadata = (function (_super) {
        __extends(ClientAppMetadata, _super);
        function ClientAppMetadata() {
            _super.call(this);
            this.EndNodeUrl = null;
            this.ActionUrl = null;
            this.AppStatus = null;
            this.Namespace = XmlNamespace.Types;
        }
        ClientAppMetadata.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "EndNodeUrl") {
                    this.EndNodeUrl = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ActionUrl") {
                    this.ActionUrl = reader.ReadElementValue();
                    return true;
                }
                if (localName === "AppStatus") {
                    this.AppStatus = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        return ClientAppMetadata;
    }(ComplexProperty));
    var ClientExtension = (function (_super) {
        __extends(ClientExtension, _super);
        function ClientExtension(type, scope, manifestStream, marketplaceAssetID, marketplaceContentMarket, isAvailable, isMandatory, isEnabledByDefault, providedTo, specificUsers, appStatus, etoken) {
            _super.call(this);
            this.Type = 0;
            this.Scope = 0;
            this.ManifestStream = null;
            this.MarketplaceAssetID = null;
            this.MarketplaceContentMarket = null;
            this.AppStatus = null;
            this.Etoken = null;
            this.IsAvailable = false;
            this.IsMandatory = false;
            this.IsEnabledByDefault = false;
            this.ProvidedTo = 0;
            this.SpecificUsers = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(type, scope, manifestStream, marketplaceAssetID, marketplaceContentMarket, isAvailable, isMandatory, isEnabledByDefault, providedTo, specificUsers, appStatus, etoken);
        }
        ClientExtension.prototype.constructor_0 = function () {
            this.Namespace = XmlNamespace.Types;
        };
        ClientExtension.prototype.constructor_1 = function (type, scope, manifestStream, marketplaceAssetID, marketplaceContentMarket, isAvailable, isMandatory, isEnabledByDefault, providedTo, specificUsers, appStatus, etoken) {
            this.constructor_0();
            this.Type = type;
            this.Scope = scope;
            this.ManifestStream = manifestStream;
            this.MarketplaceAssetID = marketplaceAssetID;
            this.MarketplaceContentMarket = marketplaceContentMarket;
            this.IsAvailable = isAvailable;
            this.IsMandatory = isMandatory;
            this.IsEnabledByDefault = isEnabledByDefault;
            this.ProvidedTo = providedTo;
            this.SpecificUsers = specificUsers;
            this.AppStatus = appStatus;
            this.Etoken = etoken;
        };
        ClientExtension.prototype.ReadAttributesFromXml = function (reader) {
            var value = reader.ReadAttributeValue("Type");
            if (!NString.IsNullOrEmpty(value)) {
                this.Type = reader.ReadAttributeValue("Type");
            }
            value = reader.ReadAttributeValue("Scope");
            if (!NString.IsNullOrEmpty(value)) {
                this.Scope = reader.ReadAttributeValue("Scope");
            }
            value = reader.ReadAttributeValue("MarketplaceAssetId");
            if (!NString.IsNullOrEmpty(value)) {
                this.MarketplaceAssetID = reader.ReadAttributeValue("MarketplaceAssetId");
            }
            value = reader.ReadAttributeValue("MarketplaceContentMarket");
            if (!NString.IsNullOrEmpty(value)) {
                this.MarketplaceContentMarket = reader.ReadAttributeValue("MarketplaceContentMarket");
            }
            value = reader.ReadAttributeValue("AppStatus");
            if (!NString.IsNullOrEmpty(value)) {
                this.AppStatus = reader.ReadAttributeValue("AppStatus");
            }
            value = reader.ReadAttributeValue("Etoken");
            if (!NString.IsNullOrEmpty(value)) {
                this.Etoken = reader.ReadAttributeValue("Etoken");
            }
            value = reader.ReadAttributeValue("IsAvailable");
            if (!NString.IsNullOrEmpty(value)) {
                this.IsAvailable = reader.ReadAttributeValue("IsAvailable");
            }
            value = reader.ReadAttributeValue("IsMandatory");
            if (!NString.IsNullOrEmpty(value)) {
                this.IsMandatory = reader.ReadAttributeValue("IsMandatory");
            }
            value = reader.ReadAttributeValue("IsEnabledByDefault");
            if (!NString.IsNullOrEmpty(value)) {
                this.IsEnabledByDefault = reader.ReadAttributeValue("IsEnabledByDefault");
            }
            value = reader.ReadAttributeValue("ProvidedTo");
            if (!NString.IsNullOrEmpty(value)) {
                this.ProvidedTo = reader.ReadAttributeValue("ProvidedTo");
            }
        };
        ClientExtension.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Type", this.Type);
            writer.WriteAttributeValue("Scope", this.Scope);
            writer.WriteAttributeValue("MarketplaceAssetId", this.MarketplaceAssetID);
            writer.WriteAttributeValue("MarketplaceContentMarket", this.MarketplaceContentMarket);
            writer.WriteAttributeValue("AppStatus", this.AppStatus);
            writer.WriteAttributeValue("Etoken", this.Etoken);
            writer.WriteAttributeValue("IsAvailable", this.IsAvailable);
            writer.WriteAttributeValue("IsMandatory", this.IsMandatory);
            writer.WriteAttributeValue("IsEnabledByDefault", this.IsEnabledByDefault);
            writer.WriteAttributeValue("ProvidedTo", this.ProvidedTo);
        };
        ClientExtension.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Manifest") {
                    this.ManifestStream = new MemoryStream();
                    reader.ReadBase64ElementValue(this.ManifestStream);
                    this.ManifestStream.Position = 0;
                    return true;
                }
                if (localName === "SpecificUsers") {
                    this.SpecificUsers = new StringList();
                    this.SpecificUsers.LoadFromXml(reader, XmlNamespace.Types, "SpecificUsers");
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        ClientExtension.prototype.WriteElementsToXml = function (writer) {
            if (this.SpecificUsers !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "SpecificUsers");
                this.SpecificUsers.WriteElementsToXml(writer);
                writer.WriteEndElement();
            }
            if (this.ManifestStream !== null) {
                if (this.ManifestStream.CanSeek) {
                    this.ManifestStream.Position = 0;
                }
                writer.WriteStartElement(XmlNamespace.Types, "Manifest");
                writer.WriteBase64ElementValue(this.ManifestStream);
                writer.WriteEndElement();
            }
        };
        return ClientExtension;
    }(ComplexProperty));
    var ClientAccessTokenRequest = (function (_super) {
        __extends(ClientAccessTokenRequest, _super);
        function ClientAccessTokenRequest(id, tokenType, scope) {
            _super.call(this);
            this.id = null;
            this.tokenType = 0;
            this.scope = null;
            if (arguments.length === 2 && (id === null || id.constructor === String) && (tokenType === null || tokenType.constructor === Number)) {
                this.constructor_0(id, tokenType);
                return;
            }
            this.constructor_1(id, tokenType, scope);
        }
        Object.defineProperty(ClientAccessTokenRequest.prototype, "Id", {
            get: function () {
                return this.id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientAccessTokenRequest.prototype, "TokenType", {
            get: function () {
                return this.tokenType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientAccessTokenRequest.prototype, "Scope", {
            get: function () {
                return this.scope;
            },
            enumerable: true,
            configurable: true
        });
        ClientAccessTokenRequest.prototype.constructor_0 = function (id, tokenType) {
            this.constructor_1(id, tokenType, null);
        };
        ClientAccessTokenRequest.prototype.constructor_1 = function (id, tokenType, scope) {
            this.id = id;
            this.tokenType = tokenType;
            this.scope = scope;
        };
        return ClientAccessTokenRequest;
    }(ComplexProperty));
    var CompleteName = (function (_super) {
        __extends(CompleteName, _super);
        function CompleteName() {
            _super.call(this);
            this.title = null;
            this.givenName = null;
            this.middleName = null;
            this.surname = null;
            this.suffix = null;
            this.initials = null;
            this.fullName = null;
            this.nickname = null;
            this.yomiGivenName = null;
            this.yomiSurname = null;
        }
        Object.defineProperty(CompleteName.prototype, "Title", {
            get: function () {
                return this.title;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "GivenName", {
            get: function () {
                return this.givenName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "MiddleName", {
            get: function () {
                return this.middleName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "Surname", {
            get: function () {
                return this.surname;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "Suffix", {
            get: function () {
                return this.suffix;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "Initials", {
            get: function () {
                return this.initials;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "FullName", {
            get: function () {
                return this.fullName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "NickName", {
            get: function () {
                return this.nickname;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "YomiGivenName", {
            get: function () {
                return this.yomiGivenName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompleteName.prototype, "YomiSurname", {
            get: function () {
                return this.yomiSurname;
            },
            enumerable: true,
            configurable: true
        });
        CompleteName.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Title":
                    this.title = reader.ReadElementValue();
                    return true;
                case "FirstName":
                    this.givenName = reader.ReadElementValue();
                    return true;
                case "MiddleName":
                    this.middleName = reader.ReadElementValue();
                    return true;
                case "LastName":
                    this.surname = reader.ReadElementValue();
                    return true;
                case "Suffix":
                    this.suffix = reader.ReadElementValue();
                    return true;
                case "Initials":
                    this.initials = reader.ReadElementValue();
                    return true;
                case "FullName":
                    this.fullName = reader.ReadElementValue();
                    return true;
                case "Nickname":
                    this.nickname = reader.ReadElementValue();
                    return true;
                case "YomiFirstName":
                    this.yomiGivenName = reader.ReadElementValue();
                    return true;
                case "YomiLastName":
                    this.yomiSurname = reader.ReadElementValue();
                    return true;
            }
            return false;
        };
        CompleteName.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "Title":
                            this.title = jsonProperty.ReadAsString(current);
                            break;
                        case "FirstName":
                            this.givenName = jsonProperty.ReadAsString(current);
                            break;
                        case "MiddleName":
                            this.middleName = jsonProperty.ReadAsString(current);
                            break;
                        case "LastName":
                            this.surname = jsonProperty.ReadAsString(current);
                            break;
                        case "Suffix":
                            this.suffix = jsonProperty.ReadAsString(current);
                            break;
                        case "Initials":
                            this.initials = jsonProperty.ReadAsString(current);
                            break;
                        case "FullName":
                            this.fullName = jsonProperty.ReadAsString(current);
                            break;
                        case "Nickname":
                            this.nickname = jsonProperty.ReadAsString(current);
                            break;
                        case "YomiFirstName":
                            this.yomiGivenName = jsonProperty.ReadAsString(current);
                            break;
                        case "YomiLastName":
                            this.yomiSurname = jsonProperty.ReadAsString(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        CompleteName.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Title", this.Title);
            writer.WriteElementValue(XmlNamespace.Types, "FirstName", this.GivenName);
            writer.WriteElementValue(XmlNamespace.Types, "MiddleName", this.MiddleName);
            writer.WriteElementValue(XmlNamespace.Types, "LastName", this.Surname);
            writer.WriteElementValue(XmlNamespace.Types, "Suffix", this.Suffix);
            writer.WriteElementValue(XmlNamespace.Types, "Initials", this.Initials);
            writer.WriteElementValue(XmlNamespace.Types, "FullName", this.FullName);
            writer.WriteElementValue(XmlNamespace.Types, "Nickname", this.NickName);
            writer.WriteElementValue(XmlNamespace.Types, "YomiFirstName", this.YomiGivenName);
            writer.WriteElementValue(XmlNamespace.Types, "YomiLastName", this.YomiSurname);
        };
        CompleteName.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Title", this.Title);
            jsonObject.Add("FirstName", this.GivenName);
            jsonObject.Add("MiddleName", this.MiddleName);
            jsonObject.Add("LastName", this.Surname);
            jsonObject.Add("Suffix", this.Suffix);
            jsonObject.Add("Initials", this.Initials);
            jsonObject.Add("FullName", this.FullName);
            jsonObject.Add("Nickname", this.NickName);
            jsonObject.Add("YomiFirstName", this.YomiGivenName);
            jsonObject.Add("YomiLastName", this.YomiSurname);
            return jsonObject;
        };
        return CompleteName;
    }(ComplexProperty));
    var ContactEntity = (function (_super) {
        __extends(ContactEntity, _super);
        function ContactEntity() {
            _super.call(this);
            this.PersonName = null;
            this.BusinessName = null;
            this.PhoneNumbers = null;
            this.Urls = null;
            this.EmailAddresses = null;
            this.Addresses = null;
            this.ContactString = null;
        }
        ContactEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "PersonName":
                    this.PersonName = reader.ReadElementValue();
                    return true;
                case "BusinessName":
                    this.BusinessName = reader.ReadElementValue();
                    return true;
                case "PhoneNumbers":
                    this.PhoneNumbers = new ContactPhoneEntityCollection();
                    this.PhoneNumbers.LoadFromXml(reader, XmlNamespace.Types, "PhoneNumbers");
                    return true;
                case "Urls":
                    this.Urls = new StringList("Url");
                    this.Urls.LoadFromXml(reader, XmlNamespace.Types, "Urls");
                    return true;
                case "EmailAddresses":
                    this.EmailAddresses = new StringList("EmailAddress");
                    this.EmailAddresses.LoadFromXml(reader, XmlNamespace.Types, "EmailAddresses");
                    return true;
                case "Addresses":
                    this.Addresses = new StringList("Address");
                    this.Addresses.LoadFromXml(reader, XmlNamespace.Types, "Addresses");
                    return true;
                case "ContactString":
                    this.ContactString = reader.ReadElementValue();
                    return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return ContactEntity;
    }(ExtractedEntity));
    var ContactEntityCollection = (function (_super) {
        __extends(ContactEntityCollection, _super);
        function ContactEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        ContactEntityCollection.prototype.constructor_0 = function () {
        };
        ContactEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        ContactEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new ContactEntity();
        };
        ContactEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new ContactEntity();
        };
        ContactEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Contact";
        };
        return ContactEntityCollection;
    }(ComplexPropertyCollection));
    var ContactPhoneEntity = (function (_super) {
        __extends(ContactPhoneEntity, _super);
        function ContactPhoneEntity() {
            _super.call(this);
            this.OriginalPhoneString = null;
            this.PhoneString = null;
            this.Type = null;
        }
        ContactPhoneEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "OriginalPhoneString") {
                    this.OriginalPhoneString = reader.ReadElementValue();
                    return true;
                }
                if (localName === "PhoneString") {
                    this.PhoneString = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Type") {
                    this.Type = reader.ReadElementValue();
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return ContactPhoneEntity;
    }(ComplexProperty));
    var ContactPhoneEntityCollection = (function (_super) {
        __extends(ContactPhoneEntityCollection, _super);
        function ContactPhoneEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        ContactPhoneEntityCollection.prototype.constructor_0 = function () {
        };
        ContactPhoneEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        ContactPhoneEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new ContactPhoneEntity();
        };
        ContactPhoneEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new ContactPhoneEntity();
        };
        ContactPhoneEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Phone";
        };
        return ContactPhoneEntityCollection;
    }(ComplexPropertyCollection));
    var ConversationNode = (function (_super) {
        __extends(ConversationNode, _super);
        function ConversationNode(propertySet) {
            _super.call(this);
            this.propertySet = null;
            this.InternetMessageId = null;
            this.ParentInternetMessageId = null;
            this.Items = null;
            this.propertySet = propertySet;
        }
        ConversationNode.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "InternetMessageId") {
                    this.InternetMessageId = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ParentInternetMessageId") {
                    this.ParentInternetMessageId = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Items") {
                    this.Items = reader.ReadServiceObjectsCollectionFromXml(XmlNamespace.Types, "Items", this.GetObjectInstance, true, this.propertySet, false);
                    return true;
                }
            }
            return false;
        };
        ConversationNode.prototype.LoadFromJson = function (jsonProperty, service) {
            this.InternetMessageId = jsonProperty.ReadAsString("ConversationIndex");
            if (jsonProperty.ContainsKey("ParentInternetMessageId")) {
                this.ParentInternetMessageId = jsonProperty.ReadAsString("ParentInternetMessageId");
            }
            if (jsonProperty.ContainsKey("Items")) {
                var ewsServiceJsonReader = new EwsServiceJsonReader(service);
                this.Items = ewsServiceJsonReader.ReadServiceObjectsCollectionFromJson(jsonProperty, "Items", this.GetObjectInstance, false, this.propertySet, false);
            }
        };
        ConversationNode.prototype.GetObjectInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        ConversationNode.prototype.GetXmlElementName = function () {
            return "ConversationNode";
        };
        return ConversationNode;
    }(ComplexProperty));
    var ConversationNodeCollection = (function (_super) {
        __extends(ConversationNodeCollection, _super);
        function ConversationNodeCollection(propertySet) {
            _super.call(this);
            this.propertySet = null;
            this.propertySet = propertySet;
        }
        ConversationNodeCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new ConversationNode(this.propertySet);
        };
        ConversationNodeCollection.prototype.CreateDefaultComplexProperty = function () {
            return new ConversationNode(this.propertySet);
        };
        ConversationNodeCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return complexProperty.GetXmlElementName();
        };
        ConversationNodeCollection.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject !== null) {
                    var conversationNode = new ConversationNode(this.propertySet);
                    conversationNode.LoadFromJson(jsonObject, service);
                    _super.prototype.InternalAdd.call(this, conversationNode);
                }
            }
        };
        ConversationNodeCollection.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        return ConversationNodeCollection;
    }(ComplexPropertyCollection));
    var ConversationRequest = (function (_super) {
        __extends(ConversationRequest, _super);
        function ConversationRequest(conversationId, syncState) {
            _super.call(this);
            this.ConversationId = null;
            this.SyncState = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(conversationId, syncState);
        }
        ConversationRequest.prototype.constructor_0 = function () {
        };
        ConversationRequest.prototype.constructor_1 = function (conversationId, syncState) {
            this.ConversationId = conversationId;
            this.SyncState = syncState;
        };
        ConversationRequest.prototype.WriteToXml = function (writer, xmlElementName) {
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            this.ConversationId.WriteToXml(writer);
            if (this.SyncState !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "SyncState", this.SyncState);
            }
            writer.WriteEndElement();
        };
        ConversationRequest.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ConversationId", this.ConversationId.InternalToJson(service));
            if (!NString.IsNullOrEmpty(this.SyncState)) {
                jsonObject.Add("SyncState", this.SyncState);
            }
            return jsonObject;
        };
        ConversationRequest.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.ConversationId, "ConversationId");
        };
        return ConversationRequest;
    }(ComplexProperty));
    var ConversationResponse = (function (_super) {
        __extends(ConversationResponse, _super);
        function ConversationResponse(propertySet) {
            _super.call(this);
            this.propertySet = null;
            this.ConversationId = null;
            this.SyncState = null;
            this.ConversationNodes = null;
            this.propertySet = propertySet;
        }
        ConversationResponse.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "ConversationId") {
                    this.ConversationId = new ConversationId();
                    this.ConversationId.LoadFromXml(reader, "ConversationId");
                    return true;
                }
                if (localName === "SyncState") {
                    this.SyncState = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ConversationNodes") {
                    this.ConversationNodes = new ConversationNodeCollection(this.propertySet);
                    this.ConversationNodes.LoadFromXml(reader, "ConversationNodes");
                    return true;
                }
            }
            return false;
        };
        ConversationResponse.prototype.LoadFromJson = function (jsonProperty, service) {
            this.ConversationId = new ConversationId();
            this.ConversationId.LoadFromJson(jsonProperty.ReadAsJsonObject("ConversationId"), service);
            if (jsonProperty.ContainsKey("SyncState")) {
                this.SyncState = jsonProperty.ReadAsString("SyncState");
            }
            this.ConversationNodes = new ConversationNodeCollection(this.propertySet);
            this.ConversationNodes.CreateFromJsonCollection(jsonProperty.ReadAsArray("ConversationNodes"), service);
        };
        return ConversationResponse;
    }(ComplexProperty));
    var DelegatePermissions = (function (_super) {
        __extends(DelegatePermissions, _super);
        function DelegatePermissions() {
            _super.call(this);
            this.delegateFolderPermissions = null;
            var dictionary = new Dictionary();
            dictionary.Add("CalendarFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            dictionary.Add("TasksFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            dictionary.Add("InboxFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            dictionary.Add("ContactsFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            dictionary.Add("NotesFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            dictionary.Add("JournalFolderPermissionLevel", new DelegatePermissions_DelegateFolderPermission());
            this.delegateFolderPermissions = dictionary;
        }
        Object.defineProperty(DelegatePermissions.prototype, "CalendarFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("CalendarFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("CalendarFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegatePermissions.prototype, "TasksFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("TasksFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("TasksFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegatePermissions.prototype, "InboxFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("InboxFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("InboxFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegatePermissions.prototype, "ContactsFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("ContactsFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("ContactsFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegatePermissions.prototype, "NotesFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("NotesFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("NotesFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegatePermissions.prototype, "JournalFolderPermissionLevel", {
            get: function () {
                return this.delegateFolderPermissions.get_Item("JournalFolderPermissionLevel").PermissionLevel;
            },
            set: function (value) {
                this.delegateFolderPermissions.get_Item("JournalFolderPermissionLevel").PermissionLevel = value;
            },
            enumerable: true,
            configurable: true
        });
        DelegatePermissions.prototype.Reset = function () {
            var enumerator = this.delegateFolderPermissions.Values.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Reset();
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        DelegatePermissions.prototype.TryReadElementFromXml = function (reader) {
            var _this = this;
            var delegateFolderPermission = null;
            if ((function () {
                var _p0 = [
                    delegateFolderPermission
                ];
                var _r = _this.delegateFolderPermissions.TryGetValue(reader.LocalName, _p0);
                delegateFolderPermission = _p0[0];
                return _r;
            })()) {
                delegateFolderPermission.Initialize(reader.ReadElementValue());
            }
            return delegateFolderPermission !== null;
        };
        DelegatePermissions.prototype.LoadFromJson = function (jsonProperty, service) {
            var _this = this;
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var delegateFolderPermission = null;
                    if ((function () {
                        var _p0 = [
                            delegateFolderPermission
                        ];
                        var _r = _this.delegateFolderPermissions.TryGetValue(current, _p0);
                        delegateFolderPermission = _p0[0];
                        return _r;
                    })()) {
                        delegateFolderPermission.Initialize(jsonProperty.ReadEnumValue(current));
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        DelegatePermissions.prototype.WriteElementsToXml = function (writer) {
            this.WritePermissionToXml(writer, "CalendarFolderPermissionLevel");
            this.WritePermissionToXml(writer, "TasksFolderPermissionLevel");
            this.WritePermissionToXml(writer, "InboxFolderPermissionLevel");
            this.WritePermissionToXml(writer, "ContactsFolderPermissionLevel");
            this.WritePermissionToXml(writer, "NotesFolderPermissionLevel");
            this.WritePermissionToXml(writer, "JournalFolderPermissionLevel");
        };
        DelegatePermissions.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            this.WritePermissionToJson(jsonObject, "CalendarFolderPermissionLevel");
            this.WritePermissionToJson(jsonObject, "TasksFolderPermissionLevel");
            this.WritePermissionToJson(jsonObject, "InboxFolderPermissionLevel");
            this.WritePermissionToJson(jsonObject, "ContactsFolderPermissionLevel");
            this.WritePermissionToJson(jsonObject, "NotesFolderPermissionLevel");
            this.WritePermissionToJson(jsonObject, "JournalFolderPermissionLevel");
            return jsonObject;
        };
        DelegatePermissions.prototype.WritePermissionToJson = function (jsonProperty, elementName) {
            var permissionLevel = this.delegateFolderPermissions.get_Item(elementName).PermissionLevel;
            if (permissionLevel !== DelegateFolderPermissionLevel.Custom) {
                jsonProperty.Add(elementName, permissionLevel);
            }
        };
        DelegatePermissions.prototype.WritePermissionToXml = function (writer, xmlElementName) {
            var permissionLevel = this.delegateFolderPermissions.get_Item(xmlElementName).PermissionLevel;
            if (permissionLevel !== DelegateFolderPermissionLevel.Custom) {
                writer.WriteElementValue(XmlNamespace.Types, xmlElementName, permissionLevel);
            }
        };
        DelegatePermissions.prototype.ValidateAddDelegate = function () {
            if (Enumerable.Any(this.delegateFolderPermissions, function (kvp) { return kvp.Value.PermissionLevel === DelegateFolderPermissionLevel.Custom; })) {
                throw new ServiceValidationException(Strings.CannotSetDelegateFolderPermissionLevelToCustom);
            }
        };
        DelegatePermissions.prototype.ValidateUpdateDelegate = function () {
            if (Enumerable.Any(this.delegateFolderPermissions, function (kvp) { return kvp.Value.PermissionLevel === DelegateFolderPermissionLevel.Custom && !kvp.Value.IsExistingPermissionLevelCustom; })) {
                throw new ServiceValidationException(Strings.CannotSetDelegateFolderPermissionLevelToCustom);
            }
        };
        return DelegatePermissions;
    }(ComplexProperty));
    var DelegatePermissions_DelegateFolderPermission = (function () {
        function DelegatePermissions_DelegateFolderPermission() {
            this.PermissionLevel = 0;
            this.IsExistingPermissionLevelCustom = false;
            _super.call(this);
        }
        DelegatePermissions_DelegateFolderPermission.prototype.Initialize = function (permissionLevel) {
            this.PermissionLevel = permissionLevel;
            this.IsExistingPermissionLevelCustom = (permissionLevel === DelegateFolderPermissionLevel.Custom);
        };
        DelegatePermissions_DelegateFolderPermission.prototype.Reset = function () {
            this.Initialize(DelegateFolderPermissionLevel.None);
        };
        return DelegatePermissions_DelegateFolderPermission;
    }());
    var DelegateUser = (function (_super) {
        __extends(DelegateUser, _super);
        function DelegateUser(primarySmtpAddressOrStandardUser) {
            _super.call(this);
            this.userId = new UserId();
            this.permissions = new DelegatePermissions();
            this.receiveCopiesOfMeetingMessages = false;
            this.viewPrivateItems = false;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (primarySmtpAddressOrStandardUser === null || primarySmtpAddressOrStandardUser.constructor === String)) {
                this.constructor_1(primarySmtpAddressOrStandardUser);
                return;
            }
            this.constructor_2(primarySmtpAddressOrStandardUser);
        }
        Object.defineProperty(DelegateUser.prototype, "UserId", {
            get: function () {
                return this.userId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegateUser.prototype, "Permissions", {
            get: function () {
                return this.permissions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegateUser.prototype, "ReceiveCopiesOfMeetingMessages", {
            get: function () {
                return this.receiveCopiesOfMeetingMessages;
            },
            set: function (value) {
                this.receiveCopiesOfMeetingMessages = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegateUser.prototype, "ViewPrivateItems", {
            get: function () {
                return this.viewPrivateItems;
            },
            set: function (value) {
                this.viewPrivateItems = value;
            },
            enumerable: true,
            configurable: true
        });
        DelegateUser.prototype.constructor_0 = function () {
            this.receiveCopiesOfMeetingMessages = false;
            this.viewPrivateItems = false;
        };
        DelegateUser.prototype.constructor_1 = function (primarySmtpAddress) {
            this.constructor_0();
            this.userId.PrimarySmtpAddress = primarySmtpAddress;
        };
        DelegateUser.prototype.constructor_2 = function (standardUser) {
            this.constructor_0();
            this.userId.StandardUser = new Nullable(standardUser);
        };
        DelegateUser.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "UserId") {
                    this.userId = new UserId();
                    this.userId.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "DelegatePermissions") {
                    this.permissions.Reset();
                    this.permissions.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "ReceiveCopiesOfMeetingMessages") {
                    this.receiveCopiesOfMeetingMessages = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ViewPrivateItems") {
                    this.viewPrivateItems = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        DelegateUser.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "UserId")) {
                            if (!(a === "DelegatePermissions")) {
                                if (!(a === "ReceiveCopiesOfMeetingMessages")) {
                                    if (a === "ViewPrivateItems") {
                                        this.viewPrivateItems = jsonProperty.ReadAsBool(current);
                                    }
                                }
                                else {
                                    this.receiveCopiesOfMeetingMessages = jsonProperty.ReadAsBool(current);
                                }
                            }
                            else {
                                this.permissions.Reset();
                                this.permissions.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            }
                        }
                        else {
                            this.userId = new UserId();
                            this.userId.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        DelegateUser.prototype.WriteElementsToXml = function (writer) {
            this.UserId.WriteToXml(writer, "UserId");
            this.Permissions.WriteToXml(writer, "DelegatePermissions");
            writer.WriteElementValue(XmlNamespace.Types, "ReceiveCopiesOfMeetingMessages", this.ReceiveCopiesOfMeetingMessages);
            writer.WriteElementValue(XmlNamespace.Types, "ViewPrivateItems", this.ViewPrivateItems);
        };
        DelegateUser.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserId", this.UserId.InternalToJson(service));
            jsonObject.Add("DelegatePermissions", this.Permissions.InternalToJson(service));
            jsonObject.Add("ReceiveCopiesOfMeetingMessages", this.ReceiveCopiesOfMeetingMessages);
            jsonObject.Add("ViewPrivateItems", this.ViewPrivateItems);
            return jsonObject;
        };
        DelegateUser.prototype.InternalValidate = function () {
            if (this.UserId === null) {
                throw new ServiceValidationException(Strings.UserIdForDelegateUserNotSpecified);
            }
            if (!this.UserId.IsValid()) {
                throw new ServiceValidationException(Strings.DelegateUserHasInvalidUserId);
            }
        };
        DelegateUser.prototype.ValidateAddDelegate = function () {
            this.permissions.ValidateAddDelegate();
        };
        DelegateUser.prototype.ValidateUpdateDelegate = function () {
            this.permissions.ValidateUpdateDelegate();
        };
        return DelegateUser;
    }(ComplexProperty));
    var DeletedOccurrenceInfo = (function (_super) {
        __extends(DeletedOccurrenceInfo, _super);
        function DeletedOccurrenceInfo() {
            _super.call(this);
            this.originalStart = null;
        }
        Object.defineProperty(DeletedOccurrenceInfo.prototype, "OriginalStart", {
            get: function () {
                return this.originalStart;
            },
            enumerable: true,
            configurable: true
        });
        DeletedOccurrenceInfo.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Start") {
                this.originalStart = reader.ReadElementValueAsDateTime().Value;
                return true;
            }
            return false;
        };
        DeletedOccurrenceInfo.prototype.LoadFromJson = function (jsonProperty, service) {
            if (jsonProperty.ContainsKey("Start")) {
                this.originalStart = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString("Start")).Value;
            }
        };
        return DeletedOccurrenceInfo;
    }(ComplexProperty));
    var DeletedOccurrenceInfoCollection = (function (_super) {
        __extends(DeletedOccurrenceInfoCollection, _super);
        function DeletedOccurrenceInfoCollection() {
            _super.call(this);
        }
        DeletedOccurrenceInfoCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === "DeletedOccurrence") {
                return new DeletedOccurrenceInfo();
            }
            return null;
        };
        DeletedOccurrenceInfoCollection.prototype.CreateDefaultComplexProperty = function () {
            return new DeletedOccurrenceInfo();
        };
        DeletedOccurrenceInfoCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Occurrence";
        };
        return DeletedOccurrenceInfoCollection;
    }(ComplexPropertyCollection));
    var DictionaryEntryProperty = (function (_super) {
        __extends(DictionaryEntryProperty, _super);
        function DictionaryEntryProperty(key) {
            _super.call(this);
            this.key = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(key);
        }
        Object.defineProperty(DictionaryEntryProperty.prototype, "Key", {
            get: function () {
                return this.key;
            },
            set: function (value) {
                this.key = value;
            },
            enumerable: true,
            configurable: true
        });
        DictionaryEntryProperty.prototype.constructor_0 = function () {
        };
        DictionaryEntryProperty.prototype.constructor_1 = function (key) {
            this.key = key;
        };
        DictionaryEntryProperty.prototype.ReadAttributesFromXml = function (reader) {
            this.key = reader.ReadAttributeValue("Key");
        };
        DictionaryEntryProperty.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Key", this.Key);
        };
        DictionaryEntryProperty.prototype.WriteSetUpdateToXml = function (writer, ewsObject, ownerDictionaryXmlElementName) {
            return false;
        };
        DictionaryEntryProperty.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            return false;
        };
        DictionaryEntryProperty.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            return false;
        };
        DictionaryEntryProperty.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            return false;
        };
        return DictionaryEntryProperty;
    }(ComplexProperty));
    var DictionaryProperty = (function (_super) {
        __extends(DictionaryProperty, _super);
        function DictionaryProperty() {
            _super.call(this);
            this.entries = new Dictionary();
            this.removedEntries = new Dictionary();
            this.addedEntries = new List();
            this.modifiedEntries = new List();
        }
        Object.defineProperty(DictionaryProperty.prototype, "Entries", {
            get: function () {
                return this.entries;
            },
            enumerable: true,
            configurable: true
        });
        DictionaryProperty.prototype.EntryChanged = function (complexProperty) {
            var tEntry = ((complexProperty instanceof TEntry) ? complexProperty : null);
            var key = tEntry.Key;
            if (!this.addedEntries.Contains(key) && !this.modifiedEntries.Contains(key)) {
                this.modifiedEntries.Add(key);
                this.Changed();
            }
        };
        DictionaryProperty.prototype.WriteUriToXml = function (writer, key) {
            writer.WriteStartElement(XmlNamespace.Types, "IndexedFieldURI");
            writer.WriteAttributeValue("FieldURI", this.GetFieldURI());
            writer.WriteAttributeValue("FieldIndex", this.GetFieldIndex(key));
            writer.WriteEndElement();
        };
        DictionaryProperty.prototype.WriteUriToJson = function (key) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter("DictionaryPropertyUri");
            jsonObject.Add("FieldURI", this.GetFieldURI());
            jsonObject.Add("FieldIndex", this.GetFieldIndex(key));
            return jsonObject;
        };
        DictionaryProperty.prototype.GetFieldIndex = function (key) {
            return key.ToString();
        };
        DictionaryProperty.prototype.GetFieldURI = function () {
            return null;
        };
        DictionaryProperty.prototype.CreateEntry = function (reader) {
            if (reader.LocalName === "Entry") {
                return this.CreateEntryInstance();
            }
            return null;
        };
        DictionaryProperty.prototype.CreateEntryInstance = function () {
            throw new NotSupportedException();
        };
        DictionaryProperty.prototype.GetEntryXmlElementName = function (entry) {
            return "Entry";
        };
        DictionaryProperty.prototype.ClearChangeLog = function () {
            this.addedEntries.Clear();
            this.removedEntries.Clear();
            this.modifiedEntries.Clear();
            var enumerator = this.entries.Values.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.ClearChangeLog();
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        DictionaryProperty.prototype.InternalAdd = function (entry) {
            entry.OnChange.Add(this.EntryChanged);
            this.entries.Add(entry.Key, entry);
            this.addedEntries.Add(entry.Key);
            this.removedEntries.Remove(entry.Key);
            this.Changed();
        };
        DictionaryProperty.prototype.InternalAddOrReplace = function (entry) {
            var _this = this;
            var tEntry;
            if ((function () {
                var _p0 = [
                    tEntry
                ];
                var _r = _this.entries.TryGetValue(entry.Key, _p0);
                tEntry = _p0[0];
                return _r;
            })()) {
                tEntry.OnChange.Remove(this.EntryChanged);
                entry.OnChange.Add(this.EntryChanged);
                if (!this.addedEntries.Contains(entry.Key) && !this.modifiedEntries.Contains(entry.Key)) {
                    this.modifiedEntries.Add(entry.Key);
                }
                this.Changed();
                return;
            }
            this.InternalAdd(entry);
        };
        DictionaryProperty.prototype.InternalRemove = function (key) {
            var _this = this;
            var tEntry;
            if ((function () {
                var _p0 = [
                    tEntry
                ];
                var _r = _this.entries.TryGetValue(key, _p0);
                tEntry = _p0[0];
                return _r;
            })()) {
                tEntry.OnChange.Remove(this.EntryChanged);
                this.entries.Remove(key);
                this.removedEntries.Add(key, tEntry);
                this.Changed();
            }
            this.addedEntries.Remove(key);
        };
        DictionaryProperty.prototype.LoadFromXml = function (reader, localElementName) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, localElementName);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        var tEntry = this.CreateEntry(reader);
                        if (tEntry !== null) {
                            tEntry.LoadFromXml(reader, reader.LocalName);
                            this.InternalAdd(tEntry);
                        }
                        else {
                            reader.SkipCurrentElement();
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, localElementName));
            }
        };
        DictionaryProperty.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject !== null) {
                    var entry = this.CreateEntryInstance();
                    entry.LoadFromJson(jsonObject, service);
                    this.InternalAdd(entry);
                }
            }
        };
        DictionaryProperty.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        DictionaryProperty.prototype.WriteToXml = function (writer, xmlNamespace, xmlElementName) {
            if (this.entries.Count > 0) {
                _super.prototype.WriteToXml.call(this, writer, xmlNamespace, xmlElementName);
            }
        };
        DictionaryProperty.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.entries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var value = current.Value;
                    value.WriteToXml(writer, this.GetEntryXmlElementName(current.Value));
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        DictionaryProperty.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = this.entries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var arg_33_0 = list;
                    var value = current.Value;
                    arg_33_0.Add(value.InternalToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list.ToArray();
        };
        DictionaryProperty.prototype.Contains = function (key) {
            return this.Entries.ContainsKey(key);
        };
        DictionaryProperty.prototype.WriteSetUpdateToXml = function (writer, ewsObject, propertyDefinition) {
            var list = new List();
            var enumerator = this.addedEntries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(this.entries.get_Item(current));
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.modifiedEntries.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    list.Add(this.entries.get_Item(current2));
                }
            }
            finally {
                enumerator2.Dispose();
            }
            var enumerator3 = list.GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    if (!current3.WriteSetUpdateToXml(writer, ewsObject, propertyDefinition.XmlElementName)) {
                        writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetSetFieldXmlElementName());
                        this.WriteUriToXml(writer, current3.Key);
                        writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetXmlElementName());
                        writer.WriteStartElement(XmlNamespace.Types, propertyDefinition.XmlElementName);
                        current3.WriteToXml(writer, this.GetEntryXmlElementName(current3));
                        writer.WriteEndElement();
                        writer.WriteEndElement();
                        writer.WriteEndElement();
                    }
                }
            }
            finally {
                enumerator3.Dispose();
            }
            var enumerator4 = this.removedEntries.Values.GetEnumerator();
            try {
                while (enumerator4.MoveNext()) {
                    var current4 = enumerator4.Current;
                    if (!current4.WriteDeleteUpdateToXml(writer, ewsObject)) {
                        writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
                        this.WriteUriToXml(writer, current4.Key);
                        writer.WriteEndElement();
                    }
                }
            }
            finally {
                enumerator4.Dispose();
            }
            return true;
        };
        DictionaryProperty.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            var list = new List();
            var enumerator = this.addedEntries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(this.entries.get_Item(current));
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.modifiedEntries.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    list.Add(this.entries.get_Item(current2));
                }
            }
            finally {
                enumerator2.Dispose();
            }
            var enumerator3 = list.GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    if (!current3.WriteSetUpdateToJson(service, ewsObject, propertyDefinition, updates)) {
                        var jsonObject = new JsonObject();
                        jsonObject.AddTypeParameter(ewsObject.GetSetFieldXmlElementName());
                        var jsonObject2 = new JsonObject();
                        jsonObject2.AddTypeParameter("DictionaryPropertyUri");
                        jsonObject2.Add("FieldURI", this.GetFieldURI());
                        var arg_112_0 = jsonObject2;
                        var arg_112_1 = "FieldIndex";
                        var key = current3.Key;
                        arg_112_0.Add(arg_112_1, key.ToString());
                        jsonObject.Add("Path", jsonObject2);
                        var obj = current3.InternalToJson(service);
                        var jsonObject3 = new JsonObject();
                        jsonObject3.AddTypeParameter(ewsObject.GetXmlElementName());
                        jsonObject3.Add(propertyDefinition.XmlElementName, NArray.ToEnumerable([
                            obj
                        ]));
                        jsonObject.Add(PropertyBag.GetPropertyUpdateItemName(ewsObject), jsonObject3);
                        updates.Add(jsonObject);
                    }
                }
            }
            finally {
                enumerator3.Dispose();
            }
            var enumerator4 = this.removedEntries.Values.GetEnumerator();
            try {
                while (enumerator4.MoveNext()) {
                    var current4 = enumerator4.Current;
                    if (!current4.WriteDeleteUpdateToJson(service, ewsObject, updates)) {
                        var jsonObject4 = new JsonObject();
                        jsonObject4.AddTypeParameter(ewsObject.GetDeleteFieldXmlElementName());
                        var jsonObject5 = new JsonObject();
                        jsonObject5.AddTypeParameter("DictionaryPropertyUri");
                        jsonObject5.Add("FieldURI", this.GetFieldURI());
                        var arg_229_0 = jsonObject5;
                        var arg_229_1 = "FieldIndex";
                        var key2 = current4.Key;
                        arg_229_0.Add(arg_229_1, key2.ToString());
                        jsonObject4.Add("Path", jsonObject5);
                        updates.Add(jsonObject4);
                    }
                }
            }
            finally {
                enumerator4.Dispose();
            }
            return true;
        };
        DictionaryProperty.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            return false;
        };
        DictionaryProperty.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            return false;
        };
        return DictionaryProperty;
    }(ComplexProperty));
    var EmailAddressCollection = (function (_super) {
        __extends(EmailAddressCollection, _super);
        function EmailAddressCollection(collectionItemXmlElementName) {
            _super.call(this);
            this.collectionItemXmlElementName = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(collectionItemXmlElementName);
        }
        EmailAddressCollection.prototype.constructor_0 = function () {
            this.constructor_1("Mailbox");
        };
        EmailAddressCollection.prototype.constructor_1 = function (collectionItemXmlElementName) {
            this.collectionItemXmlElementName = collectionItemXmlElementName;
        };
        EmailAddressCollection.prototype.Add = function (emailAddressOrSmtpAddressOrName, smtpAddress) {
            if (arguments.length === 1 && (emailAddressOrSmtpAddressOrName === null || emailAddressOrSmtpAddressOrName instanceof EmailAddress)) {
                this.Add_0(emailAddressOrSmtpAddressOrName);
                return;
            }
            if (arguments.length === 1 && (emailAddressOrSmtpAddressOrName === null || emailAddressOrSmtpAddressOrName.constructor === String)) {
                this.Add_1(emailAddressOrSmtpAddressOrName);
                return;
            }
            this.Add_2(emailAddressOrSmtpAddressOrName, smtpAddress);
        };
        EmailAddressCollection.prototype.Add_0 = function (emailAddress) {
            _super.prototype.InternalAdd.call(this, emailAddress);
        };
        EmailAddressCollection.prototype.AddRange = function (emailAddressesOrSmtpAddresses) {
            if (arguments.length === 1) {
                this.AddRange_0(emailAddressesOrSmtpAddresses);
                return;
            }
            this.AddRange_1(emailAddressesOrSmtpAddresses);
        };
        EmailAddressCollection.prototype.AddRange_0 = function (emailAddresses) {
            var enumerator = emailAddresses.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        EmailAddressCollection.prototype.Add_1 = function (smtpAddress) {
            var emailAddress = new EmailAddress(smtpAddress);
            this.Add(emailAddress);
            return emailAddress;
        };
        EmailAddressCollection.prototype.AddRange_1 = function (smtpAddresses) {
            var enumerator = smtpAddresses.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        EmailAddressCollection.prototype.Add_2 = function (name, smtpAddress) {
            var emailAddress = new EmailAddress(name, smtpAddress);
            this.Add(emailAddress);
            return emailAddress;
        };
        EmailAddressCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
        };
        EmailAddressCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        EmailAddressCollection.prototype.Remove = function (emailAddress) {
            EwsUtilities.ValidateParam(emailAddress, "emailAddress");
            return _super.prototype.InternalRemove.call(this, emailAddress);
        };
        EmailAddressCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === this.collectionItemXmlElementName) {
                return new EmailAddress();
            }
            return null;
        };
        EmailAddressCollection.prototype.CreateDefaultComplexProperty = function () {
            return new EmailAddress();
        };
        EmailAddressCollection.prototype.GetCollectionItemXmlElementName = function (emailAddress) {
            return this.collectionItemXmlElementName;
        };
        EmailAddressCollection.prototype.ShouldWriteToRequest = function () {
            return true;
        };
        return EmailAddressCollection;
    }(ComplexPropertyCollection));
    var EmailAddressDictionary = (function (_super) {
        __extends(EmailAddressDictionary, _super);
        function EmailAddressDictionary() {
            _super.call(this);
        }
        EmailAddressDictionary.prototype.get_Item = function (key) {
            return this.Entries.get_Item(key).EmailAddress;
        };
        EmailAddressDictionary.prototype.set_Item = function (key, value) {
            var _this = this;
            if (value === null) {
                _super.prototype.InternalRemove.call(this, key);
                return;
            }
            var emailAddressEntry;
            if ((function () {
                var _p0 = [
                    emailAddressEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                emailAddressEntry = _p0[0];
                return _r;
            })()) {
                emailAddressEntry.EmailAddress = value;
                this.Changed();
                return;
            }
            emailAddressEntry = new EmailAddressEntry(key, value);
            _super.prototype.InternalAdd.call(this, emailAddressEntry);
        };
        EmailAddressDictionary.prototype.GetFieldURI = function () {
            return "contacts:EmailAddress";
        };
        EmailAddressDictionary.prototype.CreateEntryInstance = function () {
            return new EmailAddressEntry();
        };
        EmailAddressDictionary.prototype.TryGetValue = function (key, emailAddress) {
            var _this = this;
            var emailAddressEntry = null;
            if ((function () {
                var _p0 = [
                    emailAddressEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                emailAddressEntry = _p0[0];
                return _r;
            })()) {
                emailAddress[0] = emailAddressEntry.EmailAddress;
                return true;
            }
            emailAddress[0] = null;
            return false;
        };
        return EmailAddressDictionary;
    }(DictionaryProperty));
    var EmailAddressEntity = (function (_super) {
        __extends(EmailAddressEntity, _super);
        function EmailAddressEntity() {
            _super.call(this);
            this.EmailAddress = null;
        }
        EmailAddressEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "EmailAddress") {
                this.EmailAddress = reader.ReadElementValue();
                return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return EmailAddressEntity;
    }(ExtractedEntity));
    var EmailAddressEntityCollection = (function (_super) {
        __extends(EmailAddressEntityCollection, _super);
        function EmailAddressEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        EmailAddressEntityCollection.prototype.constructor_0 = function () {
        };
        EmailAddressEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        EmailAddressEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new EmailAddressEntity();
        };
        EmailAddressEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new EmailAddressEntity();
        };
        EmailAddressEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "EmailAddress";
        };
        return EmailAddressEntityCollection;
    }(ComplexPropertyCollection));
    var EmailAddressEntry = (function (_super) {
        __extends(EmailAddressEntry, _super);
        function EmailAddressEntry(key, emailAddress) {
            _super.call(this);
            this.emailAddress = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(key, emailAddress);
        }
        Object.defineProperty(EmailAddressEntry.prototype, "EmailAddress", {
            get: function () {
                return this.emailAddress;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.emailAddress
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.emailAddress = _p0[0];
                    return _r;
                })();
                if (this.emailAddress !== null) {
                    this.emailAddress.OnChange.Add(this.EmailAddressChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        EmailAddressEntry.prototype.constructor_0 = function () {
            this.emailAddress = new EmailAddress();
            this.emailAddress.OnChange.Add(this.EmailAddressChanged);
        };
        EmailAddressEntry.prototype.constructor_1 = function (key, emailAddress) {
            this.emailAddress = emailAddress;
            if (this.emailAddress !== null) {
                this.emailAddress.OnChange.Add(this.EmailAddressChanged);
            }
        };
        EmailAddressEntry.prototype.ReadAttributesFromXml = function (reader) {
            _super.prototype.ReadAttributesFromXml.call(this, reader);
            this.EmailAddress.Name = reader.ReadAttributeValue("Name");
            this.EmailAddress.RoutingType = reader.ReadAttributeValue("RoutingType");
            var value = reader.ReadAttributeValue("MailboxType");
            if (!NString.IsNullOrEmpty(value)) {
                this.EmailAddress.MailboxType = new Nullable(EwsUtilities.Parse(value));
                return;
            }
            this.EmailAddress.MailboxType = null;
        };
        EmailAddressEntry.prototype.ReadTextValueFromXml = function (reader) {
            this.EmailAddress.Address = reader.ReadValue();
        };
        EmailAddressEntry.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Key")) {
                            if (!(a === "Name")) {
                                if (!(a === "RoutingType")) {
                                    if (!(a === "MailboxType")) {
                                        if (a === "EmailAddress") {
                                            this.EmailAddress.Address = jsonProperty.ReadAsString(current);
                                        }
                                    }
                                    else {
                                        this.EmailAddress.MailboxType = new Nullable(jsonProperty.ReadEnumValue(current));
                                    }
                                }
                                else {
                                    this.EmailAddress.RoutingType = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.EmailAddress.Name = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.Key = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        EmailAddressEntry.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            if (writer.Service.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                writer.WriteAttributeValue("Name", this.EmailAddress.Name);
                writer.WriteAttributeValue("RoutingType", this.EmailAddress.RoutingType);
                if (this.EmailAddress.MailboxType !== MailboxType.Unknown) {
                    writer.WriteAttributeValue("MailboxType", this.EmailAddress.MailboxType);
                }
            }
        };
        EmailAddressEntry.prototype.WriteElementsToXml = function (writer) {
            writer.WriteValue(this.EmailAddress.Address, "EmailAddress");
        };
        EmailAddressEntry.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Key", this.Key);
            jsonObject.Add("Name", this.EmailAddress.Name);
            jsonObject.Add("RoutingType", this.EmailAddress.RoutingType);
            if (this.EmailAddress.MailboxType !== null) {
                jsonObject.Add("MailboxType", this.EmailAddress.MailboxType.Value);
            }
            jsonObject.Add("EmailAddress", this.EmailAddress.Address);
            return jsonObject;
        };
        EmailAddressEntry.prototype.EmailAddressChanged = function (complexProperty) {
            this.Changed();
        };
        return EmailAddressEntry;
    }(DictionaryEntryProperty));
    var EmailUserEntity = (function (_super) {
        __extends(EmailUserEntity, _super);
        function EmailUserEntity() {
            _super.call(this);
            this.Name = null;
            this.UserId = null;
            this.Namespace = XmlNamespace.Types;
        }
        EmailUserEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Name") {
                    this.Name = reader.ReadElementValue();
                    return true;
                }
                if (localName === "UserId") {
                    this.UserId = reader.ReadElementValue();
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return EmailUserEntity;
    }(ComplexProperty));
    var EmailUserEntityCollection = (function (_super) {
        __extends(EmailUserEntityCollection, _super);
        function EmailUserEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        EmailUserEntityCollection.prototype.constructor_0 = function () {
        };
        EmailUserEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        EmailUserEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new EmailUserEntity();
        };
        EmailUserEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new EmailUserEntity();
        };
        EmailUserEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "EmailUser";
        };
        return EmailUserEntityCollection;
    }(ComplexPropertyCollection));
    var EnhancedLocation = (function (_super) {
        __extends(EnhancedLocation, _super);
        function EnhancedLocation(displayName, annotation, personaPostalAddress) {
            _super.call(this);
            this.displayName = null;
            this.annotation = null;
            this.personaPostalAddress = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (displayName === null || displayName.constructor === String)) {
                this.constructor_1(displayName);
                return;
            }
            if (arguments.length === 2 && (displayName === null || displayName.constructor === String) && (annotation === null || annotation.constructor === String)) {
                this.constructor_2(displayName, annotation);
                return;
            }
            this.constructor_3(displayName, annotation, personaPostalAddress);
        }
        Object.defineProperty(EnhancedLocation.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.displayName
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.displayName = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EnhancedLocation.prototype, "Annotation", {
            get: function () {
                return this.annotation;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.annotation
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.annotation = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EnhancedLocation.prototype, "PersonaPostalAddress", {
            get: function () {
                return this.personaPostalAddress;
            },
            set: function (value) {
                var _this = this;
                if (!NObject.GenericEquals(this.personaPostalAddress, value)) {
                    if (this.personaPostalAddress !== null) {
                        this.personaPostalAddress.OnChange.Remove(this.PersonaPostalAddress_OnChange);
                    }
                    (function () {
                        var _p0 = [
                            _this.personaPostalAddress
                        ];
                        var _r = _this.SetFieldValue(_p0, value);
                        _this.personaPostalAddress = _p0[0];
                        return _r;
                    })();
                    this.personaPostalAddress.OnChange.Add(this.PersonaPostalAddress_OnChange);
                }
            },
            enumerable: true,
            configurable: true
        });
        EnhancedLocation.prototype.constructor_0 = function () {
        };
        EnhancedLocation.prototype.constructor_1 = function (displayName) {
            this.constructor_3(displayName, NString.Empty, new PersonaPostalAddress());
        };
        EnhancedLocation.prototype.constructor_2 = function (displayName, annotation) {
            this.constructor_3(displayName, annotation, new PersonaPostalAddress());
        };
        EnhancedLocation.prototype.constructor_3 = function (displayName, annotation, personaPostalAddress) {
            this.constructor_0();
            this.displayName = displayName;
            this.annotation = annotation;
            this.personaPostalAddress = personaPostalAddress;
            this.personaPostalAddress.OnChange.Add(this.PersonaPostalAddress_OnChange);
        };
        EnhancedLocation.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DisplayName") {
                    this.displayName = reader.ReadValue();
                    return true;
                }
                if (localName === "Annotation") {
                    this.annotation = reader.ReadValue();
                    return true;
                }
                if (localName === "PostalAddress") {
                    this.personaPostalAddress = new PersonaPostalAddress();
                    this.personaPostalAddress.LoadFromXml(reader);
                    this.personaPostalAddress.OnChange.Add(this.PersonaPostalAddress_OnChange);
                    return true;
                }
            }
            return false;
        };
        EnhancedLocation.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DisplayName")) {
                            if (!(a === "Annotation")) {
                                if (a === "PostalAddress") {
                                    this.personaPostalAddress = new PersonaPostalAddress();
                                    this.personaPostalAddress.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                    this.personaPostalAddress.OnChange.Add(this.PersonaPostalAddress_OnChange);
                                }
                            }
                            else {
                                this.annotation = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.displayName = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        EnhancedLocation.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "DisplayName", this.displayName);
            writer.WriteElementValue(XmlNamespace.Types, "Annotation", this.annotation);
            this.personaPostalAddress.WriteToXml(writer);
        };
        EnhancedLocation.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("DisplayName", this.displayName);
            jsonObject.Add("Annotation", this.annotation);
            if (this.personaPostalAddress !== null) {
                jsonObject.Add("PostalAddress", this.personaPostalAddress.InternalToJson(service));
            }
            return jsonObject;
        };
        EnhancedLocation.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            EwsUtilities.ValidateParam(this.displayName, "DisplayName");
            EwsUtilities.ValidateParamAllowNull(this.annotation, "Annotation");
            EwsUtilities.ValidateParamAllowNull(this.personaPostalAddress, "PersonaPostalAddress");
        };
        EnhancedLocation.prototype.PersonaPostalAddress_OnChange = function (complexProperty) {
            this.Changed();
        };
        return EnhancedLocation;
    }(ComplexProperty));
    var EntityExtractionResult = (function (_super) {
        __extends(EntityExtractionResult, _super);
        function EntityExtractionResult() {
            _super.call(this);
            this.Addresses = null;
            this.MeetingSuggestions = null;
            this.TaskSuggestions = null;
            this.EmailAddresses = null;
            this.Contacts = null;
            this.Urls = null;
            this.PhoneNumbers = null;
            this.Namespace = XmlNamespace.Types;
        }
        EntityExtractionResult.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Addresses":
                    this.Addresses = new AddressEntityCollection();
                    this.Addresses.LoadFromXml(reader, XmlNamespace.Types, "Addresses");
                    return true;
                case "MeetingSuggestions":
                    this.MeetingSuggestions = new MeetingSuggestionCollection();
                    this.MeetingSuggestions.LoadFromXml(reader, XmlNamespace.Types, "MeetingSuggestions");
                    return true;
                case "TaskSuggestions":
                    this.TaskSuggestions = new TaskSuggestionCollection();
                    this.TaskSuggestions.LoadFromXml(reader, XmlNamespace.Types, "TaskSuggestions");
                    return true;
                case "EmailAddresses":
                    this.EmailAddresses = new EmailAddressEntityCollection();
                    this.EmailAddresses.LoadFromXml(reader, XmlNamespace.Types, "EmailAddresses");
                    return true;
                case "Contacts":
                    this.Contacts = new ContactEntityCollection();
                    this.Contacts.LoadFromXml(reader, XmlNamespace.Types, "Contacts");
                    return true;
                case "Urls":
                    this.Urls = new UrlEntityCollection();
                    this.Urls.LoadFromXml(reader, XmlNamespace.Types, "Urls");
                    return true;
                case "PhoneNumbers":
                    this.PhoneNumbers = new PhoneEntityCollection();
                    this.PhoneNumbers.LoadFromXml(reader, XmlNamespace.Types, "PhoneNumbers");
                    return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return EntityExtractionResult;
    }(ComplexProperty));
    var ExtendedProperty = (function (_super) {
        __extends(ExtendedProperty, _super);
        function ExtendedProperty(propertyDefinition) {
            _super.call(this);
            this.propertyDefinition = null;
            this.value = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(propertyDefinition);
        }
        Object.defineProperty(ExtendedProperty.prototype, "PropertyDefinition", {
            get: function () {
                return this.propertyDefinition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedProperty.prototype, "Value", {
            get: function () {
                return this.value;
            },
            set: function (value) {
                var _this = this;
                EwsUtilities.ValidateParam(value, "value");
                (function () {
                    var _p0 = [
                        _this.value
                    ];
                    var _r = _this.SetFieldValue(_p0, MapiTypeConverter.ChangeType(_this.PropertyDefinition.MapiType, value));
                    _this.value = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        ExtendedProperty.prototype.constructor_0 = function () {
        };
        ExtendedProperty.prototype.constructor_1 = function (propertyDefinition) {
            this.constructor_0();
            EwsUtilities.ValidateParam(propertyDefinition, "propertyDefinition");
            this.propertyDefinition = propertyDefinition;
        };
        ExtendedProperty.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "ExtendedFieldURI") {
                    this.propertyDefinition = new ExtendedPropertyDefinition();
                    this.propertyDefinition.LoadFromXml(reader);
                    return true;
                }
                if (localName === "Value") {
                    EwsUtilities.Assert(ExtendedPropertyDefinition.op_Inequality(this.PropertyDefinition, null), "ExtendedProperty.TryReadElementFromXml", "PropertyDefintion is missing");
                    var stringValue = reader.ReadElementValue();
                    this.value = MapiTypeConverter.ConvertToValue(this.PropertyDefinition.MapiType, stringValue);
                    return true;
                }
                if (localName === "Values") {
                    EwsUtilities.Assert(ExtendedPropertyDefinition.op_Inequality(this.PropertyDefinition, null), "ExtendedProperty.TryReadElementFromXml", "PropertyDefintion is missing");
                    var stringList = new StringList("Value");
                    stringList.LoadFromXml(reader, reader.LocalName);
                    this.value = MapiTypeConverter.ConvertToValue(this.PropertyDefinition.MapiType, stringList);
                    return true;
                }
            }
            return false;
        };
        ExtendedProperty.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "ExtendedFieldURI")) {
                            if (!(a === "Value")) {
                                if (a === "Values") {
                                    EwsUtilities.Assert(ExtendedPropertyDefinition.op_Inequality(this.PropertyDefinition, null), "ExtendedProperty.TryReadElementFromXml", "PropertyDefintion is missing");
                                    var stringList = new StringList("Value");
                                    stringList.CreateFromJsonCollection(jsonProperty.ReadAsArray(current), service);
                                    this.value = MapiTypeConverter.ConvertToValue(this.PropertyDefinition.MapiType, stringList);
                                }
                            }
                            else {
                                EwsUtilities.Assert(ExtendedPropertyDefinition.op_Inequality(this.PropertyDefinition, null), "ExtendedProperty.TryReadElementFromXml", "PropertyDefintion is missing");
                                var stringValue = jsonProperty.ReadAsString(current);
                                this.value = MapiTypeConverter.ConvertToValue(this.PropertyDefinition.MapiType, stringValue);
                            }
                        }
                        else {
                            this.propertyDefinition = new ExtendedPropertyDefinition();
                            this.propertyDefinition.LoadFromJson(jsonProperty.ReadAsJsonObject(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        ExtendedProperty.prototype.WriteElementsToXml = function (writer) {
            this.PropertyDefinition.WriteToXml(writer);
            if (MapiTypeConverter.IsArrayType(this.PropertyDefinition.MapiType)) {
                var array = ((this.Value instanceof Array) ? this.Value : null);
                writer.WriteStartElement(XmlNamespace.Types, "Values");
                for (var i = array.GetLowerBound(0); i <= array.GetUpperBound(0); i = i + 1) {
                    writer.WriteElementValue(XmlNamespace.Types, "Value", MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, array.GetValue(i)));
                }
                writer.WriteEndElement();
                return;
            }
            writer.WriteElementValue(XmlNamespace.Types, "Value", MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, this.Value));
        };
        ExtendedProperty.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            var jsonPropertyDefinition = new JsonObject();
            this.PropertyDefinition.AddJsonProperties(jsonPropertyDefinition, service);
            jsonObject.Add("ExtendedFieldURI", jsonPropertyDefinition);
            if (MapiTypeConverter.IsArrayType(this.PropertyDefinition.MapiType)) {
                var list = new List();
                var enumerator = (((this.Value instanceof Array) ? this.Value : null)).GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        list.Add(MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, current));
                    }
                }
                finally {
                    var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                    if (disposable !== null) {
                        disposable.Dispose();
                    }
                }
                jsonObject.Add("Values", NArray.ToEnumerable(list.ToArray()));
            }
            else {
                jsonObject.Add("Value", MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, this.Value));
            }
            return jsonObject;
        };
        ExtendedProperty.prototype.GetStringValue = function () {
            if (!MapiTypeConverter.IsArrayType(this.PropertyDefinition.MapiType)) {
                return MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, this.Value);
            }
            var array = ((this.Value instanceof Array) ? this.Value : null);
            if (array === null) {
                return NString.Empty;
            }
            var stringBuilder = new StringBuilder();
            stringBuilder.Append("[");
            for (var i = array.GetLowerBound(0); i <= array.GetUpperBound(0); i = i + 1) {
                stringBuilder.Append(MapiTypeConverter.ConvertToString(this.PropertyDefinition.MapiType, array.GetValue(i)));
                stringBuilder.Append(",");
            }
            stringBuilder.Append("]");
            return stringBuilder.ToString();
        };
        ExtendedProperty.prototype.Equals = function (obj) {
            var extendedProperty = ((obj instanceof ExtendedProperty) ? obj : null);
            return extendedProperty !== null && NObject.GenericEquals(extendedProperty.PropertyDefinition, this.PropertyDefinition) && this.GetStringValue() === extendedProperty.GetStringValue();
        };
        ExtendedProperty.prototype.GetHashCode = function () {
            return ((ExtendedPropertyDefinition.op_Inequality(this.PropertyDefinition, null) ? this.PropertyDefinition.GetPrintableName() : NString.Empty) + this.GetStringValue()).GetHashCode();
        };
        return ExtendedProperty;
    }(ComplexProperty));
    var ExtendedPropertyCollection = (function (_super) {
        __extends(ExtendedPropertyCollection, _super);
        function ExtendedPropertyCollection() {
            _super.call(this);
        }
        ExtendedPropertyCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new ExtendedProperty();
        };
        ExtendedPropertyCollection.prototype.CreateDefaultComplexProperty = function () {
            return new ExtendedProperty();
        };
        ExtendedPropertyCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return null;
        };
        ExtendedPropertyCollection.prototype.LoadFromXml = function (reader, localElementName) {
            var extendedProperty = new ExtendedProperty();
            extendedProperty.LoadFromXml(reader, reader.LocalName);
            _super.prototype.InternalAdd.call(this, extendedProperty);
        };
        ExtendedPropertyCollection.prototype.WriteToXml = function (writer, xmlElementName) {
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, "ExtendedProperty");
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        ExtendedPropertyCollection.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return list.ToArray();
        };
        ExtendedPropertyCollection.prototype.GetOrAddExtendedProperty = function (propertyDefinition) {
            var _this = this;
            var extendedProperty;
            if (!(function () {
                var _p0 = [
                    extendedProperty
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                extendedProperty = _p0[0];
                return _r;
            })()) {
                extendedProperty = new ExtendedProperty(propertyDefinition);
                _super.prototype.InternalAdd.call(this, extendedProperty);
            }
            return extendedProperty;
        };
        ExtendedPropertyCollection.prototype.SetExtendedProperty = function (propertyDefinition, value) {
            var orAddExtendedProperty = this.GetOrAddExtendedProperty(propertyDefinition);
            orAddExtendedProperty.Value = value;
        };
        ExtendedPropertyCollection.prototype.RemoveExtendedProperty = function (propertyDefinition) {
            var _this = this;
            EwsUtilities.ValidateParam(propertyDefinition, "propertyDefinition");
            var complexProperty;
            return (function () {
                var _p0 = [
                    complexProperty
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                complexProperty = _p0[0];
                return _r;
            })() && _super.prototype.InternalRemove.call(this, complexProperty);
        };
        ExtendedPropertyCollection.prototype.TryGetProperty = function (propertyDefinition, extendedProperty) {
            extendedProperty[0] = this.Items.Find(function (prop) { return NObject.GenericEquals(prop.PropertyDefinition, propertyDefinition); });
            return extendedProperty[0] !== null;
        };
        ExtendedPropertyCollection.prototype.TryGetValue = function (propertyDefinition, propertyValue) {
            var _this = this;
            var extendedProperty;
            if (!(function () {
                var _p0 = [
                    extendedProperty
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                extendedProperty = _p0[0];
                return _r;
            })()) {
                propertyValue[0] = null;
                return false;
            }
            if (!new Type("T").IsAssignableFrom(propertyDefinition.Type)) {
                var message = NString.Format(Strings.PropertyDefinitionTypeMismatch, EwsUtilities.GetPrintableTypeName(propertyDefinition.Type), EwsUtilities.GetPrintableTypeName(new Type("T")));
                throw new ArgumentException(message, "propertyDefinition");
            }
            propertyValue[0] = extendedProperty.Value;
            return true;
        };
        ExtendedPropertyCollection.prototype.WriteSetUpdateToXml = function (writer, ewsObject, propertyDefinition) {
            var list = new List();
            list.AddRange(this.AddedItems);
            list.AddRange(this.ModifiedItems);
            var enumerator = list.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetSetFieldXmlElementName());
                    current.PropertyDefinition.WriteToXml(writer);
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetXmlElementName());
                    current.WriteToXml(writer, "ExtendedProperty");
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.RemovedItems.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
                    current2.PropertyDefinition.WriteToXml(writer);
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator2.Dispose();
            }
            return true;
        };
        ExtendedPropertyCollection.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            var list = new List();
            list.AddRange(this.AddedItems);
            list.AddRange(this.ModifiedItems);
            var enumerator = list.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    updates.Add(PropertyBag.CreateJsonSetUpdate(current, service, ewsObject));
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.RemovedItems.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    updates.Add(PropertyBag.CreateJsonDeleteUpdate(current2.PropertyDefinition, service, ewsObject));
                }
            }
            finally {
                enumerator2.Dispose();
            }
            return true;
        };
        ExtendedPropertyCollection.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
                    current.PropertyDefinition.WriteToXml(writer);
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
            return true;
        };
        ExtendedPropertyCollection.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    updates.Add(PropertyBag.CreateJsonDeleteUpdate(current.PropertyDefinition, service, ewsObject));
                }
            }
            finally {
                enumerator.Dispose();
            }
            return true;
        };
        return ExtendedPropertyCollection;
    }(ComplexPropertyCollection));
    var FileAttachment = (function (_super) {
        __extends(FileAttachment, _super);
        function FileAttachment(ownerOrService) {
            _super.call(this, ownerOrService);
            this.fileName = null;
            this.contentStream = null;
            this.content = null;
            this.loadToStream = null;
            this.isContactPhoto = false;
            if (arguments.length === 1 && (ownerOrService === null || ownerOrService instanceof Item)) {
                this.constructor_0(ownerOrService);
                return;
            }
            this.constructor_1(ownerOrService);
        }
        Object.defineProperty(FileAttachment.prototype, "FileName", {
            get: function () {
                return this.fileName;
            },
            set: function (value) {
                _super.prototype.ThrowIfThisIsNotNew.call(this);
                this.fileName = value;
                this.content = null;
                this.contentStream = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileAttachment.prototype, "ContentStream", {
            get: function () {
                return this.contentStream;
            },
            set: function (value) {
                _super.prototype.ThrowIfThisIsNotNew.call(this);
                this.contentStream = value;
                this.content = null;
                this.fileName = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileAttachment.prototype, "Content", {
            get: function () {
                return this.content;
            },
            set: function (value) {
                _super.prototype.ThrowIfThisIsNotNew.call(this);
                this.content = value;
                this.fileName = null;
                this.contentStream = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FileAttachment.prototype, "IsContactPhoto", {
            get: function () {
                EwsUtilities.ValidatePropertyVersion(this.Service, ExchangeVersion.Exchange2010, "IsContactPhoto");
                return this.isContactPhoto;
            },
            set: function (value) {
                EwsUtilities.ValidatePropertyVersion(this.Service, ExchangeVersion.Exchange2010, "IsContactPhoto");
                _super.prototype.ThrowIfThisIsNotNew.call(this);
                this.isContactPhoto = value;
            },
            enumerable: true,
            configurable: true
        });
        FileAttachment.prototype.constructor_0 = function (owner) {
        };
        FileAttachment.prototype.constructor_1 = function (service) {
        };
        FileAttachment.prototype.GetXmlElementName = function () {
            return "FileAttachment";
        };
        FileAttachment.prototype.Validate = function (attachmentIndex) {
            if (NString.IsNullOrEmpty(this.fileName) && this.content === null && this.contentStream === null) {
                throw new ServiceValidationException(NString.Format(Strings.FileAttachmentContentIsNotSet, attachmentIndex));
            }
        };
        FileAttachment.prototype.TryReadElementFromXml = function (reader) {
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag) {
                if (reader.LocalName === "IsContactPhoto") {
                    this.isContactPhoto = reader.ReadElementValue();
                }
                else {
                    if (reader.LocalName === "Content") {
                        if (this.loadToStream !== null) {
                            reader.ReadBase64ElementValue(this.loadToStream);
                        }
                        else {
                            if (reader.Service.FileAttachmentContentHandler !== null) {
                                var outputStream = reader.Service.FileAttachmentContentHandler.GetOutputStream(this.Id);
                                if (outputStream !== null) {
                                    reader.ReadBase64ElementValue(outputStream);
                                }
                                else {
                                    this.content = reader.ReadBase64ElementValue();
                                }
                            }
                            else {
                                this.content = reader.ReadBase64ElementValue();
                            }
                        }
                        flag = true;
                    }
                }
            }
            return flag;
        };
        FileAttachment.prototype.TryReadElementFromXmlToPatch = function (reader) {
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        FileAttachment.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "IsContactPhoto")) {
                            if (a === "Content") {
                                if (this.loadToStream !== null) {
                                    jsonProperty.ReadAsBase64Content(current, this.loadToStream);
                                }
                                else {
                                    if (service.FileAttachmentContentHandler !== null) {
                                        var outputStream = service.FileAttachmentContentHandler.GetOutputStream(this.Id);
                                        if (outputStream !== null) {
                                            jsonProperty.ReadAsBase64Content(current, outputStream);
                                        }
                                        else {
                                            this.content = jsonProperty.ReadAsBase64Content(current);
                                        }
                                    }
                                    else {
                                        this.content = jsonProperty.ReadAsBase64Content(current);
                                    }
                                }
                            }
                        }
                        else {
                            this.isContactPhoto = jsonProperty.ReadAsBool(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        FileAttachment.prototype.WriteElementsToXml = function (writer) {
            var IL_A2 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        _super.prototype.WriteElementsToXml.call(this, writer);
                        if (writer.Service.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                            writer.WriteElementValue(XmlNamespace.Types, "IsContactPhoto", this.isContactPhoto);
                        }
                        writer.WriteStartElement(XmlNamespace.Types, "Content");
                        if (!NString.IsNullOrEmpty(this.FileName)) {
                            var fileStream = new FileStream(this.FileName, FileMode.Open, FileAccess.Read);
                            try {
                                writer.WriteBase64ElementValue(fileStream);
                                _goto = IL_A2;
                                continue _GOTO_LOOP;
                            }
                            finally {
                                if (fileStream !== null) {
                                    fileStream.Dispose();
                                }
                            }
                        }
                        if (this.ContentStream !== null) {
                            writer.WriteBase64ElementValue(this.ContentStream);
                        }
                        else {
                            if (this.Content !== null) {
                                writer.WriteBase64ElementValue(this.Content);
                            }
                            else {
                                EwsUtilities.Assert(false, "FileAttachment.WriteElementsToXml", "The attachment's content is not set.");
                            }
                        }
                        _goto = IL_A2;
                        continue _GOTO_LOOP;
                    case 1:
                        writer.WriteEndElement();
                        break _GOTO_LOOP;
                }
            }
        };
        FileAttachment.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            if (service.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                jsonObject.Add("IsContactPhoto", this.isContactPhoto);
            }
            if (!NString.IsNullOrEmpty(this.FileName)) {
                var fileStream = new FileStream(this.FileName, FileMode.Open, FileAccess.Read);
                try {
                    jsonObject.AddBase64("Content", fileStream);
                    return jsonObject;
                }
                finally {
                    if (fileStream !== null) {
                        fileStream.Dispose();
                    }
                }
            }
            if (this.ContentStream !== null) {
                jsonObject.AddBase64("Content", this.ContentStream);
            }
            else {
                if (this.Content !== null) {
                    jsonObject.AddBase64("Content", this.Content);
                }
                else {
                    EwsUtilities.Assert(false, "FileAttachment.WriteElementsToXml", "The attachment's content is not set.");
                }
            }
            return jsonObject;
        };
        FileAttachment.prototype.Load = function (streamOrFileName) {
            if (arguments.length === 1 && (streamOrFileName === null || streamOrFileName instanceof Stream)) {
                this.Load_0(streamOrFileName);
                return;
            }
            this.Load_1(streamOrFileName);
        };
        FileAttachment.prototype.Load_0 = function (stream) {
            this.loadToStream = stream;
            try {
                _super.prototype.Load.call(this);
            }
            finally {
                this.loadToStream = null;
            }
        };
        FileAttachment.prototype.Load_1 = function (fileName) {
            this.loadToStream = new FileStream(fileName, FileMode.Create);
            try {
                _super.prototype.Load.call(this);
            }
            finally {
                this.loadToStream.Dispose();
                this.loadToStream = null;
            }
            this.fileName = fileName;
            this.content = null;
            this.contentStream = null;
        };
        return FileAttachment;
    }(Attachment));
    var Flag = (function (_super) {
        __extends(Flag, _super);
        function Flag() {
            _super.call(this);
            this.flagStatus = 0;
            this.startDate = null;
            this.dueDate = null;
            this.completeDate = null;
        }
        Object.defineProperty(Flag.prototype, "FlagStatus", {
            get: function () {
                return this.flagStatus;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.flagStatus
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.flagStatus = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Flag.prototype, "StartDate", {
            get: function () {
                return this.startDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.startDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.startDate = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Flag.prototype, "DueDate", {
            get: function () {
                return this.dueDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dueDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.dueDate = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Flag.prototype, "CompleteDate", {
            get: function () {
                return this.completeDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.completeDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.completeDate = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Flag.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "FlagStatus") {
                    this.flagStatus = reader.ReadElementValue();
                    return true;
                }
                if (localName === "StartDate") {
                    this.startDate = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
                if (localName === "DueDate") {
                    this.dueDate = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
                if (localName === "CompleteDate") {
                    this.completeDate = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
            }
            return false;
        };
        Flag.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "FlagStatus")) {
                            if (!(a === "StartDate")) {
                                if (!(a === "DueDate")) {
                                    if (a === "CompleteDate") {
                                        this.completeDate = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                                    }
                                }
                                else {
                                    this.dueDate = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                                }
                            }
                            else {
                                this.startDate = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                            }
                        }
                        else {
                            this.flagStatus = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Flag.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "FlagStatus", this.FlagStatus);
            if (this.FlagStatus === ItemFlagStatus.Flagged) {
                var arg_26_0 = this.StartDate;
                var arg_2D_0 = this.DueDate;
                writer.WriteElementValue(XmlNamespace.Types, "StartDate", this.StartDate);
                writer.WriteElementValue(XmlNamespace.Types, "DueDate", this.DueDate);
                return;
            }
            if (this.FlagStatus === ItemFlagStatus.Complete) {
                var arg_6C_0 = this.CompleteDate;
                writer.WriteElementValue(XmlNamespace.Types, "CompleteDate", this.CompleteDate);
            }
        };
        Flag.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("FlagStatus", this.FlagStatus);
            if (this.FlagStatus === ItemFlagStatus.Flagged) {
                var arg_2B_0 = this.StartDate;
                var arg_32_0 = this.DueDate;
                jsonObject.Add("StartDate", this.StartDate);
                jsonObject.Add("DueDate", this.DueDate);
            }
            else {
                if (this.FlagStatus === ItemFlagStatus.Complete) {
                    var arg_70_0 = this.CompleteDate;
                    jsonObject.Add("CompleteDate", this.CompleteDate);
                }
            }
            return jsonObject;
        };
        Flag.prototype.Validate = function () {
            EwsUtilities.ValidateParam(this.flagStatus, "FlagStatus");
        };
        return Flag;
    }(ComplexProperty));
    var FolderId = (function (_super) {
        __extends(FolderId, _super);
        function FolderId(uniqueIdOrFolderName, mailbox) {
            _super.call(this);
            this.folderName = null;
            this.mailbox = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (uniqueIdOrFolderName === null || uniqueIdOrFolderName.constructor === String)) {
                this.constructor_1(uniqueIdOrFolderName);
                return;
            }
            if (arguments.length === 1 && (uniqueIdOrFolderName === null || uniqueIdOrFolderName.constructor === Number)) {
                this.constructor_2(uniqueIdOrFolderName);
                return;
            }
            this.constructor_3(uniqueIdOrFolderName, mailbox);
        }
        Object.defineProperty(FolderId.prototype, "FolderName", {
            get: function () {
                return this.folderName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderId.prototype, "Mailbox", {
            get: function () {
                return this.mailbox;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderId.prototype, "IsValid", {
            get: function () {
                if (this.FolderName !== null) {
                    return this.Mailbox === null || this.Mailbox.IsValid;
                }
                return this.IsValid;
            },
            enumerable: true,
            configurable: true
        });
        FolderId.prototype.constructor_0 = function () {
        };
        FolderId.prototype.constructor_1 = function (uniqueId) {
        };
        FolderId.prototype.constructor_2 = function (folderName) {
            this.folderName = new Nullable(folderName);
        };
        FolderId.prototype.constructor_3 = function (folderName, mailbox) {
            this.constructor_2(folderName);
            this.mailbox = mailbox;
        };
        FolderId.prototype.GetXmlElementName = function () {
            if (!(this.FolderName !== null)) {
                return "FolderId";
            }
            return "DistinguishedFolderId";
        };
        FolderId.prototype.WriteAttributesToXml = function (writer) {
            if (this.FolderName !== null) {
                writer.WriteAttributeValue("Id", WellKnownFolderName[this.FolderName.Value].ToLowerInvariant());
                if (this.Mailbox !== null) {
                    this.Mailbox.WriteToXml(writer, "Mailbox");
                    return;
                }
            }
            else {
                _super.prototype.WriteAttributesToXml.call(this, writer);
            }
        };
        FolderId.prototype.InternalToJson = function (service) {
            if (this.FolderName !== null) {
                var jsonObject = new JsonObject();
                jsonObject.AddTypeParameter(this.GetXmlElementName());
                jsonObject.Add("Id", WellKnownFolderName[this.FolderName.Value].ToLowerInvariant());
                if (this.Mailbox !== null) {
                    jsonObject.Add("Mailbox", this.Mailbox.InternalToJson(service));
                }
                return jsonObject;
            }
            return _super.prototype.InternalToJson.call(this, service);
        };
        FolderId.prototype.Validate = function (version) {
            if (this.FolderName !== null) {
                EwsUtilities.ValidateEnumVersionValue(this.FolderName.Value, version);
            }
        };
        FolderId.op_Implicit = function (uniqueId) {
            return new FolderId(uniqueId);
        };
        FolderId.op_Implicit = function (folderName) {
            return new FolderId(folderName);
        };
        FolderId.prototype.Equals = function (obj) {
            if (NObject.ReferenceEquals(this, obj)) {
                return true;
            }
            var folderId = ((obj instanceof FolderId) ? obj : null);
            if (folderId === null) {
                return false;
            }
            if (this.FolderName !== null) {
                if (folderId.FolderName !== null && NObject.GenericEquals(this.FolderName.Value, folderId.FolderName.Value)) {
                    if (this.Mailbox !== null) {
                        return NObject.GenericEquals(this.Mailbox, folderId.Mailbox);
                    }
                    if (folderId.Mailbox === null) {
                        return true;
                    }
                }
            }
            else {
                if (_super.prototype.Equals.call(this, folderId)) {
                    return true;
                }
            }
            return false;
        };
        FolderId.prototype.GetHashCode = function () {
            var num;
            if (this.FolderName !== null) {
                num = this.FolderName.Value;
                if (this.Mailbox !== null && this.Mailbox.IsValid) {
                    num = (num ^ this.Mailbox.GetHashCode());
                }
            }
            else {
                num = _super.prototype.GetHashCode.call(this);
            }
            return num;
        };
        FolderId.prototype.ToString = function () {
            if (!this.IsValid) {
                return NString.Empty;
            }
            if (!(this.FolderName !== null)) {
                return _super.prototype.ToString.call(this);
            }
            if (this.Mailbox !== null && this.mailbox.IsValid) {
                return NString.Format("{0} ({1})", this.folderName.Value, this.Mailbox.ToString());
            }
            return WellKnownFolderName[this.FolderName.Value];
        };
        return FolderId;
    }(ServiceId));
    var FolderIdCollection = (function (_super) {
        __extends(FolderIdCollection, _super);
        function FolderIdCollection(folderIds) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(folderIds);
        }
        FolderIdCollection.prototype.constructor_0 = function () {
        };
        FolderIdCollection.prototype.constructor_1 = function (folderIds) {
            var _this = this;
            if (folderIds !== null) {
                EwsUtilities.ForEach(folderIds, function (folderId) {
                    _super.prototype.InternalAdd.call(_this, folderId);
                });
            }
        };
        FolderIdCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new FolderId();
        };
        FolderIdCollection.prototype.CreateDefaultComplexProperty = function () {
            return new FolderId();
        };
        FolderIdCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return complexProperty.GetXmlElementName();
        };
        FolderIdCollection.prototype.Add = function (folderIdOrFolderName) {
            if (arguments.length === 1 && (folderIdOrFolderName === null || folderIdOrFolderName instanceof FolderId)) {
                this.Add_0(folderIdOrFolderName);
                return;
            }
            this.Add_1(folderIdOrFolderName);
        };
        FolderIdCollection.prototype.Add_0 = function (folderId) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            if (_super.prototype.Contains.call(this, folderId)) {
                throw new ArgumentException(Strings.IdAlreadyInList, "folderId");
            }
            _super.prototype.InternalAdd.call(this, folderId);
        };
        FolderIdCollection.prototype.Add_1 = function (folderName) {
            if (_super.prototype.Contains.call(this, folderName)) {
                throw new ArgumentException(Strings.IdAlreadyInList, "folderName");
            }
            var folderId = new FolderId(folderName);
            _super.prototype.InternalAdd.call(this, folderId);
            return folderId;
        };
        FolderIdCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
        };
        FolderIdCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        FolderIdCollection.prototype.Remove = function (folderIdOrFolderName) {
            if (arguments.length === 1 && (folderIdOrFolderName === null || folderIdOrFolderName instanceof FolderId)) {
                return this.Remove_0(folderIdOrFolderName);
            }
            return this.Remove_1(folderIdOrFolderName);
        };
        FolderIdCollection.prototype.Remove_0 = function (folderId) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            return _super.prototype.InternalRemove.call(this, folderId);
        };
        FolderIdCollection.prototype.Remove_1 = function (folderName) {
            return _super.prototype.InternalRemove.call(this, folderName);
        };
        return FolderIdCollection;
    }(ComplexPropertyCollection));
    var UserId = (function (_super) {
        __extends(UserId, _super);
        function UserId(primarySmtpAddressOrStandardUser) {
            _super.call(this);
            this.sID = null;
            this.primarySmtpAddress = null;
            this.displayName = null;
            this.standardUser = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (primarySmtpAddressOrStandardUser === null || primarySmtpAddressOrStandardUser.constructor === String)) {
                this.constructor_1(primarySmtpAddressOrStandardUser);
                return;
            }
            this.constructor_2(primarySmtpAddressOrStandardUser);
        }
        Object.defineProperty(UserId.prototype, "SID", {
            get: function () {
                return this.sID;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sID
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sID = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserId.prototype, "PrimarySmtpAddress", {
            get: function () {
                return this.primarySmtpAddress;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.primarySmtpAddress
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.primarySmtpAddress = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserId.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.displayName
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.displayName = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserId.prototype, "StandardUser", {
            get: function () {
                return this.standardUser;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.standardUser
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.standardUser = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        UserId.prototype.constructor_0 = function () {
        };
        UserId.prototype.constructor_1 = function (primarySmtpAddress) {
            this.constructor_0();
            this.primarySmtpAddress = primarySmtpAddress;
        };
        UserId.prototype.constructor_2 = function (standardUser) {
            this.constructor_0();
            this.standardUser = new Nullable(standardUser);
        };
        UserId.prototype.IsValid = function () {
            return this.StandardUser !== null || !NString.IsNullOrEmpty(this.PrimarySmtpAddress) || !NString.IsNullOrEmpty(this.SID);
        };
        UserId.op_Implicit = function (primarySmtpAddress) {
            return new UserId(primarySmtpAddress);
        };
        UserId.op_Implicit = function (standardUser) {
            return new UserId(standardUser);
        };
        UserId.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "SID") {
                    this.sID = reader.ReadValue();
                    return true;
                }
                if (localName === "PrimarySmtpAddress") {
                    this.primarySmtpAddress = reader.ReadValue();
                    return true;
                }
                if (localName === "DisplayName") {
                    this.displayName = reader.ReadValue();
                    return true;
                }
                if (localName === "DistinguishedUser") {
                    this.standardUser = new Nullable(reader.ReadValue());
                    return true;
                }
            }
            return false;
        };
        UserId.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "SID")) {
                            if (!(a === "PrimarySmtpAddress")) {
                                if (!(a === "DisplayName")) {
                                    if (a === "DistinguishedUser") {
                                        this.standardUser = new Nullable(jsonProperty.ReadEnumValue(current));
                                    }
                                }
                                else {
                                    this.displayName = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.primarySmtpAddress = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.sID = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        UserId.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "SID", this.SID);
            writer.WriteElementValue(XmlNamespace.Types, "PrimarySmtpAddress", this.PrimarySmtpAddress);
            writer.WriteElementValue(XmlNamespace.Types, "DisplayName", this.DisplayName);
            writer.WriteElementValue(XmlNamespace.Types, "DistinguishedUser", this.StandardUser);
        };
        UserId.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("SID", this.SID);
            jsonObject.Add("PrimarySmtpAddress", this.PrimarySmtpAddress);
            jsonObject.Add("DisplayName", this.DisplayName);
            if (this.StandardUser !== null) {
                jsonObject.Add("DistinguishedUser", this.StandardUser.Value);
            }
            return jsonObject;
        };
        return UserId;
    }(ComplexProperty));
    var LazyMember = (function () {
        function LazyMember(initializationDelegate) {
            this.lazyMember = null;
            this.initializationDelegate = null;
            this.lockObject = new any();
            this.initialized = false;
            _super.call(this);
            this.initializationDelegate = initializationDelegate;
        }
        Object.defineProperty(LazyMember.prototype, "Member", {
            get: function () {
                if (!this.initialized) {
                    var obj;
                    Monitor.Enter(obj = this.lockObject);
                    try {
                        if (!this.initialized) {
                            this.lazyMember = this.initializationDelegate();
                        }
                        this.initialized = true;
                    }
                    finally {
                        Monitor.Exit(obj);
                    }
                }
                return this.lazyMember;
            },
            enumerable: true,
            configurable: true
        });
        return LazyMember;
    }());
    var ServiceObjectInfo = (function () {
        function ServiceObjectInfo() {
            this.xmlElementNameToServiceObjectClassMap = null;
            this.serviceObjectConstructorsWithServiceParam = null;
            this.serviceObjectConstructorsWithAttachmentParam = null;
            _super.call(this);
            this.xmlElementNameToServiceObjectClassMap = new Dictionary();
            this.serviceObjectConstructorsWithServiceParam = new Dictionary();
            this.serviceObjectConstructorsWithAttachmentParam = new Dictionary();
            this.InitializeServiceObjectClassMap();
        }
        Object.defineProperty(ServiceObjectInfo.prototype, "XmlElementNameToServiceObjectClassMap", {
            get: function () {
                return this.xmlElementNameToServiceObjectClassMap;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectInfo.prototype, "ServiceObjectConstructorsWithServiceParam", {
            get: function () {
                return this.serviceObjectConstructorsWithServiceParam;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectInfo.prototype, "ServiceObjectConstructorsWithAttachmentParam", {
            get: function () {
                return this.serviceObjectConstructorsWithAttachmentParam;
            },
            enumerable: true,
            configurable: true
        });
        ServiceObjectInfo.prototype.InitializeServiceObjectClassMap = function () {
            this.AddServiceObjectType("CalendarItem", new Type("Appointment"), function (srv) { return new Appointment(srv); }, function (itemAttachment, isNew) { return new Appointment(itemAttachment, isNew); });
            this.AddServiceObjectType("CalendarFolder", new Type("CalendarFolder"), function (srv) { return new CalendarFolder(srv); }, null);
            this.AddServiceObjectType("Contact", new Type("Contact"), function (srv) { return new Contact(srv); }, function (itemAttachment, isNew) { return new Contact(itemAttachment); });
            this.AddServiceObjectType("ContactsFolder", new Type("ContactsFolder"), function (srv) { return new ContactsFolder(srv); }, null);
            this.AddServiceObjectType("DistributionList", new Type("ContactGroup"), function (srv) { return new ContactGroup(srv); }, function (itemAttachment, isNew) { return new ContactGroup(itemAttachment); });
            this.AddServiceObjectType("Conversation", new Type("Conversation"), function (srv) { return new Conversation(srv); }, null);
            this.AddServiceObjectType("Message", new Type("EmailMessage"), function (srv) { return new EmailMessage(srv); }, function (itemAttachment, isNew) { return new EmailMessage(itemAttachment); });
            this.AddServiceObjectType("Folder", new Type("Folder"), function (srv) { return new Folder(srv); }, null);
            this.AddServiceObjectType("Item", new Type("Item"), function (srv) { return new Item(srv); }, function (itemAttachment, isNew) { return new Item(itemAttachment); });
            this.AddServiceObjectType("MeetingCancellation", new Type("MeetingCancellation"), function (srv) { return new MeetingCancellation(srv); }, function (itemAttachment, isNew) { return new MeetingCancellation(itemAttachment); });
            this.AddServiceObjectType("MeetingMessage", new Type("MeetingMessage"), function (srv) { return new MeetingMessage(srv); }, function (itemAttachment, isNew) { return new MeetingMessage(itemAttachment); });
            this.AddServiceObjectType("MeetingRequest", new Type("MeetingRequest"), function (srv) { return new MeetingRequest(srv); }, function (itemAttachment, isNew) { return new MeetingRequest(itemAttachment); });
            this.AddServiceObjectType("MeetingResponse", new Type("MeetingResponse"), function (srv) { return new MeetingResponse(srv); }, function (itemAttachment, isNew) { return new MeetingResponse(itemAttachment); });
            this.AddServiceObjectType("PostItem", new Type("PostItem"), function (srv) { return new PostItem(srv); }, function (itemAttachment, isNew) { return new PostItem(itemAttachment); });
            this.AddServiceObjectType("SearchFolder", new Type("SearchFolder"), function (srv) { return new SearchFolder(srv); }, null);
            this.AddServiceObjectType("Task", new Type("Task"), function (srv) { return new Task(srv); }, function (itemAttachment, isNew) { return new Task(itemAttachment); });
            this.AddServiceObjectType("TasksFolder", new Type("TasksFolder"), function (srv) { return new TasksFolder(srv); }, null);
        };
        ServiceObjectInfo.prototype.AddServiceObjectType = function (xmlElementName, type, createServiceObjectWithServiceParam, createServiceObjectWithAttachmentParam) {
            this.xmlElementNameToServiceObjectClassMap.Add(xmlElementName, type);
            this.serviceObjectConstructorsWithServiceParam.Add(type, createServiceObjectWithServiceParam);
            if (createServiceObjectWithAttachmentParam !== null) {
                this.serviceObjectConstructorsWithAttachmentParam.Add(type, createServiceObjectWithAttachmentParam);
            }
        };
        return ServiceObjectInfo;
    }());
    var ServiceObject = (function () {
        function ServiceObject(service) {
            this.lockObject = new any();
            this.service = null;
            this.propertyBag = null;
            this.xmlElementName = null;
            this.OnChange = new NEvent();
            _super.call(this);
            EwsUtilities.ValidateParam(service, "service");
            EwsUtilities.ValidateServiceObjectVersion(this, service.RequestedServerVersion);
            this.service = service;
            this.propertyBag = new PropertyBag(this);
        }
        Object.defineProperty(ServiceObject.prototype, "PropertyBag", {
            get: function () {
                return this.propertyBag;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObject.prototype, "Schema", {
            get: function () {
                return this.GetSchema();
            },
            enumerable: true,
            configurable: true
        });
        ServiceObject.prototype.get_Item = function (propertyDefinition) {
            var _this = this;
            var propertyDefinition2 = ((propertyDefinition instanceof PropertyDefinition) ? propertyDefinition : null);
            if (propertyDefinition2 !== null) {
                return this.PropertyBag.get_Item(propertyDefinition2);
            }
            var extendedPropertyDefinition = ((propertyDefinition instanceof ExtendedPropertyDefinition) ? propertyDefinition : null);
            if (!ExtendedPropertyDefinition.op_Inequality(extendedPropertyDefinition, null)) {
                throw new NotSupportedException(NString.Format(Strings.OperationNotSupportedForPropertyDefinitionType, propertyDefinition.GetType().Name));
            }
            var result;
            if ((function () {
                var _p0 = [
                    result
                ];
                var _r = _this.TryGetExtendedProperty(extendedPropertyDefinition, _p0);
                result = _p0[0];
                return _r;
            })()) {
                return result;
            }
            throw new ServiceObjectPropertyException(Strings.MustLoadOrAssignPropertyBeforeAccess, propertyDefinition);
        };
        Object.defineProperty(ServiceObject.prototype, "Service", {
            get: function () {
                return this.service;
            },
            set: function (value) {
                this.service = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObject.prototype, "IsNew", {
            get: function () {
                var id = this.GetId();
                return id === null || !id.IsValid;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObject.prototype, "IsDirty", {
            get: function () {
                return this.PropertyBag.IsDirty;
            },
            enumerable: true,
            configurable: true
        });
        ServiceObject.prototype.Changed = function () {
            if (this.OnChange !== null) {
                this.OnChange(this);
            }
        };
        ServiceObject.prototype.ThrowIfThisIsNew = function () {
            if (this.IsNew) {
                throw new InvalidOperationException(Strings.ServiceObjectDoesNotHaveId);
            }
        };
        ServiceObject.prototype.ThrowIfThisIsNotNew = function () {
            if (!this.IsNew) {
                throw new InvalidOperationException(Strings.ServiceObjectAlreadyHasId);
            }
        };
        ServiceObject.prototype.GetXmlElementNameOverride = function () {
            return null;
        };
        ServiceObject.prototype.GetXmlElementName = function () {
            if (NString.IsNullOrEmpty(this.xmlElementName)) {
                this.xmlElementName = this.GetXmlElementNameOverride();
                if (NString.IsNullOrEmpty(this.xmlElementName)) {
                    var obj;
                    Monitor.Enter(obj = this.lockObject);
                    try {
                        var customAttributes = _super.prototype.GetType.call(this).GetCustomAttributes(false);
                        for (var i = 0; i < customAttributes.length; i = i + 1) {
                            var attribute = customAttributes[i];
                            var serviceObjectDefinitionAttribute = ((attribute instanceof ServiceObjectDefinitionAttribute) ? attribute : null);
                            if (serviceObjectDefinitionAttribute !== null) {
                                this.xmlElementName = serviceObjectDefinitionAttribute.XmlElementName;
                            }
                        }
                    }
                    finally {
                        Monitor.Exit(obj);
                    }
                }
            }
            EwsUtilities.Assert(!NString.IsNullOrEmpty(this.xmlElementName), "EwsObject.GetXmlElementName", NString.Format("The class {0} does not have an associated XML element name.", _super.prototype.GetType.call(this).Name));
            return this.xmlElementName;
        };
        ServiceObject.prototype.GetChangeXmlElementName = function () {
            return "ItemChange";
        };
        ServiceObject.prototype.GetSetFieldXmlElementName = function () {
            return "SetItemField";
        };
        ServiceObject.prototype.GetDeleteFieldXmlElementName = function () {
            return "DeleteItemField";
        };
        ServiceObject.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
            return false;
        };
        ServiceObject.prototype.GetIsCustomDateTimeScopingRequired = function () {
            return false;
        };
        ServiceObject.prototype.GetSchema = function () {
            throw new NotSupportedException();
        };
        ServiceObject.prototype.GetMinimumRequiredServerVersion = function () {
            throw new NotSupportedException();
        };
        ServiceObject.prototype.LoadFromXml = function (reader, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            if (arguments.length === 2 && (reader === null || reader instanceof EwsServiceXmlReader) && (clearPropertyBag === null || clearPropertyBag.constructor === Boolean)) {
                this.LoadFromXml_0(reader, clearPropertyBag);
                return;
            }
            this.LoadFromXml_1(reader, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
        };
        ServiceObject.prototype.LoadFromXml_0 = function (reader, clearPropertyBag) {
            this.PropertyBag.LoadFromXml(reader, clearPropertyBag, null, false);
        };
        ServiceObject.prototype.Validate = function () {
            this.PropertyBag.Validate();
        };
        ServiceObject.prototype.LoadFromXml_1 = function (reader, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            this.PropertyBag.LoadFromXml(reader, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
        };
        ServiceObject.prototype.LoadFromJson = function (jsonServiceObjectOrJsonObject, service, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            if (arguments.length === 5 && (jsonServiceObjectOrJsonObject === null || jsonServiceObjectOrJsonObject instanceof JsonObject) && (service === null || service instanceof ExchangeService) && (clearPropertyBag === null || clearPropertyBag.constructor === Boolean) && (requestedPropertySet === null || requestedPropertySet instanceof PropertySet) && (summaryPropertiesOnly === null || summaryPropertiesOnly.constructor === Boolean)) {
                this.LoadFromJson_0(jsonServiceObjectOrJsonObject, service, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
                return;
            }
            this.LoadFromJson_1(jsonServiceObjectOrJsonObject, service, clearPropertyBag);
        };
        ServiceObject.prototype.LoadFromJson_0 = function (jsonServiceObject, service, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            this.PropertyBag.LoadFromJson(jsonServiceObject, service, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
        };
        ServiceObject.prototype.LoadFromJson_1 = function (jsonObject, service, clearPropertyBag) {
            this.PropertyBag.LoadFromJson(jsonObject, service, clearPropertyBag, null, false);
        };
        ServiceObject.prototype.ClearChangeLog = function () {
            this.PropertyBag.ClearChangeLog();
        };
        ServiceObject.prototype.WriteToXml = function (writer) {
            this.PropertyBag.WriteToXml(writer);
        };
        ServiceObject.prototype.ToJson = function (service, isUpdateOperation) {
            return this.PropertyBag.ToJson(service, isUpdateOperation);
        };
        ServiceObject.prototype.WriteToXmlForUpdate = function (writer) {
            this.PropertyBag.WriteToXmlForUpdate(writer);
        };
        ServiceObject.prototype.WriteToJsonForUpdate = function (service) {
            return this.PropertyBag.ToJson(service, true);
        };
        ServiceObject.prototype.InternalLoad = function (propertySet) {
            throw new NotSupportedException();
        };
        ServiceObject.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new NotSupportedException();
        };
        ServiceObject.prototype.Load = function (propertySet) {
            if (arguments.length === 1 && (propertySet === null || propertySet instanceof PropertySet)) {
                this.Load_0(propertySet);
                return;
            }
            this.Load_1();
        };
        ServiceObject.prototype.Load_0 = function (propertySet) {
            this.InternalLoad(propertySet);
        };
        ServiceObject.prototype.Load_1 = function () {
            this.InternalLoad(PropertySet.FirstClassProperties);
        };
        ServiceObject.prototype.TryGetExtendedProperty = function (propertyDefinition, propertyValue) {
            var extendedProperties = this.GetExtendedProperties();
            if (extendedProperties !== null && (function () {
                var _p0 = [
                    propertyValue[0]
                ];
                var _r = extendedProperties.TryGetValue(propertyDefinition, _p0);
                propertyValue[0] = _p0[0];
                return _r;
            })()) {
                return true;
            }
            propertyValue[0] = null;
            return false;
        };
        ServiceObject.prototype.TryGetProperty = function (propertyDefinition, propertyValue) {
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (propertyValue === null || propertyValue instanceof Array)) {
                return this.TryGetProperty_0(propertyDefinition, propertyValue);
            }
            return this.TryGetProperty_1(propertyDefinition, propertyValue);
        };
        ServiceObject.prototype.TryGetProperty_0 = function (propertyDefinition, propertyValue) {
            var _this = this;
            return (function () {
                var _p0 = [
                    propertyValue[0]
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                propertyValue[0] = _p0[0];
                return _r;
            })();
        };
        ServiceObject.prototype.TryGetProperty_1 = function (propertyDefinition, propertyValue) {
            var _this = this;
            var propertyDefinition2 = ((propertyDefinition instanceof PropertyDefinition) ? propertyDefinition : null);
            if (propertyDefinition2 !== null) {
                return (function () {
                    var _p0 = [
                        propertyValue[0]
                    ];
                    var _r = _this.PropertyBag.TryGetProperty(propertyDefinition2, _p0);
                    propertyValue[0] = _p0[0];
                    return _r;
                })();
            }
            var extendedPropertyDefinition = ((propertyDefinition instanceof ExtendedPropertyDefinition) ? propertyDefinition : null);
            if (ExtendedPropertyDefinition.op_Inequality(extendedPropertyDefinition, null)) {
                return (function () {
                    var _p0 = [
                        propertyValue[0]
                    ];
                    var _r = _this.TryGetExtendedProperty(extendedPropertyDefinition, _p0);
                    propertyValue[0] = _p0[0];
                    return _r;
                })();
            }
            throw new NotSupportedException(NString.Format(Strings.OperationNotSupportedForPropertyDefinitionType, propertyDefinition.GetType().Name));
        };
        ServiceObject.prototype.GetLoadedPropertyDefinitions = function () {
            var collection = new Collection();
            var enumerator = this.PropertyBag.Properties.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    collection.Add(current);
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (this.GetExtendedProperties() !== null) {
                var enumerator2 = this.GetExtendedProperties().GetEnumerator();
                try {
                    while (enumerator2.MoveNext()) {
                        var current2 = enumerator2.Current;
                        collection.Add(current2.PropertyDefinition);
                    }
                }
                finally {
                    if (enumerator2 !== null) {
                        enumerator2.Dispose();
                    }
                }
            }
            return collection;
        };
        ServiceObject.prototype.GetIdPropertyDefinition = function () {
            return null;
        };
        ServiceObject.prototype.GetId = function () {
            var _this = this;
            var idPropertyDefinition = this.GetIdPropertyDefinition();
            var obj = null;
            if (idPropertyDefinition !== null) {
                (function () {
                    var _p0 = [
                        obj
                    ];
                    var _r = _this.PropertyBag.TryGetValue(idPropertyDefinition, _p0);
                    obj = _p0[0];
                    return _r;
                })();
            }
            return obj;
        };
        ServiceObject.prototype.GetExtendedProperties = function () {
            return null;
        };
        return ServiceObject;
    }());
    var Folder = (function (_super) {
        __extends(Folder, _super);
        function Folder(service) {
            _super.call(this, service);
        }
        Object.defineProperty(Folder.prototype, "Id", {
            get: function () {
                return this.PropertyBag.get_Item(this.GetIdPropertyDefinition());
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "ParentFolderId", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.ParentFolderId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "ChildFolderCount", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.ChildFolderCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "DisplayName", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.DisplayName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(FolderSchema.DisplayName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "FolderClass", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.FolderClass);
            },
            set: function (value) {
                this.PropertyBag.set_Item(FolderSchema.FolderClass, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "TotalCount", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.TotalCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "ExtendedProperties", {
            get: function () {
                return this.PropertyBag.get_Item(ServiceObjectSchema.ExtendedProperties);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "ManagedFolderInformation", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.ManagedFolderInformation);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "EffectiveRights", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.EffectiveRights);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "Permissions", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.Permissions);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "UnreadCount", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.UnreadCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "PolicyTag", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.PolicyTag);
            },
            set: function (value) {
                this.PropertyBag.set_Item(FolderSchema.PolicyTag, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "ArchiveTag", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.ArchiveTag);
            },
            set: function (value) {
                this.PropertyBag.set_Item(FolderSchema.ArchiveTag, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Folder.prototype, "WellKnownFolderName", {
            get: function () {
                return this.PropertyBag.get_Item(FolderSchema.WellKnownFolderName);
            },
            enumerable: true,
            configurable: true
        });
        Folder.Bind = function (service, idOrName, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Folder.Bind_0(service, idOrName, propertySet);
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId)) {
                return Folder.Bind_1(service, idOrName);
            }
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName.constructor === Number) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Folder.Bind_2(service, idOrName, propertySet);
            }
            return Folder.Bind_3(service, idOrName);
        };
        Folder.Bind_0 = function (service, id, propertySet) {
            return service.BindToFolder(id, propertySet);
        };
        Folder.Bind_1 = function (service, id) {
            return Folder.Bind(service, id, PropertySet.FirstClassProperties);
        };
        Folder.Bind_2 = function (service, name, propertySet) {
            return Folder.Bind(service, new FolderId(name), propertySet);
        };
        Folder.Bind_3 = function (service, name) {
            return Folder.Bind(service, new FolderId(name), PropertySet.FirstClassProperties);
        };
        Folder.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.PropertyBag.Contains(FolderSchema.Permissions)) {
                this.Permissions.Validate();
            }
        };
        Folder.prototype.GetSchema = function () {
            return FolderSchema.Instance;
        };
        Folder.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        Folder.prototype.GetChangeXmlElementName = function () {
            return "FolderChange";
        };
        Folder.prototype.GetSetFieldXmlElementName = function () {
            return "SetFolderField";
        };
        Folder.prototype.GetDeleteFieldXmlElementName = function () {
            return "DeleteFolderField";
        };
        Folder.prototype.InternalLoad = function (propertySet) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.Service.LoadPropertiesForFolder(this, propertySet);
        };
        Folder.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.Service.DeleteFolder(this.Id, deleteMode);
        };
        Folder.prototype.Delete = function (deleteMode) {
            this.InternalDelete(deleteMode, null, null);
        };
        Folder.prototype.Empty = function (deleteMode, deleteSubFolders) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.Service.EmptyFolder(this.Id, deleteMode, deleteSubFolders);
        };
        Folder.prototype.MarkAllItemsAsRead = function (suppressReadReceipts) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.Service.MarkAllItemsAsRead(this.Id, true, suppressReadReceipts);
        };
        Folder.prototype.MarkAllItemsAsUnread = function (suppressReadReceipts) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.Service.MarkAllItemsAsRead(this.Id, false, suppressReadReceipts);
        };
        Folder.prototype.Save = function (parentFolderIdOrParentFolderName) {
            if (arguments.length === 1 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId)) {
                this.Save_0(parentFolderIdOrParentFolderName);
                return;
            }
            this.Save_1(parentFolderIdOrParentFolderName);
        };
        Folder.prototype.Save_0 = function (parentFolderId) {
            _super.prototype.ThrowIfThisIsNotNew.call(this);
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            if (this.IsDirty) {
                this.Service.CreateFolder(this, parentFolderId);
            }
        };
        Folder.prototype.Save_1 = function (parentFolderName) {
            this.Save(new FolderId(parentFolderName));
        };
        Folder.prototype.Update = function () {
            if (this.IsDirty && this.PropertyBag.GetIsUpdateCallNecessary()) {
                this.Service.UpdateFolder(this);
            }
        };
        Folder.prototype.Copy = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Copy_0(destinationFolderIdOrDestinationFolderName);
            }
            return this.Copy_1(destinationFolderIdOrDestinationFolderName);
        };
        Folder.prototype.Copy_0 = function (destinationFolderId) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.Service.CopyFolder(this.Id, destinationFolderId);
        };
        Folder.prototype.Copy_1 = function (destinationFolderName) {
            return this.Copy(new FolderId(destinationFolderName));
        };
        Folder.prototype.Move = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Move_0(destinationFolderIdOrDestinationFolderName);
            }
            return this.Move_1(destinationFolderIdOrDestinationFolderName);
        };
        Folder.prototype.Move_0 = function (destinationFolderId) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.Service.MoveFolder(this.Id, destinationFolderId);
        };
        Folder.prototype.Move_1 = function (destinationFolderName) {
            return this.Move(new FolderId(destinationFolderName));
        };
        Folder.prototype.InternalFindItems = function (queryStringOrSearchFilter, view, groupBy) {
            if (arguments.length === 3 && (queryStringOrSearchFilter === null || queryStringOrSearchFilter.constructor === String) && (view === null || view instanceof ViewBase) && (groupBy === null || groupBy instanceof Grouping)) {
                return this.InternalFindItems_0(queryStringOrSearchFilter, view, groupBy);
            }
            return this.InternalFindItems_1(queryStringOrSearchFilter, view, groupBy);
        };
        Folder.prototype.InternalFindItems_0 = function (queryString, view, groupBy) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return this.Service.FindItems(NArray.ToEnumerable([
                this.Id
            ]), null, queryString, view, groupBy, ServiceErrorHandling.ThrowOnError);
        };
        Folder.prototype.InternalFindItems_1 = function (searchFilter, view, groupBy) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return this.Service.FindItems(NArray.ToEnumerable([
                this.Id
            ]), searchFilter, null, view, groupBy, ServiceErrorHandling.ThrowOnError);
        };
        Folder.prototype.FindItems = function (searchFilterOrQueryStringOrView, viewOrGroupBy, groupBy) {
            if (arguments.length === 2 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (viewOrGroupBy === null || viewOrGroupBy instanceof ItemView)) {
                return this.FindItems_0(searchFilterOrQueryStringOrView, viewOrGroupBy);
            }
            if (arguments.length === 2 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (viewOrGroupBy === null || viewOrGroupBy instanceof ItemView)) {
                return this.FindItems_1(searchFilterOrQueryStringOrView, viewOrGroupBy);
            }
            if (arguments.length === 1 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof ItemView)) {
                return this.FindItems_2(searchFilterOrQueryStringOrView);
            }
            if (arguments.length === 3 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (viewOrGroupBy === null || viewOrGroupBy instanceof ItemView) && (groupBy === null || groupBy instanceof Grouping)) {
                return this.FindItems_3(searchFilterOrQueryStringOrView, viewOrGroupBy, groupBy);
            }
            if (arguments.length === 3 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (viewOrGroupBy === null || viewOrGroupBy instanceof ItemView) && (groupBy === null || groupBy instanceof Grouping)) {
                return this.FindItems_4(searchFilterOrQueryStringOrView, viewOrGroupBy, groupBy);
            }
            return this.FindItems_5(searchFilterOrQueryStringOrView, viewOrGroupBy);
        };
        Folder.prototype.FindItems_0 = function (searchFilter, view) {
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var serviceResponseCollection = this.InternalFindItems(searchFilter, view, null);
            return serviceResponseCollection.get_Item(0).Results;
        };
        Folder.prototype.FindItems_1 = function (queryString, view) {
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            var serviceResponseCollection = this.InternalFindItems(queryString, view, null);
            return serviceResponseCollection.get_Item(0).Results;
        };
        Folder.prototype.FindItems_2 = function (view) {
            var serviceResponseCollection = this.InternalFindItems(null, view, null);
            return serviceResponseCollection.get_Item(0).Results;
        };
        Folder.prototype.FindItems_3 = function (searchFilter, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var serviceResponseCollection = this.InternalFindItems(searchFilter, view, groupBy);
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        Folder.prototype.FindItems_4 = function (queryString, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            var serviceResponseCollection = this.InternalFindItems(queryString, view, groupBy);
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        Folder.prototype.FindFolders = function (viewOrSearchFilter, view) {
            if (arguments.length === 1 && (viewOrSearchFilter === null || viewOrSearchFilter instanceof FolderView)) {
                return this.FindFolders_0(viewOrSearchFilter);
            }
            return this.FindFolders_1(viewOrSearchFilter, view);
        };
        Folder.prototype.FindFolders_0 = function (view) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return this.Service.FindFolders(this.Id, view);
        };
        Folder.prototype.FindFolders_1 = function (searchFilter, view) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return this.Service.FindFolders(this.Id, searchFilter, view);
        };
        Folder.prototype.FindItems_5 = function (view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            return this.FindItems(null, view, groupBy);
        };
        Folder.prototype.GetIdPropertyDefinition = function () {
            return FolderSchema.Id;
        };
        Folder.prototype.SetExtendedProperty = function (extendedPropertyDefinition, value) {
            this.ExtendedProperties.SetExtendedProperty(extendedPropertyDefinition, value);
        };
        Folder.prototype.RemoveExtendedProperty = function (extendedPropertyDefinition) {
            return this.ExtendedProperties.RemoveExtendedProperty(extendedPropertyDefinition);
        };
        Folder.prototype.GetExtendedProperties = function () {
            return this.ExtendedProperties;
        };
        return Folder;
    }(ServiceObject));
    var CalendarFolder = (function (_super) {
        __extends(CalendarFolder, _super);
        function CalendarFolder(service) {
            _super.call(this, service);
        }
        CalendarFolder.Bind = function (service, idOrName, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return CalendarFolder.Bind_0(service, idOrName, propertySet);
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId)) {
                return CalendarFolder.Bind_1(service, idOrName);
            }
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName.constructor === Number) && (propertySet === null || propertySet instanceof PropertySet)) {
                return CalendarFolder.Bind_2(service, idOrName, propertySet);
            }
            return CalendarFolder.Bind_3(service, idOrName);
        };
        CalendarFolder.Bind_0 = function (service, id, propertySet) {
            return service.BindToFolder(id, propertySet);
        };
        CalendarFolder.Bind_1 = function (service, id) {
            return CalendarFolder.Bind(service, id, PropertySet.FirstClassProperties);
        };
        CalendarFolder.Bind_2 = function (service, name, propertySet) {
            return CalendarFolder.Bind(service, new FolderId(name), propertySet);
        };
        CalendarFolder.Bind_3 = function (service, name) {
            return CalendarFolder.Bind(service, new FolderId(name), PropertySet.FirstClassProperties);
        };
        CalendarFolder.prototype.FindAppointments = function (view) {
            EwsUtilities.ValidateParam(view, "view");
            var serviceResponseCollection = _super.prototype.InternalFindItems.call(this, null, view, null);
            return serviceResponseCollection.get_Item(0).Results;
        };
        CalendarFolder.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CalendarFolder;
    }(Folder));
    var ContactsFolder = (function (_super) {
        __extends(ContactsFolder, _super);
        function ContactsFolder(service) {
            _super.call(this, service);
        }
        ContactsFolder.Bind = function (service, idOrName, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return ContactsFolder.Bind_0(service, idOrName, propertySet);
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId)) {
                return ContactsFolder.Bind_1(service, idOrName);
            }
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName.constructor === Number) && (propertySet === null || propertySet instanceof PropertySet)) {
                return ContactsFolder.Bind_2(service, idOrName, propertySet);
            }
            return ContactsFolder.Bind_3(service, idOrName);
        };
        ContactsFolder.Bind_0 = function (service, id, propertySet) {
            return service.BindToFolder(id, propertySet);
        };
        ContactsFolder.Bind_1 = function (service, id) {
            return ContactsFolder.Bind(service, id, PropertySet.FirstClassProperties);
        };
        ContactsFolder.Bind_2 = function (service, name, propertySet) {
            return ContactsFolder.Bind(service, new FolderId(name), propertySet);
        };
        ContactsFolder.Bind_3 = function (service, name) {
            return ContactsFolder.Bind(service, new FolderId(name), PropertySet.FirstClassProperties);
        };
        ContactsFolder.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return ContactsFolder;
    }(Folder));
    var SearchFolder = (function (_super) {
        __extends(SearchFolder, _super);
        function SearchFolder(service) {
            _super.call(this, service);
        }
        Object.defineProperty(SearchFolder.prototype, "SearchParameters", {
            get: function () {
                return this.PropertyBag.get_Item(SearchFolderSchema.SearchParameters);
            },
            enumerable: true,
            configurable: true
        });
        SearchFolder.Bind = function (service, idOrName, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return SearchFolder.Bind_0(service, idOrName, propertySet);
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId)) {
                return SearchFolder.Bind_1(service, idOrName);
            }
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName.constructor === Number) && (propertySet === null || propertySet instanceof PropertySet)) {
                return SearchFolder.Bind_2(service, idOrName, propertySet);
            }
            return SearchFolder.Bind_3(service, idOrName);
        };
        SearchFolder.Bind_0 = function (service, id, propertySet) {
            return service.BindToFolder(id, propertySet);
        };
        SearchFolder.Bind_1 = function (service, id) {
            return SearchFolder.Bind(service, id, PropertySet.FirstClassProperties);
        };
        SearchFolder.Bind_2 = function (service, name, propertySet) {
            return SearchFolder.Bind(service, new FolderId(name), propertySet);
        };
        SearchFolder.Bind_3 = function (service, name) {
            return SearchFolder.Bind(service, new FolderId(name), PropertySet.FirstClassProperties);
        };
        SearchFolder.prototype.GetSchema = function () {
            return SearchFolderSchema.Instance;
        };
        SearchFolder.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.SearchParameters !== null) {
                this.SearchParameters.Validate();
            }
        };
        SearchFolder.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SearchFolder;
    }(Folder));
    var TasksFolder = (function (_super) {
        __extends(TasksFolder, _super);
        function TasksFolder(service) {
            _super.call(this, service);
        }
        TasksFolder.Bind = function (service, idOrName, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return TasksFolder.Bind_0(service, idOrName, propertySet);
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName instanceof FolderId)) {
                return TasksFolder.Bind_1(service, idOrName);
            }
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (idOrName === null || idOrName.constructor === Number) && (propertySet === null || propertySet instanceof PropertySet)) {
                return TasksFolder.Bind_2(service, idOrName, propertySet);
            }
            return TasksFolder.Bind_3(service, idOrName);
        };
        TasksFolder.Bind_0 = function (service, id, propertySet) {
            return service.BindToFolder(id, propertySet);
        };
        TasksFolder.Bind_1 = function (service, id) {
            return TasksFolder.Bind(service, id, PropertySet.FirstClassProperties);
        };
        TasksFolder.Bind_2 = function (service, name, propertySet) {
            return TasksFolder.Bind(service, new FolderId(name), propertySet);
        };
        TasksFolder.Bind_3 = function (service, name) {
            return TasksFolder.Bind(service, new FolderId(name), PropertySet.FirstClassProperties);
        };
        TasksFolder.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return TasksFolder;
    }(Folder));
    var Item = (function (_super) {
        __extends(Item, _super);
        function Item(serviceOrParentAttachment) {
            _super.call(this, serviceOrParentAttachment);
            this.parentAttachment = null;
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(Item.prototype, "ParentAttachment", {
            get: function () {
                return this.parentAttachment;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "RootItemId", {
            get: function () {
                if (this.IsAttachment && this.ParentAttachment.Owner !== null) {
                    return this.ParentAttachment.Owner.RootItemId;
                }
                return this.Id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsAttachment", {
            get: function () {
                return this.parentAttachment !== null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsNew", {
            get: function () {
                if (this.IsAttachment) {
                    return this.ParentAttachment.IsNew;
                }
                return this.IsNew;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Id", {
            get: function () {
                return this.PropertyBag.get_Item(this.GetIdPropertyDefinition());
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "MimeContent", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.MimeContent);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.MimeContent, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ParentFolderId", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ParentFolderId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Sensitivity", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Sensitivity);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Sensitivity, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Attachments", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Attachments);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DateTimeReceived", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.DateTimeReceived);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Size", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Size);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Categories", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Categories);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Categories, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Culture", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Culture);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Culture, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Importance", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Importance);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Importance, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "InReplyTo", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.InReplyTo);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.InReplyTo, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsSubmitted", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsSubmitted);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsAssociated", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsAssociated);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsDraft", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsDraft);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsFromMe", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsFromMe);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsResend", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsResend);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsUnmodified", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsUnmodified);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "InternetMessageHeaders", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.InternetMessageHeaders);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DateTimeSent", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.DateTimeSent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DateTimeCreated", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.DateTimeCreated);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "AllowedResponseActions", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.AllowedResponseActions);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ReminderDueBy", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ReminderDueBy);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.ReminderDueBy, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IsReminderSet", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IsReminderSet);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.IsReminderSet, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ReminderMinutesBeforeStart", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ReminderMinutesBeforeStart);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.ReminderMinutesBeforeStart, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DisplayCc", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.DisplayCc);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DisplayTo", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.DisplayTo);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "HasAttachments", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.HasAttachments);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Body", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Body);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Body, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ItemClass", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ItemClass);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.ItemClass, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Subject", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Subject);
            },
            set: function (value) {
                this.SetSubject(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "WebClientReadFormQueryString", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.WebClientReadFormQueryString);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "WebClientEditFormQueryString", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.WebClientEditFormQueryString);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ExtendedProperties", {
            get: function () {
                return this.PropertyBag.get_Item(ServiceObjectSchema.ExtendedProperties);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "EffectiveRights", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.EffectiveRights);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "LastModifiedName", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.LastModifiedName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "LastModifiedTime", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.LastModifiedTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ConversationId", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ConversationId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "UniqueBody", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.UniqueBody);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "StoreEntryId", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.StoreEntryId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "InstanceKey", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.InstanceKey);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Flag", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Flag);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Flag, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "NormalizedBody", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.NormalizedBody);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "EntityExtractionResult", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.EntityExtractionResult);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "PolicyTag", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.PolicyTag);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.PolicyTag, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "ArchiveTag", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ArchiveTag);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.ArchiveTag, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "RetentionDate", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.RetentionDate);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "Preview", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Preview);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "TextBody", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.TextBody);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "IconIndex", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.IconIndex);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DefaultAffectedTaskOccurrences", {
            get: function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DefaultSendCancellationsMode", {
            get: function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DefaultSendInvitationsMode", {
            get: function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "DefaultSendInvitationsOrCancellationsMode", {
            get: function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Item.prototype.constructor_0 = function (service) {
        };
        Item.prototype.constructor_1 = function (parentAttachment) {
            this.constructor_0(parentAttachment.Service);
            EwsUtilities.Assert(parentAttachment !== null, "Item.ctor", "parentAttachment is null");
            this.parentAttachment = parentAttachment;
        };
        Item.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Item.Bind_0(service, id, propertySet);
            }
            return Item.Bind_1(service, id);
        };
        Item.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        Item.Bind_1 = function (service, id) {
            return Item.Bind(service, id, PropertySet.FirstClassProperties);
        };
        Item.prototype.GetSchema = function () {
            return ItemSchema.Instance;
        };
        Item.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        Item.prototype.ThrowIfThisIsAttachment = function () {
            if (this.IsAttachment) {
                throw new InvalidOperationException(Strings.OperationDoesNotSupportAttachments);
            }
        };
        Item.prototype.GetIdPropertyDefinition = function () {
            return ItemSchema.Id;
        };
        Item.prototype.InternalLoad = function (propertySet) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.ThrowIfThisIsAttachment();
            this.Service.InternalLoadPropertiesForItems(NArray.ToEnumerable([
                this
            ]), propertySet, ServiceErrorHandling.ThrowOnError);
        };
        Item.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts) {
            if (arguments.length === 3 && (deleteMode === null || deleteMode.constructor === Number) && (sendCancellationsMode === null || sendCancellationsMode instanceof Array) && (affectedTaskOccurrences === null || affectedTaskOccurrences instanceof Array)) {
                this.InternalDelete_0(deleteMode, sendCancellationsMode, affectedTaskOccurrences);
                return;
            }
            this.InternalDelete_1(deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts);
        };
        Item.prototype.InternalDelete_0 = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            this.InternalDelete(deleteMode, sendCancellationsMode, affectedTaskOccurrences, false);
        };
        Item.prototype.InternalDelete_1 = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.ThrowIfThisIsAttachment();
            if (!(sendCancellationsMode !== null)) {
                sendCancellationsMode = this.DefaultSendCancellationsMode;
            }
            if (!(affectedTaskOccurrences !== null)) {
                affectedTaskOccurrences = this.DefaultAffectedTaskOccurrences;
            }
            this.Service.DeleteItem(this.Id, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts);
        };
        Item.prototype.InternalCreate = function (parentFolderId, messageDisposition, sendInvitationsMode) {
            _super.prototype.ThrowIfThisIsNotNew.call(this);
            this.ThrowIfThisIsAttachment();
            if (this.IsNew || this.IsDirty) {
                this.Service.CreateItem(this, parentFolderId, messageDisposition, (sendInvitationsMode !== null) ? sendInvitationsMode : this.DefaultSendInvitationsMode);
                this.Attachments.Save();
            }
        };
        Item.prototype.InternalUpdate = function (parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            if (arguments.length === 4 && (parentFolderId === null || parentFolderId instanceof FolderId) && (conflictResolutionMode === null || conflictResolutionMode.constructor === Number) && (messageDisposition === null || messageDisposition instanceof Array) && (sendInvitationsOrCancellationsMode === null || sendInvitationsOrCancellationsMode instanceof Array)) {
                return this.InternalUpdate_0(parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode);
            }
            return this.InternalUpdate_1(parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts);
        };
        Item.prototype.InternalUpdate_0 = function (parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode) {
            return this.InternalUpdate(parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode, false);
        };
        Item.prototype.InternalUpdate_1 = function (parentFolderId, conflictResolutionMode, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.ThrowIfThisIsAttachment();
            var result = null;
            if (this.IsDirty && this.PropertyBag.GetIsUpdateCallNecessary()) {
                result = this.Service.UpdateItem(this, parentFolderId, conflictResolutionMode, messageDisposition, (sendInvitationsOrCancellationsMode !== null) ? sendInvitationsOrCancellationsMode : this.DefaultSendInvitationsOrCancellationsMode, suppressReadReceipts);
            }
            if (this.HasUnprocessedAttachmentChanges()) {
                this.Attachments.Validate();
                this.Attachments.Save();
            }
            return result;
        };
        Item.prototype.HasUnprocessedAttachmentChanges = function () {
            return this.Attachments.HasUnprocessedChanges();
        };
        Item.prototype.Delete = function (deleteMode, suppressReadReceipts) {
            if (arguments.length === 1 && (deleteMode === null || deleteMode.constructor === Number)) {
                this.Delete_0(deleteMode);
                return;
            }
            this.Delete_1(deleteMode, suppressReadReceipts);
        };
        Item.prototype.Delete_0 = function (deleteMode) {
            this.Delete(deleteMode, false);
        };
        Item.prototype.Delete_1 = function (deleteMode, suppressReadReceipts) {
            this.InternalDelete(deleteMode, null, null, suppressReadReceipts);
        };
        Item.prototype.Save = function (parentFolderIdOrParentFolderName) {
            if (arguments.length === 1 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId)) {
                this.Save_0(parentFolderIdOrParentFolderName);
                return;
            }
            if (arguments.length === 1 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName.constructor === Number)) {
                this.Save_1(parentFolderIdOrParentFolderName);
                return;
            }
            this.Save_2();
        };
        Item.prototype.Save_0 = function (parentFolderId) {
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            this.InternalCreate(parentFolderId, new Nullable(MessageDisposition.SaveOnly), null);
        };
        Item.prototype.Save_1 = function (parentFolderName) {
            this.InternalCreate(new FolderId(parentFolderName), new Nullable(MessageDisposition.SaveOnly), null);
        };
        Item.prototype.Save_2 = function () {
            this.InternalCreate(null, new Nullable(MessageDisposition.SaveOnly), null);
        };
        Item.prototype.Update = function (conflictResolutionMode, suppressReadReceipts) {
            if (arguments.length === 1 && (conflictResolutionMode === null || conflictResolutionMode.constructor === Number)) {
                this.Update_0(conflictResolutionMode);
                return;
            }
            this.Update_1(conflictResolutionMode, suppressReadReceipts);
        };
        Item.prototype.Update_0 = function (conflictResolutionMode) {
            this.Update(conflictResolutionMode, false);
        };
        Item.prototype.Update_1 = function (conflictResolutionMode, suppressReadReceipts) {
            this.InternalUpdate(null, conflictResolutionMode, new Nullable(MessageDisposition.SaveOnly), null, suppressReadReceipts);
        };
        Item.prototype.Copy = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Copy_0(destinationFolderIdOrDestinationFolderName);
            }
            return this.Copy_1(destinationFolderIdOrDestinationFolderName);
        };
        Item.prototype.Copy_0 = function (destinationFolderId) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.ThrowIfThisIsAttachment();
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.Service.CopyItem(this.Id, destinationFolderId);
        };
        Item.prototype.Copy_1 = function (destinationFolderName) {
            return this.Copy(new FolderId(destinationFolderName));
        };
        Item.prototype.Move = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Move_0(destinationFolderIdOrDestinationFolderName);
            }
            return this.Move_1(destinationFolderIdOrDestinationFolderName);
        };
        Item.prototype.Move_0 = function (destinationFolderId) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            this.ThrowIfThisIsAttachment();
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.Service.MoveItem(this.Id, destinationFolderId);
        };
        Item.prototype.Move_1 = function (destinationFolderName) {
            return this.Move(new FolderId(destinationFolderName));
        };
        Item.prototype.SetExtendedProperty = function (extendedPropertyDefinition, value) {
            this.ExtendedProperties.SetExtendedProperty(extendedPropertyDefinition, value);
        };
        Item.prototype.RemoveExtendedProperty = function (extendedPropertyDefinition) {
            return this.ExtendedProperties.RemoveExtendedProperty(extendedPropertyDefinition);
        };
        Item.prototype.GetExtendedProperties = function () {
            return this.ExtendedProperties;
        };
        Item.prototype.Validate = function () {
            var _this = this;
            _super.prototype.Validate.call(this);
            this.Attachments.Validate();
            var flag;
            if ((function () {
                var _p0 = [
                    flag
                ];
                var _r = _super.prototype.TryGetProperty.call(_this, ItemSchema.Flag, _p0);
                flag = _p0[0];
                return _r;
            })() && flag !== null) {
                if (this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                    throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "Flag", ExchangeVersion.Exchange2013));
                }
                flag.Validate();
            }
        };
        Item.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
            if (!isUpdateOperation && this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2010_SP2) {
                var enumerator = Enumerable.OfType(this.Attachments).GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.Item !== null && current.Item.GetIsTimeZoneHeaderRequired(false)) {
                            return true;
                        }
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
            return _super.prototype.GetIsTimeZoneHeaderRequired.call(this, isUpdateOperation);
        };
        Item.prototype.SetSubject = function (subject) {
            this.PropertyBag.set_Item(ItemSchema.Subject, subject);
        };
        return Item;
    }(ServiceObject));
    var Appointment = (function (_super) {
        __extends(Appointment, _super);
        function Appointment(serviceOrParentAttachment, isNew) {
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                _super.call(this, serviceOrParentAttachment);
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            _super.call(this, serviceOrParentAttachment);
            this.constructor_1(serviceOrParentAttachment, isNew);
        }
        Object.defineProperty(Appointment.prototype, "DefaultSendCancellationsMode", {
            get: function () {
                return new Nullable(SendCancellationsMode.SendToAllAndSaveCopy);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "DefaultSendInvitationsMode", {
            get: function () {
                return new Nullable(SendInvitationsMode.SendToAllAndSaveCopy);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "DefaultSendInvitationsOrCancellationsMode", {
            get: function () {
                return new Nullable(SendInvitationsOrCancellationsMode.SendToAllAndSaveCopy);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Start", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Start);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.Start, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "End", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.End);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.End, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "OriginalStart", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.OriginalStart);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsAllDayEvent", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsAllDayEvent);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.IsAllDayEvent, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "LegacyFreeBusyStatus", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.LegacyFreeBusyStatus);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.LegacyFreeBusyStatus, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Location", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Location);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.Location, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "When", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.When);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsMeeting", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsMeeting);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsCancelled", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsCancelled);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsRecurring", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsRecurring);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "MeetingRequestWasSent", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MeetingRequestWasSent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsResponseRequested", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsResponseRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.IsResponseRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AppointmentType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "MyResponseType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MyResponseType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Organizer", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Organizer);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "RequiredAttendees", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.RequiredAttendees);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "OptionalAttendees", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.OptionalAttendees);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Resources", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Resources);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ConflictingMeetingCount", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConflictingMeetingCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AdjacentMeetingCount", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AdjacentMeetingCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ConflictingMeetings", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConflictingMeetings);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AdjacentMeetings", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AdjacentMeetings);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Duration", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Duration);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "TimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.TimeZone);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AppointmentReplyTime", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentReplyTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AppointmentSequenceNumber", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentSequenceNumber);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AppointmentState", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentState);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "Recurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Recurrence);
            },
            set: function (value) {
                if (value !== null && value.IsRegenerationPattern) {
                    throw new ServiceLocalException(Strings.RegenerationPatternsOnlyValidForTasks);
                }
                this.PropertyBag.set_Item(AppointmentSchema.Recurrence, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "FirstOccurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.FirstOccurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "LastOccurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.LastOccurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ModifiedOccurrences", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ModifiedOccurrences);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "DeletedOccurrences", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.DeletedOccurrences);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "StartTimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.StartTimeZone);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.StartTimeZone, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "EndTimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.EndTimeZone);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.EndTimeZone, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ConferenceType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConferenceType);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.ConferenceType, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "AllowNewTimeProposal", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AllowNewTimeProposal);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.AllowNewTimeProposal, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "IsOnlineMeeting", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsOnlineMeeting);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.IsOnlineMeeting, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "MeetingWorkspaceUrl", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MeetingWorkspaceUrl);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.MeetingWorkspaceUrl, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "NetShowUrl", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.NetShowUrl);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.NetShowUrl, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ICalUid", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ICalUid);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.ICalUid, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ICalRecurrenceId", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ICalRecurrenceId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "ICalDateTimeStamp", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ICalDateTimeStamp);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "EnhancedLocation", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.EnhancedLocation);
            },
            set: function (value) {
                this.PropertyBag.set_Item(AppointmentSchema.EnhancedLocation, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "JoinOnlineMeetingUrl", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.JoinOnlineMeetingUrl);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Appointment.prototype, "OnlineMeetingSettings", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.OnlineMeetingSettings);
            },
            enumerable: true,
            configurable: true
        });
        Appointment.prototype.constructor_0 = function (service) {
            if (service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                this.StartTimeZone = service.TimeZone;
            }
        };
        Appointment.prototype.constructor_1 = function (parentAttachment, isNew) {
            if (parentAttachment.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1 && isNew) {
                this.StartTimeZone = parentAttachment.Service.TimeZone;
            }
        };
        Appointment.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Appointment.Bind_0(service, id, propertySet);
            }
            return Appointment.Bind_1(service, id);
        };
        Appointment.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        Appointment.Bind_1 = function (service, id) {
            return Appointment.Bind(service, id, PropertySet.FirstClassProperties);
        };
        Appointment.BindToOccurrence = function (service, recurringMasterId, occurenceIndex, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (recurringMasterId === null || recurringMasterId instanceof ItemId) && (occurenceIndex === null || occurenceIndex.constructor === Number)) {
                return Appointment.BindToOccurrence_0(service, recurringMasterId, occurenceIndex);
            }
            return Appointment.BindToOccurrence_1(service, recurringMasterId, occurenceIndex, propertySet);
        };
        Appointment.BindToOccurrence_0 = function (service, recurringMasterId, occurenceIndex) {
            return Appointment.BindToOccurrence(service, recurringMasterId, occurenceIndex, PropertySet.FirstClassProperties);
        };
        Appointment.BindToOccurrence_1 = function (service, recurringMasterId, occurenceIndex, propertySet) {
            var id = new AppointmentOccurrenceId(recurringMasterId.UniqueId, occurenceIndex);
            return Appointment.Bind(service, id, propertySet);
        };
        Appointment.BindToRecurringMaster = function (service, occurrenceId, propertySet) {
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (occurrenceId === null || occurrenceId instanceof ItemId)) {
                return Appointment.BindToRecurringMaster_0(service, occurrenceId);
            }
            return Appointment.BindToRecurringMaster_1(service, occurrenceId, propertySet);
        };
        Appointment.BindToRecurringMaster_0 = function (service, occurrenceId) {
            return Appointment.BindToRecurringMaster(service, occurrenceId, PropertySet.FirstClassProperties);
        };
        Appointment.BindToRecurringMaster_1 = function (service, occurrenceId, propertySet) {
            var id = new RecurringAppointmentMasterId(occurrenceId.UniqueId);
            return Appointment.Bind(service, id, propertySet);
        };
        Appointment.prototype.GetSchema = function () {
            return AppointmentSchema.Instance;
        };
        Appointment.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        Appointment.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
            var _this = this;
            if (isUpdateOperation) {
                return false;
            }
            var flag = this.PropertyBag.IsPropertyUpdated(AppointmentSchema.StartTimeZone);
            var flag2 = this.PropertyBag.IsPropertyUpdated(AppointmentSchema.EndTimeZone);
            if (flag && flag2) {
                var timeZoneInfo;
                (function () {
                    var _p0 = [
                        timeZoneInfo
                    ];
                    var _r = _this.PropertyBag.TryGetProperty(AppointmentSchema.StartTimeZone, _p0);
                    timeZoneInfo = _p0[0];
                    return _r;
                })();
                var timeZoneInfo2;
                (function () {
                    var _p0 = [
                        timeZoneInfo2
                    ];
                    var _r = _this.PropertyBag.TryGetProperty(AppointmentSchema.EndTimeZone, _p0);
                    timeZoneInfo2 = _p0[0];
                    return _r;
                })();
                return timeZoneInfo === this.Service.TimeZone || timeZoneInfo2 === this.Service.TimeZone;
            }
            return true;
        };
        Appointment.prototype.GetIsCustomDateTimeScopingRequired = function () {
            return true;
        };
        Appointment.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1 && !this.Service.Exchange2007CompatibilityMode && (this.PropertyBag.IsPropertyUpdated(AppointmentSchema.Start) || this.PropertyBag.IsPropertyUpdated(AppointmentSchema.End) || this.PropertyBag.IsPropertyUpdated(AppointmentSchema.IsAllDayEvent) || this.PropertyBag.IsPropertyUpdated(AppointmentSchema.Recurrence))) {
                if (!this.PropertyBag.Contains(AppointmentSchema.StartTimeZone)) {
                    throw new ServiceLocalException(Strings.StartTimeZoneRequired);
                }
                this.StartTimeZone = this.StartTimeZone;
            }
        };
        Appointment.prototype.CreateReply = function (replyAll) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, replyAll ? ResponseMessageType.ReplyAll : ResponseMessageType.Reply);
        };
        Appointment.prototype.Reply = function (bodyPrefix, replyAll) {
            var responseMessage = this.CreateReply(replyAll);
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.SendAndSaveCopy();
        };
        Appointment.prototype.CreateForward = function () {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, ResponseMessageType.Forward);
        };
        Appointment.prototype.Forward = function (bodyPrefix, toRecipients) {
            if (arguments.length === 2 && (bodyPrefix === null || bodyPrefix instanceof MessageBody) && (toRecipients === null || toRecipients instanceof Array)) {
                this.Forward_0(bodyPrefix, toRecipients);
                return;
            }
            this.Forward_1(bodyPrefix, toRecipients);
        };
        Appointment.prototype.Forward_0 = function (bodyPrefix, toRecipients) {
            this.Forward(bodyPrefix, toRecipients);
        };
        Appointment.prototype.Forward_1 = function (bodyPrefix, toRecipients) {
            var responseMessage = this.CreateForward();
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.ToRecipients.AddRange(toRecipients);
            responseMessage.SendAndSaveCopy();
        };
        Appointment.prototype.Save = function (destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode, sendInvitationsMode) {
            if (arguments.length === 2 && (destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode === null || destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode.constructor === Number) && (sendInvitationsMode === null || sendInvitationsMode.constructor === Number)) {
                this.Save_0(destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode, sendInvitationsMode);
                return;
            }
            if (arguments.length === 2 && (destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode === null || destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode instanceof FolderId) && (sendInvitationsMode === null || sendInvitationsMode.constructor === Number)) {
                this.Save_1(destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode, sendInvitationsMode);
                return;
            }
            this.Save_2(destinationFolderNameOrDestinationFolderIdOrSendInvitationsMode);
        };
        Appointment.prototype.Save_0 = function (destinationFolderName, sendInvitationsMode) {
            _super.prototype.InternalCreate.call(this, new FolderId(destinationFolderName), null, new Nullable(sendInvitationsMode));
        };
        Appointment.prototype.Save_1 = function (destinationFolderId, sendInvitationsMode) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            _super.prototype.InternalCreate.call(this, destinationFolderId, null, new Nullable(sendInvitationsMode));
        };
        Appointment.prototype.Save_2 = function (sendInvitationsMode) {
            _super.prototype.InternalCreate.call(this, null, null, new Nullable(sendInvitationsMode));
        };
        Appointment.prototype.Update = function (conflictResolutionMode, sendInvitationsOrCancellationsMode) {
            _super.prototype.InternalUpdate.call(this, null, conflictResolutionMode, null, new Nullable(sendInvitationsOrCancellationsMode));
        };
        Appointment.prototype.Delete = function (deleteMode, sendCancellationsMode) {
            this.InternalDelete(deleteMode, new Nullable(sendCancellationsMode), null);
        };
        Appointment.prototype.CreateAcceptMessage = function (tentative) {
            return new AcceptMeetingInvitationMessage(this, tentative);
        };
        Appointment.prototype.CreateCancelMeetingMessage = function () {
            return new CancelMeetingMessage(this);
        };
        Appointment.prototype.CreateDeclineMessage = function () {
            return new DeclineMeetingInvitationMessage(this);
        };
        Appointment.prototype.Accept = function (sendResponse) {
            return this.InternalAccept(false, sendResponse);
        };
        Appointment.prototype.AcceptTentatively = function (sendResponse) {
            return this.InternalAccept(true, sendResponse);
        };
        Appointment.prototype.InternalAccept = function (tentative, sendResponse) {
            var acceptMeetingInvitationMessage = this.CreateAcceptMessage(tentative);
            if (sendResponse) {
                return acceptMeetingInvitationMessage.SendAndSaveCopy();
            }
            return acceptMeetingInvitationMessage.Save();
        };
        Appointment.prototype.CancelMeeting = function (cancellationMessageText) {
            if (arguments.length === 0) {
                return this.CancelMeeting_0();
            }
            return this.CancelMeeting_1(cancellationMessageText);
        };
        Appointment.prototype.CancelMeeting_0 = function () {
            return this.CreateCancelMeetingMessage().SendAndSaveCopy();
        };
        Appointment.prototype.CancelMeeting_1 = function (cancellationMessageText) {
            var cancelMeetingMessage = this.CreateCancelMeetingMessage();
            cancelMeetingMessage.Body = cancellationMessageText;
            return cancelMeetingMessage.SendAndSaveCopy();
        };
        Appointment.prototype.Decline = function (sendResponse) {
            var declineMeetingInvitationMessage = this.CreateDeclineMessage();
            if (sendResponse) {
                return declineMeetingInvitationMessage.SendAndSaveCopy();
            }
            return declineMeetingInvitationMessage.Save();
        };
        return Appointment;
    }(Item));
    var Contact = (function (_super) {
        __extends(Contact, _super);
        function Contact(serviceOrParentAttachment) {
            _super.call(this, serviceOrParentAttachment);
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(Contact.prototype, "FileAs", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.FileAs);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.FileAs, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "FileAsMapping", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.FileAsMapping);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.FileAsMapping, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "DisplayName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.DisplayName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.DisplayName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "GivenName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.GivenName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.GivenName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Initials", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Initials);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Initials, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "MiddleName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.MiddleName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.MiddleName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "NickName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.NickName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.NickName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "CompleteName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.CompleteName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "CompanyName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.CompanyName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.CompanyName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "EmailAddresses", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.EmailAddresses);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PhysicalAddresses", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PhysicalAddresses);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PhoneNumbers", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PhoneNumbers);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "AssistantName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.AssistantName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.AssistantName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Birthday", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Birthday);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Birthday, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "BusinessHomePage", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.BusinessHomePage);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.BusinessHomePage, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Children", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Children);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Children, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Companies", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Companies);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Companies, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "ContactSource", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.ContactSource);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Department", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Department);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Department, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Generation", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Generation);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Generation, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "ImAddresses", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.ImAddresses);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "JobTitle", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.JobTitle);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.JobTitle, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Manager", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Manager);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Manager, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Mileage", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Mileage);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Mileage, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "OfficeLocation", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.OfficeLocation);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.OfficeLocation, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PostalAddressIndex", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PostalAddressIndex);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.PostalAddressIndex, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Profession", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Profession);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Profession, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "SpouseName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.SpouseName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.SpouseName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Surname", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Surname);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.Surname, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "WeddingAnniversary", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.WeddingAnniversary);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.WeddingAnniversary, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "HasPicture", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.HasPicture);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PhoneticFullName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PhoneticFullName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PhoneticFirstName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PhoneticFirstName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "PhoneticLastName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.PhoneticLastName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Alias", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Alias);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "Notes", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Notes);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "DirectoryPhoto", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.Photo);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "UserSMIMECertificate", {
            get: function () {
                var byteArrayArray = this.PropertyBag.get_Item(ContactSchema.UserSMIMECertificate);
                return byteArrayArray.Content;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "MSExchangeCertificate", {
            get: function () {
                var byteArrayArray = this.PropertyBag.get_Item(ContactSchema.MSExchangeCertificate);
                return byteArrayArray.Content;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "DirectoryId", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.DirectoryId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "ManagerMailbox", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.ManagerMailbox);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Contact.prototype, "DirectReports", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.DirectReports);
            },
            enumerable: true,
            configurable: true
        });
        Contact.prototype.constructor_0 = function (service) {
        };
        Contact.prototype.constructor_1 = function (parentAttachment) {
        };
        Contact.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Contact.Bind_0(service, id, propertySet);
            }
            return Contact.Bind_1(service, id);
        };
        Contact.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        Contact.Bind_1 = function (service, id) {
            return Contact.Bind(service, id, PropertySet.FirstClassProperties);
        };
        Contact.prototype.GetSchema = function () {
            return ContactSchema.Instance;
        };
        Contact.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        Contact.prototype.SetContactPicture = function (contentOrContentStreamOrFileName) {
            if (arguments.length === 1 && (contentOrContentStreamOrFileName === null || contentOrContentStreamOrFileName instanceof Array)) {
                this.SetContactPicture_0(contentOrContentStreamOrFileName);
                return;
            }
            if (arguments.length === 1 && (contentOrContentStreamOrFileName === null || contentOrContentStreamOrFileName instanceof Stream)) {
                this.SetContactPicture_1(contentOrContentStreamOrFileName);
                return;
            }
            this.SetContactPicture_2(contentOrContentStreamOrFileName);
        };
        Contact.prototype.SetContactPicture_0 = function (content) {
            EwsUtilities.ValidateMethodVersion(this.Service, ExchangeVersion.Exchange2010, "SetContactPicture");
            this.InternalRemoveContactPicture();
            var fileAttachment = this.Attachments.AddFileAttachment("ContactPicture.jpg", content);
            fileAttachment.IsContactPhoto = true;
        };
        Contact.prototype.SetContactPicture_1 = function (contentStream) {
            EwsUtilities.ValidateMethodVersion(this.Service, ExchangeVersion.Exchange2010, "SetContactPicture");
            this.InternalRemoveContactPicture();
            var fileAttachment = this.Attachments.AddFileAttachment("ContactPicture.jpg", contentStream);
            fileAttachment.IsContactPhoto = true;
        };
        Contact.prototype.SetContactPicture_2 = function (fileName) {
            EwsUtilities.ValidateMethodVersion(this.Service, ExchangeVersion.Exchange2010, "SetContactPicture");
            this.InternalRemoveContactPicture();
            var fileAttachment = this.Attachments.AddFileAttachment(Path.GetFileName(fileName), fileName);
            fileAttachment.IsContactPhoto = true;
        };
        Contact.prototype.GetContactPictureAttachment = function () {
            EwsUtilities.ValidateMethodVersion(this.Service, ExchangeVersion.Exchange2010, "GetContactPictureAttachment");
            if (!this.PropertyBag.IsPropertyLoaded(ItemSchema.Attachments)) {
                throw new PropertyException(Strings.AttachmentCollectionNotLoaded);
            }
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var fileAttachment = enumerator.Current;
                    if (fileAttachment.IsContactPhoto) {
                        return fileAttachment;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return null;
        };
        Contact.prototype.InternalRemoveContactPicture = function () {
            for (var i = this.Attachments.Count - 1; i >= 0; i = i - 1) {
                var fileAttachment = ((this.Attachments.get_Item(i) instanceof FileAttachment) ? this.Attachments.get_Item(i) : null);
                if (fileAttachment !== null && fileAttachment.IsContactPhoto) {
                    this.Attachments.Remove(fileAttachment);
                }
            }
        };
        Contact.prototype.RemoveContactPicture = function () {
            EwsUtilities.ValidateMethodVersion(this.Service, ExchangeVersion.Exchange2010, "RemoveContactPicture");
            if (!this.PropertyBag.IsPropertyLoaded(ItemSchema.Attachments)) {
                throw new PropertyException(Strings.AttachmentCollectionNotLoaded);
            }
            this.InternalRemoveContactPicture();
        };
        Contact.prototype.Validate = function () {
            var _this = this;
            _super.prototype.Validate.call(this);
            var obj;
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _super.prototype.TryGetProperty.call(_this, ContactSchema.FileAsMapping, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                EwsUtilities.ValidateEnumVersionValue(obj, this.Service.RequestedServerVersion);
            }
        };
        Contact.ContactPictureName = "ContactPicture.jpg";
        return Contact;
    }(Item));
    var ContactGroup = (function (_super) {
        __extends(ContactGroup, _super);
        function ContactGroup(serviceOrParentAttachment) {
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                _super.call(this, serviceOrParentAttachment);
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            _super.call(this, serviceOrParentAttachment);
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(ContactGroup.prototype, "FileAs", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.FileAs);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContactGroup.prototype, "DisplayName", {
            get: function () {
                return this.PropertyBag.get_Item(ContactSchema.DisplayName);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ContactSchema.DisplayName, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContactGroup.prototype, "Members", {
            get: function () {
                return this.PropertyBag.get_Item(ContactGroupSchema.Members);
            },
            enumerable: true,
            configurable: true
        });
        ContactGroup.prototype.constructor_0 = function (service) {
        };
        ContactGroup.prototype.constructor_1 = function (parentAttachment) {
        };
        ContactGroup.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return ContactGroup.Bind_0(service, id, propertySet);
            }
            return ContactGroup.Bind_1(service, id);
        };
        ContactGroup.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        ContactGroup.Bind_1 = function (service, id) {
            return ContactGroup.Bind(service, id, PropertySet.FirstClassProperties);
        };
        ContactGroup.prototype.GetSchema = function () {
            return ContactGroupSchema.Instance;
        };
        ContactGroup.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        ContactGroup.prototype.SetSubject = function (subject) {
            throw new ServiceObjectPropertyException(Strings.PropertyIsReadOnly, ItemSchema.Subject);
        };
        return ContactGroup;
    }(Item));
    var Conversation = (function (_super) {
        __extends(Conversation, _super);
        function Conversation(service) {
            _super.call(this, service);
        }
        Object.defineProperty(Conversation.prototype, "Id", {
            get: function () {
                return this.PropertyBag.get_Item(this.GetIdPropertyDefinition());
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "Topic", {
            get: function () {
                var _this = this;
                var empty = NString.Empty;
                if (this.PropertyBag.Contains(ConversationSchema.Topic)) {
                    (function () {
                        var _p0 = [
                            empty
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.Topic, _p0);
                        empty = _p0[0];
                        return _r;
                    })();
                }
                return empty;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "UniqueRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.UniqueRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalUniqueRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalUniqueRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "UniqueUnreadSenders", {
            get: function () {
                var _this = this;
                var result = null;
                if (this.PropertyBag.Contains(ConversationSchema.UniqueUnreadSenders)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.UniqueUnreadSenders, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalUniqueUnreadSenders", {
            get: function () {
                var _this = this;
                var result = null;
                if (this.PropertyBag.Contains(ConversationSchema.GlobalUniqueUnreadSenders)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.GlobalUniqueUnreadSenders, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "UniqueSenders", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.UniqueSenders);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalUniqueSenders", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalUniqueSenders);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "LastDeliveryTime", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.LastDeliveryTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalLastDeliveryTime", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalLastDeliveryTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "Categories", {
            get: function () {
                var _this = this;
                var result = null;
                if (this.PropertyBag.Contains(ConversationSchema.Categories)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.Categories, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalCategories", {
            get: function () {
                var _this = this;
                var result = null;
                if (this.PropertyBag.Contains(ConversationSchema.GlobalCategories)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.GlobalCategories, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "FlagStatus", {
            get: function () {
                var _this = this;
                var result = ConversationFlagStatus.NotFlagged;
                if (this.PropertyBag.Contains(ConversationSchema.FlagStatus)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.FlagStatus, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalFlagStatus", {
            get: function () {
                var _this = this;
                var result = ConversationFlagStatus.NotFlagged;
                if (this.PropertyBag.Contains(ConversationSchema.GlobalFlagStatus)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.GlobalFlagStatus, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "HasAttachments", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.HasAttachments);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalHasAttachments", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalHasAttachments);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "MessageCount", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.MessageCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalMessageCount", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalMessageCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "UnreadCount", {
            get: function () {
                var _this = this;
                var result = 0;
                if (this.PropertyBag.Contains(ConversationSchema.UnreadCount)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.UnreadCount, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalUnreadCount", {
            get: function () {
                var _this = this;
                var result = 0;
                if (this.PropertyBag.Contains(ConversationSchema.GlobalUnreadCount)) {
                    (function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.PropertyBag.TryGetProperty(ConversationSchema.GlobalUnreadCount, _p0);
                        result = _p0[0];
                        return _r;
                    })();
                }
                return result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "Size", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.Size);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalSize", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalSize);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "ItemClasses", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.ItemClasses);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalItemClasses", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalItemClasses);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "Importance", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.Importance);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalImportance", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalImportance);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "ItemIds", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.ItemIds);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalItemIds", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalItemIds);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "LastModifiedTime", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.LastModifiedTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "InstanceKey", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.InstanceKey);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "Preview", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.Preview);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "IconIndex", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.IconIndex);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalIconIndex", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalIconIndex);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "DraftItemIds", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.DraftItemIds);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "HasIrm", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.HasIrm);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conversation.prototype, "GlobalHasIrm", {
            get: function () {
                return this.PropertyBag.get_Item(ConversationSchema.GlobalHasIrm);
            },
            enumerable: true,
            configurable: true
        });
        Conversation.prototype.GetSchema = function () {
            return ConversationSchema.Instance;
        };
        Conversation.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        Conversation.prototype.GetIdPropertyDefinition = function () {
            return ConversationSchema.Id;
        };
        Conversation.prototype.InternalLoad = function (propertySet) {
            throw new NotSupportedException();
        };
        Conversation.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new NotSupportedException();
        };
        Conversation.prototype.GetChangeXmlElementName = function () {
            throw new NotSupportedException();
        };
        Conversation.prototype.GetDeleteFieldXmlElementName = function () {
            throw new NotSupportedException();
        };
        Conversation.prototype.GetSetFieldXmlElementName = function () {
            throw new NotSupportedException();
        };
        Conversation.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
            throw new NotSupportedException();
        };
        Conversation.prototype.GetExtendedProperties = function () {
            throw new NotSupportedException();
        };
        Conversation.prototype.EnableAlwaysCategorizeItems = function (categories, processSynchronously) {
            this.Service.EnableAlwaysCategorizeItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), categories, processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.DisableAlwaysCategorizeItems = function (processSynchronously) {
            this.Service.DisableAlwaysCategorizeItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.EnableAlwaysDeleteItems = function (processSynchronously) {
            this.Service.EnableAlwaysDeleteItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.DisableAlwaysDeleteItems = function (processSynchronously) {
            this.Service.DisableAlwaysDeleteItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.EnableAlwaysMoveItems = function (destinationFolderId, processSynchronously) {
            this.Service.EnableAlwaysMoveItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), destinationFolderId, processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.DisableAlwaysMoveItemsInConversation = function (processSynchronously) {
            this.Service.DisableAlwaysMoveItemsInConversations(NArray.ToEnumerable([
                this.Id
            ]), processSynchronously).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.DeleteItems = function (contextFolderId, deleteMode) {
            this.Service.DeleteItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, deleteMode).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.MoveItemsInConversation = function (contextFolderId, destinationFolderId) {
            this.Service.MoveItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, destinationFolderId).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.CopyItemsInConversation = function (contextFolderId, destinationFolderId) {
            this.Service.CopyItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, destinationFolderId).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.SetReadStateForItemsInConversation = function (contextFolderId, isRead, suppressReadReceipts) {
            if (arguments.length === 2 && (contextFolderId === null || contextFolderId instanceof FolderId) && (isRead === null || isRead.constructor === Boolean)) {
                this.SetReadStateForItemsInConversation_0(contextFolderId, isRead);
                return;
            }
            this.SetReadStateForItemsInConversation_1(contextFolderId, isRead, suppressReadReceipts);
        };
        Conversation.prototype.SetReadStateForItemsInConversation_0 = function (contextFolderId, isRead) {
            this.Service.SetReadStateForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, isRead).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.SetReadStateForItemsInConversation_1 = function (contextFolderId, isRead, suppressReadReceipts) {
            this.Service.SetReadStateForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, isRead, suppressReadReceipts).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.SetRetentionPolicyForItemsInConversation = function (contextFolderId, retentionPolicyType, retentionPolicyTagId) {
            this.Service.SetRetentionPolicyForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, retentionPolicyType, retentionPolicyTagId).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.FlagItemsComplete = function (contextFolderId, completeDate) {
            var flag = new Flag();
            flag.FlagStatus = ItemFlagStatus.Complete;
            var flag2 = flag;
            if (completeDate !== null) {
                flag2.CompleteDate = completeDate.Value;
            }
            this.Service.SetFlagStatusForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, flag2).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.ClearItemFlags = function (contextFolderId) {
            var flag = new Flag();
            flag.FlagStatus = ItemFlagStatus.NotFlagged;
            var flagStatus = flag;
            this.Service.SetFlagStatusForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, flagStatus).get_Item(0).ThrowIfNecessary();
        };
        Conversation.prototype.FlagItems = function (contextFolderId, startDate, dueDate) {
            var flag = new Flag();
            flag.FlagStatus = ItemFlagStatus.Flagged;
            var flag2 = flag;
            if (startDate !== null) {
                flag2.StartDate = startDate.Value;
            }
            if (dueDate !== null) {
                flag2.DueDate = dueDate.Value;
            }
            this.Service.SetFlagStatusForItemsInConversations(NArray.ToEnumerable([
                new KeyValuePair(this.Id, new Nullable(this.GlobalLastDeliveryTime))
            ]), contextFolderId, flag2).get_Item(0).ThrowIfNecessary();
        };
        return Conversation;
    }(ServiceObject));
    var EmailMessage = (function (_super) {
        __extends(EmailMessage, _super);
        function EmailMessage(serviceOrParentAttachment) {
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                _super.call(this, serviceOrParentAttachment);
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            _super.call(this, serviceOrParentAttachment);
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(EmailMessage.prototype, "ToRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ToRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "BccRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.BccRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "CcRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.CcRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ConversationTopic", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ConversationTopic);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ConversationIndex", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ConversationIndex);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "From", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.From);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.From, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "IsAssociated", {
            get: function () {
                return this.IsAssociated;
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.IsAssociated, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "IsDeliveryReceiptRequested", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsDeliveryReceiptRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsDeliveryReceiptRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "IsRead", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsRead);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsRead, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "IsReadReceiptRequested", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsReadReceiptRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsReadReceiptRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "IsResponseRequested", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsResponseRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsResponseRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "InternetMessageId", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.InternetMessageId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "References", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.References);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.References, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ReplyTo", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ReplyTo);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "Sender", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.Sender);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.Sender, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ReceivedBy", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ReceivedBy);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ReceivedRepresenting", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ReceivedRepresenting);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "ApprovalRequestData", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ApprovalRequestData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EmailMessage.prototype, "VotingInformation", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.VotingInformation);
            },
            enumerable: true,
            configurable: true
        });
        EmailMessage.prototype.constructor_0 = function (service) {
        };
        EmailMessage.prototype.constructor_1 = function (parentAttachment) {
        };
        EmailMessage.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return EmailMessage.Bind_0(service, id, propertySet);
            }
            return EmailMessage.Bind_1(service, id);
        };
        EmailMessage.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        EmailMessage.Bind_1 = function (service, id) {
            return EmailMessage.Bind(service, id, PropertySet.FirstClassProperties);
        };
        EmailMessage.prototype.GetSchema = function () {
            return EmailMessageSchema.Instance;
        };
        EmailMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        EmailMessage.prototype.InternalSend = function (parentFolderId, messageDisposition) {
            _super.prototype.ThrowIfThisIsAttachment.call(this);
            if (this.IsNew) {
                if (this.Attachments.Count === 0 || messageDisposition === MessageDisposition.SaveOnly) {
                    _super.prototype.InternalCreate.call(this, parentFolderId, new Nullable(messageDisposition), null);
                    return;
                }
                _super.prototype.InternalCreate.call(this, null, new Nullable(MessageDisposition.SaveOnly), null);
                this.Service.SendItem(this, parentFolderId);
                return;
            }
            else {
                if (_super.prototype.HasUnprocessedAttachmentChanges.call(this)) {
                    this.Attachments.Validate();
                    this.Attachments.Save();
                }
                if (this.PropertyBag.GetIsUpdateCallNecessary()) {
                    _super.prototype.InternalUpdate.call(this, parentFolderId, ConflictResolutionMode.AutoResolve, new Nullable(messageDisposition), null);
                    return;
                }
                this.Service.SendItem(this, parentFolderId);
                return;
            }
        };
        EmailMessage.prototype.CreateReply = function (replyAll) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, replyAll ? ResponseMessageType.ReplyAll : ResponseMessageType.Reply);
        };
        EmailMessage.prototype.CreateForward = function () {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, ResponseMessageType.Forward);
        };
        EmailMessage.prototype.Reply = function (bodyPrefix, replyAll) {
            var responseMessage = this.CreateReply(replyAll);
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.SendAndSaveCopy();
        };
        EmailMessage.prototype.Forward = function (bodyPrefix, toRecipients) {
            if (arguments.length === 2 && (bodyPrefix === null || bodyPrefix instanceof MessageBody) && (toRecipients === null || toRecipients instanceof Array)) {
                this.Forward_0(bodyPrefix, toRecipients);
                return;
            }
            this.Forward_1(bodyPrefix, toRecipients);
        };
        EmailMessage.prototype.Forward_0 = function (bodyPrefix, toRecipients) {
            this.Forward(bodyPrefix, toRecipients);
        };
        EmailMessage.prototype.Forward_1 = function (bodyPrefix, toRecipients) {
            var responseMessage = this.CreateForward();
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.ToRecipients.AddRange(toRecipients);
            responseMessage.SendAndSaveCopy();
        };
        EmailMessage.prototype.Send = function () {
            this.InternalSend(null, MessageDisposition.SendOnly);
        };
        EmailMessage.prototype.SendAndSaveCopy = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                this.SendAndSaveCopy_0(destinationFolderIdOrDestinationFolderName);
                return;
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName.constructor === Number)) {
                this.SendAndSaveCopy_1(destinationFolderIdOrDestinationFolderName);
                return;
            }
            this.SendAndSaveCopy_2();
        };
        EmailMessage.prototype.SendAndSaveCopy_0 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            this.InternalSend(destinationFolderId, MessageDisposition.SendAndSaveCopy);
        };
        EmailMessage.prototype.SendAndSaveCopy_1 = function (destinationFolderName) {
            this.InternalSend(new FolderId(destinationFolderName), MessageDisposition.SendAndSaveCopy);
        };
        EmailMessage.prototype.SendAndSaveCopy_2 = function () {
            this.InternalSend(new FolderId(WellKnownFolderName.SentItems), MessageDisposition.SendAndSaveCopy);
        };
        EmailMessage.prototype.SuppressReadReceipt = function () {
            _super.prototype.ThrowIfThisIsNew.call(this);
            new SuppressReadReceipt(this).InternalCreate(null, null);
        };
        return EmailMessage;
    }(Item));
    var MeetingMessage = (function (_super) {
        __extends(MeetingMessage, _super);
        function MeetingMessage(parentAttachmentOrService) {
            if (arguments.length === 1 && (parentAttachmentOrService === null || parentAttachmentOrService instanceof ItemAttachment)) {
                _super.call(this, parentAttachmentOrService);
                this.constructor_0(parentAttachmentOrService);
                return;
            }
            _super.call(this, parentAttachmentOrService);
            this.constructor_1(parentAttachmentOrService);
        }
        Object.defineProperty(MeetingMessage.prototype, "AssociatedAppointmentId", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.AssociatedAppointmentId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "IsDelegated", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.IsDelegated);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "IsOutOfDate", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.IsOutOfDate);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "HasBeenProcessed", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.HasBeenProcessed);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "IsOrganizer", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.IsOrganizer);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "ResponseType", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.ResponseType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "ICalUid", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.ICalUid);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "ICalRecurrenceId", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.ICalRecurrenceId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingMessage.prototype, "ICalDateTimeStamp", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingMessageSchema.ICalDateTimeStamp);
            },
            enumerable: true,
            configurable: true
        });
        MeetingMessage.prototype.constructor_0 = function (parentAttachment) {
        };
        MeetingMessage.prototype.constructor_1 = function (service) {
        };
        MeetingMessage.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return MeetingMessage.Bind_0(service, id, propertySet);
            }
            return MeetingMessage.Bind_1(service, id);
        };
        MeetingMessage.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        MeetingMessage.Bind_1 = function (service, id) {
            return MeetingMessage.Bind(service, id, PropertySet.FirstClassProperties);
        };
        MeetingMessage.prototype.GetSchema = function () {
            return MeetingMessageSchema.Instance;
        };
        MeetingMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return MeetingMessage;
    }(EmailMessage));
    var MeetingCancellation = (function (_super) {
        __extends(MeetingCancellation, _super);
        function MeetingCancellation(parentAttachmentOrService) {
            if (arguments.length === 1 && (parentAttachmentOrService === null || parentAttachmentOrService instanceof ItemAttachment)) {
                _super.call(this, parentAttachmentOrService);
                this.constructor_0(parentAttachmentOrService);
                return;
            }
            _super.call(this, parentAttachmentOrService);
            this.constructor_1(parentAttachmentOrService);
        }
        Object.defineProperty(MeetingCancellation.prototype, "Start", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingCancellationSchema.Start);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingCancellation.prototype, "End", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingCancellationSchema.End);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingCancellation.prototype, "Location", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingCancellationSchema.Location);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingCancellation.prototype, "Recurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Recurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingCancellation.prototype, "EnhancedLocation", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingCancellationSchema.EnhancedLocation);
            },
            enumerable: true,
            configurable: true
        });
        MeetingCancellation.prototype.constructor_0 = function (parentAttachment) {
        };
        MeetingCancellation.prototype.constructor_1 = function (service) {
        };
        MeetingCancellation.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return MeetingCancellation.Bind_0(service, id, propertySet);
            }
            return MeetingCancellation.Bind_1(service, id);
        };
        MeetingCancellation.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        MeetingCancellation.Bind_1 = function (service, id) {
            return MeetingCancellation.Bind(service, id, PropertySet.FirstClassProperties);
        };
        MeetingCancellation.prototype.GetSchema = function () {
            return MeetingCancellationSchema.Instance;
        };
        MeetingCancellation.prototype.RemoveMeetingFromCalendar = function () {
            return new CalendarActionResults(new RemoveFromCalendar(this).InternalCreate(null, null));
        };
        MeetingCancellation.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return MeetingCancellation;
    }(MeetingMessage));
    var MeetingRequest = (function (_super) {
        __extends(MeetingRequest, _super);
        function MeetingRequest(parentAttachmentOrService) {
            if (arguments.length === 1 && (parentAttachmentOrService === null || parentAttachmentOrService instanceof ItemAttachment)) {
                _super.call(this, parentAttachmentOrService);
                this.constructor_0(parentAttachmentOrService);
                return;
            }
            _super.call(this, parentAttachmentOrService);
            this.constructor_1(parentAttachmentOrService);
        }
        Object.defineProperty(MeetingRequest.prototype, "MeetingRequestType", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingRequestSchema.MeetingRequestType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IntendedFreeBusyStatus", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingRequestSchema.IntendedFreeBusyStatus);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "ChangeHighlights", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingRequestSchema.ChangeHighlights);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "EnhancedLocation", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingRequestSchema.EnhancedLocation);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Start", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Start);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "End", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.End);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "OriginalStart", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.OriginalStart);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IsAllDayEvent", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsAllDayEvent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "LegacyFreeBusyStatus", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.LegacyFreeBusyStatus);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Location", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Location);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "When", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.When);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IsMeeting", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsMeeting);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IsCancelled", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsCancelled);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IsRecurring", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsRecurring);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "MeetingRequestWasSent", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MeetingRequestWasSent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AppointmentType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "MyResponseType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MyResponseType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Organizer", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Organizer);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "RequiredAttendees", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.RequiredAttendees);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "OptionalAttendees", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.OptionalAttendees);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Resources", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Resources);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "ConflictingMeetingCount", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConflictingMeetingCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AdjacentMeetingCount", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AdjacentMeetingCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "ConflictingMeetings", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConflictingMeetings);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AdjacentMeetings", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AdjacentMeetings);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Duration", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Duration);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "TimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.TimeZone);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AppointmentReplyTime", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentReplyTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AppointmentSequenceNumber", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentSequenceNumber);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AppointmentState", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AppointmentState);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "Recurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Recurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "FirstOccurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.FirstOccurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "LastOccurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.LastOccurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "ModifiedOccurrences", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ModifiedOccurrences);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "DeletedOccurrences", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.DeletedOccurrences);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "StartTimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.StartTimeZone);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "EndTimeZone", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.EndTimeZone);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "ConferenceType", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.ConferenceType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "AllowNewTimeProposal", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.AllowNewTimeProposal);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "IsOnlineMeeting", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.IsOnlineMeeting);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "MeetingWorkspaceUrl", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.MeetingWorkspaceUrl);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingRequest.prototype, "NetShowUrl", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.NetShowUrl);
            },
            enumerable: true,
            configurable: true
        });
        MeetingRequest.prototype.constructor_0 = function (parentAttachment) {
        };
        MeetingRequest.prototype.constructor_1 = function (service) {
        };
        MeetingRequest.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return MeetingRequest.Bind_0(service, id, propertySet);
            }
            return MeetingRequest.Bind_1(service, id);
        };
        MeetingRequest.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        MeetingRequest.Bind_1 = function (service, id) {
            return MeetingRequest.Bind(service, id, PropertySet.FirstClassProperties);
        };
        MeetingRequest.prototype.GetSchema = function () {
            return MeetingRequestSchema.Instance;
        };
        MeetingRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        MeetingRequest.prototype.CreateAcceptMessage = function (tentative) {
            return new AcceptMeetingInvitationMessage(this, tentative);
        };
        MeetingRequest.prototype.CreateDeclineMessage = function () {
            return new DeclineMeetingInvitationMessage(this);
        };
        MeetingRequest.prototype.Accept = function (sendResponse) {
            return this.InternalAccept(false, sendResponse);
        };
        MeetingRequest.prototype.AcceptTentatively = function (sendResponse) {
            return this.InternalAccept(true, sendResponse);
        };
        MeetingRequest.prototype.InternalAccept = function (tentative, sendResponse) {
            var acceptMeetingInvitationMessage = this.CreateAcceptMessage(tentative);
            if (sendResponse) {
                return acceptMeetingInvitationMessage.SendAndSaveCopy();
            }
            return acceptMeetingInvitationMessage.Save();
        };
        MeetingRequest.prototype.Decline = function (sendResponse) {
            var declineMeetingInvitationMessage = this.CreateDeclineMessage();
            if (sendResponse) {
                return declineMeetingInvitationMessage.SendAndSaveCopy();
            }
            return declineMeetingInvitationMessage.Save();
        };
        return MeetingRequest;
    }(MeetingMessage));
    var MeetingResponse = (function (_super) {
        __extends(MeetingResponse, _super);
        function MeetingResponse(parentAttachmentOrService) {
            if (arguments.length === 1 && (parentAttachmentOrService === null || parentAttachmentOrService instanceof ItemAttachment)) {
                _super.call(this, parentAttachmentOrService);
                this.constructor_0(parentAttachmentOrService);
                return;
            }
            _super.call(this, parentAttachmentOrService);
            this.constructor_1(parentAttachmentOrService);
        }
        Object.defineProperty(MeetingResponse.prototype, "Start", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.Start);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "End", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.End);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "Location", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.Location);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "Recurrence", {
            get: function () {
                return this.PropertyBag.get_Item(AppointmentSchema.Recurrence);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "ProposedStart", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.ProposedStart);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "ProposedEnd", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.ProposedEnd);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingResponse.prototype, "EnhancedLocation", {
            get: function () {
                return this.PropertyBag.get_Item(MeetingResponseSchema.EnhancedLocation);
            },
            enumerable: true,
            configurable: true
        });
        MeetingResponse.prototype.constructor_0 = function (parentAttachment) {
        };
        MeetingResponse.prototype.constructor_1 = function (service) {
        };
        MeetingResponse.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return MeetingResponse.Bind_0(service, id, propertySet);
            }
            return MeetingResponse.Bind_1(service, id);
        };
        MeetingResponse.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        MeetingResponse.Bind_1 = function (service, id) {
            return MeetingResponse.Bind(service, id, PropertySet.FirstClassProperties);
        };
        MeetingResponse.prototype.GetSchema = function () {
            return MeetingResponseSchema.Instance;
        };
        MeetingResponse.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return MeetingResponse;
    }(MeetingMessage));
    var PostItem = (function (_super) {
        __extends(PostItem, _super);
        function PostItem(serviceOrParentAttachment) {
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                _super.call(this, serviceOrParentAttachment);
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            _super.call(this, serviceOrParentAttachment);
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(PostItem.prototype, "ConversationIndex", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ConversationIndex);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "ConversationTopic", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ConversationTopic);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "From", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.From);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.From, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "InternetMessageId", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.InternetMessageId);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "IsRead", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsRead);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsRead, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "PostedTime", {
            get: function () {
                return this.PropertyBag.get_Item(PostItemSchema.PostedTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "References", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.References);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.References, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostItem.prototype, "Sender", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.Sender);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.Sender, value);
            },
            enumerable: true,
            configurable: true
        });
        PostItem.prototype.constructor_0 = function (service) {
        };
        PostItem.prototype.constructor_1 = function (parentAttachment) {
        };
        PostItem.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return PostItem.Bind_0(service, id, propertySet);
            }
            return PostItem.Bind_1(service, id);
        };
        PostItem.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        PostItem.Bind_1 = function (service, id) {
            return PostItem.Bind(service, id, PropertySet.FirstClassProperties);
        };
        PostItem.prototype.GetSchema = function () {
            return PostItemSchema.Instance;
        };
        PostItem.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        PostItem.prototype.CreatePostReply = function () {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new PostReply(this);
        };
        PostItem.prototype.PostReply = function (bodyPrefix) {
            var postReply = this.CreatePostReply();
            postReply.BodyPrefix = bodyPrefix;
            postReply.Save();
        };
        PostItem.prototype.CreateReply = function (replyAll) {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, replyAll ? ResponseMessageType.ReplyAll : ResponseMessageType.Reply);
        };
        PostItem.prototype.Reply = function (bodyPrefix, replyAll) {
            var responseMessage = this.CreateReply(replyAll);
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.SendAndSaveCopy();
        };
        PostItem.prototype.CreateForward = function () {
            _super.prototype.ThrowIfThisIsNew.call(this);
            return new ResponseMessage(this, ResponseMessageType.Forward);
        };
        PostItem.prototype.Forward = function (bodyPrefix, toRecipients) {
            if (arguments.length === 2 && (bodyPrefix === null || bodyPrefix instanceof MessageBody) && (toRecipients === null || toRecipients instanceof Array)) {
                this.Forward_0(bodyPrefix, toRecipients);
                return;
            }
            this.Forward_1(bodyPrefix, toRecipients);
        };
        PostItem.prototype.Forward_0 = function (bodyPrefix, toRecipients) {
            this.Forward(bodyPrefix, toRecipients);
        };
        PostItem.prototype.Forward_1 = function (bodyPrefix, toRecipients) {
            var responseMessage = this.CreateForward();
            responseMessage.BodyPrefix = bodyPrefix;
            responseMessage.ToRecipients.AddRange(toRecipients);
            responseMessage.SendAndSaveCopy();
        };
        return PostItem;
    }(Item));
    var Task = (function (_super) {
        __extends(Task, _super);
        function Task(serviceOrParentAttachment) {
            if (arguments.length === 1 && (serviceOrParentAttachment === null || serviceOrParentAttachment instanceof ExchangeService)) {
                _super.call(this, serviceOrParentAttachment);
                this.constructor_0(serviceOrParentAttachment);
                return;
            }
            _super.call(this, serviceOrParentAttachment);
            this.constructor_1(serviceOrParentAttachment);
        }
        Object.defineProperty(Task.prototype, "ActualWork", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.ActualWork);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.ActualWork, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "AssignedTime", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.AssignedTime);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "BillingInformation", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.BillingInformation);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.BillingInformation, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "ChangeCount", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.ChangeCount);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Companies", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Companies);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.Companies, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "CompleteDate", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.CompleteDate);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.CompleteDate, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Contacts", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Contacts);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.Contacts, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "DelegationState", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.DelegationState);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Delegator", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Delegator);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "DueDate", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.DueDate);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.DueDate, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Mode", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Mode);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "IsComplete", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.IsComplete);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "IsRecurring", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.IsRecurring);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "IsTeamTask", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.IsTeamTask);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Mileage", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Mileage);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.Mileage, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Owner", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Owner);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "PercentComplete", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.PercentComplete);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.PercentComplete, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Recurrence", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Recurrence);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.Recurrence, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "StartDate", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.StartDate);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.StartDate, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "Status", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.Status);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.Status, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "StatusDescription", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.StatusDescription);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "TotalWork", {
            get: function () {
                return this.PropertyBag.get_Item(TaskSchema.TotalWork);
            },
            set: function (value) {
                this.PropertyBag.set_Item(TaskSchema.TotalWork, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Task.prototype, "DefaultAffectedTaskOccurrences", {
            get: function () {
                return new Nullable(AffectedTaskOccurrence.AllOccurrences);
            },
            enumerable: true,
            configurable: true
        });
        Task.prototype.constructor_0 = function (service) {
        };
        Task.prototype.constructor_1 = function (parentAttachment) {
        };
        Task.Bind = function (service, id, propertySet) {
            if (arguments.length === 3 && (service === null || service instanceof ExchangeService) && (id === null || id instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return Task.Bind_0(service, id, propertySet);
            }
            return Task.Bind_1(service, id);
        };
        Task.Bind_0 = function (service, id, propertySet) {
            return service.BindToItem(id, propertySet);
        };
        Task.Bind_1 = function (service, id) {
            return Task.Bind(service, id, PropertySet.FirstClassProperties);
        };
        Task.prototype.GetSchema = function () {
            return TaskSchema.Instance;
        };
        Task.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        Task.prototype.GetIsTimeZoneHeaderRequired = function (isUpdateOperation) {
            return true;
        };
        Task.prototype.DeleteCurrentOccurrence = function (deleteMode) {
            this.InternalDelete(deleteMode, null, new Nullable(AffectedTaskOccurrence.SpecifiedOccurrenceOnly));
        };
        Task.prototype.Update = function (conflictResolutionMode) {
            return _super.prototype.InternalUpdate.call(this, null, conflictResolutionMode, new Nullable(MessageDisposition.SaveOnly), null);
        };
        return Task;
    }(Item));
    var EwsUtilities = (function () {
        function EwsUtilities() {
            _super.call(this);
        }
        Object.defineProperty(EwsUtilities, "BuildVersion", {
            get: function () {
                return EwsUtilities.buildVersion.Member;
            },
            enumerable: true,
            configurable: true
        });
        EwsUtilities.Assert = function (condition, caller, message) {
        };
        EwsUtilities.GetNamespacePrefix = function (xmlNamespace) {
            switch (xmlNamespace) {
                case XmlNamespace.Messages:
                    return "m";
                case XmlNamespace.Types:
                    return "t";
                case XmlNamespace.Errors:
                    return "e";
                case XmlNamespace.Soap:
                case XmlNamespace.Soap12:
                    return "soap";
                case XmlNamespace.XmlSchemaInstance:
                    return "xsi";
                case XmlNamespace.PassportSoapFault:
                    return "psf";
                case XmlNamespace.WSTrustFebruary2005:
                    return "wst";
                case XmlNamespace.WSAddressing:
                    return "wsa";
                case XmlNamespace.Autodiscover:
                    return "a";
                default:
                    return NString.Empty;
            }
        };
        EwsUtilities.GetNamespaceUri = function (xmlNamespace) {
            switch (xmlNamespace) {
                case XmlNamespace.Messages:
                    return "http://schemas.microsoft.com/exchange/services/2006/messages";
                case XmlNamespace.Types:
                    return "http://schemas.microsoft.com/exchange/services/2006/types";
                case XmlNamespace.Errors:
                    return "http://schemas.microsoft.com/exchange/services/2006/errors";
                case XmlNamespace.Soap:
                    return "http://schemas.xmlsoap.org/soap/envelope/";
                case XmlNamespace.Soap12:
                    return "http://www.w3.org/2003/05/soap-envelope";
                case XmlNamespace.XmlSchemaInstance:
                    return "http://www.w3.org/2001/XMLSchema-instance";
                case XmlNamespace.PassportSoapFault:
                    return "http://schemas.microsoft.com/Passport/SoapServices/SOAPFault";
                case XmlNamespace.WSTrustFebruary2005:
                    return "http://schemas.xmlsoap.org/ws/2005/02/trust";
                case XmlNamespace.WSAddressing:
                    return "http://www.w3.org/2005/08/addressing";
                case XmlNamespace.Autodiscover:
                    return "http://schemas.microsoft.com/exchange/2010/Autodiscover";
                default:
                    return NString.Empty;
            }
        };
        EwsUtilities.GetNamespaceFromUri = function (namespaceUri) {
            switch (namespaceUri) {
                case "http://schemas.microsoft.com/exchange/services/2006/errors":
                    return XmlNamespace.Errors;
                case "http://schemas.microsoft.com/exchange/services/2006/types":
                    return XmlNamespace.Types;
                case "http://schemas.microsoft.com/exchange/services/2006/messages":
                    return XmlNamespace.Messages;
                case "http://schemas.xmlsoap.org/soap/envelope/":
                    return XmlNamespace.Soap;
                case "http://www.w3.org/2003/05/soap-envelope":
                    return XmlNamespace.Soap12;
                case "http://www.w3.org/2001/XMLSchema-instance":
                    return XmlNamespace.XmlSchemaInstance;
                case "http://schemas.microsoft.com/Passport/SoapServices/SOAPFault":
                    return XmlNamespace.PassportSoapFault;
                case "http://schemas.xmlsoap.org/ws/2005/02/trust":
                    return XmlNamespace.WSTrustFebruary2005;
                case "http://www.w3.org/2005/08/addressing":
                    return XmlNamespace.WSAddressing;
            }
            return XmlNamespace.NotSpecified;
        };
        EwsUtilities.CreateEwsObjectFromXmlElementName = function (service, xmlElementName) {
            var key;
            if (!(function () {
                var _p0 = [
                    key
                ];
                var _r = EwsUtilities.serviceObjectInfo.Member.XmlElementNameToServiceObjectClassMap.TryGetValue(xmlElementName, _p0);
                key = _p0[0];
                return _r;
            })()) {
                return null;
            }
            var createServiceObjectWithServiceParam;
            if ((function () {
                var _p0 = [
                    createServiceObjectWithServiceParam
                ];
                var _r = EwsUtilities.serviceObjectInfo.Member.ServiceObjectConstructorsWithServiceParam.TryGetValue(key, _p0);
                createServiceObjectWithServiceParam = _p0[0];
                return _r;
            })()) {
                return createServiceObjectWithServiceParam(service);
            }
            throw new ArgumentException(Strings.NoAppropriateConstructorForItemClass);
        };
        EwsUtilities.CreateItemFromItemClass = function (itemAttachment, itemClass, isNew) {
            var createServiceObjectWithAttachmentParam;
            if ((function () {
                var _p0 = [
                    createServiceObjectWithAttachmentParam
                ];
                var _r = EwsUtilities.serviceObjectInfo.Member.ServiceObjectConstructorsWithAttachmentParam.TryGetValue(itemClass, _p0);
                createServiceObjectWithAttachmentParam = _p0[0];
                return _r;
            })()) {
                return createServiceObjectWithAttachmentParam(itemAttachment, isNew);
            }
            throw new ArgumentException(Strings.NoAppropriateConstructorForItemClass);
        };
        EwsUtilities.CreateItemFromXmlElementName = function (itemAttachment, xmlElementName) {
            var itemClass;
            if ((function () {
                var _p0 = [
                    itemClass
                ];
                var _r = EwsUtilities.serviceObjectInfo.Member.XmlElementNameToServiceObjectClassMap.TryGetValue(xmlElementName, _p0);
                itemClass = _p0[0];
                return _r;
            })()) {
                return EwsUtilities.CreateItemFromItemClass(itemAttachment, itemClass, false);
            }
            return null;
        };
        EwsUtilities.GetItemTypeFromXmlElementName = function (xmlElementName) {
            var result = null;
            (function () {
                var _p0 = [
                    result
                ];
                var _r = EwsUtilities.serviceObjectInfo.Member.XmlElementNameToServiceObjectClassMap.TryGetValue(xmlElementName, _p0);
                result = _p0[0];
                return _r;
            })();
            return result;
        };
        EwsUtilities.FindFirstItemOfType = function (items) {
            var typeFromHandle = new Type("TItem");
            var enumerator = items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (Type.op_Equality(current.GetType(), typeFromHandle)) {
                        return current;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return null;
        };
        EwsUtilities.WriteTraceStartElement = function (writer, traceTag, includeVersion) {
            writer.WriteStartElement("Trace");
            writer.WriteAttributeString("Tag", traceTag);
            writer.WriteAttributeString("Tid", NNumber.ToString(Thread.CurrentThread.ManagedThreadId));
            writer.WriteAttributeString("Time", DateTime.UtcNow.ToString("u", DateTimeFormatInfo.InvariantInfo));
            if (includeVersion) {
                writer.WriteAttributeString("Version", EwsUtilities.BuildVersion);
            }
        };
        EwsUtilities.FormatLogMessage = function (entryKind, logEntry) {
            var stringBuilder = new StringBuilder();
            var stringWriter = new StringWriter(stringBuilder);
            try {
                var xmlTextWriter = new XmlTextWriter(stringWriter);
                try {
                    xmlTextWriter.set_Formatting(1);
                    EwsUtilities.WriteTraceStartElement(xmlTextWriter, entryKind, false);
                    xmlTextWriter.WriteWhitespace(Environment.NewLine);
                    xmlTextWriter.WriteValue(logEntry);
                    xmlTextWriter.WriteWhitespace(Environment.NewLine);
                    xmlTextWriter.WriteEndElement();
                    xmlTextWriter.WriteWhitespace(Environment.NewLine);
                }
                finally {
                    if (xmlTextWriter !== null) {
                        xmlTextWriter.Dispose();
                    }
                }
            }
            finally {
                if (stringWriter !== null) {
                    stringWriter.Dispose();
                }
            }
            return stringBuilder.ToString();
        };
        EwsUtilities.FormatHttpHeaders = function (sbOrHeaders, headers) {
            if (arguments.length === 2 && (sbOrHeaders === null || sbOrHeaders instanceof StringBuilder) && (headers === null || headers instanceof WebHeaderCollection)) {
                EwsUtilities.FormatHttpHeaders_0(sbOrHeaders, headers);
                return;
            }
            EwsUtilities.FormatHttpHeaders_1(sbOrHeaders);
        };
        EwsUtilities.FormatHttpHeaders_0 = function (sb, headers) {
            var enumerator = headers.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var text = enumerator.Current;
                    sb.Append(NString.Format("{0}: {1}\n", text, headers.get_Item(text)));
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
        };
        EwsUtilities.FormatHttpRequestHeaders = function (request) {
            if (arguments.length === 1) {
                return EwsUtilities.FormatHttpRequestHeaders_0(request);
            }
            return EwsUtilities.FormatHttpRequestHeaders_1(request);
        };
        EwsUtilities.FormatHttpRequestHeaders_0 = function (request) {
            var stringBuilder = new StringBuilder();
            stringBuilder.Append(NString.Format("{0} {1} HTTP/1.1\n", request.Method, request.RequestUri.AbsolutePath));
            EwsUtilities.FormatHttpHeaders(stringBuilder, request.Headers);
            stringBuilder.Append("\n");
            return stringBuilder.ToString();
        };
        EwsUtilities.FormatHttpResponseHeaders = function (response) {
            var stringBuilder = new StringBuilder();
            stringBuilder.Append(NString.Format("HTTP/{0} {1} {2}\n", response.ProtocolVersion, response.StatusCode, response.StatusDescription));
            stringBuilder.Append(EwsUtilities.FormatHttpHeaders(response.Headers));
            stringBuilder.Append("\n");
            return stringBuilder.ToString();
        };
        EwsUtilities.FormatHttpRequestHeaders_1 = function (request) {
            var stringBuilder = new StringBuilder();
            stringBuilder.Append(NString.Format("{0} {1} HTTP/{2}\n", NString.ToUpperInvariant(request.Method), request.RequestUri.AbsolutePath, request.ProtocolVersion));
            stringBuilder.Append(EwsUtilities.FormatHttpHeaders(request.Headers));
            stringBuilder.Append("\n");
            return stringBuilder.ToString();
        };
        EwsUtilities.FormatHttpHeaders_1 = function (headers) {
            var stringBuilder = new StringBuilder();
            var enumerator = headers.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var text = enumerator.Current;
                    stringBuilder.Append(NString.Format("{0}: {1}\n", text, headers.get_Item(text)));
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
            return stringBuilder.ToString();
        };
        EwsUtilities.FormatLogMessageWithXmlContent = function (entryKind, memoryStream) {
            var stringBuilder = new StringBuilder();
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ConformanceLevel(1);
            xmlReaderSettings.set_IgnoreComments(true);
            xmlReaderSettings.set_IgnoreWhitespace(true);
            xmlReaderSettings.set_CloseInput(false);
            var position = memoryStream.Position;
            memoryStream.Position = 0;
            try {
                var xmlReader = XmlReader.Create(memoryStream, xmlReaderSettings);
                try {
                    var stringWriter = new StringWriter(stringBuilder);
                    try {
                        var xmlTextWriter = new XmlTextWriter(stringWriter);
                        try {
                            xmlTextWriter.set_Formatting(1);
                            EwsUtilities.WriteTraceStartElement(xmlTextWriter, entryKind, true);
                            while (!xmlReader.get_EOF()) {
                                xmlTextWriter.WriteNode(xmlReader, true);
                            }
                            xmlTextWriter.WriteEndElement();
                            xmlTextWriter.WriteWhitespace(Environment.NewLine);
                        }
                        finally {
                            if (xmlTextWriter !== null) {
                                xmlTextWriter.Dispose();
                            }
                        }
                    }
                    finally {
                        if (stringWriter !== null) {
                            stringWriter.Dispose();
                        }
                    }
                }
                finally {
                    if (xmlReader !== null) {
                        xmlReader.Dispose();
                    }
                }
            }
            catch (ex_B1) {
                if (ex_B1 instanceof XmlException) {
                    stringBuilder.Length = 0;
                    memoryStream.Position = 0;
                    stringBuilder.Append(Encoding.UTF8.GetString(memoryStream.GetBuffer(), 0, memoryStream.Length));
                }
                else
                    throw ex_B1;
            }
            memoryStream.Position = position;
            return stringBuilder.ToString();
        };
        EwsUtilities.CopyStream = function (source, target) {
            var memoryStream = ((source instanceof MemoryStream) ? source : null);
            if (memoryStream !== null) {
                memoryStream.WriteTo(target);
                return;
            }
            var array = new Array(4096);
            for (var _ai = 0; _ai < array.length; ++_ai)
                array[_ai] = 0;
            var count = array.length;
            for (var i = source.Read(array, 0, count); i > 0; i = source.Read(array, 0, count)) {
                target.Write(array, 0, i);
            }
        };
        EwsUtilities.BoolToXSBool = function (value) {
            if (!value) {
                return "false";
            }
            return "true";
        };
        EwsUtilities.ParseEnumValueList = function (list, value, separators) {
            EwsUtilities.Assert(new Type("T").IsEnum, "EwsUtilities.ParseEnumValueList", "T is not an enum type.");
            var array = value.Split(separators);
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var value2 = array2[i];
                list.Add(Enum.Parse(new Type("T"), value2, false));
            }
        };
        EwsUtilities.SerializeEnum = function (value) {
            var dictionary;
            var result;
            if ((function () {
                var _p0 = [
                    dictionary
                ];
                var _r = EwsUtilities.enumToSchemaDictionaries.Member.TryGetValue(value.GetType(), _p0);
                dictionary = _p0[0];
                return _r;
            })() && (function () {
                var _p0 = [
                    result
                ];
                var _r = dictionary.TryGetValue(value, _p0);
                result = _p0[0];
                return _r;
            })()) {
                return result;
            }
            return value.ToString();
        };
        EwsUtilities.Parse = function (value) {
            if (!new Type("T").IsEnum) {
                return Convert.ChangeType(value, new Type("T"), CultureInfo.InvariantCulture);
            }
            var dictionary;
            var $enum;
            if ((function () {
                var _p0 = [
                    dictionary
                ];
                var _r = EwsUtilities.schemaToEnumDictionaries.Member.TryGetValue(new Type("T"), _p0);
                dictionary = _p0[0];
                return _r;
            })() && (function () {
                var _p0 = [
                    $enum
                ];
                var _r = dictionary.TryGetValue(value, _p0);
                $enum = _p0[0];
                return _r;
            })()) {
                return $enum;
            }
            return Enum.Parse(new Type("T"), value, false);
        };
        EwsUtilities.ConvertTime = function (dateTime, sourceTimeZone, destinationTimeZone) {
            var result;
            try {
                result = TimeZoneInfo.ConvertTime(dateTime, sourceTimeZone, destinationTimeZone);
            }
            catch (innerException) {
                if (innerException instanceof ArgumentException) {
                    throw new TimeZoneConversionException(NString.Format(Strings.CannotConvertBetweenTimeZones, EwsUtilities.DateTimeToXSDateTime(dateTime), sourceTimeZone.DisplayName, destinationTimeZone.DisplayName), innerException);
                }
                else
                    throw innerException;
            }
            return result;
        };
        EwsUtilities.ParseAsUnbiasedDatetimescopedToServicetimeZone = function (dateString, service) {
            var dateTime = DateTime.Parse(dateString, CultureInfo.InvariantCulture);
            if (service.TimeZone === TimeZoneInfo.Utc) {
                return new DateTime(dateTime.Ticks, DateTimeKind.Utc);
            }
            if (EwsUtilities.IsLocalTimeZone(service.TimeZone)) {
                return new DateTime(dateTime.Ticks, DateTimeKind.Local);
            }
            return new DateTime(dateTime.Ticks, DateTimeKind.Unspecified);
        };
        EwsUtilities.IsLocalTimeZone = function (timeZone) {
            return TimeZoneInfo.Local === timeZone || (TimeZoneInfo.Local.Id === timeZone.Id && TimeZoneInfo.Local.HasSameRules(timeZone));
        };
        EwsUtilities.DateTimeToXSDate = function (date) {
            var format;
            switch (date.Kind) {
                case DateTimeKind.Unspecified:
                    format = "yyyy-MM-dd";
                    break;
                case DateTimeKind.Utc:
                    format = "yyyy-MM-ddZ";
                    break;
                default:
                    format = "yyyy-MM-ddzzz";
                    break;
            }
            return date.ToString(format, CultureInfo.InvariantCulture);
        };
        EwsUtilities.DateTimeToXSDateTime = function (dateTime) {
            var text = "yyyy-MM-ddTHH:mm:ss.fff";
            switch (dateTime.Kind) {
                case DateTimeKind.Utc:
                    text = text + "Z";
                    break;
                case DateTimeKind.Local:
                    text = text + "zzz";
                    break;
            }
            return dateTime.ToString(text, CultureInfo.InvariantCulture);
        };
        EwsUtilities.EwsToSystemDayOfWeek = function (dayOfTheWeek) {
            if (dayOfTheWeek === DayOfTheWeek.Day || dayOfTheWeek === DayOfTheWeek.Weekday || dayOfTheWeek === DayOfTheWeek.WeekendDay) {
                throw new ArgumentException(NString.Format("Cannot convert {0} to System.DayOfWeek enum value", dayOfTheWeek), "dayOfTheWeek");
            }
            return dayOfTheWeek;
        };
        EwsUtilities.SystemToEwsDayOfTheWeek = function (dayOfWeek) {
            return dayOfWeek;
        };
        EwsUtilities.TimeSpanToXSDuration = function (timeSpan) {
            var text = (timeSpan.TotalSeconds < 0.0) ? "-" : NString.Empty;
            return NString.Format("{0}P{1}DT{2}H{3}M{4}S", [
                text, Math.abs(timeSpan.Days), Math.abs(timeSpan.Hours), Math.abs(timeSpan.Minutes), Math.abs(timeSpan.Seconds) + "." + Math.abs(timeSpan.Milliseconds)
            ]);
        };
        EwsUtilities.XSDurationToTimeSpan = function (xsDuration) {
            var regex = new Regex("(?<pos>-)?P((?<year>[0-9]+)Y)?((?<month>[0-9]+)M)?((?<day>[0-9]+)D)?(T((?<hour>[0-9]+)H)?((?<minute>[0-9]+)M)?((?<seconds>[0-9]+)(\\.(?<precision>[0-9]+))?S)?)?");
            var match = regex.Match(xsDuration);
            if (!match.Success) {
                throw new ArgumentException(Strings.XsDurationCouldNotBeParsed);
            }
            var text = match.Result("${pos}");
            var flag = false;
            if (!NString.IsNullOrEmpty(text)) {
                flag = true;
            }
            text = match.Result("${year}");
            var num = 0;
            if (!NString.IsNullOrEmpty(text)) {
                num = NNumber.Parse(text);
            }
            text = match.Result("${month}");
            var num2 = 0;
            if (!NString.IsNullOrEmpty(text)) {
                num2 = NNumber.Parse(text);
            }
            text = match.Result("${day}");
            var num3 = 0;
            if (!NString.IsNullOrEmpty(text)) {
                num3 = NNumber.Parse(text);
            }
            text = match.Result("${hour}");
            var hours = 0;
            if (!NString.IsNullOrEmpty(text)) {
                hours = NNumber.Parse(text);
            }
            text = match.Result("${minute}");
            var minutes = 0;
            if (!NString.IsNullOrEmpty(text)) {
                minutes = NNumber.Parse(text);
            }
            text = match.Result("${seconds}");
            var seconds = 0;
            if (!NString.IsNullOrEmpty(text)) {
                seconds = NNumber.Parse(text);
            }
            var milliseconds = 0;
            text = match.Result("${precision}");
            if (text.length > 4) {
                text = NString.Substring(text, 0, 4);
            }
            if (!NString.IsNullOrEmpty(text)) {
                milliseconds = NNumber.Parse(text);
            }
            num3 = num3 + num * 365 + num2 * 30;
            var timeSpan = new TimeSpan(num3, hours, minutes, seconds, milliseconds);
            if (flag) {
                timeSpan = -timeSpan;
            }
            return timeSpan;
        };
        EwsUtilities.TimeSpanToXSTime = function (timeSpan) {
            return NString.Format("{0:00}:{1:00}:{2:00}", timeSpan.Hours, timeSpan.Minutes, timeSpan.Seconds);
        };
        EwsUtilities.GetPrintableTypeName = function (type) {
            if (type.IsGenericType) {
                var value = NString.Substring(type.Name, 0, NString.IndexOf(type.Name, 96) /*'`'*/);
                var stringBuilder = new StringBuilder(value);
                var value2 = Enumerable.ToArray(Enumerable.ToList(NArray.ToEnumerable(type.GetGenericArguments())).ConvertAll(function (t) { return EwsUtilities.GetPrintableTypeName(t); }));
                stringBuilder.Append("<");
                stringBuilder.Append(NString.Join(",", value2));
                stringBuilder.Append(">");
                return stringBuilder.ToString();
            }
            if (type.IsArray) {
                var typeName = NString.Substring(type.Name, 0, NString.IndexOf(type.Name, 91) /*'['*/);
                var stringBuilder2 = new StringBuilder(EwsUtilities.GetSimplifiedTypeName(typeName));
                for (var i = 0; i < type.GetArrayRank(); i = i + 1) {
                    stringBuilder2.Append("[]");
                }
                return stringBuilder2.ToString();
            }
            return EwsUtilities.GetSimplifiedTypeName(type.Name);
        };
        EwsUtilities.GetSimplifiedTypeName = function (typeName) {
            var result;
            if (!(function () {
                var _p0 = [
                    result
                ];
                var _r = EwsUtilities.typeNameToShortNameMap.Member.TryGetValue(typeName, _p0);
                result = _p0[0];
                return _r;
            })()) {
                return typeName;
            }
            return result;
        };
        EwsUtilities.DomainFromEmailAddress = function (emailAddress) {
            var array = emailAddress.Split([
                64
            ] /*'@'*/);
            if (array.length !== 2 || NString.IsNullOrEmpty(array[1])) {
                throw new FormatException(Strings.InvalidEmailAddress);
            }
            return array[1];
        };
        EwsUtilities.ValidateParamAllowNull = function (param, paramName) {
            var selfValidate = ((param instanceof ISelfValidate) ? param : null);
            if (selfValidate !== null) {
                try {
                    selfValidate.Validate();
                }
                catch (innerException) {
                    if (innerException instanceof ServiceValidationException) {
                        throw new ArgumentException(Strings.ValidationFailed, paramName, innerException);
                    }
                    else
                        throw innerException;
                }
            }
            var serviceObject = ((param instanceof ServiceObject) ? param : null);
            if (serviceObject !== null && serviceObject.IsNew) {
                throw new ArgumentException(Strings.ObjectDoesNotHaveId, paramName);
            }
        };
        EwsUtilities.ValidateParam = function (param, paramName) {
            var text = ((param instanceof string) ? param : null);
            var flag;
            if (text !== null) {
                flag = !NString.IsNullOrEmpty(text);
            }
            else {
                flag = (param !== null);
            }
            if (!flag) {
                throw new ArgumentNullException(paramName);
            }
            EwsUtilities.ValidateParamAllowNull(param, paramName);
        };
        EwsUtilities.ValidateParamCollection = function (collection, paramName) {
            EwsUtilities.ValidateParam(collection, paramName);
            var num = 0;
            var enumerator = collection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    try {
                        EwsUtilities.ValidateParam(current, NString.Format("collection[{0}]", num));
                    }
                    catch (innerException) {
                        if (innerException instanceof ArgumentException) {
                            throw new ArgumentException(NString.Format("The element at position {0} is invalid", num), paramName, innerException);
                        }
                        else
                            throw innerException;
                    }
                    num = num + 1;
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
            if (num === 0) {
                throw new ArgumentException(Strings.CollectionIsEmpty, paramName);
            }
        };
        EwsUtilities.ValidateNonBlankStringParamAllowNull = function (param, paramName) {
            if (param !== null) {
                if (param.length === EwsUtilities.CountMatchingChars(param, function (c) { return NChar.IsWhiteSpace(c); })) {
                    throw new ArgumentException(Strings.ArgumentIsBlankString, paramName);
                }
            }
        };
        EwsUtilities.ValidateNonBlankStringParam = function (param, paramName) {
            if (param === null) {
                throw new ArgumentNullException(paramName);
            }
            EwsUtilities.ValidateNonBlankStringParamAllowNull(param, paramName);
        };
        EwsUtilities.ValidateEnumVersionValue = function (enumValue, requestVersion) {
            var type = enumValue.GetType();
            var dictionary = EwsUtilities.enumVersionDictionaries.Member.get_Item(type);
            var exchangeVersion = dictionary.get_Item(enumValue);
            if (requestVersion < exchangeVersion) {
                throw new ServiceVersionException(NString.Format(Strings.EnumValueIncompatibleWithRequestVersion, enumValue.ToString(), type.Name, exchangeVersion));
            }
        };
        EwsUtilities.ValidateServiceObjectVersion = function (serviceObject, requestVersion) {
            var minimumRequiredServerVersion = serviceObject.GetMinimumRequiredServerVersion();
            if (requestVersion < minimumRequiredServerVersion) {
                throw new ServiceVersionException(NString.Format(Strings.ObjectTypeIncompatibleWithRequestVersion, serviceObject.GetType().Name, minimumRequiredServerVersion));
            }
        };
        EwsUtilities.ValidatePropertyVersion = function (service, minimumServerVersion, propertyName) {
            if (service.RequestedServerVersion < minimumServerVersion) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, propertyName, minimumServerVersion));
            }
        };
        EwsUtilities.ValidateMethodVersion = function (service, minimumServerVersion, methodName) {
            if (service.RequestedServerVersion < minimumServerVersion) {
                throw new ServiceVersionException(NString.Format(Strings.MethodIncompatibleWithRequestVersion, methodName, minimumServerVersion));
            }
        };
        EwsUtilities.ValidateClassVersion = function (service, minimumServerVersion, className) {
            if (service.RequestedServerVersion < minimumServerVersion) {
                throw new ServiceVersionException(NString.Format(Strings.ClassIncompatibleWithRequestVersion, className, minimumServerVersion));
            }
        };
        EwsUtilities.ValidateDomainNameAllowNull = function (domainName, paramName) {
            if (domainName !== null) {
                var regex = new Regex("^[-a-zA-Z0-9_.]+$");
                if (!regex.IsMatch(domainName)) {
                    throw new ArgumentException(NString.Format(Strings.InvalidDomainName, domainName), paramName);
                }
            }
        };
        EwsUtilities.GetEnumVersion = function (enumType, enumName) {
            var member = enumType.GetMember(enumName);
            EwsUtilities.Assert(MemberInfo.op_Inequality(member, null) && member.length > 0, "EwsUtilities.GetEnumVersion", NString.Concat([
                "Enum member ", enumName, " not found in ", enumType
            ]));
            var customAttributes = member[0].GetCustomAttributes(new Type("RequiredServerVersionAttribute"), false);
            if (customAttributes !== null && customAttributes.length > 0) {
                return customAttributes[0].Version;
            }
            return ExchangeVersion.Exchange2007_SP1;
        };
        EwsUtilities.BuildEnumDict = function (enumType) {
            var dictionary = new Dictionary();
            var names = Enum.GetNames(enumType);
            var array = names;
            for (var i = 0; i < array.length; i = i + 1) {
                var text = array[i];
                var key = Enum.Parse(enumType, text, false);
                var enumVersion = EwsUtilities.GetEnumVersion(enumType, text);
                dictionary.Add(key, enumVersion);
            }
            return dictionary;
        };
        EwsUtilities.GetEnumSchemaName = function (enumType, enumName) {
            var member = enumType.GetMember(enumName);
            EwsUtilities.Assert(MemberInfo.op_Inequality(member, null) && member.length > 0, "EwsUtilities.GetEnumSchemaName", NString.Concat([
                "Enum member ", enumName, " not found in ", enumType
            ]));
            var customAttributes = member[0].GetCustomAttributes(new Type("EwsEnumAttribute"), false);
            if (customAttributes !== null && customAttributes.length > 0) {
                return customAttributes[0].SchemaName;
            }
            return null;
        };
        EwsUtilities.BuildSchemaToEnumDict = function (enumType) {
            var dictionary = new Dictionary();
            var names = Enum.GetNames(enumType);
            var array = names;
            for (var i = 0; i < array.length; i = i + 1) {
                var text = array[i];
                var value = Enum.Parse(enumType, text, false);
                var enumSchemaName = EwsUtilities.GetEnumSchemaName(enumType, text);
                if (!NString.IsNullOrEmpty(enumSchemaName)) {
                    dictionary.Add(enumSchemaName, value);
                }
            }
            return dictionary;
        };
        EwsUtilities.BuildEnumToSchemaDict = function (enumType) {
            var dictionary = new Dictionary();
            var names = Enum.GetNames(enumType);
            var array = names;
            for (var i = 0; i < array.length; i = i + 1) {
                var text = array[i];
                var key = Enum.Parse(enumType, text, false);
                var enumSchemaName = EwsUtilities.GetEnumSchemaName(enumType, text);
                if (!NString.IsNullOrEmpty(enumSchemaName)) {
                    dictionary.Add(key, enumSchemaName);
                }
            }
            return dictionary;
        };
        EwsUtilities.GetEnumeratedObjectCount = function (objects) {
            var num = 0;
            var enumerator = objects.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var arg_11_0 = enumerator.Current;
                    num = num + 1;
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
            return num;
        };
        EwsUtilities.GetEnumeratedObjectAt = function (objects, index) {
            var num = 0;
            var enumerator = objects.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (num === index) {
                        return current;
                    }
                    num = num + 1;
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
            throw new ArgumentOutOfRangeException("index", Strings.IEnumerableDoesNotContainThatManyObject);
        };
        EwsUtilities.CountMatchingChars = function (str, charPredicate) {
            var num = 0;
            for (var i = 0; i < str.length; i = i + 1) {
                var obj = str.charCodeAt(i);
                if (charPredicate(obj)) {
                    num = num + 1;
                }
            }
            return num;
        };
        EwsUtilities.TrueForAll = function (collection, predicate) {
            var enumerator = collection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (!predicate(current)) {
                        return false;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return true;
        };
        EwsUtilities.ForEach = function (collection, action) {
            var enumerator = collection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    action(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        EwsUtilities.XSFalse = "false";
        EwsUtilities.XSTrue = "true";
        EwsUtilities.EwsTypesNamespacePrefix = "t";
        EwsUtilities.EwsMessagesNamespacePrefix = "m";
        EwsUtilities.EwsErrorsNamespacePrefix = "e";
        EwsUtilities.EwsSoapNamespacePrefix = "soap";
        EwsUtilities.EwsXmlSchemaInstanceNamespacePrefix = "xsi";
        EwsUtilities.PassportSoapFaultNamespacePrefix = "psf";
        EwsUtilities.WSTrustFebruary2005NamespacePrefix = "wst";
        EwsUtilities.WSAddressingNamespacePrefix = "wsa";
        EwsUtilities.AutodiscoverSoapNamespacePrefix = "a";
        EwsUtilities.WSSecurityUtilityNamespacePrefix = "wsu";
        EwsUtilities.WSSecuritySecExtNamespacePrefix = "wsse";
        EwsUtilities.EwsTypesNamespace = "http://schemas.microsoft.com/exchange/services/2006/types";
        EwsUtilities.EwsMessagesNamespace = "http://schemas.microsoft.com/exchange/services/2006/messages";
        EwsUtilities.EwsErrorsNamespace = "http://schemas.microsoft.com/exchange/services/2006/errors";
        EwsUtilities.EwsSoapNamespace = "http://schemas.xmlsoap.org/soap/envelope/";
        EwsUtilities.EwsSoap12Namespace = "http://www.w3.org/2003/05/soap-envelope";
        EwsUtilities.EwsXmlSchemaInstanceNamespace = "http://www.w3.org/2001/XMLSchema-instance";
        EwsUtilities.PassportSoapFaultNamespace = "http://schemas.microsoft.com/Passport/SoapServices/SOAPFault";
        EwsUtilities.WSTrustFebruary2005Namespace = "http://schemas.xmlsoap.org/ws/2005/02/trust";
        EwsUtilities.WSAddressingNamespace = "http://www.w3.org/2005/08/addressing";
        EwsUtilities.AutodiscoverSoapNamespace = "http://schemas.microsoft.com/exchange/2010/Autodiscover";
        EwsUtilities.WSSecurityUtilityNamespace = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd";
        EwsUtilities.WSSecuritySecExtNamespace = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd";
        EwsUtilities.DomainRegex = "^[-a-zA-Z0-9_.]+$";
        EwsUtilities.serviceObjectInfo = new LazyMember(function () { return new ServiceObjectInfo(); });
        EwsUtilities.buildVersion = new LazyMember(function () {
            var versionInfo = FileVersionInfo.GetVersionInfo(Assembly.GetExecutingAssembly().Location);
            return versionInfo.FileVersion;
        });
        EwsUtilities.enumVersionDictionaries = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumDict(new Type("Number")));
            return dictionary;
        });
        EwsUtilities.schemaToEnumDictionaries = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(new Type("Number"), EwsUtilities.BuildSchemaToEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildSchemaToEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildSchemaToEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildSchemaToEnumDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildSchemaToEnumDict(new Type("Number")));
            return dictionary;
        });
        EwsUtilities.enumToSchemaDictionaries = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumToSchemaDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumToSchemaDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumToSchemaDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumToSchemaDict(new Type("Number")));
            dictionary.Add(new Type("Number"), EwsUtilities.BuildEnumToSchemaDict(new Type("Number")));
            return dictionary;
        });
        EwsUtilities.typeNameToShortNameMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add("Boolean", "bool");
            dictionary.Add("Int16", "short");
            dictionary.Add("Int32", "int");
            dictionary.Add("String", "string");
            return dictionary;
        });
        return EwsUtilities;
    }());
    var FolderPermission = (function (_super) {
        __extends(FolderPermission, _super);
        function FolderPermission(userIdOrPrimarySmtpAddressOrStandardUser, permissionLevel) {
            _super.call(this);
            this.userId = null;
            this.canCreateItems = false;
            this.canCreateSubFolders = false;
            this.isFolderOwner = false;
            this.isFolderVisible = false;
            this.isFolderContact = false;
            this.editItems = 0;
            this.deleteItems = 0;
            this.readItems = 0;
            this.permissionLevel = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (userIdOrPrimarySmtpAddressOrStandardUser === null || userIdOrPrimarySmtpAddressOrStandardUser instanceof UserId) && (permissionLevel === null || permissionLevel.constructor === Number)) {
                this.constructor_1(userIdOrPrimarySmtpAddressOrStandardUser, permissionLevel);
                return;
            }
            if (arguments.length === 2 && (userIdOrPrimarySmtpAddressOrStandardUser === null || userIdOrPrimarySmtpAddressOrStandardUser.constructor === String) && (permissionLevel === null || permissionLevel.constructor === Number)) {
                this.constructor_2(userIdOrPrimarySmtpAddressOrStandardUser, permissionLevel);
                return;
            }
            this.constructor_3(userIdOrPrimarySmtpAddressOrStandardUser, permissionLevel);
        }
        Object.defineProperty(FolderPermission.prototype, "UserId", {
            get: function () {
                return this.userId;
            },
            set: function (value) {
                var _this = this;
                if (this.userId !== null) {
                    this.userId.OnChange.Remove(this.PropertyChanged);
                }
                (function () {
                    var _p0 = [
                        _this.userId
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.userId = _p0[0];
                    return _r;
                })();
                if (this.userId !== null) {
                    this.userId.OnChange.Add(this.PropertyChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "CanCreateItems", {
            get: function () {
                return this.canCreateItems;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.canCreateItems
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.canCreateItems = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "CanCreateSubFolders", {
            get: function () {
                return this.canCreateSubFolders;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.canCreateSubFolders
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.canCreateSubFolders = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "IsFolderOwner", {
            get: function () {
                return this.isFolderOwner;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isFolderOwner
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isFolderOwner = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "IsFolderVisible", {
            get: function () {
                return this.isFolderVisible;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isFolderVisible
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isFolderVisible = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "IsFolderContact", {
            get: function () {
                return this.isFolderContact;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isFolderContact
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isFolderContact = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "EditItems", {
            get: function () {
                return this.editItems;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.editItems
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.editItems = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "DeleteItems", {
            get: function () {
                return this.deleteItems;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.deleteItems
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.deleteItems = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "ReadItems", {
            get: function () {
                return this.readItems;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.readItems
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.readItems = _p0[0];
                    return _r;
                })();
                this.AdjustPermissionLevel();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "PermissionLevel", {
            get: function () {
                return this.permissionLevel;
            },
            set: function (value) {
                var _this = this;
                if (this.permissionLevel !== value) {
                    if (value === FolderPermissionLevel.Custom) {
                        throw new ServiceLocalException(Strings.CannotSetPermissionLevelToCustom);
                    }
                    this.AssignIndividualPermissions(FolderPermission.defaultPermissions.Member.get_Item(value));
                    (function () {
                        var _p0 = [
                            _this.permissionLevel
                        ];
                        var _r = _this.SetFieldValue(_p0, value);
                        _this.permissionLevel = _p0[0];
                        return _r;
                    })();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermission.prototype, "DisplayPermissionLevel", {
            get: function () {
                if (this.permissionLevel === FolderPermissionLevel.Custom) {
                    var enumerator = FolderPermission.levelVariants.Member.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var current = enumerator.Current;
                            if (this.IsEqualTo(current)) {
                                return current.PermissionLevel;
                            }
                        }
                    }
                    finally {
                        enumerator.Dispose();
                    }
                }
                return this.permissionLevel;
            },
            enumerable: true,
            configurable: true
        });
        FolderPermission.prototype.IsEqualTo = function (permission) {
            return this.CanCreateItems === permission.CanCreateItems && this.CanCreateSubFolders === permission.CanCreateSubFolders && this.IsFolderContact === permission.IsFolderContact && this.IsFolderVisible === permission.IsFolderVisible && this.IsFolderOwner === permission.IsFolderOwner && this.EditItems === permission.EditItems && this.DeleteItems === permission.DeleteItems && this.ReadItems === permission.ReadItems;
        };
        FolderPermission.prototype.Clone = function () {
            return _super.prototype.MemberwiseClone.call(this);
        };
        FolderPermission.prototype.AdjustPermissionLevel = function () {
            var enumerator = FolderPermission.defaultPermissions.Member.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (this.IsEqualTo(current.Value)) {
                        this.permissionLevel = current.Key;
                        return;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            this.permissionLevel = FolderPermissionLevel.Custom;
        };
        FolderPermission.prototype.AssignIndividualPermissions = function (permission) {
            this.canCreateItems = permission.CanCreateItems;
            this.canCreateSubFolders = permission.CanCreateSubFolders;
            this.isFolderContact = permission.IsFolderContact;
            this.isFolderOwner = permission.IsFolderOwner;
            this.isFolderVisible = permission.IsFolderVisible;
            this.editItems = permission.EditItems;
            this.deleteItems = permission.DeleteItems;
            this.readItems = permission.ReadItems;
        };
        FolderPermission.prototype.constructor_0 = function () {
            this.UserId = new UserId();
        };
        FolderPermission.prototype.constructor_1 = function (userId, permissionLevel) {
            EwsUtilities.ValidateParam(userId, "userId");
            this.userId = userId;
            this.PermissionLevel = permissionLevel;
        };
        FolderPermission.prototype.constructor_2 = function (primarySmtpAddress, permissionLevel) {
            this.userId = new UserId(primarySmtpAddress);
            this.PermissionLevel = permissionLevel;
        };
        FolderPermission.prototype.constructor_3 = function (standardUser, permissionLevel) {
            this.userId = new UserId(standardUser);
            this.PermissionLevel = permissionLevel;
        };
        FolderPermission.prototype.Validate = function (isCalendarFolder, permissionIndex) {
            if (!this.UserId.IsValid()) {
                throw new ServiceValidationException(NString.Format(Strings.FolderPermissionHasInvalidUserId, permissionIndex));
            }
            if (!isCalendarFolder) {
                if (this.readItems === FolderPermissionReadAccess.TimeAndSubjectAndLocation || this.readItems === FolderPermissionReadAccess.TimeOnly) {
                    throw new ServiceLocalException(NString.Format(Strings.ReadAccessInvalidForNonCalendarFolder, this.readItems));
                }
                if (this.permissionLevel === FolderPermissionLevel.FreeBusyTimeAndSubjectAndLocation || this.permissionLevel === FolderPermissionLevel.FreeBusyTimeOnly) {
                    throw new ServiceLocalException(NString.Format(Strings.PermissionLevelInvalidForNonCalendarFolder, this.permissionLevel));
                }
            }
        };
        FolderPermission.prototype.PropertyChanged = function (complexProperty) {
            this.Changed();
        };
        FolderPermission.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "UserId":
                    this.UserId = new UserId();
                    this.UserId.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "CanCreateItems":
                    this.canCreateItems = reader.ReadValue();
                    return true;
                case "CanCreateSubFolders":
                    this.canCreateSubFolders = reader.ReadValue();
                    return true;
                case "IsFolderOwner":
                    this.isFolderOwner = reader.ReadValue();
                    return true;
                case "IsFolderVisible":
                    this.isFolderVisible = reader.ReadValue();
                    return true;
                case "IsFolderContact":
                    this.isFolderContact = reader.ReadValue();
                    return true;
                case "EditItems":
                    this.editItems = reader.ReadValue();
                    return true;
                case "DeleteItems":
                    this.deleteItems = reader.ReadValue();
                    return true;
                case "ReadItems":
                    this.readItems = reader.ReadValue();
                    return true;
                case "PermissionLevel":
                case "CalendarPermissionLevel":
                    this.permissionLevel = reader.ReadValue();
                    return true;
            }
            return false;
        };
        FolderPermission.prototype.LoadFromXml = function (reader, xmlNamespace, xmlElementName) {
            _super.prototype.LoadFromXml.call(this, reader, xmlNamespace, xmlElementName);
            this.AdjustPermissionLevel();
        };
        FolderPermission.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "UserId":
                            this.UserId = new UserId();
                            this.UserId.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "CanCreateItems":
                            this.canCreateItems = jsonProperty.ReadAsBool(current);
                            break;
                        case "CanCreateSubFolders":
                            this.canCreateSubFolders = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsFolderOwner":
                            this.isFolderOwner = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsFolderVisible":
                            this.isFolderVisible = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsFolderContact":
                            this.isFolderContact = jsonProperty.ReadAsBool(current);
                            break;
                        case "EditItems":
                            this.editItems = jsonProperty.ReadEnumValue(current);
                            break;
                        case "DeleteItems":
                            this.deleteItems = jsonProperty.ReadEnumValue(current);
                            break;
                        case "ReadItems":
                            this.readItems = jsonProperty.ReadEnumValue(current);
                            break;
                        case "PermissionLevel":
                        case "CalendarPermissionLevel":
                            this.permissionLevel = jsonProperty.ReadEnumValue(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            this.AdjustPermissionLevel();
        };
        FolderPermission.prototype.WriteElementsToXml = function (writer, isCalendarFolder) {
            if (this.UserId !== null) {
                this.UserId.WriteToXml(writer, "UserId");
            }
            if (this.PermissionLevel === FolderPermissionLevel.Custom) {
                writer.WriteElementValue(XmlNamespace.Types, "CanCreateItems", this.CanCreateItems);
                writer.WriteElementValue(XmlNamespace.Types, "CanCreateSubFolders", this.CanCreateSubFolders);
                writer.WriteElementValue(XmlNamespace.Types, "IsFolderOwner", this.IsFolderOwner);
                writer.WriteElementValue(XmlNamespace.Types, "IsFolderVisible", this.IsFolderVisible);
                writer.WriteElementValue(XmlNamespace.Types, "IsFolderContact", this.IsFolderContact);
                writer.WriteElementValue(XmlNamespace.Types, "EditItems", this.EditItems);
                writer.WriteElementValue(XmlNamespace.Types, "DeleteItems", this.DeleteItems);
                writer.WriteElementValue(XmlNamespace.Types, "ReadItems", this.ReadItems);
            }
            writer.WriteElementValue(XmlNamespace.Types, isCalendarFolder ? "CalendarPermissionLevel" : "PermissionLevel", this.PermissionLevel);
        };
        FolderPermission.prototype.WriteToXml = function (writer, xmlElementName, isCalendarFolder) {
            writer.WriteStartElement(this.Namespace, xmlElementName);
            this.WriteAttributesToXml(writer);
            this.WriteElementsToXml(writer, isCalendarFolder);
            writer.WriteEndElement();
        };
        FolderPermission.prototype.InternalToJson = function (service, isCalendarFolder) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserId", this.UserId.InternalToJson(service));
            if (this.PermissionLevel === FolderPermissionLevel.Custom) {
                jsonObject.Add("CanCreateItems", this.CanCreateItems);
                jsonObject.Add("CanCreateSubFolders", this.CanCreateSubFolders);
                jsonObject.Add("IsFolderOwner", this.IsFolderOwner);
                jsonObject.Add("IsFolderVisible", this.IsFolderVisible);
                jsonObject.Add("IsFolderContact", this.IsFolderContact);
                jsonObject.Add("EditItems", this.EditItems);
                jsonObject.Add("DeleteItems", this.DeleteItems);
                jsonObject.Add("ReadItems", this.ReadItems);
            }
            jsonObject.Add(isCalendarFolder ? "CalendarPermissionLevel" : "PermissionLevel", this.PermissionLevel);
            jsonObject.AddTypeParameter(isCalendarFolder ? "CalendarPermission" : "Permission");
            return jsonObject;
        };
        FolderPermission.defaultPermissions = new LazyMember(function () {
            var dictionary = new Dictionary();
            var folderPermission = new FolderPermission();
            folderPermission.canCreateItems = false;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.None;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = false;
            folderPermission.readItems = FolderPermissionReadAccess.None;
            dictionary.Add(FolderPermissionLevel.None, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.None;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.None;
            dictionary.Add(FolderPermissionLevel.Contributor, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = false;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.None;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.Reviewer, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.Owned;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.NoneditingAuthor, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.Owned;
            folderPermission.editItems = PermissionScope.Owned;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.Author, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = true;
            folderPermission.deleteItems = PermissionScope.Owned;
            folderPermission.editItems = PermissionScope.Owned;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.PublishingAuthor, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.All;
            folderPermission.editItems = PermissionScope.All;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.Editor, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = true;
            folderPermission.deleteItems = PermissionScope.All;
            folderPermission.editItems = PermissionScope.All;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.PublishingEditor, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = true;
            folderPermission.canCreateSubFolders = true;
            folderPermission.deleteItems = PermissionScope.All;
            folderPermission.editItems = PermissionScope.All;
            folderPermission.isFolderContact = true;
            folderPermission.isFolderOwner = true;
            folderPermission.isFolderVisible = true;
            folderPermission.readItems = FolderPermissionReadAccess.FullDetails;
            dictionary.Add(FolderPermissionLevel.Owner, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = false;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.None;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = false;
            folderPermission.readItems = FolderPermissionReadAccess.TimeOnly;
            dictionary.Add(FolderPermissionLevel.FreeBusyTimeOnly, folderPermission);
            folderPermission = new FolderPermission();
            folderPermission.canCreateItems = false;
            folderPermission.canCreateSubFolders = false;
            folderPermission.deleteItems = PermissionScope.None;
            folderPermission.editItems = PermissionScope.None;
            folderPermission.isFolderContact = false;
            folderPermission.isFolderOwner = false;
            folderPermission.isFolderVisible = false;
            folderPermission.readItems = FolderPermissionReadAccess.TimeAndSubjectAndLocation;
            dictionary.Add(FolderPermissionLevel.FreeBusyTimeAndSubjectAndLocation, folderPermission);
            return dictionary;
        });
        FolderPermission.levelVariants = new LazyMember(function () {
            var list = new List();
            var folderPermission = FolderPermission.defaultPermissions.Member.get_Item(FolderPermissionLevel.None);
            var folderPermission2 = FolderPermission.defaultPermissions.Member.get_Item(FolderPermissionLevel.Owner);
            var folderPermission3 = folderPermission.Clone();
            folderPermission3.isFolderVisible = true;
            list.Add(folderPermission3);
            folderPermission3 = folderPermission.Clone();
            folderPermission3.isFolderContact = true;
            list.Add(folderPermission3);
            folderPermission3 = folderPermission.Clone();
            folderPermission3.isFolderContact = true;
            folderPermission3.isFolderVisible = true;
            list.Add(folderPermission3);
            folderPermission3 = folderPermission2.Clone();
            folderPermission3.isFolderContact = false;
            list.Add(folderPermission3);
            return list;
        });
        return FolderPermission;
    }(ComplexProperty));
    var FolderPermissionCollection = (function (_super) {
        __extends(FolderPermissionCollection, _super);
        function FolderPermissionCollection(owner) {
            _super.call(this);
            this.isCalendarFolder = false;
            this.unknownEntries = new Collection();
            this.isCalendarFolder = (owner instanceof CalendarFolder);
        }
        Object.defineProperty(FolderPermissionCollection.prototype, "InnerCollectionXmlElementName", {
            get: function () {
                if (!this.isCalendarFolder) {
                    return "Permissions";
                }
                return "CalendarPermissions";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermissionCollection.prototype, "CollectionItemXmlElementName", {
            get: function () {
                if (!this.isCalendarFolder) {
                    return "Permission";
                }
                return "CalendarPermission";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderPermissionCollection.prototype, "UnknownEntries", {
            get: function () {
                return this.unknownEntries;
            },
            enumerable: true,
            configurable: true
        });
        FolderPermissionCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return this.CollectionItemXmlElementName;
        };
        FolderPermissionCollection.prototype.LoadFromXml = function (reader, localElementName) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, localElementName);
            reader.ReadStartElement(XmlNamespace.Types, this.InnerCollectionXmlElementName);
            _super.prototype.LoadFromXml.call(this, reader, this.InnerCollectionXmlElementName);
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, this.InnerCollectionXmlElementName);
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Types, "UnknownEntries")) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "UnknownEntry")) {
                        this.unknownEntries.Add(reader.ReadElementValue());
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, "UnknownEntries"));
            }
        };
        FolderPermissionCollection.prototype.LoadFromJson = function (jsonProperty, service) {
            var array = jsonProperty.ReadAsArray(this.InnerCollectionXmlElementName);
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var obj = array2[i];
                var folderPermission = new FolderPermission();
                folderPermission.LoadFromJson(((obj instanceof JsonObject) ? obj : null), service);
                _super.prototype.InternalAdd.call(this, folderPermission);
            }
            var array3 = jsonProperty.ReadAsArray("UnknownEntries");
            var array4 = array3;
            for (var j = 0; j < array4.length; j = j + 1) {
                var obj2 = array4[j];
                this.unknownEntries.Add(((obj2 instanceof string) ? obj2 : null));
            }
        };
        FolderPermissionCollection.prototype.Validate = function () {
            for (var i = 0; i < this.Items.Count; i = i + 1) {
                var folderPermission = this.Items.get_Item(i);
                folderPermission.Validate(this.isCalendarFolder, i);
            }
        };
        FolderPermissionCollection.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.InnerCollectionXmlElementName);
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, this.GetCollectionItemXmlElementName(current), this.isCalendarFolder);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
        };
        FolderPermissionCollection.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            var list = new List();
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service, this.isCalendarFolder));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            jsonObject.AddTypeParameter(this.InnerCollectionXmlElementName);
            jsonObject.Add(this.InnerCollectionXmlElementName, NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        FolderPermissionCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new FolderPermission();
        };
        FolderPermissionCollection.prototype.CreateDefaultComplexProperty = function () {
            return new FolderPermission();
        };
        FolderPermissionCollection.prototype.Add = function (permission) {
            _super.prototype.InternalAdd.call(this, permission);
        };
        FolderPermissionCollection.prototype.AddRange = function (permissions) {
            EwsUtilities.ValidateParam(permissions, "permissions");
            var enumerator = permissions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        FolderPermissionCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
        };
        FolderPermissionCollection.prototype.Remove = function (permission) {
            return _super.prototype.InternalRemove.call(this, permission);
        };
        FolderPermissionCollection.prototype.RemoveAt = function (index) {
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        return FolderPermissionCollection;
    }(ComplexPropertyCollection));
    var ItemAttachment = (function (_super) {
        __extends(ItemAttachment, _super);
        function ItemAttachment(ownerOrService) {
            _super.call(this, ownerOrService);
            this.item = null;
            if (arguments.length === 1 && (ownerOrService === null || ownerOrService instanceof Item)) {
                this.constructor_0(ownerOrService);
                return;
            }
            this.constructor_1(ownerOrService);
        }
        Object.defineProperty(ItemAttachment.prototype, "Item", {
            get: function () {
                return this.item;
            },
            set: function (value) {
                _super.prototype.ThrowIfThisIsNotNew.call(this);
                if (this.item !== null) {
                    this.item.OnChange.Remove(this.ItemChanged);
                }
                this.item = value;
                if (this.item !== null) {
                    this.item.OnChange.Add(this.ItemChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        ItemAttachment.prototype.constructor_0 = function (owner) {
        };
        ItemAttachment.prototype.constructor_1 = function (service) {
        };
        ItemAttachment.prototype.ItemChanged = function (serviceObject) {
            if (this.Owner !== null) {
                this.Owner.PropertyBag.Changed();
            }
        };
        ItemAttachment.prototype.GetXmlElementName = function () {
            return "ItemAttachment";
        };
        ItemAttachment.prototype.TryReadElementFromXml = function (reader) {
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag) {
                this.item = EwsUtilities.CreateItemFromXmlElementName(this, reader.LocalName);
                if (this.item !== null) {
                    this.item.LoadFromXml(reader, true);
                }
            }
            return flag;
        };
        ItemAttachment.prototype.TryReadElementFromXmlToPatch = function (reader) {
            _super.prototype.TryReadElementFromXml.call(this, reader);
            reader.Read();
            var itemTypeFromXmlElementName = EwsUtilities.GetItemTypeFromXmlElementName(reader.LocalName);
            if (Type.op_Equality(itemTypeFromXmlElementName, null)) {
                return false;
            }
            if (this.item === null || Type.op_Inequality(this.item.GetType(), itemTypeFromXmlElementName)) {
                throw new ServiceLocalException(Strings.AttachmentItemTypeMismatch);
            }
            this.item.LoadFromXml(reader, false);
            return true;
        };
        ItemAttachment.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            if (jsonProperty.ContainsKey("Item")) {
                var jsonObject = jsonProperty.ReadAsJsonObject("Item");
                if (jsonObject !== null) {
                    this.item = EwsUtilities.CreateItemFromXmlElementName(this, jsonObject.ReadTypeString());
                    if (this.item !== null) {
                        this.item.LoadFromJson(jsonObject, service, true);
                    }
                }
            }
        };
        ItemAttachment.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            this.Item.WriteToXml(writer);
        };
        ItemAttachment.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            jsonObject.Add("Item", ((this.item.ToJson(service, false) instanceof JsonObject) ? this.item.ToJson(service, false) : null));
            return jsonObject;
        };
        ItemAttachment.prototype.Validate = function (attachmentIndex) {
            if (NString.IsNullOrEmpty(this.Name)) {
                throw new ServiceValidationException(NString.Format(Strings.ItemAttachmentMustBeNamed, attachmentIndex));
            }
            this.Item.Attachments.Validate();
        };
        ItemAttachment.prototype.Load = function (additionalPropertiesOrBodyType, additionalProperties) {
            if (arguments.length === 1 && (additionalPropertiesOrBodyType === null || additionalPropertiesOrBodyType instanceof Array)) {
                this.Load_0(additionalPropertiesOrBodyType);
                return;
            }
            if (arguments.length === 1) {
                this.Load_1(additionalPropertiesOrBodyType);
                return;
            }
            if (arguments.length === 2 && (additionalPropertiesOrBodyType === null || additionalPropertiesOrBodyType.constructor === Number) && (additionalProperties === null || additionalProperties instanceof Array)) {
                this.Load_2(additionalPropertiesOrBodyType, additionalProperties);
                return;
            }
            this.Load_3(additionalPropertiesOrBodyType, additionalProperties);
        };
        ItemAttachment.prototype.Load_0 = function (additionalProperties) {
            _super.prototype.InternalLoad.call(this, null, NArray.ToEnumerable(additionalProperties));
        };
        ItemAttachment.prototype.Load_1 = function (additionalProperties) {
            _super.prototype.InternalLoad.call(this, null, additionalProperties);
        };
        ItemAttachment.prototype.Load_2 = function (bodyType, additionalProperties) {
            _super.prototype.InternalLoad.call(this, new Nullable(bodyType), NArray.ToEnumerable(additionalProperties));
        };
        ItemAttachment.prototype.Load_3 = function (bodyType, additionalProperties) {
            _super.prototype.InternalLoad.call(this, new Nullable(bodyType), additionalProperties);
        };
        return ItemAttachment;
    }(Attachment));
    var ItemAttachment = (function (_super) {
        __extends(ItemAttachment, _super);
        function ItemAttachment(owner) {
            _super.call(this, owner);
        }
        Object.defineProperty(ItemAttachment.prototype, "Item", {
            get: function () {
                return this.Item;
            },
            set: function (value) {
                this.Item = value;
            },
            enumerable: true,
            configurable: true
        });
        return ItemAttachment;
    }(ItemAttachment));
    var GroupMember = (function (_super) {
        __extends(GroupMember, _super);
        function GroupMember(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey, mailboxTypeOrRoutingType) {
            _super.call(this);
            this.addressInformation = null;
            this.status = 0;
            this.key = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember.constructor === String)) {
                this.constructor_1(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember);
                return;
            }
            if (arguments.length === 3 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember.constructor === String) && (routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey === null || routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey.constructor === String) && (mailboxTypeOrRoutingType === null || mailboxTypeOrRoutingType.constructor === Number)) {
                this.constructor_2(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey, mailboxTypeOrRoutingType);
                return;
            }
            if (arguments.length === 2 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember.constructor === String) && (routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey === null || routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey.constructor === Number)) {
                this.constructor_3(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey);
                return;
            }
            if (arguments.length === 3 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember.constructor === String) && (routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey === null || routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey.constructor === String) && (mailboxTypeOrRoutingType === null || mailboxTypeOrRoutingType.constructor === String)) {
                this.constructor_4(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey, mailboxTypeOrRoutingType);
                return;
            }
            if (arguments.length === 2 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember.constructor === String) && (routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey === null || routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey.constructor === String)) {
                this.constructor_5(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey);
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember instanceof ItemId)) {
                this.constructor_6(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember);
                return;
            }
            if (arguments.length === 2 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember instanceof ItemId) && (routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey === null || routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey.constructor === String)) {
                this.constructor_7(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey);
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember instanceof EmailAddress)) {
                this.constructor_8(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember);
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember === null || smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember instanceof GroupMember)) {
                this.constructor_9(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember);
                return;
            }
            this.constructor_10(smtpAddressOrAddressOrNameOrContactGroupIdOrContactIdOrAddressInformationOrMember, routingTypeOrMailboxTypeOrAddressOrSmtpAddressOrAddressToLinkOrEmailAddressKey);
        }
        Object.defineProperty(GroupMember.prototype, "Key", {
            get: function () {
                return this.key;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupMember.prototype, "AddressInformation", {
            get: function () {
                return this.addressInformation;
            },
            set: function (value) {
                if (this.addressInformation !== null) {
                    this.addressInformation.OnChange.Remove(this.AddressInformationChanged);
                }
                this.addressInformation = value;
                if (this.addressInformation !== null) {
                    this.addressInformation.OnChange.Add(this.AddressInformationChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupMember.prototype, "Status", {
            get: function () {
                return this.status;
            },
            enumerable: true,
            configurable: true
        });
        GroupMember.prototype.constructor_0 = function () {
            this.key = null;
            this.status = MemberStatus.Unrecognized;
        };
        GroupMember.prototype.constructor_1 = function (smtpAddress) {
            this.constructor_0();
            this.AddressInformation = new EmailAddress(smtpAddress);
        };
        GroupMember.prototype.constructor_2 = function (address, routingType, mailboxType) {
            this.constructor_0();
            switch (mailboxType) {
                case MailboxType.OneOff:
                case MailboxType.Mailbox:
                case MailboxType.PublicFolder:
                case MailboxType.PublicGroup:
                case MailboxType.Contact:
                    this.AddressInformation = new EmailAddress(null, address, routingType, mailboxType);
                    return;
            }
            throw new ServiceLocalException(Strings.InvalidMailboxType);
        };
        GroupMember.prototype.constructor_3 = function (smtpAddress, mailboxType) {
            this.constructor_2(smtpAddress, "SMTP", mailboxType);
        };
        GroupMember.prototype.constructor_4 = function (name, address, routingType) {
            this.constructor_0();
            this.AddressInformation = new EmailAddress(name, address, routingType, MailboxType.OneOff);
        };
        GroupMember.prototype.constructor_5 = function (name, smtpAddress) {
            this.constructor_4(name, smtpAddress, "SMTP");
        };
        GroupMember.prototype.constructor_6 = function (contactGroupId) {
            this.constructor_0();
            this.AddressInformation = new EmailAddress(null, null, null, MailboxType.ContactGroup, contactGroupId);
        };
        GroupMember.prototype.constructor_7 = function (contactId, addressToLink) {
            this.constructor_0();
            this.AddressInformation = new EmailAddress(null, addressToLink, null, MailboxType.Contact, contactId);
        };
        GroupMember.prototype.constructor_8 = function (addressInformation) {
            this.constructor_0();
            this.AddressInformation = new EmailAddress(addressInformation);
        };
        GroupMember.prototype.constructor_9 = function (member) {
            this.constructor_0();
            EwsUtilities.ValidateParam(member, "member");
            this.AddressInformation = new EmailAddress(member.AddressInformation);
        };
        GroupMember.prototype.constructor_10 = function (contact, emailAddressKey) {
            this.constructor_0();
            EwsUtilities.ValidateParam(contact, "contact");
            var mailbox = contact.EmailAddresses.get_Item(emailAddressKey);
            this.AddressInformation = new EmailAddress(mailbox);
            this.addressInformation.Id = contact.Id;
        };
        GroupMember.prototype.ReadAttributesFromXml = function (reader) {
            this.key = reader.ReadAttributeValue("Key");
        };
        GroupMember.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Status") {
                    this.status = EwsUtilities.Parse(reader.ReadElementValue());
                    return true;
                }
                if (localName === "Mailbox") {
                    this.AddressInformation = new EmailAddress();
                    this.AddressInformation.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        GroupMember.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Status")) {
                            if (a === "Mailbox") {
                                this.AddressInformation = new EmailAddress();
                                this.AddressInformation.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            }
                        }
                        else {
                            this.status = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        GroupMember.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Key", this.key);
        };
        GroupMember.prototype.WriteElementsToXml = function (writer) {
            this.AddressInformation.WriteToXml(writer, XmlNamespace.Types, "Mailbox");
        };
        GroupMember.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Key", this.key);
            jsonObject.Add("Mailbox", this.AddressInformation.InternalToJson(service));
            return jsonObject;
        };
        GroupMember.prototype.AddressInformationChanged = function (complexProperty) {
            this.Changed();
        };
        return GroupMember;
    }(ComplexProperty));
    var GroupMemberCollection = (function (_super) {
        __extends(GroupMemberCollection, _super);
        function GroupMemberCollection() {
            _super.call(this);
            this.collectionIsCleared = false;
        }
        GroupMemberCollection.prototype.Find = function (key) {
            EwsUtilities.ValidateParam(key, "key");
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.Key === key) {
                        return current;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            return null;
        };
        GroupMemberCollection.prototype.Clear = function () {
            _super.prototype.InternalClear.call(this);
            this.collectionIsCleared = true;
        };
        GroupMemberCollection.prototype.Add = function (member) {
            EwsUtilities.ValidateParam(member, "member");
            EwsUtilities.Assert(member.Key === null, "GroupMemberCollection.Add", "member.Key is not null.");
            EwsUtilities.Assert(!_super.prototype.Contains.call(this, member), "GroupMemberCollection.Add", "The member is already in the collection");
            _super.prototype.InternalAdd.call(this, member);
        };
        GroupMemberCollection.prototype.AddRange = function (members) {
            EwsUtilities.ValidateParam(members, "members");
            var enumerator = members.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        GroupMemberCollection.prototype.AddContactGroup = function (contactGroupId) {
            this.Add(new GroupMember(contactGroupId));
        };
        GroupMemberCollection.prototype.AddPersonalContact = function (contactId, addressToLink) {
            if (arguments.length === 2 && (contactId === null || contactId instanceof ItemId) && (addressToLink === null || addressToLink.constructor === String)) {
                this.AddPersonalContact_0(contactId, addressToLink);
                return;
            }
            this.AddPersonalContact_1(contactId);
        };
        GroupMemberCollection.prototype.AddPersonalContact_0 = function (contactId, addressToLink) {
            this.Add(new GroupMember(contactId, addressToLink));
        };
        GroupMemberCollection.prototype.AddPersonalContact_1 = function (contactId) {
            this.AddPersonalContact(contactId, null);
        };
        GroupMemberCollection.prototype.AddDirectoryUser = function (smtpAddressOrAddress, routingType) {
            if (arguments.length === 1 && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String)) {
                this.AddDirectoryUser_0(smtpAddressOrAddress);
                return;
            }
            this.AddDirectoryUser_1(smtpAddressOrAddress, routingType);
        };
        GroupMemberCollection.prototype.AddDirectoryUser_0 = function (smtpAddress) {
            this.AddDirectoryUser(smtpAddress, "SMTP");
        };
        GroupMemberCollection.prototype.AddDirectoryUser_1 = function (address, routingType) {
            this.Add(new GroupMember(address, routingType, MailboxType.Mailbox));
        };
        GroupMemberCollection.prototype.AddDirectoryContact = function (smtpAddressOrAddress, routingType) {
            if (arguments.length === 1 && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String)) {
                this.AddDirectoryContact_0(smtpAddressOrAddress);
                return;
            }
            this.AddDirectoryContact_1(smtpAddressOrAddress, routingType);
        };
        GroupMemberCollection.prototype.AddDirectoryContact_0 = function (smtpAddress) {
            this.AddDirectoryContact(smtpAddress, "SMTP");
        };
        GroupMemberCollection.prototype.AddDirectoryContact_1 = function (address, routingType) {
            this.Add(new GroupMember(address, routingType, MailboxType.Contact));
        };
        GroupMemberCollection.prototype.AddPublicGroup = function (smtpAddress) {
            this.Add(new GroupMember(smtpAddress, "SMTP", MailboxType.PublicGroup));
        };
        GroupMemberCollection.prototype.AddDirectoryPublicFolder = function (smtpAddress) {
            this.Add(new GroupMember(smtpAddress, "SMTP", MailboxType.PublicFolder));
        };
        GroupMemberCollection.prototype.AddOneOff = function (displayName, addressOrSmtpAddress, routingType) {
            if (arguments.length === 3 && (displayName === null || displayName.constructor === String) && (addressOrSmtpAddress === null || addressOrSmtpAddress.constructor === String) && (routingType === null || routingType.constructor === String)) {
                this.AddOneOff_0(displayName, addressOrSmtpAddress, routingType);
                return;
            }
            this.AddOneOff_1(displayName, addressOrSmtpAddress);
        };
        GroupMemberCollection.prototype.AddOneOff_0 = function (displayName, address, routingType) {
            this.Add(new GroupMember(displayName, address, routingType));
        };
        GroupMemberCollection.prototype.AddOneOff_1 = function (displayName, smtpAddress) {
            this.AddOneOff(displayName, smtpAddress, "SMTP");
        };
        GroupMemberCollection.prototype.AddContactEmailAddress = function (contact, emailAddressKey) {
            this.Add(new GroupMember(contact, emailAddressKey));
        };
        GroupMemberCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            _super.prototype.InternalRemoveAt.call(this, index);
        };
        GroupMemberCollection.prototype.Remove = function (member) {
            return _super.prototype.InternalRemove.call(this, member);
        };
        GroupMemberCollection.prototype.WriteSetUpdateToXml = function (writer, ownerObject, propertyDefinition) {
            if (this.collectionIsCleared) {
                if (this.AddedItems.Count === 0) {
                    this.WriteDeleteMembersCollectionToXml(writer);
                }
                else {
                    this.WriteSetOrAppendMembersToXml(writer, this.AddedItems, true);
                }
            }
            else {
                this.WriteSetOrAppendMembersToXml(writer, this.AddedItems, false);
                this.WriteDeleteMembersToXml(writer, this.ModifiedItems);
                this.WriteSetOrAppendMembersToXml(writer, this.ModifiedItems, false);
                this.WriteDeleteMembersToXml(writer, this.RemovedItems);
            }
            return true;
        };
        GroupMemberCollection.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            throw new NotImplementedException();
        };
        GroupMemberCollection.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            return false;
        };
        GroupMemberCollection.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            return false;
        };
        GroupMemberCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new GroupMember();
        };
        GroupMemberCollection.prototype.CreateDefaultComplexProperty = function () {
            return new GroupMember();
        };
        GroupMemberCollection.prototype.ClearChangeLog = function () {
            _super.prototype.ClearChangeLog.call(this);
            this.collectionIsCleared = false;
        };
        GroupMemberCollection.prototype.GetCollectionItemXmlElementName = function (member) {
            return "Member";
        };
        GroupMemberCollection.prototype.WriteDeleteMembersCollectionToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "DeleteItemField");
            ContactGroupSchema.Members.WriteToXml(writer);
            writer.WriteEndElement();
        };
        GroupMemberCollection.prototype.WriteDeleteMembersToXml = function (writer, members) {
            if (members.Count !== 0) {
                var groupMemberPropertyDefinition = new GroupMemberPropertyDefinition();
                var enumerator = members.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        writer.WriteStartElement(XmlNamespace.Types, "DeleteItemField");
                        groupMemberPropertyDefinition.Key = current.Key;
                        groupMemberPropertyDefinition.WriteToXml(writer);
                        writer.WriteEndElement();
                    }
                }
                finally {
                    enumerator.Dispose();
                }
            }
        };
        GroupMemberCollection.prototype.WriteSetOrAppendMembersToXml = function (writer, members, setMode) {
            if (members.Count !== 0) {
                writer.WriteStartElement(XmlNamespace.Types, setMode ? "SetItemField" : "AppendToItemField");
                ContactGroupSchema.Members.WriteToXml(writer);
                writer.WriteStartElement(XmlNamespace.Types, "DistributionList");
                writer.WriteStartElement(XmlNamespace.Types, "Members");
                var enumerator = members.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        current.WriteToXml(writer, "Member");
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                writer.WriteEndElement();
                writer.WriteEndElement();
                writer.WriteEndElement();
            }
        };
        GroupMemberCollection.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            var enumerator = this.ModifiedItems.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (NString.IsNullOrEmpty(current.Key)) {
                        throw new ServiceValidationException(Strings.ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return GroupMemberCollection;
    }(ComplexPropertyCollection));
    var HighlightTerm = (function (_super) {
        __extends(HighlightTerm, _super);
        function HighlightTerm() {
            _super.call(this);
            this.scope = null;
            this.value = null;
        }
        Object.defineProperty(HighlightTerm.prototype, "Scope", {
            get: function () {
                return this.scope;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HighlightTerm.prototype, "Value", {
            get: function () {
                return this.value;
            },
            enumerable: true,
            configurable: true
        });
        HighlightTerm.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Scope") {
                    this.scope = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Value") {
                    this.value = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        HighlightTerm.prototype.LoadFromJson = function (jsonProperty, service) {
            if (jsonProperty.ContainsKey("Scope")) {
                this.scope = jsonProperty.ReadAsString("Scope");
            }
            if (jsonProperty.ContainsKey("Value")) {
                this.value = jsonProperty.ReadAsString("Value");
            }
        };
        return HighlightTerm;
    }(ComplexProperty));
    var ImAddressDictionary = (function (_super) {
        __extends(ImAddressDictionary, _super);
        function ImAddressDictionary() {
            _super.call(this);
        }
        ImAddressDictionary.prototype.get_Item = function (key) {
            return this.Entries.get_Item(key).ImAddress;
        };
        ImAddressDictionary.prototype.set_Item = function (key, value) {
            var _this = this;
            if (value === null) {
                _super.prototype.InternalRemove.call(this, key);
                return;
            }
            var imAddressEntry;
            if ((function () {
                var _p0 = [
                    imAddressEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                imAddressEntry = _p0[0];
                return _r;
            })()) {
                imAddressEntry.ImAddress = value;
                this.Changed();
                return;
            }
            imAddressEntry = new ImAddressEntry(key, value);
            _super.prototype.InternalAdd.call(this, imAddressEntry);
        };
        ImAddressDictionary.prototype.GetFieldURI = function () {
            return "contacts:ImAddress";
        };
        ImAddressDictionary.prototype.CreateEntryInstance = function () {
            return new ImAddressEntry();
        };
        ImAddressDictionary.prototype.TryGetValue = function (key, imAddress) {
            var _this = this;
            var imAddressEntry = null;
            if ((function () {
                var _p0 = [
                    imAddressEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                imAddressEntry = _p0[0];
                return _r;
            })()) {
                imAddress[0] = imAddressEntry.ImAddress;
                return true;
            }
            imAddress[0] = null;
            return false;
        };
        return ImAddressDictionary;
    }(DictionaryProperty));
    var ImAddressEntry = (function (_super) {
        __extends(ImAddressEntry, _super);
        function ImAddressEntry(key, imAddress) {
            _super.call(this);
            this.imAddress = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(key, imAddress);
        }
        Object.defineProperty(ImAddressEntry.prototype, "ImAddress", {
            get: function () {
                return this.imAddress;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.imAddress
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.imAddress = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        ImAddressEntry.prototype.constructor_0 = function () {
        };
        ImAddressEntry.prototype.constructor_1 = function (key, imAddress) {
            this.imAddress = imAddress;
        };
        ImAddressEntry.prototype.ReadTextValueFromXml = function (reader) {
            this.imAddress = reader.ReadValue();
        };
        ImAddressEntry.prototype.WriteElementsToXml = function (writer) {
            writer.WriteValue(this.ImAddress, "ImAddress");
        };
        ImAddressEntry.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Key", this.Key);
            jsonObject.Add("ImAddress", this.ImAddress);
            return jsonObject;
        };
        ImAddressEntry.prototype.LoadFromJson = function (jsonProperty, service) {
            this.Key = jsonProperty.ReadEnumValue("Key");
            this.ImAddress = jsonProperty.ReadAsString("ImAddress");
        };
        return ImAddressEntry;
    }(DictionaryEntryProperty));
    var InternetMessageHeader = (function (_super) {
        __extends(InternetMessageHeader, _super);
        function InternetMessageHeader() {
            _super.call(this);
            this.name = null;
            this.value = null;
        }
        Object.defineProperty(InternetMessageHeader.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.name
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.name = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InternetMessageHeader.prototype, "Value", {
            get: function () {
                return this.value;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.value
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.value = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        InternetMessageHeader.prototype.ReadAttributesFromXml = function (reader) {
            this.name = reader.ReadAttributeValue("HeaderName");
        };
        InternetMessageHeader.prototype.ReadTextValueFromXml = function (reader) {
            this.value = reader.ReadValue();
        };
        InternetMessageHeader.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "HeaderName")) {
                            if (a === "Value") {
                                this.value = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.name = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        InternetMessageHeader.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("HeaderName", this.Name);
        };
        InternetMessageHeader.prototype.WriteElementsToXml = function (writer) {
            writer.WriteValue(this.Value, this.Name);
        };
        InternetMessageHeader.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("HeaderName", this.Name);
            jsonObject.Add("Value", this.Value);
            return jsonObject;
        };
        InternetMessageHeader.prototype.ToString = function () {
            return NString.Format("{0}={1}", this.Name, this.Value);
        };
        return InternetMessageHeader;
    }(ComplexProperty));
    var InternetMessageHeaderCollection = (function (_super) {
        __extends(InternetMessageHeaderCollection, _super);
        function InternetMessageHeaderCollection() {
            _super.call(this);
        }
        InternetMessageHeaderCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new InternetMessageHeader();
        };
        InternetMessageHeaderCollection.prototype.CreateDefaultComplexProperty = function () {
            return new InternetMessageHeader();
        };
        InternetMessageHeaderCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "InternetMessageHeader";
        };
        InternetMessageHeaderCollection.prototype.Find = function (name) {
            var enumerator = _super.prototype.GetEnumerator.call(this);
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (NString.Compare(name, current.Name, StringComparison.OrdinalIgnoreCase) === 0) {
                        return current;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return null;
        };
        return InternetMessageHeaderCollection;
    }(ComplexPropertyCollection));
    var ItemCollection = (function (_super) {
        __extends(ItemCollection, _super);
        function ItemCollection() {
            _super.call(this);
            this.items = new List();
        }
        Object.defineProperty(ItemCollection.prototype, "Count", {
            get: function () {
                return this.items.Count;
            },
            enumerable: true,
            configurable: true
        });
        ItemCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.items.get_Item(index);
        };
        ItemCollection.prototype.LoadFromXml = function (reader, localElementName) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, localElementName);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var tItem = ((EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName) instanceof TItem) ? EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName) : null);
                        if (tItem === null) {
                            reader.SkipCurrentElement();
                        }
                        else {
                            tItem.LoadFromXml(reader, true);
                            this.items.Add(tItem);
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, localElementName));
            }
        };
        ItemCollection.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                var item = ((EwsUtilities.CreateEwsObjectFromXmlElementName(service, jsonObject.ReadTypeString()) instanceof TItem) ? EwsUtilities.CreateEwsObjectFromXmlElementName(service, jsonObject.ReadTypeString()) : null);
                item.LoadFromJson(jsonObject, service, true);
                this.items.Add(item);
            }
        };
        ItemCollection.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        ItemCollection.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        return ItemCollection;
    }(ComplexProperty));
    var ItemIdCollection = (function (_super) {
        __extends(ItemIdCollection, _super);
        function ItemIdCollection() {
            _super.call(this);
        }
        ItemIdCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new ItemId();
        };
        ItemIdCollection.prototype.CreateDefaultComplexProperty = function () {
            return new ItemId();
        };
        ItemIdCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return complexProperty.GetXmlElementName();
        };
        return ItemIdCollection;
    }(ComplexPropertyCollection));
    var ConversationId = (function (_super) {
        __extends(ConversationId, _super);
        function ConversationId(uniqueId) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, uniqueId);
            this.constructor_1(uniqueId);
        }
        ConversationId.prototype.constructor_0 = function () {
        };
        ConversationId.op_Implicit = function (uniqueId) {
            return new ConversationId(uniqueId);
        };
        ConversationId.op_Implicit = function (conversationId) {
            if (conversationId === null) {
                throw new ArgumentNullException("conversationId");
            }
            if (NString.IsNullOrEmpty(conversationId.UniqueId)) {
                return NString.Empty;
            }
            return conversationId.UniqueId;
        };
        ConversationId.prototype.GetXmlElementName = function () {
            return "ConversationId";
        };
        ConversationId.prototype.GetJsonTypeName = function () {
            return "ItemId";
        };
        ConversationId.prototype.constructor_1 = function (uniqueId) {
        };
        ConversationId.prototype.ToString = function () {
            return this.UniqueId;
        };
        return ConversationId;
    }(ServiceId));
    var UniqueBody = (function (_super) {
        __extends(UniqueBody, _super);
        function UniqueBody() {
            _super.call(this);
            this.bodyType = 0;
            this.text = null;
            this.isTruncated = false;
        }
        Object.defineProperty(UniqueBody.prototype, "BodyType", {
            get: function () {
                return this.bodyType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UniqueBody.prototype, "Text", {
            get: function () {
                return this.text;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UniqueBody.prototype, "IsTruncated", {
            get: function () {
                return this.isTruncated;
            },
            enumerable: true,
            configurable: true
        });
        UniqueBody.op_Implicit = function (messageBody) {
            EwsUtilities.ValidateParam(messageBody, "messageBody");
            return messageBody.Text;
        };
        UniqueBody.prototype.ReadAttributesFromXml = function (reader) {
            this.bodyType = reader.ReadAttributeValue("BodyType");
            var value = reader.ReadAttributeValue("IsTruncated");
            if (!NString.IsNullOrEmpty(value)) {
                this.isTruncated = NBoolean.Parse(value);
            }
        };
        UniqueBody.prototype.ReadTextValueFromXml = function (reader) {
            this.text = reader.ReadValue();
        };
        UniqueBody.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "BodyType")) {
                            if (!(a === "IsTruncated")) {
                                if (a === "Value") {
                                    this.text = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.isTruncated = jsonProperty.ReadAsBool(current);
                            }
                        }
                        else {
                            this.bodyType = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        UniqueBody.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("BodyType", this.BodyType);
        };
        UniqueBody.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.Text)) {
                writer.WriteValue(this.Text, "UniqueBody");
            }
        };
        UniqueBody.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("BodyType", this.BodyType);
            jsonObject.Add("IsTruncated", this.IsTruncated);
            if (!NString.IsNullOrEmpty(this.Text)) {
                jsonObject.Add("Value", this.Text);
            }
            return jsonObject;
        };
        UniqueBody.prototype.ToString = function () {
            if (this.Text !== null) {
                return this.Text;
            }
            return NString.Empty;
        };
        return UniqueBody;
    }(ComplexProperty));
    var LobbyBypass;
    (function (LobbyBypass) {
        LobbyBypass[LobbyBypass["Disabled"] = 0] = "Disabled";
        LobbyBypass[LobbyBypass["EnabledForGatewayParticipants"] = 1] = "EnabledForGatewayParticipants";
    })(LobbyBypass || (LobbyBypass = {}));
    var OnlineMeetingAccessLevel;
    (function (OnlineMeetingAccessLevel) {
        OnlineMeetingAccessLevel[OnlineMeetingAccessLevel["Locked"] = 0] = "Locked";
        OnlineMeetingAccessLevel[OnlineMeetingAccessLevel["Invited"] = 1] = "Invited";
        OnlineMeetingAccessLevel[OnlineMeetingAccessLevel["Internal"] = 2] = "Internal";
        OnlineMeetingAccessLevel[OnlineMeetingAccessLevel["Everyone"] = 3] = "Everyone";
    })(OnlineMeetingAccessLevel || (OnlineMeetingAccessLevel = {}));
    var Presenters;
    (function (Presenters) {
        Presenters[Presenters["Disabled"] = 0] = "Disabled";
        Presenters[Presenters["Internal"] = 1] = "Internal";
        Presenters[Presenters["Everyone"] = 2] = "Everyone";
    })(Presenters || (Presenters = {}));
    var OnlineMeetingSettings = (function (_super) {
        __extends(OnlineMeetingSettings, _super);
        function OnlineMeetingSettings(lobbyBypassOrOnlineMeetingSettings, accessLevel, presenters) {
            _super.call(this);
            this.lobbyBypass = 0;
            this.accessLevel = 0;
            this.presenters = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 3 && (lobbyBypassOrOnlineMeetingSettings === null || lobbyBypassOrOnlineMeetingSettings.constructor === Number) && (accessLevel === null || accessLevel.constructor === Number) && (presenters === null || presenters.constructor === Number)) {
                this.constructor_1(lobbyBypassOrOnlineMeetingSettings, accessLevel, presenters);
                return;
            }
            this.constructor_2(lobbyBypassOrOnlineMeetingSettings);
        }
        Object.defineProperty(OnlineMeetingSettings.prototype, "LobbyBypass", {
            get: function () {
                return this.lobbyBypass;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.lobbyBypass
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.lobbyBypass = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OnlineMeetingSettings.prototype, "AccessLevel", {
            get: function () {
                return this.accessLevel;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.accessLevel
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.accessLevel = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OnlineMeetingSettings.prototype, "Presenters", {
            get: function () {
                return this.presenters;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.presenters
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.presenters = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        OnlineMeetingSettings.prototype.constructor_0 = function () {
        };
        OnlineMeetingSettings.prototype.constructor_1 = function (lobbyBypass, accessLevel, presenters) {
            this.lobbyBypass = lobbyBypass;
            this.accessLevel = accessLevel;
            this.presenters = presenters;
        };
        OnlineMeetingSettings.prototype.constructor_2 = function (onlineMeetingSettings) {
            this.constructor_0();
            EwsUtilities.ValidateParam(onlineMeetingSettings, "OnlineMeetingSettings");
            this.LobbyBypass = onlineMeetingSettings.LobbyBypass;
            this.AccessLevel = onlineMeetingSettings.AccessLevel;
            this.Presenters = onlineMeetingSettings.Presenters;
        };
        OnlineMeetingSettings.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "LobbyBypass") {
                    this.lobbyBypass = reader.ReadElementValue();
                    return true;
                }
                if (localName === "AccessLevel") {
                    this.accessLevel = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Presenters") {
                    this.presenters = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        OnlineMeetingSettings.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "LobbyBypass", this.LobbyBypass);
            writer.WriteElementValue(XmlNamespace.Types, "AccessLevel", this.AccessLevel);
            writer.WriteElementValue(XmlNamespace.Types, "Presenters", this.Presenters);
        };
        return OnlineMeetingSettings;
    }(ComplexProperty));
    var Mailbox = (function (_super) {
        __extends(Mailbox, _super);
        function Mailbox(smtpAddressOrAddress, routingType) {
            _super.call(this);
            this.Address = null;
            this.RoutingType = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (smtpAddressOrAddress === null || smtpAddressOrAddress.constructor === String)) {
                this.constructor_1(smtpAddressOrAddress);
                return;
            }
            this.constructor_2(smtpAddressOrAddress, routingType);
        }
        Object.defineProperty(Mailbox.prototype, "IsValid", {
            get: function () {
                return !NString.IsNullOrEmpty(this.Address);
            },
            enumerable: true,
            configurable: true
        });
        Mailbox.prototype.constructor_0 = function () {
        };
        Mailbox.prototype.constructor_1 = function (smtpAddress) {
            this.constructor_0();
            this.Address = smtpAddress;
        };
        Mailbox.prototype.constructor_2 = function (address, routingType) {
            this.constructor_1(address);
            this.RoutingType = routingType;
        };
        Mailbox.op_Implicit = function (smtpAddress) {
            return new Mailbox(smtpAddress);
        };
        Mailbox.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "EmailAddress") {
                    this.Address = reader.ReadElementValue();
                    return true;
                }
                if (localName === "RoutingType") {
                    this.RoutingType = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        Mailbox.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "EmailAddress", this.Address);
            writer.WriteElementValue(XmlNamespace.Types, "RoutingType", this.RoutingType);
        };
        Mailbox.prototype.LoadFromJson = function (jsonProperty, service) {
            if (jsonProperty.ContainsKey("EmailAddress")) {
                this.Address = jsonProperty.ReadAsString("EmailAddress");
            }
            if (jsonProperty.ContainsKey("RoutingType")) {
                this.RoutingType = jsonProperty.ReadAsString("RoutingType");
            }
        };
        Mailbox.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("EmailAddress", this.Address);
            jsonObject.Add("RoutingType", this.RoutingType);
            return jsonObject;
        };
        Mailbox.prototype.GetSearchString = function () {
            return this.Address;
        };
        Mailbox.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.Address, "address");
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.RoutingType, "routingType");
        };
        Mailbox.prototype.Equals = function (obj) {
            if (NObject.ReferenceEquals(this, obj)) {
                return true;
            }
            var mailbox = ((obj instanceof Mailbox) ? obj : null);
            return mailbox !== null && ((this.Address === null && mailbox.Address === null) || (this.Address !== null && this.Address === mailbox.Address)) && ((this.RoutingType === null && mailbox.RoutingType === null) || (this.RoutingType !== null && this.RoutingType === mailbox.RoutingType));
        };
        Mailbox.prototype.GetHashCode = function () {
            if (!NString.IsNullOrEmpty(this.Address)) {
                var num = NString.GetHashCode(this.Address);
                if (!NString.IsNullOrEmpty(this.RoutingType)) {
                    num = (num ^ NString.GetHashCode(this.RoutingType));
                }
                return num;
            }
            return _super.prototype.GetHashCode.call(this);
        };
        Mailbox.prototype.ToString = function () {
            if (!this.IsValid) {
                return NString.Empty;
            }
            if (!NString.IsNullOrEmpty(this.RoutingType)) {
                return this.RoutingType + ":" + this.Address;
            }
            return this.Address;
        };
        return Mailbox;
    }(ComplexProperty));
    var ManagedFolderInformation = (function (_super) {
        __extends(ManagedFolderInformation, _super);
        function ManagedFolderInformation() {
            _super.call(this);
            this.canDelete = null;
            this.canRenameOrMove = null;
            this.mustDisplayComment = null;
            this.hasQuota = null;
            this.isManagedFoldersRoot = null;
            this.managedFolderId = null;
            this.comment = null;
            this.storageQuota = null;
            this.folderSize = null;
            this.homePage = null;
        }
        Object.defineProperty(ManagedFolderInformation.prototype, "CanDelete", {
            get: function () {
                return this.canDelete;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "CanRenameOrMove", {
            get: function () {
                return this.canRenameOrMove;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "MustDisplayComment", {
            get: function () {
                return this.mustDisplayComment;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "HasQuota", {
            get: function () {
                return this.hasQuota;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "IsManagedFoldersRoot", {
            get: function () {
                return this.isManagedFoldersRoot;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "ManagedFolderId", {
            get: function () {
                return this.managedFolderId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "Comment", {
            get: function () {
                return this.comment;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "StorageQuota", {
            get: function () {
                return this.storageQuota;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "FolderSize", {
            get: function () {
                return this.folderSize;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ManagedFolderInformation.prototype, "HomePage", {
            get: function () {
                return this.homePage;
            },
            enumerable: true,
            configurable: true
        });
        ManagedFolderInformation.prototype.TryReadElementFromXml = function (reader) {
            var _this = this;
            var localName;
            switch (localName = reader.LocalName) {
                case "CanDelete":
                    this.canDelete = new Nullable(reader.ReadValue());
                    return true;
                case "CanRenameOrMove":
                    this.canRenameOrMove = new Nullable(reader.ReadValue());
                    return true;
                case "MustDisplayComment":
                    this.mustDisplayComment = new Nullable(reader.ReadValue());
                    return true;
                case "HasQuota":
                    this.hasQuota = new Nullable(reader.ReadValue());
                    return true;
                case "IsManagedFoldersRoot":
                    this.isManagedFoldersRoot = new Nullable(reader.ReadValue());
                    return true;
                case "ManagedFolderId":
                    this.managedFolderId = reader.ReadValue();
                    return true;
                case "Comment":
                    (function () {
                        var _p0 = [
                            _this.comment
                        ];
                        var _r = reader.TryReadValue(_p0);
                        _this.comment = _p0[0];
                        return _r;
                    })();
                    return true;
                case "StorageQuota":
                    this.storageQuota = new Nullable(reader.ReadValue());
                    return true;
                case "FolderSize":
                    this.folderSize = new Nullable(reader.ReadValue());
                    return true;
                case "HomePage":
                    (function () {
                        var _p0 = [
                            _this.homePage
                        ];
                        var _r = reader.TryReadValue(_p0);
                        _this.homePage = _p0[0];
                        return _r;
                    })();
                    return true;
            }
            return false;
        };
        ManagedFolderInformation.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "CanDelete":
                            this.canDelete = new Nullable(jsonProperty.ReadAsBool(current));
                            break;
                        case "CanRenameOrMove":
                            this.canRenameOrMove = new Nullable(jsonProperty.ReadAsBool(current));
                            break;
                        case "MustDisplayComment":
                            this.mustDisplayComment = new Nullable(jsonProperty.ReadAsBool(current));
                            break;
                        case "HasQuota":
                            this.hasQuota = new Nullable(jsonProperty.ReadAsBool(current));
                            break;
                        case "IsManagedFoldersRoot":
                            this.isManagedFoldersRoot = new Nullable(jsonProperty.ReadAsBool(current));
                            break;
                        case "ManagedFolderId":
                            this.managedFolderId = jsonProperty.ReadAsString(current);
                            break;
                        case "Comment":
                            {
                                var text = jsonProperty.ReadAsString(current);
                                if (text !== null) {
                                    this.comment = text;
                                }
                                break;
                            }
                        case "StorageQuota":
                            this.storageQuota = new Nullable(jsonProperty.ReadAsInt(current));
                            break;
                        case "FolderSize":
                            this.folderSize = new Nullable(jsonProperty.ReadAsInt(current));
                            break;
                        case "HomePage":
                            {
                                var text2 = jsonProperty.ReadAsString(current);
                                if (text2 !== null) {
                                    this.homePage = text2;
                                }
                                break;
                            }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return ManagedFolderInformation;
    }(ComplexProperty));
    var MeetingSuggestion = (function (_super) {
        __extends(MeetingSuggestion, _super);
        function MeetingSuggestion() {
            _super.call(this);
            this.Attendees = null;
            this.Location = null;
            this.Subject = null;
            this.MeetingString = null;
            this.StartTime = null;
            this.EndTime = null;
        }
        MeetingSuggestion.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Attendees":
                    this.Attendees = new EmailUserEntityCollection();
                    this.Attendees.LoadFromXml(reader, XmlNamespace.Types, "Attendees");
                    return true;
                case "Location":
                    this.Location = reader.ReadElementValue();
                    return true;
                case "Subject":
                    this.Subject = reader.ReadElementValue();
                    return true;
                case "MeetingString":
                    this.MeetingString = reader.ReadElementValue();
                    return true;
                case "StartTime":
                    this.StartTime = reader.ReadElementValueAsDateTime();
                    return true;
                case "EndTime":
                    this.EndTime = reader.ReadElementValueAsDateTime();
                    return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return MeetingSuggestion;
    }(ExtractedEntity));
    var MeetingSuggestionCollection = (function (_super) {
        __extends(MeetingSuggestionCollection, _super);
        function MeetingSuggestionCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        MeetingSuggestionCollection.prototype.constructor_0 = function () {
        };
        MeetingSuggestionCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        MeetingSuggestionCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new MeetingSuggestion();
        };
        MeetingSuggestionCollection.prototype.CreateDefaultComplexProperty = function () {
            return new MeetingSuggestion();
        };
        MeetingSuggestionCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "MeetingSuggestion";
        };
        return MeetingSuggestionCollection;
    }(ComplexPropertyCollection));
    var MeetingTimeZone = (function (_super) {
        __extends(MeetingTimeZone, _super);
        function MeetingTimeZone(timeZoneOrName) {
            _super.call(this);
            this.name = null;
            this.baseOffset = null;
            this.standard = null;
            this.daylight = null;
            if (arguments.length === 1 && (timeZoneOrName === null || timeZoneOrName instanceof TimeZoneInfo)) {
                this.constructor_0(timeZoneOrName);
                return;
            }
            if (arguments.length === 0) {
                this.constructor_1();
                return;
            }
            this.constructor_2(timeZoneOrName);
        }
        Object.defineProperty(MeetingTimeZone.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.name
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.name = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingTimeZone.prototype, "BaseOffset", {
            get: function () {
                return this.baseOffset;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.baseOffset
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.baseOffset = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingTimeZone.prototype, "Standard", {
            get: function () {
                return this.standard;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.standard
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.standard = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MeetingTimeZone.prototype, "Daylight", {
            get: function () {
                return this.daylight;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.daylight
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.daylight = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        MeetingTimeZone.prototype.constructor_0 = function (timeZone) {
            this.Name = timeZone.Id;
        };
        MeetingTimeZone.prototype.constructor_1 = function () {
        };
        MeetingTimeZone.prototype.constructor_2 = function (name) {
            this.constructor_1();
            this.name = name;
        };
        MeetingTimeZone.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "BaseOffset") {
                    this.baseOffset = new Nullable(EwsUtilities.XSDurationToTimeSpan(reader.ReadElementValue()));
                    return true;
                }
                if (localName === "Standard") {
                    this.standard = new TimeChange();
                    this.standard.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "Daylight") {
                    this.daylight = new TimeChange();
                    this.daylight.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        MeetingTimeZone.prototype.ReadAttributesFromXml = function (reader) {
            this.name = reader.ReadAttributeValue("TimeZoneName");
        };
        MeetingTimeZone.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "BaseOffset")) {
                            if (!(a === "Standard")) {
                                if (!(a === "Daylight")) {
                                    if (a === "TimeZoneName") {
                                        this.name = jsonProperty.ReadAsString(current);
                                    }
                                }
                                else {
                                    this.daylight = new TimeChange();
                                    this.daylight.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                }
                            }
                            else {
                                this.standard = new TimeChange();
                                this.standard.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            }
                        }
                        else {
                            this.baseOffset = new Nullable(EwsUtilities.XSDurationToTimeSpan(jsonProperty.ReadAsString(current)));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        MeetingTimeZone.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("TimeZoneName", this.Name);
        };
        MeetingTimeZone.prototype.WriteElementsToXml = function (writer) {
            if (this.BaseOffset !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "BaseOffset", EwsUtilities.TimeSpanToXSDuration(this.BaseOffset.Value));
            }
            if (this.Standard !== null) {
                this.Standard.WriteToXml(writer, "Standard");
            }
            if (this.Daylight !== null) {
                this.Daylight.WriteToXml(writer, "Daylight");
            }
        };
        MeetingTimeZone.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.BaseOffset !== null) {
                jsonObject.Add("BaseOffset", EwsUtilities.TimeSpanToXSDuration(this.BaseOffset.Value));
            }
            if (this.Standard !== null) {
                jsonObject.Add("Standard", this.Standard.InternalToJson(service));
            }
            if (this.Daylight !== null) {
                jsonObject.Add("Daylight", this.Daylight.InternalToJson(service));
            }
            jsonObject.Add("TimeZoneName", this.Name);
            return jsonObject;
        };
        MeetingTimeZone.prototype.ToTimeZoneInfo = function () {
            if (NString.IsNullOrEmpty(this.Name)) {
                return null;
            }
            var result = null;
            try {
                result = TimeZoneInfo.FindSystemTimeZoneById(this.Name);
            }
            catch (ex_1F) {
                if (ex_1F instanceof TimeZoneNotFoundException) {
                }
                else
                    throw ex_1F;
            }
            return result;
        };
        return MeetingTimeZone;
    }(ComplexProperty));
    var MessageBody = (function (_super) {
        __extends(MessageBody, _super);
        function MessageBody(bodyTypeOrText, text) {
            _super.call(this);
            this.bodyType = 0;
            this.text = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (bodyTypeOrText === null || bodyTypeOrText.constructor === Number) && (text === null || text.constructor === String)) {
                this.constructor_1(bodyTypeOrText, text);
                return;
            }
            this.constructor_2(bodyTypeOrText);
        }
        Object.defineProperty(MessageBody.prototype, "BodyType", {
            get: function () {
                return this.bodyType;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.bodyType
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.bodyType = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MessageBody.prototype, "Text", {
            get: function () {
                return this.text;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.text
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.text = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        MessageBody.prototype.constructor_0 = function () {
        };
        MessageBody.prototype.constructor_1 = function (bodyType, text) {
            this.constructor_0();
            this.bodyType = bodyType;
            this.text = text;
        };
        MessageBody.prototype.constructor_2 = function (text) {
            this.constructor_1(BodyType.HTML, text);
        };
        MessageBody.op_Implicit = function (textBody) {
            return new MessageBody(BodyType.HTML, textBody);
        };
        MessageBody.op_Implicit = function (messageBody) {
            EwsUtilities.ValidateParam(messageBody, "messageBody");
            return messageBody.Text;
        };
        MessageBody.prototype.ReadAttributesFromXml = function (reader) {
            this.bodyType = reader.ReadAttributeValue("BodyType");
        };
        MessageBody.prototype.ReadTextValueFromXml = function (reader) {
            this.text = reader.ReadValue();
        };
        MessageBody.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "BodyType")) {
                            if (a === "Value") {
                                this.text = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.bodyType = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        MessageBody.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("BodyType", this.BodyType);
        };
        MessageBody.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.Text)) {
                writer.WriteValue(this.Text, "Body");
            }
        };
        MessageBody.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("BodyType", this.BodyType);
            if (!NString.IsNullOrEmpty(this.Text)) {
                jsonObject.Add("Value", this.Text);
            }
            return jsonObject;
        };
        MessageBody.prototype.ToString = function () {
            if (this.Text !== null) {
                return this.Text;
            }
            return NString.Empty;
        };
        return MessageBody;
    }(ComplexProperty));
    var MimeContent = (function (_super) {
        __extends(MimeContent, _super);
        function MimeContent(characterSet, content) {
            _super.call(this);
            this.characterSet = null;
            this.content = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(characterSet, content);
        }
        Object.defineProperty(MimeContent.prototype, "CharacterSet", {
            get: function () {
                return this.characterSet;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.characterSet
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.characterSet = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MimeContent.prototype, "Content", {
            get: function () {
                return this.content;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.content
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.content = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        MimeContent.prototype.constructor_0 = function () {
        };
        MimeContent.prototype.constructor_1 = function (characterSet, content) {
            this.constructor_0();
            this.characterSet = characterSet;
            this.content = content;
        };
        MimeContent.prototype.ReadAttributesFromXml = function (reader) {
            this.characterSet = reader.ReadAttributeValue("CharacterSet");
        };
        MimeContent.prototype.ReadTextValueFromXml = function (reader) {
            this.content = Convert.FromBase64String(reader.ReadValue());
        };
        MimeContent.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "CharacterSet")) {
                            if (a === "Value") {
                                this.content = jsonProperty.ReadAsBase64Content(current);
                            }
                        }
                        else {
                            this.characterSet = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        MimeContent.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("CharacterSet", this.CharacterSet);
        };
        MimeContent.prototype.WriteElementsToXml = function (writer) {
            if (this.Content !== null && this.Content.length > 0) {
                writer.WriteBase64ElementValue(this.Content);
            }
        };
        MimeContent.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ChangeKey", this.CharacterSet);
            if (this.Content !== null && this.Content.length > 0) {
                jsonObject.AddBase64("Value", this.Content);
            }
            return jsonObject;
        };
        MimeContent.prototype.ToString = function () {
            if (this.Content === null) {
                return NString.Empty;
            }
            var result;
            try {
                var name = NString.IsNullOrEmpty(this.CharacterSet) ? Encoding.UTF8.EncodingName : this.CharacterSet;
                var encoding = Encoding.GetEncoding(name);
                result = encoding.GetString(this.Content);
            }
            catch (ex_44) {
                if (ex_44 instanceof ArgumentException) {
                    result = Convert.ToBase64String(this.Content);
                }
                else
                    throw ex_44;
            }
            return result;
        };
        return MimeContent;
    }(ComplexProperty));
    var NormalizedBody = (function (_super) {
        __extends(NormalizedBody, _super);
        function NormalizedBody() {
            _super.call(this);
            this.bodyType = 0;
            this.text = null;
            this.isTruncated = false;
        }
        Object.defineProperty(NormalizedBody.prototype, "BodyType", {
            get: function () {
                return this.bodyType;
            },
            set: function (value) {
                this.bodyType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalizedBody.prototype, "Text", {
            get: function () {
                return this.text;
            },
            set: function (value) {
                this.text = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalizedBody.prototype, "IsTruncated", {
            get: function () {
                return this.isTruncated;
            },
            set: function (value) {
                this.isTruncated = value;
            },
            enumerable: true,
            configurable: true
        });
        NormalizedBody.op_Implicit = function (messageBody) {
            EwsUtilities.ValidateParam(messageBody, "messageBody");
            return messageBody.Text;
        };
        NormalizedBody.prototype.ReadAttributesFromXml = function (reader) {
            this.bodyType = reader.ReadAttributeValue("BodyType");
            var value = reader.ReadAttributeValue("IsTruncated");
            if (!NString.IsNullOrEmpty(value)) {
                this.isTruncated = NBoolean.Parse(value);
            }
        };
        NormalizedBody.prototype.ReadTextValueFromXml = function (reader) {
            this.text = reader.ReadValue();
        };
        NormalizedBody.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "BodyType")) {
                            if (!(a === "IsTruncated")) {
                                if (a === "Value") {
                                    this.text = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.isTruncated = jsonProperty.ReadAsBool(current);
                            }
                        }
                        else {
                            this.bodyType = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        NormalizedBody.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("BodyType", this.BodyType);
        };
        NormalizedBody.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.Text)) {
                writer.WriteValue(this.Text, "NormalizedBody");
            }
        };
        NormalizedBody.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("BodyType", this.BodyType);
            jsonObject.Add("IsTruncated", this.IsTruncated);
            if (!NString.IsNullOrEmpty(this.Text)) {
                jsonObject.Add("Value", this.Text);
            }
            return jsonObject;
        };
        NormalizedBody.prototype.ToString = function () {
            if (this.Text !== null) {
                return this.Text;
            }
            return NString.Empty;
        };
        return NormalizedBody;
    }(ComplexProperty));
    var OccurrenceInfo = (function (_super) {
        __extends(OccurrenceInfo, _super);
        function OccurrenceInfo() {
            _super.call(this);
            this.itemId = null;
            this.start = null;
            this.end = null;
            this.originalStart = null;
        }
        Object.defineProperty(OccurrenceInfo.prototype, "ItemId", {
            get: function () {
                return this.itemId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OccurrenceInfo.prototype, "Start", {
            get: function () {
                return this.start;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OccurrenceInfo.prototype, "End", {
            get: function () {
                return this.end;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OccurrenceInfo.prototype, "OriginalStart", {
            get: function () {
                return this.originalStart;
            },
            enumerable: true,
            configurable: true
        });
        OccurrenceInfo.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "ItemId") {
                    this.itemId = new ItemId();
                    this.itemId.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "Start") {
                    this.start = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
                if (localName === "End") {
                    this.end = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
                if (localName === "OriginalStart") {
                    this.originalStart = reader.ReadElementValueAsDateTime().Value;
                    return true;
                }
            }
            return false;
        };
        OccurrenceInfo.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "ItemId")) {
                            if (!(a === "Start")) {
                                if (!(a === "End")) {
                                    if (a === "OriginalStart") {
                                        this.originalStart = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                                    }
                                }
                                else {
                                    this.end = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                                }
                            }
                            else {
                                this.start = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current)).Value;
                            }
                        }
                        else {
                            this.itemId = new ItemId();
                            this.itemId.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return OccurrenceInfo;
    }(ComplexProperty));
    var OccurrenceInfoCollection = (function (_super) {
        __extends(OccurrenceInfoCollection, _super);
        function OccurrenceInfoCollection() {
            _super.call(this);
        }
        OccurrenceInfoCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === "Occurrence") {
                return new OccurrenceInfo();
            }
            return null;
        };
        OccurrenceInfoCollection.prototype.CreateDefaultComplexProperty = function () {
            return new OccurrenceInfo();
        };
        OccurrenceInfoCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Occurrence";
        };
        return OccurrenceInfoCollection;
    }(ComplexPropertyCollection));
    var PersonaPostalAddress = (function (_super) {
        __extends(PersonaPostalAddress, _super);
        function PersonaPostalAddress(street, city, state, country, postalCode, postOfficeBox, locationSource, locationUri, formattedAddress, latitude, longitude, accuracy, altitude, altitudeAccuracy) {
            _super.call(this);
            this.street = null;
            this.city = null;
            this.state = null;
            this.country = null;
            this.postalCode = null;
            this.postOfficeBox = null;
            this.type = null;
            this.latitude = null;
            this.longitude = null;
            this.accuracy = null;
            this.altitude = null;
            this.altitudeAccuracy = null;
            this.formattedAddress = null;
            this.uri = null;
            this.source = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(street, city, state, country, postalCode, postOfficeBox, locationSource, locationUri, formattedAddress, latitude, longitude, accuracy, altitude, altitudeAccuracy);
        }
        Object.defineProperty(PersonaPostalAddress.prototype, "Street", {
            get: function () {
                return this.street;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.street
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.street = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "City", {
            get: function () {
                return this.city;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.city
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.city = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "State", {
            get: function () {
                return this.state;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.state
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.state = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Country", {
            get: function () {
                return this.country;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.country
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.country = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "PostalCode", {
            get: function () {
                return this.postalCode;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.postalCode
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.postalCode = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "PostOfficeBox", {
            get: function () {
                return this.postOfficeBox;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.postOfficeBox
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.postOfficeBox = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Type", {
            get: function () {
                return this.type;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.type
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.type = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Source", {
            get: function () {
                return this.source;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.source
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.source = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Uri", {
            get: function () {
                return this.uri;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.uri
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.uri = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Latitude", {
            get: function () {
                return this.latitude;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.latitude
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.latitude = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Longitude", {
            get: function () {
                return this.longitude;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.longitude
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.longitude = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Accuracy", {
            get: function () {
                return this.accuracy;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.accuracy
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.accuracy = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "Altitude", {
            get: function () {
                return this.altitude;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.altitude
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.altitude = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "AltitudeAccuracy", {
            get: function () {
                return this.altitudeAccuracy;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.altitudeAccuracy
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.altitudeAccuracy = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PersonaPostalAddress.prototype, "FormattedAddress", {
            get: function () {
                return this.formattedAddress;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.formattedAddress
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.formattedAddress = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        PersonaPostalAddress.prototype.constructor_0 = function () {
        };
        PersonaPostalAddress.prototype.constructor_1 = function (street, city, state, country, postalCode, postOfficeBox, locationSource, locationUri, formattedAddress, latitude, longitude, accuracy, altitude, altitudeAccuracy) {
            this.constructor_0();
            this.street = street;
            this.city = city;
            this.state = state;
            this.country = country;
            this.postalCode = postalCode;
            this.postOfficeBox = postOfficeBox;
            this.latitude = new Nullable(latitude);
            this.longitude = new Nullable(longitude);
            this.source = locationSource;
            this.uri = locationUri;
            this.formattedAddress = formattedAddress;
            this.accuracy = new Nullable(accuracy);
            this.altitude = new Nullable(altitude);
            this.altitudeAccuracy = new Nullable(altitudeAccuracy);
        };
        PersonaPostalAddress.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Street":
                    this.street = reader.ReadValue();
                    return true;
                case "City":
                    this.city = reader.ReadValue();
                    return true;
                case "State":
                    this.state = reader.ReadValue();
                    return true;
                case "Country":
                    this.country = reader.ReadValue();
                    return true;
                case "PostalCode":
                    this.postalCode = reader.ReadValue();
                    return true;
                case "PostOfficeBox":
                    this.postOfficeBox = reader.ReadValue();
                    return true;
                case "Type":
                    this.type = reader.ReadValue();
                    return true;
                case "Latitude":
                    this.latitude = new Nullable(reader.ReadValue());
                    return true;
                case "Longitude":
                    this.longitude = new Nullable(reader.ReadValue());
                    return true;
                case "Accuracy":
                    this.accuracy = new Nullable(reader.ReadValue());
                    return true;
                case "Altitude":
                    this.altitude = new Nullable(reader.ReadValue());
                    return true;
                case "AltitudeAccuracy":
                    this.altitudeAccuracy = new Nullable(reader.ReadValue());
                    return true;
                case "FormattedAddress":
                    this.formattedAddress = reader.ReadValue();
                    return true;
                case "LocationUri":
                    this.uri = reader.ReadValue();
                    return true;
                case "LocationSource":
                    this.source = reader.ReadValue();
                    return true;
            }
            return false;
        };
        PersonaPostalAddress.prototype.LoadFromXml = function (reader) {
            do {
                reader.Read();
                if (reader.NodeType === 1) {
                    this.TryReadElementFromXml(reader);
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "PostalAddress"));
        };
        PersonaPostalAddress.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "Street":
                            this.street = jsonProperty.ReadAsString(current);
                            break;
                        case "City":
                            this.city = jsonProperty.ReadAsString(current);
                            break;
                        case "Country":
                            this.country = jsonProperty.ReadAsString(current);
                            break;
                        case "PostalCode":
                            this.postalCode = jsonProperty.ReadAsString(current);
                            break;
                        case "PostOfficeBox":
                            this.postOfficeBox = jsonProperty.ReadAsString(current);
                            break;
                        case "Type":
                            this.type = jsonProperty.ReadAsString(current);
                            break;
                        case "Latitude":
                            this.latitude = new Nullable(jsonProperty.ReadAsDouble(current));
                            break;
                        case "Longitude":
                            this.longitude = new Nullable(jsonProperty.ReadAsDouble(current));
                            break;
                        case "Accuracy":
                            this.accuracy = new Nullable(jsonProperty.ReadAsDouble(current));
                            break;
                        case "Altitude":
                            this.altitude = new Nullable(jsonProperty.ReadAsDouble(current));
                            break;
                        case "AltitudeAccuracy":
                            this.altitudeAccuracy = new Nullable(jsonProperty.ReadAsDouble(current));
                            break;
                        case "FormattedAddress":
                            this.formattedAddress = jsonProperty.ReadAsString(current);
                            break;
                        case "LocationUri":
                            this.uri = jsonProperty.ReadAsString(current);
                            break;
                        case "LocationSource":
                            this.source = jsonProperty.ReadEnumValue(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        PersonaPostalAddress.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Street", this.street);
            writer.WriteElementValue(XmlNamespace.Types, "City", this.city);
            writer.WriteElementValue(XmlNamespace.Types, "State", this.state);
            writer.WriteElementValue(XmlNamespace.Types, "Country", this.country);
            writer.WriteElementValue(XmlNamespace.Types, "PostalCode", this.postalCode);
            writer.WriteElementValue(XmlNamespace.Types, "PostOfficeBox", this.postOfficeBox);
            writer.WriteElementValue(XmlNamespace.Types, "Type", this.type);
            writer.WriteElementValue(XmlNamespace.Types, "Latitude", this.latitude);
            writer.WriteElementValue(XmlNamespace.Types, "Longitude", this.longitude);
            writer.WriteElementValue(XmlNamespace.Types, "Accuracy", this.accuracy);
            writer.WriteElementValue(XmlNamespace.Types, "Altitude", this.altitude);
            writer.WriteElementValue(XmlNamespace.Types, "AltitudeAccuracy", this.altitudeAccuracy);
            writer.WriteElementValue(XmlNamespace.Types, "FormattedAddress", this.formattedAddress);
            writer.WriteElementValue(XmlNamespace.Types, "LocationUri", this.uri);
            writer.WriteElementValue(XmlNamespace.Types, "LocationSource", this.source);
        };
        PersonaPostalAddress.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Street", this.street);
            jsonObject.Add("City", this.city);
            jsonObject.Add("Country", this.country);
            jsonObject.Add("PostalCode", this.postalCode);
            jsonObject.Add("PostOfficeBox", this.postOfficeBox);
            jsonObject.Add("Type", this.type);
            jsonObject.Add("Latitude", this.latitude);
            jsonObject.Add("Longitude", this.longitude);
            jsonObject.Add("Accuracy", this.accuracy);
            jsonObject.Add("Altitude", this.altitude);
            jsonObject.Add("AltitudeAccuracy", this.altitudeAccuracy);
            jsonObject.Add("FormattedAddress", this.formattedAddress);
            jsonObject.Add("LocationUri", this.uri);
            jsonObject.Add("LocationSource", this.source);
            return jsonObject;
        };
        PersonaPostalAddress.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "PostalAddress");
            this.WriteElementsToXml(writer);
            writer.WriteEndElement();
        };
        return PersonaPostalAddress;
    }(ComplexProperty));
    var PhoneEntity = (function (_super) {
        __extends(PhoneEntity, _super);
        function PhoneEntity() {
            _super.call(this);
            this.OriginalPhoneString = null;
            this.PhoneString = null;
            this.Type = null;
        }
        PhoneEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "OriginalPhoneString") {
                    this.OriginalPhoneString = reader.ReadElementValue();
                    return true;
                }
                if (localName === "PhoneString") {
                    this.PhoneString = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Type") {
                    this.Type = reader.ReadElementValue();
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return PhoneEntity;
    }(ExtractedEntity));
    var PhoneEntityCollection = (function (_super) {
        __extends(PhoneEntityCollection, _super);
        function PhoneEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        PhoneEntityCollection.prototype.constructor_0 = function () {
        };
        PhoneEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        PhoneEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new PhoneEntity();
        };
        PhoneEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new PhoneEntity();
        };
        PhoneEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Phone";
        };
        return PhoneEntityCollection;
    }(ComplexPropertyCollection));
    var PhoneNumberDictionary = (function (_super) {
        __extends(PhoneNumberDictionary, _super);
        function PhoneNumberDictionary() {
            _super.call(this);
        }
        PhoneNumberDictionary.prototype.get_Item = function (key) {
            return this.Entries.get_Item(key).PhoneNumber;
        };
        PhoneNumberDictionary.prototype.set_Item = function (key, value) {
            var _this = this;
            if (value === null) {
                _super.prototype.InternalRemove.call(this, key);
                return;
            }
            var phoneNumberEntry;
            if ((function () {
                var _p0 = [
                    phoneNumberEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                phoneNumberEntry = _p0[0];
                return _r;
            })()) {
                phoneNumberEntry.PhoneNumber = value;
                this.Changed();
                return;
            }
            phoneNumberEntry = new PhoneNumberEntry(key, value);
            _super.prototype.InternalAdd.call(this, phoneNumberEntry);
        };
        PhoneNumberDictionary.prototype.GetFieldURI = function () {
            return "contacts:PhoneNumber";
        };
        PhoneNumberDictionary.prototype.CreateEntryInstance = function () {
            return new PhoneNumberEntry();
        };
        PhoneNumberDictionary.prototype.TryGetValue = function (key, phoneNumber) {
            var _this = this;
            var phoneNumberEntry = null;
            if ((function () {
                var _p0 = [
                    phoneNumberEntry
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                phoneNumberEntry = _p0[0];
                return _r;
            })()) {
                phoneNumber[0] = phoneNumberEntry.PhoneNumber;
                return true;
            }
            phoneNumber[0] = null;
            return false;
        };
        return PhoneNumberDictionary;
    }(DictionaryProperty));
    var PhoneNumberEntry = (function (_super) {
        __extends(PhoneNumberEntry, _super);
        function PhoneNumberEntry(key, phoneNumber) {
            _super.call(this);
            this.phoneNumber = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(key, phoneNumber);
        }
        Object.defineProperty(PhoneNumberEntry.prototype, "PhoneNumber", {
            get: function () {
                return this.phoneNumber;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.phoneNumber
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.phoneNumber = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        PhoneNumberEntry.prototype.constructor_0 = function () {
        };
        PhoneNumberEntry.prototype.constructor_1 = function (key, phoneNumber) {
            this.phoneNumber = phoneNumber;
        };
        PhoneNumberEntry.prototype.ReadTextValueFromXml = function (reader) {
            this.phoneNumber = reader.ReadValue();
        };
        PhoneNumberEntry.prototype.WriteElementsToXml = function (writer) {
            writer.WriteValue(this.PhoneNumber, "PhoneNumber");
        };
        PhoneNumberEntry.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Key", this.Key);
            jsonObject.Add("PhoneNumber", this.PhoneNumber);
            return jsonObject;
        };
        PhoneNumberEntry.prototype.LoadFromJson = function (jsonProperty, service) {
            this.Key = jsonProperty.ReadEnumValue("Key");
            this.PhoneNumber = jsonProperty.ReadAsString("PhoneNumber");
        };
        return PhoneNumberEntry;
    }(DictionaryEntryProperty));
    var PhysicalAddressDictionary = (function (_super) {
        __extends(PhysicalAddressDictionary, _super);
        function PhysicalAddressDictionary() {
            _super.call(this);
        }
        PhysicalAddressDictionary.prototype.get_Item = function (key) {
            return this.Entries.get_Item(key);
        };
        PhysicalAddressDictionary.prototype.set_Item = function (key, value) {
            if (value === null) {
                _super.prototype.InternalRemove.call(this, key);
                return;
            }
            value.Key = key;
            _super.prototype.InternalAddOrReplace.call(this, value);
        };
        PhysicalAddressDictionary.prototype.CreateEntryInstance = function () {
            return new PhysicalAddressEntry();
        };
        PhysicalAddressDictionary.prototype.TryGetValue = function (key, physicalAddress) {
            var _this = this;
            return (function () {
                var _p0 = [
                    physicalAddress[0]
                ];
                var _r = _this.Entries.TryGetValue(key, _p0);
                physicalAddress[0] = _p0[0];
                return _r;
            })();
        };
        return PhysicalAddressDictionary;
    }(DictionaryProperty));
    var PhysicalAddressEntry = (function (_super) {
        __extends(PhysicalAddressEntry, _super);
        function PhysicalAddressEntry() {
            _super.call(this);
            this.propertyBag = null;
            this.propertyBag = new SimplePropertyBag();
            this.propertyBag.OnChange.Add(this.PropertyBagChanged);
        }
        Object.defineProperty(PhysicalAddressEntry.prototype, "Street", {
            get: function () {
                return this.propertyBag.get_Item("Street");
            },
            set: function (value) {
                this.propertyBag.set_Item("Street", value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhysicalAddressEntry.prototype, "City", {
            get: function () {
                return this.propertyBag.get_Item("City");
            },
            set: function (value) {
                this.propertyBag.set_Item("City", value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhysicalAddressEntry.prototype, "State", {
            get: function () {
                return this.propertyBag.get_Item("State");
            },
            set: function (value) {
                this.propertyBag.set_Item("State", value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhysicalAddressEntry.prototype, "CountryOrRegion", {
            get: function () {
                return this.propertyBag.get_Item("CountryOrRegion");
            },
            set: function (value) {
                this.propertyBag.set_Item("CountryOrRegion", value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhysicalAddressEntry.prototype, "PostalCode", {
            get: function () {
                return this.propertyBag.get_Item("PostalCode");
            },
            set: function (value) {
                this.propertyBag.set_Item("PostalCode", value);
            },
            enumerable: true,
            configurable: true
        });
        PhysicalAddressEntry.prototype.ClearChangeLog = function () {
            this.propertyBag.ClearChangeLog();
        };
        PhysicalAddressEntry.prototype.TryReadElementFromXml = function (reader) {
            if (PhysicalAddressEntry_PhysicalAddressSchema.XmlElementNames.Contains(reader.LocalName)) {
                this.propertyBag.set_Item(reader.LocalName, reader.ReadElementValue());
                return true;
            }
            return false;
        };
        PhysicalAddressEntry.prototype.WriteElementsToXml = function (writer) {
            var enumerator = PhysicalAddressEntry_PhysicalAddressSchema.XmlElementNames.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteElementValue(XmlNamespace.Types, current, this.propertyBag.get_Item(current));
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        PhysicalAddressEntry.prototype.WriteSetUpdateToXml = function (writer, ewsObject, ownerDictionaryXmlElementName) {
            var list = new List();
            var enumerator = this.propertyBag.AddedItems.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            var enumerator2 = this.propertyBag.ModifiedItems.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    list.Add(current2);
                }
            }
            finally {
                if (enumerator2 !== null) {
                    enumerator2.Dispose();
                }
            }
            var enumerator3 = list.GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetSetFieldXmlElementName());
                    writer.WriteStartElement(XmlNamespace.Types, "IndexedFieldURI");
                    writer.WriteAttributeValue("FieldURI", PhysicalAddressEntry.GetFieldUri(current3));
                    writer.WriteAttributeValue("FieldIndex", PhysicalAddressKey[this.Key]);
                    writer.WriteEndElement();
                    writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetXmlElementName());
                    writer.WriteStartElement(XmlNamespace.Types, ownerDictionaryXmlElementName);
                    writer.WriteStartElement(XmlNamespace.Types, "Entry");
                    this.WriteAttributesToXml(writer);
                    writer.WriteElementValue(XmlNamespace.Types, current3, this.propertyBag.get_Item(current3));
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator3.Dispose();
            }
            var enumerator4 = this.propertyBag.RemovedItems.GetEnumerator();
            try {
                while (enumerator4.MoveNext()) {
                    var current4 = enumerator4.Current;
                    this.InternalWriteDeleteFieldToXml(writer, ewsObject, current4);
                }
            }
            finally {
                if (enumerator4 !== null) {
                    enumerator4.Dispose();
                }
            }
            return true;
        };
        PhysicalAddressEntry.prototype.WriteSetUpdateToJson = function (service, ewsObject, propertyDefinition, updates) {
            var list = new List();
            list.AddRange(this.propertyBag.AddedItems);
            list.AddRange(this.propertyBag.ModifiedItems);
            var enumerator = list.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var jsonObject = new JsonObject();
                    jsonObject.AddTypeParameter(ewsObject.GetSetFieldXmlElementName());
                    var jsonObject2 = new JsonObject();
                    jsonObject2.AddTypeParameter("DictionaryPropertyUri");
                    jsonObject2.Add("FieldURI", PhysicalAddressEntry.GetFieldUri(current));
                    jsonObject2.Add("FieldIndex", PhysicalAddressKey[this.Key]);
                    jsonObject.Add("Path", jsonObject2);
                    var jsonObject3 = new JsonObject();
                    jsonObject3.Add("Key", this.Key);
                    jsonObject3.Add(current, this.propertyBag.get_Item(current));
                    var jsonObject4 = new JsonObject();
                    jsonObject4.AddTypeParameter(ewsObject.GetXmlElementName());
                    jsonObject4.Add(propertyDefinition.XmlElementName, NArray.ToEnumerable([
                        jsonObject3
                    ]));
                    jsonObject.Add(PropertyBag.GetPropertyUpdateItemName(ewsObject), jsonObject4);
                    updates.Add(jsonObject);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.propertyBag.RemovedItems.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.InternalWriteDeleteUpdateToJson(ewsObject, current2, updates);
                }
            }
            finally {
                if (enumerator2 !== null) {
                    enumerator2.Dispose();
                }
            }
            return true;
        };
        PhysicalAddressEntry.prototype.WriteDeleteUpdateToXml = function (writer, ewsObject) {
            var enumerator = PhysicalAddressEntry_PhysicalAddressSchema.XmlElementNames.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.InternalWriteDeleteFieldToXml(writer, ewsObject, current);
                }
            }
            finally {
                enumerator.Dispose();
            }
            return true;
        };
        PhysicalAddressEntry.prototype.WriteDeleteUpdateToJson = function (service, ewsObject, updates) {
            var enumerator = PhysicalAddressEntry_PhysicalAddressSchema.XmlElementNames.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.InternalWriteDeleteUpdateToJson(ewsObject, current, updates);
                }
            }
            finally {
                enumerator.Dispose();
            }
            return true;
        };
        PhysicalAddressEntry.prototype.InternalWriteDeleteUpdateToJson = function (ewsObject, propertyName, updates) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(ewsObject.GetDeleteFieldXmlElementName());
            var jsonObject2 = new JsonObject();
            jsonObject2.AddTypeParameter("DictionaryPropertyUri");
            jsonObject2.Add("FieldURI", PhysicalAddressEntry.GetFieldUri(propertyName));
            jsonObject2.Add("FieldIndex", PhysicalAddressKey[this.Key]);
            jsonObject.Add("Path", jsonObject2);
            updates.Add(jsonObject);
        };
        PhysicalAddressEntry.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Key", this.Key);
            jsonObject.Add("Street", this.Street);
            jsonObject.Add("City", this.City);
            jsonObject.Add("State", this.State);
            jsonObject.Add("CountryOrRegion", this.CountryOrRegion);
            jsonObject.Add("PostalCode", this.PostalCode);
            return jsonObject;
        };
        PhysicalAddressEntry.prototype.LoadFromJson = function (jsonProperty, service) {
            this.Key = jsonProperty.ReadEnumValue("Key");
            this.Street = jsonProperty.ReadAsString("Street");
            this.City = jsonProperty.ReadAsString("City");
            this.State = jsonProperty.ReadAsString("State");
            this.Street = jsonProperty.ReadAsString("Street");
            this.CountryOrRegion = jsonProperty.ReadAsString("CountryOrRegion");
            this.PostalCode = jsonProperty.ReadAsString("PostalCode");
        };
        PhysicalAddressEntry.GetFieldUri = function (xmlElementName) {
            return "contacts:PhysicalAddress:" + xmlElementName;
        };
        PhysicalAddressEntry.prototype.PropertyBagChanged = function () {
            this.Changed();
        };
        PhysicalAddressEntry.prototype.InternalWriteDeleteFieldToXml = function (writer, ewsObject, fieldXmlElementName) {
            writer.WriteStartElement(XmlNamespace.Types, ewsObject.GetDeleteFieldXmlElementName());
            writer.WriteStartElement(XmlNamespace.Types, "IndexedFieldURI");
            writer.WriteAttributeValue("FieldURI", PhysicalAddressEntry.GetFieldUri(fieldXmlElementName));
            writer.WriteAttributeValue("FieldIndex", PhysicalAddressKey[this.Key]);
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        return PhysicalAddressEntry;
    }(DictionaryEntryProperty));
    var PhysicalAddressEntry_PhysicalAddressSchema = (function () {
        function PhysicalAddressEntry_PhysicalAddressSchema() {
            _super.call(this);
        }
        Object.defineProperty(PhysicalAddressEntry_PhysicalAddressSchema, "XmlElementNames", {
            get: function () {
                return PhysicalAddressEntry_PhysicalAddressSchema.xmlElementNames.Member;
            },
            enumerable: true,
            configurable: true
        });
        PhysicalAddressEntry_PhysicalAddressSchema.Street = "Street";
        PhysicalAddressEntry_PhysicalAddressSchema.City = "City";
        PhysicalAddressEntry_PhysicalAddressSchema.State = "State";
        PhysicalAddressEntry_PhysicalAddressSchema.CountryOrRegion = "CountryOrRegion";
        PhysicalAddressEntry_PhysicalAddressSchema.PostalCode = "PostalCode";
        PhysicalAddressEntry_PhysicalAddressSchema.xmlElementNames = new LazyMember(function () {
            var list = new List();
            list.Add("Street");
            list.Add("City");
            list.Add("State");
            list.Add("CountryOrRegion");
            list.Add("PostalCode");
            return list;
        });
        return PhysicalAddressEntry_PhysicalAddressSchema;
    }());
    var PolicyTag = (function (_super) {
        __extends(PolicyTag, _super);
        function PolicyTag(isExplicit, retentionId) {
            if (arguments.length === 0) {
                _super.call(this, "PolicyTag");
                this.constructor_0();
                return;
            }
            _super.call(this, "PolicyTag");
            this.constructor_1(isExplicit, retentionId);
        }
        PolicyTag.prototype.constructor_0 = function () {
        };
        PolicyTag.prototype.constructor_1 = function (isExplicit, retentionId) {
            this.constructor_0();
            this.IsExplicit = isExplicit;
            this.RetentionId = retentionId;
        };
        return PolicyTag;
    }(RetentionTagBase));
    var RecurringAppointmentMasterId = (function (_super) {
        __extends(RecurringAppointmentMasterId, _super);
        function RecurringAppointmentMasterId(occurrenceId) {
            _super.call(this, occurrenceId);
        }
        RecurringAppointmentMasterId.prototype.GetXmlElementName = function () {
            return "RecurringMasterItemId";
        };
        RecurringAppointmentMasterId.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("OccurrenceId", this.UniqueId);
            writer.WriteAttributeValue("ChangeKey", this.ChangeKey);
        };
        RecurringAppointmentMasterId.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetXmlElementName());
            jsonObject.Add("OccurrenceId", this.UniqueId);
            jsonObject.Add("ChangeKey", this.ChangeKey);
            return jsonObject;
        };
        return RecurringAppointmentMasterId;
    }(ItemId));
    var SearchFolderParameters = (function (_super) {
        __extends(SearchFolderParameters, _super);
        function SearchFolderParameters() {
            _super.call(this);
            this.traversal = 0;
            this.rootFolderIds = new FolderIdCollection();
            this.searchFilter = null;
            this.rootFolderIds.OnChange.Add(this.PropertyChanged);
        }
        Object.defineProperty(SearchFolderParameters.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.traversal
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.traversal = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchFolderParameters.prototype, "RootFolderIds", {
            get: function () {
                return this.rootFolderIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchFolderParameters.prototype, "SearchFilter", {
            get: function () {
                return this.searchFilter;
            },
            set: function (value) {
                var _this = this;
                if (this.searchFilter !== null) {
                    this.searchFilter.OnChange.Remove(this.PropertyChanged);
                }
                (function () {
                    var _p0 = [
                        _this.searchFilter
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.searchFilter = _p0[0];
                    return _r;
                })();
                if (this.searchFilter !== null) {
                    this.searchFilter.OnChange.Add(this.PropertyChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        SearchFolderParameters.prototype.PropertyChanged = function (complexProperty) {
            this.Changed();
        };
        SearchFolderParameters.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "BaseFolderIds") {
                    this.RootFolderIds.InternalClear();
                    this.RootFolderIds.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "Restriction") {
                    reader.Read();
                    this.searchFilter = SearchFilter.LoadFromXml(reader);
                    return true;
                }
            }
            return false;
        };
        SearchFolderParameters.prototype.ReadAttributesFromXml = function (reader) {
            this.Traversal = reader.ReadAttributeValue("Traversal");
        };
        SearchFolderParameters.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "BaseFolderIds")) {
                            if (!(a === "Restriction")) {
                                if (a === "Traversal") {
                                    this.Traversal = jsonProperty.ReadEnumValue(current);
                                }
                            }
                            else {
                                var jsonObject = jsonProperty.ReadAsJsonObject(current);
                                this.searchFilter = SearchFilter.LoadSearchFilterFromJson(jsonObject.ReadAsJsonObject("Item"), service);
                            }
                        }
                        else {
                            this.RootFolderIds.InternalClear();
                            this.RootFolderIds.CreateFromJsonCollection(jsonProperty.ReadAsArray(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        SearchFolderParameters.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Traversal", this.Traversal);
        };
        SearchFolderParameters.prototype.WriteElementsToXml = function (writer) {
            if (this.SearchFilter !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "Restriction");
                this.SearchFilter.WriteToXml(writer);
                writer.WriteEndElement();
            }
            this.RootFolderIds.WriteToXml(writer, "BaseFolderIds");
        };
        SearchFolderParameters.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Traversal", this.Traversal);
            jsonObject.Add("BaseFolderIds", this.RootFolderIds.InternalToJson(service));
            if (this.SearchFilter !== null) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("Item", this.SearchFilter.InternalToJson(service));
                jsonObject.Add("Restriction", jsonObject2);
            }
            return jsonObject;
        };
        SearchFolderParameters.prototype.Validate = function () {
            if (this.RootFolderIds.Count === 0) {
                throw new ServiceValidationException(Strings.SearchParametersRootFolderIdsEmpty);
            }
            if (this.SearchFilter !== null) {
                this.SearchFilter.InternalValidate();
            }
        };
        return SearchFolderParameters;
    }(ComplexProperty));
    var StringList = (function (_super) {
        __extends(StringList, _super);
        function StringList(stringsOrItemXmlElementName) {
            _super.call(this);
            this.items = new List();
            this.itemXmlElementName = "String";
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1) {
                this.constructor_1(stringsOrItemXmlElementName);
                return;
            }
            this.constructor_2(stringsOrItemXmlElementName);
        }
        Object.defineProperty(StringList.prototype, "Count", {
            get: function () {
                return this.items.Count;
            },
            enumerable: true,
            configurable: true
        });
        StringList.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.items.get_Item(index);
        };
        StringList.prototype.set_Item = function (index, value) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            if (this.items.get_Item(index) !== value) {
                this.items.set_Item(index, value);
                this.Changed();
            }
        };
        StringList.prototype.constructor_0 = function () {
        };
        StringList.prototype.constructor_1 = function (strings) {
            this.AddRange(strings);
        };
        StringList.prototype.constructor_2 = function (itemXmlElementName) {
            this.itemXmlElementName = itemXmlElementName;
        };
        StringList.prototype.TryReadElementFromXml = function (reader) {
            if (reader.LocalName === this.itemXmlElementName) {
                this.Add(reader.ReadValue());
                return true;
            }
            return false;
        };
        StringList.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                this.Add(((obj instanceof string) ? obj : null));
            }
        };
        StringList.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        StringList.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, this.itemXmlElementName);
                    writer.WriteValue(current, this.itemXmlElementName);
                    writer.WriteEndElement();
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        StringList.prototype.InternalToJson = function (service) {
            return new List(this).ToArray();
        };
        StringList.prototype.Add = function (s) {
            this.items.Add(s);
            this.Changed();
        };
        StringList.prototype.AddRange = function (strings) {
            var flag = false;
            var enumerator = strings.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (!this.Contains(current)) {
                        this.items.Add(current);
                        flag = true;
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            if (flag) {
                this.Changed();
            }
        };
        StringList.prototype.Contains = function (s) {
            return this.items.Contains(s);
        };
        StringList.prototype.Remove = function (s) {
            var flag = this.items.Remove(s);
            if (flag) {
                this.Changed();
            }
            return flag;
        };
        StringList.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            this.items.RemoveAt(index);
            this.Changed();
        };
        StringList.prototype.Clear = function () {
            this.items.Clear();
            this.Changed();
        };
        StringList.prototype.ToString = function () {
            return NString.Join(",", this.items.ToArray());
        };
        StringList.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        StringList.prototype.Equals = function (obj) {
            var stringList = ((obj instanceof StringList) ? obj : null);
            return stringList !== null && this.ToString() === stringList.ToString();
        };
        StringList.prototype.GetHashCode = function () {
            return NString.GetHashCode(this.ToString());
        };
        return StringList;
    }(ComplexProperty));
    var TaskSuggestion = (function (_super) {
        __extends(TaskSuggestion, _super);
        function TaskSuggestion() {
            _super.call(this);
            this.TaskString = null;
            this.Assignees = null;
        }
        TaskSuggestion.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "TaskString") {
                    this.TaskString = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Assignees") {
                    this.Assignees = new EmailUserEntityCollection();
                    this.Assignees.LoadFromXml(reader, XmlNamespace.Types, "Assignees");
                    return true;
                }
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return TaskSuggestion;
    }(ExtractedEntity));
    var TaskSuggestionCollection = (function (_super) {
        __extends(TaskSuggestionCollection, _super);
        function TaskSuggestionCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        TaskSuggestionCollection.prototype.constructor_0 = function () {
        };
        TaskSuggestionCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        TaskSuggestionCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new TaskSuggestion();
        };
        TaskSuggestionCollection.prototype.CreateDefaultComplexProperty = function () {
            return new TaskSuggestion();
        };
        TaskSuggestionCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "TaskSuggestion";
        };
        return TaskSuggestionCollection;
    }(ComplexPropertyCollection));
    var TimeChange = (function (_super) {
        __extends(TimeChange, _super);
        function TimeChange(offset, time) {
            _super.call(this);
            this.timeZoneName = null;
            this.offset = null;
            this.time = null;
            this.absoluteDate = null;
            this.recurrence = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (offset === null || offset instanceof TimeSpan)) {
                this.constructor_1(offset);
                return;
            }
            this.constructor_2(offset, time);
        }
        Object.defineProperty(TimeChange.prototype, "TimeZoneName", {
            get: function () {
                return this.timeZoneName;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.timeZoneName
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.timeZoneName = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChange.prototype, "Offset", {
            get: function () {
                return this.offset;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.offset
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.offset = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChange.prototype, "Time", {
            get: function () {
                return this.time;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.time
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.time = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChange.prototype, "AbsoluteDate", {
            get: function () {
                return this.absoluteDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.absoluteDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.absoluteDate = _p0[0];
                    return _r;
                })();
                if (this.absoluteDate !== null) {
                    this.recurrence = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChange.prototype, "Recurrence", {
            get: function () {
                return this.recurrence;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.recurrence
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.recurrence = _p0[0];
                    return _r;
                })();
                if (this.recurrence !== null) {
                    this.absoluteDate = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        TimeChange.prototype.constructor_0 = function () {
        };
        TimeChange.prototype.constructor_1 = function (offset) {
            this.constructor_0();
            this.offset = new Nullable(offset);
        };
        TimeChange.prototype.constructor_2 = function (offset, time) {
            this.constructor_1(offset);
            this.time = time;
        };
        TimeChange.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Offset") {
                    this.offset = new Nullable(EwsUtilities.XSDurationToTimeSpan(reader.ReadElementValue()));
                    return true;
                }
                if (localName === "RelativeYearlyRecurrence") {
                    this.Recurrence = new TimeChangeRecurrence();
                    this.Recurrence.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "AbsoluteDate") {
                    this.absoluteDate = new Nullable(new DateTime(DateTime.Parse(reader.ReadElementValue()).ToUniversalTime().Ticks, DateTimeKind.Unspecified));
                    return true;
                }
                if (localName === "Time") {
                    this.time = new Time(DateTime.Parse(reader.ReadElementValue()));
                    return true;
                }
            }
            return false;
        };
        TimeChange.prototype.ReadAttributesFromXml = function (reader) {
            this.timeZoneName = reader.ReadAttributeValue("TimeZoneName");
        };
        TimeChange.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("TimeZoneName", this.TimeZoneName);
        };
        TimeChange.prototype.WriteElementsToXml = function (writer) {
            if (this.Offset !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "Offset", EwsUtilities.TimeSpanToXSDuration(this.Offset.Value));
            }
            if (this.Recurrence !== null) {
                this.Recurrence.WriteToXml(writer, "RelativeYearlyRecurrence");
            }
            if (this.AbsoluteDate !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "AbsoluteDate", EwsUtilities.DateTimeToXSDate(new DateTime(this.AbsoluteDate.Value.Ticks, DateTimeKind.Unspecified)));
            }
            if (this.Time !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "Time", this.Time.ToXSTime());
            }
        };
        return TimeChange;
    }(ComplexProperty));
    var TimeChangeRecurrence = (function (_super) {
        __extends(TimeChangeRecurrence, _super);
        function TimeChangeRecurrence(dayOfTheWeekIndex, dayOfTheWeek, month) {
            _super.call(this);
            this.dayOfTheWeek = null;
            this.dayOfTheWeekIndex = null;
            this.month = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(dayOfTheWeekIndex, dayOfTheWeek, month);
        }
        Object.defineProperty(TimeChangeRecurrence.prototype, "DayOfTheWeekIndex", {
            get: function () {
                return this.dayOfTheWeekIndex;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeekIndex
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.dayOfTheWeekIndex = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChangeRecurrence.prototype, "DayOfTheWeek", {
            get: function () {
                return this.dayOfTheWeek;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeek
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.dayOfTheWeek = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeChangeRecurrence.prototype, "Month", {
            get: function () {
                return this.month;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.month
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.month = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        TimeChangeRecurrence.prototype.constructor_0 = function () {
        };
        TimeChangeRecurrence.prototype.constructor_1 = function (dayOfTheWeekIndex, dayOfTheWeek, month) {
            this.constructor_0();
            this.dayOfTheWeekIndex = new Nullable(dayOfTheWeekIndex);
            this.dayOfTheWeek = new Nullable(dayOfTheWeek);
            this.month = new Nullable(month);
        };
        TimeChangeRecurrence.prototype.WriteElementsToXml = function (writer) {
            if (this.DayOfTheWeek !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "DaysOfWeek", this.DayOfTheWeek.Value);
            }
            if (this.dayOfTheWeekIndex !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "DayOfWeekIndex", this.DayOfTheWeekIndex.Value);
            }
            if (this.Month !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "Month", this.Month.Value);
            }
        };
        TimeChangeRecurrence.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DaysOfWeek") {
                    this.dayOfTheWeek = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "DayOfWeekIndex") {
                    this.dayOfTheWeekIndex = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "Month") {
                    this.month = new Nullable(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        return TimeChangeRecurrence;
    }(ComplexProperty));
    var UserConfigurationDictionary = (function (_super) {
        __extends(UserConfigurationDictionary, _super);
        function UserConfigurationDictionary() {
            _super.call(this);
            this.dictionary = null;
            this.isDirty = false;
            this.dictionary = new Dictionary();
        }
        UserConfigurationDictionary.prototype.get_Item = function (key) {
            return this.dictionary.get_Item(key);
        };
        UserConfigurationDictionary.prototype.set_Item = function (key, value) {
            this.ValidateEntry(key, value);
            this.dictionary.set_Item(key, value);
            this.Changed();
        };
        Object.defineProperty(UserConfigurationDictionary.prototype, "Count", {
            get: function () {
                return this.dictionary.Count;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfigurationDictionary.prototype, "IsDirty", {
            get: function () {
                return this.isDirty;
            },
            set: function (value) {
                this.isDirty = value;
            },
            enumerable: true,
            configurable: true
        });
        UserConfigurationDictionary.prototype.Add = function (key, value) {
            this.ValidateEntry(key, value);
            this.dictionary.Add(key, value);
            this.Changed();
        };
        UserConfigurationDictionary.prototype.ContainsKey = function (key) {
            return this.dictionary.ContainsKey(key);
        };
        UserConfigurationDictionary.prototype.Remove = function (key) {
            var flag = this.dictionary.Remove(key);
            if (flag) {
                this.Changed();
            }
            return flag;
        };
        UserConfigurationDictionary.prototype.TryGetValue = function (key, value) {
            var _this = this;
            return (function () {
                var _p0 = [
                    value[0]
                ];
                var _r = _this.dictionary.TryGetValue(key, _p0);
                value[0] = _p0[0];
                return _r;
            })();
        };
        UserConfigurationDictionary.prototype.Clear = function () {
            if (this.dictionary.Count !== 0) {
                this.dictionary.Clear();
                this.Changed();
            }
        };
        UserConfigurationDictionary.prototype.GetEnumerator = function () {
            return this.dictionary.GetEnumerator();
        };
        UserConfigurationDictionary.prototype.Changed = function () {
            _super.prototype.Changed.call(this);
            this.isDirty = true;
        };
        UserConfigurationDictionary.prototype.WriteElementsToXml = function (writer) {
            EwsUtilities.Assert(writer !== null, "UserConfigurationDictionary.WriteElementsToXml", "writer is null");
            var enumerator = this.dictionary.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, "DictionaryEntry");
                    this.WriteObjectToXml(writer, "DictionaryKey", current.Key);
                    this.WriteObjectToXml(writer, "DictionaryValue", current.Value);
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        UserConfigurationDictionary.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = this.dictionary.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var jsonObject = new JsonObject();
                    jsonObject.Add("DictionaryKey", this.GetJsonObject(current.Key, service));
                    jsonObject.Add("DictionaryValue", this.GetJsonObject(current.Value, service));
                    list.Add(jsonObject);
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list.ToArray();
        };
        UserConfigurationDictionary.GetTypeCode = function (service, dictionaryObject, dictionaryObjectType, valueAsString) {
            var typeCode = Type.GetTypeCode(dictionaryObject.GetType());
            switch (typeCode) {
                case TypeCode.Boolean:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.Boolean;
                    valueAsString[0] = EwsUtilities.BoolToXSBool(dictionaryObject);
                    return;
                case TypeCode.Char:
                case TypeCode.SByte:
                case TypeCode.Int16:
                case TypeCode.UInt16:
                    break;
                case TypeCode.Byte:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.Byte;
                    valueAsString[0] = NNumber.ToString(dictionaryObject);
                    return;
                case TypeCode.Int32:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.Integer32;
                    valueAsString[0] = NNumber.ToString(dictionaryObject);
                    return;
                case TypeCode.UInt32:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.UnsignedInteger32;
                    valueAsString[0] = NNumber.ToString(dictionaryObject);
                    return;
                case TypeCode.Int64:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.Integer64;
                    valueAsString[0] = NNumber.ToString(dictionaryObject);
                    return;
                case TypeCode.UInt64:
                    dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.UnsignedInteger64;
                    valueAsString[0] = NNumber.ToString(dictionaryObject);
                    return;
                default:
                    switch (typeCode) {
                        case TypeCode.DateTime:
                            dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.DateTime;
                            valueAsString[0] = service.ConvertDateTimeToUniversalDateTimeString(dictionaryObject);
                            return;
                        case TypeCode.String:
                            dictionaryObjectType[0] = UserConfigurationDictionaryObjectType.String;
                            valueAsString[0] = dictionaryObject;
                            return;
                    }
                    break;
            }
            EwsUtilities.Assert(false, "UserConfigurationDictionary.WriteObjectValueToXml", "Unsupported type: " + dictionaryObject.GetType().ToString());
        };
        UserConfigurationDictionary.GetObjectType = function (type) {
            return Enum.Parse(new Type("Number"), type, false);
        };
        UserConfigurationDictionary.prototype.GetJsonObject = function (dictionaryObject, service) {
            var userConfigurationDictionaryObjectType = UserConfigurationDictionaryObjectType.String;
            if (dictionaryObject === null) {
                return null;
            }
            var array;
            if (dictionaryObject instanceof string[]) {
                userConfigurationDictionaryObjectType = UserConfigurationDictionaryObjectType.StringArray;
                array = (((dictionaryObject instanceof string[]) ? dictionaryObject : null));
            }
            else {
                if (dictionaryObject instanceof number[]) {
                    userConfigurationDictionaryObjectType = UserConfigurationDictionaryObjectType.ByteArray;
                    array = [
                        Convert.ToBase64String(((dictionaryObject instanceof number[]) ? dictionaryObject : null))
                    ];
                }
                else {
                    array = new Array(1);
                    for (var _ai = 0; _ai < array.length; ++_ai)
                        array[_ai] = null;
                    (function () {
                        var _p0 = [
                            userConfigurationDictionaryObjectType
                        ];
                        var _p1 = [
                            array[0]
                        ];
                        var _r = UserConfigurationDictionary.GetTypeCode(service, dictionaryObject, _p0, _p1);
                        userConfigurationDictionaryObjectType = _p0[0];
                        array[0] = _p1[0];
                        return _r;
                    })();
                }
            }
            var jsonObject = new JsonObject();
            jsonObject.Add("Type", userConfigurationDictionaryObjectType);
            jsonObject.Add("Value", NArray.ToEnumerable(array));
            return jsonObject;
        };
        UserConfigurationDictionary.prototype.WriteObjectToXml = function (writer, xmlElementName, dictionaryObject) {
            EwsUtilities.Assert(writer !== null, "UserConfigurationDictionary.WriteObjectToXml", "writer is null");
            EwsUtilities.Assert(xmlElementName !== null, "UserConfigurationDictionary.WriteObjectToXml", "xmlElementName is null");
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            if (dictionaryObject === null) {
                EwsUtilities.Assert(xmlElementName !== "DictionaryKey", "UserConfigurationDictionary.WriteObjectToXml", "Key is null");
                writer.WriteAttributeValue("xsi", "nil", "true");
            }
            else {
                this.WriteObjectValueToXml(writer, dictionaryObject);
            }
            writer.WriteEndElement();
        };
        UserConfigurationDictionary.prototype.WriteObjectValueToXml = function (writer, dictionaryObject) {
            EwsUtilities.Assert(writer !== null, "UserConfigurationDictionary.WriteObjectValueToXml", "writer is null");
            EwsUtilities.Assert(dictionaryObject !== null, "UserConfigurationDictionary.WriteObjectValueToXml", "dictionaryObject is null");
            var array = ((dictionaryObject instanceof string[]) ? dictionaryObject : null);
            if (array !== null) {
                this.WriteEntryTypeToXml(writer, UserConfigurationDictionaryObjectType.StringArray);
                var array2 = array;
                for (var i = 0; i < array2.length; i = i + 1) {
                    var value = array2[i];
                    this.WriteEntryValueToXml(writer, value);
                }
                return;
            }
            var dictionaryObjectType = UserConfigurationDictionaryObjectType.String;
            var value2 = null;
            var array3 = ((dictionaryObject instanceof number[]) ? dictionaryObject : null);
            if (array3 !== null) {
                dictionaryObjectType = UserConfigurationDictionaryObjectType.ByteArray;
                value2 = Convert.ToBase64String(array3);
            }
            else {
                (function () {
                    var _p0 = [
                        dictionaryObjectType
                    ];
                    var _p1 = [
                        value2
                    ];
                    var _r = UserConfigurationDictionary.GetTypeCode(writer.Service, dictionaryObject, _p0, _p1);
                    dictionaryObjectType = _p0[0];
                    value2 = _p1[0];
                    return _r;
                })();
            }
            this.WriteEntryTypeToXml(writer, dictionaryObjectType);
            this.WriteEntryValueToXml(writer, value2);
        };
        UserConfigurationDictionary.prototype.WriteEntryTypeToXml = function (writer, dictionaryObjectType) {
            writer.WriteStartElement(XmlNamespace.Types, "Type");
            writer.WriteValue(UserConfigurationDictionaryObjectType[dictionaryObjectType], "Type");
            writer.WriteEndElement();
        };
        UserConfigurationDictionary.prototype.WriteEntryValueToXml = function (writer, value) {
            writer.WriteStartElement(XmlNamespace.Types, "Value");
            if (value !== null) {
                writer.WriteValue(value, "Value");
            }
            writer.WriteEndElement();
        };
        UserConfigurationDictionary.prototype.LoadFromXml = function (reader, xmlNamespace, xmlElementName) {
            _super.prototype.LoadFromXml.call(this, reader, xmlNamespace, xmlElementName);
            this.isDirty = false;
        };
        UserConfigurationDictionary.prototype.TryReadElementFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement(this.Namespace, "DictionaryEntry");
            this.LoadEntry(reader);
            return true;
        };
        UserConfigurationDictionary.prototype.LoadEntry = function (reader) {
            EwsUtilities.Assert(reader !== null, "UserConfigurationDictionary.LoadEntry", "reader is null");
            var value = null;
            reader.ReadStartElement(this.Namespace, "DictionaryKey");
            var dictionaryObject = this.GetDictionaryObject(reader);
            reader.ReadStartElement(this.Namespace, "DictionaryValue");
            var text = reader.ReadAttributeValue(XmlNamespace.XmlSchemaInstance, "nil");
            var flag = text === null || !Convert.ToBoolean(text);
            if (flag) {
                value = this.GetDictionaryObject(reader);
            }
            this.dictionary.Add(dictionaryObject, value);
        };
        UserConfigurationDictionary.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                var dictionaryObject = this.GetDictionaryObject(jsonObject.ReadAsJsonObject("DictionaryKey"), service);
                var dictionaryObject2 = this.GetDictionaryObject(jsonObject.ReadAsJsonObject("DictionaryValue"), service);
                this.dictionary.Add(dictionaryObject, dictionaryObject2);
            }
        };
        UserConfigurationDictionary.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        UserConfigurationDictionary.prototype.GetDictionaryObject = function (jsonObjectOrReader, service) {
            if (arguments.length === 2 && (jsonObjectOrReader === null || jsonObjectOrReader instanceof JsonObject) && (service === null || service instanceof ExchangeService)) {
                return this.GetDictionaryObject_0(jsonObjectOrReader, service);
            }
            return this.GetDictionaryObject_1(jsonObjectOrReader);
        };
        UserConfigurationDictionary.prototype.GetDictionaryObject_0 = function (jsonObject, service) {
            if (jsonObject === null) {
                return null;
            }
            var objectType = UserConfigurationDictionary.GetObjectType(jsonObject.ReadAsString("Type"));
            var objectValue = this.GetObjectValue(jsonObject.ReadAsArray("Value"));
            return this.ConstructObject(objectType, objectValue, service);
        };
        UserConfigurationDictionary.prototype.GetObjectValue = function (valueArrayOrReader, type) {
            if (arguments.length === 1 && (valueArrayOrReader === null || valueArrayOrReader instanceof Array)) {
                return this.GetObjectValue_0(valueArrayOrReader);
            }
            return this.GetObjectValue_1(valueArrayOrReader, type);
        };
        UserConfigurationDictionary.prototype.GetObjectValue_0 = function (valueArray) {
            var list = new List();
            for (var i = 0; i < valueArray.length; i = i + 1) {
                var obj = valueArray[i];
                list.Add(((obj instanceof string) ? obj : null));
            }
            return list;
        };
        UserConfigurationDictionary.prototype.GetDictionaryObject_1 = function (reader) {
            EwsUtilities.Assert(reader !== null, "UserConfigurationDictionary.LoadFromXml", "reader is null");
            var objectType = this.GetObjectType(reader);
            var objectValue = this.GetObjectValue(reader, objectType);
            return this.ConstructObject(objectType, objectValue, reader.Service);
        };
        UserConfigurationDictionary.prototype.GetObjectValue_1 = function (reader, type) {
            EwsUtilities.Assert(reader !== null, "UserConfigurationDictionary.LoadFromXml", "reader is null");
            var list = new List();
            reader.ReadStartElement(this.Namespace, "Value");
            do {
                var item = null;
                if (reader.IsEmptyElement) {
                    if (type === UserConfigurationDictionaryObjectType.String || type === UserConfigurationDictionaryObjectType.StringArray) {
                        item = NString.Empty;
                    }
                    else {
                        EwsUtilities.Assert(false, "UserConfigurationDictionary.GetObjectValue", "Empty element passed for type: " + UserConfigurationDictionaryObjectType[type]);
                    }
                }
                else {
                    item = reader.ReadElementValue();
                }
                list.Add(item);
                reader.Read();
            } while (reader.IsStartElement(this.Namespace, "Value"));
            return list;
        };
        UserConfigurationDictionary.prototype.GetObjectType = function (reader) {
            EwsUtilities.Assert(reader !== null, "UserConfigurationDictionary.LoadFromXml", "reader is null");
            reader.ReadStartElement(this.Namespace, "Type");
            var type = reader.ReadElementValue();
            return UserConfigurationDictionary.GetObjectType(type);
        };
        UserConfigurationDictionary.prototype.ConstructObject = function (type, value, service) {
            EwsUtilities.Assert(value !== null, "UserConfigurationDictionary.ConstructObject", "value is null");
            EwsUtilities.Assert(value.Count === 1 || type === UserConfigurationDictionaryObjectType.StringArray, "UserConfigurationDictionary.ConstructObject", "value is array but type is not StringArray");
            var result = null;
            switch (type) {
                case UserConfigurationDictionaryObjectType.DateTime:
                    {
                        var dateTime = service.ConvertUniversalDateTimeStringToLocalDateTime(value.get_Item(0));
                        if (dateTime !== null) {
                            result = dateTime.Value;
                        }
                        else {
                            EwsUtilities.Assert(false, "UserConfigurationDictionary.ConstructObject", "DateTime is null");
                        }
                        break;
                    }
                case UserConfigurationDictionaryObjectType.Boolean:
                    result = NBoolean.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.Byte:
                    result = NNumber.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.String:
                    result = value.get_Item(0);
                    break;
                case UserConfigurationDictionaryObjectType.Integer32:
                    result = NNumber.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.UnsignedInteger32:
                    result = NNumber.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.Integer64:
                    result = NNumber.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.UnsignedInteger64:
                    result = NNumber.Parse(value.get_Item(0));
                    break;
                case UserConfigurationDictionaryObjectType.StringArray:
                    result = value.ToArray();
                    break;
                case UserConfigurationDictionaryObjectType.ByteArray:
                    result = Convert.FromBase64String(value.get_Item(0));
                    break;
                default:
                    EwsUtilities.Assert(false, "UserConfigurationDictionary.ConstructObject", "Type not recognized: " + UserConfigurationDictionaryObjectType[type]);
                    break;
            }
            return result;
        };
        UserConfigurationDictionary.prototype.ValidateEntry = function (key, value) {
            this.ValidateObject(key);
            this.ValidateObject(value);
        };
        UserConfigurationDictionary.prototype.ValidateObject = function (dictionaryObject) {
            if (dictionaryObject !== null) {
                var array = ((dictionaryObject instanceof Array) ? dictionaryObject : null);
                if (array !== null) {
                    this.ValidateArrayObject(array);
                    return;
                }
                this.ValidateObjectType(dictionaryObject.GetType());
            }
        };
        UserConfigurationDictionary.prototype.ValidateArrayObject = function (dictionaryObjectAsArray) {
            if (dictionaryObjectAsArray instanceof string[]) {
                if (dictionaryObjectAsArray.Length > 0) {
                    var enumerator = dictionaryObjectAsArray.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            if (enumerator.Current === null) {
                                throw new ServiceLocalException(Strings.NullStringArrayElementInvalid);
                            }
                        }
                        return;
                    }
                    finally {
                        var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                        if (disposable !== null) {
                            disposable.Dispose();
                        }
                    }
                }
                throw new ServiceLocalException(Strings.ZeroLengthArrayInvalid);
            }
            if (!(dictionaryObjectAsArray instanceof number[])) {
                throw new ServiceLocalException(NString.Format(Strings.ObjectTypeNotSupported, dictionaryObjectAsArray.GetType()));
            }
            if (dictionaryObjectAsArray.Length <= 0) {
                throw new ServiceLocalException(Strings.ZeroLengthArrayInvalid);
            }
        };
        UserConfigurationDictionary.prototype.ValidateObjectType = function (type) {
            var IL_52 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        var flag = false;
                        var typeCode = Type.GetTypeCode(type);
                        switch (typeCode) {
                            case TypeCode.Boolean:
                            case TypeCode.Byte:
                            case TypeCode.Int32:
                            case TypeCode.UInt32:
                            case TypeCode.Int64:
                            case TypeCode.UInt64:
                                break;
                            case TypeCode.Char:
                            case TypeCode.SByte:
                            case TypeCode.Int16:
                            case TypeCode.UInt16:
                                _goto = IL_52;
                                continue _GOTO_LOOP;
                            default:
                                switch (typeCode) {
                                    case TypeCode.DateTime:
                                    case TypeCode.String:
                                        break;
                                    case 17:
                                        _goto = IL_52;
                                        continue _GOTO_LOOP;
                                    default:
                                        _goto = IL_52;
                                        continue _GOTO_LOOP;
                                }
                                break;
                        }
                        flag = true;
                        _goto = IL_52;
                        continue _GOTO_LOOP;
                    case 1:
                        if (!flag) {
                            throw new ServiceLocalException(NString.Format(Strings.ObjectTypeNotSupported, type));
                        }
                        break _GOTO_LOOP;
                }
            }
        };
        return UserConfigurationDictionary;
    }(ComplexProperty));
    var VotingInformation = (function (_super) {
        __extends(VotingInformation, _super);
        function VotingInformation() {
            _super.call(this);
            this.userOptions = new Collection();
            this.votingResponse = null;
        }
        Object.defineProperty(VotingInformation.prototype, "UserOptions", {
            get: function () {
                return this.userOptions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VotingInformation.prototype, "VotingResponse", {
            get: function () {
                return this.votingResponse;
            },
            enumerable: true,
            configurable: true
        });
        VotingInformation.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "UserOptions") {
                    if (!reader.IsEmptyElement) {
                        do {
                            reader.Read();
                            if (reader.IsStartElement(XmlNamespace.Types, "VotingOptionData")) {
                                var votingOptionData = new VotingOptionData();
                                votingOptionData.LoadFromXml(reader, reader.LocalName);
                                this.userOptions.Add(votingOptionData);
                            }
                        } while (!reader.IsEndElement(XmlNamespace.Types, "UserOptions"));
                    }
                    return true;
                }
                if (localName === "VotingResponse") {
                    this.votingResponse = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        VotingInformation.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "UserOptions")) {
                            if (a === "VotingResponse") {
                                this.votingResponse = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            var array = jsonProperty.ReadAsArray("UserOptions");
                            if (array !== null) {
                                var array2 = array;
                                for (var i = 0; i < array2.length; i = i + 1) {
                                    var obj = array2[i];
                                    var jsonProperty2 = ((obj instanceof JsonObject) ? obj : null);
                                    var votingOptionData = new VotingOptionData();
                                    votingOptionData.LoadFromJson(jsonProperty2, service);
                                    this.userOptions.Add(votingOptionData);
                                }
                            }
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return VotingInformation;
    }(ComplexProperty));
    var VotingOptionData = (function (_super) {
        __extends(VotingOptionData, _super);
        function VotingOptionData() {
            _super.call(this);
            this.displayName = null;
            this.sendPrompt = 0;
        }
        Object.defineProperty(VotingOptionData.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VotingOptionData.prototype, "SendPrompt", {
            get: function () {
                return this.sendPrompt;
            },
            enumerable: true,
            configurable: true
        });
        VotingOptionData.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DisplayName") {
                    this.displayName = reader.ReadElementValue();
                    return true;
                }
                if (localName === "SendPrompt") {
                    this.sendPrompt = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        VotingOptionData.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DisplayName")) {
                            if (a === "SendPrompt") {
                                this.sendPrompt = jsonProperty.ReadEnumValue(current);
                            }
                        }
                        else {
                            this.displayName = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return VotingOptionData;
    }(ComplexProperty));
    var Rule = (function (_super) {
        __extends(Rule, _super);
        function Rule() {
            _super.call(this);
            this.ruleId = null;
            this.displayName = null;
            this.priority = 0;
            this.isEnabled = false;
            this.isNotSupported = false;
            this.isInError = false;
            this.conditions = null;
            this.actions = null;
            this.exceptions = null;
            this.priority = 1;
            this.isEnabled = true;
            this.conditions = new RulePredicates();
            this.actions = new RuleActions();
            this.exceptions = new RulePredicates();
        }
        Object.defineProperty(Rule.prototype, "Id", {
            get: function () {
                return this.ruleId;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.ruleId
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.ruleId = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.displayName
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.displayName = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "Priority", {
            get: function () {
                return this.priority;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.priority
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.priority = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "IsEnabled", {
            get: function () {
                return this.isEnabled;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isEnabled
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isEnabled = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "IsNotSupported", {
            get: function () {
                return this.isNotSupported;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "IsInError", {
            get: function () {
                return this.isInError;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isInError
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isInError = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "Conditions", {
            get: function () {
                return this.conditions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "Actions", {
            get: function () {
                return this.actions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rule.prototype, "Exceptions", {
            get: function () {
                return this.exceptions;
            },
            enumerable: true,
            configurable: true
        });
        Rule.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "DisplayName":
                    this.displayName = reader.ReadElementValue();
                    return true;
                case "RuleId":
                    this.ruleId = reader.ReadElementValue();
                    return true;
                case "Priority":
                    this.priority = reader.ReadElementValue();
                    return true;
                case "IsEnabled":
                    this.isEnabled = reader.ReadElementValue();
                    return true;
                case "IsNotSupported":
                    this.isNotSupported = reader.ReadElementValue();
                    return true;
                case "IsInError":
                    this.isInError = reader.ReadElementValue();
                    return true;
                case "Conditions":
                    this.conditions.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "Actions":
                    this.actions.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "Exceptions":
                    this.exceptions.LoadFromXml(reader, reader.LocalName);
                    return true;
            }
            return false;
        };
        Rule.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "DisplayName":
                            this.displayName = jsonProperty.ReadAsString(current);
                            break;
                        case "RuleId":
                            this.ruleId = jsonProperty.ReadAsString(current);
                            break;
                        case "Priority":
                            this.priority = jsonProperty.ReadAsInt(current);
                            break;
                        case "IsEnabled":
                            this.isEnabled = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsNotSupported":
                            this.isNotSupported = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsInError":
                            this.isInError = jsonProperty.ReadAsBool(current);
                            break;
                        case "Conditions":
                            this.conditions.LoadFromJson(jsonProperty, service);
                            break;
                        case "Actions":
                            this.actions.LoadFromJson(jsonProperty, service);
                            break;
                        case "Exceptions":
                            this.exceptions.LoadFromJson(jsonProperty, service);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Rule.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.Id)) {
                writer.WriteElementValue(XmlNamespace.Types, "RuleId", this.Id);
            }
            writer.WriteElementValue(XmlNamespace.Types, "DisplayName", this.DisplayName);
            writer.WriteElementValue(XmlNamespace.Types, "Priority", this.Priority);
            writer.WriteElementValue(XmlNamespace.Types, "IsEnabled", this.IsEnabled);
            writer.WriteElementValue(XmlNamespace.Types, "IsInError", this.IsInError);
            this.Conditions.WriteToXml(writer, "Conditions");
            this.Exceptions.WriteToXml(writer, "Exceptions");
            this.Actions.WriteToXml(writer, "Actions");
        };
        Rule.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (!NString.IsNullOrEmpty(this.Id)) {
                jsonObject.Add("RuleId", this.Id);
            }
            jsonObject.Add("DisplayName", this.DisplayName);
            jsonObject.Add("Priority", this.Priority);
            jsonObject.Add("IsEnabled", this.IsEnabled);
            jsonObject.Add("IsInError", this.IsInError);
            jsonObject.Add("Conditions", this.Conditions.InternalToJson(service));
            jsonObject.Add("Exceptions", this.Exceptions.InternalToJson(service));
            jsonObject.Add("Actions", this.Actions.InternalToJson(service));
            return jsonObject;
        };
        Rule.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            EwsUtilities.ValidateParam(this.displayName, "DisplayName");
            EwsUtilities.ValidateParam(this.conditions, "Conditions");
            EwsUtilities.ValidateParam(this.exceptions, "Exceptions");
            EwsUtilities.ValidateParam(this.actions, "Actions");
        };
        return Rule;
    }(ComplexProperty));
    var RuleCollection = (function (_super) {
        __extends(RuleCollection, _super);
        function RuleCollection() {
            _super.call(this);
            this.outlookRuleBlobExists = false;
            this.rules = null;
            this.rules = new List();
        }
        Object.defineProperty(RuleCollection.prototype, "OutlookRuleBlobExists", {
            get: function () {
                return this.outlookRuleBlobExists;
            },
            set: function (value) {
                this.outlookRuleBlobExists = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleCollection.prototype, "Count", {
            get: function () {
                return this.rules.Count;
            },
            enumerable: true,
            configurable: true
        });
        RuleCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.rules.Count) {
                throw new ArgumentOutOfRangeException("Index");
            }
            return this.rules.get_Item(index);
        };
        RuleCollection.prototype.TryReadElementFromXml = function (reader) {
            if (reader.IsStartElement(XmlNamespace.Types, "Rule")) {
                var rule = new Rule();
                rule.LoadFromXml(reader, "Rule");
                this.rules.Add(rule);
                return true;
            }
            return false;
        };
        RuleCollection.prototype.CreateFromJsonCollection = function (jsonCollection, service) {
            for (var i = 0; i < jsonCollection.length; i = i + 1) {
                var obj = jsonCollection[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject !== null) {
                    var rule = new Rule();
                    rule.LoadFromJson(jsonObject, service);
                    this.rules.Add(rule);
                }
            }
        };
        RuleCollection.prototype.UpdateFromJsonCollection = function (jsonCollection, service) {
            throw new NotImplementedException();
        };
        RuleCollection.prototype.GetEnumerator = function () {
            return this.rules.GetEnumerator();
        };
        return RuleCollection;
    }(ComplexProperty));
    var RuleActions = (function (_super) {
        __extends(RuleActions, _super);
        function RuleActions() {
            _super.call(this);
            this.assignCategories = null;
            this.copyToFolder = null;
            this.delete = false;
            this.forwardAsAttachmentToRecipients = null;
            this.forwardToRecipients = null;
            this.markImportance = null;
            this.markAsRead = false;
            this.moveToFolder = null;
            this.permanentDelete = false;
            this.redirectToRecipients = null;
            this.sendSMSAlertToRecipients = null;
            this.serverReplyWithMessage = null;
            this.stopProcessingRules = false;
            this.assignCategories = new StringList();
            this.forwardAsAttachmentToRecipients = new EmailAddressCollection("Address");
            this.forwardToRecipients = new EmailAddressCollection("Address");
            this.redirectToRecipients = new EmailAddressCollection("Address");
            this.sendSMSAlertToRecipients = new Collection();
        }
        Object.defineProperty(RuleActions.prototype, "AssignCategories", {
            get: function () {
                return this.assignCategories;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "CopyToFolder", {
            get: function () {
                return this.copyToFolder;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.copyToFolder
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.copyToFolder = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "Delete", {
            get: function () {
                return this.delete;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.delete
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.delete = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "ForwardAsAttachmentToRecipients", {
            get: function () {
                return this.forwardAsAttachmentToRecipients;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "ForwardToRecipients", {
            get: function () {
                return this.forwardToRecipients;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "MarkImportance", {
            get: function () {
                return this.markImportance;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.markImportance
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.markImportance = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "MarkAsRead", {
            get: function () {
                return this.markAsRead;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.markAsRead
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.markAsRead = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "MoveToFolder", {
            get: function () {
                return this.moveToFolder;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.moveToFolder
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.moveToFolder = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "PermanentDelete", {
            get: function () {
                return this.permanentDelete;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.permanentDelete
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.permanentDelete = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "RedirectToRecipients", {
            get: function () {
                return this.redirectToRecipients;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "SendSMSAlertToRecipients", {
            get: function () {
                return this.sendSMSAlertToRecipients;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "ServerReplyWithMessage", {
            get: function () {
                return this.serverReplyWithMessage;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.serverReplyWithMessage
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.serverReplyWithMessage = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleActions.prototype, "StopProcessingRules", {
            get: function () {
                return this.stopProcessingRules;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.stopProcessingRules
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.stopProcessingRules = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        RuleActions.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "AssignCategories":
                    this.assignCategories.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "CopyToFolder":
                    reader.ReadStartElement(XmlNamespace.NotSpecified, "FolderId");
                    this.copyToFolder = new FolderId();
                    this.copyToFolder.LoadFromXml(reader, "FolderId");
                    reader.ReadEndElement(XmlNamespace.NotSpecified, "CopyToFolder");
                    return true;
                case "Delete":
                    this.delete = reader.ReadElementValue();
                    return true;
                case "ForwardAsAttachmentToRecipients":
                    this.forwardAsAttachmentToRecipients.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ForwardToRecipients":
                    this.forwardToRecipients.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "MarkImportance":
                    this.markImportance = new Nullable(reader.ReadElementValue());
                    return true;
                case "MarkAsRead":
                    this.markAsRead = reader.ReadElementValue();
                    return true;
                case "MoveToFolder":
                    reader.ReadStartElement(XmlNamespace.NotSpecified, "FolderId");
                    this.moveToFolder = new FolderId();
                    this.moveToFolder.LoadFromXml(reader, "FolderId");
                    reader.ReadEndElement(XmlNamespace.NotSpecified, "MoveToFolder");
                    return true;
                case "PermanentDelete":
                    this.permanentDelete = reader.ReadElementValue();
                    return true;
                case "RedirectToRecipients":
                    this.redirectToRecipients.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "SendSMSAlertToRecipients":
                    {
                        var emailAddressCollection = new EmailAddressCollection("Address");
                        emailAddressCollection.LoadFromXml(reader, reader.LocalName);
                        this.sendSMSAlertToRecipients = RuleActions.ConvertSMSRecipientsFromEmailAddressCollectionToMobilePhoneCollection(emailAddressCollection);
                        return true;
                    }
                case "ServerReplyWithMessage":
                    this.serverReplyWithMessage = new ItemId();
                    this.serverReplyWithMessage.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "StopProcessingRules":
                    this.stopProcessingRules = reader.ReadElementValue();
                    return true;
            }
            return false;
        };
        RuleActions.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "AssignCategories":
                            this.assignCategories.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "CopyToFolder":
                            this.copyToFolder = new FolderId();
                            this.copyToFolder.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "Delete":
                            this.delete = jsonProperty.ReadAsBool(current);
                            break;
                        case "ForwardAsAttachmentToRecipients":
                            this.forwardAsAttachmentToRecipients.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "ForwardToRecipients":
                            this.forwardToRecipients.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "MarkImportance":
                            this.markImportance = new Nullable(jsonProperty.ReadEnumValue(current));
                            break;
                        case "MarkAsRead":
                            this.markAsRead = jsonProperty.ReadAsBool(current);
                            break;
                        case "MoveToFolder":
                            this.moveToFolder = new FolderId();
                            this.moveToFolder.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "PermanentDelete":
                            this.permanentDelete = jsonProperty.ReadAsBool(current);
                            break;
                        case "RedirectToRecipients":
                            this.redirectToRecipients.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "SendSMSAlertToRecipients":
                            {
                                var emailAddressCollection = new EmailAddressCollection("Address");
                                emailAddressCollection.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                this.sendSMSAlertToRecipients = RuleActions.ConvertSMSRecipientsFromEmailAddressCollectionToMobilePhoneCollection(emailAddressCollection);
                                break;
                            }
                        case "ServerReplyWithMessage":
                            this.serverReplyWithMessage = new ItemId();
                            this.serverReplyWithMessage.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            break;
                        case "StopProcessingRules":
                            this.stopProcessingRules = jsonProperty.ReadAsBool(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        RuleActions.prototype.WriteElementsToXml = function (writer) {
            if (this.AssignCategories.Count > 0) {
                this.AssignCategories.WriteToXml(writer, "AssignCategories");
            }
            if (this.CopyToFolder !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "CopyToFolder");
                this.CopyToFolder.WriteToXml(writer);
                writer.WriteEndElement();
            }
            if (this.Delete) {
                writer.WriteElementValue(XmlNamespace.Types, "Delete", this.Delete);
            }
            if (this.ForwardAsAttachmentToRecipients.Count > 0) {
                this.ForwardAsAttachmentToRecipients.WriteToXml(writer, "ForwardAsAttachmentToRecipients");
            }
            if (this.ForwardToRecipients.Count > 0) {
                this.ForwardToRecipients.WriteToXml(writer, "ForwardToRecipients");
            }
            if (this.MarkImportance !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "MarkImportance", this.MarkImportance.Value);
            }
            if (this.MarkAsRead) {
                writer.WriteElementValue(XmlNamespace.Types, "MarkAsRead", this.MarkAsRead);
            }
            if (this.MoveToFolder !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "MoveToFolder");
                this.MoveToFolder.WriteToXml(writer);
                writer.WriteEndElement();
            }
            if (this.PermanentDelete) {
                writer.WriteElementValue(XmlNamespace.Types, "PermanentDelete", this.PermanentDelete);
            }
            if (this.RedirectToRecipients.Count > 0) {
                this.RedirectToRecipients.WriteToXml(writer, "RedirectToRecipients");
            }
            if (this.SendSMSAlertToRecipients.Count > 0) {
                var emailAddressCollection = RuleActions.ConvertSMSRecipientsFromMobilePhoneCollectionToEmailAddressCollection(this.SendSMSAlertToRecipients);
                emailAddressCollection.WriteToXml(writer, "SendSMSAlertToRecipients");
            }
            if (this.ServerReplyWithMessage !== null) {
                this.ServerReplyWithMessage.WriteToXml(writer, "ServerReplyWithMessage");
            }
            if (this.StopProcessingRules) {
                writer.WriteElementValue(XmlNamespace.Types, "StopProcessingRules", this.StopProcessingRules);
            }
        };
        RuleActions.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.AssignCategories.Count > 0) {
                jsonObject.Add("AssignCategories", this.AssignCategories.InternalToJson(service));
            }
            if (this.CopyToFolder !== null) {
                jsonObject.Add("CopyToFolder", this.CopyToFolder.InternalToJson(service));
            }
            if (this.Delete) {
                jsonObject.Add("Delete", this.Delete);
            }
            if (this.ForwardAsAttachmentToRecipients.Count > 0) {
                jsonObject.Add("ForwardAsAttachmentToRecipients", this.ForwardAsAttachmentToRecipients.InternalToJson(service));
            }
            if (this.ForwardToRecipients.Count > 0) {
                jsonObject.Add("ForwardToRecipients", this.ForwardToRecipients.InternalToJson(service));
            }
            if (this.MarkImportance !== null) {
                jsonObject.Add("MarkImportance", this.MarkImportance.Value);
            }
            if (this.MarkAsRead) {
                jsonObject.Add("MarkAsRead", this.MarkAsRead);
            }
            if (this.MoveToFolder !== null) {
                jsonObject.Add("MoveToFolder", this.MoveToFolder.InternalToJson(service));
            }
            if (this.PermanentDelete) {
                jsonObject.Add("PermanentDelete", this.PermanentDelete);
            }
            if (this.RedirectToRecipients.Count > 0) {
                jsonObject.Add("RedirectToRecipients", this.RedirectToRecipients.InternalToJson(service));
            }
            if (this.SendSMSAlertToRecipients.Count > 0) {
                var emailAddressCollection = RuleActions.ConvertSMSRecipientsFromMobilePhoneCollectionToEmailAddressCollection(this.SendSMSAlertToRecipients);
                jsonObject.Add("SendSMSAlertToRecipients", emailAddressCollection.InternalToJson(service));
            }
            if (this.ServerReplyWithMessage !== null) {
                jsonObject.Add("ServerReplyWithMessage", this.ServerReplyWithMessage.InternalToJson(service));
            }
            if (this.StopProcessingRules) {
                jsonObject.Add("StopProcessingRules", this.StopProcessingRules);
            }
            return jsonObject;
        };
        RuleActions.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            EwsUtilities.ValidateParam(this.forwardAsAttachmentToRecipients, "ForwardAsAttachmentToRecipients");
            EwsUtilities.ValidateParam(this.forwardToRecipients, "ForwardToRecipients");
            EwsUtilities.ValidateParam(this.redirectToRecipients, "RedirectToRecipients");
            var enumerator = this.sendSMSAlertToRecipients.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    EwsUtilities.ValidateParam(current, "SendSMSAlertToRecipient");
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        RuleActions.ConvertSMSRecipientsFromEmailAddressCollectionToMobilePhoneCollection = function (emailCollection) {
            var collection = new Collection();
            var enumerator = emailCollection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    collection.Add(new MobilePhone(current.Name, current.Address));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return collection;
        };
        RuleActions.ConvertSMSRecipientsFromMobilePhoneCollectionToEmailAddressCollection = function (recipientCollection) {
            var emailAddressCollection = new EmailAddressCollection("Address");
            var enumerator = recipientCollection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var emailAddress = new EmailAddress(current.Name, current.PhoneNumber, "MOBILE");
                    emailAddressCollection.Add(emailAddress);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return emailAddressCollection;
        };
        RuleActions.MobileType = "MOBILE";
        return RuleActions;
    }(ComplexProperty));
    var RulePredicates = (function (_super) {
        __extends(RulePredicates, _super);
        function RulePredicates() {
            _super.call(this);
            this.categories = null;
            this.containsBodyStrings = null;
            this.containsHeaderStrings = null;
            this.containsRecipientStrings = null;
            this.containsSenderStrings = null;
            this.containsSubjectOrBodyStrings = null;
            this.containsSubjectStrings = null;
            this.flaggedForAction = null;
            this.fromAddresses = null;
            this.fromConnectedAccounts = null;
            this.hasAttachments = false;
            this.importance = null;
            this.isApprovalRequest = false;
            this.isAutomaticForward = false;
            this.isAutomaticReply = false;
            this.isEncrypted = false;
            this.isMeetingRequest = false;
            this.isMeetingResponse = false;
            this.isNonDeliveryReport = false;
            this.isPermissionControlled = false;
            this.isSigned = false;
            this.isVoicemail = false;
            this.isReadReceipt = false;
            this.itemClasses = null;
            this.messageClassifications = null;
            this.notSentToMe = false;
            this.sentCcMe = false;
            this.sentOnlyToMe = false;
            this.sentToAddresses = null;
            this.sentToMe = false;
            this.sentToOrCcMe = false;
            this.sensitivity = null;
            this.withinDateRange = null;
            this.withinSizeRange = null;
            this.categories = new StringList();
            this.containsBodyStrings = new StringList();
            this.containsHeaderStrings = new StringList();
            this.containsRecipientStrings = new StringList();
            this.containsSenderStrings = new StringList();
            this.containsSubjectOrBodyStrings = new StringList();
            this.containsSubjectStrings = new StringList();
            this.fromAddresses = new EmailAddressCollection("Address");
            this.fromConnectedAccounts = new StringList();
            this.itemClasses = new StringList();
            this.messageClassifications = new StringList();
            this.sentToAddresses = new EmailAddressCollection("Address");
            this.withinDateRange = new RulePredicateDateRange();
            this.withinSizeRange = new RulePredicateSizeRange();
        }
        Object.defineProperty(RulePredicates.prototype, "Categories", {
            get: function () {
                return this.categories;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsBodyStrings", {
            get: function () {
                return this.containsBodyStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsHeaderStrings", {
            get: function () {
                return this.containsHeaderStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsRecipientStrings", {
            get: function () {
                return this.containsRecipientStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsSenderStrings", {
            get: function () {
                return this.containsSenderStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsSubjectOrBodyStrings", {
            get: function () {
                return this.containsSubjectOrBodyStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ContainsSubjectStrings", {
            get: function () {
                return this.containsSubjectStrings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "FlaggedForAction", {
            get: function () {
                return this.flaggedForAction;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.flaggedForAction
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.flaggedForAction = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "FromAddresses", {
            get: function () {
                return this.fromAddresses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "HasAttachments", {
            get: function () {
                return this.hasAttachments;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.hasAttachments
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.hasAttachments = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "Importance", {
            get: function () {
                return this.importance;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.importance
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.importance = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsApprovalRequest", {
            get: function () {
                return this.isApprovalRequest;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isApprovalRequest
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isApprovalRequest = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsAutomaticForward", {
            get: function () {
                return this.isAutomaticForward;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isAutomaticForward
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isAutomaticForward = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsAutomaticReply", {
            get: function () {
                return this.isAutomaticReply;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isAutomaticReply
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isAutomaticReply = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsEncrypted", {
            get: function () {
                return this.isEncrypted;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isEncrypted
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isEncrypted = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsMeetingRequest", {
            get: function () {
                return this.isMeetingRequest;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isMeetingRequest
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isMeetingRequest = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsMeetingResponse", {
            get: function () {
                return this.isMeetingResponse;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isMeetingResponse
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isMeetingResponse = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsNonDeliveryReport", {
            get: function () {
                return this.isNonDeliveryReport;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isNonDeliveryReport
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isNonDeliveryReport = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsPermissionControlled", {
            get: function () {
                return this.isPermissionControlled;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isPermissionControlled
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isPermissionControlled = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsSigned", {
            get: function () {
                return this.isSigned;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isSigned
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isSigned = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsVoicemail", {
            get: function () {
                return this.isVoicemail;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isVoicemail
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isVoicemail = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "IsReadReceipt", {
            get: function () {
                return this.isReadReceipt;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.isReadReceipt
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.isReadReceipt = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "FromConnectedAccounts", {
            get: function () {
                return this.fromConnectedAccounts;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "ItemClasses", {
            get: function () {
                return this.itemClasses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "MessageClassifications", {
            get: function () {
                return this.messageClassifications;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "NotSentToMe", {
            get: function () {
                return this.notSentToMe;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.notSentToMe
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.notSentToMe = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "SentCcMe", {
            get: function () {
                return this.sentCcMe;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sentCcMe
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sentCcMe = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "SentOnlyToMe", {
            get: function () {
                return this.sentOnlyToMe;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sentOnlyToMe
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sentOnlyToMe = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "SentToAddresses", {
            get: function () {
                return this.sentToAddresses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "SentToMe", {
            get: function () {
                return this.sentToMe;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sentToMe
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sentToMe = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "SentToOrCcMe", {
            get: function () {
                return this.sentToOrCcMe;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sentToOrCcMe
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sentToOrCcMe = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "Sensitivity", {
            get: function () {
                return this.sensitivity;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.sensitivity
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.sensitivity = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "WithinDateRange", {
            get: function () {
                return this.withinDateRange;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicates.prototype, "WithinSizeRange", {
            get: function () {
                return this.withinSizeRange;
            },
            enumerable: true,
            configurable: true
        });
        RulePredicates.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Categories":
                    this.categories.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsBodyStrings":
                    this.containsBodyStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsHeaderStrings":
                    this.containsHeaderStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsRecipientStrings":
                    this.containsRecipientStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsSenderStrings":
                    this.containsSenderStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsSubjectOrBodyStrings":
                    this.containsSubjectOrBodyStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "ContainsSubjectStrings":
                    this.containsSubjectStrings.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "FlaggedForAction":
                    this.flaggedForAction = new Nullable(reader.ReadElementValue());
                    return true;
                case "FromAddresses":
                    this.fromAddresses.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "FromConnectedAccounts":
                    this.fromConnectedAccounts.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "HasAttachments":
                    this.hasAttachments = reader.ReadElementValue();
                    return true;
                case "Importance":
                    this.importance = new Nullable(reader.ReadElementValue());
                    return true;
                case "IsApprovalRequest":
                    this.isApprovalRequest = reader.ReadElementValue();
                    return true;
                case "IsAutomaticForward":
                    this.isAutomaticForward = reader.ReadElementValue();
                    return true;
                case "IsAutomaticReply":
                    this.isAutomaticReply = reader.ReadElementValue();
                    return true;
                case "IsEncrypted":
                    this.isEncrypted = reader.ReadElementValue();
                    return true;
                case "IsMeetingRequest":
                    this.isMeetingRequest = reader.ReadElementValue();
                    return true;
                case "IsMeetingResponse":
                    this.isMeetingResponse = reader.ReadElementValue();
                    return true;
                case "IsNDR":
                    this.isNonDeliveryReport = reader.ReadElementValue();
                    return true;
                case "IsPermissionControlled":
                    this.isPermissionControlled = reader.ReadElementValue();
                    return true;
                case "IsSigned":
                    this.isSigned = reader.ReadElementValue();
                    return true;
                case "IsVoicemail":
                    this.isVoicemail = reader.ReadElementValue();
                    return true;
                case "IsReadReceipt":
                    this.isReadReceipt = reader.ReadElementValue();
                    return true;
                case "ItemClasses":
                    this.itemClasses.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "MessageClassifications":
                    this.messageClassifications.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "NotSentToMe":
                    this.notSentToMe = reader.ReadElementValue();
                    return true;
                case "SentCcMe":
                    this.sentCcMe = reader.ReadElementValue();
                    return true;
                case "SentOnlyToMe":
                    this.sentOnlyToMe = reader.ReadElementValue();
                    return true;
                case "SentToAddresses":
                    this.sentToAddresses.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "SentToMe":
                    this.sentToMe = reader.ReadElementValue();
                    return true;
                case "SentToOrCcMe":
                    this.sentToOrCcMe = reader.ReadElementValue();
                    return true;
                case "Sensitivity":
                    this.sensitivity = new Nullable(reader.ReadElementValue());
                    return true;
                case "WithinDateRange":
                    this.withinDateRange.LoadFromXml(reader, reader.LocalName);
                    return true;
                case "WithinSizeRange":
                    this.withinSizeRange.LoadFromXml(reader, reader.LocalName);
                    return true;
            }
            return false;
        };
        RulePredicates.prototype.WriteElementsToXml = function (writer) {
            if (this.Categories.Count > 0) {
                this.Categories.WriteToXml(writer, "Categories");
            }
            if (this.ContainsBodyStrings.Count > 0) {
                this.ContainsBodyStrings.WriteToXml(writer, "ContainsBodyStrings");
            }
            if (this.ContainsHeaderStrings.Count > 0) {
                this.ContainsHeaderStrings.WriteToXml(writer, "ContainsHeaderStrings");
            }
            if (this.ContainsRecipientStrings.Count > 0) {
                this.ContainsRecipientStrings.WriteToXml(writer, "ContainsRecipientStrings");
            }
            if (this.ContainsSenderStrings.Count > 0) {
                this.ContainsSenderStrings.WriteToXml(writer, "ContainsSenderStrings");
            }
            if (this.ContainsSubjectOrBodyStrings.Count > 0) {
                this.ContainsSubjectOrBodyStrings.WriteToXml(writer, "ContainsSubjectOrBodyStrings");
            }
            if (this.ContainsSubjectStrings.Count > 0) {
                this.ContainsSubjectStrings.WriteToXml(writer, "ContainsSubjectStrings");
            }
            if (this.FlaggedForAction !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "FlaggedForAction", this.FlaggedForAction.Value);
            }
            if (this.FromAddresses.Count > 0) {
                this.FromAddresses.WriteToXml(writer, "FromAddresses");
            }
            if (this.FromConnectedAccounts.Count > 0) {
                this.FromConnectedAccounts.WriteToXml(writer, "FromConnectedAccounts");
            }
            if (this.HasAttachments) {
                writer.WriteElementValue(XmlNamespace.Types, "HasAttachments", this.HasAttachments);
            }
            if (this.Importance !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "Importance", this.Importance.Value);
            }
            if (this.IsApprovalRequest) {
                writer.WriteElementValue(XmlNamespace.Types, "IsApprovalRequest", this.IsApprovalRequest);
            }
            if (this.IsAutomaticForward) {
                writer.WriteElementValue(XmlNamespace.Types, "IsAutomaticForward", this.IsAutomaticForward);
            }
            if (this.IsAutomaticReply) {
                writer.WriteElementValue(XmlNamespace.Types, "IsAutomaticReply", this.IsAutomaticReply);
            }
            if (this.IsEncrypted) {
                writer.WriteElementValue(XmlNamespace.Types, "IsEncrypted", this.IsEncrypted);
            }
            if (this.IsMeetingRequest) {
                writer.WriteElementValue(XmlNamespace.Types, "IsMeetingRequest", this.IsMeetingRequest);
            }
            if (this.IsMeetingResponse) {
                writer.WriteElementValue(XmlNamespace.Types, "IsMeetingResponse", this.IsMeetingResponse);
            }
            if (this.IsNonDeliveryReport) {
                writer.WriteElementValue(XmlNamespace.Types, "IsNDR", this.IsNonDeliveryReport);
            }
            if (this.IsPermissionControlled) {
                writer.WriteElementValue(XmlNamespace.Types, "IsPermissionControlled", this.IsPermissionControlled);
            }
            if (this.isReadReceipt) {
                writer.WriteElementValue(XmlNamespace.Types, "IsReadReceipt", this.IsReadReceipt);
            }
            if (this.IsSigned) {
                writer.WriteElementValue(XmlNamespace.Types, "IsSigned", this.IsSigned);
            }
            if (this.IsVoicemail) {
                writer.WriteElementValue(XmlNamespace.Types, "IsVoicemail", this.IsVoicemail);
            }
            if (this.ItemClasses.Count > 0) {
                this.ItemClasses.WriteToXml(writer, "ItemClasses");
            }
            if (this.MessageClassifications.Count > 0) {
                this.MessageClassifications.WriteToXml(writer, "MessageClassifications");
            }
            if (this.NotSentToMe) {
                writer.WriteElementValue(XmlNamespace.Types, "NotSentToMe", this.NotSentToMe);
            }
            if (this.SentCcMe) {
                writer.WriteElementValue(XmlNamespace.Types, "SentCcMe", this.SentCcMe);
            }
            if (this.SentOnlyToMe) {
                writer.WriteElementValue(XmlNamespace.Types, "SentOnlyToMe", this.SentOnlyToMe);
            }
            if (this.SentToAddresses.Count > 0) {
                this.SentToAddresses.WriteToXml(writer, "SentToAddresses");
            }
            if (this.SentToMe) {
                writer.WriteElementValue(XmlNamespace.Types, "SentToMe", this.SentToMe);
            }
            if (this.SentToOrCcMe) {
                writer.WriteElementValue(XmlNamespace.Types, "SentToOrCcMe", this.SentToOrCcMe);
            }
            if (this.Sensitivity !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "Sensitivity", this.Sensitivity.Value);
            }
            if (this.WithinDateRange.Start !== null || this.WithinDateRange.End !== null) {
                this.WithinDateRange.WriteToXml(writer, "WithinDateRange");
            }
            if (this.WithinSizeRange.MaximumSize !== null || this.WithinSizeRange.MinimumSize !== null) {
                this.WithinSizeRange.WriteToXml(writer, "WithinSizeRange");
            }
        };
        RulePredicates.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            EwsUtilities.ValidateParam(this.fromAddresses, "FromAddresses");
            EwsUtilities.ValidateParam(this.sentToAddresses, "SentToAddresses");
            EwsUtilities.ValidateParam(this.withinDateRange, "WithinDateRange");
            EwsUtilities.ValidateParam(this.withinSizeRange, "WithinSizeRange");
        };
        return RulePredicates;
    }(ComplexProperty));
    var RulePredicateDateRange = (function (_super) {
        __extends(RulePredicateDateRange, _super);
        function RulePredicateDateRange() {
            _super.call(this);
            this.start = null;
            this.end = null;
        }
        Object.defineProperty(RulePredicateDateRange.prototype, "Start", {
            get: function () {
                return this.start;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.start
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.start = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicateDateRange.prototype, "End", {
            get: function () {
                return this.end;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.end
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.end = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        RulePredicateDateRange.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "StartDateTime") {
                    this.start = reader.ReadElementValueAsDateTime();
                    return true;
                }
                if (localName === "EndDateTime") {
                    this.end = reader.ReadElementValueAsDateTime();
                    return true;
                }
            }
            return false;
        };
        RulePredicateDateRange.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "StartDateTime")) {
                            if (a === "EndDateTime") {
                                this.end = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current));
                            }
                        }
                        else {
                            this.start = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonProperty.ReadAsString(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        RulePredicateDateRange.prototype.WriteElementsToXml = function (writer) {
            if (this.Start !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "StartDateTime", this.Start.Value);
            }
            if (this.End !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "EndDateTime", this.End.Value);
            }
        };
        RulePredicateDateRange.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.Start !== null) {
                jsonObject.Add("StartDateTime", service.ConvertDateTimeToUniversalDateTimeString(this.Start.Value));
            }
            if (this.End !== null) {
                jsonObject.Add("EndDateTime", service.ConvertDateTimeToUniversalDateTimeString(this.End.Value));
            }
            return jsonObject;
        };
        RulePredicateDateRange.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (this.start !== null && this.end !== null && DateTime.op_GreaterThan(this.start.Value, this.end.Value)) {
                throw new ServiceValidationException("Start date time cannot be bigger than end date time.");
            }
        };
        return RulePredicateDateRange;
    }(ComplexProperty));
    var RulePredicateSizeRange = (function (_super) {
        __extends(RulePredicateSizeRange, _super);
        function RulePredicateSizeRange() {
            _super.call(this);
            this.minimumSize = null;
            this.maximumSize = null;
        }
        Object.defineProperty(RulePredicateSizeRange.prototype, "MinimumSize", {
            get: function () {
                return this.minimumSize;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.minimumSize
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.minimumSize = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RulePredicateSizeRange.prototype, "MaximumSize", {
            get: function () {
                return this.maximumSize;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.maximumSize
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.maximumSize = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        RulePredicateSizeRange.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "MinimumSize") {
                    this.minimumSize = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "MaximumSize") {
                    this.maximumSize = new Nullable(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        RulePredicateSizeRange.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "MinimumSize")) {
                            if (a === "MaximumSize") {
                                this.maximumSize = new Nullable(jsonProperty.ReadAsInt(current));
                            }
                        }
                        else {
                            this.minimumSize = new Nullable(jsonProperty.ReadAsInt(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        RulePredicateSizeRange.prototype.WriteElementsToXml = function (writer) {
            if (this.MinimumSize !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "MinimumSize", this.MinimumSize.Value);
            }
            if (this.MaximumSize !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "MaximumSize", this.MaximumSize.Value);
            }
        };
        RulePredicateSizeRange.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.MinimumSize !== null) {
                jsonObject.Add("MinimumSize", this.MinimumSize.Value);
            }
            if (this.MaximumSize !== null) {
                jsonObject.Add("MaximumSize", this.MaximumSize.Value);
            }
            return jsonObject;
        };
        RulePredicateSizeRange.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (this.minimumSize !== null && this.maximumSize !== null && this.minimumSize.Value > this.maximumSize.Value) {
                throw new ServiceValidationException("MinimumSize cannot be larger than MaximumSize.");
            }
        };
        return RulePredicateSizeRange;
    }(ComplexProperty));
    var RuleOperation = (function (_super) {
        __extends(RuleOperation, _super);
        function RuleOperation() {
            _super.call(this);
            this.XmlElementName = null;
        }
        return RuleOperation;
    }(ComplexProperty));
    var CreateRuleOperation = (function (_super) {
        __extends(CreateRuleOperation, _super);
        function CreateRuleOperation(rule) {
            _super.call(this);
            this.rule = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(rule);
        }
        Object.defineProperty(CreateRuleOperation.prototype, "Rule", {
            get: function () {
                return this.rule;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.rule
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.rule = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateRuleOperation.prototype, "XmlElementName", {
            get: function () {
                return "CreateRuleOperation";
            },
            enumerable: true,
            configurable: true
        });
        CreateRuleOperation.prototype.constructor_0 = function () {
        };
        CreateRuleOperation.prototype.constructor_1 = function (rule) {
            this.rule = rule;
        };
        CreateRuleOperation.prototype.WriteElementsToXml = function (writer) {
            this.Rule.WriteToXml(writer, "Rule");
        };
        CreateRuleOperation.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Rule", this.Rule.InternalToJson(service));
            return jsonObject;
        };
        CreateRuleOperation.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.rule, "Rule");
        };
        return CreateRuleOperation;
    }(RuleOperation));
    var DeleteRuleOperation = (function (_super) {
        __extends(DeleteRuleOperation, _super);
        function DeleteRuleOperation(ruleId) {
            _super.call(this);
            this.ruleId = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(ruleId);
        }
        Object.defineProperty(DeleteRuleOperation.prototype, "RuleId", {
            get: function () {
                return this.ruleId;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.ruleId
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.ruleId = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DeleteRuleOperation.prototype, "XmlElementName", {
            get: function () {
                return "DeleteRuleOperation";
            },
            enumerable: true,
            configurable: true
        });
        DeleteRuleOperation.prototype.constructor_0 = function () {
        };
        DeleteRuleOperation.prototype.constructor_1 = function (ruleId) {
            this.ruleId = ruleId;
        };
        DeleteRuleOperation.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "RuleId", this.RuleId);
        };
        DeleteRuleOperation.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("RuleId", this.RuleId);
            return jsonObject;
        };
        DeleteRuleOperation.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.ruleId, "RuleId");
        };
        return DeleteRuleOperation;
    }(RuleOperation));
    var SetClientExtensionAction = (function (_super) {
        __extends(SetClientExtensionAction, _super);
        function SetClientExtensionAction(setClientExtensionActionId, extensionId, clientExtension) {
            _super.call(this);
            this.setClientExtensionActionId = 0;
            this.extensionId = null;
            this.clientExtension = null;
            this.Namespace = XmlNamespace.Types;
            this.setClientExtensionActionId = setClientExtensionActionId;
            this.extensionId = extensionId;
            this.clientExtension = clientExtension;
        }
        SetClientExtensionAction.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("ActionId", this.setClientExtensionActionId);
            if (!NString.IsNullOrEmpty(this.extensionId)) {
                writer.WriteAttributeValue("ExtensionId", this.extensionId);
            }
        };
        SetClientExtensionAction.prototype.WriteElementsToXml = function (writer) {
            if (this.clientExtension !== null) {
                this.clientExtension.WriteToXml(writer, XmlNamespace.Types, "ClientExtension");
            }
        };
        return SetClientExtensionAction;
    }(ComplexProperty));
    var SetRuleOperation = (function (_super) {
        __extends(SetRuleOperation, _super);
        function SetRuleOperation(rule) {
            _super.call(this);
            this.rule = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(rule);
        }
        Object.defineProperty(SetRuleOperation.prototype, "Rule", {
            get: function () {
                return this.rule;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.rule
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.rule = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SetRuleOperation.prototype, "XmlElementName", {
            get: function () {
                return "SetRuleOperation";
            },
            enumerable: true,
            configurable: true
        });
        SetRuleOperation.prototype.constructor_0 = function () {
        };
        SetRuleOperation.prototype.constructor_1 = function (rule) {
            this.rule = rule;
        };
        SetRuleOperation.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Rule") {
                this.rule = new Rule();
                this.rule.LoadFromXml(reader, reader.LocalName);
                return true;
            }
            return false;
        };
        SetRuleOperation.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "Rule") {
                        this.rule = new Rule();
                        this.rule.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        SetRuleOperation.prototype.WriteElementsToXml = function (writer) {
            this.Rule.WriteToXml(writer, "Rule");
        };
        SetRuleOperation.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Rule", this.Rule.InternalToJson(service));
            return jsonObject;
        };
        SetRuleOperation.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.rule, "Rule");
        };
        return SetRuleOperation;
    }(RuleOperation));
    var RuleOperationError = (function (_super) {
        __extends(RuleOperationError, _super);
        function RuleOperationError() {
            _super.call(this);
            this.operationIndex = 0;
            this.operation = null;
            this.ruleErrors = null;
        }
        Object.defineProperty(RuleOperationError.prototype, "Operation", {
            get: function () {
                return this.operation;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleOperationError.prototype, "Count", {
            get: function () {
                return this.ruleErrors.Count;
            },
            enumerable: true,
            configurable: true
        });
        RuleOperationError.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index");
            }
            return this.ruleErrors.get_Item(index);
        };
        RuleOperationError.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "OperationIndex") {
                    this.operationIndex = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ValidationErrors") {
                    this.ruleErrors = new RuleErrorCollection();
                    this.ruleErrors.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        RuleOperationError.prototype.LoadFromJson = function (jsonProperty, service) {
            if (jsonProperty.ContainsKey("OperationIndex")) {
                this.operationIndex = jsonProperty.ReadAsInt("OperationIndex");
            }
            if (jsonProperty.ContainsKey("ValidationErrors")) {
                this.ruleErrors = new RuleErrorCollection();
                this.ruleErrors.CreateFromJsonCollection(jsonProperty.ReadAsArray("ValidationErrors"), service);
            }
        };
        RuleOperationError.prototype.SetOperationByIndex = function (operations) {
            operations.Reset();
            for (var i = 0; i <= this.operationIndex; i = i + 1) {
                operations.MoveNext();
            }
            this.operation = operations.Current;
        };
        RuleOperationError.prototype.GetEnumerator = function () {
            return this.ruleErrors.GetEnumerator();
        };
        return RuleOperationError;
    }(ComplexProperty));
    var RuleOperationErrorCollection = (function (_super) {
        __extends(RuleOperationErrorCollection, _super);
        function RuleOperationErrorCollection() {
            _super.call(this);
        }
        RuleOperationErrorCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === "RuleOperationError") {
                return new RuleOperationError();
            }
            return null;
        };
        RuleOperationErrorCollection.prototype.CreateDefaultComplexProperty = function () {
            return new RuleOperationError();
        };
        RuleOperationErrorCollection.prototype.GetCollectionItemXmlElementName = function (operationError) {
            return "RuleOperationError";
        };
        return RuleOperationErrorCollection;
    }(ComplexPropertyCollection));
    var RuleError = (function (_super) {
        __extends(RuleError, _super);
        function RuleError() {
            _super.call(this);
            this.ruleProperty = 0;
            this.errorCode = 0;
            this.errorMessage = null;
            this.value = null;
        }
        Object.defineProperty(RuleError.prototype, "RuleProperty", {
            get: function () {
                return this.ruleProperty;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleError.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleError.prototype, "ErrorMessage", {
            get: function () {
                return this.errorMessage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RuleError.prototype, "Value", {
            get: function () {
                return this.value;
            },
            enumerable: true,
            configurable: true
        });
        RuleError.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "FieldURI") {
                    this.ruleProperty = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ErrorCode") {
                    this.errorCode = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ErrorMessage") {
                    this.errorMessage = reader.ReadElementValue();
                    return true;
                }
                if (localName === "FieldValue") {
                    this.value = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        RuleError.prototype.LoadFromJson = function (jsonProperty, service) {
            if (jsonProperty.ContainsKey("FieldURI")) {
                this.ruleProperty = jsonProperty.ReadEnumValue("FieldURI");
            }
            if (jsonProperty.ContainsKey("ErrorCode")) {
                this.errorCode = jsonProperty.ReadEnumValue("ErrorCode");
            }
            if (jsonProperty.ContainsKey("ErrorMessage")) {
                this.errorMessage = jsonProperty.ReadAsString("ErrorMessage");
            }
            if (jsonProperty.ContainsKey("FieldValue")) {
                this.value = jsonProperty.ReadAsString("FieldValue");
            }
        };
        return RuleError;
    }(ComplexProperty));
    var RuleErrorCollection = (function (_super) {
        __extends(RuleErrorCollection, _super);
        function RuleErrorCollection() {
            _super.call(this);
        }
        RuleErrorCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            if (xmlElementName === "Error") {
                return new RuleError();
            }
            return null;
        };
        RuleErrorCollection.prototype.CreateDefaultComplexProperty = function () {
            return new RuleError();
        };
        RuleErrorCollection.prototype.GetCollectionItemXmlElementName = function (ruleValidationError) {
            return "Error";
        };
        return RuleErrorCollection;
    }(ComplexPropertyCollection));
    var TextBody = (function (_super) {
        __extends(TextBody, _super);
        function TextBody(text) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, BodyType.Text, text);
            this.constructor_1(text);
        }
        TextBody.prototype.constructor_0 = function () {
        };
        TextBody.prototype.constructor_1 = function (text) {
        };
        TextBody.op_Implicit = function (textBody) {
            return new TextBody(textBody);
        };
        return TextBody;
    }(MessageBody));
    var UrlEntity = (function (_super) {
        __extends(UrlEntity, _super);
        function UrlEntity() {
            _super.call(this);
            this.Url = null;
        }
        UrlEntity.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Url") {
                this.Url = reader.ReadElementValue();
                return true;
            }
            return _super.prototype.TryReadElementFromXml.call(this, reader);
        };
        return UrlEntity;
    }(ExtractedEntity));
    var UrlEntityCollection = (function (_super) {
        __extends(UrlEntityCollection, _super);
        function UrlEntityCollection(collection) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this);
            this.constructor_1(collection);
        }
        UrlEntityCollection.prototype.constructor_0 = function () {
        };
        UrlEntityCollection.prototype.constructor_1 = function (collection) {
            if (collection !== null) {
                EwsUtilities.ForEach(collection, _super.prototype.InternalAdd);
            }
        };
        UrlEntityCollection.prototype.CreateComplexProperty = function (xmlElementName) {
            return new UrlEntity();
        };
        UrlEntityCollection.prototype.CreateDefaultComplexProperty = function () {
            return new UrlEntity();
        };
        UrlEntityCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
            return "Url";
        };
        return UrlEntityCollection;
    }(ComplexPropertyCollection));
    var CalendarEvent = (function (_super) {
        __extends(CalendarEvent, _super);
        function CalendarEvent() {
            _super.call(this);
            this.startTime = null;
            this.endTime = null;
            this.freeBusyStatus = 0;
            this.details = null;
        }
        Object.defineProperty(CalendarEvent.prototype, "StartTime", {
            get: function () {
                return this.startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEvent.prototype, "EndTime", {
            get: function () {
                return this.endTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEvent.prototype, "FreeBusyStatus", {
            get: function () {
                return this.freeBusyStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEvent.prototype, "Details", {
            get: function () {
                return this.details;
            },
            enumerable: true,
            configurable: true
        });
        CalendarEvent.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "StartTime") {
                    this.startTime = reader.ReadElementValueAsUnbiasedDateTimeScopedToServiceTimeZone();
                    return true;
                }
                if (localName === "EndTime") {
                    this.endTime = reader.ReadElementValueAsUnbiasedDateTimeScopedToServiceTimeZone();
                    return true;
                }
                if (localName === "BusyType") {
                    this.freeBusyStatus = reader.ReadElementValue();
                    return true;
                }
                if (localName === "CalendarEventDetails") {
                    this.details = new CalendarEventDetails();
                    this.details.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        CalendarEvent.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "StartTime")) {
                            if (!(a === "EndTime")) {
                                if (!(a === "BusyType")) {
                                    if (a === "CalendarEventDetails") {
                                        this.details = new CalendarEventDetails();
                                        this.details.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                    }
                                }
                                else {
                                    this.freeBusyStatus = jsonProperty.ReadEnumValue(current);
                                }
                            }
                            else {
                                this.endTime = EwsUtilities.ParseAsUnbiasedDatetimescopedToServicetimeZone(jsonProperty.ReadAsString(current), service);
                            }
                        }
                        else {
                            this.startTime = EwsUtilities.ParseAsUnbiasedDatetimescopedToServicetimeZone(jsonProperty.ReadAsString(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return CalendarEvent;
    }(ComplexProperty));
    var CalendarEventDetails = (function (_super) {
        __extends(CalendarEventDetails, _super);
        function CalendarEventDetails() {
            _super.call(this);
            this.storeId = null;
            this.subject = null;
            this.location = null;
            this.isMeeting = false;
            this.isRecurring = false;
            this.isException = false;
            this.isReminderSet = false;
            this.isPrivate = false;
        }
        Object.defineProperty(CalendarEventDetails.prototype, "StoreId", {
            get: function () {
                return this.storeId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "Subject", {
            get: function () {
                return this.subject;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "Location", {
            get: function () {
                return this.location;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "IsMeeting", {
            get: function () {
                return this.isMeeting;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "IsRecurring", {
            get: function () {
                return this.isRecurring;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "IsException", {
            get: function () {
                return this.isException;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "IsReminderSet", {
            get: function () {
                return this.isReminderSet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarEventDetails.prototype, "IsPrivate", {
            get: function () {
                return this.isPrivate;
            },
            enumerable: true,
            configurable: true
        });
        CalendarEventDetails.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "ID":
                    this.storeId = reader.ReadElementValue();
                    return true;
                case "Subject":
                    this.subject = reader.ReadElementValue();
                    return true;
                case "Location":
                    this.location = reader.ReadElementValue();
                    return true;
                case "IsMeeting":
                    this.isMeeting = reader.ReadElementValue();
                    return true;
                case "IsRecurring":
                    this.isRecurring = reader.ReadElementValue();
                    return true;
                case "IsException":
                    this.isException = reader.ReadElementValue();
                    return true;
                case "IsReminderSet":
                    this.isReminderSet = reader.ReadElementValue();
                    return true;
                case "IsPrivate":
                    this.isPrivate = reader.ReadElementValue();
                    return true;
            }
            return false;
        };
        CalendarEventDetails.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "ID":
                            this.storeId = jsonProperty.ReadAsString(current);
                            break;
                        case "Subject":
                            this.subject = jsonProperty.ReadAsString(current);
                            break;
                        case "Location":
                            this.location = jsonProperty.ReadAsString(current);
                            break;
                        case "IsMeeting":
                            this.isMeeting = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsRecurring":
                            this.isRecurring = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsException":
                            this.isException = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsReminderSet":
                            this.isReminderSet = jsonProperty.ReadAsBool(current);
                            break;
                        case "IsPrivate":
                            this.isPrivate = jsonProperty.ReadAsBool(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return CalendarEventDetails;
    }(ComplexProperty));
    var Conflict = (function (_super) {
        __extends(Conflict, _super);
        function Conflict(conflictType) {
            _super.call(this);
            this.conflictType = 0;
            this.numberOfMembers = 0;
            this.numberOfMembersAvailable = 0;
            this.numberOfMembersWithConflict = 0;
            this.numberOfMembersWithNoData = 0;
            this.freeBusyStatus = 0;
            this.conflictType = conflictType;
        }
        Object.defineProperty(Conflict.prototype, "ConflictType", {
            get: function () {
                return this.conflictType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conflict.prototype, "NumberOfMembers", {
            get: function () {
                return this.numberOfMembers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conflict.prototype, "NumberOfMembersAvailable", {
            get: function () {
                return this.numberOfMembersAvailable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conflict.prototype, "NumberOfMembersWithConflict", {
            get: function () {
                return this.numberOfMembersWithConflict;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conflict.prototype, "NumberOfMembersWithNoData", {
            get: function () {
                return this.numberOfMembersWithNoData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Conflict.prototype, "FreeBusyStatus", {
            get: function () {
                return this.freeBusyStatus;
            },
            enumerable: true,
            configurable: true
        });
        Conflict.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "NumberOfMembers") {
                    this.numberOfMembers = reader.ReadElementValue();
                    return true;
                }
                if (localName === "NumberOfMembersAvailable") {
                    this.numberOfMembersAvailable = reader.ReadElementValue();
                    return true;
                }
                if (localName === "NumberOfMembersWithConflict") {
                    this.numberOfMembersWithConflict = reader.ReadElementValue();
                    return true;
                }
                if (localName === "NumberOfMembersWithNoData") {
                    this.numberOfMembersWithNoData = reader.ReadElementValue();
                    return true;
                }
                if (localName === "BusyType") {
                    this.freeBusyStatus = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        Conflict.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "NumberOfMembers")) {
                            if (!(a === "NumberOfMembersAvailable")) {
                                if (!(a === "NumberOfMembersWithConflict")) {
                                    if (!(a === "NumberOfMembersWithNoData")) {
                                        if (a === "BusyType") {
                                            this.freeBusyStatus = jsonProperty.ReadEnumValue(current);
                                        }
                                    }
                                    else {
                                        this.numberOfMembersWithNoData = jsonProperty.ReadAsInt(current);
                                    }
                                }
                                else {
                                    this.numberOfMembersWithConflict = jsonProperty.ReadAsInt(current);
                                }
                            }
                            else {
                                this.numberOfMembersAvailable = jsonProperty.ReadAsInt(current);
                            }
                        }
                        else {
                            this.numberOfMembers = jsonProperty.ReadAsInt(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return Conflict;
    }(ComplexProperty));
    var OofSettings = (function (_super) {
        __extends(OofSettings, _super);
        function OofSettings() {
            _super.call(this);
            this.state = 0;
            this.externalAudience = 0;
            this.allowExternalOof = 0;
            this.duration = null;
            this.internalReply = null;
            this.externalReply = null;
        }
        Object.defineProperty(OofSettings.prototype, "State", {
            get: function () {
                return this.state;
            },
            set: function (value) {
                this.state = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofSettings.prototype, "ExternalAudience", {
            get: function () {
                return this.externalAudience;
            },
            set: function (value) {
                this.externalAudience = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofSettings.prototype, "Duration", {
            get: function () {
                return this.duration;
            },
            set: function (value) {
                this.duration = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofSettings.prototype, "InternalReply", {
            get: function () {
                return this.internalReply;
            },
            set: function (value) {
                this.internalReply = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofSettings.prototype, "ExternalReply", {
            get: function () {
                return this.externalReply;
            },
            set: function (value) {
                this.externalReply = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofSettings.prototype, "AllowExternalOof", {
            get: function () {
                return this.allowExternalOof;
            },
            set: function (value) {
                this.allowExternalOof = value;
            },
            enumerable: true,
            configurable: true
        });
        OofSettings.prototype.SerializeOofReply = function (oofReply, writer, xmlElementName) {
            if (oofReply !== null) {
                oofReply.WriteToXml(writer, xmlElementName);
                return;
            }
            OofReply.WriteEmptyReplyToXml(writer, xmlElementName);
        };
        OofSettings.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "OofState") {
                    this.state = reader.ReadValue();
                    return true;
                }
                if (localName === "ExternalAudience") {
                    this.externalAudience = reader.ReadValue();
                    return true;
                }
                if (localName === "Duration") {
                    this.duration = new TimeWindow();
                    this.duration.LoadFromXml(reader);
                    return true;
                }
                if (localName === "InternalReply") {
                    this.internalReply = new OofReply();
                    this.internalReply.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "ExternalReply") {
                    this.externalReply = new OofReply();
                    this.externalReply.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        OofSettings.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "OofState")) {
                            if (!(a === "ExternalAudience")) {
                                if (!(a === "Duration")) {
                                    if (!(a === "InternalReply")) {
                                        if (a === "ExternalReply") {
                                            this.externalReply = new OofReply();
                                            this.externalReply.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                        }
                                    }
                                    else {
                                        this.internalReply = new OofReply();
                                        this.internalReply.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                    }
                                }
                                else {
                                    this.duration = new TimeWindow();
                                    this.duration.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                }
                            }
                            else {
                                this.externalAudience = jsonProperty.ReadEnumValue(current);
                            }
                        }
                        else {
                            this.state = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        OofSettings.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "OofState", this.State);
            writer.WriteElementValue(XmlNamespace.Types, "ExternalAudience", this.ExternalAudience);
            if (this.Duration !== null && this.State === OofState.Scheduled) {
                this.Duration.WriteToXml(writer, "Duration");
            }
            this.SerializeOofReply(this.InternalReply, writer, "InternalReply");
            this.SerializeOofReply(this.ExternalReply, writer, "ExternalReply");
        };
        OofSettings.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("OofState", this.State);
            jsonObject.Add("ExternalAudience", this.ExternalAudience);
            if (this.Duration !== null && this.State === OofState.Scheduled) {
                jsonObject.Add("Duration", this.Duration.InternalToJson(service));
            }
            if (this.InternalReply !== null) {
                jsonObject.Add("InternalReply", this.InternalReply.InternalToJson(service));
            }
            if (this.ExternalReply !== null) {
                jsonObject.Add("ExternalReply", this.ExternalReply.InternalToJson(service));
            }
            return jsonObject;
        };
        OofSettings.prototype.Validate = function () {
            if (this.State === OofState.Scheduled) {
                if (this.Duration === null) {
                    throw new ArgumentException(Strings.DurationMustBeSpecifiedWhenScheduled);
                }
                EwsUtilities.ValidateParam(this.Duration, "Duration");
            }
        };
        return OofSettings;
    }(ComplexProperty));
    var Suggestion = (function (_super) {
        __extends(Suggestion, _super);
        function Suggestion() {
            _super.call(this);
            this.date = null;
            this.quality = 0;
            this.timeSuggestions = new Collection();
        }
        Object.defineProperty(Suggestion.prototype, "Date", {
            get: function () {
                return this.date;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Suggestion.prototype, "Quality", {
            get: function () {
                return this.quality;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Suggestion.prototype, "TimeSuggestions", {
            get: function () {
                return this.timeSuggestions;
            },
            enumerable: true,
            configurable: true
        });
        Suggestion.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Date") {
                    var dateTime = DateTime.Parse(reader.ReadElementValue(), CultureInfo.InvariantCulture);
                    if (dateTime.Kind !== DateTimeKind.Unspecified) {
                        this.date = new DateTime(dateTime.Ticks, DateTimeKind.Unspecified);
                    }
                    else {
                        this.date = dateTime;
                    }
                    return true;
                }
                if (localName === "DayQuality") {
                    this.quality = reader.ReadElementValue();
                    return true;
                }
                if (localName === "SuggestionArray") {
                    if (!reader.IsEmptyElement) {
                        do {
                            reader.Read();
                            if (reader.IsStartElement(XmlNamespace.Types, "Suggestion")) {
                                var timeSuggestion = new TimeSuggestion();
                                timeSuggestion.LoadFromXml(reader, reader.LocalName);
                                this.timeSuggestions.Add(timeSuggestion);
                            }
                        } while (!reader.IsEndElement(XmlNamespace.Types, "SuggestionArray"));
                    }
                    return true;
                }
            }
            return false;
        };
        Suggestion.prototype.LoadFromJson = function (jsonProperty, service) {
            this.date = DateTime.Parse(jsonProperty.ReadAsString("Date"));
            this.quality = jsonProperty.ReadEnumValue("DayQuality");
            var array = jsonProperty.ReadAsArray("SuggestionArray");
            for (var i = 0; i < array.length; i = i + 1) {
                var obj = array[i];
                var timeSuggestion = new TimeSuggestion();
                timeSuggestion.LoadFromJson(((obj instanceof JsonObject) ? obj : null), service);
                this.timeSuggestions.Add(timeSuggestion);
            }
        };
        return Suggestion;
    }(ComplexProperty));
    var TimeSuggestion = (function (_super) {
        __extends(TimeSuggestion, _super);
        function TimeSuggestion() {
            _super.call(this);
            this.meetingTime = null;
            this.isWorkTime = false;
            this.quality = 0;
            this.conflicts = new Collection();
        }
        Object.defineProperty(TimeSuggestion.prototype, "MeetingTime", {
            get: function () {
                return this.meetingTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeSuggestion.prototype, "IsWorkTime", {
            get: function () {
                return this.isWorkTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeSuggestion.prototype, "Quality", {
            get: function () {
                return this.quality;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeSuggestion.prototype, "Conflicts", {
            get: function () {
                return this.conflicts;
            },
            enumerable: true,
            configurable: true
        });
        TimeSuggestion.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "MeetingTime") {
                    this.meetingTime = reader.ReadElementValueAsUnbiasedDateTimeScopedToServiceTimeZone();
                    return true;
                }
                if (localName === "IsWorkTime") {
                    this.isWorkTime = reader.ReadElementValue();
                    return true;
                }
                if (localName === "SuggestionQuality") {
                    this.quality = reader.ReadElementValue();
                    return true;
                }
                if (localName === "AttendeeConflictDataArray") {
                    if (!reader.IsEmptyElement) {
                        do {
                            var IL_126 = 1;
                            var _goto = 0;
                            _GOTO_LOOP: while (true) {
                                switch (_goto) {
                                    default:
                                        reader.Read();
                                        if (reader.IsStartElement()) {
                                            var conflict = null;
                                            var localName2;
                                            if ((localName2 = reader.LocalName) === null) {
                                                EwsUtilities.Assert(false, "TimeSuggestion.TryReadElementFromXml", NString.Format("The {0} element name does not map to any AttendeeConflict descendant.", reader.LocalName));
                                                conflict.LoadFromXml(reader, reader.LocalName);
                                                this.conflicts.Add(conflict);
                                                _goto = IL_126;
                                                continue _GOTO_LOOP;
                                            }
                                            if (!(localName2 === "UnknownAttendeeConflictData")) {
                                                if (!(localName2 === "TooBigGroupAttendeeConflictData")) {
                                                    if (!(localName2 === "IndividualAttendeeConflictData")) {
                                                        if (!(localName2 === "GroupAttendeeConflictData")) {
                                                            EwsUtilities.Assert(false, "TimeSuggestion.TryReadElementFromXml", NString.Format("The {0} element name does not map to any AttendeeConflict descendant.", reader.LocalName));
                                                            conflict.LoadFromXml(reader, reader.LocalName);
                                                            this.conflicts.Add(conflict);
                                                            _goto = IL_126;
                                                            continue _GOTO_LOOP;
                                                        }
                                                        conflict = new Conflict(ConflictType.GroupConflict);
                                                    }
                                                    else {
                                                        conflict = new Conflict(ConflictType.IndividualAttendeeConflict);
                                                    }
                                                }
                                                else {
                                                    conflict = new Conflict(ConflictType.GroupTooBigConflict);
                                                }
                                            }
                                            else {
                                                conflict = new Conflict(ConflictType.UnknownAttendeeConflict);
                                            }
                                            conflict.LoadFromXml(reader, reader.LocalName);
                                            this.conflicts.Add(conflict);
                                            _goto = IL_126;
                                            continue _GOTO_LOOP;
                                        }
                                        _goto = IL_126;
                                        continue _GOTO_LOOP;
                                    case 1:
                                        break _GOTO_LOOP;
                                }
                            }
                        } while (!reader.IsEndElement(XmlNamespace.Types, "AttendeeConflictDataArray"));
                    }
                    return true;
                }
            }
            return false;
        };
        TimeSuggestion.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "MeetingTime")) {
                            if (!(a === "IsWorkTime")) {
                                if (!(a === "SuggestionQuality")) {
                                    if (a === "AttendeeConflictDataArray") {
                                        var array = jsonProperty.ReadAsArray(current);
                                        var array2 = array;
                                        for (var i = 0; i < array2.length; i = i + 1) {
                                            var IL_163 = 1;
                                            var _goto = 0;
                                            _GOTO_LOOP: while (true) {
                                                switch (_goto) {
                                                    default:
                                                        var obj = array2[i];
                                                        var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                                                        if (jsonObject !== null) {
                                                            var conflict = null;
                                                            var a2;
                                                            if ((a2 = jsonObject.ReadTypeString()) === null) {
                                                                EwsUtilities.Assert(false, "TimeSuggestion.TryReadElementFromJson", NString.Format("The {0} element name does not map to any AttendeeConflict descendant.", jsonObject.ReadTypeString()));
                                                                conflict.LoadFromJson(jsonObject, service);
                                                                this.conflicts.Add(conflict);
                                                                _goto = IL_163;
                                                                continue _GOTO_LOOP;
                                                            }
                                                            if (!(a2 === "UnknownAttendeeConflictData")) {
                                                                if (!(a2 === "TooBigGroupAttendeeConflictData")) {
                                                                    if (!(a2 === "IndividualAttendeeConflictData")) {
                                                                        if (!(a2 === "GroupAttendeeConflictData")) {
                                                                            EwsUtilities.Assert(false, "TimeSuggestion.TryReadElementFromJson", NString.Format("The {0} element name does not map to any AttendeeConflict descendant.", jsonObject.ReadTypeString()));
                                                                            conflict.LoadFromJson(jsonObject, service);
                                                                            this.conflicts.Add(conflict);
                                                                            _goto = IL_163;
                                                                            continue _GOTO_LOOP;
                                                                        }
                                                                        conflict = new Conflict(ConflictType.GroupConflict);
                                                                    }
                                                                    else {
                                                                        conflict = new Conflict(ConflictType.IndividualAttendeeConflict);
                                                                    }
                                                                }
                                                                else {
                                                                    conflict = new Conflict(ConflictType.GroupTooBigConflict);
                                                                }
                                                            }
                                                            else {
                                                                conflict = new Conflict(ConflictType.UnknownAttendeeConflict);
                                                            }
                                                            conflict.LoadFromJson(jsonObject, service);
                                                            this.conflicts.Add(conflict);
                                                            _goto = IL_163;
                                                            continue _GOTO_LOOP;
                                                        }
                                                        _goto = IL_163;
                                                        continue _GOTO_LOOP;
                                                    case 1:
                                                        break _GOTO_LOOP;
                                                }
                                            }
                                        }
                                    }
                                }
                                else {
                                    this.quality = jsonProperty.ReadEnumValue(current);
                                }
                            }
                            else {
                                this.isWorkTime = jsonProperty.ReadAsBool(current);
                            }
                        }
                        else {
                            this.meetingTime = EwsUtilities.ParseAsUnbiasedDatetimescopedToServicetimeZone(jsonProperty.ReadAsString(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return TimeSuggestion;
    }(ComplexProperty));
    var WorkingHours = (function (_super) {
        __extends(WorkingHours, _super);
        function WorkingHours() {
            _super.call(this);
            this.timeZone = null;
            this.daysOfTheWeek = new Collection();
            this.startTime = null;
            this.endTime = null;
        }
        Object.defineProperty(WorkingHours.prototype, "TimeZone", {
            get: function () {
                return this.timeZone;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WorkingHours.prototype, "DaysOfTheWeek", {
            get: function () {
                return this.daysOfTheWeek;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WorkingHours.prototype, "StartTime", {
            get: function () {
                return this.startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WorkingHours.prototype, "EndTime", {
            get: function () {
                return this.endTime;
            },
            enumerable: true,
            configurable: true
        });
        WorkingHours.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "TimeZone") {
                    var legacyAvailabilityTimeZone = new LegacyAvailabilityTimeZone();
                    legacyAvailabilityTimeZone.LoadFromXml(reader, reader.LocalName);
                    this.timeZone = legacyAvailabilityTimeZone.ToTimeZoneInfo();
                    return true;
                }
                if (localName === "WorkingPeriodArray") {
                    var list = new List();
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "WorkingPeriod")) {
                            var workingPeriod = new WorkingPeriod();
                            workingPeriod.LoadFromXml(reader, reader.LocalName);
                            list.Add(workingPeriod);
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "WorkingPeriodArray"));
                    this.startTime = list.get_Item(0).StartTime;
                    this.endTime = list.get_Item(0).EndTime;
                    var enumerator = list.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var arg_C7_0 = enumerator.Current;
                            var enumerator2 = list.get_Item(0).DaysOfWeek.GetEnumerator();
                            try {
                                while (enumerator2.MoveNext()) {
                                    var current = enumerator2.Current;
                                    if (!this.daysOfTheWeek.Contains(current)) {
                                        this.daysOfTheWeek.Add(current);
                                    }
                                }
                            }
                            finally {
                                if (enumerator2 !== null) {
                                    enumerator2.Dispose();
                                }
                            }
                        }
                    }
                    finally {
                        enumerator.Dispose();
                    }
                    return true;
                }
            }
            return false;
        };
        WorkingHours.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "TimeZone")) {
                            if (a === "WorkingPeriodArray") {
                                var list = new List();
                                var array = jsonProperty.ReadAsArray(current);
                                var array2 = array;
                                for (var i = 0; i < array2.length; i = i + 1) {
                                    var obj = array2[i];
                                    var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                                    if (jsonObject !== null) {
                                        var workingPeriod = new WorkingPeriod();
                                        workingPeriod.LoadFromJson(jsonObject, service);
                                        list.Add(workingPeriod);
                                    }
                                }
                                this.startTime = list.get_Item(0).StartTime;
                                this.endTime = list.get_Item(0).EndTime;
                                var enumerator2 = list.GetEnumerator();
                                try {
                                    while (enumerator2.MoveNext()) {
                                        var arg_EF_0 = enumerator2.Current;
                                        var enumerator3 = list.get_Item(0).DaysOfWeek.GetEnumerator();
                                        try {
                                            while (enumerator3.MoveNext()) {
                                                var current2 = enumerator3.Current;
                                                if (!this.daysOfTheWeek.Contains(current2)) {
                                                    this.daysOfTheWeek.Add(current2);
                                                }
                                            }
                                        }
                                        finally {
                                            if (enumerator3 !== null) {
                                                enumerator3.Dispose();
                                            }
                                        }
                                    }
                                }
                                finally {
                                    enumerator2.Dispose();
                                }
                            }
                        }
                        else {
                            var legacyAvailabilityTimeZone = new LegacyAvailabilityTimeZone();
                            legacyAvailabilityTimeZone.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            this.timeZone = legacyAvailabilityTimeZone.ToTimeZoneInfo();
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return WorkingHours;
    }(ComplexProperty));
    var WorkingPeriod = (function (_super) {
        __extends(WorkingPeriod, _super);
        function WorkingPeriod() {
            _super.call(this);
            this.daysOfWeek = new Collection();
            this.startTime = null;
            this.endTime = null;
        }
        Object.defineProperty(WorkingPeriod.prototype, "DaysOfWeek", {
            get: function () {
                return this.daysOfWeek;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WorkingPeriod.prototype, "StartTime", {
            get: function () {
                return this.startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WorkingPeriod.prototype, "EndTime", {
            get: function () {
                return this.endTime;
            },
            enumerable: true,
            configurable: true
        });
        WorkingPeriod.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DayOfWeek") {
                    EwsUtilities.ParseEnumValueList(this.daysOfWeek, reader.ReadElementValue(), [
                        32
                    ] /*' '*/);
                    return true;
                }
                if (localName === "StartTimeInMinutes") {
                    this.startTime = TimeSpan.FromMinutes(reader.ReadElementValue());
                    return true;
                }
                if (localName === "EndTimeInMinutes") {
                    this.endTime = TimeSpan.FromMinutes(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        WorkingPeriod.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DayOfWeek")) {
                            if (!(a === "StartTimeInMinutes")) {
                                if (a === "EndTimeInMinutes") {
                                    this.endTime = TimeSpan.FromMinutes(jsonProperty.ReadAsInt(current));
                                }
                            }
                            else {
                                this.startTime = TimeSpan.FromMinutes(jsonProperty.ReadAsInt(current));
                            }
                        }
                        else {
                            EwsUtilities.ParseEnumValueList(this.daysOfWeek, jsonProperty.ReadAsString(current), [
                                32
                            ] /*' '*/);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return WorkingPeriod;
    }(ComplexProperty));
    var DayOfTheWeekCollection = (function (_super) {
        __extends(DayOfTheWeekCollection, _super);
        function DayOfTheWeekCollection() {
            _super.call(this);
            this.items = new List();
        }
        DayOfTheWeekCollection.prototype.get_Item = function (index) {
            return this.items.get_Item(index);
        };
        Object.defineProperty(DayOfTheWeekCollection.prototype, "Count", {
            get: function () {
                return this.items.Count;
            },
            enumerable: true,
            configurable: true
        });
        DayOfTheWeekCollection.prototype.ToString = function (separator) {
            if (arguments.length === 1 && (separator === null || separator.constructor === String)) {
                return this.ToString_0(separator);
            }
            return this.ToString_1();
        };
        DayOfTheWeekCollection.prototype.ToString_0 = function (separator) {
            if (this.Count === 0) {
                return NString.Empty;
            }
            var array = new Array(this.Count);
            for (var i = 0; i < this.Count; i = i + 1) {
                array[i] = this.get_Item(i).ToString();
            }
            return NString.Join(separator, array);
        };
        DayOfTheWeekCollection.prototype.LoadFromXml = function (reader, xmlElementName) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, xmlElementName);
            EwsUtilities.ParseEnumValueList(this.items, reader.ReadElementValue(), [
                32
            ] /*' '*/);
        };
        DayOfTheWeekCollection.prototype.LoadFromJson = function (jsonProperty, service) {
            throw new InvalidOperationException();
        };
        DayOfTheWeekCollection.prototype.LoadFromJsonValue = function (jsonValue) {
            EwsUtilities.ParseEnumValueList(this.items, jsonValue, [
                32
            ] /*' '*/);
        };
        DayOfTheWeekCollection.prototype.WriteToXml = function (writer, xmlElementName) {
            var value = this.ToString(" ");
            if (!NString.IsNullOrEmpty(value)) {
                writer.WriteElementValue(XmlNamespace.Types, "DaysOfWeek", value);
            }
        };
        DayOfTheWeekCollection.prototype.InternalToJson = function (service) {
            return this.ToString(" ");
        };
        DayOfTheWeekCollection.prototype.ToString_1 = function () {
            return this.ToString(",");
        };
        DayOfTheWeekCollection.prototype.Add = function (dayOfTheWeek) {
            if (!this.items.Contains(dayOfTheWeek)) {
                this.items.Add(dayOfTheWeek);
                this.Changed();
            }
        };
        DayOfTheWeekCollection.prototype.AddRange = function (daysOfTheWeek) {
            var enumerator = daysOfTheWeek.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        DayOfTheWeekCollection.prototype.Clear = function () {
            if (this.Count > 0) {
                this.items.Clear();
                this.Changed();
            }
        };
        DayOfTheWeekCollection.prototype.Remove = function (dayOfTheWeek) {
            var flag = this.items.Remove(dayOfTheWeek);
            if (flag) {
                this.Changed();
            }
            return flag;
        };
        DayOfTheWeekCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            this.items.RemoveAt(index);
            this.Changed();
        };
        DayOfTheWeekCollection.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        return DayOfTheWeekCollection;
    }(ComplexProperty));
    var Recurrence = (function (_super) {
        __extends(Recurrence, _super);
        function Recurrence(startDate) {
            _super.call(this);
            this.startDate = null;
            this.numberOfOccurrences = null;
            this.endDate = null;
            this.XmlElementName = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate);
        }
        Object.defineProperty(Recurrence.prototype, "IsRegenerationPattern", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence.prototype, "StartDate", {
            get: function () {
                return this.GetFieldValueOrThrowIfNull(this.startDate, "StartDate");
            },
            set: function (value) {
                this.startDate = new Nullable(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence.prototype, "HasEnd", {
            get: function () {
                return this.numberOfOccurrences !== null || this.endDate !== null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence.prototype, "NumberOfOccurrences", {
            get: function () {
                return this.numberOfOccurrences;
            },
            set: function (value) {
                var _this = this;
                if (value < 1) {
                    throw new ArgumentException(Strings.NumberOfOccurrencesMustBeGreaterThanZero);
                }
                (function () {
                    var _p0 = [
                        _this.numberOfOccurrences
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.numberOfOccurrences = _p0[0];
                    return _r;
                })();
                this.endDate = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence.prototype, "EndDate", {
            get: function () {
                return this.endDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.endDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.endDate = _p0[0];
                    return _r;
                })();
                this.numberOfOccurrences = null;
            },
            enumerable: true,
            configurable: true
        });
        Recurrence.prototype.constructor_0 = function () {
        };
        Recurrence.prototype.constructor_1 = function (startDate) {
            this.constructor_0();
            this.startDate = new Nullable(startDate);
        };
        Recurrence.prototype.InternalWritePropertiesToXml = function (writer) {
        };
        Recurrence.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.XmlElementName);
            this.InternalWritePropertiesToXml(writer);
            writer.WriteEndElement();
            var recurrenceRange;
            if (!this.HasEnd) {
                recurrenceRange = new NoEndRecurrenceRange(this.StartDate);
            }
            else {
                if (this.NumberOfOccurrences !== null) {
                    recurrenceRange = new NumberedRecurrenceRange(this.StartDate, this.NumberOfOccurrences);
                }
                else {
                    recurrenceRange = new EndDateRecurrenceRange(this.StartDate, this.EndDate.Value);
                }
            }
            recurrenceRange.WriteToXml(writer, recurrenceRange.XmlElementName);
        };
        Recurrence.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("RecurrencePattern", this.PatternToJson(service));
            jsonObject.Add("RecurrenceRange", this.RangeToJson(service));
            return jsonObject;
        };
        Recurrence.prototype.RangeToJson = function (service) {
            var recurrenceRange;
            if (!this.HasEnd) {
                recurrenceRange = new NoEndRecurrenceRange(this.StartDate);
            }
            else {
                if (this.NumberOfOccurrences !== null) {
                    recurrenceRange = new NumberedRecurrenceRange(this.StartDate, this.NumberOfOccurrences);
                }
                else {
                    recurrenceRange = new EndDateRecurrenceRange(this.StartDate, this.EndDate.Value);
                }
            }
            return recurrenceRange.InternalToJson(service);
        };
        Recurrence.prototype.PatternToJson = function (service) {
            throw new NotSupportedException();
        };
        Recurrence.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
        };
        Recurrence.prototype.GetFieldValueOrThrowIfNull = function (value, name) {
            if (value !== null) {
                return value.Value;
            }
            throw new ServiceValidationException(NString.Format(Strings.PropertyValueMustBeSpecifiedForRecurrencePattern, name));
        };
        Recurrence.prototype.NeverEnds = function () {
            this.numberOfOccurrences = null;
            this.endDate = null;
            this.Changed();
        };
        Recurrence.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (!(this.startDate !== null)) {
                throw new ServiceValidationException(Strings.RecurrencePatternMustHaveStartDate);
            }
        };
        Recurrence.prototype.IsSame = function (otherRecurrence) {
            if (otherRecurrence === null) {
                return false;
            }
            var memoryStream = new MemoryStream();
            var a;
            try {
                this.InternalToJson(null).SerializeToJson(memoryStream);
                memoryStream.Position = 0;
                var streamReader = new StreamReader(memoryStream);
                try {
                    a = streamReader.ReadToEnd();
                }
                finally {
                    if (streamReader !== null) {
                        streamReader.Dispose();
                    }
                }
            }
            finally {
                if (memoryStream !== null) {
                    memoryStream.Dispose();
                }
            }
            var memoryStream2 = new MemoryStream();
            var b;
            try {
                otherRecurrence.InternalToJson(null).SerializeToJson(memoryStream2);
                memoryStream2.Position = 0;
                var streamReader2 = new StreamReader(memoryStream2);
                try {
                    b = streamReader2.ReadToEnd();
                }
                finally {
                    if (streamReader2 !== null) {
                        streamReader2.Dispose();
                    }
                }
            }
            finally {
                if (memoryStream2 !== null) {
                    memoryStream2.Dispose();
                }
            }
            return NString.Equals(a, b, StringComparison.Ordinal);
        };
        return Recurrence;
    }(ComplexProperty));
    var Recurrence_IntervalPattern = (function (_super) {
        __extends(Recurrence_IntervalPattern, _super);
        function Recurrence_IntervalPattern(startDate, interval) {
            _super.call(this);
            this.interval = 1;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_IntervalPattern.prototype, "Interval", {
            get: function () {
                return this.interval;
            },
            set: function (value) {
                var _this = this;
                if (value < 1) {
                    throw new ArgumentOutOfRangeException("value", Strings.IntervalMustBeGreaterOrEqualToOne);
                }
                (function () {
                    var _p0 = [
                        _this.interval
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.interval = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_IntervalPattern.prototype.constructor_0 = function () {
        };
        Recurrence_IntervalPattern.prototype.constructor_1 = function (startDate, interval) {
            if (interval < 1) {
                throw new ArgumentOutOfRangeException("interval", Strings.IntervalMustBeGreaterOrEqualToOne);
            }
            this.Interval = interval;
        };
        Recurrence_IntervalPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "Interval", this.Interval);
        };
        Recurrence_IntervalPattern.prototype.PatternToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.XmlElementName);
            jsonObject.Add("Interval", this.Interval);
            return jsonObject;
        };
        Recurrence_IntervalPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "Interval") {
                this.interval = reader.ReadElementValue();
                return true;
            }
            return false;
        };
        Recurrence_IntervalPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "Interval") {
                        this.interval = jsonProperty.ReadAsInt(current);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return Recurrence_IntervalPattern;
    }(Recurrence));
    var Recurrence_YearlyRegenerationPattern = (function (_super) {
        __extends(Recurrence_YearlyRegenerationPattern, _super);
        function Recurrence_YearlyRegenerationPattern(startDate, interval) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate, interval);
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_YearlyRegenerationPattern.prototype, "XmlElementName", {
            get: function () {
                return "YearlyRegeneration";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_YearlyRegenerationPattern.prototype, "IsRegenerationPattern", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_YearlyRegenerationPattern.prototype.constructor_0 = function () {
        };
        Recurrence_YearlyRegenerationPattern.prototype.constructor_1 = function (startDate, interval) {
        };
        return Recurrence_YearlyRegenerationPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_YearlyPattern = (function (_super) {
        __extends(Recurrence_YearlyPattern, _super);
        function Recurrence_YearlyPattern(startDate, month, dayOfMonth) {
            _super.call(this);
            this.month = null;
            this.dayOfMonth = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, month, dayOfMonth);
        }
        Object.defineProperty(Recurrence_YearlyPattern.prototype, "XmlElementName", {
            get: function () {
                return "AbsoluteYearlyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_YearlyPattern.prototype, "Month", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.month, "Month");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.month
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.month = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_YearlyPattern.prototype, "DayOfMonth", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfMonth, "DayOfMonth");
            },
            set: function (value) {
                var _this = this;
                if (value < 1 || value > 31) {
                    throw new ArgumentOutOfRangeException("DayOfMonth", Strings.DayOfMonthMustBeBetween1And31);
                }
                (function () {
                    var _p0 = [
                        _this.dayOfMonth
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfMonth = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_YearlyPattern.prototype.constructor_0 = function () {
        };
        Recurrence_YearlyPattern.prototype.constructor_1 = function (startDate, month, dayOfMonth) {
            this.Month = month;
            this.DayOfMonth = dayOfMonth;
        };
        Recurrence_YearlyPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DayOfMonth", this.DayOfMonth);
            writer.WriteElementValue(XmlNamespace.Types, "Month", this.Month);
        };
        Recurrence_YearlyPattern.prototype.PatternToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.XmlElementName);
            jsonObject.Add("DayOfMonth", this.DayOfMonth);
            jsonObject.Add("Month", this.Month);
            return jsonObject;
        };
        Recurrence_YearlyPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DayOfMonth") {
                    this.dayOfMonth = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "Month") {
                    this.month = new Nullable(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        Recurrence_YearlyPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DayOfMonth")) {
                            if (a === "Month") {
                                this.month = new Nullable(jsonProperty.ReadEnumValue(current));
                            }
                        }
                        else {
                            this.dayOfMonth = new Nullable(jsonProperty.ReadAsInt(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Recurrence_YearlyPattern.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (!(this.month !== null)) {
                throw new ServiceValidationException(Strings.MonthMustBeSpecifiedForRecurrencePattern);
            }
            if (!(this.dayOfMonth !== null)) {
                throw new ServiceValidationException(Strings.DayOfMonthMustBeSpecifiedForRecurrencePattern);
            }
        };
        return Recurrence_YearlyPattern;
    }(Recurrence));
    var Recurrence_WeeklyRegenerationPattern = (function (_super) {
        __extends(Recurrence_WeeklyRegenerationPattern, _super);
        function Recurrence_WeeklyRegenerationPattern(startDate, interval) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate, interval);
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_WeeklyRegenerationPattern.prototype, "XmlElementName", {
            get: function () {
                return "WeeklyRegeneration";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_WeeklyRegenerationPattern.prototype, "IsRegenerationPattern", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_WeeklyRegenerationPattern.prototype.constructor_0 = function () {
        };
        Recurrence_WeeklyRegenerationPattern.prototype.constructor_1 = function (startDate, interval) {
        };
        return Recurrence_WeeklyRegenerationPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_WeeklyPattern = (function (_super) {
        __extends(Recurrence_WeeklyPattern, _super);
        function Recurrence_WeeklyPattern(startDate, interval, daysOfTheWeek) {
            _super.call(this);
            this.daysOfTheWeek = new DayOfTheWeekCollection();
            this.firstDayOfWeek = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, interval, daysOfTheWeek);
        }
        Object.defineProperty(Recurrence_WeeklyPattern.prototype, "XmlElementName", {
            get: function () {
                return "WeeklyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_WeeklyPattern.prototype, "DaysOfTheWeek", {
            get: function () {
                return this.daysOfTheWeek;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_WeeklyPattern.prototype, "FirstDayOfWeek", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.firstDayOfWeek, "FirstDayOfWeek");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.firstDayOfWeek
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.firstDayOfWeek = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_WeeklyPattern.prototype.constructor_0 = function () {
            this.daysOfTheWeek.OnChange.Add(this.DaysOfTheWeekChanged);
        };
        Recurrence_WeeklyPattern.prototype.constructor_1 = function (startDate, interval, daysOfTheWeek) {
            this.daysOfTheWeek.AddRange(NArray.ToEnumerable(daysOfTheWeek));
        };
        Recurrence_WeeklyPattern.prototype.DaysOfTheWeekChanged = function (complexProperty) {
            this.Changed();
        };
        Recurrence_WeeklyPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            this.DaysOfTheWeek.WriteToXml(writer, "DaysOfWeek");
            if (this.firstDayOfWeek !== null) {
                EwsUtilities.ValidatePropertyVersion(writer.Service, ExchangeVersion.Exchange2010_SP1, "FirstDayOfWeek");
                writer.WriteElementValue(XmlNamespace.Types, "FirstDayOfWeek", this.firstDayOfWeek.Value);
            }
        };
        Recurrence_WeeklyPattern.prototype.PatternToJson = function (service) {
            var jsonObject = _super.prototype.PatternToJson.call(this, service);
            jsonObject.Add("DayOfWeek", this.DaysOfTheWeek.InternalToJson(service));
            if (this.firstDayOfWeek !== null) {
                EwsUtilities.ValidatePropertyVersion(service, ExchangeVersion.Exchange2010_SP1, "FirstDayOfWeek");
                jsonObject.Add("FirstDayOfWeek", this.firstDayOfWeek.Value);
            }
            return jsonObject;
        };
        Recurrence_WeeklyPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DaysOfWeek") {
                    this.DaysOfTheWeek.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "FirstDayOfWeek") {
                    this.FirstDayOfWeek = reader.ReadElementValue(XmlNamespace.Types, "FirstDayOfWeek");
                    return true;
                }
            }
            return false;
        };
        Recurrence_WeeklyPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DaysOfWeek")) {
                            if (a === "FirstDayOfWeek") {
                                this.FirstDayOfWeek = jsonProperty.ReadEnumValue(current);
                            }
                        }
                        else {
                            this.DaysOfTheWeek.LoadFromJsonValue(jsonProperty.ReadAsString(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Recurrence_WeeklyPattern.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (this.DaysOfTheWeek.Count === 0) {
                throw new ServiceValidationException(Strings.DaysOfTheWeekNotSpecified);
            }
        };
        return Recurrence_WeeklyPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_RelativeYearlyPattern = (function (_super) {
        __extends(Recurrence_RelativeYearlyPattern, _super);
        function Recurrence_RelativeYearlyPattern(startDate, month, dayOfTheWeek, dayOfTheWeekIndex) {
            _super.call(this);
            this.dayOfTheWeek = null;
            this.dayOfTheWeekIndex = null;
            this.month = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, month, dayOfTheWeek, dayOfTheWeekIndex);
        }
        Object.defineProperty(Recurrence_RelativeYearlyPattern.prototype, "XmlElementName", {
            get: function () {
                return "RelativeYearlyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_RelativeYearlyPattern.prototype, "DayOfTheWeekIndex", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfTheWeekIndex, "DayOfTheWeekIndex");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeekIndex
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfTheWeekIndex = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_RelativeYearlyPattern.prototype, "DayOfTheWeek", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfTheWeek, "DayOfTheWeek");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeek
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfTheWeek = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_RelativeYearlyPattern.prototype, "Month", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.month, "Month");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.month
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.month = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_RelativeYearlyPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DaysOfWeek", this.DayOfTheWeek);
            writer.WriteElementValue(XmlNamespace.Types, "DayOfWeekIndex", this.DayOfTheWeekIndex);
            writer.WriteElementValue(XmlNamespace.Types, "Month", this.Month);
        };
        Recurrence_RelativeYearlyPattern.prototype.PatternToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.XmlElementName);
            jsonObject.Add("DaysOfWeek", this.DayOfTheWeek);
            jsonObject.Add("DayOfWeekIndex", this.DayOfTheWeekIndex);
            jsonObject.Add("Month", this.Month);
            return jsonObject;
        };
        Recurrence_RelativeYearlyPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DaysOfWeek") {
                    this.dayOfTheWeek = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "DayOfWeekIndex") {
                    this.dayOfTheWeekIndex = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "Month") {
                    this.month = new Nullable(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        Recurrence_RelativeYearlyPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DaysOfWeek")) {
                            if (!(a === "DayOfWeekIndex")) {
                                if (a === "Month") {
                                    this.month = new Nullable(jsonProperty.ReadEnumValue(current));
                                }
                            }
                            else {
                                this.dayOfTheWeekIndex = new Nullable(jsonProperty.ReadEnumValue(current));
                            }
                        }
                        else {
                            this.dayOfTheWeek = new Nullable(jsonProperty.ReadEnumValue(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Recurrence_RelativeYearlyPattern.prototype.constructor_0 = function () {
        };
        Recurrence_RelativeYearlyPattern.prototype.constructor_1 = function (startDate, month, dayOfTheWeek, dayOfTheWeekIndex) {
            this.Month = month;
            this.DayOfTheWeek = dayOfTheWeek;
            this.DayOfTheWeekIndex = dayOfTheWeekIndex;
        };
        Recurrence_RelativeYearlyPattern.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (!(this.dayOfTheWeekIndex !== null)) {
                throw new ServiceValidationException(Strings.DayOfWeekIndexMustBeSpecifiedForRecurrencePattern);
            }
            if (!(this.dayOfTheWeek !== null)) {
                throw new ServiceValidationException(Strings.DayOfTheWeekMustBeSpecifiedForRecurrencePattern);
            }
            if (!(this.month !== null)) {
                throw new ServiceValidationException(Strings.MonthMustBeSpecifiedForRecurrencePattern);
            }
        };
        return Recurrence_RelativeYearlyPattern;
    }(Recurrence));
    var Recurrence_RelativeMonthlyPattern = (function (_super) {
        __extends(Recurrence_RelativeMonthlyPattern, _super);
        function Recurrence_RelativeMonthlyPattern(startDate, interval, dayOfTheWeek, dayOfTheWeekIndex) {
            _super.call(this);
            this.dayOfTheWeek = null;
            this.dayOfTheWeekIndex = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, interval, dayOfTheWeek, dayOfTheWeekIndex);
        }
        Object.defineProperty(Recurrence_RelativeMonthlyPattern.prototype, "XmlElementName", {
            get: function () {
                return "RelativeMonthlyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_RelativeMonthlyPattern.prototype, "DayOfTheWeekIndex", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfTheWeekIndex, "DayOfTheWeekIndex");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeekIndex
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfTheWeekIndex = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_RelativeMonthlyPattern.prototype, "DayOfTheWeek", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfTheWeek, "DayOfTheWeek");
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.dayOfTheWeek
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfTheWeek = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_RelativeMonthlyPattern.prototype.constructor_0 = function () {
        };
        Recurrence_RelativeMonthlyPattern.prototype.constructor_1 = function (startDate, interval, dayOfTheWeek, dayOfTheWeekIndex) {
            this.DayOfTheWeek = dayOfTheWeek;
            this.DayOfTheWeekIndex = dayOfTheWeekIndex;
        };
        Recurrence_RelativeMonthlyPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DaysOfWeek", this.DayOfTheWeek);
            writer.WriteElementValue(XmlNamespace.Types, "DayOfWeekIndex", this.DayOfTheWeekIndex);
        };
        Recurrence_RelativeMonthlyPattern.prototype.PatternToJson = function (service) {
            var jsonObject = _super.prototype.PatternToJson.call(this, service);
            jsonObject.Add("DaysOfWeek", this.DayOfTheWeek);
            jsonObject.Add("DayOfWeekIndex", this.DayOfTheWeekIndex);
            return jsonObject;
        };
        Recurrence_RelativeMonthlyPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DaysOfWeek") {
                    this.dayOfTheWeek = new Nullable(reader.ReadElementValue());
                    return true;
                }
                if (localName === "DayOfWeekIndex") {
                    this.dayOfTheWeekIndex = new Nullable(reader.ReadElementValue());
                    return true;
                }
            }
            return false;
        };
        Recurrence_RelativeMonthlyPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "DaysOfWeek")) {
                            if (a === "DayOfWeekIndex") {
                                this.dayOfTheWeekIndex = new Nullable(jsonProperty.ReadEnumValue(current));
                            }
                        }
                        else {
                            this.dayOfTheWeek = new Nullable(jsonProperty.ReadEnumValue(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Recurrence_RelativeMonthlyPattern.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (!(this.dayOfTheWeek !== null)) {
                throw new ServiceValidationException(Strings.DayOfTheWeekMustBeSpecifiedForRecurrencePattern);
            }
            if (!(this.dayOfTheWeekIndex !== null)) {
                throw new ServiceValidationException(Strings.DayOfWeekIndexMustBeSpecifiedForRecurrencePattern);
            }
        };
        return Recurrence_RelativeMonthlyPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_MonthlyRegenerationPattern = (function (_super) {
        __extends(Recurrence_MonthlyRegenerationPattern, _super);
        function Recurrence_MonthlyRegenerationPattern(startDate, interval) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate, interval);
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_MonthlyRegenerationPattern.prototype, "XmlElementName", {
            get: function () {
                return "MonthlyRegeneration";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_MonthlyRegenerationPattern.prototype, "IsRegenerationPattern", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_MonthlyRegenerationPattern.prototype.constructor_0 = function () {
        };
        Recurrence_MonthlyRegenerationPattern.prototype.constructor_1 = function (startDate, interval) {
        };
        return Recurrence_MonthlyRegenerationPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_MonthlyPattern = (function (_super) {
        __extends(Recurrence_MonthlyPattern, _super);
        function Recurrence_MonthlyPattern(startDate, interval, dayOfMonth) {
            _super.call(this);
            this.dayOfMonth = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, interval, dayOfMonth);
        }
        Object.defineProperty(Recurrence_MonthlyPattern.prototype, "XmlElementName", {
            get: function () {
                return "AbsoluteMonthlyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_MonthlyPattern.prototype, "DayOfMonth", {
            get: function () {
                return _super.prototype.GetFieldValueOrThrowIfNull.call(this, this.dayOfMonth, "DayOfMonth");
            },
            set: function (value) {
                var _this = this;
                if (value < 1 || value > 31) {
                    throw new ArgumentOutOfRangeException("DayOfMonth", Strings.DayOfMonthMustBeBetween1And31);
                }
                (function () {
                    var _p0 = [
                        _this.dayOfMonth
                    ];
                    var _r = _this.SetFieldValue(_p0, new Nullable(value));
                    _this.dayOfMonth = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_MonthlyPattern.prototype.constructor_0 = function () {
        };
        Recurrence_MonthlyPattern.prototype.constructor_1 = function (startDate, interval, dayOfMonth) {
            this.DayOfMonth = dayOfMonth;
        };
        Recurrence_MonthlyPattern.prototype.InternalWritePropertiesToXml = function (writer) {
            _super.prototype.InternalWritePropertiesToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DayOfMonth", this.DayOfMonth);
        };
        Recurrence_MonthlyPattern.prototype.PatternToJson = function (service) {
            var jsonObject = _super.prototype.PatternToJson.call(this, service);
            jsonObject.Add("DayOfMonth", this.DayOfMonth);
            return jsonObject;
        };
        Recurrence_MonthlyPattern.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "DayOfMonth") {
                this.dayOfMonth = new Nullable(reader.ReadElementValue());
                return true;
            }
            return false;
        };
        Recurrence_MonthlyPattern.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "DayOfMonth") {
                        this.dayOfMonth = new Nullable(jsonProperty.ReadAsInt(current));
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        Recurrence_MonthlyPattern.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (!(this.dayOfMonth !== null)) {
                throw new ServiceValidationException(Strings.DayOfMonthMustBeBetween1And31);
            }
        };
        return Recurrence_MonthlyPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_DailyRegenerationPattern = (function (_super) {
        __extends(Recurrence_DailyRegenerationPattern, _super);
        function Recurrence_DailyRegenerationPattern(startDate, interval) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate, interval);
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_DailyRegenerationPattern.prototype, "XmlElementName", {
            get: function () {
                return "DailyRegeneration";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Recurrence_DailyRegenerationPattern.prototype, "IsRegenerationPattern", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_DailyRegenerationPattern.prototype.constructor_0 = function () {
        };
        Recurrence_DailyRegenerationPattern.prototype.constructor_1 = function (startDate, interval) {
        };
        return Recurrence_DailyRegenerationPattern;
    }(Recurrence_IntervalPattern));
    var Recurrence_DailyPattern = (function (_super) {
        __extends(Recurrence_DailyPattern, _super);
        function Recurrence_DailyPattern(startDate, interval) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate, interval);
            this.constructor_1(startDate, interval);
        }
        Object.defineProperty(Recurrence_DailyPattern.prototype, "XmlElementName", {
            get: function () {
                return "DailyRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Recurrence_DailyPattern.prototype.constructor_0 = function () {
        };
        Recurrence_DailyPattern.prototype.constructor_1 = function (startDate, interval) {
        };
        return Recurrence_DailyPattern;
    }(Recurrence_IntervalPattern));
    var RecurrenceRange = (function (_super) {
        __extends(RecurrenceRange, _super);
        function RecurrenceRange(startDate) {
            _super.call(this);
            this.startDate = null;
            this.recurrence = null;
            this.XmlElementName = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate);
        }
        Object.defineProperty(RecurrenceRange.prototype, "Recurrence", {
            get: function () {
                return this.recurrence;
            },
            set: function (value) {
                this.recurrence = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RecurrenceRange.prototype, "StartDate", {
            get: function () {
                return this.startDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.startDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.startDate = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        RecurrenceRange.prototype.constructor_0 = function () {
        };
        RecurrenceRange.prototype.constructor_1 = function (startDate) {
            this.constructor_0();
            this.startDate = startDate;
        };
        RecurrenceRange.prototype.Changed = function () {
            if (this.Recurrence !== null) {
                this.Recurrence.Changed();
            }
        };
        RecurrenceRange.prototype.SetupRecurrence = function (recurrence) {
            recurrence.StartDate = this.StartDate;
        };
        RecurrenceRange.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "StartDate", EwsUtilities.DateTimeToXSDate(this.StartDate));
        };
        RecurrenceRange.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            this.AddPropertiesToJson(jsonObject, service);
            return jsonObject;
        };
        RecurrenceRange.prototype.AddPropertiesToJson = function (jsonProperty, service) {
            jsonProperty.AddTypeParameter(this.XmlElementName);
            jsonProperty.Add("StartDate", EwsUtilities.DateTimeToXSDate(this.StartDate));
        };
        RecurrenceRange.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) === null || !(localName === "StartDate")) {
                return false;
            }
            var dateTime = reader.ReadElementValueAsUnspecifiedDate();
            if (dateTime !== null) {
                this.startDate = dateTime.Value;
                return true;
            }
            return false;
        };
        RecurrenceRange.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "StartDate") {
                        var dateTime = service.ConvertStartDateToUnspecifiedDateTime(jsonProperty.ReadAsString(current));
                        if (dateTime !== null) {
                            this.startDate = dateTime.Value;
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return RecurrenceRange;
    }(ComplexProperty));
    var EndDateRecurrenceRange = (function (_super) {
        __extends(EndDateRecurrenceRange, _super);
        function EndDateRecurrenceRange(startDate, endDate) {
            _super.call(this);
            this.endDate = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, endDate);
        }
        Object.defineProperty(EndDateRecurrenceRange.prototype, "XmlElementName", {
            get: function () {
                return "EndDateRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EndDateRecurrenceRange.prototype, "EndDate", {
            get: function () {
                return this.endDate;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.endDate
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.endDate = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        EndDateRecurrenceRange.prototype.constructor_0 = function () {
        };
        EndDateRecurrenceRange.prototype.constructor_1 = function (startDate, endDate) {
            this.endDate = endDate;
        };
        EndDateRecurrenceRange.prototype.SetupRecurrence = function (recurrence) {
            _super.prototype.SetupRecurrence.call(this, recurrence);
            recurrence.EndDate = new Nullable(this.EndDate);
        };
        EndDateRecurrenceRange.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "EndDate", EwsUtilities.DateTimeToXSDate(this.EndDate));
        };
        EndDateRecurrenceRange.prototype.AddPropertiesToJson = function (jsonProperty, service) {
            _super.prototype.AddPropertiesToJson.call(this, jsonProperty, service);
            jsonProperty.Add("EndDate", EwsUtilities.DateTimeToXSDate(this.EndDate));
        };
        EndDateRecurrenceRange.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "EndDate") {
                this.endDate = reader.ReadElementValueAsDateTime().Value;
                return true;
            }
            return false;
        };
        EndDateRecurrenceRange.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "EndDate") {
                        this.endDate = service.ConvertStartDateToUnspecifiedDateTime(jsonProperty.ReadAsString(current)).Value;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return EndDateRecurrenceRange;
    }(RecurrenceRange));
    var NoEndRecurrenceRange = (function (_super) {
        __extends(NoEndRecurrenceRange, _super);
        function NoEndRecurrenceRange(startDate) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, startDate);
            this.constructor_1(startDate);
        }
        Object.defineProperty(NoEndRecurrenceRange.prototype, "XmlElementName", {
            get: function () {
                return "NoEndRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        NoEndRecurrenceRange.prototype.constructor_0 = function () {
        };
        NoEndRecurrenceRange.prototype.constructor_1 = function (startDate) {
        };
        NoEndRecurrenceRange.prototype.SetupRecurrence = function (recurrence) {
            _super.prototype.SetupRecurrence.call(this, recurrence);
            recurrence.NeverEnds();
        };
        return NoEndRecurrenceRange;
    }(RecurrenceRange));
    var NumberedRecurrenceRange = (function (_super) {
        __extends(NumberedRecurrenceRange, _super);
        function NumberedRecurrenceRange(startDate, numberOfOccurrences) {
            _super.call(this);
            this.numberOfOccurrences = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startDate, numberOfOccurrences);
        }
        Object.defineProperty(NumberedRecurrenceRange.prototype, "XmlElementName", {
            get: function () {
                return "NumberedRecurrence";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NumberedRecurrenceRange.prototype, "NumberOfOccurrences", {
            get: function () {
                return this.numberOfOccurrences;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.numberOfOccurrences
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.numberOfOccurrences = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        NumberedRecurrenceRange.prototype.constructor_0 = function () {
        };
        NumberedRecurrenceRange.prototype.constructor_1 = function (startDate, numberOfOccurrences) {
            this.numberOfOccurrences = numberOfOccurrences;
        };
        NumberedRecurrenceRange.prototype.SetupRecurrence = function (recurrence) {
            _super.prototype.SetupRecurrence.call(this, recurrence);
            recurrence.NumberOfOccurrences = this.NumberOfOccurrences;
        };
        NumberedRecurrenceRange.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            if (this.NumberOfOccurrences !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "NumberOfOccurrences", this.NumberOfOccurrences);
            }
        };
        NumberedRecurrenceRange.prototype.AddPropertiesToJson = function (jsonProperty, service) {
            _super.prototype.AddPropertiesToJson.call(this, jsonProperty, service);
            jsonProperty.Add("NumberOfOccurrences", this.NumberOfOccurrences);
        };
        NumberedRecurrenceRange.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "NumberOfOccurrences") {
                this.numberOfOccurrences = new Nullable(reader.ReadElementValue());
                return true;
            }
            return false;
        };
        NumberedRecurrenceRange.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "NumberOfOccurrences") {
                        this.numberOfOccurrences = new Nullable(jsonProperty.ReadAsInt(current));
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return NumberedRecurrenceRange;
    }(RecurrenceRange));
    var TimeZoneTransition = (function (_super) {
        __extends(TimeZoneTransition, _super);
        function TimeZoneTransition(timeZoneDefinition, targetGroupOrTargetPeriod) {
            _super.call(this);
            this.timeZoneDefinition = null;
            this.targetPeriod = null;
            this.targetGroup = null;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            if (arguments.length === 2 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition) && (targetGroupOrTargetPeriod === null || targetGroupOrTargetPeriod instanceof TimeZoneTransitionGroup)) {
                this.constructor_1(timeZoneDefinition, targetGroupOrTargetPeriod);
                return;
            }
            this.constructor_2(timeZoneDefinition, targetGroupOrTargetPeriod);
        }
        Object.defineProperty(TimeZoneTransition.prototype, "TargetPeriod", {
            get: function () {
                return this.targetPeriod;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransition.prototype, "TargetGroup", {
            get: function () {
                return this.targetGroup;
            },
            enumerable: true,
            configurable: true
        });
        TimeZoneTransition.Create = function (timeZoneDefinition, xmlElementName) {
            if (xmlElementName !== null) {
                if (xmlElementName === "AbsoluteDateTransition") {
                    return new AbsoluteDateTransition(timeZoneDefinition);
                }
                if (xmlElementName === "RecurringDayTransition") {
                    return new RelativeDayOfMonthTransition(timeZoneDefinition);
                }
                if (xmlElementName === "RecurringDateTransition") {
                    return new AbsoluteDayOfMonthTransition(timeZoneDefinition);
                }
                if (xmlElementName === "Transition") {
                    return new TimeZoneTransition(timeZoneDefinition);
                }
            }
            throw new ServiceLocalException(NString.Format(Strings.UnknownTimeZonePeriodTransitionType, xmlElementName));
        };
        TimeZoneTransition.CreateTimeZoneTransition = function (timeZoneDefinition, targetPeriod, transitionTime) {
            var timeZoneTransition;
            if (transitionTime.IsFixedDateRule) {
                timeZoneTransition = new AbsoluteDayOfMonthTransition(timeZoneDefinition, targetPeriod);
            }
            else {
                timeZoneTransition = new RelativeDayOfMonthTransition(timeZoneDefinition, targetPeriod);
            }
            timeZoneTransition.InitializeFromTransitionTime(transitionTime);
            return timeZoneTransition;
        };
        TimeZoneTransition.prototype.GetXmlElementName = function () {
            return "Transition";
        };
        TimeZoneTransition.prototype.CreateTransitionTime = function () {
            throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
        };
        TimeZoneTransition.prototype.InitializeFromTransitionTime = function (transitionTime) {
        };
        TimeZoneTransition.prototype.TryReadElementFromXml = function (reader) {
            var _this = this;
            var localName;
            if ((localName = reader.LocalName) !== null && localName === "To") {
                var IL_AF = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            var text = reader.ReadAttributeValue("Kind");
                            var text2 = reader.ReadElementValue();
                            var a;
                            if ((a = text) !== null) {
                                if (!(a === "Period")) {
                                    if (!(a === "Group")) {
                                        _goto = IL_AF;
                                        continue _GOTO_LOOP;
                                    }
                                    if (!(function () {
                                        var _p0 = [
                                            _this.targetGroup
                                        ];
                                        var _r = _this.timeZoneDefinition.TransitionGroups.TryGetValue(text2, _p0);
                                        _this.targetGroup = _p0[0];
                                        return _r;
                                    })()) {
                                        throw new ServiceLocalException(NString.Format(Strings.TransitionGroupNotFound, text2));
                                    }
                                }
                                else {
                                    if (!(function () {
                                        var _p0 = [
                                            _this.targetPeriod
                                        ];
                                        var _r = _this.timeZoneDefinition.Periods.TryGetValue(text2, _p0);
                                        _this.targetPeriod = _p0[0];
                                        return _r;
                                    })()) {
                                        throw new ServiceLocalException(NString.Format(Strings.PeriodNotFound, text2));
                                    }
                                }
                                return true;
                            }
                            _goto = IL_AF;
                            continue _GOTO_LOOP;
                        case 1:
                            throw new ServiceLocalException(Strings.UnsupportedTimeZonePeriodTransitionTarget);
                    }
                }
            }
            return false;
        };
        TimeZoneTransition.prototype.LoadFromJson = function (jsonProperty, service) {
            var _this = this;
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "To") {
                        var text = jsonProperty.ReadAsJsonObject(current).ReadAsString("Kind");
                        var text2 = jsonProperty.ReadAsJsonObject(current).ReadAsString("Value");
                        var a2;
                        if ((a2 = text) !== null) {
                            if (!(a2 === "Period")) {
                                if (a2 === "Group") {
                                    if (!(function () {
                                        var _p0 = [
                                            _this.targetGroup
                                        ];
                                        var _r = _this.timeZoneDefinition.TransitionGroups.TryGetValue(text2, _p0);
                                        _this.targetGroup = _p0[0];
                                        return _r;
                                    })()) {
                                        throw new ServiceLocalException(NString.Format(Strings.TransitionGroupNotFound, text2));
                                    }
                                    continue;
                                }
                            }
                            else {
                                if (!(function () {
                                    var _p0 = [
                                        _this.targetPeriod
                                    ];
                                    var _r = _this.timeZoneDefinition.Periods.TryGetValue(text2, _p0);
                                    _this.targetPeriod = _p0[0];
                                    return _r;
                                })()) {
                                    throw new ServiceLocalException(NString.Format(Strings.PeriodNotFound, text2));
                                }
                                continue;
                            }
                        }
                        throw new ServiceLocalException(Strings.UnsupportedTimeZonePeriodTransitionTarget);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        TimeZoneTransition.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            var jsonObject2 = new JsonObject();
            jsonObject.Add("To", jsonObject2);
            if (this.targetPeriod !== null) {
                jsonObject2.Add("Kind", "Period");
                jsonObject2.Add("Value", this.targetPeriod.Id);
            }
            else {
                jsonObject2.Add("Kind", "Group");
                jsonObject2.Add("Value", this.targetGroup.Id);
            }
            return jsonObject;
        };
        TimeZoneTransition.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "To");
            if (this.targetPeriod !== null) {
                writer.WriteAttributeValue("Kind", "Period");
                writer.WriteValue(this.targetPeriod.Id, "To");
            }
            else {
                writer.WriteAttributeValue("Kind", "Group");
                writer.WriteValue(this.targetGroup.Id, "To");
            }
            writer.WriteEndElement();
        };
        TimeZoneTransition.prototype.LoadFromXml = function (reader) {
            this.LoadFromXml(reader, this.GetXmlElementName());
        };
        TimeZoneTransition.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, this.GetXmlElementName());
        };
        TimeZoneTransition.prototype.constructor_0 = function (timeZoneDefinition) {
            this.timeZoneDefinition = timeZoneDefinition;
        };
        TimeZoneTransition.prototype.constructor_1 = function (timeZoneDefinition, targetGroup) {
            this.constructor_0(timeZoneDefinition);
            this.targetGroup = targetGroup;
        };
        TimeZoneTransition.prototype.constructor_2 = function (timeZoneDefinition, targetPeriod) {
            this.constructor_0(timeZoneDefinition);
            this.targetPeriod = targetPeriod;
        };
        TimeZoneTransition.PeriodTarget = "Period";
        TimeZoneTransition.GroupTarget = "Group";
        return TimeZoneTransition;
    }(ComplexProperty));
    var AbsoluteDateTransition = (function (_super) {
        __extends(AbsoluteDateTransition, _super);
        function AbsoluteDateTransition(timeZoneDefinition, targetGroup) {
            _super.call(this, timeZoneDefinition);
            this.dateTime = null;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            this.constructor_1(timeZoneDefinition, targetGroup);
        }
        Object.defineProperty(AbsoluteDateTransition.prototype, "DateTime", {
            get: function () {
                return this.dateTime;
            },
            set: function (value) {
                this.dateTime = value;
            },
            enumerable: true,
            configurable: true
        });
        AbsoluteDateTransition.prototype.InitializeFromTransitionTime = function (transitionTime) {
            throw new ServiceLocalException(Strings.UnsupportedTimeZonePeriodTransitionTarget);
        };
        AbsoluteDateTransition.prototype.GetXmlElementName = function () {
            return "AbsoluteDateTransition";
        };
        AbsoluteDateTransition.prototype.TryReadElementFromXml = function (reader) {
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag && reader.LocalName === "DateTime") {
                this.dateTime = DateTime.Parse(reader.ReadElementValue(), CultureInfo.InvariantCulture);
                flag = true;
            }
            return flag;
        };
        AbsoluteDateTransition.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DateTime", this.dateTime);
        };
        AbsoluteDateTransition.prototype.constructor_0 = function (timeZoneDefinition) {
        };
        AbsoluteDateTransition.prototype.constructor_1 = function (timeZoneDefinition, targetGroup) {
        };
        return AbsoluteDateTransition;
    }(TimeZoneTransition));
    var AbsoluteMonthTransition = (function (_super) {
        __extends(AbsoluteMonthTransition, _super);
        function AbsoluteMonthTransition(timeZoneDefinition, targetPeriod) {
            _super.call(this, timeZoneDefinition);
            this.timeOffset = null;
            this.month = 0;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            this.constructor_1(timeZoneDefinition, targetPeriod);
        }
        Object.defineProperty(AbsoluteMonthTransition.prototype, "TimeOffset", {
            get: function () {
                return this.timeOffset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbsoluteMonthTransition.prototype, "Month", {
            get: function () {
                return this.month;
            },
            enumerable: true,
            configurable: true
        });
        AbsoluteMonthTransition.prototype.InitializeFromTransitionTime = function (transitionTime) {
            _super.prototype.InitializeFromTransitionTime.call(this, transitionTime);
            this.timeOffset = transitionTime.TimeOfDay.TimeOfDay;
            this.month = transitionTime.Month;
        };
        AbsoluteMonthTransition.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "TimeOffset") {
                    this.timeOffset = EwsUtilities.XSDurationToTimeSpan(reader.ReadElementValue());
                    return true;
                }
                if (localName === "Month") {
                    this.month = reader.ReadElementValue();
                    EwsUtilities.Assert(this.month > 0 && this.month <= 12, "AbsoluteMonthTransition.TryReadElementFromXml", "month is not in the valid 1 - 12 range.");
                    return true;
                }
            }
            return false;
        };
        AbsoluteMonthTransition.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "TimeOffset", EwsUtilities.TimeSpanToXSDuration(this.timeOffset));
            writer.WriteElementValue(XmlNamespace.Types, "Month", this.month);
        };
        AbsoluteMonthTransition.prototype.constructor_0 = function (timeZoneDefinition) {
        };
        AbsoluteMonthTransition.prototype.constructor_1 = function (timeZoneDefinition, targetPeriod) {
        };
        return AbsoluteMonthTransition;
    }(TimeZoneTransition));
    var AbsoluteDayOfMonthTransition = (function (_super) {
        __extends(AbsoluteDayOfMonthTransition, _super);
        function AbsoluteDayOfMonthTransition(timeZoneDefinition, targetPeriod) {
            _super.call(this, timeZoneDefinition);
            this.dayOfMonth = 0;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            this.constructor_1(timeZoneDefinition, targetPeriod);
        }
        Object.defineProperty(AbsoluteDayOfMonthTransition.prototype, "DayOfMonth", {
            get: function () {
                return this.dayOfMonth;
            },
            enumerable: true,
            configurable: true
        });
        AbsoluteDayOfMonthTransition.prototype.GetXmlElementName = function () {
            return "RecurringDateTransition";
        };
        AbsoluteDayOfMonthTransition.prototype.CreateTransitionTime = function () {
            return TimeZoneInfo_TransitionTime.CreateFixedDateRule(new DateTime(this.TimeOffset.Ticks), this.Month, this.DayOfMonth);
        };
        AbsoluteDayOfMonthTransition.prototype.InitializeFromTransitionTime = function (transitionTime) {
            _super.prototype.InitializeFromTransitionTime.call(this, transitionTime);
            this.dayOfMonth = transitionTime.Day;
        };
        AbsoluteDayOfMonthTransition.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            if (reader.LocalName === "Day") {
                this.dayOfMonth = reader.ReadElementValue();
                EwsUtilities.Assert(this.dayOfMonth > 0 && this.dayOfMonth <= 31, "AbsoluteDayOfMonthTransition.TryReadElementFromXml", "dayOfMonth is not in the valid 1 - 31 range.");
                return true;
            }
            return false;
        };
        AbsoluteDayOfMonthTransition.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "Day", this.dayOfMonth);
        };
        AbsoluteDayOfMonthTransition.prototype.constructor_0 = function (timeZoneDefinition) {
        };
        AbsoluteDayOfMonthTransition.prototype.constructor_1 = function (timeZoneDefinition, targetPeriod) {
        };
        return AbsoluteDayOfMonthTransition;
    }(AbsoluteMonthTransition));
    var RelativeDayOfMonthTransition = (function (_super) {
        __extends(RelativeDayOfMonthTransition, _super);
        function RelativeDayOfMonthTransition(timeZoneDefinition, targetPeriod) {
            _super.call(this, timeZoneDefinition);
            this.dayOfTheWeek = 0;
            this.weekIndex = 0;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            this.constructor_1(timeZoneDefinition, targetPeriod);
        }
        Object.defineProperty(RelativeDayOfMonthTransition.prototype, "DayOfTheWeek", {
            get: function () {
                return this.dayOfTheWeek;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RelativeDayOfMonthTransition.prototype, "WeekIndex", {
            get: function () {
                return this.weekIndex;
            },
            enumerable: true,
            configurable: true
        });
        RelativeDayOfMonthTransition.prototype.GetXmlElementName = function () {
            return "RecurringDayTransition";
        };
        RelativeDayOfMonthTransition.prototype.CreateTransitionTime = function () {
            return TimeZoneInfo_TransitionTime.CreateFloatingDateRule(new DateTime(this.TimeOffset.Ticks), this.Month, (this.WeekIndex === -1) ? 5 : this.WeekIndex, EwsUtilities.EwsToSystemDayOfWeek(this.DayOfTheWeek));
        };
        RelativeDayOfMonthTransition.prototype.InitializeFromTransitionTime = function (transitionTime) {
            _super.prototype.InitializeFromTransitionTime.call(this, transitionTime);
            this.dayOfTheWeek = EwsUtilities.SystemToEwsDayOfTheWeek(transitionTime.DayOfWeek);
            this.weekIndex = ((transitionTime.Week === 5) ? -1 : transitionTime.Week);
        };
        RelativeDayOfMonthTransition.prototype.TryReadElementFromXml = function (reader) {
            if (_super.prototype.TryReadElementFromXml.call(this, reader)) {
                return true;
            }
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "DayOfWeek") {
                    this.dayOfTheWeek = reader.ReadElementValue();
                    return true;
                }
                if (localName === "Occurrence") {
                    this.weekIndex = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        RelativeDayOfMonthTransition.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteElementValue(XmlNamespace.Types, "DayOfWeek", this.dayOfTheWeek);
            writer.WriteElementValue(XmlNamespace.Types, "Occurrence", this.weekIndex);
        };
        RelativeDayOfMonthTransition.prototype.constructor_0 = function (timeZoneDefinition) {
        };
        RelativeDayOfMonthTransition.prototype.constructor_1 = function (timeZoneDefinition, targetPeriod) {
        };
        return RelativeDayOfMonthTransition;
    }(AbsoluteMonthTransition));
    var TimeZoneDefinition = (function (_super) {
        __extends(TimeZoneDefinition, _super);
        function TimeZoneDefinition(timeZoneInfo) {
            _super.call(this);
            this.name = null;
            this.id = null;
            this.periods = new Dictionary();
            this.transitionGroups = new Dictionary();
            this.transitions = new List();
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(timeZoneInfo);
        }
        Object.defineProperty(TimeZoneDefinition.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneDefinition.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneDefinition.prototype, "Periods", {
            get: function () {
                return this.periods;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneDefinition.prototype, "TransitionGroups", {
            get: function () {
                return this.transitionGroups;
            },
            enumerable: true,
            configurable: true
        });
        TimeZoneDefinition.prototype.CompareTransitions = function (x, y) {
            if (x === y) {
                return 0;
            }
            if (Type.op_Equality(x.GetType(), new Type("TimeZoneTransition"))) {
                return -1;
            }
            if (Type.op_Equality(y.GetType(), new Type("TimeZoneTransition"))) {
                return 1;
            }
            var absoluteDateTransition = x;
            var absoluteDateTransition2 = y;
            return DateTime.Compare(absoluteDateTransition.DateTime, absoluteDateTransition2.DateTime);
        };
        TimeZoneDefinition.prototype.constructor_0 = function () {
        };
        TimeZoneDefinition.prototype.constructor_1 = function (timeZoneInfo) {
            this.constructor_0();
            this.Id = timeZoneInfo.Id;
            this.Name = timeZoneInfo.DisplayName;
            var timeZonePeriod = new TimeZonePeriod();
            timeZonePeriod.Id = "Std";
            timeZonePeriod.Name = "Standard";
            timeZonePeriod.Bias = -timeZoneInfo.BaseUtcOffset;
            this.periods.Add(timeZonePeriod.Id, timeZonePeriod);
            var adjustmentRules = timeZoneInfo.GetAdjustmentRules();
            var item = new TimeZoneTransition(this, timeZonePeriod);
            if (adjustmentRules.length === 0) {
                var timeZoneTransitionGroup = new TimeZoneTransitionGroup(this, "0");
                timeZoneTransitionGroup.Transitions.Add(item);
                this.transitionGroups.Add(timeZoneTransitionGroup.Id, timeZoneTransitionGroup);
                var item2 = new TimeZoneTransition(this, timeZoneTransitionGroup);
                this.transitions.Add(item2);
                return;
            }
            for (var i = 0; i < adjustmentRules.length; i = i + 1) {
                var timeZoneTransitionGroup2 = new TimeZoneTransitionGroup(this, NNumber.ToString(this.transitionGroups.Count));
                timeZoneTransitionGroup2.InitializeFromAdjustmentRule(adjustmentRules[i], timeZonePeriod);
                this.transitionGroups.Add(timeZoneTransitionGroup2.Id, timeZoneTransitionGroup2);
                var item4;
                if (i === 0) {
                    if (DateTime.op_GreaterThan(adjustmentRules[i].DateStart, DateTime.MinValue.Date)) {
                        var item3 = new TimeZoneTransition(this, this.CreateTransitionGroupToPeriod(timeZonePeriod));
                        this.transitions.Add(item3);
                        var absoluteDateTransition = new AbsoluteDateTransition(this, timeZoneTransitionGroup2);
                        absoluteDateTransition.DateTime = adjustmentRules[i].DateStart;
                        item4 = absoluteDateTransition;
                    }
                    else {
                        item4 = new TimeZoneTransition(this, timeZoneTransitionGroup2);
                    }
                }
                else {
                    var absoluteDateTransition2 = new AbsoluteDateTransition(this, timeZoneTransitionGroup2);
                    absoluteDateTransition2.DateTime = adjustmentRules[i].DateStart;
                    item4 = absoluteDateTransition2;
                }
                this.transitions.Add(item4);
            }
            var dateEnd = adjustmentRules[adjustmentRules.length - 1].DateEnd;
            if (DateTime.op_LessThan(dateEnd, DateTime.MaxValue.Date)) {
                var absoluteDateTransition3 = new AbsoluteDateTransition(this, this.CreateTransitionGroupToPeriod(timeZonePeriod));
                absoluteDateTransition3.DateTime = dateEnd.AddDays(1.0);
                this.transitions.Add(absoluteDateTransition3);
            }
        };
        TimeZoneDefinition.prototype.CreateTransitionGroupToPeriod = function (timeZonePeriod) {
            var item = new TimeZoneTransition(this, timeZonePeriod);
            var timeZoneTransitionGroup = new TimeZoneTransitionGroup(this, NNumber.ToString(this.transitionGroups.Count));
            timeZoneTransitionGroup.Transitions.Add(item);
            this.transitionGroups.Add(timeZoneTransitionGroup.Id, timeZoneTransitionGroup);
            return timeZoneTransitionGroup;
        };
        TimeZoneDefinition.prototype.ReadAttributesFromXml = function (reader) {
            this.name = reader.ReadAttributeValue("Name");
            this.id = reader.ReadAttributeValue("Id");
            if (NString.IsNullOrEmpty(this.id)) {
                var text = NString.IsNullOrEmpty(this.Name) ? NString.Empty : this.Name;
                this.Id = "NoId_" + NNumber.ToString(Math.abs(NString.GetHashCode(text)));
            }
        };
        TimeZoneDefinition.prototype.WriteAttributesToXml = function (writer) {
            if (writer.Service.RequestedServerVersion !== ExchangeVersion.Exchange2007_SP1) {
                writer.WriteAttributeValue("Name", this.name);
            }
            writer.WriteAttributeValue("Id", this.id);
        };
        TimeZoneDefinition.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Periods") {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "Period")) {
                            var timeZonePeriod = new TimeZonePeriod();
                            timeZonePeriod.LoadFromXml(reader);
                            this.periods.Add(timeZonePeriod.Id, timeZonePeriod);
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "Periods"));
                    return true;
                }
                if (localName === "TransitionsGroups") {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "TransitionsGroup")) {
                            var timeZoneTransitionGroup = new TimeZoneTransitionGroup(this);
                            timeZoneTransitionGroup.LoadFromXml(reader);
                            this.transitionGroups.Add(timeZoneTransitionGroup.Id, timeZoneTransitionGroup);
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "TransitionsGroups"));
                    return true;
                }
                if (localName === "Transitions") {
                    do {
                        reader.Read();
                        if (reader.IsStartElement()) {
                            var timeZoneTransition = TimeZoneTransition.Create(this, reader.LocalName);
                            timeZoneTransition.LoadFromXml(reader);
                            this.transitions.Add(timeZoneTransition);
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "Transitions"));
                    return true;
                }
            }
            return false;
        };
        TimeZoneDefinition.prototype.LoadFromXml = function (reader) {
            this.LoadFromXml(reader, "TimeZoneDefinition");
            this.transitions.Sort(this.CompareTransitions);
        };
        TimeZoneDefinition.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Name")) {
                            if (!(a === "Id")) {
                                if (!(a === "Periods")) {
                                    if (!(a === "TransitionsGroups")) {
                                        if (a === "Transitions") {
                                            var jsonObject = jsonProperty.ReadAsJsonObject(current);
                                            var array = jsonObject.ReadAsArray("Transition");
                                            for (var i = 0; i < array.length; i = i + 1) {
                                                var obj = array[i];
                                                var jsonObject2 = ((obj instanceof JsonObject) ? obj : null);
                                                var timeZoneTransition = TimeZoneTransition.Create(this, jsonObject2.ReadTypeString());
                                                timeZoneTransition.LoadFromJson(jsonObject2, service);
                                                this.transitions.Add(timeZoneTransition);
                                            }
                                        }
                                    }
                                    else {
                                        var array2 = jsonProperty.ReadAsArray(current);
                                        for (var j = 0; j < array2.length; j = j + 1) {
                                            var obj2 = array2[j];
                                            var timeZoneTransitionGroup = new TimeZoneTransitionGroup(this);
                                            timeZoneTransitionGroup.LoadFromJson(((obj2 instanceof JsonObject) ? obj2 : null), service);
                                            this.transitionGroups.Add(timeZoneTransitionGroup.Id, timeZoneTransitionGroup);
                                        }
                                    }
                                }
                                else {
                                    var array3 = jsonProperty.ReadAsArray(current);
                                    for (var k = 0; k < array3.length; k = k + 1) {
                                        var obj3 = array3[k];
                                        var timeZonePeriod = new TimeZonePeriod();
                                        timeZonePeriod.LoadFromJson(((obj3 instanceof JsonObject) ? obj3 : null), service);
                                        this.periods.Add(timeZonePeriod.Id, timeZonePeriod);
                                    }
                                }
                            }
                            else {
                                this.id = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.name = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (NString.IsNullOrEmpty(this.id)) {
                var text = NString.IsNullOrEmpty(this.Name) ? NString.Empty : this.Name;
                this.Id = "NoId_" + NNumber.ToString(Math.abs(NString.GetHashCode(text)));
            }
            this.transitions.Sort(this.CompareTransitions);
        };
        TimeZoneDefinition.prototype.WriteElementsToXml = function (writer) {
            if (writer.Service.RequestedServerVersion !== ExchangeVersion.Exchange2007_SP1) {
                if (this.periods.Count > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "Periods");
                    var enumerator = this.periods.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var current = enumerator.Current;
                            current.Value.WriteToXml(writer);
                        }
                    }
                    finally {
                        enumerator.Dispose();
                    }
                    writer.WriteEndElement();
                }
                if (this.transitionGroups.Count > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "TransitionsGroups");
                    var enumerator2 = this.transitionGroups.GetEnumerator();
                    try {
                        while (enumerator2.MoveNext()) {
                            var current2 = enumerator2.Current;
                            current2.Value.WriteToXml(writer);
                        }
                    }
                    finally {
                        enumerator2.Dispose();
                    }
                    writer.WriteEndElement();
                }
                if (this.transitions.Count > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "Transitions");
                    var enumerator3 = this.transitions.GetEnumerator();
                    try {
                        while (enumerator3.MoveNext()) {
                            var current3 = enumerator3.Current;
                            current3.WriteToXml(writer);
                        }
                    }
                    finally {
                        enumerator3.Dispose();
                    }
                    writer.WriteEndElement();
                }
            }
        };
        TimeZoneDefinition.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Id", this.id);
            if (service.RequestedServerVersion !== ExchangeVersion.Exchange2007_SP1) {
                jsonObject.Add("Name", this.name);
                if (this.periods.Count > 0) {
                    var list = new List();
                    var enumerator = this.periods.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var current = enumerator.Current;
                            list.Add(current.Value.InternalToJson(service));
                        }
                    }
                    finally {
                        enumerator.Dispose();
                    }
                    jsonObject.Add("Periods", NArray.ToEnumerable(list.ToArray()));
                }
                if (this.transitionGroups.Count > 0) {
                    var list2 = new List();
                    var enumerator2 = this.transitionGroups.GetEnumerator();
                    try {
                        while (enumerator2.MoveNext()) {
                            var current2 = enumerator2.Current;
                            list2.Add(current2.Value.InternalToJson(service));
                        }
                    }
                    finally {
                        enumerator2.Dispose();
                    }
                    jsonObject.Add("TransitionsGroups", NArray.ToEnumerable(list2.ToArray()));
                }
                if (this.transitions.Count > 0) {
                    var jsonObject2 = new JsonObject();
                    var list3 = new List();
                    var enumerator3 = this.transitions.GetEnumerator();
                    try {
                        while (enumerator3.MoveNext()) {
                            var current3 = enumerator3.Current;
                            list3.Add(current3.InternalToJson(service));
                        }
                    }
                    finally {
                        enumerator3.Dispose();
                    }
                    jsonObject2.Add("Transition", NArray.ToEnumerable(list3.ToArray()));
                    jsonObject.Add("Transitions", jsonObject2);
                }
            }
            return jsonObject;
        };
        TimeZoneDefinition.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, "TimeZoneDefinition");
        };
        TimeZoneDefinition.prototype.Validate = function () {
            if (this.periods.Count < 1 || this.transitions.Count < 1 || this.transitionGroups.Count < 1 || this.transitionGroups.Count !== this.transitions.Count) {
                throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
            }
            if (Type.op_Inequality(this.transitions.get_Item(0).GetType(), new Type("TimeZoneTransition"))) {
                throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
            }
            var enumerator = this.transitions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var type = current.GetType();
                    if (Type.op_Inequality(type, new Type("TimeZoneTransition")) && Type.op_Inequality(type, new Type("AbsoluteDateTransition"))) {
                        throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
                    }
                    if (current.TargetGroup === null) {
                        throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.transitionGroups.Values.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    current2.Validate();
                }
            }
            finally {
                enumerator2.Dispose();
            }
        };
        TimeZoneDefinition.prototype.ToTimeZoneInfo = function () {
            this.Validate();
            var customTimeZoneCreationParams = this.transitions.get_Item(this.transitions.Count - 1).TargetGroup.GetCustomTimeZoneCreationParams();
            var list = new List();
            var startDate = DateTime.MinValue;
            for (var i = 0; i < this.transitions.Count; i = i + 1) {
                var dateTime;
                var endDate;
                if (i < this.transitions.Count - 1) {
                    dateTime = (((this.transitions.get_Item(i + 1) instanceof AbsoluteDateTransition) ? this.transitions.get_Item(i + 1) : null)).DateTime;
                    endDate = dateTime.AddDays(-1.0);
                }
                else {
                    dateTime = DateTime.MaxValue;
                    endDate = dateTime;
                }
                var adjustmentRule = this.transitions.get_Item(i).TargetGroup.CreateAdjustmentRule(startDate, endDate);
                if (adjustmentRule !== null) {
                    list.Add(adjustmentRule);
                }
                startDate = dateTime;
            }
            var result;
            if (list.Count === 0) {
                result = TimeZoneInfo.CreateCustomTimeZone(this.Id, customTimeZoneCreationParams.BaseOffsetToUtc, this.Name, customTimeZoneCreationParams.StandardDisplayName);
            }
            else {
                result = TimeZoneInfo.CreateCustomTimeZone(this.Id, customTimeZoneCreationParams.BaseOffsetToUtc, this.Name, customTimeZoneCreationParams.StandardDisplayName, customTimeZoneCreationParams.DaylightDisplayName, list.ToArray());
            }
            return result;
        };
        TimeZoneDefinition.NoIdPrefix = "NoId_";
        return TimeZoneDefinition;
    }(ComplexProperty));
    var TimeZonePeriod = (function (_super) {
        __extends(TimeZonePeriod, _super);
        function TimeZonePeriod() {
            _super.call(this);
            this.bias = null;
            this.name = null;
            this.id = null;
        }
        Object.defineProperty(TimeZonePeriod.prototype, "IsStandardPeriod", {
            get: function () {
                return NString.Compare(this.name, "Standard", StringComparison.OrdinalIgnoreCase) === 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZonePeriod.prototype, "Bias", {
            get: function () {
                return this.bias;
            },
            set: function (value) {
                this.bias = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZonePeriod.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZonePeriod.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        TimeZonePeriod.prototype.ReadAttributesFromXml = function (reader) {
            this.id = reader.ReadAttributeValue("Id");
            this.name = reader.ReadAttributeValue("Name");
            this.bias = EwsUtilities.XSDurationToTimeSpan(reader.ReadAttributeValue("Bias"));
        };
        TimeZonePeriod.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Bias", EwsUtilities.TimeSpanToXSDuration(this.bias));
            writer.WriteAttributeValue("Name", this.name);
            writer.WriteAttributeValue("Id", this.id);
        };
        TimeZonePeriod.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Bias", EwsUtilities.TimeSpanToXSDuration(this.bias));
            jsonObject.Add("Name", this.name);
            jsonObject.Add("Id", this.id);
            return jsonObject;
        };
        TimeZonePeriod.prototype.LoadFromXml = function (reader) {
            this.LoadFromXml(reader, "Period");
        };
        TimeZonePeriod.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Id")) {
                            if (!(a === "Name")) {
                                if (a === "Bias") {
                                    this.bias = EwsUtilities.XSDurationToTimeSpan(jsonProperty.ReadAsString(current));
                                }
                            }
                            else {
                                this.name = jsonProperty.ReadAsString(current);
                            }
                        }
                        else {
                            this.id = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        TimeZonePeriod.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, "Period");
        };
        TimeZonePeriod.StandardPeriodId = "Std";
        TimeZonePeriod.StandardPeriodName = "Standard";
        TimeZonePeriod.DaylightPeriodId = "Dlt";
        TimeZonePeriod.DaylightPeriodName = "Daylight";
        return TimeZonePeriod;
    }(ComplexProperty));
    var TimeZoneTransitionGroup = (function (_super) {
        __extends(TimeZoneTransitionGroup, _super);
        function TimeZoneTransitionGroup(timeZoneDefinition, id) {
            _super.call(this);
            this.timeZoneDefinition = null;
            this.id = null;
            this.transitions = new List();
            this.transitionToStandard = null;
            this.transitionToDaylight = null;
            if (arguments.length === 1 && (timeZoneDefinition === null || timeZoneDefinition instanceof TimeZoneDefinition)) {
                this.constructor_0(timeZoneDefinition);
                return;
            }
            this.constructor_1(timeZoneDefinition, id);
        }
        Object.defineProperty(TimeZoneTransitionGroup.prototype, "SupportsDaylight", {
            get: function () {
                return this.transitions.Count === 2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup.prototype, "TransitionToDaylight", {
            get: function () {
                this.InitializeTransitions();
                return this.transitionToDaylight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup.prototype, "TransitionToStandard", {
            get: function () {
                this.InitializeTransitions();
                return this.transitionToStandard;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup.prototype, "Transitions", {
            get: function () {
                return this.transitions;
            },
            enumerable: true,
            configurable: true
        });
        TimeZoneTransitionGroup.prototype.LoadFromXml = function (reader) {
            this.LoadFromXml(reader, "TransitionsGroup");
        };
        TimeZoneTransitionGroup.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, "TransitionsGroup");
        };
        TimeZoneTransitionGroup.prototype.ReadAttributesFromXml = function (reader) {
            this.id = reader.ReadAttributeValue("Id");
        };
        TimeZoneTransitionGroup.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Id")) {
                            if (a === "Transition") {
                                var array = jsonProperty.ReadAsArray(current);
                                for (var i = 0; i < array.length; i = i + 1) {
                                    var obj = array[i];
                                    var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                                    var timeZoneTransition = TimeZoneTransition.Create(this.timeZoneDefinition, jsonObject.ReadTypeString());
                                    timeZoneTransition.LoadFromJson(jsonObject, service);
                                    this.transitions.Add(timeZoneTransition);
                                }
                            }
                        }
                        else {
                            this.id = jsonProperty.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        TimeZoneTransitionGroup.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Id", this.id);
        };
        TimeZoneTransitionGroup.prototype.TryReadElementFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement();
            var timeZoneTransition = TimeZoneTransition.Create(this.timeZoneDefinition, reader.LocalName);
            timeZoneTransition.LoadFromXml(reader);
            EwsUtilities.Assert(timeZoneTransition.TargetPeriod !== null, "TimeZoneTransitionGroup.TryReadElementFromXml", "The transition's target period is null.");
            this.transitions.Add(timeZoneTransition);
            return true;
        };
        TimeZoneTransitionGroup.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.transitions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer);
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        TimeZoneTransitionGroup.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Id", this.id);
            var list = new List();
            var enumerator = this.transitions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("Transitions", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        TimeZoneTransitionGroup.prototype.InitializeFromAdjustmentRule = function (adjustmentRule, standardPeriod) {
            var timeZonePeriod = new TimeZonePeriod();
            timeZonePeriod.Id = NString.Format("{0}/{1}", "Dlt", adjustmentRule.DateStart.Year);
            timeZonePeriod.Name = "Daylight";
            timeZonePeriod.Bias = TimeSpan.op_Subtraction(standardPeriod.Bias, adjustmentRule.DaylightDelta);
            this.timeZoneDefinition.Periods.Add(timeZonePeriod.Id, timeZonePeriod);
            this.transitionToDaylight = TimeZoneTransition.CreateTimeZoneTransition(this.timeZoneDefinition, timeZonePeriod, adjustmentRule.DaylightTransitionStart);
            this.transitionToStandard = TimeZoneTransition.CreateTimeZoneTransition(this.timeZoneDefinition, standardPeriod, adjustmentRule.DaylightTransitionEnd);
            this.transitions.Add(this.transitionToDaylight);
            this.transitions.Add(this.transitionToStandard);
        };
        TimeZoneTransitionGroup.prototype.Validate = function () {
            if (this.transitions.Count < 1 || this.transitions.Count > 2) {
                throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
            }
            if (this.transitions.Count === 1 && Type.op_Inequality(this.transitions.get_Item(0).GetType(), new Type("TimeZoneTransition"))) {
                throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
            }
            if (this.transitions.Count === 2) {
                var enumerator = this.transitions.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (Type.op_Equality(current.GetType(), new Type("TimeZoneTransition"))) {
                            throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
            }
            var enumerator2 = this.transitions.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    if (current2.TargetPeriod === null) {
                        throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
                    }
                }
            }
            finally {
                enumerator2.Dispose();
            }
        };
        TimeZoneTransitionGroup.prototype.InitializeTransitions = function () {
            if (this.transitionToStandard === null) {
                var enumerator = this.transitions.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.TargetPeriod.IsStandardPeriod || this.transitions.Count === 1) {
                            this.transitionToStandard = current;
                        }
                        else {
                            this.transitionToDaylight = current;
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
            }
            if (this.transitionToStandard === null) {
                throw new ServiceLocalException(Strings.InvalidOrUnsupportedTimeZoneDefinition);
            }
        };
        TimeZoneTransitionGroup.prototype.GetCustomTimeZoneCreationParams = function () {
            var customTimeZoneCreateParams = new TimeZoneTransitionGroup_CustomTimeZoneCreateParams();
            if (this.TransitionToDaylight !== null) {
                customTimeZoneCreateParams.DaylightDisplayName = this.TransitionToDaylight.TargetPeriod.Name;
            }
            customTimeZoneCreateParams.StandardDisplayName = this.TransitionToStandard.TargetPeriod.Name;
            customTimeZoneCreateParams.BaseOffsetToUtc = -this.TransitionToStandard.TargetPeriod.Bias;
            return customTimeZoneCreateParams;
        };
        TimeZoneTransitionGroup.prototype.GetDaylightDelta = function () {
            if (this.SupportsDaylight) {
                return TimeSpan.op_Subtraction(this.TransitionToStandard.TargetPeriod.Bias, this.TransitionToDaylight.TargetPeriod.Bias);
            }
            return TimeSpan.Zero;
        };
        TimeZoneTransitionGroup.prototype.CreateAdjustmentRule = function (startDate, endDate) {
            if (this.transitions.Count === 1) {
                return null;
            }
            return TimeZoneInfo_AdjustmentRule.CreateAdjustmentRule(startDate.Date, endDate.Date, this.GetDaylightDelta(), this.TransitionToDaylight.CreateTransitionTime(), this.TransitionToStandard.CreateTransitionTime());
        };
        TimeZoneTransitionGroup.prototype.constructor_0 = function (timeZoneDefinition) {
            this.timeZoneDefinition = timeZoneDefinition;
        };
        TimeZoneTransitionGroup.prototype.constructor_1 = function (timeZoneDefinition, id) {
            this.constructor_0(timeZoneDefinition);
            this.id = id;
        };
        return TimeZoneTransitionGroup;
    }(ComplexProperty));
    var TimeZoneTransitionGroup_CustomTimeZoneCreateParams = (function () {
        function TimeZoneTransitionGroup_CustomTimeZoneCreateParams() {
            this.baseOffsetToUtc = null;
            this.standardDisplayName = null;
            this.daylightDisplayName = null;
            _super.call(this);
        }
        Object.defineProperty(TimeZoneTransitionGroup_CustomTimeZoneCreateParams.prototype, "BaseOffsetToUtc", {
            get: function () {
                return this.baseOffsetToUtc;
            },
            set: function (value) {
                this.baseOffsetToUtc = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup_CustomTimeZoneCreateParams.prototype, "StandardDisplayName", {
            get: function () {
                return this.standardDisplayName;
            },
            set: function (value) {
                this.standardDisplayName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup_CustomTimeZoneCreateParams.prototype, "DaylightDisplayName", {
            get: function () {
                return this.daylightDisplayName;
            },
            set: function (value) {
                this.daylightDisplayName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeZoneTransitionGroup_CustomTimeZoneCreateParams.prototype, "HasDaylightPeriod", {
            get: function () {
                return !NString.IsNullOrEmpty(this.daylightDisplayName);
            },
            enumerable: true,
            configurable: true
        });
        return TimeZoneTransitionGroup_CustomTimeZoneCreateParams;
    }());
    var EwsHttpWebRequest = (function () {
        function EwsHttpWebRequest(uri) {
            this.request = null;
            _super.call(this);
            this.request = WebRequest.Create(uri);
        }
        Object.defineProperty(EwsHttpWebRequest.prototype, "Accept", {
            get: function () {
                return this.request.Accept;
            },
            set: function (value) {
                this.request.Accept = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "AllowAutoRedirect", {
            get: function () {
                return this.request.AllowAutoRedirect;
            },
            set: function (value) {
                this.request.AllowAutoRedirect = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "ClientCertificates", {
            get: function () {
                return this.request.ClientCertificates;
            },
            set: function (value) {
                this.request.ClientCertificates = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "ContentType", {
            get: function () {
                return this.request.ContentType;
            },
            set: function (value) {
                this.request.ContentType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "CookieContainer", {
            get: function () {
                return this.request.CookieContainer;
            },
            set: function (value) {
                this.request.CookieContainer = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "Credentials", {
            get: function () {
                return this.request.Credentials;
            },
            set: function (value) {
                this.request.Credentials = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "Headers", {
            get: function () {
                return this.request.Headers;
            },
            set: function (value) {
                this.request.Headers = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "Method", {
            get: function () {
                return this.request.Method;
            },
            set: function (value) {
                this.request.Method = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "Proxy", {
            get: function () {
                return this.request.Proxy;
            },
            set: function (value) {
                this.request.Proxy = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "PreAuthenticate", {
            get: function () {
                return this.request.PreAuthenticate;
            },
            set: function (value) {
                this.request.PreAuthenticate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "RequestUri", {
            get: function () {
                return this.request.RequestUri;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "Timeout", {
            get: function () {
                return this.request.Timeout;
            },
            set: function (value) {
                this.request.Timeout = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "UseDefaultCredentials", {
            get: function () {
                return this.request.UseDefaultCredentials;
            },
            set: function (value) {
                this.request.UseDefaultCredentials = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "UserAgent", {
            get: function () {
                return this.request.UserAgent;
            },
            set: function (value) {
                this.request.UserAgent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "KeepAlive", {
            get: function () {
                return this.request.KeepAlive;
            },
            set: function (value) {
                this.request.KeepAlive = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebRequest.prototype, "ConnectionGroupName", {
            get: function () {
                return this.request.ConnectionGroupName;
            },
            set: function (value) {
                this.request.ConnectionGroupName = value;
            },
            enumerable: true,
            configurable: true
        });
        EwsHttpWebRequest.prototype.Abort = function () {
            this.request.Abort();
        };
        EwsHttpWebRequest.prototype.BeginGetRequestStream = function (callback, state) {
            return this.request.BeginGetRequestStream(callback, state);
        };
        EwsHttpWebRequest.prototype.BeginGetResponse = function (callback, state) {
            return this.request.BeginGetResponse(callback, state);
        };
        EwsHttpWebRequest.prototype.EndGetRequestStream = function (asyncResult) {
            return this.request.EndGetRequestStream(asyncResult);
        };
        EwsHttpWebRequest.prototype.EndGetResponse = function (asyncResult) {
            return new EwsHttpWebResponse(this.request.EndGetResponse(asyncResult));
        };
        EwsHttpWebRequest.prototype.GetRequestStream = function () {
            return this.request.GetRequestStream();
        };
        EwsHttpWebRequest.prototype.GetResponse = function () {
            return new EwsHttpWebResponse(((this.request.GetResponse() instanceof HttpWebResponse) ? this.request.GetResponse() : null));
        };
        return EwsHttpWebRequest;
    }());
    var EwsHttpWebRequestFactory = (function () {
        function EwsHttpWebRequestFactory() {
            _super.call(this);
        }
        EwsHttpWebRequestFactory.prototype.CreateRequest = function (uri) {
            return new EwsHttpWebRequest(uri);
        };
        EwsHttpWebRequestFactory.prototype.CreateExceptionResponse = function (exception) {
            EwsUtilities.ValidateParam(exception, "exception");
            if (exception.Response === null) {
                throw new InvalidOperationException("The exception does not contain response.");
            }
            return new EwsHttpWebResponse(((exception.Response instanceof HttpWebResponse) ? exception.Response : null));
        };
        return EwsHttpWebRequestFactory;
    }());
    var EwsHttpWebResponse = (function () {
        function EwsHttpWebResponse(response) {
            this.response = null;
            _super.call(this);
            this.response = response;
        }
        Object.defineProperty(EwsHttpWebResponse.prototype, "ContentEncoding", {
            get: function () {
                return this.response.ContentEncoding;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "ContentType", {
            get: function () {
                return this.response.ContentType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "Headers", {
            get: function () {
                return this.response.Headers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "ResponseUri", {
            get: function () {
                return this.response.ResponseUri;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "StatusCode", {
            get: function () {
                return this.response.StatusCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "StatusDescription", {
            get: function () {
                return this.response.StatusDescription;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsHttpWebResponse.prototype, "ProtocolVersion", {
            get: function () {
                return this.response.ProtocolVersion;
            },
            enumerable: true,
            configurable: true
        });
        EwsHttpWebResponse.prototype.Close = function () {
            this.response.Close();
        };
        EwsHttpWebResponse.prototype.GetResponseStream = function () {
            return this.response.GetResponseStream();
        };
        EwsHttpWebResponse.prototype.Dispose = function () {
            this.response.Close();
        };
        return EwsHttpWebResponse;
    }());
    var EwsXmlReader = (function () {
        function EwsXmlReader(stream) {
            this.prevNodeType = null;
            this.xmlReader = null;
            _super.call(this);
            this.xmlReader = this.InitializeXmlReader(stream);
        }
        Object.defineProperty(EwsXmlReader.prototype, "HasAttributes", {
            get: function () {
                return this.xmlReader.get_AttributeCount() > 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "IsEmptyElement", {
            get: function () {
                return this.xmlReader.get_IsEmptyElement();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "LocalName", {
            get: function () {
                return this.xmlReader.get_LocalName();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "NamespacePrefix", {
            get: function () {
                return this.xmlReader.get_Prefix();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "NamespaceUri", {
            get: function () {
                return this.xmlReader.get_NamespaceURI();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "NodeType", {
            get: function () {
                return this.xmlReader.get_NodeType();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsXmlReader.prototype, "PrevNodeType", {
            get: function () {
                return this.prevNodeType;
            },
            enumerable: true,
            configurable: true
        });
        EwsXmlReader.prototype.InitializeXmlReader = function (stream) {
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ConformanceLevel(0);
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_IgnoreComments(true);
            xmlReaderSettings.set_IgnoreProcessingInstructions(true);
            xmlReaderSettings.set_IgnoreWhitespace(true);
            xmlReaderSettings.set_XmlResolver(null);
            var xmlReaderSettings2 = xmlReaderSettings;
            var xmlTextReader = SafeXmlFactory.CreateSafeXmlTextReader(stream);
            xmlTextReader.set_Normalization(false);
            return XmlReader.Create(xmlTextReader, xmlReaderSettings2);
        };
        EwsXmlReader.FormatElementName = function (namespacePrefix, localElementName) {
            if (!NString.IsNullOrEmpty(namespacePrefix)) {
                return namespacePrefix + ":" + localElementName;
            }
            return localElementName;
        };
        EwsXmlReader.prototype.InternalReadElement = function (xmlNamespaceOrNamespacePrefix, localName, nodeType) {
            if (arguments.length === 3 && (xmlNamespaceOrNamespacePrefix === null || xmlNamespaceOrNamespacePrefix.constructor === Number) && (localName === null || localName.constructor === String) && (nodeType === null || nodeType instanceof XmlNodeType)) {
                this.InternalReadElement_0(xmlNamespaceOrNamespacePrefix, localName, nodeType);
                return;
            }
            this.InternalReadElement_1(xmlNamespaceOrNamespacePrefix, localName, nodeType);
        };
        EwsXmlReader.prototype.InternalReadElement_0 = function (xmlNamespace, localName, nodeType) {
            if (xmlNamespace === XmlNamespace.NotSpecified) {
                this.InternalReadElement(NString.Empty, localName, nodeType);
                return;
            }
            this.Read(nodeType);
            if (this.LocalName !== localName || this.NamespaceUri !== EwsUtilities.GetNamespaceUri(xmlNamespace)) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.UnexpectedElement, [
                    EwsUtilities.GetNamespacePrefix(xmlNamespace), localName, nodeType, this.xmlReader.get_Name(), this.NodeType
                ]));
            }
        };
        EwsXmlReader.prototype.InternalReadElement_1 = function (namespacePrefix, localName, nodeType) {
            this.Read(nodeType);
            if (this.LocalName !== localName || this.NamespacePrefix !== namespacePrefix) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.UnexpectedElement, [
                    namespacePrefix, localName, nodeType, this.xmlReader.get_Name(), this.NodeType
                ]));
            }
        };
        EwsXmlReader.prototype.Read = function (nodeType) {
            if (arguments.length === 0) {
                this.Read_0();
                return;
            }
            this.Read_1(nodeType);
        };
        EwsXmlReader.prototype.Read_0 = function () {
            this.prevNodeType = this.xmlReader.get_NodeType();
            if (!this.xmlReader.Read()) {
                throw new ServiceXmlDeserializationException(Strings.UnexpectedEndOfXmlDocument);
            }
        };
        EwsXmlReader.prototype.Read_1 = function (nodeType) {
            this.Read();
            if (this.NodeType !== nodeType) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.UnexpectedElementType, nodeType, this.NodeType));
            }
        };
        EwsXmlReader.prototype.ReadAttributeValue = function (xmlNamespaceOrAttributeName, attributeName) {
            if (arguments.length === 2 && (xmlNamespaceOrAttributeName === null || xmlNamespaceOrAttributeName.constructor === Number) && (attributeName === null || attributeName.constructor === String)) {
                return this.ReadAttributeValue_0(xmlNamespaceOrAttributeName, attributeName);
            }
            if (arguments.length === 1 && (xmlNamespaceOrAttributeName === null || xmlNamespaceOrAttributeName.constructor === String)) {
                return this.ReadAttributeValue_1(xmlNamespaceOrAttributeName);
            }
            return this.ReadAttributeValue_2(xmlNamespaceOrAttributeName);
        };
        EwsXmlReader.prototype.ReadAttributeValue_0 = function (xmlNamespace, attributeName) {
            if (xmlNamespace === XmlNamespace.NotSpecified) {
                return this.ReadAttributeValue(attributeName);
            }
            return this.xmlReader.GetAttribute(attributeName, EwsUtilities.GetNamespaceUri(xmlNamespace));
        };
        EwsXmlReader.prototype.ReadAttributeValue_1 = function (attributeName) {
            return this.xmlReader.GetAttribute(attributeName);
        };
        EwsXmlReader.prototype.ReadAttributeValue_2 = function (attributeName) {
            return EwsUtilities.Parse(this.ReadAttributeValue(attributeName));
        };
        EwsXmlReader.prototype.ReadNullableAttributeValue = function (attributeName) {
            var text = this.ReadAttributeValue(attributeName);
            if (text === null) {
                return null;
            }
            return new Nullable(EwsUtilities.Parse(text));
        };
        EwsXmlReader.prototype.ReadElementValue = function (namespacePrefixOrXmlNamespace, localName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (localName === null || localName.constructor === String)) {
                return this.ReadElementValue_0(namespacePrefixOrXmlNamespace, localName);
            }
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === Number) && (localName === null || localName.constructor === String)) {
                return this.ReadElementValue_1(namespacePrefixOrXmlNamespace, localName);
            }
            if (arguments.length === 0) {
                return this.ReadElementValue_2();
            }
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === Number) && (localName === null || localName.constructor === String)) {
                return this.ReadElementValue_3(namespacePrefixOrXmlNamespace, localName);
            }
            return this.ReadElementValue_4();
        };
        EwsXmlReader.prototype.ReadElementValue_0 = function (namespacePrefix, localName) {
            if (!this.IsStartElement(namespacePrefix, localName)) {
                this.ReadStartElement(namespacePrefix, localName);
            }
            var result = null;
            if (!this.IsEmptyElement) {
                result = this.ReadValue();
            }
            return result;
        };
        EwsXmlReader.prototype.ReadElementValue_1 = function (xmlNamespace, localName) {
            if (!this.IsStartElement(xmlNamespace, localName)) {
                this.ReadStartElement(xmlNamespace, localName);
            }
            var result = null;
            if (!this.IsEmptyElement) {
                result = this.ReadValue();
            }
            return result;
        };
        EwsXmlReader.prototype.ReadElementValue_2 = function () {
            this.EnsureCurrentNodeIsStartElement();
            return this.ReadElementValue(this.NamespacePrefix, this.LocalName);
        };
        EwsXmlReader.prototype.ReadElementValue_3 = function (xmlNamespace, localName) {
            if (!this.IsStartElement(xmlNamespace, localName)) {
                this.ReadStartElement(xmlNamespace, localName);
            }
            var result = null;
            if (!this.IsEmptyElement) {
                result = this.ReadValue();
            }
            return result;
        };
        EwsXmlReader.prototype.ReadElementValue_4 = function () {
            this.EnsureCurrentNodeIsStartElement();
            var arg_0C_0 = this.NamespacePrefix;
            var arg_13_0 = this.LocalName;
            var result = null;
            if (!this.IsEmptyElement) {
                result = this.ReadValue();
            }
            return result;
        };
        EwsXmlReader.prototype.ReadValue = function () {
            if (arguments.length === 0) {
                return this.ReadValue_0();
            }
            return this.ReadValue_1();
        };
        EwsXmlReader.prototype.ReadValue_0 = function () {
            return this.xmlReader.ReadString();
        };
        EwsXmlReader.prototype.TryReadValue = function (value) {
            if (this.IsEmptyElement) {
                return false;
            }
            this.Read();
            if (this.NodeType === 3) {
                value[0] = this.xmlReader.get_Value();
                return true;
            }
            return false;
        };
        EwsXmlReader.prototype.ReadValue_1 = function () {
            return EwsUtilities.Parse(this.ReadValue());
        };
        EwsXmlReader.prototype.ReadBase64ElementValue = function (outputStream) {
            if (arguments.length === 0) {
                return this.ReadBase64ElementValue_0();
            }
            return this.ReadBase64ElementValue_1(outputStream);
        };
        EwsXmlReader.prototype.ReadBase64ElementValue_0 = function () {
            this.EnsureCurrentNodeIsStartElement();
            var array = new Array(4096);
            for (var _ai = 0; _ai < array.length; ++_ai)
                array[_ai] = 0;
            var memoryStream = new MemoryStream();
            var result;
            try {
                var num;
                do {
                    num = this.xmlReader.ReadElementContentAsBase64(array, 0, 4096);
                    if (num > 0) {
                        memoryStream.Write(array, 0, num);
                    }
                } while (num > 0);
                result = ((memoryStream.Length === memoryStream.Capacity) ? memoryStream.GetBuffer() : memoryStream.ToArray());
            }
            finally {
                if (memoryStream !== null) {
                    memoryStream.Dispose();
                }
            }
            return result;
        };
        EwsXmlReader.prototype.ReadBase64ElementValue_1 = function (outputStream) {
            this.EnsureCurrentNodeIsStartElement();
            var array = new Array(4096);
            for (var _ai = 0; _ai < array.length; ++_ai)
                array[_ai] = 0;
            var num;
            do {
                num = this.xmlReader.ReadElementContentAsBase64(array, 0, 4096);
                if (num > 0) {
                    outputStream.Write(array, 0, num);
                }
            } while (num > 0);
            outputStream.Flush();
        };
        EwsXmlReader.prototype.ReadStartElement = function (namespacePrefixOrXmlNamespace, localName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (localName === null || localName.constructor === String)) {
                this.ReadStartElement_0(namespacePrefixOrXmlNamespace, localName);
                return;
            }
            this.ReadStartElement_1(namespacePrefixOrXmlNamespace, localName);
        };
        EwsXmlReader.prototype.ReadStartElement_0 = function (namespacePrefix, localName) {
            this.InternalReadElement(namespacePrefix, localName, 1);
        };
        EwsXmlReader.prototype.ReadStartElement_1 = function (xmlNamespace, localName) {
            this.InternalReadElement(xmlNamespace, localName, 1);
        };
        EwsXmlReader.prototype.ReadEndElement = function (namespacePrefixOrXmlNamespace, elementNameOrLocalName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (elementNameOrLocalName === null || elementNameOrLocalName.constructor === String)) {
                this.ReadEndElement_0(namespacePrefixOrXmlNamespace, elementNameOrLocalName);
                return;
            }
            this.ReadEndElement_1(namespacePrefixOrXmlNamespace, elementNameOrLocalName);
        };
        EwsXmlReader.prototype.ReadEndElement_0 = function (namespacePrefix, elementName) {
            this.InternalReadElement(namespacePrefix, elementName, 15);
        };
        EwsXmlReader.prototype.ReadEndElement_1 = function (xmlNamespace, localName) {
            this.InternalReadElement(xmlNamespace, localName, 15);
        };
        EwsXmlReader.prototype.ReadEndElementIfNecessary = function (xmlNamespace, localName) {
            if ((!this.IsStartElement(xmlNamespace, localName) || !this.IsEmptyElement) && !this.IsEndElement(xmlNamespace, localName)) {
                this.ReadEndElement(xmlNamespace, localName);
            }
        };
        EwsXmlReader.prototype.IsStartElement = function (namespacePrefixOrXmlNamespace, localName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (localName === null || localName.constructor === String)) {
                return this.IsStartElement_0(namespacePrefixOrXmlNamespace, localName);
            }
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === Number) && (localName === null || localName.constructor === String)) {
                return this.IsStartElement_1(namespacePrefixOrXmlNamespace, localName);
            }
            return this.IsStartElement_2();
        };
        EwsXmlReader.prototype.IsStartElement_0 = function (namespacePrefix, localName) {
            var b = EwsXmlReader.FormatElementName(namespacePrefix, localName);
            return this.NodeType === 1 && this.xmlReader.get_Name() === b;
        };
        EwsXmlReader.prototype.IsStartElement_1 = function (xmlNamespace, localName) {
            return this.LocalName === localName && this.IsStartElement() && (this.NamespacePrefix === EwsUtilities.GetNamespacePrefix(xmlNamespace) || this.NamespaceUri === EwsUtilities.GetNamespaceUri(xmlNamespace));
        };
        EwsXmlReader.prototype.IsStartElement_2 = function () {
            return this.NodeType === 1;
        };
        EwsXmlReader.prototype.IsEndElement = function (namespacePrefixOrXmlNamespace, localName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (localName === null || localName.constructor === String)) {
                return this.IsEndElement_0(namespacePrefixOrXmlNamespace, localName);
            }
            return this.IsEndElement_1(namespacePrefixOrXmlNamespace, localName);
        };
        EwsXmlReader.prototype.IsEndElement_0 = function (namespacePrefix, localName) {
            var b = EwsXmlReader.FormatElementName(namespacePrefix, localName);
            return this.NodeType === 15 && this.xmlReader.get_Name() === b;
        };
        EwsXmlReader.prototype.IsEndElement_1 = function (xmlNamespace, localName) {
            return this.LocalName === localName && this.NodeType === 15 && (this.NamespacePrefix === EwsUtilities.GetNamespacePrefix(xmlNamespace) || this.NamespaceUri === EwsUtilities.GetNamespaceUri(xmlNamespace));
        };
        EwsXmlReader.prototype.SkipElement = function (namespacePrefixOrXmlNamespace, localName) {
            if (arguments.length === 2 && (namespacePrefixOrXmlNamespace === null || namespacePrefixOrXmlNamespace.constructor === String) && (localName === null || localName.constructor === String)) {
                this.SkipElement_0(namespacePrefixOrXmlNamespace, localName);
                return;
            }
            this.SkipElement_1(namespacePrefixOrXmlNamespace, localName);
        };
        EwsXmlReader.prototype.SkipElement_0 = function (namespacePrefix, localName) {
            if (!this.IsEndElement(namespacePrefix, localName)) {
                if (!this.IsStartElement(namespacePrefix, localName)) {
                    this.ReadStartElement(namespacePrefix, localName);
                }
                if (!this.IsEmptyElement) {
                    do {
                        this.Read();
                    } while (!this.IsEndElement(namespacePrefix, localName));
                }
            }
        };
        EwsXmlReader.prototype.SkipElement_1 = function (xmlNamespace, localName) {
            if (!this.IsEndElement(xmlNamespace, localName)) {
                if (!this.IsStartElement(xmlNamespace, localName)) {
                    this.ReadStartElement(xmlNamespace, localName);
                }
                if (!this.IsEmptyElement) {
                    do {
                        this.Read();
                    } while (!this.IsEndElement(xmlNamespace, localName));
                }
            }
        };
        EwsXmlReader.prototype.SkipCurrentElement = function () {
            this.SkipElement(this.NamespacePrefix, this.LocalName);
        };
        EwsXmlReader.prototype.EnsureCurrentNodeIsStartElement = function (xmlNamespace, localName) {
            if (arguments.length === 2 && (xmlNamespace === null || xmlNamespace.constructor === Number) && (localName === null || localName.constructor === String)) {
                this.EnsureCurrentNodeIsStartElement_0(xmlNamespace, localName);
                return;
            }
            this.EnsureCurrentNodeIsStartElement_1();
        };
        EwsXmlReader.prototype.EnsureCurrentNodeIsStartElement_0 = function (xmlNamespace, localName) {
            if (!this.IsStartElement(xmlNamespace, localName)) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.ElementNotFound, localName, xmlNamespace));
            }
        };
        EwsXmlReader.prototype.EnsureCurrentNodeIsStartElement_1 = function () {
            if (this.NodeType !== 1) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.ExpectedStartElement, this.xmlReader.get_Name(), this.NodeType));
            }
        };
        EwsXmlReader.prototype.EnsureCurrentNodeIsEndElement = function (xmlNamespace, localName) {
            if (!this.IsEndElement(xmlNamespace, localName) && (!this.IsStartElement(xmlNamespace, localName) || !this.IsEmptyElement)) {
                throw new ServiceXmlDeserializationException(NString.Format(Strings.ElementNotFound, localName, xmlNamespace));
            }
        };
        EwsXmlReader.prototype.ReadOuterXml = function () {
            if (!this.IsStartElement()) {
                throw new ServiceXmlDeserializationException(Strings.CurrentPositionNotElementStart);
            }
            return this.xmlReader.ReadOuterXml();
        };
        EwsXmlReader.prototype.ReadInnerXml = function () {
            if (!this.IsStartElement()) {
                throw new ServiceXmlDeserializationException(Strings.CurrentPositionNotElementStart);
            }
            return this.xmlReader.ReadInnerXml();
        };
        EwsXmlReader.prototype.GetXmlReaderForNode = function () {
            return this.xmlReader.ReadSubtree();
        };
        EwsXmlReader.prototype.ReadToDescendant = function (xmlNamespace, localName) {
            this.xmlReader.ReadToDescendant(localName, EwsUtilities.GetNamespaceUri(xmlNamespace));
        };
        EwsXmlReader.ReadWriteBufferSize = 4096;
        return EwsXmlReader;
    }());
    var EwsServiceXmlReader = (function (_super) {
        __extends(EwsServiceXmlReader, _super);
        function EwsServiceXmlReader(stream, service) {
            _super.call(this, stream);
            this.service = null;
            this.service = service;
        }
        Object.defineProperty(EwsServiceXmlReader.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        EwsServiceXmlReader.prototype.ConvertStringToDateTime = function (dateTimeString) {
            return this.Service.ConvertUniversalDateTimeStringToLocalDateTime(dateTimeString);
        };
        EwsServiceXmlReader.prototype.ConvertStringToUnspecifiedDate = function (dateTimeString) {
            return this.Service.ConvertStartDateToUnspecifiedDateTime(dateTimeString);
        };
        EwsServiceXmlReader.prototype.ReadElementValueAsDateTime = function (xmlNamespace, localName) {
            if (arguments.length === 0) {
                return this.ReadElementValueAsDateTime_0();
            }
            return this.ReadElementValueAsDateTime_1(xmlNamespace, localName);
        };
        EwsServiceXmlReader.prototype.ReadElementValueAsDateTime_0 = function () {
            return this.ConvertStringToDateTime(_super.prototype.ReadElementValue.call(this));
        };
        EwsServiceXmlReader.prototype.ReadElementValueAsUnspecifiedDate = function () {
            return this.ConvertStringToUnspecifiedDate(_super.prototype.ReadElementValue.call(this));
        };
        EwsServiceXmlReader.prototype.ReadElementValueAsUnbiasedDateTimeScopedToServiceTimeZone = function () {
            var dateString = _super.prototype.ReadElementValue.call(this);
            return EwsUtilities.ParseAsUnbiasedDatetimescopedToServicetimeZone(dateString, this.Service);
        };
        EwsServiceXmlReader.prototype.ReadElementValueAsDateTime_1 = function (xmlNamespace, localName) {
            return this.ConvertStringToDateTime(_super.prototype.ReadElementValue.call(this, xmlNamespace, localName));
        };
        EwsServiceXmlReader.prototype.ReadServiceObjectsCollectionFromXml = function (collectionXmlNamespaceOrCollectionXmlElementName, collectionXmlElementNameOrGetObjectInstanceDelegate, getObjectInstanceDelegateOrClearPropertyBag, clearPropertyBagOrRequestedPropertySet, requestedPropertySetOrSummaryPropertiesOnly, summaryPropertiesOnly) {
            if (arguments.length === 6 && (collectionXmlNamespaceOrCollectionXmlElementName === null || collectionXmlNamespaceOrCollectionXmlElementName.constructor === Number) && (collectionXmlElementNameOrGetObjectInstanceDelegate === null || collectionXmlElementNameOrGetObjectInstanceDelegate.constructor === String) && (clearPropertyBagOrRequestedPropertySet === null || clearPropertyBagOrRequestedPropertySet.constructor === Boolean) && (requestedPropertySetOrSummaryPropertiesOnly === null || requestedPropertySetOrSummaryPropertiesOnly instanceof PropertySet) && (summaryPropertiesOnly === null || summaryPropertiesOnly.constructor === Boolean)) {
                return this.ReadServiceObjectsCollectionFromXml_0(collectionXmlNamespaceOrCollectionXmlElementName, collectionXmlElementNameOrGetObjectInstanceDelegate, getObjectInstanceDelegateOrClearPropertyBag, clearPropertyBagOrRequestedPropertySet, requestedPropertySetOrSummaryPropertiesOnly, summaryPropertiesOnly);
            }
            return this.ReadServiceObjectsCollectionFromXml_1(collectionXmlNamespaceOrCollectionXmlElementName, collectionXmlElementNameOrGetObjectInstanceDelegate, getObjectInstanceDelegateOrClearPropertyBag, clearPropertyBagOrRequestedPropertySet, requestedPropertySetOrSummaryPropertiesOnly);
        };
        EwsServiceXmlReader.prototype.ReadServiceObjectsCollectionFromXml_0 = function (collectionXmlNamespace, collectionXmlElementName, getObjectInstanceDelegate, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            var list = new List();
            var tServiceObject = null;
            if (!_super.prototype.IsStartElement.call(this, collectionXmlNamespace, collectionXmlElementName)) {
                _super.prototype.ReadStartElement.call(this, collectionXmlNamespace, collectionXmlElementName);
            }
            if (!this.IsEmptyElement) {
                while (true) {
                    _super.prototype.Read.call(this);
                    if (_super.prototype.IsStartElement.call(this)) {
                        tServiceObject = getObjectInstanceDelegate(this.Service, this.LocalName);
                        if (tServiceObject === null) {
                            _super.prototype.SkipCurrentElement.call(this);
                        }
                        else {
                            if (NString.Compare(this.LocalName, tServiceObject.GetXmlElementName(), StringComparison.Ordinal) !== 0) {
                                break;
                            }
                            tServiceObject.LoadFromXml(this, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
                            list.Add(tServiceObject);
                        }
                    }
                    if (_super.prototype.IsEndElement.call(this, collectionXmlNamespace, collectionXmlElementName)) {
                        return list;
                    }
                }
                throw new ServiceLocalException(NString.Format("The type of the object in the store ({0}) does not match that of the local object ({1}).", this.LocalName, tServiceObject.GetXmlElementName()));
            }
            return list;
        };
        EwsServiceXmlReader.prototype.ReadServiceObjectsCollectionFromXml_1 = function (collectionXmlElementName, getObjectInstanceDelegate, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            return this.ReadServiceObjectsCollectionFromXml(XmlNamespace.Messages, collectionXmlElementName, getObjectInstanceDelegate, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
        };
        return EwsServiceXmlReader;
    }(EwsXmlReader));
    var EwsServiceMultiResponseXmlReader = (function (_super) {
        __extends(EwsServiceMultiResponseXmlReader, _super);
        function EwsServiceMultiResponseXmlReader(stream, service) {
            _super.call(this, stream, service);
        }
        EwsServiceMultiResponseXmlReader.Create = function (stream, service) {
            return new EwsServiceMultiResponseXmlReader(stream, service);
        };
        EwsServiceMultiResponseXmlReader.CreateXmlReader = function (stream) {
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ConformanceLevel(0);
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_IgnoreComments(true);
            xmlReaderSettings.set_IgnoreProcessingInstructions(true);
            xmlReaderSettings.set_IgnoreWhitespace(true);
            xmlReaderSettings.set_XmlResolver(null);
            var xmlReaderSettings2 = xmlReaderSettings;
            return XmlReader.Create(stream, xmlReaderSettings2);
        };
        EwsServiceMultiResponseXmlReader.prototype.InitializeXmlReader = function (stream) {
            return EwsServiceMultiResponseXmlReader.CreateXmlReader(stream);
        };
        return EwsServiceMultiResponseXmlReader;
    }(EwsServiceXmlReader));
    var EwsServiceJsonReader = (function () {
        function EwsServiceJsonReader(service) {
            this.Service = null;
            _super.call(this);
            this.Service = service;
        }
        EwsServiceJsonReader.prototype.ReadServiceObjectsCollectionFromJson = function (jsonResponse, collectionJsonElementName, getObjectInstanceDelegate, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly) {
            var list = new List();
            var tServiceObject = null;
            var array = jsonResponse.ReadAsArray(collectionJsonElementName);
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var obj = array2[i];
                var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                if (jsonObject !== null) {
                    tServiceObject = getObjectInstanceDelegate(this.Service, jsonObject.ReadTypeString());
                    if (tServiceObject !== null) {
                        if (NString.Compare(jsonObject.ReadTypeString(), tServiceObject.GetXmlElementName(), StringComparison.Ordinal) !== 0) {
                            throw new ServiceLocalException(NString.Format("The type of the object in the store ({0}) does not match that of the local object ({1}).", jsonObject.ReadTypeString(), tServiceObject.GetXmlElementName()));
                        }
                        tServiceObject.LoadFromJson(jsonObject, this.Service, clearPropertyBag, requestedPropertySet, summaryPropertiesOnly);
                        list.Add(tServiceObject);
                    }
                }
            }
            return list;
        };
        return EwsServiceJsonReader;
    }());
    var EwsServiceXmlWriter = (function () {
        function EwsServiceXmlWriter(service, stream) {
            this.isDisposed = false;
            this.service = null;
            this.xmlWriter = null;
            this.isTimeZoneHeaderEmitted = false;
            this.requireWSSecurityUtilityNamespace = false;
            _super.call(this);
            this.service = service;
            var xmlWriterSettings = new XmlWriterSettings();
            xmlWriterSettings.set_Indent(true);
            xmlWriterSettings.set_Encoding(EwsServiceXmlWriter.utf8Encoding);
            this.xmlWriter = XmlWriter.Create(stream, xmlWriterSettings);
        }
        Object.defineProperty(EwsServiceXmlWriter.prototype, "InternalWriter", {
            get: function () {
                return this.xmlWriter;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsServiceXmlWriter.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsServiceXmlWriter.prototype, "IsTimeZoneHeaderEmitted", {
            get: function () {
                return this.isTimeZoneHeaderEmitted;
            },
            set: function (value) {
                this.isTimeZoneHeaderEmitted = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EwsServiceXmlWriter.prototype, "RequireWSSecurityUtilityNamespace", {
            get: function () {
                return this.requireWSSecurityUtilityNamespace;
            },
            set: function (value) {
                this.requireWSSecurityUtilityNamespace = value;
            },
            enumerable: true,
            configurable: true
        });
        EwsServiceXmlWriter.prototype.TryConvertObjectToString = function (value, strValue) {
            strValue[0] = null;
            var result = true;
            if (value !== null) {
                var convertible = ((value instanceof IConvertible) ? value : null);
                if (value.GetType().IsEnum) {
                    strValue[0] = EwsUtilities.SerializeEnum(value);
                }
                else {
                    if (convertible !== null) {
                        var typeCode = convertible.GetTypeCode();
                        if (typeCode !== TypeCode.Boolean) {
                            if (typeCode !== TypeCode.DateTime) {
                                strValue[0] = convertible.ToString(CultureInfo.InvariantCulture);
                            }
                            else {
                                strValue[0] = this.Service.ConvertDateTimeToUniversalDateTimeString(value);
                            }
                        }
                        else {
                            strValue[0] = EwsUtilities.BoolToXSBool(value);
                        }
                    }
                    else {
                        var formattable = ((value instanceof IFormattable) ? value : null);
                        if (formattable !== null) {
                            strValue[0] = formattable.ToString(null, null);
                        }
                        else {
                            if (value instanceof ISearchStringProvider) {
                                var searchStringProvider = ((value instanceof ISearchStringProvider) ? value : null);
                                strValue[0] = searchStringProvider.GetSearchString();
                            }
                            else {
                                if (value instanceof number[]) {
                                    strValue[0] = Convert.ToBase64String(value);
                                }
                                else {
                                    result = false;
                                }
                            }
                        }
                    }
                }
            }
            return result;
        };
        EwsServiceXmlWriter.prototype.Dispose = function () {
            if (!this.isDisposed) {
                this.xmlWriter.Close();
                this.isDisposed = true;
            }
        };
        EwsServiceXmlWriter.prototype.Flush = function () {
            this.xmlWriter.Flush();
        };
        EwsServiceXmlWriter.prototype.WriteStartElement = function (xmlNamespace, localName) {
            this.xmlWriter.WriteStartElement(EwsUtilities.GetNamespacePrefix(xmlNamespace), localName, EwsUtilities.GetNamespaceUri(xmlNamespace));
        };
        EwsServiceXmlWriter.prototype.WriteEndElement = function () {
            this.xmlWriter.WriteEndElement();
        };
        EwsServiceXmlWriter.prototype.WriteAttributeValue = function (localNameOrNamespacePrefix, valueOrAlwaysWriteEmptyStringOrLocalName, value) {
            if (arguments.length === 2 && (localNameOrNamespacePrefix === null || localNameOrNamespacePrefix.constructor === String) && (valueOrAlwaysWriteEmptyStringOrLocalName === null || valueOrAlwaysWriteEmptyStringOrLocalName.constructor === Object)) {
                this.WriteAttributeValue_0(localNameOrNamespacePrefix, valueOrAlwaysWriteEmptyStringOrLocalName);
                return;
            }
            if (arguments.length === 3 && (localNameOrNamespacePrefix === null || localNameOrNamespacePrefix.constructor === String) && (valueOrAlwaysWriteEmptyStringOrLocalName === null || valueOrAlwaysWriteEmptyStringOrLocalName.constructor === Boolean) && (value === null || value.constructor === Object)) {
                this.WriteAttributeValue_1(localNameOrNamespacePrefix, valueOrAlwaysWriteEmptyStringOrLocalName, value);
                return;
            }
            this.WriteAttributeValue_2(localNameOrNamespacePrefix, valueOrAlwaysWriteEmptyStringOrLocalName, value);
        };
        EwsServiceXmlWriter.prototype.WriteAttributeValue_0 = function (localName, value) {
            this.WriteAttributeValue(localName, false, value);
        };
        EwsServiceXmlWriter.prototype.WriteAttributeValue_1 = function (localName, alwaysWriteEmptyString, value) {
            var _this = this;
            var text;
            if (!(function () {
                var _p0 = [
                    text
                ];
                var _r = _this.TryConvertObjectToString(value, _p0);
                text = _p0[0];
                return _r;
            })()) {
                throw new ServiceXmlSerializationException(NString.Format(Strings.AttributeValueCannotBeSerialized, value.GetType().Name, localName));
            }
            if (text !== null && (alwaysWriteEmptyString || text.length !== 0)) {
                this.WriteAttributeString(localName, text);
                return;
            }
        };
        EwsServiceXmlWriter.prototype.WriteAttributeValue_2 = function (namespacePrefix, localName, value) {
            var _this = this;
            var text;
            if (!(function () {
                var _p0 = [
                    text
                ];
                var _r = _this.TryConvertObjectToString(value, _p0);
                text = _p0[0];
                return _r;
            })()) {
                throw new ServiceXmlSerializationException(NString.Format(Strings.AttributeValueCannotBeSerialized, value.GetType().Name, localName));
            }
            if (!NString.IsNullOrEmpty(text)) {
                this.WriteAttributeString(namespacePrefix, localName, text);
                return;
            }
        };
        EwsServiceXmlWriter.prototype.WriteAttributeString = function (localNameOrNamespacePrefix, stringValueOrLocalName, stringValue) {
            if (arguments.length === 2 && (localNameOrNamespacePrefix === null || localNameOrNamespacePrefix.constructor === String) && (stringValueOrLocalName === null || stringValueOrLocalName.constructor === String)) {
                this.WriteAttributeString_0(localNameOrNamespacePrefix, stringValueOrLocalName);
                return;
            }
            this.WriteAttributeString_1(localNameOrNamespacePrefix, stringValueOrLocalName, stringValue);
        };
        EwsServiceXmlWriter.prototype.WriteAttributeString_0 = function (localName, stringValue) {
            try {
                this.xmlWriter.WriteAttributeString(localName, stringValue);
            }
            catch (innerException) {
                if (innerException instanceof ArgumentException) {
                    throw new ServiceXmlSerializationException(NString.Format(Strings.InvalidAttributeValue, stringValue, localName), innerException);
                }
                else
                    throw innerException;
            }
        };
        EwsServiceXmlWriter.prototype.WriteAttributeString_1 = function (namespacePrefix, localName, stringValue) {
            try {
                this.xmlWriter.WriteAttributeString(namespacePrefix, localName, null, stringValue);
            }
            catch (innerException) {
                if (innerException instanceof ArgumentException) {
                    throw new ServiceXmlSerializationException(NString.Format(Strings.InvalidAttributeValue, stringValue, localName), innerException);
                }
                else
                    throw innerException;
            }
        };
        EwsServiceXmlWriter.prototype.WriteValue = function (value, name) {
            try {
                this.xmlWriter.WriteValue(value);
            }
            catch (innerException) {
                if (innerException instanceof ArgumentException) {
                    throw new ServiceXmlSerializationException(NString.Format(Strings.InvalidElementStringValue, value, name), innerException);
                }
                else
                    throw innerException;
            }
        };
        EwsServiceXmlWriter.prototype.WriteElementValue = function (xmlNamespace, localName, displayNameOrValue, value) {
            if (arguments.length === 4 && (xmlNamespace === null || xmlNamespace.constructor === Number) && (localName === null || localName.constructor === String) && (displayNameOrValue === null || displayNameOrValue.constructor === String) && (value === null || value.constructor === Object)) {
                this.WriteElementValue_0(xmlNamespace, localName, displayNameOrValue, value);
                return;
            }
            this.WriteElementValue_1(xmlNamespace, localName, displayNameOrValue);
        };
        EwsServiceXmlWriter.prototype.WriteElementValue_0 = function (xmlNamespace, localName, displayName, value) {
            var _this = this;
            var text;
            if (!(function () {
                var _p0 = [
                    text
                ];
                var _r = _this.TryConvertObjectToString(value, _p0);
                text = _p0[0];
                return _r;
            })()) {
                throw new ServiceXmlSerializationException(NString.Format(Strings.ElementValueCannotBeSerialized, value.GetType().Name, localName));
            }
            if (text !== null) {
                this.WriteStartElement(xmlNamespace, localName);
                this.WriteValue(text, displayName);
                this.WriteEndElement();
                return;
            }
        };
        EwsServiceXmlWriter.prototype.WriteNode = function (xmlNode) {
            if (xmlNode !== null) {
                xmlNode.WriteTo(this.xmlWriter);
            }
        };
        EwsServiceXmlWriter.prototype.WriteElementValue_1 = function (xmlNamespace, localName, value) {
            this.WriteElementValue(xmlNamespace, localName, localName, value);
        };
        EwsServiceXmlWriter.prototype.WriteBase64ElementValue = function (bufferOrStream) {
            if (arguments.length === 1 && (bufferOrStream === null || bufferOrStream instanceof Array)) {
                this.WriteBase64ElementValue_0(bufferOrStream);
                return;
            }
            this.WriteBase64ElementValue_1(bufferOrStream);
        };
        EwsServiceXmlWriter.prototype.WriteBase64ElementValue_0 = function (buffer) {
            this.xmlWriter.WriteBase64(buffer, 0, buffer.length);
        };
        EwsServiceXmlWriter.prototype.WriteBase64ElementValue_1 = function (stream) {
            var array = new Array(4096);
            for (var _ai = 0; _ai < array.length; ++_ai)
                array[_ai] = 0;
            var binaryReader = new BinaryReader(stream);
            try {
                var num;
                do {
                    num = binaryReader.Read(array, 0, 4096);
                    if (num > 0) {
                        this.xmlWriter.WriteBase64(array, 0, num);
                    }
                } while (num > 0);
            }
            finally {
                if (binaryReader !== null) {
                    binaryReader.Dispose();
                }
            }
        };
        EwsServiceXmlWriter.BufferSize = 4096;
        EwsServiceXmlWriter.utf8Encoding = new UTF8Encoding(false);
        return EwsServiceXmlWriter;
    }());
    var ExchangeServerInfo = (function () {
        function ExchangeServerInfo() {
            this.majorVersion = 0;
            this.minorVersion = 0;
            this.majorBuildNumber = 0;
            this.minorBuildNumber = 0;
            this.versionString = null;
            _super.call(this);
        }
        Object.defineProperty(ExchangeServerInfo.prototype, "MajorVersion", {
            get: function () {
                return this.majorVersion;
            },
            set: function (value) {
                this.majorVersion = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServerInfo.prototype, "MinorVersion", {
            get: function () {
                return this.minorVersion;
            },
            set: function (value) {
                this.minorVersion = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServerInfo.prototype, "MajorBuildNumber", {
            get: function () {
                return this.majorBuildNumber;
            },
            set: function (value) {
                this.majorBuildNumber = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServerInfo.prototype, "MinorBuildNumber", {
            get: function () {
                return this.minorBuildNumber;
            },
            set: function (value) {
                this.minorBuildNumber = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeServerInfo.prototype, "VersionString", {
            get: function () {
                return this.versionString;
            },
            set: function (value) {
                this.versionString = value;
            },
            enumerable: true,
            configurable: true
        });
        ExchangeServerInfo.Parse = function (readerOrJsonObject) {
            if (arguments.length === 1 && (readerOrJsonObject === null || readerOrJsonObject instanceof EwsServiceXmlReader)) {
                return ExchangeServerInfo.Parse_0(readerOrJsonObject);
            }
            return ExchangeServerInfo.Parse_1(readerOrJsonObject);
        };
        ExchangeServerInfo.Parse_0 = function (reader) {
            EwsUtilities.Assert(reader.HasAttributes, "ExchangeServerVersion.Parse", "Current element doesn't have attributes");
            var exchangeServerInfo = new ExchangeServerInfo();
            exchangeServerInfo.MajorVersion = reader.ReadAttributeValue("MajorVersion");
            exchangeServerInfo.MinorVersion = reader.ReadAttributeValue("MinorVersion");
            exchangeServerInfo.MajorBuildNumber = reader.ReadAttributeValue("MajorBuildNumber");
            exchangeServerInfo.MinorBuildNumber = reader.ReadAttributeValue("MinorBuildNumber");
            exchangeServerInfo.VersionString = reader.ReadAttributeValue("Version");
            return exchangeServerInfo;
        };
        ExchangeServerInfo.Parse_1 = function (jsonObject) {
            var exchangeServerInfo = new ExchangeServerInfo();
            exchangeServerInfo.MajorVersion = jsonObject.ReadAsInt("MajorVersion");
            exchangeServerInfo.MinorVersion = jsonObject.ReadAsInt("MinorVersion");
            exchangeServerInfo.MajorBuildNumber = jsonObject.ReadAsInt("MajorBuildNumber");
            exchangeServerInfo.MinorBuildNumber = jsonObject.ReadAsInt("MinorBuildNumber");
            exchangeServerInfo.VersionString = jsonObject.ReadAsString("Version");
            return exchangeServerInfo;
        };
        ExchangeServerInfo.prototype.ToString = function () {
            return NString.Format("{0:d}.{1:d2}.{2:d4}.{3:d3}", [
                this.MajorVersion, this.MinorVersion, this.MajorBuildNumber, this.MinorBuildNumber
            ]);
        };
        return ExchangeServerInfo;
    }());
    var ExchangeService = (function (_super) {
        __extends(ExchangeService, _super);
        function ExchangeService(timeZoneOrRequestedServerVersionOrTargetServerVersion, timeZone) {
            _super.call(this);
            this.url = null;
            this.preferredCulture = null;
            this.dateTimePrecision = 0;
            this.impersonatedUserId = null;
            this.privilegedUserId = null;
            this.managementRoles = null;
            this.fileAttachmentContentHandler = null;
            this.unifiedMessaging = null;
            this.enableScpLookup = true;
            this.renderingMode = 0;
            this.traceEnablePrettyPrinting = true;
            this.targetServerVersion = null;
            this.exchange2007CompatibilityMode = false;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (timeZoneOrRequestedServerVersionOrTargetServerVersion === null || timeZoneOrRequestedServerVersionOrTargetServerVersion instanceof TimeZoneInfo)) {
                this.constructor_1(timeZoneOrRequestedServerVersionOrTargetServerVersion);
                return;
            }
            if (arguments.length === 1 && (timeZoneOrRequestedServerVersionOrTargetServerVersion === null || timeZoneOrRequestedServerVersionOrTargetServerVersion.constructor === Number)) {
                this.constructor_2(timeZoneOrRequestedServerVersionOrTargetServerVersion);
                return;
            }
            if (arguments.length === 2 && (timeZoneOrRequestedServerVersionOrTargetServerVersion === null || timeZoneOrRequestedServerVersionOrTargetServerVersion.constructor === Number) && (timeZone === null || timeZone instanceof TimeZoneInfo)) {
                this.constructor_3(timeZoneOrRequestedServerVersionOrTargetServerVersion, timeZone);
                return;
            }
            if (arguments.length === 1 && (timeZoneOrRequestedServerVersionOrTargetServerVersion === null || timeZoneOrRequestedServerVersionOrTargetServerVersion.constructor === String)) {
                this.constructor_4(timeZoneOrRequestedServerVersionOrTargetServerVersion);
                return;
            }
            this.constructor_5(timeZoneOrRequestedServerVersionOrTargetServerVersion, timeZone);
        }
        Object.defineProperty(ExchangeService.prototype, "Url", {
            get: function () {
                return this.url;
            },
            set: function (value) {
                this.url = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "ImpersonatedUserId", {
            get: function () {
                return this.impersonatedUserId;
            },
            set: function (value) {
                this.impersonatedUserId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "PrivilegedUserId", {
            get: function () {
                return this.privilegedUserId;
            },
            set: function (value) {
                this.privilegedUserId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "ManagementRoles", {
            get: function () {
                return this.managementRoles;
            },
            set: function (value) {
                this.managementRoles = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "PreferredCulture", {
            get: function () {
                return this.preferredCulture;
            },
            set: function (value) {
                this.preferredCulture = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "DateTimePrecision", {
            get: function () {
                return this.dateTimePrecision;
            },
            set: function (value) {
                this.dateTimePrecision = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "FileAttachmentContentHandler", {
            get: function () {
                return this.fileAttachmentContentHandler;
            },
            set: function (value) {
                this.fileAttachmentContentHandler = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "TimeZone", {
            get: function () {
                return this.TimeZone;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "UnifiedMessaging", {
            get: function () {
                if (this.unifiedMessaging === null) {
                    this.unifiedMessaging = new UnifiedMessaging(this);
                }
                return this.unifiedMessaging;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "EnableScpLookup", {
            get: function () {
                return this.enableScpLookup;
            },
            set: function (value) {
                this.enableScpLookup = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "Exchange2007CompatibilityMode", {
            get: function () {
                return this.exchange2007CompatibilityMode;
            },
            set: function (value) {
                this.exchange2007CompatibilityMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "RenderingMethod", {
            get: function () {
                return this.renderingMode;
            },
            set: function (value) {
                this.renderingMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "TraceEnablePrettyPrinting", {
            get: function () {
                return this.traceEnablePrettyPrinting;
            },
            set: function (value) {
                this.traceEnablePrettyPrinting = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeService.prototype, "TargetServerVersion", {
            get: function () {
                return this.targetServerVersion;
            },
            set: function (value) {
                ExchangeService.ValidateTargetVersion(value);
                this.targetServerVersion = value;
            },
            enumerable: true,
            configurable: true
        });
        ExchangeService.prototype.InternalCreateResponseObject = function (responseObject, parentFolderId, messageDisposition) {
            var createResponseObjectRequest = new CreateResponseObjectRequest(this, ServiceErrorHandling.ThrowOnError);
            createResponseObjectRequest.ParentFolderId = parentFolderId;
            createResponseObjectRequest.Items = [
                responseObject
            ];
            createResponseObjectRequest.MessageDisposition = messageDisposition;
            var serviceResponseCollection = createResponseObjectRequest.Execute();
            return serviceResponseCollection.get_Item(0).Items;
        };
        ExchangeService.prototype.CreateFolder = function (folder, parentFolderId) {
            var createFolderRequest = new CreateFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            createFolderRequest.Folders = [
                folder
            ];
            createFolderRequest.ParentFolderId = parentFolderId;
            createFolderRequest.Execute();
        };
        ExchangeService.prototype.UpdateFolder = function (folder) {
            var updateFolderRequest = new UpdateFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            updateFolderRequest.Folders.Add(folder);
            updateFolderRequest.Execute();
        };
        ExchangeService.prototype.CopyFolder = function (folderId, destinationFolderId) {
            var copyFolderRequest = new CopyFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            copyFolderRequest.DestinationFolderId = destinationFolderId;
            copyFolderRequest.FolderIds.Add(folderId);
            var serviceResponseCollection = copyFolderRequest.Execute();
            return serviceResponseCollection.get_Item(0).Folder;
        };
        ExchangeService.prototype.MoveFolder = function (folderId, destinationFolderId) {
            var moveFolderRequest = new MoveFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            moveFolderRequest.DestinationFolderId = destinationFolderId;
            moveFolderRequest.FolderIds.Add(folderId);
            var serviceResponseCollection = moveFolderRequest.Execute();
            return serviceResponseCollection.get_Item(0).Folder;
        };
        ExchangeService.prototype.InternalFindFolders = function (parentFolderIds, searchFilter, view, errorHandlingMode) {
            var findFolderRequest = new FindFolderRequest(this, errorHandlingMode);
            findFolderRequest.ParentFolderIds.AddRange(parentFolderIds);
            findFolderRequest.SearchFilter = searchFilter;
            findFolderRequest.View = view;
            return findFolderRequest.Execute();
        };
        ExchangeService.prototype.FindFolders = function (parentFolderIdOrParentFolderName, searchFilterOrView, view) {
            if (arguments.length === 3 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrView === null || searchFilterOrView instanceof SearchFilter) && (view === null || view instanceof FolderView)) {
                return this.FindFolders_0(parentFolderIdOrParentFolderName, searchFilterOrView, view);
            }
            if (arguments.length === 2 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrView === null || searchFilterOrView instanceof FolderView)) {
                return this.FindFolders_1(parentFolderIdOrParentFolderName, searchFilterOrView);
            }
            if (arguments.length === 3 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName.constructor === Number) && (searchFilterOrView === null || searchFilterOrView instanceof SearchFilter) && (view === null || view instanceof FolderView)) {
                return this.FindFolders_2(parentFolderIdOrParentFolderName, searchFilterOrView, view);
            }
            return this.FindFolders_3(parentFolderIdOrParentFolderName, searchFilterOrView);
        };
        ExchangeService.prototype.FindFolders_0 = function (parentFolderId, searchFilter, view) {
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var serviceResponseCollection = this.InternalFindFolders(NArray.ToEnumerable([
                parentFolderId
            ]), searchFilter, view, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindFolders_1 = function (parentFolderId, view) {
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            EwsUtilities.ValidateParam(view, "view");
            var serviceResponseCollection = this.InternalFindFolders(NArray.ToEnumerable([
                parentFolderId
            ]), null, view, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindFolders_2 = function (parentFolderName, searchFilter, view) {
            return this.FindFolders(new FolderId(parentFolderName), searchFilter, view);
        };
        ExchangeService.prototype.FindFolders_3 = function (parentFolderName, view) {
            return this.FindFolders(new FolderId(parentFolderName), view);
        };
        ExchangeService.prototype.LoadPropertiesForFolder = function (folder, propertySet) {
            EwsUtilities.ValidateParam(folder, "folder");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            var getFolderRequestForLoad = new GetFolderRequestForLoad(this, ServiceErrorHandling.ThrowOnError);
            getFolderRequestForLoad.FolderIds.Add(folder);
            getFolderRequestForLoad.PropertySet = propertySet;
            getFolderRequestForLoad.Execute();
        };
        ExchangeService.prototype.BindToFolder = function (folderId, propertySet) {
            if (arguments.length === 2 && (folderId === null || folderId instanceof FolderId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return this.BindToFolder_0(folderId, propertySet);
            }
            return this.BindToFolder_1(folderId, propertySet);
        };
        ExchangeService.prototype.BindToFolder_0 = function (folderId, propertySet) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            var getFolderRequest = new GetFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            getFolderRequest.FolderIds.Add(folderId);
            getFolderRequest.PropertySet = propertySet;
            var serviceResponseCollection = getFolderRequest.Execute();
            return serviceResponseCollection.get_Item(0).Folder;
        };
        ExchangeService.prototype.BindToFolder_1 = function (folderId, propertySet) {
            var folder = this.BindToFolder(folderId, propertySet);
            if (folder instanceof TFolder) {
                return folder;
            }
            throw new ServiceLocalException(NString.Format(Strings.FolderTypeNotCompatible, folder.GetType().Name, new Type("TFolder").Name));
        };
        ExchangeService.prototype.DeleteFolder = function (folderId, deleteMode) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            var deleteFolderRequest = new DeleteFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            deleteFolderRequest.FolderIds.Add(folderId);
            deleteFolderRequest.DeleteMode = deleteMode;
            deleteFolderRequest.Execute();
        };
        ExchangeService.prototype.EmptyFolder = function (folderId, deleteMode, deleteSubFolders) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            var emptyFolderRequest = new EmptyFolderRequest(this, ServiceErrorHandling.ThrowOnError);
            emptyFolderRequest.FolderIds.Add(folderId);
            emptyFolderRequest.DeleteMode = deleteMode;
            emptyFolderRequest.DeleteSubFolders = deleteSubFolders;
            emptyFolderRequest.Execute();
        };
        ExchangeService.prototype.MarkAllItemsAsRead = function (folderId, readFlag, suppressReadReceipts) {
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "MarkAllItemsAsRead");
            var markAllItemsAsReadRequest = new MarkAllItemsAsReadRequest(this, ServiceErrorHandling.ThrowOnError);
            markAllItemsAsReadRequest.FolderIds.Add(folderId);
            markAllItemsAsReadRequest.ReadFlag = readFlag;
            markAllItemsAsReadRequest.SuppressReadReceipts = suppressReadReceipts;
            markAllItemsAsReadRequest.Execute();
        };
        ExchangeService.prototype.InternalCreateItems = function (items, parentFolderId, messageDisposition, sendInvitationsMode, errorHandling) {
            var createItemRequest = new CreateItemRequest(this, errorHandling);
            createItemRequest.ParentFolderId = parentFolderId;
            createItemRequest.Items = items;
            createItemRequest.MessageDisposition = messageDisposition;
            createItemRequest.SendInvitationsMode = sendInvitationsMode;
            return createItemRequest.Execute();
        };
        ExchangeService.prototype.CreateItems = function (items, parentFolderId, messageDisposition, sendInvitationsMode) {
            if (!EwsUtilities.TrueForAll(items, function (item) { return item.IsNew; })) {
                throw new ServiceValidationException(Strings.CreateItemsDoesNotHandleExistingItems);
            }
            if (!EwsUtilities.TrueForAll(items, function (item) { return !item.HasUnprocessedAttachmentChanges(); })) {
                throw new ServiceValidationException(Strings.CreateItemsDoesNotAllowAttachments);
            }
            return this.InternalCreateItems(items, parentFolderId, messageDisposition, sendInvitationsMode, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.CreateItem = function (item, parentFolderId, messageDisposition, sendInvitationsMode) {
            this.InternalCreateItems(NArray.ToEnumerable([
                item
            ]), parentFolderId, messageDisposition, sendInvitationsMode, ServiceErrorHandling.ThrowOnError);
        };
        ExchangeService.prototype.InternalUpdateItems = function (items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, errorHandling, suppressReadReceipt) {
            var updateItemRequest = new UpdateItemRequest(this, errorHandling);
            updateItemRequest.Items.AddRange(items);
            updateItemRequest.SavedItemsDestinationFolder = savedItemsDestinationFolderId;
            updateItemRequest.MessageDisposition = messageDisposition;
            updateItemRequest.ConflictResolutionMode = conflictResolution;
            updateItemRequest.SendInvitationsOrCancellationsMode = sendInvitationsOrCancellationsMode;
            updateItemRequest.SuppressReadReceipts = suppressReadReceipt;
            return updateItemRequest.Execute();
        };
        ExchangeService.prototype.UpdateItems = function (items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            if (arguments.length === 5 && (savedItemsDestinationFolderId === null || savedItemsDestinationFolderId instanceof FolderId) && (conflictResolution === null || conflictResolution.constructor === Number) && (messageDisposition === null || messageDisposition instanceof Array) && (sendInvitationsOrCancellationsMode === null || sendInvitationsOrCancellationsMode instanceof Array)) {
                return this.UpdateItems_0(items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode);
            }
            return this.UpdateItems_1(items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts);
        };
        ExchangeService.prototype.UpdateItems_0 = function (items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode) {
            return this.UpdateItems(items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, false);
        };
        ExchangeService.prototype.UpdateItems_1 = function (items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            if (!EwsUtilities.TrueForAll(items, function (item) { return !item.IsNew && item.IsDirty; })) {
                throw new ServiceValidationException(Strings.UpdateItemsDoesNotSupportNewOrUnchangedItems);
            }
            if (!EwsUtilities.TrueForAll(items, function (item) { return !item.HasUnprocessedAttachmentChanges(); })) {
                throw new ServiceValidationException(Strings.UpdateItemsDoesNotAllowAttachments);
            }
            return this.InternalUpdateItems(items, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, ServiceErrorHandling.ReturnErrors, suppressReadReceipts);
        };
        ExchangeService.prototype.UpdateItem = function (item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            if (arguments.length === 5 && (item === null || item instanceof Item) && (savedItemsDestinationFolderId === null || savedItemsDestinationFolderId instanceof FolderId) && (conflictResolution === null || conflictResolution.constructor === Number) && (messageDisposition === null || messageDisposition instanceof Array) && (sendInvitationsOrCancellationsMode === null || sendInvitationsOrCancellationsMode instanceof Array)) {
                return this.UpdateItem_0(item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode);
            }
            return this.UpdateItem_1(item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts);
        };
        ExchangeService.prototype.UpdateItem_0 = function (item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode) {
            return this.UpdateItem(item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, false);
        };
        ExchangeService.prototype.UpdateItem_1 = function (item, savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, suppressReadReceipts) {
            var serviceResponseCollection = this.InternalUpdateItems(NArray.ToEnumerable([
                item
            ]), savedItemsDestinationFolderId, conflictResolution, messageDisposition, sendInvitationsOrCancellationsMode, ServiceErrorHandling.ThrowOnError, suppressReadReceipts);
            return serviceResponseCollection.get_Item(0).ReturnedItem;
        };
        ExchangeService.prototype.SendItem = function (item, savedCopyDestinationFolderId) {
            var sendItemRequest = new SendItemRequest(this, ServiceErrorHandling.ThrowOnError);
            sendItemRequest.Items = [
                item
            ];
            sendItemRequest.SavedCopyDestinationFolderId = savedCopyDestinationFolderId;
            sendItemRequest.Execute();
        };
        ExchangeService.prototype.InternalCopyItems = function (itemIds, destinationFolderId, returnNewItemIds, errorHandling) {
            var copyItemRequest = new CopyItemRequest(this, errorHandling);
            copyItemRequest.ItemIds.AddRange(itemIds);
            copyItemRequest.DestinationFolderId = destinationFolderId;
            copyItemRequest.ReturnNewItemIds = returnNewItemIds;
            return copyItemRequest.Execute();
        };
        ExchangeService.prototype.CopyItems = function (itemIds, destinationFolderId, returnNewItemIds) {
            if (arguments.length === 2 && (destinationFolderId === null || destinationFolderId instanceof FolderId)) {
                return this.CopyItems_0(itemIds, destinationFolderId);
            }
            return this.CopyItems_1(itemIds, destinationFolderId, returnNewItemIds);
        };
        ExchangeService.prototype.CopyItems_0 = function (itemIds, destinationFolderId) {
            return this.InternalCopyItems(itemIds, destinationFolderId, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.CopyItems_1 = function (itemIds, destinationFolderId, returnNewItemIds) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "CopyItems");
            return this.InternalCopyItems(itemIds, destinationFolderId, new Nullable(returnNewItemIds), ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.CopyItem = function (itemId, destinationFolderId) {
            return this.InternalCopyItems(NArray.ToEnumerable([
                itemId
            ]), destinationFolderId, null, ServiceErrorHandling.ThrowOnError).get_Item(0).Item;
        };
        ExchangeService.prototype.InternalMoveItems = function (itemIds, destinationFolderId, returnNewItemIds, errorHandling) {
            var moveItemRequest = new MoveItemRequest(this, errorHandling);
            moveItemRequest.ItemIds.AddRange(itemIds);
            moveItemRequest.DestinationFolderId = destinationFolderId;
            moveItemRequest.ReturnNewItemIds = returnNewItemIds;
            return moveItemRequest.Execute();
        };
        ExchangeService.prototype.MoveItems = function (itemIds, destinationFolderId, returnNewItemIds) {
            if (arguments.length === 2 && (destinationFolderId === null || destinationFolderId instanceof FolderId)) {
                return this.MoveItems_0(itemIds, destinationFolderId);
            }
            return this.MoveItems_1(itemIds, destinationFolderId, returnNewItemIds);
        };
        ExchangeService.prototype.MoveItems_0 = function (itemIds, destinationFolderId) {
            return this.InternalMoveItems(itemIds, destinationFolderId, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.MoveItems_1 = function (itemIds, destinationFolderId, returnNewItemIds) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "MoveItems");
            return this.InternalMoveItems(itemIds, destinationFolderId, new Nullable(returnNewItemIds), ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.MoveItem = function (itemId, destinationFolderId) {
            return this.InternalMoveItems(NArray.ToEnumerable([
                itemId
            ]), destinationFolderId, null, ServiceErrorHandling.ThrowOnError).get_Item(0).Item;
        };
        ExchangeService.prototype.ArchiveItems = function (itemIds, sourceFolderId) {
            var archiveItemRequest = new ArchiveItemRequest(this, ServiceErrorHandling.ReturnErrors);
            archiveItemRequest.Ids.AddRange(itemIds);
            archiveItemRequest.SourceFolderId = sourceFolderId;
            return archiveItemRequest.Execute();
        };
        ExchangeService.prototype.FindItems = function (parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy, groupBy, errorHandlingMode) {
            if (arguments.length === 6 && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy.constructor === String) && (viewOrGroupBy === null || viewOrGroupBy instanceof ViewBase) && (groupBy === null || groupBy instanceof Grouping) && (errorHandlingMode === null || errorHandlingMode.constructor === Number)) {
                return this.FindItems_0(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy, groupBy, errorHandlingMode);
            }
            if (arguments.length === 3 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase)) {
                return this.FindItems_1(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy);
            }
            if (arguments.length === 4 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy.constructor === Boolean) && (viewOrGroupBy === null || viewOrGroupBy instanceof ViewBase)) {
                return this.FindItems_2(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
            }
            if (arguments.length === 5 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy.constructor === Boolean) && (viewOrGroupBy === null || viewOrGroupBy instanceof ViewBase) && (groupBy === null || groupBy instanceof Grouping)) {
                return this.FindItems_3(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy, groupBy);
            }
            if (arguments.length === 3 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase)) {
                return this.FindItems_4(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy);
            }
            if (arguments.length === 2 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof ViewBase)) {
                return this.FindItems_5(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView);
            }
            if (arguments.length === 3 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName.constructor === Number) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase)) {
                return this.FindItems_6(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy);
            }
            if (arguments.length === 3 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName.constructor === Number) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase)) {
                return this.FindItems_7(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy);
            }
            if (arguments.length === 2 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName.constructor === Number) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof ViewBase)) {
                return this.FindItems_8(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView);
            }
            if (arguments.length === 4 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase) && (viewOrGroupBy === null || viewOrGroupBy instanceof Grouping)) {
                return this.FindItems_9(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
            }
            if (arguments.length === 4 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase) && (viewOrGroupBy === null || viewOrGroupBy instanceof Grouping)) {
                return this.FindItems_10(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
            }
            if (arguments.length === 3 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof ViewBase) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof Grouping)) {
                return this.FindItems_11(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy);
            }
            if (arguments.length === 4 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName instanceof FolderId) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView instanceof SearchFilter) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase) && (viewOrGroupBy === null || viewOrGroupBy instanceof Grouping)) {
                return this.FindItems_12(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
            }
            if (arguments.length === 4 && (parentFolderIdsOrParentFolderIdOrParentFolderName === null || parentFolderIdsOrParentFolderIdOrParentFolderName.constructor === Number) && (searchFilterOrQueryStringOrView === null || searchFilterOrQueryStringOrView.constructor === String) && (queryStringOrViewOrReturnHighlightTermsOrGroupBy === null || queryStringOrViewOrReturnHighlightTermsOrGroupBy instanceof ViewBase) && (viewOrGroupBy === null || viewOrGroupBy instanceof Grouping)) {
                return this.FindItems_13(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
            }
            return this.FindItems_14(parentFolderIdsOrParentFolderIdOrParentFolderName, searchFilterOrQueryStringOrView, queryStringOrViewOrReturnHighlightTermsOrGroupBy, viewOrGroupBy);
        };
        ExchangeService.prototype.FindItems_0 = function (parentFolderIds, searchFilter, queryString, view, groupBy, errorHandlingMode) {
            EwsUtilities.ValidateParamCollection(parentFolderIds, "parentFolderIds");
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(groupBy, "groupBy");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var findItemRequest = new FindItemRequest(this, errorHandlingMode);
            findItemRequest.ParentFolderIds.AddRange(parentFolderIds);
            findItemRequest.SearchFilter = searchFilter;
            findItemRequest.QueryString = queryString;
            findItemRequest.View = view;
            findItemRequest.GroupBy = groupBy;
            return findItemRequest.Execute();
        };
        ExchangeService.prototype.FindItems_1 = function (parentFolderId, queryString, view) {
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), null, queryString, view, null, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindItems_2 = function (parentFolderId, queryString, returnHighlightTerms, view) {
            var array = [
                parentFolderId
            ];
            EwsUtilities.ValidateParamCollection(NArray.ToEnumerable(array), "parentFolderIds");
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParamAllowNull(returnHighlightTerms, "returnHighlightTerms");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "FindItems");
            var findItemRequest = new FindItemRequest(this, ServiceErrorHandling.ThrowOnError);
            findItemRequest.ParentFolderIds.AddRange(NArray.ToEnumerable(array));
            findItemRequest.QueryString = queryString;
            findItemRequest.ReturnHighlightTerms = returnHighlightTerms;
            findItemRequest.View = view;
            var serviceResponseCollection = findItemRequest.Execute();
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindItems_3 = function (parentFolderId, queryString, returnHighlightTerms, view, groupBy) {
            var array = [
                parentFolderId
            ];
            EwsUtilities.ValidateParamCollection(NArray.ToEnumerable(array), "parentFolderIds");
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParamAllowNull(returnHighlightTerms, "returnHighlightTerms");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "FindItems");
            var findItemRequest = new FindItemRequest(this, ServiceErrorHandling.ThrowOnError);
            findItemRequest.ParentFolderIds.AddRange(NArray.ToEnumerable(array));
            findItemRequest.QueryString = queryString;
            findItemRequest.ReturnHighlightTerms = returnHighlightTerms;
            findItemRequest.View = view;
            findItemRequest.GroupBy = groupBy;
            var serviceResponseCollection = findItemRequest.Execute();
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        ExchangeService.prototype.FindItems_4 = function (parentFolderId, searchFilter, view) {
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), searchFilter, null, view, null, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindItems_5 = function (parentFolderId, view) {
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), null, null, view, null, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindItems_6 = function (parentFolderName, queryString, view) {
            return this.FindItems(new FolderId(parentFolderName), queryString, view);
        };
        ExchangeService.prototype.FindItems_7 = function (parentFolderName, searchFilter, view) {
            return this.FindItems(new FolderId(parentFolderName), searchFilter, view);
        };
        ExchangeService.prototype.FindItems_8 = function (parentFolderName, view) {
            return this.FindItems(new FolderId(parentFolderName), null, view);
        };
        ExchangeService.prototype.FindItems_9 = function (parentFolderId, queryString, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), null, queryString, view, groupBy, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        ExchangeService.prototype.FindItems_10 = function (parentFolderId, searchFilter, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            EwsUtilities.ValidateParamAllowNull(searchFilter, "searchFilter");
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), searchFilter, null, view, groupBy, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        ExchangeService.prototype.FindItems_11 = function (parentFolderId, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), null, null, view, groupBy, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).GroupedFindResults;
        };
        ExchangeService.prototype.FindItems_12 = function (parentFolderId, searchFilter, view, groupBy) {
            return this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), searchFilter, null, view, groupBy, ServiceErrorHandling.ThrowOnError);
        };
        ExchangeService.prototype.FindItems_13 = function (parentFolderName, queryString, view, groupBy) {
            EwsUtilities.ValidateParam(groupBy, "groupBy");
            return this.FindItems(new FolderId(parentFolderName), queryString, view, groupBy);
        };
        ExchangeService.prototype.FindItems_14 = function (parentFolderName, searchFilter, view, groupBy) {
            return this.FindItems(new FolderId(parentFolderName), searchFilter, view, groupBy);
        };
        ExchangeService.prototype.FindAppointments = function (parentFolderIdOrParentFolderName, calendarView) {
            if (arguments.length === 2 && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId) && (calendarView === null || calendarView instanceof CalendarView)) {
                return this.FindAppointments_0(parentFolderIdOrParentFolderName, calendarView);
            }
            return this.FindAppointments_1(parentFolderIdOrParentFolderName, calendarView);
        };
        ExchangeService.prototype.FindAppointments_0 = function (parentFolderId, calendarView) {
            var serviceResponseCollection = this.FindItems(NArray.ToEnumerable([
                parentFolderId
            ]), null, null, calendarView, null, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Results;
        };
        ExchangeService.prototype.FindAppointments_1 = function (parentFolderName, calendarView) {
            return this.FindAppointments(new FolderId(parentFolderName), calendarView);
        };
        ExchangeService.prototype.LoadPropertiesForItems = function (items, propertySet) {
            EwsUtilities.ValidateParamCollection(items, "items");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            return this.InternalLoadPropertiesForItems(items, propertySet, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.InternalLoadPropertiesForItems = function (items, propertySet, errorHandling) {
            var getItemRequestForLoad = new GetItemRequestForLoad(this, errorHandling);
            getItemRequestForLoad.ItemIds.AddRange(items);
            getItemRequestForLoad.PropertySet = propertySet;
            return getItemRequestForLoad.Execute();
        };
        ExchangeService.prototype.InternalBindToItems = function (itemIds, propertySet, errorHandling) {
            var getItemRequest = new GetItemRequest(this, errorHandling);
            getItemRequest.ItemIds.AddRange(itemIds);
            getItemRequest.PropertySet = propertySet;
            return getItemRequest.Execute();
        };
        ExchangeService.prototype.BindToItems = function (itemIds, propertySet) {
            EwsUtilities.ValidateParamCollection(itemIds, "itemIds");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            return this.InternalBindToItems(itemIds, propertySet, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.BindToItem = function (itemId, propertySet) {
            if (arguments.length === 2 && (itemId === null || itemId instanceof ItemId) && (propertySet === null || propertySet instanceof PropertySet)) {
                return this.BindToItem_0(itemId, propertySet);
            }
            return this.BindToItem_1(itemId, propertySet);
        };
        ExchangeService.prototype.BindToItem_0 = function (itemId, propertySet) {
            EwsUtilities.ValidateParam(itemId, "itemId");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            var serviceResponseCollection = this.InternalBindToItems(NArray.ToEnumerable([
                itemId
            ]), propertySet, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).Item;
        };
        ExchangeService.prototype.BindToItem_1 = function (itemId, propertySet) {
            var item = this.BindToItem(itemId, propertySet);
            if (item instanceof TItem) {
                return item;
            }
            throw new ServiceLocalException(NString.Format(Strings.ItemTypeNotCompatible, item.GetType().Name, new Type("TItem").Name));
        };
        ExchangeService.prototype.InternalDeleteItems = function (itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, errorHandling, suppressReadReceipts) {
            var deleteItemRequest = new DeleteItemRequest(this, errorHandling);
            deleteItemRequest.ItemIds.AddRange(itemIds);
            deleteItemRequest.DeleteMode = deleteMode;
            deleteItemRequest.SendCancellationsMode = sendCancellationsMode;
            deleteItemRequest.AffectedTaskOccurrences = affectedTaskOccurrences;
            deleteItemRequest.SuppressReadReceipts = suppressReadReceipts;
            return deleteItemRequest.Execute();
        };
        ExchangeService.prototype.DeleteItems = function (itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipt) {
            if (arguments.length === 4 && (deleteMode === null || deleteMode.constructor === Number) && (sendCancellationsMode === null || sendCancellationsMode instanceof Array) && (affectedTaskOccurrences === null || affectedTaskOccurrences instanceof Array)) {
                return this.DeleteItems_0(itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences);
            }
            return this.DeleteItems_1(itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipt);
        };
        ExchangeService.prototype.DeleteItems_0 = function (itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            return this.DeleteItems(itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, false);
        };
        ExchangeService.prototype.DeleteItems_1 = function (itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipt) {
            EwsUtilities.ValidateParamCollection(itemIds, "itemIds");
            return this.InternalDeleteItems(itemIds, deleteMode, sendCancellationsMode, affectedTaskOccurrences, ServiceErrorHandling.ReturnErrors, suppressReadReceipt);
        };
        ExchangeService.prototype.DeleteItem = function (itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts) {
            if (arguments.length === 4 && (itemId === null || itemId instanceof ItemId) && (deleteMode === null || deleteMode.constructor === Number) && (sendCancellationsMode === null || sendCancellationsMode instanceof Array) && (affectedTaskOccurrences === null || affectedTaskOccurrences instanceof Array)) {
                this.DeleteItem_0(itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences);
                return;
            }
            this.DeleteItem_1(itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts);
        };
        ExchangeService.prototype.DeleteItem_0 = function (itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            this.DeleteItem(itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences, false);
        };
        ExchangeService.prototype.DeleteItem_1 = function (itemId, deleteMode, sendCancellationsMode, affectedTaskOccurrences, suppressReadReceipts) {
            EwsUtilities.ValidateParam(itemId, "itemId");
            this.InternalDeleteItems(NArray.ToEnumerable([
                itemId
            ]), deleteMode, sendCancellationsMode, affectedTaskOccurrences, ServiceErrorHandling.ThrowOnError, suppressReadReceipts);
        };
        ExchangeService.prototype.MarkAsJunk = function (itemIds, isJunk, moveItem) {
            var markAsJunkRequest = new MarkAsJunkRequest(this, ServiceErrorHandling.ReturnErrors);
            markAsJunkRequest.ItemIds.AddRange(itemIds);
            markAsJunkRequest.IsJunk = isJunk;
            markAsJunkRequest.MoveItem = moveItem;
            return markAsJunkRequest.Execute();
        };
        ExchangeService.prototype.InternalGetAttachments = function (attachments, bodyType, additionalProperties, errorHandling) {
            var getAttachmentRequest = new GetAttachmentRequest(this, errorHandling);
            getAttachmentRequest.Attachments.AddRange(attachments);
            getAttachmentRequest.BodyType = bodyType;
            if (additionalProperties !== null) {
                getAttachmentRequest.AdditionalProperties.AddRange(additionalProperties);
            }
            return getAttachmentRequest.Execute();
        };
        ExchangeService.prototype.GetAttachments = function (attachmentsOrAttachmentIds, bodyType, additionalProperties) {
            if (arguments.length === 3 && (attachmentsOrAttachmentIds === null || attachmentsOrAttachmentIds instanceof Array) && (bodyType === null || bodyType instanceof Array)) {
                return this.GetAttachments_0(attachmentsOrAttachmentIds, bodyType, additionalProperties);
            }
            return this.GetAttachments_1(attachmentsOrAttachmentIds, bodyType, additionalProperties);
        };
        ExchangeService.prototype.GetAttachments_0 = function (attachments, bodyType, additionalProperties) {
            return this.InternalGetAttachments(NArray.ToEnumerable(attachments), bodyType, additionalProperties, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.GetAttachments_1 = function (attachmentIds, bodyType, additionalProperties) {
            var getAttachmentRequest = new GetAttachmentRequest(this, ServiceErrorHandling.ReturnErrors);
            getAttachmentRequest.AttachmentIds.AddRange(NArray.ToEnumerable(attachmentIds));
            getAttachmentRequest.BodyType = bodyType;
            if (additionalProperties !== null) {
                getAttachmentRequest.AdditionalProperties.AddRange(additionalProperties);
            }
            return getAttachmentRequest.Execute();
        };
        ExchangeService.prototype.GetAttachment = function (attachment, bodyType, additionalProperties) {
            this.InternalGetAttachments(NArray.ToEnumerable([
                attachment
            ]), bodyType, additionalProperties, ServiceErrorHandling.ThrowOnError);
        };
        ExchangeService.prototype.CreateAttachments = function (parentItemId, attachments) {
            var createAttachmentRequest = new CreateAttachmentRequest(this, ServiceErrorHandling.ReturnErrors);
            createAttachmentRequest.ParentItemId = parentItemId;
            createAttachmentRequest.Attachments.AddRange(attachments);
            return createAttachmentRequest.Execute();
        };
        ExchangeService.prototype.DeleteAttachments = function (attachments) {
            var deleteAttachmentRequest = new DeleteAttachmentRequest(this, ServiceErrorHandling.ReturnErrors);
            deleteAttachmentRequest.Attachments.AddRange(attachments);
            return deleteAttachmentRequest.Execute();
        };
        ExchangeService.prototype.ResolveName = function (nameToResolve, parentFolderIdsOrSearchScope, searchScopeOrReturnContactDetails, returnContactDetailsOrContactDataPropertySet, contactDataPropertySet) {
            if (arguments.length === 1 && (nameToResolve === null || nameToResolve.constructor === String)) {
                return this.ResolveName_0(nameToResolve);
            }
            if (arguments.length === 4 && (nameToResolve === null || nameToResolve.constructor === String) && (searchScopeOrReturnContactDetails === null || searchScopeOrReturnContactDetails.constructor === Number) && (returnContactDetailsOrContactDataPropertySet === null || returnContactDetailsOrContactDataPropertySet.constructor === Boolean)) {
                return this.ResolveName_1(nameToResolve, parentFolderIdsOrSearchScope, searchScopeOrReturnContactDetails, returnContactDetailsOrContactDataPropertySet);
            }
            if (arguments.length === 5 && (nameToResolve === null || nameToResolve.constructor === String) && (searchScopeOrReturnContactDetails === null || searchScopeOrReturnContactDetails.constructor === Number) && (returnContactDetailsOrContactDataPropertySet === null || returnContactDetailsOrContactDataPropertySet.constructor === Boolean) && (contactDataPropertySet === null || contactDataPropertySet instanceof PropertySet)) {
                return this.ResolveName_2(nameToResolve, parentFolderIdsOrSearchScope, searchScopeOrReturnContactDetails, returnContactDetailsOrContactDataPropertySet, contactDataPropertySet);
            }
            if (arguments.length === 4 && (nameToResolve === null || nameToResolve.constructor === String) && (parentFolderIdsOrSearchScope === null || parentFolderIdsOrSearchScope.constructor === Number) && (searchScopeOrReturnContactDetails === null || searchScopeOrReturnContactDetails.constructor === Boolean) && (returnContactDetailsOrContactDataPropertySet === null || returnContactDetailsOrContactDataPropertySet instanceof PropertySet)) {
                return this.ResolveName_3(nameToResolve, parentFolderIdsOrSearchScope, searchScopeOrReturnContactDetails, returnContactDetailsOrContactDataPropertySet);
            }
            return this.ResolveName_4(nameToResolve, parentFolderIdsOrSearchScope, searchScopeOrReturnContactDetails);
        };
        ExchangeService.prototype.ResolveName_0 = function (nameToResolve) {
            return this.ResolveName(nameToResolve, ResolveNameSearchLocation.ContactsThenDirectory, false);
        };
        ExchangeService.prototype.ResolveName_1 = function (nameToResolve, parentFolderIds, searchScope, returnContactDetails) {
            return this.ResolveName(nameToResolve, parentFolderIds, searchScope, returnContactDetails, null);
        };
        ExchangeService.prototype.ResolveName_2 = function (nameToResolve, parentFolderIds, searchScope, returnContactDetails, contactDataPropertySet) {
            if (contactDataPropertySet !== null) {
                EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "ResolveName");
            }
            EwsUtilities.ValidateParam(nameToResolve, "nameToResolve");
            if (parentFolderIds !== null) {
                EwsUtilities.ValidateParamCollection(parentFolderIds, "parentFolderIds");
            }
            var resolveNamesRequest = new ResolveNamesRequest(this);
            resolveNamesRequest.NameToResolve = nameToResolve;
            resolveNamesRequest.ReturnFullContactData = returnContactDetails;
            resolveNamesRequest.ParentFolderIds.AddRange(parentFolderIds);
            resolveNamesRequest.SearchLocation = searchScope;
            resolveNamesRequest.ContactDataPropertySet = contactDataPropertySet;
            return resolveNamesRequest.Execute().get_Item(0).Resolutions;
        };
        ExchangeService.prototype.ResolveName_3 = function (nameToResolve, searchScope, returnContactDetails, contactDataPropertySet) {
            return this.ResolveName(nameToResolve, null, searchScope, returnContactDetails, contactDataPropertySet);
        };
        ExchangeService.prototype.ResolveName_4 = function (nameToResolve, searchScope, returnContactDetails) {
            return this.ResolveName(nameToResolve, null, searchScope, returnContactDetails);
        };
        ExchangeService.prototype.ExpandGroup = function (emailAddressOrGroupIdOrSmtpAddressOrAddress, routingType) {
            if (arguments.length === 1 && (emailAddressOrGroupIdOrSmtpAddressOrAddress === null || emailAddressOrGroupIdOrSmtpAddressOrAddress instanceof EmailAddress)) {
                return this.ExpandGroup_0(emailAddressOrGroupIdOrSmtpAddressOrAddress);
            }
            if (arguments.length === 1 && (emailAddressOrGroupIdOrSmtpAddressOrAddress === null || emailAddressOrGroupIdOrSmtpAddressOrAddress instanceof ItemId)) {
                return this.ExpandGroup_1(emailAddressOrGroupIdOrSmtpAddressOrAddress);
            }
            if (arguments.length === 1 && (emailAddressOrGroupIdOrSmtpAddressOrAddress === null || emailAddressOrGroupIdOrSmtpAddressOrAddress.constructor === String)) {
                return this.ExpandGroup_2(emailAddressOrGroupIdOrSmtpAddressOrAddress);
            }
            return this.ExpandGroup_3(emailAddressOrGroupIdOrSmtpAddressOrAddress, routingType);
        };
        ExchangeService.prototype.ExpandGroup_0 = function (emailAddress) {
            EwsUtilities.ValidateParam(emailAddress, "emailAddress");
            var expandGroupRequest = new ExpandGroupRequest(this);
            expandGroupRequest.EmailAddress = emailAddress;
            return expandGroupRequest.Execute().get_Item(0).Members;
        };
        ExchangeService.prototype.ExpandGroup_1 = function (groupId) {
            EwsUtilities.ValidateParam(groupId, "groupId");
            var emailAddress = new EmailAddress();
            emailAddress.Id = groupId;
            return this.ExpandGroup(emailAddress);
        };
        ExchangeService.prototype.ExpandGroup_2 = function (smtpAddress) {
            EwsUtilities.ValidateParam(smtpAddress, "smtpAddress");
            return this.ExpandGroup(new EmailAddress(smtpAddress));
        };
        ExchangeService.prototype.ExpandGroup_3 = function (address, routingType) {
            EwsUtilities.ValidateParam(address, "address");
            EwsUtilities.ValidateParam(routingType, "routingType");
            var emailAddress = new EmailAddress(address);
            emailAddress.RoutingType = routingType;
            return this.ExpandGroup(emailAddress);
        };
        ExchangeService.prototype.GetPasswordExpirationDate = function (mailboxSmtpAddress) {
            var getPasswordExpirationDateRequest = new GetPasswordExpirationDateRequest(this);
            getPasswordExpirationDateRequest.MailboxSmtpAddress = mailboxSmtpAddress;
            return getPasswordExpirationDateRequest.Execute().PasswordExpirationDate;
        };
        ExchangeService.prototype.SubscribeToPullNotifications = function (folderIds, timeout, watermark, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPullNotificationsRequest(folderIds, timeout, watermark, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPullNotifications = function (callback, state, folderIds, timeout, watermark, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPullNotificationsRequest(folderIds, timeout, watermark, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SubscribeToPullNotificationsOnAllFolders = function (timeout, watermark, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "SubscribeToPullNotificationsOnAllFolders");
            return this.BuildSubscribeToPullNotificationsRequest(null, timeout, watermark, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPullNotificationsOnAllFolders = function (callback, state, timeout, watermark, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "BeginSubscribeToPullNotificationsOnAllFolders");
            return this.BuildSubscribeToPullNotificationsRequest(null, timeout, watermark, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndSubscribeToPullNotifications = function (asyncResult) {
            var subscribeToPullNotificationsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return subscribeToPullNotificationsRequest.EndExecute(asyncResult).get_Item(0).Subscription;
        };
        ExchangeService.prototype.BuildSubscribeToPullNotificationsRequest = function (folderIds, timeout, watermark, eventTypes) {
            if (timeout < 1 || timeout > 1440) {
                throw new ArgumentOutOfRangeException("timeout", Strings.TimeoutMustBeBetween1And1440);
            }
            EwsUtilities.ValidateParamCollection(NArray.ToEnumerable(eventTypes), "eventTypes");
            var subscribeToPullNotificationsRequest = new SubscribeToPullNotificationsRequest(this);
            if (folderIds !== null) {
                subscribeToPullNotificationsRequest.FolderIds.AddRange(folderIds);
            }
            subscribeToPullNotificationsRequest.Timeout = timeout;
            subscribeToPullNotificationsRequest.EventTypes.AddRange(NArray.ToEnumerable(eventTypes));
            subscribeToPullNotificationsRequest.Watermark = watermark;
            return subscribeToPullNotificationsRequest;
        };
        ExchangeService.prototype.Unsubscribe = function (subscriptionId) {
            this.BuildUnsubscribeRequest(subscriptionId).Execute();
        };
        ExchangeService.prototype.BeginUnsubscribe = function (callback, state, subscriptionId) {
            return this.BuildUnsubscribeRequest(subscriptionId).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndUnsubscribe = function (asyncResult) {
            var unsubscribeRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            unsubscribeRequest.EndExecute(asyncResult);
        };
        ExchangeService.prototype.BuildUnsubscribeRequest = function (subscriptionId) {
            EwsUtilities.ValidateParam(subscriptionId, "subscriptionId");
            var unsubscribeRequest = new UnsubscribeRequest(this);
            unsubscribeRequest.SubscriptionId = subscriptionId;
            return unsubscribeRequest;
        };
        ExchangeService.prototype.GetEvents = function (subscriptionId, watermark) {
            return this.BuildGetEventsRequest(subscriptionId, watermark).Execute().get_Item(0).Results;
        };
        ExchangeService.prototype.BeginGetEvents = function (callback, state, subscriptionId, watermark) {
            return this.BuildGetEventsRequest(subscriptionId, watermark).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndGetEvents = function (asyncResult) {
            var getEventsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return getEventsRequest.EndExecute(asyncResult).get_Item(0).Results;
        };
        ExchangeService.prototype.BuildGetEventsRequest = function (subscriptionId, watermark) {
            EwsUtilities.ValidateParam(subscriptionId, "subscriptionId");
            EwsUtilities.ValidateParam(watermark, "watermark");
            var getEventsRequest = new GetEventsRequest(this);
            getEventsRequest.SubscriptionId = subscriptionId;
            getEventsRequest.Watermark = watermark;
            return getEventsRequest;
        };
        ExchangeService.prototype.SubscribeToPushNotifications = function (folderIds, url, frequency, watermark, eventTypesOrCallerData, eventTypes) {
            if (arguments.length === 5 && (url === null || url instanceof Uri) && (frequency === null || frequency.constructor === Number) && (watermark === null || watermark.constructor === String) && (eventTypesOrCallerData === null || eventTypesOrCallerData instanceof Array)) {
                return this.SubscribeToPushNotifications_0(folderIds, url, frequency, watermark, eventTypesOrCallerData);
            }
            return this.SubscribeToPushNotifications_1(folderIds, url, frequency, watermark, eventTypesOrCallerData, eventTypes);
        };
        ExchangeService.prototype.SubscribeToPushNotifications_0 = function (folderIds, url, frequency, watermark, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPushNotificationsRequest(folderIds, url, frequency, watermark, null, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPushNotifications = function (callback, state, folderIds, url, frequency, watermark, eventTypesOrCallerData, eventTypes) {
            if (arguments.length === 7 && (state === null || state.constructor === Object) && (url === null || url instanceof Uri) && (frequency === null || frequency.constructor === Number) && (watermark === null || watermark.constructor === String) && (eventTypesOrCallerData === null || eventTypesOrCallerData instanceof Array)) {
                return this.BeginSubscribeToPushNotifications_0(callback, state, folderIds, url, frequency, watermark, eventTypesOrCallerData);
            }
            return this.BeginSubscribeToPushNotifications_1(callback, state, folderIds, url, frequency, watermark, eventTypesOrCallerData, eventTypes);
        };
        ExchangeService.prototype.BeginSubscribeToPushNotifications_0 = function (callback, state, folderIds, url, frequency, watermark, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPushNotificationsRequest(folderIds, url, frequency, watermark, null, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SubscribeToPushNotificationsOnAllFolders = function (url, frequency, watermark, eventTypesOrCallerData, eventTypes) {
            if (arguments.length === 4 && (url === null || url instanceof Uri) && (frequency === null || frequency.constructor === Number) && (watermark === null || watermark.constructor === String) && (eventTypesOrCallerData === null || eventTypesOrCallerData instanceof Array)) {
                return this.SubscribeToPushNotificationsOnAllFolders_0(url, frequency, watermark, eventTypesOrCallerData);
            }
            return this.SubscribeToPushNotificationsOnAllFolders_1(url, frequency, watermark, eventTypesOrCallerData, eventTypes);
        };
        ExchangeService.prototype.SubscribeToPushNotificationsOnAllFolders_0 = function (url, frequency, watermark, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "SubscribeToPushNotificationsOnAllFolders");
            return this.BuildSubscribeToPushNotificationsRequest(null, url, frequency, watermark, null, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPushNotificationsOnAllFolders = function (callback, state, url, frequency, watermark, eventTypesOrCallerData, eventTypes) {
            if (arguments.length === 6 && (state === null || state.constructor === Object) && (url === null || url instanceof Uri) && (frequency === null || frequency.constructor === Number) && (watermark === null || watermark.constructor === String) && (eventTypesOrCallerData === null || eventTypesOrCallerData instanceof Array)) {
                return this.BeginSubscribeToPushNotificationsOnAllFolders_0(callback, state, url, frequency, watermark, eventTypesOrCallerData);
            }
            return this.BeginSubscribeToPushNotificationsOnAllFolders_1(callback, state, url, frequency, watermark, eventTypesOrCallerData, eventTypes);
        };
        ExchangeService.prototype.BeginSubscribeToPushNotificationsOnAllFolders_0 = function (callback, state, url, frequency, watermark, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "BeginSubscribeToPushNotificationsOnAllFolders");
            return this.BuildSubscribeToPushNotificationsRequest(null, url, frequency, watermark, null, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SubscribeToPushNotifications_1 = function (folderIds, url, frequency, watermark, callerData, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPushNotificationsRequest(folderIds, url, frequency, watermark, callerData, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPushNotifications_1 = function (callback, state, folderIds, url, frequency, watermark, callerData, eventTypes) {
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToPushNotificationsRequest(folderIds, url, frequency, watermark, callerData, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SubscribeToPushNotificationsOnAllFolders_1 = function (url, frequency, watermark, callerData, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "SubscribeToPushNotificationsOnAllFolders");
            return this.BuildSubscribeToPushNotificationsRequest(null, url, frequency, watermark, callerData, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToPushNotificationsOnAllFolders_1 = function (callback, state, url, frequency, watermark, callerData, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010, "BeginSubscribeToPushNotificationsOnAllFolders");
            return this.BuildSubscribeToPushNotificationsRequest(null, url, frequency, watermark, callerData, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndSubscribeToPushNotifications = function (asyncResult) {
            var subscribeToPushNotificationsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return subscribeToPushNotificationsRequest.EndExecute(asyncResult).get_Item(0).Subscription;
        };
        ExchangeService.prototype.SetTeamMailbox = function (emailAddress, sharePointSiteUrl, state) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "SetTeamMailbox");
            if (emailAddress === null) {
                throw new ArgumentNullException("emailAddress");
            }
            if (Uri.op_Equality(sharePointSiteUrl, null)) {
                throw new ArgumentNullException("sharePointSiteUrl");
            }
            var setTeamMailboxRequest = new SetTeamMailboxRequest(this, emailAddress, sharePointSiteUrl, state);
            setTeamMailboxRequest.Execute();
        };
        ExchangeService.prototype.UnpinTeamMailbox = function (emailAddress) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "UnpinTeamMailbox");
            if (emailAddress === null) {
                throw new ArgumentNullException("emailAddress");
            }
            var unpinTeamMailboxRequest = new UnpinTeamMailboxRequest(this, emailAddress);
            unpinTeamMailboxRequest.Execute();
        };
        ExchangeService.prototype.BuildSubscribeToPushNotificationsRequest = function (folderIds, url, frequency, watermark, callerData, eventTypes) {
            EwsUtilities.ValidateParam(url, "url");
            if (frequency < 1 || frequency > 1440) {
                throw new ArgumentOutOfRangeException("frequency", Strings.FrequencyMustBeBetween1And1440);
            }
            EwsUtilities.ValidateParamCollection(NArray.ToEnumerable(eventTypes), "eventTypes");
            var subscribeToPushNotificationsRequest = new SubscribeToPushNotificationsRequest(this);
            if (folderIds !== null) {
                subscribeToPushNotificationsRequest.FolderIds.AddRange(folderIds);
            }
            subscribeToPushNotificationsRequest.Url = url;
            subscribeToPushNotificationsRequest.Frequency = frequency;
            subscribeToPushNotificationsRequest.EventTypes.AddRange(NArray.ToEnumerable(eventTypes));
            subscribeToPushNotificationsRequest.Watermark = watermark;
            subscribeToPushNotificationsRequest.CallerData = callerData;
            return subscribeToPushNotificationsRequest;
        };
        ExchangeService.prototype.SubscribeToStreamingNotifications = function (folderIds, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "SubscribeToStreamingNotifications");
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToStreamingNotificationsRequest(folderIds, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToStreamingNotifications = function (callback, state, folderIds, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "BeginSubscribeToStreamingNotifications");
            EwsUtilities.ValidateParamCollection(folderIds, "folderIds");
            return this.BuildSubscribeToStreamingNotificationsRequest(folderIds, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SubscribeToStreamingNotificationsOnAllFolders = function (eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "SubscribeToStreamingNotificationsOnAllFolders");
            return this.BuildSubscribeToStreamingNotificationsRequest(null, eventTypes).Execute().get_Item(0).Subscription;
        };
        ExchangeService.prototype.BeginSubscribeToStreamingNotificationsOnAllFolders = function (callback, state, eventTypes) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "BeginSubscribeToStreamingNotificationsOnAllFolders");
            return this.BuildSubscribeToStreamingNotificationsRequest(null, eventTypes).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndSubscribeToStreamingNotifications = function (asyncResult) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "EndSubscribeToStreamingNotifications");
            var subscribeToStreamingNotificationsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return subscribeToStreamingNotificationsRequest.EndExecute(asyncResult).get_Item(0).Subscription;
        };
        ExchangeService.prototype.BuildSubscribeToStreamingNotificationsRequest = function (folderIds, eventTypes) {
            EwsUtilities.ValidateParamCollection(NArray.ToEnumerable(eventTypes), "eventTypes");
            var subscribeToStreamingNotificationsRequest = new SubscribeToStreamingNotificationsRequest(this);
            if (folderIds !== null) {
                subscribeToStreamingNotificationsRequest.FolderIds.AddRange(folderIds);
            }
            subscribeToStreamingNotificationsRequest.EventTypes.AddRange(NArray.ToEnumerable(eventTypes));
            return subscribeToStreamingNotificationsRequest;
        };
        ExchangeService.prototype.SyncFolderItems = function (syncFolderId, propertySet, ignoredItemIds, maxChangesReturned, syncScope, syncState) {
            return this.BuildSyncFolderItemsRequest(syncFolderId, propertySet, ignoredItemIds, maxChangesReturned, syncScope, syncState).Execute().get_Item(0).Changes;
        };
        ExchangeService.prototype.BeginSyncFolderItems = function (callback, state, syncFolderId, propertySet, ignoredItemIds, maxChangesReturned, syncScope, syncState) {
            return this.BuildSyncFolderItemsRequest(syncFolderId, propertySet, ignoredItemIds, maxChangesReturned, syncScope, syncState).BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndSyncFolderItems = function (asyncResult) {
            var syncFolderItemsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return syncFolderItemsRequest.EndExecute(asyncResult).get_Item(0).Changes;
        };
        ExchangeService.prototype.BuildSyncFolderItemsRequest = function (syncFolderId, propertySet, ignoredItemIds, maxChangesReturned, syncScope, syncState) {
            EwsUtilities.ValidateParam(syncFolderId, "syncFolderId");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            var syncFolderItemsRequest = new SyncFolderItemsRequest(this);
            syncFolderItemsRequest.SyncFolderId = syncFolderId;
            syncFolderItemsRequest.PropertySet = propertySet;
            if (ignoredItemIds !== null) {
                syncFolderItemsRequest.IgnoredItemIds.AddRange(ignoredItemIds);
            }
            syncFolderItemsRequest.MaxChangesReturned = maxChangesReturned;
            syncFolderItemsRequest.SyncScope = syncScope;
            syncFolderItemsRequest.SyncState = syncState;
            return syncFolderItemsRequest;
        };
        ExchangeService.prototype.SyncFolderHierarchy = function (syncFolderIdOrPropertySet, propertySetOrSyncState, syncState) {
            if (arguments.length === 3 && (syncFolderIdOrPropertySet === null || syncFolderIdOrPropertySet instanceof FolderId) && (propertySetOrSyncState === null || propertySetOrSyncState instanceof PropertySet) && (syncState === null || syncState.constructor === String)) {
                return this.SyncFolderHierarchy_0(syncFolderIdOrPropertySet, propertySetOrSyncState, syncState);
            }
            return this.SyncFolderHierarchy_1(syncFolderIdOrPropertySet, propertySetOrSyncState);
        };
        ExchangeService.prototype.SyncFolderHierarchy_0 = function (syncFolderId, propertySet, syncState) {
            return this.BuildSyncFolderHierarchyRequest(syncFolderId, propertySet, syncState).Execute().get_Item(0).Changes;
        };
        ExchangeService.prototype.BeginSyncFolderHierarchy = function (callback, state, syncFolderIdOrPropertySet, propertySetOrSyncState, syncState) {
            if (arguments.length === 5 && (state === null || state.constructor === Object) && (syncFolderIdOrPropertySet === null || syncFolderIdOrPropertySet instanceof FolderId) && (propertySetOrSyncState === null || propertySetOrSyncState instanceof PropertySet) && (syncState === null || syncState.constructor === String)) {
                return this.BeginSyncFolderHierarchy_0(callback, state, syncFolderIdOrPropertySet, propertySetOrSyncState, syncState);
            }
            return this.BeginSyncFolderHierarchy_1(callback, state, syncFolderIdOrPropertySet, propertySetOrSyncState);
        };
        ExchangeService.prototype.BeginSyncFolderHierarchy_0 = function (callback, state, syncFolderId, propertySet, syncState) {
            return this.BuildSyncFolderHierarchyRequest(syncFolderId, propertySet, syncState).BeginExecute(callback, state);
        };
        ExchangeService.prototype.SyncFolderHierarchy_1 = function (propertySet, syncState) {
            return this.SyncFolderHierarchy(null, propertySet, syncState);
        };
        ExchangeService.prototype.BeginSyncFolderHierarchy_1 = function (callback, state, propertySet, syncState) {
            return this.BeginSyncFolderHierarchy(callback, state, null, propertySet, syncState);
        };
        ExchangeService.prototype.EndSyncFolderHierarchy = function (asyncResult) {
            var syncFolderHierarchyRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return syncFolderHierarchyRequest.EndExecute(asyncResult).get_Item(0).Changes;
        };
        ExchangeService.prototype.BuildSyncFolderHierarchyRequest = function (syncFolderId, propertySet, syncState) {
            EwsUtilities.ValidateParamAllowNull(syncFolderId, "syncFolderId");
            EwsUtilities.ValidateParam(propertySet, "propertySet");
            var syncFolderHierarchyRequest = new SyncFolderHierarchyRequest(this);
            syncFolderHierarchyRequest.PropertySet = propertySet;
            syncFolderHierarchyRequest.SyncFolderId = syncFolderId;
            syncFolderHierarchyRequest.SyncState = syncState;
            return syncFolderHierarchyRequest;
        };
        ExchangeService.prototype.GetUserOofSettings = function (smtpAddress) {
            EwsUtilities.ValidateParam(smtpAddress, "smtpAddress");
            var getUserOofSettingsRequest = new GetUserOofSettingsRequest(this);
            getUserOofSettingsRequest.SmtpAddress = smtpAddress;
            return getUserOofSettingsRequest.Execute().OofSettings;
        };
        ExchangeService.prototype.SetUserOofSettings = function (smtpAddress, oofSettings) {
            EwsUtilities.ValidateParam(smtpAddress, "smtpAddress");
            EwsUtilities.ValidateParam(oofSettings, "oofSettings");
            var setUserOofSettingsRequest = new SetUserOofSettingsRequest(this);
            setUserOofSettingsRequest.SmtpAddress = smtpAddress;
            setUserOofSettingsRequest.OofSettings = oofSettings;
            setUserOofSettingsRequest.Execute();
        };
        ExchangeService.prototype.GetUserAvailability = function (attendees, timeWindow, requestedData, options) {
            if (arguments.length === 4 && (timeWindow === null || timeWindow instanceof TimeWindow) && (requestedData === null || requestedData.constructor === Number) && (options === null || options instanceof AvailabilityOptions)) {
                return this.GetUserAvailability_0(attendees, timeWindow, requestedData, options);
            }
            return this.GetUserAvailability_1(attendees, timeWindow, requestedData);
        };
        ExchangeService.prototype.GetUserAvailability_0 = function (attendees, timeWindow, requestedData, options) {
            EwsUtilities.ValidateParamCollection(attendees, "attendees");
            EwsUtilities.ValidateParam(timeWindow, "timeWindow");
            EwsUtilities.ValidateParam(options, "options");
            var getUserAvailabilityRequest = new GetUserAvailabilityRequest(this);
            getUserAvailabilityRequest.Attendees = attendees;
            getUserAvailabilityRequest.TimeWindow = timeWindow;
            getUserAvailabilityRequest.RequestedData = requestedData;
            getUserAvailabilityRequest.Options = options;
            return getUserAvailabilityRequest.Execute();
        };
        ExchangeService.prototype.GetUserAvailability_1 = function (attendees, timeWindow, requestedData) {
            return this.GetUserAvailability(attendees, timeWindow, requestedData, new AvailabilityOptions());
        };
        ExchangeService.prototype.GetRoomLists = function () {
            var getRoomListsRequest = new GetRoomListsRequest(this);
            return getRoomListsRequest.Execute().RoomLists;
        };
        ExchangeService.prototype.GetRooms = function (emailAddress) {
            EwsUtilities.ValidateParam(emailAddress, "emailAddress");
            var getRoomsRequest = new GetRoomsRequest(this);
            getRoomsRequest.RoomList = emailAddress;
            return getRoomsRequest.Execute().Rooms;
        };
        ExchangeService.prototype.FindConversation = function (view, folderId, queryString, returnHighlightTerms, mailboxScope) {
            if (arguments.length === 2 && (view === null || view instanceof ViewBase) && (folderId === null || folderId instanceof FolderId)) {
                return this.FindConversation_0(view, folderId);
            }
            if (arguments.length === 3 && (view === null || view instanceof ViewBase) && (folderId === null || folderId instanceof FolderId) && (queryString === null || queryString.constructor === String)) {
                return this.FindConversation_1(view, folderId, queryString);
            }
            if (arguments.length === 4 && (view === null || view instanceof ViewBase) && (folderId === null || folderId instanceof FolderId) && (queryString === null || queryString.constructor === String) && (returnHighlightTerms === null || returnHighlightTerms.constructor === Boolean)) {
                return this.FindConversation_2(view, folderId, queryString, returnHighlightTerms);
            }
            return this.FindConversation_3(view, folderId, queryString, returnHighlightTerms, mailboxScope);
        };
        ExchangeService.prototype.FindConversation_0 = function (view, folderId) {
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "FindConversation");
            var findConversationRequest = new FindConversationRequest(this);
            findConversationRequest.View = view;
            findConversationRequest.FolderId = new FolderIdWrapper(folderId);
            return findConversationRequest.Execute().Conversations;
        };
        ExchangeService.prototype.FindConversation_1 = function (view, folderId, queryString) {
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "FindConversation");
            var findConversationRequest = new FindConversationRequest(this);
            findConversationRequest.View = view;
            findConversationRequest.FolderId = new FolderIdWrapper(folderId);
            findConversationRequest.QueryString = queryString;
            return findConversationRequest.Execute().Conversations;
        };
        ExchangeService.prototype.FindConversation_2 = function (view, folderId, queryString, returnHighlightTerms) {
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParam(returnHighlightTerms, "returnHighlightTerms");
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "FindConversation");
            var findConversationRequest = new FindConversationRequest(this);
            findConversationRequest.View = view;
            findConversationRequest.FolderId = new FolderIdWrapper(folderId);
            findConversationRequest.QueryString = queryString;
            findConversationRequest.ReturnHighlightTerms = returnHighlightTerms;
            return findConversationRequest.Execute().Results;
        };
        ExchangeService.prototype.FindConversation_3 = function (view, folderId, queryString, returnHighlightTerms, mailboxScope) {
            EwsUtilities.ValidateParam(view, "view");
            EwsUtilities.ValidateParamAllowNull(queryString, "queryString");
            EwsUtilities.ValidateParam(returnHighlightTerms, "returnHighlightTerms");
            EwsUtilities.ValidateParam(folderId, "folderId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "FindConversation");
            var findConversationRequest = new FindConversationRequest(this);
            findConversationRequest.View = view;
            findConversationRequest.FolderId = new FolderIdWrapper(folderId);
            findConversationRequest.QueryString = queryString;
            findConversationRequest.ReturnHighlightTerms = returnHighlightTerms;
            findConversationRequest.MailboxScope = mailboxScope;
            return findConversationRequest.Execute().Results;
        };
        ExchangeService.prototype.InternalGetConversationItems = function (conversations, propertySet, foldersToIgnore, sortOrder, mailboxScope, maxItemsToReturn, errorHandling) {
            EwsUtilities.ValidateParam(conversations, "conversations");
            EwsUtilities.ValidateParam(propertySet, "itemProperties");
            EwsUtilities.ValidateParamAllowNull(foldersToIgnore, "foldersToIgnore");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "GetConversationItems");
            var getConversationItemsRequest = new GetConversationItemsRequest(this, errorHandling);
            getConversationItemsRequest.ItemProperties = propertySet;
            getConversationItemsRequest.FoldersToIgnore = new FolderIdCollection(foldersToIgnore);
            getConversationItemsRequest.SortOrder = sortOrder;
            getConversationItemsRequest.MailboxScope = mailboxScope;
            getConversationItemsRequest.MaxItemsToReturn = maxItemsToReturn;
            getConversationItemsRequest.Conversations = Enumerable.ToList(conversations);
            return getConversationItemsRequest.Execute();
        };
        ExchangeService.prototype.GetConversationItems = function (conversationsOrConversationId, propertySet, foldersToIgnoreOrSyncState, sortOrderOrFoldersToIgnore, sortOrderOrMailboxScope) {
            if (arguments.length === 4 && (propertySet === null || propertySet instanceof PropertySet) && (sortOrderOrFoldersToIgnore === null || sortOrderOrFoldersToIgnore instanceof Array)) {
                return this.GetConversationItems_0(conversationsOrConversationId, propertySet, foldersToIgnoreOrSyncState, sortOrderOrFoldersToIgnore);
            }
            if (arguments.length === 5 && (conversationsOrConversationId === null || conversationsOrConversationId instanceof ConversationId) && (propertySet === null || propertySet instanceof PropertySet) && (foldersToIgnoreOrSyncState === null || foldersToIgnoreOrSyncState.constructor === String) && (sortOrderOrMailboxScope === null || sortOrderOrMailboxScope instanceof Array)) {
                return this.GetConversationItems_1(conversationsOrConversationId, propertySet, foldersToIgnoreOrSyncState, sortOrderOrFoldersToIgnore, sortOrderOrMailboxScope);
            }
            return this.GetConversationItems_2(conversationsOrConversationId, propertySet, foldersToIgnoreOrSyncState, sortOrderOrFoldersToIgnore, sortOrderOrMailboxScope);
        };
        ExchangeService.prototype.GetConversationItems_0 = function (conversations, propertySet, foldersToIgnore, sortOrder) {
            return this.InternalGetConversationItems(conversations, propertySet, foldersToIgnore, null, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.GetConversationItems_1 = function (conversationId, propertySet, syncState, foldersToIgnore, sortOrder) {
            var list = new List();
            list.Add(new ConversationRequest(conversationId, syncState));
            return this.InternalGetConversationItems(list, propertySet, foldersToIgnore, sortOrder, null, null, ServiceErrorHandling.ThrowOnError).get_Item(0).Conversation;
        };
        ExchangeService.prototype.GetConversationItems_2 = function (conversations, propertySet, foldersToIgnore, sortOrder, mailboxScope) {
            return this.InternalGetConversationItems(conversations, propertySet, foldersToIgnore, null, mailboxScope, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.ApplyConversationAction = function (actionType, conversationIds, processRightAway, categories, enableAlwaysDelete, destinationFolderId, errorHandlingMode) {
            EwsUtilities.Assert(actionType === ConversationActionType.AlwaysCategorize || actionType === ConversationActionType.AlwaysMove || actionType === ConversationActionType.AlwaysDelete, "ApplyConversationAction", "Invalic actionType");
            EwsUtilities.ValidateParam(conversationIds, "conversationId");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "ApplyConversationAction");
            var applyConversationActionRequest = new ApplyConversationActionRequest(this, errorHandlingMode);
            var conversationAction = new ConversationAction();
            var enumerator = conversationIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    conversationAction.Action = actionType;
                    conversationAction.ConversationId = current;
                    conversationAction.ProcessRightAway = processRightAway;
                    conversationAction.Categories = categories;
                    conversationAction.EnableAlwaysDelete = enableAlwaysDelete;
                    conversationAction.DestinationFolderId = ((destinationFolderId !== null) ? new FolderIdWrapper(destinationFolderId) : null);
                    applyConversationActionRequest.ConversationActions.Add(conversationAction);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return applyConversationActionRequest.Execute();
        };
        ExchangeService.prototype.ApplyConversationOneTimeAction = function (actionType, idTimePairs, contextFolderId, destinationFolderId, deleteType, isRead, retentionPolicyType, retentionPolicyTagId, flag, suppressReadReceipts, errorHandlingMode) {
            EwsUtilities.Assert(actionType === ConversationActionType.Move || actionType === ConversationActionType.Delete || actionType === ConversationActionType.SetReadState || actionType === ConversationActionType.SetRetentionPolicy || actionType === ConversationActionType.Copy || actionType === ConversationActionType.Flag, "ApplyConversationOneTimeAction", "Invalid actionType");
            EwsUtilities.ValidateParamCollection(idTimePairs, "idTimePairs");
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2010_SP1, "ApplyConversationAction");
            var applyConversationActionRequest = new ApplyConversationActionRequest(this, errorHandlingMode);
            var enumerator = idTimePairs.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var conversationAction = new ConversationAction();
                    conversationAction.Action = actionType;
                    conversationAction.ConversationId = current.Key;
                    conversationAction.ContextFolderId = ((contextFolderId !== null) ? new FolderIdWrapper(contextFolderId) : null);
                    conversationAction.DestinationFolderId = ((destinationFolderId !== null) ? new FolderIdWrapper(destinationFolderId) : null);
                    conversationAction.ConversationLastSyncTime = current.Value;
                    conversationAction.IsRead = isRead;
                    conversationAction.DeleteType = deleteType;
                    conversationAction.RetentionPolicyType = retentionPolicyType;
                    conversationAction.RetentionPolicyTagId = retentionPolicyTagId;
                    conversationAction.Flag = flag;
                    conversationAction.SuppressReadReceipts = suppressReadReceipts;
                    applyConversationActionRequest.ConversationActions.Add(conversationAction);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return applyConversationActionRequest.Execute();
        };
        ExchangeService.prototype.EnableAlwaysCategorizeItemsInConversations = function (conversationId, categories, processSynchronously) {
            EwsUtilities.ValidateParamCollection(categories, "categories");
            return this.ApplyConversationAction(ConversationActionType.AlwaysCategorize, conversationId, processSynchronously, new StringList(categories), false, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.DisableAlwaysCategorizeItemsInConversations = function (conversationId, processSynchronously) {
            return this.ApplyConversationAction(ConversationActionType.AlwaysCategorize, conversationId, processSynchronously, null, false, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.EnableAlwaysDeleteItemsInConversations = function (conversationId, processSynchronously) {
            return this.ApplyConversationAction(ConversationActionType.AlwaysDelete, conversationId, processSynchronously, null, true, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.DisableAlwaysDeleteItemsInConversations = function (conversationId, processSynchronously) {
            return this.ApplyConversationAction(ConversationActionType.AlwaysDelete, conversationId, processSynchronously, null, false, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.EnableAlwaysMoveItemsInConversations = function (conversationId, destinationFolderId, processSynchronously) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.ApplyConversationAction(ConversationActionType.AlwaysMove, conversationId, processSynchronously, null, false, destinationFolderId, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.DisableAlwaysMoveItemsInConversations = function (conversationIds, processSynchronously) {
            return this.ApplyConversationAction(ConversationActionType.AlwaysMove, conversationIds, processSynchronously, null, false, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.MoveItemsInConversations = function (idLastSyncTimePairs, contextFolderId, destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.ApplyConversationOneTimeAction(ConversationActionType.Move, idLastSyncTimePairs, contextFolderId, destinationFolderId, null, null, null, null, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.CopyItemsInConversations = function (idLastSyncTimePairs, contextFolderId, destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.ApplyConversationOneTimeAction(ConversationActionType.Copy, idLastSyncTimePairs, contextFolderId, destinationFolderId, null, null, null, null, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.DeleteItemsInConversations = function (idLastSyncTimePairs, contextFolderId, deleteMode) {
            return this.ApplyConversationOneTimeAction(ConversationActionType.Delete, idLastSyncTimePairs, contextFolderId, null, new Nullable(deleteMode), null, null, null, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.SetReadStateForItemsInConversations = function (idLastSyncTimePairs, contextFolderId, isRead, suppressReadReceipts) {
            if (arguments.length === 3 && (contextFolderId === null || contextFolderId instanceof FolderId) && (isRead === null || isRead.constructor === Boolean)) {
                return this.SetReadStateForItemsInConversations_0(idLastSyncTimePairs, contextFolderId, isRead);
            }
            return this.SetReadStateForItemsInConversations_1(idLastSyncTimePairs, contextFolderId, isRead, suppressReadReceipts);
        };
        ExchangeService.prototype.SetReadStateForItemsInConversations_0 = function (idLastSyncTimePairs, contextFolderId, isRead) {
            return this.ApplyConversationOneTimeAction(ConversationActionType.SetReadState, idLastSyncTimePairs, contextFolderId, null, null, new Nullable(isRead), null, null, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.SetReadStateForItemsInConversations_1 = function (idLastSyncTimePairs, contextFolderId, isRead, suppressReadReceipts) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "SetReadStateForItemsInConversations");
            return this.ApplyConversationOneTimeAction(ConversationActionType.SetReadState, idLastSyncTimePairs, contextFolderId, null, null, new Nullable(isRead), null, null, null, new Nullable(suppressReadReceipts), ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.SetRetentionPolicyForItemsInConversations = function (idLastSyncTimePairs, contextFolderId, retentionPolicyType, retentionPolicyTagId) {
            return this.ApplyConversationOneTimeAction(ConversationActionType.SetRetentionPolicy, idLastSyncTimePairs, contextFolderId, null, null, null, new Nullable(retentionPolicyType), retentionPolicyTagId, null, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.SetFlagStatusForItemsInConversations = function (idLastSyncTimePairs, contextFolderId, flagStatus) {
            EwsUtilities.ValidateMethodVersion(this, ExchangeVersion.Exchange2013, "SetFlagStatusForItemsInConversations");
            return this.ApplyConversationOneTimeAction(ConversationActionType.Flag, idLastSyncTimePairs, contextFolderId, null, null, null, null, null, flagStatus, null, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.InternalConvertIds = function (ids, destinationFormat, errorHandling) {
            EwsUtilities.ValidateParamCollection(ids, "ids");
            var convertIdRequest = new ConvertIdRequest(this, errorHandling);
            convertIdRequest.Ids.AddRange(ids);
            convertIdRequest.DestinationFormat = destinationFormat;
            return convertIdRequest.Execute();
        };
        ExchangeService.prototype.ConvertIds = function (ids, destinationFormat) {
            EwsUtilities.ValidateParamCollection(ids, "ids");
            return this.InternalConvertIds(ids, destinationFormat, ServiceErrorHandling.ReturnErrors);
        };
        ExchangeService.prototype.ConvertId = function (id, destinationFormat) {
            EwsUtilities.ValidateParam(id, "id");
            var serviceResponseCollection = this.InternalConvertIds(NArray.ToEnumerable([
                id
            ]), destinationFormat, ServiceErrorHandling.ThrowOnError);
            return serviceResponseCollection.get_Item(0).ConvertedId;
        };
        ExchangeService.prototype.AddDelegates = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            if (arguments.length === 3 && (mailbox === null || mailbox instanceof Mailbox) && (meetingRequestsDeliveryScope === null || meetingRequestsDeliveryScope instanceof Array) && (delegateUsers === null || delegateUsers instanceof Array)) {
                return this.AddDelegates_0(mailbox, meetingRequestsDeliveryScope, delegateUsers);
            }
            return this.AddDelegates_1(mailbox, meetingRequestsDeliveryScope, delegateUsers);
        };
        ExchangeService.prototype.AddDelegates_0 = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            return this.AddDelegates(mailbox, meetingRequestsDeliveryScope, delegateUsers);
        };
        ExchangeService.prototype.AddDelegates_1 = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            EwsUtilities.ValidateParam(mailbox, "mailbox");
            EwsUtilities.ValidateParamCollection(delegateUsers, "delegateUsers");
            var addDelegateRequest = new AddDelegateRequest(this);
            addDelegateRequest.Mailbox = mailbox;
            addDelegateRequest.DelegateUsers.AddRange(delegateUsers);
            addDelegateRequest.MeetingRequestsDeliveryScope = meetingRequestsDeliveryScope;
            var delegateManagementResponse = addDelegateRequest.Execute();
            return delegateManagementResponse.DelegateUserResponses;
        };
        ExchangeService.prototype.UpdateDelegates = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            if (arguments.length === 3 && (mailbox === null || mailbox instanceof Mailbox) && (meetingRequestsDeliveryScope === null || meetingRequestsDeliveryScope instanceof Array) && (delegateUsers === null || delegateUsers instanceof Array)) {
                return this.UpdateDelegates_0(mailbox, meetingRequestsDeliveryScope, delegateUsers);
            }
            return this.UpdateDelegates_1(mailbox, meetingRequestsDeliveryScope, delegateUsers);
        };
        ExchangeService.prototype.UpdateDelegates_0 = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            return this.UpdateDelegates(mailbox, meetingRequestsDeliveryScope, delegateUsers);
        };
        ExchangeService.prototype.UpdateDelegates_1 = function (mailbox, meetingRequestsDeliveryScope, delegateUsers) {
            EwsUtilities.ValidateParam(mailbox, "mailbox");
            EwsUtilities.ValidateParamCollection(delegateUsers, "delegateUsers");
            var updateDelegateRequest = new UpdateDelegateRequest(this);
            updateDelegateRequest.Mailbox = mailbox;
            updateDelegateRequest.DelegateUsers.AddRange(delegateUsers);
            updateDelegateRequest.MeetingRequestsDeliveryScope = meetingRequestsDeliveryScope;
            var delegateManagementResponse = updateDelegateRequest.Execute();
            return delegateManagementResponse.DelegateUserResponses;
        };
        ExchangeService.prototype.RemoveDelegates = function (mailbox, userIds) {
            if (arguments.length === 2 && (mailbox === null || mailbox instanceof Mailbox) && (userIds === null || userIds instanceof Array)) {
                return this.RemoveDelegates_0(mailbox, userIds);
            }
            return this.RemoveDelegates_1(mailbox, userIds);
        };
        ExchangeService.prototype.RemoveDelegates_0 = function (mailbox, userIds) {
            return this.RemoveDelegates(mailbox, userIds);
        };
        ExchangeService.prototype.RemoveDelegates_1 = function (mailbox, userIds) {
            EwsUtilities.ValidateParam(mailbox, "mailbox");
            EwsUtilities.ValidateParamCollection(userIds, "userIds");
            var removeDelegateRequest = new RemoveDelegateRequest(this);
            removeDelegateRequest.Mailbox = mailbox;
            removeDelegateRequest.UserIds.AddRange(userIds);
            var delegateManagementResponse = removeDelegateRequest.Execute();
            return delegateManagementResponse.DelegateUserResponses;
        };
        ExchangeService.prototype.GetDelegates = function (mailbox, includePermissions, userIds) {
            if (arguments.length === 3 && (mailbox === null || mailbox instanceof Mailbox) && (includePermissions === null || includePermissions.constructor === Boolean) && (userIds === null || userIds instanceof Array)) {
                return this.GetDelegates_0(mailbox, includePermissions, userIds);
            }
            return this.GetDelegates_1(mailbox, includePermissions, userIds);
        };
        ExchangeService.prototype.GetDelegates_0 = function (mailbox, includePermissions, userIds) {
            return this.GetDelegates(mailbox, includePermissions, userIds);
        };
        ExchangeService.prototype.GetDelegates_1 = function (mailbox, includePermissions, userIds) {
            EwsUtilities.ValidateParam(mailbox, "mailbox");
            var getDelegateRequest = new GetDelegateRequest(this);
            getDelegateRequest.Mailbox = mailbox;
            getDelegateRequest.UserIds.AddRange(userIds);
            getDelegateRequest.IncludePermissions = includePermissions;
            var getDelegateResponse = getDelegateRequest.Execute();
            return new DelegateInformation(getDelegateResponse.DelegateUserResponses, getDelegateResponse.MeetingRequestsDeliveryScope);
        };
        ExchangeService.prototype.CreateUserConfiguration = function (userConfiguration) {
            EwsUtilities.ValidateParam(userConfiguration, "userConfiguration");
            var createUserConfigurationRequest = new CreateUserConfigurationRequest(this);
            createUserConfigurationRequest.UserConfiguration = userConfiguration;
            createUserConfigurationRequest.Execute();
        };
        ExchangeService.prototype.DeleteUserConfiguration = function (name, parentFolderId) {
            EwsUtilities.ValidateParam(name, "name");
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            var deleteUserConfigurationRequest = new DeleteUserConfigurationRequest(this);
            deleteUserConfigurationRequest.Name = name;
            deleteUserConfigurationRequest.ParentFolderId = parentFolderId;
            deleteUserConfigurationRequest.Execute();
        };
        ExchangeService.prototype.GetUserConfiguration = function (name, parentFolderId, properties) {
            EwsUtilities.ValidateParam(name, "name");
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            var getUserConfigurationRequest = new GetUserConfigurationRequest(this);
            getUserConfigurationRequest.Name = name;
            getUserConfigurationRequest.ParentFolderId = parentFolderId;
            getUserConfigurationRequest.Properties = properties;
            return getUserConfigurationRequest.Execute().get_Item(0).UserConfiguration;
        };
        ExchangeService.prototype.LoadPropertiesForUserConfiguration = function (userConfiguration, properties) {
            EwsUtilities.Assert(userConfiguration !== null, "ExchangeService.LoadPropertiesForUserConfiguration", "userConfiguration is null");
            var getUserConfigurationRequest = new GetUserConfigurationRequest(this);
            getUserConfigurationRequest.UserConfiguration = userConfiguration;
            getUserConfigurationRequest.Properties = properties;
            getUserConfigurationRequest.Execute();
        };
        ExchangeService.prototype.UpdateUserConfiguration = function (userConfiguration) {
            EwsUtilities.ValidateParam(userConfiguration, "userConfiguration");
            var updateUserConfigurationRequest = new UpdateUserConfigurationRequest(this);
            updateUserConfigurationRequest.UserConfiguration = userConfiguration;
            updateUserConfigurationRequest.Execute();
        };
        ExchangeService.prototype.GetInboxRules = function (mailboxSmtpAddress) {
            if (arguments.length === 0) {
                return this.GetInboxRules_0();
            }
            return this.GetInboxRules_1(mailboxSmtpAddress);
        };
        ExchangeService.prototype.GetInboxRules_0 = function () {
            var getInboxRulesRequest = new GetInboxRulesRequest(this);
            return getInboxRulesRequest.Execute().Rules;
        };
        ExchangeService.prototype.GetInboxRules_1 = function (mailboxSmtpAddress) {
            EwsUtilities.ValidateParam(mailboxSmtpAddress, "MailboxSmtpAddress");
            var getInboxRulesRequest = new GetInboxRulesRequest(this);
            getInboxRulesRequest.MailboxSmtpAddress = mailboxSmtpAddress;
            return getInboxRulesRequest.Execute().Rules;
        };
        ExchangeService.prototype.UpdateInboxRules = function (operations, removeOutlookRuleBlob, mailboxSmtpAddress) {
            if (arguments.length === 2 && (removeOutlookRuleBlob === null || removeOutlookRuleBlob.constructor === Boolean)) {
                this.UpdateInboxRules_0(operations, removeOutlookRuleBlob);
                return;
            }
            this.UpdateInboxRules_1(operations, removeOutlookRuleBlob, mailboxSmtpAddress);
        };
        ExchangeService.prototype.UpdateInboxRules_0 = function (operations, removeOutlookRuleBlob) {
            var updateInboxRulesRequest = new UpdateInboxRulesRequest(this);
            updateInboxRulesRequest.InboxRuleOperations = operations;
            updateInboxRulesRequest.RemoveOutlookRuleBlob = removeOutlookRuleBlob;
            updateInboxRulesRequest.Execute();
        };
        ExchangeService.prototype.UpdateInboxRules_1 = function (operations, removeOutlookRuleBlob, mailboxSmtpAddress) {
            var updateInboxRulesRequest = new UpdateInboxRulesRequest(this);
            updateInboxRulesRequest.InboxRuleOperations = operations;
            updateInboxRulesRequest.RemoveOutlookRuleBlob = removeOutlookRuleBlob;
            updateInboxRulesRequest.MailboxSmtpAddress = mailboxSmtpAddress;
            updateInboxRulesRequest.Execute();
        };
        ExchangeService.prototype.GetDiscoverySearchConfiguration = function (searchId, expandGroupMembership, inPlaceHoldConfigurationOnly) {
            var getDiscoverySearchConfigurationRequest = new GetDiscoverySearchConfigurationRequest(this);
            getDiscoverySearchConfigurationRequest.SearchId = searchId;
            getDiscoverySearchConfigurationRequest.ExpandGroupMembership = expandGroupMembership;
            getDiscoverySearchConfigurationRequest.InPlaceHoldConfigurationOnly = inPlaceHoldConfigurationOnly;
            return getDiscoverySearchConfigurationRequest.Execute();
        };
        ExchangeService.prototype.GetSearchableMailboxes = function (searchFilter, expandGroupMembership) {
            var getSearchableMailboxesRequest = new GetSearchableMailboxesRequest(this);
            getSearchableMailboxesRequest.SearchFilter = searchFilter;
            getSearchableMailboxesRequest.ExpandGroupMembership = expandGroupMembership;
            return getSearchableMailboxesRequest.Execute();
        };
        ExchangeService.prototype.SearchMailboxes = function (mailboxQueriesOrSearchParameters, resultType, sortByProperty, sortOrder, pageSize, pageDirection, pageItemReference) {
            if (arguments.length === 2 && (resultType === null || resultType.constructor === Number)) {
                return this.SearchMailboxes_0(mailboxQueriesOrSearchParameters, resultType);
            }
            if (arguments.length === 7 && (resultType === null || resultType.constructor === Number) && (sortByProperty === null || sortByProperty.constructor === String) && (sortOrder === null || sortOrder.constructor === Number) && (pageSize === null || pageSize.constructor === Number) && (pageDirection === null || pageDirection.constructor === Number) && (pageItemReference === null || pageItemReference.constructor === String)) {
                return this.SearchMailboxes_1(mailboxQueriesOrSearchParameters, resultType, sortByProperty, sortOrder, pageSize, pageDirection, pageItemReference);
            }
            return this.SearchMailboxes_2(mailboxQueriesOrSearchParameters);
        };
        ExchangeService.prototype.SearchMailboxes_0 = function (mailboxQueries, resultType) {
            var searchMailboxesRequest = new SearchMailboxesRequest(this, ServiceErrorHandling.ReturnErrors);
            if (mailboxQueries !== null) {
                searchMailboxesRequest.SearchQueries.AddRange(mailboxQueries);
            }
            searchMailboxesRequest.ResultType = resultType;
            return searchMailboxesRequest.Execute();
        };
        ExchangeService.prototype.SearchMailboxes_1 = function (mailboxQueries, resultType, sortByProperty, sortOrder, pageSize, pageDirection, pageItemReference) {
            var searchMailboxesRequest = new SearchMailboxesRequest(this, ServiceErrorHandling.ReturnErrors);
            if (mailboxQueries !== null) {
                searchMailboxesRequest.SearchQueries.AddRange(mailboxQueries);
            }
            searchMailboxesRequest.ResultType = resultType;
            searchMailboxesRequest.SortByProperty = sortByProperty;
            searchMailboxesRequest.SortOrder = sortOrder;
            searchMailboxesRequest.PageSize = pageSize;
            searchMailboxesRequest.PageDirection = pageDirection;
            searchMailboxesRequest.PageItemReference = pageItemReference;
            return searchMailboxesRequest.Execute();
        };
        ExchangeService.prototype.SearchMailboxes_2 = function (searchParameters) {
            EwsUtilities.ValidateParam(searchParameters, "searchParameters");
            EwsUtilities.ValidateParam(searchParameters.SearchQueries, "searchParameters.SearchQueries");
            var searchMailboxesRequest = this.CreateSearchMailboxesRequest(searchParameters);
            return searchMailboxesRequest.Execute();
        };
        ExchangeService.prototype.BeginSearchMailboxes = function (callback, state, searchParameters) {
            EwsUtilities.ValidateParam(searchParameters, "searchParameters");
            EwsUtilities.ValidateParam(searchParameters.SearchQueries, "searchParameters.SearchQueries");
            var searchMailboxesRequest = this.CreateSearchMailboxesRequest(searchParameters);
            return searchMailboxesRequest.BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndSearchMailboxes = function (asyncResult) {
            var searchMailboxesRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return searchMailboxesRequest.EndExecute(asyncResult);
        };
        ExchangeService.prototype.SetHoldOnMailboxes = function (holdIdOrParameters, actionType, query, mailboxesOrInPlaceHoldIdentity, itemHoldPeriod) {
            if (arguments.length === 4 && (holdIdOrParameters === null || holdIdOrParameters.constructor === String) && (actionType === null || actionType.constructor === Number) && (query === null || query.constructor === String) && (mailboxesOrInPlaceHoldIdentity === null || mailboxesOrInPlaceHoldIdentity instanceof Array)) {
                return this.SetHoldOnMailboxes_0(holdIdOrParameters, actionType, query, mailboxesOrInPlaceHoldIdentity);
            }
            if (arguments.length === 4 && (holdIdOrParameters === null || holdIdOrParameters.constructor === String) && (actionType === null || actionType.constructor === Number) && (query === null || query.constructor === String) && (mailboxesOrInPlaceHoldIdentity === null || mailboxesOrInPlaceHoldIdentity.constructor === String)) {
                return this.SetHoldOnMailboxes_1(holdIdOrParameters, actionType, query, mailboxesOrInPlaceHoldIdentity);
            }
            if (arguments.length === 5 && (holdIdOrParameters === null || holdIdOrParameters.constructor === String) && (actionType === null || actionType.constructor === Number) && (query === null || query.constructor === String) && (mailboxesOrInPlaceHoldIdentity === null || mailboxesOrInPlaceHoldIdentity.constructor === String) && (itemHoldPeriod === null || itemHoldPeriod.constructor === String)) {
                return this.SetHoldOnMailboxes_2(holdIdOrParameters, actionType, query, mailboxesOrInPlaceHoldIdentity, itemHoldPeriod);
            }
            return this.SetHoldOnMailboxes_3(holdIdOrParameters);
        };
        ExchangeService.prototype.SetHoldOnMailboxes_0 = function (holdId, actionType, query, mailboxes) {
            var setHoldOnMailboxesRequest = new SetHoldOnMailboxesRequest(this);
            setHoldOnMailboxesRequest.HoldId = holdId;
            setHoldOnMailboxesRequest.ActionType = actionType;
            setHoldOnMailboxesRequest.Query = query;
            setHoldOnMailboxesRequest.Mailboxes = mailboxes;
            setHoldOnMailboxesRequest.InPlaceHoldIdentity = null;
            return setHoldOnMailboxesRequest.Execute();
        };
        ExchangeService.prototype.SetHoldOnMailboxes_1 = function (holdId, actionType, query, inPlaceHoldIdentity) {
            return this.SetHoldOnMailboxes(holdId, actionType, query, inPlaceHoldIdentity, null);
        };
        ExchangeService.prototype.SetHoldOnMailboxes_2 = function (holdId, actionType, query, inPlaceHoldIdentity, itemHoldPeriod) {
            var setHoldOnMailboxesRequest = new SetHoldOnMailboxesRequest(this);
            setHoldOnMailboxesRequest.HoldId = holdId;
            setHoldOnMailboxesRequest.ActionType = actionType;
            setHoldOnMailboxesRequest.Query = query;
            setHoldOnMailboxesRequest.Mailboxes = null;
            setHoldOnMailboxesRequest.InPlaceHoldIdentity = inPlaceHoldIdentity;
            setHoldOnMailboxesRequest.ItemHoldPeriod = itemHoldPeriod;
            return setHoldOnMailboxesRequest.Execute();
        };
        ExchangeService.prototype.SetHoldOnMailboxes_3 = function (parameters) {
            EwsUtilities.ValidateParam(parameters, "parameters");
            var setHoldOnMailboxesRequest = new SetHoldOnMailboxesRequest(this);
            setHoldOnMailboxesRequest.HoldId = parameters.HoldId;
            setHoldOnMailboxesRequest.ActionType = parameters.ActionType;
            setHoldOnMailboxesRequest.Query = parameters.Query;
            setHoldOnMailboxesRequest.Mailboxes = parameters.Mailboxes;
            setHoldOnMailboxesRequest.Language = parameters.Language;
            setHoldOnMailboxesRequest.InPlaceHoldIdentity = parameters.InPlaceHoldIdentity;
            return setHoldOnMailboxesRequest.Execute();
        };
        ExchangeService.prototype.GetHoldOnMailboxes = function (holdId) {
            var getHoldOnMailboxesRequest = new GetHoldOnMailboxesRequest(this);
            getHoldOnMailboxesRequest.HoldId = holdId;
            return getHoldOnMailboxesRequest.Execute();
        };
        ExchangeService.prototype.GetNonIndexableItemDetails = function (mailboxesOrParameters, pageSize, pageItemReference, pageDirection) {
            if (arguments.length === 1 && (mailboxesOrParameters === null || mailboxesOrParameters instanceof Array)) {
                return this.GetNonIndexableItemDetails_0(mailboxesOrParameters);
            }
            if (arguments.length === 4 && (mailboxesOrParameters === null || mailboxesOrParameters instanceof Array) && (pageSize === null || pageSize instanceof Array) && (pageItemReference === null || pageItemReference.constructor === String) && (pageDirection === null || pageDirection instanceof Array)) {
                return this.GetNonIndexableItemDetails_1(mailboxesOrParameters, pageSize, pageItemReference, pageDirection);
            }
            return this.GetNonIndexableItemDetails_2(mailboxesOrParameters);
        };
        ExchangeService.prototype.GetNonIndexableItemDetails_0 = function (mailboxes) {
            return this.GetNonIndexableItemDetails(mailboxes, null, null, null);
        };
        ExchangeService.prototype.GetNonIndexableItemDetails_1 = function (mailboxes, pageSize, pageItemReference, pageDirection) {
            var getNonIndexableItemDetailsParameters = new GetNonIndexableItemDetailsParameters();
            getNonIndexableItemDetailsParameters.Mailboxes = mailboxes;
            getNonIndexableItemDetailsParameters.PageSize = pageSize;
            getNonIndexableItemDetailsParameters.PageItemReference = pageItemReference;
            getNonIndexableItemDetailsParameters.PageDirection = pageDirection;
            getNonIndexableItemDetailsParameters.SearchArchiveOnly = false;
            var parameters = getNonIndexableItemDetailsParameters;
            return this.GetNonIndexableItemDetails(parameters);
        };
        ExchangeService.prototype.GetNonIndexableItemDetails_2 = function (parameters) {
            var getNonIndexableItemDetailsRequest = this.CreateGetNonIndexableItemDetailsRequest(parameters);
            return getNonIndexableItemDetailsRequest.Execute();
        };
        ExchangeService.prototype.BeginGetNonIndexableItemDetails = function (callback, state, parameters) {
            var getNonIndexableItemDetailsRequest = this.CreateGetNonIndexableItemDetailsRequest(parameters);
            return getNonIndexableItemDetailsRequest.BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndGetNonIndexableItemDetails = function (asyncResult) {
            var getNonIndexableItemDetailsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return getNonIndexableItemDetailsRequest.EndInternalExecute(asyncResult);
        };
        ExchangeService.prototype.GetNonIndexableItemStatistics = function (mailboxesOrParameters) {
            if (arguments.length === 1 && (mailboxesOrParameters === null || mailboxesOrParameters instanceof Array)) {
                return this.GetNonIndexableItemStatistics_0(mailboxesOrParameters);
            }
            return this.GetNonIndexableItemStatistics_1(mailboxesOrParameters);
        };
        ExchangeService.prototype.GetNonIndexableItemStatistics_0 = function (mailboxes) {
            var getNonIndexableItemStatisticsParameters = new GetNonIndexableItemStatisticsParameters();
            getNonIndexableItemStatisticsParameters.Mailboxes = mailboxes;
            getNonIndexableItemStatisticsParameters.SearchArchiveOnly = false;
            var parameters = getNonIndexableItemStatisticsParameters;
            return this.GetNonIndexableItemStatistics(parameters);
        };
        ExchangeService.prototype.GetNonIndexableItemStatistics_1 = function (parameters) {
            var getNonIndexableItemStatisticsRequest = this.CreateGetNonIndexableItemStatisticsRequest(parameters);
            return getNonIndexableItemStatisticsRequest.Execute();
        };
        ExchangeService.prototype.BeginGetNonIndexableItemStatistics = function (callback, state, parameters) {
            var getNonIndexableItemStatisticsRequest = this.CreateGetNonIndexableItemStatisticsRequest(parameters);
            return getNonIndexableItemStatisticsRequest.BeginExecute(callback, state);
        };
        ExchangeService.prototype.EndGetNonIndexableItemStatistics = function (asyncResult) {
            var getNonIndexableItemStatisticsRequest = AsyncRequestResult.ExtractServiceRequest(this, asyncResult);
            return getNonIndexableItemStatisticsRequest.EndInternalExecute(asyncResult);
        };
        ExchangeService.prototype.CreateGetNonIndexableItemDetailsRequest = function (parameters) {
            EwsUtilities.ValidateParam(parameters, "parameters");
            EwsUtilities.ValidateParam(parameters.Mailboxes, "parameters.Mailboxes");
            var getNonIndexableItemDetailsRequest = new GetNonIndexableItemDetailsRequest(this);
            getNonIndexableItemDetailsRequest.Mailboxes = parameters.Mailboxes;
            getNonIndexableItemDetailsRequest.PageSize = parameters.PageSize;
            getNonIndexableItemDetailsRequest.PageItemReference = parameters.PageItemReference;
            getNonIndexableItemDetailsRequest.PageDirection = parameters.PageDirection;
            getNonIndexableItemDetailsRequest.SearchArchiveOnly = parameters.SearchArchiveOnly;
            return getNonIndexableItemDetailsRequest;
        };
        ExchangeService.prototype.CreateGetNonIndexableItemStatisticsRequest = function (parameters) {
            EwsUtilities.ValidateParam(parameters, "parameters");
            EwsUtilities.ValidateParam(parameters.Mailboxes, "parameters.Mailboxes");
            var getNonIndexableItemStatisticsRequest = new GetNonIndexableItemStatisticsRequest(this);
            getNonIndexableItemStatisticsRequest.Mailboxes = parameters.Mailboxes;
            getNonIndexableItemStatisticsRequest.SearchArchiveOnly = parameters.SearchArchiveOnly;
            return getNonIndexableItemStatisticsRequest;
        };
        ExchangeService.prototype.CreateSearchMailboxesRequest = function (searchParameters) {
            var searchMailboxesRequest = new SearchMailboxesRequest(this, ServiceErrorHandling.ReturnErrors);
            searchMailboxesRequest.SearchQueries.AddRange(NArray.ToEnumerable(searchParameters.SearchQueries));
            searchMailboxesRequest.ResultType = searchParameters.ResultType;
            searchMailboxesRequest.PreviewItemResponseShape = searchParameters.PreviewItemResponseShape;
            searchMailboxesRequest.SortByProperty = searchParameters.SortBy;
            searchMailboxesRequest.SortOrder = searchParameters.SortOrder;
            searchMailboxesRequest.Language = searchParameters.Language;
            searchMailboxesRequest.PerformDeduplication = searchParameters.PerformDeduplication;
            searchMailboxesRequest.PageSize = searchParameters.PageSize;
            searchMailboxesRequest.PageDirection = searchParameters.PageDirection;
            searchMailboxesRequest.PageItemReference = searchParameters.PageItemReference;
            return searchMailboxesRequest;
        };
        ExchangeService.prototype.GetUserRetentionPolicyTags = function () {
            var getUserRetentionPolicyTagsRequest = new GetUserRetentionPolicyTagsRequest(this);
            return getUserRetentionPolicyTagsRequest.Execute();
        };
        ExchangeService.prototype.DefaultAutodiscoverRedirectionUrlValidationCallback = function (redirectionUrl) {
            throw new AutodiscoverLocalException(NString.Format(Strings.AutodiscoverRedirectBlocked, redirectionUrl));
        };
        ExchangeService.prototype.AutodiscoverUrl = function (emailAddress, validateRedirectionUrlCallback) {
            if (arguments.length === 1 && (emailAddress === null || emailAddress.constructor === String)) {
                this.AutodiscoverUrl_0(emailAddress);
                return;
            }
            this.AutodiscoverUrl_1(emailAddress, validateRedirectionUrlCallback);
        };
        ExchangeService.prototype.AutodiscoverUrl_0 = function (emailAddress) {
            this.AutodiscoverUrl(emailAddress, this.DefaultAutodiscoverRedirectionUrlValidationCallback);
        };
        ExchangeService.prototype.AutodiscoverUrl_1 = function (emailAddress, validateRedirectionUrlCallback) {
            var autodiscoverUrl;
            if (this.RequestedServerVersion > ExchangeVersion.Exchange2007_SP1) {
                try {
                    autodiscoverUrl = this.GetAutodiscoverUrl(emailAddress, this.RequestedServerVersion, validateRedirectionUrlCallback);
                    this.Url = this.AdjustServiceUriFromCredentials(autodiscoverUrl);
                    return;
                }
                catch (ex) {
                    if (ex instanceof AutodiscoverLocalException) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service call failed with error '{0}'. Will try legacy service", ex.Message));
                    }
                    else if (ex instanceof ServiceRemoteException) {
                        if (ex2 instanceof AccountIsLockedException) {
                            throw ex;
                        }
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service call failed with error '{0}'. Will try legacy service", ex2.Message));
                    }
                    else
                        throw ex;
                }
            }
            autodiscoverUrl = this.GetAutodiscoverUrl(emailAddress, ExchangeVersion.Exchange2007_SP1, validateRedirectionUrlCallback);
            this.Url = this.AdjustServiceUriFromCredentials(autodiscoverUrl);
        };
        ExchangeService.prototype.AdjustServiceUriFromCredentials = function (uri) {
            if (this.Credentials === null) {
                return uri;
            }
            return this.Credentials.AdjustUrl(uri);
        };
        ExchangeService.prototype.GetAutodiscoverUrl = function (emailAddress, requestedServerVersion, validateRedirectionUrlCallback) {
            var autodiscoverService = new AutodiscoverService(this, requestedServerVersion);
            autodiscoverService.RedirectionUrlValidationCallback = validateRedirectionUrlCallback;
            autodiscoverService.EnableScpLookup = this.EnableScpLookup;
            var autodiscoverService2 = autodiscoverService;
            var userSettings = autodiscoverService2.GetUserSettings(emailAddress, [
                UserSettingName.InternalEwsUrl, UserSettingName.ExternalEwsUrl
            ]);
            switch (userSettings.ErrorCode) {
                case AutodiscoverErrorCode.NoError:
                    return this.GetEwsUrlFromResponse(userSettings, autodiscoverService2.IsExternal.GetValueOrDefault(true));
                case AutodiscoverErrorCode.InvalidUser:
                    throw new ServiceRemoteException(NString.Format(Strings.InvalidUser, emailAddress));
                case AutodiscoverErrorCode.InvalidRequest:
                    throw new ServiceRemoteException(NString.Format(Strings.InvalidAutodiscoverRequest, userSettings.ErrorMessage));
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No EWS Url returned for user {0}, error code is {1}", emailAddress, userSettings.ErrorCode));
            throw new ServiceRemoteException(userSettings.ErrorMessage);
        };
        ExchangeService.prototype.GetEwsUrlFromResponse = function (response, isExternal) {
            var text;
            if (isExternal && (function () {
                var _p0 = [
                    text
                ];
                var _r = response.TryGetSettingValue(UserSettingName.ExternalEwsUrl, _p0);
                text = _p0[0];
                return _r;
            })() && !NString.IsNullOrEmpty(text)) {
                return new Uri(text);
            }
            if (((function () {
                var _p0 = [
                    text
                ];
                var _r = response.TryGetSettingValue(UserSettingName.InternalEwsUrl, _p0);
                text = _p0[0];
                return _r;
            })() || (function () {
                var _p0 = [
                    text
                ];
                var _r = response.TryGetSettingValue(UserSettingName.ExternalEwsUrl, _p0);
                text = _p0[0];
                return _r;
            })()) && !NString.IsNullOrEmpty(text)) {
                return new Uri(text);
            }
            throw new AutodiscoverLocalException(Strings.AutodiscoverDidNotReturnEwsUrl);
        };
        ExchangeService.prototype.GetClientAccessToken = function (idAndTypesOrTokenRequests) {
            if (arguments.length === 1) {
                return this.GetClientAccessToken_0(idAndTypesOrTokenRequests);
            }
            return this.GetClientAccessToken_1(idAndTypesOrTokenRequests);
        };
        ExchangeService.prototype.GetClientAccessToken_0 = function (idAndTypes) {
            new GetClientAccessTokenRequest(this, ServiceErrorHandling.ReturnErrors);
            var list = new List();
            var enumerator = idAndTypes.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var item = new ClientAccessTokenRequest(current.Key, current.Value);
                    list.Add(item);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return this.GetClientAccessToken(list.ToArray());
        };
        ExchangeService.prototype.GetClientAccessToken_1 = function (tokenRequests) {
            var getClientAccessTokenRequest = new GetClientAccessTokenRequest(this, ServiceErrorHandling.ReturnErrors);
            getClientAccessTokenRequest.TokenRequests = tokenRequests;
            return getClientAccessTokenRequest.Execute();
        };
        ExchangeService.prototype.GetAppManifests = function (apiVersionSupported, schemaVersionSupported) {
            if (arguments.length === 0) {
                return this.GetAppManifests_0();
            }
            return this.GetAppManifests_1(apiVersionSupported, schemaVersionSupported);
        };
        ExchangeService.prototype.GetAppManifests_0 = function () {
            var getAppManifestsRequest = new GetAppManifestsRequest(this);
            return getAppManifestsRequest.Execute().Manifests;
        };
        ExchangeService.prototype.GetAppManifests_1 = function (apiVersionSupported, schemaVersionSupported) {
            var getAppManifestsRequest = new GetAppManifestsRequest(this);
            getAppManifestsRequest.ApiVersionSupported = apiVersionSupported;
            getAppManifestsRequest.SchemaVersionSupported = schemaVersionSupported;
            return getAppManifestsRequest.Execute().Apps;
        };
        ExchangeService.prototype.InstallApp = function (manifestStream) {
            EwsUtilities.ValidateParam(manifestStream, "manifestStream");
            var installAppRequest = new InstallAppRequest(this, manifestStream);
            installAppRequest.Execute();
        };
        ExchangeService.prototype.UninstallApp = function (id) {
            EwsUtilities.ValidateParam(id, "id");
            var uninstallAppRequest = new UninstallAppRequest(this, id);
            uninstallAppRequest.Execute();
        };
        ExchangeService.prototype.DisableApp = function (id, disableReason) {
            EwsUtilities.ValidateParam(id, "id");
            EwsUtilities.ValidateParam(disableReason, "disableReason");
            var disableAppRequest = new DisableAppRequest(this, id, disableReason);
            disableAppRequest.Execute();
        };
        ExchangeService.prototype.GetAppMarketplaceUrl = function (apiVersionSupported, schemaVersionSupported) {
            if (arguments.length === 0) {
                return this.GetAppMarketplaceUrl_0();
            }
            return this.GetAppMarketplaceUrl_1(apiVersionSupported, schemaVersionSupported);
        };
        ExchangeService.prototype.GetAppMarketplaceUrl_0 = function () {
            return this.GetAppMarketplaceUrl(null, null);
        };
        ExchangeService.prototype.GetAppMarketplaceUrl_1 = function (apiVersionSupported, schemaVersionSupported) {
            var getAppMarketplaceUrlRequest = new GetAppMarketplaceUrlRequest(this);
            getAppMarketplaceUrlRequest.ApiVersionSupported = apiVersionSupported;
            getAppMarketplaceUrlRequest.SchemaVersionSupported = schemaVersionSupported;
            return getAppMarketplaceUrlRequest.Execute().AppMarketplaceUrl;
        };
        ExchangeService.prototype.GetClientExtension = function (requestedExtensionIds, shouldReturnEnabledOnly, isUserScope, userId, userEnabledExtensionIds, userDisabledExtensionIds, isDebug) {
            var getClientExtensionRequest = new GetClientExtensionRequest(this, requestedExtensionIds, shouldReturnEnabledOnly, isUserScope, userId, userEnabledExtensionIds, userDisabledExtensionIds, isDebug);
            return getClientExtensionRequest.Execute();
        };
        ExchangeService.prototype.GetEncryptionConfiguration = function () {
            var getEncryptionConfigurationRequest = new GetEncryptionConfigurationRequest(this);
            return getEncryptionConfigurationRequest.Execute();
        };
        ExchangeService.prototype.SetEncryptionConfiguration = function (imageBase64, emailText, portalText, disclaimerText) {
            var setEncryptionConfigurationRequest = new SetEncryptionConfigurationRequest(this, imageBase64, emailText, portalText, disclaimerText);
            setEncryptionConfigurationRequest.Execute();
        };
        ExchangeService.prototype.SetClientExtension = function (actions) {
            var setClientExtensionRequest = new SetClientExtensionRequest(this, actions);
            setClientExtensionRequest.Execute();
        };
        ExchangeService.prototype.ExecuteDiagnosticMethod = function (verb, parameter) {
            var executeDiagnosticMethodRequest = new ExecuteDiagnosticMethodRequest(this);
            executeDiagnosticMethodRequest.Verb = verb;
            executeDiagnosticMethodRequest.Parameter = parameter;
            return executeDiagnosticMethodRequest.Execute().get_Item(0).ReturnValue;
        };
        ExchangeService.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (Uri.op_Equality(this.Url, null)) {
                throw new ServiceLocalException(Strings.ServiceUrlMustBeSet);
            }
            if (this.PrivilegedUserId !== null && this.ImpersonatedUserId !== null) {
                throw new ServiceLocalException(Strings.CannotSetBothImpersonatedAndPrivilegedUser);
            }
        };
        ExchangeService.ValidateTargetVersion = function (version) {
            if (NString.IsNullOrEmpty(version)) {
                throw new ArgumentException("Target version must not be empty.");
            }
            var array = NString.Trim(version).Split([
                59
            ] /*';'*/);
            switch (array.length) {
                case 1:
                    break;
                case 2:
                    {
                        var text = NString.Trim(array[1]);
                        var array2 = text.Split([
                            61
                        ] /*'='*/);
                        if (array2.length !== 2 || !(NString.Trim(array2[0]) === "minimum") || !ExchangeService.IsMajorMinor(NString.Trim(array2[1]))) {
                            throw new ArgumentException("Target version must match X.Y or Exchange20XX.");
                        }
                        break;
                    }
                default:
                    throw new ArgumentException("Target version should have the form.");
            }
            var versionPart = NString.Trim(array[0]);
            if (NString.StartsWith(array[0], "Exchange20")) {
                return;
            }
            if (ExchangeService.IsMajorMinor(versionPart)) {
                return;
            }
            throw new ArgumentException("Target version must match X.Y or Exchange20XX.");
        };
        ExchangeService.IsMajorMinor = function (versionPart) {
            var array = versionPart.Split([
                46
            ] /*'.'*/);
            if (array.length !== 2) {
                return false;
            }
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var text = array2[i];
                var text2 = text;
                for (var j = 0; j < text2.length; j = j + 1) {
                    var c = text2.charCodeAt(j);
                    if (!NChar.IsDigit(c)) {
                        return false;
                    }
                }
            }
            return true;
        };
        ExchangeService.prototype.constructor_0 = function () {
        };
        ExchangeService.prototype.constructor_1 = function (timeZone) {
        };
        ExchangeService.prototype.constructor_2 = function (requestedServerVersion) {
        };
        ExchangeService.prototype.constructor_3 = function (requestedServerVersion, timeZone) {
        };
        ExchangeService.prototype.constructor_4 = function (targetServerVersion) {
            ExchangeService.ValidateTargetVersion(targetServerVersion);
            this.TargetServerVersion = targetServerVersion;
        };
        ExchangeService.prototype.constructor_5 = function (targetServerVersion, timeZone) {
            ExchangeService.ValidateTargetVersion(targetServerVersion);
            this.TargetServerVersion = targetServerVersion;
        };
        ExchangeService.prototype.PrepareHttpWebRequest = function (methodName) {
            var uri = this.Url;
            if (this.RenderingMethod === ExchangeService_RenderingMode.JSON) {
                uri = new Uri(uri, NString.Format("{0}/{1}{2}", uri.AbsolutePath, methodName, uri.Query));
            }
            else {
                uri = this.AdjustServiceUriFromCredentials(uri);
            }
            var ewsHttpWebRequest = _super.prototype.PrepareHttpWebRequestForUrl.call(this, uri, this.AcceptGzipEncoding, true);
            if (!NString.IsNullOrEmpty(this.TargetServerVersion)) {
                ewsHttpWebRequest.Headers.Set("X-EWS-TargetVersion", this.TargetServerVersion);
            }
            return ewsHttpWebRequest;
        };
        ExchangeService.prototype.SetContentType = function (request) {
            if (this.renderingMode === ExchangeService_RenderingMode.Xml) {
                request.ContentType = "text/xml; charset=utf-8";
                request.Accept = "text/xml";
                return;
            }
            if (this.renderingMode === ExchangeService_RenderingMode.JSON) {
                request.ContentType = "application/json; charset=utf-8";
                request.Accept = "application/json";
                return;
            }
            _super.prototype.SetContentType.call(this, request);
        };
        ExchangeService.prototype.ProcessHttpErrorResponse = function (httpWebResponse, webException) {
            _super.prototype.InternalProcessHttpErrorResponse.call(this, httpWebResponse, webException, TraceFlags.EwsResponseHttpHeaders, TraceFlags.EwsResponse);
        };
        ExchangeService.TargetServerVersionHeaderName = "X-EWS-TargetVersion";
        return ExchangeService;
    }(ExchangeServiceBase));
    var ExchangeService_RenderingMode;
    (function (ExchangeService_RenderingMode) {
        ExchangeService_RenderingMode[ExchangeService_RenderingMode["Xml"] = 0] = "Xml";
        ExchangeService_RenderingMode[ExchangeService_RenderingMode["JSON"] = 1] = "JSON";
    })(ExchangeService_RenderingMode || (ExchangeService_RenderingMode = {}));
    var JsonNames = (function () {
        function JsonNames() {
            _super.call(this);
        }
        JsonNames.Events = "Events";
        JsonNames.NotificationType = "NotificationType";
        JsonNames.OldFolderId = "OldFolderId";
        JsonNames.OldItemId = "OldItemId";
        JsonNames.PathToExtendedFieldType = "ExtendedPropertyUri";
        JsonNames.PathToIndexedFieldType = "DictionaryPropertyUri";
        JsonNames.PathToUnindexedFieldType = "PropertyUri";
        JsonNames.Path = "Path";
        JsonNames.RecurrencePattern = "RecurrencePattern";
        JsonNames.RecurrenceRange = "RecurrenceRange";
        return JsonNames;
    }());
    var JsonObject = (function (_super) {
        __extends(JsonObject, _super);
        function JsonObject() {
            _super.call(this);
        }
        JsonObject.ValidateObject = function (entry) {
            if (entry !== null && !(entry instanceof JsonObject) && !(entry instanceof Enum) && !(entry.constructor === Boolean) && !(entry.constructor === String) && !(entry.constructor === Number) && !(entry.constructor === Number) && !(entry.constructor === Number) && !(entry.constructor === Number) && !(entry instanceof DateTime) && !entry.GetType().IsArray) {
                throw new InvalidOperationException(NString.Format("Object [{0}] in the array is not serializable to JSON", entry));
            }
        };
        JsonObject.prototype.Add = function (name, value) {
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value instanceof JsonObject)) {
                this.Add_0(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === String)) {
                this.Add_1(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value instanceof Enum)) {
                this.Add_2(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Boolean)) {
                this.Add_3(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Number)) {
                this.Add_4(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Number)) {
                this.Add_5(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Number)) {
                this.Add_6(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Number)) {
                this.Add_7(name, value);
                return;
            }
            if (arguments.length === 2 && (name === null || name.constructor === String) && (value === null || value.constructor === Object)) {
                this.Add_8(name, value);
                return;
            }
            this.Add_9(name, value);
        };
        JsonObject.prototype.Add_0 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_1 = function (name, value) {
            if (value !== null) {
                this.InternalAdd(name, value);
            }
        };
        JsonObject.prototype.Add_2 = function (name, value) {
            if (value !== null) {
                this.InternalAdd(name, value.ToString());
            }
        };
        JsonObject.prototype.Add_3 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_4 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_5 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_6 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_7 = function (name, value) {
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.Add_8 = function (name, value) {
            JsonObject.ValidateObject(value);
            this.InternalAdd(name, value);
        };
        JsonObject.prototype.InternalAdd = function (name, value) {
            _super.prototype.Add.call(this, name, value);
        };
        JsonObject.prototype.AddTypeParameter = function (typeName) {
            this.InternalAdd("__type", NString.Format("{0}:#{1}", typeName, "Exchange"));
        };
        JsonObject.prototype.Add_9 = function (name, value) {
            var array = Enumerable.ToArray(value);
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var entry = array2[i];
                JsonObject.ValidateObject(entry);
            }
            this.InternalAdd(name, array);
        };
        JsonObject.prototype.AddBase64 = function (key, streamOrBuffer, offset, count) {
            if (arguments.length === 2 && (key === null || key.constructor === String) && (streamOrBuffer === null || streamOrBuffer instanceof Stream)) {
                this.AddBase64_0(key, streamOrBuffer);
                return;
            }
            if (arguments.length === 2 && (key === null || key.constructor === String) && (streamOrBuffer === null || streamOrBuffer instanceof Array)) {
                this.AddBase64_1(key, streamOrBuffer);
                return;
            }
            this.AddBase64_2(key, streamOrBuffer, offset, count);
        };
        JsonObject.prototype.AddBase64_0 = function (key, stream) {
            var memoryStream = new MemoryStream();
            try {
                var array = new Array(4096);
                for (var _ai = 0; _ai < array.length; ++_ai)
                    array[_ai] = 0;
                var count;
                while ((count = stream.Read(array, 0, array.length)) !== 0) {
                    memoryStream.Write(array, 0, count);
                }
                this.AddBase64(key, memoryStream.GetBuffer(), 0, memoryStream.Length);
            }
            finally {
                if (memoryStream !== null) {
                    memoryStream.Dispose();
                }
            }
        };
        JsonObject.prototype.AddBase64_1 = function (key, buffer) {
            this.AddBase64(key, buffer, 0, buffer.length);
        };
        JsonObject.prototype.AddBase64_2 = function (key, buffer, offset, count) {
            this.InternalAdd(key, Convert.ToBase64String(buffer, offset, count));
        };
        JsonObject.prototype.SerializeToJson = function (stream, prettyPrint) {
            if (arguments.length === 1 && (stream === null || stream instanceof Stream)) {
                this.SerializeToJson_0(stream);
                return;
            }
            this.SerializeToJson_1(stream, prettyPrint);
        };
        JsonObject.prototype.SerializeToJson_0 = function (stream) {
            this.SerializeToJson(stream, false);
        };
        JsonObject.prototype.SerializeToJson_1 = function (stream, prettyPrint) {
            var jsonWriter = new JsonWriter(stream, prettyPrint);
            try {
                this.WriteValue(jsonWriter, this);
                jsonWriter.Flush();
            }
            finally {
                if (jsonWriter !== null) {
                    jsonWriter.Dispose();
                }
            }
        };
        JsonObject.prototype.WriteKeyValuePair = function (writer, key, value) {
            writer.WriteKey(key);
            this.WriteValue(writer, value);
        };
        JsonObject.prototype.WriteValue = function (writer, value) {
            if (value === null) {
                writer.WriteNullValue();
                return;
            }
            if (value.constructor === String) {
                writer.WriteValue(value);
                return;
            }
            if (value.GetType().IsEnum) {
                writer.WriteValue(value);
                return;
            }
            if (value.constructor === Number) {
                writer.WriteValue(value);
                return;
            }
            if (value.constructor === Number) {
                writer.WriteValue(value);
                return;
            }
            if (value.constructor === Number) {
                writer.WriteValue(value);
                return;
            }
            if (value.constructor === Number) {
                writer.WriteValue(value);
                return;
            }
            if (value.constructor === Boolean) {
                writer.WriteValue(value);
                return;
            }
            if (value instanceof DateTime) {
                writer.WriteValue(value);
                return;
            }
            if (value instanceof JsonObject) {
                writer.PushObjectClosure();
                var jsonObject = ((value instanceof JsonObject) ? value : null);
                if (jsonObject.ContainsKey("__type")) {
                    this.WriteKeyValuePair(writer, "__type", jsonObject.get_Item("__type"));
                }
                var enumerator = jsonObject.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.Key !== "__type") {
                            this.WriteKeyValuePair(writer, current.Key, current.Value);
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                writer.PopClosure();
                return;
            }
            if (value.GetType().IsArray) {
                writer.PushArrayClosure();
                var enumerator2 = value.GetEnumerator();
                try {
                    while (enumerator2.MoveNext()) {
                        var current2 = enumerator2.Current;
                        this.WriteValue(writer, current2);
                    }
                }
                finally {
                    var disposable = ((enumerator2 instanceof IDisposable) ? enumerator2 : null);
                    if (disposable !== null) {
                        disposable.Dispose();
                    }
                }
                writer.PopClosure();
                return;
            }
            throw new InvalidOperationException(NString.Format("Object [{0}] is not JSON serializable", value));
        };
        JsonObject.prototype.ReadAsInt = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                throw new ServiceJsonDeserializationException();
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (!(obj.constructor === Number)) {
                throw new ServiceJsonDeserializationException();
            }
            return obj;
        };
        JsonObject.prototype.ReadAsDouble = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                throw new ServiceJsonDeserializationException();
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (!(obj.constructor === Number)) {
                throw new ServiceJsonDeserializationException();
            }
            return obj;
        };
        JsonObject.prototype.ReadAsString = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                throw new ServiceJsonDeserializationException();
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (obj !== null && !(obj.constructor === String)) {
                throw new ServiceJsonDeserializationException();
            }
            return ((obj instanceof string) ? obj : null);
        };
        JsonObject.prototype.ReadAsJsonObject = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                throw new ServiceJsonDeserializationException();
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (obj !== null && !(obj instanceof JsonObject)) {
                throw new ServiceJsonDeserializationException();
            }
            return ((obj instanceof JsonObject) ? obj : null);
        };
        JsonObject.prototype.ReadAsArray = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                return new Array(0);
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (obj !== null && !(obj instanceof any[])) {
                throw new ServiceJsonDeserializationException();
            }
            return ((obj instanceof any[]) ? obj : null);
        };
        JsonObject.prototype.HasTypeProperty = function () {
            return _super.prototype.ContainsKey.call(this, "__type");
        };
        JsonObject.prototype.ReadTypeString = function () {
            if (!this.HasTypeProperty()) {
                throw new ServiceJsonDeserializationException();
            }
            var text = this.ReadAsString("__type");
            return NString.Substring(text, 0, NString.IndexOf(text, NString.Format(":#{0}", "Exchange")));
        };
        JsonObject.prototype.ReadEnumValue = function (key) {
            return EwsUtilities.Parse(this.ReadAsString(key));
        };
        JsonObject.prototype.ReadAsBool = function (key) {
            if (!_super.prototype.ContainsKey.call(this, key)) {
                throw new ServiceJsonDeserializationException();
            }
            var obj = _super.prototype.get_Item.call(this, key);
            if (!(obj.constructor === Boolean)) {
                throw new ServiceJsonDeserializationException();
            }
            return obj;
        };
        JsonObject.prototype.ReadAsBase64Content = function (key, stream) {
            if (arguments.length === 2 && (key === null || key.constructor === String) && (stream === null || stream instanceof Stream)) {
                this.ReadAsBase64Content_0(key, stream);
                return;
            }
            this.ReadAsBase64Content_1(key);
        };
        JsonObject.prototype.ReadAsBase64Content_0 = function (key, stream) {
            var array = this.ReadAsBase64Content(key);
            stream.Write(array, 0, array.length);
        };
        JsonObject.prototype.ReadAsBase64Content_1 = function (key) {
            var s = this.ReadAsString(key);
            return Convert.FromBase64String(s);
        };
        JsonObject.TypeAttribute = "__type";
        JsonObject.JsonTypeNamespace = "Exchange";
        JsonObject.JsonValueString = "Value";
        return JsonObject;
    }(Dictionary));
    var JsonParser = (function () {
        function JsonParser(inputStream) {
            this.tokenizer = null;
            _super.call(this);
            this.tokenizer = new JsonTokenizer(inputStream);
        }
        JsonParser.prototype.Parse = function () {
            return this.ParseObject();
        };
        JsonParser.prototype.ParseObject = function () {
            var _this = this;
            var jsonObject = new JsonObject();
            var text;
            (function () {
                var _p0 = [
                    text
                ];
                var _r = _this.ReadAndValidateToken(_p0, [
                    JsonTokenType.ObjectOpen
                ]);
                text = _p0[0];
                return _r;
            })();
            while (this.tokenizer.Peek() !== JsonTokenType.ObjectClose) {
                this.ParseKeyValuePair(jsonObject);
                if (this.tokenizer.Peek() !== JsonTokenType.Comma) {
                    break;
                }
                (function () {
                    var _p0 = [
                        text
                    ];
                    var _r = _this.ReadAndValidateToken(_p0, [
                        JsonTokenType.Comma
                    ]);
                    text = _p0[0];
                    return _r;
                })();
            }
            (function () {
                var _p0 = [
                    text
                ];
                var _r = _this.ReadAndValidateToken(_p0, [
                    JsonTokenType.ObjectClose
                ]);
                text = _p0[0];
                return _r;
            })();
            return jsonObject;
        };
        JsonParser.prototype.ParseKeyValuePair = function (jsonObject) {
            var _this = this;
            var expectedTokenTypes = new Array(1);
            for (var _ai = 0; _ai < expectedTokenTypes.length; ++_ai)
                expectedTokenTypes[_ai] = 0;
            var text;
            (function () {
                var _p0 = [
                    text
                ];
                var _r = _this.ReadAndValidateToken(_p0, expectedTokenTypes);
                text = _p0[0];
                return _r;
            })();
            var text2;
            (function () {
                var _p0 = [
                    text2
                ];
                var _r = _this.ReadAndValidateToken(_p0, [
                    JsonTokenType.Colon
                ]);
                text2 = _p0[0];
                return _r;
            })();
            text = this.UnescapeString(text);
            jsonObject.Add(text, this.ParseValue());
        };
        JsonParser.prototype.ParseValue = function () {
            var _this = this;
            switch (this.tokenizer.Peek()) {
                case JsonTokenType.String:
                    {
                        var expectedTokenTypes = new Array(1);
                        for (var _ai = 0; _ai < expectedTokenTypes.length; ++_ai)
                            expectedTokenTypes[_ai] = 0;
                        var text;
                        (function () {
                            var _p0 = [
                                text
                            ];
                            var _r = _this.ReadAndValidateToken(_p0, expectedTokenTypes);
                            text = _p0[0];
                            return _r;
                        })();
                        return this.UnescapeString(text);
                    }
                case JsonTokenType.Number:
                    {
                        var text;
                        (function () {
                            var _p0 = [
                                text
                            ];
                            var _r = _this.ReadAndValidateToken(_p0, [
                                JsonTokenType.Number
                            ]);
                            text = _p0[0];
                            return _r;
                        })();
                        return this.ParseNumber(text);
                    }
                case JsonTokenType.Boolean:
                    {
                        var text;
                        (function () {
                            var _p0 = [
                                text
                            ];
                            var _r = _this.ReadAndValidateToken(_p0, [
                                JsonTokenType.Boolean
                            ]);
                            text = _p0[0];
                            return _r;
                        })();
                        return NBoolean.Parse(text);
                    }
                case JsonTokenType.Null:
                    {
                        var text;
                        (function () {
                            var _p0 = [
                                text
                            ];
                            var _r = _this.ReadAndValidateToken(_p0, [
                                JsonTokenType.Null
                            ]);
                            text = _p0[0];
                            return _r;
                        })();
                        return null;
                    }
                case JsonTokenType.ObjectOpen:
                    return this.ParseObject();
                case JsonTokenType.ArrayOpen:
                    return this.ParseArray();
            }
            throw new ServiceJsonDeserializationException();
        };
        JsonParser.prototype.ParseNumber = function (valueToken) {
            if (Regex.IsMatch(valueToken, "^-?\\d+$")) {
                return NNumber.Parse(valueToken, CultureInfo.InvariantCulture);
            }
            return NNumber.Parse(valueToken, CultureInfo.InvariantCulture);
        };
        JsonParser.prototype.ParseArray = function () {
            var _this = this;
            var list = new List();
            var text;
            (function () {
                var _p0 = [
                    text
                ];
                var _r = _this.ReadAndValidateToken(_p0, [
                    JsonTokenType.ArrayOpen
                ]);
                text = _p0[0];
                return _r;
            })();
            while (this.tokenizer.Peek() !== JsonTokenType.ArrayClose) {
                list.Add(this.ParseValue());
                if (this.tokenizer.Peek() !== JsonTokenType.Comma) {
                    break;
                }
                (function () {
                    var _p0 = [
                        text
                    ];
                    var _r = _this.ReadAndValidateToken(_p0, [
                        JsonTokenType.Comma
                    ]);
                    text = _p0[0];
                    return _r;
                })();
            }
            (function () {
                var _p0 = [
                    text
                ];
                var _r = _this.ReadAndValidateToken(_p0, [
                    JsonTokenType.ArrayClose
                ]);
                text = _p0[0];
                return _r;
            })();
            return list.ToArray();
        };
        JsonParser.prototype.UnescapeString = function (value) {
            var text = NString.Substring(value, 1, value.length - 2);
            if (Enumerable.Contains(text, 92) /*'\'*/) {
                if (NString.Contains(text, "\\\\")) {
                    text = NString.Replace(text, "\\\\", "\\");
                }
                if (NString.Contains(text, "\\\"")) {
                    text = NString.Replace(text, "\\\"", "\"");
                }
                if (NString.Contains(text, "\\/")) {
                    text = NString.Replace(text, "\\/", "/");
                }
                if (NString.Contains(text, "\\b")) {
                    text = NString.Replace(text, "\\b", "\b");
                }
                if (NString.Contains(text, "\\f")) {
                    text = NString.Replace(text, "\\f", "\f");
                }
                if (NString.Contains(text, "\\n")) {
                    text = NString.Replace(text, "\\n", "\n");
                }
                if (NString.Contains(text, "\\r")) {
                    text = NString.Replace(text, "\\r", "\r");
                }
                if (NString.Contains(text, "\\t")) {
                    text = NString.Replace(text, "\\t", "\t");
                }
                if (NString.Contains(text, "\\u")) {
                    var matchCollection = Regex.Matches(text, "\\\\u([\\da-fA-F]{4})");
                    var enumerator = matchCollection.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var match = enumerator.Current;
                            if (match.Success) {
                                var utf = NNumber.Parse(NString.Substring(match.Value, 2), NumberStyles.HexNumber);
                                var newValue = NChar.ConvertFromUtf32(utf);
                                text = NString.Replace(text, match.Value, newValue);
                            }
                        }
                    }
                    finally {
                        var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                        if (disposable !== null) {
                            disposable.Dispose();
                        }
                    }
                }
            }
            return text;
        };
        JsonParser.prototype.ReadAndValidateToken = function (token, expectedTokenTypes) {
            var _this = this;
            var jsonTokenType = (function () {
                var _p0 = [
                    token[0]
                ];
                var _r = _this.tokenizer.NextToken(_p0);
                token[0] = _p0[0];
                return _r;
            })();
            for (var i = 0; i < expectedTokenTypes.length; i = i + 1) {
                var jsonTokenType2 = expectedTokenTypes[i];
                if (jsonTokenType === jsonTokenType2) {
                    return jsonTokenType;
                }
            }
            throw new ServiceJsonDeserializationException();
        };
        return JsonParser;
    }());
    var JsonTokenType;
    (function (JsonTokenType) {
        JsonTokenType[JsonTokenType["String"] = 0] = "String";
        JsonTokenType[JsonTokenType["Number"] = 1] = "Number";
        JsonTokenType[JsonTokenType["Boolean"] = 2] = "Boolean";
        JsonTokenType[JsonTokenType["Null"] = 3] = "Null";
        JsonTokenType[JsonTokenType["ObjectOpen"] = 4] = "ObjectOpen";
        JsonTokenType[JsonTokenType["ObjectClose"] = 5] = "ObjectClose";
        JsonTokenType[JsonTokenType["ArrayOpen"] = 6] = "ArrayOpen";
        JsonTokenType[JsonTokenType["ArrayClose"] = 7] = "ArrayClose";
        JsonTokenType[JsonTokenType["Colon"] = 8] = "Colon";
        JsonTokenType[JsonTokenType["Comma"] = 9] = "Comma";
        JsonTokenType[JsonTokenType["EndOfFile"] = 10] = "EndOfFile";
    })(JsonTokenType || (JsonTokenType = {}));
    var JsonTokenizer = (function () {
        function JsonTokenizer(input) {
            this.currentMatch = null;
            this.nextTokenType = 0;
            this.nextToken = null;
            this.nextTokenPeeked = false;
            _super.call(this);
            var streamReader = new StreamReader(input);
            var input2 = streamReader.ReadToEnd();
            this.currentMatch = JsonTokenizer.fullTokenizerRegex.Match(input2);
        }
        JsonTokenizer.JsonTokenizer_cctor = function () {
            JsonTokenizer.jsonStringRegEx = new Regex("\"([^\\\\\"]|\\\\\"|\\\\\\\\|\\\\/|\\\\b|\\\\f|\\\\n|\\\\r|\\\\t|\\\\u[\\da-fA-F]{4})*\"", RegexOptions.Compiled);
            JsonTokenizer.jsonNumberRegEx = new Regex("-?\\d+(.\\d+)?([eE][+-]?\\d+)?", RegexOptions.Compiled);
            JsonTokenizer.jsonBooleanRegEx = new Regex("(true|false)", RegexOptions.Compiled);
            JsonTokenizer.jsonNullRegEx = new Regex("null", RegexOptions.Compiled);
            JsonTokenizer.jsonOpenObjectRegEx = new Regex("\\{", RegexOptions.Compiled);
            JsonTokenizer.jsonCloseObjectRegEx = new Regex("\\}", RegexOptions.Compiled);
            JsonTokenizer.jsonOpenArrayRegEx = new Regex("\\[", RegexOptions.Compiled);
            JsonTokenizer.jsonCloseArrayRegEx = new Regex("\\]", RegexOptions.Compiled);
            JsonTokenizer.jsonColonRegEx = new Regex("\\:", RegexOptions.Compiled);
            JsonTokenizer.jsonCommaRegEx = new Regex("\\,", RegexOptions.Compiled);
            JsonTokenizer.whitespaceRegEx = new Regex("\\s");
            JsonTokenizer.tokenDictionary = new Dictionary();
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.Number, JsonTokenizer.jsonNumberRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.Boolean, JsonTokenizer.jsonBooleanRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.Null, JsonTokenizer.jsonNullRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.ObjectOpen, JsonTokenizer.jsonOpenObjectRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.ObjectClose, JsonTokenizer.jsonCloseObjectRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.ArrayOpen, JsonTokenizer.jsonOpenArrayRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.ArrayClose, JsonTokenizer.jsonCloseArrayRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.Colon, JsonTokenizer.jsonColonRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.Comma, JsonTokenizer.jsonCommaRegEx);
            JsonTokenizer.tokenDictionary.Add(JsonTokenType.String, JsonTokenizer.jsonStringRegEx);
            var stringBuilder = new StringBuilder();
            var flag = true;
            var enumerator = JsonTokenizer.tokenDictionary.Values.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (flag) {
                        flag = false;
                    }
                    else {
                        stringBuilder.Append("|");
                    }
                    stringBuilder.Append("(");
                    stringBuilder.Append(current.ToString());
                    stringBuilder.Append(")");
                }
            }
            finally {
                enumerator.Dispose();
            }
            JsonTokenizer.fullTokenizerRegex = new Regex(stringBuilder.ToString(), RegexOptions.Compiled);
        };
        JsonTokenizer.prototype.Peek = function () {
            var _this = this;
            if (!this.nextTokenPeeked) {
                this.nextTokenType = (function () {
                    var _p0 = [
                        _this.nextToken
                    ];
                    var _r = _this.NextToken(_p0);
                    _this.nextToken = _p0[0];
                    return _r;
                })();
                this.nextTokenPeeked = true;
            }
            return this.nextTokenType;
        };
        JsonTokenizer.prototype.NextToken = function (token) {
            if (this.nextTokenPeeked) {
                token[0] = this.nextToken;
                this.nextTokenPeeked = false;
                return this.nextTokenType;
            }
            token[0] = this.currentMatch.Value;
            while (token[0].Trim().length === 0) {
                this.AdvanceRegExMatch();
                token[0] = this.currentMatch.Value;
            }
            var enumerator = JsonTokenizer.tokenDictionary.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var match = current.Value.Match(token[0]);
                    if (match.Success && match.Index === 0 && match.Length === token[0].length) {
                        this.AdvanceRegExMatch();
                        return current.Key;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            throw new ServiceJsonDeserializationException();
        };
        JsonTokenizer.prototype.AdvanceRegExMatch = function () {
            this.currentMatch = this.currentMatch.NextMatch();
        };
        JsonTokenizer.JsonStringRegExCode = "\"([^\\\\\"]|\\\\\"|\\\\\\\\|\\\\/|\\\\b|\\\\f|\\\\n|\\\\r|\\\\t|\\\\u[\\da-fA-F]{4})*\"";
        JsonTokenizer.JsonNumberRegExCode = "-?\\d+(.\\d+)?([eE][+-]?\\d+)?";
        JsonTokenizer.JsonBooleanRegExCode = "(true|false)";
        JsonTokenizer.JsonNullRegExCode = "null";
        JsonTokenizer.JsonOpenObjectRegExCode = "\\{";
        JsonTokenizer.JsonCloseObjectRegExCode = "\\}";
        JsonTokenizer.JsonOpenArrayRegExCode = "\\[";
        JsonTokenizer.JsonCloseArrayRegExCode = "\\]";
        JsonTokenizer.JsonColonRegExCode = "\\:";
        JsonTokenizer.JsonCommaRegExCode = "\\,";
        JsonTokenizer.jsonStringRegEx = null;
        JsonTokenizer.jsonNumberRegEx = null;
        JsonTokenizer.jsonBooleanRegEx = null;
        JsonTokenizer.jsonNullRegEx = null;
        JsonTokenizer.jsonOpenObjectRegEx = null;
        JsonTokenizer.jsonCloseObjectRegEx = null;
        JsonTokenizer.jsonOpenArrayRegEx = null;
        JsonTokenizer.jsonCloseArrayRegEx = null;
        JsonTokenizer.jsonColonRegEx = null;
        JsonTokenizer.jsonCommaRegEx = null;
        JsonTokenizer.whitespaceRegEx = null;
        JsonTokenizer.tokenDictionary = null;
        JsonTokenizer.fullTokenizerRegex = null;
        return JsonTokenizer;
    }());
    var JsonWriter = (function (_super) {
        __extends(JsonWriter, _super);
        function JsonWriter(outStream, prettyPrint) {
            _super.call(this);
            this.outStream = null;
            this.shouldCloseStream = false;
            this.prettyPrint = false;
            this.writingStringValue = false;
            this.smallBuffer = new Array(10);
            this.singleCharBuffer = new Array(1);
            this.closures = new Stack();
            this.closureHasMembers = new Stack();
            this.outStream = outStream;
            this.prettyPrint = prettyPrint;
            this.shouldCloseStream = false;
        }
        Object.defineProperty(JsonWriter.prototype, "Encoding", {
            get: function () {
                return Encoding.UTF8;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(JsonWriter.prototype, "ShouldCloseStream", {
            get: function () {
                return this.shouldCloseStream;
            },
            set: function (value) {
                this.shouldCloseStream = value;
            },
            enumerable: true,
            configurable: true
        });
        JsonWriter.prototype.Dispose = function (disposing) {
            if (this.shouldCloseStream) {
                this.outStream.Flush();
                this.outStream.Dispose();
            }
            _super.prototype.Dispose.call(this, disposing);
        };
        JsonWriter.prototype.Write = function (value) {
            if (value === 13 /*'\r'*/ && this.writingStringValue) {
                this.WriteInternal(92) /*'\'*/;
                this.WriteInternal(114) /*'r'*/;
                return;
            }
            if (value === 10 /*'\n'*/ && this.writingStringValue) {
                this.WriteInternal(92) /*'\'*/;
                this.WriteInternal(110) /*'n'*/;
                return;
            }
            if (value === 9 /*'\t'*/ && this.writingStringValue) {
                this.WriteInternal(92) /*'\'*/;
                this.WriteInternal(116) /*'t'*/;
                return;
            }
            if (value === 34 /*'"'*/ || value === 92 /*'\'*/) {
                this.WriteInternal(92) /*'\'*/;
            }
            this.WriteInternal(value);
        };
        JsonWriter.prototype.PushObjectClosure = function () {
            this.AddingValue();
            this.closures.Push(125) /*'}'*/;
            this.closureHasMembers.Push(false);
            this.WriteInternal(123) /*'{'*/;
            this.WriteIndentation();
        };
        JsonWriter.prototype.PushArrayClosure = function () {
            this.AddingValue();
            this.closures.Push(93) /*']'*/;
            this.closureHasMembers.Push(false);
            this.WriteInternal(91) /*'['*/;
            this.WriteIndentation();
        };
        JsonWriter.prototype.PopClosure = function () {
            var value = this.closures.Pop();
            this.closureHasMembers.Pop();
            this.WriteIndentation();
            this.WriteInternal(value);
        };
        JsonWriter.prototype.WriteQuote = function () {
            this.WriteInternal(34) /*'"'*/;
        };
        JsonWriter.prototype.WriteKey = function (key) {
            if (this.closureHasMembers.Peek()) {
                this.WriteInternal(44) /*','*/;
                this.WriteIndentation();
            }
            this.WriteQuote();
            this.Write(key);
            this.WriteQuote();
            if (this.prettyPrint) {
                this.Write(" : ");
                return;
            }
            this.WriteInternal(58) /*':'*/;
        };
        JsonWriter.prototype.WriteValue = function (value) {
            if (arguments.length === 1 && (value === null || value.constructor === String)) {
                this.WriteValue_0(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value.constructor === Boolean)) {
                this.WriteValue_1(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value.constructor === Number)) {
                this.WriteValue_2(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value.constructor === Number)) {
                this.WriteValue_3(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value instanceof Enum)) {
                this.WriteValue_4(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value instanceof DateTime)) {
                this.WriteValue_5(value);
                return;
            }
            if (arguments.length === 1 && (value === null || value.constructor === Number)) {
                this.WriteValue_6(value);
                return;
            }
            this.WriteValue_7(value);
        };
        JsonWriter.prototype.WriteValue_0 = function (value) {
            this.AddingValue();
            this.WriteQuote();
            this.writingStringValue = true;
            this.Write(value);
            this.writingStringValue = false;
            this.WriteQuote();
        };
        JsonWriter.prototype.WriteValue_1 = function (value) {
            this.AddingValue();
            this.Write(NString.ToLowerInvariant(NBoolean.ToString(value)));
        };
        JsonWriter.prototype.WriteValue_2 = function (value) {
            this.AddingValue();
            this.Write(value);
        };
        JsonWriter.prototype.WriteValue_3 = function (value) {
            this.AddingValue();
            this.Write(value);
        };
        JsonWriter.prototype.WriteValue_4 = function (value) {
            this.WriteValue(EwsUtilities.SerializeEnum(value));
        };
        JsonWriter.prototype.WriteValue_5 = function (value) {
            this.WriteValue(EwsUtilities.DateTimeToXSDateTime(value));
        };
        JsonWriter.prototype.WriteValue_6 = function (value) {
            this.AddingValue();
            this.Write(value);
        };
        JsonWriter.prototype.WriteValue_7 = function (value) {
            this.AddingValue();
            this.Write(value);
        };
        JsonWriter.prototype.WriteNullValue = function () {
            this.AddingValue();
            this.Write("null");
        };
        JsonWriter.prototype.WriteInternal = function (value) {
            this.singleCharBuffer[0] = value;
            var bytes = this.Encoding.GetBytes(this.singleCharBuffer, 0, 1, this.smallBuffer, 0);
            this.outStream.Write(this.smallBuffer, 0, bytes);
        };
        JsonWriter.prototype.WriteIndentation = function () {
            if (this.prettyPrint) {
                this.WriteInternal(13) /*'\r'*/;
                this.WriteInternal(10) /*'\n'*/;
                for (var i = this.closures.Count - 1; i >= 0; i = i - 1) {
                    this.Write("  ");
                }
            }
        };
        JsonWriter.prototype.AddingValue = function () {
            if (this.closures.Count > 0) {
                if (this.closures.Peek() === 93 /*']'*/ && this.closureHasMembers.Peek()) {
                    this.WriteInternal(44) /*','*/;
                    this.WriteIndentation();
                }
                if (!this.closureHasMembers.Peek()) {
                    this.closureHasMembers.Pop();
                    this.closureHasMembers.Push(true);
                }
            }
        };
        JsonWriter.Indentation = "  ";
        return JsonWriter;
    }(TextWriter));
    var PropertyBag = (function () {
        function PropertyBag(owner) {
            this.owner = null;
            this.isDirty = false;
            this.loading = false;
            this.onlySummaryPropertiesRequested = false;
            this.loadedProperties = new List();
            this.properties = new Dictionary();
            this.deletedProperties = new Dictionary();
            this.modifiedProperties = new List();
            this.addedProperties = new List();
            this.requestedPropertySet = null;
            _super.call(this);
            EwsUtilities.Assert(owner !== null, "PropertyBag.ctor", "owner is null");
            this.owner = owner;
        }
        Object.defineProperty(PropertyBag.prototype, "Properties", {
            get: function () {
                return this.properties;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertyBag.prototype, "Owner", {
            get: function () {
                return this.owner;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertyBag.prototype, "IsDirty", {
            get: function () {
                var num = this.modifiedProperties.Count + this.deletedProperties.Count + this.addedProperties.Count;
                return num > 0 || this.isDirty;
            },
            enumerable: true,
            configurable: true
        });
        PropertyBag.prototype.get_Item = function (propertyDefinition) {
            var _this = this;
            var ex;
            var propertyValueOrException = (function () {
                var _p0 = [
                    ex
                ];
                var _r = _this.GetPropertyValueOrException(propertyDefinition, _p0);
                ex = _p0[0];
                return _r;
            })();
            if (ex === null) {
                return propertyValueOrException;
            }
            throw ex;
        };
        PropertyBag.prototype.set_Item = function (propertyDefinition, value) {
            var _this = this;
            if (propertyDefinition.Version > this.Owner.Service.RequestedServerVersion) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, propertyDefinition.Name, propertyDefinition.Version));
            }
            if (!this.loading) {
                if (this.Owner.IsNew && !propertyDefinition.HasFlag(PropertyDefinitionFlags.CanSet, new Nullable(this.Owner.Service.RequestedServerVersion))) {
                    throw new ServiceObjectPropertyException(Strings.PropertyIsReadOnly, propertyDefinition);
                }
                if (!this.Owner.IsNew) {
                    var item = ((this.Owner instanceof Item) ? this.Owner : null);
                    if (item !== null && item.IsAttachment) {
                        throw new ServiceObjectPropertyException(Strings.ItemAttachmentCannotBeUpdated, propertyDefinition);
                    }
                    if (value === null && !propertyDefinition.HasFlag(PropertyDefinitionFlags.CanDelete)) {
                        throw new ServiceObjectPropertyException(Strings.PropertyCannotBeDeleted, propertyDefinition);
                    }
                    if (!propertyDefinition.HasFlag(PropertyDefinitionFlags.CanUpdate)) {
                        throw new ServiceObjectPropertyException(Strings.PropertyCannotBeUpdated, propertyDefinition);
                    }
                }
            }
            if (value === null) {
                this.DeleteProperty(propertyDefinition);
                return;
            }
            var obj;
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.properties.TryGetValue(propertyDefinition, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                var complexProperty = ((obj instanceof ComplexProperty) ? obj : null);
                if (complexProperty !== null) {
                    complexProperty.OnChange.Remove(this.PropertyChanged);
                }
            }
            if (this.deletedProperties.Remove(propertyDefinition)) {
                PropertyBag.AddToChangeList(propertyDefinition, this.modifiedProperties);
            }
            else {
                if (!this.properties.ContainsKey(propertyDefinition)) {
                    PropertyBag.AddToChangeList(propertyDefinition, this.addedProperties);
                }
                else {
                    if (!this.modifiedProperties.Contains(propertyDefinition)) {
                        PropertyBag.AddToChangeList(propertyDefinition, this.modifiedProperties);
                    }
                }
            }
            this.InitComplexProperty(((value instanceof ComplexProperty) ? value : null));
            this.properties.set_Item(propertyDefinition, value);
            this.Changed();
        };
        PropertyBag.AddToChangeList = function (propertyDefinition, changeList) {
            if (!changeList.Contains(propertyDefinition)) {
                changeList.Add(propertyDefinition);
            }
        };
        PropertyBag.CreateJsonSetUpdate = function (propertyDefinitionOrValue, service, serviceObject, propertyBag) {
            if (arguments.length === 4 && (propertyDefinitionOrValue === null || propertyDefinitionOrValue instanceof PropertyDefinition) && (service === null || service instanceof ExchangeService) && (serviceObject === null || serviceObject instanceof ServiceObject) && (propertyBag === null || propertyBag instanceof PropertyBag)) {
                return PropertyBag.CreateJsonSetUpdate_0(propertyDefinitionOrValue, service, serviceObject, propertyBag);
            }
            return PropertyBag.CreateJsonSetUpdate_1(propertyDefinitionOrValue, service, serviceObject);
        };
        PropertyBag.CreateJsonSetUpdate_0 = function (propertyDefinition, service, serviceObject, propertyBag) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(serviceObject.GetSetFieldXmlElementName());
            jsonObject.Add("Path", propertyDefinition.ToJson(service));
            var jsonObject2 = new JsonObject();
            jsonObject2.AddTypeParameter(serviceObject.GetXmlElementName());
            propertyDefinition.WriteJsonValue(jsonObject2, propertyBag, service, true);
            jsonObject.Add(PropertyBag.GetPropertyUpdateItemName(serviceObject), jsonObject2);
            return jsonObject;
        };
        PropertyBag.CreateJsonSetUpdate_1 = function (value, service, serviceObject) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(serviceObject.GetSetFieldXmlElementName());
            jsonObject.Add("Path", value.PropertyDefinition.ToJson(service));
            var jsonObject2 = new JsonObject();
            jsonObject2.AddTypeParameter(serviceObject.GetXmlElementName());
            jsonObject2.Add("ExtendedProperty", NArray.ToEnumerable([
                value.InternalToJson(service)
            ]));
            jsonObject.Add(PropertyBag.GetPropertyUpdateItemName(serviceObject), jsonObject2);
            return jsonObject;
        };
        PropertyBag.CreateJsonDeleteUpdate = function (propertyDefinition, service, serviceObject) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(serviceObject.GetDeleteFieldXmlElementName());
            jsonObject.Add("PropertyPath", propertyDefinition.ToJson(service));
            return jsonObject;
        };
        PropertyBag.GetPropertyUpdateItemName = function (serviceObject) {
            if (!(serviceObject instanceof Folder)) {
                return "Item";
            }
            return "Folder";
        };
        PropertyBag.prototype.IsPropertyLoaded = function (propertyDefinition) {
            return this.loadedProperties.Contains(propertyDefinition) || this.IsRequestedProperty(propertyDefinition);
        };
        PropertyBag.prototype.IsRequestedProperty = function (propertyDefinition) {
            if (this.requestedPropertySet === null) {
                return false;
            }
            if (this.requestedPropertySet.BasePropertySet === BasePropertySet.FirstClassProperties) {
                var list = this.onlySummaryPropertiesRequested ? this.Owner.Schema.FirstClassSummaryProperties : this.Owner.Schema.FirstClassProperties;
                return list.Contains(propertyDefinition) || this.requestedPropertySet.Contains(propertyDefinition);
            }
            return this.requestedPropertySet.Contains(propertyDefinition);
        };
        PropertyBag.prototype.IsPropertyUpdated = function (propertyDefinition) {
            return this.modifiedProperties.Contains(propertyDefinition) || this.addedProperties.Contains(propertyDefinition);
        };
        PropertyBag.prototype.TryGetProperty = function (propertyDefinition, propertyValue) {
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinition) && (propertyValue === null || propertyValue instanceof Array)) {
                return this.TryGetProperty_0(propertyDefinition, propertyValue);
            }
            return this.TryGetProperty_1(propertyDefinition, propertyValue);
        };
        PropertyBag.prototype.TryGetProperty_0 = function (propertyDefinition, propertyValue) {
            var _this = this;
            var ex;
            propertyValue[0] = (function () {
                var _p0 = [
                    ex
                ];
                var _r = _this.GetPropertyValueOrException(propertyDefinition, _p0);
                ex = _p0[0];
                return _r;
            })();
            return ex === null;
        };
        PropertyBag.prototype.TryGetProperty_1 = function (propertyDefinition, propertyValue) {
            var _this = this;
            if (!new Type("T").IsAssignableFrom(propertyDefinition.Type)) {
                var message = NString.Format(Strings.PropertyDefinitionTypeMismatch, EwsUtilities.GetPrintableTypeName(propertyDefinition.Type), EwsUtilities.GetPrintableTypeName(new Type("T")));
                throw new ArgumentException(message, "propertyDefinition");
            }
            var obj;
            var flag = (function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                obj = _p0[0];
                return _r;
            })();
            propertyValue[0] = (flag ? obj : null);
            return flag;
        };
        PropertyBag.prototype.GetPropertyValueOrException = function (propertyDefinition, exception) {
            var _this = this;
            var obj = null;
            exception[0] = null;
            if (propertyDefinition.Version > this.Owner.Service.RequestedServerVersion) {
                exception[0] = new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, propertyDefinition.Name, propertyDefinition.Version));
                return null;
            }
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.TryGetValue(propertyDefinition, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                return obj;
            }
            if (propertyDefinition.HasFlag(PropertyDefinitionFlags.AutoInstantiateOnRead)) {
                var complexPropertyDefinitionBase = ((propertyDefinition instanceof ComplexPropertyDefinitionBase) ? propertyDefinition : null);
                EwsUtilities.Assert(complexPropertyDefinitionBase !== null, "PropertyBag.get_this[]", "propertyDefinition is marked with AutoInstantiateOnRead but is not a descendant of ComplexPropertyDefinitionBase");
                obj = complexPropertyDefinitionBase.CreatePropertyInstance(this.Owner);
                if (obj !== null) {
                    this.InitComplexProperty(((obj instanceof ComplexProperty) ? obj : null));
                    this.properties.set_Item(propertyDefinition, obj);
                }
            }
            else {
                if (propertyDefinition !== this.Owner.GetIdPropertyDefinition()) {
                    if (!this.IsPropertyLoaded(propertyDefinition)) {
                        exception[0] = new ServiceObjectPropertyException(Strings.MustLoadOrAssignPropertyBeforeAccess, propertyDefinition);
                        return null;
                    }
                    if (!propertyDefinition.IsNullable) {
                        var message = this.IsRequestedProperty(propertyDefinition) ? Strings.ValuePropertyNotLoaded : Strings.ValuePropertyNotAssigned;
                        exception[0] = new ServiceObjectPropertyException(message, propertyDefinition);
                    }
                }
            }
            return obj;
        };
        PropertyBag.prototype.Changed = function () {
            this.isDirty = true;
            this.Owner.Changed();
        };
        PropertyBag.prototype.Contains = function (propertyDefinition) {
            return this.properties.ContainsKey(propertyDefinition);
        };
        PropertyBag.prototype.TryGetValue = function (propertyDefinition, propertyValue) {
            var _this = this;
            return (function () {
                var _p0 = [
                    propertyValue[0]
                ];
                var _r = _this.properties.TryGetValue(propertyDefinition, _p0);
                propertyValue[0] = _p0[0];
                return _r;
            })();
        };
        PropertyBag.prototype.PropertyChanged = function (complexProperty) {
            var enumerator = this.properties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.Value === complexProperty && !this.deletedProperties.ContainsKey(current.Key)) {
                        PropertyBag.AddToChangeList(current.Key, this.modifiedProperties);
                        this.Changed();
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        PropertyBag.prototype.DeleteProperty = function (propertyDefinition) {
            var _this = this;
            if (!this.deletedProperties.ContainsKey(propertyDefinition)) {
                var obj;
                (function () {
                    var _p0 = [
                        obj
                    ];
                    var _r = _this.properties.TryGetValue(propertyDefinition, _p0);
                    obj = _p0[0];
                    return _r;
                })();
                this.properties.Remove(propertyDefinition);
                this.modifiedProperties.Remove(propertyDefinition);
                this.deletedProperties.Add(propertyDefinition, obj);
                var complexProperty = ((obj instanceof ComplexProperty) ? obj : null);
                if (complexProperty !== null) {
                    complexProperty.OnChange.Remove(this.PropertyChanged);
                }
            }
        };
        PropertyBag.prototype.Clear = function () {
            this.ClearChangeLog();
            this.properties.Clear();
            this.loadedProperties.Clear();
            this.requestedPropertySet = null;
        };
        PropertyBag.prototype.ClearChangeLog = function () {
            this.deletedProperties.Clear();
            this.modifiedProperties.Clear();
            this.addedProperties.Clear();
            var enumerator = this.properties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var complexProperty = ((current.Value instanceof ComplexProperty) ? current.Value : null);
                    if (complexProperty !== null) {
                        complexProperty.ClearChangeLog();
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            this.isDirty = false;
        };
        PropertyBag.prototype.LoadFromXml = function (reader, clear, requestedPropertySet, onlySummaryPropertiesRequested) {
            var _this = this;
            if (clear) {
                this.Clear();
            }
            this.loading = true;
            this.requestedPropertySet = requestedPropertySet;
            this.onlySummaryPropertiesRequested = onlySummaryPropertiesRequested;
            try {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var propertyDefinition;
                        if ((function () {
                            var _p0 = [
                                propertyDefinition
                            ];
                            var _r = _this.Owner.Schema.TryGetPropertyDefinition(reader.LocalName, _p0);
                            propertyDefinition = _p0[0];
                            return _r;
                        })()) {
                            propertyDefinition.LoadPropertyValueFromXml(reader, this);
                            this.loadedProperties.Add(propertyDefinition);
                        }
                        else {
                            reader.SkipCurrentElement();
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, this.Owner.GetXmlElementName()));
                this.ClearChangeLog();
            }
            finally {
                this.loading = false;
            }
        };
        PropertyBag.prototype.LoadFromJson = function (jsonServiceObject, service, clear, requestedPropertySet, onlySummaryPropertiesRequested) {
            var _this = this;
            if (clear) {
                this.Clear();
            }
            this.loading = true;
            this.requestedPropertySet = requestedPropertySet;
            this.onlySummaryPropertiesRequested = onlySummaryPropertiesRequested;
            try {
                var enumerator = jsonServiceObject.Keys.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        var propertyDefinition;
                        if ((function () {
                            var _p0 = [
                                propertyDefinition
                            ];
                            var _r = _this.Owner.Schema.TryGetPropertyDefinition(current, _p0);
                            propertyDefinition = _p0[0];
                            return _r;
                        })()) {
                            propertyDefinition.LoadPropertyValueFromJson(jsonServiceObject.get_Item(current), service, this);
                            this.loadedProperties.Add(propertyDefinition);
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                this.ClearChangeLog();
            }
            finally {
                this.loading = false;
            }
        };
        PropertyBag.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.Owner.GetXmlElementName());
            var enumerator = this.Owner.Schema.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.HasFlag(PropertyDefinitionFlags.CanSet, new Nullable(writer.Service.RequestedServerVersion)) && this.Contains(current)) {
                        current.WritePropertyValueToXml(writer, this, false);
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
        };
        PropertyBag.prototype.ToJson = function (service, isUpdateOperation) {
            var jsonObject = new JsonObject();
            if (!isUpdateOperation) {
                this.ToJsonForCreate(service, jsonObject);
            }
            else {
                this.ToJsonForUpdate(service, jsonObject);
            }
            return jsonObject;
        };
        PropertyBag.prototype.ToJsonForUpdate = function (service, jsonObject) {
            jsonObject.AddTypeParameter(this.Owner.GetChangeXmlElementName());
            jsonObject.Add(this.Owner.GetId().GetJsonTypeName(), this.Owner.GetId().InternalToJson(service));
            var list = new List();
            var enumerator = this.addedProperties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.WriteSetUpdateToJson(list, current, service);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.modifiedProperties.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.WriteSetUpdateToJson(list, current2, service);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            var enumerator3 = this.deletedProperties.GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    this.WriteDeleteUpdateToJson(list, current3.Key, current3.Value, service);
                }
            }
            finally {
                enumerator3.Dispose();
            }
            jsonObject.Add("Updates", NArray.ToEnumerable(list.ToArray()));
        };
        PropertyBag.prototype.ToJsonForCreate = function (service, jsonObject) {
            jsonObject.AddTypeParameter(this.Owner.GetXmlElementName());
            var enumerator = this.Owner.Schema.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.HasFlag(PropertyDefinitionFlags.CanSet, new Nullable(service.RequestedServerVersion)) && this.Contains(current)) {
                        current.WriteJsonValue(jsonObject, this, service, false);
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        PropertyBag.prototype.WriteToXmlForUpdate = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.Owner.GetChangeXmlElementName());
            this.Owner.GetId().WriteToXml(writer);
            writer.WriteStartElement(XmlNamespace.Types, "Updates");
            var enumerator = this.addedProperties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.WriteSetUpdateToXml(writer, current);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.modifiedProperties.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.WriteSetUpdateToXml(writer, current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            var enumerator3 = this.deletedProperties.GetEnumerator();
            try {
                while (enumerator3.MoveNext()) {
                    var current3 = enumerator3.Current;
                    this.WriteDeleteUpdateToXml(writer, current3.Key, current3.Value);
                }
            }
            finally {
                enumerator3.Dispose();
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        PropertyBag.prototype.GetIsUpdateCallNecessary = function () {
            var list = new List();
            list.AddRange(this.addedProperties);
            list.AddRange(this.modifiedProperties);
            list.AddRange(this.deletedProperties.Keys);
            var enumerator = list.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.HasFlag(PropertyDefinitionFlags.CanUpdate)) {
                        return true;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            return false;
        };
        PropertyBag.prototype.InitComplexProperty = function (complexProperty) {
            if (complexProperty !== null) {
                complexProperty.OnChange.Add(this.PropertyChanged);
                var ownedProperty = ((complexProperty instanceof IOwnedProperty) ? complexProperty : null);
                if (ownedProperty !== null) {
                    ownedProperty.Owner = this.Owner;
                }
            }
        };
        PropertyBag.prototype.WriteSetUpdateToXml = function (writer, propertyDefinition) {
            if (propertyDefinition.HasFlag(PropertyDefinitionFlags.CanUpdate)) {
                var obj = this.get_Item(propertyDefinition);
                var flag = false;
                var customUpdateSerializer = ((obj instanceof ICustomUpdateSerializer) ? obj : null);
                if (customUpdateSerializer !== null) {
                    flag = customUpdateSerializer.WriteSetUpdateToXml(writer, this.Owner, propertyDefinition);
                }
                if (!flag) {
                    writer.WriteStartElement(XmlNamespace.Types, this.Owner.GetSetFieldXmlElementName());
                    propertyDefinition.WriteToXml(writer);
                    writer.WriteStartElement(XmlNamespace.Types, this.Owner.GetXmlElementName());
                    propertyDefinition.WritePropertyValueToXml(writer, this, true);
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                }
            }
        };
        PropertyBag.prototype.WriteSetUpdateToJson = function (jsonUpdates, propertyDefinition, service) {
            if (propertyDefinition.HasFlag(PropertyDefinitionFlags.CanUpdate)) {
                var obj = this.get_Item(propertyDefinition);
                var flag = false;
                var customUpdateSerializer = ((obj instanceof ICustomUpdateSerializer) ? obj : null);
                if (customUpdateSerializer !== null) {
                    flag = customUpdateSerializer.WriteSetUpdateToJson(service, this.Owner, propertyDefinition, jsonUpdates);
                }
                if (!flag) {
                    var item = PropertyBag.CreateJsonSetUpdate(propertyDefinition, service, this.Owner, this);
                    jsonUpdates.Add(item);
                }
            }
        };
        PropertyBag.prototype.WriteDeleteUpdateToXml = function (writer, propertyDefinition, propertyValue) {
            if (propertyDefinition.HasFlag(PropertyDefinitionFlags.CanDelete)) {
                var flag = false;
                var customUpdateSerializer = ((propertyValue instanceof ICustomUpdateSerializer) ? propertyValue : null);
                if (customUpdateSerializer !== null) {
                    flag = customUpdateSerializer.WriteDeleteUpdateToXml(writer, this.Owner);
                }
                if (!flag) {
                    writer.WriteStartElement(XmlNamespace.Types, this.Owner.GetDeleteFieldXmlElementName());
                    propertyDefinition.WriteToXml(writer);
                    writer.WriteEndElement();
                }
            }
        };
        PropertyBag.prototype.WriteDeleteUpdateToJson = function (jsonUpdates, propertyDefinition, propertyValue, service) {
            if (propertyDefinition.HasFlag(PropertyDefinitionFlags.CanDelete)) {
                var flag = false;
                var customUpdateSerializer = ((propertyValue instanceof ICustomUpdateSerializer) ? propertyValue : null);
                if (customUpdateSerializer !== null) {
                    flag = customUpdateSerializer.WriteDeleteUpdateToJson(service, this.Owner, jsonUpdates);
                }
                if (!flag) {
                    var item = PropertyBag.CreateJsonDeleteUpdate(propertyDefinition, service, this.Owner);
                    jsonUpdates.Add(item);
                }
            }
        };
        PropertyBag.prototype.Validate = function () {
            var enumerator = this.addedProperties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.ValidatePropertyValue(current);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.modifiedProperties.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.ValidatePropertyValue(current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
        };
        PropertyBag.prototype.ValidatePropertyValue = function (propertyDefinition) {
            var _this = this;
            var obj;
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.TryGetProperty(propertyDefinition, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                var selfValidate = ((obj instanceof ISelfValidate) ? obj : null);
                if (selfValidate !== null) {
                    selfValidate.Validate();
                }
            }
        };
        return PropertyBag;
    }());
    var PropertySet = (function () {
        function PropertySet(basePropertySetOrAdditionalProperties, additionalProperties) {
            this.basePropertySet = 0;
            this.additionalProperties = new List();
            this.requestedBodyType = null;
            this.requestedUniqueBodyType = null;
            this.requestedNormalizedBodyType = null;
            this.filterHtml = null;
            this.convertHtmlCodePageToUTF8 = null;
            this.inlineImageUrlTemplate = null;
            this.blockExternalImages = null;
            this.addTargetToLinks = null;
            this.isReadOnly = false;
            this.maximumBodySize = null;
            _super.call(this);
            if (arguments.length === 2 && (basePropertySetOrAdditionalProperties === null || basePropertySetOrAdditionalProperties.constructor === Number) && (additionalProperties === null || additionalProperties instanceof Array)) {
                this.constructor_0(basePropertySetOrAdditionalProperties, additionalProperties);
                return;
            }
            if (arguments.length === 2 && (basePropertySetOrAdditionalProperties === null || basePropertySetOrAdditionalProperties.constructor === Number)) {
                this.constructor_1(basePropertySetOrAdditionalProperties, additionalProperties);
                return;
            }
            if (arguments.length === 0) {
                this.constructor_2();
                return;
            }
            if (arguments.length === 1 && (basePropertySetOrAdditionalProperties === null || basePropertySetOrAdditionalProperties.constructor === Number)) {
                this.constructor_3(basePropertySetOrAdditionalProperties);
                return;
            }
            if (arguments.length === 1 && (basePropertySetOrAdditionalProperties === null || basePropertySetOrAdditionalProperties instanceof Array)) {
                this.constructor_4(basePropertySetOrAdditionalProperties);
                return;
            }
            this.constructor_5(basePropertySetOrAdditionalProperties);
        }
        Object.defineProperty(PropertySet.prototype, "BasePropertySet", {
            get: function () {
                return this.basePropertySet;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.basePropertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "RequestedBodyType", {
            get: function () {
                return this.requestedBodyType;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.requestedBodyType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "RequestedUniqueBodyType", {
            get: function () {
                return this.requestedUniqueBodyType;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.requestedUniqueBodyType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "RequestedNormalizedBodyType", {
            get: function () {
                return this.requestedNormalizedBodyType;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.requestedNormalizedBodyType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "Count", {
            get: function () {
                return this.additionalProperties.Count;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "FilterHtmlContent", {
            get: function () {
                return this.filterHtml;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.filterHtml = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "ConvertHtmlCodePageToUTF8", {
            get: function () {
                return this.convertHtmlCodePageToUTF8;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.convertHtmlCodePageToUTF8 = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "InlineImageUrlTemplate", {
            get: function () {
                return this.inlineImageUrlTemplate;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.inlineImageUrlTemplate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "BlockExternalImages", {
            get: function () {
                return this.blockExternalImages;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.blockExternalImages = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "AddBlankTargetToLinks", {
            get: function () {
                return this.addTargetToLinks;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.addTargetToLinks = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertySet.prototype, "MaximumBodySize", {
            get: function () {
                return this.maximumBodySize;
            },
            set: function (value) {
                this.ThrowIfReadonly();
                this.maximumBodySize = value;
            },
            enumerable: true,
            configurable: true
        });
        PropertySet.prototype.get_Item = function (index) {
            return this.additionalProperties.get_Item(index);
        };
        Object.defineProperty(PropertySet, "DefaultPropertySetMap", {
            get: function () {
                return PropertySet.defaultPropertySetMap;
            },
            enumerable: true,
            configurable: true
        });
        PropertySet.prototype.constructor_0 = function (basePropertySet, additionalProperties) {
            this.constructor_1(basePropertySet, additionalProperties);
        };
        PropertySet.prototype.constructor_1 = function (basePropertySet, additionalProperties) {
            this.basePropertySet = basePropertySet;
            if (additionalProperties !== null) {
                this.additionalProperties.AddRange(additionalProperties);
            }
        };
        PropertySet.prototype.constructor_2 = function () {
            this.constructor_0(BasePropertySet.IdOnly, null);
        };
        PropertySet.prototype.constructor_3 = function (basePropertySet) {
            this.constructor_0(basePropertySet, null);
        };
        PropertySet.prototype.constructor_4 = function (additionalProperties) {
            this.constructor_0(BasePropertySet.IdOnly, additionalProperties);
        };
        PropertySet.prototype.constructor_5 = function (additionalProperties) {
            this.constructor_1(BasePropertySet.IdOnly, additionalProperties);
        };
        PropertySet.op_Implicit = function (basePropertySet) {
            return new PropertySet(basePropertySet);
        };
        PropertySet.prototype.Add = function (property) {
            this.ThrowIfReadonly();
            EwsUtilities.ValidateParam(property, "property");
            if (!this.additionalProperties.Contains(property)) {
                this.additionalProperties.Add(property);
            }
        };
        PropertySet.prototype.AddRange = function (properties) {
            this.ThrowIfReadonly();
            EwsUtilities.ValidateParamCollection(properties, "properties");
            var enumerator = properties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        PropertySet.prototype.Clear = function () {
            this.ThrowIfReadonly();
            this.additionalProperties.Clear();
        };
        PropertySet.CreateReadonlyPropertySet = function (basePropertySet) {
            var propertySet = new PropertySet(basePropertySet);
            propertySet.isReadOnly = true;
            return propertySet;
        };
        PropertySet.GetShapeName = function (serviceObjectType) {
            switch (serviceObjectType) {
                case ServiceObjectType.Folder:
                    return "FolderShape";
                case ServiceObjectType.Item:
                    return "ItemShape";
                case ServiceObjectType.Conversation:
                    return "ConversationShape";
                default:
                    EwsUtilities.Assert(false, "PropertySet.GetShapeName", NString.Format("An unexpected object type {0} for property shape. This code path should never be reached.", serviceObjectType));
                    return NString.Empty;
            }
        };
        PropertySet.prototype.ThrowIfReadonly = function () {
            if (this.isReadOnly) {
                throw new NotSupportedException(Strings.PropertySetCannotBeModified);
            }
        };
        PropertySet.prototype.Contains = function (property) {
            return this.additionalProperties.Contains(property);
        };
        PropertySet.prototype.Remove = function (property) {
            this.ThrowIfReadonly();
            return this.additionalProperties.Remove(property);
        };
        PropertySet.prototype.Validate = function () {
            this.InternalValidate();
        };
        PropertySet.WriteAdditionalPropertiesToXml = function (writer, propertyDefinitions) {
            writer.WriteStartElement(XmlNamespace.Types, "AdditionalProperties");
            var enumerator = propertyDefinitions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
        };
        PropertySet.WriteAdditionalPropertiesToJson = function (jsonItemShape, service, propertyDefinitions) {
            var list = new List();
            var enumerator = propertyDefinitions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.ToJson(service));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            jsonItemShape.Add("AdditionalProperties", NArray.ToEnumerable(list.ToArray()));
        };
        PropertySet.prototype.InternalValidate = function () {
            for (var i = 0; i < this.additionalProperties.Count; i = i + 1) {
                if (this.additionalProperties.get_Item(i) === null) {
                    throw new ServiceValidationException(NString.Format(Strings.AdditionalPropertyIsNull, i));
                }
            }
        };
        PropertySet.prototype.ValidateForRequest = function (request, summaryPropertiesOnly) {
            var enumerator = this.additionalProperties.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var propertyDefinition = ((current instanceof PropertyDefinition) ? current : null);
                    if (propertyDefinition !== null) {
                        if (propertyDefinition.Version > request.Service.RequestedServerVersion) {
                            throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, propertyDefinition.Name, propertyDefinition.Version));
                        }
                        if (summaryPropertiesOnly && !propertyDefinition.HasFlag(PropertyDefinitionFlags.CanFind, new Nullable(request.Service.RequestedServerVersion))) {
                            throw new ServiceValidationException(NString.Format(Strings.NonSummaryPropertyCannotBeUsed, propertyDefinition.Name, request.GetXmlElementName()));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (this.FilterHtmlContent !== null && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "FilterHtmlContent", ExchangeVersion.Exchange2010));
            }
            if (this.ConvertHtmlCodePageToUTF8 !== null && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2010_SP1) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "ConvertHtmlCodePageToUTF8", ExchangeVersion.Exchange2010_SP1));
            }
            if (!NString.IsNullOrEmpty(this.InlineImageUrlTemplate) && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "InlineImageUrlTemplate", ExchangeVersion.Exchange2013));
            }
            if (this.BlockExternalImages !== null && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "BlockExternalImages", ExchangeVersion.Exchange2013));
            }
            if (this.AddBlankTargetToLinks !== null && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "AddTargetToLinks", ExchangeVersion.Exchange2013));
            }
            if (this.MaximumBodySize !== null && request.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.PropertyIncompatibleWithRequestVersion, "MaximumBodySize", ExchangeVersion.Exchange2013));
            }
        };
        PropertySet.prototype.WriteToXml = function (writer, serviceObjectType) {
            var shapeName = PropertySet.GetShapeName(serviceObjectType);
            writer.WriteStartElement(XmlNamespace.Messages, shapeName);
            writer.WriteElementValue(XmlNamespace.Types, "BaseShape", PropertySet.defaultPropertySetMap.Member.get_Item(this.BasePropertySet));
            if (serviceObjectType === ServiceObjectType.Item) {
                if (this.RequestedBodyType !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "BodyType", this.RequestedBodyType.Value);
                }
                if (this.RequestedUniqueBodyType !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "UniqueBodyType", this.RequestedUniqueBodyType.Value);
                }
                if (this.RequestedNormalizedBodyType !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "NormalizedBodyType", this.RequestedNormalizedBodyType.Value);
                }
                if (this.FilterHtmlContent !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "FilterHtmlContent", this.FilterHtmlContent.Value);
                }
                if (this.ConvertHtmlCodePageToUTF8 !== null && writer.Service.RequestedServerVersion >= ExchangeVersion.Exchange2010_SP1) {
                    writer.WriteElementValue(XmlNamespace.Types, "ConvertHtmlCodePageToUTF8", this.ConvertHtmlCodePageToUTF8.Value);
                }
                if (!NString.IsNullOrEmpty(this.InlineImageUrlTemplate) && writer.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    writer.WriteElementValue(XmlNamespace.Types, "InlineImageUrlTemplate", this.InlineImageUrlTemplate);
                }
                if (this.BlockExternalImages !== null && writer.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    writer.WriteElementValue(XmlNamespace.Types, "BlockExternalImages", this.BlockExternalImages.Value);
                }
                if (this.AddBlankTargetToLinks !== null && writer.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    writer.WriteElementValue(XmlNamespace.Types, "AddBlankTargetToLinks", this.AddBlankTargetToLinks.Value);
                }
                if (this.MaximumBodySize !== null && writer.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    writer.WriteElementValue(XmlNamespace.Types, "MaximumBodySize", this.MaximumBodySize.Value);
                }
            }
            if (this.additionalProperties.Count > 0) {
                PropertySet.WriteAdditionalPropertiesToXml(writer, this.additionalProperties);
            }
            writer.WriteEndElement();
        };
        PropertySet.prototype.WriteGetShapeToJson = function (jsonRequest, service, serviceObjectType) {
            var shapeName = PropertySet.GetShapeName(serviceObjectType);
            var jsonObject = new JsonObject();
            jsonObject.Add("BaseShape", PropertySet.defaultPropertySetMap.Member.get_Item(this.BasePropertySet));
            if (serviceObjectType === ServiceObjectType.Item) {
                if (this.RequestedBodyType !== null) {
                    jsonObject.Add("BodyType", this.RequestedBodyType.Value);
                }
                if (this.FilterHtmlContent !== null) {
                    jsonObject.Add("FilterHtmlContent", this.FilterHtmlContent.Value);
                }
                if (this.ConvertHtmlCodePageToUTF8 !== null && service.RequestedServerVersion >= ExchangeVersion.Exchange2010_SP1) {
                    jsonObject.Add("ConvertHtmlCodePageToUTF8", this.ConvertHtmlCodePageToUTF8.Value);
                }
                if (!NString.IsNullOrEmpty(this.InlineImageUrlTemplate) && service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    jsonObject.Add("InlineImageUrlTemplate", this.InlineImageUrlTemplate);
                }
                if (this.BlockExternalImages !== null && service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    jsonObject.Add("BlockExternalImages", this.BlockExternalImages.Value);
                }
                if (this.AddBlankTargetToLinks !== null && service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    jsonObject.Add("AddBlankTargetToLinks", this.AddBlankTargetToLinks.Value);
                }
                if (this.MaximumBodySize !== null && service.RequestedServerVersion >= ExchangeVersion.Exchange2013) {
                    jsonObject.Add("MaximumBodySize", this.MaximumBodySize.Value);
                }
            }
            if (this.additionalProperties.Count > 0) {
                PropertySet.WriteAdditionalPropertiesToJson(jsonObject, service, this.additionalProperties);
            }
            jsonRequest.Add(shapeName, jsonObject);
        };
        PropertySet.prototype.GetEnumerator = function () {
            return this.additionalProperties.GetEnumerator();
        };
        PropertySet.IdOnly = PropertySet.CreateReadonlyPropertySet(BasePropertySet.IdOnly);
        PropertySet.FirstClassProperties = PropertySet.CreateReadonlyPropertySet(BasePropertySet.FirstClassProperties);
        PropertySet.defaultPropertySetMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(BasePropertySet.IdOnly, "IdOnly");
            dictionary.Add(BasePropertySet.FirstClassProperties, "AllProperties");
            return dictionary;
        });
        return PropertySet;
    }());
    var SimplePropertyBag = (function () {
        function SimplePropertyBag() {
            this.items = new Dictionary();
            this.removedItems = new List();
            this.addedItems = new List();
            this.modifiedItems = new List();
            this.OnChange = new NEvent();
            _super.call(this);
        }
        Object.defineProperty(SimplePropertyBag.prototype, "AddedItems", {
            get: function () {
                return this.addedItems;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimplePropertyBag.prototype, "RemovedItems", {
            get: function () {
                return this.removedItems;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimplePropertyBag.prototype, "ModifiedItems", {
            get: function () {
                return this.modifiedItems;
            },
            enumerable: true,
            configurable: true
        });
        SimplePropertyBag.prototype.get_Item = function (key) {
            var _this = this;
            var result;
            if ((function () {
                var _p0 = [
                    result
                ];
                var _r = _this.TryGetValue(key, _p0);
                result = _p0[0];
                return _r;
            })()) {
                return result;
            }
            return null;
        };
        SimplePropertyBag.prototype.set_Item = function (key, value) {
            if (value === null) {
                this.InternalRemoveItem(key);
                return;
            }
            if (this.removedItems.Remove(key)) {
                this.InternalAddItemToChangeList(key, this.modifiedItems);
            }
            else {
                if (!this.ContainsKey(key)) {
                    SimplePropertyBag(InternalAddItemToChangeList(key, this.addedItems));
                }
                else {
                    if (!this.modifiedItems.Contains(key)) {
                        SimplePropertyBag(InternalAddItemToChangeList(key, this.modifiedItems));
                    }
                }
            }
            this.items.set_Item(key, value);
            this.Changed();
        };
        SimplePropertyBag.InternalAddItemToChangeList = function (key, changeList) {
            if (!changeList.Contains(key)) {
                changeList.Add(key);
            }
        };
        SimplePropertyBag.prototype.Changed = function () {
            if (this.OnChange !== null) {
                this.OnChange();
            }
        };
        SimplePropertyBag.prototype.InternalRemoveItem = function (key) {
            var _this = this;
            var obj;
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.TryGetValue(key, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                this.items.Remove(key);
                this.removedItems.Add(key);
                this.Changed();
            }
        };
        SimplePropertyBag.prototype.ClearChangeLog = function () {
            this.removedItems.Clear();
            this.addedItems.Clear();
            this.modifiedItems.Clear();
        };
        SimplePropertyBag.prototype.ContainsKey = function (key) {
            return this.items.ContainsKey(key);
        };
        SimplePropertyBag.prototype.TryGetValue = function (key, value) {
            var _this = this;
            return (function () {
                var _p0 = [
                    value[0]
                ];
                var _r = _this.items.TryGetValue(key, _p0);
                value[0] = _p0[0];
                return _r;
            })();
        };
        SimplePropertyBag.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        return SimplePropertyBag;
    }());
    var XmlAttributeNames = (function () {
        function XmlAttributeNames() {
            _super.call(this);
        }
        XmlAttributeNames.XmlNs = "xmlns";
        XmlAttributeNames.Id = "Id";
        XmlAttributeNames.ChangeKey = "ChangeKey";
        XmlAttributeNames.RecurringMasterId = "RecurringMasterId";
        XmlAttributeNames.InstanceIndex = "InstanceIndex";
        XmlAttributeNames.OccurrenceId = "OccurrenceId";
        XmlAttributeNames.Traversal = "Traversal";
        XmlAttributeNames.ViewFilter = "ViewFilter";
        XmlAttributeNames.Offset = "Offset";
        XmlAttributeNames.MaxEntriesReturned = "MaxEntriesReturned";
        XmlAttributeNames.BasePoint = "BasePoint";
        XmlAttributeNames.ResponseClass = "ResponseClass";
        XmlAttributeNames.IndexedPagingOffset = "IndexedPagingOffset";
        XmlAttributeNames.TotalItemsInView = "TotalItemsInView";
        XmlAttributeNames.IncludesLastItemInRange = "IncludesLastItemInRange";
        XmlAttributeNames.BodyType = "BodyType";
        XmlAttributeNames.MessageDisposition = "MessageDisposition";
        XmlAttributeNames.SaveItemToFolder = "SaveItemToFolder";
        XmlAttributeNames.RootItemChangeKey = "RootItemChangeKey";
        XmlAttributeNames.DeleteType = "DeleteType";
        XmlAttributeNames.DeleteSubFolders = "DeleteSubFolders";
        XmlAttributeNames.AffectedTaskOccurrences = "AffectedTaskOccurrences";
        XmlAttributeNames.SendMeetingCancellations = "SendMeetingCancellations";
        XmlAttributeNames.SuppressReadReceipts = "SuppressReadReceipts";
        XmlAttributeNames.FieldURI = "FieldURI";
        XmlAttributeNames.FieldIndex = "FieldIndex";
        XmlAttributeNames.ConflictResolution = "ConflictResolution";
        XmlAttributeNames.SendMeetingInvitationsOrCancellations = "SendMeetingInvitationsOrCancellations";
        XmlAttributeNames.CharacterSet = "CharacterSet";
        XmlAttributeNames.HeaderName = "HeaderName";
        XmlAttributeNames.SendMeetingInvitations = "SendMeetingInvitations";
        XmlAttributeNames.Key = "Key";
        XmlAttributeNames.RoutingType = "RoutingType";
        XmlAttributeNames.MailboxType = "MailboxType";
        XmlAttributeNames.DistinguishedPropertySetId = "DistinguishedPropertySetId";
        XmlAttributeNames.PropertySetId = "PropertySetId";
        XmlAttributeNames.PropertyTag = "PropertyTag";
        XmlAttributeNames.PropertyName = "PropertyName";
        XmlAttributeNames.PropertyId = "PropertyId";
        XmlAttributeNames.PropertyType = "PropertyType";
        XmlAttributeNames.TimeZoneName = "TimeZoneName";
        XmlAttributeNames.ReturnFullContactData = "ReturnFullContactData";
        XmlAttributeNames.ContactDataShape = "ContactDataShape";
        XmlAttributeNames.Numerator = "Numerator";
        XmlAttributeNames.Denominator = "Numerator";
        XmlAttributeNames.Value = "Value";
        XmlAttributeNames.ContainmentMode = "ContainmentMode";
        XmlAttributeNames.ContainmentComparison = "ContainmentComparison";
        XmlAttributeNames.Order = "Order";
        XmlAttributeNames.StartDate = "StartDate";
        XmlAttributeNames.EndDate = "EndDate";
        XmlAttributeNames.Version = "Version";
        XmlAttributeNames.Aggregate = "Aggregate";
        XmlAttributeNames.SearchScope = "SearchScope";
        XmlAttributeNames.Format = "Format";
        XmlAttributeNames.Mailbox = "Mailbox";
        XmlAttributeNames.DestinationFormat = "DestinationFormat";
        XmlAttributeNames.FolderId = "FolderId";
        XmlAttributeNames.ItemId = "ItemId";
        XmlAttributeNames.IncludePermissions = "IncludePermissions";
        XmlAttributeNames.InitialName = "InitialName";
        XmlAttributeNames.FinalName = "FinalName";
        XmlAttributeNames.AuthenticationMethod = "AuthenticationMethod";
        XmlAttributeNames.Time = "Time";
        XmlAttributeNames.Name = "Name";
        XmlAttributeNames.Bias = "Bias";
        XmlAttributeNames.Kind = "Kind";
        XmlAttributeNames.SubscribeToAllFolders = "SubscribeToAllFolders";
        XmlAttributeNames.PublicFolderServer = "PublicFolderServer";
        XmlAttributeNames.IsArchive = "IsArchive";
        XmlAttributeNames.ReturnHighlightTerms = "ReturnHighlightTerms";
        XmlAttributeNames.IsExplicit = "IsExplicit";
        XmlAttributeNames.ClientExtensionUserIdentity = "UserId";
        XmlAttributeNames.ClientExtensionEnabledOnly = "EnabledOnly";
        XmlAttributeNames.SetClientExtensionActionId = "ActionId";
        XmlAttributeNames.ClientExtensionId = "ExtensionId";
        XmlAttributeNames.ClientExtensionIsAvailable = "IsAvailable";
        XmlAttributeNames.ClientExtensionIsMandatory = "IsMandatory";
        XmlAttributeNames.ClientExtensionIsEnabledByDefault = "IsEnabledByDefault";
        XmlAttributeNames.ClientExtensionProvidedTo = "ProvidedTo";
        XmlAttributeNames.ClientExtensionType = "Type";
        XmlAttributeNames.ClientExtensionScope = "Scope";
        XmlAttributeNames.ClientExtensionMarketplaceAssetID = "MarketplaceAssetId";
        XmlAttributeNames.ClientExtensionMarketplaceContentMarket = "MarketplaceContentMarket";
        XmlAttributeNames.ClientExtensionAppStatus = "AppStatus";
        XmlAttributeNames.ClientExtensionEtoken = "Etoken";
        XmlAttributeNames.IsTruncated = "IsTruncated";
        XmlAttributeNames.IsJunk = "IsJunk";
        XmlAttributeNames.MoveItem = "MoveItem";
        XmlAttributeNames.Nil = "nil";
        XmlAttributeNames.Type = "type";
        return XmlAttributeNames;
    }());
    var XmlElementNames = (function () {
        function XmlElementNames() {
            _super.call(this);
        }
        XmlElementNames.AllProperties = "AllProperties";
        XmlElementNames.ParentFolderIds = "ParentFolderIds";
        XmlElementNames.DistinguishedFolderId = "DistinguishedFolderId";
        XmlElementNames.ItemId = "ItemId";
        XmlElementNames.ItemIds = "ItemIds";
        XmlElementNames.FolderId = "FolderId";
        XmlElementNames.FolderIds = "FolderIds";
        XmlElementNames.OccurrenceItemId = "OccurrenceItemId";
        XmlElementNames.RecurringMasterItemId = "RecurringMasterItemId";
        XmlElementNames.ItemShape = "ItemShape";
        XmlElementNames.FolderShape = "FolderShape";
        XmlElementNames.BaseShape = "BaseShape";
        XmlElementNames.IndexedPageItemView = "IndexedPageItemView";
        XmlElementNames.IndexedPageFolderView = "IndexedPageFolderView";
        XmlElementNames.FractionalPageItemView = "FractionalPageItemView";
        XmlElementNames.FractionalPageFolderView = "FractionalPageFolderView";
        XmlElementNames.SeekToConditionPageItemView = "SeekToConditionPageItemView";
        XmlElementNames.ResponseCode = "ResponseCode";
        XmlElementNames.RootFolder = "RootFolder";
        XmlElementNames.Folder = "Folder";
        XmlElementNames.ContactsFolder = "ContactsFolder";
        XmlElementNames.TasksFolder = "TasksFolder";
        XmlElementNames.SearchFolder = "SearchFolder";
        XmlElementNames.Folders = "Folders";
        XmlElementNames.Item = "Item";
        XmlElementNames.Items = "Items";
        XmlElementNames.Message = "Message";
        XmlElementNames.Mailbox = "Mailbox";
        XmlElementNames.Body = "Body";
        XmlElementNames.From = "From";
        XmlElementNames.Sender = "Sender";
        XmlElementNames.Name = "Name";
        XmlElementNames.Address = "Address";
        XmlElementNames.EmailAddress = "EmailAddress";
        XmlElementNames.RoutingType = "RoutingType";
        XmlElementNames.MailboxType = "MailboxType";
        XmlElementNames.ToRecipients = "ToRecipients";
        XmlElementNames.CcRecipients = "CcRecipients";
        XmlElementNames.BccRecipients = "BccRecipients";
        XmlElementNames.ReplyTo = "ReplyTo";
        XmlElementNames.ConversationTopic = "ConversationTopic";
        XmlElementNames.ConversationIndex = "ConversationIndex";
        XmlElementNames.IsDeliveryReceiptRequested = "IsDeliveryReceiptRequested";
        XmlElementNames.IsRead = "IsRead";
        XmlElementNames.IsReadReceiptRequested = "IsReadReceiptRequested";
        XmlElementNames.IsResponseRequested = "IsResponseRequested";
        XmlElementNames.InternetMessageId = "InternetMessageId";
        XmlElementNames.References = "References";
        XmlElementNames.ParentItemId = "ParentItemId";
        XmlElementNames.ParentFolderId = "ParentFolderId";
        XmlElementNames.ChildFolderCount = "ChildFolderCount";
        XmlElementNames.DisplayName = "DisplayName";
        XmlElementNames.TotalCount = "TotalCount";
        XmlElementNames.ItemClass = "ItemClass";
        XmlElementNames.FolderClass = "FolderClass";
        XmlElementNames.Subject = "Subject";
        XmlElementNames.MimeContent = "MimeContent";
        XmlElementNames.Sensitivity = "Sensitivity";
        XmlElementNames.Attachments = "Attachments";
        XmlElementNames.DateTimeReceived = "DateTimeReceived";
        XmlElementNames.Size = "Size";
        XmlElementNames.Categories = "Categories";
        XmlElementNames.Importance = "Importance";
        XmlElementNames.InReplyTo = "InReplyTo";
        XmlElementNames.IsSubmitted = "IsSubmitted";
        XmlElementNames.IsAssociated = "IsAssociated";
        XmlElementNames.IsDraft = "IsDraft";
        XmlElementNames.IsFromMe = "IsFromMe";
        XmlElementNames.IsResend = "IsResend";
        XmlElementNames.IsUnmodified = "IsUnmodified";
        XmlElementNames.InternetMessageHeader = "InternetMessageHeader";
        XmlElementNames.InternetMessageHeaders = "InternetMessageHeaders";
        XmlElementNames.DateTimeSent = "DateTimeSent";
        XmlElementNames.DateTimeCreated = "DateTimeCreated";
        XmlElementNames.ResponseObjects = "ResponseObjects";
        XmlElementNames.ReminderDueBy = "ReminderDueBy";
        XmlElementNames.ReminderIsSet = "ReminderIsSet";
        XmlElementNames.ReminderMinutesBeforeStart = "ReminderMinutesBeforeStart";
        XmlElementNames.DisplayCc = "DisplayCc";
        XmlElementNames.DisplayTo = "DisplayTo";
        XmlElementNames.HasAttachments = "HasAttachments";
        XmlElementNames.ExtendedProperty = "ExtendedProperty";
        XmlElementNames.Culture = "Culture";
        XmlElementNames.FileAttachment = "FileAttachment";
        XmlElementNames.ItemAttachment = "ItemAttachment";
        XmlElementNames.AttachmentIds = "AttachmentIds";
        XmlElementNames.AttachmentId = "AttachmentId";
        XmlElementNames.ContentType = "ContentType";
        XmlElementNames.ContentLocation = "ContentLocation";
        XmlElementNames.ContentId = "ContentId";
        XmlElementNames.Content = "Content";
        XmlElementNames.SavedItemFolderId = "SavedItemFolderId";
        XmlElementNames.MessageText = "MessageText";
        XmlElementNames.DescriptiveLinkKey = "DescriptiveLinkKey";
        XmlElementNames.ItemChange = "ItemChange";
        XmlElementNames.ItemChanges = "ItemChanges";
        XmlElementNames.FolderChange = "FolderChange";
        XmlElementNames.FolderChanges = "FolderChanges";
        XmlElementNames.Updates = "Updates";
        XmlElementNames.AppendToItemField = "AppendToItemField";
        XmlElementNames.SetItemField = "SetItemField";
        XmlElementNames.DeleteItemField = "DeleteItemField";
        XmlElementNames.SetFolderField = "SetFolderField";
        XmlElementNames.DeleteFolderField = "DeleteFolderField";
        XmlElementNames.FieldURI = "FieldURI";
        XmlElementNames.RootItemId = "RootItemId";
        XmlElementNames.ReferenceItemId = "ReferenceItemId";
        XmlElementNames.NewBodyContent = "NewBodyContent";
        XmlElementNames.ReplyToItem = "ReplyToItem";
        XmlElementNames.ReplyAllToItem = "ReplyAllToItem";
        XmlElementNames.ForwardItem = "ForwardItem";
        XmlElementNames.AcceptItem = "AcceptItem";
        XmlElementNames.TentativelyAcceptItem = "TentativelyAcceptItem";
        XmlElementNames.DeclineItem = "DeclineItem";
        XmlElementNames.CancelCalendarItem = "CancelCalendarItem";
        XmlElementNames.RemoveItem = "RemoveItem";
        XmlElementNames.SuppressReadReceipt = "SuppressReadReceipt";
        XmlElementNames.SuppressReadReceipts = "SuppressReadReceipts";
        XmlElementNames.String = "String";
        XmlElementNames.Start = "Start";
        XmlElementNames.End = "End";
        XmlElementNames.ProposedStart = "ProposedStart";
        XmlElementNames.ProposedEnd = "ProposedEnd";
        XmlElementNames.OriginalStart = "OriginalStart";
        XmlElementNames.IsAllDayEvent = "IsAllDayEvent";
        XmlElementNames.LegacyFreeBusyStatus = "LegacyFreeBusyStatus";
        XmlElementNames.Location = "Location";
        XmlElementNames.When = "When";
        XmlElementNames.IsMeeting = "IsMeeting";
        XmlElementNames.IsCancelled = "IsCancelled";
        XmlElementNames.IsRecurring = "IsRecurring";
        XmlElementNames.MeetingRequestWasSent = "MeetingRequestWasSent";
        XmlElementNames.CalendarItemType = "CalendarItemType";
        XmlElementNames.MyResponseType = "MyResponseType";
        XmlElementNames.Organizer = "Organizer";
        XmlElementNames.RequiredAttendees = "RequiredAttendees";
        XmlElementNames.OptionalAttendees = "OptionalAttendees";
        XmlElementNames.Resources = "Resources";
        XmlElementNames.ConflictingMeetingCount = "ConflictingMeetingCount";
        XmlElementNames.AdjacentMeetingCount = "AdjacentMeetingCount";
        XmlElementNames.ConflictingMeetings = "ConflictingMeetings";
        XmlElementNames.AdjacentMeetings = "AdjacentMeetings";
        XmlElementNames.Duration = "Duration";
        XmlElementNames.TimeZone = "TimeZone";
        XmlElementNames.AppointmentReplyTime = "AppointmentReplyTime";
        XmlElementNames.AppointmentSequenceNumber = "AppointmentSequenceNumber";
        XmlElementNames.AppointmentState = "AppointmentState";
        XmlElementNames.Recurrence = "Recurrence";
        XmlElementNames.FirstOccurrence = "FirstOccurrence";
        XmlElementNames.LastOccurrence = "LastOccurrence";
        XmlElementNames.ModifiedOccurrences = "ModifiedOccurrences";
        XmlElementNames.DeletedOccurrences = "DeletedOccurrences";
        XmlElementNames.MeetingTimeZone = "MeetingTimeZone";
        XmlElementNames.ConferenceType = "ConferenceType";
        XmlElementNames.AllowNewTimeProposal = "AllowNewTimeProposal";
        XmlElementNames.IsOnlineMeeting = "IsOnlineMeeting";
        XmlElementNames.MeetingWorkspaceUrl = "MeetingWorkspaceUrl";
        XmlElementNames.NetShowUrl = "NetShowUrl";
        XmlElementNames.JoinOnlineMeetingUrl = "JoinOnlineMeetingUrl";
        XmlElementNames.OnlineMeetingSettings = "OnlineMeetingSettings";
        XmlElementNames.LobbyBypass = "LobbyBypass";
        XmlElementNames.AccessLevel = "AccessLevel";
        XmlElementNames.Presenters = "Presenters";
        XmlElementNames.CalendarItem = "CalendarItem";
        XmlElementNames.CalendarFolder = "CalendarFolder";
        XmlElementNames.Attendee = "Attendee";
        XmlElementNames.ResponseType = "ResponseType";
        XmlElementNames.LastResponseTime = "LastResponseTime";
        XmlElementNames.Occurrence = "Occurrence";
        XmlElementNames.DeletedOccurrence = "DeletedOccurrence";
        XmlElementNames.RelativeYearlyRecurrence = "RelativeYearlyRecurrence";
        XmlElementNames.AbsoluteYearlyRecurrence = "AbsoluteYearlyRecurrence";
        XmlElementNames.RelativeMonthlyRecurrence = "RelativeMonthlyRecurrence";
        XmlElementNames.AbsoluteMonthlyRecurrence = "AbsoluteMonthlyRecurrence";
        XmlElementNames.WeeklyRecurrence = "WeeklyRecurrence";
        XmlElementNames.DailyRecurrence = "DailyRecurrence";
        XmlElementNames.DailyRegeneration = "DailyRegeneration";
        XmlElementNames.WeeklyRegeneration = "WeeklyRegeneration";
        XmlElementNames.MonthlyRegeneration = "MonthlyRegeneration";
        XmlElementNames.YearlyRegeneration = "YearlyRegeneration";
        XmlElementNames.NoEndRecurrence = "NoEndRecurrence";
        XmlElementNames.EndDateRecurrence = "EndDateRecurrence";
        XmlElementNames.NumberedRecurrence = "NumberedRecurrence";
        XmlElementNames.Interval = "Interval";
        XmlElementNames.DayOfMonth = "DayOfMonth";
        XmlElementNames.DayOfWeek = "DayOfWeek";
        XmlElementNames.DaysOfWeek = "DaysOfWeek";
        XmlElementNames.DayOfWeekIndex = "DayOfWeekIndex";
        XmlElementNames.Month = "Month";
        XmlElementNames.StartDate = "StartDate";
        XmlElementNames.EndDate = "EndDate";
        XmlElementNames.StartTime = "StartTime";
        XmlElementNames.EndTime = "EndTime";
        XmlElementNames.NumberOfOccurrences = "NumberOfOccurrences";
        XmlElementNames.AssociatedCalendarItemId = "AssociatedCalendarItemId";
        XmlElementNames.IsDelegated = "IsDelegated";
        XmlElementNames.IsOutOfDate = "IsOutOfDate";
        XmlElementNames.HasBeenProcessed = "HasBeenProcessed";
        XmlElementNames.IsOrganizer = "IsOrganizer";
        XmlElementNames.MeetingMessage = "MeetingMessage";
        XmlElementNames.FileAs = "FileAs";
        XmlElementNames.FileAsMapping = "FileAsMapping";
        XmlElementNames.GivenName = "GivenName";
        XmlElementNames.Initials = "Initials";
        XmlElementNames.MiddleName = "MiddleName";
        XmlElementNames.NickName = "Nickname";
        XmlElementNames.CompleteName = "CompleteName";
        XmlElementNames.CompanyName = "CompanyName";
        XmlElementNames.EmailAddresses = "EmailAddresses";
        XmlElementNames.PhysicalAddresses = "PhysicalAddresses";
        XmlElementNames.PhoneNumbers = "PhoneNumbers";
        XmlElementNames.PhoneNumber = "PhoneNumber";
        XmlElementNames.AssistantName = "AssistantName";
        XmlElementNames.Birthday = "Birthday";
        XmlElementNames.BusinessHomePage = "BusinessHomePage";
        XmlElementNames.Children = "Children";
        XmlElementNames.Companies = "Companies";
        XmlElementNames.ContactSource = "ContactSource";
        XmlElementNames.Department = "Department";
        XmlElementNames.Generation = "Generation";
        XmlElementNames.ImAddresses = "ImAddresses";
        XmlElementNames.ImAddress = "ImAddress";
        XmlElementNames.JobTitle = "JobTitle";
        XmlElementNames.Manager = "Manager";
        XmlElementNames.Mileage = "Mileage";
        XmlElementNames.OfficeLocation = "OfficeLocation";
        XmlElementNames.PostalAddressIndex = "PostalAddressIndex";
        XmlElementNames.Profession = "Profession";
        XmlElementNames.SpouseName = "SpouseName";
        XmlElementNames.Surname = "Surname";
        XmlElementNames.WeddingAnniversary = "WeddingAnniversary";
        XmlElementNames.HasPicture = "HasPicture";
        XmlElementNames.Title = "Title";
        XmlElementNames.FirstName = "FirstName";
        XmlElementNames.LastName = "LastName";
        XmlElementNames.Suffix = "Suffix";
        XmlElementNames.FullName = "FullName";
        XmlElementNames.YomiFirstName = "YomiFirstName";
        XmlElementNames.YomiLastName = "YomiLastName";
        XmlElementNames.Contact = "Contact";
        XmlElementNames.Entry = "Entry";
        XmlElementNames.Street = "Street";
        XmlElementNames.City = "City";
        XmlElementNames.State = "State";
        XmlElementNames.SharePointSiteUrl = "SharePointSiteUrl";
        XmlElementNames.Country = "Country";
        XmlElementNames.CountryOrRegion = "CountryOrRegion";
        XmlElementNames.PostalCode = "PostalCode";
        XmlElementNames.PostOfficeBox = "PostOfficeBox";
        XmlElementNames.Members = "Members";
        XmlElementNames.Member = "Member";
        XmlElementNames.AdditionalProperties = "AdditionalProperties";
        XmlElementNames.ExtendedFieldURI = "ExtendedFieldURI";
        XmlElementNames.Value = "Value";
        XmlElementNames.Values = "Values";
        XmlElementNames.ToFolderId = "ToFolderId";
        XmlElementNames.ActualWork = "ActualWork";
        XmlElementNames.AssignedTime = "AssignedTime";
        XmlElementNames.BillingInformation = "BillingInformation";
        XmlElementNames.ChangeCount = "ChangeCount";
        XmlElementNames.CompleteDate = "CompleteDate";
        XmlElementNames.Contacts = "Contacts";
        XmlElementNames.DelegationState = "DelegationState";
        XmlElementNames.Delegator = "Delegator";
        XmlElementNames.DueDate = "DueDate";
        XmlElementNames.IsAssignmentEditable = "IsAssignmentEditable";
        XmlElementNames.IsComplete = "IsComplete";
        XmlElementNames.IsTeamTask = "IsTeamTask";
        XmlElementNames.Owner = "Owner";
        XmlElementNames.PercentComplete = "PercentComplete";
        XmlElementNames.Status = "Status";
        XmlElementNames.StatusDescription = "StatusDescription";
        XmlElementNames.TotalWork = "TotalWork";
        XmlElementNames.Task = "Task";
        XmlElementNames.MailboxCulture = "MailboxCulture";
        XmlElementNames.MeetingRequestType = "MeetingRequestType";
        XmlElementNames.IntendedFreeBusyStatus = "IntendedFreeBusyStatus";
        XmlElementNames.MeetingRequest = "MeetingRequest";
        XmlElementNames.MeetingResponse = "MeetingResponse";
        XmlElementNames.MeetingCancellation = "MeetingCancellation";
        XmlElementNames.ChangeHighlights = "ChangeHighlights";
        XmlElementNames.HasLocationChanged = "HasLocationChanged";
        XmlElementNames.HasStartTimeChanged = "HasStartTimeChanged";
        XmlElementNames.HasEndTimeChanged = "HasEndTimeChanged";
        XmlElementNames.BaseOffset = "BaseOffset";
        XmlElementNames.Offset = "Offset";
        XmlElementNames.Standard = "Standard";
        XmlElementNames.Daylight = "Daylight";
        XmlElementNames.Time = "Time";
        XmlElementNames.AbsoluteDate = "AbsoluteDate";
        XmlElementNames.UnresolvedEntry = "UnresolvedEntry";
        XmlElementNames.ResolutionSet = "ResolutionSet";
        XmlElementNames.Resolution = "Resolution";
        XmlElementNames.DistributionList = "DistributionList";
        XmlElementNames.DLExpansion = "DLExpansion";
        XmlElementNames.IndexedFieldURI = "IndexedFieldURI";
        XmlElementNames.PullSubscriptionRequest = "PullSubscriptionRequest";
        XmlElementNames.PushSubscriptionRequest = "PushSubscriptionRequest";
        XmlElementNames.StreamingSubscriptionRequest = "StreamingSubscriptionRequest";
        XmlElementNames.EventTypes = "EventTypes";
        XmlElementNames.EventType = "EventType";
        XmlElementNames.Timeout = "Timeout";
        XmlElementNames.Watermark = "Watermark";
        XmlElementNames.SubscriptionId = "SubscriptionId";
        XmlElementNames.SubscriptionIds = "SubscriptionIds";
        XmlElementNames.StatusFrequency = "StatusFrequency";
        XmlElementNames.URL = "URL";
        XmlElementNames.CallerData = "CallerData";
        XmlElementNames.Notification = "Notification";
        XmlElementNames.Notifications = "Notifications";
        XmlElementNames.PreviousWatermark = "PreviousWatermark";
        XmlElementNames.MoreEvents = "MoreEvents";
        XmlElementNames.TimeStamp = "TimeStamp";
        XmlElementNames.UnreadCount = "UnreadCount";
        XmlElementNames.OldParentFolderId = "OldParentFolderId";
        XmlElementNames.CopiedEvent = "CopiedEvent";
        XmlElementNames.CreatedEvent = "CreatedEvent";
        XmlElementNames.DeletedEvent = "DeletedEvent";
        XmlElementNames.ModifiedEvent = "ModifiedEvent";
        XmlElementNames.MovedEvent = "MovedEvent";
        XmlElementNames.NewMailEvent = "NewMailEvent";
        XmlElementNames.StatusEvent = "StatusEvent";
        XmlElementNames.FreeBusyChangedEvent = "FreeBusyChangedEvent";
        XmlElementNames.ExchangeImpersonation = "ExchangeImpersonation";
        XmlElementNames.ConnectingSID = "ConnectingSID";
        XmlElementNames.OpenAsAdminOrSystemService = "OpenAsAdminOrSystemService";
        XmlElementNames.LogonType = "LogonType";
        XmlElementNames.BudgetType = "BudgetType";
        XmlElementNames.ManagementRole = "ManagementRole";
        XmlElementNames.UserRoles = "UserRoles";
        XmlElementNames.ApplicationRoles = "ApplicationRoles";
        XmlElementNames.Role = "Role";
        XmlElementNames.SyncFolderId = "SyncFolderId";
        XmlElementNames.SyncScope = "SyncScope";
        XmlElementNames.SyncState = "SyncState";
        XmlElementNames.Ignore = "Ignore";
        XmlElementNames.MaxChangesReturned = "MaxChangesReturned";
        XmlElementNames.Changes = "Changes";
        XmlElementNames.IncludesLastItemInRange = "IncludesLastItemInRange";
        XmlElementNames.IncludesLastFolderInRange = "IncludesLastFolderInRange";
        XmlElementNames.Create = "Create";
        XmlElementNames.Update = "Update";
        XmlElementNames.Delete = "Delete";
        XmlElementNames.ReadFlagChange = "ReadFlagChange";
        XmlElementNames.SearchParameters = "SearchParameters";
        XmlElementNames.SoftDeleted = "SoftDeleted";
        XmlElementNames.Shallow = "Shallow";
        XmlElementNames.Associated = "Associated";
        XmlElementNames.BaseFolderId = "BaseFolderId";
        XmlElementNames.BaseFolderIds = "BaseFolderIds";
        XmlElementNames.SortOrder = "SortOrder";
        XmlElementNames.FieldOrder = "FieldOrder";
        XmlElementNames.CanDelete = "CanDelete";
        XmlElementNames.CanRenameOrMove = "CanRenameOrMove";
        XmlElementNames.MustDisplayComment = "MustDisplayComment";
        XmlElementNames.HasQuota = "HasQuota";
        XmlElementNames.IsManagedFoldersRoot = "IsManagedFoldersRoot";
        XmlElementNames.ManagedFolderId = "ManagedFolderId";
        XmlElementNames.Comment = "Comment";
        XmlElementNames.StorageQuota = "StorageQuota";
        XmlElementNames.FolderSize = "FolderSize";
        XmlElementNames.HomePage = "HomePage";
        XmlElementNames.ManagedFolderInformation = "ManagedFolderInformation";
        XmlElementNames.CalendarView = "CalendarView";
        XmlElementNames.PostedTime = "PostedTime";
        XmlElementNames.PostItem = "PostItem";
        XmlElementNames.RequestServerVersion = "RequestServerVersion";
        XmlElementNames.PostReplyItem = "PostReplyItem";
        XmlElementNames.CreateAssociated = "CreateAssociated";
        XmlElementNames.CreateContents = "CreateContents";
        XmlElementNames.CreateHierarchy = "CreateHierarchy";
        XmlElementNames.Modify = "Modify";
        XmlElementNames.Read = "Read";
        XmlElementNames.EffectiveRights = "EffectiveRights";
        XmlElementNames.LastModifiedName = "LastModifiedName";
        XmlElementNames.LastModifiedTime = "LastModifiedTime";
        XmlElementNames.ConversationId = "ConversationId";
        XmlElementNames.UniqueBody = "UniqueBody";
        XmlElementNames.BodyType = "BodyType";
        XmlElementNames.NormalizedBodyType = "NormalizedBodyType";
        XmlElementNames.UniqueBodyType = "UniqueBodyType";
        XmlElementNames.AttachmentShape = "AttachmentShape";
        XmlElementNames.UserId = "UserId";
        XmlElementNames.UserIds = "UserIds";
        XmlElementNames.CanCreateItems = "CanCreateItems";
        XmlElementNames.CanCreateSubFolders = "CanCreateSubFolders";
        XmlElementNames.IsFolderOwner = "IsFolderOwner";
        XmlElementNames.IsFolderVisible = "IsFolderVisible";
        XmlElementNames.IsFolderContact = "IsFolderContact";
        XmlElementNames.EditItems = "EditItems";
        XmlElementNames.DeleteItems = "DeleteItems";
        XmlElementNames.ReadItems = "ReadItems";
        XmlElementNames.PermissionLevel = "PermissionLevel";
        XmlElementNames.CalendarPermissionLevel = "CalendarPermissionLevel";
        XmlElementNames.SID = "SID";
        XmlElementNames.PrimarySmtpAddress = "PrimarySmtpAddress";
        XmlElementNames.DistinguishedUser = "DistinguishedUser";
        XmlElementNames.PermissionSet = "PermissionSet";
        XmlElementNames.Permissions = "Permissions";
        XmlElementNames.Permission = "Permission";
        XmlElementNames.CalendarPermissions = "CalendarPermissions";
        XmlElementNames.CalendarPermission = "CalendarPermission";
        XmlElementNames.GroupBy = "GroupBy";
        XmlElementNames.AggregateOn = "AggregateOn";
        XmlElementNames.Groups = "Groups";
        XmlElementNames.GroupedItems = "GroupedItems";
        XmlElementNames.GroupIndex = "GroupIndex";
        XmlElementNames.ConflictResults = "ConflictResults";
        XmlElementNames.Count = "Count";
        XmlElementNames.OofSettings = "OofSettings";
        XmlElementNames.UserOofSettings = "UserOofSettings";
        XmlElementNames.OofState = "OofState";
        XmlElementNames.ExternalAudience = "ExternalAudience";
        XmlElementNames.AllowExternalOof = "AllowExternalOof";
        XmlElementNames.InternalReply = "InternalReply";
        XmlElementNames.ExternalReply = "ExternalReply";
        XmlElementNames.Bias = "Bias";
        XmlElementNames.DayOrder = "DayOrder";
        XmlElementNames.Year = "Year";
        XmlElementNames.StandardTime = "StandardTime";
        XmlElementNames.DaylightTime = "DaylightTime";
        XmlElementNames.MailboxData = "MailboxData";
        XmlElementNames.MailboxDataArray = "MailboxDataArray";
        XmlElementNames.Email = "Email";
        XmlElementNames.AttendeeType = "AttendeeType";
        XmlElementNames.ExcludeConflicts = "ExcludeConflicts";
        XmlElementNames.FreeBusyViewOptions = "FreeBusyViewOptions";
        XmlElementNames.SuggestionsViewOptions = "SuggestionsViewOptions";
        XmlElementNames.FreeBusyView = "FreeBusyView";
        XmlElementNames.TimeWindow = "TimeWindow";
        XmlElementNames.MergedFreeBusyIntervalInMinutes = "MergedFreeBusyIntervalInMinutes";
        XmlElementNames.RequestedView = "RequestedView";
        XmlElementNames.FreeBusyViewType = "FreeBusyViewType";
        XmlElementNames.CalendarEventArray = "CalendarEventArray";
        XmlElementNames.CalendarEvent = "CalendarEvent";
        XmlElementNames.BusyType = "BusyType";
        XmlElementNames.MergedFreeBusy = "MergedFreeBusy";
        XmlElementNames.WorkingHours = "WorkingHours";
        XmlElementNames.WorkingPeriodArray = "WorkingPeriodArray";
        XmlElementNames.WorkingPeriod = "WorkingPeriod";
        XmlElementNames.StartTimeInMinutes = "StartTimeInMinutes";
        XmlElementNames.EndTimeInMinutes = "EndTimeInMinutes";
        XmlElementNames.GoodThreshold = "GoodThreshold";
        XmlElementNames.MaximumResultsByDay = "MaximumResultsByDay";
        XmlElementNames.MaximumNonWorkHourResultsByDay = "MaximumNonWorkHourResultsByDay";
        XmlElementNames.MeetingDurationInMinutes = "MeetingDurationInMinutes";
        XmlElementNames.MinimumSuggestionQuality = "MinimumSuggestionQuality";
        XmlElementNames.DetailedSuggestionsWindow = "DetailedSuggestionsWindow";
        XmlElementNames.CurrentMeetingTime = "CurrentMeetingTime";
        XmlElementNames.GlobalObjectId = "GlobalObjectId";
        XmlElementNames.SuggestionDayResultArray = "SuggestionDayResultArray";
        XmlElementNames.SuggestionDayResult = "SuggestionDayResult";
        XmlElementNames.Date = "Date";
        XmlElementNames.DayQuality = "DayQuality";
        XmlElementNames.SuggestionArray = "SuggestionArray";
        XmlElementNames.Suggestion = "Suggestion";
        XmlElementNames.MeetingTime = "MeetingTime";
        XmlElementNames.IsWorkTime = "IsWorkTime";
        XmlElementNames.SuggestionQuality = "SuggestionQuality";
        XmlElementNames.AttendeeConflictDataArray = "AttendeeConflictDataArray";
        XmlElementNames.UnknownAttendeeConflictData = "UnknownAttendeeConflictData";
        XmlElementNames.TooBigGroupAttendeeConflictData = "TooBigGroupAttendeeConflictData";
        XmlElementNames.IndividualAttendeeConflictData = "IndividualAttendeeConflictData";
        XmlElementNames.GroupAttendeeConflictData = "GroupAttendeeConflictData";
        XmlElementNames.NumberOfMembers = "NumberOfMembers";
        XmlElementNames.NumberOfMembersAvailable = "NumberOfMembersAvailable";
        XmlElementNames.NumberOfMembersWithConflict = "NumberOfMembersWithConflict";
        XmlElementNames.NumberOfMembersWithNoData = "NumberOfMembersWithNoData";
        XmlElementNames.SourceIds = "SourceIds";
        XmlElementNames.AlternateId = "AlternateId";
        XmlElementNames.AlternatePublicFolderId = "AlternatePublicFolderId";
        XmlElementNames.AlternatePublicFolderItemId = "AlternatePublicFolderItemId";
        XmlElementNames.DelegatePermissions = "DelegatePermissions";
        XmlElementNames.ReceiveCopiesOfMeetingMessages = "ReceiveCopiesOfMeetingMessages";
        XmlElementNames.ViewPrivateItems = "ViewPrivateItems";
        XmlElementNames.CalendarFolderPermissionLevel = "CalendarFolderPermissionLevel";
        XmlElementNames.TasksFolderPermissionLevel = "TasksFolderPermissionLevel";
        XmlElementNames.InboxFolderPermissionLevel = "InboxFolderPermissionLevel";
        XmlElementNames.ContactsFolderPermissionLevel = "ContactsFolderPermissionLevel";
        XmlElementNames.NotesFolderPermissionLevel = "NotesFolderPermissionLevel";
        XmlElementNames.JournalFolderPermissionLevel = "JournalFolderPermissionLevel";
        XmlElementNames.DelegateUser = "DelegateUser";
        XmlElementNames.DelegateUsers = "DelegateUsers";
        XmlElementNames.DeliverMeetingRequests = "DeliverMeetingRequests";
        XmlElementNames.MessageXml = "MessageXml";
        XmlElementNames.UserConfiguration = "UserConfiguration";
        XmlElementNames.UserConfigurationName = "UserConfigurationName";
        XmlElementNames.UserConfigurationProperties = "UserConfigurationProperties";
        XmlElementNames.Dictionary = "Dictionary";
        XmlElementNames.DictionaryEntry = "DictionaryEntry";
        XmlElementNames.DictionaryKey = "DictionaryKey";
        XmlElementNames.DictionaryValue = "DictionaryValue";
        XmlElementNames.XmlData = "XmlData";
        XmlElementNames.BinaryData = "BinaryData";
        XmlElementNames.FilterHtmlContent = "FilterHtmlContent";
        XmlElementNames.ConvertHtmlCodePageToUTF8 = "ConvertHtmlCodePageToUTF8";
        XmlElementNames.UnknownEntries = "UnknownEntries";
        XmlElementNames.UnknownEntry = "UnknownEntry";
        XmlElementNames.PasswordExpirationDate = "PasswordExpirationDate";
        XmlElementNames.Flag = "Flag";
        XmlElementNames.PersonaPostalAddress = "PostalAddress";
        XmlElementNames.PostalAddressType = "Type";
        XmlElementNames.EnhancedLocation = "EnhancedLocation";
        XmlElementNames.LocationDisplayName = "DisplayName";
        XmlElementNames.LocationAnnotation = "Annotation";
        XmlElementNames.LocationSource = "LocationSource";
        XmlElementNames.LocationUri = "LocationUri";
        XmlElementNames.Latitude = "Latitude";
        XmlElementNames.Longitude = "Longitude";
        XmlElementNames.Accuracy = "Accuracy";
        XmlElementNames.Altitude = "Altitude";
        XmlElementNames.AltitudeAccuracy = "AltitudeAccuracy";
        XmlElementNames.FormattedAddress = "FormattedAddress";
        XmlElementNames.Guid = "Guid";
        XmlElementNames.PhoneCallId = "PhoneCallId";
        XmlElementNames.DialString = "DialString";
        XmlElementNames.PhoneCallInformation = "PhoneCallInformation";
        XmlElementNames.PhoneCallState = "PhoneCallState";
        XmlElementNames.ConnectionFailureCause = "ConnectionFailureCause";
        XmlElementNames.SIPResponseCode = "SIPResponseCode";
        XmlElementNames.SIPResponseText = "SIPResponseText";
        XmlElementNames.WebClientReadFormQueryString = "WebClientReadFormQueryString";
        XmlElementNames.WebClientEditFormQueryString = "WebClientEditFormQueryString";
        XmlElementNames.Ids = "Ids";
        XmlElementNames.Id = "Id";
        XmlElementNames.TimeZoneDefinitions = "TimeZoneDefinitions";
        XmlElementNames.TimeZoneDefinition = "TimeZoneDefinition";
        XmlElementNames.Periods = "Periods";
        XmlElementNames.Period = "Period";
        XmlElementNames.TransitionsGroups = "TransitionsGroups";
        XmlElementNames.TransitionsGroup = "TransitionsGroup";
        XmlElementNames.Transitions = "Transitions";
        XmlElementNames.Transition = "Transition";
        XmlElementNames.AbsoluteDateTransition = "AbsoluteDateTransition";
        XmlElementNames.RecurringDayTransition = "RecurringDayTransition";
        XmlElementNames.RecurringDateTransition = "RecurringDateTransition";
        XmlElementNames.DateTime = "DateTime";
        XmlElementNames.TimeOffset = "TimeOffset";
        XmlElementNames.Day = "Day";
        XmlElementNames.TimeZoneContext = "TimeZoneContext";
        XmlElementNames.StartTimeZone = "StartTimeZone";
        XmlElementNames.EndTimeZone = "EndTimeZone";
        XmlElementNames.ReceivedBy = "ReceivedBy";
        XmlElementNames.ReceivedRepresenting = "ReceivedRepresenting";
        XmlElementNames.Uid = "UID";
        XmlElementNames.RecurrenceId = "RecurrenceId";
        XmlElementNames.DateTimeStamp = "DateTimeStamp";
        XmlElementNames.IsInline = "IsInline";
        XmlElementNames.IsContactPhoto = "IsContactPhoto";
        XmlElementNames.QueryString = "QueryString";
        XmlElementNames.HighlightTerms = "HighlightTerms";
        XmlElementNames.HighlightTerm = "Term";
        XmlElementNames.HighlightTermScope = "Scope";
        XmlElementNames.HighlightTermValue = "Value";
        XmlElementNames.CalendarEventDetails = "CalendarEventDetails";
        XmlElementNames.ID = "ID";
        XmlElementNames.IsException = "IsException";
        XmlElementNames.IsReminderSet = "IsReminderSet";
        XmlElementNames.IsPrivate = "IsPrivate";
        XmlElementNames.FirstDayOfWeek = "FirstDayOfWeek";
        XmlElementNames.Verb = "Verb";
        XmlElementNames.Parameter = "Parameter";
        XmlElementNames.ReturnValue = "ReturnValue";
        XmlElementNames.ReturnNewItemIds = "ReturnNewItemIds";
        XmlElementNames.DateTimePrecision = "DateTimePrecision";
        XmlElementNames.ConvertInlineImagesToDataUrls = "ConvertInlineImagesToDataUrls";
        XmlElementNames.InlineImageUrlTemplate = "InlineImageUrlTemplate";
        XmlElementNames.BlockExternalImages = "BlockExternalImages";
        XmlElementNames.AddBlankTargetToLinks = "AddBlankTargetToLinks";
        XmlElementNames.MaximumBodySize = "MaximumBodySize";
        XmlElementNames.StoreEntryId = "StoreEntryId";
        XmlElementNames.InstanceKey = "InstanceKey";
        XmlElementNames.NormalizedBody = "NormalizedBody";
        XmlElementNames.PolicyTag = "PolicyTag";
        XmlElementNames.ArchiveTag = "ArchiveTag";
        XmlElementNames.RetentionDate = "RetentionDate";
        XmlElementNames.DisableReason = "DisableReason";
        XmlElementNames.AppMarketplaceUrl = "AppMarketplaceUrl";
        XmlElementNames.TextBody = "TextBody";
        XmlElementNames.IconIndex = "IconIndex";
        XmlElementNames.GlobalIconIndex = "GlobalIconIndex";
        XmlElementNames.DraftItemIds = "DraftItemIds";
        XmlElementNames.HasIrm = "HasIrm";
        XmlElementNames.GlobalHasIrm = "GlobalHasIrm";
        XmlElementNames.ApprovalRequestData = "ApprovalRequestData";
        XmlElementNames.IsUndecidedApprovalRequest = "IsUndecidedApprovalRequest";
        XmlElementNames.ApprovalDecision = "ApprovalDecision";
        XmlElementNames.ApprovalDecisionMaker = "ApprovalDecisionMaker";
        XmlElementNames.ApprovalDecisionTime = "ApprovalDecisionTime";
        XmlElementNames.VotingOptionData = "VotingOptionData";
        XmlElementNames.VotingOptionDisplayName = "DisplayName";
        XmlElementNames.SendPrompt = "SendPrompt";
        XmlElementNames.VotingInformation = "VotingInformation";
        XmlElementNames.UserOptions = "UserOptions";
        XmlElementNames.VotingResponse = "VotingResponse";
        XmlElementNames.NlgEntityExtractionResult = "EntityExtractionResult";
        XmlElementNames.NlgAddresses = "Addresses";
        XmlElementNames.NlgAddress = "Address";
        XmlElementNames.NlgMeetingSuggestions = "MeetingSuggestions";
        XmlElementNames.NlgMeetingSuggestion = "MeetingSuggestion";
        XmlElementNames.NlgTaskSuggestions = "TaskSuggestions";
        XmlElementNames.NlgTaskSuggestion = "TaskSuggestion";
        XmlElementNames.NlgBusinessName = "BusinessName";
        XmlElementNames.NlgPeopleName = "PeopleName";
        XmlElementNames.NlgEmailAddresses = "EmailAddresses";
        XmlElementNames.NlgEmailAddress = "EmailAddress";
        XmlElementNames.NlgEmailPosition = "Position";
        XmlElementNames.NlgContacts = "Contacts";
        XmlElementNames.NlgContact = "Contact";
        XmlElementNames.NlgContactString = "ContactString";
        XmlElementNames.NlgUrls = "Urls";
        XmlElementNames.NlgUrl = "Url";
        XmlElementNames.NlgPhoneNumbers = "PhoneNumbers";
        XmlElementNames.NlgPhone = "Phone";
        XmlElementNames.NlgAttendees = "Attendees";
        XmlElementNames.NlgEmailUser = "EmailUser";
        XmlElementNames.NlgLocation = "Location";
        XmlElementNames.NlgSubject = "Subject";
        XmlElementNames.NlgMeetingString = "MeetingString";
        XmlElementNames.NlgStartTime = "StartTime";
        XmlElementNames.NlgEndTime = "EndTime";
        XmlElementNames.NlgTaskString = "TaskString";
        XmlElementNames.NlgAssignees = "Assignees";
        XmlElementNames.NlgPersonName = "PersonName";
        XmlElementNames.NlgOriginalPhoneString = "OriginalPhoneString";
        XmlElementNames.NlgPhoneString = "PhoneString";
        XmlElementNames.NlgType = "Type";
        XmlElementNames.NlgName = "Name";
        XmlElementNames.NlgUserId = "UserId";
        XmlElementNames.GetClientAccessToken = "GetClientAccessToken";
        XmlElementNames.GetClientAccessTokenResponse = "GetClientAccessTokenResponse";
        XmlElementNames.GetClientAccessTokenResponseMessage = "GetClientAccessTokenResponseMessage";
        XmlElementNames.TokenRequests = "TokenRequests";
        XmlElementNames.TokenRequest = "TokenRequest";
        XmlElementNames.TokenType = "TokenType";
        XmlElementNames.TokenValue = "TokenValue";
        XmlElementNames.TTL = "TTL";
        XmlElementNames.Tokens = "Tokens";
        XmlElementNames.MarkAsJunk = "MarkAsJunk";
        XmlElementNames.MarkAsJunkResponse = "MarkAsJunkResponse";
        XmlElementNames.MarkAsJunkResponseMessage = "MarkAsJunkResponseMessage";
        XmlElementNames.MovedItemId = "MovedItemId";
        XmlElementNames.Conversations = "Conversations";
        XmlElementNames.Conversation = "Conversation";
        XmlElementNames.UniqueRecipients = "UniqueRecipients";
        XmlElementNames.GlobalUniqueRecipients = "GlobalUniqueRecipients";
        XmlElementNames.UniqueUnreadSenders = "UniqueUnreadSenders";
        XmlElementNames.GlobalUniqueUnreadSenders = "GlobalUniqueUnreadSenders";
        XmlElementNames.UniqueSenders = "UniqueSenders";
        XmlElementNames.GlobalUniqueSenders = "GlobalUniqueSenders";
        XmlElementNames.LastDeliveryTime = "LastDeliveryTime";
        XmlElementNames.GlobalLastDeliveryTime = "GlobalLastDeliveryTime";
        XmlElementNames.GlobalCategories = "GlobalCategories";
        XmlElementNames.FlagStatus = "FlagStatus";
        XmlElementNames.GlobalFlagStatus = "GlobalFlagStatus";
        XmlElementNames.GlobalHasAttachments = "GlobalHasAttachments";
        XmlElementNames.MessageCount = "MessageCount";
        XmlElementNames.GlobalMessageCount = "GlobalMessageCount";
        XmlElementNames.GlobalUnreadCount = "GlobalUnreadCount";
        XmlElementNames.GlobalSize = "GlobalSize";
        XmlElementNames.ItemClasses = "ItemClasses";
        XmlElementNames.GlobalItemClasses = "GlobalItemClasses";
        XmlElementNames.GlobalImportance = "GlobalImportance";
        XmlElementNames.GlobalInferredImportance = "GlobalInferredImportance";
        XmlElementNames.GlobalItemIds = "GlobalItemIds";
        XmlElementNames.ChangeType = "ChangeType";
        XmlElementNames.ReadFlag = "ReadFlag";
        XmlElementNames.TotalConversationsInView = "TotalConversationsInView";
        XmlElementNames.IndexedOffset = "IndexedOffset";
        XmlElementNames.ConversationShape = "ConversationShape";
        XmlElementNames.MailboxScope = "MailboxScope";
        XmlElementNames.ApplyConversationAction = "ApplyConversationAction";
        XmlElementNames.ConversationActions = "ConversationActions";
        XmlElementNames.ConversationAction = "ConversationAction";
        XmlElementNames.ApplyConversationActionResponse = "ApplyConversationActionResponse";
        XmlElementNames.ApplyConversationActionResponseMessage = "ApplyConversationActionResponseMessage";
        XmlElementNames.EnableAlwaysDelete = "EnableAlwaysDelete";
        XmlElementNames.ProcessRightAway = "ProcessRightAway";
        XmlElementNames.DestinationFolderId = "DestinationFolderId";
        XmlElementNames.ContextFolderId = "ContextFolderId";
        XmlElementNames.ConversationLastSyncTime = "ConversationLastSyncTime";
        XmlElementNames.AlwaysCategorize = "AlwaysCategorize";
        XmlElementNames.AlwaysDelete = "AlwaysDelete";
        XmlElementNames.AlwaysMove = "AlwaysMove";
        XmlElementNames.Move = "Move";
        XmlElementNames.Copy = "Copy";
        XmlElementNames.SetReadState = "SetReadState";
        XmlElementNames.SetRetentionPolicy = "SetRetentionPolicy";
        XmlElementNames.DeleteType = "DeleteType";
        XmlElementNames.RetentionPolicyType = "RetentionPolicyType";
        XmlElementNames.RetentionPolicyTagId = "RetentionPolicyTagId";
        XmlElementNames.FoldersToIgnore = "FoldersToIgnore";
        XmlElementNames.ParentInternetMessageId = "ParentInternetMessageId";
        XmlElementNames.ConversationNode = "ConversationNode";
        XmlElementNames.ConversationNodes = "ConversationNodes";
        XmlElementNames.MaxItemsToReturn = "MaxItemsToReturn";
        XmlElementNames.SetTeamMailbox = "SetTeamMailbox";
        XmlElementNames.SetTeamMailboxResponse = "SetTeamMailboxResponse";
        XmlElementNames.UnpinTeamMailbox = "UnpinTeamMailbox";
        XmlElementNames.UnpinTeamMailboxResponse = "UnpinTeamMailboxResponse";
        XmlElementNames.RoomLists = "RoomLists";
        XmlElementNames.Rooms = "Rooms";
        XmlElementNames.Room = "Room";
        XmlElementNames.RoomList = "RoomList";
        XmlElementNames.RoomId = "Id";
        XmlElementNames.Autodiscover = "Autodiscover";
        XmlElementNames.BinarySecret = "BinarySecret";
        XmlElementNames.Response = "Response";
        XmlElementNames.User = "User";
        XmlElementNames.LegacyDN = "LegacyDN";
        XmlElementNames.DeploymentId = "DeploymentId";
        XmlElementNames.Account = "Account";
        XmlElementNames.AccountType = "AccountType";
        XmlElementNames.Action = "Action";
        XmlElementNames.To = "To";
        XmlElementNames.RedirectAddr = "RedirectAddr";
        XmlElementNames.RedirectUrl = "RedirectUrl";
        XmlElementNames.Protocol = "Protocol";
        XmlElementNames.Type = "Type";
        XmlElementNames.Server = "Server";
        XmlElementNames.OwnerSmtpAddress = "OwnerSmtpAddress";
        XmlElementNames.ServerDN = "ServerDN";
        XmlElementNames.ServerVersion = "ServerVersion";
        XmlElementNames.ServerVersionInfo = "ServerVersionInfo";
        XmlElementNames.AD = "AD";
        XmlElementNames.AuthPackage = "AuthPackage";
        XmlElementNames.MdbDN = "MdbDN";
        XmlElementNames.EWSUrl = "EwsUrl";
        XmlElementNames.EwsPartnerUrl = "EwsPartnerUrl";
        XmlElementNames.EmwsUrl = "EmwsUrl";
        XmlElementNames.ASUrl = "ASUrl";
        XmlElementNames.OOFUrl = "OOFUrl";
        XmlElementNames.UMUrl = "UMUrl";
        XmlElementNames.OABUrl = "OABUrl";
        XmlElementNames.Internal = "Internal";
        XmlElementNames.External = "External";
        XmlElementNames.OWAUrl = "OWAUrl";
        XmlElementNames.Error = "Error";
        XmlElementNames.ErrorCode = "ErrorCode";
        XmlElementNames.DebugData = "DebugData";
        XmlElementNames.Users = "Users";
        XmlElementNames.RequestedSettings = "RequestedSettings";
        XmlElementNames.Setting = "Setting";
        XmlElementNames.GetUserSettingsRequestMessage = "GetUserSettingsRequestMessage";
        XmlElementNames.RequestedServerVersion = "RequestedServerVersion";
        XmlElementNames.Request = "Request";
        XmlElementNames.RedirectTarget = "RedirectTarget";
        XmlElementNames.UserSettings = "UserSettings";
        XmlElementNames.UserSettingErrors = "UserSettingErrors";
        XmlElementNames.GetUserSettingsResponseMessage = "GetUserSettingsResponseMessage";
        XmlElementNames.ErrorMessage = "ErrorMessage";
        XmlElementNames.UserResponse = "UserResponse";
        XmlElementNames.UserResponses = "UserResponses";
        XmlElementNames.UserSettingError = "UserSettingError";
        XmlElementNames.Domain = "Domain";
        XmlElementNames.Domains = "Domains";
        XmlElementNames.DomainResponse = "DomainResponse";
        XmlElementNames.DomainResponses = "DomainResponses";
        XmlElementNames.DomainSetting = "DomainSetting";
        XmlElementNames.DomainSettings = "DomainSettings";
        XmlElementNames.DomainStringSetting = "DomainStringSetting";
        XmlElementNames.DomainSettingError = "DomainSettingError";
        XmlElementNames.DomainSettingErrors = "DomainSettingErrors";
        XmlElementNames.GetDomainSettingsRequestMessage = "GetDomainSettingsRequestMessage";
        XmlElementNames.GetDomainSettingsResponseMessage = "GetDomainSettingsResponseMessage";
        XmlElementNames.SettingName = "SettingName";
        XmlElementNames.UserSetting = "UserSetting";
        XmlElementNames.StringSetting = "StringSetting";
        XmlElementNames.WebClientUrlCollectionSetting = "WebClientUrlCollectionSetting";
        XmlElementNames.WebClientUrls = "WebClientUrls";
        XmlElementNames.WebClientUrl = "WebClientUrl";
        XmlElementNames.AuthenticationMethods = "AuthenticationMethods";
        XmlElementNames.Url = "Url";
        XmlElementNames.AlternateMailboxCollectionSetting = "AlternateMailboxCollectionSetting";
        XmlElementNames.AlternateMailboxes = "AlternateMailboxes";
        XmlElementNames.AlternateMailbox = "AlternateMailbox";
        XmlElementNames.ProtocolConnectionCollectionSetting = "ProtocolConnectionCollectionSetting";
        XmlElementNames.ProtocolConnections = "ProtocolConnections";
        XmlElementNames.ProtocolConnection = "ProtocolConnection";
        XmlElementNames.DocumentSharingLocationCollectionSetting = "DocumentSharingLocationCollectionSetting";
        XmlElementNames.DocumentSharingLocations = "DocumentSharingLocations";
        XmlElementNames.DocumentSharingLocation = "DocumentSharingLocation";
        XmlElementNames.ServiceUrl = "ServiceUrl";
        XmlElementNames.LocationUrl = "LocationUrl";
        XmlElementNames.SupportedFileExtensions = "SupportedFileExtensions";
        XmlElementNames.FileExtension = "FileExtension";
        XmlElementNames.ExternalAccessAllowed = "ExternalAccessAllowed";
        XmlElementNames.AnonymousAccessAllowed = "AnonymousAccessAllowed";
        XmlElementNames.CanModifyPermissions = "CanModifyPermissions";
        XmlElementNames.IsDefault = "IsDefault";
        XmlElementNames.EncryptionMethod = "EncryptionMethod";
        XmlElementNames.Hostname = "Hostname";
        XmlElementNames.Port = "Port";
        XmlElementNames.Version = "Version";
        XmlElementNames.MajorVersion = "MajorVersion";
        XmlElementNames.MinorVersion = "MinorVersion";
        XmlElementNames.MajorBuildNumber = "MajorBuildNumber";
        XmlElementNames.MinorBuildNumber = "MinorBuildNumber";
        XmlElementNames.RequestedVersion = "RequestedVersion";
        XmlElementNames.PublicFolderServer = "PublicFolderServer";
        XmlElementNames.Ssl = "SSL";
        XmlElementNames.SharingUrl = "SharingUrl";
        XmlElementNames.EcpUrl = "EcpUrl";
        XmlElementNames.EcpUrl_um = "EcpUrl-um";
        XmlElementNames.EcpUrl_aggr = "EcpUrl-aggr";
        XmlElementNames.EcpUrl_sms = "EcpUrl-sms";
        XmlElementNames.EcpUrl_mt = "EcpUrl-mt";
        XmlElementNames.EcpUrl_ret = "EcpUrl-ret";
        XmlElementNames.EcpUrl_publish = "EcpUrl-publish";
        XmlElementNames.EcpUrl_photo = "EcpUrl-photo";
        XmlElementNames.ExchangeRpcUrl = "ExchangeRpcUrl";
        XmlElementNames.EcpUrl_connect = "EcpUrl-connect";
        XmlElementNames.EcpUrl_tm = "EcpUrl-tm";
        XmlElementNames.EcpUrl_tmCreating = "EcpUrl-tmCreating";
        XmlElementNames.EcpUrl_tmEditing = "EcpUrl-tmEditing";
        XmlElementNames.EcpUrl_tmHiding = "EcpUrl-tmHiding";
        XmlElementNames.SiteMailboxCreationURL = "SiteMailboxCreationURL";
        XmlElementNames.EcpUrl_extinstall = "EcpUrl-extinstall";
        XmlElementNames.PartnerToken = "PartnerToken";
        XmlElementNames.PartnerTokenReference = "PartnerTokenReference";
        XmlElementNames.ServerExclusiveConnect = "ServerExclusiveConnect";
        XmlElementNames.AutoDiscoverSMTPAddress = "AutoDiscoverSMTPAddress";
        XmlElementNames.CertPrincipalName = "CertPrincipalName";
        XmlElementNames.GroupingInformation = "GroupingInformation";
        XmlElementNames.MailboxSmtpAddress = "MailboxSmtpAddress";
        XmlElementNames.RuleId = "RuleId";
        XmlElementNames.Priority = "Priority";
        XmlElementNames.IsEnabled = "IsEnabled";
        XmlElementNames.IsNotSupported = "IsNotSupported";
        XmlElementNames.IsInError = "IsInError";
        XmlElementNames.Conditions = "Conditions";
        XmlElementNames.Exceptions = "Exceptions";
        XmlElementNames.Actions = "Actions";
        XmlElementNames.InboxRules = "InboxRules";
        XmlElementNames.Rule = "Rule";
        XmlElementNames.OutlookRuleBlobExists = "OutlookRuleBlobExists";
        XmlElementNames.RemoveOutlookRuleBlob = "RemoveOutlookRuleBlob";
        XmlElementNames.ContainsBodyStrings = "ContainsBodyStrings";
        XmlElementNames.ContainsHeaderStrings = "ContainsHeaderStrings";
        XmlElementNames.ContainsRecipientStrings = "ContainsRecipientStrings";
        XmlElementNames.ContainsSenderStrings = "ContainsSenderStrings";
        XmlElementNames.ContainsSubjectOrBodyStrings = "ContainsSubjectOrBodyStrings";
        XmlElementNames.ContainsSubjectStrings = "ContainsSubjectStrings";
        XmlElementNames.FlaggedForAction = "FlaggedForAction";
        XmlElementNames.FromAddresses = "FromAddresses";
        XmlElementNames.FromConnectedAccounts = "FromConnectedAccounts";
        XmlElementNames.IsApprovalRequest = "IsApprovalRequest";
        XmlElementNames.IsAutomaticForward = "IsAutomaticForward";
        XmlElementNames.IsAutomaticReply = "IsAutomaticReply";
        XmlElementNames.IsEncrypted = "IsEncrypted";
        XmlElementNames.IsMeetingRequest = "IsMeetingRequest";
        XmlElementNames.IsMeetingResponse = "IsMeetingResponse";
        XmlElementNames.IsNDR = "IsNDR";
        XmlElementNames.IsPermissionControlled = "IsPermissionControlled";
        XmlElementNames.IsSigned = "IsSigned";
        XmlElementNames.IsVoicemail = "IsVoicemail";
        XmlElementNames.IsReadReceipt = "IsReadReceipt";
        XmlElementNames.MessageClassifications = "MessageClassifications";
        XmlElementNames.NotSentToMe = "NotSentToMe";
        XmlElementNames.SentCcMe = "SentCcMe";
        XmlElementNames.SentOnlyToMe = "SentOnlyToMe";
        XmlElementNames.SentToAddresses = "SentToAddresses";
        XmlElementNames.SentToMe = "SentToMe";
        XmlElementNames.SentToOrCcMe = "SentToOrCcMe";
        XmlElementNames.WithinDateRange = "WithinDateRange";
        XmlElementNames.WithinSizeRange = "WithinSizeRange";
        XmlElementNames.MinimumSize = "MinimumSize";
        XmlElementNames.MaximumSize = "MaximumSize";
        XmlElementNames.StartDateTime = "StartDateTime";
        XmlElementNames.EndDateTime = "EndDateTime";
        XmlElementNames.AssignCategories = "AssignCategories";
        XmlElementNames.CopyToFolder = "CopyToFolder";
        XmlElementNames.FlagMessage = "FlagMessage";
        XmlElementNames.ForwardAsAttachmentToRecipients = "ForwardAsAttachmentToRecipients";
        XmlElementNames.ForwardToRecipients = "ForwardToRecipients";
        XmlElementNames.MarkImportance = "MarkImportance";
        XmlElementNames.MarkAsRead = "MarkAsRead";
        XmlElementNames.MoveToFolder = "MoveToFolder";
        XmlElementNames.PermanentDelete = "PermanentDelete";
        XmlElementNames.RedirectToRecipients = "RedirectToRecipients";
        XmlElementNames.SendSMSAlertToRecipients = "SendSMSAlertToRecipients";
        XmlElementNames.ServerReplyWithMessage = "ServerReplyWithMessage";
        XmlElementNames.StopProcessingRules = "StopProcessingRules";
        XmlElementNames.CreateRuleOperation = "CreateRuleOperation";
        XmlElementNames.SetRuleOperation = "SetRuleOperation";
        XmlElementNames.DeleteRuleOperation = "DeleteRuleOperation";
        XmlElementNames.Operations = "Operations";
        XmlElementNames.RuleOperationErrors = "RuleOperationErrors";
        XmlElementNames.RuleOperationError = "RuleOperationError";
        XmlElementNames.OperationIndex = "OperationIndex";
        XmlElementNames.ValidationErrors = "ValidationErrors";
        XmlElementNames.FieldValue = "FieldValue";
        XmlElementNames.Not = "Not";
        XmlElementNames.Bitmask = "Bitmask";
        XmlElementNames.Constant = "Constant";
        XmlElementNames.Restriction = "Restriction";
        XmlElementNames.Condition = "Condition";
        XmlElementNames.Contains = "Contains";
        XmlElementNames.Excludes = "Excludes";
        XmlElementNames.Exists = "Exists";
        XmlElementNames.FieldURIOrConstant = "FieldURIOrConstant";
        XmlElementNames.And = "And";
        XmlElementNames.Or = "Or";
        XmlElementNames.IsEqualTo = "IsEqualTo";
        XmlElementNames.IsNotEqualTo = "IsNotEqualTo";
        XmlElementNames.IsGreaterThan = "IsGreaterThan";
        XmlElementNames.IsGreaterThanOrEqualTo = "IsGreaterThanOrEqualTo";
        XmlElementNames.IsLessThan = "IsLessThan";
        XmlElementNames.IsLessThanOrEqualTo = "IsLessThanOrEqualTo";
        XmlElementNames.PhoneticFullName = "PhoneticFullName";
        XmlElementNames.PhoneticFirstName = "PhoneticFirstName";
        XmlElementNames.PhoneticLastName = "PhoneticLastName";
        XmlElementNames.Alias = "Alias";
        XmlElementNames.Notes = "Notes";
        XmlElementNames.Photo = "Photo";
        XmlElementNames.UserSMIMECertificate = "UserSMIMECertificate";
        XmlElementNames.MSExchangeCertificate = "MSExchangeCertificate";
        XmlElementNames.DirectoryId = "DirectoryId";
        XmlElementNames.ManagerMailbox = "ManagerMailbox";
        XmlElementNames.DirectReports = "DirectReports";
        XmlElementNames.ResponseMessage = "ResponseMessage";
        XmlElementNames.ResponseMessages = "ResponseMessages";
        XmlElementNames.FindConversation = "FindConversation";
        XmlElementNames.FindConversationResponse = "FindConversationResponse";
        XmlElementNames.FindConversationResponseMessage = "FindConversationResponseMessage";
        XmlElementNames.GetConversationItems = "GetConversationItems";
        XmlElementNames.GetConversationItemsResponse = "GetConversationItemsResponse";
        XmlElementNames.GetConversationItemsResponseMessage = "GetConversationItemsResponseMessage";
        XmlElementNames.FindItem = "FindItem";
        XmlElementNames.FindItemResponse = "FindItemResponse";
        XmlElementNames.FindItemResponseMessage = "FindItemResponseMessage";
        XmlElementNames.GetItem = "GetItem";
        XmlElementNames.GetItemResponse = "GetItemResponse";
        XmlElementNames.GetItemResponseMessage = "GetItemResponseMessage";
        XmlElementNames.CreateItem = "CreateItem";
        XmlElementNames.CreateItemResponse = "CreateItemResponse";
        XmlElementNames.CreateItemResponseMessage = "CreateItemResponseMessage";
        XmlElementNames.SendItem = "SendItem";
        XmlElementNames.SendItemResponse = "SendItemResponse";
        XmlElementNames.SendItemResponseMessage = "SendItemResponseMessage";
        XmlElementNames.DeleteItem = "DeleteItem";
        XmlElementNames.DeleteItemResponse = "DeleteItemResponse";
        XmlElementNames.DeleteItemResponseMessage = "DeleteItemResponseMessage";
        XmlElementNames.UpdateItem = "UpdateItem";
        XmlElementNames.UpdateItemResponse = "UpdateItemResponse";
        XmlElementNames.UpdateItemResponseMessage = "UpdateItemResponseMessage";
        XmlElementNames.CopyItem = "CopyItem";
        XmlElementNames.CopyItemResponse = "CopyItemResponse";
        XmlElementNames.CopyItemResponseMessage = "CopyItemResponseMessage";
        XmlElementNames.MoveItem = "MoveItem";
        XmlElementNames.MoveItemResponse = "MoveItemResponse";
        XmlElementNames.MoveItemResponseMessage = "MoveItemResponseMessage";
        XmlElementNames.ArchiveItem = "ArchiveItem";
        XmlElementNames.ArchiveItemResponse = "ArchiveItemResponse";
        XmlElementNames.ArchiveItemResponseMessage = "ArchiveItemResponseMessage";
        XmlElementNames.ArchiveSourceFolderId = "ArchiveSourceFolderId";
        XmlElementNames.FindFolder = "FindFolder";
        XmlElementNames.FindFolderResponse = "FindFolderResponse";
        XmlElementNames.FindFolderResponseMessage = "FindFolderResponseMessage";
        XmlElementNames.GetFolder = "GetFolder";
        XmlElementNames.GetFolderResponse = "GetFolderResponse";
        XmlElementNames.GetFolderResponseMessage = "GetFolderResponseMessage";
        XmlElementNames.CreateFolder = "CreateFolder";
        XmlElementNames.CreateFolderResponse = "CreateFolderResponse";
        XmlElementNames.CreateFolderResponseMessage = "CreateFolderResponseMessage";
        XmlElementNames.DeleteFolder = "DeleteFolder";
        XmlElementNames.DeleteFolderResponse = "DeleteFolderResponse";
        XmlElementNames.DeleteFolderResponseMessage = "DeleteFolderResponseMessage";
        XmlElementNames.EmptyFolder = "EmptyFolder";
        XmlElementNames.EmptyFolderResponse = "EmptyFolderResponse";
        XmlElementNames.EmptyFolderResponseMessage = "EmptyFolderResponseMessage";
        XmlElementNames.UpdateFolder = "UpdateFolder";
        XmlElementNames.UpdateFolderResponse = "UpdateFolderResponse";
        XmlElementNames.UpdateFolderResponseMessage = "UpdateFolderResponseMessage";
        XmlElementNames.CopyFolder = "CopyFolder";
        XmlElementNames.CopyFolderResponse = "CopyFolderResponse";
        XmlElementNames.CopyFolderResponseMessage = "CopyFolderResponseMessage";
        XmlElementNames.MoveFolder = "MoveFolder";
        XmlElementNames.MoveFolderResponse = "MoveFolderResponse";
        XmlElementNames.MoveFolderResponseMessage = "MoveFolderResponseMessage";
        XmlElementNames.MarkAllItemsAsRead = "MarkAllItemsAsRead";
        XmlElementNames.MarkAllItemsAsReadResponse = "MarkAllItemsAsReadResponse";
        XmlElementNames.MarkAllItemsAsReadResponseMessage = "MarkAllItemsAsReadResponseMessage";
        XmlElementNames.GetAttachment = "GetAttachment";
        XmlElementNames.GetAttachmentResponse = "GetAttachmentResponse";
        XmlElementNames.GetAttachmentResponseMessage = "GetAttachmentResponseMessage";
        XmlElementNames.CreateAttachment = "CreateAttachment";
        XmlElementNames.CreateAttachmentResponse = "CreateAttachmentResponse";
        XmlElementNames.CreateAttachmentResponseMessage = "CreateAttachmentResponseMessage";
        XmlElementNames.DeleteAttachment = "DeleteAttachment";
        XmlElementNames.DeleteAttachmentResponse = "DeleteAttachmentResponse";
        XmlElementNames.DeleteAttachmentResponseMessage = "DeleteAttachmentResponseMessage";
        XmlElementNames.ResolveNames = "ResolveNames";
        XmlElementNames.ResolveNamesResponse = "ResolveNamesResponse";
        XmlElementNames.ResolveNamesResponseMessage = "ResolveNamesResponseMessage";
        XmlElementNames.ExpandDL = "ExpandDL";
        XmlElementNames.ExpandDLResponse = "ExpandDLResponse";
        XmlElementNames.ExpandDLResponseMessage = "ExpandDLResponseMessage";
        XmlElementNames.Subscribe = "Subscribe";
        XmlElementNames.SubscribeResponse = "SubscribeResponse";
        XmlElementNames.SubscribeResponseMessage = "SubscribeResponseMessage";
        XmlElementNames.SubscriptionRequest = "SubscriptionRequest";
        XmlElementNames.Unsubscribe = "Unsubscribe";
        XmlElementNames.UnsubscribeResponse = "UnsubscribeResponse";
        XmlElementNames.UnsubscribeResponseMessage = "UnsubscribeResponseMessage";
        XmlElementNames.GetEvents = "GetEvents";
        XmlElementNames.GetEventsResponse = "GetEventsResponse";
        XmlElementNames.GetEventsResponseMessage = "GetEventsResponseMessage";
        XmlElementNames.GetStreamingEvents = "GetStreamingEvents";
        XmlElementNames.GetStreamingEventsResponse = "GetStreamingEventsResponse";
        XmlElementNames.GetStreamingEventsResponseMessage = "GetStreamingEventsResponseMessage";
        XmlElementNames.ConnectionStatus = "ConnectionStatus";
        XmlElementNames.ErrorSubscriptionIds = "ErrorSubscriptionIds";
        XmlElementNames.ConnectionTimeout = "ConnectionTimeout";
        XmlElementNames.HeartbeatFrequency = "HeartbeatFrequency";
        XmlElementNames.SyncFolderItems = "SyncFolderItems";
        XmlElementNames.SyncFolderItemsResponse = "SyncFolderItemsResponse";
        XmlElementNames.SyncFolderItemsResponseMessage = "SyncFolderItemsResponseMessage";
        XmlElementNames.SyncFolderHierarchy = "SyncFolderHierarchy";
        XmlElementNames.SyncFolderHierarchyResponse = "SyncFolderHierarchyResponse";
        XmlElementNames.SyncFolderHierarchyResponseMessage = "SyncFolderHierarchyResponseMessage";
        XmlElementNames.GetUserOofSettingsRequest = "GetUserOofSettingsRequest";
        XmlElementNames.GetUserOofSettingsResponse = "GetUserOofSettingsResponse";
        XmlElementNames.SetUserOofSettingsRequest = "SetUserOofSettingsRequest";
        XmlElementNames.SetUserOofSettingsResponse = "SetUserOofSettingsResponse";
        XmlElementNames.GetUserAvailabilityRequest = "GetUserAvailabilityRequest";
        XmlElementNames.GetUserAvailabilityResponse = "GetUserAvailabilityResponse";
        XmlElementNames.FreeBusyResponseArray = "FreeBusyResponseArray";
        XmlElementNames.FreeBusyResponse = "FreeBusyResponse";
        XmlElementNames.SuggestionsResponse = "SuggestionsResponse";
        XmlElementNames.GetRoomListsRequest = "GetRoomLists";
        XmlElementNames.GetRoomListsResponse = "GetRoomListsResponse";
        XmlElementNames.GetRoomsRequest = "GetRooms";
        XmlElementNames.GetRoomsResponse = "GetRoomsResponse";
        XmlElementNames.ConvertId = "ConvertId";
        XmlElementNames.ConvertIdResponse = "ConvertIdResponse";
        XmlElementNames.ConvertIdResponseMessage = "ConvertIdResponseMessage";
        XmlElementNames.AddDelegate = "AddDelegate";
        XmlElementNames.AddDelegateResponse = "AddDelegateResponse";
        XmlElementNames.DelegateUserResponseMessageType = "DelegateUserResponseMessageType";
        XmlElementNames.RemoveDelegate = "RemoveDelegate";
        XmlElementNames.RemoveDelegateResponse = "RemoveDelegateResponse";
        XmlElementNames.GetDelegate = "GetDelegate";
        XmlElementNames.GetDelegateResponse = "GetDelegateResponse";
        XmlElementNames.UpdateDelegate = "UpdateDelegate";
        XmlElementNames.UpdateDelegateResponse = "UpdateDelegateResponse";
        XmlElementNames.CreateUserConfiguration = "CreateUserConfiguration";
        XmlElementNames.CreateUserConfigurationResponse = "CreateUserConfigurationResponse";
        XmlElementNames.CreateUserConfigurationResponseMessage = "CreateUserConfigurationResponseMessage";
        XmlElementNames.DeleteUserConfiguration = "DeleteUserConfiguration";
        XmlElementNames.DeleteUserConfigurationResponse = "DeleteUserConfigurationResponse";
        XmlElementNames.DeleteUserConfigurationResponseMessage = "DeleteUserConfigurationResponseMessage";
        XmlElementNames.GetUserConfiguration = "GetUserConfiguration";
        XmlElementNames.GetUserConfigurationResponse = "GetUserConfigurationResponse";
        XmlElementNames.GetUserConfigurationResponseMessage = "GetUserConfigurationResponseMessage";
        XmlElementNames.UpdateUserConfiguration = "UpdateUserConfiguration";
        XmlElementNames.UpdateUserConfigurationResponse = "UpdateUserConfigurationResponse";
        XmlElementNames.UpdateUserConfigurationResponseMessage = "UpdateUserConfigurationResponseMessage";
        XmlElementNames.PlayOnPhone = "PlayOnPhone";
        XmlElementNames.PlayOnPhoneResponse = "PlayOnPhoneResponse";
        XmlElementNames.GetPhoneCall = "GetPhoneCallInformation";
        XmlElementNames.GetPhoneCallResponse = "GetPhoneCallInformationResponse";
        XmlElementNames.DisconnectPhoneCall = "DisconnectPhoneCall";
        XmlElementNames.DisconnectPhoneCallResponse = "DisconnectPhoneCallResponse";
        XmlElementNames.GetServerTimeZones = "GetServerTimeZones";
        XmlElementNames.GetServerTimeZonesResponse = "GetServerTimeZonesResponse";
        XmlElementNames.GetServerTimeZonesResponseMessage = "GetServerTimeZonesResponseMessage";
        XmlElementNames.GetInboxRules = "GetInboxRules";
        XmlElementNames.GetInboxRulesResponse = "GetInboxRulesResponse";
        XmlElementNames.UpdateInboxRules = "UpdateInboxRules";
        XmlElementNames.UpdateInboxRulesResponse = "UpdateInboxRulesResponse";
        XmlElementNames.ExecuteDiagnosticMethod = "ExecuteDiagnosticMethod";
        XmlElementNames.ExecuteDiagnosticMethodResponse = "ExecuteDiagnosticMethodResponse";
        XmlElementNames.ExecuteDiagnosticMethodResponseMEssage = "ExecuteDiagnosticMethodResponseMessage";
        XmlElementNames.GetPasswordExpirationDateRequest = "GetPasswordExpirationDate";
        XmlElementNames.GetPasswordExpirationDateResponse = "GetPasswordExpirationDateResponse";
        XmlElementNames.GetSearchableMailboxes = "GetSearchableMailboxes";
        XmlElementNames.GetSearchableMailboxesResponse = "GetSearchableMailboxesResponse";
        XmlElementNames.GetDiscoverySearchConfiguration = "GetDiscoverySearchConfiguration";
        XmlElementNames.GetDiscoverySearchConfigurationResponse = "GetDiscoverySearchConfigurationResponse";
        XmlElementNames.GetHoldOnMailboxes = "GetHoldOnMailboxes";
        XmlElementNames.GetHoldOnMailboxesResponse = "GetHoldOnMailboxesResponse";
        XmlElementNames.SetHoldOnMailboxes = "SetHoldOnMailboxes";
        XmlElementNames.SetHoldOnMailboxesResponse = "SetHoldOnMailboxesResponse";
        XmlElementNames.SearchMailboxes = "SearchMailboxes";
        XmlElementNames.SearchMailboxesResponse = "SearchMailboxesResponse";
        XmlElementNames.SearchMailboxesResponseMessage = "SearchMailboxesResponseMessage";
        XmlElementNames.GetNonIndexableItemDetails = "GetNonIndexableItemDetails";
        XmlElementNames.GetNonIndexableItemDetailsResponse = "GetNonIndexableItemDetailsResponse";
        XmlElementNames.GetNonIndexableItemStatistics = "GetNonIndexableItemStatistics";
        XmlElementNames.GetNonIndexableItemStatisticsResponse = "GetNonIndexableItemStatisticsResponse";
        XmlElementNames.SearchQueries = "SearchQueries";
        XmlElementNames.SearchQuery = "SearchQuery";
        XmlElementNames.MailboxQuery = "MailboxQuery";
        XmlElementNames.Query = "Query";
        XmlElementNames.MailboxSearchScopes = "MailboxSearchScopes";
        XmlElementNames.MailboxSearchScope = "MailboxSearchScope";
        XmlElementNames.SearchScope = "SearchScope";
        XmlElementNames.ResultType = "ResultType";
        XmlElementNames.SortBy = "SortBy";
        XmlElementNames.Order = "Order";
        XmlElementNames.Language = "Language";
        XmlElementNames.Deduplication = "Deduplication";
        XmlElementNames.PageSize = "PageSize";
        XmlElementNames.PageItemReference = "PageItemReference";
        XmlElementNames.PageDirection = "PageDirection";
        XmlElementNames.PreviewItemResponseShape = "PreviewItemResponseShape";
        XmlElementNames.ExtendedProperties = "ExtendedProperties";
        XmlElementNames.PageItemSize = "PageItemSize";
        XmlElementNames.PageItemCount = "PageItemCount";
        XmlElementNames.ItemCount = "ItemCount";
        XmlElementNames.KeywordStats = "KeywordStats";
        XmlElementNames.KeywordStat = "KeywordStat";
        XmlElementNames.Keyword = "Keyword";
        XmlElementNames.ItemHits = "ItemHits";
        XmlElementNames.SearchPreviewItem = "SearchPreviewItem";
        XmlElementNames.ChangeKey = "ChangeKey";
        XmlElementNames.ParentId = "ParentId";
        XmlElementNames.MailboxId = "MailboxId";
        XmlElementNames.UniqueHash = "UniqueHash";
        XmlElementNames.SortValue = "SortValue";
        XmlElementNames.OwaLink = "OwaLink";
        XmlElementNames.SmtpAddress = "SmtpAddress";
        XmlElementNames.CreatedTime = "CreatedTime";
        XmlElementNames.ReceivedTime = "ReceivedTime";
        XmlElementNames.SentTime = "SentTime";
        XmlElementNames.Preview = "Preview";
        XmlElementNames.HasAttachment = "HasAttachment";
        XmlElementNames.FailedMailboxes = "FailedMailboxes";
        XmlElementNames.FailedMailbox = "FailedMailbox";
        XmlElementNames.Token = "Token";
        XmlElementNames.Refiners = "Refiners";
        XmlElementNames.Refiner = "Refiner";
        XmlElementNames.MailboxStats = "MailboxStats";
        XmlElementNames.MailboxStat = "MailboxStat";
        XmlElementNames.HoldId = "HoldId";
        XmlElementNames.ActionType = "ActionType";
        XmlElementNames.Mailboxes = "Mailboxes";
        XmlElementNames.SearchFilter = "SearchFilter";
        XmlElementNames.ReferenceId = "ReferenceId";
        XmlElementNames.IsMembershipGroup = "IsMembershipGroup";
        XmlElementNames.ExpandGroupMembership = "ExpandGroupMembership";
        XmlElementNames.SearchableMailboxes = "SearchableMailboxes";
        XmlElementNames.SearchableMailbox = "SearchableMailbox";
        XmlElementNames.SearchMailboxesResult = "SearchMailboxesResult";
        XmlElementNames.MailboxHoldResult = "MailboxHoldResult";
        XmlElementNames.Statuses = "Statuses";
        XmlElementNames.MailboxHoldStatuses = "MailboxHoldStatuses";
        XmlElementNames.MailboxHoldStatus = "MailboxHoldStatus";
        XmlElementNames.AdditionalInfo = "AdditionalInfo";
        XmlElementNames.NonIndexableItemDetail = "NonIndexableItemDetail";
        XmlElementNames.NonIndexableItemStatistic = "NonIndexableItemStatistic";
        XmlElementNames.NonIndexableItemDetails = "NonIndexableItemDetails";
        XmlElementNames.NonIndexableItemStatistics = "NonIndexableItemStatistics";
        XmlElementNames.NonIndexableItemDetailsResult = "NonIndexableItemDetailsResult";
        XmlElementNames.SearchArchiveOnly = "SearchArchiveOnly";
        XmlElementNames.ErrorDescription = "ErrorDescription";
        XmlElementNames.IsPartiallyIndexed = "IsPartiallyIndexed";
        XmlElementNames.IsPermanentFailure = "IsPermanentFailure";
        XmlElementNames.AttemptCount = "AttemptCount";
        XmlElementNames.LastAttemptTime = "LastAttemptTime";
        XmlElementNames.SearchId = "SearchId";
        XmlElementNames.DiscoverySearchConfigurations = "DiscoverySearchConfigurations";
        XmlElementNames.DiscoverySearchConfiguration = "DiscoverySearchConfiguration";
        XmlElementNames.InPlaceHoldConfigurationOnly = "InPlaceHoldConfigurationOnly";
        XmlElementNames.InPlaceHoldIdentity = "InPlaceHoldIdentity";
        XmlElementNames.ItemHoldPeriod = "ItemHoldPeriod";
        XmlElementNames.ManagedByOrganization = "ManagedByOrganization";
        XmlElementNames.IsExternalMailbox = "IsExternalMailbox";
        XmlElementNames.ExternalEmailAddress = "ExternalEmailAddress";
        XmlElementNames.ExtendedAttributes = "ExtendedAttributes";
        XmlElementNames.ExtendedAttribute = "ExtendedAttribute";
        XmlElementNames.ExtendedAttributeName = "Name";
        XmlElementNames.ExtendedAttributeValue = "Value";
        XmlElementNames.SearchScopeType = "SearchScopeType";
        XmlElementNames.GetAppManifestsRequest = "GetAppManifests";
        XmlElementNames.GetAppManifestsResponse = "GetAppManifestsResponse";
        XmlElementNames.Manifests = "Manifests";
        XmlElementNames.Manifest = "Manifest";
        XmlElementNames.Apps = "Apps";
        XmlElementNames.App = "App";
        XmlElementNames.Metadata = "Metadata";
        XmlElementNames.ActionUrl = "ActionUrl";
        XmlElementNames.AppStatus = "AppStatus";
        XmlElementNames.EndNodeUrl = "EndNodeUrl";
        XmlElementNames.GetClientExtensionRequest = "GetClientExtension";
        XmlElementNames.ClientExtensionUserRequest = "UserParameters";
        XmlElementNames.ClientExtensionUserEnabled = "UserEnabledExtensions";
        XmlElementNames.ClientExtensionUserDisabled = "UserDisabledExtensions";
        XmlElementNames.ClientExtensionRequestedIds = "RequestedExtensionIds";
        XmlElementNames.ClientExtensionIsDebug = "IsDebug";
        XmlElementNames.ClientExtensionRawMasterTableXml = "RawMasterTableXml";
        XmlElementNames.GetClientExtensionResponse = "GetClientExtensionResponse";
        XmlElementNames.ClientExtensionSpecificUsers = "SpecificUsers";
        XmlElementNames.ClientExtensions = "ClientExtensions";
        XmlElementNames.ClientExtension = "ClientExtension";
        XmlElementNames.SetClientExtensionRequest = "SetClientExtension";
        XmlElementNames.SetClientExtensionActions = "Actions";
        XmlElementNames.SetClientExtensionAction = "Action";
        XmlElementNames.SetClientExtensionResponse = "SetClientExtensionResponse";
        XmlElementNames.SetClientExtensionResponseMessage = "SetClientExtensionResponseMessage";
        XmlElementNames.GetEncryptionConfigurationRequest = "GetEncryptionConfiguration";
        XmlElementNames.SetEncryptionConfigurationRequest = "SetEncryptionConfiguration";
        XmlElementNames.EncryptionConfigurationImageBase64 = "ImageBase64";
        XmlElementNames.EncryptionConfigurationEmailText = "EmailText";
        XmlElementNames.EncryptionConfigurationPortalText = "PortalText";
        XmlElementNames.EncryptionConfigurationDisclaimerText = "DisclaimerText";
        XmlElementNames.GetEncryptionConfigurationResponse = "GetEncryptionConfigurationResponse";
        XmlElementNames.SetEncryptionConfigurationResponse = "SetEncryptionConfigurationResponse";
        XmlElementNames.InstallAppRequest = "InstallApp";
        XmlElementNames.InstallAppResponse = "InstallAppResponse";
        XmlElementNames.UninstallAppRequest = "UninstallApp";
        XmlElementNames.UninstallAppResponse = "UninstallAppResponse";
        XmlElementNames.DisableAppRequest = "DisableApp";
        XmlElementNames.DisableAppResponse = "DisableAppResponse";
        XmlElementNames.GetAppMarketplaceUrlRequest = "GetAppMarketplaceUrl";
        XmlElementNames.GetAppMarketplaceUrlResponse = "GetAppMarketplaceUrlResponse";
        XmlElementNames.GetUserRetentionPolicyTags = "GetUserRetentionPolicyTags";
        XmlElementNames.GetUserRetentionPolicyTagsResponse = "GetUserRetentionPolicyTagsResponse";
        XmlElementNames.RetentionPolicyTags = "RetentionPolicyTags";
        XmlElementNames.RetentionPolicyTag = "RetentionPolicyTag";
        XmlElementNames.RetentionId = "RetentionId";
        XmlElementNames.RetentionPeriod = "RetentionPeriod";
        XmlElementNames.RetentionAction = "RetentionAction";
        XmlElementNames.Description = "Description";
        XmlElementNames.IsVisible = "IsVisible";
        XmlElementNames.OptedInto = "OptedInto";
        XmlElementNames.IsArchive = "IsArchive";
        XmlElementNames.SOAPEnvelopeElementName = "Envelope";
        XmlElementNames.SOAPHeaderElementName = "Header";
        XmlElementNames.SOAPBodyElementName = "Body";
        XmlElementNames.SOAPFaultElementName = "Fault";
        XmlElementNames.SOAPFaultCodeElementName = "faultcode";
        XmlElementNames.SOAPFaultStringElementName = "faultstring";
        XmlElementNames.SOAPFaultActorElementName = "faultactor";
        XmlElementNames.SOAPDetailElementName = "detail";
        XmlElementNames.EwsResponseCodeElementName = "ResponseCode";
        XmlElementNames.EwsMessageElementName = "Message";
        XmlElementNames.EwsLineElementName = "Line";
        XmlElementNames.EwsPositionElementName = "Position";
        XmlElementNames.EwsErrorCodeElementName = "ErrorCode";
        XmlElementNames.EwsExceptionTypeElementName = "ExceptionType";
        return XmlElementNames;
    }());
    var ServiceRequestBase = (function () {
        function ServiceRequestBase(service) {
            this.service = null;
            _super.call(this);
            this.service = service;
            this.ThrowIfNotSupportedByRequestedServerVersion();
        }
        Object.defineProperty(ServiceRequestBase.prototype, "EmitTimeZoneHeader", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceRequestBase.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        ServiceRequestBase.GetResponseStream = function (response, readTimeout) {
            if (arguments.length === 1) {
                return ServiceRequestBase.GetResponseStream_0(response);
            }
            return ServiceRequestBase.GetResponseStream_1(response, readTimeout);
        };
        ServiceRequestBase.GetResponseStream_0 = function (response) {
            var arg_06_0 = response.ContentEncoding;
            var responseStream = response.GetResponseStream();
            return ServiceRequestBase.WrapStream(responseStream, response.ContentEncoding);
        };
        ServiceRequestBase.GetResponseStream_1 = function (response, readTimeout) {
            var responseStream = response.GetResponseStream();
            responseStream.ReadTimeout = readTimeout;
            return ServiceRequestBase.WrapStream(responseStream, response.ContentEncoding);
        };
        ServiceRequestBase.WrapStream = function (responseStream, contentEncoding) {
            if (NString.Contains(NString.ToLowerInvariant(contentEncoding), "gzip")) {
                return new GZipStream(responseStream, CompressionMode.Decompress);
            }
            if (NString.Contains(NString.ToLowerInvariant(contentEncoding), "deflate")) {
                return new DeflateStream(responseStream, CompressionMode.Decompress);
            }
            return responseStream;
        };
        ServiceRequestBase.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        ServiceRequestBase.prototype.GetResponseXmlElementName = function () {
            throw new NotSupportedException();
        };
        ServiceRequestBase.prototype.GetMinimumRequiredServerVersion = function () {
            throw new NotSupportedException();
        };
        ServiceRequestBase.prototype.WriteElementsToXml = function (writer) {
            throw new NotSupportedException();
        };
        ServiceRequestBase.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        ServiceRequestBase.prototype.ParseResponse_0 = function (reader) {
            throw new NotSupportedException();
        };
        ServiceRequestBase.prototype.ParseResponse_1 = function (jsonBody) {
            var serviceResponse = new ServiceResponse();
            serviceResponse.LoadFromJson(jsonBody, this.Service);
            return serviceResponse;
        };
        ServiceRequestBase.prototype.Validate = function () {
            this.Service.Validate();
        };
        ServiceRequestBase.prototype.WriteBodyToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, this.GetXmlElementName());
            this.WriteAttributesToXml(writer);
            this.WriteElementsToXml(writer);
            writer.WriteEndElement();
        };
        ServiceRequestBase.prototype.WriteAttributesToXml = function (writer) {
        };
        ServiceRequestBase.prototype.ThrowIfNotSupportedByRequestedServerVersion = function () {
            if (this.Service.RequestedServerVersion < this.GetMinimumRequiredServerVersion()) {
                throw new ServiceVersionException(NString.Format(Strings.RequestIncompatibleWithRequestVersion, this.GetXmlElementName(), this.GetMinimumRequiredServerVersion()));
            }
        };
        ServiceRequestBase.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Soap, "Envelope");
            writer.WriteAttributeValue("xmlns", "xsi", "http://www.w3.org/2001/XMLSchema-instance");
            writer.WriteAttributeValue("xmlns", "m", "http://schemas.microsoft.com/exchange/services/2006/messages");
            writer.WriteAttributeValue("xmlns", "t", "http://schemas.microsoft.com/exchange/services/2006/types");
            if (writer.RequireWSSecurityUtilityNamespace) {
                writer.WriteAttributeValue("xmlns", "wsu", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");
            }
            writer.WriteStartElement(XmlNamespace.Soap, "Header");
            if (this.Service.Credentials !== null) {
                this.Service.Credentials.EmitExtraSoapHeaderNamespaceAliases(writer.InternalWriter);
            }
            if (!this.Service.SuppressXmlVersionHeader) {
                writer.WriteStartElement(XmlNamespace.Types, "RequestServerVersion");
                writer.WriteAttributeValue("Version", this.GetRequestedServiceVersionString());
                writer.WriteEndElement();
            }
            if ((this.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1 || this.EmitTimeZoneHeader) && !this.Service.Exchange2007CompatibilityMode) {
                writer.WriteStartElement(XmlNamespace.Types, "TimeZoneContext");
                this.Service.TimeZoneDefinition.WriteToXml(writer);
                writer.WriteEndElement();
                writer.IsTimeZoneHeaderEmitted = true;
            }
            if (this.Service.PreferredCulture !== null) {
                writer.WriteElementValue(XmlNamespace.Types, "MailboxCulture", this.Service.PreferredCulture.Name);
            }
            if (this.Service.DateTimePrecision !== DateTimePrecision.Default) {
                writer.WriteElementValue(XmlNamespace.Types, "DateTimePrecision", DateTimePrecision[this.Service.DateTimePrecision]);
            }
            if (this.Service.ImpersonatedUserId !== null) {
                this.Service.ImpersonatedUserId.WriteToXml(writer);
            }
            else {
                if (this.Service.PrivilegedUserId !== null) {
                    this.Service.PrivilegedUserId.WriteToXml(writer, this.Service.RequestedServerVersion);
                }
                else {
                    if (this.Service.ManagementRoles !== null) {
                        this.Service.ManagementRoles.WriteToXml(writer);
                    }
                }
            }
            if (this.Service.Credentials !== null) {
                this.Service.Credentials.SerializeExtraSoapHeaders(writer.InternalWriter, this.GetXmlElementName());
            }
            this.Service.DoOnSerializeCustomSoapHeaders(writer.InternalWriter);
            writer.WriteEndElement();
            writer.WriteStartElement(XmlNamespace.Soap, "Body");
            this.WriteBodyToXml(writer);
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        ServiceRequestBase.prototype.CreateJsonRequest = function () {
            var jsonSerializable = ((this instanceof IJsonSerializable) ? this : null);
            if (jsonSerializable === null) {
                throw new JsonSerializationNotImplementedException();
            }
            var jsonObject = new JsonObject();
            jsonObject.Add("Header", this.CreateJsonHeaders());
            jsonObject.Add("Body", jsonSerializable.ToJson(this.service));
            return jsonObject;
        };
        ServiceRequestBase.prototype.CreateJsonHeaders = function () {
            var jsonObject = new JsonObject();
            jsonObject.Add("RequestServerVersion", this.GetRequestedServiceVersionString());
            if ((this.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1 || this.EmitTimeZoneHeader) && !this.Service.Exchange2007CompatibilityMode) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("TimeZoneDefinition", this.Service.TimeZoneDefinition.InternalToJson(this.Service));
                jsonObject.Add("TimeZoneContext", jsonObject2);
            }
            if (this.Service.PreferredCulture !== null) {
                jsonObject.Add("MailboxCulture", this.Service.PreferredCulture.Name);
            }
            if (this.Service.DateTimePrecision !== DateTimePrecision.Default) {
                jsonObject.Add("DateTimePrecision", DateTimePrecision[this.Service.DateTimePrecision]);
            }
            if (this.Service.ManagementRoles !== null) {
                jsonObject.Add("ManagementRole", this.Service.ManagementRoles.ToJsonObject());
            }
            return jsonObject;
        };
        ServiceRequestBase.prototype.GetRequestedServiceVersionString = function () {
            if (this.Service.Exchange2007CompatibilityMode && this.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                return "Exchange2007";
            }
            return ExchangeVersion[this.Service.RequestedServerVersion];
        };
        ServiceRequestBase.prototype.EmitRequest = function (request) {
            if (this.Service.RenderingMethod === ExchangeService_RenderingMode.Xml) {
                var webRequestStream = this.GetWebRequestStream(request);
                try {
                    var ewsServiceXmlWriter = new EwsServiceXmlWriter(this.Service, webRequestStream);
                    try {
                        this.WriteToXml(ewsServiceXmlWriter);
                    }
                    finally {
                        if (ewsServiceXmlWriter !== null) {
                            ewsServiceXmlWriter.Dispose();
                        }
                    }
                    return;
                }
                finally {
                    if (webRequestStream !== null) {
                        webRequestStream.Dispose();
                    }
                }
            }
            if (this.Service.RenderingMethod === ExchangeService_RenderingMode.JSON) {
                var jsonObject = this.CreateJsonRequest();
                var webRequestStream2 = this.GetWebRequestStream(request);
                try {
                    jsonObject.SerializeToJson(webRequestStream2);
                }
                finally {
                    if (webRequestStream2 !== null) {
                        webRequestStream2.Dispose();
                    }
                }
            }
        };
        ServiceRequestBase.prototype.TraceAndEmitRequest = function (request, needSignature, needTrace) {
            if (this.service.RenderingMethod === ExchangeService_RenderingMode.Xml) {
                var memoryStream = new MemoryStream();
                try {
                    var ewsServiceXmlWriter = new EwsServiceXmlWriter(this.Service, memoryStream);
                    try {
                        ewsServiceXmlWriter.RequireWSSecurityUtilityNamespace = needSignature;
                        this.WriteToXml(ewsServiceXmlWriter);
                    }
                    finally {
                        if (ewsServiceXmlWriter !== null) {
                            ewsServiceXmlWriter.Dispose();
                        }
                    }
                    if (needSignature) {
                        this.service.Credentials.Sign(memoryStream);
                    }
                    if (needTrace) {
                        this.TraceXmlRequest(memoryStream);
                    }
                    var webRequestStream = this.GetWebRequestStream(request);
                    try {
                        EwsUtilities.CopyStream(memoryStream, webRequestStream);
                    }
                    finally {
                        if (webRequestStream !== null) {
                            webRequestStream.Dispose();
                        }
                    }
                    return;
                }
                finally {
                    if (memoryStream !== null) {
                        memoryStream.Dispose();
                    }
                }
            }
            if (this.service.RenderingMethod === ExchangeService_RenderingMode.JSON) {
                var jsonObject = this.CreateJsonRequest();
                this.TraceJsonRequest(jsonObject);
                var webRequestStream2 = this.GetWebRequestStream(request);
                try {
                    jsonObject.SerializeToJson(webRequestStream2);
                }
                finally {
                    if (webRequestStream2 !== null) {
                        webRequestStream2.Dispose();
                    }
                }
            }
        };
        ServiceRequestBase.prototype.GetWebRequestStream = function (request) {
            return request.EndGetRequestStream(request.BeginGetRequestStream(null, null));
        };
        ServiceRequestBase.prototype.ReadResponse = function (ewsXmlReader) {
            this.ReadPreamble(ewsXmlReader);
            ewsXmlReader.ReadStartElement(XmlNamespace.Soap, "Envelope");
            this.ReadSoapHeader(ewsXmlReader);
            ewsXmlReader.ReadStartElement(XmlNamespace.Soap, "Body");
            ewsXmlReader.ReadStartElement(XmlNamespace.Messages, this.GetResponseXmlElementName());
            var result = this.ParseResponse(ewsXmlReader);
            ewsXmlReader.ReadEndElementIfNecessary(XmlNamespace.Messages, this.GetResponseXmlElementName());
            ewsXmlReader.ReadEndElement(XmlNamespace.Soap, "Body");
            ewsXmlReader.ReadEndElement(XmlNamespace.Soap, "Envelope");
            return result;
        };
        ServiceRequestBase.prototype.BuildResponseObjectFromJson = function (jsonResponse) {
            if (jsonResponse.ContainsKey("Header")) {
                this.ReadSoapHeader(jsonResponse.ReadAsJsonObject("Header"));
            }
            return this.ParseResponse(jsonResponse.ReadAsJsonObject("Body"));
        };
        ServiceRequestBase.prototype.ReadPreamble = function (ewsXmlReader) {
            this.ReadXmlDeclaration(ewsXmlReader);
        };
        ServiceRequestBase.prototype.ReadSoapHeader = function (readerOrJsonHeader) {
            if (arguments.length === 1 && (readerOrJsonHeader === null || readerOrJsonHeader instanceof EwsServiceXmlReader)) {
                this.ReadSoapHeader_0(readerOrJsonHeader);
                return;
            }
            this.ReadSoapHeader_1(readerOrJsonHeader);
        };
        ServiceRequestBase.prototype.ReadSoapHeader_0 = function (reader) {
            reader.ReadStartElement(XmlNamespace.Soap, "Header");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "ServerVersionInfo")) {
                    this.Service.ServerInfo = ExchangeServerInfo.Parse(reader);
                }
            } while (!reader.IsEndElement(XmlNamespace.Soap, "Header"));
        };
        ServiceRequestBase.prototype.ReadSoapHeader_1 = function (jsonHeader) {
            if (jsonHeader.ContainsKey("ServerVersionInfo")) {
                this.Service.ServerInfo = ExchangeServerInfo.Parse(jsonHeader.ReadAsJsonObject("ServerVersionInfo"));
            }
        };
        ServiceRequestBase.prototype.ReadSoapFault = function (readerOrJsonSoapFault) {
            if (arguments.length === 1 && (readerOrJsonSoapFault === null || readerOrJsonSoapFault instanceof EwsServiceXmlReader)) {
                return this.ReadSoapFault_0(readerOrJsonSoapFault);
            }
            return this.ReadSoapFault_1(readerOrJsonSoapFault);
        };
        ServiceRequestBase.prototype.ReadSoapFault_0 = function (reader) {
            var soapFaultDetails = null;
            try {
                this.ReadXmlDeclaration(reader);
                reader.Read();
                if (!reader.IsStartElement() || reader.LocalName !== "Envelope") {
                    var result = soapFaultDetails;
                    return result;
                }
                var namespaceFromUri = EwsUtilities.GetNamespaceFromUri(reader.NamespaceUri);
                if (namespaceFromUri === XmlNamespace.NotSpecified) {
                    var result = soapFaultDetails;
                    return result;
                }
                reader.Read();
                if (reader.IsStartElement(namespaceFromUri, "Header")) {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "ServerVersionInfo")) {
                            this.Service.ServerInfo = ExchangeServerInfo.Parse(reader);
                        }
                    } while (!reader.IsEndElement(namespaceFromUri, "Header"));
                    reader.Read();
                }
                if (reader.IsStartElement(namespaceFromUri, "Body")) {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(namespaceFromUri, "Fault")) {
                            soapFaultDetails = SoapFaultDetails.Parse(reader, namespaceFromUri);
                        }
                    } while (!reader.IsEndElement(namespaceFromUri, "Body"));
                }
                reader.ReadEndElement(namespaceFromUri, "Envelope");
            }
            catch (ex_D9) {
                if (ex_D9 instanceof XmlException) {
                }
                else
                    throw ex_D9;
            }
            return soapFaultDetails;
        };
        ServiceRequestBase.prototype.ReadSoapFault_1 = function (jsonSoapFault) {
            var result = null;
            if (jsonSoapFault.ContainsKey("Header")) {
                this.ReadSoapHeader(jsonSoapFault.ReadAsJsonObject("Header"));
            }
            if (jsonSoapFault.ContainsKey("Body")) {
                result = SoapFaultDetails.Parse(jsonSoapFault.ReadAsJsonObject("Body"));
            }
            return result;
        };
        ServiceRequestBase.prototype.ValidateAndEmitRequest = function (request) {
            this.Validate();
            request[0] = this.BuildEwsHttpWebRequest();
            if (this.service.SendClientLatencies) {
                var text = null;
                var obj;
                Monitor.Enter(obj = ServiceRequestBase.clientStatisticsCache);
                try {
                    if (ServiceRequestBase.clientStatisticsCache.Count > 0) {
                        text = ServiceRequestBase.clientStatisticsCache.get_Item(0);
                        ServiceRequestBase.clientStatisticsCache.RemoveAt(0);
                    }
                }
                finally {
                    Monitor.Exit(obj);
                }
                if (!NString.IsNullOrEmpty(text)) {
                    if (request[0].Headers.get_Item("X-ClientStatistics") !== null) {
                        request[0].Headers.set_Item("X-ClientStatistics", request[0].Headers.get_Item("X-ClientStatistics") + text);
                    }
                    else {
                        request[0].Headers.Add("X-ClientStatistics", text);
                    }
                }
            }
            var utcNow = DateTime.UtcNow;
            var ewsHttpWebResponse = null;
            try {
                ewsHttpWebResponse = this.GetEwsHttpWebResponse(request[0]);
            }
            finally {
                if (this.service.SendClientLatencies) {
                    var value = DateTime.op_Subtraction(DateTime.UtcNow, utcNow).TotalMilliseconds;
                    var value2 = NString.Empty;
                    var value3 = NString.Replace(_super.prototype.GetType.call(this).Name, "Request", NString.Empty);
                    if (ewsHttpWebResponse !== null && ewsHttpWebResponse.Headers !== null) {
                        var requestIdResponseHeaders = ServiceRequestBase.RequestIdResponseHeaders;
                        for (var i = 0; i < requestIdResponseHeaders.length; i = i + 1) {
                            var name = requestIdResponseHeaders[i];
                            var text2 = ewsHttpWebResponse.Headers.Get(name);
                            if (!NString.IsNullOrEmpty(text2)) {
                                value2 = text2;
                                break;
                            }
                        }
                    }
                    var stringBuilder = new StringBuilder();
                    stringBuilder.Append("MessageId=");
                    stringBuilder.Append(value2);
                    stringBuilder.Append(",ResponseTime=");
                    stringBuilder.Append(value);
                    stringBuilder.Append(",SoapAction=");
                    stringBuilder.Append(value3);
                    stringBuilder.Append(";");
                    var obj2;
                    Monitor.Enter(obj2 = ServiceRequestBase.clientStatisticsCache);
                    try {
                        ServiceRequestBase.clientStatisticsCache.Add(stringBuilder.ToString());
                    }
                    finally {
                        Monitor.Exit(obj2);
                    }
                }
            }
            return ewsHttpWebResponse;
        };
        ServiceRequestBase.prototype.BuildEwsHttpWebRequest = function () {
            var result;
            try {
                var ewsHttpWebRequest = this.Service.PrepareHttpWebRequest(this.GetXmlElementName());
                this.Service.TraceHttpRequestHeaders(TraceFlags.EwsRequestHttpHeaders, ewsHttpWebRequest);
                var flag = this.Service.Credentials !== null && this.Service.Credentials.NeedSignature;
                var flag2 = this.Service.IsTraceEnabledFor(TraceFlags.EwsRequest);
                if (flag || flag2) {
                    this.TraceAndEmitRequest(ewsHttpWebRequest, flag, flag2);
                }
                else {
                    this.EmitRequest(ewsHttpWebRequest);
                }
                result = ewsHttpWebRequest;
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Status === WebExceptionStatus.ProtocolError && ex.Response !== null) {
                        this.ProcessWebException(ex);
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else if (ex instanceof IOException) {
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else
                    throw ex;
            }
            return result;
        };
        ServiceRequestBase.prototype.GetEwsHttpWebResponse = function (request) {
            var response;
            try {
                response = request.GetResponse();
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Status === WebExceptionStatus.ProtocolError && ex.Response !== null) {
                        this.ProcessWebException(ex);
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else if (ex instanceof IOException) {
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else
                    throw ex;
            }
            return response;
        };
        ServiceRequestBase.prototype.EndGetEwsHttpWebResponse = function (request, asyncResult) {
            var result;
            try {
                result = request.EndGetResponse(asyncResult);
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Status === WebExceptionStatus.ProtocolError && ex.Response !== null) {
                        this.ProcessWebException(ex);
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else if (ex instanceof IOException) {
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else
                    throw ex;
            }
            return result;
        };
        ServiceRequestBase.prototype.ProcessWebException = function (webException) {
            if (webException.Response !== null) {
                var ewsHttpWebResponse = this.Service.HttpWebRequestFactory.CreateExceptionResponse(webException);
                var soapFaultDetails = null;
                if (ewsHttpWebResponse.StatusCode === HttpStatusCode.InternalServerError) {
                    this.Service.ProcessHttpResponseHeaders(TraceFlags.EwsResponseHttpHeaders, ewsHttpWebResponse);
                    if (this.Service.IsTraceEnabledFor(TraceFlags.EwsResponse)) {
                        var memoryStream = new MemoryStream();
                        try {
                            var responseStream = ServiceRequestBase.GetResponseStream(ewsHttpWebResponse);
                            try {
                                EwsUtilities.CopyStream(responseStream, memoryStream);
                                memoryStream.Position = 0;
                            }
                            finally {
                                if (responseStream !== null) {
                                    responseStream.Dispose();
                                }
                            }
                            if (this.Service.RenderingMethod !== ExchangeService_RenderingMode.Xml) {
                                if (this.Service.RenderingMethod === ExchangeService_RenderingMode.JSON) {
                                    this.TraceResponseJson(ewsHttpWebResponse, memoryStream);
                                    try {
                                        var jsonSoapFault = new JsonParser(memoryStream).Parse();
                                        soapFaultDetails = this.ReadSoapFault(jsonSoapFault);
                                        goto;
                                        IL_DC;
                                    }
                                    catch (ex_D3) {
                                        if (ex_D3 instanceof ServiceJsonDeserializationException) {
                                            goto;
                                            IL_DC;
                                        }
                                        else
                                            throw ex_D3;
                                    }
                                }
                                throw new InvalidOperationException();
                            }
                            this.TraceResponseXml(ewsHttpWebResponse, memoryStream);
                            var reader = new EwsServiceXmlReader(memoryStream, this.Service);
                            soapFaultDetails = this.ReadSoapFault(reader);
                            IL_DC: goto;
                            IL_155;
                        }
                        finally {
                            if (memoryStream !== null) {
                                memoryStream.Dispose();
                            }
                        }
                    }
                    var responseStream2 = ServiceRequestBase.GetResponseStream(ewsHttpWebResponse);
                    try {
                        if (this.Service.RenderingMethod !== ExchangeService_RenderingMode.Xml) {
                            if (this.Service.RenderingMethod === ExchangeService_RenderingMode.JSON) {
                                try {
                                    var jsonSoapFault2 = new JsonParser(responseStream2).Parse();
                                    soapFaultDetails = this.ReadSoapFault(jsonSoapFault2);
                                    goto;
                                    IL_147;
                                }
                                catch (ex_13E) {
                                    if (ex_13E instanceof ServiceJsonDeserializationException) {
                                        goto;
                                        IL_147;
                                    }
                                    else
                                        throw ex_13E;
                                }
                            }
                            throw new InvalidOperationException();
                        }
                        var reader2 = new EwsServiceXmlReader(responseStream2, this.Service);
                        soapFaultDetails = this.ReadSoapFault(reader2);
                        IL_147: ;
                    }
                    finally {
                        if (responseStream2 !== null) {
                            responseStream2.Dispose();
                        }
                    }
                    IL_155: if (soapFaultDetails !== null) {
                        var responseCode = soapFaultDetails.ResponseCode;
                        if (responseCode <= ServiceError.ErrorInvalidServerVersion) {
                            if (responseCode !== ServiceError.ErrorIncorrectSchemaVersion) {
                                if (responseCode === ServiceError.ErrorInvalidServerVersion) {
                                    throw new ServiceVersionException(Strings.ServerVersionNotSupported);
                                }
                            }
                            else {
                                EwsUtilities.Assert(false, "ServiceRequestBase.ProcessWebException", "Exchange server supports requested version but request was invalid for that version");
                            }
                        }
                        else {
                            if (responseCode !== ServiceError.ErrorSchemaValidation) {
                                if (responseCode === ServiceError.ErrorServerBusy) {
                                    throw new ServerBusyException(new ServiceResponse(soapFaultDetails));
                                }
                            }
                            else {
                                if (this.Service.ServerInfo !== null && this.Service.ServerInfo.MajorVersion === 8 && this.Service.ServerInfo.MinorVersion === 0) {
                                    throw new ServiceVersionException(Strings.ServerVersionNotSupported);
                                }
                            }
                        }
                        throw new ServiceResponseException(new ServiceResponse(soapFaultDetails));
                    }
                }
                else {
                    this.Service.ProcessHttpErrorResponse(ewsHttpWebResponse, webException);
                }
            }
        };
        ServiceRequestBase.prototype.TraceXmlRequest = function (memoryStream) {
            this.Service.TraceXml(TraceFlags.EwsRequest, memoryStream);
        };
        ServiceRequestBase.prototype.TraceJsonRequest = function (requestObject) {
            var memoryStream = new MemoryStream();
            try {
                requestObject.SerializeToJson(memoryStream, this.Service.TraceEnablePrettyPrinting);
                memoryStream.Position = 0;
                var streamReader = new StreamReader(memoryStream);
                try {
                    this.Service.TraceMessage(TraceFlags.EwsRequest, streamReader.ReadToEnd());
                }
                finally {
                    if (streamReader !== null) {
                        streamReader.Dispose();
                    }
                }
            }
            finally {
                if (memoryStream !== null) {
                    memoryStream.Dispose();
                }
            }
        };
        ServiceRequestBase.prototype.TraceResponseXml = function (response, memoryStream) {
            if (!NString.IsNullOrEmpty(response.ContentType) && (NString.StartsWith(response.ContentType, "text/", StringComparison.OrdinalIgnoreCase) || NString.StartsWith(response.ContentType, "application/soap", StringComparison.OrdinalIgnoreCase))) {
                this.Service.TraceXml(TraceFlags.EwsResponse, memoryStream);
                return;
            }
            this.Service.TraceMessage(TraceFlags.EwsResponse, "Non-textual response");
        };
        ServiceRequestBase.prototype.TraceResponseJson = function (response, memoryStream) {
            var jsonObject = new JsonParser(memoryStream).Parse();
            var memoryStream2 = new MemoryStream();
            try {
                jsonObject.SerializeToJson(memoryStream2, this.Service.TraceEnablePrettyPrinting);
                memoryStream2.Position = 0;
                var streamReader = new StreamReader(memoryStream2);
                try {
                    this.Service.TraceMessage(TraceFlags.EwsResponse, streamReader.ReadToEnd());
                }
                finally {
                    if (streamReader !== null) {
                        streamReader.Dispose();
                    }
                }
            }
            finally {
                if (memoryStream2 !== null) {
                    memoryStream2.Dispose();
                }
            }
            memoryStream.Seek(0, SeekOrigin.Begin);
        };
        ServiceRequestBase.prototype.ReadXmlDeclaration = function (reader) {
            try {
                reader.Read(17);
            }
            catch (innerException) {
                if (innerException instanceof XmlException) {
                    throw new ServiceRequestException(Strings.ServiceResponseDoesNotContainXml, innerException);
                }
                else if (innerException instanceof ServiceXmlDeserializationException) {
                    throw new ServiceRequestException(Strings.ServiceResponseDoesNotContainXml, innerException2);
                }
                else
                    throw innerException;
            }
        };
        ServiceRequestBase.XMLSchemaNamespace = "http://www.w3.org/2001/XMLSchema";
        ServiceRequestBase.XMLSchemaInstanceNamespace = "http://www.w3.org/2001/XMLSchema-instance";
        ServiceRequestBase.ClientStatisticsRequestHeader = "X-ClientStatistics";
        ServiceRequestBase.RequestIdResponseHeaders = [
            "RequestId", "request-id"
        ];
        ServiceRequestBase.clientStatisticsCache = new List();
        return ServiceRequestBase;
    }());
    var SimpleServiceRequestBase = (function (_super) {
        __extends(SimpleServiceRequestBase, _super);
        function SimpleServiceRequestBase(service) {
            _super.call(this, service);
        }
        SimpleServiceRequestBase.prototype.InternalExecute = function () {
            var _this = this;
            var ewsHttpWebRequest;
            var response = (function () {
                var _p0 = [
                    ewsHttpWebRequest
                ];
                var _r = _super.prototype.ValidateAndEmitRequest.call(_this, _p0);
                ewsHttpWebRequest = _p0[0];
                return _r;
            })();
            return this.ReadResponse(response);
        };
        SimpleServiceRequestBase.prototype.EndInternalExecute = function (asyncResult) {
            var asyncRequestResult = asyncResult;
            var response = _super.prototype.EndGetEwsHttpWebResponse.call(this, asyncRequestResult.WebRequest, asyncRequestResult.WebAsyncResult);
            return this.ReadResponse(response);
        };
        SimpleServiceRequestBase.prototype.BeginExecute = function (callback, state) {
            this.Validate();
            var ewsHttpWebRequest = _super.prototype.BuildEwsHttpWebRequest.call(this);
            var state2 = new WebAsyncCallStateAnchor(this, ewsHttpWebRequest, callback, state);
            var webAsyncResult = ewsHttpWebRequest.BeginGetResponse(SimpleServiceRequestBase.WebRequestAsyncCallback, state2);
            return new AsyncRequestResult(this, ewsHttpWebRequest, webAsyncResult, state);
        };
        SimpleServiceRequestBase.WebRequestAsyncCallback = function (webAsyncResult) {
            var webAsyncCallStateAnchor = ((webAsyncResult.AsyncState instanceof WebAsyncCallStateAnchor) ? webAsyncResult.AsyncState : null);
            if (webAsyncCallStateAnchor !== null && webAsyncCallStateAnchor.AsyncCallback !== null) {
                var ar = new AsyncRequestResult(webAsyncCallStateAnchor.ServiceRequest, webAsyncCallStateAnchor.WebRequest, webAsyncResult, webAsyncCallStateAnchor.AsyncState);
                webAsyncCallStateAnchor.AsyncCallback(ar);
            }
        };
        SimpleServiceRequestBase.prototype.ReadResponse = function (response) {
            var result;
            try {
                var IL_E8 = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            this.Service.ProcessHttpResponseHeaders(TraceFlags.EwsResponseHttpHeaders, response);
                            if (this.Service.IsTraceEnabledFor(TraceFlags.EwsResponse)) {
                                var memoryStream = new MemoryStream();
                                try {
                                    var responseStream = ServiceRequestBase.GetResponseStream(response);
                                    try {
                                        EwsUtilities.CopyStream(responseStream, memoryStream);
                                        memoryStream.Position = 0;
                                    }
                                    finally {
                                        if (responseStream !== null) {
                                            responseStream.Dispose();
                                        }
                                    }
                                    if (this.Service.RenderingMethod === ExchangeService_RenderingMode.Xml) {
                                        _super.prototype.TraceResponseXml.call(this, response, memoryStream);
                                        result = this.ReadResponseXml(memoryStream);
                                    }
                                    else {
                                        if (this.Service.RenderingMethod !== ExchangeService_RenderingMode.JSON) {
                                            throw new InvalidOperationException("Unknown RenderingMethod.");
                                        }
                                        _super.prototype.TraceResponseJson.call(this, response, memoryStream);
                                        result = this.ReadResponseJson(memoryStream);
                                    }
                                    _goto = IL_E8;
                                    continue _GOTO_LOOP;
                                }
                                finally {
                                    if (memoryStream !== null) {
                                        memoryStream.Dispose();
                                    }
                                }
                            }
                            var responseStream2 = ServiceRequestBase.GetResponseStream(response);
                            try {
                                if (this.Service.RenderingMethod === ExchangeService_RenderingMode.Xml) {
                                    result = this.ReadResponseXml(responseStream2);
                                }
                                else {
                                    if (this.Service.RenderingMethod !== ExchangeService_RenderingMode.JSON) {
                                        throw new InvalidOperationException("Unknown RenderingMethod.");
                                    }
                                    result = this.ReadResponseJson(responseStream2);
                                }
                            }
                            finally {
                                if (responseStream2 !== null) {
                                    responseStream2.Dispose();
                                }
                            }
                            _goto = IL_E8;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Response !== null) {
                        var response2 = this.Service.HttpWebRequestFactory.CreateExceptionResponse(ex);
                        this.Service.ProcessHttpResponseHeaders(TraceFlags.EwsResponseHttpHeaders, response2);
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else if (ex instanceof IOException) {
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else
                    throw ex;
            }
            finally {
                if (response !== null) {
                    response.Close();
                }
            }
            return result;
        };
        SimpleServiceRequestBase.prototype.ReadResponseJson = function (responseStream) {
            var jsonResponse = new JsonParser(responseStream).Parse();
            return _super.prototype.BuildResponseObjectFromJson.call(this, jsonResponse);
        };
        SimpleServiceRequestBase.prototype.ReadResponseXml = function (responseStream) {
            var ewsXmlReader = new EwsServiceXmlReader(responseStream, this.Service);
            return _super.prototype.ReadResponse.call(this, ewsXmlReader);
        };
        return SimpleServiceRequestBase;
    }(ServiceRequestBase));
    var DelegateManagementRequestBase = (function (_super) {
        __extends(DelegateManagementRequestBase, _super);
        function DelegateManagementRequestBase(service) {
            _super.call(this, service);
            this.mailbox = null;
        }
        Object.defineProperty(DelegateManagementRequestBase.prototype, "Mailbox", {
            get: function () {
                return this.mailbox;
            },
            set: function (value) {
                this.mailbox = value;
            },
            enumerable: true,
            configurable: true
        });
        DelegateManagementRequestBase.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Mailbox, "Mailbox");
        };
        DelegateManagementRequestBase.prototype.WriteElementsToXml = function (writer) {
            this.Mailbox.WriteToXml(writer, XmlNamespace.Messages, "Mailbox");
        };
        DelegateManagementRequestBase.prototype.CreateResponse = function () {
            throw new NotSupportedException();
        };
        DelegateManagementRequestBase.prototype.ParseResponse = function (reader) {
            var delegateManagementResponse = this.CreateResponse();
            delegateManagementResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return delegateManagementResponse;
        };
        DelegateManagementRequestBase.prototype.Execute = function () {
            var result = _super.prototype.InternalExecute.call(this);
            result.ThrowIfNecessary();
            return result;
        };
        return DelegateManagementRequestBase;
    }(SimpleServiceRequestBase));
    var AddDelegateRequest = (function (_super) {
        __extends(AddDelegateRequest, _super);
        function AddDelegateRequest(service) {
            _super.call(this, service);
            this.delegateUsers = new List();
            this.meetingRequestsDeliveryScope = null;
        }
        Object.defineProperty(AddDelegateRequest.prototype, "MeetingRequestsDeliveryScope", {
            get: function () {
                return this.meetingRequestsDeliveryScope;
            },
            set: function (value) {
                this.meetingRequestsDeliveryScope = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AddDelegateRequest.prototype, "DelegateUsers", {
            get: function () {
                return this.delegateUsers;
            },
            enumerable: true,
            configurable: true
        });
        AddDelegateRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.DelegateUsers, "DelegateUsers");
            var enumerator = this.DelegateUsers.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.ValidateUpdateDelegate();
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (this.MeetingRequestsDeliveryScope !== null) {
                EwsUtilities.ValidateEnumVersionValue(this.MeetingRequestsDeliveryScope.Value, this.Service.RequestedServerVersion);
            }
        };
        AddDelegateRequest.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Messages, "DelegateUsers");
            var enumerator = this.DelegateUsers.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, "DelegateUser");
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            if (this.MeetingRequestsDeliveryScope !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "DeliverMeetingRequests", this.MeetingRequestsDeliveryScope.Value);
            }
        };
        AddDelegateRequest.prototype.GetXmlElementName = function () {
            return "AddDelegate";
        };
        AddDelegateRequest.prototype.GetResponseXmlElementName = function () {
            return "AddDelegateResponse";
        };
        AddDelegateRequest.prototype.CreateResponse = function () {
            return new DelegateManagementResponse(true, this.delegateUsers);
        };
        AddDelegateRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return AddDelegateRequest;
    }(DelegateManagementRequestBase));
    var MultiResponseServiceRequest = (function (_super) {
        __extends(MultiResponseServiceRequest, _super);
        function MultiResponseServiceRequest(service, errorHandlingMode) {
            _super.call(this, service);
            this.errorHandlingMode = 0;
            this.errorHandlingMode = errorHandlingMode;
        }
        Object.defineProperty(MultiResponseServiceRequest.prototype, "ErrorHandlingMode", {
            get: function () {
                return this.errorHandlingMode;
            },
            enumerable: true,
            configurable: true
        });
        MultiResponseServiceRequest.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        MultiResponseServiceRequest.prototype.ParseResponse_0 = function (reader) {
            var serviceResponseCollection = new ServiceResponseCollection();
            reader.ReadStartElement(XmlNamespace.Messages, "ResponseMessages");
            for (var i = 0; i < this.GetExpectedResponseMessageCount(); i = i + 1) {
                reader.Read();
                if (reader.IsEndElement(XmlNamespace.Messages, "ResponseMessages")) {
                    break;
                }
                var response = this.CreateServiceResponse(reader.Service, i);
                response.LoadFromXml(reader, this.GetResponseMessageXmlElementName());
                serviceResponseCollection.Add(response);
            }
            if (serviceResponseCollection.Count < this.GetExpectedResponseMessageCount()) {
                if (serviceResponseCollection.Count === 1) {
                    var tResponse = serviceResponseCollection.get_Item(0);
                    if (tResponse.Result === ServiceResult.Error) {
                        throw new ServiceResponseException(serviceResponseCollection.get_Item(0));
                    }
                }
                throw new ServiceXmlDeserializationException(NString.Format(Strings.TooFewServiceReponsesReturned, this.GetResponseMessageXmlElementName(), this.GetExpectedResponseMessageCount(), serviceResponseCollection.Count));
            }
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "ResponseMessages");
            return serviceResponseCollection;
        };
        MultiResponseServiceRequest.prototype.ParseResponse_1 = function (jsonBody) {
            var serviceResponseCollection = new ServiceResponseCollection();
            var array = jsonBody.ReadAsJsonObject("ResponseMessages").ReadAsArray("Items");
            var num = 0;
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var obj = array2[i];
                var response = this.CreateServiceResponse(this.Service, num);
                response.LoadFromJson(((obj instanceof JsonObject) ? obj : null), this.Service);
                serviceResponseCollection.Add(response);
                num = num + 1;
            }
            if (serviceResponseCollection.Count < this.GetExpectedResponseMessageCount()) {
                if (serviceResponseCollection.Count === 1) {
                    var tResponse = serviceResponseCollection.get_Item(0);
                    if (tResponse.Result === ServiceResult.Error) {
                        throw new ServiceResponseException(serviceResponseCollection.get_Item(0));
                    }
                }
                throw new ServiceJsonDeserializationException();
            }
            return serviceResponseCollection;
        };
        MultiResponseServiceRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            throw new NotSupportedException();
        };
        MultiResponseServiceRequest.prototype.GetResponseMessageXmlElementName = function () {
            throw new NotSupportedException();
        };
        MultiResponseServiceRequest.prototype.GetExpectedResponseMessageCount = function () {
            throw new NotSupportedException();
        };
        MultiResponseServiceRequest.prototype.Execute = function () {
            var serviceResponseCollection = _super.prototype.InternalExecute.call(this);
            if (this.ErrorHandlingMode === ServiceErrorHandling.ThrowOnError) {
                EwsUtilities.Assert(serviceResponseCollection.Count === 1, "MultiResponseServiceRequest.Execute", "ServiceErrorHandling.ThrowOnError error handling is only valid for singleton request");
                var tResponse = serviceResponseCollection.get_Item(0);
                tResponse.ThrowIfNecessary();
            }
            return serviceResponseCollection;
        };
        MultiResponseServiceRequest.prototype.EndExecute = function (asyncResult) {
            var serviceResponseCollection = _super.prototype.EndInternalExecute.call(this, asyncResult);
            if (this.ErrorHandlingMode === ServiceErrorHandling.ThrowOnError) {
                EwsUtilities.Assert(serviceResponseCollection.Count === 1, "MultiResponseServiceRequest.Execute", "ServiceErrorHandling.ThrowOnError error handling is only valid for singleton request");
                var tResponse = serviceResponseCollection.get_Item(0);
                tResponse.ThrowIfNecessary();
            }
            return serviceResponseCollection;
        };
        return MultiResponseServiceRequest;
    }(SimpleServiceRequestBase));
    var ApplyConversationActionRequest = (function (_super) {
        __extends(ApplyConversationActionRequest, _super);
        function ApplyConversationActionRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.conversationActions = new List();
        }
        Object.defineProperty(ApplyConversationActionRequest.prototype, "ConversationActions", {
            get: function () {
                return this.conversationActions;
            },
            enumerable: true,
            configurable: true
        });
        ApplyConversationActionRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        ApplyConversationActionRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.conversationActions.Count;
        };
        ApplyConversationActionRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.conversationActions, "conversationActions");
            for (var i = 0; i < this.ConversationActions.Count; i = i + 1) {
                this.ConversationActions.get_Item(i).Validate();
            }
        };
        ApplyConversationActionRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "ConversationActions");
            for (var i = 0; i < this.ConversationActions.Count; i = i + 1) {
                this.ConversationActions.get_Item(i).WriteElementsToXml(writer);
            }
            writer.WriteEndElement();
        };
        ApplyConversationActionRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            var list = new List();
            var enumerator = this.conversationActions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.ToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("ConversationActions", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        ApplyConversationActionRequest.prototype.GetXmlElementName = function () {
            return "ApplyConversationAction";
        };
        ApplyConversationActionRequest.prototype.GetResponseXmlElementName = function () {
            return "ApplyConversationActionResponse";
        };
        ApplyConversationActionRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ApplyConversationActionResponseMessage";
        };
        ApplyConversationActionRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        return ApplyConversationActionRequest;
    }(MultiResponseServiceRequest));
    var ArchiveItemRequest = (function (_super) {
        __extends(ArchiveItemRequest, _super);
        function ArchiveItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.sourceFolderId = null;
            this.ids = new ItemIdWrapperList();
        }
        Object.defineProperty(ArchiveItemRequest.prototype, "SourceFolderId", {
            get: function () {
                return this.sourceFolderId;
            },
            set: function (value) {
                this.sourceFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ArchiveItemRequest.prototype, "Ids", {
            get: function () {
                return this.ids;
            },
            enumerable: true,
            configurable: true
        });
        ArchiveItemRequest.prototype.Validate = function () {
            EwsUtilities.ValidateParam(this.sourceFolderId, "SourceFolderId");
            this.sourceFolderId.Validate(this.Service.RequestedServerVersion);
        };
        ArchiveItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ArchiveItemResponse();
        };
        ArchiveItemRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.ids.Count;
        };
        ArchiveItemRequest.prototype.GetXmlElementName = function () {
            return "ArchiveItem";
        };
        ArchiveItemRequest.prototype.GetResponseXmlElementName = function () {
            return "ArchiveItemResponse";
        };
        ArchiveItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ArchiveItemResponseMessage";
        };
        ArchiveItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        ArchiveItemRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "ArchiveSourceFolderId");
            this.SourceFolderId.WriteToXml(writer);
            writer.WriteEndElement();
            this.WriteIdsToXml(writer);
        };
        ArchiveItemRequest.prototype.WriteIdsToXml = function (writer) {
            this.Ids.WriteToXml(writer, XmlNamespace.Messages, "ItemIds");
        };
        ArchiveItemRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ArchiveSourceFolderId", this.SourceFolderId.InternalToJson(service));
            this.AddIdsToJson(jsonObject, service);
            return jsonObject;
        };
        ArchiveItemRequest.prototype.AddIdsToJson = function (jsonObject, service) {
            jsonObject.Add("ItemIds", this.Ids.InternalToJson(service));
        };
        return ArchiveItemRequest;
    }(MultiResponseServiceRequest));
    var AsyncRequestResult = (function () {
        function AsyncRequestResult(serviceRequest, webRequest, webAsyncResult, asyncState) {
            this.ServiceRequest = null;
            this.WebRequest = null;
            this.WebAsyncResult = null;
            this.AsyncState = null;
            _super.call(this);
            EwsUtilities.ValidateParam(serviceRequest, "serviceRequest");
            EwsUtilities.ValidateParam(webRequest, "webRequest");
            EwsUtilities.ValidateParam(webAsyncResult, "webAsyncResult");
            this.ServiceRequest = serviceRequest;
            this.WebAsyncResult = webAsyncResult;
            this.WebRequest = webRequest;
            this.AsyncState = asyncState;
        }
        Object.defineProperty(AsyncRequestResult.prototype, "AsyncWaitHandle", {
            get: function () {
                return this.WebAsyncResult.AsyncWaitHandle;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRequestResult.prototype, "CompletedSynchronously", {
            get: function () {
                return this.WebAsyncResult.CompletedSynchronously;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRequestResult.prototype, "IsCompleted", {
            get: function () {
                return this.WebAsyncResult.IsCompleted;
            },
            enumerable: true,
            configurable: true
        });
        AsyncRequestResult.ExtractServiceRequest = function (exchangeService, asyncResult) {
            EwsUtilities.ValidateParam(asyncResult, "asyncResult");
            var asyncRequestResult = ((asyncResult instanceof AsyncRequestResult) ? asyncResult : null);
            if (asyncRequestResult === null) {
                throw new ArgumentException(Strings.InvalidAsyncResult, "asyncResult");
            }
            if (asyncRequestResult.ServiceRequest === null) {
                throw new ArgumentException(Strings.InvalidAsyncResult, "asyncResult");
            }
            if (!NObject.ReferenceEquals(asyncRequestResult.ServiceRequest.Service, exchangeService)) {
                throw new ArgumentException(Strings.InvalidAsyncResult, "asyncResult");
            }
            var t = ((asyncRequestResult.ServiceRequest instanceof T) ? asyncRequestResult.ServiceRequest : null);
            if (t === null) {
                throw new ArgumentException(Strings.InvalidAsyncResult, "asyncResult");
            }
            return t;
        };
        return AsyncRequestResult;
    }());
    var WebAsyncCallStateAnchor = (function () {
        function WebAsyncCallStateAnchor(serviceRequest, webRequest, asyncCallback, asyncState) {
            this.ServiceRequest = null;
            this.WebRequest = null;
            this.AsyncState = null;
            this.AsyncCallback = null;
            _super.call(this);
            EwsUtilities.ValidateParam(serviceRequest, "serviceRequest");
            EwsUtilities.ValidateParam(webRequest, "webRequest");
            this.ServiceRequest = serviceRequest;
            this.WebRequest = webRequest;
            this.AsyncCallback = asyncCallback;
            this.AsyncState = asyncState;
        }
        return WebAsyncCallStateAnchor;
    }());
    var ConvertIdRequest = (function (_super) {
        __extends(ConvertIdRequest, _super);
        function ConvertIdRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.destinationFormat = IdFormat.EwsId;
            this.ids = new List();
        }
        Object.defineProperty(ConvertIdRequest.prototype, "DestinationFormat", {
            get: function () {
                return this.destinationFormat;
            },
            set: function (value) {
                this.destinationFormat = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvertIdRequest.prototype, "Ids", {
            get: function () {
                return this.ids;
            },
            enumerable: true,
            configurable: true
        });
        ConvertIdRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ConvertIdResponse();
        };
        ConvertIdRequest.prototype.GetResponseXmlElementName = function () {
            return "ConvertIdResponse";
        };
        ConvertIdRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ConvertIdResponseMessage";
        };
        ConvertIdRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.Ids.Count;
        };
        ConvertIdRequest.prototype.GetXmlElementName = function () {
            return "ConvertId";
        };
        ConvertIdRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.Ids, "Ids");
        };
        ConvertIdRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteAttributeValue("DestinationFormat", this.DestinationFormat);
            writer.WriteStartElement(XmlNamespace.Messages, "SourceIds");
            var enumerator = this.Ids.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer);
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        ConvertIdRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        ConvertIdRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("DestinationFormat", this.DestinationFormat);
            var list = new List();
            var enumerator = this.Ids.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.ToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("SourceIds", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        return ConvertIdRequest;
    }(MultiResponseServiceRequest));
    var MoveCopyRequest = (function (_super) {
        __extends(MoveCopyRequest, _super);
        function MoveCopyRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.destinationFolderId = null;
        }
        Object.defineProperty(MoveCopyRequest.prototype, "DestinationFolderId", {
            get: function () {
                return this.destinationFolderId;
            },
            set: function (value) {
                this.destinationFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        MoveCopyRequest.prototype.Validate = function () {
            EwsUtilities.ValidateParam(this.DestinationFolderId, "DestinationFolderId");
            this.DestinationFolderId.Validate(this.Service.RequestedServerVersion);
        };
        MoveCopyRequest.prototype.WriteIdsToXml = function (writer) {
            throw new NotSupportedException();
        };
        MoveCopyRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "ToFolderId");
            this.DestinationFolderId.WriteToXml(writer);
            writer.WriteEndElement();
            this.WriteIdsToXml(writer);
        };
        MoveCopyRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            var jsonObject2 = new JsonObject();
            jsonObject2.Add("BaseFolderId", this.DestinationFolderId.InternalToJson(service));
            jsonObject.Add("ToFolderId", jsonObject2);
            this.AddIdsToJson(jsonObject, service);
            return jsonObject;
        };
        MoveCopyRequest.prototype.AddIdsToJson = function (jsonObject, service) {
            throw new NotSupportedException();
        };
        return MoveCopyRequest;
    }(MultiResponseServiceRequest));
    var MoveCopyFolderRequest = (function (_super) {
        __extends(MoveCopyFolderRequest, _super);
        function MoveCopyFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folderIds = new FolderIdWrapperList();
        }
        Object.defineProperty(MoveCopyFolderRequest.prototype, "FolderIds", {
            get: function () {
                return this.folderIds;
            },
            enumerable: true,
            configurable: true
        });
        MoveCopyFolderRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.FolderIds, "FolderIds");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
        };
        MoveCopyFolderRequest.prototype.WriteIdsToXml = function (writer) {
            this.folderIds.WriteToXml(writer, XmlNamespace.Messages, "FolderIds");
        };
        MoveCopyFolderRequest.prototype.AddIdsToJson = function (jsonObject, service) {
            if (this.folderIds.Count > 0) {
                jsonObject.Add("FolderIds", this.folderIds.InternalToJson(service));
            }
        };
        MoveCopyFolderRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.FolderIds.Count;
        };
        return MoveCopyFolderRequest;
    }(MoveCopyRequest));
    var CopyFolderRequest = (function (_super) {
        __extends(CopyFolderRequest, _super);
        function CopyFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        CopyFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new MoveCopyFolderResponse();
        };
        CopyFolderRequest.prototype.GetXmlElementName = function () {
            return "CopyFolder";
        };
        CopyFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "CopyFolderResponse";
        };
        CopyFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "CopyFolderResponseMessage";
        };
        CopyFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CopyFolderRequest;
    }(MoveCopyFolderRequest));
    var MoveCopyItemRequest = (function (_super) {
        __extends(MoveCopyItemRequest, _super);
        function MoveCopyItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.itemIds = new ItemIdWrapperList();
            this.ReturnNewItemIds = null;
        }
        Object.defineProperty(MoveCopyItemRequest.prototype, "ItemIds", {
            get: function () {
                return this.itemIds;
            },
            enumerable: true,
            configurable: true
        });
        MoveCopyItemRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.ItemIds, "ItemIds");
        };
        MoveCopyItemRequest.prototype.WriteIdsToXml = function (writer) {
            this.ItemIds.WriteToXml(writer, XmlNamespace.Messages, "ItemIds");
            if (this.ReturnNewItemIds !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "ReturnNewItemIds", this.ReturnNewItemIds.Value);
            }
        };
        MoveCopyItemRequest.prototype.AddIdsToJson = function (jsonObject, service) {
            jsonObject.Add("ItemIds", this.ItemIds.InternalToJson(service));
            if (this.ReturnNewItemIds !== null) {
                jsonObject.Add("ReturnNewItemIds", this.ReturnNewItemIds.Value);
            }
        };
        MoveCopyItemRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.ItemIds.Count;
        };
        return MoveCopyItemRequest;
    }(MoveCopyRequest));
    var CopyItemRequest = (function (_super) {
        __extends(CopyItemRequest, _super);
        function CopyItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        CopyItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new MoveCopyItemResponse();
        };
        CopyItemRequest.prototype.GetXmlElementName = function () {
            return "CopyItem";
        };
        CopyItemRequest.prototype.GetResponseXmlElementName = function () {
            return "CopyItemResponse";
        };
        CopyItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "CopyItemResponseMessage";
        };
        CopyItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CopyItemRequest;
    }(MoveCopyItemRequest));
    var CreateAttachmentRequest = (function (_super) {
        __extends(CreateAttachmentRequest, _super);
        function CreateAttachmentRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.parentItemId = null;
            this.attachments = new List();
        }
        Object.defineProperty(CreateAttachmentRequest.prototype, "EmitTimeZoneHeader", {
            get: function () {
                var enumerator = Enumerable.OfType(this.attachments).GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.Item !== null && current.Item.GetIsTimeZoneHeaderRequired(false)) {
                            return true;
                        }
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateAttachmentRequest.prototype, "Attachments", {
            get: function () {
                return this.attachments;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateAttachmentRequest.prototype, "ParentItemId", {
            get: function () {
                return this.parentItemId;
            },
            set: function (value) {
                this.parentItemId = value;
            },
            enumerable: true,
            configurable: true
        });
        CreateAttachmentRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.ParentItemId, "ParentItemId");
        };
        CreateAttachmentRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new CreateAttachmentResponse(this.Attachments.get_Item(responseIndex));
        };
        CreateAttachmentRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.Attachments.Count;
        };
        CreateAttachmentRequest.prototype.GetXmlElementName = function () {
            return "CreateAttachment";
        };
        CreateAttachmentRequest.prototype.GetResponseXmlElementName = function () {
            return "CreateAttachmentResponse";
        };
        CreateAttachmentRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "CreateAttachmentResponseMessage";
        };
        CreateAttachmentRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "ParentItemId");
            writer.WriteAttributeValue("Id", this.ParentItemId);
            writer.WriteEndElement();
            writer.WriteStartElement(XmlNamespace.Messages, "Attachments");
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, current.GetXmlElementName());
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        CreateAttachmentRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ParentItemId", new ItemId(this.ParentItemId).InternalToJson(service));
            var list = new List();
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("Attachments", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        CreateAttachmentRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CreateAttachmentRequest;
    }(MultiResponseServiceRequest));
    var CreateRequest = (function (_super) {
        __extends(CreateRequest, _super);
        function CreateRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.parentFolderId = null;
            this.objects = null;
        }
        Object.defineProperty(CreateRequest.prototype, "Objects", {
            get: function () {
                return this.objects;
            },
            set: function (value) {
                this.objects = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateRequest.prototype, "ParentFolderId", {
            get: function () {
                return this.parentFolderId;
            },
            set: function (value) {
                this.parentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        CreateRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.ParentFolderId !== null) {
                this.ParentFolderId.Validate(this.Service.RequestedServerVersion);
            }
        };
        CreateRequest.prototype.GetExpectedResponseMessageCount = function () {
            return EwsUtilities.GetEnumeratedObjectCount(this.objects);
        };
        CreateRequest.prototype.GetParentFolderXmlElementName = function () {
            throw new NotSupportedException();
        };
        CreateRequest.prototype.GetObjectCollectionXmlElementName = function () {
            throw new NotSupportedException();
        };
        CreateRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.ParentFolderId !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, this.GetParentFolderXmlElementName());
                this.ParentFolderId.WriteToXml(writer);
                writer.WriteEndElement();
            }
            writer.WriteStartElement(XmlNamespace.Messages, this.GetObjectCollectionXmlElementName());
            var enumerator = this.objects.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var serviceObject = enumerator.Current;
                    serviceObject.WriteToXml(writer);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
        };
        CreateRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.ParentFolderId !== null) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("BaseFolderId", this.ParentFolderId.InternalToJson(service));
                jsonObject.Add(this.GetParentFolderXmlElementName(), jsonObject2);
            }
            var list = new List();
            var enumerator = this.objects.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var serviceObject = enumerator.Current;
                    list.Add(serviceObject.ToJson(service, false));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            jsonObject.Add(this.GetObjectCollectionXmlElementName(), NArray.ToEnumerable(list.ToArray()));
            this.AddJsonProperties(jsonObject, service);
            return jsonObject;
        };
        CreateRequest.prototype.AddJsonProperties = function (jsonRequest, service) {
        };
        return CreateRequest;
    }(MultiResponseServiceRequest));
    var CreateFolderRequest = (function (_super) {
        __extends(CreateFolderRequest, _super);
        function CreateFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        Object.defineProperty(CreateFolderRequest.prototype, "Folders", {
            get: function () {
                return this.Objects;
            },
            set: function (value) {
                this.Objects = value;
            },
            enumerable: true,
            configurable: true
        });
        CreateFolderRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Folders, "Folders");
            var enumerator = this.Folders.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Validate();
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        CreateFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new CreateFolderResponse(EwsUtilities.GetEnumeratedObjectAt(this.Folders, responseIndex));
        };
        CreateFolderRequest.prototype.GetXmlElementName = function () {
            return "CreateFolder";
        };
        CreateFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "CreateFolderResponse";
        };
        CreateFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "CreateFolderResponseMessage";
        };
        CreateFolderRequest.prototype.GetParentFolderXmlElementName = function () {
            return "ParentFolderId";
        };
        CreateFolderRequest.prototype.GetObjectCollectionXmlElementName = function () {
            return "Folders";
        };
        CreateFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CreateFolderRequest;
    }(CreateRequest));
    var CreateItemRequestBase = (function (_super) {
        __extends(CreateItemRequestBase, _super);
        function CreateItemRequestBase(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.messageDisposition = null;
            this.sendInvitationsMode = null;
        }
        Object.defineProperty(CreateItemRequestBase.prototype, "EmitTimeZoneHeader", {
            get: function () {
                var enumerator = this.Items.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.GetIsTimeZoneHeaderRequired(false)) {
                            return true;
                        }
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateItemRequestBase.prototype, "MessageDisposition", {
            get: function () {
                return this.messageDisposition;
            },
            set: function (value) {
                this.messageDisposition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateItemRequestBase.prototype, "SendInvitationsMode", {
            get: function () {
                return this.sendInvitationsMode;
            },
            set: function (value) {
                this.sendInvitationsMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CreateItemRequestBase.prototype, "Items", {
            get: function () {
                return this.Objects;
            },
            set: function (value) {
                this.Objects = value;
            },
            enumerable: true,
            configurable: true
        });
        CreateItemRequestBase.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Items, "Items");
        };
        CreateItemRequestBase.prototype.GetXmlElementName = function () {
            return "CreateItem";
        };
        CreateItemRequestBase.prototype.GetResponseXmlElementName = function () {
            return "CreateItemResponse";
        };
        CreateItemRequestBase.prototype.GetResponseMessageXmlElementName = function () {
            return "CreateItemResponseMessage";
        };
        CreateItemRequestBase.prototype.GetParentFolderXmlElementName = function () {
            return "SavedItemFolderId";
        };
        CreateItemRequestBase.prototype.GetObjectCollectionXmlElementName = function () {
            return "Items";
        };
        CreateItemRequestBase.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            if (this.MessageDisposition !== null) {
                writer.WriteAttributeValue("MessageDisposition", this.MessageDisposition.Value);
            }
            if (this.SendInvitationsMode !== null) {
                writer.WriteAttributeValue("SendMeetingInvitations", this.SendInvitationsMode.Value);
            }
        };
        CreateItemRequestBase.prototype.AddJsonProperties = function (jsonRequest, service) {
            _super.prototype.AddJsonProperties.call(this, jsonRequest, service);
            if (this.MessageDisposition !== null) {
                jsonRequest.Add("MessageDisposition", this.MessageDisposition.Value);
            }
            if (this.SendInvitationsMode !== null) {
                jsonRequest.Add("SendMeetingInvitations", this.SendInvitationsMode.Value);
            }
        };
        return CreateItemRequestBase;
    }(CreateRequest));
    var CreateItemRequest = (function (_super) {
        __extends(CreateItemRequest, _super);
        function CreateItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        CreateItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new CreateItemResponse(EwsUtilities.GetEnumeratedObjectAt(this.Items, responseIndex));
        };
        CreateItemRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Validate();
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        CreateItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CreateItemRequest;
    }(CreateItemRequestBase));
    var CreateResponseObjectRequest = (function (_super) {
        __extends(CreateResponseObjectRequest, _super);
        function CreateResponseObjectRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        CreateResponseObjectRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new CreateResponseObjectResponse();
        };
        CreateResponseObjectRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return CreateResponseObjectRequest;
    }(CreateItemRequestBase));
    var CreateUserConfigurationRequest = (function (_super) {
        __extends(CreateUserConfigurationRequest, _super);
        function CreateUserConfigurationRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.userConfiguration = null;
        }
        Object.defineProperty(CreateUserConfigurationRequest.prototype, "UserConfiguration", {
            get: function () {
                return this.userConfiguration;
            },
            set: function (value) {
                this.userConfiguration = value;
            },
            enumerable: true,
            configurable: true
        });
        CreateUserConfigurationRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.userConfiguration, "userConfiguration");
        };
        CreateUserConfigurationRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        CreateUserConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        CreateUserConfigurationRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        CreateUserConfigurationRequest.prototype.GetXmlElementName = function () {
            return "CreateUserConfiguration";
        };
        CreateUserConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "CreateUserConfigurationResponse";
        };
        CreateUserConfigurationRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "CreateUserConfigurationResponseMessage";
        };
        CreateUserConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            this.userConfiguration.WriteToXml(writer, XmlNamespace.Messages, "UserConfiguration");
        };
        CreateUserConfigurationRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserConfiguration", this.UserConfiguration.ToJson(service));
            return jsonObject;
        };
        return CreateUserConfigurationRequest;
    }(MultiResponseServiceRequest));
    var DeleteAttachmentRequest = (function (_super) {
        __extends(DeleteAttachmentRequest, _super);
        function DeleteAttachmentRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.attachments = new List();
        }
        Object.defineProperty(DeleteAttachmentRequest.prototype, "Attachments", {
            get: function () {
                return this.attachments;
            },
            enumerable: true,
            configurable: true
        });
        DeleteAttachmentRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.Attachments, "Attachments");
            for (var i = 0; i < this.Attachments.Count; i = i + 1) {
                EwsUtilities.ValidateParam(this.Attachments.get_Item(i).Id, NString.Format("Attachment[{0}].Id", i));
            }
        };
        DeleteAttachmentRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new DeleteAttachmentResponse(this.Attachments.get_Item(responseIndex));
        };
        DeleteAttachmentRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.Attachments.Count;
        };
        DeleteAttachmentRequest.prototype.GetXmlElementName = function () {
            return "DeleteAttachment";
        };
        DeleteAttachmentRequest.prototype.GetResponseXmlElementName = function () {
            return "DeleteAttachmentResponse";
        };
        DeleteAttachmentRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "DeleteAttachmentResponseMessage";
        };
        DeleteAttachmentRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "AttachmentIds");
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, "AttachmentId");
                    writer.WriteAttributeValue("Id", current.Id);
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        DeleteAttachmentRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            var list = new List();
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var jsonObject2 = new JsonObject();
                    jsonObject2.AddTypeParameter("AttachmentId");
                    jsonObject2.Add("Id", current.Id);
                    list.Add(jsonObject2);
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("AttachmentIds", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        DeleteAttachmentRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return DeleteAttachmentRequest;
    }(MultiResponseServiceRequest));
    var DeleteRequest = (function (_super) {
        __extends(DeleteRequest, _super);
        function DeleteRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.deleteMode = DeleteMode.SoftDelete;
        }
        Object.defineProperty(DeleteRequest.prototype, "DeleteMode", {
            get: function () {
                return this.deleteMode;
            },
            set: function (value) {
                this.deleteMode = value;
            },
            enumerable: true,
            configurable: true
        });
        DeleteRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("DeleteType", this.DeleteMode);
        };
        DeleteRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("DeleteType", DeleteMode[this.DeleteMode]);
            this.InternalToJson(jsonObject);
            return jsonObject;
        };
        DeleteRequest.prototype.InternalToJson = function (body) {
            throw new NotSupportedException();
        };
        return DeleteRequest;
    }(MultiResponseServiceRequest));
    var DeleteFolderRequest = (function (_super) {
        __extends(DeleteFolderRequest, _super);
        function DeleteFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folderIds = new FolderIdWrapperList();
        }
        Object.defineProperty(DeleteFolderRequest.prototype, "FolderIds", {
            get: function () {
                return this.folderIds;
            },
            enumerable: true,
            configurable: true
        });
        DeleteFolderRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.FolderIds, "FolderIds");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
        };
        DeleteFolderRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.FolderIds.Count;
        };
        DeleteFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        DeleteFolderRequest.prototype.GetXmlElementName = function () {
            return "DeleteFolder";
        };
        DeleteFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "DeleteFolderResponse";
        };
        DeleteFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "DeleteFolderResponseMessage";
        };
        DeleteFolderRequest.prototype.WriteElementsToXml = function (writer) {
            this.FolderIds.WriteToXml(writer, XmlNamespace.Messages, "FolderIds");
        };
        DeleteFolderRequest.prototype.InternalToJson = function (body) {
            body.Add("FolderIds", this.FolderIds.InternalToJson(this.Service));
        };
        DeleteFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return DeleteFolderRequest;
    }(DeleteRequest));
    var DeleteItemRequest = (function (_super) {
        __extends(DeleteItemRequest, _super);
        function DeleteItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.itemIds = new ItemIdWrapperList();
            this.affectedTaskOccurrences = null;
            this.sendCancellationsMode = null;
            this.SuppressReadReceipts = false;
        }
        Object.defineProperty(DeleteItemRequest.prototype, "ItemIds", {
            get: function () {
                return this.itemIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DeleteItemRequest.prototype, "AffectedTaskOccurrences", {
            get: function () {
                return this.affectedTaskOccurrences;
            },
            set: function (value) {
                this.affectedTaskOccurrences = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DeleteItemRequest.prototype, "SendCancellationsMode", {
            get: function () {
                return this.sendCancellationsMode;
            },
            set: function (value) {
                this.sendCancellationsMode = value;
            },
            enumerable: true,
            configurable: true
        });
        DeleteItemRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.ItemIds, "ItemIds");
            if (this.SuppressReadReceipts && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "SuppressReadReceipts", ExchangeVersion.Exchange2013));
            }
        };
        DeleteItemRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.itemIds.Count;
        };
        DeleteItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        DeleteItemRequest.prototype.GetXmlElementName = function () {
            return "DeleteItem";
        };
        DeleteItemRequest.prototype.GetResponseXmlElementName = function () {
            return "DeleteItemResponse";
        };
        DeleteItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "DeleteItemResponseMessage";
        };
        DeleteItemRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            if (this.AffectedTaskOccurrences !== null) {
                writer.WriteAttributeValue("AffectedTaskOccurrences", this.AffectedTaskOccurrences.Value);
            }
            if (this.SendCancellationsMode !== null) {
                writer.WriteAttributeValue("SendMeetingCancellations", this.SendCancellationsMode.Value);
            }
            if (this.SuppressReadReceipts) {
                writer.WriteAttributeValue("SuppressReadReceipts", true);
            }
        };
        DeleteItemRequest.prototype.WriteElementsToXml = function (writer) {
            this.itemIds.WriteToXml(writer, XmlNamespace.Messages, "ItemIds");
        };
        DeleteItemRequest.prototype.InternalToJson = function (body) {
            if (this.AffectedTaskOccurrences !== null) {
                body.Add("AffectedTaskOccurrences", this.AffectedTaskOccurrences.Value);
            }
            if (this.SendCancellationsMode !== null) {
                body.Add("SendMeetingCancellations", this.SendCancellationsMode.Value);
            }
            if (this.SuppressReadReceipts) {
                body.Add("SuppressReadReceipts", true);
            }
            if (this.ItemIds.Count > 0) {
                body.Add("ItemIds", this.ItemIds.InternalToJson(this.Service));
            }
        };
        DeleteItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return DeleteItemRequest;
    }(DeleteRequest));
    var DeleteUserConfigurationRequest = (function (_super) {
        __extends(DeleteUserConfigurationRequest, _super);
        function DeleteUserConfigurationRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.name = null;
            this.parentFolderId = null;
        }
        Object.defineProperty(DeleteUserConfigurationRequest.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DeleteUserConfigurationRequest.prototype, "ParentFolderId", {
            get: function () {
                return this.parentFolderId;
            },
            set: function (value) {
                this.parentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        DeleteUserConfigurationRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.name, "name");
            EwsUtilities.ValidateParam(this.parentFolderId, "parentFolderId");
            this.ParentFolderId.Validate(this.Service.RequestedServerVersion);
        };
        DeleteUserConfigurationRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        DeleteUserConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        DeleteUserConfigurationRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        DeleteUserConfigurationRequest.prototype.GetXmlElementName = function () {
            return "DeleteUserConfiguration";
        };
        DeleteUserConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "DeleteUserConfigurationResponse";
        };
        DeleteUserConfigurationRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "DeleteUserConfigurationResponseMessage";
        };
        DeleteUserConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            UserConfiguration.WriteUserConfigurationNameToXml(writer, XmlNamespace.Messages, this.name, this.parentFolderId);
        };
        DeleteUserConfigurationRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserConfigurationName", UserConfiguration.GetJsonUserConfigName(service, this.parentFolderId, this.name));
            return jsonObject;
        };
        return DeleteUserConfigurationRequest;
    }(MultiResponseServiceRequest));
    var DisableReasonType;
    (function (DisableReasonType) {
        DisableReasonType[DisableReasonType["NoReason"] = 0] = "NoReason";
        DisableReasonType[DisableReasonType["OutlookClientPerformance"] = 1] = "OutlookClientPerformance";
        DisableReasonType[DisableReasonType["OWAClientPerformance"] = 2] = "OWAClientPerformance";
        DisableReasonType[DisableReasonType["MobileClientPerformance"] = 3] = "MobileClientPerformance";
    })(DisableReasonType || (DisableReasonType = {}));
    var DisableAppRequest = (function (_super) {
        __extends(DisableAppRequest, _super);
        function DisableAppRequest(service, id, disableReason) {
            _super.call(this, service);
            this.Id = null;
            this.DisableReason = 0;
            this.Id = id;
            this.DisableReason = disableReason;
        }
        DisableAppRequest.prototype.GetXmlElementName = function () {
            return "DisableApp";
        };
        DisableAppRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "ID", this.Id);
            writer.WriteElementValue(XmlNamespace.Messages, "DisableReason", this.DisableReason);
        };
        DisableAppRequest.prototype.GetResponseXmlElementName = function () {
            return "DisableAppResponse";
        };
        DisableAppRequest.prototype.ParseResponse = function (reader) {
            var disableAppResponse = new DisableAppResponse();
            disableAppResponse.LoadFromXml(reader, "DisableAppResponse");
            return disableAppResponse;
        };
        DisableAppRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        DisableAppRequest.prototype.Execute = function () {
            var disableAppResponse = _super.prototype.InternalExecute.call(this);
            disableAppResponse.ThrowIfNecessary();
            return disableAppResponse;
        };
        return DisableAppRequest;
    }(SimpleServiceRequestBase));
    var DisconnectPhoneCallRequest = (function (_super) {
        __extends(DisconnectPhoneCallRequest, _super);
        function DisconnectPhoneCallRequest(service) {
            _super.call(this, service);
            this.id = null;
        }
        Object.defineProperty(DisconnectPhoneCallRequest.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        DisconnectPhoneCallRequest.prototype.GetXmlElementName = function () {
            return "DisconnectPhoneCall";
        };
        DisconnectPhoneCallRequest.prototype.WriteElementsToXml = function (writer) {
            this.id.WriteToXml(writer, XmlNamespace.Messages, "PhoneCallId");
        };
        DisconnectPhoneCallRequest.prototype.GetResponseXmlElementName = function () {
            return "DisconnectPhoneCallResponse";
        };
        DisconnectPhoneCallRequest.prototype.ParseResponse = function (reader) {
            var serviceResponse = new ServiceResponse();
            serviceResponse.LoadFromXml(reader, "DisconnectPhoneCallResponse");
            return serviceResponse;
        };
        DisconnectPhoneCallRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        DisconnectPhoneCallRequest.prototype.Execute = function () {
            var serviceResponse = _super.prototype.InternalExecute.call(this);
            serviceResponse.ThrowIfNecessary();
            return serviceResponse;
        };
        return DisconnectPhoneCallRequest;
    }(SimpleServiceRequestBase));
    var EmptyFolderRequest = (function (_super) {
        __extends(EmptyFolderRequest, _super);
        function EmptyFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folderIds = new FolderIdWrapperList();
            this.DeleteSubFolders = false;
        }
        Object.defineProperty(EmptyFolderRequest.prototype, "FolderIds", {
            get: function () {
                return this.folderIds;
            },
            enumerable: true,
            configurable: true
        });
        EmptyFolderRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.FolderIds, "FolderIds");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
        };
        EmptyFolderRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.FolderIds.Count;
        };
        EmptyFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        EmptyFolderRequest.prototype.GetXmlElementName = function () {
            return "EmptyFolder";
        };
        EmptyFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "EmptyFolderResponse";
        };
        EmptyFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "EmptyFolderResponseMessage";
        };
        EmptyFolderRequest.prototype.WriteElementsToXml = function (writer) {
            this.FolderIds.WriteToXml(writer, XmlNamespace.Messages, "FolderIds");
        };
        EmptyFolderRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("DeleteSubFolders", this.DeleteSubFolders);
        };
        EmptyFolderRequest.prototype.InternalToJson = function (body) {
            body.Add("DeleteSubFolders", this.DeleteSubFolders);
            body.Add("FolderIds", this.FolderIds.InternalToJson(this.Service));
        };
        EmptyFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        return EmptyFolderRequest;
    }(DeleteRequest));
    var ExecuteDiagnosticMethodRequest = (function (_super) {
        __extends(ExecuteDiagnosticMethodRequest, _super);
        function ExecuteDiagnosticMethodRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.Verb = null;
            this.Parameter = null;
        }
        ExecuteDiagnosticMethodRequest.prototype.GetXmlElementName = function () {
            return "ExecuteDiagnosticMethod";
        };
        ExecuteDiagnosticMethodRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "Verb", this.Verb);
            writer.WriteStartElement(XmlNamespace.Messages, "Parameter");
            writer.WriteNode(this.Parameter);
            writer.WriteEndElement();
        };
        ExecuteDiagnosticMethodRequest.prototype.GetResponseXmlElementName = function () {
            return "ExecuteDiagnosticMethodResponse";
        };
        ExecuteDiagnosticMethodRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        ExecuteDiagnosticMethodRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ExecuteDiagnosticMethodResponse(service);
        };
        ExecuteDiagnosticMethodRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ExecuteDiagnosticMethodResponseMessage";
        };
        ExecuteDiagnosticMethodRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        return ExecuteDiagnosticMethodRequest;
    }(MultiResponseServiceRequest));
    var ExpandGroupRequest = (function (_super) {
        __extends(ExpandGroupRequest, _super);
        function ExpandGroupRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.emailAddress = null;
        }
        Object.defineProperty(ExpandGroupRequest.prototype, "EmailAddress", {
            get: function () {
                return this.emailAddress;
            },
            set: function (value) {
                this.emailAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        ExpandGroupRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.EmailAddress, "EmailAddress");
        };
        ExpandGroupRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ExpandGroupResponse();
        };
        ExpandGroupRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        ExpandGroupRequest.prototype.GetXmlElementName = function () {
            return "ExpandDL";
        };
        ExpandGroupRequest.prototype.GetResponseXmlElementName = function () {
            return "ExpandDLResponse";
        };
        ExpandGroupRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ExpandDLResponseMessage";
        };
        ExpandGroupRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.EmailAddress !== null) {
                this.EmailAddress.WriteToXml(writer, XmlNamespace.Messages, "Mailbox");
            }
        };
        ExpandGroupRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return ExpandGroupRequest;
    }(MultiResponseServiceRequest));
    var FindConversationRequest = (function (_super) {
        __extends(FindConversationRequest, _super);
        function FindConversationRequest(service) {
            _super.call(this, service);
            this.view = null;
            this.folderId = null;
            this.queryString = null;
            this.returnHighlightTerms = false;
            this.mailboxScope = null;
        }
        Object.defineProperty(FindConversationRequest.prototype, "View", {
            get: function () {
                return this.view;
            },
            set: function (value) {
                this.view = value;
                if (this.view instanceof SeekToConditionItemView) {
                    this.view.SetServiceObjectType(ServiceObjectType.Conversation);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindConversationRequest.prototype, "FolderId", {
            get: function () {
                return this.folderId;
            },
            set: function (value) {
                this.folderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindConversationRequest.prototype, "QueryString", {
            get: function () {
                return this.queryString;
            },
            set: function (value) {
                this.queryString = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindConversationRequest.prototype, "ReturnHighlightTerms", {
            get: function () {
                return this.returnHighlightTerms;
            },
            set: function (value) {
                this.returnHighlightTerms = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindConversationRequest.prototype, "MailboxScope", {
            get: function () {
                return this.mailboxScope;
            },
            set: function (value) {
                this.mailboxScope = value;
            },
            enumerable: true,
            configurable: true
        });
        FindConversationRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            this.view.InternalValidate(this);
            if (!NString.IsNullOrEmpty(this.queryString) && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "queryString", ExchangeVersion.Exchange2013));
            }
            if (this.ReturnHighlightTerms && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "returnHighlightTerms", ExchangeVersion.Exchange2013));
            }
            if (this.View instanceof SeekToConditionItemView && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "SeekToConditionItemView", ExchangeVersion.Exchange2013));
            }
            if (this.MailboxScope !== null && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "MailboxScope", ExchangeVersion.Exchange2013));
            }
        };
        FindConversationRequest.prototype.WriteAttributesToXml = function (writer) {
            this.View.WriteAttributesToXml(writer);
        };
        FindConversationRequest.prototype.WriteElementsToXml = function (writer) {
            this.View.WriteToXml(writer, null);
            this.View.WriteOrderByToXml(writer);
            writer.WriteStartElement(XmlNamespace.Messages, "ParentFolderId");
            this.FolderId.WriteToXml(writer);
            writer.WriteEndElement();
            if (this.MailboxScope !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "MailboxScope", this.MailboxScope.Value);
            }
            if (!NString.IsNullOrEmpty(this.queryString)) {
                writer.WriteStartElement(XmlNamespace.Messages, "QueryString");
                if (this.ReturnHighlightTerms) {
                    writer.WriteAttributeString("ReturnHighlightTerms", NString.ToLowerInvariant(NBoolean.ToString(this.ReturnHighlightTerms)));
                }
                writer.WriteValue(this.queryString, "QueryString");
                writer.WriteEndElement();
            }
            if (this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013 && this.View.PropertySet !== null) {
                this.View.PropertySet.WriteToXml(writer, ServiceObjectType.Conversation);
            }
        };
        FindConversationRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Paging", this.View.WritePagingToJson(service));
            this.View.AddJsonProperties(jsonObject, service);
            var jsonObject2 = new JsonObject();
            jsonObject2.Add("BaseFolderId", this.FolderId.InternalToJson(service));
            jsonObject.Add("ParentFolderId", jsonObject2);
            if (this.MailboxScope !== null) {
                jsonObject.Add("MailboxScope", this.MailboxScope.Value);
            }
            if (!NString.IsNullOrEmpty(this.queryString)) {
                var jsonObject3 = new JsonObject();
                jsonObject3.Add("Value", this.QueryString);
                if (this.ReturnHighlightTerms) {
                    jsonObject3.Add("ReturnHighlightTerms", NString.ToLowerInvariant(NBoolean.ToString(this.ReturnHighlightTerms)));
                }
                jsonObject.Add("QueryString", jsonObject3);
            }
            if (this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013 && this.View.PropertySet !== null) {
                this.View.PropertySet.WriteGetShapeToJson(jsonObject, service, ServiceObjectType.Conversation);
            }
            return jsonObject;
        };
        FindConversationRequest.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        FindConversationRequest.prototype.ParseResponse_0 = function (reader) {
            var findConversationResponse = new FindConversationResponse();
            findConversationResponse.LoadFromXml(reader, "FindConversationResponse");
            return findConversationResponse;
        };
        FindConversationRequest.prototype.ParseResponse_1 = function (jsonBody) {
            var findConversationResponse = new FindConversationResponse();
            findConversationResponse.LoadFromJson(jsonBody, this.Service);
            return findConversationResponse;
        };
        FindConversationRequest.prototype.GetXmlElementName = function () {
            return "FindConversation";
        };
        FindConversationRequest.prototype.GetResponseXmlElementName = function () {
            return "FindConversationResponse";
        };
        FindConversationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        FindConversationRequest.prototype.Execute = function () {
            var findConversationResponse = _super.prototype.InternalExecute.call(this);
            findConversationResponse.ThrowIfNecessary();
            return findConversationResponse;
        };
        return FindConversationRequest;
    }(SimpleServiceRequestBase));
    var FindRequest = (function (_super) {
        __extends(FindRequest, _super);
        function FindRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.parentFolderIds = new FolderIdWrapperList();
            this.searchFilter = null;
            this.queryString = null;
            this.returnHighlightTerms = false;
            this.view = null;
        }
        Object.defineProperty(FindRequest.prototype, "ParentFolderIds", {
            get: function () {
                return this.parentFolderIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindRequest.prototype, "SearchFilter", {
            get: function () {
                return this.searchFilter;
            },
            set: function (value) {
                this.searchFilter = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindRequest.prototype, "QueryString", {
            get: function () {
                return this.queryString;
            },
            set: function (value) {
                this.queryString = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindRequest.prototype, "ReturnHighlightTerms", {
            get: function () {
                return this.returnHighlightTerms;
            },
            set: function (value) {
                this.returnHighlightTerms = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindRequest.prototype, "View", {
            get: function () {
                return this.view;
            },
            set: function (value) {
                this.view = value;
            },
            enumerable: true,
            configurable: true
        });
        FindRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            this.View.InternalValidate(this);
            if (!NString.IsNullOrEmpty(this.queryString) && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "queryString", ExchangeVersion.Exchange2010));
            }
            if (this.ReturnHighlightTerms && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "returnHighlightTerms", ExchangeVersion.Exchange2013));
            }
            if (this.View instanceof SeekToConditionItemView && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "SeekToConditionItemView", ExchangeVersion.Exchange2013));
            }
            if (!NString.IsNullOrEmpty(this.queryString) && this.searchFilter !== null) {
                throw new ServiceLocalException(Strings.BothSearchFilterAndQueryStringCannotBeSpecified);
            }
        };
        FindRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.ParentFolderIds.Count;
        };
        FindRequest.prototype.GetGroupBy = function () {
            return null;
        };
        FindRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            this.View.WriteAttributesToXml(writer);
        };
        FindRequest.prototype.WriteElementsToXml = function (writer) {
            this.View.WriteToXml(writer, this.GetGroupBy());
            if (this.SearchFilter !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "Restriction");
                this.SearchFilter.WriteToXml(writer);
                writer.WriteEndElement();
            }
            this.View.WriteOrderByToXml(writer);
            this.ParentFolderIds.WriteToXml(writer, XmlNamespace.Messages, "ParentFolderIds");
            if (!NString.IsNullOrEmpty(this.queryString)) {
                writer.WriteStartElement(XmlNamespace.Messages, "QueryString");
                if (this.ReturnHighlightTerms) {
                    writer.WriteAttributeString("ReturnHighlightTerms", NString.ToLowerInvariant(NBoolean.ToString(this.ReturnHighlightTerms)));
                }
                writer.WriteValue(this.queryString, "QueryString");
                writer.WriteEndElement();
            }
        };
        FindRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.View.WriteShapeToJson(jsonObject, service);
            jsonObject.Add("Paging", this.View.WritePagingToJson(service));
            var obj = this.View.WriteGroupingToJson(service, this.GetGroupBy());
            if (obj !== null) {
                jsonObject.Add("Grouping", obj);
            }
            this.View.AddJsonProperties(jsonObject, service);
            if (this.SearchFilter !== null) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("Item", this.SearchFilter.InternalToJson(service));
                jsonObject.Add("Restriction", jsonObject2);
            }
            jsonObject.Add("ParentFolderIds", this.ParentFolderIds.InternalToJson(service));
            if (!NString.IsNullOrEmpty(this.queryString)) {
                var jsonObject3 = new JsonObject();
                jsonObject3.Add("Value", this.QueryString);
                if (this.ReturnHighlightTerms) {
                    jsonObject3.Add("ReturnHighlightTerms", NString.ToLowerInvariant(NBoolean.ToString(this.ReturnHighlightTerms)));
                }
                jsonObject.Add("QueryString", jsonObject3);
            }
            return jsonObject;
        };
        return FindRequest;
    }(MultiResponseServiceRequest));
    var FindFolderRequest = (function (_super) {
        __extends(FindFolderRequest, _super);
        function FindFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        FindFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new FindFolderResponse(this.View.GetPropertySetOrDefault());
        };
        FindFolderRequest.prototype.GetXmlElementName = function () {
            return "FindFolder";
        };
        FindFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "FindFolderResponse";
        };
        FindFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "FindFolderResponseMessage";
        };
        FindFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return FindFolderRequest;
    }(FindRequest));
    var FindItemRequest = (function (_super) {
        __extends(FindItemRequest, _super);
        function FindItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.groupBy = null;
        }
        Object.defineProperty(FindItemRequest.prototype, "GroupBy", {
            get: function () {
                return this.groupBy;
            },
            set: function (value) {
                this.groupBy = value;
            },
            enumerable: true,
            configurable: true
        });
        FindItemRequest.prototype.GetGroupBy = function () {
            return this.GroupBy;
        };
        FindItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new FindItemResponse(this.GroupBy !== null, this.View.GetPropertySetOrDefault());
        };
        FindItemRequest.prototype.GetXmlElementName = function () {
            return "FindItem";
        };
        FindItemRequest.prototype.GetResponseXmlElementName = function () {
            return "FindItemResponse";
        };
        FindItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "FindItemResponseMessage";
        };
        FindItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return FindItemRequest;
    }(FindRequest));
    var GetAttachmentRequest = (function (_super) {
        __extends(GetAttachmentRequest, _super);
        function GetAttachmentRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.attachments = new List();
            this.attachmentIds = new List();
            this.additionalProperties = new List();
            this.bodyType = null;
        }
        Object.defineProperty(GetAttachmentRequest.prototype, "Attachments", {
            get: function () {
                return this.attachments;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetAttachmentRequest.prototype, "AttachmentIds", {
            get: function () {
                return this.attachmentIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetAttachmentRequest.prototype, "AdditionalProperties", {
            get: function () {
                return this.additionalProperties;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetAttachmentRequest.prototype, "BodyType", {
            get: function () {
                return this.bodyType;
            },
            set: function (value) {
                this.bodyType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetAttachmentRequest.prototype, "EmitTimeZoneHeader", {
            get: function () {
                return this.additionalProperties.Contains(ItemSchema.MimeContent);
            },
            enumerable: true,
            configurable: true
        });
        GetAttachmentRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.Attachments.Count > 0) {
                EwsUtilities.ValidateParamCollection(this.Attachments, "Attachments");
            }
            if (this.AttachmentIds.Count > 0) {
                EwsUtilities.ValidateParamCollection(this.AttachmentIds, "AttachmentIds");
            }
            if (this.AttachmentIds.Count === 0 && this.Attachments.Count === 0) {
                throw new ArgumentException(Strings.CollectionIsEmpty, "Attachments/AttachmentIds");
            }
            for (var i = 0; i < this.AdditionalProperties.Count; i = i + 1) {
                EwsUtilities.ValidateParam(this.AdditionalProperties.get_Item(i), NString.Format("AdditionalProperties[{0}]", i));
            }
        };
        GetAttachmentRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetAttachmentResponse((this.Attachments.Count > 0) ? this.Attachments.get_Item(responseIndex) : null);
        };
        GetAttachmentRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.Attachments.Count + this.AttachmentIds.Count;
        };
        GetAttachmentRequest.prototype.GetXmlElementName = function () {
            return "GetAttachment";
        };
        GetAttachmentRequest.prototype.GetResponseXmlElementName = function () {
            return "GetAttachmentResponse";
        };
        GetAttachmentRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetAttachmentResponseMessage";
        };
        GetAttachmentRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.BodyType !== null || this.AdditionalProperties.Count > 0) {
                writer.WriteStartElement(XmlNamespace.Messages, "AttachmentShape");
                if (this.BodyType !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "BodyType", this.BodyType.Value);
                }
                if (this.AdditionalProperties.Count > 0) {
                    PropertySet.WriteAdditionalPropertiesToXml(writer, this.AdditionalProperties);
                }
                writer.WriteEndElement();
            }
            writer.WriteStartElement(XmlNamespace.Messages, "AttachmentIds");
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.WriteAttachmentIdXml(writer, current.Id);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.AttachmentIds.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.WriteAttachmentIdXml(writer, current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            writer.WriteEndElement();
        };
        GetAttachmentRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.BodyType !== null || this.AdditionalProperties.Count > 0) {
                var jsonObject2 = new JsonObject();
                if (this.BodyType !== null) {
                    jsonObject2.Add("BodyType", this.BodyType.Value);
                }
                if (this.AdditionalProperties.Count > 0) {
                    PropertySet.WriteAdditionalPropertiesToJson(jsonObject2, service, this.AdditionalProperties);
                }
                jsonObject.Add("AttachmentShape", jsonObject2);
            }
            var list = new List();
            var enumerator = this.Attachments.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.AddJsonAttachmentIdToList(list, current.Id);
                }
            }
            finally {
                enumerator.Dispose();
            }
            var enumerator2 = this.AttachmentIds.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    this.AddJsonAttachmentIdToList(list, current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            jsonObject.Add("AttachmentIds", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        GetAttachmentRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        GetAttachmentRequest.prototype.WriteAttachmentIdXml = function (writer, attachmentId) {
            writer.WriteStartElement(XmlNamespace.Types, "AttachmentId");
            writer.WriteAttributeValue("Id", attachmentId);
            writer.WriteEndElement();
        };
        GetAttachmentRequest.prototype.AddJsonAttachmentIdToList = function (attachmentIds, attachmentId) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Id", attachmentId);
            attachmentIds.Add(jsonObject);
        };
        return GetAttachmentRequest;
    }(MultiResponseServiceRequest));
    var GetClientAccessTokenRequest = (function (_super) {
        __extends(GetClientAccessTokenRequest, _super);
        function GetClientAccessTokenRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.TokenRequests = null;
        }
        GetClientAccessTokenRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetClientAccessTokenResponse(this.TokenRequests[responseIndex].Id, this.TokenRequests[responseIndex].TokenType);
        };
        GetClientAccessTokenRequest.prototype.GetXmlElementName = function () {
            return "GetClientAccessToken";
        };
        GetClientAccessTokenRequest.prototype.GetResponseXmlElementName = function () {
            return "GetClientAccessTokenResponse";
        };
        GetClientAccessTokenRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetClientAccessTokenResponseMessage";
        };
        GetClientAccessTokenRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.TokenRequests.length;
        };
        GetClientAccessTokenRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "TokenRequests");
            var tokenRequests = this.TokenRequests;
            for (var i = 0; i < tokenRequests.length; i = i + 1) {
                var clientAccessTokenRequest = tokenRequests[i];
                writer.WriteStartElement(XmlNamespace.Types, "TokenRequest");
                writer.WriteElementValue(XmlNamespace.Types, "Id", clientAccessTokenRequest.Id);
                writer.WriteElementValue(XmlNamespace.Types, "TokenType", clientAccessTokenRequest.TokenType);
                if (!NString.IsNullOrEmpty(clientAccessTokenRequest.Scope)) {
                    writer.WriteElementValue(XmlNamespace.Types, "Scope", clientAccessTokenRequest.Scope);
                }
                writer.WriteEndElement();
            }
            writer.WriteEndElement();
        };
        GetClientAccessTokenRequest.prototype.ToJson = function (service) {
            var list = new List();
            var tokenRequests = this.TokenRequests;
            for (var i = 0; i < tokenRequests.length; i = i + 1) {
                var clientAccessTokenRequest = tokenRequests[i];
                var jsonObject = new JsonObject();
                jsonObject.AddTypeParameter("TokenRequest");
                jsonObject.Add("Id", clientAccessTokenRequest.Id);
                jsonObject.Add("TokenType", clientAccessTokenRequest.TokenType);
                if (!NString.IsNullOrEmpty(clientAccessTokenRequest.Scope)) {
                    jsonObject.Add("Scope", clientAccessTokenRequest.Scope);
                }
                list.Add(jsonObject);
            }
            var jsonObject2 = new JsonObject();
            jsonObject2.Add("TokenRequests", NArray.ToEnumerable(list.ToArray()));
            return jsonObject2;
        };
        GetClientAccessTokenRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.TokenRequests === null || this.TokenRequests.length === 0) {
                throw new ServiceValidationException(Strings.HoldIdParameterIsNotSpecified);
            }
        };
        GetClientAccessTokenRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        return GetClientAccessTokenRequest;
    }(MultiResponseServiceRequest));
    var GetClientExtensionRequest = (function (_super) {
        __extends(GetClientExtensionRequest, _super);
        function GetClientExtensionRequest(service, requestedExtensionIds, shouldReturnEnabledOnly, isUserScope, userId, userEnabledExtensionIds, userDisabledExtensionIds, isDebug) {
            _super.call(this, service);
            this.requestedExtensionIds = null;
            this.shouldReturnEnabledOnly = false;
            this.isUserScope = false;
            this.userId = null;
            this.userEnabledExtensionIds = null;
            this.userDisabledExtensionIds = null;
            this.isDebug = false;
            this.requestedExtensionIds = requestedExtensionIds;
            this.shouldReturnEnabledOnly = shouldReturnEnabledOnly;
            this.isUserScope = isUserScope;
            this.userId = userId;
            this.userEnabledExtensionIds = userEnabledExtensionIds;
            this.userDisabledExtensionIds = userDisabledExtensionIds;
            this.isDebug = isDebug;
        }
        GetClientExtensionRequest.prototype.GetXmlElementName = function () {
            return "GetClientExtension";
        };
        GetClientExtensionRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.requestedExtensionIds !== null && this.requestedExtensionIds.Count > 0) {
                writer.WriteStartElement(XmlNamespace.Messages, "RequestedExtensionIds");
                this.requestedExtensionIds.WriteElementsToXml(writer);
                writer.WriteEndElement();
            }
            if (this.isUserScope) {
                writer.WriteStartElement(XmlNamespace.Messages, "UserParameters");
                writer.WriteAttributeValue("UserId", this.userId);
                if (this.shouldReturnEnabledOnly) {
                    writer.WriteAttributeValue("EnabledOnly", this.shouldReturnEnabledOnly);
                }
                if (this.userEnabledExtensionIds !== null && this.userEnabledExtensionIds.Count > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "UserEnabledExtensions");
                    this.userEnabledExtensionIds.WriteElementsToXml(writer);
                    writer.WriteEndElement();
                }
                if (this.userDisabledExtensionIds !== null && this.userDisabledExtensionIds.Count > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "UserDisabledExtensions");
                    this.userDisabledExtensionIds.WriteElementsToXml(writer);
                    writer.WriteEndElement();
                }
                writer.WriteEndElement();
            }
            if (this.isDebug) {
                writer.WriteElementValue(XmlNamespace.Messages, "IsDebug", this.isDebug);
            }
        };
        GetClientExtensionRequest.prototype.GetResponseXmlElementName = function () {
            return "GetClientExtensionResponse";
        };
        GetClientExtensionRequest.prototype.ParseResponse = function (reader) {
            var getClientExtensionResponse = new GetClientExtensionResponse();
            getClientExtensionResponse.LoadFromXml(reader, "GetClientExtensionResponse");
            return getClientExtensionResponse;
        };
        GetClientExtensionRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetClientExtensionRequest.prototype.Execute = function () {
            var getClientExtensionResponse = _super.prototype.InternalExecute.call(this);
            getClientExtensionResponse.ThrowIfNecessary();
            return getClientExtensionResponse;
        };
        return GetClientExtensionRequest;
    }(SimpleServiceRequestBase));
    var GetEncryptionConfigurationRequest = (function (_super) {
        __extends(GetEncryptionConfigurationRequest, _super);
        function GetEncryptionConfigurationRequest(service) {
            _super.call(this, service);
        }
        GetEncryptionConfigurationRequest.prototype.GetXmlElementName = function () {
            return "GetEncryptionConfiguration";
        };
        GetEncryptionConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
        };
        GetEncryptionConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "GetEncryptionConfigurationResponse";
        };
        GetEncryptionConfigurationRequest.prototype.ParseResponse = function (reader) {
            var getEncryptionConfigurationResponse = new GetEncryptionConfigurationResponse();
            getEncryptionConfigurationResponse.LoadFromXml(reader, "GetEncryptionConfigurationResponse");
            return getEncryptionConfigurationResponse;
        };
        GetEncryptionConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetEncryptionConfigurationRequest.prototype.Execute = function () {
            var getEncryptionConfigurationResponse = _super.prototype.InternalExecute.call(this);
            getEncryptionConfigurationResponse.ThrowIfNecessary();
            return getEncryptionConfigurationResponse;
        };
        return GetEncryptionConfigurationRequest;
    }(SimpleServiceRequestBase));
    var GetAppManifestsRequest = (function (_super) {
        __extends(GetAppManifestsRequest, _super);
        function GetAppManifestsRequest(service) {
            _super.call(this, service);
            this.ApiVersionSupported = null;
            this.SchemaVersionSupported = null;
        }
        GetAppManifestsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.ApiVersionSupported, "ApiVersionSupported");
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.SchemaVersionSupported, "SchemaVersionSupported");
        };
        GetAppManifestsRequest.prototype.GetXmlElementName = function () {
            return "GetAppManifests";
        };
        GetAppManifestsRequest.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.ApiVersionSupported)) {
                writer.WriteElementValue(XmlNamespace.Messages, "ApiVersionSupported", this.ApiVersionSupported);
            }
            if (!NString.IsNullOrEmpty(this.SchemaVersionSupported)) {
                writer.WriteElementValue(XmlNamespace.Messages, "SchemaVersionSupported", this.SchemaVersionSupported);
            }
        };
        GetAppManifestsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetAppManifestsResponse";
        };
        GetAppManifestsRequest.prototype.ParseResponse = function (reader) {
            var getAppManifestsResponse = new GetAppManifestsResponse();
            getAppManifestsResponse.LoadFromXml(reader, "GetAppManifestsResponse");
            return getAppManifestsResponse;
        };
        GetAppManifestsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetAppManifestsRequest.prototype.Execute = function () {
            var getAppManifestsResponse = _super.prototype.InternalExecute.call(this);
            getAppManifestsResponse.ThrowIfNecessary();
            return getAppManifestsResponse;
        };
        return GetAppManifestsRequest;
    }(SimpleServiceRequestBase));
    var GetAppMarketplaceUrlRequest = (function (_super) {
        __extends(GetAppMarketplaceUrlRequest, _super);
        function GetAppMarketplaceUrlRequest(service) {
            _super.call(this, service);
            this.ApiVersionSupported = null;
            this.SchemaVersionSupported = null;
        }
        GetAppMarketplaceUrlRequest.prototype.GetXmlElementName = function () {
            return "GetAppMarketplaceUrl";
        };
        GetAppMarketplaceUrlRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.ApiVersionSupported, "ApiVersionSupported");
            EwsUtilities.ValidateNonBlankStringParamAllowNull(this.SchemaVersionSupported, "SchemaVersionSupported");
        };
        GetAppMarketplaceUrlRequest.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.ApiVersionSupported)) {
                writer.WriteElementValue(XmlNamespace.Messages, "ApiVersionSupported", this.ApiVersionSupported);
            }
            if (!NString.IsNullOrEmpty(this.SchemaVersionSupported)) {
                writer.WriteElementValue(XmlNamespace.Messages, "SchemaVersionSupported", this.SchemaVersionSupported);
            }
        };
        GetAppMarketplaceUrlRequest.prototype.GetResponseXmlElementName = function () {
            return "GetAppMarketplaceUrlResponse";
        };
        GetAppMarketplaceUrlRequest.prototype.ParseResponse = function (reader) {
            var getAppMarketplaceUrlResponse = new GetAppMarketplaceUrlResponse();
            getAppMarketplaceUrlResponse.LoadFromXml(reader, "GetAppMarketplaceUrlResponse");
            return getAppMarketplaceUrlResponse;
        };
        GetAppMarketplaceUrlRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetAppMarketplaceUrlRequest.prototype.Execute = function () {
            var getAppMarketplaceUrlResponse = _super.prototype.InternalExecute.call(this);
            getAppMarketplaceUrlResponse.ThrowIfNecessary();
            return getAppMarketplaceUrlResponse;
        };
        return GetAppMarketplaceUrlRequest;
    }(SimpleServiceRequestBase));
    var GetConversationItemsRequest = (function (_super) {
        __extends(GetConversationItemsRequest, _super);
        function GetConversationItemsRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.Conversations = null;
            this.ItemProperties = null;
            this.FoldersToIgnore = null;
            this.MaxItemsToReturn = null;
            this.SortOrder = null;
            this.MailboxScope = null;
        }
        GetConversationItemsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.MailboxScope !== null && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "MailboxScope", ExchangeVersion.Exchange2013));
            }
        };
        GetConversationItemsRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
        };
        GetConversationItemsRequest.prototype.WriteElementsToXml = function (writer) {
            this.ItemProperties.WriteToXml(writer, ServiceObjectType.Item);
            this.FoldersToIgnore.WriteToXml(writer, XmlNamespace.Messages, "FoldersToIgnore");
            if (this.MaxItemsToReturn !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "MaxItemsToReturn", this.MaxItemsToReturn.Value);
            }
            if (this.SortOrder !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "SortOrder", this.SortOrder.Value);
            }
            if (this.MailboxScope !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "MailboxScope", this.MailboxScope.Value);
            }
            writer.WriteStartElement(XmlNamespace.Messages, "Conversations");
            this.Conversations.ForEach(function (conversation) {
                conversation.WriteToXml(writer, "Conversation");
            });
            writer.WriteEndElement();
        };
        GetConversationItemsRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.ItemProperties.WriteGetShapeToJson(jsonObject, service, ServiceObjectType.Item);
            if (this.FoldersToIgnore.Count > 0) {
                jsonObject.Add("FoldersToIgnore", this.FoldersToIgnore.InternalToJson(service));
            }
            if (this.MaxItemsToReturn !== null) {
                jsonObject.Add("MaxItemsToReturn", this.MaxItemsToReturn.Value);
            }
            if (this.SortOrder !== null) {
                jsonObject.Add("SortOrder", this.SortOrder.Value);
            }
            if (this.MailboxScope !== null) {
                jsonObject.Add("MailboxScope", this.MailboxScope.Value);
            }
            var jsonPropertyCollection = new List();
            this.Conversations.ForEach(function (conversation) {
                jsonPropertyCollection.Add(conversation.InternalToJson(service));
            });
            jsonObject.Add("Conversations", NArray.ToEnumerable(jsonPropertyCollection.ToArray()));
            return jsonObject;
        };
        GetConversationItemsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetConversationItemsResponse(this.ItemProperties);
        };
        GetConversationItemsRequest.prototype.GetXmlElementName = function () {
            return "GetConversationItems";
        };
        GetConversationItemsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetConversationItemsResponse";
        };
        GetConversationItemsRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetConversationItemsResponseMessage";
        };
        GetConversationItemsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetConversationItemsRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.Conversations.Count;
        };
        return GetConversationItemsRequest;
    }(MultiResponseServiceRequest));
    var GetDelegateRequest = (function (_super) {
        __extends(GetDelegateRequest, _super);
        function GetDelegateRequest(service) {
            _super.call(this, service);
            this.userIds = new List();
            this.includePermissions = false;
        }
        Object.defineProperty(GetDelegateRequest.prototype, "UserIds", {
            get: function () {
                return this.userIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDelegateRequest.prototype, "IncludePermissions", {
            get: function () {
                return this.includePermissions;
            },
            set: function (value) {
                this.includePermissions = value;
            },
            enumerable: true,
            configurable: true
        });
        GetDelegateRequest.prototype.CreateResponse = function () {
            return new GetDelegateResponse(true);
        };
        GetDelegateRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("IncludePermissions", this.IncludePermissions);
        };
        GetDelegateRequest.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            if (this.UserIds.Count > 0) {
                writer.WriteStartElement(XmlNamespace.Messages, "UserIds");
                var enumerator = this.UserIds.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        current.WriteToXml(writer, "UserId");
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                writer.WriteEndElement();
            }
        };
        GetDelegateRequest.prototype.GetResponseXmlElementName = function () {
            return "GetDelegateResponse";
        };
        GetDelegateRequest.prototype.GetXmlElementName = function () {
            return "GetDelegate";
        };
        GetDelegateRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return GetDelegateRequest;
    }(DelegateManagementRequestBase));
    var GetDiscoverySearchConfigurationRequest = (function (_super) {
        __extends(GetDiscoverySearchConfigurationRequest, _super);
        function GetDiscoverySearchConfigurationRequest(service) {
            _super.call(this, service);
            this.SearchId = null;
            this.ExpandGroupMembership = false;
            this.InPlaceHoldConfigurationOnly = false;
        }
        GetDiscoverySearchConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "GetDiscoverySearchConfigurationResponse";
        };
        GetDiscoverySearchConfigurationRequest.prototype.GetXmlElementName = function () {
            return "GetDiscoverySearchConfiguration";
        };
        GetDiscoverySearchConfigurationRequest.prototype.ParseResponse = function (reader) {
            var getDiscoverySearchConfigurationResponse = new GetDiscoverySearchConfigurationResponse();
            getDiscoverySearchConfigurationResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getDiscoverySearchConfigurationResponse;
        };
        GetDiscoverySearchConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "SearchId", this.SearchId || NString.Empty);
            writer.WriteElementValue(XmlNamespace.Messages, "ExpandGroupMembership", NBoolean.ToString(this.ExpandGroupMembership).ToLower());
            writer.WriteElementValue(XmlNamespace.Messages, "InPlaceHoldConfigurationOnly", NBoolean.ToString(this.InPlaceHoldConfigurationOnly).ToLower());
        };
        GetDiscoverySearchConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetDiscoverySearchConfigurationRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetDiscoverySearchConfigurationRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetDiscoverySearchConfigurationRequest;
    }(SimpleServiceRequestBase));
    var GetEventsRequest = (function (_super) {
        __extends(GetEventsRequest, _super);
        function GetEventsRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.subscriptionId = null;
            this.watermark = null;
        }
        Object.defineProperty(GetEventsRequest.prototype, "SubscriptionId", {
            get: function () {
                return this.subscriptionId;
            },
            set: function (value) {
                this.subscriptionId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsRequest.prototype, "Watermark", {
            get: function () {
                return this.watermark;
            },
            set: function (value) {
                this.watermark = value;
            },
            enumerable: true,
            configurable: true
        });
        GetEventsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetEventsResponse();
        };
        GetEventsRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        GetEventsRequest.prototype.GetXmlElementName = function () {
            return "GetEvents";
        };
        GetEventsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetEventsResponse";
        };
        GetEventsRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetEventsResponseMessage";
        };
        GetEventsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateNonBlankStringParam(this.SubscriptionId, "SubscriptionId");
            EwsUtilities.ValidateNonBlankStringParam(this.Watermark, "Watermark");
        };
        GetEventsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "SubscriptionId", this.SubscriptionId);
            writer.WriteElementValue(XmlNamespace.Messages, "Watermark", this.Watermark);
        };
        GetEventsRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("SubscriptionId", this.SubscriptionId);
            jsonObject.Add("Watermark", this.Watermark);
            return jsonObject;
        };
        GetEventsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return GetEventsRequest;
    }(MultiResponseServiceRequest));
    var GetRequest = (function (_super) {
        __extends(GetRequest, _super);
        function GetRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.propertySet = null;
        }
        Object.defineProperty(GetRequest.prototype, "PropertySet", {
            get: function () {
                return this.propertySet;
            },
            set: function (value) {
                this.propertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        GetRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.PropertySet, "PropertySet");
            this.PropertySet.ValidateForRequest(this, false);
        };
        GetRequest.prototype.GetServiceObjectType = function () {
            throw new NotSupportedException();
        };
        GetRequest.prototype.WriteElementsToXml = function (writer) {
            this.propertySet.WriteToXml(writer, this.GetServiceObjectType());
        };
        GetRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.propertySet.WriteGetShapeToJson(jsonObject, service, this.GetServiceObjectType());
            this.AddIdsToRequest(jsonObject, service);
            return jsonObject;
        };
        GetRequest.prototype.AddIdsToRequest = function (jsonRequest, service) {
            throw new NotSupportedException();
        };
        return GetRequest;
    }(MultiResponseServiceRequest));
    var GetFolderRequestBase = (function (_super) {
        __extends(GetFolderRequestBase, _super);
        function GetFolderRequestBase(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folderIds = new FolderIdWrapperList();
        }
        Object.defineProperty(GetFolderRequestBase.prototype, "FolderIds", {
            get: function () {
                return this.folderIds;
            },
            enumerable: true,
            configurable: true
        });
        GetFolderRequestBase.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.FolderIds, "FolderIds");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
        };
        GetFolderRequestBase.prototype.GetExpectedResponseMessageCount = function () {
            return this.FolderIds.Count;
        };
        GetFolderRequestBase.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Folder;
        };
        GetFolderRequestBase.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            this.FolderIds.WriteToXml(writer, XmlNamespace.Messages, "FolderIds");
        };
        GetFolderRequestBase.prototype.AddIdsToRequest = function (jsonRequest, service) {
            jsonRequest.Add("FolderIds", this.FolderIds.InternalToJson(service));
        };
        GetFolderRequestBase.prototype.GetXmlElementName = function () {
            return "GetFolder";
        };
        GetFolderRequestBase.prototype.GetResponseXmlElementName = function () {
            return "GetFolderResponse";
        };
        GetFolderRequestBase.prototype.GetResponseMessageXmlElementName = function () {
            return "GetFolderResponseMessage";
        };
        GetFolderRequestBase.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return GetFolderRequestBase;
    }(GetRequest));
    var GetFolderRequest = (function (_super) {
        __extends(GetFolderRequest, _super);
        function GetFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        GetFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetFolderResponse(this.FolderIds.get_Item(responseIndex).GetFolder(), this.PropertySet);
        };
        return GetFolderRequest;
    }(GetFolderRequestBase));
    var GetFolderRequestForLoad = (function (_super) {
        __extends(GetFolderRequestForLoad, _super);
        function GetFolderRequestForLoad(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        GetFolderRequestForLoad.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetFolderResponse(this.FolderIds.get_Item(responseIndex).GetFolder(), this.PropertySet);
        };
        return GetFolderRequestForLoad;
    }(GetFolderRequestBase));
    var GetHoldOnMailboxesRequest = (function (_super) {
        __extends(GetHoldOnMailboxesRequest, _super);
        function GetHoldOnMailboxesRequest(service) {
            _super.call(this, service);
            this.HoldId = null;
        }
        GetHoldOnMailboxesRequest.prototype.GetResponseXmlElementName = function () {
            return "GetHoldOnMailboxesResponse";
        };
        GetHoldOnMailboxesRequest.prototype.GetXmlElementName = function () {
            return "GetHoldOnMailboxes";
        };
        GetHoldOnMailboxesRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (NString.IsNullOrEmpty(this.HoldId)) {
                throw new ServiceValidationException(Strings.HoldIdParameterIsNotSpecified);
            }
        };
        GetHoldOnMailboxesRequest.prototype.ParseResponse = function (reader) {
            var getHoldOnMailboxesResponse = new GetHoldOnMailboxesResponse();
            getHoldOnMailboxesResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getHoldOnMailboxesResponse;
        };
        GetHoldOnMailboxesRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "HoldId", this.HoldId);
        };
        GetHoldOnMailboxesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetHoldOnMailboxesRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetHoldOnMailboxesRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetHoldOnMailboxesRequest;
    }(SimpleServiceRequestBase));
    var GetInboxRulesRequest = (function (_super) {
        __extends(GetInboxRulesRequest, _super);
        function GetInboxRulesRequest(service) {
            _super.call(this, service);
            this.mailboxSmtpAddress = null;
        }
        Object.defineProperty(GetInboxRulesRequest.prototype, "MailboxSmtpAddress", {
            get: function () {
                return this.mailboxSmtpAddress;
            },
            set: function (value) {
                this.mailboxSmtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        GetInboxRulesRequest.prototype.GetXmlElementName = function () {
            return "GetInboxRules";
        };
        GetInboxRulesRequest.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.mailboxSmtpAddress)) {
                writer.WriteElementValue(XmlNamespace.Messages, "MailboxSmtpAddress", this.mailboxSmtpAddress);
            }
        };
        GetInboxRulesRequest.prototype.GetResponseXmlElementName = function () {
            return "GetInboxRulesResponse";
        };
        GetInboxRulesRequest.prototype.ParseResponse = function (reader) {
            var getInboxRulesResponse = new GetInboxRulesResponse();
            getInboxRulesResponse.LoadFromXml(reader, "GetInboxRulesResponse");
            return getInboxRulesResponse;
        };
        GetInboxRulesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        GetInboxRulesRequest.prototype.Execute = function () {
            var getInboxRulesResponse = _super.prototype.InternalExecute.call(this);
            getInboxRulesResponse.ThrowIfNecessary();
            return getInboxRulesResponse;
        };
        return GetInboxRulesRequest;
    }(SimpleServiceRequestBase));
    var GetItemRequestBase = (function (_super) {
        __extends(GetItemRequestBase, _super);
        function GetItemRequestBase(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.itemIds = new ItemIdWrapperList();
        }
        Object.defineProperty(GetItemRequestBase.prototype, "ItemIds", {
            get: function () {
                return this.itemIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetItemRequestBase.prototype, "EmitTimeZoneHeader", {
            get: function () {
                return this.PropertySet.Contains(ItemSchema.MimeContent);
            },
            enumerable: true,
            configurable: true
        });
        GetItemRequestBase.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.ItemIds, "ItemIds");
        };
        GetItemRequestBase.prototype.GetExpectedResponseMessageCount = function () {
            return this.ItemIds.Count;
        };
        GetItemRequestBase.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Item;
        };
        GetItemRequestBase.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            this.ItemIds.WriteToXml(writer, XmlNamespace.Messages, "ItemIds");
        };
        GetItemRequestBase.prototype.AddIdsToRequest = function (jsonRequest, service) {
            jsonRequest.Add("ItemIds", this.ItemIds.InternalToJson(service));
        };
        GetItemRequestBase.prototype.GetXmlElementName = function () {
            return "GetItem";
        };
        GetItemRequestBase.prototype.GetResponseXmlElementName = function () {
            return "GetItemResponse";
        };
        GetItemRequestBase.prototype.GetResponseMessageXmlElementName = function () {
            return "GetItemResponseMessage";
        };
        GetItemRequestBase.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return GetItemRequestBase;
    }(GetRequest));
    var GetItemRequest = (function (_super) {
        __extends(GetItemRequest, _super);
        function GetItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        GetItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetItemResponse(this.ItemIds.get_Item(responseIndex), this.PropertySet);
        };
        return GetItemRequest;
    }(GetItemRequestBase));
    var GetItemRequestForLoad = (function (_super) {
        __extends(GetItemRequestForLoad, _super);
        function GetItemRequestForLoad(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        GetItemRequestForLoad.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetItemResponse(this.ItemIds.get_Item(responseIndex), this.PropertySet);
        };
        return GetItemRequestForLoad;
    }(GetItemRequestBase));
    var GetNonIndexableItemDetailsRequest = (function (_super) {
        __extends(GetNonIndexableItemDetailsRequest, _super);
        function GetNonIndexableItemDetailsRequest(service) {
            _super.call(this, service);
            this.Mailboxes = null;
            this.PageSize = null;
            this.PageItemReference = null;
            this.PageDirection = null;
            this.SearchArchiveOnly = false;
        }
        GetNonIndexableItemDetailsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetNonIndexableItemDetailsResponse";
        };
        GetNonIndexableItemDetailsRequest.prototype.GetXmlElementName = function () {
            return "GetNonIndexableItemDetails";
        };
        GetNonIndexableItemDetailsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.Mailboxes === null || this.Mailboxes.length === 0) {
                throw new ServiceValidationException(Strings.MailboxesParameterIsNotSpecified);
            }
        };
        GetNonIndexableItemDetailsRequest.prototype.ParseResponse = function (reader) {
            var getNonIndexableItemDetailsResponse = new GetNonIndexableItemDetailsResponse();
            getNonIndexableItemDetailsResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getNonIndexableItemDetailsResponse;
        };
        GetNonIndexableItemDetailsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "Mailboxes");
            var mailboxes = this.Mailboxes;
            for (var i = 0; i < mailboxes.length; i = i + 1) {
                var value = mailboxes[i];
                writer.WriteElementValue(XmlNamespace.Types, "LegacyDN", value);
            }
            writer.WriteEndElement();
            if (this.PageSize !== null && this.PageSize !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "PageSize", NNumber.ToString(this.PageSize.Value));
            }
            if (!NString.IsNullOrEmpty(this.PageItemReference)) {
                writer.WriteElementValue(XmlNamespace.Messages, "PageItemReference", this.PageItemReference);
            }
            if (this.PageDirection !== null && this.PageDirection !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "PageDirection", SearchPageDirection[this.PageDirection.Value]);
            }
            writer.WriteElementValue(XmlNamespace.Messages, "SearchArchiveOnly", this.SearchArchiveOnly);
        };
        GetNonIndexableItemDetailsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetNonIndexableItemDetailsRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetNonIndexableItemDetailsRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetNonIndexableItemDetailsRequest;
    }(SimpleServiceRequestBase));
    var GetNonIndexableItemStatisticsRequest = (function (_super) {
        __extends(GetNonIndexableItemStatisticsRequest, _super);
        function GetNonIndexableItemStatisticsRequest(service) {
            _super.call(this, service);
            this.Mailboxes = null;
            this.SearchArchiveOnly = false;
        }
        GetNonIndexableItemStatisticsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetNonIndexableItemStatisticsResponse";
        };
        GetNonIndexableItemStatisticsRequest.prototype.GetXmlElementName = function () {
            return "GetNonIndexableItemStatistics";
        };
        GetNonIndexableItemStatisticsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.Mailboxes === null || this.Mailboxes.length === 0) {
                throw new ServiceValidationException(Strings.MailboxesParameterIsNotSpecified);
            }
        };
        GetNonIndexableItemStatisticsRequest.prototype.ParseResponse = function (reader) {
            var getNonIndexableItemStatisticsResponse = new GetNonIndexableItemStatisticsResponse();
            getNonIndexableItemStatisticsResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getNonIndexableItemStatisticsResponse;
        };
        GetNonIndexableItemStatisticsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "Mailboxes");
            var mailboxes = this.Mailboxes;
            for (var i = 0; i < mailboxes.length; i = i + 1) {
                var value = mailboxes[i];
                writer.WriteElementValue(XmlNamespace.Types, "LegacyDN", value);
            }
            writer.WriteEndElement();
            writer.WriteElementValue(XmlNamespace.Messages, "SearchArchiveOnly", this.SearchArchiveOnly);
        };
        GetNonIndexableItemStatisticsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetNonIndexableItemStatisticsRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetNonIndexableItemStatisticsRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetNonIndexableItemStatisticsRequest;
    }(SimpleServiceRequestBase));
    var GetPasswordExpirationDateRequest = (function (_super) {
        __extends(GetPasswordExpirationDateRequest, _super);
        function GetPasswordExpirationDateRequest(service) {
            _super.call(this, service);
            this.mailboxSmtpAddress = null;
        }
        Object.defineProperty(GetPasswordExpirationDateRequest.prototype, "MailboxSmtpAddress", {
            get: function () {
                return this.mailboxSmtpAddress;
            },
            set: function (value) {
                this.mailboxSmtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        GetPasswordExpirationDateRequest.prototype.GetXmlElementName = function () {
            return "GetPasswordExpirationDate";
        };
        GetPasswordExpirationDateRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "MailboxSmtpAddress", this.MailboxSmtpAddress);
        };
        GetPasswordExpirationDateRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("MailboxSmtpAddress", this.MailboxSmtpAddress);
            return jsonObject;
        };
        GetPasswordExpirationDateRequest.prototype.GetResponseXmlElementName = function () {
            return "GetPasswordExpirationDateResponse";
        };
        GetPasswordExpirationDateRequest.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        GetPasswordExpirationDateRequest.prototype.ParseResponse_0 = function (reader) {
            var getPasswordExpirationDateResponse = new GetPasswordExpirationDateResponse();
            getPasswordExpirationDateResponse.LoadFromXml(reader, "GetPasswordExpirationDateResponse");
            return getPasswordExpirationDateResponse;
        };
        GetPasswordExpirationDateRequest.prototype.ParseResponse_1 = function (jsonBody) {
            var getPasswordExpirationDateResponse = new GetPasswordExpirationDateResponse();
            getPasswordExpirationDateResponse.LoadFromJson(jsonBody, this.Service);
            return getPasswordExpirationDateResponse;
        };
        GetPasswordExpirationDateRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        GetPasswordExpirationDateRequest.prototype.Execute = function () {
            var getPasswordExpirationDateResponse = _super.prototype.InternalExecute.call(this);
            getPasswordExpirationDateResponse.ThrowIfNecessary();
            return getPasswordExpirationDateResponse;
        };
        return GetPasswordExpirationDateRequest;
    }(SimpleServiceRequestBase));
    var GetPhoneCallRequest = (function (_super) {
        __extends(GetPhoneCallRequest, _super);
        function GetPhoneCallRequest(service) {
            _super.call(this, service);
            this.id = null;
        }
        Object.defineProperty(GetPhoneCallRequest.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        GetPhoneCallRequest.prototype.GetXmlElementName = function () {
            return "GetPhoneCallInformation";
        };
        GetPhoneCallRequest.prototype.WriteElementsToXml = function (writer) {
            this.id.WriteToXml(writer, XmlNamespace.Messages, "PhoneCallId");
        };
        GetPhoneCallRequest.prototype.GetResponseXmlElementName = function () {
            return "GetPhoneCallInformationResponse";
        };
        GetPhoneCallRequest.prototype.ParseResponse = function (reader) {
            var getPhoneCallResponse = new GetPhoneCallResponse(this.Service);
            getPhoneCallResponse.LoadFromXml(reader, "GetPhoneCallInformationResponse");
            return getPhoneCallResponse;
        };
        GetPhoneCallRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        GetPhoneCallRequest.prototype.Execute = function () {
            var getPhoneCallResponse = _super.prototype.InternalExecute.call(this);
            getPhoneCallResponse.ThrowIfNecessary();
            return getPhoneCallResponse;
        };
        return GetPhoneCallRequest;
    }(SimpleServiceRequestBase));
    var GetRoomListsRequest = (function (_super) {
        __extends(GetRoomListsRequest, _super);
        function GetRoomListsRequest(service) {
            _super.call(this, service);
        }
        GetRoomListsRequest.prototype.GetXmlElementName = function () {
            return "GetRoomLists";
        };
        GetRoomListsRequest.prototype.WriteElementsToXml = function (writer) {
        };
        GetRoomListsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetRoomListsResponse";
        };
        GetRoomListsRequest.prototype.ParseResponse = function (reader) {
            var getRoomListsResponse = new GetRoomListsResponse();
            getRoomListsResponse.LoadFromXml(reader, "GetRoomListsResponse");
            return getRoomListsResponse;
        };
        GetRoomListsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        GetRoomListsRequest.prototype.Execute = function () {
            var getRoomListsResponse = _super.prototype.InternalExecute.call(this);
            getRoomListsResponse.ThrowIfNecessary();
            return getRoomListsResponse;
        };
        return GetRoomListsRequest;
    }(SimpleServiceRequestBase));
    var GetRoomsRequest = (function (_super) {
        __extends(GetRoomsRequest, _super);
        function GetRoomsRequest(service) {
            _super.call(this, service);
            this.roomList = null;
        }
        Object.defineProperty(GetRoomsRequest.prototype, "RoomList", {
            get: function () {
                return this.roomList;
            },
            set: function (value) {
                this.roomList = value;
            },
            enumerable: true,
            configurable: true
        });
        GetRoomsRequest.prototype.GetXmlElementName = function () {
            return "GetRooms";
        };
        GetRoomsRequest.prototype.WriteElementsToXml = function (writer) {
            this.RoomList.WriteToXml(writer, XmlNamespace.Messages, "RoomList");
        };
        GetRoomsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetRoomsResponse";
        };
        GetRoomsRequest.prototype.ParseResponse = function (reader) {
            var getRoomsResponse = new GetRoomsResponse();
            getRoomsResponse.LoadFromXml(reader, "GetRoomsResponse");
            return getRoomsResponse;
        };
        GetRoomsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        GetRoomsRequest.prototype.Execute = function () {
            var getRoomsResponse = _super.prototype.InternalExecute.call(this);
            getRoomsResponse.ThrowIfNecessary();
            return getRoomsResponse;
        };
        return GetRoomsRequest;
    }(SimpleServiceRequestBase));
    var GetSearchableMailboxesRequest = (function (_super) {
        __extends(GetSearchableMailboxesRequest, _super);
        function GetSearchableMailboxesRequest(service) {
            _super.call(this, service);
            this.SearchFilter = null;
            this.ExpandGroupMembership = false;
        }
        GetSearchableMailboxesRequest.prototype.GetResponseXmlElementName = function () {
            return "GetSearchableMailboxesResponse";
        };
        GetSearchableMailboxesRequest.prototype.GetXmlElementName = function () {
            return "GetSearchableMailboxes";
        };
        GetSearchableMailboxesRequest.prototype.ParseResponse = function (reader) {
            var getSearchableMailboxesResponse = new GetSearchableMailboxesResponse();
            getSearchableMailboxesResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getSearchableMailboxesResponse;
        };
        GetSearchableMailboxesRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "SearchFilter", this.SearchFilter || NString.Empty);
            writer.WriteElementValue(XmlNamespace.Messages, "ExpandGroupMembership", NBoolean.ToString(this.ExpandGroupMembership).ToLower());
        };
        GetSearchableMailboxesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetSearchableMailboxesRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetSearchableMailboxesRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetSearchableMailboxesRequest;
    }(SimpleServiceRequestBase));
    var GetServerTimeZonesRequest = (function (_super) {
        __extends(GetServerTimeZonesRequest, _super);
        function GetServerTimeZonesRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.ids = null;
        }
        Object.defineProperty(GetServerTimeZonesRequest.prototype, "Ids", {
            get: function () {
                return this.ids;
            },
            set: function (value) {
                this.ids = value;
            },
            enumerable: true,
            configurable: true
        });
        GetServerTimeZonesRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.ids !== null) {
                EwsUtilities.ValidateParamCollection(this.ids, "Ids");
            }
        };
        GetServerTimeZonesRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new GetServerTimeZonesResponse();
        };
        GetServerTimeZonesRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetServerTimeZonesResponseMessage";
        };
        GetServerTimeZonesRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        GetServerTimeZonesRequest.prototype.GetXmlElementName = function () {
            return "GetServerTimeZones";
        };
        GetServerTimeZonesRequest.prototype.GetResponseXmlElementName = function () {
            return "GetServerTimeZonesResponse";
        };
        GetServerTimeZonesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        GetServerTimeZonesRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.Ids !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "Ids");
                var enumerator = this.ids.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        writer.WriteElementValue(XmlNamespace.Types, "Id", current);
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                writer.WriteEndElement();
            }
        };
        return GetServerTimeZonesRequest;
    }(MultiResponseServiceRequest));
    var HangingServiceRequestBase = (function (_super) {
        __extends(HangingServiceRequestBase, _super);
        function HangingServiceRequestBase(service, handler, heartbeatFrequency) {
            _super.call(this, service);
            this.responseHandler = null;
            this.response = null;
            this.request = null;
            this.heartbeatFrequencyMilliseconds = 0;
            this.lockObject = new any();
            this.OnDisconnect = new NEvent();
            this.IsConnected = false;
            this.responseHandler = handler;
            this.heartbeatFrequencyMilliseconds = heartbeatFrequency;
        }
        HangingServiceRequestBase.prototype.InternalExecute = function () {
            var _this = this;
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                this.response = (function () {
                    var _p0 = [
                        _this.request
                    ];
                    var _r = _super.prototype.ValidateAndEmitRequest.call(_this, _p0);
                    _this.request = _p0[0];
                    return _r;
                })();
                this.InternalOnConnect();
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        HangingServiceRequestBase.prototype.ParseResponses = function (state) {
            try {
                var arg_05_0 = Guid.Empty;
                var hangingTraceStream = null;
                var memoryStream = null;
                try {
                    var flag = this.Service.IsTraceEnabledFor(TraceFlags.EwsResponse);
                    var responseStream = this.response.GetResponseStream();
                    try {
                        responseStream.ReadTimeout = 2 * this.heartbeatFrequencyMilliseconds;
                        hangingTraceStream = new HangingTraceStream(responseStream, this.Service);
                        if (flag) {
                            memoryStream = new MemoryStream();
                            hangingTraceStream.SetResponseCopy(memoryStream);
                        }
                        var ewsXmlReader = EwsServiceMultiResponseXmlReader.Create(hangingTraceStream, this.Service);
                        while (this.IsConnected) {
                            var obj = null;
                            if (flag) {
                                try {
                                    obj = _super.prototype.ReadResponse.call(this, ewsXmlReader);
                                }
                                finally {
                                    this.Service.TraceXml(TraceFlags.EwsResponse, memoryStream);
                                }
                                memoryStream.Close();
                                memoryStream = new MemoryStream();
                                hangingTraceStream.SetResponseCopy(memoryStream);
                            }
                            else {
                                obj = _super.prototype.ReadResponse.call(this, ewsXmlReader);
                            }
                            this.responseHandler(obj);
                        }
                    }
                    finally {
                        if (responseStream !== null) {
                            responseStream.Dispose();
                        }
                    }
                }
                catch (exception) {
                    if (exception instanceof TimeoutException) {
                        this.Disconnect(HangingRequestDisconnectReason.Timeout, exception);
                    }
                    else if (exception instanceof IOException) {
                        this.Disconnect(HangingRequestDisconnectReason.Exception, exception2);
                    }
                    else if (exception instanceof HttpException) {
                        this.Disconnect(HangingRequestDisconnectReason.Exception, exception3);
                    }
                    else if (exception instanceof WebException) {
                        this.Disconnect(HangingRequestDisconnectReason.Exception, exception4);
                    }
                    else if (exception instanceof ObjectDisposedException) {
                        this.Disconnect(HangingRequestDisconnectReason.Exception, exception5);
                    }
                    else if (exception instanceof NotSupportedException) {
                        this.Disconnect(HangingRequestDisconnectReason.UserInitiated, null);
                    }
                    else if (exception instanceof XmlException) {
                        this.Disconnect(HangingRequestDisconnectReason.UserInitiated, exception6);
                    }
                    else
                        throw exception;
                }
                finally {
                    if (memoryStream !== null) {
                        memoryStream.Dispose();
                        memoryStream = null;
                    }
                }
            }
            catch (exception7) {
                if (exception7 instanceof ServiceLocalException) {
                    this.Disconnect(HangingRequestDisconnectReason.Exception, exception7);
                }
                else
                    throw exception7;
            }
        };
        HangingServiceRequestBase.prototype.Disconnect = function (reason, exception) {
            if (arguments.length === 0) {
                this.Disconnect_0();
                return;
            }
            this.Disconnect_1(reason, exception);
        };
        HangingServiceRequestBase.prototype.Disconnect_0 = function () {
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                this.request.Abort();
                this.response.Close();
                this.Disconnect(HangingRequestDisconnectReason.UserInitiated, null);
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        HangingServiceRequestBase.prototype.Disconnect_1 = function (reason, exception) {
            if (this.IsConnected) {
                this.response.Close();
                this.InternalOnDisconnect(reason, exception);
            }
        };
        HangingServiceRequestBase.prototype.InternalOnConnect = function () {
            if (!this.IsConnected) {
                this.IsConnected = true;
                this.Service.ProcessHttpResponseHeaders(TraceFlags.EwsResponseHttpHeaders, this.response);
                ThreadPool.QueueUserWorkItem(this.ParseResponses);
            }
        };
        HangingServiceRequestBase.prototype.InternalOnDisconnect = function (reason, exception) {
            if (this.IsConnected) {
                this.IsConnected = false;
                this.OnDisconnect(this, new HangingRequestDisconnectEventArgs(reason, exception));
            }
        };
        HangingServiceRequestBase.prototype.ReadPreamble = function (ewsXmlReader) {
        };
        HangingServiceRequestBase.BufferSize = 4096;
        HangingServiceRequestBase.LogAllWireBytes = false;
        return HangingServiceRequestBase;
    }(ServiceRequestBase));
    var GetStreamingEventsRequest = (function (_super) {
        __extends(GetStreamingEventsRequest, _super);
        function GetStreamingEventsRequest(service, serviceObjectHandler, subscriptionIds, connectionTimeout) {
            _super.call(this, service, serviceObjectHandler, GetStreamingEventsRequest.heartbeatFrequency);
            this.subscriptionIds = null;
            this.connectionTimeout = 0;
            this.subscriptionIds = subscriptionIds;
            this.connectionTimeout = connectionTimeout;
        }
        Object.defineProperty(GetStreamingEventsRequest, "HeartbeatFrequency", {
            set: function (value) {
                GetStreamingEventsRequest.heartbeatFrequency = value;
            },
            enumerable: true,
            configurable: true
        });
        GetStreamingEventsRequest.prototype.GetXmlElementName = function () {
            return "GetStreamingEvents";
        };
        GetStreamingEventsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetStreamingEventsResponse";
        };
        GetStreamingEventsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "SubscriptionIds");
            var enumerator = this.subscriptionIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteElementValue(XmlNamespace.Types, "SubscriptionId", current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
            writer.WriteElementValue(XmlNamespace.Messages, "ConnectionTimeout", this.connectionTimeout);
        };
        GetStreamingEventsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        GetStreamingEventsRequest.prototype.ParseResponse = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "ResponseMessages");
            var getStreamingEventsResponse = new GetStreamingEventsResponse(this);
            getStreamingEventsResponse.LoadFromXml(reader, "GetStreamingEventsResponseMessage");
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "ResponseMessages");
            return getStreamingEventsResponse;
        };
        GetStreamingEventsRequest.HeartbeatFrequencyDefault = 45000;
        GetStreamingEventsRequest.heartbeatFrequency = 45000;
        return GetStreamingEventsRequest;
    }(HangingServiceRequestBase));
    var GetUserAvailabilityRequest = (function (_super) {
        __extends(GetUserAvailabilityRequest, _super);
        function GetUserAvailabilityRequest(service) {
            _super.call(this, service);
            this.attendees = null;
            this.timeWindow = null;
            this.requestedData = AvailabilityData.FreeBusyAndSuggestions;
            this.options = null;
        }
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "EmitTimeZoneHeader", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "IsFreeBusyViewRequested", {
            get: function () {
                return this.requestedData === AvailabilityData.FreeBusy || this.requestedData === AvailabilityData.FreeBusyAndSuggestions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "IsSuggestionsViewRequested", {
            get: function () {
                return this.requestedData === AvailabilityData.Suggestions || this.requestedData === AvailabilityData.FreeBusyAndSuggestions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "Attendees", {
            get: function () {
                return this.attendees;
            },
            set: function (value) {
                this.attendees = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "TimeWindow", {
            get: function () {
                return this.timeWindow;
            },
            set: function (value) {
                this.timeWindow = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "RequestedData", {
            get: function () {
                return this.requestedData;
            },
            set: function (value) {
                this.requestedData = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityRequest.prototype, "Options", {
            get: function () {
                return this.options;
            },
            set: function (value) {
                this.options = value;
            },
            enumerable: true,
            configurable: true
        });
        GetUserAvailabilityRequest.prototype.GetXmlElementName = function () {
            return "GetUserAvailabilityRequest";
        };
        GetUserAvailabilityRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            this.Options.Validate(this.TimeWindow.Duration);
        };
        GetUserAvailabilityRequest.prototype.WriteElementsToXml = function (writer) {
            if (writer.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                var legacyAvailabilityTimeZone = new LegacyAvailabilityTimeZone(writer.Service.TimeZone);
                legacyAvailabilityTimeZone.WriteToXml(writer, "TimeZone");
            }
            writer.WriteStartElement(XmlNamespace.Messages, "MailboxDataArray");
            var enumerator = this.Attendees.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
            this.Options.WriteToXml(writer, this);
        };
        GetUserAvailabilityRequest.prototype.GetResponseXmlElementName = function () {
            return "GetUserAvailabilityResponse";
        };
        GetUserAvailabilityRequest.prototype.ParseResponse = function (reader) {
            var getUserAvailabilityResults = new GetUserAvailabilityResults();
            if (this.IsFreeBusyViewRequested) {
                getUserAvailabilityResults.AttendeesAvailability = new ServiceResponseCollection();
                reader.ReadStartElement(XmlNamespace.Messages, "FreeBusyResponseArray");
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Messages, "FreeBusyResponse")) {
                        var attendeeAvailability = new AttendeeAvailability();
                        attendeeAvailability.LoadFromXml(reader, "ResponseMessage");
                        if (attendeeAvailability.ErrorCode === ServiceError.NoError) {
                            attendeeAvailability.LoadFreeBusyViewFromXml(reader, this.Options.RequestedFreeBusyView);
                        }
                        getUserAvailabilityResults.AttendeesAvailability.Add(attendeeAvailability);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "FreeBusyResponseArray"));
            }
            if (this.IsSuggestionsViewRequested) {
                getUserAvailabilityResults.SuggestionsResponse = new SuggestionsResponse();
                reader.ReadStartElement(XmlNamespace.Messages, "SuggestionsResponse");
                getUserAvailabilityResults.SuggestionsResponse.LoadFromXml(reader, "ResponseMessage");
                if (getUserAvailabilityResults.SuggestionsResponse.ErrorCode === ServiceError.NoError) {
                    getUserAvailabilityResults.SuggestionsResponse.LoadSuggestedDaysFromXml(reader);
                }
                reader.ReadEndElement(XmlNamespace.Messages, "SuggestionsResponse");
            }
            return getUserAvailabilityResults;
        };
        GetUserAvailabilityRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        GetUserAvailabilityRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        return GetUserAvailabilityRequest;
    }(SimpleServiceRequestBase));
    var GetUserConfigurationRequest = (function (_super) {
        __extends(GetUserConfigurationRequest, _super);
        function GetUserConfigurationRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.name = null;
            this.parentFolderId = null;
            this.properties = 0;
            this.userConfiguration = null;
        }
        Object.defineProperty(GetUserConfigurationRequest.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserConfigurationRequest.prototype, "ParentFolderId", {
            get: function () {
                return this.parentFolderId;
            },
            set: function (value) {
                this.parentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserConfigurationRequest.prototype, "UserConfiguration", {
            get: function () {
                return this.userConfiguration;
            },
            set: function (value) {
                this.userConfiguration = value;
                this.name = this.userConfiguration.Name;
                this.parentFolderId = this.userConfiguration.ParentFolderId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserConfigurationRequest.prototype, "Properties", {
            get: function () {
                return this.properties;
            },
            set: function (value) {
                this.properties = value;
            },
            enumerable: true,
            configurable: true
        });
        GetUserConfigurationRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.name, "name");
            EwsUtilities.ValidateParam(this.parentFolderId, "parentFolderId");
            this.ParentFolderId.Validate(this.Service.RequestedServerVersion);
        };
        GetUserConfigurationRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            if (this.userConfiguration === null) {
                this.userConfiguration = new UserConfiguration(service, this.properties);
                this.userConfiguration.Name = this.name;
                this.userConfiguration.ParentFolderId = this.parentFolderId;
            }
            return new GetUserConfigurationResponse(this.userConfiguration);
        };
        GetUserConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        GetUserConfigurationRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        GetUserConfigurationRequest.prototype.GetXmlElementName = function () {
            return "GetUserConfiguration";
        };
        GetUserConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "GetUserConfigurationResponse";
        };
        GetUserConfigurationRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "GetUserConfigurationResponseMessage";
        };
        GetUserConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            UserConfiguration.WriteUserConfigurationNameToXml(writer, XmlNamespace.Messages, this.name, this.parentFolderId);
            writer.WriteElementValue(XmlNamespace.Messages, "UserConfigurationProperties", UserConfigurationProperties[this.properties].Replace(",", NString.Empty));
        };
        GetUserConfigurationRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserConfigurationName", UserConfiguration.GetJsonUserConfigName(service, this.parentFolderId, this.name));
            jsonObject.Add("UserConfigurationProperties", UserConfigurationProperties[this.properties].Replace(",", NString.Empty));
            return jsonObject;
        };
        GetUserConfigurationRequest.EnumDelimiter = ",";
        return GetUserConfigurationRequest;
    }(MultiResponseServiceRequest));
    var GetUserOofSettingsRequest = (function (_super) {
        __extends(GetUserOofSettingsRequest, _super);
        function GetUserOofSettingsRequest(service) {
            _super.call(this, service);
            this.smtpAddress = null;
        }
        Object.defineProperty(GetUserOofSettingsRequest.prototype, "SmtpAddress", {
            get: function () {
                return this.smtpAddress;
            },
            set: function (value) {
                this.smtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        GetUserOofSettingsRequest.prototype.GetXmlElementName = function () {
            return "GetUserOofSettingsRequest";
        };
        GetUserOofSettingsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.SmtpAddress, "SmtpAddress");
        };
        GetUserOofSettingsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "Mailbox");
            writer.WriteElementValue(XmlNamespace.Types, "Address", this.SmtpAddress);
            writer.WriteEndElement();
        };
        GetUserOofSettingsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetUserOofSettingsResponse";
        };
        GetUserOofSettingsRequest.prototype.ParseResponse = function (reader) {
            var getUserOofSettingsResponse = new GetUserOofSettingsResponse();
            getUserOofSettingsResponse.LoadFromXml(reader, "ResponseMessage");
            if (getUserOofSettingsResponse.ErrorCode === ServiceError.NoError) {
                reader.ReadStartElement(XmlNamespace.Types, "OofSettings");
                getUserOofSettingsResponse.OofSettings = new OofSettings();
                getUserOofSettingsResponse.OofSettings.LoadFromXml(reader, reader.LocalName);
                getUserOofSettingsResponse.OofSettings.AllowExternalOof = reader.ReadElementValue(XmlNamespace.Messages, "AllowExternalOof");
            }
            return getUserOofSettingsResponse;
        };
        GetUserOofSettingsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        GetUserOofSettingsRequest.prototype.Execute = function () {
            var getUserOofSettingsResponse = _super.prototype.InternalExecute.call(this);
            getUserOofSettingsResponse.ThrowIfNecessary();
            return getUserOofSettingsResponse;
        };
        return GetUserOofSettingsRequest;
    }(SimpleServiceRequestBase));
    var GetUserRetentionPolicyTagsRequest = (function (_super) {
        __extends(GetUserRetentionPolicyTagsRequest, _super);
        function GetUserRetentionPolicyTagsRequest(service) {
            _super.call(this, service);
        }
        GetUserRetentionPolicyTagsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetUserRetentionPolicyTagsResponse";
        };
        GetUserRetentionPolicyTagsRequest.prototype.GetXmlElementName = function () {
            return "GetUserRetentionPolicyTags";
        };
        GetUserRetentionPolicyTagsRequest.prototype.ParseResponse = function (reader) {
            var getUserRetentionPolicyTagsResponse = new GetUserRetentionPolicyTagsResponse();
            getUserRetentionPolicyTagsResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return getUserRetentionPolicyTagsResponse;
        };
        GetUserRetentionPolicyTagsRequest.prototype.WriteElementsToXml = function (writer) {
        };
        GetUserRetentionPolicyTagsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        GetUserRetentionPolicyTagsRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        GetUserRetentionPolicyTagsRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return GetUserRetentionPolicyTagsRequest;
    }(SimpleServiceRequestBase));
    var HangingRequestDisconnectReason;
    (function (HangingRequestDisconnectReason) {
        HangingRequestDisconnectReason[HangingRequestDisconnectReason["Clean"] = 0] = "Clean";
        HangingRequestDisconnectReason[HangingRequestDisconnectReason["UserInitiated"] = 1] = "UserInitiated";
        HangingRequestDisconnectReason[HangingRequestDisconnectReason["Timeout"] = 2] = "Timeout";
        HangingRequestDisconnectReason[HangingRequestDisconnectReason["Exception"] = 3] = "Exception";
    })(HangingRequestDisconnectReason || (HangingRequestDisconnectReason = {}));
    var HangingRequestDisconnectEventArgs = (function (_super) {
        __extends(HangingRequestDisconnectEventArgs, _super);
        function HangingRequestDisconnectEventArgs(reason, exception) {
            _super.call(this);
            this.Reason = 0;
            this.Exception = null;
            this.Reason = reason;
            this.Exception = exception;
        }
        return HangingRequestDisconnectEventArgs;
    }(EventArgs));
    var InstallAppRequest = (function (_super) {
        __extends(InstallAppRequest, _super);
        function InstallAppRequest(service, manifestStream) {
            _super.call(this, service);
            this.manifestStream = null;
            this.manifestStream = manifestStream;
        }
        InstallAppRequest.prototype.GetXmlElementName = function () {
            return "InstallApp";
        };
        InstallAppRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "Manifest");
            writer.WriteBase64ElementValue(this.manifestStream);
            writer.WriteEndElement();
        };
        InstallAppRequest.prototype.GetResponseXmlElementName = function () {
            return "InstallAppResponse";
        };
        InstallAppRequest.prototype.ParseResponse = function (reader) {
            var installAppResponse = new InstallAppResponse();
            installAppResponse.LoadFromXml(reader, "InstallAppResponse");
            return installAppResponse;
        };
        InstallAppRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        InstallAppRequest.prototype.Execute = function () {
            var installAppResponse = _super.prototype.InternalExecute.call(this);
            installAppResponse.ThrowIfNecessary();
            return installAppResponse;
        };
        return InstallAppRequest;
    }(SimpleServiceRequestBase));
    var MarkAllItemsAsReadRequest = (function (_super) {
        __extends(MarkAllItemsAsReadRequest, _super);
        function MarkAllItemsAsReadRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folderIds = new FolderIdWrapperList();
            this.ReadFlag = false;
            this.SuppressReadReceipts = false;
        }
        Object.defineProperty(MarkAllItemsAsReadRequest.prototype, "FolderIds", {
            get: function () {
                return this.folderIds;
            },
            enumerable: true,
            configurable: true
        });
        MarkAllItemsAsReadRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.FolderIds, "FolderIds");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
        };
        MarkAllItemsAsReadRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.FolderIds.Count;
        };
        MarkAllItemsAsReadRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        MarkAllItemsAsReadRequest.prototype.GetXmlElementName = function () {
            return "MarkAllItemsAsRead";
        };
        MarkAllItemsAsReadRequest.prototype.GetResponseXmlElementName = function () {
            return "MarkAllItemsAsReadResponse";
        };
        MarkAllItemsAsReadRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "MarkAllItemsAsReadResponseMessage";
        };
        MarkAllItemsAsReadRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "ReadFlag", this.ReadFlag);
            writer.WriteElementValue(XmlNamespace.Messages, "SuppressReadReceipts", this.SuppressReadReceipts);
            this.FolderIds.WriteToXml(writer, XmlNamespace.Messages, "FolderIds");
        };
        MarkAllItemsAsReadRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ReadFlag", this.ReadFlag);
            jsonObject.Add("SuppressReadReceipts", this.SuppressReadReceipts);
            jsonObject.Add("FolderIds", this.FolderIds.InternalToJson(this.Service));
            return jsonObject;
        };
        MarkAllItemsAsReadRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        return MarkAllItemsAsReadRequest;
    }(MultiResponseServiceRequest));
    var MarkAsJunkRequest = (function (_super) {
        __extends(MarkAsJunkRequest, _super);
        function MarkAsJunkRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.itemIds = new ItemIdWrapperList();
            this.IsJunk = false;
            this.MoveItem = false;
        }
        Object.defineProperty(MarkAsJunkRequest.prototype, "ItemIds", {
            get: function () {
                return this.itemIds;
            },
            enumerable: true,
            configurable: true
        });
        MarkAsJunkRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.ItemIds, "ItemIds");
        };
        MarkAsJunkRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new MarkAsJunkResponse();
        };
        MarkAsJunkRequest.prototype.GetXmlElementName = function () {
            return "MarkAsJunk";
        };
        MarkAsJunkRequest.prototype.GetResponseXmlElementName = function () {
            return "MarkAsJunkResponse";
        };
        MarkAsJunkRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "MarkAsJunkResponseMessage";
        };
        MarkAsJunkRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.itemIds.Count;
        };
        MarkAsJunkRequest.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("IsJunk", this.IsJunk);
            writer.WriteAttributeValue("MoveItem", this.MoveItem);
        };
        MarkAsJunkRequest.prototype.WriteElementsToXml = function (writer) {
            this.itemIds.WriteToXml(writer, XmlNamespace.Messages, "ItemIds");
        };
        MarkAsJunkRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ItemIds", this.ItemIds.InternalToJson(service));
            return jsonObject;
        };
        MarkAsJunkRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        return MarkAsJunkRequest;
    }(MultiResponseServiceRequest));
    var MoveFolderRequest = (function (_super) {
        __extends(MoveFolderRequest, _super);
        function MoveFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        MoveFolderRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new MoveCopyFolderResponse();
        };
        MoveFolderRequest.prototype.GetXmlElementName = function () {
            return "MoveFolder";
        };
        MoveFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "MoveFolderResponse";
        };
        MoveFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "MoveFolderResponseMessage";
        };
        MoveFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return MoveFolderRequest;
    }(MoveCopyFolderRequest));
    var MoveItemRequest = (function (_super) {
        __extends(MoveItemRequest, _super);
        function MoveItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
        }
        MoveItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new MoveCopyItemResponse();
        };
        MoveItemRequest.prototype.GetXmlElementName = function () {
            return "MoveItem";
        };
        MoveItemRequest.prototype.GetResponseXmlElementName = function () {
            return "MoveItemResponse";
        };
        MoveItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "MoveItemResponseMessage";
        };
        MoveItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return MoveItemRequest;
    }(MoveCopyItemRequest));
    var RemoveDelegateRequest = (function (_super) {
        __extends(RemoveDelegateRequest, _super);
        function RemoveDelegateRequest(service) {
            _super.call(this, service);
            this.userIds = new List();
        }
        Object.defineProperty(RemoveDelegateRequest.prototype, "UserIds", {
            get: function () {
                return this.userIds;
            },
            enumerable: true,
            configurable: true
        });
        RemoveDelegateRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.UserIds, "UserIds");
        };
        RemoveDelegateRequest.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Messages, "UserIds");
            var enumerator = this.UserIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, "UserId");
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        RemoveDelegateRequest.prototype.GetResponseXmlElementName = function () {
            return "RemoveDelegateResponse";
        };
        RemoveDelegateRequest.prototype.GetXmlElementName = function () {
            return "RemoveDelegate";
        };
        RemoveDelegateRequest.prototype.CreateResponse = function () {
            return new DelegateManagementResponse(false, null);
        };
        RemoveDelegateRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return RemoveDelegateRequest;
    }(DelegateManagementRequestBase));
    var ResolveNamesRequest = (function (_super) {
        __extends(ResolveNamesRequest, _super);
        function ResolveNamesRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.nameToResolve = null;
            this.returnFullContactData = false;
            this.searchLocation = 0;
            this.contactDataPropertySet = null;
            this.parentFolderIds = new FolderIdWrapperList();
        }
        Object.defineProperty(ResolveNamesRequest.prototype, "NameToResolve", {
            get: function () {
                return this.nameToResolve;
            },
            set: function (value) {
                this.nameToResolve = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResolveNamesRequest.prototype, "ReturnFullContactData", {
            get: function () {
                return this.returnFullContactData;
            },
            set: function (value) {
                this.returnFullContactData = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResolveNamesRequest.prototype, "SearchLocation", {
            get: function () {
                return this.searchLocation;
            },
            set: function (value) {
                this.searchLocation = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResolveNamesRequest.prototype, "ContactDataPropertySet", {
            get: function () {
                return this.contactDataPropertySet;
            },
            set: function (value) {
                this.contactDataPropertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResolveNamesRequest.prototype, "ParentFolderIds", {
            get: function () {
                return this.parentFolderIds;
            },
            enumerable: true,
            configurable: true
        });
        ResolveNamesRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateNonBlankStringParam(this.NameToResolve, "NameToResolve");
        };
        ResolveNamesRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ResolveNamesResponse(service);
        };
        ResolveNamesRequest.prototype.GetXmlElementName = function () {
            return "ResolveNames";
        };
        ResolveNamesRequest.prototype.GetResponseXmlElementName = function () {
            return "ResolveNamesResponse";
        };
        ResolveNamesRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "ResolveNamesResponseMessage";
        };
        ResolveNamesRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        ResolveNamesRequest.prototype.WriteAttributesToXml = function (writer) {
            var _this = this;
            writer.WriteAttributeValue("ReturnFullContactData", this.ReturnFullContactData);
            var value = null;
            (function () {
                var _p0 = [
                    value
                ];
                var _r = ResolveNamesRequest.searchScopeMap.Member.TryGetValue(_this.SearchLocation, _p0);
                value = _p0[0];
                return _r;
            })();
            EwsUtilities.Assert(!NString.IsNullOrEmpty(value), "ResolveNameRequest.WriteAttributesToXml", "The specified search location cannot be mapped to an EWS search scope.");
            var value2 = null;
            if (this.contactDataPropertySet !== null) {
                (function () {
                    var _p0 = [
                        value2
                    ];
                    var _r = PropertySet.DefaultPropertySetMap.Member.TryGetValue(_this.contactDataPropertySet.BasePropertySet, _p0);
                    value2 = _p0[0];
                    return _r;
                })();
            }
            if (!this.Service.Exchange2007CompatibilityMode) {
                writer.WriteAttributeValue("SearchScope", value);
            }
            if (!NString.IsNullOrEmpty(value2)) {
                writer.WriteAttributeValue("ContactDataShape", value2);
            }
        };
        ResolveNamesRequest.prototype.WriteElementsToXml = function (writer) {
            this.ParentFolderIds.WriteToXml(writer, XmlNamespace.Messages, "ParentFolderIds");
            writer.WriteElementValue(XmlNamespace.Messages, "UnresolvedEntry", this.NameToResolve);
        };
        ResolveNamesRequest.prototype.ToJson = function (service) {
            var _this = this;
            var jsonObject = new JsonObject();
            if (this.ParentFolderIds.Count > 0) {
                jsonObject.Add("ParentFolderIds", this.ParentFolderIds.InternalToJson(service));
            }
            jsonObject.Add("UnresolvedEntry", this.NameToResolve);
            jsonObject.Add("ReturnFullContactData", this.ReturnFullContactData);
            var value = null;
            (function () {
                var _p0 = [
                    value
                ];
                var _r = ResolveNamesRequest.searchScopeMap.Member.TryGetValue(_this.SearchLocation, _p0);
                value = _p0[0];
                return _r;
            })();
            EwsUtilities.Assert(!NString.IsNullOrEmpty(value), "ResolveNameRequest.ToJson", "The specified search location cannot be mapped to an EWS search scope.");
            var value2 = null;
            if (this.contactDataPropertySet !== null) {
                (function () {
                    var _p0 = [
                        value2
                    ];
                    var _r = PropertySet.DefaultPropertySetMap.Member.TryGetValue(_this.contactDataPropertySet.BasePropertySet, _p0);
                    value2 = _p0[0];
                    return _r;
                })();
            }
            if (!this.Service.Exchange2007CompatibilityMode) {
                jsonObject.Add("SearchScope", value);
            }
            if (!NString.IsNullOrEmpty(value2)) {
                jsonObject.Add("ContactDataShape", value2);
            }
            return jsonObject;
        };
        ResolveNamesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        ResolveNamesRequest.searchScopeMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(ResolveNameSearchLocation.DirectoryOnly, "ActiveDirectory");
            dictionary.Add(ResolveNameSearchLocation.DirectoryThenContacts, "ActiveDirectoryContacts");
            dictionary.Add(ResolveNameSearchLocation.ContactsOnly, "Contacts");
            dictionary.Add(ResolveNameSearchLocation.ContactsThenDirectory, "ContactsActiveDirectory");
            return dictionary;
        });
        return ResolveNamesRequest;
    }(MultiResponseServiceRequest));
    var PlayOnPhoneRequest = (function (_super) {
        __extends(PlayOnPhoneRequest, _super);
        function PlayOnPhoneRequest(service) {
            _super.call(this, service);
            this.itemId = null;
            this.dialString = null;
        }
        Object.defineProperty(PlayOnPhoneRequest.prototype, "ItemId", {
            get: function () {
                return this.itemId;
            },
            set: function (value) {
                this.itemId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PlayOnPhoneRequest.prototype, "DialString", {
            get: function () {
                return this.dialString;
            },
            set: function (value) {
                this.dialString = value;
            },
            enumerable: true,
            configurable: true
        });
        PlayOnPhoneRequest.prototype.GetXmlElementName = function () {
            return "PlayOnPhone";
        };
        PlayOnPhoneRequest.prototype.WriteElementsToXml = function (writer) {
            this.itemId.WriteToXml(writer, XmlNamespace.Messages, "ItemId");
            writer.WriteElementValue(XmlNamespace.Messages, "DialString", this.dialString);
        };
        PlayOnPhoneRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("ItemId", this.ItemId.InternalToJson(service));
            jsonObject.Add("DialString", this.dialString);
            return jsonObject;
        };
        PlayOnPhoneRequest.prototype.GetResponseXmlElementName = function () {
            return "PlayOnPhoneResponse";
        };
        PlayOnPhoneRequest.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        PlayOnPhoneRequest.prototype.ParseResponse_0 = function (reader) {
            var playOnPhoneResponse = new PlayOnPhoneResponse(this.Service);
            playOnPhoneResponse.LoadFromXml(reader, "PlayOnPhoneResponse");
            return playOnPhoneResponse;
        };
        PlayOnPhoneRequest.prototype.ParseResponse_1 = function (jsonBody) {
            var playOnPhoneResponse = new PlayOnPhoneResponse(this.Service);
            playOnPhoneResponse.LoadFromJson(jsonBody, this.Service);
            return playOnPhoneResponse;
        };
        PlayOnPhoneRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        PlayOnPhoneRequest.prototype.Execute = function () {
            var playOnPhoneResponse = _super.prototype.InternalExecute.call(this);
            playOnPhoneResponse.ThrowIfNecessary();
            return playOnPhoneResponse;
        };
        return PlayOnPhoneRequest;
    }(SimpleServiceRequestBase));
    var SearchMailboxesRequest = (function (_super) {
        __extends(SearchMailboxesRequest, _super);
        function SearchMailboxesRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.searchQueries = new List();
            this.searchResultType = SearchResultType.PreviewOnly;
            this.sortOrder = 0;
            this.sortByProperty = null;
            this.performDeduplication = false;
            this.pageSize = 0;
            this.pageItemReference = null;
            this.pageDirection = 0;
            this.previewItemResponseShape = null;
            this.Language = null;
            this.ServerVersion = 0;
        }
        Object.defineProperty(SearchMailboxesRequest.prototype, "SearchQueries", {
            get: function () {
                return this.searchQueries;
            },
            set: function (value) {
                this.searchQueries = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "ResultType", {
            get: function () {
                return this.searchResultType;
            },
            set: function (value) {
                this.searchResultType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "PreviewItemResponseShape", {
            get: function () {
                return this.previewItemResponseShape;
            },
            set: function (value) {
                this.previewItemResponseShape = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "SortOrder", {
            get: function () {
                return this.sortOrder;
            },
            set: function (value) {
                this.sortOrder = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "SortByProperty", {
            get: function () {
                return this.sortByProperty;
            },
            set: function (value) {
                this.sortByProperty = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "PerformDeduplication", {
            get: function () {
                return this.performDeduplication;
            },
            set: function (value) {
                this.performDeduplication = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "PageSize", {
            get: function () {
                return this.pageSize;
            },
            set: function (value) {
                this.pageSize = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "PageItemReference", {
            get: function () {
                return this.pageItemReference;
            },
            set: function (value) {
                this.pageItemReference = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchMailboxesRequest.prototype, "PageDirection", {
            get: function () {
                return this.pageDirection;
            },
            set: function (value) {
                this.pageDirection = value;
            },
            enumerable: true,
            configurable: true
        });
        SearchMailboxesRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SearchMailboxesResponse();
        };
        SearchMailboxesRequest.prototype.GetResponseXmlElementName = function () {
            return "SearchMailboxesResponse";
        };
        SearchMailboxesRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SearchMailboxesResponseMessage";
        };
        SearchMailboxesRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        SearchMailboxesRequest.prototype.GetXmlElementName = function () {
            return "SearchMailboxes";
        };
        SearchMailboxesRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.SearchQueries === null || this.SearchQueries.Count === 0) {
                throw new ServiceValidationException(Strings.MailboxQueriesParameterIsNotSpecified);
            }
            var enumerator = this.SearchQueries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.MailboxSearchScopes === null || current.MailboxSearchScopes.length === 0) {
                        throw new ServiceValidationException(Strings.MailboxQueriesParameterIsNotSpecified);
                    }
                    var mailboxSearchScopes = current.MailboxSearchScopes;
                    for (var i = 0; i < mailboxSearchScopes.length; i = i + 1) {
                        var mailboxSearchScope = mailboxSearchScopes[i];
                        if (mailboxSearchScope.ExtendedAttributes !== null && mailboxSearchScope.ExtendedAttributes.Count > 0 && !DiscoverySchemaChanges.SearchMailboxesExtendedData.IsCompatible(this)) {
                            throw new ServiceVersionException(NString.Format(Strings.ClassIncompatibleWithRequestVersion, new Type("ExtendedAttribute").Name, DiscoverySchemaChanges.SearchMailboxesExtendedData.MinimumServerVersion));
                        }
                        if (mailboxSearchScope.SearchScopeType !== MailboxSearchScopeType.LegacyExchangeDN && (!DiscoverySchemaChanges.SearchMailboxesExtendedData.IsCompatible(this) || !DiscoverySchemaChanges.SearchMailboxesAdditionalSearchScopes.IsCompatible(this))) {
                            throw new ServiceVersionException(NString.Format(Strings.EnumValueIncompatibleWithRequestVersion, MailboxSearchScopeType[mailboxSearchScope.SearchScopeType], new Type("Number").Name, DiscoverySchemaChanges.SearchMailboxesAdditionalSearchScopes.MinimumServerVersion));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (!NString.IsNullOrEmpty(this.SortByProperty)) {
                var propertyDefinitionBase = null;
                try {
                    propertyDefinitionBase = ServiceObjectSchema.FindPropertyDefinition(this.SortByProperty);
                }
                catch (ex_181) {
                    if (ex_181 instanceof KeyNotFoundException) {
                    }
                    else
                        throw ex_181;
                }
                if (propertyDefinitionBase === null) {
                    throw new ServiceValidationException(NString.Format(Strings.InvalidSortByPropertyForMailboxSearch, this.SortByProperty));
                }
            }
        };
        SearchMailboxesRequest.prototype.ParseResponse = function (readerOrJsonBody) {
            if (arguments.length === 1 && (readerOrJsonBody === null || readerOrJsonBody instanceof EwsServiceXmlReader)) {
                return this.ParseResponse_0(readerOrJsonBody);
            }
            return this.ParseResponse_1(readerOrJsonBody);
        };
        SearchMailboxesRequest.prototype.ParseResponse_0 = function (reader) {
            var serviceResponseCollection = new ServiceResponseCollection();
            reader.ReadStartElement(XmlNamespace.Messages, "ResponseMessages");
            while (true) {
                reader.Read();
                if (reader.IsEndElement(XmlNamespace.Messages, "ResponseMessages")) {
                    break;
                }
                var searchMailboxesResponse = new SearchMailboxesResponse();
                searchMailboxesResponse.LoadFromXml(reader, this.GetResponseMessageXmlElementName());
                serviceResponseCollection.Add(searchMailboxesResponse);
            }
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "ResponseMessages");
            return serviceResponseCollection;
        };
        SearchMailboxesRequest.prototype.ParseResponse_1 = function (jsonBody) {
            var serviceResponseCollection = new ServiceResponseCollection();
            var array = jsonBody.ReadAsJsonObject("ResponseMessages").ReadAsArray("Items");
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var obj = array2[i];
                var searchMailboxesResponse = new SearchMailboxesResponse();
                searchMailboxesResponse.LoadFromJson(((obj instanceof JsonObject) ? obj : null), this.Service);
                serviceResponseCollection.Add(searchMailboxesResponse);
            }
            return serviceResponseCollection;
        };
        SearchMailboxesRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "SearchQueries");
            var enumerator = this.SearchQueries.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Types, "MailboxQuery");
                    writer.WriteElementValue(XmlNamespace.Types, "Query", current.Query);
                    writer.WriteStartElement(XmlNamespace.Types, "MailboxSearchScopes");
                    var mailboxSearchScopes = current.MailboxSearchScopes;
                    for (var i = 0; i < mailboxSearchScopes.length; i = i + 1) {
                        var mailboxSearchScope = mailboxSearchScopes[i];
                        if (mailboxSearchScope.SearchScopeType === MailboxSearchScopeType.LegacyExchangeDN || DiscoverySchemaChanges.SearchMailboxesAdditionalSearchScopes.IsCompatible(this)) {
                            writer.WriteStartElement(XmlNamespace.Types, "MailboxSearchScope");
                            writer.WriteElementValue(XmlNamespace.Types, "Mailbox", mailboxSearchScope.Mailbox);
                            writer.WriteElementValue(XmlNamespace.Types, "SearchScope", mailboxSearchScope.SearchScope);
                            if (DiscoverySchemaChanges.SearchMailboxesExtendedData.IsCompatible(this)) {
                                writer.WriteStartElement(XmlNamespace.Types, "ExtendedAttributes");
                                if (mailboxSearchScope.SearchScopeType !== MailboxSearchScopeType.LegacyExchangeDN) {
                                    writer.WriteStartElement(XmlNamespace.Types, "ExtendedAttribute");
                                    writer.WriteElementValue(XmlNamespace.Types, "Name", "SearchScopeType");
                                    writer.WriteElementValue(XmlNamespace.Types, "Value", mailboxSearchScope.SearchScopeType);
                                    writer.WriteEndElement();
                                }
                                if (mailboxSearchScope.ExtendedAttributes !== null && mailboxSearchScope.ExtendedAttributes.Count > 0) {
                                    var enumerator2 = mailboxSearchScope.ExtendedAttributes.GetEnumerator();
                                    try {
                                        while (enumerator2.MoveNext()) {
                                            var current2 = enumerator2.Current;
                                            writer.WriteStartElement(XmlNamespace.Types, "ExtendedAttribute");
                                            writer.WriteElementValue(XmlNamespace.Types, "Name", current2.Name);
                                            writer.WriteElementValue(XmlNamespace.Types, "Value", current2.Value);
                                            writer.WriteEndElement();
                                        }
                                    }
                                    finally {
                                        enumerator2.Dispose();
                                    }
                                }
                                writer.WriteEndElement();
                            }
                            writer.WriteEndElement();
                        }
                    }
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            writer.WriteElementValue(XmlNamespace.Messages, "ResultType", this.ResultType);
            if (this.PreviewItemResponseShape !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "PreviewItemResponseShape");
                writer.WriteElementValue(XmlNamespace.Types, "BaseShape", this.PreviewItemResponseShape.BaseShape);
                if (ExtendedPropertyDefinition.op_Inequality(this.PreviewItemResponseShape.AdditionalProperties, null) && this.PreviewItemResponseShape.AdditionalProperties.length > 0) {
                    writer.WriteStartElement(XmlNamespace.Types, "AdditionalProperties");
                    var additionalProperties = this.PreviewItemResponseShape.AdditionalProperties;
                    for (var j = 0; j < additionalProperties.length; j = j + 1) {
                        var extendedPropertyDefinition = additionalProperties[j];
                        extendedPropertyDefinition.WriteToXml(writer);
                    }
                    writer.WriteEndElement();
                }
                writer.WriteEndElement();
            }
            if (!NString.IsNullOrEmpty(this.SortByProperty)) {
                writer.WriteStartElement(XmlNamespace.Messages, "SortBy");
                writer.WriteAttributeValue("Order", SortDirection[this.SortOrder]);
                writer.WriteStartElement(XmlNamespace.Types, "FieldURI");
                writer.WriteAttributeValue("FieldURI", this.sortByProperty);
                writer.WriteEndElement();
                writer.WriteEndElement();
            }
            if (!NString.IsNullOrEmpty(this.Language)) {
                writer.WriteElementValue(XmlNamespace.Messages, "Language", this.Language);
            }
            writer.WriteElementValue(XmlNamespace.Messages, "Deduplication", this.performDeduplication);
            if (this.PageSize > 0) {
                writer.WriteElementValue(XmlNamespace.Messages, "PageSize", NNumber.ToString(this.PageSize));
            }
            if (!NString.IsNullOrEmpty(this.PageItemReference)) {
                writer.WriteElementValue(XmlNamespace.Messages, "PageItemReference", this.PageItemReference);
            }
            writer.WriteElementValue(XmlNamespace.Messages, "PageDirection", SearchPageDirection[this.PageDirection]);
        };
        SearchMailboxesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        SearchMailboxesRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return SearchMailboxesRequest;
    }(MultiResponseServiceRequest));
    var SendItemRequest = (function (_super) {
        __extends(SendItemRequest, _super);
        function SendItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.items = null;
            this.savedCopyDestinationFolderId = null;
        }
        Object.defineProperty(SendItemRequest.prototype, "Items", {
            get: function () {
                return this.items;
            },
            set: function (value) {
                this.items = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SendItemRequest.prototype, "SavedCopyDestinationFolderId", {
            get: function () {
                return this.savedCopyDestinationFolderId;
            },
            set: function (value) {
                this.savedCopyDestinationFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        SendItemRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Items, "Items");
            if (this.SavedCopyDestinationFolderId !== null) {
                this.SavedCopyDestinationFolderId.Validate(this.Service.RequestedServerVersion);
            }
        };
        SendItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        SendItemRequest.prototype.GetExpectedResponseMessageCount = function () {
            return EwsUtilities.GetEnumeratedObjectCount(this.Items);
        };
        SendItemRequest.prototype.GetXmlElementName = function () {
            return "SendItem";
        };
        SendItemRequest.prototype.GetResponseXmlElementName = function () {
            return "SendItemResponse";
        };
        SendItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SendItemResponseMessage";
        };
        SendItemRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("SaveItemToFolder", this.SavedCopyDestinationFolderId !== null);
        };
        SendItemRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "ItemIds");
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Id.WriteToXml(writer, "ItemId");
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
            if (this.SavedCopyDestinationFolderId !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "SavedItemFolderId");
                this.SavedCopyDestinationFolderId.WriteToXml(writer);
                writer.WriteEndElement();
            }
        };
        SendItemRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("SaveItemToFolder", this.SavedCopyDestinationFolderId !== null);
            if (this.SavedCopyDestinationFolderId !== null) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("BaseFolderId", this.SavedCopyDestinationFolderId.InternalToJson(service));
                jsonObject.Add("SavedItemFolderId", jsonObject2);
            }
            var list = new List();
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.Id.InternalToJson(service));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            jsonObject.Add("ItemIds", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        SendItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SendItemRequest;
    }(MultiResponseServiceRequest));
    var SetClientExtensionRequest = (function (_super) {
        __extends(SetClientExtensionRequest, _super);
        function SetClientExtensionRequest(service, actions) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.actions = null;
            this.actions = actions;
        }
        SetClientExtensionRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.actions, "actions");
        };
        SetClientExtensionRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        SetClientExtensionRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        SetClientExtensionRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.actions.Count;
        };
        SetClientExtensionRequest.prototype.GetXmlElementName = function () {
            return "SetClientExtension";
        };
        SetClientExtensionRequest.prototype.GetResponseXmlElementName = function () {
            return "SetClientExtensionResponse";
        };
        SetClientExtensionRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SetClientExtensionResponseMessage";
        };
        SetClientExtensionRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "Actions");
            var enumerator = this.actions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, "Action");
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        return SetClientExtensionRequest;
    }(MultiResponseServiceRequest));
    var SetEncryptionConfigurationRequest = (function (_super) {
        __extends(SetEncryptionConfigurationRequest, _super);
        function SetEncryptionConfigurationRequest(service, imageBase64, emailText, portalText, disclaimerText) {
            _super.call(this, service);
            this.imageBase64 = null;
            this.emailText = null;
            this.portalText = null;
            this.disclaimerText = null;
            this.emailText = emailText;
            this.portalText = portalText;
            this.imageBase64 = imageBase64;
            this.disclaimerText = disclaimerText;
        }
        Object.defineProperty(SetEncryptionConfigurationRequest.prototype, "ImageBase64", {
            get: function () {
                return this.imageBase64;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SetEncryptionConfigurationRequest.prototype, "EmailText", {
            get: function () {
                return this.emailText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SetEncryptionConfigurationRequest.prototype, "PortalText", {
            get: function () {
                return this.portalText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SetEncryptionConfigurationRequest.prototype, "DisclaimerText", {
            get: function () {
                return this.disclaimerText;
            },
            enumerable: true,
            configurable: true
        });
        SetEncryptionConfigurationRequest.prototype.GetXmlElementName = function () {
            return "SetEncryptionConfiguration";
        };
        SetEncryptionConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "ImageBase64", this.ImageBase64);
            writer.WriteElementValue(XmlNamespace.Messages, "EmailText", this.EmailText);
            writer.WriteElementValue(XmlNamespace.Messages, "PortalText", this.PortalText);
            writer.WriteElementValue(XmlNamespace.Messages, "DisclaimerText", this.disclaimerText);
        };
        SetEncryptionConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "SetEncryptionConfigurationResponse";
        };
        SetEncryptionConfigurationRequest.prototype.ParseResponse = function (reader) {
            var setEncryptionConfigurationResponse = new SetEncryptionConfigurationResponse();
            setEncryptionConfigurationResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return setEncryptionConfigurationResponse;
        };
        SetEncryptionConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        SetEncryptionConfigurationRequest.prototype.Execute = function () {
            var setEncryptionConfigurationResponse = _super.prototype.InternalExecute.call(this);
            setEncryptionConfigurationResponse.ThrowIfNecessary();
            return setEncryptionConfigurationResponse;
        };
        return SetEncryptionConfigurationRequest;
    }(SimpleServiceRequestBase));
    var SetHoldOnMailboxesRequest = (function (_super) {
        __extends(SetHoldOnMailboxesRequest, _super);
        function SetHoldOnMailboxesRequest(service) {
            _super.call(this, service);
            this.ActionType = 0;
            this.HoldId = null;
            this.Query = null;
            this.Mailboxes = null;
            this.Language = null;
            this.InPlaceHoldIdentity = null;
            this.ItemHoldPeriod = null;
        }
        SetHoldOnMailboxesRequest.prototype.GetResponseXmlElementName = function () {
            return "SetHoldOnMailboxesResponse";
        };
        SetHoldOnMailboxesRequest.prototype.GetXmlElementName = function () {
            return "SetHoldOnMailboxes";
        };
        SetHoldOnMailboxesRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (NString.IsNullOrEmpty(this.HoldId)) {
                throw new ServiceValidationException(Strings.HoldIdParameterIsNotSpecified);
            }
            if (NString.IsNullOrEmpty(this.InPlaceHoldIdentity) && (this.Mailboxes === null || this.Mailboxes.length === 0)) {
                throw new ServiceValidationException(Strings.HoldMailboxesParameterIsNotSpecified);
            }
        };
        SetHoldOnMailboxesRequest.prototype.ParseResponse = function (reader) {
            var setHoldOnMailboxesResponse = new SetHoldOnMailboxesResponse();
            setHoldOnMailboxesResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return setHoldOnMailboxesResponse;
        };
        SetHoldOnMailboxesRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "ActionType", HoldAction[this.ActionType]);
            writer.WriteElementValue(XmlNamespace.Messages, "HoldId", this.HoldId);
            writer.WriteElementValue(XmlNamespace.Messages, "Query", this.Query || NString.Empty);
            if (this.Mailboxes !== null && this.Mailboxes.length > 0) {
                writer.WriteStartElement(XmlNamespace.Messages, "Mailboxes");
                var mailboxes = this.Mailboxes;
                for (var i = 0; i < mailboxes.length; i = i + 1) {
                    var value = mailboxes[i];
                    writer.WriteElementValue(XmlNamespace.Types, "String", value);
                }
                writer.WriteEndElement();
            }
            if (!NString.IsNullOrEmpty(this.Language)) {
                writer.WriteElementValue(XmlNamespace.Messages, "Language", this.Language);
            }
            if (!NString.IsNullOrEmpty(this.InPlaceHoldIdentity)) {
                writer.WriteElementValue(XmlNamespace.Messages, "InPlaceHoldIdentity", this.InPlaceHoldIdentity);
            }
            if (!NString.IsNullOrEmpty(this.ItemHoldPeriod)) {
                writer.WriteElementValue(XmlNamespace.Messages, "ItemHoldPeriod", this.ItemHoldPeriod);
            }
        };
        SetHoldOnMailboxesRequest.prototype.Execute = function () {
            return _super.prototype.InternalExecute.call(this);
        };
        SetHoldOnMailboxesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        SetHoldOnMailboxesRequest.prototype.ToJson = function (service) {
            return new JsonObject();
        };
        return SetHoldOnMailboxesRequest;
    }(SimpleServiceRequestBase));
    var SetTeamMailboxRequest = (function (_super) {
        __extends(SetTeamMailboxRequest, _super);
        function SetTeamMailboxRequest(service, emailAddress, sharePointSiteUrl, state) {
            _super.call(this, service);
            this.emailAddress = null;
            this.sharePointSiteUrl = null;
            this.state = 0;
            if (emailAddress === null) {
                throw new ArgumentNullException("emailAddress");
            }
            if (Uri.op_Equality(sharePointSiteUrl, null)) {
                throw new ArgumentNullException("sharePointSiteUrl");
            }
            this.emailAddress = emailAddress;
            this.sharePointSiteUrl = sharePointSiteUrl;
            this.state = state;
        }
        SetTeamMailboxRequest.prototype.GetXmlElementName = function () {
            return "SetTeamMailbox";
        };
        SetTeamMailboxRequest.prototype.WriteElementsToXml = function (writer) {
            this.emailAddress.WriteToXml(writer, XmlNamespace.Messages, "EmailAddress");
            writer.WriteElementValue(XmlNamespace.Messages, "SharePointSiteUrl", this.sharePointSiteUrl.ToString());
            writer.WriteElementValue(XmlNamespace.Messages, "State", TeamMailboxLifecycleState[this.state]);
        };
        SetTeamMailboxRequest.prototype.GetResponseXmlElementName = function () {
            return "SetTeamMailboxResponse";
        };
        SetTeamMailboxRequest.prototype.ParseResponse = function (reader) {
            var serviceResponse = new ServiceResponse();
            serviceResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return serviceResponse;
        };
        SetTeamMailboxRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        SetTeamMailboxRequest.prototype.Execute = function () {
            var serviceResponse = _super.prototype.InternalExecute.call(this);
            serviceResponse.ThrowIfNecessary();
            return serviceResponse;
        };
        return SetTeamMailboxRequest;
    }(SimpleServiceRequestBase));
    var SetUserOofSettingsRequest = (function (_super) {
        __extends(SetUserOofSettingsRequest, _super);
        function SetUserOofSettingsRequest(service) {
            _super.call(this, service);
            this.smtpAddress = null;
            this.oofSettings = null;
        }
        Object.defineProperty(SetUserOofSettingsRequest.prototype, "SmtpAddress", {
            get: function () {
                return this.smtpAddress;
            },
            set: function (value) {
                this.smtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SetUserOofSettingsRequest.prototype, "OofSettings", {
            get: function () {
                return this.oofSettings;
            },
            set: function (value) {
                this.oofSettings = value;
            },
            enumerable: true,
            configurable: true
        });
        SetUserOofSettingsRequest.prototype.GetXmlElementName = function () {
            return "SetUserOofSettingsRequest";
        };
        SetUserOofSettingsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.SmtpAddress, "SmtpAddress");
            EwsUtilities.ValidateParam(this.OofSettings, "OofSettings");
        };
        SetUserOofSettingsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "Mailbox");
            writer.WriteElementValue(XmlNamespace.Types, "Address", this.SmtpAddress);
            writer.WriteEndElement();
            this.OofSettings.WriteToXml(writer, "UserOofSettings");
        };
        SetUserOofSettingsRequest.prototype.GetResponseXmlElementName = function () {
            return "SetUserOofSettingsResponse";
        };
        SetUserOofSettingsRequest.prototype.ParseResponse = function (reader) {
            var serviceResponse = new ServiceResponse();
            serviceResponse.LoadFromXml(reader, "ResponseMessage");
            return serviceResponse;
        };
        SetUserOofSettingsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        SetUserOofSettingsRequest.prototype.Execute = function () {
            var serviceResponse = _super.prototype.InternalExecute.call(this);
            serviceResponse.ThrowIfNecessary();
            return serviceResponse;
        };
        return SetUserOofSettingsRequest;
    }(SimpleServiceRequestBase));
    var SubscribeRequest = (function (_super) {
        __extends(SubscribeRequest, _super);
        function SubscribeRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.FolderIds = null;
            this.EventTypes = null;
            this.Watermark = null;
            this.FolderIds = new FolderIdWrapperList();
            this.EventTypes = new List();
        }
        SubscribeRequest.prototype.Validate = function () {
            var _this = this;
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.FolderIds, "FolderIds");
            EwsUtilities.ValidateParamCollection(this.EventTypes, "EventTypes");
            this.FolderIds.Validate(this.Service.RequestedServerVersion);
            if (Enumerable.Count(this.EventTypes, function (eventType) { return eventType === EventType.Status; }) > 0) {
                throw new ServiceValidationException(Strings.CannotSubscribeToStatusEvents);
            }
            if (!NString.IsNullOrEmpty(this.Watermark)) {
                EwsUtilities.ValidateNonBlankStringParam(this.Watermark, "Watermark");
            }
            this.EventTypes.ForEach(function (eventType) {
                EwsUtilities.ValidateEnumVersionValue(eventType, _this.Service.RequestedServerVersion);
            });
        };
        SubscribeRequest.prototype.GetSubscriptionXmlElementName = function () {
            throw new NotSupportedException();
        };
        SubscribeRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        SubscribeRequest.prototype.GetXmlElementName = function () {
            return "Subscribe";
        };
        SubscribeRequest.prototype.GetResponseXmlElementName = function () {
            return "SubscribeResponse";
        };
        SubscribeRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SubscribeResponseMessage";
        };
        SubscribeRequest.prototype.InternalWriteElementsToXml = function (writer) {
            throw new NotSupportedException();
        };
        SubscribeRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, this.GetSubscriptionXmlElementName());
            if (this.FolderIds.Count === 0) {
                writer.WriteAttributeValue("SubscribeToAllFolders", true);
            }
            this.FolderIds.WriteToXml(writer, XmlNamespace.Types, "FolderIds");
            writer.WriteStartElement(XmlNamespace.Types, "EventTypes");
            var enumerator = this.EventTypes.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteElementValue(XmlNamespace.Types, "EventType", current);
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            if (!NString.IsNullOrEmpty(this.Watermark)) {
                writer.WriteElementValue(XmlNamespace.Types, "Watermark", this.Watermark);
            }
            this.InternalWriteElementsToXml(writer);
            writer.WriteEndElement();
        };
        SubscribeRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            var jsonObject2 = new JsonObject();
            jsonObject2.AddTypeParameter(this.GetSubscriptionXmlElementName());
            jsonObject2.Add("EventTypes", this.EventTypes.ToArray());
            if (this.FolderIds.Count > 0) {
                jsonObject2.Add("FolderIds", this.FolderIds.InternalToJson(service));
            }
            else {
                jsonObject2.Add("SubscribeToAllFolders", true);
            }
            if (!NString.IsNullOrEmpty(this.Watermark)) {
                jsonObject2.Add("Watermark", this.Watermark);
            }
            this.AddJsonProperties(jsonObject2, service);
            jsonObject.Add("SubscriptionRequest", jsonObject2);
            return jsonObject;
        };
        SubscribeRequest.prototype.AddJsonProperties = function (jsonSubscribeRequest, service) {
            throw new NotSupportedException();
        };
        return SubscribeRequest;
    }(MultiResponseServiceRequest));
    var SubscribeToPullNotificationsRequest = (function (_super) {
        __extends(SubscribeToPullNotificationsRequest, _super);
        function SubscribeToPullNotificationsRequest(service) {
            _super.call(this, service);
            this.timeout = 30;
        }
        Object.defineProperty(SubscribeToPullNotificationsRequest.prototype, "Timeout", {
            get: function () {
                return this.timeout;
            },
            set: function (value) {
                this.timeout = value;
            },
            enumerable: true,
            configurable: true
        });
        SubscribeToPullNotificationsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (this.Timeout < 1 || this.Timeout > 1440) {
                throw new ArgumentException(NString.Format(Strings.InvalidTimeoutValue, this.Timeout));
            }
        };
        SubscribeToPullNotificationsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SubscribeResponse(new PullSubscription(service));
        };
        SubscribeToPullNotificationsRequest.prototype.GetSubscriptionXmlElementName = function () {
            return "PullSubscriptionRequest";
        };
        SubscribeToPullNotificationsRequest.prototype.InternalWriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Timeout", this.Timeout);
        };
        SubscribeToPullNotificationsRequest.prototype.AddJsonProperties = function (jsonSubscribeRequest, service) {
            jsonSubscribeRequest.Add("Timeout", this.Timeout);
        };
        SubscribeToPullNotificationsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SubscribeToPullNotificationsRequest;
    }(SubscribeRequest));
    var SubscribeToPushNotificationsRequest = (function (_super) {
        __extends(SubscribeToPushNotificationsRequest, _super);
        function SubscribeToPushNotificationsRequest(service) {
            _super.call(this, service);
            this.frequency = 30;
            this.url = null;
            this.callerData = null;
        }
        Object.defineProperty(SubscribeToPushNotificationsRequest.prototype, "Frequency", {
            get: function () {
                return this.frequency;
            },
            set: function (value) {
                this.frequency = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SubscribeToPushNotificationsRequest.prototype, "Url", {
            get: function () {
                return this.url;
            },
            set: function (value) {
                this.url = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SubscribeToPushNotificationsRequest.prototype, "CallerData", {
            get: function () {
                return this.callerData;
            },
            set: function (value) {
                this.callerData = value;
            },
            enumerable: true,
            configurable: true
        });
        SubscribeToPushNotificationsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Url, "Url");
            if (this.Frequency < 1 || this.Frequency > 1440) {
                throw new ArgumentException(NString.Format(Strings.InvalidFrequencyValue, this.Frequency));
            }
        };
        SubscribeToPushNotificationsRequest.prototype.GetSubscriptionXmlElementName = function () {
            return "PushSubscriptionRequest";
        };
        SubscribeToPushNotificationsRequest.prototype.InternalWriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "StatusFrequency", this.Frequency);
            writer.WriteElementValue(XmlNamespace.Types, "URL", this.Url.ToString());
            if (this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2013 && !NString.IsNullOrEmpty(this.callerData)) {
                writer.WriteElementValue(XmlNamespace.Types, "CallerData", this.CallerData);
            }
        };
        SubscribeToPushNotificationsRequest.prototype.AddJsonProperties = function (jsonSubscribeRequest, service) {
            jsonSubscribeRequest.Add("StatusFrequency", this.Frequency);
            jsonSubscribeRequest.Add("URL", this.Url.ToString());
        };
        SubscribeToPushNotificationsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SubscribeResponse(new PushSubscription(service));
        };
        SubscribeToPushNotificationsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SubscribeToPushNotificationsRequest;
    }(SubscribeRequest));
    var SubscribeToStreamingNotificationsRequest = (function (_super) {
        __extends(SubscribeToStreamingNotificationsRequest, _super);
        function SubscribeToStreamingNotificationsRequest(service) {
            _super.call(this, service);
        }
        SubscribeToStreamingNotificationsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            if (!NString.IsNullOrEmpty(this.Watermark)) {
                throw new ArgumentException("Watermarks cannot be used with StreamingSubscriptions.", "Watermark");
            }
        };
        SubscribeToStreamingNotificationsRequest.prototype.GetSubscriptionXmlElementName = function () {
            return "StreamingSubscriptionRequest";
        };
        SubscribeToStreamingNotificationsRequest.prototype.InternalWriteElementsToXml = function (writer) {
        };
        SubscribeToStreamingNotificationsRequest.prototype.AddJsonProperties = function (jsonSubscribeRequest, service) {
        };
        SubscribeToStreamingNotificationsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SubscribeResponse(new StreamingSubscription(service));
        };
        SubscribeToStreamingNotificationsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        return SubscribeToStreamingNotificationsRequest;
    }(SubscribeRequest));
    var SyncFolderHierarchyRequest = (function (_super) {
        __extends(SyncFolderHierarchyRequest, _super);
        function SyncFolderHierarchyRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.propertySet = null;
            this.syncFolderId = null;
            this.syncState = null;
        }
        Object.defineProperty(SyncFolderHierarchyRequest.prototype, "PropertySet", {
            get: function () {
                return this.propertySet;
            },
            set: function (value) {
                this.propertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderHierarchyRequest.prototype, "SyncFolderId", {
            get: function () {
                return this.syncFolderId;
            },
            set: function (value) {
                this.syncFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderHierarchyRequest.prototype, "SyncState", {
            get: function () {
                return this.syncState;
            },
            set: function (value) {
                this.syncState = value;
            },
            enumerable: true,
            configurable: true
        });
        SyncFolderHierarchyRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SyncFolderHierarchyResponse(this.PropertySet);
        };
        SyncFolderHierarchyRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        SyncFolderHierarchyRequest.prototype.GetXmlElementName = function () {
            return "SyncFolderHierarchy";
        };
        SyncFolderHierarchyRequest.prototype.GetResponseXmlElementName = function () {
            return "SyncFolderHierarchyResponse";
        };
        SyncFolderHierarchyRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SyncFolderHierarchyResponseMessage";
        };
        SyncFolderHierarchyRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.PropertySet, "PropertySet");
            if (this.SyncFolderId !== null) {
                this.SyncFolderId.Validate(this.Service.RequestedServerVersion);
            }
            this.PropertySet.ValidateForRequest(this, false);
        };
        SyncFolderHierarchyRequest.prototype.WriteElementsToXml = function (writer) {
            this.PropertySet.WriteToXml(writer, ServiceObjectType.Folder);
            if (this.SyncFolderId !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "SyncFolderId");
                this.SyncFolderId.WriteToXml(writer);
                writer.WriteEndElement();
            }
            writer.WriteElementValue(XmlNamespace.Messages, "SyncState", this.SyncState);
        };
        SyncFolderHierarchyRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.propertySet.WriteGetShapeToJson(jsonObject, service, ServiceObjectType.Folder);
            if (this.SyncFolderId !== null) {
                var jsonObject2 = new JsonObject();
                jsonObject2.Add("BaseFolderId", this.SyncFolderId.InternalToJson(service));
                jsonObject.Add("SyncFolderId", jsonObject2);
            }
            jsonObject.Add("SyncState", this.SyncState);
            return jsonObject;
        };
        SyncFolderHierarchyRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SyncFolderHierarchyRequest;
    }(MultiResponseServiceRequest));
    var SyncFolderItemsRequest = (function (_super) {
        __extends(SyncFolderItemsRequest, _super);
        function SyncFolderItemsRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.propertySet = null;
            this.syncFolderId = null;
            this.syncScope = 0;
            this.syncState = null;
            this.ignoredItemIds = new ItemIdWrapperList();
            this.maxChangesReturned = 100;
        }
        Object.defineProperty(SyncFolderItemsRequest.prototype, "PropertySet", {
            get: function () {
                return this.propertySet;
            },
            set: function (value) {
                this.propertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderItemsRequest.prototype, "SyncFolderId", {
            get: function () {
                return this.syncFolderId;
            },
            set: function (value) {
                this.syncFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderItemsRequest.prototype, "SyncScope", {
            get: function () {
                return this.syncScope;
            },
            set: function (value) {
                this.syncScope = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderItemsRequest.prototype, "SyncState", {
            get: function () {
                return this.syncState;
            },
            set: function (value) {
                this.syncState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderItemsRequest.prototype, "IgnoredItemIds", {
            get: function () {
                return this.ignoredItemIds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SyncFolderItemsRequest.prototype, "MaxChangesReturned", {
            get: function () {
                return this.maxChangesReturned;
            },
            set: function (value) {
                if (value >= 1 && value <= 512) {
                    this.maxChangesReturned = value;
                    return;
                }
                throw new ArgumentException(Strings.MaxChangesMustBeBetween1And512);
            },
            enumerable: true,
            configurable: true
        });
        SyncFolderItemsRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new SyncFolderItemsResponse(this.PropertySet);
        };
        SyncFolderItemsRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        SyncFolderItemsRequest.prototype.GetXmlElementName = function () {
            return "SyncFolderItems";
        };
        SyncFolderItemsRequest.prototype.GetResponseXmlElementName = function () {
            return "SyncFolderItemsResponse";
        };
        SyncFolderItemsRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "SyncFolderItemsResponseMessage";
        };
        SyncFolderItemsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.PropertySet, "PropertySet");
            EwsUtilities.ValidateParam(this.SyncFolderId, "SyncFolderId");
            this.SyncFolderId.Validate(this.Service.RequestedServerVersion);
            if (this.Service.RequestedServerVersion < ExchangeVersion.Exchange2010 && this.syncScope !== SyncFolderItemsScope.NormalItems) {
                throw new ServiceVersionException(NString.Format(Strings.EnumValueIncompatibleWithRequestVersion, SyncFolderItemsScope[this.syncScope], this.syncScope.GetType().Name, ExchangeVersion.Exchange2010));
            }
            this.PropertySet.ValidateForRequest(this, true);
        };
        SyncFolderItemsRequest.prototype.WriteElementsToXml = function (writer) {
            this.PropertySet.WriteToXml(writer, ServiceObjectType.Item);
            writer.WriteStartElement(XmlNamespace.Messages, "SyncFolderId");
            this.SyncFolderId.WriteToXml(writer);
            writer.WriteEndElement();
            writer.WriteElementValue(XmlNamespace.Messages, "SyncState", this.SyncState);
            this.IgnoredItemIds.WriteToXml(writer, XmlNamespace.Messages, "Ignore");
            writer.WriteElementValue(XmlNamespace.Messages, "MaxChangesReturned", this.MaxChangesReturned);
            if (this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2010) {
                writer.WriteElementValue(XmlNamespace.Messages, "SyncScope", this.syncScope);
            }
        };
        SyncFolderItemsRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.propertySet.WriteGetShapeToJson(jsonObject, service, ServiceObjectType.Item);
            var jsonObject2 = new JsonObject();
            jsonObject2.Add("BaseFolderId", this.SyncFolderId.InternalToJson(service));
            jsonObject.Add("SyncFolderId", jsonObject2);
            jsonObject.Add("SyncState", this.SyncState);
            if (this.IgnoredItemIds.Count > 0) {
                jsonObject.Add("Ignore", this.IgnoredItemIds.InternalToJson(service));
            }
            jsonObject.Add("MaxChangesReturned", this.MaxChangesReturned);
            if (this.Service.RequestedServerVersion >= ExchangeVersion.Exchange2010) {
                jsonObject.Add("SyncScope", this.SyncScope);
            }
            return jsonObject;
        };
        SyncFolderItemsRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return SyncFolderItemsRequest;
    }(MultiResponseServiceRequest));
    var UninstallAppRequest = (function (_super) {
        __extends(UninstallAppRequest, _super);
        function UninstallAppRequest(service, id) {
            _super.call(this, service);
            this.ID = null;
            this.ID = id;
        }
        UninstallAppRequest.prototype.GetXmlElementName = function () {
            return "UninstallApp";
        };
        UninstallAppRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "ID", this.ID);
        };
        UninstallAppRequest.prototype.GetResponseXmlElementName = function () {
            return "UninstallAppResponse";
        };
        UninstallAppRequest.prototype.ParseResponse = function (reader) {
            var uninstallAppResponse = new UninstallAppResponse();
            uninstallAppResponse.LoadFromXml(reader, "UninstallAppResponse");
            return uninstallAppResponse;
        };
        UninstallAppRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        UninstallAppRequest.prototype.Execute = function () {
            var uninstallAppResponse = _super.prototype.InternalExecute.call(this);
            uninstallAppResponse.ThrowIfNecessary();
            return uninstallAppResponse;
        };
        return UninstallAppRequest;
    }(SimpleServiceRequestBase));
    var UnpinTeamMailboxRequest = (function (_super) {
        __extends(UnpinTeamMailboxRequest, _super);
        function UnpinTeamMailboxRequest(service, emailAddress) {
            _super.call(this, service);
            this.emailAddress = null;
            if (emailAddress === null) {
                throw new ArgumentNullException("emailAddress");
            }
            this.emailAddress = emailAddress;
        }
        UnpinTeamMailboxRequest.prototype.GetXmlElementName = function () {
            return "UnpinTeamMailbox";
        };
        UnpinTeamMailboxRequest.prototype.WriteElementsToXml = function (writer) {
            this.emailAddress.WriteToXml(writer, XmlNamespace.Messages, "EmailAddress");
        };
        UnpinTeamMailboxRequest.prototype.GetResponseXmlElementName = function () {
            return "UnpinTeamMailboxResponse";
        };
        UnpinTeamMailboxRequest.prototype.ParseResponse = function (reader) {
            var serviceResponse = new ServiceResponse();
            serviceResponse.LoadFromXml(reader, this.GetResponseXmlElementName());
            return serviceResponse;
        };
        UnpinTeamMailboxRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2013;
        };
        UnpinTeamMailboxRequest.prototype.Execute = function () {
            var serviceResponse = _super.prototype.InternalExecute.call(this);
            serviceResponse.ThrowIfNecessary();
            return serviceResponse;
        };
        return UnpinTeamMailboxRequest;
    }(SimpleServiceRequestBase));
    var UnsubscribeRequest = (function (_super) {
        __extends(UnsubscribeRequest, _super);
        function UnsubscribeRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.SubscriptionId = null;
        }
        UnsubscribeRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        UnsubscribeRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        UnsubscribeRequest.prototype.GetXmlElementName = function () {
            return "Unsubscribe";
        };
        UnsubscribeRequest.prototype.GetResponseXmlElementName = function () {
            return "UnsubscribeResponse";
        };
        UnsubscribeRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "UnsubscribeResponseMessage";
        };
        UnsubscribeRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateNonBlankStringParam(this.SubscriptionId, "SubscriptionId");
        };
        UnsubscribeRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Messages, "SubscriptionId", this.SubscriptionId);
        };
        UnsubscribeRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("SubscriptionId", this.SubscriptionId);
            return jsonObject;
        };
        UnsubscribeRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return UnsubscribeRequest;
    }(MultiResponseServiceRequest));
    var UpdateDelegateRequest = (function (_super) {
        __extends(UpdateDelegateRequest, _super);
        function UpdateDelegateRequest(service) {
            _super.call(this, service);
            this.delegateUsers = new List();
            this.meetingRequestsDeliveryScope = null;
        }
        Object.defineProperty(UpdateDelegateRequest.prototype, "MeetingRequestsDeliveryScope", {
            get: function () {
                return this.meetingRequestsDeliveryScope;
            },
            set: function (value) {
                this.meetingRequestsDeliveryScope = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateDelegateRequest.prototype, "DelegateUsers", {
            get: function () {
                return this.delegateUsers;
            },
            enumerable: true,
            configurable: true
        });
        UpdateDelegateRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.DelegateUsers, "DelegateUsers");
            var enumerator = this.DelegateUsers.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.ValidateUpdateDelegate();
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        UpdateDelegateRequest.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Messages, "DelegateUsers");
            var enumerator = this.DelegateUsers.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, "DelegateUser");
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            if (this.MeetingRequestsDeliveryScope !== null) {
                writer.WriteElementValue(XmlNamespace.Messages, "DeliverMeetingRequests", this.MeetingRequestsDeliveryScope.Value);
            }
        };
        UpdateDelegateRequest.prototype.GetResponseXmlElementName = function () {
            return "UpdateDelegateResponse";
        };
        UpdateDelegateRequest.prototype.CreateResponse = function () {
            return new DelegateManagementResponse(true, this.delegateUsers);
        };
        UpdateDelegateRequest.prototype.GetXmlElementName = function () {
            return "UpdateDelegate";
        };
        UpdateDelegateRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return UpdateDelegateRequest;
    }(DelegateManagementRequestBase));
    var UpdateFolderRequest = (function (_super) {
        __extends(UpdateFolderRequest, _super);
        function UpdateFolderRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.folders = new List();
        }
        Object.defineProperty(UpdateFolderRequest.prototype, "Folders", {
            get: function () {
                return this.folders;
            },
            enumerable: true,
            configurable: true
        });
        UpdateFolderRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.Folders, "Folders");
            for (var i = 0; i < this.Folders.Count; i = i + 1) {
                var folder = this.Folders.get_Item(i);
                if (folder === null || folder.IsNew) {
                    throw new ArgumentException(NString.Format(Strings.FolderToUpdateCannotBeNullOrNew, i));
                }
                folder.Validate();
            }
        };
        UpdateFolderRequest.prototype.CreateServiceResponse = function (session, responseIndex) {
            return new UpdateFolderResponse(this.Folders.get_Item(responseIndex));
        };
        UpdateFolderRequest.prototype.GetXmlElementName = function () {
            return "UpdateFolder";
        };
        UpdateFolderRequest.prototype.GetResponseXmlElementName = function () {
            return "UpdateFolderResponse";
        };
        UpdateFolderRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "UpdateFolderResponseMessage";
        };
        UpdateFolderRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.folders.Count;
        };
        UpdateFolderRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "FolderChanges");
            var enumerator = this.folders.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXmlForUpdate(writer);
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        UpdateFolderRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            var list = new List();
            var enumerator = this.folders.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.WriteToJsonForUpdate(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("FolderChanges", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        UpdateFolderRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return UpdateFolderRequest;
    }(MultiResponseServiceRequest));
    var UpdateInboxRulesRequest = (function (_super) {
        __extends(UpdateInboxRulesRequest, _super);
        function UpdateInboxRulesRequest(service) {
            _super.call(this, service);
            this.mailboxSmtpAddress = null;
            this.removeOutlookRuleBlob = false;
            this.inboxRuleOperations = null;
        }
        Object.defineProperty(UpdateInboxRulesRequest.prototype, "MailboxSmtpAddress", {
            get: function () {
                return this.mailboxSmtpAddress;
            },
            set: function (value) {
                this.mailboxSmtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateInboxRulesRequest.prototype, "RemoveOutlookRuleBlob", {
            get: function () {
                return this.removeOutlookRuleBlob;
            },
            set: function (value) {
                this.removeOutlookRuleBlob = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateInboxRulesRequest.prototype, "InboxRuleOperations", {
            get: function () {
                return this.inboxRuleOperations;
            },
            set: function (value) {
                this.inboxRuleOperations = value;
            },
            enumerable: true,
            configurable: true
        });
        UpdateInboxRulesRequest.prototype.GetXmlElementName = function () {
            return "UpdateInboxRules";
        };
        UpdateInboxRulesRequest.prototype.WriteElementsToXml = function (writer) {
            if (!NString.IsNullOrEmpty(this.mailboxSmtpAddress)) {
                writer.WriteElementValue(XmlNamespace.Messages, "MailboxSmtpAddress", this.mailboxSmtpAddress);
            }
            writer.WriteElementValue(XmlNamespace.Messages, "RemoveOutlookRuleBlob", this.RemoveOutlookRuleBlob);
            writer.WriteStartElement(XmlNamespace.Messages, "Operations");
            var enumerator = this.inboxRuleOperations.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer, current.XmlElementName);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            writer.WriteEndElement();
        };
        UpdateInboxRulesRequest.prototype.GetResponseXmlElementName = function () {
            return "UpdateInboxRulesResponse";
        };
        UpdateInboxRulesRequest.prototype.ParseResponse = function (reader) {
            var updateInboxRulesResponse = new UpdateInboxRulesResponse();
            updateInboxRulesResponse.LoadFromXml(reader, "UpdateInboxRulesResponse");
            return updateInboxRulesResponse;
        };
        UpdateInboxRulesRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010_SP1;
        };
        UpdateInboxRulesRequest.prototype.Validate = function () {
            if (this.inboxRuleOperations === null) {
                throw new ArgumentException("RuleOperations cannot be null.", "Operations");
            }
            var num = 0;
            var enumerator = this.inboxRuleOperations.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    EwsUtilities.ValidateParam(current, "RuleOperation");
                    num = num + 1;
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            if (num === 0) {
                throw new ArgumentException("RuleOperations cannot be empty.", "Operations");
            }
            this.Service.Validate();
        };
        UpdateInboxRulesRequest.prototype.Execute = function () {
            var updateInboxRulesResponse = _super.prototype.InternalExecute.call(this);
            if (updateInboxRulesResponse.Result === ServiceResult.Error) {
                throw new UpdateInboxRulesException(updateInboxRulesResponse, this.inboxRuleOperations.GetEnumerator());
            }
            return updateInboxRulesResponse;
        };
        return UpdateInboxRulesRequest;
    }(SimpleServiceRequestBase));
    var UpdateItemRequest = (function (_super) {
        __extends(UpdateItemRequest, _super);
        function UpdateItemRequest(service, errorHandlingMode) {
            _super.call(this, service, errorHandlingMode);
            this.items = new List();
            this.savedItemsDestinationFolder = null;
            this.conflictResolutionMode = 0;
            this.messageDisposition = null;
            this.sendInvitationsOrCancellationsMode = null;
            this.SuppressReadReceipts = false;
        }
        Object.defineProperty(UpdateItemRequest.prototype, "EmitTimeZoneHeader", {
            get: function () {
                var enumerator = this.Items.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.GetIsTimeZoneHeaderRequired(true)) {
                            return true;
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemRequest.prototype, "MessageDisposition", {
            get: function () {
                return this.messageDisposition;
            },
            set: function (value) {
                this.messageDisposition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemRequest.prototype, "ConflictResolutionMode", {
            get: function () {
                return this.conflictResolutionMode;
            },
            set: function (value) {
                this.conflictResolutionMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemRequest.prototype, "SendInvitationsOrCancellationsMode", {
            get: function () {
                return this.sendInvitationsOrCancellationsMode;
            },
            set: function (value) {
                this.sendInvitationsOrCancellationsMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemRequest.prototype, "Items", {
            get: function () {
                return this.items;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemRequest.prototype, "SavedItemsDestinationFolder", {
            get: function () {
                return this.savedItemsDestinationFolder;
            },
            set: function (value) {
                this.savedItemsDestinationFolder = value;
            },
            enumerable: true,
            configurable: true
        });
        UpdateItemRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParamCollection(this.Items, "Items");
            for (var i = 0; i < this.Items.Count; i = i + 1) {
                if (this.Items.get_Item(i) === null || this.Items.get_Item(i).IsNew) {
                    throw new ArgumentException(NString.Format(Strings.ItemToUpdateCannotBeNullOrNew, i));
                }
            }
            if (this.SavedItemsDestinationFolder !== null) {
                this.SavedItemsDestinationFolder.Validate(this.Service.RequestedServerVersion);
            }
            var enumerator = this.Items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Validate();
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (this.SuppressReadReceipts && this.Service.RequestedServerVersion < ExchangeVersion.Exchange2013) {
                throw new ServiceVersionException(NString.Format(Strings.ParameterIncompatibleWithRequestVersion, "SuppressReadReceipts", ExchangeVersion.Exchange2013));
            }
        };
        UpdateItemRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new UpdateItemResponse(this.Items.get_Item(responseIndex));
        };
        UpdateItemRequest.prototype.GetXmlElementName = function () {
            return "UpdateItem";
        };
        UpdateItemRequest.prototype.GetResponseXmlElementName = function () {
            return "UpdateItemResponse";
        };
        UpdateItemRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "UpdateItemResponseMessage";
        };
        UpdateItemRequest.prototype.GetExpectedResponseMessageCount = function () {
            return this.items.Count;
        };
        UpdateItemRequest.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            if (this.MessageDisposition !== null) {
                writer.WriteAttributeValue("MessageDisposition", this.MessageDisposition);
            }
            if (this.SuppressReadReceipts) {
                writer.WriteAttributeValue("SuppressReadReceipts", true);
            }
            writer.WriteAttributeValue("ConflictResolution", this.ConflictResolutionMode);
            if (this.SendInvitationsOrCancellationsMode !== null) {
                writer.WriteAttributeValue("SendMeetingInvitationsOrCancellations", this.SendInvitationsOrCancellationsMode.Value);
            }
        };
        UpdateItemRequest.prototype.WriteElementsToXml = function (writer) {
            if (this.SavedItemsDestinationFolder !== null) {
                writer.WriteStartElement(XmlNamespace.Messages, "SavedItemFolderId");
                this.SavedItemsDestinationFolder.WriteToXml(writer);
                writer.WriteEndElement();
            }
            writer.WriteStartElement(XmlNamespace.Messages, "ItemChanges");
            var enumerator = this.items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXmlForUpdate(writer);
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
        };
        UpdateItemRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.MessageDisposition !== null) {
                jsonObject.Add("MessageDisposition", this.MessageDisposition);
            }
            jsonObject.Add("ConflictResolution", this.ConflictResolutionMode);
            if (this.SendInvitationsOrCancellationsMode !== null) {
                jsonObject.Add("SendMeetingInvitationsOrCancellations", this.SendInvitationsOrCancellationsMode.Value);
            }
            if (this.SuppressReadReceipts) {
                jsonObject.Add("SuppressReadReceipts", true);
            }
            if (this.SavedItemsDestinationFolder !== null) {
                jsonObject.Add("SavedItemFolderId", this.SavedItemsDestinationFolder.InternalToJson(service));
            }
            var list = new List();
            var enumerator = this.items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.WriteToJsonForUpdate(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            jsonObject.Add("ItemChanges", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        UpdateItemRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return UpdateItemRequest;
    }(MultiResponseServiceRequest));
    var UpdateUserConfigurationRequest = (function (_super) {
        __extends(UpdateUserConfigurationRequest, _super);
        function UpdateUserConfigurationRequest(service) {
            _super.call(this, service, ServiceErrorHandling.ThrowOnError);
            this.userConfiguration = null;
        }
        Object.defineProperty(UpdateUserConfigurationRequest.prototype, "UserConfiguration", {
            get: function () {
                return this.userConfiguration;
            },
            set: function (value) {
                this.userConfiguration = value;
            },
            enumerable: true,
            configurable: true
        });
        UpdateUserConfigurationRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.userConfiguration, "userConfiguration");
        };
        UpdateUserConfigurationRequest.prototype.CreateServiceResponse = function (service, responseIndex) {
            return new ServiceResponse();
        };
        UpdateUserConfigurationRequest.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2010;
        };
        UpdateUserConfigurationRequest.prototype.GetExpectedResponseMessageCount = function () {
            return 1;
        };
        UpdateUserConfigurationRequest.prototype.GetXmlElementName = function () {
            return "UpdateUserConfiguration";
        };
        UpdateUserConfigurationRequest.prototype.GetResponseXmlElementName = function () {
            return "UpdateUserConfigurationResponse";
        };
        UpdateUserConfigurationRequest.prototype.GetResponseMessageXmlElementName = function () {
            return "UpdateUserConfigurationResponseMessage";
        };
        UpdateUserConfigurationRequest.prototype.WriteElementsToXml = function (writer) {
            this.userConfiguration.WriteToXml(writer, XmlNamespace.Messages, "UserConfiguration");
        };
        UpdateUserConfigurationRequest.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserConfiguration", this.UserConfiguration.ToJson(service));
            return jsonObject;
        };
        return UpdateUserConfigurationRequest;
    }(MultiResponseServiceRequest));
    var ServiceResponse = (function () {
        function ServiceResponse(soapFaultDetailsOrResponseCode, errorMessage) {
            this.result = 0;
            this.errorCode = 0;
            this.errorMessage = null;
            this.errorDetails = new Dictionary();
            this.errorProperties = new Collection();
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (soapFaultDetailsOrResponseCode === null || soapFaultDetailsOrResponseCode instanceof SoapFaultDetails)) {
                this.constructor_1(soapFaultDetailsOrResponseCode);
                return;
            }
            this.constructor_2(soapFaultDetailsOrResponseCode, errorMessage);
        }
        Object.defineProperty(ServiceResponse.prototype, "BatchProcessingStopped", {
            get: function () {
                return this.result === ServiceResult.Warning && this.errorCode === ServiceError.ErrorBatchProcessingStopped;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponse.prototype, "Result", {
            get: function () {
                return this.result;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponse.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponse.prototype, "ErrorMessage", {
            get: function () {
                return this.errorMessage;
            },
            set: function (value) {
                this.errorMessage = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponse.prototype, "ErrorDetails", {
            get: function () {
                return this.errorDetails;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponse.prototype, "ErrorProperties", {
            get: function () {
                return this.errorProperties;
            },
            enumerable: true,
            configurable: true
        });
        ServiceResponse.prototype.constructor_0 = function () {
        };
        ServiceResponse.prototype.constructor_1 = function (soapFaultDetails) {
            this.result = ServiceResult.Error;
            this.errorCode = soapFaultDetails.ResponseCode;
            this.errorMessage = soapFaultDetails.FaultString;
            this.errorDetails = soapFaultDetails.ErrorDetails;
        };
        ServiceResponse.prototype.constructor_2 = function (responseCode, errorMessage) {
            this.result = ServiceResult.Error;
            this.errorCode = responseCode;
            this.errorMessage = errorMessage;
            this.errorDetails = null;
        };
        ServiceResponse.prototype.LoadFromXml = function (reader, xmlElementName) {
            if (!reader.IsStartElement(XmlNamespace.Messages, xmlElementName)) {
                reader.ReadStartElement(XmlNamespace.Messages, xmlElementName);
            }
            this.result = reader.ReadAttributeValue("ResponseClass");
            if (this.result === ServiceResult.Success || this.result === ServiceResult.Warning) {
                if (this.result === ServiceResult.Warning) {
                    this.errorMessage = reader.ReadElementValue(XmlNamespace.Messages, "MessageText");
                }
                this.errorCode = reader.ReadElementValue(XmlNamespace.Messages, "ResponseCode");
                if (this.result === ServiceResult.Warning) {
                    reader.ReadElementValue(XmlNamespace.Messages, "DescriptiveLinkKey");
                }
                if (this.BatchProcessingStopped) {
                    do {
                        reader.Read();
                    } while (!reader.IsEndElement(XmlNamespace.Messages, xmlElementName));
                }
                else {
                    this.ReadElementsFromXml(reader);
                    reader.ReadEndElementIfNecessary(XmlNamespace.Messages, xmlElementName);
                }
            }
            else {
                this.errorMessage = reader.ReadElementValue(XmlNamespace.Messages, "MessageText");
                this.errorCode = reader.ReadElementValue(XmlNamespace.Messages, "ResponseCode");
                reader.ReadElementValue(XmlNamespace.Messages, "DescriptiveLinkKey");
                while (!reader.IsEndElement(XmlNamespace.Messages, xmlElementName)) {
                    reader.Read();
                    if (reader.IsStartElement() && !this.LoadExtraErrorDetailsFromXml(reader, reader.LocalName)) {
                        reader.SkipCurrentElement();
                    }
                }
            }
            this.MapErrorCodeToErrorMessage();
            this.Loaded();
        };
        ServiceResponse.prototype.LoadFromJson = function (responseObject, service) {
            this.result = Enum.Parse(new Type("Number"), responseObject.ReadAsString("ResponseClass"));
            this.errorCode = Enum.Parse(new Type("Number"), responseObject.ReadAsString("ResponseCode"));
            if (this.result === ServiceResult.Warning || this.result === ServiceResult.Error) {
                this.errorMessage = responseObject.ReadAsString("MessageText");
            }
            if ((this.result === ServiceResult.Success || this.result === ServiceResult.Warning) && !this.BatchProcessingStopped) {
                this.ReadElementsFromJson(responseObject, service);
            }
            this.MapErrorCodeToErrorMessage();
            this.Loaded();
        };
        ServiceResponse.prototype.ParseMessageXml = function (reader) {
            do {
                reader.Read();
                var localName;
                if (reader.IsStartElement() && (localName = reader.LocalName) !== null) {
                    if (!(localName === "Value")) {
                        if (!(localName === "FieldURI")) {
                            if (!(localName === "IndexedFieldURI")) {
                                if (localName === "ExtendedFieldURI") {
                                    var extendedPropertyDefinition = new ExtendedPropertyDefinition();
                                    extendedPropertyDefinition.LoadFromXml(reader);
                                    this.errorProperties.Add(extendedPropertyDefinition);
                                }
                            }
                            else {
                                this.errorProperties.Add(new IndexedPropertyDefinition(reader.ReadAttributeValue("FieldURI"), reader.ReadAttributeValue("FieldIndex")));
                            }
                        }
                        else {
                            this.errorProperties.Add(ServiceObjectSchema.FindPropertyDefinition(reader.ReadAttributeValue("FieldURI")));
                        }
                    }
                    else {
                        this.errorDetails.Add(reader.ReadAttributeValue("Name"), reader.ReadElementValue());
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "MessageXml"));
        };
        ServiceResponse.prototype.Loaded = function () {
        };
        ServiceResponse.prototype.MapErrorCodeToErrorMessage = function () {
            if (this.ErrorCode === ServiceError.ErrorIrresolvableConflict) {
                this.ErrorMessage = Strings.ItemIsOutOfDate;
            }
        };
        ServiceResponse.prototype.ReadElementsFromXml = function (reader) {
        };
        ServiceResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
        };
        ServiceResponse.prototype.LoadExtraErrorDetailsFromXml = function (reader, xmlElementName) {
            if (reader.IsStartElement(XmlNamespace.Messages, "MessageXml") && !reader.IsEmptyElement) {
                this.ParseMessageXml(reader);
                return true;
            }
            return false;
        };
        ServiceResponse.prototype.ThrowIfNecessary = function () {
            this.InternalThrowIfNecessary();
        };
        ServiceResponse.prototype.InternalThrowIfNecessary = function () {
            if (this.Result === ServiceResult.Error) {
                throw new ServiceResponseException(this);
            }
        };
        return ServiceResponse;
    }());
    var ArchiveItemResponse = (function (_super) {
        __extends(ArchiveItemResponse, _super);
        function ArchiveItemResponse() {
            _super.call(this);
            this.item = null;
        }
        Object.defineProperty(ArchiveItemResponse.prototype, "Item", {
            get: function () {
                return this.item;
            },
            enumerable: true,
            configurable: true
        });
        ArchiveItemResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        ArchiveItemResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Items", this.GetObjectInstance, false, null, false);
            if (list.Count > 0) {
                this.item = list.get_Item(0);
            }
        };
        ArchiveItemResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var ewsServiceJsonReader = new EwsServiceJsonReader(service);
            var list = ewsServiceJsonReader.ReadServiceObjectsCollectionFromJson(responseObject, "Folders", this.GetObjectInstance, false, null, false);
            if (list.Count > 0) {
                this.item = list.get_Item(0);
            }
        };
        return ArchiveItemResponse;
    }(ServiceResponse));
    var AttendeeAvailability = (function (_super) {
        __extends(AttendeeAvailability, _super);
        function AttendeeAvailability() {
            _super.call(this);
            this.calendarEvents = new Collection();
            this.mergedFreeBusyStatus = new Collection();
            this.viewType = 0;
            this.workingHours = null;
        }
        Object.defineProperty(AttendeeAvailability.prototype, "CalendarEvents", {
            get: function () {
                return this.calendarEvents;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttendeeAvailability.prototype, "ViewType", {
            get: function () {
                return this.viewType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttendeeAvailability.prototype, "MergedFreeBusyStatus", {
            get: function () {
                return this.mergedFreeBusyStatus;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttendeeAvailability.prototype, "WorkingHours", {
            get: function () {
                return this.workingHours;
            },
            enumerable: true,
            configurable: true
        });
        AttendeeAvailability.prototype.LoadFreeBusyViewFromXml = function (reader, viewType) {
            reader.ReadStartElement(XmlNamespace.Messages, "FreeBusyView");
            var value = reader.ReadElementValue(XmlNamespace.Types, "FreeBusyViewType");
            this.viewType = Enum.Parse(new Type("Number"), value, false);
            do {
                reader.Read();
                var localName;
                if (reader.IsStartElement() && (localName = reader.LocalName) !== null) {
                    if (!(localName === "MergedFreeBusy")) {
                        if (!(localName === "CalendarEventArray")) {
                            if (localName === "WorkingHours") {
                                this.workingHours = new WorkingHours();
                                this.workingHours.LoadFromXml(reader, reader.LocalName);
                            }
                        }
                        else {
                            do {
                                reader.Read();
                                if (reader.IsStartElement(XmlNamespace.Types, "CalendarEvent")) {
                                    var calendarEvent = new CalendarEvent();
                                    calendarEvent.LoadFromXml(reader, "CalendarEvent");
                                    this.calendarEvents.Add(calendarEvent);
                                }
                            } while (!reader.IsEndElement(XmlNamespace.Types, "CalendarEventArray"));
                        }
                    }
                    else {
                        var text = reader.ReadElementValue();
                        for (var i = 0; i < text.length; i = i + 1) {
                            this.mergedFreeBusyStatus.Add(NNumber.Parse(NNumber.ToString(text.charCodeAt(i))));
                        }
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "FreeBusyView"));
        };
        return AttendeeAvailability;
    }(ServiceResponse));
    var ConvertIdResponse = (function (_super) {
        __extends(ConvertIdResponse, _super);
        function ConvertIdResponse() {
            _super.call(this);
            this.convertedId = null;
        }
        Object.defineProperty(ConvertIdResponse.prototype, "ConvertedId", {
            get: function () {
                return this.convertedId;
            },
            enumerable: true,
            configurable: true
        });
        ConvertIdResponse.prototype.ReadElementsFromXml = function (reader) {
            var IL_A2 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        _super.prototype.ReadElementsFromXml.call(this, reader);
                        reader.ReadStartElement(XmlNamespace.Messages, "AlternateId");
                        var text = reader.ReadAttributeValue(XmlNamespace.XmlSchemaInstance, "type");
                        var num = NString.IndexOf(text, 58);
                        if (num > -1) {
                            text = NString.Substring(text, num + 1);
                        }
                        var a;
                        if ((a = text) !== null) {
                            if (a === "AlternateIdType") {
                                this.convertedId = new AlternateId();
                                _goto = IL_A2;
                                continue _GOTO_LOOP;
                            }
                            if (a === "AlternatePublicFolderIdType") {
                                this.convertedId = new AlternatePublicFolderId();
                                _goto = IL_A2;
                                continue _GOTO_LOOP;
                            }
                            if (a === "AlternatePublicFolderItemIdType") {
                                this.convertedId = new AlternatePublicFolderItemId();
                                _goto = IL_A2;
                                continue _GOTO_LOOP;
                            }
                        }
                        EwsUtilities.Assert(false, "ConvertIdResponse.ReadElementsFromXml", NString.Format("Unknown alternate Id class: {0}", text));
                        _goto = IL_A2;
                        continue _GOTO_LOOP;
                    case 1:
                        this.convertedId.LoadAttributesFromXml(reader);
                        reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "AlternateId");
                        break _GOTO_LOOP;
                }
            }
        };
        ConvertIdResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var IL_72 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        var text = responseObject.ReadTypeString();
                        var a;
                        if ((a = text) !== null) {
                            if (a === "AlternateIdType") {
                                this.convertedId = new AlternateId();
                                _goto = IL_72;
                                continue _GOTO_LOOP;
                            }
                            if (a === "AlternatePublicFolderIdType") {
                                this.convertedId = new AlternatePublicFolderId();
                                _goto = IL_72;
                                continue _GOTO_LOOP;
                            }
                            if (a === "AlternatePublicFolderItemIdType") {
                                this.convertedId = new AlternatePublicFolderItemId();
                                _goto = IL_72;
                                continue _GOTO_LOOP;
                            }
                        }
                        EwsUtilities.Assert(false, "ConvertIdResponse.ReadElementsFromXml", NString.Format("Unknown alternate Id class: {0}", text));
                        _goto = IL_72;
                        continue _GOTO_LOOP;
                    case 1:
                        this.convertedId.LoadAttributesFromJson(responseObject);
                        break _GOTO_LOOP;
                }
            }
        };
        return ConvertIdResponse;
    }(ServiceResponse));
    var CreateAttachmentResponse = (function (_super) {
        __extends(CreateAttachmentResponse, _super);
        function CreateAttachmentResponse(attachment) {
            _super.call(this);
            this.attachment = null;
            EwsUtilities.Assert(attachment !== null, "CreateAttachmentResponse.ctor", "attachment is null");
            this.attachment = attachment;
        }
        Object.defineProperty(CreateAttachmentResponse.prototype, "Attachment", {
            get: function () {
                return this.attachment;
            },
            enumerable: true,
            configurable: true
        });
        CreateAttachmentResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "Attachments");
            reader.Read(1);
            this.attachment.LoadFromXml(reader, reader.LocalName);
            reader.ReadEndElement(XmlNamespace.Messages, "Attachments");
        };
        CreateAttachmentResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var array = responseObject.ReadAsArray("Attachments");
            if (array !== null && array.length > 0) {
                this.attachment.LoadFromJson(((array[0] instanceof JsonObject) ? array[0] : null), service);
            }
        };
        return CreateAttachmentResponse;
    }(ServiceResponse));
    var CreateFolderResponse = (function (_super) {
        __extends(CreateFolderResponse, _super);
        function CreateFolderResponse(folder) {
            _super.call(this);
            this.folder = null;
            this.folder = folder;
        }
        CreateFolderResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            if (this.folder !== null) {
                return this.folder;
            }
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        CreateFolderResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Folders", this.GetObjectInstance, false, null, false);
            this.folder = list.get_Item(0);
        };
        CreateFolderResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            var list = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(responseObject, "Folders", this.GetObjectInstance, false, null, false);
            this.folder = list.get_Item(0);
        };
        CreateFolderResponse.prototype.Loaded = function () {
            if (this.Result === ServiceResult.Success) {
                this.folder.ClearChangeLog();
            }
        };
        return CreateFolderResponse;
    }(ServiceResponse));
    var CreateItemResponseBase = (function (_super) {
        __extends(CreateItemResponseBase, _super);
        function CreateItemResponseBase() {
            _super.call(this);
            this.items = null;
        }
        Object.defineProperty(CreateItemResponseBase.prototype, "Items", {
            get: function () {
                return this.items;
            },
            enumerable: true,
            configurable: true
        });
        CreateItemResponseBase.prototype.GetObjectInstance = function (service, xmlElementName) {
            throw new NotSupportedException();
        };
        CreateItemResponseBase.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.items = reader.ReadServiceObjectsCollectionFromXml("Items", this.GetObjectInstance, false, null, false);
        };
        CreateItemResponseBase.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.items = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(responseObject, "Items", this.GetObjectInstance, false, null, false);
        };
        return CreateItemResponseBase;
    }(ServiceResponse));
    var CreateItemResponse = (function (_super) {
        __extends(CreateItemResponse, _super);
        function CreateItemResponse(item) {
            _super.call(this);
            this.item = null;
            this.item = item;
        }
        CreateItemResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            return this.item;
        };
        CreateItemResponse.prototype.Loaded = function () {
            if (this.Result === ServiceResult.Success) {
                this.item.ClearChangeLog();
            }
        };
        return CreateItemResponse;
    }(CreateItemResponseBase));
    var CreateResponseObjectResponse = (function (_super) {
        __extends(CreateResponseObjectResponse, _super);
        function CreateResponseObjectResponse() {
            _super.call(this);
        }
        CreateResponseObjectResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        return CreateResponseObjectResponse;
    }(CreateItemResponseBase));
    var DelegateManagementResponse = (function (_super) {
        __extends(DelegateManagementResponse, _super);
        function DelegateManagementResponse(readDelegateUsers, delegateUsers) {
            _super.call(this);
            this.readDelegateUsers = false;
            this.delegateUsers = null;
            this.delegateUserResponses = null;
            this.readDelegateUsers = readDelegateUsers;
            this.delegateUsers = delegateUsers;
        }
        Object.defineProperty(DelegateManagementResponse.prototype, "DelegateUserResponses", {
            get: function () {
                return this.delegateUserResponses;
            },
            enumerable: true,
            configurable: true
        });
        DelegateManagementResponse.prototype.ReadElementsFromXml = function (reader) {
            if (this.ErrorCode === ServiceError.NoError) {
                this.delegateUserResponses = new Collection();
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Messages, "ResponseMessages")) {
                    var num = 0;
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Messages, "DelegateUserResponseMessageType")) {
                            var delegateUser = null;
                            if (this.readDelegateUsers && this.delegateUsers !== null) {
                                delegateUser = this.delegateUsers.get_Item(num);
                            }
                            var delegateUserResponse = new DelegateUserResponse(this.readDelegateUsers, delegateUser);
                            delegateUserResponse.LoadFromXml(reader, "DelegateUserResponseMessageType");
                            this.delegateUserResponses.Add(delegateUserResponse);
                            num = num + 1;
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Messages, "ResponseMessages"));
                }
            }
        };
        return DelegateManagementResponse;
    }(ServiceResponse));
    var DelegateUserResponse = (function (_super) {
        __extends(DelegateUserResponse, _super);
        function DelegateUserResponse(readDelegateUser, delegateUser) {
            _super.call(this);
            this.readDelegateUser = false;
            this.delegateUser = null;
            this.readDelegateUser = readDelegateUser;
            this.delegateUser = delegateUser;
        }
        Object.defineProperty(DelegateUserResponse.prototype, "DelegateUser", {
            get: function () {
                return this.delegateUser;
            },
            enumerable: true,
            configurable: true
        });
        DelegateUserResponse.prototype.ReadElementsFromXml = function (reader) {
            if (this.readDelegateUser) {
                if (this.delegateUser === null) {
                    this.delegateUser = new DelegateUser();
                }
                reader.ReadStartElement(XmlNamespace.Messages, "DelegateUser");
                this.delegateUser.LoadFromXml(reader, XmlNamespace.Messages, reader.LocalName);
            }
        };
        return DelegateUserResponse;
    }(ServiceResponse));
    var DeleteAttachmentResponse = (function (_super) {
        __extends(DeleteAttachmentResponse, _super);
        function DeleteAttachmentResponse(attachment) {
            _super.call(this);
            this.attachment = null;
            EwsUtilities.Assert(attachment !== null, "DeleteAttachmentResponse.ctor", "attachment is null");
            this.attachment = attachment;
        }
        Object.defineProperty(DeleteAttachmentResponse.prototype, "Attachment", {
            get: function () {
                return this.attachment;
            },
            enumerable: true,
            configurable: true
        });
        DeleteAttachmentResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "RootItemId");
            var text = reader.ReadAttributeValue("RootItemChangeKey");
            if (!NString.IsNullOrEmpty(text) && this.attachment.Owner !== null) {
                this.attachment.Owner.RootItemId.ChangeKey = text;
            }
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "RootItemId");
        };
        DeleteAttachmentResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("RootItemId")) {
                var jsonObject = responseObject.ReadAsJsonObject("RootItemId");
                var changeKey;
                if (jsonObject.ContainsKey("RootItemChangeKey") && !NString.IsNullOrEmpty(changeKey = jsonObject.ReadAsString("RootItemChangeKey")) && this.attachment.Owner !== null) {
                    this.attachment.Owner.RootItemId.ChangeKey = changeKey;
                }
            }
        };
        return DeleteAttachmentResponse;
    }(ServiceResponse));
    var DisableAppResponse = (function (_super) {
        __extends(DisableAppResponse, _super);
        function DisableAppResponse() {
            _super.call(this);
        }
        return DisableAppResponse;
    }(ServiceResponse));
    var GetAppMarketplaceUrlResponse = (function (_super) {
        __extends(GetAppMarketplaceUrlResponse, _super);
        function GetAppMarketplaceUrlResponse() {
            _super.call(this);
            this.appMarketplaceUrl = null;
        }
        Object.defineProperty(GetAppMarketplaceUrlResponse.prototype, "AppMarketplaceUrl", {
            get: function () {
                return this.appMarketplaceUrl;
            },
            enumerable: true,
            configurable: true
        });
        GetAppMarketplaceUrlResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.appMarketplaceUrl = reader.ReadElementValue(XmlNamespace.NotSpecified, "AppMarketplaceUrl");
        };
        return GetAppMarketplaceUrlResponse;
    }(ServiceResponse));
    var ExecuteDiagnosticMethodResponse = (function (_super) {
        __extends(ExecuteDiagnosticMethodResponse, _super);
        function ExecuteDiagnosticMethodResponse(service) {
            _super.call(this);
            this.ReturnValue = null;
            EwsUtilities.Assert(service !== null, "ExecuteDiagnosticMethodResponse.ctor", "service is null");
        }
        ExecuteDiagnosticMethodResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "ReturnValue");
            var xmlReaderForNode = reader.GetXmlReaderForNode();
            try {
                this.ReturnValue = new SafeXmlDocument();
                this.ReturnValue.Load(xmlReaderForNode);
            }
            finally {
                if (xmlReaderForNode !== null) {
                    xmlReaderForNode.Dispose();
                }
            }
            reader.SkipCurrentElement();
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "ReturnValue");
        };
        return ExecuteDiagnosticMethodResponse;
    }(ServiceResponse));
    var ExpandGroupResponse = (function (_super) {
        __extends(ExpandGroupResponse, _super);
        function ExpandGroupResponse() {
            _super.call(this);
            this.members = new ExpandGroupResults();
        }
        Object.defineProperty(ExpandGroupResponse.prototype, "Members", {
            get: function () {
                return this.members;
            },
            enumerable: true,
            configurable: true
        });
        ExpandGroupResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.Members.LoadFromXml(reader);
        };
        return ExpandGroupResponse;
    }(ServiceResponse));
    var FindConversationResponse = (function (_super) {
        __extends(FindConversationResponse, _super);
        function FindConversationResponse() {
            _super.call(this);
            this.Results = null;
            this.Results = new FindConversationResults();
        }
        Object.defineProperty(FindConversationResponse.prototype, "Conversations", {
            get: function () {
                return this.Results.Conversations;
            },
            enumerable: true,
            configurable: true
        });
        FindConversationResponse.prototype.ReadElementsFromXml = function (reader) {
            EwsUtilities.Assert(this.Results.Conversations !== null, "FindConversationResponse.ReadElementsFromXml", "conversations is null.");
            EwsUtilities.Assert(this.Results.HighlightTerms !== null, "FindConversationResponse.ReadElementsFromXml", "highlightTerms is null.");
            reader.ReadStartElement(XmlNamespace.Messages, "Conversations");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var conversation = EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName);
                        if (conversation === null) {
                            reader.SkipCurrentElement();
                        }
                        else {
                            conversation.LoadFromXml(reader, true, null, false);
                            this.Results.Conversations.Add(conversation);
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "Conversations"));
            }
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "HighlightTerms") && !reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var highlightTerm = new HighlightTerm();
                        highlightTerm.LoadFromXml(reader, XmlNamespace.Types, "Term");
                        this.Results.HighlightTerms.Add(highlightTerm);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "HighlightTerms"));
            }
            if (reader.IsStartElement(XmlNamespace.Messages, "TotalConversationsInView") && !reader.IsEmptyElement) {
                this.Results.TotalCount = new Nullable(reader.ReadElementValue());
                reader.Read();
            }
            if (reader.IsStartElement(XmlNamespace.Messages, "IndexedOffset") && !reader.IsEmptyElement) {
                this.Results.IndexedOffset = new Nullable(reader.ReadElementValue());
                reader.Read();
            }
        };
        FindConversationResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            EwsUtilities.Assert(this.Results.Conversations !== null, "FindConversationResponse.ReadElementsFromXml", "conversations is null.");
            EwsUtilities.Assert(this.Results.HighlightTerms !== null, "FindConversationResponse.ReadElementsFromXml", "highlightTerms is null.");
            var array = responseObject.ReadAsArray("Conversations");
            for (var i = 0; i < array.length; i = i + 1) {
                var obj = array[i];
                var jsonServiceObject = ((obj instanceof JsonObject) ? obj : null);
                var conversation = EwsUtilities.CreateEwsObjectFromXmlElementName(service, "Conversation");
                if (conversation !== null) {
                    conversation.LoadFromJson(jsonServiceObject, service, true, null, false);
                    this.Conversations.Add(conversation);
                }
            }
            var array2 = responseObject.ReadAsArray("HighlightTerms");
            if (array2 !== null) {
                var array3 = array2;
                for (var j = 0; j < array3.length; j = j + 1) {
                    var obj2 = array3[j];
                    var jsonProperty = ((obj2 instanceof JsonObject) ? obj2 : null);
                    var highlightTerm = new HighlightTerm();
                    highlightTerm.LoadFromJson(jsonProperty, service);
                    this.Results.HighlightTerms.Add(highlightTerm);
                }
            }
            if (responseObject.ContainsKey("TotalConversationsInView")) {
                this.Results.TotalCount = new Nullable(responseObject.ReadAsInt("TotalConversationsInView"));
            }
            if (responseObject.ContainsKey("IndexedOffset")) {
                this.Results.IndexedOffset = new Nullable(responseObject.ReadAsInt("IndexedOffset"));
            }
        };
        return FindConversationResponse;
    }(ServiceResponse));
    var FindFolderResponse = (function (_super) {
        __extends(FindFolderResponse, _super);
        function FindFolderResponse(propertySet) {
            _super.call(this);
            this.results = new FindFoldersResults();
            this.propertySet = null;
            this.propertySet = propertySet;
            EwsUtilities.Assert(this.propertySet !== null, "FindFolderResponse.ctor", "PropertySet should not be null");
        }
        Object.defineProperty(FindFolderResponse.prototype, "Results", {
            get: function () {
                return this.results;
            },
            enumerable: true,
            configurable: true
        });
        FindFolderResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "RootFolder");
            this.results.TotalCount = reader.ReadAttributeValue("TotalItemsInView");
            this.results.MoreAvailable = !reader.ReadAttributeValue("IncludesLastItemInRange");
            this.results.NextPageOffset = (this.results.MoreAvailable ? reader.ReadNullableAttributeValue("IndexedPagingOffset") : null);
            reader.ReadStartElement(XmlNamespace.Types, "Folders");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var folder = EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName);
                        if (folder === null) {
                            reader.SkipCurrentElement();
                        }
                        else {
                            folder.LoadFromXml(reader, true, this.propertySet, true);
                            this.results.Folders.Add(folder);
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, "Folders"));
            }
            reader.ReadEndElement(XmlNamespace.Messages, "RootFolder");
        };
        FindFolderResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var _this = this;
            var jsonObject = responseObject.ReadAsJsonObject("RootFolder");
            this.results.TotalCount = jsonObject.ReadAsInt("TotalItemsInView");
            this.results.MoreAvailable = jsonObject.ReadAsBool("IncludesLastItemInRange");
            if (this.results.MoreAvailable) {
                if (jsonObject.ContainsKey("IndexedPagingOffset")) {
                    this.results.NextPageOffset = new Nullable(jsonObject.ReadAsInt("IndexedPagingOffset"));
                }
                else {
                    this.results.NextPageOffset = null;
                }
            }
            if (jsonObject.ContainsKey("Folders")) {
                var list = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(jsonObject, "Folders", this.CreateFolderInstance, true, this.propertySet, true);
                list.ForEach(function (folder) {
                    _this.results.Folders.Add(folder);
                });
            }
        };
        FindFolderResponse.prototype.CreateFolderInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        return FindFolderResponse;
    }(ServiceResponse));
    var FindItemResponse = (function (_super) {
        __extends(FindItemResponse, _super);
        function FindItemResponse(isGrouped, propertySet) {
            _super.call(this);
            this.results = null;
            this.isGrouped = false;
            this.groupedFindResults = null;
            this.propertySet = null;
            this.isGrouped = isGrouped;
            this.propertySet = propertySet;
            EwsUtilities.Assert(this.propertySet !== null, "FindItemResponse.ctor", "PropertySet should not be null");
        }
        Object.defineProperty(FindItemResponse.prototype, "GroupedFindResults", {
            get: function () {
                return this.groupedFindResults;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindItemResponse.prototype, "Results", {
            get: function () {
                return this.results;
            },
            enumerable: true,
            configurable: true
        });
        FindItemResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "RootFolder");
            var totalCount = reader.ReadAttributeValue("TotalItemsInView");
            var flag = !reader.ReadAttributeValue("IncludesLastItemInRange");
            var nextPageOffset = flag ? reader.ReadNullableAttributeValue("IndexedPagingOffset") : null;
            if (!this.isGrouped) {
                this.results = new FindItemsResults();
                this.results.TotalCount = totalCount;
                this.results.NextPageOffset = nextPageOffset;
                this.results.MoreAvailable = flag;
                FindItemResponse(InternalReadItemsFromXml(reader, this.propertySet, this.results.Items));
            }
            else {
                this.groupedFindResults = new GroupedFindItemsResults();
                this.groupedFindResults.TotalCount = totalCount;
                this.groupedFindResults.NextPageOffset = nextPageOffset;
                this.groupedFindResults.MoreAvailable = flag;
                reader.ReadStartElement(XmlNamespace.Types, "Groups");
                if (!reader.IsEmptyElement) {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "GroupedItems")) {
                            var groupIndex = reader.ReadElementValue(XmlNamespace.Types, "GroupIndex");
                            var list = new List();
                            FindItemResponse(InternalReadItemsFromXml(reader, this.propertySet, list));
                            reader.ReadEndElement(XmlNamespace.Types, "GroupedItems");
                            this.groupedFindResults.ItemGroups.Add(new ItemGroup(groupIndex, list));
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "Groups"));
                }
            }
            reader.ReadEndElement(XmlNamespace.Messages, "RootFolder");
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "HighlightTerms") && !reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var highlightTerm = new HighlightTerm();
                        highlightTerm.LoadFromXml(reader, XmlNamespace.Types, "Term");
                        this.results.HighlightTerms.Add(highlightTerm);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "HighlightTerms"));
            }
        };
        FindItemResponse.InternalReadItemsFromXml = function (reader, propertySet, destinationList) {
            EwsUtilities.Assert(destinationList !== null, "FindItemResponse.InternalReadItemsFromXml", "destinationList is null.");
            reader.ReadStartElement(XmlNamespace.Types, "Items");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1) {
                        var tItem = EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName);
                        if (tItem === null) {
                            reader.SkipCurrentElement();
                        }
                        else {
                            tItem.LoadFromXml(reader, true, propertySet, true);
                            destinationList.Add(tItem);
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, "Items"));
            }
        };
        FindItemResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            var jsonObject = responseObject.ReadAsJsonObject("RootFolder");
            var totalCount = jsonObject.ReadAsInt("TotalItemsInView");
            var flag = !jsonObject.ReadAsBool("IncludesLastItemInRange");
            var nextPageOffset = new Nullable();
            if (flag && jsonObject.ContainsKey("IndexedPagingOffset")) {
                nextPageOffset = new Nullable(jsonObject.ReadAsInt("IndexedPagingOffset"));
            }
            if (!this.isGrouped) {
                this.results = new FindItemsResults();
                this.results.TotalCount = totalCount;
                this.results.NextPageOffset = nextPageOffset;
                this.results.MoreAvailable = flag;
                this.InternalReadItemsFromJson(jsonObject, this.propertySet, service, this.results.Items);
            }
            else {
                this.groupedFindResults = new GroupedFindItemsResults();
                this.groupedFindResults.TotalCount = totalCount;
                this.groupedFindResults.NextPageOffset = nextPageOffset;
                this.groupedFindResults.MoreAvailable = flag;
                if (jsonObject.ContainsKey("Groups")) {
                    var source = jsonObject.ReadAsArray("Groups");
                    var enumerator = Enumerable.OfType(NArray.ToEnumerable(source)).GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var current = enumerator.Current;
                            if (current.ContainsKey("GroupedItems")) {
                                var jsonObject2 = current.ReadAsJsonObject("GroupedItems");
                                var groupIndex = jsonObject2.ReadAsString("GroupIndex");
                                var list = new List();
                                this.InternalReadItemsFromJson(jsonObject2, this.propertySet, service, list);
                                this.groupedFindResults.ItemGroups.Add(new ItemGroup(groupIndex, list));
                            }
                        }
                    }
                    finally {
                        if (enumerator !== null) {
                            enumerator.Dispose();
                        }
                    }
                }
            }
            var array = responseObject.ReadAsArray("HighlightTerms");
            if (array !== null) {
                var array2 = array;
                for (var i = 0; i < array2.length; i = i + 1) {
                    var obj = array2[i];
                    var jsonProperty = ((obj instanceof JsonObject) ? obj : null);
                    var highlightTerm = new HighlightTerm();
                    highlightTerm.LoadFromJson(jsonProperty, service);
                    this.results.HighlightTerms.Add(highlightTerm);
                }
            }
        };
        FindItemResponse.prototype.InternalReadItemsFromJson = function (jsonObject, propertySet, service, destinationList) {
            EwsUtilities.Assert(destinationList !== null, "FindItemResponse.InternalReadItemsFromJson", "destinationList is null.");
            if (jsonObject.ContainsKey("Items")) {
                var list = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(jsonObject, "Items", this.CreateItemInstance, true, this.propertySet, true);
                list.ForEach(function (item) {
                    destinationList.Add(item);
                });
            }
        };
        FindItemResponse.prototype.CreateItemInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        return FindItemResponse;
    }(ServiceResponse));
    var GetAttachmentResponse = (function (_super) {
        __extends(GetAttachmentResponse, _super);
        function GetAttachmentResponse(attachment) {
            _super.call(this);
            this.attachment = null;
            this.attachment = attachment;
        }
        Object.defineProperty(GetAttachmentResponse.prototype, "Attachment", {
            get: function () {
                return this.attachment;
            },
            enumerable: true,
            configurable: true
        });
        GetAttachmentResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "Attachments");
            if (!reader.IsEmptyElement) {
                reader.Read(1);
                if (this.attachment === null) {
                    if (NString.Equals(reader.LocalName, "FileAttachment", StringComparison.OrdinalIgnoreCase)) {
                        this.attachment = new FileAttachment(reader.Service);
                    }
                    else {
                        if (NString.Equals(reader.LocalName, "ItemAttachment", StringComparison.OrdinalIgnoreCase)) {
                            this.attachment = new ItemAttachment(reader.Service);
                        }
                    }
                }
                if (this.attachment !== null) {
                    this.attachment.LoadFromXml(reader, reader.LocalName);
                }
                reader.ReadEndElement(XmlNamespace.Messages, "Attachments");
            }
        };
        GetAttachmentResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var array;
            if (responseObject.ContainsKey("Attachments") && (array = responseObject.ReadAsArray("Attachments")).length > 0) {
                var jsonObject = ((array[0] instanceof JsonObject) ? array[0] : null);
                if (this.attachment === null && jsonObject !== null) {
                    if (jsonObject.ContainsKey("FileAttachment")) {
                        this.attachment = new FileAttachment(service);
                    }
                    else {
                        if (jsonObject.ContainsKey("ItemAttachment")) {
                            this.attachment = new ItemAttachment(service);
                        }
                    }
                }
                if (this.attachment !== null) {
                    this.attachment.LoadFromJson(jsonObject, service);
                }
            }
        };
        return GetAttachmentResponse;
    }(ServiceResponse));
    var GetClientAccessTokenResponse = (function (_super) {
        __extends(GetClientAccessTokenResponse, _super);
        function GetClientAccessTokenResponse(id, tokenType) {
            _super.call(this);
            this.Id = null;
            this.TokenType = 0;
            this.TokenValue = null;
            this.TTL = 0;
            this.Id = id;
            this.TokenType = tokenType;
        }
        GetClientAccessTokenResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "Token");
            this.Id = reader.ReadElementValue(XmlNamespace.Types, "Id");
            this.TokenType = Enum.Parse(new Type("Number"), reader.ReadElementValue(XmlNamespace.Types, "TokenType"));
            this.TokenValue = reader.ReadElementValue(XmlNamespace.Types, "TokenValue");
            this.TTL = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "TTL"));
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "Token");
        };
        GetClientAccessTokenResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("Token")) {
                var jsonObject = responseObject.ReadAsJsonObject("Token");
                this.Id = jsonObject.ReadAsString("Id");
                this.TokenType = Enum.Parse(new Type("Number"), jsonObject.ReadAsString("TokenType"));
                this.TokenValue = jsonObject.ReadAsString("TokenValue");
                this.TTL = jsonObject.ReadAsInt("TTL");
            }
        };
        return GetClientAccessTokenResponse;
    }(ServiceResponse));
    var GetClientExtensionResponse = (function (_super) {
        __extends(GetClientExtensionResponse, _super);
        function GetClientExtensionResponse() {
            _super.call(this);
            this.clientExtension = new Collection();
            this.rawMasterTableXml = null;
        }
        Object.defineProperty(GetClientExtensionResponse.prototype, "ClientExtensions", {
            get: function () {
                return this.clientExtension;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetClientExtensionResponse.prototype, "RawMasterTableXml", {
            get: function () {
                return this.rawMasterTableXml;
            },
            enumerable: true,
            configurable: true
        });
        GetClientExtensionResponse.prototype.ReadElementsFromXml = function (reader) {
            this.ClientExtensions.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "ClientExtensions");
            if (!reader.IsEmptyElement) {
                reader.Read();
                while (reader.IsStartElement(XmlNamespace.Types, "ClientExtension")) {
                    var clientExtension = new ClientExtension();
                    clientExtension.LoadFromXml(reader, XmlNamespace.Types, "ClientExtension");
                    this.ClientExtensions.Add(clientExtension);
                    reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Types, "ClientExtension");
                    reader.Read();
                }
                reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Messages, "ClientExtensions");
            }
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "RawMasterTableXml")) {
                this.rawMasterTableXml = reader.ReadElementValue();
            }
        };
        return GetClientExtensionResponse;
    }(ServiceResponse));
    var GetEncryptionConfigurationResponse = (function (_super) {
        __extends(GetEncryptionConfigurationResponse, _super);
        function GetEncryptionConfigurationResponse() {
            _super.call(this);
            this.imageBase64 = null;
            this.emailText = null;
            this.portalText = null;
            this.disclaimerText = null;
        }
        Object.defineProperty(GetEncryptionConfigurationResponse.prototype, "ImageBase64", {
            get: function () {
                return this.imageBase64;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEncryptionConfigurationResponse.prototype, "EmailText", {
            get: function () {
                return this.emailText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEncryptionConfigurationResponse.prototype, "PortalText", {
            get: function () {
                return this.portalText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEncryptionConfigurationResponse.prototype, "DisclaimerText", {
            get: function () {
                return this.disclaimerText;
            },
            enumerable: true,
            configurable: true
        });
        GetEncryptionConfigurationResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.imageBase64 = reader.ReadElementValue(XmlNamespace.Messages, "ImageBase64");
            this.emailText = reader.ReadElementValue(XmlNamespace.Messages, "EmailText");
            this.portalText = reader.ReadElementValue(XmlNamespace.Messages, "PortalText");
            this.disclaimerText = reader.ReadElementValue(XmlNamespace.Messages, "DisclaimerText");
        };
        return GetEncryptionConfigurationResponse;
    }(ServiceResponse));
    var GetAppManifestsResponse = (function (_super) {
        __extends(GetAppManifestsResponse, _super);
        function GetAppManifestsResponse() {
            _super.call(this);
            this.manifests = new Collection();
            this.apps = new Collection();
        }
        Object.defineProperty(GetAppManifestsResponse.prototype, "Manifests", {
            get: function () {
                return this.manifests;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetAppManifestsResponse.prototype, "Apps", {
            get: function () {
                return this.apps;
            },
            enumerable: true,
            configurable: true
        });
        GetAppManifestsResponse.prototype.ReadElementsFromXml = function (reader) {
            this.Manifests.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.Read(1);
            var flag;
            if ("Manifests" === reader.LocalName) {
                flag = true;
            }
            else {
                if (!("Apps" === reader.LocalName)) {
                    throw new ServiceXmlDeserializationException(NString.Format(Strings.UnexpectedElement, [
                        EwsUtilities.GetNamespacePrefix(XmlNamespace.Messages), "Manifests", 1, reader.LocalName, reader.NodeType
                    ]));
                }
                flag = false;
            }
            if (!reader.IsEmptyElement) {
                reader.Read();
                if (flag) {
                    this.ReadFromExchange2013(reader);
                }
                else {
                    this.ReadFromExchange2013Sp1(reader);
                }
            }
            reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Messages, flag ? "Manifests" : "Apps");
        };
        GetAppManifestsResponse.prototype.ReadFromExchange2013 = function (reader) {
            while (reader.IsStartElement(XmlNamespace.Messages, "Manifest")) {
                var xmlDocument = ClientApp.ReadToXmlDocument(reader);
                this.Manifests.Add(xmlDocument);
                var arg_29_0 = this.Apps;
                var clientApp = new ClientApp();
                clientApp.Manifest = xmlDocument;
                arg_29_0.Add(clientApp);
            }
        };
        GetAppManifestsResponse.prototype.ReadFromExchange2013Sp1 = function (reader) {
            while (reader.IsStartElement(XmlNamespace.Types, "App")) {
                var clientApp = new ClientApp();
                clientApp.LoadFromXml(reader, "App");
                this.Apps.Add(clientApp);
                this.Manifests.Add(clientApp.Manifest);
                reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Types, "App");
                reader.Read();
            }
        };
        return GetAppManifestsResponse;
    }(ServiceResponse));
    var GetConversationItemsResponse = (function (_super) {
        __extends(GetConversationItemsResponse, _super);
        function GetConversationItemsResponse(propertySet) {
            _super.call(this);
            this.propertySet = null;
            this.Conversation = null;
            this.propertySet = propertySet;
        }
        GetConversationItemsResponse.prototype.ReadElementsFromXml = function (reader) {
            this.Conversation = new ConversationResponse(this.propertySet);
            reader.ReadStartElement(XmlNamespace.Messages, "Conversation");
            this.Conversation.LoadFromXml(reader, XmlNamespace.Messages, "Conversation");
        };
        GetConversationItemsResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            this.Conversation = new ConversationResponse(this.propertySet);
            this.Conversation.LoadFromJson(responseObject.ReadAsJsonObject("Conversation"), service);
        };
        return GetConversationItemsResponse;
    }(ServiceResponse));
    var GetDelegateResponse = (function (_super) {
        __extends(GetDelegateResponse, _super);
        function GetDelegateResponse(readDelegateUsers) {
            _super.call(this, readDelegateUsers, null);
            this.meetingRequestsDeliveryScope = MeetingRequestsDeliveryScope.NoForward;
        }
        Object.defineProperty(GetDelegateResponse.prototype, "MeetingRequestsDeliveryScope", {
            get: function () {
                return this.meetingRequestsDeliveryScope;
            },
            enumerable: true,
            configurable: true
        });
        GetDelegateResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            if (this.ErrorCode === ServiceError.NoError) {
                if (this.DelegateUserResponses.Count > 0) {
                    reader.Read();
                }
                if (reader.IsStartElement(XmlNamespace.Messages, "DeliverMeetingRequests")) {
                    this.meetingRequestsDeliveryScope = reader.ReadElementValue();
                }
            }
        };
        return GetDelegateResponse;
    }(DelegateManagementResponse));
    var GetDiscoverySearchConfigurationResponse = (function (_super) {
        __extends(GetDiscoverySearchConfigurationResponse, _super);
        function GetDiscoverySearchConfigurationResponse() {
            _super.call(this);
            this.configurations = new List();
        }
        Object.defineProperty(GetDiscoverySearchConfigurationResponse.prototype, "DiscoverySearchConfigurations", {
            get: function () {
                return this.configurations.ToArray();
            },
            enumerable: true,
            configurable: true
        });
        GetDiscoverySearchConfigurationResponse.prototype.ReadElementsFromXml = function (reader) {
            this.configurations.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "DiscoverySearchConfigurations");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "DiscoverySearchConfiguration")) {
                        this.configurations.Add(DiscoverySearchConfiguration.LoadFromXml(reader));
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "DiscoverySearchConfigurations"));
            }
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "DiscoverySearchConfigurations");
        };
        GetDiscoverySearchConfigurationResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            this.configurations.Clear();
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("DiscoverySearchConfigurations")) {
                var array = responseObject.ReadAsArray("DiscoverySearchConfigurations");
                for (var i = 0; i < array.length; i = i + 1) {
                    var obj = array[i];
                    var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                    this.configurations.Add(DiscoverySearchConfiguration.LoadFromJson(jsonObject));
                }
            }
        };
        return GetDiscoverySearchConfigurationResponse;
    }(ServiceResponse));
    var GetEventsResponse = (function (_super) {
        __extends(GetEventsResponse, _super);
        function GetEventsResponse() {
            _super.call(this);
            this.results = new GetEventsResults();
        }
        Object.defineProperty(GetEventsResponse.prototype, "Results", {
            get: function () {
                return this.results;
            },
            enumerable: true,
            configurable: true
        });
        GetEventsResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.results.LoadFromXml(reader);
        };
        GetEventsResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.results.LoadFromJson(responseObject.ReadAsJsonObject("Notification"), service);
        };
        return GetEventsResponse;
    }(ServiceResponse));
    var GetStreamingEventsResponse = (function (_super) {
        __extends(GetStreamingEventsResponse, _super);
        function GetStreamingEventsResponse(request) {
            _super.call(this);
            this.results = new GetStreamingEventsResults();
            this.request = null;
            this.ErrorSubscriptionIds = null;
            this.ErrorSubscriptionIds = new List();
            this.request = request;
        }
        Object.defineProperty(GetStreamingEventsResponse.prototype, "Results", {
            get: function () {
                return this.results;
            },
            enumerable: true,
            configurable: true
        });
        GetStreamingEventsResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.Read();
            if (reader.LocalName === "Notifications") {
                this.results.LoadFromXml(reader);
                return;
            }
            if (reader.LocalName === "ConnectionStatus") {
                var text = reader.ReadElementValue(XmlNamespace.Messages, "ConnectionStatus");
                if (text === ConnectionStatus[GetStreamingEventsResponse_ConnectionStatus.Closed]) {
                    this.request.Disconnect(HangingRequestDisconnectReason.Clean, null);
                }
            }
        };
        GetStreamingEventsResponse.prototype.LoadExtraErrorDetailsFromXml = function (reader, xmlElementName) {
            var result = _super.prototype.LoadExtraErrorDetailsFromXml.call(this, reader, xmlElementName);
            if (reader.IsStartElement(XmlNamespace.Messages, "ErrorSubscriptionIds")) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === "SubscriptionId") {
                        this.ErrorSubscriptionIds.Add(reader.ReadElementValue(XmlNamespace.Messages, "SubscriptionId"));
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "ErrorSubscriptionIds"));
                return true;
            }
            return result;
        };
        return GetStreamingEventsResponse;
    }(ServiceResponse));
    var GetStreamingEventsResponse_ConnectionStatus;
    (function (GetStreamingEventsResponse_ConnectionStatus) {
        GetStreamingEventsResponse_ConnectionStatus[GetStreamingEventsResponse_ConnectionStatus["OK"] = 0] = "OK";
        GetStreamingEventsResponse_ConnectionStatus[GetStreamingEventsResponse_ConnectionStatus["Closed"] = 1] = "Closed";
    })(GetStreamingEventsResponse_ConnectionStatus || (GetStreamingEventsResponse_ConnectionStatus = {}));
    var GetFolderResponse = (function (_super) {
        __extends(GetFolderResponse, _super);
        function GetFolderResponse(folder, propertySet) {
            _super.call(this);
            this.folder = null;
            this.propertySet = null;
            this.folder = folder;
            this.propertySet = propertySet;
            EwsUtilities.Assert(this.propertySet !== null, "GetFolderResponse.ctor", "PropertySet should not be null");
        }
        Object.defineProperty(GetFolderResponse.prototype, "Folder", {
            get: function () {
                return this.folder;
            },
            enumerable: true,
            configurable: true
        });
        GetFolderResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Folders", this.GetObjectInstance, true, this.propertySet, false);
            this.folder = list.get_Item(0);
        };
        GetFolderResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            var list = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(responseObject, "Folders", this.GetObjectInstance, true, this.propertySet, false);
            this.folder = list.get_Item(0);
        };
        GetFolderResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            if (this.Folder !== null) {
                return this.Folder;
            }
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        return GetFolderResponse;
    }(ServiceResponse));
    var GetHoldOnMailboxesResponse = (function (_super) {
        __extends(GetHoldOnMailboxesResponse, _super);
        function GetHoldOnMailboxesResponse() {
            _super.call(this);
            this.holdResult = null;
        }
        Object.defineProperty(GetHoldOnMailboxesResponse.prototype, "HoldResult", {
            get: function () {
                return this.holdResult;
            },
            enumerable: true,
            configurable: true
        });
        GetHoldOnMailboxesResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.holdResult = MailboxHoldResult.LoadFromXml(reader);
        };
        GetHoldOnMailboxesResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("MailboxHoldResult")) {
                var jsonObject = responseObject.ReadAsJsonObject("MailboxHoldResult");
                this.holdResult = MailboxHoldResult.LoadFromJson(jsonObject);
            }
        };
        return GetHoldOnMailboxesResponse;
    }(ServiceResponse));
    var GetInboxRulesResponse = (function (_super) {
        __extends(GetInboxRulesResponse, _super);
        function GetInboxRulesResponse() {
            _super.call(this);
            this.ruleCollection = null;
            this.ruleCollection = new RuleCollection();
        }
        Object.defineProperty(GetInboxRulesResponse.prototype, "Rules", {
            get: function () {
                return this.ruleCollection;
            },
            enumerable: true,
            configurable: true
        });
        GetInboxRulesResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.Read();
            this.ruleCollection.OutlookRuleBlobExists = reader.ReadElementValue(XmlNamespace.Messages, "OutlookRuleBlobExists");
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.NotSpecified, "InboxRules")) {
                this.ruleCollection.LoadFromXml(reader, XmlNamespace.NotSpecified, "InboxRules");
            }
        };
        return GetInboxRulesResponse;
    }(ServiceResponse));
    var GetItemResponse = (function (_super) {
        __extends(GetItemResponse, _super);
        function GetItemResponse(item, propertySet) {
            _super.call(this);
            this.item = null;
            this.propertySet = null;
            this.item = item;
            this.propertySet = propertySet;
            EwsUtilities.Assert(this.propertySet !== null, "GetItemResponse.ctor", "PropertySet should not be null");
        }
        Object.defineProperty(GetItemResponse.prototype, "Item", {
            get: function () {
                return this.item;
            },
            enumerable: true,
            configurable: true
        });
        GetItemResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Items", this.GetObjectInstance, true, this.propertySet, false);
            this.item = list.get_Item(0);
        };
        GetItemResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            var list = new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(responseObject, "Items", this.GetObjectInstance, true, this.propertySet, false);
            this.item = list.get_Item(0);
        };
        GetItemResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            if (this.Item !== null) {
                return this.Item;
            }
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        return GetItemResponse;
    }(ServiceResponse));
    var GetNonIndexableItemDetailsResponse = (function (_super) {
        __extends(GetNonIndexableItemDetailsResponse, _super);
        function GetNonIndexableItemDetailsResponse() {
            _super.call(this);
            this.NonIndexableItemsResult = null;
        }
        GetNonIndexableItemDetailsResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.NonIndexableItemsResult = NonIndexableItemDetailsResult.LoadFromXml(reader);
        };
        GetNonIndexableItemDetailsResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            throw new NotImplementedException("GetNonIndexableItemdDetails doesn't support JSON.");
        };
        return GetNonIndexableItemDetailsResponse;
    }(ServiceResponse));
    var GetNonIndexableItemStatisticsResponse = (function (_super) {
        __extends(GetNonIndexableItemStatisticsResponse, _super);
        function GetNonIndexableItemStatisticsResponse() {
            _super.call(this);
            this.NonIndexableStatistics = null;
        }
        GetNonIndexableItemStatisticsResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.NonIndexableStatistics = NonIndexableItemStatistic.LoadFromXml(reader);
        };
        GetNonIndexableItemStatisticsResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            throw new NotImplementedException("GetNonIndexableItemStatistics doesn't support JSON.");
        };
        return GetNonIndexableItemStatisticsResponse;
    }(ServiceResponse));
    var GetPhoneCallResponse = (function (_super) {
        __extends(GetPhoneCallResponse, _super);
        function GetPhoneCallResponse(service) {
            _super.call(this);
            this.phoneCall = null;
            EwsUtilities.Assert(service !== null, "GetPhoneCallResponse.ctor", "service is null");
            this.phoneCall = new PhoneCall(service);
        }
        Object.defineProperty(GetPhoneCallResponse.prototype, "PhoneCall", {
            get: function () {
                return this.phoneCall;
            },
            enumerable: true,
            configurable: true
        });
        GetPhoneCallResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "PhoneCallInformation");
            this.phoneCall.LoadFromXml(reader, XmlNamespace.Messages, "PhoneCallInformation");
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "PhoneCallInformation");
        };
        return GetPhoneCallResponse;
    }(ServiceResponse));
    var GetPasswordExpirationDateResponse = (function (_super) {
        __extends(GetPasswordExpirationDateResponse, _super);
        function GetPasswordExpirationDateResponse() {
            _super.call(this);
            this.passwordExpirationDate = null;
        }
        Object.defineProperty(GetPasswordExpirationDateResponse.prototype, "PasswordExpirationDate", {
            get: function () {
                return this.passwordExpirationDate;
            },
            enumerable: true,
            configurable: true
        });
        GetPasswordExpirationDateResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.passwordExpirationDate = reader.ReadElementValueAsDateTime(XmlNamespace.NotSpecified, "PasswordExpirationDate");
        };
        GetPasswordExpirationDateResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.passwordExpirationDate = new Nullable(service.ConvertUniversalDateTimeStringToLocalDateTime(responseObject.ReadAsString("PasswordExpirationDate")).Value);
        };
        return GetPasswordExpirationDateResponse;
    }(ServiceResponse));
    var GetRoomListsResponse = (function (_super) {
        __extends(GetRoomListsResponse, _super);
        function GetRoomListsResponse() {
            _super.call(this);
            this.roomLists = new EmailAddressCollection();
        }
        Object.defineProperty(GetRoomListsResponse.prototype, "RoomLists", {
            get: function () {
                return this.roomLists;
            },
            enumerable: true,
            configurable: true
        });
        GetRoomListsResponse.prototype.ReadElementsFromXml = function (reader) {
            this.RoomLists.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "RoomLists");
            if (!reader.IsEmptyElement) {
                reader.Read();
                while (reader.IsStartElement(XmlNamespace.Types, "Address")) {
                    var emailAddress = new EmailAddress();
                    emailAddress.LoadFromXml(reader, "Address");
                    this.RoomLists.Add(emailAddress);
                    reader.Read();
                }
                reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Messages, "RoomLists");
            }
        };
        return GetRoomListsResponse;
    }(ServiceResponse));
    var GetRoomsResponse = (function (_super) {
        __extends(GetRoomsResponse, _super);
        function GetRoomsResponse() {
            _super.call(this);
            this.rooms = new Collection();
        }
        Object.defineProperty(GetRoomsResponse.prototype, "Rooms", {
            get: function () {
                return this.rooms;
            },
            enumerable: true,
            configurable: true
        });
        GetRoomsResponse.prototype.ReadElementsFromXml = function (reader) {
            this.Rooms.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "Rooms");
            if (!reader.IsEmptyElement) {
                reader.Read();
                while (reader.IsStartElement(XmlNamespace.Types, "Room")) {
                    reader.Read();
                    var emailAddress = new EmailAddress();
                    emailAddress.LoadFromXml(reader, "Id");
                    this.Rooms.Add(emailAddress);
                    reader.ReadEndElement(XmlNamespace.Types, "Room");
                    reader.Read();
                }
                reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Messages, "Rooms");
            }
        };
        return GetRoomsResponse;
    }(ServiceResponse));
    var GetSearchableMailboxesResponse = (function (_super) {
        __extends(GetSearchableMailboxesResponse, _super);
        function GetSearchableMailboxesResponse() {
            _super.call(this);
            this.searchableMailboxes = new List();
            this.FailedMailboxes = null;
        }
        Object.defineProperty(GetSearchableMailboxesResponse.prototype, "SearchableMailboxes", {
            get: function () {
                return this.searchableMailboxes.ToArray();
            },
            enumerable: true,
            configurable: true
        });
        GetSearchableMailboxesResponse.prototype.ReadElementsFromXml = function (reader) {
            this.searchableMailboxes.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "SearchableMailboxes");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "SearchableMailbox")) {
                        this.searchableMailboxes.Add(SearchableMailbox.LoadFromXml(reader));
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "SearchableMailboxes"));
            }
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "FailedMailboxes")) {
                this.FailedMailboxes = FailedSearchMailbox.LoadFailedMailboxesXml(XmlNamespace.Messages, reader);
            }
        };
        GetSearchableMailboxesResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            this.searchableMailboxes.Clear();
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("SearchMailboxes")) {
                var array = responseObject.ReadAsArray("SearchableMailboxes");
                for (var i = 0; i < array.length; i = i + 1) {
                    var obj = array[i];
                    var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                    this.searchableMailboxes.Add(SearchableMailbox.LoadFromJson(jsonObject));
                }
            }
        };
        return GetSearchableMailboxesResponse;
    }(ServiceResponse));
    var GetServerTimeZonesResponse = (function (_super) {
        __extends(GetServerTimeZonesResponse, _super);
        function GetServerTimeZonesResponse() {
            _super.call(this);
            this.timeZones = new Collection();
        }
        Object.defineProperty(GetServerTimeZonesResponse.prototype, "TimeZones", {
            get: function () {
                return this.timeZones;
            },
            enumerable: true,
            configurable: true
        });
        GetServerTimeZonesResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "TimeZoneDefinitions");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "TimeZoneDefinition")) {
                        var timeZoneDefinition = new TimeZoneDefinition();
                        timeZoneDefinition.LoadFromXml(reader);
                        this.timeZones.Add(timeZoneDefinition.ToTimeZoneInfo());
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "TimeZoneDefinitions"));
            }
        };
        return GetServerTimeZonesResponse;
    }(ServiceResponse));
    var GetUserConfigurationResponse = (function (_super) {
        __extends(GetUserConfigurationResponse, _super);
        function GetUserConfigurationResponse(userConfiguration) {
            _super.call(this);
            this.userConfiguration = null;
            EwsUtilities.Assert(userConfiguration !== null, "GetUserConfigurationResponse.ctor", "userConfiguration is null");
            this.userConfiguration = userConfiguration;
        }
        Object.defineProperty(GetUserConfigurationResponse.prototype, "UserConfiguration", {
            get: function () {
                return this.userConfiguration;
            },
            enumerable: true,
            configurable: true
        });
        GetUserConfigurationResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.userConfiguration.LoadFromXml(reader);
        };
        GetUserConfigurationResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.UserConfiguration.LoadFromJson(responseObject.ReadAsJsonObject("UserConfiguration"), service);
        };
        return GetUserConfigurationResponse;
    }(ServiceResponse));
    var GetUserOofSettingsResponse = (function (_super) {
        __extends(GetUserOofSettingsResponse, _super);
        function GetUserOofSettingsResponse() {
            _super.call(this);
            this.oofSettings = null;
        }
        Object.defineProperty(GetUserOofSettingsResponse.prototype, "OofSettings", {
            get: function () {
                return this.oofSettings;
            },
            set: function (value) {
                this.oofSettings = value;
            },
            enumerable: true,
            configurable: true
        });
        return GetUserOofSettingsResponse;
    }(ServiceResponse));
    var GetUserRetentionPolicyTagsResponse = (function (_super) {
        __extends(GetUserRetentionPolicyTagsResponse, _super);
        function GetUserRetentionPolicyTagsResponse() {
            _super.call(this);
            this.retentionPolicyTags = new List();
        }
        Object.defineProperty(GetUserRetentionPolicyTagsResponse.prototype, "RetentionPolicyTags", {
            get: function () {
                return this.retentionPolicyTags.ToArray();
            },
            enumerable: true,
            configurable: true
        });
        GetUserRetentionPolicyTagsResponse.prototype.ReadElementsFromXml = function (reader) {
            this.retentionPolicyTags.Clear();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadStartElement(XmlNamespace.Messages, "RetentionPolicyTags");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "RetentionPolicyTag")) {
                        this.retentionPolicyTags.Add(RetentionPolicyTag.LoadFromXml(reader));
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "RetentionPolicyTags"));
                reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "RetentionPolicyTags");
            }
        };
        GetUserRetentionPolicyTagsResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            this.retentionPolicyTags.Clear();
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("RetentionPolicyTags")) {
                var array = responseObject.ReadAsArray("RetentionPolicyTags");
                for (var i = 0; i < array.length; i = i + 1) {
                    var obj = array[i];
                    var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                    this.retentionPolicyTags.Add(RetentionPolicyTag.LoadFromJson(jsonObject));
                }
            }
        };
        return GetUserRetentionPolicyTagsResponse;
    }(ServiceResponse));
    var InstallAppResponse = (function (_super) {
        __extends(InstallAppResponse, _super);
        function InstallAppResponse() {
            _super.call(this);
        }
        return InstallAppResponse;
    }(ServiceResponse));
    var MarkAsJunkResponse = (function (_super) {
        __extends(MarkAsJunkResponse, _super);
        function MarkAsJunkResponse() {
            _super.call(this);
            this.MovedItemId = null;
        }
        MarkAsJunkResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "MovedItemId")) {
                this.MovedItemId = new ItemId();
                this.MovedItemId.LoadFromXml(reader, XmlNamespace.Messages, "MovedItemId");
                reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "MovedItemId");
            }
        };
        MarkAsJunkResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("Token")) {
                this.MovedItemId = new ItemId();
                this.MovedItemId.LoadFromJson(responseObject.ReadAsJsonObject("MovedItemId"), service);
            }
        };
        return MarkAsJunkResponse;
    }(ServiceResponse));
    var MoveCopyFolderResponse = (function (_super) {
        __extends(MoveCopyFolderResponse, _super);
        function MoveCopyFolderResponse() {
            _super.call(this);
            this.folder = null;
        }
        Object.defineProperty(MoveCopyFolderResponse.prototype, "Folder", {
            get: function () {
                return this.folder;
            },
            enumerable: true,
            configurable: true
        });
        MoveCopyFolderResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        MoveCopyFolderResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Folders", this.GetObjectInstance, false, null, false);
            this.folder = list.get_Item(0);
        };
        MoveCopyFolderResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var ewsServiceJsonReader = new EwsServiceJsonReader(service);
            var list = ewsServiceJsonReader.ReadServiceObjectsCollectionFromJson(responseObject, "Folders", this.GetObjectInstance, false, null, false);
            this.folder = list.get_Item(0);
        };
        return MoveCopyFolderResponse;
    }(ServiceResponse));
    var MoveCopyItemResponse = (function (_super) {
        __extends(MoveCopyItemResponse, _super);
        function MoveCopyItemResponse() {
            _super.call(this);
            this.item = null;
        }
        Object.defineProperty(MoveCopyItemResponse.prototype, "Item", {
            get: function () {
                return this.item;
            },
            enumerable: true,
            configurable: true
        });
        MoveCopyItemResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            return EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
        };
        MoveCopyItemResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            var list = reader.ReadServiceObjectsCollectionFromXml("Items", this.GetObjectInstance, false, null, false);
            if (list.Count > 0) {
                this.item = list.get_Item(0);
            }
        };
        MoveCopyItemResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            var ewsServiceJsonReader = new EwsServiceJsonReader(service);
            var list = ewsServiceJsonReader.ReadServiceObjectsCollectionFromJson(responseObject, "Folders", this.GetObjectInstance, false, null, false);
            if (list.Count > 0) {
                this.item = list.get_Item(0);
            }
        };
        return MoveCopyItemResponse;
    }(ServiceResponse));
    var ResolveNamesResponse = (function (_super) {
        __extends(ResolveNamesResponse, _super);
        function ResolveNamesResponse(service) {
            _super.call(this);
            this.resolutions = null;
            EwsUtilities.Assert(service !== null, "ResolveNamesResponse.ctor", "service is null");
            this.resolutions = new NameResolutionCollection(service);
        }
        Object.defineProperty(ResolveNamesResponse.prototype, "Resolutions", {
            get: function () {
                return this.resolutions;
            },
            enumerable: true,
            configurable: true
        });
        ResolveNamesResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.Resolutions.LoadFromXml(reader);
        };
        ResolveNamesResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.Resolutions.LoadFromJson(responseObject.ReadAsJsonObject("ResolutionSet"), service);
        };
        ResolveNamesResponse.prototype.InternalThrowIfNecessary = function () {
            if (this.ErrorCode !== ServiceError.ErrorNameResolutionNoResults) {
                _super.prototype.InternalThrowIfNecessary.call(this);
            }
        };
        return ResolveNamesResponse;
    }(ServiceResponse));
    var PlayOnPhoneResponse = (function (_super) {
        __extends(PlayOnPhoneResponse, _super);
        function PlayOnPhoneResponse(service) {
            _super.call(this);
            this.phoneCallId = null;
            EwsUtilities.Assert(service !== null, "PlayOnPhoneResponse.ctor", "service is null");
            this.phoneCallId = new PhoneCallId();
        }
        Object.defineProperty(PlayOnPhoneResponse.prototype, "PhoneCallId", {
            get: function () {
                return this.phoneCallId;
            },
            enumerable: true,
            configurable: true
        });
        PlayOnPhoneResponse.prototype.ReadElementsFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "PhoneCallId");
            this.phoneCallId.LoadFromXml(reader, XmlNamespace.Messages, "PhoneCallId");
            reader.ReadEndElementIfNecessary(XmlNamespace.Messages, "PhoneCallId");
        };
        PlayOnPhoneResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.phoneCallId.LoadFromJson(responseObject.ReadAsJsonObject("PhoneCallId"), service);
        };
        return PlayOnPhoneResponse;
    }(ServiceResponse));
    var SearchMailboxesResponse = (function (_super) {
        __extends(SearchMailboxesResponse, _super);
        function SearchMailboxesResponse() {
            _super.call(this);
            this.searchResult = null;
        }
        Object.defineProperty(SearchMailboxesResponse.prototype, "SearchResult", {
            get: function () {
                return this.searchResult;
            },
            set: function (value) {
                this.searchResult = value;
            },
            enumerable: true,
            configurable: true
        });
        SearchMailboxesResponse.prototype.ReadElementsFromXml = function (reader) {
            this.searchResult = new SearchMailboxesResult();
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.searchResult = SearchMailboxesResult.LoadFromXml(reader);
        };
        SearchMailboxesResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("SearchMailboxesResult")) {
                var jsonObject = responseObject.ReadAsJsonObject("SearchMailboxesResult");
                this.searchResult = SearchMailboxesResult.LoadFromJson(jsonObject);
            }
        };
        return SearchMailboxesResponse;
    }(ServiceResponse));
    var ServiceResponseCollection = (function () {
        function ServiceResponseCollection() {
            this.responses = new List();
            this.overallResult = 0;
            _super.call(this);
        }
        Object.defineProperty(ServiceResponseCollection.prototype, "Count", {
            get: function () {
                return this.responses.Count;
            },
            enumerable: true,
            configurable: true
        });
        ServiceResponseCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.responses.get_Item(index);
        };
        Object.defineProperty(ServiceResponseCollection.prototype, "OverallResult", {
            get: function () {
                return this.overallResult;
            },
            enumerable: true,
            configurable: true
        });
        ServiceResponseCollection.prototype.Add = function (response) {
            EwsUtilities.Assert(response !== null, "EwsResponseList.Add", "response is null");
            if (response.Result > this.overallResult) {
                this.overallResult = response.Result;
            }
            this.responses.Add(response);
        };
        ServiceResponseCollection.prototype.GetEnumerator = function () {
            return this.responses.GetEnumerator();
        };
        return ServiceResponseCollection;
    }());
    var SetEncryptionConfigurationResponse = (function (_super) {
        __extends(SetEncryptionConfigurationResponse, _super);
        function SetEncryptionConfigurationResponse() {
            _super.call(this);
        }
        return SetEncryptionConfigurationResponse;
    }(ServiceResponse));
    var SetHoldOnMailboxesResponse = (function (_super) {
        __extends(SetHoldOnMailboxesResponse, _super);
        function SetHoldOnMailboxesResponse() {
            _super.call(this);
            this.holdResult = null;
        }
        Object.defineProperty(SetHoldOnMailboxesResponse.prototype, "HoldResult", {
            get: function () {
                return this.holdResult;
            },
            enumerable: true,
            configurable: true
        });
        SetHoldOnMailboxesResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.holdResult = MailboxHoldResult.LoadFromXml(reader);
        };
        SetHoldOnMailboxesResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            if (responseObject.ContainsKey("MailboxHoldResult")) {
                var jsonObject = responseObject.ReadAsJsonObject("MailboxHoldResult");
                this.holdResult = MailboxHoldResult.LoadFromJson(jsonObject);
            }
        };
        return SetHoldOnMailboxesResponse;
    }(ServiceResponse));
    var SubscribeResponse = (function (_super) {
        __extends(SubscribeResponse, _super);
        function SubscribeResponse(subscription) {
            _super.call(this);
            this.subscription = null;
            EwsUtilities.Assert(subscription !== null, "SubscribeResponse.ctor", "subscription is null");
            this.subscription = subscription;
        }
        Object.defineProperty(SubscribeResponse.prototype, "Subscription", {
            get: function () {
                return this.subscription;
            },
            enumerable: true,
            configurable: true
        });
        SubscribeResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            this.subscription.LoadFromXml(reader);
        };
        SubscribeResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            this.subscription.LoadFromJson(responseObject, service);
        };
        return SubscribeResponse;
    }(ServiceResponse));
    var SuggestionsResponse = (function (_super) {
        __extends(SuggestionsResponse, _super);
        function SuggestionsResponse() {
            _super.call(this);
            this.daySuggestions = new Collection();
        }
        Object.defineProperty(SuggestionsResponse.prototype, "Suggestions", {
            get: function () {
                return this.daySuggestions;
            },
            enumerable: true,
            configurable: true
        });
        SuggestionsResponse.prototype.LoadSuggestedDaysFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "SuggestionDayResultArray");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "SuggestionDayResult")) {
                    var suggestion = new Suggestion();
                    suggestion.LoadFromXml(reader, reader.LocalName);
                    this.daySuggestions.Add(suggestion);
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "SuggestionDayResultArray"));
        };
        return SuggestionsResponse;
    }(ServiceResponse));
    var SyncResponse = (function (_super) {
        __extends(SyncResponse, _super);
        function SyncResponse(propertySet) {
            _super.call(this);
            this.changes = new ChangeCollection();
            this.propertySet = null;
            this.SummaryPropertiesOnly = false;
            this.propertySet = propertySet;
            EwsUtilities.Assert(this.propertySet !== null, "SyncResponse.ctor", "PropertySet should not be null");
        }
        Object.defineProperty(SyncResponse.prototype, "Changes", {
            get: function () {
                return this.changes;
            },
            enumerable: true,
            configurable: true
        });
        SyncResponse.prototype.GetIncludesLastInRangeXmlElementName = function () {
            throw new NotSupportedException();
        };
        SyncResponse.prototype.CreateChangeInstance = function () {
            throw new NotSupportedException();
        };
        SyncResponse.prototype.GetChangeElementName = function () {
            throw new NotSupportedException();
        };
        SyncResponse.prototype.GetChangeIdElementName = function () {
            throw new NotSupportedException();
        };
        SyncResponse.prototype.ReadElementsFromXml = function (reader) {
            this.Changes.SyncState = reader.ReadElementValue(XmlNamespace.Messages, "SyncState");
            this.Changes.MoreChangesAvailable = !reader.ReadElementValue(XmlNamespace.Messages, this.GetIncludesLastInRangeXmlElementName());
            reader.ReadStartElement(XmlNamespace.Messages, "Changes");
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        var tChange = this.CreateChangeInstance();
                        var localName;
                        if ((localName = reader.LocalName) === null) {
                            goto;
                            IL_E1;
                        }
                        if (!(localName === "Create")) {
                            if (!(localName === "Update")) {
                                if (!(localName === "Delete")) {
                                    if (!(localName === "ReadFlagChange")) {
                                        goto;
                                        IL_E1;
                                    }
                                    tChange.ChangeType = ChangeType.ReadFlagChange;
                                }
                                else {
                                    tChange.ChangeType = ChangeType.Delete;
                                }
                            }
                            else {
                                tChange.ChangeType = ChangeType.Update;
                            }
                        }
                        else {
                            tChange.ChangeType = ChangeType.Create;
                        }
                        IL_E7: if (tChange !== null) {
                            reader.Read();
                            reader.EnsureCurrentNodeIsStartElement();
                            switch (tChange.ChangeType) {
                                case ChangeType.Delete:
                                case ChangeType.ReadFlagChange:
                                    tChange.Id = tChange.CreateId();
                                    tChange.Id.LoadFromXml(reader, tChange.Id.GetXmlElementName());
                                    if (tChange.ChangeType === ChangeType.ReadFlagChange) {
                                        reader.Read();
                                        reader.EnsureCurrentNodeIsStartElement();
                                        var itemChange = ((tChange instanceof ItemChange) ? tChange : null);
                                        EwsUtilities.Assert(itemChange !== null, "SyncResponse.ReadElementsFromXml", "ReadFlagChange is only valid on ItemChange");
                                        itemChange.IsRead = reader.ReadElementValue(XmlNamespace.Types, "IsRead");
                                    }
                                    break;
                                default:
                                    tChange.ServiceObject = EwsUtilities.CreateEwsObjectFromXmlElementName(reader.Service, reader.LocalName);
                                    tChange.ServiceObject.LoadFromXml(reader, true, this.propertySet, this.SummaryPropertiesOnly);
                                    break;
                            }
                            reader.ReadEndElementIfNecessary(XmlNamespace.Types, ChangeType[tChange.ChangeType]);
                            this.changes.Add(tChange);
                            goto;
                            IL_222;
                        }
                        goto;
                        IL_222;
                        IL_E1: reader.SkipCurrentElement();
                        goto;
                        IL_E7;
                    }
                    IL_222: ;
                } while (!reader.IsEndElement(XmlNamespace.Messages, "Changes"));
            }
        };
        SyncResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            this.Changes.SyncState = responseObject.ReadAsString("SyncState");
            this.Changes.MoreChangesAvailable = !responseObject.ReadAsBool(this.GetIncludesLastInRangeXmlElementName());
            var jsonObject = responseObject.ReadAsJsonObject("Changes");
            var array = jsonObject.ReadAsArray("Changes");
            for (var i = 0; i < array.length; i = i + 1) {
                var obj = array[i];
                var jsonObject2 = ((obj instanceof JsonObject) ? obj : null);
                var tChange = this.CreateChangeInstance();
                var text = jsonObject2.ReadAsString("ChangeType");
                var a;
                if ((a = text) !== null) {
                    if (!(a === "Create")) {
                        if (!(a === "Update")) {
                            if (!(a === "Delete")) {
                                if (a === "ReadFlagChange") {
                                    tChange.ChangeType = ChangeType.ReadFlagChange;
                                }
                            }
                            else {
                                tChange.ChangeType = ChangeType.Delete;
                            }
                        }
                        else {
                            tChange.ChangeType = ChangeType.Update;
                        }
                    }
                    else {
                        tChange.ChangeType = ChangeType.Create;
                    }
                }
                if (tChange !== null) {
                    switch (tChange.ChangeType) {
                        case ChangeType.Delete:
                        case ChangeType.ReadFlagChange:
                            {
                                tChange.Id = tChange.CreateId();
                                var jsonProperty = jsonObject2.ReadAsJsonObject(this.GetChangeIdElementName());
                                tChange.Id.LoadFromJson(jsonProperty, service);
                                if (tChange.ChangeType === ChangeType.ReadFlagChange) {
                                    var itemChange = ((tChange instanceof ItemChange) ? tChange : null);
                                    EwsUtilities.Assert(itemChange !== null, "SyncResponse.ReadElementsFromJson", "ReadFlagChange is only valid on ItemChange");
                                    itemChange.IsRead = jsonObject2.ReadAsBool("IsRead");
                                }
                                break;
                            }
                        default:
                            {
                                var jsonObject3 = jsonObject2.ReadAsJsonObject(this.GetChangeElementName());
                                tChange.ServiceObject = EwsUtilities.CreateEwsObjectFromXmlElementName(service, jsonObject3.ReadTypeString());
                                tChange.ServiceObject.LoadFromJson(jsonObject3, service, true, this.propertySet, this.SummaryPropertiesOnly);
                                break;
                            }
                    }
                    this.changes.Add(tChange);
                }
            }
        };
        return SyncResponse;
    }(ServiceResponse));
    var SyncFolderHierarchyResponse = (function (_super) {
        __extends(SyncFolderHierarchyResponse, _super);
        function SyncFolderHierarchyResponse(propertySet) {
            _super.call(this, propertySet);
        }
        Object.defineProperty(SyncFolderHierarchyResponse.prototype, "SummaryPropertiesOnly", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        SyncFolderHierarchyResponse.prototype.GetIncludesLastInRangeXmlElementName = function () {
            return "IncludesLastFolderInRange";
        };
        SyncFolderHierarchyResponse.prototype.CreateChangeInstance = function () {
            return new FolderChange();
        };
        SyncFolderHierarchyResponse.prototype.GetChangeElementName = function () {
            return "Folder";
        };
        SyncFolderHierarchyResponse.prototype.GetChangeIdElementName = function () {
            return "FolderId";
        };
        return SyncFolderHierarchyResponse;
    }(SyncResponse));
    var SyncFolderItemsResponse = (function (_super) {
        __extends(SyncFolderItemsResponse, _super);
        function SyncFolderItemsResponse(propertySet) {
            _super.call(this, propertySet);
        }
        Object.defineProperty(SyncFolderItemsResponse.prototype, "SummaryPropertiesOnly", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        SyncFolderItemsResponse.prototype.GetIncludesLastInRangeXmlElementName = function () {
            return "IncludesLastItemInRange";
        };
        SyncFolderItemsResponse.prototype.CreateChangeInstance = function () {
            return new ItemChange();
        };
        SyncFolderItemsResponse.prototype.GetChangeElementName = function () {
            return "Item";
        };
        SyncFolderItemsResponse.prototype.GetChangeIdElementName = function () {
            return "ItemId";
        };
        return SyncFolderItemsResponse;
    }(SyncResponse));
    var UninstallAppResponse = (function (_super) {
        __extends(UninstallAppResponse, _super);
        function UninstallAppResponse() {
            _super.call(this);
        }
        return UninstallAppResponse;
    }(ServiceResponse));
    var UpdateFolderResponse = (function (_super) {
        __extends(UpdateFolderResponse, _super);
        function UpdateFolderResponse(folder) {
            _super.call(this);
            this.folder = null;
            EwsUtilities.Assert(folder !== null, "UpdateFolderResponse.ctor", "folder is null");
            this.folder = folder;
        }
        UpdateFolderResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadServiceObjectsCollectionFromXml("Folders", this.GetObjectInstance, false, null, false);
        };
        UpdateFolderResponse.prototype.Loaded = function () {
            if (this.Result === ServiceResult.Success) {
                this.folder.ClearChangeLog();
            }
        };
        UpdateFolderResponse.prototype.GetObjectInstance = function (session, xmlElementName) {
            return this.folder;
        };
        return UpdateFolderResponse;
    }(ServiceResponse));
    var UpdateInboxRulesResponse = (function (_super) {
        __extends(UpdateInboxRulesResponse, _super);
        function UpdateInboxRulesResponse() {
            _super.call(this);
            this.errors = null;
            this.errors = new RuleOperationErrorCollection();
        }
        Object.defineProperty(UpdateInboxRulesResponse.prototype, "Errors", {
            get: function () {
                return this.errors;
            },
            enumerable: true,
            configurable: true
        });
        UpdateInboxRulesResponse.prototype.LoadExtraErrorDetailsFromXml = function (reader, xmlElementName) {
            if (xmlElementName === "MessageXml") {
                return _super.prototype.LoadExtraErrorDetailsFromXml.call(this, reader, xmlElementName);
            }
            if (xmlElementName === "RuleOperationErrors") {
                this.errors.LoadFromXml(reader, XmlNamespace.Messages, xmlElementName);
                return true;
            }
            return false;
        };
        return UpdateInboxRulesResponse;
    }(ServiceResponse));
    var UpdateItemResponse = (function (_super) {
        __extends(UpdateItemResponse, _super);
        function UpdateItemResponse(item) {
            _super.call(this);
            this.item = null;
            this.returnedItem = null;
            this.conflictCount = 0;
            EwsUtilities.Assert(item !== null, "UpdateItemResponse.ctor", "item is null");
            this.item = item;
        }
        Object.defineProperty(UpdateItemResponse.prototype, "ReturnedItem", {
            get: function () {
                return this.returnedItem;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateItemResponse.prototype, "ConflictCount", {
            get: function () {
                return this.conflictCount;
            },
            enumerable: true,
            configurable: true
        });
        UpdateItemResponse.prototype.ReadElementsFromXml = function (reader) {
            _super.prototype.ReadElementsFromXml.call(this, reader);
            reader.ReadServiceObjectsCollectionFromXml("Items", this.GetObjectInstance, false, null, false);
            if (!reader.Service.Exchange2007CompatibilityMode) {
                reader.ReadStartElement(XmlNamespace.Messages, "ConflictResults");
                this.conflictCount = reader.ReadElementValue(XmlNamespace.Types, "Count");
                reader.ReadEndElement(XmlNamespace.Messages, "ConflictResults");
            }
            if (this.returnedItem !== null && this.item.Id.UniqueId === this.returnedItem.Id.UniqueId) {
                this.item.Id.ChangeKey = this.returnedItem.Id.ChangeKey;
                this.returnedItem = null;
            }
        };
        UpdateItemResponse.prototype.ReadElementsFromJson = function (responseObject, service) {
            _super.prototype.ReadElementsFromJson.call(this, responseObject, service);
            new EwsServiceJsonReader(service).ReadServiceObjectsCollectionFromJson(responseObject, "Items", this.GetObjectInstance, false, null, false);
            if (!service.Exchange2007CompatibilityMode) {
                this.conflictCount = responseObject.ReadAsJsonObject("ConflictResults").ReadAsInt("Count");
            }
            if (this.returnedItem !== null && this.item.Id.UniqueId === this.returnedItem.Id.UniqueId) {
                this.item.Id.ChangeKey = this.returnedItem.Id.ChangeKey;
                this.returnedItem = null;
            }
        };
        UpdateItemResponse.prototype.Loaded = function () {
            if (this.Result === ServiceResult.Success) {
                this.item.ClearChangeLog();
            }
        };
        UpdateItemResponse.prototype.GetObjectInstance = function (service, xmlElementName) {
            this.returnedItem = EwsUtilities.CreateEwsObjectFromXmlElementName(service, xmlElementName);
            return this.returnedItem;
        };
        return UpdateItemResponse;
    }(ServiceResponse));
    var ResponseObject = (function (_super) {
        __extends(ResponseObject, _super);
        function ResponseObject(referenceItem) {
            _super.call(this, referenceItem.Service);
            this.referenceItem = null;
            EwsUtilities.Assert(referenceItem !== null, "ResponseObject.ctor", "referenceItem is null");
            referenceItem.ThrowIfThisIsNew();
            this.referenceItem = referenceItem;
        }
        Object.defineProperty(ResponseObject.prototype, "IsReadReceiptRequested", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsReadReceiptRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsReadReceiptRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseObject.prototype, "IsDeliveryReceiptRequested", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.IsDeliveryReceiptRequested);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.IsDeliveryReceiptRequested, value);
            },
            enumerable: true,
            configurable: true
        });
        ResponseObject.prototype.GetSchema = function () {
            return ResponseObjectSchema.Instance;
        };
        ResponseObject.prototype.InternalLoad = function (propertySet) {
            throw new NotSupportedException();
        };
        ResponseObject.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new NotSupportedException();
        };
        ResponseObject.prototype.InternalCreate = function (destinationFolderId, messageDisposition) {
            this.PropertyBag.get_Item(ResponseObjectSchema.ReferenceItemId).Assign(this.referenceItem.Id);
            return this.Service.InternalCreateResponseObject(this, destinationFolderId, new Nullable(messageDisposition));
        };
        ResponseObject.prototype.Save = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Save_0(destinationFolderIdOrDestinationFolderName);
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName.constructor === Number)) {
                return this.Save_1(destinationFolderIdOrDestinationFolderName);
            }
            return this.Save_2();
        };
        ResponseObject.prototype.Save_0 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return ((this.InternalCreate(destinationFolderId, MessageDisposition.SaveOnly).get_Item(0) instanceof TMessage) ? this.InternalCreate(destinationFolderId, MessageDisposition.SaveOnly).get_Item(0) : null);
        };
        ResponseObject.prototype.Save_1 = function (destinationFolderName) {
            return ((this.InternalCreate(new FolderId(destinationFolderName), MessageDisposition.SaveOnly).get_Item(0) instanceof TMessage) ? this.InternalCreate(new FolderId(destinationFolderName), MessageDisposition.SaveOnly).get_Item(0) : null);
        };
        ResponseObject.prototype.Save_2 = function () {
            return ((this.InternalCreate(null, MessageDisposition.SaveOnly).get_Item(0) instanceof TMessage) ? this.InternalCreate(null, MessageDisposition.SaveOnly).get_Item(0) : null);
        };
        ResponseObject.prototype.Send = function () {
            this.InternalCreate(null, MessageDisposition.SendOnly);
        };
        ResponseObject.prototype.SendAndSaveCopy = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                this.SendAndSaveCopy_0(destinationFolderIdOrDestinationFolderName);
                return;
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName.constructor === Number)) {
                this.SendAndSaveCopy_1(destinationFolderIdOrDestinationFolderName);
                return;
            }
            this.SendAndSaveCopy_2();
        };
        ResponseObject.prototype.SendAndSaveCopy_0 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            this.InternalCreate(destinationFolderId, MessageDisposition.SendAndSaveCopy);
        };
        ResponseObject.prototype.SendAndSaveCopy_1 = function (destinationFolderName) {
            this.InternalCreate(new FolderId(destinationFolderName), MessageDisposition.SendAndSaveCopy);
        };
        ResponseObject.prototype.SendAndSaveCopy_2 = function () {
            this.InternalCreate(null, MessageDisposition.SendAndSaveCopy);
        };
        return ResponseObject;
    }(ServiceObject));
    var CalendarResponseMessageBase = (function (_super) {
        __extends(CalendarResponseMessageBase, _super);
        function CalendarResponseMessageBase(referenceItem) {
            _super.call(this, referenceItem);
        }
        CalendarResponseMessageBase.prototype.Save = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Save_0(destinationFolderIdOrDestinationFolderName);
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName.constructor === Number)) {
                return this.Save_1(destinationFolderIdOrDestinationFolderName);
            }
            return this.Save_2();
        };
        CalendarResponseMessageBase.prototype.Save_0 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return CalendarActionResults(_super.prototype.InternalCreate.call(this, destinationFolderId, MessageDisposition.SaveOnly));
        };
        CalendarResponseMessageBase.prototype.Save_1 = function (destinationFolderName) {
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, new FolderId(destinationFolderName), MessageDisposition.SaveOnly));
        };
        CalendarResponseMessageBase.prototype.Save_2 = function () {
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, null, MessageDisposition.SaveOnly));
        };
        CalendarResponseMessageBase.prototype.Send = function () {
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, null, MessageDisposition.SendOnly));
        };
        CalendarResponseMessageBase.prototype.SendAndSaveCopy = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.SendAndSaveCopy_0(destinationFolderIdOrDestinationFolderName);
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName.constructor === Number)) {
                return this.SendAndSaveCopy_1(destinationFolderIdOrDestinationFolderName);
            }
            return this.SendAndSaveCopy_2();
        };
        CalendarResponseMessageBase.prototype.SendAndSaveCopy_0 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, destinationFolderId, MessageDisposition.SendAndSaveCopy));
        };
        CalendarResponseMessageBase.prototype.SendAndSaveCopy_1 = function (destinationFolderName) {
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, new FolderId(destinationFolderName), MessageDisposition.SendAndSaveCopy));
        };
        CalendarResponseMessageBase.prototype.SendAndSaveCopy_2 = function () {
            return new CalendarActionResults(_super.prototype.InternalCreate.call(this, null, MessageDisposition.SendAndSaveCopy));
        };
        return CalendarResponseMessageBase;
    }(ResponseObject));
    var CalendarResponseMessage = (function (_super) {
        __extends(CalendarResponseMessage, _super);
        function CalendarResponseMessage(referenceItem) {
            _super.call(this, referenceItem);
        }
        Object.defineProperty(CalendarResponseMessage.prototype, "Body", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Body);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Body, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "ToRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ToRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "CcRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.CcRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "BccRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.BccRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "ItemClass", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.ItemClass);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.ItemClass, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "Sensitivity", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Sensitivity);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Sensitivity, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "Attachments", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Attachments);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "InternetMessageHeaders", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.InternetMessageHeaders);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarResponseMessage.prototype, "Sender", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.Sender);
            },
            set: function (value) {
                this.PropertyBag.set_Item(EmailMessageSchema.Sender, value);
            },
            enumerable: true,
            configurable: true
        });
        CalendarResponseMessage.prototype.GetSchema = function () {
            return CalendarResponseObjectSchema.Instance;
        };
        return CalendarResponseMessage;
    }(CalendarResponseMessageBase));
    var AcceptMeetingInvitationMessage = (function (_super) {
        __extends(AcceptMeetingInvitationMessage, _super);
        function AcceptMeetingInvitationMessage(referenceItem, tentative) {
            _super.call(this, referenceItem);
            this.tentative = false;
            this.tentative = tentative;
        }
        Object.defineProperty(AcceptMeetingInvitationMessage.prototype, "Tentative", {
            get: function () {
                return this.tentative;
            },
            enumerable: true,
            configurable: true
        });
        AcceptMeetingInvitationMessage.prototype.GetXmlElementNameOverride = function () {
            if (this.tentative) {
                return "TentativelyAcceptItem";
            }
            return "AcceptItem";
        };
        AcceptMeetingInvitationMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return AcceptMeetingInvitationMessage;
    }(CalendarResponseMessage));
    var CancelMeetingMessage = (function (_super) {
        __extends(CancelMeetingMessage, _super);
        function CancelMeetingMessage(referenceItem) {
            _super.call(this, referenceItem);
        }
        Object.defineProperty(CancelMeetingMessage.prototype, "Body", {
            get: function () {
                return this.PropertyBag.get_Item(CancelMeetingMessageSchema.Body);
            },
            set: function (value) {
                this.PropertyBag.set_Item(CancelMeetingMessageSchema.Body, value);
            },
            enumerable: true,
            configurable: true
        });
        CancelMeetingMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        CancelMeetingMessage.prototype.GetSchema = function () {
            return CancelMeetingMessageSchema.Instance;
        };
        return CancelMeetingMessage;
    }(CalendarResponseMessageBase));
    var DeclineMeetingInvitationMessage = (function (_super) {
        __extends(DeclineMeetingInvitationMessage, _super);
        function DeclineMeetingInvitationMessage(referenceItem) {
            _super.call(this, referenceItem);
        }
        DeclineMeetingInvitationMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        return DeclineMeetingInvitationMessage;
    }(CalendarResponseMessage));
    var PostReply = (function (_super) {
        __extends(PostReply, _super);
        function PostReply(referenceItem) {
            _super.call(this, referenceItem.Service);
            this.referenceItem = null;
            EwsUtilities.Assert(referenceItem !== null, "PostReply.ctor", "referenceItem is null");
            referenceItem.ThrowIfThisIsNew();
            this.referenceItem = referenceItem;
        }
        Object.defineProperty(PostReply.prototype, "Subject", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Subject);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Subject, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostReply.prototype, "Body", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Body);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Body, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PostReply.prototype, "BodyPrefix", {
            get: function () {
                return this.PropertyBag.get_Item(ResponseObjectSchema.BodyPrefix);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ResponseObjectSchema.BodyPrefix, value);
            },
            enumerable: true,
            configurable: true
        });
        PostReply.prototype.GetSchema = function () {
            return PostReplySchema.Instance;
        };
        PostReply.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        PostReply.prototype.InternalCreate = function (parentFolderId, messageDisposition) {
            this.PropertyBag.get_Item(ResponseObjectSchema.ReferenceItemId).Assign(this.referenceItem.Id);
            var items = this.Service.InternalCreateResponseObject(this, parentFolderId, messageDisposition);
            var postItem = EwsUtilities.FindFirstItemOfType(items);
            EwsUtilities.Assert(postItem !== null, "PostReply.InternalCreate", "postItem is null. The CreateItem call did not return the expected PostItem.");
            return postItem;
        };
        PostReply.prototype.InternalLoad = function (propertySet) {
            throw new InvalidOperationException(Strings.LoadingThisObjectTypeNotSupported);
        };
        PostReply.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new InvalidOperationException(Strings.DeletingThisObjectTypeNotAuthorized);
        };
        PostReply.prototype.Save = function (destinationFolderIdOrDestinationFolderName) {
            if (arguments.length === 0) {
                return this.Save_0();
            }
            if (arguments.length === 1 && (destinationFolderIdOrDestinationFolderName === null || destinationFolderIdOrDestinationFolderName instanceof FolderId)) {
                return this.Save_1(destinationFolderIdOrDestinationFolderName);
            }
            return this.Save_2(destinationFolderIdOrDestinationFolderName);
        };
        PostReply.prototype.Save_0 = function () {
            return this.InternalCreate(null, null);
        };
        PostReply.prototype.Save_1 = function (destinationFolderId) {
            EwsUtilities.ValidateParam(destinationFolderId, "destinationFolderId");
            return this.InternalCreate(destinationFolderId, null);
        };
        PostReply.prototype.Save_2 = function (destinationFolderName) {
            return this.InternalCreate(new FolderId(destinationFolderName), null);
        };
        return PostReply;
    }(ServiceObject));
    var RemoveFromCalendar = (function (_super) {
        __extends(RemoveFromCalendar, _super);
        function RemoveFromCalendar(referenceItem) {
            _super.call(this, referenceItem.Service);
            this.referenceItem = null;
            EwsUtilities.Assert(referenceItem !== null, "RemoveFromCalendar.ctor", "referenceItem is null");
            referenceItem.ThrowIfThisIsNew();
            this.referenceItem = referenceItem;
        }
        RemoveFromCalendar.prototype.GetSchema = function () {
            return ResponseObjectSchema.Instance;
        };
        RemoveFromCalendar.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        RemoveFromCalendar.prototype.InternalLoad = function (propertySet) {
            throw new NotSupportedException();
        };
        RemoveFromCalendar.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new NotSupportedException();
        };
        RemoveFromCalendar.prototype.InternalCreate = function (parentFolderId, messageDisposition) {
            this.PropertyBag.get_Item(ResponseObjectSchema.ReferenceItemId).Assign(this.referenceItem.Id);
            return this.Service.InternalCreateResponseObject(this, parentFolderId, messageDisposition);
        };
        return RemoveFromCalendar;
    }(ServiceObject));
    var ResponseMessage = (function (_super) {
        __extends(ResponseMessage, _super);
        function ResponseMessage(referenceItem, responseType) {
            _super.call(this, referenceItem);
            this.responseType = 0;
            this.responseType = responseType;
        }
        Object.defineProperty(ResponseMessage.prototype, "ResponseType", {
            get: function () {
                return this.responseType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "Body", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Body);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Body, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "ToRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.ToRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "CcRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.CcRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "BccRecipients", {
            get: function () {
                return this.PropertyBag.get_Item(EmailMessageSchema.BccRecipients);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "Subject", {
            get: function () {
                return this.PropertyBag.get_Item(ItemSchema.Subject);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ItemSchema.Subject, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseMessage.prototype, "BodyPrefix", {
            get: function () {
                return this.PropertyBag.get_Item(ResponseObjectSchema.BodyPrefix);
            },
            set: function (value) {
                this.PropertyBag.set_Item(ResponseObjectSchema.BodyPrefix, value);
            },
            enumerable: true,
            configurable: true
        });
        ResponseMessage.prototype.GetSchema = function () {
            return ResponseMessageSchema.Instance;
        };
        ResponseMessage.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        ResponseMessage.prototype.GetXmlElementNameOverride = function () {
            switch (this.responseType) {
                case ResponseMessageType.Reply:
                    return "ReplyToItem";
                case ResponseMessageType.ReplyAll:
                    return "ReplyAllToItem";
                case ResponseMessageType.Forward:
                    return "ForwardItem";
                default:
                    EwsUtilities.Assert(false, "ResponseMessage.GetXmlElementNameOverride", "An unexpected value for responseType could not be handled.");
                    return null;
            }
        };
        return ResponseMessage;
    }(ResponseObject));
    var SuppressReadReceipt = (function (_super) {
        __extends(SuppressReadReceipt, _super);
        function SuppressReadReceipt(referenceItem) {
            _super.call(this, referenceItem.Service);
            this.referenceItem = null;
            EwsUtilities.Assert(referenceItem !== null, "SuppressReadReceipt.ctor", "referenceItem is null");
            referenceItem.ThrowIfThisIsNew();
            this.referenceItem = referenceItem;
        }
        SuppressReadReceipt.prototype.GetSchema = function () {
            return ResponseObjectSchema.Instance;
        };
        SuppressReadReceipt.prototype.GetMinimumRequiredServerVersion = function () {
            return ExchangeVersion.Exchange2007_SP1;
        };
        SuppressReadReceipt.prototype.InternalLoad = function (propertySet) {
            throw new NotSupportedException();
        };
        SuppressReadReceipt.prototype.InternalDelete = function (deleteMode, sendCancellationsMode, affectedTaskOccurrences) {
            throw new NotSupportedException();
        };
        SuppressReadReceipt.prototype.InternalCreate = function (parentFolderId, messageDisposition) {
            this.PropertyBag.get_Item(ResponseObjectSchema.ReferenceItemId).Assign(this.referenceItem.Id);
            this.Service.InternalCreateResponseObject(this, parentFolderId, messageDisposition);
        };
        return SuppressReadReceipt;
    }(ServiceObject));
    var PropertyDefinitionBase = (function () {
        function PropertyDefinitionBase() {
            this.Version = 0;
            this.Type = null;
            _super.call(this);
        }
        PropertyDefinitionBase.TryLoadFromXml = function (reader, propertyDefinition) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "FieldURI") {
                    propertyDefinition[0] = ServiceObjectSchema.FindPropertyDefinition(reader.ReadAttributeValue("FieldURI"));
                    reader.SkipCurrentElement();
                    return true;
                }
                if (localName === "IndexedFieldURI") {
                    propertyDefinition[0] = new IndexedPropertyDefinition(reader.ReadAttributeValue("FieldURI"), reader.ReadAttributeValue("FieldIndex"));
                    reader.SkipCurrentElement();
                    return true;
                }
                if (localName === "ExtendedFieldURI") {
                    propertyDefinition[0] = new ExtendedPropertyDefinition();
                    (((propertyDefinition[0] instanceof ExtendedPropertyDefinition) ? propertyDefinition[0] : null)).LoadFromXml(reader);
                    return true;
                }
            }
            return false;
        };
        PropertyDefinitionBase.TryLoadFromJson = function (jsonObject) {
            var a;
            if ((a = jsonObject.ReadTypeString()) !== null) {
                if (a === "PropertyUri") {
                    return ServiceObjectSchema.FindPropertyDefinition(jsonObject.ReadAsString("FieldURI"));
                }
                if (a === "DictionaryPropertyUri") {
                    return new IndexedPropertyDefinition(jsonObject.ReadAsString("FieldURI"), jsonObject.ReadAsString("FieldIndex"));
                }
                if (a === "ExtendedPropertyUri") {
                    var extendedPropertyDefinition = new ExtendedPropertyDefinition();
                    extendedPropertyDefinition.LoadFromJson(jsonObject);
                    return extendedPropertyDefinition;
                }
            }
            return null;
        };
        PropertyDefinitionBase.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        PropertyDefinitionBase.prototype.GetJsonType = function () {
            throw new NotSupportedException();
        };
        PropertyDefinitionBase.prototype.WriteAttributesToXml = function (writer) {
            throw new NotSupportedException();
        };
        PropertyDefinitionBase.prototype.GetPrintableName = function () {
            throw new NotSupportedException();
        };
        PropertyDefinitionBase.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.GetXmlElementName());
            this.WriteAttributesToXml(writer);
            writer.WriteEndElement();
        };
        PropertyDefinitionBase.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetJsonType());
            this.AddJsonProperties(jsonObject, service);
            return jsonObject;
        };
        PropertyDefinitionBase.prototype.AddJsonProperties = function (jsonPropertyDefinition, service) {
            throw new NotSupportedException();
        };
        PropertyDefinitionBase.prototype.ToString = function () {
            return this.GetPrintableName();
        };
        return PropertyDefinitionBase;
    }());
    var ServiceObjectPropertyDefinition = (function (_super) {
        __extends(ServiceObjectPropertyDefinition, _super);
        function ServiceObjectPropertyDefinition(uri) {
            _super.call(this);
            this.uri = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(uri);
        }
        Object.defineProperty(ServiceObjectPropertyDefinition.prototype, "Version", {
            get: function () {
                return ExchangeVersion.Exchange2007_SP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectPropertyDefinition.prototype, "Uri", {
            get: function () {
                return this.uri;
            },
            enumerable: true,
            configurable: true
        });
        ServiceObjectPropertyDefinition.prototype.GetXmlElementName = function () {
            return "FieldURI";
        };
        ServiceObjectPropertyDefinition.prototype.GetJsonType = function () {
            return "PropertyUri";
        };
        ServiceObjectPropertyDefinition.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("FieldURI", this.Uri);
        };
        ServiceObjectPropertyDefinition.prototype.AddJsonProperties = function (jsonPropertyDefinition, service) {
            jsonPropertyDefinition.Add("FieldURI", this.Uri);
        };
        ServiceObjectPropertyDefinition.prototype.constructor_0 = function () {
        };
        ServiceObjectPropertyDefinition.prototype.constructor_1 = function (uri) {
            EwsUtilities.Assert(!NString.IsNullOrEmpty(uri), "ServiceObjectPropertyDefinition.ctor", "uri is null or empty");
            this.uri = uri;
        };
        return ServiceObjectPropertyDefinition;
    }(PropertyDefinitionBase));
    var PropertyDefinition = (function (_super) {
        __extends(PropertyDefinition, _super);
        function PropertyDefinition(xmlElementName, uriOrFlags, versionOrFlags, version) {
            _super.call(this, uriOrFlags);
            this.xmlElementName = null;
            this.flags = 0;
            this.name = null;
            this.version = 0;
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uriOrFlags === null || uriOrFlags.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_0(xmlElementName, uriOrFlags, versionOrFlags);
                return;
            }
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uriOrFlags === null || uriOrFlags.constructor === Number) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_1(xmlElementName, uriOrFlags, versionOrFlags);
                return;
            }
            this.constructor_2(xmlElementName, uriOrFlags, versionOrFlags, version);
        }
        Object.defineProperty(PropertyDefinition.prototype, "Version", {
            get: function () {
                return this.version;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertyDefinition.prototype, "XmlElementName", {
            get: function () {
                return this.xmlElementName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PropertyDefinition.prototype, "Name", {
            get: function () {
                if (NString.IsNullOrEmpty(this.name)) {
                    ServiceObjectSchema.InitializeSchemaPropertyNames();
                }
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        PropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
            this.xmlElementName = xmlElementName;
            this.flags = PropertyDefinitionFlags.None;
            this.version = version;
        };
        PropertyDefinition.prototype.constructor_1 = function (xmlElementName, flags, version) {
            this.xmlElementName = xmlElementName;
            this.flags = flags;
            this.version = version;
        };
        PropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version) {
            this.constructor_0(xmlElementName, uri, version);
            this.flags = flags;
        };
        PropertyDefinition.prototype.HasFlag = function (flag, version) {
            if (arguments.length === 1 && (flag === null || flag.constructor === Number)) {
                return this.HasFlag_0(flag);
            }
            return this.HasFlag_1(flag, version);
        };
        PropertyDefinition.prototype.HasFlag_0 = function (flag) {
            return this.HasFlag(flag, null);
        };
        PropertyDefinition.prototype.HasFlag_1 = function (flag, version) {
            return (this.flags & flag) === flag;
        };
        PropertyDefinition.prototype.RegisterAssociatedInternalProperties = function (properties) {
        };
        PropertyDefinition.prototype.GetAssociatedInternalProperties = function () {
            var list = new List();
            this.RegisterAssociatedInternalProperties(list);
            return list;
        };
        PropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            throw new NotSupportedException();
        };
        PropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            throw new NotSupportedException();
        };
        PropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            throw new NotSupportedException();
        };
        PropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            throw new NotSupportedException();
        };
        PropertyDefinition.prototype.GetPrintableName = function () {
            return this.Name;
        };
        return PropertyDefinition;
    }(ServiceObjectPropertyDefinition));
    var ComplexPropertyDefinitionBase = (function (_super) {
        __extends(ComplexPropertyDefinitionBase, _super);
        function ComplexPropertyDefinitionBase(xmlElementName, flagsOrUri, versionOrFlags, version) {
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (flagsOrUri === null || flagsOrUri.constructor === Number) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                _super.call(this, xmlElementName, flagsOrUri, versionOrFlags);
                this.constructor_0(xmlElementName, flagsOrUri, versionOrFlags);
                return;
            }
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (flagsOrUri === null || flagsOrUri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                _super.call(this, xmlElementName, flagsOrUri, versionOrFlags);
                this.constructor_1(xmlElementName, flagsOrUri, versionOrFlags);
                return;
            }
            _super.call(this, xmlElementName, flagsOrUri, versionOrFlags, version);
            this.constructor_2(xmlElementName, flagsOrUri, versionOrFlags, version);
        }
        ComplexPropertyDefinitionBase.prototype.constructor_0 = function (xmlElementName, flags, version) {
        };
        ComplexPropertyDefinitionBase.prototype.constructor_1 = function (xmlElementName, uri, version) {
        };
        ComplexPropertyDefinitionBase.prototype.constructor_2 = function (xmlElementName, uri, flags, version) {
        };
        ComplexPropertyDefinitionBase.prototype.CreatePropertyInstance = function (owner) {
            throw new NotSupportedException();
        };
        ComplexPropertyDefinitionBase.prototype.InternalLoadFromXml = function (reader, propertyBag) {
            var _this = this;
            var obj;
            if (!(function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.GetPropertyInstance(propertyBag, _p0);
                obj = _p0[0];
                return _r;
            })() && this.HasFlag(PropertyDefinitionFlags.UpdateCollectionItems, new Nullable(propertyBag.Owner.Service.RequestedServerVersion))) {
                (((obj instanceof ComplexProperty) ? obj : null)).UpdateFromXml(reader, reader.LocalName);
            }
            else {
                (((obj instanceof ComplexProperty) ? obj : null)).LoadFromXml(reader, reader.LocalName);
            }
            propertyBag.set_Item(this, obj);
        };
        ComplexPropertyDefinitionBase.prototype.InternalLoadFromJson = function (jsonObject, service, propertyBag) {
            var _this = this;
            var obj;
            (function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.GetPropertyInstance(propertyBag, _p0);
                obj = _p0[0];
                return _r;
            })();
            (((obj instanceof ComplexProperty) ? obj : null)).LoadFromJson(jsonObject, service);
            propertyBag.set_Item(this, obj);
        };
        ComplexPropertyDefinitionBase.prototype.InternalLoadCollectionFromJson = function (jsonCollection, service, propertyBag) {
            var _this = this;
            var obj;
            var propertyInstance = (function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.GetPropertyInstance(propertyBag, _p0);
                obj = _p0[0];
                return _r;
            })();
            var jsonCollectionDeserializer = ((obj instanceof IJsonCollectionDeserializer) ? obj : null);
            if (jsonCollectionDeserializer === null) {
                throw new ServiceJsonDeserializationException();
            }
            if (!propertyInstance && this.HasFlag(PropertyDefinitionFlags.UpdateCollectionItems, new Nullable(propertyBag.Owner.Service.RequestedServerVersion))) {
                jsonCollectionDeserializer.UpdateFromJsonCollection(jsonCollection, service);
            }
            else {
                jsonCollectionDeserializer.CreateFromJsonCollection(jsonCollection, service);
            }
            propertyBag.set_Item(this, jsonCollectionDeserializer);
        };
        ComplexPropertyDefinitionBase.prototype.GetPropertyInstance = function (propertyBag, complexProperty) {
            var _this = this;
            complexProperty[0] = null;
            if (!(function () {
                var _p0 = [
                    complexProperty[0]
                ];
                var _r = propertyBag.TryGetValue(_this, _p0);
                complexProperty[0] = _p0[0];
                return _r;
            })() || !this.HasFlag(PropertyDefinitionFlags.ReuseInstance, new Nullable(propertyBag.Owner.Service.RequestedServerVersion))) {
                complexProperty[0] = this.CreatePropertyInstance(propertyBag.Owner);
                return true;
            }
            return false;
        };
        ComplexPropertyDefinitionBase.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, this.XmlElementName);
            if (!reader.IsEmptyElement || reader.HasAttributes) {
                this.InternalLoadFromXml(reader, propertyBag);
            }
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, this.XmlElementName);
        };
        ComplexPropertyDefinitionBase.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var jsonObject = ((value instanceof JsonObject) ? value : null);
            if (jsonObject !== null) {
                this.InternalLoadFromJson(jsonObject, service, propertyBag);
                return;
            }
            if (value.GetType().IsArray) {
                this.InternalLoadCollectionFromJson(((value instanceof any[]) ? value : null), service, propertyBag);
            }
        };
        ComplexPropertyDefinitionBase.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var complexProperty = propertyBag.get_Item(this);
            if (complexProperty !== null) {
                complexProperty.WriteToXml(writer, this.XmlElementName);
            }
        };
        ComplexPropertyDefinitionBase.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            var complexProperty = propertyBag.get_Item(this);
            if (complexProperty !== null) {
                jsonObject.Add(this.XmlElementName, complexProperty.InternalToJson(service));
            }
        };
        return ComplexPropertyDefinitionBase;
    }(PropertyDefinition));
    var ComplexPropertyDefinition = (function (_super) {
        __extends(ComplexPropertyDefinition, _super);
        function ComplexPropertyDefinition(xmlElementName, flagsOrUri, versionOrFlags, propertyCreationDelegateOrVersion, propertyCreationDelegate) {
            _super.call(this, xmlElementName, flagsOrUri, versionOrFlags);
            this.propertyCreationDelegate = null;
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (flagsOrUri === null || flagsOrUri.constructor === Number) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_0(xmlElementName, flagsOrUri, versionOrFlags, propertyCreationDelegateOrVersion);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (flagsOrUri === null || flagsOrUri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_1(xmlElementName, flagsOrUri, versionOrFlags, propertyCreationDelegateOrVersion);
                return;
            }
            this.constructor_2(xmlElementName, flagsOrUri, versionOrFlags, propertyCreationDelegateOrVersion, propertyCreationDelegate);
        }
        Object.defineProperty(ComplexPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("TComplexProperty");
            },
            enumerable: true,
            configurable: true
        });
        ComplexPropertyDefinition.prototype.constructor_0 = function (xmlElementName, flags, version, propertyCreationDelegate) {
            EwsUtilities.Assert(propertyCreationDelegate !== null, "ComplexPropertyDefinition ctor", "CreateComplexPropertyDelegate cannot be null");
            this.propertyCreationDelegate = propertyCreationDelegate;
        };
        ComplexPropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, version, propertyCreationDelegate) {
            this.propertyCreationDelegate = propertyCreationDelegate;
        };
        ComplexPropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, propertyCreationDelegate) {
            this.propertyCreationDelegate = propertyCreationDelegate;
        };
        ComplexPropertyDefinition.prototype.CreatePropertyInstance = function (owner) {
            var tComplexProperty = this.propertyCreationDelegate();
            var ownedProperty = ((tComplexProperty instanceof IOwnedProperty) ? tComplexProperty : null);
            if (ownedProperty !== null) {
                ownedProperty.Owner = owner;
            }
            return tComplexProperty;
        };
        return ComplexPropertyDefinition;
    }(ComplexPropertyDefinitionBase));
    var ServiceObjectSchema = (function () {
        function ServiceObjectSchema() {
            this.properties = new Dictionary();
            this.visibleProperties = new List();
            this.firstClassProperties = new List();
            this.firstClassSummaryProperties = new List();
            this.indexedProperties = new List();
            _super.call(this);
            this.RegisterProperties();
        }
        Object.defineProperty(ServiceObjectSchema.prototype, "FirstClassProperties", {
            get: function () {
                return this.firstClassProperties;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectSchema.prototype, "FirstClassSummaryProperties", {
            get: function () {
                return this.firstClassSummaryProperties;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceObjectSchema.prototype, "IndexedProperties", {
            get: function () {
                return this.indexedProperties;
            },
            enumerable: true,
            configurable: true
        });
        ServiceObjectSchema.ForeachPublicStaticPropertyFieldInType = function (type, propFieldDelegate) {
            var fields = type.GetFields(BindingFlags.DeclaredOnly | BindingFlags.Static | BindingFlags.Public);
            var array = fields;
            for (var i = 0; i < array.length; i = i + 1) {
                var fieldInfo = array[i];
                if (Type.op_Equality(fieldInfo.FieldType, new Type("PropertyDefinition")) || fieldInfo.FieldType.IsSubclassOf(new Type("PropertyDefinition"))) {
                    var propertyDefinition = fieldInfo.GetValue(null);
                    propFieldDelegate(propertyDefinition, fieldInfo);
                }
            }
        };
        ServiceObjectSchema.AddSchemaPropertiesToDictionary = function (type, propDefDictionary) {
            ServiceObjectSchema.ForeachPublicStaticPropertyFieldInType(type, function (propertyDefinition, fieldInfo) {
                if (!NString.IsNullOrEmpty(propertyDefinition.Uri)) {
                    var propertyDefinitionBase;
                    if ((function () {
                        var _p0 = [
                            propertyDefinitionBase
                        ];
                        var _r = propDefDictionary.TryGetValue(propertyDefinition.Uri, _p0);
                        propertyDefinitionBase = _p0[0];
                        return _r;
                    })()) {
                        EwsUtilities.Assert(propertyDefinitionBase === propertyDefinition, "Schema.allSchemaProperties.delegate", NString.Format("There are at least two distinct property definitions with the following URI: {0}", propertyDefinition.Uri));
                        return;
                    }
                    propDefDictionary.Add(propertyDefinition.Uri, propertyDefinition);
                    var associatedInternalProperties = propertyDefinition.GetAssociatedInternalProperties();
                    var enumerator = associatedInternalProperties.GetEnumerator();
                    try {
                        while (enumerator.MoveNext()) {
                            var current = enumerator.Current;
                            propDefDictionary.Add(current.Uri, current);
                        }
                    }
                    finally {
                        enumerator.Dispose();
                    }
                }
            });
        };
        ServiceObjectSchema.AddSchemaPropertyNamesToDictionary = function (type, propertyNameDictionary) {
            ServiceObjectSchema.ForeachPublicStaticPropertyFieldInType(type, function (propertyDefinition, fieldInfo) {
                propertyNameDictionary.Add(propertyDefinition, fieldInfo.Name);
            });
        };
        ServiceObjectSchema.FindPropertyDefinition = function (uri) {
            return ServiceObjectSchema.allSchemaProperties.Member.get_Item(uri);
        };
        ServiceObjectSchema.InitializeSchemaPropertyNames = function () {
            var obj;
            Monitor.Enter(obj = ServiceObjectSchema.lockObject);
            try {
                var enumerator = ServiceObjectSchema.allSchemaTypes.Member.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        ServiceObjectSchema.ForeachPublicStaticPropertyFieldInType(current, function (propDef, fieldInfo) {
                            propDef.Name = fieldInfo.Name;
                        });
                    }
                }
                finally {
                    enumerator.Dispose();
                }
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        ServiceObjectSchema.prototype.RegisterProperty = function (property, isInternal) {
            if (arguments.length === 2 && (property === null || property instanceof PropertyDefinition) && (isInternal === null || isInternal.constructor === Boolean)) {
                this.RegisterProperty_0(property, isInternal);
                return;
            }
            this.RegisterProperty_1(property);
        };
        ServiceObjectSchema.prototype.RegisterProperty_0 = function (property, isInternal) {
            this.properties.Add(property.XmlElementName, property);
            if (!isInternal) {
                this.visibleProperties.Add(property);
            }
            if (!property.HasFlag(PropertyDefinitionFlags.MustBeExplicitlyLoaded)) {
                this.firstClassProperties.Add(property);
            }
            if (property.HasFlag(PropertyDefinitionFlags.CanFind)) {
                this.firstClassSummaryProperties.Add(property);
            }
        };
        ServiceObjectSchema.prototype.RegisterProperty_1 = function (property) {
            this.RegisterProperty(property, false);
        };
        ServiceObjectSchema.prototype.RegisterInternalProperty = function (property) {
            this.RegisterProperty(property, true);
        };
        ServiceObjectSchema.prototype.RegisterIndexedProperty = function (indexedProperty) {
            this.indexedProperties.Add(indexedProperty);
        };
        ServiceObjectSchema.prototype.RegisterProperties = function () {
        };
        ServiceObjectSchema.prototype.TryGetPropertyDefinition = function (xmlElementName, propertyDefinition) {
            var _this = this;
            return (function () {
                var _p0 = [
                    propertyDefinition[0]
                ];
                var _r = _this.properties.TryGetValue(xmlElementName, _p0);
                propertyDefinition[0] = _p0[0];
                return _r;
            })();
        };
        ServiceObjectSchema.prototype.GetEnumerator = function () {
            return this.visibleProperties.GetEnumerator();
        };
        ServiceObjectSchema.lockObject = new any();
        ServiceObjectSchema.allSchemaTypes = new LazyMember(function () {
            var list = new List();
            list.Add(new Type("AppointmentSchema"));
            list.Add(new Type("CalendarResponseObjectSchema"));
            list.Add(new Type("CancelMeetingMessageSchema"));
            list.Add(new Type("ContactGroupSchema"));
            list.Add(new Type("ContactSchema"));
            list.Add(new Type("ConversationSchema"));
            list.Add(new Type("EmailMessageSchema"));
            list.Add(new Type("FolderSchema"));
            list.Add(new Type("ItemSchema"));
            list.Add(new Type("MeetingMessageSchema"));
            list.Add(new Type("MeetingRequestSchema"));
            list.Add(new Type("MeetingCancellationSchema"));
            list.Add(new Type("MeetingResponseSchema"));
            list.Add(new Type("PostItemSchema"));
            list.Add(new Type("PostReplySchema"));
            list.Add(new Type("ResponseMessageSchema"));
            list.Add(new Type("ResponseObjectSchema"));
            list.Add(new Type("ServiceObjectSchema"));
            list.Add(new Type("SearchFolderSchema"));
            list.Add(new Type("TaskSchema"));
            return list;
        });
        ServiceObjectSchema.allSchemaProperties = new LazyMember(function () {
            var dictionary = new Dictionary();
            var enumerator = ServiceObjectSchema.allSchemaTypes.Member.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    ServiceObjectSchema.AddSchemaPropertiesToDictionary(current, dictionary);
                }
            }
            finally {
                enumerator.Dispose();
            }
            return dictionary;
        });
        ServiceObjectSchema.ExtendedProperties = new ComplexPropertyDefinition("ExtendedProperty", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.ReuseInstance | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new ExtendedPropertyCollection(); });
        return ServiceObjectSchema;
    }());
    var AttachmentsPropertyDefinition = (function (_super) {
        __extends(AttachmentsPropertyDefinition, _super);
        function AttachmentsPropertyDefinition() {
            _super.call(this, "Attachments", "item:Attachments", PropertyDefinitionFlags.AutoInstantiateOnRead, ExchangeVersion.Exchange2007_SP1, function () { return new AttachmentCollection(); });
        }
        AttachmentsPropertyDefinition.prototype.HasFlag = function (flag, version) {
            if (version !== null && version >= ExchangeVersion.Exchange2010_SP2) {
                return (flag & AttachmentsPropertyDefinition.Exchange2010SP2PropertyDefinitionFlags) === flag;
            }
            return _super.prototype.HasFlag.call(this, flag, version);
        };
        AttachmentsPropertyDefinition.Exchange2010SP2PropertyDefinitionFlags = PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.ReuseInstance | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.UpdateCollectionItems;
        return AttachmentsPropertyDefinition;
    }(ComplexPropertyDefinition));
    var TypedPropertyDefinition = (function (_super) {
        __extends(TypedPropertyDefinition, _super);
        function TypedPropertyDefinition(xmlElementName, uri, versionOrFlags, version, isNullable) {
            _super.call(this, xmlElementName, uri, versionOrFlags);
            this.isNullable = false;
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_0(xmlElementName, uri, versionOrFlags);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number) && (version === null || version.constructor === Number)) {
                this.constructor_1(xmlElementName, uri, versionOrFlags, version);
                return;
            }
            this.constructor_2(xmlElementName, uri, versionOrFlags, version, isNullable);
        }
        Object.defineProperty(TypedPropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return this.isNullable;
            },
            enumerable: true,
            configurable: true
        });
        TypedPropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
            this.isNullable = false;
        };
        TypedPropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, flags, version) {
        };
        TypedPropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, isNullable) {
            this.constructor_1(xmlElementName, uri, flags, version);
            this.isNullable = isNullable;
        };
        TypedPropertyDefinition.prototype.Parse = function (value) {
            throw new NotSupportedException();
        };
        TypedPropertyDefinition.prototype.ToString = function (value) {
            return NObject.GenericToString(value);
        };
        TypedPropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var value = reader.ReadElementValue(XmlNamespace.Types, this.XmlElementName);
            if (!NString.IsNullOrEmpty(value)) {
                propertyBag.set_Item(this, this.Parse(value));
            }
        };
        TypedPropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var value2 = ((value instanceof string) ? value : null);
            if (!NString.IsNullOrEmpty(value2)) {
                propertyBag.set_Item(this, this.Parse(value2));
                return;
            }
            if (value !== null) {
                propertyBag.set_Item(this, this.Parse(NObject.GenericToString(value)));
            }
        };
        TypedPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var obj = propertyBag.get_Item(this);
            if (obj !== null) {
                writer.WriteElementValue(XmlNamespace.Types, this.XmlElementName, this.Name, obj);
            }
        };
        return TypedPropertyDefinition;
    }(PropertyDefinition));
    var GenericPropertyDefinition = (function (_super) {
        __extends(GenericPropertyDefinition, _super);
        function GenericPropertyDefinition(xmlElementName, uri, versionOrFlags, version, isNullable) {
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags);
                this.constructor_0(xmlElementName, uri, versionOrFlags);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number) && (version === null || version.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags, version);
                this.constructor_1(xmlElementName, uri, versionOrFlags, version);
                return;
            }
            _super.call(this, xmlElementName, uri, versionOrFlags, version, isNullable);
            this.constructor_2(xmlElementName, uri, versionOrFlags, version, isNullable);
        }
        Object.defineProperty(GenericPropertyDefinition.prototype, "Type", {
            get: function () {
                if (!this.IsNullable) {
                    return new Type("TPropertyValue");
                }
                return new Type("Array");
            },
            enumerable: true,
            configurable: true
        });
        GenericPropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
        };
        GenericPropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, flags, version) {
        };
        GenericPropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, isNullable) {
        };
        GenericPropertyDefinition.prototype.Parse = function (value) {
            return EwsUtilities.Parse(value);
        };
        GenericPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            jsonObject.Add(this.XmlElementName, propertyBag.get_Item(this));
        };
        return GenericPropertyDefinition;
    }(TypedPropertyDefinition));
    var BoolPropertyDefinition = (function (_super) {
        __extends(BoolPropertyDefinition, _super);
        function BoolPropertyDefinition(xmlElementName, uri, versionOrFlags, version, isNullable) {
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags);
                this.constructor_0(xmlElementName, uri, versionOrFlags);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number) && (version === null || version.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags, version);
                this.constructor_1(xmlElementName, uri, versionOrFlags, version);
                return;
            }
            _super.call(this, xmlElementName, uri, versionOrFlags, version, isNullable);
            this.constructor_2(xmlElementName, uri, versionOrFlags, version, isNullable);
        }
        BoolPropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
        };
        BoolPropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, flags, version) {
        };
        BoolPropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, isNullable) {
        };
        BoolPropertyDefinition.prototype.ToString = function (value) {
            return EwsUtilities.BoolToXSBool(value);
        };
        return BoolPropertyDefinition;
    }(GenericPropertyDefinition));
    var ByteArrayPropertyDefinition = (function (_super) {
        __extends(ByteArrayPropertyDefinition, _super);
        function ByteArrayPropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(ByteArrayPropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ByteArrayPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("Array");
            },
            enumerable: true,
            configurable: true
        });
        ByteArrayPropertyDefinition.prototype.Parse = function (value) {
            return Convert.FromBase64String(value);
        };
        ByteArrayPropertyDefinition.prototype.ToString = function (value) {
            return Convert.ToBase64String(value);
        };
        ByteArrayPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            if (propertyBag.get_Item(this) !== null) {
                jsonObject.Add(this.XmlElementName, this.ToString(propertyBag.get_Item(this)));
            }
        };
        return ByteArrayPropertyDefinition;
    }(TypedPropertyDefinition));
    var DateTimePropertyDefinition = (function (_super) {
        __extends(DateTimePropertyDefinition, _super);
        function DateTimePropertyDefinition(xmlElementName, uri, versionOrFlags, version, isNullable) {
            _super.call(this, xmlElementName, uri, versionOrFlags);
            this.isNullable = false;
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                this.constructor_0(xmlElementName, uri, versionOrFlags);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number) && (version === null || version.constructor === Number)) {
                this.constructor_1(xmlElementName, uri, versionOrFlags, version);
                return;
            }
            this.constructor_2(xmlElementName, uri, versionOrFlags, version, isNullable);
        }
        Object.defineProperty(DateTimePropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return this.isNullable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DateTimePropertyDefinition.prototype, "Type", {
            get: function () {
                if (!this.IsNullable) {
                    return new Type("DateTime");
                }
                return new Type("Array");
            },
            enumerable: true,
            configurable: true
        });
        DateTimePropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
        };
        DateTimePropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, flags, version) {
        };
        DateTimePropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, isNullable) {
            this.isNullable = isNullable;
        };
        DateTimePropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var value = reader.ReadElementValue(XmlNamespace.Types, this.XmlElementName);
            propertyBag.set_Item(this, reader.Service.ConvertUniversalDateTimeStringToLocalDateTime(value));
        };
        DateTimePropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var value2 = ((value instanceof string) ? value : null);
            if (!NString.IsNullOrEmpty(value2)) {
                propertyBag.set_Item(this, service.ConvertUniversalDateTimeStringToLocalDateTime(value2));
            }
        };
        DateTimePropertyDefinition.prototype.ScopeToTimeZone = function (service, dateTime, propertyBag, isUpdateOperation) {
            var result;
            try {
                result = new DateTime(EwsUtilities.ConvertTime(dateTime, service.TimeZone, TimeZoneInfo.Utc).Ticks, DateTimeKind.Utc);
            }
            catch (innerException) {
                if (innerException instanceof TimeZoneConversionException) {
                    throw new PropertyException(NString.Format(Strings.InvalidDateTime, dateTime), this.Name, innerException);
                }
                else
                    throw innerException;
            }
            return result;
        };
        DateTimePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var obj = propertyBag.get_Item(this);
            if (obj !== null) {
                writer.WriteStartElement(XmlNamespace.Types, this.XmlElementName);
                var convertedDateTime = this.GetConvertedDateTime(writer.Service, propertyBag, isUpdateOperation, obj);
                writer.WriteValue(EwsUtilities.DateTimeToXSDateTime(convertedDateTime), this.Name);
                writer.WriteEndElement();
            }
        };
        DateTimePropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            var obj = propertyBag.get_Item(this);
            if (obj !== null) {
                var convertedDateTime = this.GetConvertedDateTime(service, propertyBag, isUpdateOperation, obj);
                jsonObject.Add(this.XmlElementName, EwsUtilities.DateTimeToXSDateTime(convertedDateTime));
            }
        };
        DateTimePropertyDefinition.prototype.GetConvertedDateTime = function (service, propertyBag, isUpdateOperation, value) {
            var dateTime = value;
            var result;
            if (dateTime.Kind === DateTimeKind.Unspecified) {
                result = this.ScopeToTimeZone(service, value, propertyBag, isUpdateOperation);
            }
            else {
                result = dateTime;
            }
            return result;
        };
        return DateTimePropertyDefinition;
    }(PropertyDefinition));
    var EffectiveRightsPropertyDefinition = (function (_super) {
        __extends(EffectiveRightsPropertyDefinition, _super);
        function EffectiveRightsPropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(EffectiveRightsPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("Number");
            },
            enumerable: true,
            configurable: true
        });
        EffectiveRightsPropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var effectiveRights = EffectiveRights.None;
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, this.XmlElementName);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    var localName;
                    if (reader.IsStartElement() && (localName = reader.LocalName) !== null) {
                        if (_PrivateImplementationDetails_) {
                            70549;
                            B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                        }
                        $$method0x600186b - 1 === null;
                        {
                            var expr_47 = new Dictionary(7);
                            expr_47.Add("CreateAssociated", 0);
                            expr_47.Add("CreateContents", 1);
                            expr_47.Add("CreateHierarchy", 2);
                            expr_47.Add("Delete", 3);
                            expr_47.Add("Modify", 4);
                            expr_47.Add("Read", 5);
                            expr_47.Add("ViewPrivateItems", 6);
                            _PrivateImplementationDetails_;
                            {
                                70549;
                                B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                            }
                            $$method0x600186b - 1;
                            expr_47;
                        }
                        var num;
                        if ((function () {
                            var _p0 = [
                                num
                            ];
                            var _r = _PrivateImplementationDetails_, _a = (void 0)[70549], B87 = _a === void 0 ? -FCC0 - 4468 - A58C - F62EC848C70D : _a, $$method0x600186b = -1., TryGetValue = (localName, _p0);
                            num = _p0[0];
                            return _r;
                        })()) {
                            switch (num) {
                                case 0:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.CreateAssociated);
                                    }
                                    break;
                                case 1:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.CreateContents);
                                    }
                                    break;
                                case 2:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.CreateHierarchy);
                                    }
                                    break;
                                case 3:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.Delete);
                                    }
                                    break;
                                case 4:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.Modify);
                                    }
                                    break;
                                case 5:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.Read);
                                    }
                                    break;
                                case 6:
                                    if (reader.ReadElementValue()) {
                                        effectiveRights = (effectiveRights | EffectiveRights.ViewPrivateItems);
                                    }
                                    break;
                            }
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, this.XmlElementName));
            }
            propertyBag.set_Item(this, effectiveRights);
        };
        EffectiveRightsPropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var effectiveRights = EffectiveRights.None;
            var jsonObject = ((value instanceof JsonObject) ? value : null);
            if (jsonObject !== null) {
                var enumerator = jsonObject.Keys.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        var key;
                        switch (key = current) {
                            case "CreateAssociated":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.CreateAssociated);
                                }
                                break;
                            case "CreateContents":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.CreateContents);
                                }
                                break;
                            case "CreateHierarchy":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.CreateHierarchy);
                                }
                                break;
                            case "Delete":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.Delete);
                                }
                                break;
                            case "Modify":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.Modify);
                                }
                                break;
                            case "Read":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.Read);
                                }
                                break;
                            case "ViewPrivateItems":
                                if (jsonObject.ReadAsBool(current)) {
                                    effectiveRights = (effectiveRights | EffectiveRights.ViewPrivateItems);
                                }
                                break;
                        }
                    }
                }
                finally {
                    enumerator.Dispose();
                }
            }
            propertyBag.set_Item(this, value);
        };
        EffectiveRightsPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        };
        EffectiveRightsPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
        };
        return EffectiveRightsPropertyDefinition;
    }(PropertyDefinition));
    var IntPropertyDefinition = (function (_super) {
        __extends(IntPropertyDefinition, _super);
        function IntPropertyDefinition(xmlElementName, uri, versionOrFlags, version, isNullable) {
            if (arguments.length === 3 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags);
                this.constructor_0(xmlElementName, uri, versionOrFlags);
                return;
            }
            if (arguments.length === 4 && (xmlElementName === null || xmlElementName.constructor === String) && (uri === null || uri.constructor === String) && (versionOrFlags === null || versionOrFlags.constructor === Number) && (version === null || version.constructor === Number)) {
                _super.call(this, xmlElementName, uri, versionOrFlags, version);
                this.constructor_1(xmlElementName, uri, versionOrFlags, version);
                return;
            }
            _super.call(this, xmlElementName, uri, versionOrFlags, version, isNullable);
            this.constructor_2(xmlElementName, uri, versionOrFlags, version, isNullable);
        }
        IntPropertyDefinition.prototype.constructor_0 = function (xmlElementName, uri, version) {
        };
        IntPropertyDefinition.prototype.constructor_1 = function (xmlElementName, uri, flags, version) {
        };
        IntPropertyDefinition.prototype.constructor_2 = function (xmlElementName, uri, flags, version, isNullable) {
        };
        return IntPropertyDefinition;
    }(GenericPropertyDefinition));
    var ResponseObjectsPropertyDefinition = (function (_super) {
        __extends(ResponseObjectsPropertyDefinition, _super);
        function ResponseObjectsPropertyDefinition(xmlElementName, uri, version) {
            _super.call(this, xmlElementName, uri, version);
        }
        Object.defineProperty(ResponseObjectsPropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResponseObjectsPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("Number");
            },
            enumerable: true,
            configurable: true
        });
        ResponseObjectsPropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var responseActions = ResponseActions.None;
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, this.XmlElementName);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        responseActions = (responseActions | ResponseObjectsPropertyDefinition.GetResponseAction(reader.LocalName));
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, this.XmlElementName));
            }
            propertyBag.set_Item(this, responseActions);
        };
        ResponseObjectsPropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var responseActions = ResponseActions.None;
            var array = ((value instanceof any[]) ? value : null);
            if (array !== null) {
                var enumerator = Enumerable.OfType(NArray.ToEnumerable(array)).GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        if (current.HasTypeProperty()) {
                            var text = current.ReadTypeString();
                            if (!NString.IsNullOrEmpty(text)) {
                                responseActions = (responseActions | ResponseObjectsPropertyDefinition.GetResponseAction(text));
                            }
                        }
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
            propertyBag.set_Item(this, responseActions);
        };
        ResponseObjectsPropertyDefinition.GetResponseAction = function (responseActionString) {
            var result = ResponseActions.None;
            switch (responseActionString) {
                case "AcceptItem":
                    result = ResponseActions.Accept;
                    break;
                case "TentativelyAcceptItem":
                    result = ResponseActions.TentativelyAccept;
                    break;
                case "DeclineItem":
                    result = ResponseActions.Decline;
                    break;
                case "ReplyToItem":
                    result = ResponseActions.Reply;
                    break;
                case "ForwardItem":
                    result = ResponseActions.Forward;
                    break;
                case "ReplyAllToItem":
                    result = ResponseActions.ReplyAll;
                    break;
                case "CancelCalendarItem":
                    result = ResponseActions.Cancel;
                    break;
                case "RemoveItem":
                    result = ResponseActions.RemoveFromCalendar;
                    break;
                case "SuppressReadReceipt":
                    result = ResponseActions.SuppressReadReceipt;
                    break;
                case "PostReplyItem":
                    result = ResponseActions.PostReply;
                    break;
            }
            return result;
        };
        ResponseObjectsPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        };
        ResponseObjectsPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
        };
        return ResponseObjectsPropertyDefinition;
    }(PropertyDefinition));
    var ScopedDateTimePropertyDefinition = (function (_super) {
        __extends(ScopedDateTimePropertyDefinition, _super);
        function ScopedDateTimePropertyDefinition(xmlElementName, uri, flags, version, getPropertyDefinitionCallback) {
            _super.call(this, xmlElementName, uri, flags, version);
            this.getPropertyDefinitionCallback = null;
            EwsUtilities.Assert(getPropertyDefinitionCallback !== null, "ScopedDateTimePropertyDefinition.ctor", "getPropertyDefinitionCallback is null.");
            this.getPropertyDefinitionCallback = getPropertyDefinitionCallback;
        }
        ScopedDateTimePropertyDefinition.prototype.GetTimeZoneProperty = function (version) {
            var propertyDefinition = this.getPropertyDefinitionCallback(version);
            EwsUtilities.Assert(propertyDefinition !== null, "ScopedDateTimePropertyDefinition.GetTimeZoneProperty", "timeZoneProperty is null.");
            return propertyDefinition;
        };
        ScopedDateTimePropertyDefinition.prototype.ScopeToTimeZone = function (service, dateTime, propertyBag, isUpdateOperation) {
            if (!propertyBag.Owner.GetIsCustomDateTimeScopingRequired()) {
                return _super.prototype.ScopeToTimeZone.call(this, service, dateTime, propertyBag, isUpdateOperation);
            }
            var timeZoneProperty = this.GetTimeZoneProperty(service.RequestedServerVersion);
            var obj = null;
            (function () {
                var _p0 = [
                    obj
                ];
                var _r = propertyBag.TryGetProperty(timeZoneProperty, _p0);
                obj = _p0[0];
                return _r;
            })();
            if (obj !== null && propertyBag.IsPropertyUpdated(timeZoneProperty)) {
                try {
                    return new DateTime(EwsUtilities.ConvertTime(dateTime, obj, TimeZoneInfo.Utc).Ticks, DateTimeKind.Utc);
                }
                catch (innerException) {
                    if (innerException instanceof TimeZoneConversionException) {
                        throw new PropertyException(NString.Format(Strings.InvalidDateTime, dateTime), this.Name, innerException);
                    }
                    else
                        throw innerException;
                }
            }
            if (!isUpdateOperation) {
                return _super.prototype.ScopeToTimeZone.call(this, service, dateTime, propertyBag, isUpdateOperation);
            }
            if (service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                return _super.prototype.ScopeToTimeZone.call(this, service, dateTime, propertyBag, isUpdateOperation);
            }
            return dateTime;
        };
        return ScopedDateTimePropertyDefinition;
    }(DateTimePropertyDefinition));
    var StringPropertyDefinition = (function (_super) {
        __extends(StringPropertyDefinition, _super);
        function StringPropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(StringPropertyDefinition.prototype, "IsNullable", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StringPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("String");
            },
            enumerable: true,
            configurable: true
        });
        StringPropertyDefinition.prototype.Parse = function (value) {
            return value;
        };
        StringPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            jsonObject.Add(this.XmlElementName, propertyBag.get_Item(this));
        };
        return StringPropertyDefinition;
    }(TypedPropertyDefinition));
    var ItemSchema = (function (_super) {
        __extends(ItemSchema, _super);
        function ItemSchema() {
            _super.call(this);
        }
        ItemSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ItemSchema.MimeContent);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Id);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ParentFolderId);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ItemClass);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Subject);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Sensitivity);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Body);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Attachments);
            _super.prototype.RegisterProperty.call(this, ItemSchema.DateTimeReceived);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Size);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Categories);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Importance);
            _super.prototype.RegisterProperty.call(this, ItemSchema.InReplyTo);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsSubmitted);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsDraft);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsFromMe);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsResend);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsUnmodified);
            _super.prototype.RegisterProperty.call(this, ItemSchema.InternetMessageHeaders);
            _super.prototype.RegisterProperty.call(this, ItemSchema.DateTimeSent);
            _super.prototype.RegisterProperty.call(this, ItemSchema.DateTimeCreated);
            _super.prototype.RegisterProperty.call(this, ItemSchema.AllowedResponseActions);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ReminderDueBy);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsReminderSet);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ReminderMinutesBeforeStart);
            _super.prototype.RegisterProperty.call(this, ItemSchema.DisplayCc);
            _super.prototype.RegisterProperty.call(this, ItemSchema.DisplayTo);
            _super.prototype.RegisterProperty.call(this, ItemSchema.HasAttachments);
            _super.prototype.RegisterProperty.call(this, ServiceObjectSchema.ExtendedProperties);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Culture);
            _super.prototype.RegisterProperty.call(this, ItemSchema.EffectiveRights);
            _super.prototype.RegisterProperty.call(this, ItemSchema.LastModifiedName);
            _super.prototype.RegisterProperty.call(this, ItemSchema.LastModifiedTime);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IsAssociated);
            _super.prototype.RegisterProperty.call(this, ItemSchema.WebClientReadFormQueryString);
            _super.prototype.RegisterProperty.call(this, ItemSchema.WebClientEditFormQueryString);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ConversationId);
            _super.prototype.RegisterProperty.call(this, ItemSchema.UniqueBody);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Flag);
            _super.prototype.RegisterProperty.call(this, ItemSchema.StoreEntryId);
            _super.prototype.RegisterProperty.call(this, ItemSchema.InstanceKey);
            _super.prototype.RegisterProperty.call(this, ItemSchema.NormalizedBody);
            _super.prototype.RegisterProperty.call(this, ItemSchema.EntityExtractionResult);
            _super.prototype.RegisterProperty.call(this, ItemSchema.PolicyTag);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ArchiveTag);
            _super.prototype.RegisterProperty.call(this, ItemSchema.RetentionDate);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Preview);
            _super.prototype.RegisterProperty.call(this, ItemSchema.TextBody);
            _super.prototype.RegisterProperty.call(this, ItemSchema.IconIndex);
        };
        ItemSchema.Id = new ComplexPropertyDefinition("ItemId", "item:ItemId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new ItemId(); });
        ItemSchema.Body = new ComplexPropertyDefinition("Body", "item:Body", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new MessageBody(); });
        ItemSchema.ItemClass = new StringPropertyDefinition("ItemClass", "item:ItemClass", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.Subject = new StringPropertyDefinition("Subject", "item:Subject", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.MimeContent = new ComplexPropertyDefinition("MimeContent", "item:MimeContent", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2007_SP1, function () { return new MimeContent(); });
        ItemSchema.ParentFolderId = new ComplexPropertyDefinition("ParentFolderId", "item:ParentFolderId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new FolderId(); });
        ItemSchema.Sensitivity = new GenericPropertyDefinition("Sensitivity", "item:Sensitivity", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.Attachments = new AttachmentsPropertyDefinition();
        ItemSchema.DateTimeReceived = new DateTimePropertyDefinition("DateTimeReceived", "item:DateTimeReceived", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.Size = new IntPropertyDefinition("Size", "item:Size", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.Categories = new ComplexPropertyDefinition("Categories", "item:Categories", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new StringList(); });
        ItemSchema.Importance = new GenericPropertyDefinition("Importance", "item:Importance", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.InReplyTo = new StringPropertyDefinition("InReplyTo", "item:InReplyTo", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.IsSubmitted = new BoolPropertyDefinition("IsSubmitted", "item:IsSubmitted", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.IsAssociated = new BoolPropertyDefinition("IsAssociated", "item:IsAssociated", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010);
        ItemSchema.IsDraft = new BoolPropertyDefinition("IsDraft", "item:IsDraft", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.IsFromMe = new BoolPropertyDefinition("IsFromMe", "item:IsFromMe", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.IsResend = new BoolPropertyDefinition("IsResend", "item:IsResend", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.IsUnmodified = new BoolPropertyDefinition("IsUnmodified", "item:IsUnmodified", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.InternetMessageHeaders = new ComplexPropertyDefinition("InternetMessageHeaders", "item:InternetMessageHeaders", ExchangeVersion.Exchange2007_SP1, function () { return new InternetMessageHeaderCollection(); });
        ItemSchema.DateTimeSent = new DateTimePropertyDefinition("DateTimeSent", "item:DateTimeSent", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.DateTimeCreated = new DateTimePropertyDefinition("DateTimeCreated", "item:DateTimeCreated", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.AllowedResponseActions = new ResponseObjectsPropertyDefinition("ResponseObjects", "item:ResponseObjects", ExchangeVersion.Exchange2007_SP1);
        ItemSchema.ReminderDueBy = new ScopedDateTimePropertyDefinition("ReminderDueBy", "item:ReminderDueBy", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function (version) { return AppointmentSchema.StartTimeZone; });
        ItemSchema.IsReminderSet = new BoolPropertyDefinition("ReminderIsSet", "item:ReminderIsSet", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.ReminderMinutesBeforeStart = new IntPropertyDefinition("ReminderMinutesBeforeStart", "item:ReminderMinutesBeforeStart", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.DisplayCc = new StringPropertyDefinition("DisplayCc", "item:DisplayCc", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.DisplayTo = new StringPropertyDefinition("DisplayTo", "item:DisplayTo", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.HasAttachments = new BoolPropertyDefinition("HasAttachments", "item:HasAttachments", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.Culture = new StringPropertyDefinition("Culture", "item:Culture", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.EffectiveRights = new EffectiveRightsPropertyDefinition("EffectiveRights", "item:EffectiveRights", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.LastModifiedName = new StringPropertyDefinition("LastModifiedName", "item:LastModifiedName", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.LastModifiedTime = new DateTimePropertyDefinition("LastModifiedTime", "item:LastModifiedTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ItemSchema.WebClientReadFormQueryString = new StringPropertyDefinition("WebClientReadFormQueryString", "item:WebClientReadFormQueryString", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010);
        ItemSchema.WebClientEditFormQueryString = new StringPropertyDefinition("WebClientEditFormQueryString", "item:WebClientEditFormQueryString", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010);
        ItemSchema.ConversationId = new ComplexPropertyDefinition("ConversationId", "item:ConversationId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010, function () { return new ConversationId(); });
        ItemSchema.UniqueBody = new ComplexPropertyDefinition("UniqueBody", "item:UniqueBody", PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2010, function () { return new UniqueBody(); });
        ItemSchema.StoreEntryId = new ByteArrayPropertyDefinition("StoreEntryId", "item:StoreEntryId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP2);
        ItemSchema.InstanceKey = new ByteArrayPropertyDefinition("InstanceKey", "item:InstanceKey", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ItemSchema.NormalizedBody = new ComplexPropertyDefinition("NormalizedBody", "item:NormalizedBody", PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2013, function () { return new NormalizedBody(); });
        ItemSchema.EntityExtractionResult = new ComplexPropertyDefinition("EntityExtractionResult", "item:EntityExtractionResult", PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2013, function () { return new EntityExtractionResult(); });
        ItemSchema.Flag = new ComplexPropertyDefinition("Flag", "item:Flag", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new Flag(); });
        ItemSchema.PolicyTag = new ComplexPropertyDefinition("PolicyTag", "item:PolicyTag", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new PolicyTag(); });
        ItemSchema.ArchiveTag = new ComplexPropertyDefinition("ArchiveTag", "item:ArchiveTag", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new ArchiveTag(); });
        ItemSchema.RetentionDate = new DateTimePropertyDefinition("RetentionDate", "item:RetentionDate", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, true);
        ItemSchema.Preview = new StringPropertyDefinition("Preview", "item:Preview", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ItemSchema.TextBody = new ComplexPropertyDefinition("TextBody", "item:TextBody", PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2013, function () { return new TextBody(); });
        ItemSchema.IconIndex = new GenericPropertyDefinition("IconIndex", "item:IconIndex", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ItemSchema.Instance = new ItemSchema();
        return ItemSchema;
    }(ServiceObjectSchema));
    var ItemSchema_FieldUris = (function () {
        function ItemSchema_FieldUris() {
            _super.call(this);
        }
        ItemSchema_FieldUris.ItemId = "item:ItemId";
        ItemSchema_FieldUris.ParentFolderId = "item:ParentFolderId";
        ItemSchema_FieldUris.ItemClass = "item:ItemClass";
        ItemSchema_FieldUris.MimeContent = "item:MimeContent";
        ItemSchema_FieldUris.Attachments = "item:Attachments";
        ItemSchema_FieldUris.Subject = "item:Subject";
        ItemSchema_FieldUris.DateTimeReceived = "item:DateTimeReceived";
        ItemSchema_FieldUris.Size = "item:Size";
        ItemSchema_FieldUris.Categories = "item:Categories";
        ItemSchema_FieldUris.HasAttachments = "item:HasAttachments";
        ItemSchema_FieldUris.Importance = "item:Importance";
        ItemSchema_FieldUris.InReplyTo = "item:InReplyTo";
        ItemSchema_FieldUris.InternetMessageHeaders = "item:InternetMessageHeaders";
        ItemSchema_FieldUris.IsAssociated = "item:IsAssociated";
        ItemSchema_FieldUris.IsDraft = "item:IsDraft";
        ItemSchema_FieldUris.IsFromMe = "item:IsFromMe";
        ItemSchema_FieldUris.IsResend = "item:IsResend";
        ItemSchema_FieldUris.IsSubmitted = "item:IsSubmitted";
        ItemSchema_FieldUris.IsUnmodified = "item:IsUnmodified";
        ItemSchema_FieldUris.DateTimeSent = "item:DateTimeSent";
        ItemSchema_FieldUris.DateTimeCreated = "item:DateTimeCreated";
        ItemSchema_FieldUris.Body = "item:Body";
        ItemSchema_FieldUris.ResponseObjects = "item:ResponseObjects";
        ItemSchema_FieldUris.Sensitivity = "item:Sensitivity";
        ItemSchema_FieldUris.ReminderDueBy = "item:ReminderDueBy";
        ItemSchema_FieldUris.ReminderIsSet = "item:ReminderIsSet";
        ItemSchema_FieldUris.ReminderMinutesBeforeStart = "item:ReminderMinutesBeforeStart";
        ItemSchema_FieldUris.DisplayTo = "item:DisplayTo";
        ItemSchema_FieldUris.DisplayCc = "item:DisplayCc";
        ItemSchema_FieldUris.Culture = "item:Culture";
        ItemSchema_FieldUris.EffectiveRights = "item:EffectiveRights";
        ItemSchema_FieldUris.LastModifiedName = "item:LastModifiedName";
        ItemSchema_FieldUris.LastModifiedTime = "item:LastModifiedTime";
        ItemSchema_FieldUris.WebClientReadFormQueryString = "item:WebClientReadFormQueryString";
        ItemSchema_FieldUris.WebClientEditFormQueryString = "item:WebClientEditFormQueryString";
        ItemSchema_FieldUris.ConversationId = "item:ConversationId";
        ItemSchema_FieldUris.UniqueBody = "item:UniqueBody";
        ItemSchema_FieldUris.StoreEntryId = "item:StoreEntryId";
        ItemSchema_FieldUris.InstanceKey = "item:InstanceKey";
        ItemSchema_FieldUris.NormalizedBody = "item:NormalizedBody";
        ItemSchema_FieldUris.EntityExtractionResult = "item:EntityExtractionResult";
        ItemSchema_FieldUris.Flag = "item:Flag";
        ItemSchema_FieldUris.PolicyTag = "item:PolicyTag";
        ItemSchema_FieldUris.ArchiveTag = "item:ArchiveTag";
        ItemSchema_FieldUris.RetentionDate = "item:RetentionDate";
        ItemSchema_FieldUris.Preview = "item:Preview";
        ItemSchema_FieldUris.TextBody = "item:TextBody";
        ItemSchema_FieldUris.IconIndex = "item:IconIndex";
        return ItemSchema_FieldUris;
    }());
    var ContainedPropertyDefinition = (function (_super) {
        __extends(ContainedPropertyDefinition, _super);
        function ContainedPropertyDefinition(xmlElementName, uri, containedXmlElementName, flags, version, propertyCreationDelegate) {
            _super.call(this, xmlElementName, uri, flags, version, propertyCreationDelegate);
            this.containedXmlElementName = null;
            this.containedXmlElementName = containedXmlElementName;
        }
        ContainedPropertyDefinition.prototype.InternalLoadFromXml = function (reader, propertyBag) {
            reader.ReadStartElement(XmlNamespace.Types, this.containedXmlElementName);
            _super.prototype.InternalLoadFromXml.call(this, reader, propertyBag);
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, this.containedXmlElementName);
        };
        ContainedPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var complexProperty = propertyBag.get_Item(this);
            if (complexProperty !== null) {
                writer.WriteStartElement(XmlNamespace.Types, this.XmlElementName);
                complexProperty.WriteToXml(writer, this.containedXmlElementName);
                writer.WriteEndElement();
            }
        };
        return ContainedPropertyDefinition;
    }(ComplexPropertyDefinition));
    var MeetingTimeZonePropertyDefinition = (function (_super) {
        __extends(MeetingTimeZonePropertyDefinition, _super);
        function MeetingTimeZonePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(MeetingTimeZonePropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("MeetingTimeZone");
            },
            enumerable: true,
            configurable: true
        });
        MeetingTimeZonePropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var meetingTimeZone = new MeetingTimeZone();
            meetingTimeZone.LoadFromXml(reader, this.XmlElementName);
            propertyBag.set_Item(AppointmentSchema.StartTimeZone, meetingTimeZone.ToTimeZoneInfo());
        };
        MeetingTimeZonePropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var jsonObject = ((value instanceof JsonObject) ? value : null);
            if (jsonObject !== null) {
                var meetingTimeZone = new MeetingTimeZone();
                meetingTimeZone.LoadFromJson(jsonObject, service);
                propertyBag.set_Item(AppointmentSchema.StartTimeZone, meetingTimeZone.ToTimeZoneInfo());
            }
        };
        MeetingTimeZonePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var meetingTimeZone = propertyBag.get_Item(this);
            if (meetingTimeZone !== null) {
                meetingTimeZone.WriteToXml(writer, this.XmlElementName);
            }
        };
        MeetingTimeZonePropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            var meetingTimeZone = ((propertyBag.get_Item(this) instanceof MeetingTimeZone) ? propertyBag.get_Item(this) : null);
            if (meetingTimeZone !== null) {
                jsonObject.Add(this.XmlElementName, meetingTimeZone.InternalToJson(service));
            }
        };
        return MeetingTimeZonePropertyDefinition;
    }(PropertyDefinition));
    var RecurrencePropertyDefinition = (function (_super) {
        __extends(RecurrencePropertyDefinition, _super);
        function RecurrencePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(RecurrencePropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("Recurrence");
            },
            enumerable: true,
            configurable: true
        });
        RecurrencePropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "Recurrence");
            reader.Read(1);
            var recurrenceFromString = RecurrencePropertyDefinition.GetRecurrenceFromString(reader.LocalName);
            recurrenceFromString.LoadFromXml(reader, reader.LocalName);
            reader.Read(1);
            var recurrenceRange = RecurrencePropertyDefinition.GetRecurrenceRange(reader.LocalName);
            recurrenceRange.LoadFromXml(reader, reader.LocalName);
            recurrenceRange.SetupRecurrence(recurrenceFromString);
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, "Recurrence");
            propertyBag.set_Item(this, recurrenceFromString);
        };
        RecurrencePropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var jsonObject = ((value instanceof JsonObject) ? value : null);
            var jsonObject2 = jsonObject.ReadAsJsonObject("RecurrencePattern");
            var recurrenceFromString = RecurrencePropertyDefinition.GetRecurrenceFromString(jsonObject2.ReadTypeString());
            recurrenceFromString.LoadFromJson(jsonObject2, service);
            var jsonObject3 = jsonObject.ReadAsJsonObject("RecurrenceRange");
            var recurrenceRange = RecurrencePropertyDefinition.GetRecurrenceRange(jsonObject3.ReadTypeString());
            recurrenceRange.LoadFromJson(jsonObject3, service);
            recurrenceRange.SetupRecurrence(recurrenceFromString);
            propertyBag.set_Item(this, recurrenceFromString);
        };
        RecurrencePropertyDefinition.GetRecurrenceRange = function (recurrenceRangeString) {
            var IL_46 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        if (recurrenceRangeString !== null) {
                            var result;
                            if (!(recurrenceRangeString === "NoEndRecurrence")) {
                                if (!(recurrenceRangeString === "EndDateRecurrence")) {
                                    if (!(recurrenceRangeString === "NumberedRecurrence")) {
                                        _goto = IL_46;
                                        continue _GOTO_LOOP;
                                    }
                                    result = new NumberedRecurrenceRange();
                                }
                                else {
                                    result = new EndDateRecurrenceRange();
                                }
                            }
                            else {
                                result = new NoEndRecurrenceRange();
                            }
                            return result;
                        }
                        _goto = IL_46;
                        continue _GOTO_LOOP;
                    case 1:
                        throw new ServiceXmlDeserializationException(NString.Format(Strings.InvalidRecurrenceRange, recurrenceRangeString));
                }
            }
        };
        RecurrencePropertyDefinition.GetRecurrenceFromString = function (recurranceString) {
            var IL_131 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        if (recurranceString !== null) {
                            if (_PrivateImplementationDetails_) {
                                70549;
                                B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                            }
                            $$method0x60018b5 - 1 === null;
                            {
                                var expr_1D = new Dictionary(10);
                                expr_1D.Add("RelativeYearlyRecurrence", 0);
                                expr_1D.Add("AbsoluteYearlyRecurrence", 1);
                                expr_1D.Add("RelativeMonthlyRecurrence", 2);
                                expr_1D.Add("AbsoluteMonthlyRecurrence", 3);
                                expr_1D.Add("DailyRecurrence", 4);
                                expr_1D.Add("DailyRegeneration", 5);
                                expr_1D.Add("WeeklyRecurrence", 6);
                                expr_1D.Add("WeeklyRegeneration", 7);
                                expr_1D.Add("MonthlyRegeneration", 8);
                                expr_1D.Add("YearlyRegeneration", 9);
                                _PrivateImplementationDetails_;
                                {
                                    70549;
                                    B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                                }
                                $$method0x60018b5 - 1;
                                expr_1D;
                            }
                            var num;
                            if ((function () {
                                var _p0 = [
                                    num
                                ];
                                var _r = _PrivateImplementationDetails_, _a = (void 0)[70549], B87 = _a === void 0 ? -FCC0 - 4468 - A58C - F62EC848C70D : _a, $$method0x60018b5 = -1., TryGetValue = (recurranceString, _p0);
                                num = _p0[0];
                                return _r;
                            })()) {
                                var result;
                                switch (num) {
                                    case 0:
                                        result = new Recurrence_RelativeYearlyPattern();
                                        break;
                                    case 1:
                                        result = new Recurrence_YearlyPattern();
                                        break;
                                    case 2:
                                        result = new Recurrence_RelativeMonthlyPattern();
                                        break;
                                    case 3:
                                        result = new Recurrence_MonthlyPattern();
                                        break;
                                    case 4:
                                        result = new Recurrence_DailyPattern();
                                        break;
                                    case 5:
                                        result = new Recurrence_DailyRegenerationPattern();
                                        break;
                                    case 6:
                                        result = new Recurrence_WeeklyPattern();
                                        break;
                                    case 7:
                                        result = new Recurrence_WeeklyRegenerationPattern();
                                        break;
                                    case 8:
                                        result = new Recurrence_MonthlyRegenerationPattern();
                                        break;
                                    case 9:
                                        result = new Recurrence_YearlyRegenerationPattern();
                                        break;
                                    default:
                                        _goto = IL_131;
                                        continue _GOTO_LOOP;
                                }
                                return result;
                            }
                        }
                        _goto = IL_131;
                        continue _GOTO_LOOP;
                    case 1:
                        throw new ServiceXmlDeserializationException(NString.Format(Strings.InvalidRecurrencePattern, recurranceString));
                }
            }
        };
        RecurrencePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var recurrence = propertyBag.get_Item(this);
            if (recurrence !== null) {
                recurrence.WriteToXml(writer, "Recurrence");
            }
        };
        RecurrencePropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            var recurrence = ((propertyBag.get_Item(this) instanceof Recurrence) ? propertyBag.get_Item(this) : null);
            if (recurrence !== null) {
                jsonObject.Add(this.XmlElementName, recurrence.InternalToJson(service));
            }
        };
        return RecurrencePropertyDefinition;
    }(PropertyDefinition));
    var TimeZonePropertyDefinition = (function (_super) {
        __extends(TimeZonePropertyDefinition, _super);
        function TimeZonePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(TimeZonePropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("TimeZoneInfo");
            },
            enumerable: true,
            configurable: true
        });
        TimeZonePropertyDefinition.prototype.LoadPropertyValueFromXml = function (reader, propertyBag) {
            var timeZoneDefinition = new TimeZoneDefinition();
            timeZoneDefinition.LoadFromXml(reader, this.XmlElementName);
            propertyBag.set_Item(this, timeZoneDefinition.ToTimeZoneInfo());
        };
        TimeZonePropertyDefinition.prototype.LoadPropertyValueFromJson = function (value, service, propertyBag) {
            var timeZoneDefinition = new TimeZoneDefinition();
            var jsonObject = ((value instanceof JsonObject) ? value : null);
            if (jsonObject !== null) {
                timeZoneDefinition.LoadFromJson(jsonObject, service);
            }
            propertyBag.set_Item(this, timeZoneDefinition.ToTimeZoneInfo());
        };
        TimeZonePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var timeZoneInfo = propertyBag.get_Item(this);
            if (timeZoneInfo !== null && (!writer.IsTimeZoneHeaderEmitted || timeZoneInfo !== writer.Service.TimeZone)) {
                var timeZoneDefinition = new TimeZoneDefinition(timeZoneInfo);
                timeZoneDefinition.WriteToXml(writer, this.XmlElementName);
            }
        };
        TimeZonePropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            var timeZoneInfo = ((propertyBag.get_Item(this) instanceof TimeZoneInfo) ? propertyBag.get_Item(this) : null);
            if (timeZoneInfo !== null && timeZoneInfo !== service.TimeZone) {
                var timeZoneDefinition = new TimeZoneDefinition(timeZoneInfo);
                jsonObject.Add(this.XmlElementName, timeZoneDefinition.InternalToJson(service));
            }
        };
        return TimeZonePropertyDefinition;
    }(PropertyDefinition));
    var StartTimeZonePropertyDefinition = (function (_super) {
        __extends(StartTimeZonePropertyDefinition, _super);
        function StartTimeZonePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        StartTimeZonePropertyDefinition.prototype.RegisterAssociatedInternalProperties = function (properties) {
            _super.prototype.RegisterAssociatedInternalProperties.call(this, properties);
            properties.Add(AppointmentSchema.MeetingTimeZone);
        };
        StartTimeZonePropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
            var obj = propertyBag.get_Item(this);
            if (obj !== null) {
                if (writer.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                    var exchangeService = ((writer.Service instanceof ExchangeService) ? writer.Service : null);
                    if (exchangeService !== null && !exchangeService.Exchange2007CompatibilityMode) {
                        var meetingTimeZone = new MeetingTimeZone(obj);
                        meetingTimeZone.WriteToXml(writer, "MeetingTimeZone");
                        return;
                    }
                }
                else {
                    _super.prototype.WritePropertyValueToXml.call(this, writer, propertyBag, isUpdateOperation);
                }
            }
        };
        StartTimeZonePropertyDefinition.prototype.WriteToXml = function (writer) {
            if (writer.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) {
                AppointmentSchema.MeetingTimeZone.WriteToXml(writer);
                return;
            }
            _super.prototype.WriteToXml.call(this, writer);
        };
        StartTimeZonePropertyDefinition.prototype.HasFlag = function (flag, version) {
            if (version !== null && version.Value === ExchangeVersion.Exchange2007_SP1) {
                return AppointmentSchema.MeetingTimeZone.HasFlag(flag, version);
            }
            return _super.prototype.HasFlag.call(this, flag, version);
        };
        return StartTimeZonePropertyDefinition;
    }(TimeZonePropertyDefinition));
    var TimeSpanPropertyDefinition = (function (_super) {
        __extends(TimeSpanPropertyDefinition, _super);
        function TimeSpanPropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        TimeSpanPropertyDefinition.prototype.Parse = function (value) {
            return EwsUtilities.XSDurationToTimeSpan(value);
        };
        TimeSpanPropertyDefinition.prototype.ToString = function (value) {
            return EwsUtilities.TimeSpanToXSDuration(value);
        };
        TimeSpanPropertyDefinition.prototype.WriteJsonValue = function (jsonObject, propertyBag, service, isUpdateOperation) {
            jsonObject.Add(this.XmlElementName, propertyBag.get_Item(this));
        };
        return TimeSpanPropertyDefinition;
    }(GenericPropertyDefinition));
    var AppointmentSchema = (function (_super) {
        __extends(AppointmentSchema, _super);
        function AppointmentSchema() {
            _super.call(this);
        }
        AppointmentSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ICalUid);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ICalRecurrenceId);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ICalDateTimeStamp);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Start);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.End);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.OriginalStart);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsAllDayEvent);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.LegacyFreeBusyStatus);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Location);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.When);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsMeeting);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsCancelled);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsRecurring);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.MeetingRequestWasSent);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsResponseRequested);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AppointmentType);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.MyResponseType);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Organizer);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.RequiredAttendees);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.OptionalAttendees);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Resources);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ConflictingMeetingCount);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AdjacentMeetingCount);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ConflictingMeetings);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AdjacentMeetings);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Duration);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.TimeZone);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AppointmentReplyTime);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AppointmentSequenceNumber);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AppointmentState);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.Recurrence);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.FirstOccurrence);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.LastOccurrence);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ModifiedOccurrences);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.DeletedOccurrences);
            _super.prototype.RegisterInternalProperty.call(this, AppointmentSchema.MeetingTimeZone);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.StartTimeZone);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.EndTimeZone);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.ConferenceType);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.AllowNewTimeProposal);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.IsOnlineMeeting);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.MeetingWorkspaceUrl);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.NetShowUrl);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.EnhancedLocation);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.JoinOnlineMeetingUrl);
            _super.prototype.RegisterProperty.call(this, AppointmentSchema.OnlineMeetingSettings);
        };
        AppointmentSchema.StartTimeZone = new StartTimeZonePropertyDefinition("StartTimeZone", "calendar:StartTimeZone", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.EndTimeZone = new TimeZonePropertyDefinition("EndTimeZone", "calendar:EndTimeZone", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010);
        AppointmentSchema.Start = new ScopedDateTimePropertyDefinition("Start", "calendar:Start", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function (version) { return AppointmentSchema.StartTimeZone; });
        AppointmentSchema.End = new ScopedDateTimePropertyDefinition("End", "calendar:End", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function (version) {
            if (version !== ExchangeVersion.Exchange2007_SP1) {
                return AppointmentSchema.EndTimeZone;
            }
            return AppointmentSchema.StartTimeZone;
        });
        AppointmentSchema.OriginalStart = new DateTimePropertyDefinition("OriginalStart", "calendar:OriginalStart", ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsAllDayEvent = new BoolPropertyDefinition("IsAllDayEvent", "calendar:IsAllDayEvent", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.LegacyFreeBusyStatus = new GenericPropertyDefinition("LegacyFreeBusyStatus", "calendar:LegacyFreeBusyStatus", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.Location = new StringPropertyDefinition("Location", "calendar:Location", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.When = new StringPropertyDefinition("When", "calendar:When", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsMeeting = new BoolPropertyDefinition("IsMeeting", "calendar:IsMeeting", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsCancelled = new BoolPropertyDefinition("IsCancelled", "calendar:IsCancelled", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsRecurring = new BoolPropertyDefinition("IsRecurring", "calendar:IsRecurring", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.MeetingRequestWasSent = new BoolPropertyDefinition("MeetingRequestWasSent", "calendar:MeetingRequestWasSent", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsResponseRequested = new BoolPropertyDefinition("IsResponseRequested", "calendar:IsResponseRequested", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AppointmentType = new GenericPropertyDefinition("CalendarItemType", "calendar:CalendarItemType", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.MyResponseType = new GenericPropertyDefinition("MyResponseType", "calendar:MyResponseType", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.Organizer = new ContainedPropertyDefinition("Organizer", "calendar:Organizer", "Mailbox", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddress(); });
        AppointmentSchema.RequiredAttendees = new ComplexPropertyDefinition("RequiredAttendees", "calendar:RequiredAttendees", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new AttendeeCollection(); });
        AppointmentSchema.OptionalAttendees = new ComplexPropertyDefinition("OptionalAttendees", "calendar:OptionalAttendees", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new AttendeeCollection(); });
        AppointmentSchema.Resources = new ComplexPropertyDefinition("Resources", "calendar:Resources", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new AttendeeCollection(); });
        AppointmentSchema.ConflictingMeetingCount = new IntPropertyDefinition("ConflictingMeetingCount", "calendar:ConflictingMeetingCount", ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AdjacentMeetingCount = new IntPropertyDefinition("AdjacentMeetingCount", "calendar:AdjacentMeetingCount", ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.ConflictingMeetings = new ComplexPropertyDefinition("ConflictingMeetings", "calendar:ConflictingMeetings", ExchangeVersion.Exchange2007_SP1, function () { return new ItemCollection(); });
        AppointmentSchema.AdjacentMeetings = new ComplexPropertyDefinition("AdjacentMeetings", "calendar:AdjacentMeetings", ExchangeVersion.Exchange2007_SP1, function () { return new ItemCollection(); });
        AppointmentSchema.Duration = new TimeSpanPropertyDefinition("Duration", "calendar:Duration", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.TimeZone = new StringPropertyDefinition("TimeZone", "calendar:TimeZone", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AppointmentReplyTime = new DateTimePropertyDefinition("AppointmentReplyTime", "calendar:AppointmentReplyTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AppointmentSequenceNumber = new IntPropertyDefinition("AppointmentSequenceNumber", "calendar:AppointmentSequenceNumber", ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AppointmentState = new IntPropertyDefinition("AppointmentState", "calendar:AppointmentState", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.Recurrence = new RecurrencePropertyDefinition("Recurrence", "calendar:Recurrence", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.FirstOccurrence = new ComplexPropertyDefinition("FirstOccurrence", "calendar:FirstOccurrence", ExchangeVersion.Exchange2007_SP1, function () { return new OccurrenceInfo(); });
        AppointmentSchema.LastOccurrence = new ComplexPropertyDefinition("LastOccurrence", "calendar:LastOccurrence", ExchangeVersion.Exchange2007_SP1, function () { return new OccurrenceInfo(); });
        AppointmentSchema.ModifiedOccurrences = new ComplexPropertyDefinition("ModifiedOccurrences", "calendar:ModifiedOccurrences", ExchangeVersion.Exchange2007_SP1, function () { return new OccurrenceInfoCollection(); });
        AppointmentSchema.DeletedOccurrences = new ComplexPropertyDefinition("DeletedOccurrences", "calendar:DeletedOccurrences", ExchangeVersion.Exchange2007_SP1, function () { return new DeletedOccurrenceInfoCollection(); });
        AppointmentSchema.MeetingTimeZone = new MeetingTimeZonePropertyDefinition("MeetingTimeZone", "calendar:MeetingTimeZone", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.ConferenceType = new IntPropertyDefinition("ConferenceType", "calendar:ConferenceType", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.AllowNewTimeProposal = new BoolPropertyDefinition("AllowNewTimeProposal", "calendar:AllowNewTimeProposal", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.IsOnlineMeeting = new BoolPropertyDefinition("IsOnlineMeeting", "calendar:IsOnlineMeeting", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.MeetingWorkspaceUrl = new StringPropertyDefinition("MeetingWorkspaceUrl", "calendar:MeetingWorkspaceUrl", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.NetShowUrl = new StringPropertyDefinition("NetShowUrl", "calendar:NetShowUrl", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.ICalUid = new StringPropertyDefinition("UID", "calendar:UID", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        AppointmentSchema.ICalRecurrenceId = new DateTimePropertyDefinition("RecurrenceId", "calendar:RecurrenceId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        AppointmentSchema.ICalDateTimeStamp = new DateTimePropertyDefinition("DateTimeStamp", "calendar:DateTimeStamp", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        AppointmentSchema.EnhancedLocation = new ComplexPropertyDefinition("EnhancedLocation", "calendar:EnhancedLocation", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new EnhancedLocation(); });
        AppointmentSchema.JoinOnlineMeetingUrl = new StringPropertyDefinition("JoinOnlineMeetingUrl", "calendar:JoinOnlineMeetingUrl", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        AppointmentSchema.OnlineMeetingSettings = new ComplexPropertyDefinition("OnlineMeetingSettings", "calendar:OnlineMeetingSettings", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new OnlineMeetingSettings(); });
        AppointmentSchema.Instance = new AppointmentSchema();
        return AppointmentSchema;
    }(ItemSchema));
    var AppointmentSchema_FieldUris = (function () {
        function AppointmentSchema_FieldUris() {
            _super.call(this);
        }
        AppointmentSchema_FieldUris.Start = "calendar:Start";
        AppointmentSchema_FieldUris.End = "calendar:End";
        AppointmentSchema_FieldUris.OriginalStart = "calendar:OriginalStart";
        AppointmentSchema_FieldUris.IsAllDayEvent = "calendar:IsAllDayEvent";
        AppointmentSchema_FieldUris.LegacyFreeBusyStatus = "calendar:LegacyFreeBusyStatus";
        AppointmentSchema_FieldUris.Location = "calendar:Location";
        AppointmentSchema_FieldUris.When = "calendar:When";
        AppointmentSchema_FieldUris.IsMeeting = "calendar:IsMeeting";
        AppointmentSchema_FieldUris.IsCancelled = "calendar:IsCancelled";
        AppointmentSchema_FieldUris.IsRecurring = "calendar:IsRecurring";
        AppointmentSchema_FieldUris.MeetingRequestWasSent = "calendar:MeetingRequestWasSent";
        AppointmentSchema_FieldUris.IsResponseRequested = "calendar:IsResponseRequested";
        AppointmentSchema_FieldUris.CalendarItemType = "calendar:CalendarItemType";
        AppointmentSchema_FieldUris.MyResponseType = "calendar:MyResponseType";
        AppointmentSchema_FieldUris.Organizer = "calendar:Organizer";
        AppointmentSchema_FieldUris.RequiredAttendees = "calendar:RequiredAttendees";
        AppointmentSchema_FieldUris.OptionalAttendees = "calendar:OptionalAttendees";
        AppointmentSchema_FieldUris.Resources = "calendar:Resources";
        AppointmentSchema_FieldUris.ConflictingMeetingCount = "calendar:ConflictingMeetingCount";
        AppointmentSchema_FieldUris.AdjacentMeetingCount = "calendar:AdjacentMeetingCount";
        AppointmentSchema_FieldUris.ConflictingMeetings = "calendar:ConflictingMeetings";
        AppointmentSchema_FieldUris.AdjacentMeetings = "calendar:AdjacentMeetings";
        AppointmentSchema_FieldUris.Duration = "calendar:Duration";
        AppointmentSchema_FieldUris.TimeZone = "calendar:TimeZone";
        AppointmentSchema_FieldUris.AppointmentReplyTime = "calendar:AppointmentReplyTime";
        AppointmentSchema_FieldUris.AppointmentSequenceNumber = "calendar:AppointmentSequenceNumber";
        AppointmentSchema_FieldUris.AppointmentState = "calendar:AppointmentState";
        AppointmentSchema_FieldUris.Recurrence = "calendar:Recurrence";
        AppointmentSchema_FieldUris.FirstOccurrence = "calendar:FirstOccurrence";
        AppointmentSchema_FieldUris.LastOccurrence = "calendar:LastOccurrence";
        AppointmentSchema_FieldUris.ModifiedOccurrences = "calendar:ModifiedOccurrences";
        AppointmentSchema_FieldUris.DeletedOccurrences = "calendar:DeletedOccurrences";
        AppointmentSchema_FieldUris.MeetingTimeZone = "calendar:MeetingTimeZone";
        AppointmentSchema_FieldUris.StartTimeZone = "calendar:StartTimeZone";
        AppointmentSchema_FieldUris.EndTimeZone = "calendar:EndTimeZone";
        AppointmentSchema_FieldUris.ConferenceType = "calendar:ConferenceType";
        AppointmentSchema_FieldUris.AllowNewTimeProposal = "calendar:AllowNewTimeProposal";
        AppointmentSchema_FieldUris.IsOnlineMeeting = "calendar:IsOnlineMeeting";
        AppointmentSchema_FieldUris.MeetingWorkspaceUrl = "calendar:MeetingWorkspaceUrl";
        AppointmentSchema_FieldUris.NetShowUrl = "calendar:NetShowUrl";
        AppointmentSchema_FieldUris.Uid = "calendar:UID";
        AppointmentSchema_FieldUris.RecurrenceId = "calendar:RecurrenceId";
        AppointmentSchema_FieldUris.DateTimeStamp = "calendar:DateTimeStamp";
        AppointmentSchema_FieldUris.EnhancedLocation = "calendar:EnhancedLocation";
        AppointmentSchema_FieldUris.JoinOnlineMeetingUrl = "calendar:JoinOnlineMeetingUrl";
        AppointmentSchema_FieldUris.OnlineMeetingSettings = "calendar:OnlineMeetingSettings";
        return AppointmentSchema_FieldUris;
    }());
    var CalendarResponseObjectSchema = (function (_super) {
        __extends(CalendarResponseObjectSchema, _super);
        function CalendarResponseObjectSchema() {
            _super.call(this);
        }
        CalendarResponseObjectSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ItemSchema.ItemClass);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Sensitivity);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Body);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Attachments);
            _super.prototype.RegisterProperty.call(this, ItemSchema.InternetMessageHeaders);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.Sender);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ToRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.CcRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.BccRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsReadReceiptRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsDeliveryReceiptRequested);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.ReferenceItemId);
        };
        CalendarResponseObjectSchema.Instance = new CalendarResponseObjectSchema();
        return CalendarResponseObjectSchema;
    }(ServiceObjectSchema));
    var CancelMeetingMessageSchema = (function (_super) {
        __extends(CancelMeetingMessageSchema, _super);
        function CancelMeetingMessageSchema() {
            _super.call(this);
        }
        CancelMeetingMessageSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsReadReceiptRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsDeliveryReceiptRequested);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.ReferenceItemId);
            _super.prototype.RegisterProperty.call(this, CancelMeetingMessageSchema.Body);
        };
        CancelMeetingMessageSchema.Body = new ComplexPropertyDefinition("NewBodyContent", PropertyDefinitionFlags.CanSet, ExchangeVersion.Exchange2007_SP1, function () { return new MessageBody(); });
        CancelMeetingMessageSchema.Instance = new CancelMeetingMessageSchema();
        return CancelMeetingMessageSchema;
    }(ServiceObjectSchema));
    var ConversationSchema = (function (_super) {
        __extends(ConversationSchema, _super);
        function ConversationSchema() {
            _super.call(this);
        }
        ConversationSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Id);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Topic);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueRecipients);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueRecipients);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueUnreadSenders);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueUnreadSenders);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.UniqueSenders);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUniqueSenders);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.LastDeliveryTime);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalLastDeliveryTime);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Categories);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalCategories);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.FlagStatus);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalFlagStatus);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.HasAttachments);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalHasAttachments);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.MessageCount);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalMessageCount);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.UnreadCount);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalUnreadCount);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Size);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalSize);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.ItemClasses);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalItemClasses);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Importance);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalImportance);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.ItemIds);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalItemIds);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.LastModifiedTime);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.InstanceKey);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.Preview);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.IconIndex);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalIconIndex);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.DraftItemIds);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.HasIrm);
            _super.prototype.RegisterProperty.call(this, ConversationSchema.GlobalHasIrm);
        };
        ConversationSchema.Id = new ComplexPropertyDefinition("ConversationId", "conversation:ConversationId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new ConversationId(); });
        ConversationSchema.Topic = new StringPropertyDefinition("ConversationTopic", "conversation:ConversationTopic", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.UniqueRecipients = new ComplexPropertyDefinition("UniqueRecipients", "conversation:UniqueRecipients", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.GlobalUniqueRecipients = new ComplexPropertyDefinition("GlobalUniqueRecipients", "conversation:GlobalUniqueRecipients", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.UniqueUnreadSenders = new ComplexPropertyDefinition("UniqueUnreadSenders", "conversation:UniqueUnreadSenders", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.GlobalUniqueUnreadSenders = new ComplexPropertyDefinition("GlobalUniqueUnreadSenders", "conversation:GlobalUniqueUnreadSenders", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.UniqueSenders = new ComplexPropertyDefinition("UniqueSenders", "conversation:UniqueSenders", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.GlobalUniqueSenders = new ComplexPropertyDefinition("GlobalUniqueSenders", "conversation:GlobalUniqueSenders", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.LastDeliveryTime = new DateTimePropertyDefinition("LastDeliveryTime", "conversation:LastDeliveryTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalLastDeliveryTime = new DateTimePropertyDefinition("GlobalLastDeliveryTime", "conversation:GlobalLastDeliveryTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.Categories = new ComplexPropertyDefinition("Categories", "conversation:Categories", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.GlobalCategories = new ComplexPropertyDefinition("GlobalCategories", "conversation:GlobalCategories", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList(); });
        ConversationSchema.FlagStatus = new GenericPropertyDefinition("FlagStatus", "conversation:FlagStatus", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalFlagStatus = new GenericPropertyDefinition("GlobalFlagStatus", "conversation:GlobalFlagStatus", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.HasAttachments = new BoolPropertyDefinition("HasAttachments", "conversation:HasAttachments", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalHasAttachments = new BoolPropertyDefinition("GlobalHasAttachments", "conversation:GlobalHasAttachments", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.MessageCount = new IntPropertyDefinition("MessageCount", "conversation:MessageCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalMessageCount = new IntPropertyDefinition("GlobalMessageCount", "conversation:GlobalMessageCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.UnreadCount = new IntPropertyDefinition("UnreadCount", "conversation:UnreadCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalUnreadCount = new IntPropertyDefinition("GlobalUnreadCount", "conversation:GlobalUnreadCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.Size = new IntPropertyDefinition("Size", "conversation:Size", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalSize = new IntPropertyDefinition("GlobalSize", "conversation:GlobalSize", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.ItemClasses = new ComplexPropertyDefinition("ItemClasses", "conversation:ItemClasses", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList("ItemClass"); });
        ConversationSchema.GlobalItemClasses = new ComplexPropertyDefinition("GlobalItemClasses", "conversation:GlobalItemClasses", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new StringList("ItemClass"); });
        ConversationSchema.Importance = new GenericPropertyDefinition("Importance", "conversation:Importance", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.GlobalImportance = new GenericPropertyDefinition("GlobalImportance", "conversation:GlobalImportance", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ConversationSchema.ItemIds = new ComplexPropertyDefinition("ItemIds", "conversation:ItemIds", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new ItemIdCollection(); });
        ConversationSchema.GlobalItemIds = new ComplexPropertyDefinition("GlobalItemIds", "conversation:GlobalItemIds", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new ItemIdCollection(); });
        ConversationSchema.LastModifiedTime = new DateTimePropertyDefinition("LastModifiedTime", "conversation:LastModifiedTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.InstanceKey = new ByteArrayPropertyDefinition("InstanceKey", "conversation:InstanceKey", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.Preview = new StringPropertyDefinition("Preview", "conversation:Preview", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.IconIndex = new GenericPropertyDefinition("IconIndex", "conversation:IconIndex", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.GlobalIconIndex = new GenericPropertyDefinition("GlobalIconIndex", "conversation:GlobalIconIndex", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.DraftItemIds = new ComplexPropertyDefinition("DraftItemIds", "conversation:DraftItemIds", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new ItemIdCollection(); });
        ConversationSchema.HasIrm = new BoolPropertyDefinition("HasIrm", "conversation:HasIrm", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.GlobalHasIrm = new BoolPropertyDefinition("GlobalHasIrm", "conversation:GlobalHasIrm", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        ConversationSchema.Instance = new ConversationSchema();
        return ConversationSchema;
    }(ServiceObjectSchema));
    var ConversationSchema_FieldUris = (function () {
        function ConversationSchema_FieldUris() {
            _super.call(this);
        }
        ConversationSchema_FieldUris.ConversationId = "conversation:ConversationId";
        ConversationSchema_FieldUris.ConversationTopic = "conversation:ConversationTopic";
        ConversationSchema_FieldUris.UniqueRecipients = "conversation:UniqueRecipients";
        ConversationSchema_FieldUris.GlobalUniqueRecipients = "conversation:GlobalUniqueRecipients";
        ConversationSchema_FieldUris.UniqueUnreadSenders = "conversation:UniqueUnreadSenders";
        ConversationSchema_FieldUris.GlobalUniqueUnreadSenders = "conversation:GlobalUniqueUnreadSenders";
        ConversationSchema_FieldUris.UniqueSenders = "conversation:UniqueSenders";
        ConversationSchema_FieldUris.GlobalUniqueSenders = "conversation:GlobalUniqueSenders";
        ConversationSchema_FieldUris.LastDeliveryTime = "conversation:LastDeliveryTime";
        ConversationSchema_FieldUris.GlobalLastDeliveryTime = "conversation:GlobalLastDeliveryTime";
        ConversationSchema_FieldUris.Categories = "conversation:Categories";
        ConversationSchema_FieldUris.GlobalCategories = "conversation:GlobalCategories";
        ConversationSchema_FieldUris.FlagStatus = "conversation:FlagStatus";
        ConversationSchema_FieldUris.GlobalFlagStatus = "conversation:GlobalFlagStatus";
        ConversationSchema_FieldUris.HasAttachments = "conversation:HasAttachments";
        ConversationSchema_FieldUris.GlobalHasAttachments = "conversation:GlobalHasAttachments";
        ConversationSchema_FieldUris.MessageCount = "conversation:MessageCount";
        ConversationSchema_FieldUris.GlobalMessageCount = "conversation:GlobalMessageCount";
        ConversationSchema_FieldUris.UnreadCount = "conversation:UnreadCount";
        ConversationSchema_FieldUris.GlobalUnreadCount = "conversation:GlobalUnreadCount";
        ConversationSchema_FieldUris.Size = "conversation:Size";
        ConversationSchema_FieldUris.GlobalSize = "conversation:GlobalSize";
        ConversationSchema_FieldUris.ItemClasses = "conversation:ItemClasses";
        ConversationSchema_FieldUris.GlobalItemClasses = "conversation:GlobalItemClasses";
        ConversationSchema_FieldUris.Importance = "conversation:Importance";
        ConversationSchema_FieldUris.GlobalImportance = "conversation:GlobalImportance";
        ConversationSchema_FieldUris.ItemIds = "conversation:ItemIds";
        ConversationSchema_FieldUris.GlobalItemIds = "conversation:GlobalItemIds";
        ConversationSchema_FieldUris.LastModifiedTime = "conversation:LastModifiedTime";
        ConversationSchema_FieldUris.InstanceKey = "conversation:InstanceKey";
        ConversationSchema_FieldUris.Preview = "conversation:Preview";
        ConversationSchema_FieldUris.IconIndex = "conversation:IconIndex";
        ConversationSchema_FieldUris.GlobalIconIndex = "conversation:GlobalIconIndex";
        ConversationSchema_FieldUris.DraftItemIds = "conversation:DraftItemIds";
        ConversationSchema_FieldUris.HasIrm = "conversation:HasIrm";
        ConversationSchema_FieldUris.GlobalHasIrm = "conversation:GlobalHasIrm";
        return ConversationSchema_FieldUris;
    }());
    var ContactGroupSchema = (function (_super) {
        __extends(ContactGroupSchema, _super);
        function ContactGroupSchema() {
            _super.call(this);
        }
        ContactGroupSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ContactGroupSchema.DisplayName);
            _super.prototype.RegisterProperty.call(this, ContactGroupSchema.FileAs);
            _super.prototype.RegisterProperty.call(this, ContactGroupSchema.Members);
        };
        ContactGroupSchema.DisplayName = ContactSchema.DisplayName;
        ContactGroupSchema.FileAs = ContactSchema.FileAs;
        ContactGroupSchema.Members = new ComplexPropertyDefinition("Members", "distributionlist:Members", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2010, function () { return new GroupMemberCollection(); });
        ContactGroupSchema.Instance = new ContactGroupSchema();
        return ContactGroupSchema;
    }(ItemSchema));
    var ContactGroupSchema_FieldUris = (function () {
        function ContactGroupSchema_FieldUris() {
            _super.call(this);
        }
        ContactGroupSchema_FieldUris.Members = "distributionlist:Members";
        return ContactGroupSchema_FieldUris;
    }());
    var IndexedPropertyDefinition = (function (_super) {
        __extends(IndexedPropertyDefinition, _super);
        function IndexedPropertyDefinition(uri, index) {
            _super.call(this, uri);
            this.index = null;
            this.index = index;
        }
        Object.defineProperty(IndexedPropertyDefinition.prototype, "Index", {
            get: function () {
                return this.index;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndexedPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("String");
            },
            enumerable: true,
            configurable: true
        });
        IndexedPropertyDefinition.IsEqualTo = function (idxPropDef1, idxPropDef2) {
            return NObject.ReferenceEquals(idxPropDef1, idxPropDef2) || (IndexedPropertyDefinition.op_Inequality(idxPropDef1, null) && IndexedPropertyDefinition.op_Inequality(idxPropDef2, null) && idxPropDef1.Uri === idxPropDef2.Uri && idxPropDef1.Index === idxPropDef2.Index);
        };
        IndexedPropertyDefinition.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("FieldIndex", this.Index);
        };
        IndexedPropertyDefinition.prototype.AddJsonProperties = function (jsonPropertyDefinition, service) {
            _super.prototype.AddJsonProperties.call(this, jsonPropertyDefinition, service);
            jsonPropertyDefinition.Add("FieldIndex", this.Index);
        };
        IndexedPropertyDefinition.prototype.GetXmlElementName = function () {
            return "IndexedFieldURI";
        };
        IndexedPropertyDefinition.prototype.GetJsonType = function () {
            return "DictionaryPropertyUri";
        };
        IndexedPropertyDefinition.prototype.GetPrintableName = function () {
            return NString.Format("{0}:{1}", this.Uri, this.Index);
        };
        IndexedPropertyDefinition.op_Equality = function (idxPropDef1, idxPropDef2) {
            return IndexedPropertyDefinition.IsEqualTo(idxPropDef1, idxPropDef2);
        };
        IndexedPropertyDefinition.op_Inequality = function (idxPropDef1, idxPropDef2) {
            return !IndexedPropertyDefinition.IsEqualTo(idxPropDef1, idxPropDef2);
        };
        IndexedPropertyDefinition.prototype.Equals = function (obj) {
            var idxPropDef = ((obj instanceof IndexedPropertyDefinition) ? obj : null);
            return IndexedPropertyDefinition.IsEqualTo(idxPropDef, this);
        };
        IndexedPropertyDefinition.prototype.GetHashCode = function () {
            return NString.GetHashCode(this.Uri) ^ NString.GetHashCode(this.Index);
        };
        return IndexedPropertyDefinition;
    }(ServiceObjectPropertyDefinition));
    var ContactSchema = (function (_super) {
        __extends(ContactSchema, _super);
        function ContactSchema() {
            _super.call(this);
        }
        ContactSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ContactSchema.FileAs);
            _super.prototype.RegisterProperty.call(this, ContactSchema.FileAsMapping);
            _super.prototype.RegisterProperty.call(this, ContactSchema.DisplayName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.GivenName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Initials);
            _super.prototype.RegisterProperty.call(this, ContactSchema.MiddleName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.NickName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.CompleteName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.CompanyName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.EmailAddresses);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PhysicalAddresses);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PhoneNumbers);
            _super.prototype.RegisterProperty.call(this, ContactSchema.AssistantName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Birthday);
            _super.prototype.RegisterProperty.call(this, ContactSchema.BusinessHomePage);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Children);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Companies);
            _super.prototype.RegisterProperty.call(this, ContactSchema.ContactSource);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Department);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Generation);
            _super.prototype.RegisterProperty.call(this, ContactSchema.ImAddresses);
            _super.prototype.RegisterProperty.call(this, ContactSchema.JobTitle);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Manager);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Mileage);
            _super.prototype.RegisterProperty.call(this, ContactSchema.OfficeLocation);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PostalAddressIndex);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Profession);
            _super.prototype.RegisterProperty.call(this, ContactSchema.SpouseName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Surname);
            _super.prototype.RegisterProperty.call(this, ContactSchema.WeddingAnniversary);
            _super.prototype.RegisterProperty.call(this, ContactSchema.HasPicture);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PhoneticFullName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PhoneticFirstName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.PhoneticLastName);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Alias);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Notes);
            _super.prototype.RegisterProperty.call(this, ContactSchema.Photo);
            _super.prototype.RegisterProperty.call(this, ContactSchema.UserSMIMECertificate);
            _super.prototype.RegisterProperty.call(this, ContactSchema.MSExchangeCertificate);
            _super.prototype.RegisterProperty.call(this, ContactSchema.DirectoryId);
            _super.prototype.RegisterProperty.call(this, ContactSchema.ManagerMailbox);
            _super.prototype.RegisterProperty.call(this, ContactSchema.DirectReports);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.EmailAddress1);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.EmailAddress2);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.EmailAddress3);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.ImAddress1);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.ImAddress2);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.ImAddress3);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.AssistantPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessFax);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessPhone2);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.Callback);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.CarPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.CompanyMainPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeFax);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomePhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomePhone2);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.Isdn);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.MobilePhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherFax);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherTelephone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.Pager);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.PrimaryPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.RadioPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.Telex);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.TtyTddPhone);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessAddressStreet);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessAddressCity);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessAddressState);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessAddressCountryOrRegion);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.BusinessAddressPostalCode);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeAddressStreet);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeAddressCity);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeAddressState);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeAddressCountryOrRegion);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.HomeAddressPostalCode);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherAddressStreet);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherAddressCity);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherAddressState);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherAddressCountryOrRegion);
            _super.prototype.RegisterIndexedProperty.call(this, ContactSchema.OtherAddressPostalCode);
        };
        ContactSchema.FileAs = new StringPropertyDefinition("FileAs", "contacts:FileAs", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.FileAsMapping = new GenericPropertyDefinition("FileAsMapping", "contacts:FileAsMapping", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.DisplayName = new StringPropertyDefinition("DisplayName", "contacts:DisplayName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.GivenName = new StringPropertyDefinition("GivenName", "contacts:GivenName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Initials = new StringPropertyDefinition("Initials", "contacts:Initials", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.MiddleName = new StringPropertyDefinition("MiddleName", "contacts:MiddleName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.NickName = new StringPropertyDefinition("Nickname", "contacts:Nickname", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.CompleteName = new ComplexPropertyDefinition("CompleteName", "contacts:CompleteName", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new CompleteName(); });
        ContactSchema.CompanyName = new StringPropertyDefinition("CompanyName", "contacts:CompanyName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.EmailAddresses = new ComplexPropertyDefinition("EmailAddresses", "contacts:EmailAddresses", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddressDictionary(); });
        ContactSchema.PhysicalAddresses = new ComplexPropertyDefinition("PhysicalAddresses", "contacts:PhysicalAddresses", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new PhysicalAddressDictionary(); });
        ContactSchema.PhoneNumbers = new ComplexPropertyDefinition("PhoneNumbers", "contacts:PhoneNumbers", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new PhoneNumberDictionary(); });
        ContactSchema.AssistantName = new StringPropertyDefinition("AssistantName", "contacts:AssistantName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Birthday = new DateTimePropertyDefinition("Birthday", "contacts:Birthday", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.BusinessHomePage = new StringPropertyDefinition("BusinessHomePage", "contacts:BusinessHomePage", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Children = new ComplexPropertyDefinition("Children", "contacts:Children", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new StringList(); });
        ContactSchema.Companies = new ComplexPropertyDefinition("Companies", "contacts:Companies", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new StringList(); });
        ContactSchema.ContactSource = new GenericPropertyDefinition("ContactSource", "contacts:ContactSource", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Department = new StringPropertyDefinition("Department", "contacts:Department", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Generation = new StringPropertyDefinition("Generation", "contacts:Generation", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.ImAddresses = new ComplexPropertyDefinition("ImAddresses", "contacts:ImAddresses", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new ImAddressDictionary(); });
        ContactSchema.JobTitle = new StringPropertyDefinition("JobTitle", "contacts:JobTitle", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Manager = new StringPropertyDefinition("Manager", "contacts:Manager", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Mileage = new StringPropertyDefinition("Mileage", "contacts:Mileage", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.OfficeLocation = new StringPropertyDefinition("OfficeLocation", "contacts:OfficeLocation", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.PostalAddressIndex = new GenericPropertyDefinition("PostalAddressIndex", "contacts:PostalAddressIndex", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Profession = new StringPropertyDefinition("Profession", "contacts:Profession", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.SpouseName = new StringPropertyDefinition("SpouseName", "contacts:SpouseName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.Surname = new StringPropertyDefinition("Surname", "contacts:Surname", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.WeddingAnniversary = new DateTimePropertyDefinition("WeddingAnniversary", "contacts:WeddingAnniversary", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        ContactSchema.HasPicture = new BoolPropertyDefinition("HasPicture", "contacts:HasPicture", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010);
        ContactSchema.PhoneticFullName = new StringPropertyDefinition("PhoneticFullName", "contacts:PhoneticFullName", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.PhoneticFirstName = new StringPropertyDefinition("PhoneticFirstName", "contacts:PhoneticFirstName", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.PhoneticLastName = new StringPropertyDefinition("PhoneticLastName", "contacts:PhoneticLastName", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.Alias = new StringPropertyDefinition("Alias", "contacts:Alias", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.Notes = new StringPropertyDefinition("Notes", "contacts:Notes", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.Photo = new ByteArrayPropertyDefinition("Photo", "contacts:Photo", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.UserSMIMECertificate = new ComplexPropertyDefinition("UserSMIMECertificate", "contacts:UserSMIMECertificate", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new ByteArrayArray(); });
        ContactSchema.MSExchangeCertificate = new ComplexPropertyDefinition("MSExchangeCertificate", "contacts:MSExchangeCertificate", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new ByteArrayArray(); });
        ContactSchema.DirectoryId = new StringPropertyDefinition("DirectoryId", "contacts:DirectoryId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1);
        ContactSchema.ManagerMailbox = new ContainedPropertyDefinition("ManagerMailbox", "contacts:ManagerMailbox", "Mailbox", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new EmailAddress(); });
        ContactSchema.DirectReports = new ComplexPropertyDefinition("DirectReports", "contacts:DirectReports", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2010_SP1, function () { return new EmailAddressCollection(); });
        ContactSchema.EmailAddress1 = new IndexedPropertyDefinition("contacts:EmailAddress", "EmailAddress1");
        ContactSchema.EmailAddress2 = new IndexedPropertyDefinition("contacts:EmailAddress", "EmailAddress2");
        ContactSchema.EmailAddress3 = new IndexedPropertyDefinition("contacts:EmailAddress", "EmailAddress3");
        ContactSchema.ImAddress1 = new IndexedPropertyDefinition("contacts:ImAddress", "ImAddress1");
        ContactSchema.ImAddress2 = new IndexedPropertyDefinition("contacts:ImAddress", "ImAddress2");
        ContactSchema.ImAddress3 = new IndexedPropertyDefinition("contacts:ImAddress", "ImAddress3");
        ContactSchema.AssistantPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "AssistantPhone");
        ContactSchema.BusinessFax = new IndexedPropertyDefinition("contacts:PhoneNumber", "BusinessFax");
        ContactSchema.BusinessPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "BusinessPhone");
        ContactSchema.BusinessPhone2 = new IndexedPropertyDefinition("contacts:PhoneNumber", "BusinessPhone2");
        ContactSchema.Callback = new IndexedPropertyDefinition("contacts:PhoneNumber", "Callback");
        ContactSchema.CarPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "CarPhone");
        ContactSchema.CompanyMainPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "CompanyMainPhone");
        ContactSchema.HomeFax = new IndexedPropertyDefinition("contacts:PhoneNumber", "HomeFax");
        ContactSchema.HomePhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "HomePhone");
        ContactSchema.HomePhone2 = new IndexedPropertyDefinition("contacts:PhoneNumber", "HomePhone2");
        ContactSchema.Isdn = new IndexedPropertyDefinition("contacts:PhoneNumber", "Isdn");
        ContactSchema.MobilePhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "MobilePhone");
        ContactSchema.OtherFax = new IndexedPropertyDefinition("contacts:PhoneNumber", "OtherFax");
        ContactSchema.OtherTelephone = new IndexedPropertyDefinition("contacts:PhoneNumber", "OtherTelephone");
        ContactSchema.Pager = new IndexedPropertyDefinition("contacts:PhoneNumber", "Pager");
        ContactSchema.PrimaryPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "PrimaryPhone");
        ContactSchema.RadioPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "RadioPhone");
        ContactSchema.Telex = new IndexedPropertyDefinition("contacts:PhoneNumber", "Telex");
        ContactSchema.TtyTddPhone = new IndexedPropertyDefinition("contacts:PhoneNumber", "TtyTddPhone");
        ContactSchema.BusinessAddressStreet = new IndexedPropertyDefinition("contacts:PhysicalAddress:Street", "Business");
        ContactSchema.BusinessAddressCity = new IndexedPropertyDefinition("contacts:PhysicalAddress:City", "Business");
        ContactSchema.BusinessAddressState = new IndexedPropertyDefinition("contacts:PhysicalAddress:State", "Business");
        ContactSchema.BusinessAddressCountryOrRegion = new IndexedPropertyDefinition("contacts:PhysicalAddress:CountryOrRegion", "Business");
        ContactSchema.BusinessAddressPostalCode = new IndexedPropertyDefinition("contacts:PhysicalAddress:PostalCode", "Business");
        ContactSchema.HomeAddressStreet = new IndexedPropertyDefinition("contacts:PhysicalAddress:Street", "Home");
        ContactSchema.HomeAddressCity = new IndexedPropertyDefinition("contacts:PhysicalAddress:City", "Home");
        ContactSchema.HomeAddressState = new IndexedPropertyDefinition("contacts:PhysicalAddress:State", "Home");
        ContactSchema.HomeAddressCountryOrRegion = new IndexedPropertyDefinition("contacts:PhysicalAddress:CountryOrRegion", "Home");
        ContactSchema.HomeAddressPostalCode = new IndexedPropertyDefinition("contacts:PhysicalAddress:PostalCode", "Home");
        ContactSchema.OtherAddressStreet = new IndexedPropertyDefinition("contacts:PhysicalAddress:Street", "Other");
        ContactSchema.OtherAddressCity = new IndexedPropertyDefinition("contacts:PhysicalAddress:City", "Other");
        ContactSchema.OtherAddressState = new IndexedPropertyDefinition("contacts:PhysicalAddress:State", "Other");
        ContactSchema.OtherAddressCountryOrRegion = new IndexedPropertyDefinition("contacts:PhysicalAddress:CountryOrRegion", "Other");
        ContactSchema.OtherAddressPostalCode = new IndexedPropertyDefinition("contacts:PhysicalAddress:PostalCode", "Other");
        ContactSchema.Instance = new ContactSchema();
        return ContactSchema;
    }(ItemSchema));
    var ContactSchema_FieldUris = (function () {
        function ContactSchema_FieldUris() {
            _super.call(this);
        }
        ContactSchema_FieldUris.FileAs = "contacts:FileAs";
        ContactSchema_FieldUris.FileAsMapping = "contacts:FileAsMapping";
        ContactSchema_FieldUris.DisplayName = "contacts:DisplayName";
        ContactSchema_FieldUris.GivenName = "contacts:GivenName";
        ContactSchema_FieldUris.Initials = "contacts:Initials";
        ContactSchema_FieldUris.MiddleName = "contacts:MiddleName";
        ContactSchema_FieldUris.NickName = "contacts:Nickname";
        ContactSchema_FieldUris.CompleteName = "contacts:CompleteName";
        ContactSchema_FieldUris.CompanyName = "contacts:CompanyName";
        ContactSchema_FieldUris.EmailAddress = "contacts:EmailAddress";
        ContactSchema_FieldUris.EmailAddresses = "contacts:EmailAddresses";
        ContactSchema_FieldUris.PhysicalAddresses = "contacts:PhysicalAddresses";
        ContactSchema_FieldUris.PhoneNumber = "contacts:PhoneNumber";
        ContactSchema_FieldUris.PhoneNumbers = "contacts:PhoneNumbers";
        ContactSchema_FieldUris.AssistantName = "contacts:AssistantName";
        ContactSchema_FieldUris.Birthday = "contacts:Birthday";
        ContactSchema_FieldUris.BusinessHomePage = "contacts:BusinessHomePage";
        ContactSchema_FieldUris.Children = "contacts:Children";
        ContactSchema_FieldUris.Companies = "contacts:Companies";
        ContactSchema_FieldUris.ContactSource = "contacts:ContactSource";
        ContactSchema_FieldUris.Department = "contacts:Department";
        ContactSchema_FieldUris.Generation = "contacts:Generation";
        ContactSchema_FieldUris.ImAddress = "contacts:ImAddress";
        ContactSchema_FieldUris.ImAddresses = "contacts:ImAddresses";
        ContactSchema_FieldUris.JobTitle = "contacts:JobTitle";
        ContactSchema_FieldUris.Manager = "contacts:Manager";
        ContactSchema_FieldUris.Mileage = "contacts:Mileage";
        ContactSchema_FieldUris.OfficeLocation = "contacts:OfficeLocation";
        ContactSchema_FieldUris.PhysicalAddressCity = "contacts:PhysicalAddress:City";
        ContactSchema_FieldUris.PhysicalAddressCountryOrRegion = "contacts:PhysicalAddress:CountryOrRegion";
        ContactSchema_FieldUris.PhysicalAddressState = "contacts:PhysicalAddress:State";
        ContactSchema_FieldUris.PhysicalAddressStreet = "contacts:PhysicalAddress:Street";
        ContactSchema_FieldUris.PhysicalAddressPostalCode = "contacts:PhysicalAddress:PostalCode";
        ContactSchema_FieldUris.PostalAddressIndex = "contacts:PostalAddressIndex";
        ContactSchema_FieldUris.Profession = "contacts:Profession";
        ContactSchema_FieldUris.SpouseName = "contacts:SpouseName";
        ContactSchema_FieldUris.Surname = "contacts:Surname";
        ContactSchema_FieldUris.WeddingAnniversary = "contacts:WeddingAnniversary";
        ContactSchema_FieldUris.HasPicture = "contacts:HasPicture";
        ContactSchema_FieldUris.PhoneticFullName = "contacts:PhoneticFullName";
        ContactSchema_FieldUris.PhoneticFirstName = "contacts:PhoneticFirstName";
        ContactSchema_FieldUris.PhoneticLastName = "contacts:PhoneticLastName";
        ContactSchema_FieldUris.Alias = "contacts:Alias";
        ContactSchema_FieldUris.Notes = "contacts:Notes";
        ContactSchema_FieldUris.Photo = "contacts:Photo";
        ContactSchema_FieldUris.UserSMIMECertificate = "contacts:UserSMIMECertificate";
        ContactSchema_FieldUris.MSExchangeCertificate = "contacts:MSExchangeCertificate";
        ContactSchema_FieldUris.DirectoryId = "contacts:DirectoryId";
        ContactSchema_FieldUris.ManagerMailbox = "contacts:ManagerMailbox";
        ContactSchema_FieldUris.DirectReports = "contacts:DirectReports";
        return ContactSchema_FieldUris;
    }());
    var EmailMessageSchema = (function (_super) {
        __extends(EmailMessageSchema, _super);
        function EmailMessageSchema() {
            _super.call(this);
        }
        EmailMessageSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.Sender);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ToRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.CcRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.BccRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsReadReceiptRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsDeliveryReceiptRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ConversationIndex);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ConversationTopic);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.From);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.InternetMessageId);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsRead);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsResponseRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.References);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ReplyTo);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ReceivedBy);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ReceivedRepresenting);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ApprovalRequestData);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.VotingInformation);
        };
        EmailMessageSchema.ToRecipients = new ComplexPropertyDefinition("ToRecipients", "message:ToRecipients", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddressCollection(); });
        EmailMessageSchema.BccRecipients = new ComplexPropertyDefinition("BccRecipients", "message:BccRecipients", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddressCollection(); });
        EmailMessageSchema.CcRecipients = new ComplexPropertyDefinition("CcRecipients", "message:CcRecipients", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddressCollection(); });
        EmailMessageSchema.ConversationIndex = new ByteArrayPropertyDefinition("ConversationIndex", "message:ConversationIndex", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.ConversationTopic = new StringPropertyDefinition("ConversationTopic", "message:ConversationTopic", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.From = new ContainedPropertyDefinition("From", "message:From", "Mailbox", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddress(); });
        EmailMessageSchema.IsDeliveryReceiptRequested = new BoolPropertyDefinition("IsDeliveryReceiptRequested", "message:IsDeliveryReceiptRequested", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.IsRead = new BoolPropertyDefinition("IsRead", "message:IsRead", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.IsReadReceiptRequested = new BoolPropertyDefinition("IsReadReceiptRequested", "message:IsReadReceiptRequested", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.IsResponseRequested = new BoolPropertyDefinition("IsResponseRequested", "message:IsResponseRequested", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        EmailMessageSchema.InternetMessageId = new StringPropertyDefinition("InternetMessageId", "message:InternetMessageId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.References = new StringPropertyDefinition("References", "message:References", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        EmailMessageSchema.ReplyTo = new ComplexPropertyDefinition("ReplyTo", "message:ReplyTo", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddressCollection(); });
        EmailMessageSchema.Sender = new ContainedPropertyDefinition("Sender", "message:Sender", "Mailbox", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddress(); });
        EmailMessageSchema.ReceivedBy = new ContainedPropertyDefinition("ReceivedBy", "message:ReceivedBy", "Mailbox", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddress(); });
        EmailMessageSchema.ReceivedRepresenting = new ContainedPropertyDefinition("ReceivedRepresenting", "message:ReceivedRepresenting", "Mailbox", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new EmailAddress(); });
        EmailMessageSchema.ApprovalRequestData = new ComplexPropertyDefinition("ApprovalRequestData", "message:ApprovalRequestData", ExchangeVersion.Exchange2013, function () { return new ApprovalRequestData(); });
        EmailMessageSchema.VotingInformation = new ComplexPropertyDefinition("VotingInformation", "message:VotingInformation", ExchangeVersion.Exchange2013, function () { return new VotingInformation(); });
        EmailMessageSchema.Instance = new EmailMessageSchema();
        return EmailMessageSchema;
    }(ItemSchema));
    var EmailMessageSchema_FieldUris = (function () {
        function EmailMessageSchema_FieldUris() {
            _super.call(this);
        }
        EmailMessageSchema_FieldUris.ConversationIndex = "message:ConversationIndex";
        EmailMessageSchema_FieldUris.ConversationTopic = "message:ConversationTopic";
        EmailMessageSchema_FieldUris.InternetMessageId = "message:InternetMessageId";
        EmailMessageSchema_FieldUris.IsRead = "message:IsRead";
        EmailMessageSchema_FieldUris.IsResponseRequested = "message:IsResponseRequested";
        EmailMessageSchema_FieldUris.IsReadReceiptRequested = "message:IsReadReceiptRequested";
        EmailMessageSchema_FieldUris.IsDeliveryReceiptRequested = "message:IsDeliveryReceiptRequested";
        EmailMessageSchema_FieldUris.References = "message:References";
        EmailMessageSchema_FieldUris.ReplyTo = "message:ReplyTo";
        EmailMessageSchema_FieldUris.From = "message:From";
        EmailMessageSchema_FieldUris.Sender = "message:Sender";
        EmailMessageSchema_FieldUris.ToRecipients = "message:ToRecipients";
        EmailMessageSchema_FieldUris.CcRecipients = "message:CcRecipients";
        EmailMessageSchema_FieldUris.BccRecipients = "message:BccRecipients";
        EmailMessageSchema_FieldUris.ReceivedBy = "message:ReceivedBy";
        EmailMessageSchema_FieldUris.ReceivedRepresenting = "message:ReceivedRepresenting";
        EmailMessageSchema_FieldUris.ApprovalRequestData = "message:ApprovalRequestData";
        EmailMessageSchema_FieldUris.VotingInformation = "message:VotingInformation";
        return EmailMessageSchema_FieldUris;
    }());
    var PermissionSetPropertyDefinition = (function (_super) {
        __extends(PermissionSetPropertyDefinition, _super);
        function PermissionSetPropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        Object.defineProperty(PermissionSetPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("FolderPermissionCollection");
            },
            enumerable: true,
            configurable: true
        });
        PermissionSetPropertyDefinition.prototype.CreatePropertyInstance = function (owner) {
            var folder = ((owner instanceof Folder) ? owner : null);
            EwsUtilities.Assert(folder !== null, "PermissionCollectionPropertyDefinition.CreatePropertyInstance", "The owner parameter is not of type Folder or a derived class.");
            return new FolderPermissionCollection(folder);
        };
        return PermissionSetPropertyDefinition;
    }(ComplexPropertyDefinitionBase));
    var FolderSchema = (function (_super) {
        __extends(FolderSchema, _super);
        function FolderSchema() {
            _super.call(this);
        }
        FolderSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, FolderSchema.Id);
            _super.prototype.RegisterProperty.call(this, FolderSchema.ParentFolderId);
            _super.prototype.RegisterProperty.call(this, FolderSchema.FolderClass);
            _super.prototype.RegisterProperty.call(this, FolderSchema.DisplayName);
            _super.prototype.RegisterProperty.call(this, FolderSchema.TotalCount);
            _super.prototype.RegisterProperty.call(this, FolderSchema.ChildFolderCount);
            _super.prototype.RegisterProperty.call(this, ServiceObjectSchema.ExtendedProperties);
            _super.prototype.RegisterProperty.call(this, FolderSchema.ManagedFolderInformation);
            _super.prototype.RegisterProperty.call(this, FolderSchema.EffectiveRights);
            _super.prototype.RegisterProperty.call(this, FolderSchema.Permissions);
            _super.prototype.RegisterProperty.call(this, FolderSchema.UnreadCount);
            _super.prototype.RegisterProperty.call(this, FolderSchema.WellKnownFolderName);
            _super.prototype.RegisterProperty.call(this, FolderSchema.PolicyTag);
            _super.prototype.RegisterProperty.call(this, FolderSchema.ArchiveTag);
        };
        FolderSchema.Id = new ComplexPropertyDefinition("FolderId", "folder:FolderId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new FolderId(); });
        FolderSchema.FolderClass = new StringPropertyDefinition("FolderClass", "folder:FolderClass", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.ParentFolderId = new ComplexPropertyDefinition("ParentFolderId", "folder:ParentFolderId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new FolderId(); });
        FolderSchema.ChildFolderCount = new IntPropertyDefinition("ChildFolderCount", "folder:ChildFolderCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.DisplayName = new StringPropertyDefinition("DisplayName", "folder:DisplayName", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.UnreadCount = new IntPropertyDefinition("UnreadCount", "folder:UnreadCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.TotalCount = new IntPropertyDefinition("TotalCount", "folder:TotalCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.ManagedFolderInformation = new ComplexPropertyDefinition("ManagedFolderInformation", "folder:ManagedFolderInformation", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new ManagedFolderInformation(); });
        FolderSchema.EffectiveRights = new EffectiveRightsPropertyDefinition("EffectiveRights", "folder:EffectiveRights", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.Permissions = new PermissionSetPropertyDefinition("PermissionSet", "folder:PermissionSet", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.MustBeExplicitlyLoaded, ExchangeVersion.Exchange2007_SP1);
        FolderSchema.WellKnownFolderName = new GenericPropertyDefinition("DistinguishedFolderId", "folder:DistinguishedFolderId", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, true);
        FolderSchema.PolicyTag = new ComplexPropertyDefinition("PolicyTag", "folder:PolicyTag", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new PolicyTag(); });
        FolderSchema.ArchiveTag = new ComplexPropertyDefinition("ArchiveTag", "folder:ArchiveTag", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function () { return new ArchiveTag(); });
        FolderSchema.Instance = new FolderSchema();
        return FolderSchema;
    }(ServiceObjectSchema));
    var FolderSchema_FieldUris = (function () {
        function FolderSchema_FieldUris() {
            _super.call(this);
        }
        FolderSchema_FieldUris.FolderId = "folder:FolderId";
        FolderSchema_FieldUris.ParentFolderId = "folder:ParentFolderId";
        FolderSchema_FieldUris.DisplayName = "folder:DisplayName";
        FolderSchema_FieldUris.UnreadCount = "folder:UnreadCount";
        FolderSchema_FieldUris.TotalCount = "folder:TotalCount";
        FolderSchema_FieldUris.ChildFolderCount = "folder:ChildFolderCount";
        FolderSchema_FieldUris.FolderClass = "folder:FolderClass";
        FolderSchema_FieldUris.ManagedFolderInformation = "folder:ManagedFolderInformation";
        FolderSchema_FieldUris.EffectiveRights = "folder:EffectiveRights";
        FolderSchema_FieldUris.PermissionSet = "folder:PermissionSet";
        FolderSchema_FieldUris.PolicyTag = "folder:PolicyTag";
        FolderSchema_FieldUris.ArchiveTag = "folder:ArchiveTag";
        FolderSchema_FieldUris.DistinguishedFolderId = "folder:DistinguishedFolderId";
        return FolderSchema_FieldUris;
    }());
    var MeetingMessageSchema = (function (_super) {
        __extends(MeetingMessageSchema, _super);
        function MeetingMessageSchema() {
            _super.call(this);
        }
        MeetingMessageSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.AssociatedAppointmentId);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.IsDelegated);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.IsOutOfDate);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.HasBeenProcessed);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.ResponseType);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.ICalUid);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.ICalRecurrenceId);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.ICalDateTimeStamp);
            _super.prototype.RegisterProperty.call(this, MeetingMessageSchema.IsOrganizer);
        };
        MeetingMessageSchema.AssociatedAppointmentId = new ComplexPropertyDefinition("AssociatedCalendarItemId", "meeting:AssociatedCalendarItemId", ExchangeVersion.Exchange2007_SP1, function () { return new ItemId(); });
        MeetingMessageSchema.IsDelegated = new BoolPropertyDefinition("IsDelegated", "meeting:IsDelegated", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        MeetingMessageSchema.IsOutOfDate = new BoolPropertyDefinition("IsOutOfDate", "meeting:IsOutOfDate", ExchangeVersion.Exchange2007_SP1);
        MeetingMessageSchema.HasBeenProcessed = new BoolPropertyDefinition("HasBeenProcessed", "meeting:HasBeenProcessed", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        MeetingMessageSchema.ResponseType = new GenericPropertyDefinition("ResponseType", "meeting:ResponseType", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        MeetingMessageSchema.ICalUid = AppointmentSchema.ICalUid;
        MeetingMessageSchema.ICalRecurrenceId = AppointmentSchema.ICalRecurrenceId;
        MeetingMessageSchema.ICalDateTimeStamp = AppointmentSchema.ICalDateTimeStamp;
        MeetingMessageSchema.IsOrganizer = new GenericPropertyDefinition("IsOrganizer", "cal:IsOrganizer", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013);
        MeetingMessageSchema.Instance = new MeetingMessageSchema();
        return MeetingMessageSchema;
    }(EmailMessageSchema));
    var MeetingMessageSchema_FieldUris = (function () {
        function MeetingMessageSchema_FieldUris() {
            _super.call(this);
        }
        MeetingMessageSchema_FieldUris.AssociatedCalendarItemId = "meeting:AssociatedCalendarItemId";
        MeetingMessageSchema_FieldUris.IsDelegated = "meeting:IsDelegated";
        MeetingMessageSchema_FieldUris.IsOutOfDate = "meeting:IsOutOfDate";
        MeetingMessageSchema_FieldUris.HasBeenProcessed = "meeting:HasBeenProcessed";
        MeetingMessageSchema_FieldUris.ResponseType = "meeting:ResponseType";
        MeetingMessageSchema_FieldUris.IsOrganizer = "cal:IsOrganizer";
        return MeetingMessageSchema_FieldUris;
    }());
    var MeetingCancellationSchema = (function (_super) {
        __extends(MeetingCancellationSchema, _super);
        function MeetingCancellationSchema() {
            _super.call(this);
        }
        MeetingCancellationSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.Start);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.End);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.Location);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.Recurrence);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.AppointmentType);
            _super.prototype.RegisterProperty.call(this, MeetingCancellationSchema.EnhancedLocation);
        };
        MeetingCancellationSchema.Start = AppointmentSchema.Start;
        MeetingCancellationSchema.End = AppointmentSchema.End;
        MeetingCancellationSchema.Location = AppointmentSchema.Location;
        MeetingCancellationSchema.AppointmentType = AppointmentSchema.AppointmentType;
        MeetingCancellationSchema.Recurrence = AppointmentSchema.Recurrence;
        MeetingCancellationSchema.EnhancedLocation = AppointmentSchema.EnhancedLocation;
        MeetingCancellationSchema.Instance = new MeetingCancellationSchema();
        return MeetingCancellationSchema;
    }(MeetingMessageSchema));
    var MeetingRequestSchema = (function (_super) {
        __extends(MeetingRequestSchema, _super);
        function MeetingRequestSchema() {
            _super.call(this);
        }
        MeetingRequestSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingRequestType);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IntendedFreeBusyStatus);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ChangeHighlights);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Start);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.End);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.OriginalStart);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsAllDayEvent);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.LegacyFreeBusyStatus);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Location);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.When);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsMeeting);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsCancelled);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsRecurring);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingRequestWasSent);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentType);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MyResponseType);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Organizer);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.RequiredAttendees);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.OptionalAttendees);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Resources);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConflictingMeetingCount);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AdjacentMeetingCount);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConflictingMeetings);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AdjacentMeetings);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Duration);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.TimeZone);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentReplyTime);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentSequenceNumber);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AppointmentState);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.Recurrence);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.FirstOccurrence);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.LastOccurrence);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ModifiedOccurrences);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.DeletedOccurrences);
            _super.prototype.RegisterInternalProperty.call(this, MeetingRequestSchema.MeetingTimeZone);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.StartTimeZone);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.EndTimeZone);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.ConferenceType);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.AllowNewTimeProposal);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.IsOnlineMeeting);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.MeetingWorkspaceUrl);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.NetShowUrl);
            _super.prototype.RegisterProperty.call(this, MeetingRequestSchema.EnhancedLocation);
        };
        MeetingRequestSchema.MeetingRequestType = new GenericPropertyDefinition("MeetingRequestType", "meetingRequest:MeetingRequestType", ExchangeVersion.Exchange2007_SP1);
        MeetingRequestSchema.IntendedFreeBusyStatus = new GenericPropertyDefinition("IntendedFreeBusyStatus", "meetingRequest:IntendedFreeBusyStatus", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        MeetingRequestSchema.ChangeHighlights = new ComplexPropertyDefinition("ChangeHighlights", "meetingRequest:ChangeHighlights", ExchangeVersion.Exchange2013, function () { return new ChangeHighlights(); });
        MeetingRequestSchema.EnhancedLocation = AppointmentSchema.EnhancedLocation;
        MeetingRequestSchema.Start = AppointmentSchema.Start;
        MeetingRequestSchema.End = AppointmentSchema.End;
        MeetingRequestSchema.OriginalStart = AppointmentSchema.OriginalStart;
        MeetingRequestSchema.IsAllDayEvent = AppointmentSchema.IsAllDayEvent;
        MeetingRequestSchema.LegacyFreeBusyStatus = AppointmentSchema.LegacyFreeBusyStatus;
        MeetingRequestSchema.Location = AppointmentSchema.Location;
        MeetingRequestSchema.When = AppointmentSchema.When;
        MeetingRequestSchema.IsMeeting = AppointmentSchema.IsMeeting;
        MeetingRequestSchema.IsCancelled = AppointmentSchema.IsCancelled;
        MeetingRequestSchema.IsRecurring = AppointmentSchema.IsRecurring;
        MeetingRequestSchema.MeetingRequestWasSent = AppointmentSchema.MeetingRequestWasSent;
        MeetingRequestSchema.AppointmentType = AppointmentSchema.AppointmentType;
        MeetingRequestSchema.MyResponseType = AppointmentSchema.MyResponseType;
        MeetingRequestSchema.Organizer = AppointmentSchema.Organizer;
        MeetingRequestSchema.RequiredAttendees = AppointmentSchema.RequiredAttendees;
        MeetingRequestSchema.OptionalAttendees = AppointmentSchema.OptionalAttendees;
        MeetingRequestSchema.Resources = AppointmentSchema.Resources;
        MeetingRequestSchema.ConflictingMeetingCount = AppointmentSchema.ConflictingMeetingCount;
        MeetingRequestSchema.AdjacentMeetingCount = AppointmentSchema.AdjacentMeetingCount;
        MeetingRequestSchema.ConflictingMeetings = AppointmentSchema.ConflictingMeetings;
        MeetingRequestSchema.AdjacentMeetings = AppointmentSchema.AdjacentMeetings;
        MeetingRequestSchema.Duration = AppointmentSchema.Duration;
        MeetingRequestSchema.TimeZone = AppointmentSchema.TimeZone;
        MeetingRequestSchema.AppointmentReplyTime = AppointmentSchema.AppointmentReplyTime;
        MeetingRequestSchema.AppointmentSequenceNumber = AppointmentSchema.AppointmentSequenceNumber;
        MeetingRequestSchema.AppointmentState = AppointmentSchema.AppointmentState;
        MeetingRequestSchema.Recurrence = AppointmentSchema.Recurrence;
        MeetingRequestSchema.FirstOccurrence = AppointmentSchema.FirstOccurrence;
        MeetingRequestSchema.LastOccurrence = AppointmentSchema.LastOccurrence;
        MeetingRequestSchema.ModifiedOccurrences = AppointmentSchema.ModifiedOccurrences;
        MeetingRequestSchema.DeletedOccurrences = AppointmentSchema.DeletedOccurrences;
        MeetingRequestSchema.MeetingTimeZone = AppointmentSchema.MeetingTimeZone;
        MeetingRequestSchema.StartTimeZone = AppointmentSchema.StartTimeZone;
        MeetingRequestSchema.EndTimeZone = AppointmentSchema.EndTimeZone;
        MeetingRequestSchema.ConferenceType = AppointmentSchema.ConferenceType;
        MeetingRequestSchema.AllowNewTimeProposal = AppointmentSchema.AllowNewTimeProposal;
        MeetingRequestSchema.IsOnlineMeeting = AppointmentSchema.IsOnlineMeeting;
        MeetingRequestSchema.MeetingWorkspaceUrl = AppointmentSchema.MeetingWorkspaceUrl;
        MeetingRequestSchema.NetShowUrl = AppointmentSchema.NetShowUrl;
        MeetingRequestSchema.Instance = new MeetingRequestSchema();
        return MeetingRequestSchema;
    }(MeetingMessageSchema));
    var MeetingRequestSchema_FieldUris = (function () {
        function MeetingRequestSchema_FieldUris() {
            _super.call(this);
        }
        MeetingRequestSchema_FieldUris.MeetingRequestType = "meetingRequest:MeetingRequestType";
        MeetingRequestSchema_FieldUris.IntendedFreeBusyStatus = "meetingRequest:IntendedFreeBusyStatus";
        MeetingRequestSchema_FieldUris.ChangeHighlights = "meetingRequest:ChangeHighlights";
        return MeetingRequestSchema_FieldUris;
    }());
    var MeetingResponseSchema = (function (_super) {
        __extends(MeetingResponseSchema, _super);
        function MeetingResponseSchema() {
            _super.call(this);
        }
        MeetingResponseSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.Start);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.End);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.Location);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.Recurrence);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.AppointmentType);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.ProposedStart);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.ProposedEnd);
            _super.prototype.RegisterProperty.call(this, MeetingResponseSchema.EnhancedLocation);
        };
        MeetingResponseSchema.Start = AppointmentSchema.Start;
        MeetingResponseSchema.End = AppointmentSchema.End;
        MeetingResponseSchema.Location = AppointmentSchema.Location;
        MeetingResponseSchema.AppointmentType = AppointmentSchema.AppointmentType;
        MeetingResponseSchema.Recurrence = AppointmentSchema.Recurrence;
        MeetingResponseSchema.ProposedStart = new ScopedDateTimePropertyDefinition("ProposedStart", "meeting:ProposedStart", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function (version) { return AppointmentSchema.StartTimeZone; });
        MeetingResponseSchema.ProposedEnd = new ScopedDateTimePropertyDefinition("ProposedEnd", "meeting:ProposedEnd", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2013, function (version) { return AppointmentSchema.EndTimeZone; });
        MeetingResponseSchema.EnhancedLocation = AppointmentSchema.EnhancedLocation;
        MeetingResponseSchema.Instance = new MeetingResponseSchema();
        return MeetingResponseSchema;
    }(MeetingMessageSchema));
    var MeetingResponseSchema_FieldUris = (function () {
        function MeetingResponseSchema_FieldUris() {
            _super.call(this);
        }
        MeetingResponseSchema_FieldUris.ProposedStart = "meeting:ProposedStart";
        MeetingResponseSchema_FieldUris.ProposedEnd = "meeting:ProposedEnd";
        return MeetingResponseSchema_FieldUris;
    }());
    var PostItemSchema = (function (_super) {
        __extends(PostItemSchema, _super);
        function PostItemSchema() {
            _super.call(this);
        }
        PostItemSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.ConversationIndex);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.ConversationTopic);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.From);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.InternetMessageId);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.IsRead);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.PostedTime);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.References);
            _super.prototype.RegisterProperty.call(this, PostItemSchema.Sender);
        };
        PostItemSchema.ConversationIndex = EmailMessageSchema.ConversationIndex;
        PostItemSchema.ConversationTopic = EmailMessageSchema.ConversationTopic;
        PostItemSchema.From = EmailMessageSchema.From;
        PostItemSchema.InternetMessageId = EmailMessageSchema.InternetMessageId;
        PostItemSchema.IsRead = EmailMessageSchema.IsRead;
        PostItemSchema.PostedTime = new DateTimePropertyDefinition("PostedTime", "postitem:PostedTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        PostItemSchema.References = EmailMessageSchema.References;
        PostItemSchema.Sender = EmailMessageSchema.Sender;
        PostItemSchema.Instance = new PostItemSchema();
        return PostItemSchema;
    }(ItemSchema));
    var PostItemSchema_FieldUris = (function () {
        function PostItemSchema_FieldUris() {
            _super.call(this);
        }
        PostItemSchema_FieldUris.PostedTime = "postitem:PostedTime";
        return PostItemSchema_FieldUris;
    }());
    var PostReplySchema = (function (_super) {
        __extends(PostReplySchema, _super);
        function PostReplySchema() {
            _super.call(this);
        }
        PostReplySchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Subject);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Body);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.ReferenceItemId);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.BodyPrefix);
        };
        PostReplySchema.Instance = new PostReplySchema();
        return PostReplySchema;
    }(ServiceObjectSchema));
    var ResponseMessageSchema = (function (_super) {
        __extends(ResponseMessageSchema, _super);
        function ResponseMessageSchema() {
            _super.call(this);
        }
        ResponseMessageSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Subject);
            _super.prototype.RegisterProperty.call(this, ItemSchema.Body);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.ToRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.CcRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.BccRecipients);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsReadReceiptRequested);
            _super.prototype.RegisterProperty.call(this, EmailMessageSchema.IsDeliveryReceiptRequested);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.ReferenceItemId);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.BodyPrefix);
        };
        ResponseMessageSchema.Instance = new ResponseMessageSchema();
        return ResponseMessageSchema;
    }(ServiceObjectSchema));
    var ResponseObjectSchema = (function (_super) {
        __extends(ResponseObjectSchema, _super);
        function ResponseObjectSchema() {
            _super.call(this);
        }
        ResponseObjectSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, ResponseObjectSchema.ReferenceItemId);
        };
        ResponseObjectSchema.ReferenceItemId = new ComplexPropertyDefinition("ReferenceItemId", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet, ExchangeVersion.Exchange2007_SP1, function () { return new ItemId(); });
        ResponseObjectSchema.BodyPrefix = new ComplexPropertyDefinition("NewBodyContent", PropertyDefinitionFlags.CanSet, ExchangeVersion.Exchange2007_SP1, function () { return new MessageBody(); });
        ResponseObjectSchema.Instance = new ResponseObjectSchema();
        return ResponseObjectSchema;
    }(ServiceObjectSchema));
    var SearchFolderSchema = (function (_super) {
        __extends(SearchFolderSchema, _super);
        function SearchFolderSchema() {
            _super.call(this);
        }
        SearchFolderSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, SearchFolderSchema.SearchParameters);
        };
        SearchFolderSchema.SearchParameters = new ComplexPropertyDefinition("SearchParameters", "folder:SearchParameters", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate, ExchangeVersion.Exchange2007_SP1, function () { return new SearchFolderParameters(); });
        SearchFolderSchema.Instance = new SearchFolderSchema();
        return SearchFolderSchema;
    }(FolderSchema));
    var SearchFolderSchema_FieldUris = (function () {
        function SearchFolderSchema_FieldUris() {
            _super.call(this);
        }
        SearchFolderSchema_FieldUris.SearchParameters = "folder:SearchParameters";
        return SearchFolderSchema_FieldUris;
    }());
    var DoublePropertyDefinition = (function (_super) {
        __extends(DoublePropertyDefinition, _super);
        function DoublePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        return DoublePropertyDefinition;
    }(GenericPropertyDefinition));
    var TaskDelegationStatePropertyDefinition = (function (_super) {
        __extends(TaskDelegationStatePropertyDefinition, _super);
        function TaskDelegationStatePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        TaskDelegationStatePropertyDefinition.prototype.Parse = function (value) {
            if (value !== null) {
                if (value === "NoMatch") {
                    return TaskDelegationState.NoDelegation;
                }
                if (value === "OwnNew") {
                    return TaskDelegationState.Unknown;
                }
                if (value === "Owned") {
                    return TaskDelegationState.Accepted;
                }
                if (value === "Accepted") {
                    return TaskDelegationState.Declined;
                }
            }
            EwsUtilities.Assert(false, "TaskDelegationStatePropertyDefinition.Parse", NString.Format("TaskDelegationStatePropertyDefinition.Parse(): value {0} cannot be handled.", value));
            return null;
        };
        TaskDelegationStatePropertyDefinition.prototype.ToString = function (value) {
            switch (value) {
                case TaskDelegationState.NoDelegation:
                    return "NoMatch";
                case TaskDelegationState.Unknown:
                    return "OwnNew";
                case TaskDelegationState.Accepted:
                    return "Owned";
                case TaskDelegationState.Declined:
                    return "Accepted";
                default:
                    EwsUtilities.Assert(false, "TaskDelegationStatePropertyDefinition.ToString", "Invalid TaskDelegationState value.");
                    return null;
            }
        };
        TaskDelegationStatePropertyDefinition.NoMatch = "NoMatch";
        TaskDelegationStatePropertyDefinition.OwnNew = "OwnNew";
        TaskDelegationStatePropertyDefinition.Owned = "Owned";
        TaskDelegationStatePropertyDefinition.Accepted = "Accepted";
        return TaskDelegationStatePropertyDefinition;
    }(GenericPropertyDefinition));
    var TaskSchema = (function (_super) {
        __extends(TaskSchema, _super);
        function TaskSchema() {
            _super.call(this);
        }
        TaskSchema.prototype.RegisterProperties = function () {
            _super.prototype.RegisterProperties.call(this);
            _super.prototype.RegisterProperty.call(this, TaskSchema.ActualWork);
            _super.prototype.RegisterProperty.call(this, TaskSchema.AssignedTime);
            _super.prototype.RegisterProperty.call(this, TaskSchema.BillingInformation);
            _super.prototype.RegisterProperty.call(this, TaskSchema.ChangeCount);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Companies);
            _super.prototype.RegisterProperty.call(this, TaskSchema.CompleteDate);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Contacts);
            _super.prototype.RegisterProperty.call(this, TaskSchema.DelegationState);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Delegator);
            _super.prototype.RegisterProperty.call(this, TaskSchema.DueDate);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Mode);
            _super.prototype.RegisterProperty.call(this, TaskSchema.IsComplete);
            _super.prototype.RegisterProperty.call(this, TaskSchema.IsRecurring);
            _super.prototype.RegisterProperty.call(this, TaskSchema.IsTeamTask);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Mileage);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Owner);
            _super.prototype.RegisterProperty.call(this, TaskSchema.PercentComplete);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Recurrence);
            _super.prototype.RegisterProperty.call(this, TaskSchema.StartDate);
            _super.prototype.RegisterProperty.call(this, TaskSchema.Status);
            _super.prototype.RegisterProperty.call(this, TaskSchema.StatusDescription);
            _super.prototype.RegisterProperty.call(this, TaskSchema.TotalWork);
        };
        TaskSchema.ActualWork = new IntPropertyDefinition("ActualWork", "task:ActualWork", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.AssignedTime = new DateTimePropertyDefinition("AssignedTime", "task:AssignedTime", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.BillingInformation = new StringPropertyDefinition("BillingInformation", "task:BillingInformation", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.ChangeCount = new IntPropertyDefinition("ChangeCount", "task:ChangeCount", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.Companies = new ComplexPropertyDefinition("Companies", "task:Companies", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new StringList(); });
        TaskSchema.CompleteDate = new DateTimePropertyDefinition("CompleteDate", "task:CompleteDate", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.Contacts = new ComplexPropertyDefinition("Contacts", "task:Contacts", PropertyDefinitionFlags.AutoInstantiateOnRead | PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, function () { return new StringList(); });
        TaskSchema.DelegationState = new TaskDelegationStatePropertyDefinition("DelegationState", "task:DelegationState", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.Delegator = new StringPropertyDefinition("Delegator", "task:Delegator", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.DueDate = new DateTimePropertyDefinition("DueDate", "task:DueDate", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.Mode = new GenericPropertyDefinition("IsAssignmentEditable", "task:IsAssignmentEditable", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.IsComplete = new BoolPropertyDefinition("IsComplete", "task:IsComplete", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.IsRecurring = new BoolPropertyDefinition("IsRecurring", "task:IsRecurring", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.IsTeamTask = new BoolPropertyDefinition("IsTeamTask", "task:IsTeamTask", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.Mileage = new StringPropertyDefinition("Mileage", "task:Mileage", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.Owner = new StringPropertyDefinition("Owner", "task:Owner", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.PercentComplete = new DoublePropertyDefinition("PercentComplete", "task:PercentComplete", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.Recurrence = new RecurrencePropertyDefinition("Recurrence", "task:Recurrence", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.StartDate = new DateTimePropertyDefinition("StartDate", "task:StartDate", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.Status = new GenericPropertyDefinition("Status", "task:Status", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.StatusDescription = new StringPropertyDefinition("StatusDescription", "task:StatusDescription", PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1);
        TaskSchema.TotalWork = new IntPropertyDefinition("TotalWork", "task:TotalWork", PropertyDefinitionFlags.CanSet | PropertyDefinitionFlags.CanUpdate | PropertyDefinitionFlags.CanDelete | PropertyDefinitionFlags.CanFind, ExchangeVersion.Exchange2007_SP1, true);
        TaskSchema.Instance = new TaskSchema();
        return TaskSchema;
    }(ItemSchema));
    var TaskSchema_FieldUris = (function () {
        function TaskSchema_FieldUris() {
            _super.call(this);
        }
        TaskSchema_FieldUris.ActualWork = "task:ActualWork";
        TaskSchema_FieldUris.AssignedTime = "task:AssignedTime";
        TaskSchema_FieldUris.BillingInformation = "task:BillingInformation";
        TaskSchema_FieldUris.ChangeCount = "task:ChangeCount";
        TaskSchema_FieldUris.Companies = "task:Companies";
        TaskSchema_FieldUris.CompleteDate = "task:CompleteDate";
        TaskSchema_FieldUris.Contacts = "task:Contacts";
        TaskSchema_FieldUris.DelegationState = "task:DelegationState";
        TaskSchema_FieldUris.Delegator = "task:Delegator";
        TaskSchema_FieldUris.DueDate = "task:DueDate";
        TaskSchema_FieldUris.IsAssignmentEditable = "task:IsAssignmentEditable";
        TaskSchema_FieldUris.IsComplete = "task:IsComplete";
        TaskSchema_FieldUris.IsRecurring = "task:IsRecurring";
        TaskSchema_FieldUris.IsTeamTask = "task:IsTeamTask";
        TaskSchema_FieldUris.Mileage = "task:Mileage";
        TaskSchema_FieldUris.Owner = "task:Owner";
        TaskSchema_FieldUris.PercentComplete = "task:PercentComplete";
        TaskSchema_FieldUris.Recurrence = "task:Recurrence";
        TaskSchema_FieldUris.StartDate = "task:StartDate";
        TaskSchema_FieldUris.Status = "task:Status";
        TaskSchema_FieldUris.StatusDescription = "task:StatusDescription";
        TaskSchema_FieldUris.TotalWork = "task:TotalWork";
        return TaskSchema_FieldUris;
    }());
    var ExchangeCredentials = (function () {
        function ExchangeCredentials() {
            _super.call(this);
        }
        Object.defineProperty(ExchangeCredentials.prototype, "NeedSignature", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        ExchangeCredentials.op_Implicit = function (credentials) {
            return new WebCredentials(credentials);
        };
        ExchangeCredentials.op_Implicit = function (credentials) {
            return new WebCredentials(credentials);
        };
        ExchangeCredentials.GetUriWithoutSuffix = function (url) {
            var absoluteUri = url.AbsoluteUri;
            var num = NString.IndexOf(absoluteUri, "/wssecurity", StringComparison.OrdinalIgnoreCase);
            if (num !== -1) {
                return NString.Substring(absoluteUri, 0, num);
            }
            return absoluteUri;
        };
        ExchangeCredentials.prototype.PreAuthenticate = function () {
        };
        ExchangeCredentials.prototype.PrepareWebRequest = function (request) {
        };
        ExchangeCredentials.prototype.EmitExtraSoapHeaderNamespaceAliases = function (writer) {
        };
        ExchangeCredentials.prototype.SerializeExtraSoapHeaders = function (writer, webMethodName) {
        };
        ExchangeCredentials.prototype.SerializeWSSecurityHeaders = function (writer) {
        };
        ExchangeCredentials.prototype.AdjustUrl = function (url) {
            return new Uri(ExchangeCredentials.GetUriWithoutSuffix(url));
        };
        ExchangeCredentials.prototype.Sign = function (memoryStream) {
            throw new InvalidOperationException();
        };
        return ExchangeCredentials;
    }());
    var ClientCertificateCredentials = (function (_super) {
        __extends(ClientCertificateCredentials, _super);
        function ClientCertificateCredentials(clientCertificates) {
            _super.call(this);
            this.clientCertificates = null;
            EwsUtilities.ValidateParam(clientCertificates, "clientCertificates");
            this.clientCertificates = clientCertificates;
        }
        Object.defineProperty(ClientCertificateCredentials.prototype, "ClientCertificates", {
            get: function () {
                return this.clientCertificates;
            },
            enumerable: true,
            configurable: true
        });
        ClientCertificateCredentials.prototype.PrepareWebRequest = function (request) {
            request.ClientCertificates = this.ClientCertificates;
        };
        return ClientCertificateCredentials;
    }(ExchangeCredentials));
    var OAuthCredentials = (function (_super) {
        __extends(OAuthCredentials, _super);
        function OAuthCredentials(tokenOrCredentials, verbatim) {
            _super.call(this);
            this.token = null;
            this.credentials = null;
            if (arguments.length === 1 && (tokenOrCredentials === null || tokenOrCredentials.constructor === String)) {
                this.constructor_0(tokenOrCredentials);
                return;
            }
            if (arguments.length === 2 && (tokenOrCredentials === null || tokenOrCredentials.constructor === String) && (verbatim === null || verbatim.constructor === Boolean)) {
                this.constructor_1(tokenOrCredentials, verbatim);
                return;
            }
            this.constructor_2(tokenOrCredentials);
        }
        OAuthCredentials.prototype.constructor_0 = function (token) {
            this.constructor_1(token, false);
        };
        OAuthCredentials.prototype.constructor_1 = function (token, verbatim) {
            EwsUtilities.ValidateParam(token, "token");
            var text;
            if (verbatim) {
                text = token;
            }
            else {
                var num = NString.IndexOf(token, 32);
                if (num === -1) {
                    text = token;
                }
                else {
                    var strA = NString.Substring(token, 0, num);
                    if (NString.Compare(strA, "Bearer", StringComparison.OrdinalIgnoreCase) !== 0) {
                        throw new ArgumentException(Strings.InvalidAuthScheme);
                    }
                    text = NString.Substring(token, num + 1);
                }
                if (!OAuthCredentials.validTokenPattern.IsMatch(text)) {
                    throw new ArgumentException(Strings.InvalidOAuthToken);
                }
            }
            this.token = "Bearer " + text;
        };
        OAuthCredentials.prototype.constructor_2 = function (credentials) {
            EwsUtilities.ValidateParam(credentials, "credentials");
            this.credentials = credentials;
        };
        OAuthCredentials.prototype.PrepareWebRequest = function (request) {
            _super.prototype.PrepareWebRequest.call(this, request);
            if (this.token !== null) {
                request.Headers.Remove(HttpRequestHeader.Authorization);
                request.Headers.Add(HttpRequestHeader.Authorization, this.token);
                return;
            }
            request.Credentials = this.credentials;
        };
        OAuthCredentials.BearerAuthenticationType = "Bearer";
        OAuthCredentials.validTokenPattern = new Regex("^[A-Za-z0-9-_]+\\.[A-Za-z0-9-_]+\\.[A-Za-z0-9-_]*$", RegexOptions.Compiled);
        return OAuthCredentials;
    }(ExchangeCredentials));
    var WSSecurityBasedCredentials = (function (_super) {
        __extends(WSSecurityBasedCredentials, _super);
        function WSSecurityBasedCredentials(securityToken, addTimestamp) {
            _super.call(this);
            this.addTimestamp = false;
            this.securityToken = null;
            this.ewsUrl = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (securityToken === null || securityToken.constructor === String)) {
                this.constructor_1(securityToken);
                return;
            }
            this.constructor_2(securityToken, addTimestamp);
        }
        Object.defineProperty(WSSecurityBasedCredentials.prototype, "SecurityToken", {
            get: function () {
                return this.securityToken;
            },
            set: function (value) {
                this.securityToken = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WSSecurityBasedCredentials.prototype, "EwsUrl", {
            get: function () {
                return this.ewsUrl;
            },
            set: function (value) {
                this.ewsUrl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WSSecurityBasedCredentials, "NamespaceManager", {
            get: function () {
                if (WSSecurityBasedCredentials.namespaceManager === null) {
                    WSSecurityBasedCredentials.namespaceManager = new XmlNamespaceManager(new NameTable());
                    WSSecurityBasedCredentials.namespaceManager.AddNamespace("wsu", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");
                    WSSecurityBasedCredentials.namespaceManager.AddNamespace("wsa", "http://www.w3.org/2005/08/addressing");
                    WSSecurityBasedCredentials.namespaceManager.AddNamespace("soap", "http://schemas.xmlsoap.org/soap/envelope/");
                    WSSecurityBasedCredentials.namespaceManager.AddNamespace("t", "http://schemas.microsoft.com/exchange/services/2006/types");
                    WSSecurityBasedCredentials.namespaceManager.AddNamespace("wsse", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
                }
                return WSSecurityBasedCredentials.namespaceManager;
            },
            enumerable: true,
            configurable: true
        });
        WSSecurityBasedCredentials.prototype.constructor_0 = function () {
        };
        WSSecurityBasedCredentials.prototype.constructor_1 = function (securityToken) {
            this.securityToken = securityToken;
        };
        WSSecurityBasedCredentials.prototype.constructor_2 = function (securityToken, addTimestamp) {
            this.securityToken = securityToken;
            this.addTimestamp = addTimestamp;
        };
        WSSecurityBasedCredentials.prototype.PreAuthenticate = function () {
        };
        WSSecurityBasedCredentials.prototype.EmitExtraSoapHeaderNamespaceAliases = function (writer) {
            writer.WriteAttributeString("xmlns", "wsse", null, "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
            writer.WriteAttributeString("xmlns", "wsa", null, "http://www.w3.org/2005/08/addressing");
        };
        WSSecurityBasedCredentials.prototype.SerializeExtraSoapHeaders = function (writer, webMethodName) {
            this.SerializeWSAddressingHeaders(writer, webMethodName);
            this.SerializeWSSecurityHeaders(writer);
        };
        WSSecurityBasedCredentials.prototype.SerializeWSAddressingHeaders = function (xmlWriter, webMethodName) {
            EwsUtilities.Assert(webMethodName !== null, "WSSecurityBasedCredentials.SerializeWSAddressingHeaders", "Web method name cannot be null!");
            EwsUtilities.Assert(Uri.op_Inequality(this.ewsUrl, null), "WSSecurityBasedCredentials.SerializeWSAddressingHeaders", "EWS Url cannot be null!");
            var text = NString.Format("<wsa:Action soap:mustUnderstand='1'>http://schemas.microsoft.com/exchange/services/2006/messages/{0}</wsa:Action><wsa:ReplyTo><wsa:Address>http://www.w3.org/2005/08/addressing/anonymous</wsa:Address></wsa:ReplyTo><wsa:To soap:mustUnderstand='1'>{1}</wsa:To>", webMethodName, this.ewsUrl);
            xmlWriter.WriteRaw(text);
        };
        WSSecurityBasedCredentials.prototype.SerializeWSSecurityHeaders = function (xmlWriter) {
            EwsUtilities.Assert(this.securityToken !== null, "WSSecurityBasedCredentials.SerializeWSSecurityHeaders", "Security token cannot be null!");
            var str = null;
            if (this.addTimestamp) {
                var utcNow = DateTime.UtcNow;
                str = NString.Format("<wsu:Timestamp><wsu:Created>{0:yyyy'-'MM'-'dd'T'HH':'mm':'ss'Z'}</wsu:Created><wsu:Expires>{1:yyyy'-'MM'-'dd'T'HH':'mm':'ss'Z'}</wsu:Expires></wsu:Timestamp>", utcNow, utcNow.AddMinutes(5.0));
            }
            var text = NString.Format("<wsse:Security soap:mustUnderstand='1'>  {0}</wsse:Security>", str + this.securityToken);
            xmlWriter.WriteRaw(text);
        };
        WSSecurityBasedCredentials.prototype.AdjustUrl = function (url) {
            return new Uri(ExchangeCredentials.GetUriWithoutSuffix(url) + "/wssecurity");
        };
        WSSecurityBasedCredentials.WsAddressingHeadersFormat = "<wsa:Action soap:mustUnderstand='1'>http://schemas.microsoft.com/exchange/services/2006/messages/{0}</wsa:Action><wsa:ReplyTo><wsa:Address>http://www.w3.org/2005/08/addressing/anonymous</wsa:Address></wsa:ReplyTo><wsa:To soap:mustUnderstand='1'>{1}</wsa:To>";
        WSSecurityBasedCredentials.WsSecurityHeaderFormat = "<wsse:Security soap:mustUnderstand='1'>  {0}</wsse:Security>";
        WSSecurityBasedCredentials.WsuTimeStampFormat = "<wsu:Timestamp><wsu:Created>{0:yyyy'-'MM'-'dd'T'HH':'mm':'ss'Z'}</wsu:Created><wsu:Expires>{1:yyyy'-'MM'-'dd'T'HH':'mm':'ss'Z'}</wsu:Expires></wsu:Timestamp>";
        WSSecurityBasedCredentials.WsSecurityPathSuffix = "/wssecurity";
        WSSecurityBasedCredentials.namespaceManager = null;
        return WSSecurityBasedCredentials;
    }(ExchangeCredentials));
    var PartnerTokenCredentials = (function (_super) {
        __extends(PartnerTokenCredentials, _super);
        function PartnerTokenCredentials(securityToken, securityTokenReference) {
            _super.call(this, securityToken, true);
            this.keyInfoNode = null;
            EwsUtilities.ValidateParam(securityToken, "securityToken");
            EwsUtilities.ValidateParam(securityTokenReference, "securityTokenReference");
            var safeXmlDocument = new SafeXmlDocument();
            safeXmlDocument.set_PreserveWhitespace(true);
            safeXmlDocument.LoadXml(securityTokenReference);
            this.keyInfoNode = new KeyInfoNode(safeXmlDocument.get_DocumentElement());
        }
        Object.defineProperty(PartnerTokenCredentials.prototype, "NeedSignature", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        PartnerTokenCredentials.prototype.PrepareWebRequest = function (request) {
            this.EwsUrl = request.RequestUri;
        };
        PartnerTokenCredentials.prototype.AdjustUrl = function (url) {
            return new Uri(ExchangeCredentials.GetUriWithoutSuffix(url) + "/wssecurity/symmetrickey");
        };
        PartnerTokenCredentials.prototype.Sign = function (memoryStream) {
            memoryStream.Position = 0;
            var safeXmlDocument = new SafeXmlDocument();
            safeXmlDocument.set_PreserveWhitespace(true);
            safeXmlDocument.Load(memoryStream);
            var wSSecurityUtilityIdSignedXml = new WSSecurityUtilityIdSignedXml(safeXmlDocument);
            wSSecurityUtilityIdSignedXml.get_SignedInfo().set_CanonicalizationMethod("http://www.w3.org/2001/10/xml-exc-c14n#");
            wSSecurityUtilityIdSignedXml.AddReference("/soap:Envelope/soap:Header/wsse:Security/wsu:Timestamp");
            wSSecurityUtilityIdSignedXml.get_KeyInfo().AddClause(this.keyInfoNode);
            var hMACSHA = new HMACSHA1(ExchangeServiceBase.SessionKey);
            try {
                wSSecurityUtilityIdSignedXml.ComputeSignature(hMACSHA);
            }
            finally {
                if (hMACSHA !== null) {
                    hMACSHA.Dispose();
                }
            }
            var xml = wSSecurityUtilityIdSignedXml.GetXml();
            var xmlNode = safeXmlDocument.SelectSingleNode("/soap:Envelope/soap:Header/wsse:Security", WSSecurityBasedCredentials.NamespaceManager);
            xmlNode.AppendChild(xml);
            memoryStream.Position = 0;
            safeXmlDocument.Save(memoryStream);
        };
        PartnerTokenCredentials.WsSecuritySymmetricKeyPathSuffix = "/wssecurity/symmetrickey";
        return PartnerTokenCredentials;
    }(WSSecurityBasedCredentials));
    var TokenCredentials = (function (_super) {
        __extends(TokenCredentials, _super);
        function TokenCredentials(securityToken) {
            _super.call(this, securityToken);
            EwsUtilities.ValidateParam(securityToken, "securityToken");
        }
        TokenCredentials.prototype.PrepareWebRequest = function (request) {
            this.EwsUrl = request.RequestUri;
        };
        return TokenCredentials;
    }(WSSecurityBasedCredentials));
    var WebCredentials = (function (_super) {
        __extends(WebCredentials, _super);
        function WebCredentials(credentialsOrUsername, password, domain) {
            _super.call(this);
            this.credentials = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1) {
                this.constructor_1(credentialsOrUsername);
                return;
            }
            if (arguments.length === 2 && (credentialsOrUsername === null || credentialsOrUsername.constructor === String) && (password === null || password.constructor === String)) {
                this.constructor_2(credentialsOrUsername, password);
                return;
            }
            this.constructor_3(credentialsOrUsername, password, domain);
        }
        Object.defineProperty(WebCredentials.prototype, "Credentials", {
            get: function () {
                return this.credentials;
            },
            enumerable: true,
            configurable: true
        });
        WebCredentials.prototype.constructor_0 = function () {
            this.constructor_1(CredentialCache.DefaultNetworkCredentials);
        };
        WebCredentials.prototype.constructor_1 = function (credentials) {
            EwsUtilities.ValidateParam(credentials, "credentials");
            this.credentials = credentials;
        };
        WebCredentials.prototype.constructor_2 = function (username, password) {
            this.constructor_1(new NetworkCredential(username, password));
        };
        WebCredentials.prototype.constructor_3 = function (username, password, domain) {
            this.constructor_1(new NetworkCredential(username, password, domain));
        };
        WebCredentials.prototype.PrepareWebRequest = function (request) {
            request.Credentials = this.credentials;
        };
        WebCredentials.prototype.AdjustUrl = function (url) {
            return url;
        };
        return WebCredentials;
    }(ExchangeCredentials));
    var WindowsLiveCredentials = (function (_super) {
        __extends(WindowsLiveCredentials, _super);
        function WindowsLiveCredentials(windowsLiveId, password) {
            _super.call(this);
            this.windowsLiveId = null;
            this.password = null;
            this.windowsLiveUrl = null;
            this.isAuthenticated = false;
            this.traceEnabled = false;
            this.traceListener = new EwsTraceListener();
            if (windowsLiveId === null) {
                throw new ArgumentNullException("windowsLiveId");
            }
            if (password === null) {
                throw new ArgumentNullException("password");
            }
            this.windowsLiveId = windowsLiveId;
            this.password = password;
            this.windowsLiveUrl = WindowsLiveCredentials.DefaultWindowsLiveUrl;
        }
        Object.defineProperty(WindowsLiveCredentials.prototype, "TraceEnabled", {
            get: function () {
                return this.traceEnabled;
            },
            set: function (value) {
                this.traceEnabled = value;
                if (this.traceEnabled && this.traceListener === null) {
                    this.traceListener = new EwsTraceListener();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowsLiveCredentials.prototype, "TraceListener", {
            get: function () {
                return this.traceListener;
            },
            set: function (value) {
                this.traceListener = value;
                this.traceEnabled = (value !== null);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowsLiveCredentials.prototype, "WindowsLiveUrl", {
            get: function () {
                return this.windowsLiveUrl;
            },
            set: function (value) {
                this.EwsUrl = null;
                this.IsAuthenticated = false;
                this.windowsLiveUrl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowsLiveCredentials.prototype, "IsAuthenticated", {
            get: function () {
                return this.isAuthenticated;
            },
            set: function (value) {
                this.isAuthenticated = value;
            },
            enumerable: true,
            configurable: true
        });
        WindowsLiveCredentials.prototype.PrepareWebRequest = function (request) {
            if (Uri.op_Equality(this.EwsUrl, null) || Uri.op_Inequality(this.EwsUrl, request.RequestUri)) {
                this.IsAuthenticated = false;
                this.MakeTokenRequestToWindowsLive(request.RequestUri);
                this.IsAuthenticated = true;
                this.EwsUrl = request.RequestUri;
            }
        };
        WindowsLiveCredentials.prototype.EmitTokenRequest = function (uriForTokenEndpointReference) {
            var utcNow = DateTime.UtcNow;
            var securityTimestamp = new SecurityTimestamp(utcNow, utcNow.AddMinutes(5.0), "Timestamp");
            var s = NString.Format("<?xml version='1.0' encoding='UTF-8'?><s:Envelope xmlns:s='http://www.w3.org/2003/05/soap-envelope'             xmlns:wsse='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd'             xmlns:saml='urn:oasis:names:tc:SAML:1.0:assertion'             xmlns:wsp='http://schemas.xmlsoap.org/ws/2004/09/policy'             xmlns:wsu='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd'             xmlns:wsa='http://www.w3.org/2005/08/addressing'             xmlns:wssc='http://schemas.xmlsoap.org/ws/2005/02/sc'             xmlns:wst='http://schemas.xmlsoap.org/ws/2005/02/trust'             xmlns:ps='http://schemas.microsoft.com/Passport/SoapServices/PPCRL'>  <s:Header>    <wsa:Action s:mustUnderstand='1'>http://schemas.xmlsoap.org/ws/2005/02/trust/RST/Issue</wsa:Action>    <wsa:To s:mustUnderstand='1'>{0}</wsa:To>    <ps:AuthInfo Id='PPAuthInfo'>      <ps:HostingApp>{{63f179af-8bcd-49a0-a3e5-1154c02df090}}</ps:HostingApp>      <ps:BinaryVersion>5</ps:BinaryVersion>      <ps:UIVersion>1</ps:UIVersion>      <ps:Cookies></ps:Cookies>      <ps:RequestParams>AQAAAAIAAABsYwQAAAAxMDMz</ps:RequestParams>    </ps:AuthInfo>    <wsse:Security>      <wsse:UsernameToken wsu:Id='user'>        <wsse:Username>{1}</wsse:Username>        <wsse:Password>{2}</wsse:Password>      </wsse:UsernameToken>      <wsu:Timestamp Id='Timestamp'>        <wsu:Created>{3}</wsu:Created>        <wsu:Expires>{4}</wsu:Expires>      </wsu:Timestamp>    </wsse:Security>  </s:Header>  <s:Body>    <ps:RequestMultipleSecurityTokens Id='RSTS'>      <wst:RequestSecurityToken Id='RST0'>        <wst:RequestType>http://schemas.xmlsoap.org/ws/2005/02/trust/Issue</wst:RequestType>        <wsp:AppliesTo>          <wsa:EndpointReference>            <wsa:Address>http://Passport.NET/tb</wsa:Address>          </wsa:EndpointReference>        </wsp:AppliesTo>      </wst:RequestSecurityToken>      <wst:RequestSecurityToken Id='RST1'>        <wst:RequestType>http://schemas.xmlsoap.org/ws/2005/02/trust/Issue</wst:RequestType>        <wsp:AppliesTo>          <wsa:EndpointReference>            <wsa:Address>{5}</wsa:Address>          </wsa:EndpointReference>        </wsp:AppliesTo>        <wsp:PolicyReference URI='LBI_FED_SSL'></wsp:PolicyReference>      </wst:RequestSecurityToken>    </ps:RequestMultipleSecurityTokens>  </s:Body></s:Envelope>", [
                this.windowsLiveUrl, this.windowsLiveId, this.password, securityTimestamp.GetCreationTimeChars(), securityTimestamp.GetExpiryTimeChars(), uriForTokenEndpointReference.ToString()
            ]);
            var httpWebRequest = WebRequest.Create(this.windowsLiveUrl);
            httpWebRequest.Method = "POST";
            httpWebRequest.ContentType = "text/xml; charset=utf-8";
            var bytes = Encoding.UTF8.GetBytes(s);
            httpWebRequest.ContentLength = bytes.length;
            var requestStream = httpWebRequest.GetRequestStream();
            try {
                requestStream.Write(bytes, 0, bytes.length);
            }
            finally {
                if (requestStream !== null) {
                    requestStream.Dispose();
                }
            }
            return httpWebRequest.GetResponse();
        };
        WindowsLiveCredentials.prototype.TraceResponse = function (response, memoryStream) {
            EwsUtilities.Assert(memoryStream !== null, "WindowsLiveCredentials.TraceResponse", "memoryStream cannot be null");
            if (!this.TraceEnabled) {
                return;
            }
            if (!NString.IsNullOrEmpty(response.ContentType) && (NString.StartsWith(response.ContentType, "text/", StringComparison.OrdinalIgnoreCase) || NString.StartsWith(response.ContentType, "application/soap", StringComparison.OrdinalIgnoreCase))) {
                this.traceListener.Trace("WindowsLiveResponse", EwsUtilities.FormatLogMessageWithXmlContent("WindowsLiveResponse", memoryStream));
                return;
            }
            this.traceListener.Trace("WindowsLiveResponse", "Non-textual response");
        };
        WindowsLiveCredentials.prototype.TraceWebException = function (e) {
            if (e.Response === null) {
                if (this.TraceEnabled) {
                    var traceMessage = NString.Format("Exception Received when sending Windows Live token request: {0}", e);
                    this.traceListener.Trace("WindowsLiveResponse", traceMessage);
                }
                return;
            }
            if (this.TraceEnabled) {
                var memoryStream = new MemoryStream();
                try {
                    var responseStream = e.Response.GetResponseStream();
                    try {
                        EwsUtilities.CopyStream(responseStream, memoryStream);
                        memoryStream.Position = 0;
                    }
                    finally {
                        if (responseStream !== null) {
                            responseStream.Dispose();
                        }
                    }
                    this.TraceResponse(e.Response, memoryStream);
                }
                finally {
                    if (memoryStream !== null) {
                        memoryStream.Dispose();
                    }
                }
            }
        };
        WindowsLiveCredentials.prototype.MakeTokenRequestToWindowsLive = function (uriForTokenEndpointReference) {
            var response;
            try {
                response = this.EmitTokenRequest(uriForTokenEndpointReference);
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Status === WebExceptionStatus.ProtocolError && ex.Response !== null) {
                        this.TraceWebException(ex);
                    }
                    else {
                        if (this.TraceEnabled) {
                            var traceMessage = NString.Format("Error occurred sending request - status was {0}, exception {1}", ex.Status, ex);
                            this.traceListener.Trace("WindowsLiveCredentials", traceMessage);
                        }
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else
                    throw ex;
            }
            try {
                this.ProcessTokenResponse(response);
            }
            catch (ex2) {
                if (ex2 instanceof WebException) {
                    if (this.TraceEnabled) {
                        var traceMessage2 = NString.Format("Error occurred sending request - status was {0}, exception {1}", ex2.Status, ex2);
                        this.traceListener.Trace("WindowsLiveCredentials", traceMessage2);
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else
                    throw ex2;
            }
        };
        WindowsLiveCredentials.prototype.ReadWindowsLiveRSTResponseHeaders = function (rstResponse) {
            rstResponse.ReadStartElement("S", "Header");
            rstResponse.ReadToDescendant(XmlNamespace.PassportSoapFault, "pp");
            if (rstResponse.IsEndElement("S", "Header")) {
                if (this.TraceEnabled) {
                    this.traceListener.Trace("WindowsLiveResponse", "Could not find Passport SOAP fault information in Windows Live response");
                }
                throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, "pp"));
            }
            rstResponse.ReadToDescendant(XmlNamespace.PassportSoapFault, "reqstatus");
            if (rstResponse.IsEndElement(XmlNamespace.PassportSoapFault, "pp")) {
                if (this.TraceEnabled) {
                    this.traceListener.Trace("WindowsLiveResponse", "Could not find reqstatus element in Passport SOAP fault information in Windows Live response");
                }
                throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, "reqstatus"));
            }
            var text = rstResponse.ReadElementValue();
            while (!rstResponse.IsEndElement("S", "Header")) {
                rstResponse.Read();
            }
            if (!NString.Equals(text, "0x0")) {
                if (this.TraceEnabled) {
                    var traceMessage = NString.Format("Received status {0} from Windows Live instead of {1}.", text, "0x0");
                    this.traceListener.Trace("WindowsLiveResponse", traceMessage);
                    rstResponse.ReadStartElement("S", "Body");
                    this.traceListener.Trace("WindowsLiveResponse", NString.Format("Windows Live reported Fault : {0}", rstResponse.ReadInnerXml()));
                }
                throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, "reqstatus: " + text));
            }
        };
        WindowsLiveCredentials.prototype.ParseWindowsLiveRSTResponseBody = function (rstResponse) {
            rstResponse.ReadStartElement(XmlNamespace.WSTrustFebruary2005, "RequestSecurityTokenResponseCollection");
            rstResponse.SkipElement(XmlNamespace.WSTrustFebruary2005, "RequestSecurityTokenResponse");
            rstResponse.ReadStartElement(XmlNamespace.WSTrustFebruary2005, "RequestSecurityTokenResponse");
            while (!rstResponse.IsEndElement(XmlNamespace.WSTrustFebruary2005, "RequestSecurityTokenResponse")) {
                if (rstResponse.IsStartElement() && rstResponse.LocalName === "EncryptedData" && rstResponse.NamespaceUri === "http://www.w3.org/2001/04/xmlenc#") {
                    this.SecurityToken = rstResponse.ReadOuterXml();
                }
                else {
                    if (rstResponse.IsStartElement(XmlNamespace.PassportSoapFault, "pp")) {
                        if (this.TraceEnabled) {
                            var traceMessage = NString.Format("Windows Live reported an error retrieving the token - {0}", rstResponse.ReadOuterXml());
                            this.traceListener.Trace("WindowsLiveResponse", traceMessage);
                        }
                        throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, "EncryptedData"));
                    }
                }
                rstResponse.Read();
            }
            if (this.SecurityToken === null) {
                if (this.TraceEnabled) {
                    var traceMessage2 = NString.Format("Did not find all required parts of the Windows Live response - Security Token - {0}", (this.SecurityToken === null) ? "NOT FOUND" : "found");
                    this.traceListener.Trace("WindowsLiveResponse", traceMessage2);
                }
                throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, "No security token found."));
            }
            rstResponse.Read();
        };
        WindowsLiveCredentials.prototype.ProcessTokenResponse = function (response) {
            var responseStream = response.GetResponseStream();
            try {
                this.SecurityToken = null;
                var ewsXmlReader = new EwsXmlReader(responseStream);
                ewsXmlReader.Read(17);
                ewsXmlReader.ReadStartElement("S", "Envelope");
                this.ReadWindowsLiveRSTResponseHeaders(ewsXmlReader);
                ewsXmlReader.ReadStartElement("S", "Body");
                this.ParseWindowsLiveRSTResponseBody(ewsXmlReader);
            }
            finally {
                if (responseStream !== null) {
                    responseStream.Dispose();
                }
            }
        };
        WindowsLiveCredentials.XmlEncNamespace = "http://www.w3.org/2001/04/xmlenc#";
        WindowsLiveCredentials.WindowsLiveSoapNamespacePrefix = "S";
        WindowsLiveCredentials.RequestSecurityTokenResponseCollectionElementName = "RequestSecurityTokenResponseCollection";
        WindowsLiveCredentials.RequestSecurityTokenResponseElementName = "RequestSecurityTokenResponse";
        WindowsLiveCredentials.EncryptedDataElementName = "EncryptedData";
        WindowsLiveCredentials.PpElementName = "pp";
        WindowsLiveCredentials.ReqstatusElementName = "reqstatus";
        WindowsLiveCredentials.SuccessfulReqstatus = "0x0";
        WindowsLiveCredentials.XmlSignatureReference = "_EWSTKREF";
        WindowsLiveCredentials.DefaultWindowsLiveUrl = new Uri("https://login.live.com/rst2.srf");
        return WindowsLiveCredentials;
    }(WSSecurityBasedCredentials));
    var WSSecurityUtilityIdSignedXml = (function (_super) {
        __extends(WSSecurityUtilityIdSignedXml, _super);
        function WSSecurityUtilityIdSignedXml(document) {
            _super.call(this, document);
            this.document = null;
            this.ids = null;
            this.document = document;
            this.ids = new Dictionary();
        }
        WSSecurityUtilityIdSignedXml.GetUniqueId = function () {
            return WSSecurityUtilityIdSignedXml.commonPrefix + (function () {
                var _p0 = [
                    WSSecurityUtilityIdSignedXml.nextId
                ];
                var _r = Interlocked.Increment(_p0);
                WSSecurityUtilityIdSignedXml.nextId = _p0[0];
                return _r;
            })().ToString(CultureInfo.InvariantCulture);
        };
        WSSecurityUtilityIdSignedXml.prototype.AddReference = function (xpath) {
            var xmlElement = ((this.document.SelectSingleNode(xpath, WSSecurityBasedCredentials.NamespaceManager) instanceof XmlElement) ? this.document.SelectSingleNode(xpath, WSSecurityBasedCredentials.NamespaceManager) : null);
            if (xmlElement !== null) {
                var uniqueId = WSSecurityUtilityIdSignedXml.GetUniqueId();
                var xmlAttribute = this.document.CreateAttribute("wsu", "Id", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");
                xmlAttribute.set_Value(uniqueId);
                xmlElement.get_Attributes().Append(xmlAttribute);
                var reference = new Reference();
                reference.set_Uri("#" + uniqueId);
                reference.AddTransform(new XmlDsigExcC14NTransform());
                _super.prototype.AddReference.call(this, reference);
                this.ids.Add(uniqueId, xmlElement);
            }
        };
        WSSecurityUtilityIdSignedXml.prototype.GetIdElement = function (document, idValue) {
            return this.ids.get_Item(idValue);
        };
        WSSecurityUtilityIdSignedXml.nextId = 0;
        WSSecurityUtilityIdSignedXml.commonPrefix = "uuid-" + Guid.NewGuid().ToString() + "-";
        return WSSecurityUtilityIdSignedXml;
    }(SignedXml));
    var X509CertificateCredentials = (function (_super) {
        __extends(X509CertificateCredentials, _super);
        function X509CertificateCredentials(certificate) {
            _super.call(this, null, true);
            this.certificate = null;
            this.keyInfoClause = null;
            EwsUtilities.ValidateParam(certificate, "certificate");
            if (!certificate.HasPrivateKey) {
                throw new ServiceValidationException(Strings.CertificateHasNoPrivateKey);
            }
            this.certificate = certificate;
            var uniqueId = WSSecurityUtilityIdSignedXml.GetUniqueId();
            this.SecurityToken = NString.Format("<wsse:BinarySecurityToken EncodingType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-soap-message-security-1.0#Base64Binary\" ValueType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3\" wsu:Id=\"{0}\">{1}</wsse:BinarySecurityToken>", uniqueId, Convert.ToBase64String(this.certificate.GetRawCertData()));
            var safeXmlDocument = new SafeXmlDocument();
            safeXmlDocument.set_PreserveWhitespace(true);
            safeXmlDocument.LoadXml(NString.Format("<wsse:SecurityTokenReference xmlns:wsse=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\" ><wsse:Reference URI=\"#{0}\" ValueType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3\" /></wsse:SecurityTokenReference>", uniqueId));
            this.keyInfoClause = new KeyInfoNode(safeXmlDocument.get_DocumentElement());
        }
        Object.defineProperty(X509CertificateCredentials.prototype, "NeedSignature", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        X509CertificateCredentials.prototype.PrepareWebRequest = function (request) {
            this.EwsUrl = request.RequestUri;
        };
        X509CertificateCredentials.prototype.AdjustUrl = function (url) {
            return new Uri(ExchangeCredentials.GetUriWithoutSuffix(url) + "/wssecurity/x509cert");
        };
        X509CertificateCredentials.prototype.Sign = function (memoryStream) {
            memoryStream.Position = 0;
            var safeXmlDocument = new SafeXmlDocument();
            safeXmlDocument.set_PreserveWhitespace(true);
            safeXmlDocument.Load(memoryStream);
            var wSSecurityUtilityIdSignedXml = new WSSecurityUtilityIdSignedXml(safeXmlDocument);
            wSSecurityUtilityIdSignedXml.get_SignedInfo().set_CanonicalizationMethod("http://www.w3.org/2001/10/xml-exc-c14n#");
            wSSecurityUtilityIdSignedXml.set_SigningKey(this.certificate.PrivateKey);
            wSSecurityUtilityIdSignedXml.AddReference("/soap:Envelope/soap:Header/wsa:To");
            wSSecurityUtilityIdSignedXml.AddReference("/soap:Envelope/soap:Header/wsse:Security/wsu:Timestamp");
            wSSecurityUtilityIdSignedXml.get_KeyInfo().AddClause(this.keyInfoClause);
            wSSecurityUtilityIdSignedXml.ComputeSignature();
            var xml = wSSecurityUtilityIdSignedXml.GetXml();
            var xmlNode = safeXmlDocument.SelectSingleNode("/soap:Envelope/soap:Header/wsse:Security", WSSecurityBasedCredentials.NamespaceManager);
            xmlNode.AppendChild(xml);
            memoryStream.Position = 0;
            safeXmlDocument.Save(memoryStream);
        };
        X509CertificateCredentials.prototype.ToString = function () {
            return NString.Format("X509:<I>={0},<S>={1}", this.certificate.Issuer, this.certificate.Subject);
        };
        X509CertificateCredentials.BinarySecurityTokenFormat = "<wsse:BinarySecurityToken EncodingType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-soap-message-security-1.0#Base64Binary\" ValueType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3\" wsu:Id=\"{0}\">{1}</wsse:BinarySecurityToken>";
        X509CertificateCredentials.KeyInfoClauseFormat = "<wsse:SecurityTokenReference xmlns:wsse=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\" ><wsse:Reference URI=\"#{0}\" ValueType=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3\" /></wsse:SecurityTokenReference>";
        X509CertificateCredentials.WsSecurityX509CertPathSuffix = "/wssecurity/x509cert";
        return X509CertificateCredentials;
    }(WSSecurityBasedCredentials));
    var RetentionPolicyTag = (function () {
        function RetentionPolicyTag(displayName, retentionId, retentionPeriod, type, retentionAction, isVisible, optedInto, isArchive) {
            this.DisplayName = null;
            this.RetentionId = null;
            this.RetentionPeriod = 0;
            this.Type = 0;
            this.RetentionAction = 0;
            this.Description = null;
            this.IsVisible = false;
            this.OptedInto = false;
            this.IsArchive = false;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(displayName, retentionId, retentionPeriod, type, retentionAction, isVisible, optedInto, isArchive);
        }
        RetentionPolicyTag.prototype.constructor_0 = function () {
        };
        RetentionPolicyTag.prototype.constructor_1 = function (displayName, retentionId, retentionPeriod, type, retentionAction, isVisible, optedInto, isArchive) {
            this.DisplayName = displayName;
            this.RetentionId = retentionId;
            this.RetentionPeriod = retentionPeriod;
            this.Type = type;
            this.RetentionAction = retentionAction;
            this.IsVisible = isVisible;
            this.OptedInto = optedInto;
            this.IsArchive = isArchive;
        };
        RetentionPolicyTag.LoadFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "RetentionPolicyTag");
            var retentionPolicyTag = new RetentionPolicyTag();
            retentionPolicyTag.DisplayName = reader.ReadElementValue(XmlNamespace.Types, "DisplayName");
            retentionPolicyTag.RetentionId = new Guid(reader.ReadElementValue(XmlNamespace.Types, "RetentionId"));
            retentionPolicyTag.RetentionPeriod = reader.ReadElementValue(XmlNamespace.Types, "RetentionPeriod");
            retentionPolicyTag.Type = reader.ReadElementValue(XmlNamespace.Types, "Type");
            retentionPolicyTag.RetentionAction = reader.ReadElementValue(XmlNamespace.Types, "RetentionAction");
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Types, "Description")) {
                retentionPolicyTag.Description = reader.ReadElementValue(XmlNamespace.Types, "Description");
            }
            retentionPolicyTag.IsVisible = reader.ReadElementValue(XmlNamespace.Types, "IsVisible");
            retentionPolicyTag.OptedInto = reader.ReadElementValue(XmlNamespace.Types, "OptedInto");
            retentionPolicyTag.IsArchive = reader.ReadElementValue(XmlNamespace.Types, "IsArchive");
            return retentionPolicyTag;
        };
        RetentionPolicyTag.LoadFromJson = function (jsonObject) {
            var retentionPolicyTag = new RetentionPolicyTag();
            if (jsonObject.ContainsKey("DisplayName")) {
                retentionPolicyTag.DisplayName = jsonObject.ReadAsString("DisplayName");
            }
            if (jsonObject.ContainsKey("RetentionId")) {
                retentionPolicyTag.RetentionId = new Guid(jsonObject.ReadAsString("RetentionId"));
            }
            if (jsonObject.ContainsKey("RetentionPeriod")) {
                retentionPolicyTag.RetentionPeriod = jsonObject.ReadAsInt("RetentionPeriod");
            }
            if (jsonObject.ContainsKey("Type")) {
                retentionPolicyTag.Type = jsonObject.ReadEnumValue("Type");
            }
            if (jsonObject.ContainsKey("RetentionAction")) {
                retentionPolicyTag.RetentionAction = jsonObject.ReadEnumValue("RetentionAction");
            }
            if (jsonObject.ContainsKey("Description")) {
                retentionPolicyTag.Description = jsonObject.ReadAsString("Description");
            }
            if (jsonObject.ContainsKey("IsVisible")) {
                retentionPolicyTag.IsVisible = jsonObject.ReadAsBool("IsVisible");
            }
            if (jsonObject.ContainsKey("OptedInto")) {
                retentionPolicyTag.OptedInto = jsonObject.ReadAsBool("OptedInto");
            }
            if (jsonObject.ContainsKey("IsArchive")) {
                retentionPolicyTag.IsArchive = jsonObject.ReadAsBool("IsArchive");
            }
            return retentionPolicyTag;
        };
        return RetentionPolicyTag;
    }());
    var AffectedTaskOccurrence;
    (function (AffectedTaskOccurrence) {
        AffectedTaskOccurrence[AffectedTaskOccurrence["AllOccurrences"] = 0] = "AllOccurrences";
        AffectedTaskOccurrence[AffectedTaskOccurrence["SpecifiedOccurrenceOnly"] = 1] = "SpecifiedOccurrenceOnly";
    })(AffectedTaskOccurrence || (AffectedTaskOccurrence = {}));
    var AggregateType;
    (function (AggregateType) {
        AggregateType[AggregateType["Minimum"] = 0] = "Minimum";
        AggregateType[AggregateType["Maximum"] = 1] = "Maximum";
    })(AggregateType || (AggregateType = {}));
    var AppointmentType;
    (function (AppointmentType) {
        AppointmentType[AppointmentType["Single"] = 0] = "Single";
        AppointmentType[AppointmentType["Occurrence"] = 1] = "Occurrence";
        AppointmentType[AppointmentType["Exception"] = 2] = "Exception";
        AppointmentType[AppointmentType["RecurringMaster"] = 3] = "RecurringMaster";
    })(AppointmentType || (AppointmentType = {}));
    var AutodiscoverEndpoints;
    (function (AutodiscoverEndpoints) {
        AutodiscoverEndpoints[AutodiscoverEndpoints["None"] = 0] = "None";
        AutodiscoverEndpoints[AutodiscoverEndpoints["Legacy"] = 1] = "Legacy";
        AutodiscoverEndpoints[AutodiscoverEndpoints["Soap"] = 2] = "Soap";
        AutodiscoverEndpoints[AutodiscoverEndpoints["WsSecurity"] = 4] = "WsSecurity";
        AutodiscoverEndpoints[AutodiscoverEndpoints["WSSecuritySymmetricKey"] = 8] = "WSSecuritySymmetricKey";
        AutodiscoverEndpoints[AutodiscoverEndpoints["WSSecurityX509Cert"] = 16] = "WSSecurityX509Cert";
        AutodiscoverEndpoints[AutodiscoverEndpoints["OAuth"] = 32] = "OAuth";
    })(AutodiscoverEndpoints || (AutodiscoverEndpoints = {}));
    var AvailabilityData;
    (function (AvailabilityData) {
        AvailabilityData[AvailabilityData["FreeBusy"] = 0] = "FreeBusy";
        AvailabilityData[AvailabilityData["Suggestions"] = 1] = "Suggestions";
        AvailabilityData[AvailabilityData["FreeBusyAndSuggestions"] = 2] = "FreeBusyAndSuggestions";
    })(AvailabilityData || (AvailabilityData = {}));
    var BasePropertySet;
    (function (BasePropertySet) {
        BasePropertySet[BasePropertySet["IdOnly"] = 0] = "IdOnly";
        BasePropertySet[BasePropertySet["FirstClassProperties"] = 1] = "FirstClassProperties";
    })(BasePropertySet || (BasePropertySet = {}));
    var BodyType;
    (function (BodyType) {
        BodyType[BodyType["HTML"] = 0] = "HTML";
        BodyType[BodyType["Text"] = 1] = "Text";
    })(BodyType || (BodyType = {}));
    var ChangeType;
    (function (ChangeType) {
        ChangeType[ChangeType["Create"] = 0] = "Create";
        ChangeType[ChangeType["Update"] = 1] = "Update";
        ChangeType[ChangeType["Delete"] = 2] = "Delete";
        ChangeType[ChangeType["ReadFlagChange"] = 3] = "ReadFlagChange";
    })(ChangeType || (ChangeType = {}));
    var ClientAccessTokenType;
    (function (ClientAccessTokenType) {
        ClientAccessTokenType[ClientAccessTokenType["CallerIdentity"] = 0] = "CallerIdentity";
        ClientAccessTokenType[ClientAccessTokenType["ExtensionCallback"] = 1] = "ExtensionCallback";
        ClientAccessTokenType[ClientAccessTokenType["ScopedToken"] = 2] = "ScopedToken";
    })(ClientAccessTokenType || (ClientAccessTokenType = {}));
    var EmailPosition;
    (function (EmailPosition) {
        EmailPosition[EmailPosition["LatestReply"] = 0] = "LatestReply";
        EmailPosition[EmailPosition["Other"] = 1] = "Other";
        EmailPosition[EmailPosition["Subject"] = 2] = "Subject";
        EmailPosition[EmailPosition["Signature"] = 3] = "Signature";
    })(EmailPosition || (EmailPosition = {}));
    var ClientExtensionProvidedTo;
    (function (ClientExtensionProvidedTo) {
        ClientExtensionProvidedTo[ClientExtensionProvidedTo["Everyone"] = 0] = "Everyone";
        ClientExtensionProvidedTo[ClientExtensionProvidedTo["SpecificUsers"] = 1] = "SpecificUsers";
    })(ClientExtensionProvidedTo || (ClientExtensionProvidedTo = {}));
    var ComparisonMode;
    (function (ComparisonMode) {
        ComparisonMode[ComparisonMode["Exact"] = 0] = "Exact";
        ComparisonMode[ComparisonMode["IgnoreCase"] = 1] = "IgnoreCase";
        ComparisonMode[ComparisonMode["IgnoreNonSpacingCharacters"] = 2] = "IgnoreNonSpacingCharacters";
        ComparisonMode[ComparisonMode["IgnoreCaseAndNonSpacingCharacters"] = 3] = "IgnoreCaseAndNonSpacingCharacters";
    })(ComparisonMode || (ComparisonMode = {}));
    var ConflictResolutionMode;
    (function (ConflictResolutionMode) {
        ConflictResolutionMode[ConflictResolutionMode["NeverOverwrite"] = 0] = "NeverOverwrite";
        ConflictResolutionMode[ConflictResolutionMode["AutoResolve"] = 1] = "AutoResolve";
        ConflictResolutionMode[ConflictResolutionMode["AlwaysOverwrite"] = 2] = "AlwaysOverwrite";
    })(ConflictResolutionMode || (ConflictResolutionMode = {}));
    var ConflictType;
    (function (ConflictType) {
        ConflictType[ConflictType["IndividualAttendeeConflict"] = 0] = "IndividualAttendeeConflict";
        ConflictType[ConflictType["GroupConflict"] = 1] = "GroupConflict";
        ConflictType[ConflictType["GroupTooBigConflict"] = 2] = "GroupTooBigConflict";
        ConflictType[ConflictType["UnknownAttendeeConflict"] = 3] = "UnknownAttendeeConflict";
    })(ConflictType || (ConflictType = {}));
    var ConnectingIdType;
    (function (ConnectingIdType) {
        ConnectingIdType[ConnectingIdType["PrincipalName"] = 0] = "PrincipalName";
        ConnectingIdType[ConnectingIdType["SID"] = 1] = "SID";
        ConnectingIdType[ConnectingIdType["SmtpAddress"] = 2] = "SmtpAddress";
    })(ConnectingIdType || (ConnectingIdType = {}));
    var ConnectionFailureCause;
    (function (ConnectionFailureCause) {
        ConnectionFailureCause[ConnectionFailureCause["None"] = 0] = "None";
        ConnectionFailureCause[ConnectionFailureCause["UserBusy"] = 1] = "UserBusy";
        ConnectionFailureCause[ConnectionFailureCause["NoAnswer"] = 2] = "NoAnswer";
        ConnectionFailureCause[ConnectionFailureCause["Unavailable"] = 3] = "Unavailable";
        ConnectionFailureCause[ConnectionFailureCause["Other"] = 4] = "Other";
    })(ConnectionFailureCause || (ConnectionFailureCause = {}));
    var ContactSource;
    (function (ContactSource) {
        ContactSource[ContactSource["ActiveDirectory"] = 0] = "ActiveDirectory";
        ContactSource[ContactSource["Store"] = 1] = "Store";
    })(ContactSource || (ContactSource = {}));
    var ContainmentMode;
    (function (ContainmentMode) {
        ContainmentMode[ContainmentMode["FullString"] = 0] = "FullString";
        ContainmentMode[ContainmentMode["Prefixed"] = 1] = "Prefixed";
        ContainmentMode[ContainmentMode["Substring"] = 2] = "Substring";
        ContainmentMode[ContainmentMode["PrefixOnWords"] = 3] = "PrefixOnWords";
        ContainmentMode[ContainmentMode["ExactPhrase"] = 4] = "ExactPhrase";
    })(ContainmentMode || (ContainmentMode = {}));
    var ConversationActionType;
    (function (ConversationActionType) {
        ConversationActionType[ConversationActionType["AlwaysCategorize"] = 0] = "AlwaysCategorize";
        ConversationActionType[ConversationActionType["AlwaysDelete"] = 1] = "AlwaysDelete";
        ConversationActionType[ConversationActionType["AlwaysMove"] = 2] = "AlwaysMove";
        ConversationActionType[ConversationActionType["Delete"] = 3] = "Delete";
        ConversationActionType[ConversationActionType["Move"] = 4] = "Move";
        ConversationActionType[ConversationActionType["Copy"] = 5] = "Copy";
        ConversationActionType[ConversationActionType["SetReadState"] = 6] = "SetReadState";
        ConversationActionType[ConversationActionType["SetRetentionPolicy"] = 7] = "SetRetentionPolicy";
        ConversationActionType[ConversationActionType["Flag"] = 8] = "Flag";
    })(ConversationActionType || (ConversationActionType = {}));
    var ConversationFlagStatus;
    (function (ConversationFlagStatus) {
        ConversationFlagStatus[ConversationFlagStatus["NotFlagged"] = 0] = "NotFlagged";
        ConversationFlagStatus[ConversationFlagStatus["Flagged"] = 1] = "Flagged";
        ConversationFlagStatus[ConversationFlagStatus["Complete"] = 2] = "Complete";
    })(ConversationFlagStatus || (ConversationFlagStatus = {}));
    var ConversationQueryTraversal;
    (function (ConversationQueryTraversal) {
        ConversationQueryTraversal[ConversationQueryTraversal["Shallow"] = 0] = "Shallow";
        ConversationQueryTraversal[ConversationQueryTraversal["Deep"] = 1] = "Deep";
    })(ConversationQueryTraversal || (ConversationQueryTraversal = {}));
    var ConversationSortOrder;
    (function (ConversationSortOrder) {
        ConversationSortOrder[ConversationSortOrder["TreeOrderAscending"] = 0] = "TreeOrderAscending";
        ConversationSortOrder[ConversationSortOrder["TreeOrderDescending"] = 1] = "TreeOrderDescending";
        ConversationSortOrder[ConversationSortOrder["DateOrderAscending"] = 2] = "DateOrderAscending";
        ConversationSortOrder[ConversationSortOrder["DateOrderDescending"] = 3] = "DateOrderDescending";
    })(ConversationSortOrder || (ConversationSortOrder = {}));
    var DateTimePrecision;
    (function (DateTimePrecision) {
        DateTimePrecision[DateTimePrecision["Default"] = 0] = "Default";
        DateTimePrecision[DateTimePrecision["Seconds"] = 1] = "Seconds";
        DateTimePrecision[DateTimePrecision["Milliseconds"] = 2] = "Milliseconds";
    })(DateTimePrecision || (DateTimePrecision = {}));
    var DayOfTheWeekIndex;
    (function (DayOfTheWeekIndex) {
        DayOfTheWeekIndex[DayOfTheWeekIndex["First"] = 0] = "First";
        DayOfTheWeekIndex[DayOfTheWeekIndex["Second"] = 1] = "Second";
        DayOfTheWeekIndex[DayOfTheWeekIndex["Third"] = 2] = "Third";
        DayOfTheWeekIndex[DayOfTheWeekIndex["Fourth"] = 3] = "Fourth";
        DayOfTheWeekIndex[DayOfTheWeekIndex["Last"] = 4] = "Last";
    })(DayOfTheWeekIndex || (DayOfTheWeekIndex = {}));
    var DayOfTheWeek;
    (function (DayOfTheWeek) {
        DayOfTheWeek[DayOfTheWeek["Sunday"] = 0] = "Sunday";
        DayOfTheWeek[DayOfTheWeek["Monday"] = 1] = "Monday";
        DayOfTheWeek[DayOfTheWeek["Tuesday"] = 2] = "Tuesday";
        DayOfTheWeek[DayOfTheWeek["Wednesday"] = 3] = "Wednesday";
        DayOfTheWeek[DayOfTheWeek["Thursday"] = 4] = "Thursday";
        DayOfTheWeek[DayOfTheWeek["Friday"] = 5] = "Friday";
        DayOfTheWeek[DayOfTheWeek["Saturday"] = 6] = "Saturday";
        DayOfTheWeek[DayOfTheWeek["Day"] = 7] = "Day";
        DayOfTheWeek[DayOfTheWeek["Weekday"] = 8] = "Weekday";
        DayOfTheWeek[DayOfTheWeek["WeekendDay"] = 9] = "WeekendDay";
    })(DayOfTheWeek || (DayOfTheWeek = {}));
    var DefaultExtendedPropertySet;
    (function (DefaultExtendedPropertySet) {
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["Meeting"] = 0] = "Meeting";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["Appointment"] = 1] = "Appointment";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["Common"] = 2] = "Common";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["PublicStrings"] = 3] = "PublicStrings";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["Address"] = 4] = "Address";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["InternetHeaders"] = 5] = "InternetHeaders";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["CalendarAssistant"] = 6] = "CalendarAssistant";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["UnifiedMessaging"] = 7] = "UnifiedMessaging";
        DefaultExtendedPropertySet[DefaultExtendedPropertySet["Task"] = 8] = "Task";
    })(DefaultExtendedPropertySet || (DefaultExtendedPropertySet = {}));
    var DelegateFolderPermissionLevel;
    (function (DelegateFolderPermissionLevel) {
        DelegateFolderPermissionLevel[DelegateFolderPermissionLevel["None"] = 0] = "None";
        DelegateFolderPermissionLevel[DelegateFolderPermissionLevel["Editor"] = 1] = "Editor";
        DelegateFolderPermissionLevel[DelegateFolderPermissionLevel["Reviewer"] = 2] = "Reviewer";
        DelegateFolderPermissionLevel[DelegateFolderPermissionLevel["Author"] = 3] = "Author";
        DelegateFolderPermissionLevel[DelegateFolderPermissionLevel["Custom"] = 4] = "Custom";
    })(DelegateFolderPermissionLevel || (DelegateFolderPermissionLevel = {}));
    var DeleteMode;
    (function (DeleteMode) {
        DeleteMode[DeleteMode["HardDelete"] = 0] = "HardDelete";
        DeleteMode[DeleteMode["SoftDelete"] = 1] = "SoftDelete";
        DeleteMode[DeleteMode["MoveToDeletedItems"] = 2] = "MoveToDeletedItems";
    })(DeleteMode || (DeleteMode = {}));
    var EffectiveRights;
    (function (EffectiveRights) {
        EffectiveRights[EffectiveRights["None"] = 0] = "None";
        EffectiveRights[EffectiveRights["CreateAssociated"] = 1] = "CreateAssociated";
        EffectiveRights[EffectiveRights["CreateContents"] = 2] = "CreateContents";
        EffectiveRights[EffectiveRights["CreateHierarchy"] = 4] = "CreateHierarchy";
        EffectiveRights[EffectiveRights["Delete"] = 8] = "Delete";
        EffectiveRights[EffectiveRights["Modify"] = 16] = "Modify";
        EffectiveRights[EffectiveRights["Read"] = 32] = "Read";
        EffectiveRights[EffectiveRights["ViewPrivateItems"] = 64] = "ViewPrivateItems";
    })(EffectiveRights || (EffectiveRights = {}));
    var ElcFolderType;
    (function (ElcFolderType) {
        ElcFolderType[ElcFolderType["Calendar"] = 1] = "Calendar";
        ElcFolderType[ElcFolderType["Contacts"] = 2] = "Contacts";
        ElcFolderType[ElcFolderType["DeletedItems"] = 3] = "DeletedItems";
        ElcFolderType[ElcFolderType["Drafts"] = 4] = "Drafts";
        ElcFolderType[ElcFolderType["Inbox"] = 5] = "Inbox";
        ElcFolderType[ElcFolderType["JunkEmail"] = 6] = "JunkEmail";
        ElcFolderType[ElcFolderType["Journal"] = 7] = "Journal";
        ElcFolderType[ElcFolderType["Notes"] = 8] = "Notes";
        ElcFolderType[ElcFolderType["Outbox"] = 9] = "Outbox";
        ElcFolderType[ElcFolderType["SentItems"] = 10] = "SentItems";
        ElcFolderType[ElcFolderType["Tasks"] = 11] = "Tasks";
        ElcFolderType[ElcFolderType["All"] = 12] = "All";
        ElcFolderType[ElcFolderType["ManagedCustomFolder"] = 13] = "ManagedCustomFolder";
        ElcFolderType[ElcFolderType["RssSubscriptions"] = 14] = "RssSubscriptions";
        ElcFolderType[ElcFolderType["SyncIssues"] = 15] = "SyncIssues";
        ElcFolderType[ElcFolderType["ConversationHistory"] = 16] = "ConversationHistory";
        ElcFolderType[ElcFolderType["Personal"] = 17] = "Personal";
        ElcFolderType[ElcFolderType["RecoverableItems"] = 18] = "RecoverableItems";
        ElcFolderType[ElcFolderType["NonIpmRoot"] = 19] = "NonIpmRoot";
    })(ElcFolderType || (ElcFolderType = {}));
    var EmailAddressKey;
    (function (EmailAddressKey) {
        EmailAddressKey[EmailAddressKey["EmailAddress1"] = 0] = "EmailAddress1";
        EmailAddressKey[EmailAddressKey["EmailAddress2"] = 1] = "EmailAddress2";
        EmailAddressKey[EmailAddressKey["EmailAddress3"] = 2] = "EmailAddress3";
    })(EmailAddressKey || (EmailAddressKey = {}));
    var EventType;
    (function (EventType) {
        EventType[EventType["Status"] = 0] = "Status";
        EventType[EventType["NewMail"] = 1] = "NewMail";
        EventType[EventType["Deleted"] = 2] = "Deleted";
        EventType[EventType["Modified"] = 3] = "Modified";
        EventType[EventType["Moved"] = 4] = "Moved";
        EventType[EventType["Copied"] = 5] = "Copied";
        EventType[EventType["Created"] = 6] = "Created";
        EventType[EventType["FreeBusyChanged"] = 7] = "FreeBusyChanged";
    })(EventType || (EventType = {}));
    var ExchangeVersion;
    (function (ExchangeVersion) {
        ExchangeVersion[ExchangeVersion["Exchange2007_SP1"] = 0] = "Exchange2007_SP1";
        ExchangeVersion[ExchangeVersion["Exchange2010"] = 1] = "Exchange2010";
        ExchangeVersion[ExchangeVersion["Exchange2010_SP1"] = 2] = "Exchange2010_SP1";
        ExchangeVersion[ExchangeVersion["Exchange2010_SP2"] = 3] = "Exchange2010_SP2";
        ExchangeVersion[ExchangeVersion["Exchange2013"] = 4] = "Exchange2013";
        ExchangeVersion[ExchangeVersion["Exchange2013_SP1"] = 5] = "Exchange2013_SP1";
    })(ExchangeVersion || (ExchangeVersion = {}));
    var ExtensionInstallScope;
    (function (ExtensionInstallScope) {
        ExtensionInstallScope[ExtensionInstallScope["None"] = 0] = "None";
        ExtensionInstallScope[ExtensionInstallScope["User"] = 1] = "User";
        ExtensionInstallScope[ExtensionInstallScope["Organization"] = 2] = "Organization";
        ExtensionInstallScope[ExtensionInstallScope["Default"] = 3] = "Default";
    })(ExtensionInstallScope || (ExtensionInstallScope = {}));
    var ExtensionType;
    (function (ExtensionType) {
        ExtensionType[ExtensionType["Default"] = 0] = "Default";
        ExtensionType[ExtensionType["Private"] = 1] = "Private";
        ExtensionType[ExtensionType["MarketPlace"] = 2] = "MarketPlace";
    })(ExtensionType || (ExtensionType = {}));
    var FileAsMapping;
    (function (FileAsMapping) {
        FileAsMapping[FileAsMapping["None"] = 0] = "None";
        FileAsMapping[FileAsMapping["SurnameCommaGivenName"] = 1] = "SurnameCommaGivenName";
        FileAsMapping[FileAsMapping["GivenNameSpaceSurname"] = 2] = "GivenNameSpaceSurname";
        FileAsMapping[FileAsMapping["Company"] = 3] = "Company";
        FileAsMapping[FileAsMapping["SurnameCommaGivenNameCompany"] = 4] = "SurnameCommaGivenNameCompany";
        FileAsMapping[FileAsMapping["CompanySurnameGivenName"] = 5] = "CompanySurnameGivenName";
        FileAsMapping[FileAsMapping["SurnameGivenName"] = 6] = "SurnameGivenName";
        FileAsMapping[FileAsMapping["SurnameGivenNameCompany"] = 7] = "SurnameGivenNameCompany";
        FileAsMapping[FileAsMapping["CompanySurnameCommaGivenName"] = 8] = "CompanySurnameCommaGivenName";
        FileAsMapping[FileAsMapping["SurnameGivenNameSuffix"] = 9] = "SurnameGivenNameSuffix";
        FileAsMapping[FileAsMapping["SurnameSpaceGivenNameCompany"] = 10] = "SurnameSpaceGivenNameCompany";
        FileAsMapping[FileAsMapping["CompanySurnameSpaceGivenName"] = 11] = "CompanySurnameSpaceGivenName";
        FileAsMapping[FileAsMapping["SurnameSpaceGivenName"] = 12] = "SurnameSpaceGivenName";
        FileAsMapping[FileAsMapping["DisplayName"] = 13] = "DisplayName";
        FileAsMapping[FileAsMapping["GivenName"] = 14] = "GivenName";
        FileAsMapping[FileAsMapping["SurnameGivenNameMiddleSuffix"] = 15] = "SurnameGivenNameMiddleSuffix";
        FileAsMapping[FileAsMapping["Surname"] = 16] = "Surname";
        FileAsMapping[FileAsMapping["Empty"] = 17] = "Empty";
    })(FileAsMapping || (FileAsMapping = {}));
    var FlaggedForAction;
    (function (FlaggedForAction) {
        FlaggedForAction[FlaggedForAction["Any"] = 0] = "Any";
        FlaggedForAction[FlaggedForAction["Call"] = 1] = "Call";
        FlaggedForAction[FlaggedForAction["DoNotForward"] = 2] = "DoNotForward";
        FlaggedForAction[FlaggedForAction["FollowUp"] = 3] = "FollowUp";
        FlaggedForAction[FlaggedForAction["FYI"] = 4] = "FYI";
        FlaggedForAction[FlaggedForAction["Forward"] = 5] = "Forward";
        FlaggedForAction[FlaggedForAction["NoResponseNecessary"] = 6] = "NoResponseNecessary";
        FlaggedForAction[FlaggedForAction["Read"] = 7] = "Read";
        FlaggedForAction[FlaggedForAction["Reply"] = 8] = "Reply";
        FlaggedForAction[FlaggedForAction["ReplyToAll"] = 9] = "ReplyToAll";
        FlaggedForAction[FlaggedForAction["Review"] = 10] = "Review";
    })(FlaggedForAction || (FlaggedForAction = {}));
    var FolderPermissionLevel;
    (function (FolderPermissionLevel) {
        FolderPermissionLevel[FolderPermissionLevel["None"] = 0] = "None";
        FolderPermissionLevel[FolderPermissionLevel["Owner"] = 1] = "Owner";
        FolderPermissionLevel[FolderPermissionLevel["PublishingEditor"] = 2] = "PublishingEditor";
        FolderPermissionLevel[FolderPermissionLevel["Editor"] = 3] = "Editor";
        FolderPermissionLevel[FolderPermissionLevel["PublishingAuthor"] = 4] = "PublishingAuthor";
        FolderPermissionLevel[FolderPermissionLevel["Author"] = 5] = "Author";
        FolderPermissionLevel[FolderPermissionLevel["NoneditingAuthor"] = 6] = "NoneditingAuthor";
        FolderPermissionLevel[FolderPermissionLevel["Reviewer"] = 7] = "Reviewer";
        FolderPermissionLevel[FolderPermissionLevel["Contributor"] = 8] = "Contributor";
        FolderPermissionLevel[FolderPermissionLevel["FreeBusyTimeOnly"] = 9] = "FreeBusyTimeOnly";
        FolderPermissionLevel[FolderPermissionLevel["FreeBusyTimeAndSubjectAndLocation"] = 10] = "FreeBusyTimeAndSubjectAndLocation";
        FolderPermissionLevel[FolderPermissionLevel["Custom"] = 11] = "Custom";
    })(FolderPermissionLevel || (FolderPermissionLevel = {}));
    var FolderPermissionReadAccess;
    (function (FolderPermissionReadAccess) {
        FolderPermissionReadAccess[FolderPermissionReadAccess["None"] = 0] = "None";
        FolderPermissionReadAccess[FolderPermissionReadAccess["TimeOnly"] = 1] = "TimeOnly";
        FolderPermissionReadAccess[FolderPermissionReadAccess["TimeAndSubjectAndLocation"] = 2] = "TimeAndSubjectAndLocation";
        FolderPermissionReadAccess[FolderPermissionReadAccess["FullDetails"] = 3] = "FullDetails";
    })(FolderPermissionReadAccess || (FolderPermissionReadAccess = {}));
    var FolderTraversal;
    (function (FolderTraversal) {
        FolderTraversal[FolderTraversal["Shallow"] = 0] = "Shallow";
        FolderTraversal[FolderTraversal["Deep"] = 1] = "Deep";
        FolderTraversal[FolderTraversal["SoftDeleted"] = 2] = "SoftDeleted";
    })(FolderTraversal || (FolderTraversal = {}));
    var FreeBusyViewType;
    (function (FreeBusyViewType) {
        FreeBusyViewType[FreeBusyViewType["None"] = 0] = "None";
        FreeBusyViewType[FreeBusyViewType["MergedOnly"] = 1] = "MergedOnly";
        FreeBusyViewType[FreeBusyViewType["FreeBusy"] = 2] = "FreeBusy";
        FreeBusyViewType[FreeBusyViewType["FreeBusyMerged"] = 3] = "FreeBusyMerged";
        FreeBusyViewType[FreeBusyViewType["Detailed"] = 4] = "Detailed";
        FreeBusyViewType[FreeBusyViewType["DetailedMerged"] = 5] = "DetailedMerged";
    })(FreeBusyViewType || (FreeBusyViewType = {}));
    var HoldAction;
    (function (HoldAction) {
        HoldAction[HoldAction["Create"] = 0] = "Create";
        HoldAction[HoldAction["Update"] = 1] = "Update";
        HoldAction[HoldAction["Remove"] = 2] = "Remove";
    })(HoldAction || (HoldAction = {}));
    var HoldStatus;
    (function (HoldStatus) {
        HoldStatus[HoldStatus["NotOnHold"] = 0] = "NotOnHold";
        HoldStatus[HoldStatus["Pending"] = 1] = "Pending";
        HoldStatus[HoldStatus["OnHold"] = 2] = "OnHold";
        HoldStatus[HoldStatus["PartialHold"] = 3] = "PartialHold";
        HoldStatus[HoldStatus["Failed"] = 4] = "Failed";
    })(HoldStatus || (HoldStatus = {}));
    var IconIndex;
    (function (IconIndex) {
        IconIndex[IconIndex["Default"] = 0] = "Default";
        IconIndex[IconIndex["PostItem"] = 1] = "PostItem";
        IconIndex[IconIndex["MailRead"] = 2] = "MailRead";
        IconIndex[IconIndex["MailUnread"] = 3] = "MailUnread";
        IconIndex[IconIndex["MailReplied"] = 4] = "MailReplied";
        IconIndex[IconIndex["MailForwarded"] = 5] = "MailForwarded";
        IconIndex[IconIndex["MailEncrypted"] = 6] = "MailEncrypted";
        IconIndex[IconIndex["MailSmimeSigned"] = 7] = "MailSmimeSigned";
        IconIndex[IconIndex["MailEncryptedReplied"] = 8] = "MailEncryptedReplied";
        IconIndex[IconIndex["MailSmimeSignedReplied"] = 9] = "MailSmimeSignedReplied";
        IconIndex[IconIndex["MailEncryptedForwarded"] = 10] = "MailEncryptedForwarded";
        IconIndex[IconIndex["MailSmimeSignedForwarded"] = 11] = "MailSmimeSignedForwarded";
        IconIndex[IconIndex["MailEncryptedRead"] = 12] = "MailEncryptedRead";
        IconIndex[IconIndex["MailSmimeSignedRead"] = 13] = "MailSmimeSignedRead";
        IconIndex[IconIndex["MailIrm"] = 14] = "MailIrm";
        IconIndex[IconIndex["MailIrmForwarded"] = 15] = "MailIrmForwarded";
        IconIndex[IconIndex["MailIrmReplied"] = 16] = "MailIrmReplied";
        IconIndex[IconIndex["SmsSubmitted"] = 17] = "SmsSubmitted";
        IconIndex[IconIndex["SmsRoutedToDeliveryPoint"] = 18] = "SmsRoutedToDeliveryPoint";
        IconIndex[IconIndex["SmsRoutedToExternalMessagingSystem"] = 19] = "SmsRoutedToExternalMessagingSystem";
        IconIndex[IconIndex["SmsDelivered"] = 20] = "SmsDelivered";
        IconIndex[IconIndex["OutlookDefaultForContacts"] = 21] = "OutlookDefaultForContacts";
        IconIndex[IconIndex["AppointmentItem"] = 22] = "AppointmentItem";
        IconIndex[IconIndex["AppointmentRecur"] = 23] = "AppointmentRecur";
        IconIndex[IconIndex["AppointmentMeet"] = 24] = "AppointmentMeet";
        IconIndex[IconIndex["AppointmentMeetRecur"] = 25] = "AppointmentMeetRecur";
        IconIndex[IconIndex["AppointmentMeetNY"] = 26] = "AppointmentMeetNY";
        IconIndex[IconIndex["AppointmentMeetYes"] = 27] = "AppointmentMeetYes";
        IconIndex[IconIndex["AppointmentMeetNo"] = 28] = "AppointmentMeetNo";
        IconIndex[IconIndex["AppointmentMeetMaybe"] = 29] = "AppointmentMeetMaybe";
        IconIndex[IconIndex["AppointmentMeetCancel"] = 30] = "AppointmentMeetCancel";
        IconIndex[IconIndex["AppointmentMeetInfo"] = 31] = "AppointmentMeetInfo";
        IconIndex[IconIndex["TaskItem"] = 32] = "TaskItem";
        IconIndex[IconIndex["TaskRecur"] = 33] = "TaskRecur";
        IconIndex[IconIndex["TaskOwned"] = 34] = "TaskOwned";
        IconIndex[IconIndex["TaskDelegated"] = 35] = "TaskDelegated";
    })(IconIndex || (IconIndex = {}));
    var IdFormat;
    (function (IdFormat) {
        IdFormat[IdFormat["EwsLegacyId"] = 0] = "EwsLegacyId";
        IdFormat[IdFormat["EwsId"] = 1] = "EwsId";
        IdFormat[IdFormat["EntryId"] = 2] = "EntryId";
        IdFormat[IdFormat["HexEntryId"] = 3] = "HexEntryId";
        IdFormat[IdFormat["StoreId"] = 4] = "StoreId";
        IdFormat[IdFormat["OwaId"] = 5] = "OwaId";
    })(IdFormat || (IdFormat = {}));
    var ImAddressKey;
    (function (ImAddressKey) {
        ImAddressKey[ImAddressKey["ImAddress1"] = 0] = "ImAddress1";
        ImAddressKey[ImAddressKey["ImAddress2"] = 1] = "ImAddress2";
        ImAddressKey[ImAddressKey["ImAddress3"] = 2] = "ImAddress3";
    })(ImAddressKey || (ImAddressKey = {}));
    var Importance;
    (function (Importance) {
        Importance[Importance["Low"] = 0] = "Low";
        Importance[Importance["Normal"] = 1] = "Normal";
        Importance[Importance["High"] = 2] = "High";
    })(Importance || (Importance = {}));
    var ItemFlagStatus;
    (function (ItemFlagStatus) {
        ItemFlagStatus[ItemFlagStatus["NotFlagged"] = 0] = "NotFlagged";
        ItemFlagStatus[ItemFlagStatus["Flagged"] = 1] = "Flagged";
        ItemFlagStatus[ItemFlagStatus["Complete"] = 2] = "Complete";
    })(ItemFlagStatus || (ItemFlagStatus = {}));
    var ItemTraversal;
    (function (ItemTraversal) {
        ItemTraversal[ItemTraversal["Shallow"] = 0] = "Shallow";
        ItemTraversal[ItemTraversal["SoftDeleted"] = 1] = "SoftDeleted";
        ItemTraversal[ItemTraversal["Associated"] = 2] = "Associated";
    })(ItemTraversal || (ItemTraversal = {}));
    var LegacyFreeBusyStatus;
    (function (LegacyFreeBusyStatus) {
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["Free"] = 0] = "Free";
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["Tentative"] = 1] = "Tentative";
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["Busy"] = 2] = "Busy";
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["OOF"] = 3] = "OOF";
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["WorkingElsewhere"] = 4] = "WorkingElsewhere";
        LegacyFreeBusyStatus[LegacyFreeBusyStatus["NoData"] = 5] = "NoData";
    })(LegacyFreeBusyStatus || (LegacyFreeBusyStatus = {}));
    var LocationSource;
    (function (LocationSource) {
        LocationSource[LocationSource["None"] = 0] = "None";
        LocationSource[LocationSource["LocationServices"] = 1] = "LocationServices";
        LocationSource[LocationSource["PhonebookServices"] = 2] = "PhonebookServices";
        LocationSource[LocationSource["Device"] = 3] = "Device";
        LocationSource[LocationSource["Contact"] = 4] = "Contact";
        LocationSource[LocationSource["Resource"] = 5] = "Resource";
    })(LocationSource || (LocationSource = {}));
    var LogicalOperator;
    (function (LogicalOperator) {
        LogicalOperator[LogicalOperator["And"] = 0] = "And";
        LogicalOperator[LogicalOperator["Or"] = 1] = "Or";
    })(LogicalOperator || (LogicalOperator = {}));
    var MailboxSearchLocation;
    (function (MailboxSearchLocation) {
        MailboxSearchLocation[MailboxSearchLocation["PrimaryOnly"] = 0] = "PrimaryOnly";
        MailboxSearchLocation[MailboxSearchLocation["ArchiveOnly"] = 1] = "ArchiveOnly";
        MailboxSearchLocation[MailboxSearchLocation["All"] = 2] = "All";
    })(MailboxSearchLocation || (MailboxSearchLocation = {}));
    var MailboxSearchScopeType;
    (function (MailboxSearchScopeType) {
        MailboxSearchScopeType[MailboxSearchScopeType["LegacyExchangeDN"] = 0] = "LegacyExchangeDN";
        MailboxSearchScopeType[MailboxSearchScopeType["PublicFolder"] = 1] = "PublicFolder";
        MailboxSearchScopeType[MailboxSearchScopeType["Recipient"] = 2] = "Recipient";
        MailboxSearchScopeType[MailboxSearchScopeType["MailboxGuid"] = 3] = "MailboxGuid";
        MailboxSearchScopeType[MailboxSearchScopeType["AllPublicFolders"] = 4] = "AllPublicFolders";
        MailboxSearchScopeType[MailboxSearchScopeType["AllMailboxes"] = 5] = "AllMailboxes";
        MailboxSearchScopeType[MailboxSearchScopeType["SavedSearchId"] = 6] = "SavedSearchId";
        MailboxSearchScopeType[MailboxSearchScopeType["AutoDetect"] = 7] = "AutoDetect";
    })(MailboxSearchScopeType || (MailboxSearchScopeType = {}));
    var MailboxType;
    (function (MailboxType) {
        MailboxType[MailboxType["Unknown"] = 0] = "Unknown";
        MailboxType[MailboxType["OneOff"] = 1] = "OneOff";
        MailboxType[MailboxType["Mailbox"] = 2] = "Mailbox";
        MailboxType[MailboxType["PublicFolder"] = 3] = "PublicFolder";
        MailboxType[MailboxType["PublicGroup"] = 4] = "PublicGroup";
        MailboxType[MailboxType["ContactGroup"] = 5] = "ContactGroup";
        MailboxType[MailboxType["Contact"] = 6] = "Contact";
    })(MailboxType || (MailboxType = {}));
    var MapiPropertyType;
    (function (MapiPropertyType) {
        MapiPropertyType[MapiPropertyType["ApplicationTime"] = 0] = "ApplicationTime";
        MapiPropertyType[MapiPropertyType["ApplicationTimeArray"] = 1] = "ApplicationTimeArray";
        MapiPropertyType[MapiPropertyType["Binary"] = 2] = "Binary";
        MapiPropertyType[MapiPropertyType["BinaryArray"] = 3] = "BinaryArray";
        MapiPropertyType[MapiPropertyType["Boolean"] = 4] = "Boolean";
        MapiPropertyType[MapiPropertyType["CLSID"] = 5] = "CLSID";
        MapiPropertyType[MapiPropertyType["CLSIDArray"] = 6] = "CLSIDArray";
        MapiPropertyType[MapiPropertyType["Currency"] = 7] = "Currency";
        MapiPropertyType[MapiPropertyType["CurrencyArray"] = 8] = "CurrencyArray";
        MapiPropertyType[MapiPropertyType["Double"] = 9] = "Double";
        MapiPropertyType[MapiPropertyType["DoubleArray"] = 10] = "DoubleArray";
        MapiPropertyType[MapiPropertyType["Error"] = 11] = "Error";
        MapiPropertyType[MapiPropertyType["Float"] = 12] = "Float";
        MapiPropertyType[MapiPropertyType["FloatArray"] = 13] = "FloatArray";
        MapiPropertyType[MapiPropertyType["Integer"] = 14] = "Integer";
        MapiPropertyType[MapiPropertyType["IntegerArray"] = 15] = "IntegerArray";
        MapiPropertyType[MapiPropertyType["Long"] = 16] = "Long";
        MapiPropertyType[MapiPropertyType["LongArray"] = 17] = "LongArray";
        MapiPropertyType[MapiPropertyType["Null"] = 18] = "Null";
        MapiPropertyType[MapiPropertyType["Object"] = 19] = "Object";
        MapiPropertyType[MapiPropertyType["ObjectArray"] = 20] = "ObjectArray";
        MapiPropertyType[MapiPropertyType["Short"] = 21] = "Short";
        MapiPropertyType[MapiPropertyType["ShortArray"] = 22] = "ShortArray";
        MapiPropertyType[MapiPropertyType["SystemTime"] = 23] = "SystemTime";
        MapiPropertyType[MapiPropertyType["SystemTimeArray"] = 24] = "SystemTimeArray";
        MapiPropertyType[MapiPropertyType["String"] = 25] = "String";
        MapiPropertyType[MapiPropertyType["StringArray"] = 26] = "StringArray";
    })(MapiPropertyType || (MapiPropertyType = {}));
    var MemberStatus;
    (function (MemberStatus) {
        MemberStatus[MemberStatus["Unrecognized"] = 0] = "Unrecognized";
        MemberStatus[MemberStatus["Normal"] = 1] = "Normal";
        MemberStatus[MemberStatus["Demoted"] = 2] = "Demoted";
    })(MemberStatus || (MemberStatus = {}));
    var MeetingAttendeeType;
    (function (MeetingAttendeeType) {
        MeetingAttendeeType[MeetingAttendeeType["Organizer"] = 0] = "Organizer";
        MeetingAttendeeType[MeetingAttendeeType["Required"] = 1] = "Required";
        MeetingAttendeeType[MeetingAttendeeType["Optional"] = 2] = "Optional";
        MeetingAttendeeType[MeetingAttendeeType["Room"] = 3] = "Room";
        MeetingAttendeeType[MeetingAttendeeType["Resource"] = 4] = "Resource";
    })(MeetingAttendeeType || (MeetingAttendeeType = {}));
    var MeetingRequestsDeliveryScope;
    (function (MeetingRequestsDeliveryScope) {
        MeetingRequestsDeliveryScope[MeetingRequestsDeliveryScope["DelegatesOnly"] = 0] = "DelegatesOnly";
        MeetingRequestsDeliveryScope[MeetingRequestsDeliveryScope["DelegatesAndMe"] = 1] = "DelegatesAndMe";
        MeetingRequestsDeliveryScope[MeetingRequestsDeliveryScope["DelegatesAndSendInformationToMe"] = 2] = "DelegatesAndSendInformationToMe";
        MeetingRequestsDeliveryScope[MeetingRequestsDeliveryScope["NoForward"] = 3] = "NoForward";
    })(MeetingRequestsDeliveryScope || (MeetingRequestsDeliveryScope = {}));
    var MeetingRequestType;
    (function (MeetingRequestType) {
        MeetingRequestType[MeetingRequestType["None"] = 0] = "None";
        MeetingRequestType[MeetingRequestType["FullUpdate"] = 1] = "FullUpdate";
        MeetingRequestType[MeetingRequestType["InformationalUpdate"] = 2] = "InformationalUpdate";
        MeetingRequestType[MeetingRequestType["NewMeetingRequest"] = 3] = "NewMeetingRequest";
        MeetingRequestType[MeetingRequestType["Outdated"] = 4] = "Outdated";
        MeetingRequestType[MeetingRequestType["SilentUpdate"] = 5] = "SilentUpdate";
        MeetingRequestType[MeetingRequestType["PrincipalWantsCopy"] = 6] = "PrincipalWantsCopy";
    })(MeetingRequestType || (MeetingRequestType = {}));
    var MessageDisposition;
    (function (MessageDisposition) {
        MessageDisposition[MessageDisposition["SaveOnly"] = 0] = "SaveOnly";
        MessageDisposition[MessageDisposition["SendAndSaveCopy"] = 1] = "SendAndSaveCopy";
        MessageDisposition[MessageDisposition["SendOnly"] = 2] = "SendOnly";
    })(MessageDisposition || (MessageDisposition = {}));
    var Month;
    (function (Month) {
        Month[Month["January"] = 1] = "January";
        Month[Month["February"] = 2] = "February";
        Month[Month["March"] = 3] = "March";
        Month[Month["April"] = 4] = "April";
        Month[Month["May"] = 5] = "May";
        Month[Month["June"] = 6] = "June";
        Month[Month["July"] = 7] = "July";
        Month[Month["August"] = 8] = "August";
        Month[Month["September"] = 9] = "September";
        Month[Month["October"] = 10] = "October";
        Month[Month["November"] = 11] = "November";
        Month[Month["December"] = 12] = "December";
    })(Month || (Month = {}));
    var OffsetBasePoint;
    (function (OffsetBasePoint) {
        OffsetBasePoint[OffsetBasePoint["Beginning"] = 0] = "Beginning";
        OffsetBasePoint[OffsetBasePoint["End"] = 1] = "End";
    })(OffsetBasePoint || (OffsetBasePoint = {}));
    var OofExternalAudience;
    (function (OofExternalAudience) {
        OofExternalAudience[OofExternalAudience["None"] = 0] = "None";
        OofExternalAudience[OofExternalAudience["Known"] = 1] = "Known";
        OofExternalAudience[OofExternalAudience["All"] = 2] = "All";
    })(OofExternalAudience || (OofExternalAudience = {}));
    var OofState;
    (function (OofState) {
        OofState[OofState["Disabled"] = 0] = "Disabled";
        OofState[OofState["Enabled"] = 1] = "Enabled";
        OofState[OofState["Scheduled"] = 2] = "Scheduled";
    })(OofState || (OofState = {}));
    var PermissionScope;
    (function (PermissionScope) {
        PermissionScope[PermissionScope["None"] = 0] = "None";
        PermissionScope[PermissionScope["Owned"] = 1] = "Owned";
        PermissionScope[PermissionScope["All"] = 2] = "All";
    })(PermissionScope || (PermissionScope = {}));
    var PhoneCallState;
    (function (PhoneCallState) {
        PhoneCallState[PhoneCallState["Idle"] = 0] = "Idle";
        PhoneCallState[PhoneCallState["Connecting"] = 1] = "Connecting";
        PhoneCallState[PhoneCallState["Alerted"] = 2] = "Alerted";
        PhoneCallState[PhoneCallState["Connected"] = 3] = "Connected";
        PhoneCallState[PhoneCallState["Disconnected"] = 4] = "Disconnected";
        PhoneCallState[PhoneCallState["Incoming"] = 5] = "Incoming";
        PhoneCallState[PhoneCallState["Transferring"] = 6] = "Transferring";
        PhoneCallState[PhoneCallState["Forwarding"] = 7] = "Forwarding";
    })(PhoneCallState || (PhoneCallState = {}));
    var PhoneNumberKey;
    (function (PhoneNumberKey) {
        PhoneNumberKey[PhoneNumberKey["AssistantPhone"] = 0] = "AssistantPhone";
        PhoneNumberKey[PhoneNumberKey["BusinessFax"] = 1] = "BusinessFax";
        PhoneNumberKey[PhoneNumberKey["BusinessPhone"] = 2] = "BusinessPhone";
        PhoneNumberKey[PhoneNumberKey["BusinessPhone2"] = 3] = "BusinessPhone2";
        PhoneNumberKey[PhoneNumberKey["Callback"] = 4] = "Callback";
        PhoneNumberKey[PhoneNumberKey["CarPhone"] = 5] = "CarPhone";
        PhoneNumberKey[PhoneNumberKey["CompanyMainPhone"] = 6] = "CompanyMainPhone";
        PhoneNumberKey[PhoneNumberKey["HomeFax"] = 7] = "HomeFax";
        PhoneNumberKey[PhoneNumberKey["HomePhone"] = 8] = "HomePhone";
        PhoneNumberKey[PhoneNumberKey["HomePhone2"] = 9] = "HomePhone2";
        PhoneNumberKey[PhoneNumberKey["Isdn"] = 10] = "Isdn";
        PhoneNumberKey[PhoneNumberKey["MobilePhone"] = 11] = "MobilePhone";
        PhoneNumberKey[PhoneNumberKey["OtherFax"] = 12] = "OtherFax";
        PhoneNumberKey[PhoneNumberKey["OtherTelephone"] = 13] = "OtherTelephone";
        PhoneNumberKey[PhoneNumberKey["Pager"] = 14] = "Pager";
        PhoneNumberKey[PhoneNumberKey["PrimaryPhone"] = 15] = "PrimaryPhone";
        PhoneNumberKey[PhoneNumberKey["RadioPhone"] = 16] = "RadioPhone";
        PhoneNumberKey[PhoneNumberKey["Telex"] = 17] = "Telex";
        PhoneNumberKey[PhoneNumberKey["TtyTddPhone"] = 18] = "TtyTddPhone";
    })(PhoneNumberKey || (PhoneNumberKey = {}));
    var PhysicalAddressIndex;
    (function (PhysicalAddressIndex) {
        PhysicalAddressIndex[PhysicalAddressIndex["None"] = 0] = "None";
        PhysicalAddressIndex[PhysicalAddressIndex["Business"] = 1] = "Business";
        PhysicalAddressIndex[PhysicalAddressIndex["Home"] = 2] = "Home";
        PhysicalAddressIndex[PhysicalAddressIndex["Other"] = 3] = "Other";
    })(PhysicalAddressIndex || (PhysicalAddressIndex = {}));
    var PhysicalAddressKey;
    (function (PhysicalAddressKey) {
        PhysicalAddressKey[PhysicalAddressKey["Business"] = 0] = "Business";
        PhysicalAddressKey[PhysicalAddressKey["Home"] = 1] = "Home";
        PhysicalAddressKey[PhysicalAddressKey["Other"] = 2] = "Other";
    })(PhysicalAddressKey || (PhysicalAddressKey = {}));
    var PreviewItemBaseShape;
    (function (PreviewItemBaseShape) {
        PreviewItemBaseShape[PreviewItemBaseShape["Default"] = 0] = "Default";
        PreviewItemBaseShape[PreviewItemBaseShape["Compact"] = 1] = "Compact";
    })(PreviewItemBaseShape || (PreviewItemBaseShape = {}));
    var PrivilegedLogonType;
    (function (PrivilegedLogonType) {
        PrivilegedLogonType[PrivilegedLogonType["Admin"] = 0] = "Admin";
        PrivilegedLogonType[PrivilegedLogonType["SystemService"] = 1] = "SystemService";
    })(PrivilegedLogonType || (PrivilegedLogonType = {}));
    var PropertyDefinitionFlags;
    (function (PropertyDefinitionFlags) {
        PropertyDefinitionFlags[PropertyDefinitionFlags["None"] = 0] = "None";
        PropertyDefinitionFlags[PropertyDefinitionFlags["AutoInstantiateOnRead"] = 1] = "AutoInstantiateOnRead";
        PropertyDefinitionFlags[PropertyDefinitionFlags["ReuseInstance"] = 2] = "ReuseInstance";
        PropertyDefinitionFlags[PropertyDefinitionFlags["CanSet"] = 4] = "CanSet";
        PropertyDefinitionFlags[PropertyDefinitionFlags["CanUpdate"] = 8] = "CanUpdate";
        PropertyDefinitionFlags[PropertyDefinitionFlags["CanDelete"] = 16] = "CanDelete";
        PropertyDefinitionFlags[PropertyDefinitionFlags["CanFind"] = 32] = "CanFind";
        PropertyDefinitionFlags[PropertyDefinitionFlags["MustBeExplicitlyLoaded"] = 64] = "MustBeExplicitlyLoaded";
        PropertyDefinitionFlags[PropertyDefinitionFlags["UpdateCollectionItems"] = 128] = "UpdateCollectionItems";
    })(PropertyDefinitionFlags || (PropertyDefinitionFlags = {}));
    var ResolveNameSearchLocation;
    (function (ResolveNameSearchLocation) {
        ResolveNameSearchLocation[ResolveNameSearchLocation["DirectoryOnly"] = 0] = "DirectoryOnly";
        ResolveNameSearchLocation[ResolveNameSearchLocation["DirectoryThenContacts"] = 1] = "DirectoryThenContacts";
        ResolveNameSearchLocation[ResolveNameSearchLocation["ContactsOnly"] = 2] = "ContactsOnly";
        ResolveNameSearchLocation[ResolveNameSearchLocation["ContactsThenDirectory"] = 3] = "ContactsThenDirectory";
    })(ResolveNameSearchLocation || (ResolveNameSearchLocation = {}));
    var ResponseActions;
    (function (ResponseActions) {
        ResponseActions[ResponseActions["None"] = 0] = "None";
        ResponseActions[ResponseActions["Accept"] = 1] = "Accept";
        ResponseActions[ResponseActions["TentativelyAccept"] = 2] = "TentativelyAccept";
        ResponseActions[ResponseActions["Decline"] = 4] = "Decline";
        ResponseActions[ResponseActions["Reply"] = 8] = "Reply";
        ResponseActions[ResponseActions["ReplyAll"] = 16] = "ReplyAll";
        ResponseActions[ResponseActions["Forward"] = 32] = "Forward";
        ResponseActions[ResponseActions["Cancel"] = 64] = "Cancel";
        ResponseActions[ResponseActions["RemoveFromCalendar"] = 128] = "RemoveFromCalendar";
        ResponseActions[ResponseActions["SuppressReadReceipt"] = 256] = "SuppressReadReceipt";
        ResponseActions[ResponseActions["PostReply"] = 512] = "PostReply";
    })(ResponseActions || (ResponseActions = {}));
    var ResponseMessageType;
    (function (ResponseMessageType) {
        ResponseMessageType[ResponseMessageType["Reply"] = 0] = "Reply";
        ResponseMessageType[ResponseMessageType["ReplyAll"] = 1] = "ReplyAll";
        ResponseMessageType[ResponseMessageType["Forward"] = 2] = "Forward";
    })(ResponseMessageType || (ResponseMessageType = {}));
    var MeetingResponseType;
    (function (MeetingResponseType) {
        MeetingResponseType[MeetingResponseType["Unknown"] = 0] = "Unknown";
        MeetingResponseType[MeetingResponseType["Organizer"] = 1] = "Organizer";
        MeetingResponseType[MeetingResponseType["Tentative"] = 2] = "Tentative";
        MeetingResponseType[MeetingResponseType["Accept"] = 3] = "Accept";
        MeetingResponseType[MeetingResponseType["Decline"] = 4] = "Decline";
        MeetingResponseType[MeetingResponseType["NoResponseReceived"] = 5] = "NoResponseReceived";
    })(MeetingResponseType || (MeetingResponseType = {}));
    var RetentionActionType;
    (function (RetentionActionType) {
        RetentionActionType[RetentionActionType["None"] = 0] = "None";
        RetentionActionType[RetentionActionType["MoveToDeletedItems"] = 1] = "MoveToDeletedItems";
        RetentionActionType[RetentionActionType["MoveToFolder"] = 2] = "MoveToFolder";
        RetentionActionType[RetentionActionType["DeleteAndAllowRecovery"] = 3] = "DeleteAndAllowRecovery";
        RetentionActionType[RetentionActionType["PermanentlyDelete"] = 4] = "PermanentlyDelete";
        RetentionActionType[RetentionActionType["MarkAsPastRetentionLimit"] = 5] = "MarkAsPastRetentionLimit";
        RetentionActionType[RetentionActionType["MoveToArchive"] = 6] = "MoveToArchive";
    })(RetentionActionType || (RetentionActionType = {}));
    var RetentionType;
    (function (RetentionType) {
        RetentionType[RetentionType["Delete"] = 0] = "Delete";
        RetentionType[RetentionType["Archive"] = 1] = "Archive";
    })(RetentionType || (RetentionType = {}));
    var RuleProperty;
    (function (RuleProperty) {
        RuleProperty[RuleProperty["RuleId"] = 0] = "RuleId";
        RuleProperty[RuleProperty["DisplayName"] = 1] = "DisplayName";
        RuleProperty[RuleProperty["Priority"] = 2] = "Priority";
        RuleProperty[RuleProperty["IsNotSupported"] = 3] = "IsNotSupported";
        RuleProperty[RuleProperty["Actions"] = 4] = "Actions";
        RuleProperty[RuleProperty["ConditionCategories"] = 5] = "ConditionCategories";
        RuleProperty[RuleProperty["ConditionContainsBodyStrings"] = 6] = "ConditionContainsBodyStrings";
        RuleProperty[RuleProperty["ConditionContainsHeaderStrings"] = 7] = "ConditionContainsHeaderStrings";
        RuleProperty[RuleProperty["ConditionContainsRecipientStrings"] = 8] = "ConditionContainsRecipientStrings";
        RuleProperty[RuleProperty["ConditionContainsSenderStrings"] = 9] = "ConditionContainsSenderStrings";
        RuleProperty[RuleProperty["ConditionContainsSubjectOrBodyStrings"] = 10] = "ConditionContainsSubjectOrBodyStrings";
        RuleProperty[RuleProperty["ConditionContainsSubjectStrings"] = 11] = "ConditionContainsSubjectStrings";
        RuleProperty[RuleProperty["ConditionFlaggedForAction"] = 12] = "ConditionFlaggedForAction";
        RuleProperty[RuleProperty["ConditionFromAddresses"] = 13] = "ConditionFromAddresses";
        RuleProperty[RuleProperty["ConditionFromConnectedAccounts"] = 14] = "ConditionFromConnectedAccounts";
        RuleProperty[RuleProperty["ConditionHasAttachments"] = 15] = "ConditionHasAttachments";
        RuleProperty[RuleProperty["ConditionImportance"] = 16] = "ConditionImportance";
        RuleProperty[RuleProperty["ConditionIsApprovalRequest"] = 17] = "ConditionIsApprovalRequest";
        RuleProperty[RuleProperty["ConditionIsAutomaticForward"] = 18] = "ConditionIsAutomaticForward";
        RuleProperty[RuleProperty["ConditionIsAutomaticReply"] = 19] = "ConditionIsAutomaticReply";
        RuleProperty[RuleProperty["ConditionIsEncrypted"] = 20] = "ConditionIsEncrypted";
        RuleProperty[RuleProperty["ConditionIsMeetingRequest"] = 21] = "ConditionIsMeetingRequest";
        RuleProperty[RuleProperty["ConditionIsMeetingResponse"] = 22] = "ConditionIsMeetingResponse";
        RuleProperty[RuleProperty["ConditionIsNonDeliveryReport"] = 23] = "ConditionIsNonDeliveryReport";
        RuleProperty[RuleProperty["ConditionIsPermissionControlled"] = 24] = "ConditionIsPermissionControlled";
        RuleProperty[RuleProperty["ConditionIsRead"] = 25] = "ConditionIsRead";
        RuleProperty[RuleProperty["ConditionIsSigned"] = 26] = "ConditionIsSigned";
        RuleProperty[RuleProperty["ConditionIsVoicemail"] = 27] = "ConditionIsVoicemail";
        RuleProperty[RuleProperty["ConditionIsReadReceipt"] = 28] = "ConditionIsReadReceipt";
        RuleProperty[RuleProperty["ConditionItemClasses"] = 29] = "ConditionItemClasses";
        RuleProperty[RuleProperty["ConditionMessageClassifications"] = 30] = "ConditionMessageClassifications";
        RuleProperty[RuleProperty["ConditionNotSentToMe"] = 31] = "ConditionNotSentToMe";
        RuleProperty[RuleProperty["ConditionSentCcMe"] = 32] = "ConditionSentCcMe";
        RuleProperty[RuleProperty["ConditionSentOnlyToMe"] = 33] = "ConditionSentOnlyToMe";
        RuleProperty[RuleProperty["ConditionSentToAddresses"] = 34] = "ConditionSentToAddresses";
        RuleProperty[RuleProperty["ConditionSentToMe"] = 35] = "ConditionSentToMe";
        RuleProperty[RuleProperty["ConditionSentToOrCcMe"] = 36] = "ConditionSentToOrCcMe";
        RuleProperty[RuleProperty["ConditionSensitivity"] = 37] = "ConditionSensitivity";
        RuleProperty[RuleProperty["ConditionWithinDateRange"] = 38] = "ConditionWithinDateRange";
        RuleProperty[RuleProperty["ConditionWithinSizeRange"] = 39] = "ConditionWithinSizeRange";
        RuleProperty[RuleProperty["ExceptionCategories"] = 40] = "ExceptionCategories";
        RuleProperty[RuleProperty["ExceptionContainsBodyStrings"] = 41] = "ExceptionContainsBodyStrings";
        RuleProperty[RuleProperty["ExceptionContainsHeaderStrings"] = 42] = "ExceptionContainsHeaderStrings";
        RuleProperty[RuleProperty["ExceptionContainsRecipientStrings"] = 43] = "ExceptionContainsRecipientStrings";
        RuleProperty[RuleProperty["ExceptionContainsSenderStrings"] = 44] = "ExceptionContainsSenderStrings";
        RuleProperty[RuleProperty["ExceptionContainsSubjectOrBodyStrings"] = 45] = "ExceptionContainsSubjectOrBodyStrings";
        RuleProperty[RuleProperty["ExceptionContainsSubjectStrings"] = 46] = "ExceptionContainsSubjectStrings";
        RuleProperty[RuleProperty["ExceptionFlaggedForAction"] = 47] = "ExceptionFlaggedForAction";
        RuleProperty[RuleProperty["ExceptionFromAddresses"] = 48] = "ExceptionFromAddresses";
        RuleProperty[RuleProperty["ExceptionFromConnectedAccounts"] = 49] = "ExceptionFromConnectedAccounts";
        RuleProperty[RuleProperty["ExceptionHasAttachments"] = 50] = "ExceptionHasAttachments";
        RuleProperty[RuleProperty["ExceptionImportance"] = 51] = "ExceptionImportance";
        RuleProperty[RuleProperty["ExceptionIsApprovalRequest"] = 52] = "ExceptionIsApprovalRequest";
        RuleProperty[RuleProperty["ExceptionIsAutomaticForward"] = 53] = "ExceptionIsAutomaticForward";
        RuleProperty[RuleProperty["ExceptionIsAutomaticReply"] = 54] = "ExceptionIsAutomaticReply";
        RuleProperty[RuleProperty["ExceptionIsEncrypted"] = 55] = "ExceptionIsEncrypted";
        RuleProperty[RuleProperty["ExceptionIsMeetingRequest"] = 56] = "ExceptionIsMeetingRequest";
        RuleProperty[RuleProperty["ExceptionIsMeetingResponse"] = 57] = "ExceptionIsMeetingResponse";
        RuleProperty[RuleProperty["ExceptionIsNonDeliveryReport"] = 58] = "ExceptionIsNonDeliveryReport";
        RuleProperty[RuleProperty["ExceptionIsPermissionControlled"] = 59] = "ExceptionIsPermissionControlled";
        RuleProperty[RuleProperty["ExceptionIsRead"] = 60] = "ExceptionIsRead";
        RuleProperty[RuleProperty["ExceptionIsSigned"] = 61] = "ExceptionIsSigned";
        RuleProperty[RuleProperty["ExceptionIsVoicemail"] = 62] = "ExceptionIsVoicemail";
        RuleProperty[RuleProperty["ExceptionItemClasses"] = 63] = "ExceptionItemClasses";
        RuleProperty[RuleProperty["ExceptionMessageClassifications"] = 64] = "ExceptionMessageClassifications";
        RuleProperty[RuleProperty["ExceptionNotSentToMe"] = 65] = "ExceptionNotSentToMe";
        RuleProperty[RuleProperty["ExceptionSentCcMe"] = 66] = "ExceptionSentCcMe";
        RuleProperty[RuleProperty["ExceptionSentOnlyToMe"] = 67] = "ExceptionSentOnlyToMe";
        RuleProperty[RuleProperty["ExceptionSentToAddresses"] = 68] = "ExceptionSentToAddresses";
        RuleProperty[RuleProperty["ExceptionSentToMe"] = 69] = "ExceptionSentToMe";
        RuleProperty[RuleProperty["ExceptionSentToOrCcMe"] = 70] = "ExceptionSentToOrCcMe";
        RuleProperty[RuleProperty["ExceptionSensitivity"] = 71] = "ExceptionSensitivity";
        RuleProperty[RuleProperty["ExceptionWithinDateRange"] = 72] = "ExceptionWithinDateRange";
        RuleProperty[RuleProperty["ExceptionWithinSizeRange"] = 73] = "ExceptionWithinSizeRange";
        RuleProperty[RuleProperty["ActionCategories"] = 74] = "ActionCategories";
        RuleProperty[RuleProperty["ActionCopyToFolder"] = 75] = "ActionCopyToFolder";
        RuleProperty[RuleProperty["ActionDelete"] = 76] = "ActionDelete";
        RuleProperty[RuleProperty["ActionForwardAsAttachmentToRecipients"] = 77] = "ActionForwardAsAttachmentToRecipients";
        RuleProperty[RuleProperty["ActionForwardToRecipients"] = 78] = "ActionForwardToRecipients";
        RuleProperty[RuleProperty["ActionImportance"] = 79] = "ActionImportance";
        RuleProperty[RuleProperty["ActionMarkAsRead"] = 80] = "ActionMarkAsRead";
        RuleProperty[RuleProperty["ActionMoveToFolder"] = 81] = "ActionMoveToFolder";
        RuleProperty[RuleProperty["ActionPermanentDelete"] = 82] = "ActionPermanentDelete";
        RuleProperty[RuleProperty["ActionRedirectToRecipients"] = 83] = "ActionRedirectToRecipients";
        RuleProperty[RuleProperty["ActionSendSMSAlertToRecipients"] = 84] = "ActionSendSMSAlertToRecipients";
        RuleProperty[RuleProperty["ActionServerReplyWithMessage"] = 85] = "ActionServerReplyWithMessage";
        RuleProperty[RuleProperty["ActionStopProcessingRules"] = 86] = "ActionStopProcessingRules";
        RuleProperty[RuleProperty["IsEnabled"] = 87] = "IsEnabled";
        RuleProperty[RuleProperty["IsInError"] = 88] = "IsInError";
        RuleProperty[RuleProperty["Conditions"] = 89] = "Conditions";
        RuleProperty[RuleProperty["Exceptions"] = 90] = "Exceptions";
    })(RuleProperty || (RuleProperty = {}));
    var RuleErrorCode;
    (function (RuleErrorCode) {
        RuleErrorCode[RuleErrorCode["ADOperationFailure"] = 0] = "ADOperationFailure";
        RuleErrorCode[RuleErrorCode["ConnectedAccountNotFound"] = 1] = "ConnectedAccountNotFound";
        RuleErrorCode[RuleErrorCode["CreateWithRuleId"] = 2] = "CreateWithRuleId";
        RuleErrorCode[RuleErrorCode["EmptyValueFound"] = 3] = "EmptyValueFound";
        RuleErrorCode[RuleErrorCode["DuplicatedPriority"] = 4] = "DuplicatedPriority";
        RuleErrorCode[RuleErrorCode["DuplicatedOperationOnTheSameRule"] = 5] = "DuplicatedOperationOnTheSameRule";
        RuleErrorCode[RuleErrorCode["FolderDoesNotExist"] = 6] = "FolderDoesNotExist";
        RuleErrorCode[RuleErrorCode["InvalidAddress"] = 7] = "InvalidAddress";
        RuleErrorCode[RuleErrorCode["InvalidDateRange"] = 8] = "InvalidDateRange";
        RuleErrorCode[RuleErrorCode["InvalidFolderId"] = 9] = "InvalidFolderId";
        RuleErrorCode[RuleErrorCode["InvalidSizeRange"] = 10] = "InvalidSizeRange";
        RuleErrorCode[RuleErrorCode["InvalidValue"] = 11] = "InvalidValue";
        RuleErrorCode[RuleErrorCode["MessageClassificationNotFound"] = 12] = "MessageClassificationNotFound";
        RuleErrorCode[RuleErrorCode["MissingAction"] = 13] = "MissingAction";
        RuleErrorCode[RuleErrorCode["MissingParameter"] = 14] = "MissingParameter";
        RuleErrorCode[RuleErrorCode["MissingRangeValue"] = 15] = "MissingRangeValue";
        RuleErrorCode[RuleErrorCode["NotSettable"] = 16] = "NotSettable";
        RuleErrorCode[RuleErrorCode["RecipientDoesNotExist"] = 17] = "RecipientDoesNotExist";
        RuleErrorCode[RuleErrorCode["RuleNotFound"] = 18] = "RuleNotFound";
        RuleErrorCode[RuleErrorCode["SizeLessThanZero"] = 19] = "SizeLessThanZero";
        RuleErrorCode[RuleErrorCode["StringValueTooBig"] = 20] = "StringValueTooBig";
        RuleErrorCode[RuleErrorCode["UnsupportedAddress"] = 21] = "UnsupportedAddress";
        RuleErrorCode[RuleErrorCode["UnexpectedError"] = 22] = "UnexpectedError";
        RuleErrorCode[RuleErrorCode["UnsupportedRule"] = 23] = "UnsupportedRule";
    })(RuleErrorCode || (RuleErrorCode = {}));
    var SearchFolderTraversal;
    (function (SearchFolderTraversal) {
        SearchFolderTraversal[SearchFolderTraversal["Shallow"] = 0] = "Shallow";
        SearchFolderTraversal[SearchFolderTraversal["Deep"] = 1] = "Deep";
    })(SearchFolderTraversal || (SearchFolderTraversal = {}));
    var SearchPageDirection;
    (function (SearchPageDirection) {
        SearchPageDirection[SearchPageDirection["Next"] = 0] = "Next";
        SearchPageDirection[SearchPageDirection["Previous"] = 1] = "Previous";
    })(SearchPageDirection || (SearchPageDirection = {}));
    var SearchResultType;
    (function (SearchResultType) {
        SearchResultType[SearchResultType["StatisticsOnly"] = 0] = "StatisticsOnly";
        SearchResultType[SearchResultType["PreviewOnly"] = 1] = "PreviewOnly";
    })(SearchResultType || (SearchResultType = {}));
    var SendCancellationsMode;
    (function (SendCancellationsMode) {
        SendCancellationsMode[SendCancellationsMode["SendToNone"] = 0] = "SendToNone";
        SendCancellationsMode[SendCancellationsMode["SendOnlyToAll"] = 1] = "SendOnlyToAll";
        SendCancellationsMode[SendCancellationsMode["SendToAllAndSaveCopy"] = 2] = "SendToAllAndSaveCopy";
    })(SendCancellationsMode || (SendCancellationsMode = {}));
    var SendInvitationsMode;
    (function (SendInvitationsMode) {
        SendInvitationsMode[SendInvitationsMode["SendToNone"] = 0] = "SendToNone";
        SendInvitationsMode[SendInvitationsMode["SendOnlyToAll"] = 1] = "SendOnlyToAll";
        SendInvitationsMode[SendInvitationsMode["SendToAllAndSaveCopy"] = 2] = "SendToAllAndSaveCopy";
    })(SendInvitationsMode || (SendInvitationsMode = {}));
    var SendInvitationsOrCancellationsMode;
    (function (SendInvitationsOrCancellationsMode) {
        SendInvitationsOrCancellationsMode[SendInvitationsOrCancellationsMode["SendToNone"] = 0] = "SendToNone";
        SendInvitationsOrCancellationsMode[SendInvitationsOrCancellationsMode["SendOnlyToAll"] = 1] = "SendOnlyToAll";
        SendInvitationsOrCancellationsMode[SendInvitationsOrCancellationsMode["SendOnlyToChanged"] = 2] = "SendOnlyToChanged";
        SendInvitationsOrCancellationsMode[SendInvitationsOrCancellationsMode["SendToAllAndSaveCopy"] = 3] = "SendToAllAndSaveCopy";
        SendInvitationsOrCancellationsMode[SendInvitationsOrCancellationsMode["SendToChangedAndSaveCopy"] = 4] = "SendToChangedAndSaveCopy";
    })(SendInvitationsOrCancellationsMode || (SendInvitationsOrCancellationsMode = {}));
    var SendPrompt;
    (function (SendPrompt) {
        SendPrompt[SendPrompt["None"] = 0] = "None";
        SendPrompt[SendPrompt["Send"] = 1] = "Send";
        SendPrompt[SendPrompt["VotingOption"] = 2] = "VotingOption";
    })(SendPrompt || (SendPrompt = {}));
    var Sensitivity;
    (function (Sensitivity) {
        Sensitivity[Sensitivity["Normal"] = 0] = "Normal";
        Sensitivity[Sensitivity["Personal"] = 1] = "Personal";
        Sensitivity[Sensitivity["Private"] = 2] = "Private";
        Sensitivity[Sensitivity["Confidential"] = 3] = "Confidential";
    })(Sensitivity || (Sensitivity = {}));
    var ServiceError;
    (function (ServiceError) {
        ServiceError[ServiceError["NoError"] = 0] = "NoError";
        ServiceError[ServiceError["ErrorAccessDenied"] = 1] = "ErrorAccessDenied";
        ServiceError[ServiceError["ErrorAccessModeSpecified"] = 2] = "ErrorAccessModeSpecified";
        ServiceError[ServiceError["ErrorAccountDisabled"] = 3] = "ErrorAccountDisabled";
        ServiceError[ServiceError["ErrorAddDelegatesFailed"] = 4] = "ErrorAddDelegatesFailed";
        ServiceError[ServiceError["ErrorAddressSpaceNotFound"] = 5] = "ErrorAddressSpaceNotFound";
        ServiceError[ServiceError["ErrorADOperation"] = 6] = "ErrorADOperation";
        ServiceError[ServiceError["ErrorADSessionFilter"] = 7] = "ErrorADSessionFilter";
        ServiceError[ServiceError["ErrorADUnavailable"] = 8] = "ErrorADUnavailable";
        ServiceError[ServiceError["ErrorAffectedTaskOccurrencesRequired"] = 9] = "ErrorAffectedTaskOccurrencesRequired";
        ServiceError[ServiceError["ErrorApplyConversationActionFailed"] = 10] = "ErrorApplyConversationActionFailed";
        ServiceError[ServiceError["ErrorArchiveMailboxNotEnabled"] = 11] = "ErrorArchiveMailboxNotEnabled";
        ServiceError[ServiceError["ErrorArchiveFolderPathCreation"] = 12] = "ErrorArchiveFolderPathCreation";
        ServiceError[ServiceError["ErrorArchiveMailboxServiceDiscoveryFailed"] = 13] = "ErrorArchiveMailboxServiceDiscoveryFailed";
        ServiceError[ServiceError["ErrorAttachmentNestLevelLimitExceeded"] = 14] = "ErrorAttachmentNestLevelLimitExceeded";
        ServiceError[ServiceError["ErrorAttachmentSizeLimitExceeded"] = 15] = "ErrorAttachmentSizeLimitExceeded";
        ServiceError[ServiceError["ErrorAutoDiscoverFailed"] = 16] = "ErrorAutoDiscoverFailed";
        ServiceError[ServiceError["ErrorAvailabilityConfigNotFound"] = 17] = "ErrorAvailabilityConfigNotFound";
        ServiceError[ServiceError["ErrorBatchProcessingStopped"] = 18] = "ErrorBatchProcessingStopped";
        ServiceError[ServiceError["ErrorCalendarCannotMoveOrCopyOccurrence"] = 19] = "ErrorCalendarCannotMoveOrCopyOccurrence";
        ServiceError[ServiceError["ErrorCalendarCannotUpdateDeletedItem"] = 20] = "ErrorCalendarCannotUpdateDeletedItem";
        ServiceError[ServiceError["ErrorCalendarCannotUseIdForOccurrenceId"] = 21] = "ErrorCalendarCannotUseIdForOccurrenceId";
        ServiceError[ServiceError["ErrorCalendarCannotUseIdForRecurringMasterId"] = 22] = "ErrorCalendarCannotUseIdForRecurringMasterId";
        ServiceError[ServiceError["ErrorCalendarDurationIsTooLong"] = 23] = "ErrorCalendarDurationIsTooLong";
        ServiceError[ServiceError["ErrorCalendarEndDateIsEarlierThanStartDate"] = 24] = "ErrorCalendarEndDateIsEarlierThanStartDate";
        ServiceError[ServiceError["ErrorCalendarFolderIsInvalidForCalendarView"] = 25] = "ErrorCalendarFolderIsInvalidForCalendarView";
        ServiceError[ServiceError["ErrorCalendarInvalidAttributeValue"] = 26] = "ErrorCalendarInvalidAttributeValue";
        ServiceError[ServiceError["ErrorCalendarInvalidDayForTimeChangePattern"] = 27] = "ErrorCalendarInvalidDayForTimeChangePattern";
        ServiceError[ServiceError["ErrorCalendarInvalidDayForWeeklyRecurrence"] = 28] = "ErrorCalendarInvalidDayForWeeklyRecurrence";
        ServiceError[ServiceError["ErrorCalendarInvalidPropertyState"] = 29] = "ErrorCalendarInvalidPropertyState";
        ServiceError[ServiceError["ErrorCalendarInvalidPropertyValue"] = 30] = "ErrorCalendarInvalidPropertyValue";
        ServiceError[ServiceError["ErrorCalendarInvalidRecurrence"] = 31] = "ErrorCalendarInvalidRecurrence";
        ServiceError[ServiceError["ErrorCalendarInvalidTimeZone"] = 32] = "ErrorCalendarInvalidTimeZone";
        ServiceError[ServiceError["ErrorCalendarIsCancelledForAccept"] = 33] = "ErrorCalendarIsCancelledForAccept";
        ServiceError[ServiceError["ErrorCalendarIsCancelledForDecline"] = 34] = "ErrorCalendarIsCancelledForDecline";
        ServiceError[ServiceError["ErrorCalendarIsCancelledForRemove"] = 35] = "ErrorCalendarIsCancelledForRemove";
        ServiceError[ServiceError["ErrorCalendarIsCancelledForTentative"] = 36] = "ErrorCalendarIsCancelledForTentative";
        ServiceError[ServiceError["ErrorCalendarIsDelegatedForAccept"] = 37] = "ErrorCalendarIsDelegatedForAccept";
        ServiceError[ServiceError["ErrorCalendarIsDelegatedForDecline"] = 38] = "ErrorCalendarIsDelegatedForDecline";
        ServiceError[ServiceError["ErrorCalendarIsDelegatedForRemove"] = 39] = "ErrorCalendarIsDelegatedForRemove";
        ServiceError[ServiceError["ErrorCalendarIsDelegatedForTentative"] = 40] = "ErrorCalendarIsDelegatedForTentative";
        ServiceError[ServiceError["ErrorCalendarIsNotOrganizer"] = 41] = "ErrorCalendarIsNotOrganizer";
        ServiceError[ServiceError["ErrorCalendarIsOrganizerForAccept"] = 42] = "ErrorCalendarIsOrganizerForAccept";
        ServiceError[ServiceError["ErrorCalendarIsOrganizerForDecline"] = 43] = "ErrorCalendarIsOrganizerForDecline";
        ServiceError[ServiceError["ErrorCalendarIsOrganizerForRemove"] = 44] = "ErrorCalendarIsOrganizerForRemove";
        ServiceError[ServiceError["ErrorCalendarIsOrganizerForTentative"] = 45] = "ErrorCalendarIsOrganizerForTentative";
        ServiceError[ServiceError["ErrorCalendarMeetingRequestIsOutOfDate"] = 46] = "ErrorCalendarMeetingRequestIsOutOfDate";
        ServiceError[ServiceError["ErrorCalendarOccurrenceIndexIsOutOfRecurrenceRange"] = 47] = "ErrorCalendarOccurrenceIndexIsOutOfRecurrenceRange";
        ServiceError[ServiceError["ErrorCalendarOccurrenceIsDeletedFromRecurrence"] = 48] = "ErrorCalendarOccurrenceIsDeletedFromRecurrence";
        ServiceError[ServiceError["ErrorCalendarOutOfRange"] = 49] = "ErrorCalendarOutOfRange";
        ServiceError[ServiceError["ErrorCalendarViewRangeTooBig"] = 50] = "ErrorCalendarViewRangeTooBig";
        ServiceError[ServiceError["ErrorCallerIsInvalidADAccount"] = 51] = "ErrorCallerIsInvalidADAccount";
        ServiceError[ServiceError["ErrorCannotArchiveCalendarContactTaskFolderException"] = 52] = "ErrorCannotArchiveCalendarContactTaskFolderException";
        ServiceError[ServiceError["ErrorCannotArchiveItemsInArchiveMailbox"] = 53] = "ErrorCannotArchiveItemsInArchiveMailbox";
        ServiceError[ServiceError["ErrorCannotArchiveItemsInPublicFolders"] = 54] = "ErrorCannotArchiveItemsInPublicFolders";
        ServiceError[ServiceError["ErrorCannotCreateCalendarItemInNonCalendarFolder"] = 55] = "ErrorCannotCreateCalendarItemInNonCalendarFolder";
        ServiceError[ServiceError["ErrorCannotCreateContactInNonContactFolder"] = 56] = "ErrorCannotCreateContactInNonContactFolder";
        ServiceError[ServiceError["ErrorCannotCreatePostItemInNonMailFolder"] = 57] = "ErrorCannotCreatePostItemInNonMailFolder";
        ServiceError[ServiceError["ErrorCannotCreateTaskInNonTaskFolder"] = 58] = "ErrorCannotCreateTaskInNonTaskFolder";
        ServiceError[ServiceError["ErrorCannotDeleteObject"] = 59] = "ErrorCannotDeleteObject";
        ServiceError[ServiceError["ErrorCannotDeleteTaskOccurrence"] = 60] = "ErrorCannotDeleteTaskOccurrence";
        ServiceError[ServiceError["ErrorCannotDisableMandatoryExtension"] = 61] = "ErrorCannotDisableMandatoryExtension";
        ServiceError[ServiceError["ErrorCannotEmptyFolder"] = 62] = "ErrorCannotEmptyFolder";
        ServiceError[ServiceError["ErrorCannotGetExternalEcpUrl"] = 63] = "ErrorCannotGetExternalEcpUrl";
        ServiceError[ServiceError["ErrorCannotGetSourceFolderPath"] = 64] = "ErrorCannotGetSourceFolderPath";
        ServiceError[ServiceError["ErrorCannotOpenFileAttachment"] = 65] = "ErrorCannotOpenFileAttachment";
        ServiceError[ServiceError["ErrorCannotSetCalendarPermissionOnNonCalendarFolder"] = 66] = "ErrorCannotSetCalendarPermissionOnNonCalendarFolder";
        ServiceError[ServiceError["ErrorCannotSetNonCalendarPermissionOnCalendarFolder"] = 67] = "ErrorCannotSetNonCalendarPermissionOnCalendarFolder";
        ServiceError[ServiceError["ErrorCannotSetPermissionUnknownEntries"] = 68] = "ErrorCannotSetPermissionUnknownEntries";
        ServiceError[ServiceError["ErrorCannotSpecifySearchFolderAsSourceFolder"] = 69] = "ErrorCannotSpecifySearchFolderAsSourceFolder";
        ServiceError[ServiceError["ErrorCannotUseFolderIdForItemId"] = 70] = "ErrorCannotUseFolderIdForItemId";
        ServiceError[ServiceError["ErrorCannotUseItemIdForFolderId"] = 71] = "ErrorCannotUseItemIdForFolderId";
        ServiceError[ServiceError["ErrorChangeKeyRequired"] = 72] = "ErrorChangeKeyRequired";
        ServiceError[ServiceError["ErrorChangeKeyRequiredForWriteOperations"] = 73] = "ErrorChangeKeyRequiredForWriteOperations";
        ServiceError[ServiceError["ErrorClientDisconnected"] = 74] = "ErrorClientDisconnected";
        ServiceError[ServiceError["ErrorConnectionFailed"] = 75] = "ErrorConnectionFailed";
        ServiceError[ServiceError["ErrorContainsFilterWrongType"] = 76] = "ErrorContainsFilterWrongType";
        ServiceError[ServiceError["ErrorContentConversionFailed"] = 77] = "ErrorContentConversionFailed";
        ServiceError[ServiceError["ErrorCorruptData"] = 78] = "ErrorCorruptData";
        ServiceError[ServiceError["ErrorCreateItemAccessDenied"] = 79] = "ErrorCreateItemAccessDenied";
        ServiceError[ServiceError["ErrorCreateManagedFolderPartialCompletion"] = 80] = "ErrorCreateManagedFolderPartialCompletion";
        ServiceError[ServiceError["ErrorCreateSubfolderAccessDenied"] = 81] = "ErrorCreateSubfolderAccessDenied";
        ServiceError[ServiceError["ErrorCrossMailboxMoveCopy"] = 82] = "ErrorCrossMailboxMoveCopy";
        ServiceError[ServiceError["ErrorCrossSiteRequest"] = 83] = "ErrorCrossSiteRequest";
        ServiceError[ServiceError["ErrorDataSizeLimitExceeded"] = 84] = "ErrorDataSizeLimitExceeded";
        ServiceError[ServiceError["ErrorDataSourceOperation"] = 85] = "ErrorDataSourceOperation";
        ServiceError[ServiceError["ErrorDelegateAlreadyExists"] = 86] = "ErrorDelegateAlreadyExists";
        ServiceError[ServiceError["ErrorDelegateCannotAddOwner"] = 87] = "ErrorDelegateCannotAddOwner";
        ServiceError[ServiceError["ErrorDelegateMissingConfiguration"] = 88] = "ErrorDelegateMissingConfiguration";
        ServiceError[ServiceError["ErrorDelegateNoUser"] = 89] = "ErrorDelegateNoUser";
        ServiceError[ServiceError["ErrorDelegateValidationFailed"] = 90] = "ErrorDelegateValidationFailed";
        ServiceError[ServiceError["ErrorDeleteDistinguishedFolder"] = 91] = "ErrorDeleteDistinguishedFolder";
        ServiceError[ServiceError["ErrorDeleteItemsFailed"] = 92] = "ErrorDeleteItemsFailed";
        ServiceError[ServiceError["ErrorDistinguishedUserNotSupported"] = 93] = "ErrorDistinguishedUserNotSupported";
        ServiceError[ServiceError["ErrorDistributionListMemberNotExist"] = 94] = "ErrorDistributionListMemberNotExist";
        ServiceError[ServiceError["ErrorDuplicateInputFolderNames"] = 95] = "ErrorDuplicateInputFolderNames";
        ServiceError[ServiceError["ErrorDuplicateLegacyDistinguishedName"] = 96] = "ErrorDuplicateLegacyDistinguishedName";
        ServiceError[ServiceError["ErrorDuplicateSOAPHeader"] = 97] = "ErrorDuplicateSOAPHeader";
        ServiceError[ServiceError["ErrorDuplicateUserIdsSpecified"] = 98] = "ErrorDuplicateUserIdsSpecified";
        ServiceError[ServiceError["ErrorEmailAddressMismatch"] = 99] = "ErrorEmailAddressMismatch";
        ServiceError[ServiceError["ErrorEventNotFound"] = 100] = "ErrorEventNotFound";
        ServiceError[ServiceError["ErrorExceededConnectionCount"] = 101] = "ErrorExceededConnectionCount";
        ServiceError[ServiceError["ErrorExceededFindCountLimit"] = 102] = "ErrorExceededFindCountLimit";
        ServiceError[ServiceError["ErrorExceededSubscriptionCount"] = 103] = "ErrorExceededSubscriptionCount";
        ServiceError[ServiceError["ErrorExpiredSubscription"] = 104] = "ErrorExpiredSubscription";
        ServiceError[ServiceError["ErrorExtensionNotFound"] = 105] = "ErrorExtensionNotFound";
        ServiceError[ServiceError["ErrorFolderCorrupt"] = 106] = "ErrorFolderCorrupt";
        ServiceError[ServiceError["ErrorFolderExists"] = 107] = "ErrorFolderExists";
        ServiceError[ServiceError["ErrorFolderNotFound"] = 108] = "ErrorFolderNotFound";
        ServiceError[ServiceError["ErrorFolderPropertRequestFailed"] = 109] = "ErrorFolderPropertRequestFailed";
        ServiceError[ServiceError["ErrorFolderSave"] = 110] = "ErrorFolderSave";
        ServiceError[ServiceError["ErrorFolderSaveFailed"] = 111] = "ErrorFolderSaveFailed";
        ServiceError[ServiceError["ErrorFolderSavePropertyError"] = 112] = "ErrorFolderSavePropertyError";
        ServiceError[ServiceError["ErrorFreeBusyDLLimitReached"] = 113] = "ErrorFreeBusyDLLimitReached";
        ServiceError[ServiceError["ErrorFreeBusyGenerationFailed"] = 114] = "ErrorFreeBusyGenerationFailed";
        ServiceError[ServiceError["ErrorGetServerSecurityDescriptorFailed"] = 115] = "ErrorGetServerSecurityDescriptorFailed";
        ServiceError[ServiceError["ErrorImContactLimitReached"] = 116] = "ErrorImContactLimitReached";
        ServiceError[ServiceError["ErrorImGroupDisplayNameAlreadyExists"] = 117] = "ErrorImGroupDisplayNameAlreadyExists";
        ServiceError[ServiceError["ErrorImGroupLimitReached"] = 118] = "ErrorImGroupLimitReached";
        ServiceError[ServiceError["ErrorImpersonateUserDenied"] = 119] = "ErrorImpersonateUserDenied";
        ServiceError[ServiceError["ErrorImpersonationDenied"] = 120] = "ErrorImpersonationDenied";
        ServiceError[ServiceError["ErrorImpersonationFailed"] = 121] = "ErrorImpersonationFailed";
        ServiceError[ServiceError["ErrorInboxRulesValidationError"] = 122] = "ErrorInboxRulesValidationError";
        ServiceError[ServiceError["ErrorIncorrectSchemaVersion"] = 123] = "ErrorIncorrectSchemaVersion";
        ServiceError[ServiceError["ErrorIncorrectUpdatePropertyCount"] = 124] = "ErrorIncorrectUpdatePropertyCount";
        ServiceError[ServiceError["ErrorIndividualMailboxLimitReached"] = 125] = "ErrorIndividualMailboxLimitReached";
        ServiceError[ServiceError["ErrorInsufficientResources"] = 126] = "ErrorInsufficientResources";
        ServiceError[ServiceError["ErrorInternalServerError"] = 127] = "ErrorInternalServerError";
        ServiceError[ServiceError["ErrorInternalServerTransientError"] = 128] = "ErrorInternalServerTransientError";
        ServiceError[ServiceError["ErrorInvalidAccessLevel"] = 129] = "ErrorInvalidAccessLevel";
        ServiceError[ServiceError["ErrorInvalidArgument"] = 130] = "ErrorInvalidArgument";
        ServiceError[ServiceError["ErrorInvalidAttachmentId"] = 131] = "ErrorInvalidAttachmentId";
        ServiceError[ServiceError["ErrorInvalidAttachmentSubfilter"] = 132] = "ErrorInvalidAttachmentSubfilter";
        ServiceError[ServiceError["ErrorInvalidAttachmentSubfilterTextFilter"] = 133] = "ErrorInvalidAttachmentSubfilterTextFilter";
        ServiceError[ServiceError["ErrorInvalidAuthorizationContext"] = 134] = "ErrorInvalidAuthorizationContext";
        ServiceError[ServiceError["ErrorInvalidChangeKey"] = 135] = "ErrorInvalidChangeKey";
        ServiceError[ServiceError["ErrorInvalidClientSecurityContext"] = 136] = "ErrorInvalidClientSecurityContext";
        ServiceError[ServiceError["ErrorInvalidCompleteDate"] = 137] = "ErrorInvalidCompleteDate";
        ServiceError[ServiceError["ErrorInvalidContactEmailAddress"] = 138] = "ErrorInvalidContactEmailAddress";
        ServiceError[ServiceError["ErrorInvalidContactEmailIndex"] = 139] = "ErrorInvalidContactEmailIndex";
        ServiceError[ServiceError["ErrorInvalidCrossForestCredentials"] = 140] = "ErrorInvalidCrossForestCredentials";
        ServiceError[ServiceError["ErrorInvalidDelegatePermission"] = 141] = "ErrorInvalidDelegatePermission";
        ServiceError[ServiceError["ErrorInvalidDelegateUserId"] = 142] = "ErrorInvalidDelegateUserId";
        ServiceError[ServiceError["ErrorInvalidExchangeImpersonationHeaderData"] = 143] = "ErrorInvalidExchangeImpersonationHeaderData";
        ServiceError[ServiceError["ErrorInvalidExcludesRestriction"] = 144] = "ErrorInvalidExcludesRestriction";
        ServiceError[ServiceError["ErrorInvalidExpressionTypeForSubFilter"] = 145] = "ErrorInvalidExpressionTypeForSubFilter";
        ServiceError[ServiceError["ErrorInvalidExtendedProperty"] = 146] = "ErrorInvalidExtendedProperty";
        ServiceError[ServiceError["ErrorInvalidExtendedPropertyValue"] = 147] = "ErrorInvalidExtendedPropertyValue";
        ServiceError[ServiceError["ErrorInvalidExternalSharingInitiator"] = 148] = "ErrorInvalidExternalSharingInitiator";
        ServiceError[ServiceError["ErrorInvalidExternalSharingSubscriber"] = 149] = "ErrorInvalidExternalSharingSubscriber";
        ServiceError[ServiceError["ErrorInvalidFederatedOrganizationId"] = 150] = "ErrorInvalidFederatedOrganizationId";
        ServiceError[ServiceError["ErrorInvalidFolderId"] = 151] = "ErrorInvalidFolderId";
        ServiceError[ServiceError["ErrorInvalidFolderTypeForOperation"] = 152] = "ErrorInvalidFolderTypeForOperation";
        ServiceError[ServiceError["ErrorInvalidFractionalPagingParameters"] = 153] = "ErrorInvalidFractionalPagingParameters";
        ServiceError[ServiceError["ErrorInvalidFreeBusyViewType"] = 154] = "ErrorInvalidFreeBusyViewType";
        ServiceError[ServiceError["ErrorInvalidGetSharingFolderRequest"] = 155] = "ErrorInvalidGetSharingFolderRequest";
        ServiceError[ServiceError["ErrorInvalidId"] = 156] = "ErrorInvalidId";
        ServiceError[ServiceError["ErrorInvalidImContactId"] = 157] = "ErrorInvalidImContactId";
        ServiceError[ServiceError["ErrorInvalidImDistributionGroupSmtpAddress"] = 158] = "ErrorInvalidImDistributionGroupSmtpAddress";
        ServiceError[ServiceError["ErrorInvalidImGroupId"] = 159] = "ErrorInvalidImGroupId";
        ServiceError[ServiceError["ErrorInvalidIdEmpty"] = 160] = "ErrorInvalidIdEmpty";
        ServiceError[ServiceError["ErrorInvalidIdMalformed"] = 161] = "ErrorInvalidIdMalformed";
        ServiceError[ServiceError["ErrorInvalidIdMalformedEwsLegacyIdFormat"] = 162] = "ErrorInvalidIdMalformedEwsLegacyIdFormat";
        ServiceError[ServiceError["ErrorInvalidIdMonikerTooLong"] = 163] = "ErrorInvalidIdMonikerTooLong";
        ServiceError[ServiceError["ErrorInvalidIdNotAnItemAttachmentId"] = 164] = "ErrorInvalidIdNotAnItemAttachmentId";
        ServiceError[ServiceError["ErrorInvalidIdReturnedByResolveNames"] = 165] = "ErrorInvalidIdReturnedByResolveNames";
        ServiceError[ServiceError["ErrorInvalidIdStoreObjectIdTooLong"] = 166] = "ErrorInvalidIdStoreObjectIdTooLong";
        ServiceError[ServiceError["ErrorInvalidIdTooManyAttachmentLevels"] = 167] = "ErrorInvalidIdTooManyAttachmentLevels";
        ServiceError[ServiceError["ErrorInvalidIdXml"] = 168] = "ErrorInvalidIdXml";
        ServiceError[ServiceError["ErrorInvalidIndexedPagingParameters"] = 169] = "ErrorInvalidIndexedPagingParameters";
        ServiceError[ServiceError["ErrorInvalidInternetHeaderChildNodes"] = 170] = "ErrorInvalidInternetHeaderChildNodes";
        ServiceError[ServiceError["ErrorInvalidItemForOperationAcceptItem"] = 171] = "ErrorInvalidItemForOperationAcceptItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationArchiveItem"] = 172] = "ErrorInvalidItemForOperationArchiveItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationCancelItem"] = 173] = "ErrorInvalidItemForOperationCancelItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationCreateItem"] = 174] = "ErrorInvalidItemForOperationCreateItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationCreateItemAttachment"] = 175] = "ErrorInvalidItemForOperationCreateItemAttachment";
        ServiceError[ServiceError["ErrorInvalidItemForOperationDeclineItem"] = 176] = "ErrorInvalidItemForOperationDeclineItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationExpandDL"] = 177] = "ErrorInvalidItemForOperationExpandDL";
        ServiceError[ServiceError["ErrorInvalidItemForOperationRemoveItem"] = 178] = "ErrorInvalidItemForOperationRemoveItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationSendItem"] = 179] = "ErrorInvalidItemForOperationSendItem";
        ServiceError[ServiceError["ErrorInvalidItemForOperationTentative"] = 180] = "ErrorInvalidItemForOperationTentative";
        ServiceError[ServiceError["ErrorInvalidLogonType"] = 181] = "ErrorInvalidLogonType";
        ServiceError[ServiceError["ErrorInvalidMailbox"] = 182] = "ErrorInvalidMailbox";
        ServiceError[ServiceError["ErrorInvalidManagedFolderProperty"] = 183] = "ErrorInvalidManagedFolderProperty";
        ServiceError[ServiceError["ErrorInvalidManagedFolderQuota"] = 184] = "ErrorInvalidManagedFolderQuota";
        ServiceError[ServiceError["ErrorInvalidManagedFolderSize"] = 185] = "ErrorInvalidManagedFolderSize";
        ServiceError[ServiceError["ErrorInvalidMergedFreeBusyInterval"] = 186] = "ErrorInvalidMergedFreeBusyInterval";
        ServiceError[ServiceError["ErrorInvalidNameForNameResolution"] = 187] = "ErrorInvalidNameForNameResolution";
        ServiceError[ServiceError["ErrorInvalidNetworkServiceContext"] = 188] = "ErrorInvalidNetworkServiceContext";
        ServiceError[ServiceError["ErrorInvalidOofParameter"] = 189] = "ErrorInvalidOofParameter";
        ServiceError[ServiceError["ErrorInvalidOperation"] = 190] = "ErrorInvalidOperation";
        ServiceError[ServiceError["ErrorInvalidOrganizationRelationshipForFreeBusy"] = 191] = "ErrorInvalidOrganizationRelationshipForFreeBusy";
        ServiceError[ServiceError["ErrorInvalidPagingMaxRows"] = 192] = "ErrorInvalidPagingMaxRows";
        ServiceError[ServiceError["ErrorInvalidParentFolder"] = 193] = "ErrorInvalidParentFolder";
        ServiceError[ServiceError["ErrorInvalidPercentCompleteValue"] = 194] = "ErrorInvalidPercentCompleteValue";
        ServiceError[ServiceError["ErrorInvalidPermissionSettings"] = 195] = "ErrorInvalidPermissionSettings";
        ServiceError[ServiceError["ErrorInvalidPhoneCallId"] = 196] = "ErrorInvalidPhoneCallId";
        ServiceError[ServiceError["ErrorInvalidPhoneNumber"] = 197] = "ErrorInvalidPhoneNumber";
        ServiceError[ServiceError["ErrorInvalidPropertyAppend"] = 198] = "ErrorInvalidPropertyAppend";
        ServiceError[ServiceError["ErrorInvalidPropertyDelete"] = 199] = "ErrorInvalidPropertyDelete";
        ServiceError[ServiceError["ErrorInvalidPropertyForExists"] = 200] = "ErrorInvalidPropertyForExists";
        ServiceError[ServiceError["ErrorInvalidPropertyForOperation"] = 201] = "ErrorInvalidPropertyForOperation";
        ServiceError[ServiceError["ErrorInvalidPropertyRequest"] = 202] = "ErrorInvalidPropertyRequest";
        ServiceError[ServiceError["ErrorInvalidPropertySet"] = 203] = "ErrorInvalidPropertySet";
        ServiceError[ServiceError["ErrorInvalidPropertyUpdateSentMessage"] = 204] = "ErrorInvalidPropertyUpdateSentMessage";
        ServiceError[ServiceError["ErrorInvalidProxySecurityContext"] = 205] = "ErrorInvalidProxySecurityContext";
        ServiceError[ServiceError["ErrorInvalidPullSubscriptionId"] = 206] = "ErrorInvalidPullSubscriptionId";
        ServiceError[ServiceError["ErrorInvalidPushSubscriptionUrl"] = 207] = "ErrorInvalidPushSubscriptionUrl";
        ServiceError[ServiceError["ErrorInvalidRecipients"] = 208] = "ErrorInvalidRecipients";
        ServiceError[ServiceError["ErrorInvalidRecipientSubfilter"] = 209] = "ErrorInvalidRecipientSubfilter";
        ServiceError[ServiceError["ErrorInvalidRecipientSubfilterComparison"] = 210] = "ErrorInvalidRecipientSubfilterComparison";
        ServiceError[ServiceError["ErrorInvalidRecipientSubfilterOrder"] = 211] = "ErrorInvalidRecipientSubfilterOrder";
        ServiceError[ServiceError["ErrorInvalidRecipientSubfilterTextFilter"] = 212] = "ErrorInvalidRecipientSubfilterTextFilter";
        ServiceError[ServiceError["ErrorInvalidReferenceItem"] = 213] = "ErrorInvalidReferenceItem";
        ServiceError[ServiceError["ErrorInvalidRequest"] = 214] = "ErrorInvalidRequest";
        ServiceError[ServiceError["ErrorInvalidRestriction"] = 215] = "ErrorInvalidRestriction";
        ServiceError[ServiceError["ErrorInvalidRetentionTagTypeMismatch"] = 216] = "ErrorInvalidRetentionTagTypeMismatch";
        ServiceError[ServiceError["ErrorInvalidRetentionTagInvisible"] = 217] = "ErrorInvalidRetentionTagInvisible";
        ServiceError[ServiceError["ErrorInvalidRetentionTagInheritance"] = 218] = "ErrorInvalidRetentionTagInheritance";
        ServiceError[ServiceError["ErrorInvalidRetentionTagIdGuid"] = 219] = "ErrorInvalidRetentionTagIdGuid";
        ServiceError[ServiceError["ErrorInvalidRoutingType"] = 220] = "ErrorInvalidRoutingType";
        ServiceError[ServiceError["ErrorInvalidScheduledOofDuration"] = 221] = "ErrorInvalidScheduledOofDuration";
        ServiceError[ServiceError["ErrorInvalidSchemaVersionForMailboxVersion"] = 222] = "ErrorInvalidSchemaVersionForMailboxVersion";
        ServiceError[ServiceError["ErrorInvalidSecurityDescriptor"] = 223] = "ErrorInvalidSecurityDescriptor";
        ServiceError[ServiceError["ErrorInvalidSendItemSaveSettings"] = 224] = "ErrorInvalidSendItemSaveSettings";
        ServiceError[ServiceError["ErrorInvalidSerializedAccessToken"] = 225] = "ErrorInvalidSerializedAccessToken";
        ServiceError[ServiceError["ErrorInvalidServerVersion"] = 226] = "ErrorInvalidServerVersion";
        ServiceError[ServiceError["ErrorInvalidSharingData"] = 227] = "ErrorInvalidSharingData";
        ServiceError[ServiceError["ErrorInvalidSharingMessage"] = 228] = "ErrorInvalidSharingMessage";
        ServiceError[ServiceError["ErrorInvalidSid"] = 229] = "ErrorInvalidSid";
        ServiceError[ServiceError["ErrorInvalidSIPUri"] = 230] = "ErrorInvalidSIPUri";
        ServiceError[ServiceError["ErrorInvalidSmtpAddress"] = 231] = "ErrorInvalidSmtpAddress";
        ServiceError[ServiceError["ErrorInvalidSubfilterType"] = 232] = "ErrorInvalidSubfilterType";
        ServiceError[ServiceError["ErrorInvalidSubfilterTypeNotAttendeeType"] = 233] = "ErrorInvalidSubfilterTypeNotAttendeeType";
        ServiceError[ServiceError["ErrorInvalidSubfilterTypeNotRecipientType"] = 234] = "ErrorInvalidSubfilterTypeNotRecipientType";
        ServiceError[ServiceError["ErrorInvalidSubscription"] = 235] = "ErrorInvalidSubscription";
        ServiceError[ServiceError["ErrorInvalidSubscriptionRequest"] = 236] = "ErrorInvalidSubscriptionRequest";
        ServiceError[ServiceError["ErrorInvalidSyncStateData"] = 237] = "ErrorInvalidSyncStateData";
        ServiceError[ServiceError["ErrorInvalidTimeInterval"] = 238] = "ErrorInvalidTimeInterval";
        ServiceError[ServiceError["ErrorInvalidUserInfo"] = 239] = "ErrorInvalidUserInfo";
        ServiceError[ServiceError["ErrorInvalidUserOofSettings"] = 240] = "ErrorInvalidUserOofSettings";
        ServiceError[ServiceError["ErrorInvalidUserPrincipalName"] = 241] = "ErrorInvalidUserPrincipalName";
        ServiceError[ServiceError["ErrorInvalidUserSid"] = 242] = "ErrorInvalidUserSid";
        ServiceError[ServiceError["ErrorInvalidUserSidMissingUPN"] = 243] = "ErrorInvalidUserSidMissingUPN";
        ServiceError[ServiceError["ErrorInvalidValueForProperty"] = 244] = "ErrorInvalidValueForProperty";
        ServiceError[ServiceError["ErrorInvalidWatermark"] = 245] = "ErrorInvalidWatermark";
        ServiceError[ServiceError["ErrorIPGatewayNotFound"] = 246] = "ErrorIPGatewayNotFound";
        ServiceError[ServiceError["ErrorIrresolvableConflict"] = 247] = "ErrorIrresolvableConflict";
        ServiceError[ServiceError["ErrorItemCorrupt"] = 248] = "ErrorItemCorrupt";
        ServiceError[ServiceError["ErrorItemNotFound"] = 249] = "ErrorItemNotFound";
        ServiceError[ServiceError["ErrorItemPropertyRequestFailed"] = 250] = "ErrorItemPropertyRequestFailed";
        ServiceError[ServiceError["ErrorItemSave"] = 251] = "ErrorItemSave";
        ServiceError[ServiceError["ErrorItemSavePropertyError"] = 252] = "ErrorItemSavePropertyError";
        ServiceError[ServiceError["ErrorLegacyMailboxFreeBusyViewTypeNotMerged"] = 253] = "ErrorLegacyMailboxFreeBusyViewTypeNotMerged";
        ServiceError[ServiceError["ErrorLocalServerObjectNotFound"] = 254] = "ErrorLocalServerObjectNotFound";
        ServiceError[ServiceError["ErrorLogonAsNetworkServiceFailed"] = 255] = "ErrorLogonAsNetworkServiceFailed";
        ServiceError[ServiceError["ErrorMailboxConfiguration"] = 256] = "ErrorMailboxConfiguration";
        ServiceError[ServiceError["ErrorMailboxDataArrayEmpty"] = 257] = "ErrorMailboxDataArrayEmpty";
        ServiceError[ServiceError["ErrorMailboxDataArrayTooBig"] = 258] = "ErrorMailboxDataArrayTooBig";
        ServiceError[ServiceError["ErrorMailboxFailover"] = 259] = "ErrorMailboxFailover";
        ServiceError[ServiceError["ErrorMailboxHoldNotFound"] = 260] = "ErrorMailboxHoldNotFound";
        ServiceError[ServiceError["ErrorMailboxLogonFailed"] = 261] = "ErrorMailboxLogonFailed";
        ServiceError[ServiceError["ErrorMailboxMoveInProgress"] = 262] = "ErrorMailboxMoveInProgress";
        ServiceError[ServiceError["ErrorMailboxStoreUnavailable"] = 263] = "ErrorMailboxStoreUnavailable";
        ServiceError[ServiceError["ErrorMailRecipientNotFound"] = 264] = "ErrorMailRecipientNotFound";
        ServiceError[ServiceError["ErrorMailTipsDisabled"] = 265] = "ErrorMailTipsDisabled";
        ServiceError[ServiceError["ErrorManagedFolderAlreadyExists"] = 266] = "ErrorManagedFolderAlreadyExists";
        ServiceError[ServiceError["ErrorManagedFolderNotFound"] = 267] = "ErrorManagedFolderNotFound";
        ServiceError[ServiceError["ErrorManagedFoldersRootFailure"] = 268] = "ErrorManagedFoldersRootFailure";
        ServiceError[ServiceError["ErrorMeetingSuggestionGenerationFailed"] = 269] = "ErrorMeetingSuggestionGenerationFailed";
        ServiceError[ServiceError["ErrorMessageDispositionRequired"] = 270] = "ErrorMessageDispositionRequired";
        ServiceError[ServiceError["ErrorMessageSizeExceeded"] = 271] = "ErrorMessageSizeExceeded";
        ServiceError[ServiceError["ErrorMessageTrackingNoSuchDomain"] = 272] = "ErrorMessageTrackingNoSuchDomain";
        ServiceError[ServiceError["ErrorMessageTrackingPermanentError"] = 273] = "ErrorMessageTrackingPermanentError";
        ServiceError[ServiceError["ErrorMessageTrackingTransientError"] = 274] = "ErrorMessageTrackingTransientError";
        ServiceError[ServiceError["ErrorMimeContentConversionFailed"] = 275] = "ErrorMimeContentConversionFailed";
        ServiceError[ServiceError["ErrorMimeContentInvalid"] = 276] = "ErrorMimeContentInvalid";
        ServiceError[ServiceError["ErrorMimeContentInvalidBase64String"] = 277] = "ErrorMimeContentInvalidBase64String";
        ServiceError[ServiceError["ErrorMissedNotificationEvents"] = 278] = "ErrorMissedNotificationEvents";
        ServiceError[ServiceError["ErrorMissingArgument"] = 279] = "ErrorMissingArgument";
        ServiceError[ServiceError["ErrorMissingEmailAddress"] = 280] = "ErrorMissingEmailAddress";
        ServiceError[ServiceError["ErrorMissingEmailAddressForManagedFolder"] = 281] = "ErrorMissingEmailAddressForManagedFolder";
        ServiceError[ServiceError["ErrorMissingInformationEmailAddress"] = 282] = "ErrorMissingInformationEmailAddress";
        ServiceError[ServiceError["ErrorMissingInformationReferenceItemId"] = 283] = "ErrorMissingInformationReferenceItemId";
        ServiceError[ServiceError["ErrorMissingInformationSharingFolderId"] = 284] = "ErrorMissingInformationSharingFolderId";
        ServiceError[ServiceError["ErrorMissingItemForCreateItemAttachment"] = 285] = "ErrorMissingItemForCreateItemAttachment";
        ServiceError[ServiceError["ErrorMissingManagedFolderId"] = 286] = "ErrorMissingManagedFolderId";
        ServiceError[ServiceError["ErrorMissingRecipients"] = 287] = "ErrorMissingRecipients";
        ServiceError[ServiceError["ErrorMissingUserIdInformation"] = 288] = "ErrorMissingUserIdInformation";
        ServiceError[ServiceError["ErrorMoreThanOneAccessModeSpecified"] = 289] = "ErrorMoreThanOneAccessModeSpecified";
        ServiceError[ServiceError["ErrorMoveCopyFailed"] = 290] = "ErrorMoveCopyFailed";
        ServiceError[ServiceError["ErrorMoveDistinguishedFolder"] = 291] = "ErrorMoveDistinguishedFolder";
        ServiceError[ServiceError["ErrorMultiLegacyMailboxAccess"] = 292] = "ErrorMultiLegacyMailboxAccess";
        ServiceError[ServiceError["ErrorNameResolutionMultipleResults"] = 293] = "ErrorNameResolutionMultipleResults";
        ServiceError[ServiceError["ErrorNameResolutionNoMailbox"] = 294] = "ErrorNameResolutionNoMailbox";
        ServiceError[ServiceError["ErrorNameResolutionNoResults"] = 295] = "ErrorNameResolutionNoResults";
        ServiceError[ServiceError["ErrorNewEventStreamConnectionOpened"] = 296] = "ErrorNewEventStreamConnectionOpened";
        ServiceError[ServiceError["ErrorNoApplicableProxyCASServersAvailable"] = 297] = "ErrorNoApplicableProxyCASServersAvailable";
        ServiceError[ServiceError["ErrorNoCalendar"] = 298] = "ErrorNoCalendar";
        ServiceError[ServiceError["ErrorNoDestinationCASDueToKerberosRequirements"] = 299] = "ErrorNoDestinationCASDueToKerberosRequirements";
        ServiceError[ServiceError["ErrorNoDestinationCASDueToSSLRequirements"] = 300] = "ErrorNoDestinationCASDueToSSLRequirements";
        ServiceError[ServiceError["ErrorNoDestinationCASDueToVersionMismatch"] = 301] = "ErrorNoDestinationCASDueToVersionMismatch";
        ServiceError[ServiceError["ErrorNoFolderClassOverride"] = 302] = "ErrorNoFolderClassOverride";
        ServiceError[ServiceError["ErrorNoFreeBusyAccess"] = 303] = "ErrorNoFreeBusyAccess";
        ServiceError[ServiceError["ErrorNonExistentMailbox"] = 304] = "ErrorNonExistentMailbox";
        ServiceError[ServiceError["ErrorNonPrimarySmtpAddress"] = 305] = "ErrorNonPrimarySmtpAddress";
        ServiceError[ServiceError["ErrorNoPropertyTagForCustomProperties"] = 306] = "ErrorNoPropertyTagForCustomProperties";
        ServiceError[ServiceError["ErrorNoPublicFolderReplicaAvailable"] = 307] = "ErrorNoPublicFolderReplicaAvailable";
        ServiceError[ServiceError["ErrorNoPublicFolderServerAvailable"] = 308] = "ErrorNoPublicFolderServerAvailable";
        ServiceError[ServiceError["ErrorNoRespondingCASInDestinationSite"] = 309] = "ErrorNoRespondingCASInDestinationSite";
        ServiceError[ServiceError["ErrorNotAllowedExternalSharingByPolicy"] = 310] = "ErrorNotAllowedExternalSharingByPolicy";
        ServiceError[ServiceError["ErrorNotDelegate"] = 311] = "ErrorNotDelegate";
        ServiceError[ServiceError["ErrorNotEnoughMemory"] = 312] = "ErrorNotEnoughMemory";
        ServiceError[ServiceError["ErrorNotSupportedSharingMessage"] = 313] = "ErrorNotSupportedSharingMessage";
        ServiceError[ServiceError["ErrorObjectTypeChanged"] = 314] = "ErrorObjectTypeChanged";
        ServiceError[ServiceError["ErrorOccurrenceCrossingBoundary"] = 315] = "ErrorOccurrenceCrossingBoundary";
        ServiceError[ServiceError["ErrorOccurrenceTimeSpanTooBig"] = 316] = "ErrorOccurrenceTimeSpanTooBig";
        ServiceError[ServiceError["ErrorOperationNotAllowedWithPublicFolderRoot"] = 317] = "ErrorOperationNotAllowedWithPublicFolderRoot";
        ServiceError[ServiceError["ErrorOrganizationNotFederated"] = 318] = "ErrorOrganizationNotFederated";
        ServiceError[ServiceError["ErrorOutlookRuleBlobExists"] = 319] = "ErrorOutlookRuleBlobExists";
        ServiceError[ServiceError["ErrorParentFolderIdRequired"] = 320] = "ErrorParentFolderIdRequired";
        ServiceError[ServiceError["ErrorParentFolderNotFound"] = 321] = "ErrorParentFolderNotFound";
        ServiceError[ServiceError["ErrorPasswordChangeRequired"] = 322] = "ErrorPasswordChangeRequired";
        ServiceError[ServiceError["ErrorPasswordExpired"] = 323] = "ErrorPasswordExpired";
        ServiceError[ServiceError["ErrorPermissionNotAllowedByPolicy"] = 324] = "ErrorPermissionNotAllowedByPolicy";
        ServiceError[ServiceError["ErrorPhoneNumberNotDialable"] = 325] = "ErrorPhoneNumberNotDialable";
        ServiceError[ServiceError["ErrorPropertyUpdate"] = 326] = "ErrorPropertyUpdate";
        ServiceError[ServiceError["ErrorPropertyValidationFailure"] = 327] = "ErrorPropertyValidationFailure";
        ServiceError[ServiceError["ErrorProxiedSubscriptionCallFailure"] = 328] = "ErrorProxiedSubscriptionCallFailure";
        ServiceError[ServiceError["ErrorProxyCallFailed"] = 329] = "ErrorProxyCallFailed";
        ServiceError[ServiceError["ErrorProxyGroupSidLimitExceeded"] = 330] = "ErrorProxyGroupSidLimitExceeded";
        ServiceError[ServiceError["ErrorProxyRequestNotAllowed"] = 331] = "ErrorProxyRequestNotAllowed";
        ServiceError[ServiceError["ErrorProxyRequestProcessingFailed"] = 332] = "ErrorProxyRequestProcessingFailed";
        ServiceError[ServiceError["ErrorProxyServiceDiscoveryFailed"] = 333] = "ErrorProxyServiceDiscoveryFailed";
        ServiceError[ServiceError["ErrorProxyTokenExpired"] = 334] = "ErrorProxyTokenExpired";
        ServiceError[ServiceError["ErrorPublicFolderRequestProcessingFailed"] = 335] = "ErrorPublicFolderRequestProcessingFailed";
        ServiceError[ServiceError["ErrorPublicFolderServerNotFound"] = 336] = "ErrorPublicFolderServerNotFound";
        ServiceError[ServiceError["ErrorQueryFilterTooLong"] = 337] = "ErrorQueryFilterTooLong";
        ServiceError[ServiceError["ErrorQuotaExceeded"] = 338] = "ErrorQuotaExceeded";
        ServiceError[ServiceError["ErrorReadEventsFailed"] = 339] = "ErrorReadEventsFailed";
        ServiceError[ServiceError["ErrorReadReceiptNotPending"] = 340] = "ErrorReadReceiptNotPending";
        ServiceError[ServiceError["ErrorRecurrenceEndDateTooBig"] = 341] = "ErrorRecurrenceEndDateTooBig";
        ServiceError[ServiceError["ErrorRecurrenceHasNoOccurrence"] = 342] = "ErrorRecurrenceHasNoOccurrence";
        ServiceError[ServiceError["ErrorRemoveDelegatesFailed"] = 343] = "ErrorRemoveDelegatesFailed";
        ServiceError[ServiceError["ErrorRequestAborted"] = 344] = "ErrorRequestAborted";
        ServiceError[ServiceError["ErrorRequestStreamTooBig"] = 345] = "ErrorRequestStreamTooBig";
        ServiceError[ServiceError["ErrorRequiredPropertyMissing"] = 346] = "ErrorRequiredPropertyMissing";
        ServiceError[ServiceError["ErrorResolveNamesInvalidFolderType"] = 347] = "ErrorResolveNamesInvalidFolderType";
        ServiceError[ServiceError["ErrorResolveNamesOnlyOneContactsFolderAllowed"] = 348] = "ErrorResolveNamesOnlyOneContactsFolderAllowed";
        ServiceError[ServiceError["ErrorResponseSchemaValidation"] = 349] = "ErrorResponseSchemaValidation";
        ServiceError[ServiceError["ErrorRestrictionTooComplex"] = 350] = "ErrorRestrictionTooComplex";
        ServiceError[ServiceError["ErrorRestrictionTooLong"] = 351] = "ErrorRestrictionTooLong";
        ServiceError[ServiceError["ErrorResultSetTooBig"] = 352] = "ErrorResultSetTooBig";
        ServiceError[ServiceError["ErrorRulesOverQuota"] = 353] = "ErrorRulesOverQuota";
        ServiceError[ServiceError["ErrorSavedItemFolderNotFound"] = 354] = "ErrorSavedItemFolderNotFound";
        ServiceError[ServiceError["ErrorSchemaValidation"] = 355] = "ErrorSchemaValidation";
        ServiceError[ServiceError["ErrorSearchFolderNotInitialized"] = 356] = "ErrorSearchFolderNotInitialized";
        ServiceError[ServiceError["ErrorSendAsDenied"] = 357] = "ErrorSendAsDenied";
        ServiceError[ServiceError["ErrorSendMeetingCancellationsRequired"] = 358] = "ErrorSendMeetingCancellationsRequired";
        ServiceError[ServiceError["ErrorSendMeetingInvitationsOrCancellationsRequired"] = 359] = "ErrorSendMeetingInvitationsOrCancellationsRequired";
        ServiceError[ServiceError["ErrorSendMeetingInvitationsRequired"] = 360] = "ErrorSendMeetingInvitationsRequired";
        ServiceError[ServiceError["ErrorSentMeetingRequestUpdate"] = 361] = "ErrorSentMeetingRequestUpdate";
        ServiceError[ServiceError["ErrorSentTaskRequestUpdate"] = 362] = "ErrorSentTaskRequestUpdate";
        ServiceError[ServiceError["ErrorServerBusy"] = 363] = "ErrorServerBusy";
        ServiceError[ServiceError["ErrorServiceDiscoveryFailed"] = 364] = "ErrorServiceDiscoveryFailed";
        ServiceError[ServiceError["ErrorSharingNoExternalEwsAvailable"] = 365] = "ErrorSharingNoExternalEwsAvailable";
        ServiceError[ServiceError["ErrorSharingSynchronizationFailed"] = 366] = "ErrorSharingSynchronizationFailed";
        ServiceError[ServiceError["ErrorStaleObject"] = 367] = "ErrorStaleObject";
        ServiceError[ServiceError["ErrorSubmissionQuotaExceeded"] = 368] = "ErrorSubmissionQuotaExceeded";
        ServiceError[ServiceError["ErrorSubscriptionAccessDenied"] = 369] = "ErrorSubscriptionAccessDenied";
        ServiceError[ServiceError["ErrorSubscriptionDelegateAccessNotSupported"] = 370] = "ErrorSubscriptionDelegateAccessNotSupported";
        ServiceError[ServiceError["ErrorSubscriptionNotFound"] = 371] = "ErrorSubscriptionNotFound";
        ServiceError[ServiceError["ErrorSubscriptionUnsubscribed"] = 372] = "ErrorSubscriptionUnsubscribed";
        ServiceError[ServiceError["ErrorSyncFolderNotFound"] = 373] = "ErrorSyncFolderNotFound";
        ServiceError[ServiceError["ErrorTeamMailboxNotFound"] = 374] = "ErrorTeamMailboxNotFound";
        ServiceError[ServiceError["ErrorTeamMailboxNotLinkedToSharePoint"] = 375] = "ErrorTeamMailboxNotLinkedToSharePoint";
        ServiceError[ServiceError["ErrorTeamMailboxUrlValidationFailed"] = 376] = "ErrorTeamMailboxUrlValidationFailed";
        ServiceError[ServiceError["ErrorTeamMailboxNotAuthorizedOwner"] = 377] = "ErrorTeamMailboxNotAuthorizedOwner";
        ServiceError[ServiceError["ErrorTeamMailboxActiveToPendingDelete"] = 378] = "ErrorTeamMailboxActiveToPendingDelete";
        ServiceError[ServiceError["ErrorTeamMailboxFailedSendingNotifications"] = 379] = "ErrorTeamMailboxFailedSendingNotifications";
        ServiceError[ServiceError["ErrorTeamMailboxErrorUnknown"] = 380] = "ErrorTeamMailboxErrorUnknown";
        ServiceError[ServiceError["ErrorTimeIntervalTooBig"] = 381] = "ErrorTimeIntervalTooBig";
        ServiceError[ServiceError["ErrorTimeoutExpired"] = 382] = "ErrorTimeoutExpired";
        ServiceError[ServiceError["ErrorTimeZone"] = 383] = "ErrorTimeZone";
        ServiceError[ServiceError["ErrorToFolderNotFound"] = 384] = "ErrorToFolderNotFound";
        ServiceError[ServiceError["ErrorTokenSerializationDenied"] = 385] = "ErrorTokenSerializationDenied";
        ServiceError[ServiceError["ErrorUnableToGetUserOofSettings"] = 386] = "ErrorUnableToGetUserOofSettings";
        ServiceError[ServiceError["ErrorUnableToRemoveImContactFromGroup"] = 387] = "ErrorUnableToRemoveImContactFromGroup";
        ServiceError[ServiceError["ErrorUnifiedMessagingDialPlanNotFound"] = 388] = "ErrorUnifiedMessagingDialPlanNotFound";
        ServiceError[ServiceError["ErrorUnifiedMessagingRequestFailed"] = 389] = "ErrorUnifiedMessagingRequestFailed";
        ServiceError[ServiceError["ErrorUnifiedMessagingServerNotFound"] = 390] = "ErrorUnifiedMessagingServerNotFound";
        ServiceError[ServiceError["ErrorUnsupportedCulture"] = 391] = "ErrorUnsupportedCulture";
        ServiceError[ServiceError["ErrorUnsupportedMapiPropertyType"] = 392] = "ErrorUnsupportedMapiPropertyType";
        ServiceError[ServiceError["ErrorUnsupportedMimeConversion"] = 393] = "ErrorUnsupportedMimeConversion";
        ServiceError[ServiceError["ErrorUnsupportedPathForQuery"] = 394] = "ErrorUnsupportedPathForQuery";
        ServiceError[ServiceError["ErrorUnsupportedPathForSortGroup"] = 395] = "ErrorUnsupportedPathForSortGroup";
        ServiceError[ServiceError["ErrorUnsupportedPropertyDefinition"] = 396] = "ErrorUnsupportedPropertyDefinition";
        ServiceError[ServiceError["ErrorUnsupportedQueryFilter"] = 397] = "ErrorUnsupportedQueryFilter";
        ServiceError[ServiceError["ErrorUnsupportedRecurrence"] = 398] = "ErrorUnsupportedRecurrence";
        ServiceError[ServiceError["ErrorUnsupportedSubFilter"] = 399] = "ErrorUnsupportedSubFilter";
        ServiceError[ServiceError["ErrorUnsupportedTypeForConversion"] = 400] = "ErrorUnsupportedTypeForConversion";
        ServiceError[ServiceError["ErrorUpdateDelegatesFailed"] = 401] = "ErrorUpdateDelegatesFailed";
        ServiceError[ServiceError["ErrorUpdatePropertyMismatch"] = 402] = "ErrorUpdatePropertyMismatch";
        ServiceError[ServiceError["ErrorUserNotAllowedByPolicy"] = 403] = "ErrorUserNotAllowedByPolicy";
        ServiceError[ServiceError["ErrorUserNotUnifiedMessagingEnabled"] = 404] = "ErrorUserNotUnifiedMessagingEnabled";
        ServiceError[ServiceError["ErrorUserWithoutFederatedProxyAddress"] = 405] = "ErrorUserWithoutFederatedProxyAddress";
        ServiceError[ServiceError["ErrorValueOutOfRange"] = 406] = "ErrorValueOutOfRange";
        ServiceError[ServiceError["ErrorVirusDetected"] = 407] = "ErrorVirusDetected";
        ServiceError[ServiceError["ErrorVirusMessageDeleted"] = 408] = "ErrorVirusMessageDeleted";
        ServiceError[ServiceError["ErrorVoiceMailNotImplemented"] = 409] = "ErrorVoiceMailNotImplemented";
        ServiceError[ServiceError["ErrorWebRequestInInvalidState"] = 410] = "ErrorWebRequestInInvalidState";
        ServiceError[ServiceError["ErrorWin32InteropError"] = 411] = "ErrorWin32InteropError";
        ServiceError[ServiceError["ErrorWorkingHoursSaveFailed"] = 412] = "ErrorWorkingHoursSaveFailed";
        ServiceError[ServiceError["ErrorWorkingHoursXmlMalformed"] = 413] = "ErrorWorkingHoursXmlMalformed";
        ServiceError[ServiceError["ErrorWrongServerVersion"] = 414] = "ErrorWrongServerVersion";
        ServiceError[ServiceError["ErrorWrongServerVersionDelegate"] = 415] = "ErrorWrongServerVersionDelegate";
        ServiceError[ServiceError["ErrorInvalidClientAccessTokenRequest"] = 416] = "ErrorInvalidClientAccessTokenRequest";
        ServiceError[ServiceError["ErrorInvalidManagementRoleHeader"] = 417] = "ErrorInvalidManagementRoleHeader";
        ServiceError[ServiceError["ErrorSearchQueryHasTooManyKeywords"] = 418] = "ErrorSearchQueryHasTooManyKeywords";
        ServiceError[ServiceError["ErrorSearchTooManyMailboxes"] = 419] = "ErrorSearchTooManyMailboxes";
        ServiceError[ServiceError["ErrorInvalidRetentionTagNone"] = 420] = "ErrorInvalidRetentionTagNone";
        ServiceError[ServiceError["ErrorDiscoverySearchesDisabled"] = 421] = "ErrorDiscoverySearchesDisabled";
        ServiceError[ServiceError["ErrorCalendarSeekToConditionNotSupported"] = 422] = "ErrorCalendarSeekToConditionNotSupported";
        ServiceError[ServiceError["ErrorArchiveMailboxSearchFailed"] = 423] = "ErrorArchiveMailboxSearchFailed";
        ServiceError[ServiceError["ErrorGetRemoteArchiveFolderFailed"] = 424] = "ErrorGetRemoteArchiveFolderFailed";
        ServiceError[ServiceError["ErrorFindRemoteArchiveFolderFailed"] = 425] = "ErrorFindRemoteArchiveFolderFailed";
        ServiceError[ServiceError["ErrorGetRemoteArchiveItemFailed"] = 426] = "ErrorGetRemoteArchiveItemFailed";
        ServiceError[ServiceError["ErrorExportRemoteArchiveItemsFailed"] = 427] = "ErrorExportRemoteArchiveItemsFailed";
        ServiceError[ServiceError["ErrorClientIntentInvalidStateDefinition"] = 428] = "ErrorClientIntentInvalidStateDefinition";
        ServiceError[ServiceError["ErrorClientIntentNotFound"] = 429] = "ErrorClientIntentNotFound";
        ServiceError[ServiceError["ErrorContentIndexingNotEnabled"] = 430] = "ErrorContentIndexingNotEnabled";
        ServiceError[ServiceError["ErrorDeleteUnifiedMessagingPromptFailed"] = 431] = "ErrorDeleteUnifiedMessagingPromptFailed";
        ServiceError[ServiceError["ErrorLocationServicesDisabled"] = 432] = "ErrorLocationServicesDisabled";
        ServiceError[ServiceError["ErrorLocationServicesInvalidRequest"] = 433] = "ErrorLocationServicesInvalidRequest";
        ServiceError[ServiceError["ErrorLocationServicesRequestFailed"] = 434] = "ErrorLocationServicesRequestFailed";
        ServiceError[ServiceError["ErrorLocationServicesRequestTimedOut"] = 435] = "ErrorLocationServicesRequestTimedOut";
        ServiceError[ServiceError["ErrorWeatherServiceDisabled"] = 436] = "ErrorWeatherServiceDisabled";
        ServiceError[ServiceError["ErrorMailboxScopeNotAllowedWithoutQueryString"] = 437] = "ErrorMailboxScopeNotAllowedWithoutQueryString";
        ServiceError[ServiceError["ErrorNoSpeechDetected"] = 438] = "ErrorNoSpeechDetected";
        ServiceError[ServiceError["ErrorPromptPublishingOperationFailed"] = 439] = "ErrorPromptPublishingOperationFailed";
        ServiceError[ServiceError["ErrorPublicFolderMailboxDiscoveryFailed"] = 440] = "ErrorPublicFolderMailboxDiscoveryFailed";
        ServiceError[ServiceError["ErrorPublicFolderOperationFailed"] = 441] = "ErrorPublicFolderOperationFailed";
        ServiceError[ServiceError["ErrorPublicFolderSyncException"] = 442] = "ErrorPublicFolderSyncException";
        ServiceError[ServiceError["ErrorRecipientNotFound"] = 443] = "ErrorRecipientNotFound";
        ServiceError[ServiceError["ErrorRecognizerNotInstalled"] = 444] = "ErrorRecognizerNotInstalled";
        ServiceError[ServiceError["ErrorSpeechGrammarError"] = 445] = "ErrorSpeechGrammarError";
        ServiceError[ServiceError["ErrorTooManyObjectsOpened"] = 446] = "ErrorTooManyObjectsOpened";
        ServiceError[ServiceError["ErrorUMServerUnavailable"] = 447] = "ErrorUMServerUnavailable";
        ServiceError[ServiceError["ErrorUnifiedMessagingPromptNotFound"] = 448] = "ErrorUnifiedMessagingPromptNotFound";
        ServiceError[ServiceError["ErrorUnifiedMessagingReportDataNotFound"] = 449] = "ErrorUnifiedMessagingReportDataNotFound";
        ServiceError[ServiceError["ErrorInvalidPhotoSize"] = 450] = "ErrorInvalidPhotoSize";
        ServiceError[ServiceError["ErrorCalendarIsGroupMailboxForAccept"] = 451] = "ErrorCalendarIsGroupMailboxForAccept";
        ServiceError[ServiceError["ErrorCalendarIsGroupMailboxForDecline"] = 452] = "ErrorCalendarIsGroupMailboxForDecline";
        ServiceError[ServiceError["ErrorCalendarIsGroupMailboxForTentative"] = 453] = "ErrorCalendarIsGroupMailboxForTentative";
        ServiceError[ServiceError["ErrorCalendarIsGroupMailboxForSuppressReadReceipt"] = 454] = "ErrorCalendarIsGroupMailboxForSuppressReadReceipt";
    })(ServiceError || (ServiceError = {}));
    var ServiceErrorHandling;
    (function (ServiceErrorHandling) {
        ServiceErrorHandling[ServiceErrorHandling["ReturnErrors"] = 0] = "ReturnErrors";
        ServiceErrorHandling[ServiceErrorHandling["ThrowOnError"] = 1] = "ThrowOnError";
    })(ServiceErrorHandling || (ServiceErrorHandling = {}));
    var ServiceObjectType;
    (function (ServiceObjectType) {
        ServiceObjectType[ServiceObjectType["Folder"] = 0] = "Folder";
        ServiceObjectType[ServiceObjectType["Item"] = 1] = "Item";
        ServiceObjectType[ServiceObjectType["Conversation"] = 2] = "Conversation";
    })(ServiceObjectType || (ServiceObjectType = {}));
    var ServiceResult;
    (function (ServiceResult) {
        ServiceResult[ServiceResult["Success"] = 0] = "Success";
        ServiceResult[ServiceResult["Warning"] = 1] = "Warning";
        ServiceResult[ServiceResult["Error"] = 2] = "Error";
    })(ServiceResult || (ServiceResult = {}));
    var SetClientExtensionActionId;
    (function (SetClientExtensionActionId) {
        SetClientExtensionActionId[SetClientExtensionActionId["Install"] = 0] = "Install";
        SetClientExtensionActionId[SetClientExtensionActionId["Uninstall"] = 1] = "Uninstall";
        SetClientExtensionActionId[SetClientExtensionActionId["Configure"] = 2] = "Configure";
    })(SetClientExtensionActionId || (SetClientExtensionActionId = {}));
    var SortDirection;
    (function (SortDirection) {
        SortDirection[SortDirection["Ascending"] = 0] = "Ascending";
        SortDirection[SortDirection["Descending"] = 1] = "Descending";
    })(SortDirection || (SortDirection = {}));
    var StandardUser;
    (function (StandardUser) {
        StandardUser[StandardUser["Default"] = 0] = "Default";
        StandardUser[StandardUser["Anonymous"] = 1] = "Anonymous";
    })(StandardUser || (StandardUser = {}));
    var SuggestionQuality;
    (function (SuggestionQuality) {
        SuggestionQuality[SuggestionQuality["Excellent"] = 0] = "Excellent";
        SuggestionQuality[SuggestionQuality["Good"] = 1] = "Good";
        SuggestionQuality[SuggestionQuality["Fair"] = 2] = "Fair";
        SuggestionQuality[SuggestionQuality["Poor"] = 3] = "Poor";
    })(SuggestionQuality || (SuggestionQuality = {}));
    var SyncFolderItemsScope;
    (function (SyncFolderItemsScope) {
        SyncFolderItemsScope[SyncFolderItemsScope["NormalItems"] = 0] = "NormalItems";
        SyncFolderItemsScope[SyncFolderItemsScope["NormalAndAssociatedItems"] = 1] = "NormalAndAssociatedItems";
    })(SyncFolderItemsScope || (SyncFolderItemsScope = {}));
    var TaskDelegationState;
    (function (TaskDelegationState) {
        TaskDelegationState[TaskDelegationState["NoDelegation"] = 0] = "NoDelegation";
        TaskDelegationState[TaskDelegationState["Unknown"] = 1] = "Unknown";
        TaskDelegationState[TaskDelegationState["Accepted"] = 2] = "Accepted";
        TaskDelegationState[TaskDelegationState["Declined"] = 3] = "Declined";
    })(TaskDelegationState || (TaskDelegationState = {}));
    var TaskMode;
    (function (TaskMode) {
        TaskMode[TaskMode["Normal"] = 0] = "Normal";
        TaskMode[TaskMode["Request"] = 1] = "Request";
        TaskMode[TaskMode["RequestAccepted"] = 2] = "RequestAccepted";
        TaskMode[TaskMode["RequestDeclined"] = 3] = "RequestDeclined";
        TaskMode[TaskMode["Update"] = 4] = "Update";
        TaskMode[TaskMode["SelfDelegated"] = 5] = "SelfDelegated";
    })(TaskMode || (TaskMode = {}));
    var TaskStatus;
    (function (TaskStatus) {
        TaskStatus[TaskStatus["NotStarted"] = 0] = "NotStarted";
        TaskStatus[TaskStatus["InProgress"] = 1] = "InProgress";
        TaskStatus[TaskStatus["Completed"] = 2] = "Completed";
        TaskStatus[TaskStatus["WaitingOnOthers"] = 3] = "WaitingOnOthers";
        TaskStatus[TaskStatus["Deferred"] = 4] = "Deferred";
    })(TaskStatus || (TaskStatus = {}));
    var TeamMailboxLifecycleState;
    (function (TeamMailboxLifecycleState) {
        TeamMailboxLifecycleState[TeamMailboxLifecycleState["Active"] = 0] = "Active";
        TeamMailboxLifecycleState[TeamMailboxLifecycleState["Closed"] = 1] = "Closed";
        TeamMailboxLifecycleState[TeamMailboxLifecycleState["Unlinked"] = 2] = "Unlinked";
        TeamMailboxLifecycleState[TeamMailboxLifecycleState["PendingDelete"] = 3] = "PendingDelete";
    })(TeamMailboxLifecycleState || (TeamMailboxLifecycleState = {}));
    var TraceFlags;
    (function (TraceFlags) {
        TraceFlags[TraceFlags["None"] = 0] = "None";
        TraceFlags[TraceFlags["EwsRequest"] = 1] = "EwsRequest";
        TraceFlags[TraceFlags["EwsResponse"] = 2] = "EwsResponse";
        TraceFlags[TraceFlags["EwsResponseHttpHeaders"] = 4] = "EwsResponseHttpHeaders";
        TraceFlags[TraceFlags["AutodiscoverRequest"] = 8] = "AutodiscoverRequest";
        TraceFlags[TraceFlags["AutodiscoverResponse"] = 16] = "AutodiscoverResponse";
        TraceFlags[TraceFlags["AutodiscoverResponseHttpHeaders"] = 32] = "AutodiscoverResponseHttpHeaders";
        TraceFlags[TraceFlags["AutodiscoverConfiguration"] = 64] = "AutodiscoverConfiguration";
        TraceFlags[TraceFlags["DebugMessage"] = 128] = "DebugMessage";
        TraceFlags[TraceFlags["EwsRequestHttpHeaders"] = 256] = "EwsRequestHttpHeaders";
        TraceFlags[TraceFlags["AutodiscoverRequestHttpHeaders"] = 512] = "AutodiscoverRequestHttpHeaders";
        TraceFlags[TraceFlags["All"] = 9223372036854776000] = "All";
    })(TraceFlags || (TraceFlags = {}));
    var UserConfigurationProperties;
    (function (UserConfigurationProperties) {
        UserConfigurationProperties[UserConfigurationProperties["Id"] = 1] = "Id";
        UserConfigurationProperties[UserConfigurationProperties["Dictionary"] = 2] = "Dictionary";
        UserConfigurationProperties[UserConfigurationProperties["XmlData"] = 4] = "XmlData";
        UserConfigurationProperties[UserConfigurationProperties["BinaryData"] = 8] = "BinaryData";
        UserConfigurationProperties[UserConfigurationProperties["All"] = 15] = "All";
    })(UserConfigurationProperties || (UserConfigurationProperties = {}));
    var UserConfigurationDictionaryObjectType;
    (function (UserConfigurationDictionaryObjectType) {
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["DateTime"] = 0] = "DateTime";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["Boolean"] = 1] = "Boolean";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["Byte"] = 2] = "Byte";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["String"] = 3] = "String";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["Integer32"] = 4] = "Integer32";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["UnsignedInteger32"] = 5] = "UnsignedInteger32";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["Integer64"] = 6] = "Integer64";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["UnsignedInteger64"] = 7] = "UnsignedInteger64";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["StringArray"] = 8] = "StringArray";
        UserConfigurationDictionaryObjectType[UserConfigurationDictionaryObjectType["ByteArray"] = 9] = "ByteArray";
    })(UserConfigurationDictionaryObjectType || (UserConfigurationDictionaryObjectType = {}));
    var ViewFilter;
    (function (ViewFilter) {
        ViewFilter[ViewFilter["All"] = 0] = "All";
        ViewFilter[ViewFilter["Flagged"] = 1] = "Flagged";
        ViewFilter[ViewFilter["HasAttachment"] = 2] = "HasAttachment";
        ViewFilter[ViewFilter["ToOrCcMe"] = 3] = "ToOrCcMe";
        ViewFilter[ViewFilter["Unread"] = 4] = "Unread";
        ViewFilter[ViewFilter["TaskActive"] = 5] = "TaskActive";
        ViewFilter[ViewFilter["TaskOverdue"] = 6] = "TaskOverdue";
        ViewFilter[ViewFilter["TaskCompleted"] = 7] = "TaskCompleted";
        ViewFilter[ViewFilter["Suggestions"] = 8] = "Suggestions";
        ViewFilter[ViewFilter["SuggestionsRespond"] = 9] = "SuggestionsRespond";
        ViewFilter[ViewFilter["SuggestionsDelete"] = 10] = "SuggestionsDelete";
    })(ViewFilter || (ViewFilter = {}));
    var WellKnownFolderName;
    (function (WellKnownFolderName) {
        WellKnownFolderName[WellKnownFolderName["Calendar"] = 0] = "Calendar";
        WellKnownFolderName[WellKnownFolderName["Contacts"] = 1] = "Contacts";
        WellKnownFolderName[WellKnownFolderName["DeletedItems"] = 2] = "DeletedItems";
        WellKnownFolderName[WellKnownFolderName["Drafts"] = 3] = "Drafts";
        WellKnownFolderName[WellKnownFolderName["Inbox"] = 4] = "Inbox";
        WellKnownFolderName[WellKnownFolderName["Journal"] = 5] = "Journal";
        WellKnownFolderName[WellKnownFolderName["Notes"] = 6] = "Notes";
        WellKnownFolderName[WellKnownFolderName["Outbox"] = 7] = "Outbox";
        WellKnownFolderName[WellKnownFolderName["SentItems"] = 8] = "SentItems";
        WellKnownFolderName[WellKnownFolderName["Tasks"] = 9] = "Tasks";
        WellKnownFolderName[WellKnownFolderName["MsgFolderRoot"] = 10] = "MsgFolderRoot";
        WellKnownFolderName[WellKnownFolderName["PublicFoldersRoot"] = 11] = "PublicFoldersRoot";
        WellKnownFolderName[WellKnownFolderName["Root"] = 12] = "Root";
        WellKnownFolderName[WellKnownFolderName["JunkEmail"] = 13] = "JunkEmail";
        WellKnownFolderName[WellKnownFolderName["SearchFolders"] = 14] = "SearchFolders";
        WellKnownFolderName[WellKnownFolderName["VoiceMail"] = 15] = "VoiceMail";
        WellKnownFolderName[WellKnownFolderName["RecoverableItemsRoot"] = 16] = "RecoverableItemsRoot";
        WellKnownFolderName[WellKnownFolderName["RecoverableItemsDeletions"] = 17] = "RecoverableItemsDeletions";
        WellKnownFolderName[WellKnownFolderName["RecoverableItemsVersions"] = 18] = "RecoverableItemsVersions";
        WellKnownFolderName[WellKnownFolderName["RecoverableItemsPurges"] = 19] = "RecoverableItemsPurges";
        WellKnownFolderName[WellKnownFolderName["ArchiveRoot"] = 20] = "ArchiveRoot";
        WellKnownFolderName[WellKnownFolderName["ArchiveMsgFolderRoot"] = 21] = "ArchiveMsgFolderRoot";
        WellKnownFolderName[WellKnownFolderName["ArchiveDeletedItems"] = 22] = "ArchiveDeletedItems";
        WellKnownFolderName[WellKnownFolderName["ArchiveRecoverableItemsRoot"] = 23] = "ArchiveRecoverableItemsRoot";
        WellKnownFolderName[WellKnownFolderName["ArchiveRecoverableItemsDeletions"] = 24] = "ArchiveRecoverableItemsDeletions";
        WellKnownFolderName[WellKnownFolderName["ArchiveRecoverableItemsVersions"] = 25] = "ArchiveRecoverableItemsVersions";
        WellKnownFolderName[WellKnownFolderName["ArchiveRecoverableItemsPurges"] = 26] = "ArchiveRecoverableItemsPurges";
        WellKnownFolderName[WellKnownFolderName["SyncIssues"] = 27] = "SyncIssues";
        WellKnownFolderName[WellKnownFolderName["Conflicts"] = 28] = "Conflicts";
        WellKnownFolderName[WellKnownFolderName["LocalFailures"] = 29] = "LocalFailures";
        WellKnownFolderName[WellKnownFolderName["ServerFailures"] = 30] = "ServerFailures";
        WellKnownFolderName[WellKnownFolderName["RecipientCache"] = 31] = "RecipientCache";
        WellKnownFolderName[WellKnownFolderName["QuickContacts"] = 32] = "QuickContacts";
        WellKnownFolderName[WellKnownFolderName["ConversationHistory"] = 33] = "ConversationHistory";
        WellKnownFolderName[WellKnownFolderName["ToDoSearch"] = 34] = "ToDoSearch";
    })(WellKnownFolderName || (WellKnownFolderName = {}));
    var XmlNamespace;
    (function (XmlNamespace) {
        XmlNamespace[XmlNamespace["NotSpecified"] = 0] = "NotSpecified";
        XmlNamespace[XmlNamespace["Messages"] = 1] = "Messages";
        XmlNamespace[XmlNamespace["Types"] = 2] = "Types";
        XmlNamespace[XmlNamespace["Errors"] = 3] = "Errors";
        XmlNamespace[XmlNamespace["Soap"] = 4] = "Soap";
        XmlNamespace[XmlNamespace["Soap12"] = 5] = "Soap12";
        XmlNamespace[XmlNamespace["XmlSchemaInstance"] = 6] = "XmlSchemaInstance";
        XmlNamespace[XmlNamespace["PassportSoapFault"] = 7] = "PassportSoapFault";
        XmlNamespace[XmlNamespace["WSTrustFebruary2005"] = 8] = "WSTrustFebruary2005";
        XmlNamespace[XmlNamespace["WSAddressing"] = 9] = "WSAddressing";
        XmlNamespace[XmlNamespace["Autodiscover"] = 10] = "Autodiscover";
    })(XmlNamespace || (XmlNamespace = {}));
    var ServiceRemoteException = (function (_super) {
        __extends(ServiceRemoteException, _super);
        function ServiceRemoteException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceRemoteException.prototype.constructor_0 = function () {
        };
        ServiceRemoteException.prototype.constructor_1 = function (message) {
        };
        ServiceRemoteException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceRemoteException;
    }(Exception));
    var AccountIsLockedException = (function (_super) {
        __extends(AccountIsLockedException, _super);
        function AccountIsLockedException(message, accountUnlockUrl, innerException) {
            _super.call(this, message, innerException);
            this.AccountUnlockUrl = null;
            this.AccountUnlockUrl = accountUnlockUrl;
        }
        return AccountIsLockedException;
    }(ServiceRemoteException));
    var ServiceLocalException = (function (_super) {
        __extends(ServiceLocalException, _super);
        function ServiceLocalException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceLocalException.prototype.constructor_0 = function () {
        };
        ServiceLocalException.prototype.constructor_1 = function (message) {
        };
        ServiceLocalException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceLocalException;
    }(Exception));
    var AutodiscoverLocalException = (function (_super) {
        __extends(AutodiscoverLocalException, _super);
        function AutodiscoverLocalException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        AutodiscoverLocalException.prototype.constructor_0 = function () {
        };
        AutodiscoverLocalException.prototype.constructor_1 = function (message) {
        };
        AutodiscoverLocalException.prototype.constructor_2 = function (message, innerException) {
        };
        return AutodiscoverLocalException;
    }(ServiceLocalException));
    var BatchServiceResponseException = (function (_super) {
        __extends(BatchServiceResponseException, _super);
        function BatchServiceResponseException(serviceResponses, message, innerException) {
            _super.call(this, message);
            this.responses = null;
            if (arguments.length === 2 && (serviceResponses === null || serviceResponses instanceof ServiceResponseCollection) && (message === null || message.constructor === String)) {
                this.constructor_0(serviceResponses, message);
                return;
            }
            this.constructor_1(serviceResponses, message, innerException);
        }
        Object.defineProperty(BatchServiceResponseException.prototype, "ServiceResponses", {
            get: function () {
                return this.responses;
            },
            enumerable: true,
            configurable: true
        });
        BatchServiceResponseException.prototype.constructor_0 = function (serviceResponses, message) {
            EwsUtilities.Assert(serviceResponses !== null, "MultiServiceResponseException.ctor", "serviceResponses is null");
            this.responses = serviceResponses;
        };
        BatchServiceResponseException.prototype.constructor_1 = function (serviceResponses, message, innerException) {
            EwsUtilities.Assert(serviceResponses !== null, "MultiServiceResponseException.ctor", "serviceResponses is null");
            this.responses = serviceResponses;
        };
        return BatchServiceResponseException;
    }(ServiceRemoteException));
    var CreateAttachmentException = (function (_super) {
        __extends(CreateAttachmentException, _super);
        function CreateAttachmentException(serviceResponses, message, innerException) {
            if (arguments.length === 2 && (serviceResponses === null || serviceResponses instanceof ServiceResponseCollection) && (message === null || message.constructor === String)) {
                _super.call(this, serviceResponses, message);
                this.constructor_0(serviceResponses, message);
                return;
            }
            _super.call(this, serviceResponses, message, innerException);
            this.constructor_1(serviceResponses, message, innerException);
        }
        CreateAttachmentException.prototype.constructor_0 = function (serviceResponses, message) {
        };
        CreateAttachmentException.prototype.constructor_1 = function (serviceResponses, message, innerException) {
        };
        return CreateAttachmentException;
    }(BatchServiceResponseException));
    var DeleteAttachmentException = (function (_super) {
        __extends(DeleteAttachmentException, _super);
        function DeleteAttachmentException(serviceResponses, message, innerException) {
            if (arguments.length === 2 && (serviceResponses === null || serviceResponses instanceof ServiceResponseCollection) && (message === null || message.constructor === String)) {
                _super.call(this, serviceResponses, message);
                this.constructor_0(serviceResponses, message);
                return;
            }
            _super.call(this, serviceResponses, message, innerException);
            this.constructor_1(serviceResponses, message, innerException);
        }
        DeleteAttachmentException.prototype.constructor_0 = function (serviceResponses, message) {
        };
        DeleteAttachmentException.prototype.constructor_1 = function (serviceResponses, message, innerException) {
        };
        return DeleteAttachmentException;
    }(BatchServiceResponseException));
    var JsonDeserializationNotImplementedException = (function (_super) {
        __extends(JsonDeserializationNotImplementedException, _super);
        function JsonDeserializationNotImplementedException(message) {
            if (arguments.length === 0) {
                _super.call(this, Strings.JsonDeserializationNotImplemented);
                this.constructor_0();
                return;
            }
            _super.call(this, message);
            this.constructor_1(message);
        }
        JsonDeserializationNotImplementedException.prototype.constructor_0 = function () {
        };
        JsonDeserializationNotImplementedException.prototype.constructor_1 = function (message) {
        };
        return JsonDeserializationNotImplementedException;
    }(ServiceLocalException));
    var JsonSerializationNotImplementedException = (function (_super) {
        __extends(JsonSerializationNotImplementedException, _super);
        function JsonSerializationNotImplementedException() {
            _super.call(this, Strings.JsonSerializationNotImplemented);
        }
        return JsonSerializationNotImplementedException;
    }(Exception));
    var PropertyException = (function (_super) {
        __extends(PropertyException, _super);
        function PropertyException(nameOrMessage, name, innerException) {
            _super.call(this);
            this.name = null;
            if (arguments.length === 1 && (nameOrMessage === null || nameOrMessage.constructor === String)) {
                this.constructor_0(nameOrMessage);
                return;
            }
            if (arguments.length === 2 && (nameOrMessage === null || nameOrMessage.constructor === String) && (name === null || name.constructor === String)) {
                this.constructor_1(nameOrMessage, name);
                return;
            }
            this.constructor_2(nameOrMessage, name, innerException);
        }
        Object.defineProperty(PropertyException.prototype, "Name", {
            get: function () {
                return this.name;
            },
            enumerable: true,
            configurable: true
        });
        PropertyException.prototype.constructor_0 = function (name) {
            this.name = name;
        };
        PropertyException.prototype.constructor_1 = function (message, name) {
            this.name = name;
        };
        PropertyException.prototype.constructor_2 = function (message, name, innerException) {
            this.name = name;
        };
        return PropertyException;
    }(ServiceLocalException));
    var ServiceResponseException = (function (_super) {
        __extends(ServiceResponseException, _super);
        function ServiceResponseException(response) {
            _super.call(this);
            this.response = null;
            this.response = response;
        }
        Object.defineProperty(ServiceResponseException.prototype, "Response", {
            get: function () {
                return this.response;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponseException.prototype, "ErrorCode", {
            get: function () {
                return this.response.ErrorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ServiceResponseException.prototype, "Message", {
            get: function () {
                var _this = this;
                var text;
                var text2;
                var text3;
                if (this.Response.ErrorCode === ServiceError.ErrorInternalServerError && (function () {
                    var _p0 = [
                        text
                    ];
                    var _r = _this.Response.ErrorDetails.TryGetValue("ExceptionClass", _p0);
                    text = _p0[0];
                    return _r;
                })() && (function () {
                    var _p0 = [
                        text2
                    ];
                    var _r = _this.Response.ErrorDetails.TryGetValue("ExceptionMessage", _p0);
                    text2 = _p0[0];
                    return _r;
                })() && (function () {
                    var _p0 = [
                        text3
                    ];
                    var _r = _this.Response.ErrorDetails.TryGetValue("StackTrace", _p0);
                    text3 = _p0[0];
                    return _r;
                })()) {
                    return NString.Format(Strings.ServerErrorAndStackTraceDetails, [
                        this.Response.ErrorMessage, text, text2, text3
                    ]);
                }
                return this.Response.ErrorMessage;
            },
            enumerable: true,
            configurable: true
        });
        ServiceResponseException.ExceptionClassKey = "ExceptionClass";
        ServiceResponseException.ExceptionMessageKey = "ExceptionMessage";
        ServiceResponseException.StackTraceKey = "StackTrace";
        return ServiceResponseException;
    }(ServiceRemoteException));
    var ServerBusyException = (function (_super) {
        __extends(ServerBusyException, _super);
        function ServerBusyException(response) {
            var _this = this;
            _super.call(this, response);
            this.backOffMilliseconds = 0;
            if (response.ErrorDetails !== null && response.ErrorDetails.ContainsKey("BackOffMilliseconds")) {
                (function () {
                    var _p0 = [
                        _this.backOffMilliseconds
                    ];
                    var _r = NNumber.TryParse(response.ErrorDetails.get_Item("BackOffMilliseconds"), _p0);
                    _this.backOffMilliseconds = _p0[0];
                    return _r;
                })();
            }
        }
        Object.defineProperty(ServerBusyException.prototype, "BackOffMilliseconds", {
            get: function () {
                return this.backOffMilliseconds;
            },
            enumerable: true,
            configurable: true
        });
        ServerBusyException.BackOffMillisecondsKey = "BackOffMilliseconds";
        return ServerBusyException;
    }(ServiceResponseException));
    var ServiceJsonDeserializationException = (function (_super) {
        __extends(ServiceJsonDeserializationException, _super);
        function ServiceJsonDeserializationException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceJsonDeserializationException.prototype.constructor_0 = function () {
        };
        ServiceJsonDeserializationException.prototype.constructor_1 = function (message) {
        };
        ServiceJsonDeserializationException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceJsonDeserializationException;
    }(ServiceLocalException));
    var ServiceObjectPropertyException = (function (_super) {
        __extends(ServiceObjectPropertyException, _super);
        function ServiceObjectPropertyException(propertyDefinitionOrMessage, propertyDefinition, innerException) {
            _super.call(this, propertyDefinitionOrMessage.GetPrintableName());
            this.propertyDefinition = null;
            if (arguments.length === 1 && (propertyDefinitionOrMessage === null || propertyDefinitionOrMessage instanceof PropertyDefinitionBase)) {
                this.constructor_0(propertyDefinitionOrMessage);
                return;
            }
            if (arguments.length === 2 && (propertyDefinitionOrMessage === null || propertyDefinitionOrMessage.constructor === String) && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase)) {
                this.constructor_1(propertyDefinitionOrMessage, propertyDefinition);
                return;
            }
            this.constructor_2(propertyDefinitionOrMessage, propertyDefinition, innerException);
        }
        Object.defineProperty(ServiceObjectPropertyException.prototype, "PropertyDefinition", {
            get: function () {
                return this.propertyDefinition;
            },
            enumerable: true,
            configurable: true
        });
        ServiceObjectPropertyException.prototype.constructor_0 = function (propertyDefinition) {
            this.propertyDefinition = propertyDefinition;
        };
        ServiceObjectPropertyException.prototype.constructor_1 = function (message, propertyDefinition) {
            this.propertyDefinition = propertyDefinition;
        };
        ServiceObjectPropertyException.prototype.constructor_2 = function (message, propertyDefinition, innerException) {
            this.propertyDefinition = propertyDefinition;
        };
        return ServiceObjectPropertyException;
    }(PropertyException));
    var ServiceRequestException = (function (_super) {
        __extends(ServiceRequestException, _super);
        function ServiceRequestException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceRequestException.prototype.constructor_0 = function () {
        };
        ServiceRequestException.prototype.constructor_1 = function (message) {
        };
        ServiceRequestException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceRequestException;
    }(ServiceRemoteException));
    var ServiceValidationException = (function (_super) {
        __extends(ServiceValidationException, _super);
        function ServiceValidationException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceValidationException.prototype.constructor_0 = function () {
        };
        ServiceValidationException.prototype.constructor_1 = function (message) {
        };
        ServiceValidationException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceValidationException;
    }(ServiceLocalException));
    var ServiceVersionException = (function (_super) {
        __extends(ServiceVersionException, _super);
        function ServiceVersionException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceVersionException.prototype.constructor_0 = function () {
        };
        ServiceVersionException.prototype.constructor_1 = function (message) {
        };
        ServiceVersionException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceVersionException;
    }(ServiceLocalException));
    var ServiceXmlDeserializationException = (function (_super) {
        __extends(ServiceXmlDeserializationException, _super);
        function ServiceXmlDeserializationException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceXmlDeserializationException.prototype.constructor_0 = function () {
        };
        ServiceXmlDeserializationException.prototype.constructor_1 = function (message) {
        };
        ServiceXmlDeserializationException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceXmlDeserializationException;
    }(ServiceLocalException));
    var ServiceXmlSerializationException = (function (_super) {
        __extends(ServiceXmlSerializationException, _super);
        function ServiceXmlSerializationException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        ServiceXmlSerializationException.prototype.constructor_0 = function () {
        };
        ServiceXmlSerializationException.prototype.constructor_1 = function (message) {
        };
        ServiceXmlSerializationException.prototype.constructor_2 = function (message, innerException) {
        };
        return ServiceXmlSerializationException;
    }(ServiceLocalException));
    var TimeZoneConversionException = (function (_super) {
        __extends(TimeZoneConversionException, _super);
        function TimeZoneConversionException(message, innerException) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (message === null || message.constructor === String)) {
                _super.call(this, message);
                this.constructor_1(message);
                return;
            }
            _super.call(this, message, innerException);
            this.constructor_2(message, innerException);
        }
        TimeZoneConversionException.prototype.constructor_0 = function () {
        };
        TimeZoneConversionException.prototype.constructor_1 = function (message) {
        };
        TimeZoneConversionException.prototype.constructor_2 = function (message, innerException) {
        };
        return TimeZoneConversionException;
    }(ServiceLocalException));
    var UpdateInboxRulesException = (function (_super) {
        __extends(UpdateInboxRulesException, _super);
        function UpdateInboxRulesException(serviceResponse, ruleOperations) {
            _super.call(this);
            this.serviceResponse = null;
            this.errors = null;
            this.serviceResponse = serviceResponse;
            this.errors = serviceResponse.Errors;
            var enumerator = this.errors.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.SetOperationByIndex(ruleOperations);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        }
        Object.defineProperty(UpdateInboxRulesException.prototype, "ServiceResponse", {
            get: function () {
                return this.serviceResponse;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateInboxRulesException.prototype, "Errors", {
            get: function () {
                return this.errors;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateInboxRulesException.prototype, "ErrorCode", {
            get: function () {
                return this.serviceResponse.ErrorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateInboxRulesException.prototype, "ErrorMessage", {
            get: function () {
                return this.serviceResponse.ErrorMessage;
            },
            enumerable: true,
            configurable: true
        });
        return UpdateInboxRulesException;
    }(ServiceRemoteException));
    var DiscoverySearchConfiguration = (function () {
        function DiscoverySearchConfiguration() {
            this.SearchId = null;
            this.SearchQuery = null;
            this.SearchableMailboxes = null;
            this.InPlaceHoldIdentity = null;
            this.ManagedByOrganization = null;
            this.Language = null;
            _super.call(this);
        }
        DiscoverySearchConfiguration.LoadFromXml = function (reader) {
            var list = new List();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "DiscoverySearchConfiguration");
            var discoverySearchConfiguration = new DiscoverySearchConfiguration();
            discoverySearchConfiguration.SearchId = reader.ReadElementValue(XmlNamespace.Types, "SearchId");
            discoverySearchConfiguration.SearchQuery = NString.Empty;
            discoverySearchConfiguration.InPlaceHoldIdentity = NString.Empty;
            discoverySearchConfiguration.ManagedByOrganization = NString.Empty;
            discoverySearchConfiguration.Language = NString.Empty;
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "SearchQuery")) {
                    discoverySearchConfiguration.SearchQuery = reader.ReadElementValue(XmlNamespace.Types, "SearchQuery");
                    reader.ReadEndElementIfNecessary(XmlNamespace.Types, "SearchQuery");
                }
                else {
                    if (reader.IsStartElement(XmlNamespace.Types, "SearchableMailboxes")) {
                        if (!reader.IsEmptyElement) {
                            while (!reader.IsEndElement(XmlNamespace.Types, "SearchableMailboxes")) {
                                reader.Read();
                                if (reader.IsStartElement(XmlNamespace.Types, "SearchableMailbox")) {
                                    list.Add(SearchableMailbox.LoadFromXml(reader));
                                    reader.ReadEndElementIfNecessary(XmlNamespace.Types, "SearchableMailbox");
                                }
                            }
                        }
                    }
                    else {
                        if (reader.IsStartElement(XmlNamespace.Types, "InPlaceHoldIdentity")) {
                            discoverySearchConfiguration.InPlaceHoldIdentity = reader.ReadElementValue(XmlNamespace.Types, "InPlaceHoldIdentity");
                            reader.ReadEndElementIfNecessary(XmlNamespace.Types, "InPlaceHoldIdentity");
                        }
                        else {
                            if (reader.IsStartElement(XmlNamespace.Types, "ManagedByOrganization")) {
                                discoverySearchConfiguration.ManagedByOrganization = reader.ReadElementValue(XmlNamespace.Types, "ManagedByOrganization");
                                reader.ReadEndElementIfNecessary(XmlNamespace.Types, "ManagedByOrganization");
                            }
                            else {
                                if (!reader.IsStartElement(XmlNamespace.Types, "Language")) {
                                    break;
                                }
                                discoverySearchConfiguration.Language = reader.ReadElementValue(XmlNamespace.Types, "Language");
                                reader.ReadEndElementIfNecessary(XmlNamespace.Types, "Language");
                            }
                        }
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "DiscoverySearchConfiguration"));
            discoverySearchConfiguration.SearchableMailboxes = ((list.Count === 0) ? null : list.ToArray());
            return discoverySearchConfiguration;
        };
        DiscoverySearchConfiguration.LoadFromJson = function (jsonObject) {
            var list = new List();
            var discoverySearchConfiguration = new DiscoverySearchConfiguration();
            if (jsonObject.ContainsKey("SearchId")) {
                discoverySearchConfiguration.SearchId = jsonObject.ReadAsString("SearchId");
            }
            if (jsonObject.ContainsKey("InPlaceHoldIdentity")) {
                discoverySearchConfiguration.InPlaceHoldIdentity = jsonObject.ReadAsString("InPlaceHoldIdentity");
            }
            if (jsonObject.ContainsKey("ManagedByOrganization")) {
                discoverySearchConfiguration.ManagedByOrganization = jsonObject.ReadAsString("ManagedByOrganization");
            }
            if (jsonObject.ContainsKey("SearchQuery")) {
                discoverySearchConfiguration.SearchQuery = jsonObject.ReadAsString("SearchQuery");
            }
            if (jsonObject.ContainsKey("SearchableMailboxes")) {
                var array = jsonObject.ReadAsArray("SearchableMailboxes");
                for (var i = 0; i < array.length; i = i + 1) {
                    var obj = array[i];
                    var jsonObject2 = ((obj instanceof JsonObject) ? obj : null);
                    list.Add(SearchableMailbox.LoadFromJson(jsonObject2));
                }
            }
            if (jsonObject.ContainsKey("Language")) {
                discoverySearchConfiguration.Language = jsonObject.ReadAsString("Language");
            }
            discoverySearchConfiguration.SearchableMailboxes = ((list.Count === 0) ? null : list.ToArray());
            return discoverySearchConfiguration;
        };
        return DiscoverySearchConfiguration;
    }());
    var ExtendedAttributes = (function (_super) {
        __extends(ExtendedAttributes, _super);
        function ExtendedAttributes() {
            _super.call(this);
        }
        return ExtendedAttributes;
    }(List));
    var ExtendedAttribute = (function () {
        function ExtendedAttribute(name, value) {
            this.Name = null;
            this.Value = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(name, value);
        }
        ExtendedAttribute.prototype.constructor_0 = function () {
        };
        ExtendedAttribute.prototype.constructor_1 = function (name, value) {
            this.Name = name;
            this.Value = value;
        };
        return ExtendedAttribute;
    }());
    var FailedSearchMailbox = (function () {
        function FailedSearchMailbox(mailbox, errorCode, errorMessage, isArchive) {
            this.Mailbox = null;
            this.ErrorCode = 0;
            this.ErrorMessage = null;
            this.IsArchive = false;
            _super.call(this);
            if (arguments.length === 3 && (mailbox === null || mailbox.constructor === String) && (errorCode === null || errorCode.constructor === Number) && (errorMessage === null || errorMessage.constructor === String)) {
                this.constructor_0(mailbox, errorCode, errorMessage);
                return;
            }
            this.constructor_1(mailbox, errorCode, errorMessage, isArchive);
        }
        FailedSearchMailbox.prototype.constructor_0 = function (mailbox, errorCode, errorMessage) {
            this.constructor_1(mailbox, errorCode, errorMessage, false);
        };
        FailedSearchMailbox.prototype.constructor_1 = function (mailbox, errorCode, errorMessage, isArchive) {
            this.Mailbox = mailbox;
            this.ErrorCode = errorCode;
            this.ErrorMessage = errorMessage;
            this.IsArchive = isArchive;
        };
        FailedSearchMailbox.LoadFailedMailboxesXml = function (rootXmlNamespace, reader) {
            var list = new List();
            reader.EnsureCurrentNodeIsStartElement(rootXmlNamespace, "FailedMailboxes");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "FailedMailbox")) {
                    var mailbox = reader.ReadElementValue(XmlNamespace.Types, "Mailbox");
                    var errorCode = 0;
                    (function () {
                        var _p0 = [
                            errorCode
                        ];
                        var _r = NNumber.TryParse(reader.ReadElementValue(XmlNamespace.Types, "ErrorCode"), _p0);
                        errorCode = _p0[0];
                        return _r;
                    })();
                    var errorMessage = reader.ReadElementValue(XmlNamespace.Types, "ErrorMessage");
                    var isArchive = false;
                    (function () {
                        var _p0 = [
                            isArchive
                        ];
                        var _r = NBoolean.TryParse(reader.ReadElementValue(XmlNamespace.Types, "IsArchive"), _p0);
                        isArchive = _p0[0];
                        return _r;
                    })();
                    list.Add(new FailedSearchMailbox(mailbox, errorCode, errorMessage, isArchive));
                }
            } while (!reader.IsEndElement(rootXmlNamespace, "FailedMailboxes"));
            if (list.Count !== 0) {
                return list.ToArray();
            }
            return null;
        };
        return FailedSearchMailbox;
    }());
    var KeywordStatisticsSearchResult = (function () {
        function KeywordStatisticsSearchResult() {
            this.Keyword = null;
            this.ItemHits = 0;
            this.Size = 0;
            _super.call(this);
        }
        return KeywordStatisticsSearchResult;
    }());
    var MailboxHoldStatus = (function () {
        function MailboxHoldStatus(mailbox, status, additionalInfo) {
            this.Mailbox = null;
            this.Status = 0;
            this.AdditionalInfo = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(mailbox, status, additionalInfo);
        }
        MailboxHoldStatus.prototype.constructor_0 = function () {
        };
        MailboxHoldStatus.prototype.constructor_1 = function (mailbox, status, additionalInfo) {
            this.Mailbox = mailbox;
            this.Status = status;
            this.AdditionalInfo = additionalInfo;
        };
        return MailboxHoldStatus;
    }());
    var MailboxHoldResult = (function () {
        function MailboxHoldResult() {
            this.HoldId = null;
            this.Query = null;
            this.Statuses = null;
            _super.call(this);
        }
        MailboxHoldResult.LoadFromXml = function (reader) {
            var list = new List();
            reader.ReadStartElement(XmlNamespace.Messages, "MailboxHoldResult");
            var mailboxHoldResult = new MailboxHoldResult();
            mailboxHoldResult.HoldId = reader.ReadElementValue(XmlNamespace.Types, "HoldId");
            reader.Read();
            mailboxHoldResult.Query = NString.Empty;
            if (reader.IsStartElement(XmlNamespace.Types, "Query")) {
                mailboxHoldResult.Query = reader.ReadElementValue(XmlNamespace.Types, "Query");
                reader.ReadStartElement(XmlNamespace.Types, "MailboxHoldStatuses");
            }
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "MailboxHoldStatus")) {
                    var mailbox = reader.ReadElementValue(XmlNamespace.Types, "Mailbox");
                    var status = Enum.Parse(new Type("Number"), reader.ReadElementValue(XmlNamespace.Types, "Status"));
                    var additionalInfo = reader.ReadElementValue(XmlNamespace.Types, "AdditionalInfo");
                    list.Add(new MailboxHoldStatus(mailbox, status, additionalInfo));
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "MailboxHoldResult"));
            mailboxHoldResult.Statuses = ((list.Count === 0) ? null : list.ToArray());
            return mailboxHoldResult;
        };
        MailboxHoldResult.LoadFromJson = function (jsonObject) {
            var list = new List();
            var mailboxHoldResult = new MailboxHoldResult();
            if (jsonObject.ContainsKey("HoldId")) {
                mailboxHoldResult.HoldId = jsonObject.ReadAsString("HoldId");
            }
            if (jsonObject.ContainsKey("Query")) {
                mailboxHoldResult.Query = jsonObject.ReadAsString("Query");
            }
            if (jsonObject.ContainsKey("Statuses")) {
                var array = jsonObject.ReadAsArray("Statuses");
                for (var i = 0; i < array.length; i = i + 1) {
                    var obj = array[i];
                    var mailboxHoldStatus = new MailboxHoldStatus();
                    var jsonObject2 = ((obj instanceof JsonObject) ? obj : null);
                    if (jsonObject2.ContainsKey("Mailbox")) {
                        mailboxHoldStatus.Mailbox = jsonObject2.ReadAsString("Mailbox");
                    }
                    if (jsonObject2.ContainsKey("Status")) {
                        mailboxHoldStatus.Status = Enum.Parse(new Type("Number"), jsonObject2.ReadAsString("Status"));
                    }
                    if (jsonObject2.ContainsKey("AdditionalInfo")) {
                        mailboxHoldStatus.AdditionalInfo = jsonObject2.ReadAsString("AdditionalInfo");
                    }
                    list.Add(mailboxHoldStatus);
                }
            }
            mailboxHoldResult.Statuses = ((list.Count === 0) ? null : list.ToArray());
            return mailboxHoldResult;
        };
        return MailboxHoldResult;
    }());
    var MailboxQuery = (function () {
        function MailboxQuery(query, searchScopes) {
            this.Query = null;
            this.MailboxSearchScopes = null;
            _super.call(this);
            this.Query = query;
            this.MailboxSearchScopes = searchScopes;
        }
        return MailboxQuery;
    }());
    var MailboxSearchScope = (function () {
        function MailboxSearchScope(mailbox, searchScope) {
            this.searchScope = MailboxSearchLocation.All;
            this.scopeType = 0;
            this.Mailbox = null;
            this.ExtendedAttributes = null;
            _super.call(this);
            this.Mailbox = mailbox;
            this.searchScope = searchScope;
            this.ExtendedAttributes = new ExtendedAttributes();
        }
        Object.defineProperty(MailboxSearchScope.prototype, "SearchScope", {
            get: function () {
                return this.searchScope;
            },
            set: function (value) {
                this.searchScope = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MailboxSearchScope.prototype, "SearchScopeType", {
            get: function () {
                return this.scopeType;
            },
            set: function (value) {
                this.scopeType = value;
            },
            enumerable: true,
            configurable: true
        });
        return MailboxSearchScope;
    }());
    var PreviewItemMailbox = (function () {
        function PreviewItemMailbox(mailboxId, primarySmtpAddress) {
            this.MailboxId = null;
            this.PrimarySmtpAddress = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(mailboxId, primarySmtpAddress);
        }
        PreviewItemMailbox.prototype.constructor_0 = function () {
        };
        PreviewItemMailbox.prototype.constructor_1 = function (mailboxId, primarySmtpAddress) {
            this.MailboxId = mailboxId;
            this.PrimarySmtpAddress = primarySmtpAddress;
        };
        return PreviewItemMailbox;
    }());
    var ItemIndexError;
    (function (ItemIndexError) {
        ItemIndexError[ItemIndexError["None"] = 0] = "None";
        ItemIndexError[ItemIndexError["GenericError"] = 1] = "GenericError";
        ItemIndexError[ItemIndexError["Timeout"] = 2] = "Timeout";
        ItemIndexError[ItemIndexError["StaleEvent"] = 3] = "StaleEvent";
        ItemIndexError[ItemIndexError["MailboxOffline"] = 4] = "MailboxOffline";
        ItemIndexError[ItemIndexError["AttachmentLimitReached"] = 5] = "AttachmentLimitReached";
        ItemIndexError[ItemIndexError["MarsWriterTruncation"] = 6] = "MarsWriterTruncation";
    })(ItemIndexError || (ItemIndexError = {}));
    var NonIndexableItem = (function () {
        function NonIndexableItem() {
            this.ItemId = null;
            this.ErrorCode = 0;
            this.ErrorDescription = null;
            this.IsPartiallyIndexed = false;
            this.IsPermanentFailure = false;
            this.AttemptCount = 0;
            this.LastAttemptTime = null;
            this.AdditionalInfo = null;
            this.SortValue = null;
            _super.call(this);
        }
        NonIndexableItem.LoadFromXml = function (reader) {
            var result = null;
            if (reader.IsStartElement(XmlNamespace.Types, "NonIndexableItemDetail")) {
                var itemId = null;
                var errorCode = ItemIndexError.None;
                var errorDescription = null;
                var isPartiallyIndexed = false;
                var isPermanentFailure = false;
                var attemptCount = 0;
                var lastAttemptTime = new Nullable();
                var additionalInfo = null;
                var sortValue = null;
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "ItemId")) {
                        itemId = new ItemId();
                        itemId.ReadAttributesFromXml(reader);
                    }
                    else {
                        if (reader.IsStartElement(XmlNamespace.Types, "ErrorDescription")) {
                            errorDescription = reader.ReadElementValue(XmlNamespace.Types, "ErrorDescription");
                        }
                        else {
                            if (reader.IsStartElement(XmlNamespace.Types, "IsPartiallyIndexed")) {
                                isPartiallyIndexed = reader.ReadElementValue(XmlNamespace.Types, "IsPartiallyIndexed");
                            }
                            else {
                                if (reader.IsStartElement(XmlNamespace.Types, "IsPermanentFailure")) {
                                    isPermanentFailure = reader.ReadElementValue(XmlNamespace.Types, "IsPermanentFailure");
                                }
                                else {
                                    if (reader.IsStartElement(XmlNamespace.Types, "AttemptCount")) {
                                        attemptCount = reader.ReadElementValue(XmlNamespace.Types, "AttemptCount");
                                    }
                                    else {
                                        if (reader.IsStartElement(XmlNamespace.Types, "LastAttemptTime")) {
                                            lastAttemptTime = new Nullable(reader.ReadElementValue(XmlNamespace.Types, "LastAttemptTime"));
                                        }
                                        else {
                                            if (reader.IsStartElement(XmlNamespace.Types, "AdditionalInfo")) {
                                                additionalInfo = reader.ReadElementValue(XmlNamespace.Types, "AdditionalInfo");
                                            }
                                            else {
                                                if (reader.IsStartElement(XmlNamespace.Types, "SortValue")) {
                                                    sortValue = reader.ReadElementValue(XmlNamespace.Types, "SortValue");
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Types, "NonIndexableItemDetail"));
                var nonIndexableItem = new NonIndexableItem();
                nonIndexableItem.ItemId = itemId;
                nonIndexableItem.ErrorCode = errorCode;
                nonIndexableItem.ErrorDescription = errorDescription;
                nonIndexableItem.IsPartiallyIndexed = isPartiallyIndexed;
                nonIndexableItem.IsPermanentFailure = isPermanentFailure;
                nonIndexableItem.AttemptCount = attemptCount;
                nonIndexableItem.LastAttemptTime = lastAttemptTime;
                nonIndexableItem.AdditionalInfo = additionalInfo;
                nonIndexableItem.SortValue = sortValue;
                result = nonIndexableItem;
            }
            return result;
        };
        return NonIndexableItem;
    }());
    var NonIndexableItemDetailsResult = (function () {
        function NonIndexableItemDetailsResult() {
            this.Items = null;
            this.FailedMailboxes = null;
            _super.call(this);
        }
        NonIndexableItemDetailsResult.LoadFromXml = function (reader) {
            var nonIndexableItemDetailsResult = new NonIndexableItemDetailsResult();
            reader.ReadStartElement(XmlNamespace.Messages, "NonIndexableItemDetailsResult");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "Items")) {
                    var list = new List();
                    if (!reader.IsEmptyElement) {
                        do {
                            reader.Read();
                            var nonIndexableItem = NonIndexableItem.LoadFromXml(reader);
                            if (nonIndexableItem !== null) {
                                list.Add(nonIndexableItem);
                            }
                        } while (!reader.IsEndElement(XmlNamespace.Types, "Items"));
                        nonIndexableItemDetailsResult.Items = list.ToArray();
                    }
                }
                if (reader.IsStartElement(XmlNamespace.Types, "FailedMailboxes")) {
                    nonIndexableItemDetailsResult.FailedMailboxes = FailedSearchMailbox.LoadFailedMailboxesXml(XmlNamespace.Types, reader);
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "NonIndexableItemDetailsResult"));
            return nonIndexableItemDetailsResult;
        };
        NonIndexableItemDetailsResult.LoadFromJson = function (jsonObject) {
            return new NonIndexableItemDetailsResult();
        };
        return NonIndexableItemDetailsResult;
    }());
    var NonIndexableItemParameters = (function () {
        function NonIndexableItemParameters() {
            this.Mailboxes = null;
            this.SearchArchiveOnly = false;
            _super.call(this);
        }
        return NonIndexableItemParameters;
    }());
    var GetNonIndexableItemStatisticsParameters = (function (_super) {
        __extends(GetNonIndexableItemStatisticsParameters, _super);
        function GetNonIndexableItemStatisticsParameters() {
            _super.call(this);
        }
        return GetNonIndexableItemStatisticsParameters;
    }(NonIndexableItemParameters));
    var GetNonIndexableItemDetailsParameters = (function (_super) {
        __extends(GetNonIndexableItemDetailsParameters, _super);
        function GetNonIndexableItemDetailsParameters() {
            _super.call(this);
            this.PageSize = null;
            this.PageItemReference = null;
            this.PageDirection = null;
        }
        return GetNonIndexableItemDetailsParameters;
    }(NonIndexableItemParameters));
    var NonIndexableItemStatistic = (function () {
        function NonIndexableItemStatistic() {
            this.Mailbox = null;
            this.ItemCount = 0;
            this.ErrorMessage = null;
            _super.call(this);
        }
        NonIndexableItemStatistic.LoadFromXml = function (reader) {
            var list = new List();
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Messages, "NonIndexableItemStatistics")) {
                do {
                    reader.Read();
                    if (reader.IsStartElement(XmlNamespace.Types, "NonIndexableItemStatistic")) {
                        var mailbox = reader.ReadElementValue(XmlNamespace.Types, "Mailbox");
                        var num = reader.ReadElementValue(XmlNamespace.Types, "ItemCount");
                        var errorMessage = null;
                        if (reader.IsStartElement(XmlNamespace.Types, "ErrorMessage")) {
                            errorMessage = reader.ReadElementValue(XmlNamespace.Types, "ErrorMessage");
                        }
                        var arg_8B_0 = list;
                        var nonIndexableItemStatistic = new NonIndexableItemStatistic();
                        nonIndexableItemStatistic.Mailbox = mailbox;
                        nonIndexableItemStatistic.ItemCount = num;
                        nonIndexableItemStatistic.ErrorMessage = errorMessage;
                        arg_8B_0.Add(nonIndexableItemStatistic);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "NonIndexableItemStatistics"));
            }
            return list;
        };
        return NonIndexableItemStatistic;
    }());
    var PreviewItemResponseShape = (function () {
        function PreviewItemResponseShape(baseShape, additionalProperties) {
            this.BaseShape = 0;
            this.AdditionalProperties = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(baseShape, additionalProperties);
        }
        PreviewItemResponseShape.prototype.constructor_0 = function () {
        };
        PreviewItemResponseShape.prototype.constructor_1 = function (baseShape, additionalProperties) {
            this.BaseShape = baseShape;
            this.AdditionalProperties = additionalProperties;
        };
        return PreviewItemResponseShape;
    }());
    var SearchableMailbox = (function () {
        function SearchableMailbox(guid, smtpAddress, isExternalMailbox, externalEmailAddress, displayName, isMembershipGroup, referenceId) {
            this.Guid = null;
            this.SmtpAddress = null;
            this.IsExternalMailbox = false;
            this.ExternalEmailAddress = null;
            this.DisplayName = null;
            this.IsMembershipGroup = false;
            this.ReferenceId = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(guid, smtpAddress, isExternalMailbox, externalEmailAddress, displayName, isMembershipGroup, referenceId);
        }
        SearchableMailbox.prototype.constructor_0 = function () {
        };
        SearchableMailbox.prototype.constructor_1 = function (guid, smtpAddress, isExternalMailbox, externalEmailAddress, displayName, isMembershipGroup, referenceId) {
            this.Guid = guid;
            this.SmtpAddress = smtpAddress;
            this.IsExternalMailbox = isExternalMailbox;
            this.ExternalEmailAddress = externalEmailAddress;
            this.DisplayName = displayName;
            this.IsMembershipGroup = isMembershipGroup;
            this.ReferenceId = referenceId;
        };
        SearchableMailbox.LoadFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "SearchableMailbox");
            var searchableMailbox = new SearchableMailbox();
            searchableMailbox.Guid = new Guid(reader.ReadElementValue(XmlNamespace.Types, "Guid"));
            searchableMailbox.SmtpAddress = reader.ReadElementValue(XmlNamespace.Types, "PrimarySmtpAddress");
            var isExternalMailbox = false;
            (function () {
                var _p0 = [
                    isExternalMailbox
                ];
                var _r = NBoolean.TryParse(reader.ReadElementValue(XmlNamespace.Types, "IsExternalMailbox"), _p0);
                isExternalMailbox = _p0[0];
                return _r;
            })();
            searchableMailbox.IsExternalMailbox = isExternalMailbox;
            searchableMailbox.ExternalEmailAddress = reader.ReadElementValue(XmlNamespace.Types, "ExternalEmailAddress");
            searchableMailbox.DisplayName = reader.ReadElementValue(XmlNamespace.Types, "DisplayName");
            var isMembershipGroup = false;
            (function () {
                var _p0 = [
                    isMembershipGroup
                ];
                var _r = NBoolean.TryParse(reader.ReadElementValue(XmlNamespace.Types, "IsMembershipGroup"), _p0);
                isMembershipGroup = _p0[0];
                return _r;
            })();
            searchableMailbox.IsMembershipGroup = isMembershipGroup;
            searchableMailbox.ReferenceId = reader.ReadElementValue(XmlNamespace.Types, "ReferenceId");
            return searchableMailbox;
        };
        SearchableMailbox.LoadFromJson = function (jsonObject) {
            var searchableMailbox = new SearchableMailbox();
            if (jsonObject.ContainsKey("Guid")) {
                searchableMailbox.Guid = new Guid(jsonObject.ReadAsString("Guid"));
            }
            if (jsonObject.ContainsKey("DisplayName")) {
                searchableMailbox.DisplayName = jsonObject.ReadAsString("DisplayName");
            }
            if (jsonObject.ContainsKey("PrimarySmtpAddress")) {
                searchableMailbox.SmtpAddress = jsonObject.ReadAsString("PrimarySmtpAddress");
            }
            if (jsonObject.ContainsKey("IsExternalMailbox")) {
                searchableMailbox.IsExternalMailbox = jsonObject.ReadAsBool("IsExternalMailbox");
            }
            if (jsonObject.ContainsKey("ExternalEmailAddress")) {
                searchableMailbox.ExternalEmailAddress = jsonObject.ReadAsString("ExternalEmailAddress");
            }
            if (jsonObject.ContainsKey("IsMembershipGroup")) {
                searchableMailbox.IsMembershipGroup = jsonObject.ReadAsBool("IsMembershipGroup");
            }
            if (jsonObject.ContainsKey("ReferenceId")) {
                searchableMailbox.ReferenceId = jsonObject.ReadAsString("ReferenceId");
            }
            return searchableMailbox;
        };
        return SearchableMailbox;
    }());
    var SearchMailboxesParameters = (function () {
        function SearchMailboxesParameters() {
            this.SearchQueries = null;
            this.ResultType = 0;
            this.SortBy = null;
            this.SortOrder = 0;
            this.PerformDeduplication = false;
            this.PageSize = 0;
            this.PageDirection = 0;
            this.PageItemReference = null;
            this.PreviewItemResponseShape = null;
            this.Language = null;
            _super.call(this);
        }
        return SearchMailboxesParameters;
    }());
    var SearchMailboxesResult = (function () {
        function SearchMailboxesResult() {
            this.SearchQueries = null;
            this.ResultType = 0;
            this.ItemCount = 0;
            this.Size = 0;
            this.PageItemCount = 0;
            this.PageItemSize = 0;
            this.KeywordStats = null;
            this.PreviewItems = null;
            this.FailedMailboxes = null;
            this.Refiners = null;
            this.MailboxStats = null;
            _super.call(this);
        }
        SearchMailboxesResult.LoadFromXml = function (reader) {
            var searchMailboxesResult = new SearchMailboxesResult();
            reader.ReadStartElement(XmlNamespace.Messages, "SearchMailboxesResult");
            var list = new List();
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "SearchQueries")) {
                    reader.ReadStartElement(XmlNamespace.Types, "MailboxQuery");
                    var query = reader.ReadElementValue(XmlNamespace.Types, "Query");
                    reader.ReadStartElement(XmlNamespace.Types, "MailboxSearchScopes");
                    var list2 = new List();
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "MailboxSearchScope")) {
                            var mailbox = reader.ReadElementValue(XmlNamespace.Types, "Mailbox");
                            reader.ReadStartElement(XmlNamespace.Types, "SearchScope");
                            var value = reader.ReadElementValue(XmlNamespace.Types, "SearchScope");
                            reader.ReadEndElement(XmlNamespace.Types, "MailboxSearchScope");
                            list2.Add(new MailboxSearchScope(mailbox, Enum.Parse(new Type("Number"), value)));
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "MailboxSearchScopes"));
                    reader.ReadEndElementIfNecessary(XmlNamespace.Types, "MailboxSearchScopes");
                    list.Add(new MailboxQuery(query, list2.ToArray()));
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "SearchQueries"));
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, "SearchQueries");
            searchMailboxesResult.SearchQueries = list.ToArray();
            searchMailboxesResult.ResultType = Enum.Parse(new Type("Number"), reader.ReadElementValue(XmlNamespace.Types, "ResultType"));
            searchMailboxesResult.ItemCount = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "ItemCount"));
            searchMailboxesResult.Size = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "Size"));
            searchMailboxesResult.PageItemCount = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "PageItemCount"));
            searchMailboxesResult.PageItemSize = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "PageItemSize"));
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "KeywordStats")) {
                    searchMailboxesResult.KeywordStats = SearchMailboxesResult.LoadKeywordStatsXml(reader);
                }
                if (reader.IsStartElement(XmlNamespace.Types, "Items")) {
                    searchMailboxesResult.PreviewItems = SearchMailboxesResult.LoadPreviewItemsXml(reader);
                }
                if (reader.IsStartElement(XmlNamespace.Types, "FailedMailboxes")) {
                    searchMailboxesResult.FailedMailboxes = FailedSearchMailbox.LoadFailedMailboxesXml(XmlNamespace.Types, reader);
                }
                if (reader.IsStartElement(XmlNamespace.Types, "Refiners")) {
                    var list3 = new List();
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "Refiner")) {
                            list3.Add(SearchRefinerItem.LoadFromXml(reader));
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "Refiners"));
                    if (list3.Count > 0) {
                        searchMailboxesResult.Refiners = list3.ToArray();
                    }
                }
                if (reader.IsStartElement(XmlNamespace.Types, "MailboxStats")) {
                    var list4 = new List();
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "MailboxStat")) {
                            list4.Add(MailboxStatisticsItem.LoadFromXml(reader));
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "MailboxStats"));
                    if (list4.Count > 0) {
                        searchMailboxesResult.MailboxStats = list4.ToArray();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "SearchMailboxesResult"));
            return searchMailboxesResult;
        };
        SearchMailboxesResult.LoadFromJson = function (jsonObject) {
            return new SearchMailboxesResult();
        };
        SearchMailboxesResult.LoadKeywordStatsXml = function (reader) {
            var list = new List();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "KeywordStats");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "KeywordStat")) {
                    var keywordStatisticsSearchResult = new KeywordStatisticsSearchResult();
                    keywordStatisticsSearchResult.Keyword = reader.ReadElementValue(XmlNamespace.Types, "Keyword");
                    keywordStatisticsSearchResult.ItemHits = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "ItemHits"));
                    keywordStatisticsSearchResult.Size = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "Size"));
                    list.Add(keywordStatisticsSearchResult);
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "KeywordStats"));
            if (list.Count !== 0) {
                return list.ToArray();
            }
            return null;
        };
        SearchMailboxesResult.LoadPreviewItemsXml = function (reader) {
            var list = new List();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "Items");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "SearchPreviewItem")) {
                    var searchPreviewItem = new SearchPreviewItem();
                    do {
                        reader.Read();
                        if (reader.IsStartElement(XmlNamespace.Types, "Id")) {
                            searchPreviewItem.Id = new ItemId();
                            searchPreviewItem.Id.ReadAttributesFromXml(reader);
                        }
                        else {
                            if (reader.IsStartElement(XmlNamespace.Types, "ParentId")) {
                                searchPreviewItem.ParentId = new ItemId();
                                searchPreviewItem.ParentId.ReadAttributesFromXml(reader);
                            }
                            else {
                                if (reader.IsStartElement(XmlNamespace.Types, "Mailbox")) {
                                    searchPreviewItem.Mailbox = new PreviewItemMailbox();
                                    searchPreviewItem.Mailbox.MailboxId = reader.ReadElementValue(XmlNamespace.Types, "MailboxId");
                                    searchPreviewItem.Mailbox.PrimarySmtpAddress = reader.ReadElementValue(XmlNamespace.Types, "PrimarySmtpAddress");
                                }
                                else {
                                    if (reader.IsStartElement(XmlNamespace.Types, "UniqueHash")) {
                                        searchPreviewItem.UniqueHash = reader.ReadElementValue(XmlNamespace.Types, "UniqueHash");
                                    }
                                    else {
                                        if (reader.IsStartElement(XmlNamespace.Types, "SortValue")) {
                                            searchPreviewItem.SortValue = reader.ReadElementValue(XmlNamespace.Types, "SortValue");
                                        }
                                        else {
                                            if (reader.IsStartElement(XmlNamespace.Types, "OwaLink")) {
                                                searchPreviewItem.OwaLink = reader.ReadElementValue(XmlNamespace.Types, "OwaLink");
                                            }
                                            else {
                                                if (reader.IsStartElement(XmlNamespace.Types, "Sender")) {
                                                    searchPreviewItem.Sender = reader.ReadElementValue(XmlNamespace.Types, "Sender");
                                                }
                                                else {
                                                    if (reader.IsStartElement(XmlNamespace.Types, "ToRecipients")) {
                                                        searchPreviewItem.ToRecipients = SearchMailboxesResult.GetRecipients(reader, "ToRecipients");
                                                    }
                                                    else {
                                                        if (reader.IsStartElement(XmlNamespace.Types, "CcRecipients")) {
                                                            searchPreviewItem.CcRecipients = SearchMailboxesResult.GetRecipients(reader, "CcRecipients");
                                                        }
                                                        else {
                                                            if (reader.IsStartElement(XmlNamespace.Types, "BccRecipients")) {
                                                                searchPreviewItem.BccRecipients = SearchMailboxesResult.GetRecipients(reader, "BccRecipients");
                                                            }
                                                            else {
                                                                if (reader.IsStartElement(XmlNamespace.Types, "CreatedTime")) {
                                                                    searchPreviewItem.CreatedTime = DateTime.Parse(reader.ReadElementValue(XmlNamespace.Types, "CreatedTime"));
                                                                }
                                                                else {
                                                                    if (reader.IsStartElement(XmlNamespace.Types, "ReceivedTime")) {
                                                                        searchPreviewItem.ReceivedTime = DateTime.Parse(reader.ReadElementValue(XmlNamespace.Types, "ReceivedTime"));
                                                                    }
                                                                    else {
                                                                        if (reader.IsStartElement(XmlNamespace.Types, "SentTime")) {
                                                                            searchPreviewItem.SentTime = DateTime.Parse(reader.ReadElementValue(XmlNamespace.Types, "SentTime"));
                                                                        }
                                                                        else {
                                                                            if (reader.IsStartElement(XmlNamespace.Types, "Subject")) {
                                                                                searchPreviewItem.Subject = reader.ReadElementValue(XmlNamespace.Types, "Subject");
                                                                            }
                                                                            else {
                                                                                if (reader.IsStartElement(XmlNamespace.Types, "Preview")) {
                                                                                    searchPreviewItem.Preview = reader.ReadElementValue(XmlNamespace.Types, "Preview");
                                                                                }
                                                                                else {
                                                                                    if (reader.IsStartElement(XmlNamespace.Types, "Size")) {
                                                                                        searchPreviewItem.Size = NNumber.Parse(reader.ReadElementValue(XmlNamespace.Types, "Size"));
                                                                                    }
                                                                                    else {
                                                                                        if (reader.IsStartElement(XmlNamespace.Types, "Importance")) {
                                                                                            searchPreviewItem.Importance = Enum.Parse(new Type("Number"), reader.ReadElementValue(XmlNamespace.Types, "Importance"));
                                                                                        }
                                                                                        else {
                                                                                            if (reader.IsStartElement(XmlNamespace.Types, "Read")) {
                                                                                                searchPreviewItem.Read = NBoolean.Parse(reader.ReadElementValue(XmlNamespace.Types, "Read"));
                                                                                            }
                                                                                            else {
                                                                                                if (reader.IsStartElement(XmlNamespace.Types, "HasAttachment")) {
                                                                                                    searchPreviewItem.HasAttachment = NBoolean.Parse(reader.ReadElementValue(XmlNamespace.Types, "HasAttachment"));
                                                                                                }
                                                                                                else {
                                                                                                    if (reader.IsStartElement(XmlNamespace.Types, "ExtendedProperties")) {
                                                                                                        searchPreviewItem.ExtendedProperties = SearchMailboxesResult.LoadExtendedPropertiesXml(reader);
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    } while (!reader.IsEndElement(XmlNamespace.Types, "SearchPreviewItem"));
                    list.Add(searchPreviewItem);
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "Items"));
            if (list.Count !== 0) {
                return list.ToArray();
            }
            return null;
        };
        SearchMailboxesResult.GetRecipients = function (reader, elementName) {
            var list = new List();
            do {
                if (reader.IsStartElement(XmlNamespace.Types, "SmtpAddress")) {
                    list.Add(reader.ReadElementValue(XmlNamespace.Types, "SmtpAddress"));
                }
                reader.Read();
            } while (!reader.IsEndElement(XmlNamespace.Types, elementName));
            if (list.Count !== 0) {
                return list.ToArray();
            }
            return null;
        };
        SearchMailboxesResult.LoadExtendedPropertiesXml = function (reader) {
            var extendedPropertyCollection = new ExtendedPropertyCollection();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "ExtendedProperties");
            do {
                reader.Read();
                if (reader.IsStartElement(XmlNamespace.Types, "ExtendedProperty")) {
                    extendedPropertyCollection.LoadFromXml(reader, "ExtendedProperty");
                }
            } while (!reader.IsEndElement(XmlNamespace.Types, "ExtendedProperties"));
            if (extendedPropertyCollection.Count !== 0) {
                return extendedPropertyCollection;
            }
            return null;
        };
        return SearchMailboxesResult;
    }());
    var SearchRefinerItem = (function () {
        function SearchRefinerItem() {
            this.Name = null;
            this.Value = null;
            this.Count = 0;
            this.Token = null;
            _super.call(this);
        }
        SearchRefinerItem.LoadFromXml = function (reader) {
            var searchRefinerItem = new SearchRefinerItem();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "Refiner");
            searchRefinerItem.Name = reader.ReadElementValue(XmlNamespace.Types, "Name");
            searchRefinerItem.Value = reader.ReadElementValue(XmlNamespace.Types, "Value");
            searchRefinerItem.Count = reader.ReadElementValue(XmlNamespace.Types, "Count");
            searchRefinerItem.Token = reader.ReadElementValue(XmlNamespace.Types, "Token");
            return searchRefinerItem;
        };
        return SearchRefinerItem;
    }());
    var MailboxStatisticsItem = (function () {
        function MailboxStatisticsItem() {
            this.MailboxId = null;
            this.DisplayName = null;
            this.ItemCount = 0;
            this.Size = 0;
            _super.call(this);
        }
        MailboxStatisticsItem.LoadFromXml = function (reader) {
            var mailboxStatisticsItem = new MailboxStatisticsItem();
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "MailboxStat");
            mailboxStatisticsItem.MailboxId = reader.ReadElementValue(XmlNamespace.Types, "MailboxId");
            mailboxStatisticsItem.DisplayName = reader.ReadElementValue(XmlNamespace.Types, "DisplayName");
            mailboxStatisticsItem.ItemCount = reader.ReadElementValue(XmlNamespace.Types, "ItemCount");
            mailboxStatisticsItem.Size = reader.ReadElementValue(XmlNamespace.Types, "Size");
            return mailboxStatisticsItem;
        };
        return MailboxStatisticsItem;
    }());
    var SearchPreviewItem = (function () {
        function SearchPreviewItem() {
            this.Id = null;
            this.Mailbox = null;
            this.ParentId = null;
            this.ItemClass = null;
            this.UniqueHash = null;
            this.SortValue = null;
            this.OwaLink = null;
            this.Sender = null;
            this.ToRecipients = null;
            this.CcRecipients = null;
            this.BccRecipients = null;
            this.CreatedTime = null;
            this.ReceivedTime = null;
            this.SentTime = null;
            this.Subject = null;
            this.Size = 0;
            this.Preview = null;
            this.Importance = 0;
            this.Read = false;
            this.HasAttachment = false;
            this.ExtendedProperties = null;
            _super.call(this);
        }
        return SearchPreviewItem;
    }());
    var SetHoldOnMailboxesParameters = (function () {
        function SetHoldOnMailboxesParameters() {
            this.ActionType = 0;
            this.HoldId = null;
            this.Query = null;
            this.Mailboxes = null;
            this.Language = null;
            this.InPlaceHoldIdentity = null;
            _super.call(this);
        }
        return SetHoldOnMailboxesParameters;
    }());
    var DiscoverySchemaChanges = (function () {
        function DiscoverySchemaChanges() {
        }
        DiscoverySchemaChanges.DiscoverySchemaChanges_cctor = function () {
            DiscoverySchemaChanges.SearchMailboxesExtendedData = new DiscoverySchemaChanges_SchemaChange("15.0.730.0");
            DiscoverySchemaChanges.SearchMailboxesAdditionalSearchScopes = new DiscoverySchemaChanges_SchemaChange("15.0.730.0");
        };
        DiscoverySchemaChanges.SearchMailboxesExtendedData = null;
        DiscoverySchemaChanges.SearchMailboxesAdditionalSearchScopes = null;
        return DiscoverySchemaChanges;
    }());
    var DiscoverySchemaChanges_SchemaChange = (function () {
        function DiscoverySchemaChanges_SchemaChange(serverVersionOrServerBuild) {
            this.MinimumServerVersion = 0;
            _super.call(this);
            if (arguments.length === 1 && (serverVersionOrServerBuild === null || serverVersionOrServerBuild.constructor === Number)) {
                this.constructor_0(serverVersionOrServerBuild);
                return;
            }
            this.constructor_1(serverVersionOrServerBuild);
        }
        DiscoverySchemaChanges_SchemaChange.prototype.constructor_0 = function (serverVersion) {
            this.MinimumServerVersion = serverVersion;
        };
        DiscoverySchemaChanges_SchemaChange.prototype.constructor_1 = function (serverBuild) {
            var version = new Version(serverBuild);
            this.MinimumServerVersion = ((version.Build & 32767) | (version.Minor & 63) << 16 | (version.Major & 63) << 22 | 1879080960);
        };
        DiscoverySchemaChanges_SchemaChange.prototype.IsCompatible = function (versionable) {
            return versionable.ServerVersion === 0 || versionable.ServerVersion >= this.MinimumServerVersion;
        };
        return DiscoverySchemaChanges_SchemaChange;
    }());
    var AbstractFolderIdWrapper = (function () {
        function AbstractFolderIdWrapper() {
            _super.call(this);
        }
        AbstractFolderIdWrapper.prototype.GetFolder = function () {
            return null;
        };
        AbstractFolderIdWrapper.prototype.WriteToXml = function (writer) {
            throw new NotSupportedException();
        };
        AbstractFolderIdWrapper.prototype.Validate = function (version) {
        };
        AbstractFolderIdWrapper.prototype.ToJson = function (service) {
            return this.InternalToJson(service);
        };
        AbstractFolderIdWrapper.prototype.InternalToJson = function (service) {
            throw new NotSupportedException();
        };
        return AbstractFolderIdWrapper;
    }());
    var AbstractItemIdWrapper = (function () {
        function AbstractItemIdWrapper() {
            _super.call(this);
        }
        AbstractItemIdWrapper.prototype.GetItem = function () {
            return null;
        };
        AbstractItemIdWrapper.prototype.WriteToXml = function (writer) {
            throw new NotSupportedException();
        };
        AbstractItemIdWrapper.prototype.ToJson = function (service) {
            return this.IternalToJson(service);
        };
        AbstractItemIdWrapper.prototype.IternalToJson = function (service) {
            throw new NotSupportedException();
        };
        return AbstractItemIdWrapper;
    }());
    var CalendarActionResults = (function () {
        function CalendarActionResults(items) {
            this.appointment = null;
            this.meetingRequest = null;
            this.meetingResponse = null;
            this.meetingCancellation = null;
            _super.call(this);
            this.appointment = EwsUtilities.FindFirstItemOfType(items);
            this.meetingRequest = EwsUtilities.FindFirstItemOfType(items);
            this.meetingResponse = EwsUtilities.FindFirstItemOfType(items);
            this.meetingCancellation = EwsUtilities.FindFirstItemOfType(items);
        }
        Object.defineProperty(CalendarActionResults.prototype, "Appointment", {
            get: function () {
                return this.appointment;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarActionResults.prototype, "MeetingRequest", {
            get: function () {
                return this.meetingRequest;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarActionResults.prototype, "MeetingResponse", {
            get: function () {
                return this.meetingResponse;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarActionResults.prototype, "MeetingCancellation", {
            get: function () {
                return this.meetingCancellation;
            },
            enumerable: true,
            configurable: true
        });
        return CalendarActionResults;
    }());
    var ConversationAction = (function () {
        function ConversationAction() {
            this.Action = 0;
            this.ConversationId = null;
            this.ProcessRightAway = false;
            this.Categories = null;
            this.EnableAlwaysDelete = false;
            this.IsRead = null;
            this.SuppressReadReceipts = null;
            this.DeleteType = null;
            this.Flag = null;
            this.ConversationLastSyncTime = null;
            this.ContextFolderId = null;
            this.DestinationFolderId = null;
            this.RetentionPolicyType = null;
            this.RetentionPolicyTagId = null;
            _super.call(this);
        }
        ConversationAction.prototype.GetXmlElementName = function () {
            return "ApplyConversationAction";
        };
        ConversationAction.prototype.Validate = function () {
            EwsUtilities.ValidateParam(this.ConversationId, "conversationId");
        };
        ConversationAction.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "ConversationAction");
            try {
                var value = NString.Empty;
                switch (this.Action) {
                    case ConversationActionType.AlwaysCategorize:
                        value = "AlwaysCategorize";
                        break;
                    case ConversationActionType.AlwaysDelete:
                        value = "AlwaysDelete";
                        break;
                    case ConversationActionType.AlwaysMove:
                        value = "AlwaysMove";
                        break;
                    case ConversationActionType.Delete:
                        value = "Delete";
                        break;
                    case ConversationActionType.Move:
                        value = "Move";
                        break;
                    case ConversationActionType.Copy:
                        value = "Copy";
                        break;
                    case ConversationActionType.SetReadState:
                        value = "SetReadState";
                        break;
                    case ConversationActionType.SetRetentionPolicy:
                        value = "SetRetentionPolicy";
                        break;
                    case ConversationActionType.Flag:
                        value = "Flag";
                        break;
                    default:
                        throw new ArgumentException("ConversationAction");
                }
                writer.WriteElementValue(XmlNamespace.Types, "Action", value);
                this.ConversationId.WriteToXml(writer, XmlNamespace.Types, "ConversationId");
                if (this.Action === ConversationActionType.AlwaysCategorize || this.Action === ConversationActionType.AlwaysDelete || this.Action === ConversationActionType.AlwaysMove) {
                    writer.WriteElementValue(XmlNamespace.Types, "ProcessRightAway", EwsUtilities.BoolToXSBool(this.ProcessRightAway));
                }
                if (this.Action === ConversationActionType.AlwaysCategorize) {
                    if (this.Categories !== null && this.Categories.Count > 0) {
                        this.Categories.WriteToXml(writer, XmlNamespace.Types, "Categories");
                    }
                }
                else {
                    if (this.Action === ConversationActionType.AlwaysDelete) {
                        writer.WriteElementValue(XmlNamespace.Types, "EnableAlwaysDelete", EwsUtilities.BoolToXSBool(this.EnableAlwaysDelete));
                    }
                    else {
                        if (this.Action === ConversationActionType.AlwaysMove) {
                            if (this.DestinationFolderId !== null) {
                                writer.WriteStartElement(XmlNamespace.Types, "DestinationFolderId");
                                this.DestinationFolderId.WriteToXml(writer);
                                writer.WriteEndElement();
                            }
                        }
                        else {
                            if (this.ContextFolderId !== null) {
                                writer.WriteStartElement(XmlNamespace.Types, "ContextFolderId");
                                this.ContextFolderId.WriteToXml(writer);
                                writer.WriteEndElement();
                            }
                            if (this.ConversationLastSyncTime !== null) {
                                writer.WriteElementValue(XmlNamespace.Types, "ConversationLastSyncTime", this.ConversationLastSyncTime.Value);
                            }
                            if (this.Action === ConversationActionType.Copy) {
                                EwsUtilities.Assert(this.DestinationFolderId !== null, "ApplyconversationActionRequest", "DestinationFolderId should be set when performing copy action");
                                writer.WriteStartElement(XmlNamespace.Types, "DestinationFolderId");
                                this.DestinationFolderId.WriteToXml(writer);
                                writer.WriteEndElement();
                            }
                            else {
                                if (this.Action === ConversationActionType.Move) {
                                    EwsUtilities.Assert(this.DestinationFolderId !== null, "ApplyconversationActionRequest", "DestinationFolderId should be set when performing move action");
                                    writer.WriteStartElement(XmlNamespace.Types, "DestinationFolderId");
                                    this.DestinationFolderId.WriteToXml(writer);
                                    writer.WriteEndElement();
                                }
                                else {
                                    if (this.Action === ConversationActionType.Delete) {
                                        EwsUtilities.Assert(this.DeleteType !== null, "ApplyconversationActionRequest", "DeleteType should be specified when deleting a conversation.");
                                        writer.WriteElementValue(XmlNamespace.Types, "DeleteType", this.DeleteType.Value);
                                    }
                                    else {
                                        if (this.Action === ConversationActionType.SetReadState) {
                                            EwsUtilities.Assert(this.IsRead !== null, "ApplyconversationActionRequest", "IsRead should be specified when marking/unmarking a conversation as read.");
                                            writer.WriteElementValue(XmlNamespace.Types, "IsRead", this.IsRead.Value);
                                            if (this.SuppressReadReceipts !== null) {
                                                writer.WriteElementValue(XmlNamespace.Types, "SuppressReadReceipts", this.SuppressReadReceipts.Value);
                                            }
                                        }
                                        else {
                                            if (this.Action === ConversationActionType.SetRetentionPolicy) {
                                                EwsUtilities.Assert(this.RetentionPolicyType !== null, "ApplyconversationActionRequest", "RetentionPolicyType should be specified when setting a retention policy on a conversation.");
                                                writer.WriteElementValue(XmlNamespace.Types, "RetentionPolicyType", this.RetentionPolicyType.Value);
                                                if (this.RetentionPolicyTagId !== null) {
                                                    writer.WriteElementValue(XmlNamespace.Types, "RetentionPolicyTagId", this.RetentionPolicyTagId.Value);
                                                }
                                            }
                                            else {
                                                if (this.Action === ConversationActionType.Flag) {
                                                    EwsUtilities.Assert(this.Flag !== null, "ApplyconversationActionRequest", "Flag should be specified when flagging conversation items.");
                                                    writer.WriteStartElement(XmlNamespace.Types, "Flag");
                                                    this.Flag.WriteElementsToXml(writer);
                                                    writer.WriteEndElement();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            finally {
                writer.WriteEndElement();
            }
        };
        ConversationAction.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Action", this.Action);
            jsonObject.Add("ConversationId", this.ConversationId.InternalToJson(service));
            if (this.Action === ConversationActionType.AlwaysCategorize || this.Action === ConversationActionType.AlwaysDelete || this.Action === ConversationActionType.AlwaysMove) {
                jsonObject.Add("ProcessRightAway", this.ProcessRightAway);
            }
            if (this.Action === ConversationActionType.AlwaysCategorize) {
                if (this.Categories !== null && this.Categories.Count > 0) {
                    jsonObject.Add("Categories", this.Categories.InternalToJson(service));
                }
            }
            else {
                if (this.Action === ConversationActionType.AlwaysDelete) {
                    jsonObject.Add("EnableAlwaysDelete", this.EnableAlwaysDelete);
                }
                else {
                    if (this.Action === ConversationActionType.AlwaysMove) {
                        if (this.DestinationFolderId !== null) {
                            var jsonObject2 = new JsonObject();
                            jsonObject2.Add("BaseFolderId", this.DestinationFolderId.InternalToJson(service));
                            jsonObject.Add("DestinationFolderId", jsonObject2);
                        }
                    }
                    else {
                        if (this.ContextFolderId !== null) {
                            var jsonObject3 = new JsonObject();
                            jsonObject3.Add("BaseFolderId", this.ContextFolderId.InternalToJson(service));
                            jsonObject.Add("ContextFolderId", jsonObject3);
                        }
                        if (this.ConversationLastSyncTime !== null) {
                            jsonObject.Add("ConversationLastSyncTime", this.ConversationLastSyncTime.Value);
                        }
                        if (this.Action === ConversationActionType.Copy) {
                            EwsUtilities.Assert(this.DestinationFolderId !== null, "ApplyconversationActionRequest", "DestinationFolderId should be set when performing copy action");
                            var jsonObject4 = new JsonObject();
                            jsonObject4.Add("BaseFolderId", this.DestinationFolderId.InternalToJson(service));
                            jsonObject.Add("DestinationFolderId", jsonObject4);
                        }
                        else {
                            if (this.Action === ConversationActionType.Move) {
                                EwsUtilities.Assert(this.DestinationFolderId !== null, "ApplyconversationActionRequest", "DestinationFolderId should be set when performing move action");
                                var jsonObject5 = new JsonObject();
                                jsonObject5.Add("BaseFolderId", this.DestinationFolderId.InternalToJson(service));
                                jsonObject.Add("DestinationFolderId", jsonObject5);
                            }
                            else {
                                if (this.Action === ConversationActionType.Delete) {
                                    EwsUtilities.Assert(this.DeleteType !== null, "ApplyconversationActionRequest", "DeleteType should be specified when deleting a conversation.");
                                    jsonObject.Add("DeleteType", this.DeleteType.Value);
                                }
                                else {
                                    if (this.Action === ConversationActionType.SetReadState) {
                                        EwsUtilities.Assert(this.IsRead !== null, "ApplyconversationActionRequest", "IsRead should be specified when marking/unmarking a conversation as read.");
                                        jsonObject.Add("IsRead", this.IsRead.Value);
                                        if (this.SuppressReadReceipts !== null) {
                                            jsonObject.Add("SuppressReadReceipts", this.SuppressReadReceipts !== null);
                                        }
                                    }
                                    else {
                                        if (this.Action === ConversationActionType.SetRetentionPolicy) {
                                            EwsUtilities.Assert(this.RetentionPolicyType !== null, "ApplyconversationActionRequest", "RetentionPolicyType should be specified when setting a retention policy on a conversation.");
                                            jsonObject.Add("RetentionPolicyType", this.RetentionPolicyType.Value);
                                            if (this.RetentionPolicyTagId !== null) {
                                                jsonObject.Add("RetentionPolicyTagId", this.RetentionPolicyTagId.Value);
                                            }
                                        }
                                        else {
                                            if (this.Action === ConversationActionType.Flag) {
                                                EwsUtilities.Assert(this.Flag !== null, "ApplyconversationActionRequest", "Flag should be specified when flagging items in a conversation.");
                                                jsonObject.Add("Flag", this.Flag.InternalToJson(service));
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return jsonObject;
        };
        return ConversationAction;
    }());
    var DelegateInformation = (function () {
        function DelegateInformation(delegateUserResponses, meetingReqestsDeliveryScope) {
            this.delegateUserResponses = null;
            this.meetingReqestsDeliveryScope = 0;
            _super.call(this);
            this.delegateUserResponses = new Collection(delegateUserResponses);
            this.meetingReqestsDeliveryScope = meetingReqestsDeliveryScope;
        }
        Object.defineProperty(DelegateInformation.prototype, "DelegateUserResponses", {
            get: function () {
                return this.delegateUserResponses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DelegateInformation.prototype, "MeetingRequestsDeliveryScope", {
            get: function () {
                return this.meetingReqestsDeliveryScope;
            },
            enumerable: true,
            configurable: true
        });
        return DelegateInformation;
    }());
    var EwsTraceListener = (function () {
        function EwsTraceListener(writer) {
            this.writer = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(writer);
        }
        EwsTraceListener.prototype.constructor_0 = function () {
            this.constructor_1(NConsole.Out);
        };
        EwsTraceListener.prototype.constructor_1 = function (writer) {
            this.writer = writer;
        };
        EwsTraceListener.prototype.Trace = function (traceType, traceMessage) {
            this.writer.Write(traceMessage);
        };
        return EwsTraceListener;
    }());
    var ExpandGroupResults = (function () {
        function ExpandGroupResults() {
            this.includesAllMembers = false;
            this.members = new Collection();
            _super.call(this);
        }
        Object.defineProperty(ExpandGroupResults.prototype, "Count", {
            get: function () {
                return this.members.Count;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExpandGroupResults.prototype, "IncludesAllMembers", {
            get: function () {
                return this.includesAllMembers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExpandGroupResults.prototype, "Members", {
            get: function () {
                return this.members;
            },
            enumerable: true,
            configurable: true
        });
        ExpandGroupResults.prototype.GetEnumerator = function () {
            return this.members.GetEnumerator();
        };
        ExpandGroupResults.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "DLExpansion");
            if (!reader.IsEmptyElement) {
                var num = reader.ReadAttributeValue("TotalItemsInView");
                this.includesAllMembers = reader.ReadAttributeValue("IncludesLastItemInRange");
                for (var i = 0; i < num; i = i + 1) {
                    var emailAddress = new EmailAddress();
                    reader.ReadStartElement(XmlNamespace.Types, "Mailbox");
                    emailAddress.LoadFromXml(reader, "Mailbox");
                    this.members.Add(emailAddress);
                }
                reader.ReadEndElement(XmlNamespace.Messages, "DLExpansion");
            }
        };
        return ExpandGroupResults;
    }());
    var FolderIdWrapper = (function (_super) {
        __extends(FolderIdWrapper, _super);
        function FolderIdWrapper(folderId) {
            _super.call(this);
            this.folderId = null;
            EwsUtilities.Assert(folderId !== null, "FolderIdWrapper.ctor", "folderId is null");
            this.folderId = folderId;
        }
        FolderIdWrapper.prototype.WriteToXml = function (writer) {
            this.folderId.WriteToXml(writer);
        };
        FolderIdWrapper.prototype.Validate = function (version) {
            this.folderId.Validate(version);
        };
        FolderIdWrapper.prototype.InternalToJson = function (service) {
            return this.folderId.InternalToJson(service);
        };
        return FolderIdWrapper;
    }(AbstractFolderIdWrapper));
    var FolderIdWrapperList = (function () {
        function FolderIdWrapperList() {
            this.ids = new List();
            _super.call(this);
        }
        Object.defineProperty(FolderIdWrapperList.prototype, "Count", {
            get: function () {
                return this.ids.Count;
            },
            enumerable: true,
            configurable: true
        });
        FolderIdWrapperList.prototype.get_Item = function (index) {
            return this.ids.get_Item(index);
        };
        FolderIdWrapperList.prototype.Add = function (folderOrFolderId) {
            if (arguments.length === 1 && (folderOrFolderId === null || folderOrFolderId instanceof Folder)) {
                this.Add_0(folderOrFolderId);
                return;
            }
            this.Add_1(folderOrFolderId);
        };
        FolderIdWrapperList.prototype.Add_0 = function (folder) {
            this.ids.Add(new FolderWrapper(folder));
        };
        FolderIdWrapperList.prototype.AddRange = function (foldersOrFolderIds) {
            if (arguments.length === 1) {
                this.AddRange_0(foldersOrFolderIds);
                return;
            }
            this.AddRange_1(foldersOrFolderIds);
        };
        FolderIdWrapperList.prototype.AddRange_0 = function (folders) {
            if (folders !== null) {
                var enumerator = folders.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        this.Add(current);
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
        };
        FolderIdWrapperList.prototype.Add_1 = function (folderId) {
            this.ids.Add(new FolderIdWrapper(folderId));
        };
        FolderIdWrapperList.prototype.AddRange_1 = function (folderIds) {
            if (folderIds !== null) {
                var enumerator = folderIds.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        this.Add(current);
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
        };
        FolderIdWrapperList.prototype.WriteToXml = function (writer, ewsNamesapce, xmlElementName) {
            if (this.Count > 0) {
                writer.WriteStartElement(ewsNamesapce, xmlElementName);
                var enumerator = this.ids.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        current.WriteToXml(writer);
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                writer.WriteEndElement();
            }
        };
        FolderIdWrapperList.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = this.ids.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.ToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list.ToArray();
        };
        FolderIdWrapperList.prototype.Validate = function (version) {
            var enumerator = this.ids.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.Validate(version);
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        FolderIdWrapperList.prototype.GetEnumerator = function () {
            return this.ids.GetEnumerator();
        };
        return FolderIdWrapperList;
    }());
    var FolderWrapper = (function (_super) {
        __extends(FolderWrapper, _super);
        function FolderWrapper(folder) {
            _super.call(this);
            this.folder = null;
            EwsUtilities.Assert(folder !== null, "FolderWrapper.ctor", "folder is null");
            EwsUtilities.Assert(!folder.IsNew, "FolderWrapper.ctor", "folder does not have an Id");
            this.folder = folder;
        }
        FolderWrapper.prototype.GetFolder = function () {
            return this.folder;
        };
        FolderWrapper.prototype.WriteToXml = function (writer) {
            this.folder.Id.WriteToXml(writer);
        };
        FolderWrapper.prototype.InternalToJson = function (service) {
            return this.folder.Id.InternalToJson(service);
        };
        return FolderWrapper;
    }(AbstractFolderIdWrapper));
    var HangingTraceStream = (function (_super) {
        __extends(HangingTraceStream, _super);
        function HangingTraceStream(stream, service) {
            _super.call(this);
            this.underlyingStream = null;
            this.service = null;
            this.responseCopy = null;
            this.underlyingStream = stream;
            this.service = service;
        }
        Object.defineProperty(HangingTraceStream.prototype, "CanRead", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HangingTraceStream.prototype, "CanSeek", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HangingTraceStream.prototype, "CanWrite", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HangingTraceStream.prototype, "Length", {
            get: function () {
                throw new NotSupportedException();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HangingTraceStream.prototype, "Position", {
            get: function () {
                throw new NotSupportedException();
            },
            set: function (value) {
                throw new NotSupportedException();
            },
            enumerable: true,
            configurable: true
        });
        HangingTraceStream.prototype.Flush = function () {
        };
        HangingTraceStream.prototype.Read = function (buffer, offset, count) {
            var num = this.underlyingStream.Read(buffer, offset, count);
            if (HangingServiceRequestBase.LogAllWireBytes) {
                var $string = Encoding.UTF8.GetString(buffer, offset, num);
                var logEntry = NString.Format("HangingTraceStream ID [{0}] returned {1} bytes. Bytes returned: [{2}]", this.GetHashCode(), num, $string);
                this.service.TraceMessage(TraceFlags.DebugMessage, logEntry);
            }
            if (this.responseCopy !== null) {
                this.responseCopy.Write(buffer, offset, num);
            }
            return num;
        };
        HangingTraceStream.prototype.Seek = function (offset, origin) {
            throw new NotSupportedException();
        };
        HangingTraceStream.prototype.SetLength = function (value) {
            throw new NotSupportedException();
        };
        HangingTraceStream.prototype.Write = function (buffer, offset, count) {
            throw new NotSupportedException();
        };
        HangingTraceStream.prototype.SetResponseCopy = function (responseCopy) {
            this.responseCopy = responseCopy;
        };
        return HangingTraceStream;
    }(Stream));
    var ImpersonatedUserId = (function () {
        function ImpersonatedUserId(idType, id) {
            this.idType = 0;
            this.id = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(idType, id);
        }
        Object.defineProperty(ImpersonatedUserId.prototype, "IdType", {
            get: function () {
                return this.idType;
            },
            set: function (value) {
                this.idType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImpersonatedUserId.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        ImpersonatedUserId.prototype.constructor_0 = function () {
        };
        ImpersonatedUserId.prototype.constructor_1 = function (idType, id) {
            this.constructor_0();
            this.idType = idType;
            this.id = id;
        };
        ImpersonatedUserId.prototype.WriteToXml = function (writer) {
            if (NString.IsNullOrEmpty(this.id)) {
                throw new ArgumentException(Strings.IdPropertyMustBeSet);
            }
            writer.WriteStartElement(XmlNamespace.Types, "ExchangeImpersonation");
            writer.WriteStartElement(XmlNamespace.Types, "ConnectingSID");
            var localName = (this.idType === ConnectingIdType.SmtpAddress && writer.Service.RequestedServerVersion === ExchangeVersion.Exchange2007_SP1) ? "PrimarySmtpAddress" : ConnectingIdType[this.IdType];
            writer.WriteElementValue(XmlNamespace.Types, localName, this.id);
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        return ImpersonatedUserId;
    }());
    var ItemIdWrapper = (function (_super) {
        __extends(ItemIdWrapper, _super);
        function ItemIdWrapper(itemId) {
            _super.call(this);
            this.itemId = null;
            EwsUtilities.Assert(itemId !== null, "ItemIdWrapper.ctor", "itemId is null");
            this.itemId = itemId;
        }
        ItemIdWrapper.prototype.WriteToXml = function (writer) {
            this.itemId.WriteToXml(writer);
        };
        ItemIdWrapper.prototype.IternalToJson = function (service) {
            return this.itemId.InternalToJson(service);
        };
        return ItemIdWrapper;
    }(AbstractItemIdWrapper));
    var ItemIdWrapperList = (function () {
        function ItemIdWrapperList() {
            this.itemIds = new List();
            _super.call(this);
        }
        Object.defineProperty(ItemIdWrapperList.prototype, "Count", {
            get: function () {
                return this.itemIds.Count;
            },
            enumerable: true,
            configurable: true
        });
        ItemIdWrapperList.prototype.get_Item = function (index) {
            return this.itemIds.get_Item(index).GetItem();
        };
        ItemIdWrapperList.prototype.Add = function (itemOrItemId) {
            if (arguments.length === 1 && (itemOrItemId === null || itemOrItemId instanceof Item)) {
                this.Add_0(itemOrItemId);
                return;
            }
            this.Add_1(itemOrItemId);
        };
        ItemIdWrapperList.prototype.Add_0 = function (item) {
            this.itemIds.Add(new ItemWrapper(item));
        };
        ItemIdWrapperList.prototype.AddRange = function (itemsOrItemIds) {
            if (arguments.length === 1) {
                this.AddRange_0(itemsOrItemIds);
                return;
            }
            this.AddRange_1(itemsOrItemIds);
        };
        ItemIdWrapperList.prototype.AddRange_0 = function (items) {
            var enumerator = items.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        ItemIdWrapperList.prototype.Add_1 = function (itemId) {
            this.itemIds.Add(new ItemIdWrapper(itemId));
        };
        ItemIdWrapperList.prototype.AddRange_1 = function (itemIds) {
            var enumerator = itemIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.Add(current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        ItemIdWrapperList.prototype.WriteToXml = function (writer, ewsNamesapce, xmlElementName) {
            if (this.Count > 0) {
                writer.WriteStartElement(ewsNamesapce, xmlElementName);
                var enumerator = this.itemIds.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        current.WriteToXml(writer);
                    }
                }
                finally {
                    enumerator.Dispose();
                }
                writer.WriteEndElement();
            }
        };
        ItemIdWrapperList.prototype.InternalToJson = function (service) {
            var list = new List();
            var enumerator = this.itemIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.ToJson(service));
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list.ToArray();
        };
        ItemIdWrapperList.prototype.GetEnumerator = function () {
            return this.itemIds.GetEnumerator();
        };
        return ItemIdWrapperList;
    }());
    var ItemWrapper = (function (_super) {
        __extends(ItemWrapper, _super);
        function ItemWrapper(item) {
            _super.call(this);
            this.item = null;
            EwsUtilities.Assert(item !== null, "ItemWrapper.ctor", "item is null");
            EwsUtilities.Assert(!item.IsNew, "ItemWrapper.ctor", "item does not have an Id");
            this.item = item;
        }
        ItemWrapper.prototype.GetItem = function () {
            return this.item;
        };
        ItemWrapper.prototype.WriteToXml = function (writer) {
            this.item.Id.WriteToXml(writer);
        };
        ItemWrapper.prototype.IternalToJson = function (service) {
            return this.item.Id.ToJson(service);
        };
        return ItemWrapper;
    }(AbstractItemIdWrapper));
    var ManagementRoles = (function () {
        function ManagementRoles(userRoleOrUserRoles, applicationRoleOrApplicationRoles) {
            this.userRoles = null;
            this.applicationRoles = null;
            _super.call(this);
            if (arguments.length === 1 && (userRoleOrUserRoles === null || userRoleOrUserRoles.constructor === String)) {
                this.constructor_0(userRoleOrUserRoles);
                return;
            }
            if (arguments.length === 2 && (userRoleOrUserRoles === null || userRoleOrUserRoles.constructor === String) && (applicationRoleOrApplicationRoles === null || applicationRoleOrApplicationRoles.constructor === String)) {
                this.constructor_1(userRoleOrUserRoles, applicationRoleOrApplicationRoles);
                return;
            }
            this.constructor_2(userRoleOrUserRoles, applicationRoleOrApplicationRoles);
        }
        ManagementRoles.prototype.constructor_0 = function (userRole) {
            EwsUtilities.ValidateParam(userRole, "userRole");
            this.userRoles = [
                userRole
            ];
        };
        ManagementRoles.prototype.constructor_1 = function (userRole, applicationRole) {
            if (userRole !== null) {
                EwsUtilities.ValidateParam(userRole, "userRole");
                this.userRoles = [
                    userRole
                ];
            }
            if (applicationRole !== null) {
                EwsUtilities.ValidateParam(applicationRole, "applicationRole");
                this.applicationRoles = [
                    applicationRole
                ];
            }
        };
        ManagementRoles.prototype.constructor_2 = function (userRoles, applicationRoles) {
            if (userRoles !== null) {
                this.userRoles = Enumerable.ToArray(NArray.ToEnumerable(userRoles));
            }
            if (applicationRoles !== null) {
                this.applicationRoles = Enumerable.ToArray(NArray.ToEnumerable(applicationRoles));
            }
        };
        ManagementRoles.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "ManagementRole");
            this.WriteRolesToXml(writer, this.userRoles, "UserRoles");
            this.WriteRolesToXml(writer, this.applicationRoles, "ApplicationRoles");
            writer.WriteEndElement();
        };
        ManagementRoles.prototype.WriteRolesToXml = function (writer, roles, elementName) {
            if (roles !== null) {
                writer.WriteStartElement(XmlNamespace.Types, elementName);
                for (var i = 0; i < roles.length; i = i + 1) {
                    var value = roles[i];
                    writer.WriteElementValue(XmlNamespace.Types, "Role", value);
                }
                writer.WriteEndElement();
            }
        };
        ManagementRoles.prototype.ToJsonObject = function () {
            var jsonObject = new JsonObject();
            if (this.userRoles !== null) {
                jsonObject.Add("UserRoles", NArray.ToEnumerable(this.userRoles));
            }
            if (this.applicationRoles !== null) {
                jsonObject.Add("ApplicationRoles", NArray.ToEnumerable(this.applicationRoles));
            }
            return jsonObject;
        };
        return ManagementRoles;
    }());
    var MapiTypeConverterMapEntry = (function () {
        function MapiTypeConverterMapEntry(type) {
            this.Parse = null;
            this.ConvertToString = null;
            this.Type = null;
            this.IsArray = false;
            _super.call(this);
            EwsUtilities.Assert(MapiTypeConverterMapEntry.defaultValueMap.Member.ContainsKey(type), "MapiTypeConverterMapEntry ctor", NString.Format("No default value entry for type {0}", type.Name));
            this.Type = type;
            this.ConvertToString = (function (o) { return Convert.ChangeType(o, new Type("String"), CultureInfo.InvariantCulture); });
            this.Parse = (function (s) { return Convert.ChangeType(s, type, CultureInfo.InvariantCulture); });
        }
        Object.defineProperty(MapiTypeConverterMapEntry.prototype, "DefaultValue", {
            get: function () {
                return MapiTypeConverterMapEntry.defaultValueMap.Member.get_Item(this.Type);
            },
            enumerable: true,
            configurable: true
        });
        MapiTypeConverterMapEntry.prototype.ChangeType = function (value) {
            if (this.IsArray) {
                this.ValidateValueAsArray(value);
                return value;
            }
            if (Type.op_Equality(value.GetType(), this.Type)) {
                return value;
            }
            var result;
            try {
                result = Convert.ChangeType(value, this.Type, CultureInfo.InvariantCulture);
            }
            catch (innerException) {
                if (innerException instanceof InvalidCastException) {
                    throw new ArgumentException(NString.Format(Strings.ValueOfTypeCannotBeConverted, value, value.GetType(), this.Type), innerException);
                }
                else
                    throw innerException;
            }
            return result;
        };
        MapiTypeConverterMapEntry.prototype.ConvertToValue = function (stringValue) {
            var result;
            try {
                result = this.Parse(stringValue);
            }
            catch (innerException) {
                if (innerException instanceof FormatException) {
                    throw new ServiceXmlDeserializationException(NString.Format(Strings.ValueCannotBeConverted, stringValue, this.Type), innerException);
                }
                else if (innerException instanceof InvalidCastException) {
                    throw new ServiceXmlDeserializationException(NString.Format(Strings.ValueCannotBeConverted, stringValue, this.Type), innerException2);
                }
                else if (innerException instanceof OverflowException) {
                    throw new ServiceXmlDeserializationException(NString.Format(Strings.ValueCannotBeConverted, stringValue, this.Type), innerException3);
                }
                else
                    throw innerException;
            }
            return result;
        };
        MapiTypeConverterMapEntry.prototype.ConvertToValueOrDefault = function (stringValue) {
            if (!NString.IsNullOrEmpty(stringValue)) {
                return this.ConvertToValue(stringValue);
            }
            return this.DefaultValue;
        };
        MapiTypeConverterMapEntry.prototype.ValidateValueAsArray = function (value) {
            var array = ((value instanceof Array) ? value : null);
            if (array === null) {
                throw new ArgumentException(NString.Format(Strings.IncompatibleTypeForArray, value.GetType(), this.Type));
            }
            if (array.Rank !== 1) {
                throw new ArgumentException(Strings.ArrayMustHaveSingleDimension);
            }
            if (array.Length === 0) {
                throw new ArgumentException(Strings.ArrayMustHaveAtLeastOneElement);
            }
            if (Type.op_Inequality(array.GetType().GetElementType(), this.Type)) {
                throw new ArgumentException(NString.Format(Strings.IncompatibleTypeForArray, value.GetType(), this.Type));
            }
        };
        MapiTypeConverterMapEntry.defaultValueMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(new Type("Boolean"), false);
            dictionary.Add(new Type("Array"), null);
            dictionary.Add(new Type("Number"), 0);
            dictionary.Add(new Type("Number"), 0);
            dictionary.Add(new Type("Number"), 0);
            dictionary.Add(new Type("Number"), 0);
            dictionary.Add(new Type("Number"), 0.0);
            dictionary.Add(new Type("DateTime"), DateTime.MinValue);
            dictionary.Add(new Type("Guid"), Guid.Empty);
            dictionary.Add(new Type("String"), null);
            return dictionary;
        });
        return MapiTypeConverterMapEntry;
    }());
    var MapiTypeConverter = (function () {
        function MapiTypeConverter() {
            _super.call(this);
        }
        Object.defineProperty(MapiTypeConverter, "MapiTypeConverterMap", {
            get: function () {
                return MapiTypeConverter.mapiTypeConverterMap.Member;
            },
            enumerable: true,
            configurable: true
        });
        MapiTypeConverter.ConvertToValue = function (mapiPropType, stringsOrStringValue) {
            if (arguments.length === 2 && (mapiPropType === null || mapiPropType.constructor === Number)) {
                return MapiTypeConverter.ConvertToValue_0(mapiPropType, stringsOrStringValue);
            }
            return MapiTypeConverter.ConvertToValue_1(mapiPropType, stringsOrStringValue);
        };
        MapiTypeConverter.ConvertToValue_0 = function (mapiPropType, strings) {
            EwsUtilities.ValidateParam(strings, "strings");
            var mapiTypeConverterMapEntry = MapiTypeConverter.MapiTypeConverterMap.get_Item(mapiPropType);
            var array = NArray.CreateInstance(mapiTypeConverterMapEntry.Type, Enumerable.Count(strings));
            var num = 0;
            var enumerator = strings.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var value = mapiTypeConverterMapEntry.ConvertToValueOrDefault(current);
                    array.SetValue(value, num++);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            return array;
        };
        MapiTypeConverter.ConvertToValue_1 = function (mapiPropType, stringValue) {
            return MapiTypeConverter.MapiTypeConverterMap.get_Item(mapiPropType).ConvertToValue(stringValue);
        };
        MapiTypeConverter.ConvertToString = function (mapiPropType, value) {
            if (value !== null) {
                return MapiTypeConverter.MapiTypeConverterMap.get_Item(mapiPropType).ConvertToString(value);
            }
            return NString.Empty;
        };
        MapiTypeConverter.ChangeType = function (mapiType, value) {
            EwsUtilities.ValidateParam(value, "value");
            return MapiTypeConverter.MapiTypeConverterMap.get_Item(mapiType).ChangeType(value);
        };
        MapiTypeConverter.ParseMapiIntegerValue = function (s) {
            var num;
            if ((function () {
                var _p0 = [
                    num
                ];
                var _r = NNumber.TryParse(s, NumberStyles.Integer, CultureInfo.InvariantCulture, _p0);
                num = _p0[0];
                return _r;
            })()) {
                return num;
            }
            return s;
        };
        MapiTypeConverter.IsArrayType = function (mapiType) {
            return MapiTypeConverter.MapiTypeConverterMap.get_Item(mapiType).IsArray;
        };
        MapiTypeConverter.UtcDataTimeStyles = DateTimeStyles.AdjustToUniversal | DateTimeStyles.AssumeUniversal;
        MapiTypeConverter.mapiTypeConverterMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(MapiPropertyType.ApplicationTime, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_39_0 = dictionary;
            var arg_39_1 = MapiPropertyType.ApplicationTimeArray;
            var mapiTypeConverterMapEntry = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry.IsArray = true;
            arg_39_0.Add(arg_39_1, mapiTypeConverterMapEntry);
            var mapiTypeConverterMapEntry2 = new MapiTypeConverterMapEntry(new Type("Array"));
            mapiTypeConverterMapEntry2.Parse = function (s) {
                if (!NString.IsNullOrEmpty(s)) {
                    return Convert.FromBase64String(s);
                }
                return null;
            };
            mapiTypeConverterMapEntry2.ConvertToString = (function (o) { return Convert.ToBase64String(o); });
            var value = mapiTypeConverterMapEntry2;
            dictionary.Add(MapiPropertyType.Binary, value);
            var mapiTypeConverterMapEntry3 = new MapiTypeConverterMapEntry(new Type("Array"));
            mapiTypeConverterMapEntry3.Parse = function (s) {
                if (!NString.IsNullOrEmpty(s)) {
                    return Convert.FromBase64String(s);
                }
                return null;
            };
            mapiTypeConverterMapEntry3.ConvertToString = (function (o) { return Convert.ToBase64String(o); });
            mapiTypeConverterMapEntry3.IsArray = true;
            var value2 = mapiTypeConverterMapEntry3;
            dictionary.Add(MapiPropertyType.BinaryArray, value2);
            var mapiTypeConverterMapEntry4 = new MapiTypeConverterMapEntry(new Type("Boolean"));
            mapiTypeConverterMapEntry4.Parse = (function (s) { return Convert.ChangeType(s, new Type("Boolean"), CultureInfo.InvariantCulture); });
            mapiTypeConverterMapEntry4.ConvertToString = (function (o) { return NBoolean.ToString(o, CultureInfo.InvariantCulture).ToLower(); });
            var value3 = mapiTypeConverterMapEntry4;
            dictionary.Add(MapiPropertyType.Boolean, value3);
            var mapiTypeConverterMapEntry5 = new MapiTypeConverterMapEntry(new Type("Guid"));
            mapiTypeConverterMapEntry5.Parse = (function (s) { return new Guid(s); });
            mapiTypeConverterMapEntry5.ConvertToString = (function (o) { return o.ToString(); });
            var value4 = mapiTypeConverterMapEntry5;
            dictionary.Add(MapiPropertyType.CLSID, value4);
            var mapiTypeConverterMapEntry6 = new MapiTypeConverterMapEntry(new Type("Guid"));
            mapiTypeConverterMapEntry6.Parse = (function (s) { return new Guid(s); });
            mapiTypeConverterMapEntry6.ConvertToString = (function (o) { return o.ToString(); });
            mapiTypeConverterMapEntry6.IsArray = true;
            var value5 = mapiTypeConverterMapEntry6;
            dictionary.Add(MapiPropertyType.CLSIDArray, value5);
            dictionary.Add(MapiPropertyType.Currency, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_279_0 = dictionary;
            var arg_279_1 = MapiPropertyType.CurrencyArray;
            var mapiTypeConverterMapEntry7 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry7.IsArray = true;
            arg_279_0.Add(arg_279_1, mapiTypeConverterMapEntry7);
            dictionary.Add(MapiPropertyType.Double, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_2B3_0 = dictionary;
            var arg_2B3_1 = MapiPropertyType.DoubleArray;
            var mapiTypeConverterMapEntry8 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry8.IsArray = true;
            arg_2B3_0.Add(arg_2B3_1, mapiTypeConverterMapEntry8);
            dictionary.Add(MapiPropertyType.Error, new MapiTypeConverterMapEntry(new Type("Number")));
            dictionary.Add(MapiPropertyType.Float, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_304_0 = dictionary;
            var arg_304_1 = MapiPropertyType.FloatArray;
            var mapiTypeConverterMapEntry9 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry9.IsArray = true;
            arg_304_0.Add(arg_304_1, mapiTypeConverterMapEntry9);
            var arg_343_0 = dictionary;
            var arg_343_1 = MapiPropertyType.Integer;
            var mapiTypeConverterMapEntry10 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry10.Parse = (function (s) { return MapiTypeConverter.ParseMapiIntegerValue(s); });
            arg_343_0.Add(arg_343_1, mapiTypeConverterMapEntry10);
            var arg_366_0 = dictionary;
            var arg_366_1 = MapiPropertyType.IntegerArray;
            var mapiTypeConverterMapEntry11 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry11.IsArray = true;
            arg_366_0.Add(arg_366_1, mapiTypeConverterMapEntry11);
            dictionary.Add(MapiPropertyType.Long, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_3A0_0 = dictionary;
            var arg_3A0_1 = MapiPropertyType.LongArray;
            var mapiTypeConverterMapEntry12 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry12.IsArray = true;
            arg_3A0_0.Add(arg_3A0_1, mapiTypeConverterMapEntry12);
            var mapiTypeConverterMapEntry13 = new MapiTypeConverterMapEntry(new Type("String"));
            mapiTypeConverterMapEntry13.Parse = (function (s) { return s; });
            var value6 = mapiTypeConverterMapEntry13;
            dictionary.Add(MapiPropertyType.Object, value6);
            var mapiTypeConverterMapEntry14 = new MapiTypeConverterMapEntry(new Type("String"));
            mapiTypeConverterMapEntry14.Parse = (function (s) { return s; });
            mapiTypeConverterMapEntry14.IsArray = true;
            var value7 = mapiTypeConverterMapEntry14;
            dictionary.Add(MapiPropertyType.ObjectArray, value7);
            dictionary.Add(MapiPropertyType.Short, new MapiTypeConverterMapEntry(new Type("Number")));
            var arg_468_0 = dictionary;
            var arg_468_1 = MapiPropertyType.ShortArray;
            var mapiTypeConverterMapEntry15 = new MapiTypeConverterMapEntry(new Type("Number"));
            mapiTypeConverterMapEntry15.IsArray = true;
            arg_468_0.Add(arg_468_1, mapiTypeConverterMapEntry15);
            var mapiTypeConverterMapEntry16 = new MapiTypeConverterMapEntry(new Type("String"));
            mapiTypeConverterMapEntry16.Parse = (function (s) { return s; });
            var value8 = mapiTypeConverterMapEntry16;
            dictionary.Add(MapiPropertyType.String, value8);
            var mapiTypeConverterMapEntry17 = new MapiTypeConverterMapEntry(new Type("String"));
            mapiTypeConverterMapEntry17.Parse = (function (s) { return s; });
            mapiTypeConverterMapEntry17.IsArray = true;
            var value9 = mapiTypeConverterMapEntry17;
            dictionary.Add(MapiPropertyType.StringArray, value9);
            var mapiTypeConverterMapEntry18 = new MapiTypeConverterMapEntry(new Type("DateTime"));
            mapiTypeConverterMapEntry18.Parse = (function (s) { return DateTime.Parse(s, CultureInfo.InvariantCulture, DateTimeStyles.AdjustToUniversal | DateTimeStyles.AssumeUniversal); });
            mapiTypeConverterMapEntry18.ConvertToString = (function (o) { return EwsUtilities.DateTimeToXSDateTime(o); });
            var value10 = mapiTypeConverterMapEntry18;
            dictionary.Add(MapiPropertyType.SystemTime, value10);
            var mapiTypeConverterMapEntry19 = new MapiTypeConverterMapEntry(new Type("DateTime"));
            mapiTypeConverterMapEntry19.IsArray = true;
            mapiTypeConverterMapEntry19.Parse = (function (s) { return DateTime.Parse(s, CultureInfo.InvariantCulture, DateTimeStyles.AdjustToUniversal | DateTimeStyles.AssumeUniversal); });
            mapiTypeConverterMapEntry19.ConvertToString = (function (o) { return EwsUtilities.DateTimeToXSDateTime(o); });
            var value11 = mapiTypeConverterMapEntry19;
            dictionary.Add(MapiPropertyType.SystemTimeArray, value11);
            return dictionary;
        });
        return MapiTypeConverter;
    }());
    var MobilePhone = (function () {
        function MobilePhone(name, phoneNumber) {
            this.name = null;
            this.phoneNumber = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(name, phoneNumber);
        }
        Object.defineProperty(MobilePhone.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MobilePhone.prototype, "PhoneNumber", {
            get: function () {
                return this.phoneNumber;
            },
            set: function (value) {
                this.phoneNumber = value;
            },
            enumerable: true,
            configurable: true
        });
        MobilePhone.prototype.constructor_0 = function () {
        };
        MobilePhone.prototype.constructor_1 = function (name, phoneNumber) {
            this.name = name;
            this.phoneNumber = phoneNumber;
        };
        MobilePhone.prototype.Validate = function () {
            if (NString.IsNullOrEmpty(this.PhoneNumber)) {
                throw new ServiceValidationException("PhoneNumber cannot be empty.");
            }
        };
        return MobilePhone;
    }());
    var NameResolution = (function () {
        function NameResolution(owner) {
            this.owner = null;
            this.mailbox = new EmailAddress();
            this.contact = null;
            _super.call(this);
            EwsUtilities.Assert(owner !== null, "NameResolution.ctor", "owner is null.");
            this.owner = owner;
        }
        Object.defineProperty(NameResolution.prototype, "Mailbox", {
            get: function () {
                return this.mailbox;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NameResolution.prototype, "Contact", {
            get: function () {
                return this.contact;
            },
            enumerable: true,
            configurable: true
        });
        NameResolution.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Types, "Resolution");
            reader.ReadStartElement(XmlNamespace.Types, "Mailbox");
            this.mailbox.LoadFromXml(reader, "Mailbox");
            reader.Read();
            if (reader.IsStartElement(XmlNamespace.Types, "Contact")) {
                this.contact = new Contact(this.owner.Session);
                this.contact.LoadFromXml(reader, true, PropertySet.FirstClassProperties, false);
                reader.ReadEndElement(XmlNamespace.Types, "Resolution");
                return;
            }
            reader.EnsureCurrentNodeIsEndElement(XmlNamespace.Types, "Resolution");
        };
        NameResolution.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Mailbox")) {
                            if (a === "Contact") {
                                this.contact = new Contact(this.owner.Session);
                                this.contact.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service, true, PropertySet.FirstClassProperties, false);
                            }
                        }
                        else {
                            this.mailbox.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        return NameResolution;
    }());
    var NameResolutionCollection = (function () {
        function NameResolutionCollection(service) {
            this.service = null;
            this.includesAllResolutions = false;
            this.items = new List();
            _super.call(this);
            EwsUtilities.Assert(service !== null, "NameResolutionSet.ctor", "service is null.");
            this.service = service;
        }
        Object.defineProperty(NameResolutionCollection.prototype, "Session", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NameResolutionCollection.prototype, "Count", {
            get: function () {
                return this.items.Count;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NameResolutionCollection.prototype, "IncludesAllResolutions", {
            get: function () {
                return this.includesAllResolutions;
            },
            enumerable: true,
            configurable: true
        });
        NameResolutionCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.items.get_Item(index);
        };
        NameResolutionCollection.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "ResolutionSet");
            var num = reader.ReadAttributeValue("TotalItemsInView");
            this.includesAllResolutions = reader.ReadAttributeValue("IncludesLastItemInRange");
            for (var i = 0; i < num; i = i + 1) {
                var nameResolution = new NameResolution(this);
                nameResolution.LoadFromXml(reader);
                this.items.Add(nameResolution);
            }
            reader.ReadEndElement(XmlNamespace.Messages, "ResolutionSet");
        };
        NameResolutionCollection.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "TotalItemsInView")) {
                            if (!(a === "IncludesLastItemInRange")) {
                                if (a === "Resolutions") {
                                    var array = jsonProperty.ReadAsArray(current);
                                    var array2 = array;
                                    for (var i = 0; i < array2.length; i = i + 1) {
                                        var obj = array2[i];
                                        var jsonObject = ((obj instanceof JsonObject) ? obj : null);
                                        if (jsonObject !== null) {
                                            var nameResolution = new NameResolution(this);
                                            nameResolution.LoadFromJson(jsonObject, service);
                                            this.items.Add(nameResolution);
                                        }
                                    }
                                }
                            }
                            else {
                                this.includesAllResolutions = jsonProperty.ReadAsBool(current);
                            }
                        }
                        else {
                            jsonProperty.ReadAsInt(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        NameResolutionCollection.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        return NameResolutionCollection;
    }());
    var PrivilegedUserId = (function () {
        function PrivilegedUserId(openType, idType, id) {
            this.logonType = 0;
            this.idType = 0;
            this.id = null;
            this.budgetType = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(openType, idType, id);
        }
        Object.defineProperty(PrivilegedUserId.prototype, "IdType", {
            get: function () {
                return this.idType;
            },
            set: function (value) {
                this.idType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrivilegedUserId.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrivilegedUserId.prototype, "LogonType", {
            get: function () {
                return this.logonType;
            },
            set: function (value) {
                this.logonType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrivilegedUserId.prototype, "BudgetType", {
            get: function () {
                return this.budgetType;
            },
            set: function (value) {
                this.budgetType = value;
            },
            enumerable: true,
            configurable: true
        });
        PrivilegedUserId.prototype.constructor_0 = function () {
        };
        PrivilegedUserId.prototype.constructor_1 = function (openType, idType, id) {
            this.constructor_0();
            this.logonType = openType;
            this.idType = idType;
            this.id = id;
        };
        PrivilegedUserId.prototype.WriteToXml = function (writer, requestedServerVersion) {
            if (NString.IsNullOrEmpty(this.id)) {
                throw new ArgumentException(Strings.IdPropertyMustBeSet);
            }
            writer.WriteStartElement(XmlNamespace.Types, "OpenAsAdminOrSystemService");
            writer.WriteAttributeString("LogonType", PrivilegedLogonType[this.logonType]);
            if (requestedServerVersion >= ExchangeVersion.Exchange2013 && this.budgetType !== null) {
                writer.WriteAttributeString("BudgetType", PrivilegedUserIdBudgetType[this.budgetType.Value]);
            }
            writer.WriteStartElement(XmlNamespace.Types, "ConnectingSID");
            writer.WriteElementValue(XmlNamespace.Types, ConnectingIdType[this.idType], this.id);
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        return PrivilegedUserId;
    }());
    var PrivilegedUserIdBudgetType;
    (function (PrivilegedUserIdBudgetType) {
        PrivilegedUserIdBudgetType[PrivilegedUserIdBudgetType["Default"] = 0] = "Default";
        PrivilegedUserIdBudgetType[PrivilegedUserIdBudgetType["RunningAsBackgroundLoad"] = 1] = "RunningAsBackgroundLoad";
        PrivilegedUserIdBudgetType[PrivilegedUserIdBudgetType["Unthrottled"] = 2] = "Unthrottled";
    })(PrivilegedUserIdBudgetType || (PrivilegedUserIdBudgetType = {}));
    var SoapFaultDetails = (function () {
        function SoapFaultDetails() {
            this.faultCode = null;
            this.faultString = null;
            this.faultActor = null;
            this.responseCode = ServiceError.ErrorInternalServerError;
            this.message = null;
            this.errorCode = 0;
            this.exceptionType = null;
            this.lineNumber = 0;
            this.positionWithinLine = 0;
            this.errorDetails = new Dictionary();
            _super.call(this);
        }
        Object.defineProperty(SoapFaultDetails.prototype, "FaultCode", {
            get: function () {
                return this.faultCode;
            },
            set: function (value) {
                this.faultCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "FaultString", {
            get: function () {
                return this.faultString;
            },
            set: function (value) {
                this.faultString = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "FaultActor", {
            get: function () {
                return this.faultActor;
            },
            set: function (value) {
                this.faultActor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "ResponseCode", {
            get: function () {
                return this.responseCode;
            },
            set: function (value) {
                this.responseCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "Message", {
            get: function () {
                return this.message;
            },
            set: function (value) {
                this.message = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            set: function (value) {
                this.errorCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "ExceptionType", {
            get: function () {
                return this.exceptionType;
            },
            set: function (value) {
                this.exceptionType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "LineNumber", {
            get: function () {
                return this.lineNumber;
            },
            set: function (value) {
                this.lineNumber = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "PositionWithinLine", {
            get: function () {
                return this.positionWithinLine;
            },
            set: function (value) {
                this.positionWithinLine = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoapFaultDetails.prototype, "ErrorDetails", {
            get: function () {
                return this.errorDetails;
            },
            set: function (value) {
                this.errorDetails = value;
            },
            enumerable: true,
            configurable: true
        });
        SoapFaultDetails.Parse = function (readerOrJsonObject, soapNamespace) {
            if (arguments.length === 2 && (readerOrJsonObject === null || readerOrJsonObject instanceof EwsXmlReader) && (soapNamespace === null || soapNamespace.constructor === Number)) {
                return SoapFaultDetails.Parse_0(readerOrJsonObject, soapNamespace);
            }
            return SoapFaultDetails.Parse_1(readerOrJsonObject);
        };
        SoapFaultDetails.Parse_0 = function (reader, soapNamespace) {
            var soapFaultDetails = new SoapFaultDetails();
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "faultcode")) {
                        if (!(localName === "faultstring")) {
                            if (!(localName === "faultactor")) {
                                if (localName === "detail") {
                                    soapFaultDetails.ParseDetailNode(reader);
                                }
                            }
                            else {
                                soapFaultDetails.FaultActor = reader.ReadElementValue();
                            }
                        }
                        else {
                            soapFaultDetails.FaultString = reader.ReadElementValue();
                        }
                    }
                    else {
                        soapFaultDetails.FaultCode = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(soapNamespace, "Fault"));
            return soapFaultDetails;
        };
        SoapFaultDetails.Parse_1 = function (jsonObject) {
            var soapFaultDetails = new SoapFaultDetails();
            var enumerator = jsonObject.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null && a === "FaultMessage") {
                        soapFaultDetails.FaultString = jsonObject.ReadAsString(current);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            return soapFaultDetails;
        };
        SoapFaultDetails.prototype.ParseDetailNode = function (reader) {
            do {
                var IL_132 = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            var localName;
                            if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                                if (_PrivateImplementationDetails_) {
                                    70549;
                                    B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                                }
                                $$method0x60016c6 - 1 === null;
                                {
                                    var expr_2E = new Dictionary(7);
                                    expr_2E.Add("ResponseCode", 0);
                                    expr_2E.Add("Message", 1);
                                    expr_2E.Add("Line", 2);
                                    expr_2E.Add("Position", 3);
                                    expr_2E.Add("ErrorCode", 4);
                                    expr_2E.Add("ExceptionType", 5);
                                    expr_2E.Add("MessageXml", 6);
                                    _PrivateImplementationDetails_;
                                    {
                                        70549;
                                        B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                                    }
                                    $$method0x60016c6 - 1;
                                    expr_2E;
                                }
                                var num;
                                if ((function () {
                                    var _p0 = [
                                        num
                                    ];
                                    var _r = _PrivateImplementationDetails_, _a = (void 0)[70549], B87 = _a === void 0 ? -FCC0 - 4468 - A58C - F62EC848C70D : _a, $$method0x60016c6 = -1., TryGetValue = (localName, _p0);
                                    num = _p0[0];
                                    return _r;
                                })()) {
                                    switch (num) {
                                        case 0:
                                            try {
                                                this.ResponseCode = reader.ReadElementValue();
                                                _goto = IL_132;
                                                continue _GOTO_LOOP;
                                            }
                                            catch (ex_CF) {
                                                if (ex_CF instanceof ArgumentException) {
                                                    this.ResponseCode = ServiceError.ErrorInternalServerError;
                                                    _goto = IL_132;
                                                    continue _GOTO_LOOP;
                                                }
                                                else
                                                    throw ex_CF;
                                            }
                                            break;
                                        case 1:
                                            break;
                                        case 2:
                                            this.LineNumber = reader.ReadElementValue();
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                        case 3:
                                            this.PositionWithinLine = reader.ReadElementValue();
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                        case 4:
                                            try {
                                                this.ErrorCode = reader.ReadElementValue();
                                                _goto = IL_132;
                                                continue _GOTO_LOOP;
                                            }
                                            catch (ex_112) {
                                                if (ex_112 instanceof ArgumentException) {
                                                    this.ErrorCode = ServiceError.ErrorInternalServerError;
                                                    _goto = IL_132;
                                                    continue _GOTO_LOOP;
                                                }
                                                else
                                                    throw ex_112;
                                            }
                                            this.ExceptionType = reader.ReadElementValue();
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                        case 5:
                                            this.ExceptionType = reader.ReadElementValue();
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                        case 6:
                                            this.ParseMessageXml(reader);
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                        default:
                                            _goto = IL_132;
                                            continue _GOTO_LOOP;
                                    }
                                    this.Message = reader.ReadElementValue();
                                    _goto = IL_132;
                                    continue _GOTO_LOOP;
                                }
                            }
                            _goto = IL_132;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, "detail"));
        };
        SoapFaultDetails.prototype.ParseMessageXml = function (reader) {
            var namespaceFromUri = EwsUtilities.GetNamespaceFromUri(reader.NamespaceUri);
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    var localName;
                    if (reader.IsStartElement() && !reader.IsEmptyElement && (localName = reader.LocalName) !== null && localName === "Value") {
                        this.errorDetails.Add(reader.ReadAttributeValue("Name"), reader.ReadElementValue());
                    }
                } while (!reader.IsEndElement(namespaceFromUri, "MessageXml"));
            }
        };
        return SoapFaultDetails;
    }());
    var Time = (function () {
        function Time(minutesOrDateTimeOrHours, minutes, seconds) {
            this.hours = 0;
            this.minutes = 0;
            this.seconds = 0;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (minutesOrDateTimeOrHours === null || minutesOrDateTimeOrHours.constructor === Number)) {
                this.constructor_1(minutesOrDateTimeOrHours);
                return;
            }
            if (arguments.length === 1 && (minutesOrDateTimeOrHours === null || minutesOrDateTimeOrHours instanceof DateTime)) {
                this.constructor_2(minutesOrDateTimeOrHours);
                return;
            }
            this.constructor_3(minutesOrDateTimeOrHours, minutes, seconds);
        }
        Object.defineProperty(Time.prototype, "Hours", {
            get: function () {
                return this.hours;
            },
            set: function (value) {
                if (value >= 0 && value < 24) {
                    this.hours = value;
                    return;
                }
                throw new ArgumentException(Strings.HourMustBeBetween0And23);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Time.prototype, "Minutes", {
            get: function () {
                return this.minutes;
            },
            set: function (value) {
                if (value >= 0 && value < 60) {
                    this.minutes = value;
                    return;
                }
                throw new ArgumentException(Strings.MinuteMustBeBetween0And59);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Time.prototype, "Seconds", {
            get: function () {
                return this.seconds;
            },
            set: function (value) {
                if (value >= 0 && value < 60) {
                    this.seconds = value;
                    return;
                }
                throw new ArgumentException(Strings.SecondMustBeBetween0And59);
            },
            enumerable: true,
            configurable: true
        });
        Time.prototype.constructor_0 = function () {
        };
        Time.prototype.constructor_1 = function (minutes) {
            this.constructor_0();
            if (minutes < 0 || minutes >= 1440) {
                throw new ArgumentException(Strings.MinutesMustBeBetween0And1439, "minutes");
            }
            this.Hours = minutes / 60;
            this.Minutes = minutes % 60;
            this.Seconds = 0;
        };
        Time.prototype.constructor_2 = function (dateTime) {
            this.Hours = dateTime.Hour;
            this.Minutes = dateTime.Minute;
            this.Seconds = dateTime.Second;
        };
        Time.prototype.constructor_3 = function (hours, minutes, seconds) {
            this.constructor_0();
            this.Hours = hours;
            this.Minutes = minutes;
            this.Seconds = seconds;
        };
        Time.prototype.ToXSTime = function () {
            return NString.Format("{0:00}:{1:00}:{2:00}", this.Hours, this.Minutes, this.Seconds);
        };
        Time.prototype.ConvertToMinutes = function () {
            return this.Minutes + this.Hours * 60;
        };
        return Time;
    }());
    var UserConfiguration = (function () {
        function UserConfiguration(service, requestedProperties) {
            this.service = null;
            this.name = null;
            this.parentFolderId = null;
            this.itemId = null;
            this.dictionary = null;
            this.xmlData = null;
            this.binaryData = null;
            this.propertiesAvailableForAccess = 0;
            this.updatedProperties = 0;
            this.isNew = false;
            _super.call(this);
            if (arguments.length === 1 && (service === null || service instanceof ExchangeService)) {
                this.constructor_0(service);
                return;
            }
            this.constructor_1(service, requestedProperties);
        }
        Object.defineProperty(UserConfiguration.prototype, "Name", {
            get: function () {
                return this.name;
            },
            set: function (value) {
                this.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "ParentFolderId", {
            get: function () {
                return this.parentFolderId;
            },
            set: function (value) {
                this.parentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "ItemId", {
            get: function () {
                return this.itemId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "Dictionary", {
            get: function () {
                return this.dictionary;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "XmlData", {
            get: function () {
                this.ValidatePropertyAccess(UserConfigurationProperties.XmlData);
                return this.xmlData;
            },
            set: function (value) {
                this.xmlData = value;
                this.MarkPropertyForUpdate(UserConfigurationProperties.XmlData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "BinaryData", {
            get: function () {
                this.ValidatePropertyAccess(UserConfigurationProperties.BinaryData);
                return this.binaryData;
            },
            set: function (value) {
                this.binaryData = value;
                this.MarkPropertyForUpdate(UserConfigurationProperties.BinaryData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UserConfiguration.prototype, "IsDirty", {
            get: function () {
                return this.updatedProperties !== 0 || this.dictionary.IsDirty;
            },
            enumerable: true,
            configurable: true
        });
        UserConfiguration.prototype.constructor_0 = function (service) {
            this.constructor_1(service, UserConfigurationProperties.Dictionary | UserConfigurationProperties.XmlData | UserConfigurationProperties.BinaryData);
        };
        UserConfiguration.WriteByteArrayToXml = function (writer, byteArray, xmlElementName) {
            EwsUtilities.Assert(writer !== null, "UserConfiguration.WriteByteArrayToXml", "writer is null");
            EwsUtilities.Assert(xmlElementName !== null, "UserConfiguration.WriteByteArrayToXml", "xmlElementName is null");
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            if (byteArray !== null && byteArray.length > 0) {
                writer.WriteValue(Convert.ToBase64String(byteArray), xmlElementName);
            }
            writer.WriteEndElement();
        };
        UserConfiguration.WriteUserConfigurationNameToXml = function (writer, xmlNamespace, name, parentFolderId) {
            EwsUtilities.Assert(writer !== null, "UserConfiguration.WriteUserConfigurationNameToXml", "writer is null");
            EwsUtilities.Assert(name !== null, "UserConfiguration.WriteUserConfigurationNameToXml", "name is null");
            EwsUtilities.Assert(parentFolderId !== null, "UserConfiguration.WriteUserConfigurationNameToXml", "parentFolderId is null");
            writer.WriteStartElement(xmlNamespace, "UserConfigurationName");
            writer.WriteAttributeValue("Name", name);
            parentFolderId.WriteToXml(writer);
            writer.WriteEndElement();
        };
        UserConfiguration.prototype.constructor_1 = function (service, requestedProperties) {
            EwsUtilities.ValidateParam(service, "service");
            if (service.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                throw new ServiceVersionException(NString.Format(Strings.ObjectTypeIncompatibleWithRequestVersion, _super.prototype.GetType.call(this).Name, ExchangeVersion.Exchange2010));
            }
            this.service = service;
            this.isNew = true;
            this.InitializeProperties(requestedProperties);
        };
        UserConfiguration.Bind = function (service, name, parentFolderIdOrParentFolderName, properties) {
            if (arguments.length === 4 && (service === null || service instanceof ExchangeService) && (name === null || name.constructor === String) && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId) && (properties === null || properties.constructor === Number)) {
                return UserConfiguration.Bind_0(service, name, parentFolderIdOrParentFolderName, properties);
            }
            return UserConfiguration.Bind_1(service, name, parentFolderIdOrParentFolderName, properties);
        };
        UserConfiguration.Bind_0 = function (service, name, parentFolderId, properties) {
            var userConfiguration = service.GetUserConfiguration(name, parentFolderId, properties);
            userConfiguration.isNew = false;
            return userConfiguration;
        };
        UserConfiguration.Bind_1 = function (service, name, parentFolderName, properties) {
            return UserConfiguration.Bind(service, name, new FolderId(parentFolderName), properties);
        };
        UserConfiguration.prototype.Save = function (name, parentFolderIdOrParentFolderName) {
            if (arguments.length === 2 && (name === null || name.constructor === String) && (parentFolderIdOrParentFolderName === null || parentFolderIdOrParentFolderName instanceof FolderId)) {
                this.Save_0(name, parentFolderIdOrParentFolderName);
                return;
            }
            this.Save_1(name, parentFolderIdOrParentFolderName);
        };
        UserConfiguration.prototype.Save_0 = function (name, parentFolderId) {
            EwsUtilities.ValidateParam(name, "name");
            EwsUtilities.ValidateParam(parentFolderId, "parentFolderId");
            parentFolderId.Validate(this.service.RequestedServerVersion);
            if (!this.isNew) {
                throw new InvalidOperationException(Strings.CannotSaveNotNewUserConfiguration);
            }
            this.parentFolderId = parentFolderId;
            this.name = name;
            this.service.CreateUserConfiguration(this);
            this.isNew = false;
            this.ResetIsDirty();
        };
        UserConfiguration.prototype.Save_1 = function (name, parentFolderName) {
            this.Save(name, new FolderId(parentFolderName));
        };
        UserConfiguration.prototype.Update = function () {
            if (this.isNew) {
                throw new InvalidOperationException(Strings.CannotUpdateNewUserConfiguration);
            }
            if (this.IsPropertyUpdated(UserConfigurationProperties.BinaryData) || this.IsPropertyUpdated(UserConfigurationProperties.Dictionary) || this.IsPropertyUpdated(UserConfigurationProperties.XmlData)) {
                this.service.UpdateUserConfiguration(this);
            }
            this.ResetIsDirty();
        };
        UserConfiguration.prototype.Delete = function () {
            if (this.isNew) {
                throw new InvalidOperationException(Strings.DeleteInvalidForUnsavedUserConfiguration);
            }
            this.service.DeleteUserConfiguration(this.name, this.parentFolderId);
        };
        UserConfiguration.prototype.Load = function (properties) {
            this.InitializeProperties(properties);
            this.service.LoadPropertiesForUserConfiguration(this, properties);
        };
        UserConfiguration.prototype.WriteToXml = function (writer, xmlNamespace, xmlElementName) {
            EwsUtilities.Assert(writer !== null, "UserConfiguration.WriteToXml", "writer is null");
            EwsUtilities.Assert(xmlElementName !== null, "UserConfiguration.WriteToXml", "xmlElementName is null");
            writer.WriteStartElement(xmlNamespace, xmlElementName);
            UserConfiguration.WriteUserConfigurationNameToXml(writer, XmlNamespace.Types, this.name, this.parentFolderId);
            if (this.IsPropertyUpdated(UserConfigurationProperties.Dictionary)) {
                this.dictionary.WriteToXml(writer, "Dictionary");
            }
            if (this.IsPropertyUpdated(UserConfigurationProperties.XmlData)) {
                this.WriteXmlDataToXml(writer);
            }
            if (this.IsPropertyUpdated(UserConfigurationProperties.BinaryData)) {
                this.WriteBinaryDataToXml(writer);
            }
            writer.WriteEndElement();
        };
        UserConfiguration.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("UserConfigurationName", this.GetJsonUserConfigName(service));
            jsonObject.Add("ItemId", this.itemId);
            if (this.IsPropertyUpdated(UserConfigurationProperties.Dictionary)) {
                jsonObject.Add("Dictionary", this.dictionary.ToJson(service));
            }
            if (this.IsPropertyUpdated(UserConfigurationProperties.XmlData)) {
                jsonObject.Add("XmlData", this.GetBase64PropertyValue(this.XmlData));
            }
            if (this.IsPropertyUpdated(UserConfigurationProperties.BinaryData)) {
                jsonObject.Add("BinaryData", this.GetBase64PropertyValue(this.BinaryData));
            }
            return jsonObject;
        };
        UserConfiguration.prototype.GetJsonUserConfigName = function (service) {
            var folderId = this.parentFolderId;
            var text = this.name;
            return UserConfiguration.GetJsonUserConfigName(service, folderId, text);
        };
        UserConfiguration.GetJsonUserConfigName = function (service, parentFolderId, name) {
            var jsonObject = new JsonObject();
            jsonObject.Add("BaseFolderId", parentFolderId.InternalToJson(service));
            jsonObject.Add("Name", name);
            return jsonObject;
        };
        UserConfiguration.prototype.GetBase64PropertyValue = function (bytes) {
            if (bytes === null || bytes.length === 0) {
                return NString.Empty;
            }
            return Convert.ToBase64String(bytes);
        };
        UserConfiguration.prototype.IsPropertyUpdated = function (property) {
            var IL_A7 = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        var flag = false;
                        var flag2 = false;
                        switch (property) {
                            case UserConfigurationProperties.Dictionary:
                                flag = this.Dictionary.IsDirty;
                                flag2 = (this.Dictionary.Count === 0);
                                _goto = IL_A7;
                                continue _GOTO_LOOP;
                            case UserConfigurationProperties.Id | UserConfigurationProperties.Dictionary:
                                break;
                            case UserConfigurationProperties.XmlData:
                                flag = ((property & this.updatedProperties) === property);
                                flag2 = (this.xmlData === null || this.xmlData.length === 0);
                                _goto = IL_A7;
                                continue _GOTO_LOOP;
                            default:
                                if (property === UserConfigurationProperties.BinaryData) {
                                    flag = ((property & this.updatedProperties) === property);
                                    flag2 = (this.binaryData === null || this.binaryData.length === 0);
                                    _goto = IL_A7;
                                    continue _GOTO_LOOP;
                                }
                                break;
                        }
                        EwsUtilities.Assert(false, "UserConfiguration.IsPropertyUpdated", "property not supported: " + UserConfigurationProperties[property]);
                        _goto = IL_A7;
                        continue _GOTO_LOOP;
                    case 1:
                        return flag && (!flag2 || !this.isNew);
                }
            }
        };
        UserConfiguration.prototype.WriteXmlDataToXml = function (writer) {
            EwsUtilities.Assert(writer !== null, "UserConfiguration.WriteXmlDataToXml", "writer is null");
            UserConfiguration.WriteByteArrayToXml(writer, this.xmlData, "XmlData");
        };
        UserConfiguration.prototype.WriteBinaryDataToXml = function (writer) {
            EwsUtilities.Assert(writer !== null, "UserConfiguration.WriteBinaryDataToXml", "writer is null");
            UserConfiguration.WriteByteArrayToXml(writer, this.binaryData, "BinaryData");
        };
        UserConfiguration.prototype.LoadFromXml = function (reader) {
            EwsUtilities.Assert(reader !== null, "UserConfiguration.LoadFromXml", "reader is null");
            reader.ReadStartElement(XmlNamespace.Messages, "UserConfiguration");
            reader.Read();
            do {
                var IL_146 = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            if (reader.NodeType === 1) {
                                var localName;
                                if ((localName = reader.LocalName) !== null) {
                                    if (localName === "UserConfigurationName") {
                                        var text = reader.ReadAttributeValue("Name");
                                        EwsUtilities.Assert(NString.Compare(this.name, text, StringComparison.Ordinal) === 0, "UserConfiguration.LoadFromXml", "UserConfigurationName does not match: Expected: " + this.name + " Name in response: " + text);
                                        reader.SkipCurrentElement();
                                        _goto = IL_146;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "ItemId") {
                                        this.itemId = new ItemId();
                                        this.itemId.LoadFromXml(reader, "ItemId");
                                        _goto = IL_146;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "Dictionary") {
                                        this.dictionary.LoadFromXml(reader, "Dictionary");
                                        _goto = IL_146;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "XmlData") {
                                        this.xmlData = Convert.FromBase64String(reader.ReadElementValue());
                                        _goto = IL_146;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "BinaryData") {
                                        this.binaryData = Convert.FromBase64String(reader.ReadElementValue());
                                        _goto = IL_146;
                                        continue _GOTO_LOOP;
                                    }
                                }
                                EwsUtilities.Assert(false, "UserConfiguration.LoadFromXml", "Xml element not supported: " + reader.LocalName);
                            }
                            _goto = IL_146;
                            continue _GOTO_LOOP;
                        case 1:
                            reader.Read();
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "UserConfiguration"));
        };
        UserConfiguration.prototype.LoadFromJson = function (responseObject, service) {
            var enumerator = responseObject.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "UserConfigurationName")) {
                            if (!(a === "ItemId")) {
                                if (!(a === "Dictionary")) {
                                    if (!(a === "XmlData")) {
                                        if (a === "BinaryData") {
                                            this.binaryData = Convert.FromBase64String(responseObject.ReadAsString(current));
                                        }
                                    }
                                    else {
                                        this.xmlData = Convert.FromBase64String(responseObject.ReadAsString(current));
                                    }
                                }
                                else {
                                    this.dictionary.CreateFromJsonCollection(responseObject.ReadAsArray(current), service);
                                }
                            }
                            else {
                                this.itemId = new ItemId();
                                this.itemId.LoadFromJson(responseObject.ReadAsJsonObject(current), service);
                            }
                        }
                        else {
                            var jsonObject = responseObject.ReadAsJsonObject(current);
                            var text = jsonObject.ReadAsString("Name");
                            EwsUtilities.Assert(NString.Compare(this.name, text, StringComparison.Ordinal) === 0, "UserConfiguration.LoadFromJson", "UserConfigurationName does not match: Expected: " + this.name + " Name in response: " + text);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        UserConfiguration.prototype.InitializeProperties = function (requestedProperties) {
            this.itemId = null;
            this.dictionary = new UserConfigurationDictionary();
            this.xmlData = null;
            this.binaryData = null;
            this.propertiesAvailableForAccess = requestedProperties;
            this.ResetIsDirty();
        };
        UserConfiguration.prototype.ResetIsDirty = function () {
            this.updatedProperties = 0;
            this.dictionary.IsDirty = false;
        };
        UserConfiguration.prototype.ValidatePropertyAccess = function (property) {
            if ((property & this.propertiesAvailableForAccess) !== property) {
                throw new PropertyException(Strings.MustLoadOrAssignPropertyBeforeAccess, UserConfigurationProperties[property]);
            }
        };
        UserConfiguration.prototype.MarkPropertyForUpdate = function (property) {
            this.updatedProperties = (this.updatedProperties | property);
            this.propertiesAvailableForAccess = (this.propertiesAvailableForAccess | property);
        };
        UserConfiguration.ObjectVersion = ExchangeVersion.Exchange2010;
        UserConfiguration.PropertiesAvailableForNewObject = UserConfigurationProperties.Dictionary | UserConfigurationProperties.XmlData | UserConfigurationProperties.BinaryData;
        UserConfiguration.NoProperties = 0;
        return UserConfiguration;
    }());
    var AttendeeInfo = (function () {
        function AttendeeInfo(smtpAddress, attendeeType, excludeConflicts) {
            this.smtpAddress = null;
            this.attendeeType = MeetingAttendeeType.Required;
            this.excludeConflicts = false;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 3 && (smtpAddress === null || smtpAddress.constructor === String) && (attendeeType === null || attendeeType.constructor === Number) && (excludeConflicts === null || excludeConflicts.constructor === Boolean)) {
                this.constructor_1(smtpAddress, attendeeType, excludeConflicts);
                return;
            }
            this.constructor_2(smtpAddress);
        }
        Object.defineProperty(AttendeeInfo.prototype, "SmtpAddress", {
            get: function () {
                return this.smtpAddress;
            },
            set: function (value) {
                this.smtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttendeeInfo.prototype, "AttendeeType", {
            get: function () {
                return this.attendeeType;
            },
            set: function (value) {
                this.attendeeType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttendeeInfo.prototype, "ExcludeConflicts", {
            get: function () {
                return this.excludeConflicts;
            },
            set: function (value) {
                this.excludeConflicts = value;
            },
            enumerable: true,
            configurable: true
        });
        AttendeeInfo.prototype.constructor_0 = function () {
        };
        AttendeeInfo.prototype.constructor_1 = function (smtpAddress, attendeeType, excludeConflicts) {
            this.constructor_0();
            this.smtpAddress = smtpAddress;
            this.attendeeType = attendeeType;
            this.excludeConflicts = excludeConflicts;
        };
        AttendeeInfo.prototype.constructor_2 = function (smtpAddress) {
            this.constructor_1(smtpAddress, MeetingAttendeeType.Required, false);
            this.smtpAddress = smtpAddress;
        };
        AttendeeInfo.op_Implicit = function (smtpAddress) {
            return new AttendeeInfo(smtpAddress);
        };
        AttendeeInfo.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, "MailboxData");
            writer.WriteStartElement(XmlNamespace.Types, "Email");
            writer.WriteElementValue(XmlNamespace.Types, "Address", this.SmtpAddress);
            writer.WriteEndElement();
            writer.WriteElementValue(XmlNamespace.Types, "AttendeeType", this.attendeeType);
            writer.WriteElementValue(XmlNamespace.Types, "ExcludeConflicts", this.excludeConflicts);
            writer.WriteEndElement();
        };
        AttendeeInfo.prototype.Validate = function () {
            EwsUtilities.ValidateParam(this.smtpAddress, "SmtpAddress");
        };
        return AttendeeInfo;
    }());
    var AvailabilityOptions = (function () {
        function AvailabilityOptions() {
            this.mergedFreeBusyInterval = 30;
            this.requestedFreeBusyView = FreeBusyViewType.Detailed;
            this.goodSuggestionThreshold = 25;
            this.maximumSuggestionsPerDay = 10;
            this.maximumNonWorkHoursSuggestionsPerDay = 0;
            this.meetingDuration = 60;
            this.minimumSuggestionQuality = SuggestionQuality.Fair;
            this.detailedSuggestionsWindow = null;
            this.currentMeetingTime = null;
            this.globalObjectId = null;
            _super.call(this);
        }
        Object.defineProperty(AvailabilityOptions.prototype, "MergedFreeBusyInterval", {
            get: function () {
                return this.mergedFreeBusyInterval;
            },
            set: function (value) {
                if (value < 5 || value > 1440) {
                    throw new ArgumentException(NString.Format(Strings.InvalidPropertyValueNotInRange, "MergedFreeBusyInterval", 5, 1440));
                }
                this.mergedFreeBusyInterval = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "RequestedFreeBusyView", {
            get: function () {
                return this.requestedFreeBusyView;
            },
            set: function (value) {
                this.requestedFreeBusyView = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "GoodSuggestionThreshold", {
            get: function () {
                return this.goodSuggestionThreshold;
            },
            set: function (value) {
                if (value < 1 || value > 49) {
                    throw new ArgumentException(NString.Format(Strings.InvalidPropertyValueNotInRange, "GoodSuggestionThreshold", 1, 49));
                }
                this.goodSuggestionThreshold = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "MaximumSuggestionsPerDay", {
            get: function () {
                return this.maximumSuggestionsPerDay;
            },
            set: function (value) {
                if (value < 0 || value > 48) {
                    throw new ArgumentException(NString.Format(Strings.InvalidPropertyValueNotInRange, "MaximumSuggestionsPerDay", 0, 48));
                }
                this.maximumSuggestionsPerDay = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "MaximumNonWorkHoursSuggestionsPerDay", {
            get: function () {
                return this.maximumNonWorkHoursSuggestionsPerDay;
            },
            set: function (value) {
                if (value < 0 || value > 48) {
                    throw new ArgumentException(NString.Format(Strings.InvalidPropertyValueNotInRange, "MaximumNonWorkHoursSuggestionsPerDay", 0, 48));
                }
                this.maximumNonWorkHoursSuggestionsPerDay = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "MeetingDuration", {
            get: function () {
                return this.meetingDuration;
            },
            set: function (value) {
                if (value < 30 || value > 1440) {
                    throw new ArgumentException(NString.Format(Strings.InvalidPropertyValueNotInRange, "MeetingDuration", 30, 1440));
                }
                this.meetingDuration = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "MinimumSuggestionQuality", {
            get: function () {
                return this.minimumSuggestionQuality;
            },
            set: function (value) {
                this.minimumSuggestionQuality = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "DetailedSuggestionsWindow", {
            get: function () {
                return this.detailedSuggestionsWindow;
            },
            set: function (value) {
                this.detailedSuggestionsWindow = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "CurrentMeetingTime", {
            get: function () {
                return this.currentMeetingTime;
            },
            set: function (value) {
                this.currentMeetingTime = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AvailabilityOptions.prototype, "GlobalObjectId", {
            get: function () {
                return this.globalObjectId;
            },
            set: function (value) {
                this.globalObjectId = value;
            },
            enumerable: true,
            configurable: true
        });
        AvailabilityOptions.prototype.Validate = function (timeWindow) {
            if (TimeSpan.op_GreaterThan(TimeSpan.FromMinutes(this.MergedFreeBusyInterval), timeWindow)) {
                throw new ArgumentException(Strings.MergedFreeBusyIntervalMustBeSmallerThanTimeWindow, "MergedFreeBusyInterval");
            }
            EwsUtilities.ValidateParamAllowNull(this.DetailedSuggestionsWindow, "DetailedSuggestionsWindow");
        };
        AvailabilityOptions.prototype.WriteToXml = function (writer, request) {
            if (request.IsFreeBusyViewRequested) {
                writer.WriteStartElement(XmlNamespace.Types, "FreeBusyViewOptions");
                request.TimeWindow.WriteToXmlUnscopedDatesOnly(writer, "TimeWindow");
                writer.WriteElementValue(XmlNamespace.Types, "MergedFreeBusyIntervalInMinutes", this.MergedFreeBusyInterval);
                writer.WriteElementValue(XmlNamespace.Types, "RequestedView", this.RequestedFreeBusyView);
                writer.WriteEndElement();
            }
            if (request.IsSuggestionsViewRequested) {
                writer.WriteStartElement(XmlNamespace.Types, "SuggestionsViewOptions");
                writer.WriteElementValue(XmlNamespace.Types, "GoodThreshold", this.GoodSuggestionThreshold);
                writer.WriteElementValue(XmlNamespace.Types, "MaximumResultsByDay", this.MaximumSuggestionsPerDay);
                writer.WriteElementValue(XmlNamespace.Types, "MaximumNonWorkHourResultsByDay", this.MaximumNonWorkHoursSuggestionsPerDay);
                writer.WriteElementValue(XmlNamespace.Types, "MeetingDurationInMinutes", this.MeetingDuration);
                writer.WriteElementValue(XmlNamespace.Types, "MinimumSuggestionQuality", this.MinimumSuggestionQuality);
                var timeWindow = (this.DetailedSuggestionsWindow === null) ? request.TimeWindow : this.DetailedSuggestionsWindow;
                timeWindow.WriteToXmlUnscopedDatesOnly(writer, "DetailedSuggestionsWindow");
                if (this.CurrentMeetingTime !== null) {
                    writer.WriteElementValue(XmlNamespace.Types, "CurrentMeetingTime", this.CurrentMeetingTime.Value);
                }
                writer.WriteElementValue(XmlNamespace.Types, "GlobalObjectId", this.GlobalObjectId);
                writer.WriteEndElement();
            }
        };
        return AvailabilityOptions;
    }());
    var GetUserAvailabilityResults = (function () {
        function GetUserAvailabilityResults() {
            this.attendeesAvailability = null;
            this.suggestionsResponse = null;
            _super.call(this);
        }
        Object.defineProperty(GetUserAvailabilityResults.prototype, "SuggestionsResponse", {
            get: function () {
                return this.suggestionsResponse;
            },
            set: function (value) {
                this.suggestionsResponse = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityResults.prototype, "AttendeesAvailability", {
            get: function () {
                return this.attendeesAvailability;
            },
            set: function (value) {
                this.attendeesAvailability = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetUserAvailabilityResults.prototype, "Suggestions", {
            get: function () {
                if (this.suggestionsResponse === null) {
                    return null;
                }
                this.suggestionsResponse.ThrowIfNecessary();
                return this.suggestionsResponse.Suggestions;
            },
            enumerable: true,
            configurable: true
        });
        return GetUserAvailabilityResults;
    }());
    var LegacyAvailabilityTimeZone = (function (_super) {
        __extends(LegacyAvailabilityTimeZone, _super);
        function LegacyAvailabilityTimeZone(timeZoneInfo) {
            _super.call(this);
            this.bias = null;
            this.standardTime = null;
            this.daylightTime = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(timeZoneInfo);
        }
        LegacyAvailabilityTimeZone.prototype.constructor_0 = function () {
        };
        LegacyAvailabilityTimeZone.prototype.constructor_1 = function (timeZoneInfo) {
            this.constructor_0();
            this.bias = -timeZoneInfo.BaseUtcOffset;
            var adjustmentRules = timeZoneInfo.GetAdjustmentRules();
            if (adjustmentRules.length === 0) {
                this.daylightTime = new LegacyAvailabilityTimeZoneTime();
                this.daylightTime.Delta = TimeSpan.Zero;
                this.daylightTime.DayOrder = 1;
                this.daylightTime.DayOfTheWeek = DayOfTheWeek.Sunday;
                this.daylightTime.Month = 10;
                this.daylightTime.TimeOfDay = TimeSpan.FromHours(2.0);
                this.daylightTime.Year = 0;
                this.standardTime = new LegacyAvailabilityTimeZoneTime();
                this.standardTime.Delta = TimeSpan.Zero;
                this.standardTime.DayOrder = 1;
                this.standardTime.DayOfTheWeek = DayOfTheWeek.Sunday;
                this.standardTime.Month = 3;
                this.standardTime.TimeOfDay = TimeSpan.FromHours(2.0);
                this.daylightTime.Year = 0;
                return;
            }
            var adjustmentRule = adjustmentRules[adjustmentRules.length - 1];
            this.standardTime = new LegacyAvailabilityTimeZoneTime(adjustmentRule.DaylightTransitionEnd, TimeSpan.Zero);
            this.daylightTime = new LegacyAvailabilityTimeZoneTime(adjustmentRule.DaylightTransitionStart, -adjustmentRule.DaylightDelta);
        };
        LegacyAvailabilityTimeZone.prototype.ToTimeZoneInfo = function () {
            if (this.daylightTime.HasTransitionTime && this.standardTime.HasTransitionTime) {
                var adjustmentRule = TimeZoneInfo_AdjustmentRule.CreateAdjustmentRule(DateTime.MinValue.Date, DateTime.MaxValue.Date, -this.daylightTime.Delta, this.daylightTime.ToTransitionTime(), this.standardTime.ToTransitionTime());
                return TimeZoneInfo.CreateCustomTimeZone(Guid.NewGuid().ToString(), -this.bias, "Custom time zone", "Standard time", "Daylight time", [
                    adjustmentRule
                ]);
            }
            return TimeZoneInfo.CreateCustomTimeZone(Guid.NewGuid().ToString(), -this.bias, "Custom time zone", "Standard time");
        };
        LegacyAvailabilityTimeZone.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "Bias") {
                    this.bias = TimeSpan.FromMinutes(reader.ReadElementValue());
                    return true;
                }
                if (localName === "StandardTime") {
                    this.standardTime = new LegacyAvailabilityTimeZoneTime();
                    this.standardTime.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
                if (localName === "DaylightTime") {
                    this.daylightTime = new LegacyAvailabilityTimeZoneTime();
                    this.daylightTime.LoadFromXml(reader, reader.LocalName);
                    return true;
                }
            }
            return false;
        };
        LegacyAvailabilityTimeZone.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "Bias")) {
                            if (!(a === "StandardTime")) {
                                if (a === "DaylightTime") {
                                    this.daylightTime = new LegacyAvailabilityTimeZoneTime();
                                    this.daylightTime.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                                }
                            }
                            else {
                                this.standardTime = new LegacyAvailabilityTimeZoneTime();
                                this.standardTime.LoadFromJson(jsonProperty.ReadAsJsonObject(current), service);
                            }
                        }
                        else {
                            this.bias = TimeSpan.FromMinutes(jsonProperty.ReadAsInt(current));
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        LegacyAvailabilityTimeZone.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Bias", this.bias.TotalMinutes);
            this.standardTime.WriteToXml(writer, "StandardTime");
            this.daylightTime.WriteToXml(writer, "DaylightTime");
        };
        LegacyAvailabilityTimeZone.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Bias", this.bias.TotalMinutes);
            jsonObject.Add("StandardTime", this.standardTime.InternalToJson(service));
            jsonObject.Add("DaylightTime", this.daylightTime.InternalToJson(service));
            return jsonObject;
        };
        return LegacyAvailabilityTimeZone;
    }(ComplexProperty));
    var LegacyAvailabilityTimeZoneTime = (function (_super) {
        __extends(LegacyAvailabilityTimeZoneTime, _super);
        function LegacyAvailabilityTimeZoneTime(transitionTime, delta) {
            _super.call(this);
            this.delta = null;
            this.year = 0;
            this.month = 0;
            this.dayOrder = 0;
            this.dayOfTheWeek = 0;
            this.timeOfDay = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(transitionTime, delta);
        }
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "HasTransitionTime", {
            get: function () {
                return this.month >= 1 && this.month <= 12;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "Delta", {
            get: function () {
                return this.delta;
            },
            set: function (value) {
                this.delta = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "TimeOfDay", {
            get: function () {
                return this.timeOfDay;
            },
            set: function (value) {
                this.timeOfDay = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "DayOrder", {
            get: function () {
                return this.dayOrder;
            },
            set: function (value) {
                this.dayOrder = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "Month", {
            get: function () {
                return this.month;
            },
            set: function (value) {
                this.month = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "DayOfTheWeek", {
            get: function () {
                return this.dayOfTheWeek;
            },
            set: function (value) {
                this.dayOfTheWeek = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegacyAvailabilityTimeZoneTime.prototype, "Year", {
            get: function () {
                return this.year;
            },
            set: function (value) {
                this.year = value;
            },
            enumerable: true,
            configurable: true
        });
        LegacyAvailabilityTimeZoneTime.prototype.constructor_0 = function () {
        };
        LegacyAvailabilityTimeZoneTime.prototype.constructor_1 = function (transitionTime, delta) {
            this.constructor_0();
            this.delta = delta;
            if (transitionTime.IsFixedDateRule) {
                this.year = DateTime.Today.Year;
                this.month = transitionTime.Month;
                this.dayOrder = transitionTime.Day;
                this.timeOfDay = transitionTime.TimeOfDay.TimeOfDay;
                return;
            }
            this.year = 0;
            this.month = transitionTime.Month;
            this.dayOfTheWeek = EwsUtilities.SystemToEwsDayOfTheWeek(transitionTime.DayOfWeek);
            this.dayOrder = transitionTime.Week;
            this.timeOfDay = transitionTime.TimeOfDay.TimeOfDay;
        };
        LegacyAvailabilityTimeZoneTime.prototype.ToTransitionTime = function () {
            if (this.year === 0) {
                return TimeZoneInfo_TransitionTime.CreateFloatingDateRule(new DateTime(DateTime.MinValue.Year, DateTime.MinValue.Month, DateTime.MinValue.Day, this.timeOfDay.Hours, this.timeOfDay.Minutes, this.timeOfDay.Seconds), this.month, this.dayOrder, EwsUtilities.EwsToSystemDayOfWeek(this.dayOfTheWeek));
            }
            return TimeZoneInfo_TransitionTime.CreateFixedDateRule(new DateTime(this.timeOfDay.Ticks), this.month, this.dayOrder);
        };
        LegacyAvailabilityTimeZoneTime.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            switch (localName = reader.LocalName) {
                case "Bias":
                    this.delta = TimeSpan.FromMinutes(reader.ReadElementValue());
                    return true;
                case "Time":
                    this.timeOfDay = TimeSpan.Parse(reader.ReadElementValue());
                    return true;
                case "DayOrder":
                    this.dayOrder = reader.ReadElementValue();
                    return true;
                case "DayOfWeek":
                    this.dayOfTheWeek = reader.ReadElementValue();
                    return true;
                case "Month":
                    this.month = reader.ReadElementValue();
                    return true;
                case "Year":
                    this.year = reader.ReadElementValue();
                    return true;
            }
            return false;
        };
        LegacyAvailabilityTimeZoneTime.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "Bias":
                            this.delta = TimeSpan.FromMinutes(jsonProperty.ReadAsInt(current));
                            break;
                        case "Time":
                            this.timeOfDay = TimeSpan.Parse(jsonProperty.ReadAsString(current));
                            break;
                        case "DayOrder":
                            this.dayOrder = jsonProperty.ReadAsInt(current);
                            break;
                        case "DayOfWeek":
                            this.dayOfTheWeek = jsonProperty.ReadEnumValue(current);
                            break;
                        case "Month":
                            this.month = jsonProperty.ReadAsInt(current);
                            break;
                        case "Year":
                            this.year = jsonProperty.ReadAsInt(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        LegacyAvailabilityTimeZoneTime.prototype.WriteElementsToXml = function (writer) {
            writer.WriteElementValue(XmlNamespace.Types, "Bias", this.delta.TotalMinutes);
            writer.WriteElementValue(XmlNamespace.Types, "Time", EwsUtilities.TimeSpanToXSTime(this.timeOfDay));
            writer.WriteElementValue(XmlNamespace.Types, "DayOrder", this.dayOrder);
            writer.WriteElementValue(XmlNamespace.Types, "Month", this.month);
            if (this.Year === 0) {
                writer.WriteElementValue(XmlNamespace.Types, "DayOfWeek", this.dayOfTheWeek);
            }
            if (this.Year !== 0) {
                writer.WriteElementValue(XmlNamespace.Types, "Year", this.Year);
            }
        };
        LegacyAvailabilityTimeZoneTime.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Bias", this.delta.TotalMinutes);
            jsonObject.Add("Time", EwsUtilities.TimeSpanToXSTime(this.timeOfDay));
            jsonObject.Add("DayOrder", this.dayOrder);
            jsonObject.Add("Month", this.month);
            if (this.Year === 0) {
                jsonObject.Add("DayOfWeek", this.dayOfTheWeek);
            }
            if (this.Year !== 0) {
                jsonObject.Add("Year", this.Year);
            }
            return jsonObject;
        };
        return LegacyAvailabilityTimeZoneTime;
    }(ComplexProperty));
    var OofReply = (function () {
        function OofReply(message) {
            this.culture = CultureInfo.CurrentCulture.Name;
            this.message = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(message);
        }
        Object.defineProperty(OofReply.prototype, "Culture", {
            get: function () {
                return this.culture;
            },
            set: function (value) {
                this.culture = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OofReply.prototype, "Message", {
            get: function () {
                return this.message;
            },
            set: function (value) {
                this.message = value;
            },
            enumerable: true,
            configurable: true
        });
        OofReply.WriteEmptyReplyToXml = function (writer, xmlElementName) {
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            writer.WriteEndElement();
        };
        OofReply.prototype.constructor_0 = function () {
        };
        OofReply.prototype.constructor_1 = function (message) {
            this.message = message;
        };
        OofReply.op_Implicit = function (message) {
            return new OofReply(message);
        };
        OofReply.op_Implicit = function (oofReply) {
            EwsUtilities.ValidateParam(oofReply, "oofReply");
            return oofReply.Message;
        };
        OofReply.prototype.LoadFromXml = function (reader, xmlElementName) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, xmlElementName);
            if (reader.HasAttributes) {
                this.culture = reader.ReadAttributeValue("xml:lang");
            }
            this.message = reader.ReadElementValue(XmlNamespace.Types, "Message");
            reader.ReadEndElement(XmlNamespace.Types, xmlElementName);
        };
        OofReply.prototype.LoadFromJson = function (jsonObject, service) {
            if (jsonObject.ContainsKey("xml:lang")) {
                this.culture = jsonObject.ReadAsString("xml:lang");
            }
            this.message = jsonObject.ReadAsString("Message");
        };
        OofReply.prototype.WriteToXml = function (writer, xmlElementName) {
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            if (this.Culture !== null) {
                writer.WriteAttributeValue("xml", "lang", this.Culture);
            }
            writer.WriteElementValue(XmlNamespace.Types, "Message", this.Message);
            writer.WriteEndElement();
        };
        OofReply.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            if (this.Culture !== null) {
                jsonObject.Add("xml:lang", this.Culture);
            }
            jsonObject.Add("Message", this.Message);
            return jsonObject;
        };
        OofReply.prototype.ToString = function () {
            return this.Message;
        };
        return OofReply;
    }());
    var TimeWindow = (function () {
        function TimeWindow(startTime, endTime) {
            this.startTime = null;
            this.endTime = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(startTime, endTime);
        }
        Object.defineProperty(TimeWindow.prototype, "StartTime", {
            get: function () {
                return this.startTime;
            },
            set: function (value) {
                this.startTime = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeWindow.prototype, "EndTime", {
            get: function () {
                return this.endTime;
            },
            set: function (value) {
                this.endTime = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeWindow.prototype, "Duration", {
            get: function () {
                return DateTime.op_Subtraction(this.endTime, this.startTime);
            },
            enumerable: true,
            configurable: true
        });
        TimeWindow.prototype.constructor_0 = function () {
        };
        TimeWindow.prototype.constructor_1 = function (startTime, endTime) {
            this.constructor_0();
            this.startTime = startTime;
            this.endTime = endTime;
        };
        TimeWindow.prototype.LoadFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "Duration");
            this.startTime = reader.ReadElementValueAsDateTime(XmlNamespace.Types, "StartTime").Value;
            this.endTime = reader.ReadElementValueAsDateTime(XmlNamespace.Types, "EndTime").Value;
            reader.ReadEndElement(XmlNamespace.Types, "Duration");
        };
        TimeWindow.prototype.LoadFromJson = function (jsonObject, service) {
            this.startTime = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonObject.ReadAsString("StartTime")).Value;
            this.endTime = service.ConvertUniversalDateTimeStringToLocalDateTime(jsonObject.ReadAsString("EndTime")).Value;
        };
        TimeWindow.WriteToXml = function (writer, xmlElementName, startTime, endTime) {
            writer.WriteStartElement(XmlNamespace.Types, xmlElementName);
            writer.WriteElementValue(XmlNamespace.Types, "StartTime", startTime);
            writer.WriteElementValue(XmlNamespace.Types, "EndTime", endTime);
            writer.WriteEndElement();
        };
        TimeWindow.prototype.WriteToXmlUnscopedDatesOnly = function (writer, xmlElementName) {
            TimeWindow.WriteToXml(writer, xmlElementName, this.StartTime.ToString("yyyy-MM-ddT00:00:00", CultureInfo.InvariantCulture), this.EndTime.ToString("yyyy-MM-ddT00:00:00", CultureInfo.InvariantCulture));
        };
        TimeWindow.prototype.WriteToXml = function (writer, xmlElementName) {
            TimeWindow.WriteToXml(writer, xmlElementName, this.StartTime, this.EndTime);
        };
        TimeWindow.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("StartTime", EwsUtilities.DateTimeToXSDateTime(this.startTime));
            jsonObject.Add("EndTime", EwsUtilities.DateTimeToXSDateTime(this.endTime));
            return jsonObject;
        };
        TimeWindow.prototype.Validate = function () {
            if (DateTime.op_GreaterThanOrEqual(this.StartTime, this.EndTime)) {
                throw new ArgumentException(Strings.TimeWindowStartTimeMustBeGreaterThanEndTime);
            }
        };
        return TimeWindow;
    }());
    var AlternateIdBase = (function () {
        function AlternateIdBase(format) {
            this.Format = 0;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(format);
        }
        AlternateIdBase.prototype.constructor_0 = function () {
        };
        AlternateIdBase.prototype.constructor_1 = function (format) {
            this.constructor_0();
            this.Format = format;
        };
        AlternateIdBase.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        AlternateIdBase.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Format", this.Format);
        };
        AlternateIdBase.prototype.LoadAttributesFromXml = function (reader) {
            this.Format = reader.ReadAttributeValue("Format");
        };
        AlternateIdBase.prototype.LoadAttributesFromJson = function (responseObject) {
            this.Format = responseObject.ReadEnumValue("Format");
        };
        AlternateIdBase.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Types, this.GetXmlElementName());
            this.WriteAttributesToXml(writer);
            writer.WriteEndElement();
        };
        AlternateIdBase.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            this.InternalToJson(jsonObject);
            return jsonObject;
        };
        AlternateIdBase.prototype.InternalToJson = function (jsonObject) {
            jsonObject.Add("Format", this.Format);
            jsonObject.AddTypeParameter(this.GetXmlElementName());
        };
        AlternateIdBase.prototype.InternalValidate = function () {
        };
        AlternateIdBase.prototype.Validate = function () {
            this.InternalValidate();
        };
        return AlternateIdBase;
    }());
    var AlternateId = (function (_super) {
        __extends(AlternateId, _super);
        function AlternateId(format, id, mailbox, isArchive) {
            _super.call(this);
            this.UniqueId = null;
            this.Mailbox = null;
            this.IsArchive = false;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 3 && (format === null || format.constructor === Number) && (id === null || id.constructor === String) && (mailbox === null || mailbox.constructor === String)) {
                this.constructor_1(format, id, mailbox);
                return;
            }
            this.constructor_2(format, id, mailbox, isArchive);
        }
        AlternateId.prototype.constructor_0 = function () {
        };
        AlternateId.prototype.constructor_1 = function (format, id, mailbox) {
            this.UniqueId = id;
            this.Mailbox = mailbox;
        };
        AlternateId.prototype.constructor_2 = function (format, id, mailbox, isArchive) {
            this.UniqueId = id;
            this.Mailbox = mailbox;
            this.IsArchive = isArchive;
        };
        AlternateId.prototype.GetXmlElementName = function () {
            return "AlternateId";
        };
        AlternateId.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("Id", this.UniqueId);
            writer.WriteAttributeValue("Mailbox", this.Mailbox);
            if (this.IsArchive) {
                writer.WriteAttributeValue("IsArchive", true);
            }
        };
        AlternateId.prototype.InternalToJson = function (jsonObject) {
            _super.prototype.InternalToJson.call(this, jsonObject);
            jsonObject.Add("Id", this.UniqueId);
            jsonObject.Add("Mailbox", this.Mailbox);
            if (this.IsArchive) {
                jsonObject.Add("IsArchive", true);
            }
        };
        AlternateId.prototype.LoadAttributesFromXml = function (reader) {
            _super.prototype.LoadAttributesFromXml.call(this, reader);
            this.UniqueId = reader.ReadAttributeValue("Id");
            this.Mailbox = reader.ReadAttributeValue("Mailbox");
            var value = reader.ReadAttributeValue("IsArchive");
            if (!NString.IsNullOrEmpty(value)) {
                this.IsArchive = reader.ReadAttributeValue("IsArchive");
                return;
            }
            this.IsArchive = false;
        };
        AlternateId.prototype.LoadAttributesFromJson = function (responseObject) {
            _super.prototype.LoadAttributesFromJson.call(this, responseObject);
            this.UniqueId = responseObject.ReadAsString("Id");
            this.Mailbox = responseObject.ReadAsString("Mailbox");
            this.IsArchive = (responseObject.ContainsKey("IsArchive") && responseObject.ReadAsBool("IsArchive"));
        };
        AlternateId.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.Mailbox, "mailbox");
        };
        AlternateId.SchemaTypeName = "AlternateIdType";
        return AlternateId;
    }(AlternateIdBase));
    var AlternatePublicFolderId = (function (_super) {
        __extends(AlternatePublicFolderId, _super);
        function AlternatePublicFolderId(format, folderId) {
            _super.call(this);
            this.FolderId = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(format, folderId);
        }
        AlternatePublicFolderId.prototype.constructor_0 = function () {
        };
        AlternatePublicFolderId.prototype.constructor_1 = function (format, folderId) {
            this.FolderId = folderId;
        };
        AlternatePublicFolderId.prototype.GetXmlElementName = function () {
            return "AlternatePublicFolderId";
        };
        AlternatePublicFolderId.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("FolderId", this.FolderId);
        };
        AlternatePublicFolderId.prototype.InternalToJson = function (jsonObject) {
            _super.prototype.InternalToJson.call(this, jsonObject);
            jsonObject.Add("FolderId", this.FolderId);
        };
        AlternatePublicFolderId.prototype.LoadAttributesFromXml = function (reader) {
            _super.prototype.LoadAttributesFromXml.call(this, reader);
            this.FolderId = reader.ReadAttributeValue("FolderId");
        };
        AlternatePublicFolderId.prototype.LoadAttributesFromJson = function (responseObject) {
            _super.prototype.LoadAttributesFromJson.call(this, responseObject);
            this.FolderId = responseObject.ReadAsString("FolderId");
        };
        AlternatePublicFolderId.SchemaTypeName = "AlternatePublicFolderIdType";
        return AlternatePublicFolderId;
    }(AlternateIdBase));
    var AlternatePublicFolderItemId = (function (_super) {
        __extends(AlternatePublicFolderItemId, _super);
        function AlternatePublicFolderItemId(format, folderId, itemId) {
            _super.call(this);
            this.itemId = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(format, folderId, itemId);
        }
        Object.defineProperty(AlternatePublicFolderItemId.prototype, "ItemId", {
            get: function () {
                return this.itemId;
            },
            set: function (value) {
                this.itemId = value;
            },
            enumerable: true,
            configurable: true
        });
        AlternatePublicFolderItemId.prototype.constructor_0 = function () {
        };
        AlternatePublicFolderItemId.prototype.constructor_1 = function (format, folderId, itemId) {
            this.itemId = itemId;
        };
        AlternatePublicFolderItemId.prototype.GetXmlElementName = function () {
            return "AlternatePublicFolderItemId";
        };
        AlternatePublicFolderItemId.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("ItemId", this.ItemId);
        };
        AlternatePublicFolderItemId.prototype.InternalToJson = function (jsonObject) {
            _super.prototype.InternalToJson.call(this, jsonObject);
            jsonObject.Add("ItemId", this.ItemId);
        };
        AlternatePublicFolderItemId.prototype.LoadAttributesFromXml = function (reader) {
            _super.prototype.LoadAttributesFromXml.call(this, reader);
            this.itemId = reader.ReadAttributeValue("ItemId");
        };
        AlternatePublicFolderItemId.prototype.LoadAttributesFromJson = function (responseObject) {
            _super.prototype.LoadAttributesFromJson.call(this, responseObject);
            this.itemId = responseObject.ReadAsString("ItemId");
        };
        AlternatePublicFolderItemId.SchemaTypeName = "AlternatePublicFolderItemIdType";
        return AlternatePublicFolderItemId;
    }(AlternatePublicFolderId));
    var NotificationEvent = (function () {
        function NotificationEvent(eventType, timestamp) {
            this.eventType = 0;
            this.timestamp = null;
            this.parentFolderId = null;
            this.oldParentFolderId = null;
            _super.call(this);
            this.eventType = eventType;
            this.timestamp = timestamp;
        }
        Object.defineProperty(NotificationEvent.prototype, "EventType", {
            get: function () {
                return this.eventType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NotificationEvent.prototype, "TimeStamp", {
            get: function () {
                return this.timestamp;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NotificationEvent.prototype, "ParentFolderId", {
            get: function () {
                return this.parentFolderId;
            },
            set: function (value) {
                this.parentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NotificationEvent.prototype, "OldParentFolderId", {
            get: function () {
                return this.oldParentFolderId;
            },
            set: function (value) {
                this.oldParentFolderId = value;
            },
            enumerable: true,
            configurable: true
        });
        NotificationEvent.prototype.InternalLoadFromXml = function (reader) {
        };
        NotificationEvent.prototype.LoadFromXml = function (reader, xmlElementName) {
            this.InternalLoadFromXml(reader);
            reader.ReadEndElementIfNecessary(XmlNamespace.Types, xmlElementName);
        };
        NotificationEvent.prototype.LoadFromJson = function (jsonEvent, service) {
            throw new NotSupportedException();
        };
        return NotificationEvent;
    }());
    var FolderEvent = (function (_super) {
        __extends(FolderEvent, _super);
        function FolderEvent(eventType, timestamp) {
            _super.call(this, eventType, timestamp);
            this.folderId = null;
            this.oldFolderId = null;
            this.unreadCount = null;
        }
        Object.defineProperty(FolderEvent.prototype, "FolderId", {
            get: function () {
                return this.folderId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderEvent.prototype, "OldFolderId", {
            get: function () {
                return this.oldFolderId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderEvent.prototype, "UnreadCount", {
            get: function () {
                return this.unreadCount;
            },
            enumerable: true,
            configurable: true
        });
        FolderEvent.prototype.InternalLoadFromXml = function (reader) {
            _super.prototype.InternalLoadFromXml.call(this, reader);
            this.folderId = new FolderId();
            this.folderId.LoadFromXml(reader, reader.LocalName);
            reader.Read();
            this.ParentFolderId = new FolderId();
            this.ParentFolderId.LoadFromXml(reader, "ParentFolderId");
            switch (this.EventType) {
                case EventType.Modified:
                    reader.Read();
                    if (reader.IsStartElement()) {
                        reader.EnsureCurrentNodeIsStartElement(XmlNamespace.Types, "UnreadCount");
                        this.unreadCount = new Nullable(NNumber.Parse(reader.ReadValue()));
                    }
                    return;
                case EventType.Moved:
                case EventType.Copied:
                    reader.Read();
                    this.oldFolderId = new FolderId();
                    this.oldFolderId.LoadFromXml(reader, reader.LocalName);
                    reader.Read();
                    this.OldParentFolderId = new FolderId();
                    this.OldParentFolderId.LoadFromXml(reader, reader.LocalName);
                    return;
                default:
                    return;
            }
        };
        FolderEvent.prototype.LoadFromJson = function (jsonEvent, service) {
            this.folderId = new FolderId();
            this.folderId.LoadFromJson(jsonEvent.ReadAsJsonObject("FolderId"), service);
            this.ParentFolderId = new FolderId();
            this.ParentFolderId.LoadFromJson(jsonEvent.ReadAsJsonObject("ParentFolderId"), service);
            switch (this.EventType) {
                case EventType.Modified:
                    if (jsonEvent.ContainsKey("UnreadCount")) {
                        this.unreadCount = new Nullable(jsonEvent.ReadAsInt("UnreadCount"));
                    }
                    return;
                case EventType.Moved:
                case EventType.Copied:
                    this.oldFolderId = new FolderId();
                    this.oldFolderId.LoadFromJson(jsonEvent.ReadAsJsonObject("OldFolderId"), service);
                    this.OldParentFolderId = new FolderId();
                    this.OldParentFolderId.LoadFromJson(jsonEvent.ReadAsJsonObject("OldParentFolderId"), service);
                    return;
                default:
                    return;
            }
        };
        return FolderEvent;
    }(NotificationEvent));
    var GetEventsResults = (function () {
        function GetEventsResults() {
            this.privateWatermark = null;
            this.subscriptionId = null;
            this.previousWatermark = null;
            this.moreEventsAvailable = false;
            this.events = new Collection();
            _super.call(this);
        }
        Object.defineProperty(GetEventsResults, "XmlElementNameToEventTypeMap", {
            get: function () {
                return GetEventsResults.xmlElementNameToEventTypeMap.Member;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "SubscriptionId", {
            get: function () {
                return this.subscriptionId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "PreviousWatermark", {
            get: function () {
                return this.previousWatermark;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "NewWatermark", {
            get: function () {
                return this.newWatermark;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "MoreEventsAvailable", {
            get: function () {
                return this.moreEventsAvailable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "FolderEvents", {
            get: function () {
                return Enumerable.OfType(this.events);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "ItemEvents", {
            get: function () {
                return Enumerable.OfType(this.events);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetEventsResults.prototype, "AllEvents", {
            get: function () {
                return this.events;
            },
            enumerable: true,
            configurable: true
        });
        GetEventsResults.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "Notification");
            this.subscriptionId = reader.ReadElementValue(XmlNamespace.Types, "SubscriptionId");
            this.previousWatermark = reader.ReadElementValue(XmlNamespace.Types, "PreviousWatermark");
            this.moreEventsAvailable = reader.ReadElementValue(XmlNamespace.Types, "MoreEvents");
            do {
                reader.Read();
                if (reader.IsStartElement()) {
                    var localName = reader.LocalName;
                    var eventType;
                    if ((function () {
                        var _p0 = [
                            eventType
                        ];
                        var _r = GetEventsResults.xmlElementNameToEventTypeMap.Member.TryGetValue(localName, _p0);
                        eventType = _p0[0];
                        return _r;
                    })()) {
                        this.newWatermark = reader.ReadElementValue(XmlNamespace.Types, "Watermark");
                        if (eventType === EventType.Status) {
                            reader.ReadEndElementIfNecessary(XmlNamespace.Types, localName);
                        }
                        else {
                            this.LoadNotificationEventFromXml(reader, localName, eventType);
                        }
                    }
                    else {
                        reader.SkipCurrentElement();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Messages, "Notification"));
        };
        GetEventsResults.prototype.LoadFromJson = function (eventsResponse, service) {
            var enumerator = eventsResponse.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "SubscriptionId")) {
                            if (!(a === "PreviousWatermark")) {
                                if (!(a === "MoreEvents")) {
                                    if (a === "Events") {
                                        this.LoadEventsFromJson(eventsResponse.ReadAsArray(current), service);
                                    }
                                }
                                else {
                                    this.moreEventsAvailable = eventsResponse.ReadAsBool(current);
                                }
                            }
                            else {
                                this.previousWatermark = eventsResponse.ReadAsString(current);
                            }
                        }
                        else {
                            this.subscriptionId = eventsResponse.ReadAsString(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        GetEventsResults.prototype.LoadEventsFromJson = function (jsonEventsArray, service) {
            for (var i = 0; i < jsonEventsArray.length; i = i + 1) {
                var jsonObject = jsonEventsArray[i];
                this.newWatermark = jsonObject.ReadAsString("Watermark");
                var eventType = jsonObject.ReadEnumValue("NotificationType");
                if (eventType !== EventType.Status) {
                    var notificationEvent;
                    if (jsonObject.ContainsKey("FolderId")) {
                        notificationEvent = new FolderEvent(eventType, service.ConvertUniversalDateTimeStringToLocalDateTime(jsonObject.ReadAsString("TimeStamp")).Value);
                    }
                    else {
                        notificationEvent = new ItemEvent(eventType, service.ConvertUniversalDateTimeStringToLocalDateTime(jsonObject.ReadAsString("TimeStamp")).Value);
                    }
                    notificationEvent.LoadFromJson(jsonObject, service);
                    this.events.Add(notificationEvent);
                }
            }
        };
        GetEventsResults.prototype.LoadNotificationEventFromXml = function (reader, eventElementName, eventType) {
            var timestamp = reader.ReadElementValue(XmlNamespace.Types, "TimeStamp");
            reader.Read();
            var notificationEvent;
            if (reader.LocalName === "FolderId") {
                notificationEvent = new FolderEvent(eventType, timestamp);
            }
            else {
                notificationEvent = new ItemEvent(eventType, timestamp);
            }
            notificationEvent.LoadFromXml(reader, eventElementName);
            this.events.Add(notificationEvent);
        };
        GetEventsResults.xmlElementNameToEventTypeMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add("CopiedEvent", EventType.Copied);
            dictionary.Add("CreatedEvent", EventType.Created);
            dictionary.Add("DeletedEvent", EventType.Deleted);
            dictionary.Add("ModifiedEvent", EventType.Modified);
            dictionary.Add("MovedEvent", EventType.Moved);
            dictionary.Add("NewMailEvent", EventType.NewMail);
            dictionary.Add("StatusEvent", EventType.Status);
            dictionary.Add("FreeBusyChangedEvent", EventType.FreeBusyChanged);
            return dictionary;
        });
        return GetEventsResults;
    }());
    var GetStreamingEventsResults = (function () {
        function GetStreamingEventsResults() {
            this.events = new Collection();
            _super.call(this);
        }
        Object.defineProperty(GetStreamingEventsResults.prototype, "Notifications", {
            get: function () {
                return this.events;
            },
            enumerable: true,
            configurable: true
        });
        GetStreamingEventsResults.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.Messages, "Notification");
            do {
                var notificationGroup = null;
                notificationGroup.SubscriptionId = reader.ReadElementValue(XmlNamespace.Types, "SubscriptionId");
                notificationGroup.Events = new Collection();
                Monitor.Enter(this);
                try {
                    this.events.Add(notificationGroup);
                }
                finally {
                    Monitor.Exit(this);
                }
                do {
                    reader.Read();
                    if (reader.IsStartElement()) {
                        var localName = reader.LocalName;
                        var eventType;
                        if ((function () {
                            var _p0 = [
                                eventType
                            ];
                            var _r = GetEventsResults.XmlElementNameToEventTypeMap.TryGetValue(localName, _p0);
                            eventType = _p0[0];
                            return _r;
                        })()) {
                            if (eventType === EventType.Status) {
                                reader.ReadEndElementIfNecessary(XmlNamespace.Types, localName);
                            }
                            else {
                                this.LoadNotificationEventFromXml(reader, localName, eventType, notificationGroup);
                            }
                        }
                        else {
                            reader.SkipCurrentElement();
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Messages, "Notification"));
                reader.Read();
            } while (!reader.IsEndElement(XmlNamespace.Messages, "Notifications"));
        };
        GetStreamingEventsResults.prototype.LoadNotificationEventFromXml = function (reader, eventElementName, eventType, notifications) {
            var timestamp = reader.ReadElementValue(XmlNamespace.Types, "TimeStamp");
            reader.Read();
            var notificationEvent;
            if (reader.LocalName === "FolderId") {
                notificationEvent = new FolderEvent(eventType, timestamp);
            }
            else {
                notificationEvent = new ItemEvent(eventType, timestamp);
            }
            notificationEvent.LoadFromXml(reader, eventElementName);
            notifications.Events.Add(notificationEvent);
        };
        return GetStreamingEventsResults;
    }());
    var GetStreamingEventsResults_NotificationGroup = (function () {
        function GetStreamingEventsResults_NotificationGroup() {
            this.SubscriptionId = null;
            this.Events = null;
            _super.call(this);
        }
        return GetStreamingEventsResults_NotificationGroup;
    }());
    var ItemEvent = (function (_super) {
        __extends(ItemEvent, _super);
        function ItemEvent(eventType, timestamp) {
            _super.call(this, eventType, timestamp);
            this.itemId = null;
            this.oldItemId = null;
        }
        Object.defineProperty(ItemEvent.prototype, "ItemId", {
            get: function () {
                return this.itemId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ItemEvent.prototype, "OldItemId", {
            get: function () {
                return this.oldItemId;
            },
            enumerable: true,
            configurable: true
        });
        ItemEvent.prototype.InternalLoadFromXml = function (reader) {
            _super.prototype.InternalLoadFromXml.call(this, reader);
            this.itemId = new ItemId();
            this.itemId.LoadFromXml(reader, reader.LocalName);
            reader.Read();
            this.ParentFolderId = new FolderId();
            this.ParentFolderId.LoadFromXml(reader, "ParentFolderId");
            switch (this.EventType) {
                case EventType.Moved:
                case EventType.Copied:
                    reader.Read();
                    this.oldItemId = new ItemId();
                    this.oldItemId.LoadFromXml(reader, reader.LocalName);
                    reader.Read();
                    this.OldParentFolderId = new FolderId();
                    this.OldParentFolderId.LoadFromXml(reader, reader.LocalName);
                    return;
                default:
                    return;
            }
        };
        ItemEvent.prototype.LoadFromJson = function (jsonEvent, service) {
            this.itemId = new ItemId();
            this.itemId.LoadFromJson(jsonEvent.ReadAsJsonObject("ItemId"), service);
            this.ParentFolderId = new FolderId();
            this.ParentFolderId.LoadFromJson(jsonEvent.ReadAsJsonObject("ParentFolderId"), service);
            switch (this.EventType) {
                case EventType.Moved:
                case EventType.Copied:
                    this.oldItemId = new ItemId();
                    this.oldItemId.LoadFromJson(jsonEvent.ReadAsJsonObject("OldItemId"), service);
                    this.OldParentFolderId = new FolderId();
                    this.OldParentFolderId.LoadFromJson(jsonEvent.ReadAsJsonObject("OldParentFolderId"), service);
                    return;
                default:
                    return;
            }
        };
        return ItemEvent;
    }(NotificationEvent));
    var NotificationEventArgs = (function (_super) {
        __extends(NotificationEventArgs, _super);
        function NotificationEventArgs(subscription, events) {
            _super.call(this);
            this.Subscription = null;
            this.Events = null;
            this.Subscription = subscription;
            this.Events = events;
        }
        return NotificationEventArgs;
    }(EventArgs));
    var SubscriptionBase = (function () {
        function SubscriptionBase(service, id, watermark) {
            this.service = null;
            this.id = null;
            this.watermark = null;
            _super.call(this);
            if (arguments.length === 1 && (service === null || service instanceof ExchangeService)) {
                this.constructor_0(service);
                return;
            }
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (id === null || id.constructor === String)) {
                this.constructor_1(service, id);
                return;
            }
            this.constructor_2(service, id, watermark);
        }
        Object.defineProperty(SubscriptionBase.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SubscriptionBase.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SubscriptionBase.prototype, "Watermark", {
            get: function () {
                return this.watermark;
            },
            set: function (value) {
                this.watermark = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SubscriptionBase.prototype, "UsesWatermark", {
            get: function () {
                return true;
            },
            enumerable: true,
            configurable: true
        });
        SubscriptionBase.prototype.constructor_0 = function (service) {
            EwsUtilities.ValidateParam(service, "service");
            this.service = service;
        };
        SubscriptionBase.prototype.constructor_1 = function (service, id) {
            this.constructor_0(service);
            EwsUtilities.ValidateParam(id, "id");
            this.id = id;
        };
        SubscriptionBase.prototype.constructor_2 = function (service, id, watermark) {
            this.constructor_1(service, id);
            this.watermark = watermark;
        };
        SubscriptionBase.prototype.LoadFromXml = function (reader) {
            this.id = reader.ReadElementValue(XmlNamespace.Messages, "SubscriptionId");
            if (this.UsesWatermark) {
                this.watermark = reader.ReadElementValue(XmlNamespace.Messages, "Watermark");
            }
        };
        SubscriptionBase.prototype.LoadFromJson = function (jsonResponse, service) {
            this.id = jsonResponse.ReadAsString("SubscriptionId");
            if (this.UsesWatermark) {
                this.watermark = jsonResponse.ReadAsString("Watermark");
            }
        };
        return SubscriptionBase;
    }());
    var PullSubscription = (function (_super) {
        __extends(PullSubscription, _super);
        function PullSubscription(service) {
            _super.call(this, service);
            this.moreEventsAvailable = null;
        }
        Object.defineProperty(PullSubscription.prototype, "MoreEventsAvailable", {
            get: function () {
                return this.moreEventsAvailable;
            },
            enumerable: true,
            configurable: true
        });
        PullSubscription.prototype.GetEvents = function () {
            var events = this.Service.GetEvents(this.Id, this.Watermark);
            this.Watermark = events.NewWatermark;
            this.moreEventsAvailable = new Nullable(events.MoreEventsAvailable);
            return events;
        };
        PullSubscription.prototype.BeginGetEvents = function (callback, state) {
            return this.Service.BeginGetEvents(callback, state, this.Id, this.Watermark);
        };
        PullSubscription.prototype.EndGetEvents = function (asyncResult) {
            var getEventsResults = this.Service.EndGetEvents(asyncResult);
            this.Watermark = getEventsResults.NewWatermark;
            this.moreEventsAvailable = new Nullable(getEventsResults.MoreEventsAvailable);
            return getEventsResults;
        };
        PullSubscription.prototype.Unsubscribe = function () {
            this.Service.Unsubscribe(this.Id);
        };
        PullSubscription.prototype.BeginUnsubscribe = function (callback, state) {
            return this.Service.BeginUnsubscribe(callback, state, this.Id);
        };
        PullSubscription.prototype.EndUnsubscribe = function (asyncResult) {
            this.Service.EndUnsubscribe(asyncResult);
        };
        return PullSubscription;
    }(SubscriptionBase));
    var PushSubscription = (function (_super) {
        __extends(PushSubscription, _super);
        function PushSubscription(service) {
            _super.call(this, service);
        }
        return PushSubscription;
    }(SubscriptionBase));
    var StreamingSubscription = (function (_super) {
        __extends(StreamingSubscription, _super);
        function StreamingSubscription(service) {
            _super.call(this, service);
        }
        Object.defineProperty(StreamingSubscription.prototype, "Service", {
            get: function () {
                return this.Service;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingSubscription.prototype, "UsesWatermark", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        StreamingSubscription.prototype.Unsubscribe = function () {
            this.Service.Unsubscribe(this.Id);
        };
        StreamingSubscription.prototype.BeginUnsubscribe = function (callback, state) {
            return this.Service.BeginUnsubscribe(callback, state, this.Id);
        };
        StreamingSubscription.prototype.EndUnsubscribe = function (asyncResult) {
            this.Service.EndUnsubscribe(asyncResult);
        };
        return StreamingSubscription;
    }(SubscriptionBase));
    var StreamingSubscriptionConnection = (function () {
        function StreamingSubscriptionConnection(service, lifetimeOrSubscriptions, lifetime) {
            this.subscriptions = null;
            this.connectionTimeout = 0;
            this.session = null;
            this.isDisposed = false;
            this.currentHangingRequest = null;
            this.lockObject = new any();
            this.OnNotificationEvent = new NEvent();
            this.OnSubscriptionError = new NEvent();
            this.OnDisconnect = new NEvent();
            _super.call(this);
            if (arguments.length === 2 && (service === null || service instanceof ExchangeService) && (lifetimeOrSubscriptions === null || lifetimeOrSubscriptions.constructor === Number)) {
                this.constructor_0(service, lifetimeOrSubscriptions);
                return;
            }
            this.constructor_1(service, lifetimeOrSubscriptions, lifetime);
        }
        Object.defineProperty(StreamingSubscriptionConnection.prototype, "CurrentSubscriptions", {
            get: function () {
                var list = new List();
                var obj;
                Monitor.Enter(obj = this.lockObject);
                try {
                    list.AddRange(this.subscriptions.Values);
                }
                finally {
                    Monitor.Exit(obj);
                }
                return list;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingSubscriptionConnection.prototype, "IsOpen", {
            get: function () {
                this.ThrowIfDisposed();
                return this.currentHangingRequest !== null && this.currentHangingRequest.IsConnected;
            },
            enumerable: true,
            configurable: true
        });
        StreamingSubscriptionConnection.prototype.constructor_0 = function (service, lifetime) {
            EwsUtilities.ValidateParam(service, "service");
            EwsUtilities.ValidateClassVersion(service, ExchangeVersion.Exchange2010_SP1, _super.prototype.GetType.call(this).Name);
            if (lifetime < 1 || lifetime > 30) {
                throw new ArgumentOutOfRangeException("lifetime");
            }
            this.session = service;
            this.subscriptions = new Dictionary();
            this.connectionTimeout = lifetime;
        };
        StreamingSubscriptionConnection.prototype.constructor_1 = function (service, subscriptions, lifetime) {
            this.constructor_0(service, lifetime);
            EwsUtilities.ValidateParamCollection(subscriptions, "subscriptions");
            var enumerator = subscriptions.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    this.subscriptions.Add(current.Id, current);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        StreamingSubscriptionConnection.prototype.AddSubscription = function (subscription) {
            this.ThrowIfDisposed();
            EwsUtilities.ValidateParam(subscription, "subscription");
            this.ValidateConnectionState(false, Strings.CannotAddSubscriptionToLiveConnection);
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                if (!this.subscriptions.ContainsKey(subscription.Id)) {
                    this.subscriptions.Add(subscription.Id, subscription);
                }
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        StreamingSubscriptionConnection.prototype.RemoveSubscription = function (subscription) {
            this.ThrowIfDisposed();
            EwsUtilities.ValidateParam(subscription, "subscription");
            this.ValidateConnectionState(false, Strings.CannotRemoveSubscriptionFromLiveConnection);
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                this.subscriptions.Remove(subscription.Id);
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        StreamingSubscriptionConnection.prototype.Open = function () {
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                this.ThrowIfDisposed();
                this.ValidateConnectionState(false, Strings.CannotCallConnectDuringLiveConnection);
                if (this.subscriptions.Count === 0) {
                    throw new ServiceLocalException(Strings.NoSubscriptionsOnConnection);
                }
                this.currentHangingRequest = new GetStreamingEventsRequest(this.session, this.HandleServiceResponseObject, this.subscriptions.Keys, this.connectionTimeout);
                this.currentHangingRequest.OnDisconnect.Add(this.OnRequestDisconnect);
                this.currentHangingRequest.InternalExecute();
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        StreamingSubscriptionConnection.prototype.OnRequestDisconnect = function (sender, args) {
            this.InternalOnDisconnect(args.Exception);
        };
        StreamingSubscriptionConnection.prototype.Close = function () {
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                this.ThrowIfDisposed();
                this.ValidateConnectionState(true, Strings.CannotCallDisconnectWithNoLiveConnection);
                this.currentHangingRequest.Disconnect();
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        StreamingSubscriptionConnection.prototype.InternalOnDisconnect = function (ex) {
            if (this.OnDisconnect !== null) {
                this.OnDisconnect(this, new SubscriptionErrorEventArgs(null, ex));
            }
            this.currentHangingRequest = null;
        };
        StreamingSubscriptionConnection.prototype.ValidateConnectionState = function (isConnectedExpected, errorMessage) {
            if ((isConnectedExpected && !this.IsOpen) || (!isConnectedExpected && this.IsOpen)) {
                throw new ServiceLocalException(errorMessage);
            }
        };
        StreamingSubscriptionConnection.prototype.HandleServiceResponseObject = function (response) {
            var getStreamingEventsResponse = ((response instanceof GetStreamingEventsResponse) ? response : null);
            if (getStreamingEventsResponse === null) {
                throw new ArgumentException();
            }
            if (getStreamingEventsResponse.Result === ServiceResult.Success || getStreamingEventsResponse.Result === ServiceResult.Warning) {
                if (getStreamingEventsResponse.Results.Notifications.Count > 0) {
                    this.IssueNotificationEvents(getStreamingEventsResponse);
                    return;
                }
            }
            else {
                if (getStreamingEventsResponse.Result === ServiceResult.Error) {
                    if (getStreamingEventsResponse.ErrorSubscriptionIds === null || getStreamingEventsResponse.ErrorSubscriptionIds.Count === 0) {
                        this.IssueGeneralFailure(getStreamingEventsResponse);
                        return;
                    }
                    this.IssueSubscriptionFailures(getStreamingEventsResponse);
                }
            }
        };
        StreamingSubscriptionConnection.prototype.IssueSubscriptionFailures = function (gseResponse) {
            var exception = new ServiceResponseException(gseResponse);
            var enumerator = gseResponse.ErrorSubscriptionIds.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var streamingSubscription = null;
                    var obj;
                    Monitor.Enter(obj = this.lockObject);
                    try {
                        if (this.subscriptions !== null && this.subscriptions.ContainsKey(current)) {
                            streamingSubscription = this.subscriptions.get_Item(current);
                        }
                    }
                    finally {
                        Monitor.Exit(obj);
                    }
                    if (streamingSubscription !== null) {
                        var args = new SubscriptionErrorEventArgs(streamingSubscription, exception);
                        if (this.OnSubscriptionError !== null) {
                            this.OnSubscriptionError(this, args);
                        }
                    }
                    if (gseResponse.ErrorCode !== ServiceError.ErrorMissedNotificationEvents) {
                        var obj2;
                        Monitor.Enter(obj2 = this.lockObject);
                        try {
                            if (this.subscriptions !== null && this.subscriptions.ContainsKey(current)) {
                                this.subscriptions.Remove(current);
                            }
                        }
                        finally {
                            Monitor.Exit(obj2);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        StreamingSubscriptionConnection.prototype.IssueGeneralFailure = function (gseResponse) {
            var args = new SubscriptionErrorEventArgs(null, new ServiceResponseException(gseResponse));
            if (this.OnSubscriptionError !== null) {
                this.OnSubscriptionError(this, args);
            }
        };
        StreamingSubscriptionConnection.prototype.IssueNotificationEvents = function (gseResponse) {
            var enumerator = gseResponse.Results.Notifications.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var streamingSubscription = null;
                    var obj;
                    Monitor.Enter(obj = this.lockObject);
                    try {
                        if (this.subscriptions !== null && this.subscriptions.ContainsKey(current.SubscriptionId)) {
                            streamingSubscription = this.subscriptions.get_Item(current.SubscriptionId);
                        }
                    }
                    finally {
                        Monitor.Exit(obj);
                    }
                    if (streamingSubscription !== null) {
                        var args = new NotificationEventArgs(streamingSubscription, current.Events);
                        if (this.OnNotificationEvent !== null) {
                            this.OnNotificationEvent(this, args);
                        }
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        StreamingSubscriptionConnection.prototype._StreamingSubscriptionConnection = function () {
            this.Dispose(false);
        };
        StreamingSubscriptionConnection.prototype.Dispose = function (suppressFinalizer) {
            if (arguments.length === 0) {
                this.Dispose_0();
                return;
            }
            this.Dispose_1(suppressFinalizer);
        };
        StreamingSubscriptionConnection.prototype.Dispose_0 = function () {
            this.Dispose(true);
        };
        StreamingSubscriptionConnection.prototype.Dispose_1 = function (suppressFinalizer) {
            if (suppressFinalizer) {
                GC.SuppressFinalize(this);
            }
            var obj;
            Monitor.Enter(obj = this.lockObject);
            try {
                if (!this.isDisposed) {
                    if (this.currentHangingRequest !== null) {
                        this.currentHangingRequest = null;
                    }
                    this.subscriptions = null;
                    this.session = null;
                    this.isDisposed = true;
                }
            }
            finally {
                Monitor.Exit(obj);
            }
        };
        StreamingSubscriptionConnection.prototype.ThrowIfDisposed = function () {
            if (this.isDisposed) {
                throw new ObjectDisposedException(_super.prototype.GetType.call(this).FullName);
            }
        };
        return StreamingSubscriptionConnection;
    }());
    var SubscriptionErrorEventArgs = (function (_super) {
        __extends(SubscriptionErrorEventArgs, _super);
        function SubscriptionErrorEventArgs(subscription, exception) {
            _super.call(this);
            this.Subscription = null;
            this.Exception = null;
            this.Subscription = subscription;
            this.Exception = exception;
        }
        return SubscriptionErrorEventArgs;
    }(EventArgs));
    var ExtendedPropertyDefinition = (function (_super) {
        __extends(ExtendedPropertyDefinition, _super);
        function ExtendedPropertyDefinition(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId, mapiType) {
            _super.call(this);
            this.propertySet = null;
            this.propertySetId = null;
            this.tag = null;
            this.name = null;
            this.id = null;
            this.mapiType = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (mapiTypeOrTagOrPropertySetOrPropertySetId === null || mapiTypeOrTagOrPropertySetOrPropertySetId.constructor === Number)) {
                this.constructor_1(mapiTypeOrTagOrPropertySetOrPropertySetId);
                return;
            }
            if (arguments.length === 2 && (mapiTypeOrTagOrPropertySetOrPropertySetId === null || mapiTypeOrTagOrPropertySetOrPropertySetId.constructor === Number) && (mapiTypeOrNameOrId === null || mapiTypeOrNameOrId.constructor === Number)) {
                this.constructor_2(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId);
                return;
            }
            if (arguments.length === 3 && (mapiTypeOrTagOrPropertySetOrPropertySetId === null || mapiTypeOrTagOrPropertySetOrPropertySetId.constructor === Number) && (mapiTypeOrNameOrId === null || mapiTypeOrNameOrId.constructor === String) && (mapiType === null || mapiType.constructor === Number)) {
                this.constructor_3(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId, mapiType);
                return;
            }
            if (arguments.length === 3 && (mapiTypeOrTagOrPropertySetOrPropertySetId === null || mapiTypeOrTagOrPropertySetOrPropertySetId.constructor === Number) && (mapiTypeOrNameOrId === null || mapiTypeOrNameOrId.constructor === Number) && (mapiType === null || mapiType.constructor === Number)) {
                this.constructor_4(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId, mapiType);
                return;
            }
            if (arguments.length === 3 && (mapiTypeOrTagOrPropertySetOrPropertySetId === null || mapiTypeOrTagOrPropertySetOrPropertySetId instanceof Guid) && (mapiTypeOrNameOrId === null || mapiTypeOrNameOrId.constructor === String) && (mapiType === null || mapiType.constructor === Number)) {
                this.constructor_5(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId, mapiType);
                return;
            }
            this.constructor_6(mapiTypeOrTagOrPropertySetOrPropertySetId, mapiTypeOrNameOrId, mapiType);
        }
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "Version", {
            get: function () {
                return ExchangeVersion.Exchange2007_SP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "PropertySet", {
            get: function () {
                return this.propertySet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "PropertySetId", {
            get: function () {
                return this.propertySetId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "Tag", {
            get: function () {
                return this.tag;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "Name", {
            get: function () {
                return this.name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "Id", {
            get: function () {
                return this.id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "MapiType", {
            get: function () {
                return this.mapiType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedPropertyDefinition.prototype, "Type", {
            get: function () {
                return MapiTypeConverter.MapiTypeConverterMap.get_Item(this.MapiType).Type;
            },
            enumerable: true,
            configurable: true
        });
        ExtendedPropertyDefinition.prototype.constructor_0 = function () {
            this.mapiType = MapiPropertyType.String;
        };
        ExtendedPropertyDefinition.prototype.constructor_1 = function (mapiType) {
            this.constructor_0();
            this.mapiType = mapiType;
        };
        ExtendedPropertyDefinition.prototype.constructor_2 = function (tag, mapiType) {
            this.constructor_1(mapiType);
            if (tag < 0 || tag > 65535) {
                throw new ArgumentOutOfRangeException("tag", Strings.TagValueIsOutOfRange);
            }
            this.tag = new Nullable(tag);
        };
        ExtendedPropertyDefinition.prototype.constructor_3 = function (propertySet, name, mapiType) {
            this.constructor_1(mapiType);
            EwsUtilities.ValidateParam(name, "name");
            this.propertySet = new Nullable(propertySet);
            this.name = name;
        };
        ExtendedPropertyDefinition.prototype.constructor_4 = function (propertySet, id, mapiType) {
            this.constructor_1(mapiType);
            this.propertySet = new Nullable(propertySet);
            this.id = new Nullable(id);
        };
        ExtendedPropertyDefinition.prototype.constructor_5 = function (propertySetId, name, mapiType) {
            this.constructor_1(mapiType);
            EwsUtilities.ValidateParam(name, "name");
            this.propertySetId = new Nullable(propertySetId);
            this.name = name;
        };
        ExtendedPropertyDefinition.prototype.constructor_6 = function (propertySetId, id, mapiType) {
            this.constructor_1(mapiType);
            this.propertySetId = new Nullable(propertySetId);
            this.id = new Nullable(id);
        };
        ExtendedPropertyDefinition.IsEqualTo = function (extPropDef1, extPropDef2) {
            return NObject.ReferenceEquals(extPropDef1, extPropDef2) || (ExtendedPropertyDefinition.op_Inequality(extPropDef1, null) && ExtendedPropertyDefinition.op_Inequality(extPropDef2, null) && extPropDef1.Id === extPropDef2.Id && extPropDef1.MapiType === extPropDef2.MapiType && extPropDef1.Tag === extPropDef2.Tag && extPropDef1.Name === extPropDef2.Name && extPropDef1.PropertySet === extPropDef2.PropertySet && extPropDef1.propertySetId === extPropDef2.propertySetId);
        };
        ExtendedPropertyDefinition.prototype.GetXmlElementName = function () {
            return "ExtendedFieldURI";
        };
        ExtendedPropertyDefinition.prototype.GetJsonType = function () {
            return "ExtendedPropertyUri";
        };
        ExtendedPropertyDefinition.prototype.WriteAttributesToXml = function (writer) {
            if (this.propertySet !== null) {
                writer.WriteAttributeValue("DistinguishedPropertySetId", this.propertySet.Value);
            }
            if (this.propertySetId !== null) {
                writer.WriteAttributeValue("PropertySetId", this.propertySetId.Value.ToString());
            }
            if (this.tag !== null) {
                writer.WriteAttributeValue("PropertyTag", this.tag.Value);
            }
            if (!NString.IsNullOrEmpty(this.name)) {
                writer.WriteAttributeValue("PropertyName", this.name);
            }
            if (this.id !== null) {
                writer.WriteAttributeValue("PropertyId", this.id.Value);
            }
            writer.WriteAttributeValue("PropertyType", this.mapiType);
        };
        ExtendedPropertyDefinition.prototype.AddJsonProperties = function (jsonPropertyDefinition, service) {
            if (this.propertySet !== null) {
                jsonPropertyDefinition.Add("DistinguishedPropertySetId", this.propertySet.Value);
            }
            if (this.propertySetId !== null) {
                jsonPropertyDefinition.Add("PropertySetId", this.propertySetId.Value.ToString());
            }
            if (this.tag !== null) {
                jsonPropertyDefinition.Add("PropertyTag", this.tag.Value);
            }
            if (!NString.IsNullOrEmpty(this.name)) {
                jsonPropertyDefinition.Add("PropertyName", this.name);
            }
            if (this.id !== null) {
                jsonPropertyDefinition.Add("PropertyId", this.id.Value);
            }
            jsonPropertyDefinition.Add("PropertyType", this.mapiType);
        };
        ExtendedPropertyDefinition.prototype.LoadFromXml = function (reader) {
            var text = reader.ReadAttributeValue("DistinguishedPropertySetId");
            if (!NString.IsNullOrEmpty(text)) {
                this.propertySet = new Nullable(Enum.Parse(new Type("Number"), text, false));
            }
            text = reader.ReadAttributeValue("PropertySetId");
            if (!NString.IsNullOrEmpty(text)) {
                this.propertySetId = new Nullable(new Guid(text));
            }
            text = reader.ReadAttributeValue("PropertyTag");
            if (!NString.IsNullOrEmpty(text)) {
                this.tag = new Nullable(Convert.ToUInt16(text, 16));
            }
            this.name = reader.ReadAttributeValue("PropertyName");
            text = reader.ReadAttributeValue("PropertyId");
            if (!NString.IsNullOrEmpty(text)) {
                this.id = new Nullable(NNumber.Parse(text));
            }
            this.mapiType = reader.ReadAttributeValue("PropertyType");
        };
        ExtendedPropertyDefinition.prototype.LoadFromJson = function (jsonObject) {
            var enumerator = jsonObject.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var key;
                    switch (key = current) {
                        case "DistinguishedPropertySetId":
                            this.propertySet = new Nullable(jsonObject.ReadEnumValue(current));
                            break;
                        case "PropertySetId":
                            this.propertySetId = new Nullable(new Guid(jsonObject.ReadAsString(current)));
                            break;
                        case "PropertyTag":
                            this.tag = new Nullable(Convert.ToUInt16(jsonObject.ReadAsString(current), 16));
                            break;
                        case "PropertyName":
                            this.name = jsonObject.ReadAsString(current);
                            break;
                        case "PropertyId":
                            this.id = new Nullable(jsonObject.ReadAsInt(current));
                            break;
                        case "PropertyType":
                            this.mapiType = jsonObject.ReadEnumValue(current);
                            break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        ExtendedPropertyDefinition.op_Equality = function (extPropDef1, extPropDef2) {
            return ExtendedPropertyDefinition.IsEqualTo(extPropDef1, extPropDef2);
        };
        ExtendedPropertyDefinition.op_Inequality = function (extPropDef1, extPropDef2) {
            return !ExtendedPropertyDefinition.IsEqualTo(extPropDef1, extPropDef2);
        };
        ExtendedPropertyDefinition.prototype.Equals = function (obj) {
            var extPropDef = ((obj instanceof ExtendedPropertyDefinition) ? obj : null);
            return ExtendedPropertyDefinition.IsEqualTo(extPropDef, this);
        };
        ExtendedPropertyDefinition.prototype.GetHashCode = function () {
            return NString.GetHashCode(this.GetPrintableName());
        };
        ExtendedPropertyDefinition.prototype.GetPrintableName = function () {
            var stringBuilder = new StringBuilder();
            stringBuilder.Append("{");
            stringBuilder.Append(this.FormatField("Name", this.Name));
            stringBuilder.Append(this.FormatField("MapiType", new Nullable(this.MapiType)));
            stringBuilder.Append(this.FormatField("Id", this.Id));
            stringBuilder.Append(this.FormatField("PropertySet", this.PropertySet));
            stringBuilder.Append(this.FormatField("PropertySetId", this.PropertySetId));
            stringBuilder.Append(this.FormatField("Tag", this.Tag));
            stringBuilder.Append("}");
            return stringBuilder.ToString();
        };
        ExtendedPropertyDefinition.prototype.FormatField = function (name, fieldValue) {
            if (fieldValue === null) {
                return NString.Empty;
            }
            return NString.Format("{0}: {1} ", name, fieldValue.ToString());
        };
        ExtendedPropertyDefinition.FieldFormat = "{0}: {1} ";
        ExtendedPropertyDefinition.PropertySetFieldName = "PropertySet";
        ExtendedPropertyDefinition.PropertySetIdFieldName = "PropertySetId";
        ExtendedPropertyDefinition.TagFieldName = "Tag";
        ExtendedPropertyDefinition.NameFieldName = "Name";
        ExtendedPropertyDefinition.IdFieldName = "Id";
        ExtendedPropertyDefinition.MapiTypeFieldName = "MapiType";
        return ExtendedPropertyDefinition;
    }(PropertyDefinitionBase));
    var GroupMemberPropertyDefinition = (function (_super) {
        __extends(GroupMemberPropertyDefinition, _super);
        function GroupMemberPropertyDefinition(key) {
            _super.call(this, "distributionlist:Members:Member");
            this.key = null;
            if (arguments.length === 1 && (key === null || key.constructor === String)) {
                this.constructor_0(key);
                return;
            }
            this.constructor_1();
        }
        Object.defineProperty(GroupMemberPropertyDefinition.prototype, "Key", {
            get: function () {
                return this.key;
            },
            set: function (value) {
                this.key = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupMemberPropertyDefinition.prototype, "Type", {
            get: function () {
                return new Type("String");
            },
            enumerable: true,
            configurable: true
        });
        GroupMemberPropertyDefinition.prototype.constructor_0 = function (key) {
            this.key = key;
        };
        GroupMemberPropertyDefinition.prototype.constructor_1 = function () {
        };
        GroupMemberPropertyDefinition.prototype.GetXmlElementName = function () {
            return "IndexedFieldURI";
        };
        GroupMemberPropertyDefinition.prototype.GetJsonType = function () {
            return "DictionaryPropertyUri";
        };
        GroupMemberPropertyDefinition.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("FieldIndex", this.Key);
        };
        GroupMemberPropertyDefinition.prototype.AddJsonProperties = function (jsonPropertyDefinition, service) {
            _super.prototype.AddJsonProperties.call(this, jsonPropertyDefinition, service);
            jsonPropertyDefinition.Add("FieldIndex", this.Key);
        };
        GroupMemberPropertyDefinition.prototype.GetPrintableName = function () {
            return NString.Format("{0}:{1}", "distributionlist:Members:Member", this.Key);
        };
        GroupMemberPropertyDefinition.FieldUri = "distributionlist:Members:Member";
        return GroupMemberPropertyDefinition;
    }(ServiceObjectPropertyDefinition));
    var ListValuePropertyDefinition = (function (_super) {
        __extends(ListValuePropertyDefinition, _super);
        function ListValuePropertyDefinition(xmlElementName, uri, flags, version) {
            _super.call(this, xmlElementName, uri, flags, version);
        }
        ListValuePropertyDefinition.prototype.Parse = function (value) {
            var value2 = NString.IsNullOrEmpty(value) ? value : NString.Replace(value, 32, /*' '*/ 44);
            return EwsUtilities.Parse(value2);
        };
        return ListValuePropertyDefinition;
    }(GenericPropertyDefinition));
    var ExchangeResourceManager = (function (_super) {
        __extends(ExchangeResourceManager, _super);
        function ExchangeResourceManager(baseName, assembly) {
            _super.call(this, baseName, assembly);
        }
        Object.defineProperty(ExchangeResourceManager.prototype, "BaseName", {
            get: function () {
                return this.BaseName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExchangeResourceManager.prototype, "AssemblyName", {
            get: function () {
                return this.MainAssembly.GetName().Name;
            },
            enumerable: true,
            configurable: true
        });
        ExchangeResourceManager.GetResourceManager = function (baseName, assembly) {
            if (Assembly.op_Equality(assembly, null)) {
                throw new ArgumentNullException("assembly");
            }
            var key = baseName + assembly.GetName().Name;
            var obj;
            Monitor.Enter(obj = ExchangeResourceManager.lockObject);
            var result;
            try {
                var exchangeResourceManager = ExchangeResourceManager.resourceManagers.get_Item(key);
                if (exchangeResourceManager === null) {
                    exchangeResourceManager = new ExchangeResourceManager(baseName, assembly);
                    ExchangeResourceManager.resourceManagers.set_Item(key, exchangeResourceManager);
                }
                result = exchangeResourceManager;
            }
            finally {
                Monitor.Exit(obj);
            }
            return result;
        };
        ExchangeResourceManager.prototype.GetString = function (name, culture) {
            if (arguments.length === 1 && (name === null || name.constructor === String)) {
                return this.GetString_0(name);
            }
            return this.GetString_1(name, culture);
        };
        ExchangeResourceManager.prototype.GetString_0 = function (name) {
            return this.GetString(name, CultureInfo.CurrentCulture);
        };
        ExchangeResourceManager.prototype.GetString_1 = function (name, culture) {
            return _super.prototype.GetString.call(this, name, culture);
        };
        ExchangeResourceManager.resourceManagers = new HybridDictionary();
        ExchangeResourceManager.lockObject = new any();
        return ExchangeResourceManager;
    }(ResourceManager));
    var LocalizedString = (function () {
        function LocalizedString(idOrValueOrFormatOrInfo, resourceManagerOrInsertsOrContext, inserts) {
            this.Id = null;
            this.Inserts = null;
            this.ResourceManager = null;
            _super.call(this);
            if (arguments.length === 3 && (idOrValueOrFormatOrInfo === null || idOrValueOrFormatOrInfo.constructor === String) && (resourceManagerOrInsertsOrContext === null || resourceManagerOrInsertsOrContext instanceof ExchangeResourceManager) && (inserts === null || inserts instanceof Array)) {
                this.constructor_0(idOrValueOrFormatOrInfo, resourceManagerOrInsertsOrContext, inserts);
                return;
            }
            if (arguments.length === 1 && (idOrValueOrFormatOrInfo === null || idOrValueOrFormatOrInfo.constructor === String)) {
                this.constructor_1(idOrValueOrFormatOrInfo);
                return;
            }
            if (arguments.length === 2 && (idOrValueOrFormatOrInfo === null || idOrValueOrFormatOrInfo.constructor === String) && (resourceManagerOrInsertsOrContext === null || resourceManagerOrInsertsOrContext instanceof Array)) {
                this.constructor_2(idOrValueOrFormatOrInfo, resourceManagerOrInsertsOrContext);
                return;
            }
            this.constructor_3(idOrValueOrFormatOrInfo, resourceManagerOrInsertsOrContext);
        }
        Object.defineProperty(LocalizedString.prototype, "LocalizedString", {
            get: function () {
                return this;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LocalizedString.prototype, "IsEmpty", {
            get: function () {
                return null === this.Id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LocalizedString.prototype, "BaseId", {
            get: function () {
                var text = ((this.ResourceManager !== null) ? this.ResourceManager.BaseName : NString.Empty) + this.Id;
                return NString.GetHashCode(text);
            },
            enumerable: true,
            configurable: true
        });
        LocalizedString.op_Equality = function (s1, s2) {
            return s1.Equals(s2);
        };
        LocalizedString.op_Inequality = function (s1, s2) {
            return !s1.Equals(s2);
        };
        LocalizedString.op_Implicit = function (value) {
            return value.ToString();
        };
        LocalizedString.Join = function (separator, value) {
            if (value === null || value.length === 0) {
                return LocalizedString.Empty;
            }
            if (separator === null) {
                separator = NString.Empty;
            }
            var array = new Array(value.length + 1);
            array[0] = separator;
            NArray.Copy(value, 0, array, 1, value.length);
            var stringBuilder = new StringBuilder(6 * value.length);
            stringBuilder.Append("{");
            for (var i = 1; i < value.length; i = i + 1) {
                stringBuilder.Append(i);
                stringBuilder.Append("}{0}{");
            }
            stringBuilder.Append(value.length + "}");
            return new LocalizedString(stringBuilder.ToString(), array);
        };
        LocalizedString.prototype.constructor_0 = function (id, resourceManager, inserts) {
            if (id === null) {
                throw new ArgumentNullException("id");
            }
            if (resourceManager === null) {
                throw new ArgumentNullException("resourceManager");
            }
            this.Id = id;
            this.ResourceManager = resourceManager;
            this.Inserts = ((inserts !== null && inserts.length > 0) ? inserts : null);
        };
        LocalizedString.prototype.constructor_1 = function (value) {
            this.Id = value;
            this.Inserts = null;
            this.ResourceManager = null;
        };
        LocalizedString.prototype.constructor_2 = function (format, inserts) {
            this.Id = format;
            this.Inserts = inserts;
            this.ResourceManager = null;
        };
        LocalizedString.prototype.constructor_3 = function (info, context) {
            this.Inserts = info.GetValue("inserts", new Type("Array"));
            this.ResourceManager = null;
            this.Id = null;
            try {
                var $string = info.GetString("baseName");
                var string2 = info.GetString("assemblyName");
                var assembly = Assembly.Load(string2);
                this.ResourceManager = ExchangeResourceManager.GetResourceManager($string, assembly);
                this.Id = info.GetString("id");
                if (this.ResourceManager.GetString(this.Id) === null) {
                    this.ResourceManager = null;
                }
            }
            catch (ex_87) {
                if (ex_87 instanceof SerializationException) {
                    this.ResourceManager = null;
                }
                else if (ex_87 instanceof FileNotFoundException) {
                    this.ResourceManager = null;
                }
                else if (ex_87 instanceof MissingManifestResourceException) {
                    this.ResourceManager = null;
                }
                else
                    throw ex_87;
            }
            if (this.ResourceManager === null) {
                this.Id = info.GetString("fallback");
            }
        };
        LocalizedString.prototype.GetObjectData = function (info, context) {
            var array = null;
            if (this.Inserts !== null && this.Inserts.length > 0) {
                array = new Array(this.Inserts.length);
                for (var i = 0; i < this.Inserts.length; i = i + 1) {
                    var obj = this.Inserts[i];
                    if (obj !== null) {
                        if (obj instanceof ILocalizedString) {
                            obj = obj.LocalizedString;
                        }
                        else {
                            if (!obj.GetType().IsSerializable && !(obj instanceof ISerializable)) {
                                var obj2 = LocalizedString.TranslateObject(obj, CultureInfo.InvariantCulture);
                                if (obj2 === obj) {
                                    obj = NObject.GenericToString(obj);
                                }
                                else {
                                    obj = obj2;
                                }
                            }
                        }
                    }
                    array[i] = obj;
                }
            }
            info.AddValue("inserts", array);
            if (this.ResourceManager !== null) {
                info.AddValue("baseName", this.ResourceManager.BaseName);
                info.AddValue("assemblyName", this.ResourceManager.AssemblyName);
                info.AddValue("id", this.Id);
                info.AddValue("fallback", this.ResourceManager.GetString(this.Id, CultureInfo.InvariantCulture));
                return;
            }
            info.AddValue("fallback", this.Id);
        };
        LocalizedString.prototype.ToString = function (formatProvider) {
            if (arguments.length === 0) {
                return this.ToString_0();
            }
            return this.ToString_1(formatProvider);
        };
        LocalizedString.prototype.ToString_0 = function () {
            return this.ToString(null, null);
        };
        LocalizedString.prototype.ToString_1 = function (formatProvider) {
            return this.ToString(null, formatProvider);
        };
        LocalizedString.prototype.GetHashCode = function () {
            var num = (this.Id !== null) ? NString.GetHashCode(this.Id) : 0;
            var num2 = (this.ResourceManager !== null) ? this.ResourceManager.GetHashCode() : 0;
            var num3 = num ^ num2;
            if (this.Inserts !== null) {
                for (var i = 0; i < this.Inserts.length; i = i + 1) {
                    num3 = (num3 ^ i ^ ((this.Inserts[i] !== null) ? NObject.GenericGetHashCode(this.Inserts[i]) : 0));
                }
            }
            return num3;
        };
        LocalizedString.prototype.Equals = function (obj) {
            if (arguments.length === 1 && (obj === null || obj.constructor === Object)) {
                return this.Equals_0(obj);
            }
            return this.Equals_1(obj);
        };
        LocalizedString.prototype.Equals_0 = function (obj) {
            return obj instanceof LocalizedString && this.Equals(obj);
        };
        LocalizedString.prototype.Equals_1 = function (obj) {
            if (!NString.Equals(this.Id, obj.Id, StringComparison.OrdinalIgnoreCase)) {
                return false;
            }
            if (null !== this.ResourceManager ^ null !== obj.ResourceManager) {
                return false;
            }
            if (this.ResourceManager !== null && !NObject.GenericEquals(this.ResourceManager, obj.ResourceManager)) {
                return false;
            }
            if (null !== this.Inserts ^ null !== obj.Inserts) {
                return false;
            }
            if (this.Inserts !== null && obj.Inserts !== null) {
                if (this.Inserts.length !== obj.Inserts.length) {
                    return false;
                }
                for (var i = 0; i < this.Inserts.length; i = i + 1) {
                    if (null !== this.Inserts[i] ^ null !== obj.Inserts[i]) {
                        return false;
                    }
                    if (this.Inserts[i] !== null && obj.Inserts[i] !== null && !NObject.GenericEquals(this.Inserts[i], obj.Inserts[i])) {
                        return false;
                    }
                }
            }
            return true;
        };
        LocalizedString.TranslateObject = function (badObject, formatProvider) {
            var ex = ((badObject instanceof Exception) ? badObject : null);
            if (ex !== null) {
                return ex.Message;
            }
            return badObject;
        };
        LocalizedString.Empty = null;
        return LocalizedString;
    }());
    var SearchFilter = (function (_super) {
        __extends(SearchFilter, _super);
        function SearchFilter() {
            _super.call(this);
        }
        SearchFilter.LoadFromXml = function (reader) {
            reader.EnsureCurrentNodeIsStartElement();
            var localName = reader.LocalName;
            var searchFilterInstance = SearchFilter.GetSearchFilterInstance(localName);
            if (searchFilterInstance !== null) {
                searchFilterInstance.LoadFromXml(reader, reader.LocalName);
            }
            return searchFilterInstance;
        };
        SearchFilter.LoadSearchFilterFromJson = function (jsonObject, service) {
            var searchFilterInstance = SearchFilter.GetSearchFilterInstance(jsonObject.ReadTypeString());
            if (searchFilterInstance !== null) {
                searchFilterInstance.LoadFromJson(jsonObject, service);
            }
            return searchFilterInstance;
        };
        SearchFilter.GetSearchFilterInstance = function (localName) {
            var result;
            switch (localName) {
                case "Exists":
                    result = new SearchFilter_Exists();
                    return result;
                case "Contains":
                    result = new SearchFilter_ContainsSubstring();
                    return result;
                case "Excludes":
                    result = new SearchFilter_ExcludesBitmask();
                    return result;
                case "Not":
                    result = new SearchFilter_Not();
                    return result;
                case "And":
                    result = new SearchFilter_SearchFilterCollection(LogicalOperator.And);
                    return result;
                case "Or":
                    result = new SearchFilter_SearchFilterCollection(LogicalOperator.Or);
                    return result;
                case "IsEqualTo":
                    result = new SearchFilter_IsEqualTo();
                    return result;
                case "IsNotEqualTo":
                    result = new SearchFilter_IsNotEqualTo();
                    return result;
                case "IsGreaterThan":
                    result = new SearchFilter_IsGreaterThan();
                    return result;
                case "IsGreaterThanOrEqualTo":
                    result = new SearchFilter_IsGreaterThanOrEqualTo();
                    return result;
                case "IsLessThan":
                    result = new SearchFilter_IsLessThan();
                    return result;
                case "IsLessThanOrEqualTo":
                    result = new SearchFilter_IsLessThanOrEqualTo();
                    return result;
            }
            result = null;
            return result;
        };
        SearchFilter.prototype.GetXmlElementName = function () {
            throw new NotSupportedException();
        };
        SearchFilter.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetXmlElementName());
            return jsonObject;
        };
        SearchFilter.prototype.WriteToXml = function (writer) {
            _super.prototype.WriteToXml.call(this, writer, this.GetXmlElementName());
        };
        return SearchFilter;
    }(ComplexProperty));
    var SearchFilter_SearchFilterCollection = (function (_super) {
        __extends(SearchFilter_SearchFilterCollection, _super);
        function SearchFilter_SearchFilterCollection(logicalOperator, searchFilters) {
            _super.call(this);
            this.searchFilters = new List();
            this.logicalOperator = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (logicalOperator === null || logicalOperator.constructor === Number)) {
                this.constructor_1(logicalOperator);
                return;
            }
            if (arguments.length === 2 && (logicalOperator === null || logicalOperator.constructor === Number) && (searchFilters === null || searchFilters instanceof Array)) {
                this.constructor_2(logicalOperator, searchFilters);
                return;
            }
            this.constructor_3(logicalOperator, searchFilters);
        }
        Object.defineProperty(SearchFilter_SearchFilterCollection.prototype, "Count", {
            get: function () {
                return this.searchFilters.Count;
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_SearchFilterCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.searchFilters.get_Item(index);
        };
        SearchFilter_SearchFilterCollection.prototype.set_Item = function (index, value) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            this.searchFilters.set_Item(index, value);
        };
        Object.defineProperty(SearchFilter_SearchFilterCollection.prototype, "LogicalOperator", {
            get: function () {
                return this.logicalOperator;
            },
            set: function (value) {
                this.logicalOperator = value;
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_SearchFilterCollection.prototype.constructor_0 = function () {
        };
        SearchFilter_SearchFilterCollection.prototype.constructor_1 = function (logicalOperator) {
            this.logicalOperator = logicalOperator;
        };
        SearchFilter_SearchFilterCollection.prototype.constructor_2 = function (logicalOperator, searchFilters) {
            this.constructor_1(logicalOperator);
            this.AddRange(NArray.ToEnumerable(searchFilters));
        };
        SearchFilter_SearchFilterCollection.prototype.constructor_3 = function (logicalOperator, searchFilters) {
            this.constructor_1(logicalOperator);
            this.AddRange(searchFilters);
        };
        SearchFilter_SearchFilterCollection.prototype.InternalValidate = function () {
            for (var i = 0; i < this.Count; i = i + 1) {
                try {
                    this.get_Item(i).InternalValidate();
                }
                catch (innerException) {
                    if (innerException instanceof ServiceValidationException) {
                        throw new ServiceValidationException(NString.Format(Strings.SearchFilterAtIndexIsInvalid, i), innerException);
                    }
                    else
                        throw innerException;
                }
            }
        };
        SearchFilter_SearchFilterCollection.prototype.SearchFilterChanged = function (complexProperty) {
            this.Changed();
        };
        SearchFilter_SearchFilterCollection.prototype.GetXmlElementName = function () {
            return LogicalOperator[this.LogicalOperator];
        };
        SearchFilter_SearchFilterCollection.prototype.TryReadElementFromXml = function (reader) {
            this.Add(SearchFilter.LoadFromXml(reader));
            return true;
        };
        SearchFilter_SearchFilterCollection.prototype.LoadFromJson = function (jsonProperty, service) {
            var array = jsonProperty.ReadAsArray("Item");
            var array2 = array;
            for (var i = 0; i < array2.length; i = i + 1) {
                var obj = array2[i];
                this.Add(SearchFilter.LoadSearchFilterFromJson(((obj instanceof JsonObject) ? obj : null), service));
            }
        };
        SearchFilter_SearchFilterCollection.prototype.WriteElementsToXml = function (writer) {
            var enumerator = this.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.WriteToXml(writer);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        SearchFilter_SearchFilterCollection.prototype.WriteToXml = function (writer) {
            if (this.Count === 1) {
                this.get_Item(0).WriteToXml(writer);
                return;
            }
            _super.prototype.WriteToXml.call(this, writer);
        };
        SearchFilter_SearchFilterCollection.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            var list = new List();
            var enumerator = this.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.InternalToJson(service));
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            jsonObject.Add("Items", NArray.ToEnumerable(list.ToArray()));
            return jsonObject;
        };
        SearchFilter_SearchFilterCollection.prototype.Add = function (searchFilter) {
            if (searchFilter === null) {
                throw new ArgumentNullException("searchFilter");
            }
            searchFilter.OnChange.Add(this.SearchFilterChanged);
            this.searchFilters.Add(searchFilter);
            this.Changed();
        };
        SearchFilter_SearchFilterCollection.prototype.AddRange = function (searchFilters) {
            if (searchFilters === null) {
                throw new ArgumentNullException("searchFilters");
            }
            var enumerator = searchFilters.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.OnChange.Add(this.SearchFilterChanged);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
            this.searchFilters.AddRange(searchFilters);
            this.Changed();
        };
        SearchFilter_SearchFilterCollection.prototype.Clear = function () {
            if (this.Count > 0) {
                var enumerator = this.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        current.OnChange.Remove(this.SearchFilterChanged);
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                this.searchFilters.Clear();
                this.Changed();
            }
        };
        SearchFilter_SearchFilterCollection.prototype.Contains = function (searchFilter) {
            return this.searchFilters.Contains(searchFilter);
        };
        SearchFilter_SearchFilterCollection.prototype.Remove = function (searchFilter) {
            if (searchFilter === null) {
                throw new ArgumentNullException("searchFilter");
            }
            if (this.Contains(searchFilter)) {
                searchFilter.OnChange.Remove(this.SearchFilterChanged);
                this.searchFilters.Remove(searchFilter);
                this.Changed();
            }
        };
        SearchFilter_SearchFilterCollection.prototype.RemoveAt = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            this.get_Item(index).OnChange.Remove(this.SearchFilterChanged);
            this.searchFilters.RemoveAt(index);
            this.Changed();
        };
        SearchFilter_SearchFilterCollection.prototype.GetEnumerator = function () {
            return this.searchFilters.GetEnumerator();
        };
        return SearchFilter_SearchFilterCollection;
    }(SearchFilter));
    var SearchFilter_Not = (function (_super) {
        __extends(SearchFilter_Not, _super);
        function SearchFilter_Not(searchFilter) {
            _super.call(this);
            this.searchFilter = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(searchFilter);
        }
        Object.defineProperty(SearchFilter_Not.prototype, "SearchFilter", {
            get: function () {
                return this.searchFilter;
            },
            set: function (value) {
                var _this = this;
                if (this.searchFilter !== null) {
                    this.searchFilter.OnChange.Remove(this.SearchFilterChanged);
                }
                (function () {
                    var _p0 = [
                        _this.searchFilter
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.searchFilter = _p0[0];
                    return _r;
                })();
                if (this.searchFilter !== null) {
                    this.searchFilter.OnChange.Add(this.SearchFilterChanged);
                }
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_Not.prototype.constructor_0 = function () {
        };
        SearchFilter_Not.prototype.constructor_1 = function (searchFilter) {
            this.searchFilter = searchFilter;
        };
        SearchFilter_Not.prototype.SearchFilterChanged = function (complexProperty) {
            this.Changed();
        };
        SearchFilter_Not.prototype.InternalValidate = function () {
            if (this.searchFilter === null) {
                throw new ServiceValidationException(Strings.SearchFilterMustBeSet);
            }
        };
        SearchFilter_Not.prototype.GetXmlElementName = function () {
            return "Not";
        };
        SearchFilter_Not.prototype.TryReadElementFromXml = function (reader) {
            this.searchFilter = SearchFilter.LoadFromXml(reader);
            return true;
        };
        SearchFilter_Not.prototype.LoadFromJson = function (jsonProperty, service) {
            this.searchFilter = SearchFilter.LoadSearchFilterFromJson(jsonProperty.ReadAsJsonObject("Item"), service);
        };
        SearchFilter_Not.prototype.WriteElementsToXml = function (writer) {
            this.SearchFilter.WriteToXml(writer);
        };
        SearchFilter_Not.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            jsonObject.Add("Item", this.SearchFilter.InternalToJson(service));
            return jsonObject;
        };
        return SearchFilter_Not;
    }(SearchFilter));
    var SearchFilter_PropertyBasedFilter = (function (_super) {
        __extends(SearchFilter_PropertyBasedFilter, _super);
        function SearchFilter_PropertyBasedFilter(propertyDefinition) {
            _super.call(this);
            this.propertyDefinition = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(propertyDefinition);
        }
        Object.defineProperty(SearchFilter_PropertyBasedFilter.prototype, "PropertyDefinition", {
            get: function () {
                return this.propertyDefinition;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.propertyDefinition
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.propertyDefinition = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_PropertyBasedFilter.prototype.constructor_0 = function () {
        };
        SearchFilter_PropertyBasedFilter.prototype.constructor_1 = function (propertyDefinition) {
            this.propertyDefinition = propertyDefinition;
        };
        SearchFilter_PropertyBasedFilter.prototype.InternalValidate = function () {
            if (this.propertyDefinition === null) {
                throw new ServiceValidationException(Strings.PropertyDefinitionPropertyMustBeSet);
            }
        };
        SearchFilter_PropertyBasedFilter.prototype.TryReadElementFromXml = function (reader) {
            var _this = this;
            return (function () {
                var _p0 = [
                    _this.propertyDefinition
                ];
                var _r = PropertyDefinitionBase.TryLoadFromXml(reader, _p0);
                _this.propertyDefinition = _p0[0];
                return _r;
            })();
        };
        SearchFilter_PropertyBasedFilter.prototype.LoadFromJson = function (jsonProperty, service) {
            this.PropertyDefinition = PropertyDefinitionBase.TryLoadFromJson(jsonProperty.ReadAsJsonObject("Item"));
        };
        SearchFilter_PropertyBasedFilter.prototype.WriteElementsToXml = function (writer) {
            this.PropertyDefinition.WriteToXml(writer);
        };
        SearchFilter_PropertyBasedFilter.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            jsonObject.Add("Item", this.PropertyDefinition.ToJson(service));
            return jsonObject;
        };
        return SearchFilter_PropertyBasedFilter;
    }(SearchFilter));
    var SearchFilter_RelationalFilter = (function (_super) {
        __extends(SearchFilter_RelationalFilter, _super);
        function SearchFilter_RelationalFilter(propertyDefinition, otherPropertyDefinitionOrValue) {
            _super.call(this);
            this.otherPropertyDefinition = null;
            this.value = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        Object.defineProperty(SearchFilter_RelationalFilter.prototype, "OtherPropertyDefinition", {
            get: function () {
                return this.otherPropertyDefinition;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.otherPropertyDefinition
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.otherPropertyDefinition = _p0[0];
                    return _r;
                })();
                this.value = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchFilter_RelationalFilter.prototype, "Value", {
            get: function () {
                return this.value;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.value
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.value = _p0[0];
                    return _r;
                })();
                this.otherPropertyDefinition = null;
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_RelationalFilter.prototype.constructor_0 = function () {
        };
        SearchFilter_RelationalFilter.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
            this.otherPropertyDefinition = otherPropertyDefinition;
        };
        SearchFilter_RelationalFilter.prototype.constructor_2 = function (propertyDefinition, value) {
            this.value = value;
        };
        SearchFilter_RelationalFilter.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (this.otherPropertyDefinition === null && this.value === null) {
                throw new ServiceValidationException(Strings.EqualityComparisonFilterIsInvalid);
            }
            if (this.value !== null && !(this.value instanceof IConvertible) && !(this.value instanceof ISearchStringProvider)) {
                throw new ServiceValidationException(NString.Format(Strings.SearchFilterComparisonValueTypeIsNotSupported, this.value.GetType().Name));
            }
        };
        SearchFilter_RelationalFilter.prototype.TryReadElementFromXml = function (reader) {
            var _this = this;
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag && reader.LocalName === "FieldURIOrConstant") {
                reader.Read();
                reader.EnsureCurrentNodeIsStartElement();
                if (reader.IsStartElement(XmlNamespace.Types, "Constant")) {
                    this.value = reader.ReadAttributeValue("Value");
                    flag = true;
                }
                else {
                    flag = (function () {
                        var _p0 = [
                            _this.otherPropertyDefinition
                        ];
                        var _r = PropertyDefinitionBase.TryLoadFromXml(reader, _p0);
                        _this.otherPropertyDefinition = _p0[0];
                        return _r;
                    })();
                }
            }
            return flag;
        };
        SearchFilter_RelationalFilter.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            var jsonObject = jsonProperty.ReadAsJsonObject("FieldURIOrConstant").ReadAsJsonObject("Item");
            if (jsonObject.ReadTypeString() === "Constant") {
                this.value = jsonObject.get_Item("Value");
                return;
            }
            this.otherPropertyDefinition = PropertyDefinitionBase.TryLoadFromJson(jsonProperty);
        };
        SearchFilter_RelationalFilter.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Types, "FieldURIOrConstant");
            if (this.Value !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "Constant");
                writer.WriteAttributeValue("Value", true, this.Value);
                writer.WriteEndElement();
            }
            else {
                this.OtherPropertyDefinition.WriteToXml(writer);
            }
            writer.WriteEndElement();
        };
        SearchFilter_RelationalFilter.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            var jsonObject2 = new JsonObject();
            if (this.Value !== null) {
                var jsonObject3 = new JsonObject();
                jsonObject3.Add("Value", this.Value);
                jsonObject3.AddTypeParameter("Constant");
                jsonObject2.Add("Item", jsonObject3);
            }
            else {
                jsonObject2.Add("Item", this.OtherPropertyDefinition.ToJson(service));
            }
            jsonObject.Add("FieldURIOrConstant", jsonObject2);
            return jsonObject;
        };
        return SearchFilter_RelationalFilter;
    }(SearchFilter_PropertyBasedFilter));
    var SearchFilter_IsLessThanOrEqualTo = (function (_super) {
        __extends(SearchFilter_IsLessThanOrEqualTo, _super);
        function SearchFilter_IsLessThanOrEqualTo(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsLessThanOrEqualTo.prototype.constructor_0 = function () {
        };
        SearchFilter_IsLessThanOrEqualTo.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsLessThanOrEqualTo.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsLessThanOrEqualTo.prototype.GetXmlElementName = function () {
            return "IsLessThanOrEqualTo";
        };
        return SearchFilter_IsLessThanOrEqualTo;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_IsLessThan = (function (_super) {
        __extends(SearchFilter_IsLessThan, _super);
        function SearchFilter_IsLessThan(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsLessThan.prototype.constructor_0 = function () {
        };
        SearchFilter_IsLessThan.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsLessThan.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsLessThan.prototype.GetXmlElementName = function () {
            return "IsLessThan";
        };
        return SearchFilter_IsLessThan;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_IsGreaterThanOrEqualTo = (function (_super) {
        __extends(SearchFilter_IsGreaterThanOrEqualTo, _super);
        function SearchFilter_IsGreaterThanOrEqualTo(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsGreaterThanOrEqualTo.prototype.constructor_0 = function () {
        };
        SearchFilter_IsGreaterThanOrEqualTo.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsGreaterThanOrEqualTo.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsGreaterThanOrEqualTo.prototype.GetXmlElementName = function () {
            return "IsGreaterThanOrEqualTo";
        };
        return SearchFilter_IsGreaterThanOrEqualTo;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_IsGreaterThan = (function (_super) {
        __extends(SearchFilter_IsGreaterThan, _super);
        function SearchFilter_IsGreaterThan(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsGreaterThan.prototype.constructor_0 = function () {
        };
        SearchFilter_IsGreaterThan.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsGreaterThan.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsGreaterThan.prototype.GetXmlElementName = function () {
            return "IsGreaterThan";
        };
        return SearchFilter_IsGreaterThan;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_IsNotEqualTo = (function (_super) {
        __extends(SearchFilter_IsNotEqualTo, _super);
        function SearchFilter_IsNotEqualTo(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsNotEqualTo.prototype.constructor_0 = function () {
        };
        SearchFilter_IsNotEqualTo.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsNotEqualTo.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsNotEqualTo.prototype.GetXmlElementName = function () {
            return "IsNotEqualTo";
        };
        return SearchFilter_IsNotEqualTo;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_IsEqualTo = (function (_super) {
        __extends(SearchFilter_IsEqualTo, _super);
        function SearchFilter_IsEqualTo(propertyDefinition, otherPropertyDefinitionOrValue) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (otherPropertyDefinitionOrValue === null || otherPropertyDefinitionOrValue instanceof PropertyDefinitionBase)) {
                _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
                this.constructor_1(propertyDefinition, otherPropertyDefinitionOrValue);
                return;
            }
            _super.call(this, propertyDefinition, otherPropertyDefinitionOrValue);
            this.constructor_2(propertyDefinition, otherPropertyDefinitionOrValue);
        }
        SearchFilter_IsEqualTo.prototype.constructor_0 = function () {
        };
        SearchFilter_IsEqualTo.prototype.constructor_1 = function (propertyDefinition, otherPropertyDefinition) {
        };
        SearchFilter_IsEqualTo.prototype.constructor_2 = function (propertyDefinition, value) {
        };
        SearchFilter_IsEqualTo.prototype.GetXmlElementName = function () {
            return "IsEqualTo";
        };
        return SearchFilter_IsEqualTo;
    }(SearchFilter_RelationalFilter));
    var SearchFilter_Exists = (function (_super) {
        __extends(SearchFilter_Exists, _super);
        function SearchFilter_Exists(propertyDefinition) {
            if (arguments.length === 0) {
                _super.call(this);
                this.constructor_0();
                return;
            }
            _super.call(this, propertyDefinition);
            this.constructor_1(propertyDefinition);
        }
        SearchFilter_Exists.prototype.constructor_0 = function () {
        };
        SearchFilter_Exists.prototype.constructor_1 = function (propertyDefinition) {
        };
        SearchFilter_Exists.prototype.GetXmlElementName = function () {
            return "Exists";
        };
        return SearchFilter_Exists;
    }(SearchFilter_PropertyBasedFilter));
    var SearchFilter_ExcludesBitmask = (function (_super) {
        __extends(SearchFilter_ExcludesBitmask, _super);
        function SearchFilter_ExcludesBitmask(propertyDefinition, bitmask) {
            _super.call(this);
            this.bitmask = 0;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(propertyDefinition, bitmask);
        }
        Object.defineProperty(SearchFilter_ExcludesBitmask.prototype, "Bitmask", {
            get: function () {
                return this.bitmask;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.bitmask
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.bitmask = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_ExcludesBitmask.prototype.constructor_0 = function () {
        };
        SearchFilter_ExcludesBitmask.prototype.constructor_1 = function (propertyDefinition, bitmask) {
            this.bitmask = bitmask;
        };
        SearchFilter_ExcludesBitmask.prototype.GetXmlElementName = function () {
            return "Excludes";
        };
        SearchFilter_ExcludesBitmask.prototype.TryReadElementFromXml = function (reader) {
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag && reader.LocalName === "Bitmask") {
                this.bitmask = Convert.ToInt32(reader.ReadAttributeValue("Value"), 16);
            }
            return flag;
        };
        SearchFilter_ExcludesBitmask.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            this.bitmask = Convert.ToInt32(jsonProperty.ReadAsJsonObject("Bitmask").ReadAsString("Value"), 16);
        };
        SearchFilter_ExcludesBitmask.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Types, "Bitmask");
            writer.WriteAttributeValue("Value", this.Bitmask);
            writer.WriteEndElement();
        };
        SearchFilter_ExcludesBitmask.prototype.InternalToJson = function (service) {
            var result = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            var jsonObject = new JsonObject();
            jsonObject.Add("Value", "0x" + NNumber.ToString(this.Bitmask, "X", CultureInfo.InvariantCulture));
            return result;
        };
        return SearchFilter_ExcludesBitmask;
    }(SearchFilter_PropertyBasedFilter));
    var SearchFilter_ContainsSubstring = (function (_super) {
        __extends(SearchFilter_ContainsSubstring, _super);
        function SearchFilter_ContainsSubstring(propertyDefinition, value, containmentMode, comparisonMode) {
            _super.call(this);
            this.containmentMode = ContainmentMode.Substring;
            this.comparisonMode = ComparisonMode.IgnoreCase;
            this.value = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 2 && (propertyDefinition === null || propertyDefinition instanceof PropertyDefinitionBase) && (value === null || value.constructor === String)) {
                this.constructor_1(propertyDefinition, value);
                return;
            }
            this.constructor_2(propertyDefinition, value, containmentMode, comparisonMode);
        }
        Object.defineProperty(SearchFilter_ContainsSubstring.prototype, "ContainmentMode", {
            get: function () {
                return this.containmentMode;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.containmentMode
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.containmentMode = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchFilter_ContainsSubstring.prototype, "ComparisonMode", {
            get: function () {
                return this.comparisonMode;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.comparisonMode
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.comparisonMode = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SearchFilter_ContainsSubstring.prototype, "Value", {
            get: function () {
                return this.value;
            },
            set: function (value) {
                var _this = this;
                (function () {
                    var _p0 = [
                        _this.value
                    ];
                    var _r = _this.SetFieldValue(_p0, value);
                    _this.value = _p0[0];
                    return _r;
                })();
            },
            enumerable: true,
            configurable: true
        });
        SearchFilter_ContainsSubstring.prototype.constructor_0 = function () {
        };
        SearchFilter_ContainsSubstring.prototype.constructor_1 = function (propertyDefinition, value) {
            this.value = value;
        };
        SearchFilter_ContainsSubstring.prototype.constructor_2 = function (propertyDefinition, value, containmentMode, comparisonMode) {
            this.constructor_1(propertyDefinition, value);
            this.containmentMode = containmentMode;
            this.comparisonMode = comparisonMode;
        };
        SearchFilter_ContainsSubstring.prototype.InternalValidate = function () {
            _super.prototype.InternalValidate.call(this);
            if (NString.IsNullOrEmpty(this.value)) {
                throw new ServiceValidationException(Strings.ValuePropertyMustBeSet);
            }
        };
        SearchFilter_ContainsSubstring.prototype.GetXmlElementName = function () {
            return "Contains";
        };
        SearchFilter_ContainsSubstring.prototype.TryReadElementFromXml = function (reader) {
            var flag = _super.prototype.TryReadElementFromXml.call(this, reader);
            if (!flag && reader.LocalName === "Constant") {
                this.value = reader.ReadAttributeValue("Value");
                flag = true;
            }
            return flag;
        };
        SearchFilter_ContainsSubstring.prototype.ReadAttributesFromXml = function (reader) {
            _super.prototype.ReadAttributesFromXml.call(this, reader);
            this.containmentMode = reader.ReadAttributeValue("ContainmentMode");
            try {
                this.comparisonMode = reader.ReadAttributeValue("ContainmentComparison");
            }
            catch (ex_2B) {
                if (ex_2B instanceof ArgumentException) {
                    this.comparisonMode = ComparisonMode.IgnoreCaseAndNonSpacingCharacters;
                }
                else
                    throw ex_2B;
            }
        };
        SearchFilter_ContainsSubstring.prototype.LoadFromJson = function (jsonProperty, service) {
            _super.prototype.LoadFromJson.call(this, jsonProperty, service);
            this.value = jsonProperty.ReadAsJsonObject("Constant").ReadAsString("Value");
            this.containmentMode = jsonProperty.ReadEnumValue("ContainmentMode");
            this.comparisonMode = jsonProperty.ReadEnumValue("ContainmentComparison");
        };
        SearchFilter_ContainsSubstring.prototype.WriteAttributesToXml = function (writer) {
            _super.prototype.WriteAttributesToXml.call(this, writer);
            writer.WriteAttributeValue("ContainmentMode", this.ContainmentMode);
            writer.WriteAttributeValue("ContainmentComparison", this.ComparisonMode);
        };
        SearchFilter_ContainsSubstring.prototype.WriteElementsToXml = function (writer) {
            _super.prototype.WriteElementsToXml.call(this, writer);
            writer.WriteStartElement(XmlNamespace.Types, "Constant");
            writer.WriteAttributeValue("Value", this.Value);
            writer.WriteEndElement();
        };
        SearchFilter_ContainsSubstring.prototype.InternalToJson = function (service) {
            var jsonObject = ((_super.prototype.InternalToJson.call(this, service) instanceof JsonObject) ? _super.prototype.InternalToJson.call(this, service) : null);
            jsonObject.Add("ContainmentMode", this.ContainmentMode);
            jsonObject.Add("ContainmentComparison", this.ComparisonMode);
            var jsonObject2 = new JsonObject();
            jsonObject2.Add("Value", this.Value);
            jsonObject.Add("Constant", jsonObject2);
            return jsonObject;
        };
        return SearchFilter_ContainsSubstring;
    }(SearchFilter_PropertyBasedFilter));
    var ViewBase = (function () {
        function ViewBase() {
            this.propertySet = null;
            _super.call(this);
        }
        Object.defineProperty(ViewBase.prototype, "PropertySet", {
            get: function () {
                return this.propertySet;
            },
            set: function (value) {
                this.propertySet = value;
            },
            enumerable: true,
            configurable: true
        });
        ViewBase.prototype.InternalValidate = function (request) {
            if (this.PropertySet !== null) {
                this.PropertySet.InternalValidate();
                this.PropertySet.ValidateForRequest(request, true);
            }
        };
        ViewBase.prototype.InternalWriteViewToXml = function (writer) {
            var maxEntriesReturned = this.GetMaxEntriesReturned();
            if (maxEntriesReturned !== null) {
                writer.WriteAttributeValue("MaxEntriesReturned", maxEntriesReturned.Value);
            }
        };
        ViewBase.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
            throw new NotSupportedException();
        };
        ViewBase.prototype.WriteOrderByToXml = function (writer) {
            throw new NotSupportedException();
        };
        ViewBase.prototype.GetViewXmlElementName = function () {
            throw new NotSupportedException();
        };
        ViewBase.prototype.GetViewJsonTypeName = function () {
            return this.GetViewXmlElementName();
        };
        ViewBase.prototype.GetMaxEntriesReturned = function () {
            throw new NotSupportedException();
        };
        ViewBase.prototype.GetServiceObjectType = function () {
            throw new NotSupportedException();
        };
        ViewBase.prototype.WriteAttributesToXml = function (writer) {
            throw new NotSupportedException();
        };
        ViewBase.prototype.AddJsonProperties = function (jsonRequest, service) {
            throw new NotSupportedException();
        };
        ViewBase.prototype.WriteToXml = function (writer, groupBy) {
            this.GetPropertySetOrDefault().WriteToXml(writer, this.GetServiceObjectType());
            writer.WriteStartElement(XmlNamespace.Messages, this.GetViewXmlElementName());
            this.InternalWriteViewToXml(writer);
            writer.WriteEndElement();
            this.InternalWriteSearchSettingsToXml(writer, groupBy);
        };
        ViewBase.prototype.WriteShapeToJson = function (jsonRequest, service) {
            this.GetPropertySetOrDefault().WriteGetShapeToJson(jsonRequest, service, this.GetServiceObjectType());
        };
        ViewBase.prototype.WritePagingToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.AddTypeParameter(this.GetViewJsonTypeName());
            this.InternalWritePagingToJson(jsonObject, service);
            return jsonObject;
        };
        ViewBase.prototype.InternalWritePagingToJson = function (jsonView, service) {
            var maxEntriesReturned = this.GetMaxEntriesReturned();
            if (maxEntriesReturned !== null) {
                jsonView.Add("MaxEntriesReturned", maxEntriesReturned.Value);
            }
        };
        ViewBase.prototype.WriteGroupingToJson = function (service, groupBy) {
            throw new NotSupportedException();
        };
        ViewBase.prototype.GetPropertySetOrDefault = function () {
            return this.PropertySet || PropertySet.FirstClassProperties;
        };
        return ViewBase;
    }());
    var CalendarView = (function (_super) {
        __extends(CalendarView, _super);
        function CalendarView(startDate, endDate, maxItemsReturned) {
            _super.call(this);
            this.traversal = 0;
            this.maxItemsReturned = null;
            this.startDate = null;
            this.endDate = null;
            if (arguments.length === 2 && (startDate === null || startDate instanceof DateTime) && (endDate === null || endDate instanceof DateTime)) {
                this.constructor_0(startDate, endDate);
                return;
            }
            this.constructor_1(startDate, endDate, maxItemsReturned);
        }
        Object.defineProperty(CalendarView.prototype, "StartDate", {
            get: function () {
                return this.startDate;
            },
            set: function (value) {
                this.startDate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarView.prototype, "EndDate", {
            get: function () {
                return this.endDate;
            },
            set: function (value) {
                this.endDate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarView.prototype, "MaxItemsReturned", {
            get: function () {
                return this.maxItemsReturned;
            },
            set: function (value) {
                if (value !== null && value.Value <= 0) {
                    throw new ArgumentException(Strings.ValueMustBeGreaterThanZero);
                }
                this.maxItemsReturned = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CalendarView.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                this.traversal = value;
            },
            enumerable: true,
            configurable: true
        });
        CalendarView.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Traversal", this.Traversal);
        };
        CalendarView.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
        };
        CalendarView.prototype.WriteGroupingToJson = function (service, groupBy) {
            return null;
        };
        CalendarView.prototype.WriteOrderByToXml = function (writer) {
        };
        CalendarView.prototype.AddJsonProperties = function (jsonRequest, service) {
            jsonRequest.Add("Traversal", this.Traversal);
        };
        CalendarView.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Item;
        };
        CalendarView.prototype.constructor_0 = function (startDate, endDate) {
            this.startDate = startDate;
            this.endDate = endDate;
        };
        CalendarView.prototype.constructor_1 = function (startDate, endDate, maxItemsReturned) {
            this.constructor_0(startDate, endDate);
            this.MaxItemsReturned = new Nullable(maxItemsReturned);
        };
        CalendarView.prototype.InternalValidate = function (request) {
            _super.prototype.InternalValidate.call(this, request);
            if (DateTime.op_LessThan(this.endDate, this.StartDate)) {
                throw new ServiceValidationException(Strings.EndDateMustBeGreaterThanStartDate);
            }
        };
        CalendarView.prototype.InternalWriteViewToXml = function (writer) {
            _super.prototype.InternalWriteViewToXml.call(this, writer);
            writer.WriteAttributeValue("StartDate", this.StartDate);
            writer.WriteAttributeValue("EndDate", this.EndDate);
        };
        CalendarView.prototype.InternalWritePagingToJson = function (jsonView, service) {
            _super.prototype.InternalWritePagingToJson.call(this, jsonView, service);
            jsonView.Add("StartDate", this.StartDate);
            jsonView.Add("EndDate", this.EndDate);
        };
        CalendarView.prototype.GetViewXmlElementName = function () {
            return "CalendarView";
        };
        CalendarView.prototype.GetViewJsonTypeName = function () {
            return "CalendarPageView";
        };
        CalendarView.prototype.GetMaxEntriesReturned = function () {
            return this.MaxItemsReturned;
        };
        return CalendarView;
    }(ViewBase));
    var FindConversationResults = (function () {
        function FindConversationResults() {
            this.Conversations = null;
            this.HighlightTerms = null;
            this.TotalCount = null;
            this.IndexedOffset = null;
            _super.call(this);
            this.Conversations = new Collection();
            this.HighlightTerms = new Collection();
            this.TotalCount = null;
        }
        return FindConversationResults;
    }());
    var FindFoldersResults = (function () {
        function FindFoldersResults() {
            this.totalCount = 0;
            this.nextPageOffset = null;
            this.moreAvailable = false;
            this.folders = new Collection();
            _super.call(this);
        }
        Object.defineProperty(FindFoldersResults.prototype, "TotalCount", {
            get: function () {
                return this.totalCount;
            },
            set: function (value) {
                this.totalCount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindFoldersResults.prototype, "NextPageOffset", {
            get: function () {
                return this.nextPageOffset;
            },
            set: function (value) {
                this.nextPageOffset = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindFoldersResults.prototype, "MoreAvailable", {
            get: function () {
                return this.moreAvailable;
            },
            set: function (value) {
                this.moreAvailable = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindFoldersResults.prototype, "Folders", {
            get: function () {
                return this.folders;
            },
            enumerable: true,
            configurable: true
        });
        FindFoldersResults.prototype.GetEnumerator = function () {
            return this.folders.GetEnumerator();
        };
        return FindFoldersResults;
    }());
    var FindItemsResults = (function () {
        function FindItemsResults() {
            this.totalCount = 0;
            this.nextPageOffset = null;
            this.moreAvailable = false;
            this.items = new Collection();
            this.highlightTerms = new Collection();
            _super.call(this);
        }
        Object.defineProperty(FindItemsResults.prototype, "TotalCount", {
            get: function () {
                return this.totalCount;
            },
            set: function (value) {
                this.totalCount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindItemsResults.prototype, "NextPageOffset", {
            get: function () {
                return this.nextPageOffset;
            },
            set: function (value) {
                this.nextPageOffset = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindItemsResults.prototype, "MoreAvailable", {
            get: function () {
                return this.moreAvailable;
            },
            set: function (value) {
                this.moreAvailable = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindItemsResults.prototype, "Items", {
            get: function () {
                return this.items;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FindItemsResults.prototype, "HighlightTerms", {
            get: function () {
                return this.highlightTerms;
            },
            enumerable: true,
            configurable: true
        });
        FindItemsResults.prototype.GetEnumerator = function () {
            return this.items.GetEnumerator();
        };
        return FindItemsResults;
    }());
    var PagedView = (function (_super) {
        __extends(PagedView, _super);
        function PagedView(pageSize, offset, offsetBasePoint) {
            _super.call(this);
            this.pageSize = 0;
            this.offsetBasePoint = 0;
            this.offset = 0;
            if (arguments.length === 1 && (pageSize === null || pageSize.constructor === Number)) {
                this.constructor_0(pageSize);
                return;
            }
            if (arguments.length === 2 && (pageSize === null || pageSize.constructor === Number) && (offset === null || offset.constructor === Number)) {
                this.constructor_1(pageSize, offset);
                return;
            }
            this.constructor_2(pageSize, offset, offsetBasePoint);
        }
        Object.defineProperty(PagedView.prototype, "PageSize", {
            get: function () {
                return this.pageSize;
            },
            set: function (value) {
                if (value <= 0) {
                    throw new ArgumentException(Strings.ValueMustBeGreaterThanZero);
                }
                this.pageSize = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PagedView.prototype, "OffsetBasePoint", {
            get: function () {
                return this.offsetBasePoint;
            },
            set: function (value) {
                this.offsetBasePoint = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PagedView.prototype, "Offset", {
            get: function () {
                return this.offset;
            },
            set: function (value) {
                if (value >= 0) {
                    this.offset = value;
                    return;
                }
                throw new ArgumentException(Strings.OffsetMustBeGreaterThanZero);
            },
            enumerable: true,
            configurable: true
        });
        PagedView.prototype.InternalWriteViewToXml = function (writer) {
            _super.prototype.InternalWriteViewToXml.call(this, writer);
            writer.WriteAttributeValue("Offset", this.Offset);
            writer.WriteAttributeValue("BasePoint", this.OffsetBasePoint);
        };
        PagedView.prototype.InternalWritePagingToJson = function (jsonView, service) {
            _super.prototype.InternalWritePagingToJson.call(this, jsonView, service);
            jsonView.Add("Offset", this.Offset);
            jsonView.Add("BasePoint", this.OffsetBasePoint);
        };
        PagedView.prototype.GetMaxEntriesReturned = function () {
            return new Nullable(this.PageSize);
        };
        PagedView.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
            if (groupBy !== null) {
                groupBy.WriteToXml(writer);
            }
        };
        PagedView.prototype.WriteGroupingToJson = function (service, groupBy) {
            if (groupBy !== null) {
                return groupBy.ToJson(service);
            }
            return null;
        };
        PagedView.prototype.WriteOrderByToXml = function (writer) {
        };
        PagedView.prototype.InternalValidate = function (request) {
            _super.prototype.InternalValidate.call(this, request);
        };
        PagedView.prototype.constructor_0 = function (pageSize) {
            this.PageSize = pageSize;
        };
        PagedView.prototype.constructor_1 = function (pageSize, offset) {
            this.constructor_0(pageSize);
            this.Offset = offset;
        };
        PagedView.prototype.constructor_2 = function (pageSize, offset, offsetBasePoint) {
            this.constructor_1(pageSize, offset);
            this.OffsetBasePoint = offsetBasePoint;
        };
        return PagedView;
    }(ViewBase));
    var ConversationIndexedItemView = (function (_super) {
        __extends(ConversationIndexedItemView, _super);
        function ConversationIndexedItemView(pageSize, offset, offsetBasePoint) {
            _super.call(this, pageSize);
            this.orderBy = new OrderByCollection();
            this.traversal = null;
            this.viewFilter = null;
            if (arguments.length === 1 && (pageSize === null || pageSize.constructor === Number)) {
                this.constructor_0(pageSize);
                return;
            }
            if (arguments.length === 2 && (pageSize === null || pageSize.constructor === Number) && (offset === null || offset.constructor === Number)) {
                this.constructor_1(pageSize, offset);
                return;
            }
            this.constructor_2(pageSize, offset, offsetBasePoint);
        }
        Object.defineProperty(ConversationIndexedItemView.prototype, "OrderBy", {
            get: function () {
                return this.orderBy;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConversationIndexedItemView.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                this.traversal = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConversationIndexedItemView.prototype, "ViewFilter", {
            get: function () {
                return this.viewFilter;
            },
            set: function (value) {
                this.viewFilter = value;
            },
            enumerable: true,
            configurable: true
        });
        ConversationIndexedItemView.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Conversation;
        };
        ConversationIndexedItemView.prototype.WriteAttributesToXml = function (writer) {
            if (this.Traversal !== null) {
                writer.WriteAttributeValue("Traversal", this.Traversal);
            }
            if (this.ViewFilter !== null) {
                writer.WriteAttributeValue("ViewFilter", this.ViewFilter);
            }
        };
        ConversationIndexedItemView.prototype.GetViewXmlElementName = function () {
            return "IndexedPageItemView";
        };
        ConversationIndexedItemView.prototype.GetViewJsonTypeName = function () {
            return "IndexedPageView";
        };
        ConversationIndexedItemView.prototype.InternalValidate = function (request) {
            _super.prototype.InternalValidate.call(this, request);
            if (this.Traversal !== null) {
                EwsUtilities.ValidateEnumVersionValue(this.traversal, request.Service.RequestedServerVersion);
            }
            if (this.ViewFilter !== null) {
                EwsUtilities.ValidateEnumVersionValue(this.viewFilter, request.Service.RequestedServerVersion);
            }
        };
        ConversationIndexedItemView.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
            _super.prototype.InternalWriteSearchSettingsToXml.call(this, writer, groupBy);
        };
        ConversationIndexedItemView.prototype.WriteOrderByToXml = function (writer) {
            this.orderBy.WriteToXml(writer, "SortOrder");
        };
        ConversationIndexedItemView.prototype.AddJsonProperties = function (jsonRequest, service) {
            jsonRequest.Add("SortOrder", this.orderBy.ToJson(service));
            if (this.Traversal !== null) {
                jsonRequest.Add("Traversal", this.Traversal);
            }
            if (this.ViewFilter !== null) {
                jsonRequest.Add("ViewFilter", this.ViewFilter);
            }
        };
        ConversationIndexedItemView.prototype.WriteToXml = function (writer, groupBy) {
            writer.WriteStartElement(XmlNamespace.Messages, this.GetViewXmlElementName());
            this.InternalWriteViewToXml(writer);
            writer.WriteEndElement();
        };
        ConversationIndexedItemView.prototype.constructor_0 = function (pageSize) {
        };
        ConversationIndexedItemView.prototype.constructor_1 = function (pageSize, offset) {
            this.Offset = offset;
        };
        ConversationIndexedItemView.prototype.constructor_2 = function (pageSize, offset, offsetBasePoint) {
        };
        return ConversationIndexedItemView;
    }(PagedView));
    var FolderView = (function (_super) {
        __extends(FolderView, _super);
        function FolderView(pageSize, offset, offsetBasePoint) {
            _super.call(this, pageSize);
            this.traversal = 0;
            if (arguments.length === 1 && (pageSize === null || pageSize.constructor === Number)) {
                this.constructor_0(pageSize);
                return;
            }
            if (arguments.length === 2 && (pageSize === null || pageSize.constructor === Number) && (offset === null || offset.constructor === Number)) {
                this.constructor_1(pageSize, offset);
                return;
            }
            this.constructor_2(pageSize, offset, offsetBasePoint);
        }
        Object.defineProperty(FolderView.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                this.traversal = value;
            },
            enumerable: true,
            configurable: true
        });
        FolderView.prototype.GetViewXmlElementName = function () {
            return "IndexedPageFolderView";
        };
        FolderView.prototype.GetViewJsonTypeName = function () {
            return "IndexedPageView";
        };
        FolderView.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Folder;
        };
        FolderView.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Traversal", this.Traversal);
        };
        FolderView.prototype.AddJsonProperties = function (jsonRequest, service) {
            jsonRequest.Add("Traversal", this.Traversal);
        };
        FolderView.prototype.constructor_0 = function (pageSize) {
        };
        FolderView.prototype.constructor_1 = function (pageSize, offset) {
        };
        FolderView.prototype.constructor_2 = function (pageSize, offset, offsetBasePoint) {
        };
        return FolderView;
    }(PagedView));
    var GroupedFindItemsResults = (function () {
        function GroupedFindItemsResults() {
            this.totalCount = 0;
            this.nextPageOffset = null;
            this.moreAvailable = false;
            this.itemGroups = new Collection();
            _super.call(this);
        }
        Object.defineProperty(GroupedFindItemsResults.prototype, "TotalCount", {
            get: function () {
                return this.totalCount;
            },
            set: function (value) {
                this.totalCount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupedFindItemsResults.prototype, "NextPageOffset", {
            get: function () {
                return this.nextPageOffset;
            },
            set: function (value) {
                this.nextPageOffset = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupedFindItemsResults.prototype, "MoreAvailable", {
            get: function () {
                return this.moreAvailable;
            },
            set: function (value) {
                this.moreAvailable = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GroupedFindItemsResults.prototype, "ItemGroups", {
            get: function () {
                return this.itemGroups;
            },
            enumerable: true,
            configurable: true
        });
        GroupedFindItemsResults.prototype.GetEnumerator = function () {
            return this.itemGroups.GetEnumerator();
        };
        return GroupedFindItemsResults;
    }());
    var Grouping = (function () {
        function Grouping(groupOn, sortDirection, aggregateOn, aggregateType) {
            this.sortDirection = 0;
            this.groupOn = null;
            this.aggregateOn = null;
            this.aggregateType = 0;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(groupOn, sortDirection, aggregateOn, aggregateType);
        }
        Object.defineProperty(Grouping.prototype, "SortDirection", {
            get: function () {
                return this.sortDirection;
            },
            set: function (value) {
                this.sortDirection = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Grouping.prototype, "GroupOn", {
            get: function () {
                return this.groupOn;
            },
            set: function (value) {
                this.groupOn = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Grouping.prototype, "AggregateOn", {
            get: function () {
                return this.aggregateOn;
            },
            set: function (value) {
                this.aggregateOn = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Grouping.prototype, "AggregateType", {
            get: function () {
                return this.aggregateType;
            },
            set: function (value) {
                this.aggregateType = value;
            },
            enumerable: true,
            configurable: true
        });
        Grouping.prototype.InternalValidate = function () {
            EwsUtilities.ValidateParam(this.GroupOn, "GroupOn");
            EwsUtilities.ValidateParam(this.AggregateOn, "AggregateOn");
        };
        Grouping.prototype.constructor_0 = function () {
        };
        Grouping.prototype.constructor_1 = function (groupOn, sortDirection, aggregateOn, aggregateType) {
            this.constructor_0();
            EwsUtilities.ValidateParam(groupOn, "groupOn");
            EwsUtilities.ValidateParam(aggregateOn, "aggregateOn");
            this.groupOn = groupOn;
            this.sortDirection = sortDirection;
            this.aggregateOn = aggregateOn;
            this.aggregateType = aggregateType;
        };
        Grouping.prototype.WriteToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Messages, "GroupBy");
            writer.WriteAttributeValue("Order", this.SortDirection);
            this.GroupOn.WriteToXml(writer);
            writer.WriteStartElement(XmlNamespace.Types, "AggregateOn");
            writer.WriteAttributeValue("Aggregate", this.AggregateType);
            this.AggregateOn.WriteToXml(writer);
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        Grouping.prototype.ToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Order", this.SortDirection);
            throw new NotImplementedException();
        };
        Grouping.prototype.Validate = function () {
            this.InternalValidate();
        };
        return Grouping;
    }());
    var ItemGroup = (function () {
        function ItemGroup(groupIndex, items) {
            this.GroupIndex = null;
            this.Items = null;
            _super.call(this);
            EwsUtilities.Assert(items !== null, "ItemGroup.ctor", "items is null");
            this.GroupIndex = groupIndex;
            this.Items = new Collection(items);
        }
        return ItemGroup;
    }());
    var ItemView = (function (_super) {
        __extends(ItemView, _super);
        function ItemView(pageSize, offset, offsetBasePoint) {
            _super.call(this, pageSize);
            this.traversal = 0;
            this.orderBy = new OrderByCollection();
            if (arguments.length === 1 && (pageSize === null || pageSize.constructor === Number)) {
                this.constructor_0(pageSize);
                return;
            }
            if (arguments.length === 2 && (pageSize === null || pageSize.constructor === Number) && (offset === null || offset.constructor === Number)) {
                this.constructor_1(pageSize, offset);
                return;
            }
            this.constructor_2(pageSize, offset, offsetBasePoint);
        }
        Object.defineProperty(ItemView.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                this.traversal = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ItemView.prototype, "OrderBy", {
            get: function () {
                return this.orderBy;
            },
            enumerable: true,
            configurable: true
        });
        ItemView.prototype.GetViewXmlElementName = function () {
            return "IndexedPageItemView";
        };
        ItemView.prototype.GetViewJsonTypeName = function () {
            return "IndexedPageView";
        };
        ItemView.prototype.GetServiceObjectType = function () {
            return ServiceObjectType.Item;
        };
        ItemView.prototype.InternalValidate = function (request) {
            _super.prototype.InternalValidate.call(this, request);
            EwsUtilities.ValidateEnumVersionValue(this.traversal, request.Service.RequestedServerVersion);
        };
        ItemView.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Traversal", this.Traversal);
        };
        ItemView.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
            _super.prototype.InternalWriteSearchSettingsToXml.call(this, writer, groupBy);
        };
        ItemView.prototype.WriteOrderByToXml = function (writer) {
            this.orderBy.WriteToXml(writer, "SortOrder");
        };
        ItemView.prototype.AddJsonProperties = function (jsonRequest, service) {
            jsonRequest.Add("Traversal", this.Traversal);
            var obj = this.orderBy.ToJson(service);
            if (obj !== null) {
                jsonRequest.Add("SortOrder", obj);
            }
        };
        ItemView.prototype.constructor_0 = function (pageSize) {
        };
        ItemView.prototype.constructor_1 = function (pageSize, offset) {
            this.Offset = offset;
        };
        ItemView.prototype.constructor_2 = function (pageSize, offset, offsetBasePoint) {
        };
        return ItemView;
    }(PagedView));
    var OrderByCollection = (function () {
        function OrderByCollection() {
            this.propDefSortOrderPairList = null;
            _super.call(this);
            this.propDefSortOrderPairList = new List();
        }
        Object.defineProperty(OrderByCollection.prototype, "Count", {
            get: function () {
                return this.propDefSortOrderPairList.Count;
            },
            enumerable: true,
            configurable: true
        });
        OrderByCollection.prototype.get_Item = function (index) {
            return this.propDefSortOrderPairList.get_Item(index);
        };
        OrderByCollection.prototype.Add = function (propertyDefinition, sortDirection) {
            if (this.Contains(propertyDefinition)) {
                throw new ServiceLocalException(NString.Format(Strings.PropertyAlreadyExistsInOrderByCollection, propertyDefinition.GetPrintableName()));
            }
            this.propDefSortOrderPairList.Add(new KeyValuePair(propertyDefinition, sortDirection));
        };
        OrderByCollection.prototype.Clear = function () {
            this.propDefSortOrderPairList.Clear();
        };
        OrderByCollection.prototype.Contains = function (propertyDefinition) {
            return this.propDefSortOrderPairList.Exists(function (pair) { return NObject.GenericEquals(pair.Key, propertyDefinition); });
        };
        OrderByCollection.prototype.Remove = function (propertyDefinition) {
            var num = this.propDefSortOrderPairList.RemoveAll(function (pair) { return NObject.GenericEquals(pair.Key, propertyDefinition); });
            return num > 0;
        };
        OrderByCollection.prototype.RemoveAt = function (index) {
            this.propDefSortOrderPairList.RemoveAt(index);
        };
        OrderByCollection.prototype.TryGetValue = function (propertyDefinition, sortDirection) {
            var enumerator = this.propDefSortOrderPairList.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (NObject.GenericEquals(current.Value, propertyDefinition)) {
                        sortDirection[0] = current.Value;
                        return true;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            sortDirection[0] = SortDirection.Ascending;
            return false;
        };
        OrderByCollection.prototype.WriteToXml = function (writer, xmlElementName) {
            if (this.Count > 0) {
                writer.WriteStartElement(XmlNamespace.Messages, xmlElementName);
                var enumerator = this.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        writer.WriteStartElement(XmlNamespace.Types, "FieldOrder");
                        writer.WriteAttributeValue("Order", current.Value);
                        current.Key.WriteToXml(writer);
                        writer.WriteEndElement();
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                writer.WriteEndElement();
            }
        };
        OrderByCollection.prototype.ToJson = function (service) {
            if (this.Count > 0) {
                var list = new List();
                var enumerator = this.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        var jsonObject = new JsonObject();
                        jsonObject.Add("Order", current.Value);
                        jsonObject.Add("Path", current.Key.ToJson(service));
                        list.Add(jsonObject);
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
                return list.ToArray();
            }
            return null;
        };
        OrderByCollection.prototype.GetEnumerator = function () {
            return this.propDefSortOrderPairList.GetEnumerator();
        };
        return OrderByCollection;
    }());
    var SeekToConditionItemView = (function (_super) {
        __extends(SeekToConditionItemView, _super);
        function SeekToConditionItemView(condition, pageSize, offsetBasePoint) {
            _super.call(this);
            this.pageSize = 0;
            this.traversal = 0;
            this.condition = null;
            this.offsetBasePoint = 0;
            this.orderBy = new OrderByCollection();
            this.serviceObjType = 0;
            if (arguments.length === 2 && (condition === null || condition instanceof SearchFilter) && (pageSize === null || pageSize.constructor === Number)) {
                this.constructor_0(condition, pageSize);
                return;
            }
            this.constructor_1(condition, pageSize, offsetBasePoint);
        }
        Object.defineProperty(SeekToConditionItemView.prototype, "PageSize", {
            get: function () {
                return this.pageSize;
            },
            set: function (value) {
                if (value <= 0) {
                    throw new ArgumentException(Strings.ValueMustBeGreaterThanZero);
                }
                this.pageSize = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SeekToConditionItemView.prototype, "OffsetBasePoint", {
            get: function () {
                return this.offsetBasePoint;
            },
            set: function (value) {
                this.offsetBasePoint = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SeekToConditionItemView.prototype, "Condition", {
            get: function () {
                return this.condition;
            },
            set: function (value) {
                if (value === null) {
                    throw new ArgumentNullException("Condition");
                }
                this.condition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SeekToConditionItemView.prototype, "Traversal", {
            get: function () {
                return this.traversal;
            },
            set: function (value) {
                this.traversal = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SeekToConditionItemView.prototype, "OrderBy", {
            get: function () {
                return this.orderBy;
            },
            enumerable: true,
            configurable: true
        });
        SeekToConditionItemView.prototype.GetServiceObjectType = function () {
            return this.serviceObjType;
        };
        SeekToConditionItemView.prototype.SetServiceObjectType = function (objType) {
            this.serviceObjType = objType;
        };
        SeekToConditionItemView.prototype.WriteAttributesToXml = function (writer) {
            if (this.serviceObjType === ServiceObjectType.Item) {
                writer.WriteAttributeValue("Traversal", this.Traversal);
            }
        };
        SeekToConditionItemView.prototype.GetViewXmlElementName = function () {
            return "SeekToConditionPageItemView";
        };
        SeekToConditionItemView.prototype.GetViewJsonTypeName = function () {
            return "SeekToConditionPageView";
        };
        SeekToConditionItemView.prototype.InternalValidate = function (request) {
            _super.prototype.InternalValidate.call(this, request);
        };
        SeekToConditionItemView.prototype.InternalWriteViewToXml = function (writer) {
            _super.prototype.InternalWriteViewToXml.call(this, writer);
            writer.WriteAttributeValue("BasePoint", this.OffsetBasePoint);
            if (this.Condition !== null) {
                writer.WriteStartElement(XmlNamespace.Types, "Condition");
                this.Condition.WriteToXml(writer);
                writer.WriteEndElement();
            }
        };
        SeekToConditionItemView.prototype.InternalWritePagingToJson = function (jsonView, service) {
            _super.prototype.InternalWritePagingToJson.call(this, jsonView, service);
            jsonView.Add("BasePoint", this.OffsetBasePoint);
            if (this.Condition !== null) {
                var jsonObject = new JsonObject();
                jsonObject.Add("Item", this.Condition.InternalToJson(service));
                jsonView.Add("Condition", jsonObject);
            }
        };
        SeekToConditionItemView.prototype.InternalWriteSearchSettingsToXml = function (writer, groupBy) {
            if (groupBy !== null) {
                groupBy.WriteToXml(writer);
            }
        };
        SeekToConditionItemView.prototype.WriteGroupingToJson = function (service, groupBy) {
            if (groupBy !== null) {
                return groupBy.ToJson(service);
            }
            return null;
        };
        SeekToConditionItemView.prototype.GetMaxEntriesReturned = function () {
            return new Nullable(this.PageSize);
        };
        SeekToConditionItemView.prototype.WriteOrderByToXml = function (writer) {
            this.orderBy.WriteToXml(writer, "SortOrder");
        };
        SeekToConditionItemView.prototype.AddJsonProperties = function (jsonRequest, service) {
            if (this.serviceObjType === ServiceObjectType.Item) {
                jsonRequest.Add("Traversal", this.Traversal);
            }
            jsonRequest.Add("SortOrder", this.orderBy.ToJson(service));
        };
        SeekToConditionItemView.prototype.WriteToXml = function (writer, groupBy) {
            if (this.serviceObjType === ServiceObjectType.Item) {
                _super.prototype.GetPropertySetOrDefault.call(this).WriteToXml(writer, this.GetServiceObjectType());
            }
            writer.WriteStartElement(XmlNamespace.Messages, this.GetViewXmlElementName());
            this.InternalWriteViewToXml(writer);
            writer.WriteEndElement();
        };
        SeekToConditionItemView.prototype.constructor_0 = function (condition, pageSize) {
            this.Condition = condition;
            this.PageSize = pageSize;
            this.serviceObjType = ServiceObjectType.Item;
        };
        SeekToConditionItemView.prototype.constructor_1 = function (condition, pageSize, offsetBasePoint) {
            this.constructor_0(condition, pageSize);
            this.OffsetBasePoint = offsetBasePoint;
        };
        return SeekToConditionItemView;
    }(ViewBase));
    var SecurityTimestamp = (function () {
        function SecurityTimestamp(creationTimeUtc, expiryTimeUtc, id, digestAlgorithm, digest) {
            this.id = null;
            this.digestAlgorithm = null;
            this.digest = null;
            this.computedCreationTimeUtc = null;
            this.computedExpiryTimeUtc = null;
            this.creationTimeUtc = null;
            this.expiryTimeUtc = null;
            _super.call(this);
            if (arguments.length === 3 && (creationTimeUtc === null || creationTimeUtc instanceof DateTime) && (expiryTimeUtc === null || expiryTimeUtc instanceof DateTime) && (id === null || id.constructor === String)) {
                this.constructor_0(creationTimeUtc, expiryTimeUtc, id);
                return;
            }
            this.constructor_1(creationTimeUtc, expiryTimeUtc, id, digestAlgorithm, digest);
        }
        Object.defineProperty(SecurityTimestamp.prototype, "CreationTimeUtc", {
            get: function () {
                return this.creationTimeUtc;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SecurityTimestamp.prototype, "ExpiryTimeUtc", {
            get: function () {
                return this.expiryTimeUtc;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SecurityTimestamp.prototype, "Id", {
            get: function () {
                return this.id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SecurityTimestamp.prototype, "DigestAlgorithm", {
            get: function () {
                return this.digestAlgorithm;
            },
            enumerable: true,
            configurable: true
        });
        SecurityTimestamp.prototype.constructor_0 = function (creationTimeUtc, expiryTimeUtc, id) {
            this.constructor_1(creationTimeUtc, expiryTimeUtc, id, null, null);
        };
        SecurityTimestamp.prototype.constructor_1 = function (creationTimeUtc, expiryTimeUtc, id, digestAlgorithm, digest) {
            EwsUtilities.Assert(creationTimeUtc.Kind === DateTimeKind.Utc, "SecurityTimestamp.ctor", "creation time must be in UTC");
            EwsUtilities.Assert(expiryTimeUtc.Kind === DateTimeKind.Utc, "SecurityTimestamp.ctor", "expiry time must be in UTC");
            if (DateTime.op_GreaterThan(creationTimeUtc, expiryTimeUtc)) {
                throw new ArgumentOutOfRangeException("recordedExpiryTime");
            }
            this.creationTimeUtc = creationTimeUtc;
            this.expiryTimeUtc = expiryTimeUtc;
            this.id = id;
            this.digestAlgorithm = digestAlgorithm;
            this.digest = digest;
        };
        SecurityTimestamp.prototype.GetDigest = function () {
            return this.digest;
        };
        SecurityTimestamp.prototype.GetCreationTimeChars = function () {
            var _this = this;
            if (this.computedCreationTimeUtc === null) {
                this.computedCreationTimeUtc = (function () {
                    var _p0 = [
                        _this.creationTimeUtc
                    ];
                    var _r = SecurityTimestamp.ToChars(_p0);
                    _this.creationTimeUtc = _p0[0];
                    return _r;
                })();
            }
            return this.computedCreationTimeUtc;
        };
        SecurityTimestamp.prototype.GetExpiryTimeChars = function () {
            var _this = this;
            if (this.computedExpiryTimeUtc === null) {
                this.computedExpiryTimeUtc = (function () {
                    var _p0 = [
                        _this.expiryTimeUtc
                    ];
                    var _r = SecurityTimestamp.ToChars(_p0);
                    _this.expiryTimeUtc = _p0[0];
                    return _r;
                })();
            }
            return this.computedExpiryTimeUtc;
        };
        SecurityTimestamp.ToChars = function (utcTimeOrN, buffer, offset, count) {
            if (arguments.length === 1 && (utcTimeOrN === null || utcTimeOrN instanceof Array)) {
                return SecurityTimestamp.ToChars_0(utcTimeOrN);
            }
            return SecurityTimestamp.ToChars_1(utcTimeOrN, buffer, offset[0], count);
        };
        SecurityTimestamp.ToChars_0 = function (utcTime) {
            var array = new Array("yyyy-MM-ddTHH:mm:ss.fffZ".length);
            var num = 0;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Year, array, _p0, 4);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 45 /*'-'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Month, array, _p0, 2);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 45 /*'-'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Day, array, _p0, 2);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 84 /*'T'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Hour, array, _p0, 2);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 58 /*':'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Minute, array, _p0, 2);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 58 /*':'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Second, array, _p0, 2);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 46 /*'.'*/;
            (function () {
                var _p0 = [
                    num
                ];
                var _r = SecurityTimestamp.ToChars(utcTime[0].Millisecond, array, _p0, 3);
                num = _p0[0];
                return _r;
            })();
            array[num++] = 90 /*'Z'*/;
            return array;
        };
        SecurityTimestamp.ToChars_1 = function (n, buffer, offset, count) {
            for (var i = offset[0] + count - 1; i >= offset[0]; i = i - 1) {
                buffer[i] = (48 + n % 10);
                n = n / 10;
            }
            EwsUtilities.Assert(n === 0, "SecurityTimestamp.ToChars", "Overflow in encoding timestamp field");
            offset[0] = offset[0] + count;
        };
        SecurityTimestamp.prototype.ToString = function () {
            return NString.Format(CultureInfo.InvariantCulture, "SecurityTimestamp: Id={0}, CreationTimeUtc={1}, ExpirationTimeUtc={2}", [
                this.Id, XmlConvert.ToString(this.CreationTimeUtc, 3), XmlConvert.ToString(this.ExpiryTimeUtc, 3)
            ]);
        };
        SecurityTimestamp.DefaultTimestampValidityDurationString = "00:05:00";
        SecurityTimestamp.DefaultFormat = "yyyy-MM-ddTHH:mm:ss.fffZ";
        SecurityTimestamp.DefaultTimestampValidityDuration = TimeSpan.Parse("00:05:00");
        SecurityTimestamp.DefaultTimeToLive = SecurityTimestamp.DefaultTimestampValidityDuration;
        return SecurityTimestamp;
    }());
    var SafeXmlDocument = (function (_super) {
        __extends(SafeXmlDocument, _super);
        function SafeXmlDocument(impOrNt) {
            _super.call(this);
            this.settings = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (impOrNt === null || impOrNt instanceof XmlImplementation)) {
                this.constructor_1(impOrNt);
                return;
            }
            this.constructor_2(impOrNt);
        }
        SafeXmlDocument.prototype.constructor_0 = function () {
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_XmlResolver(null);
            this.settings = xmlReaderSettings;
            _super.prototype..ctor();
        };
        SafeXmlDocument.prototype.constructor_1 = function (imp) {
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_XmlResolver(null);
            this.settings = xmlReaderSettings;
            _super.prototype..ctor();
            throw new NotSupportedException("Not supported");
        };
        SafeXmlDocument.prototype.constructor_2 = function (nt) {
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_XmlResolver(null);
            this.settings = xmlReaderSettings;
            _super.prototype..ctor(nt);
        };
        SafeXmlDocument.prototype.Load = function (inStreamOrFilenameOrTxtReaderOrReader) {
            if (arguments.length === 1 && (inStreamOrFilenameOrTxtReaderOrReader === null || inStreamOrFilenameOrTxtReaderOrReader instanceof Stream)) {
                this.Load_0(inStreamOrFilenameOrTxtReaderOrReader);
                return;
            }
            if (arguments.length === 1 && (inStreamOrFilenameOrTxtReaderOrReader === null || inStreamOrFilenameOrTxtReaderOrReader.constructor === String)) {
                this.Load_1(inStreamOrFilenameOrTxtReaderOrReader);
                return;
            }
            if (arguments.length === 1 && (inStreamOrFilenameOrTxtReaderOrReader === null || inStreamOrFilenameOrTxtReaderOrReader instanceof TextReader)) {
                this.Load_2(inStreamOrFilenameOrTxtReaderOrReader);
                return;
            }
            this.Load_3(inStreamOrFilenameOrTxtReaderOrReader);
        };
        SafeXmlDocument.prototype.Load_0 = function (inStream) {
            var xmlReader = XmlReader.Create(inStream, this.settings);
            try {
                this.Load(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
        };
        SafeXmlDocument.prototype.Load_1 = function (filename) {
            var xmlReader = XmlReader.Create(filename, this.settings);
            try {
                this.Load(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
        };
        SafeXmlDocument.prototype.Load_2 = function (txtReader) {
            var xmlReader = XmlReader.Create(txtReader, this.settings);
            try {
                this.Load(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
        };
        SafeXmlDocument.prototype.Load_3 = function (reader) {
            if (reader.get_Settings() !== null && !reader.get_Settings().get_ProhibitDtd()) {
                throw new XmlDtdException();
            }
            try {
                _super.prototype.Load.call(this, reader);
            }
            catch (ex) {
                if (ex instanceof XmlException) {
                    if (NString.StartsWith(ex.Message, "For security reasons DTD is prohibited in this XML document.", StringComparison.OrdinalIgnoreCase)) {
                        throw new XmlDtdException();
                    }
                }
                else
                    throw ex;
            }
        };
        SafeXmlDocument.prototype.LoadXml = function (xml) {
            var xmlReader = XmlReader.Create(new StringReader(xml), this.settings);
            try {
                _super.prototype.Load.call(this, xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
        };
        return SafeXmlDocument;
    }(XmlDocument));
    var SafeXmlFactory = (function () {
        function SafeXmlFactory() {
        }
        SafeXmlFactory.CreateSafeXmlTextReader = function (streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType, contextOrNt) {
            if (arguments.length === 1 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment instanceof Stream)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_0(streamOrUrlOrInputOrXmlFragment);
            }
            if (arguments.length === 1 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_1(streamOrUrlOrInputOrXmlFragment);
            }
            if (arguments.length === 1 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment instanceof TextReader)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_2(streamOrUrlOrInputOrXmlFragment);
            }
            if (arguments.length === 2 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment instanceof Stream) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof XmlNameTable)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_3(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType);
            }
            if (arguments.length === 2 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof Stream)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_4(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType);
            }
            if (arguments.length === 2 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof TextReader)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_5(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType);
            }
            if (arguments.length === 2 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof XmlNameTable)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_6(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType);
            }
            if (arguments.length === 2 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment instanceof TextReader) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof XmlNameTable)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_7(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType);
            }
            if (arguments.length === 3 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment instanceof Stream) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof XmlNodeType) && (contextOrNt === null || contextOrNt instanceof XmlParserContext)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_8(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType, contextOrNt);
            }
            if (arguments.length === 3 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof Stream) && (contextOrNt === null || contextOrNt instanceof XmlNameTable)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_9(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType, contextOrNt);
            }
            if (arguments.length === 3 && (streamOrUrlOrInputOrXmlFragment === null || streamOrUrlOrInputOrXmlFragment.constructor === String) && (ntOrInputOrFragType === null || ntOrInputOrFragType instanceof TextReader) && (contextOrNt === null || contextOrNt instanceof XmlNameTable)) {
                return SafeXmlFactory.CreateSafeXmlTextReader_10(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType, contextOrNt);
            }
            return SafeXmlFactory.CreateSafeXmlTextReader_11(streamOrUrlOrInputOrXmlFragment, ntOrInputOrFragType, contextOrNt);
        };
        SafeXmlFactory.CreateSafeXmlTextReader_0 = function (stream) {
            var xmlTextReader = new XmlTextReader(stream);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_1 = function (url) {
            var xmlTextReader = new XmlTextReader(url);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_2 = function (input) {
            var xmlTextReader = new XmlTextReader(input);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_3 = function (input, nt) {
            var xmlTextReader = new XmlTextReader(input, nt);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_4 = function (url, input) {
            var xmlTextReader = new XmlTextReader(url, input);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_5 = function (url, input) {
            var xmlTextReader = new XmlTextReader(url, input);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_6 = function (url, nt) {
            var xmlTextReader = new XmlTextReader(url, nt);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_7 = function (input, nt) {
            var xmlTextReader = new XmlTextReader(input, nt);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_8 = function (xmlFragment, fragType, context) {
            var xmlTextReader = new XmlTextReader(xmlFragment, fragType, context);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_9 = function (url, input, nt) {
            var xmlTextReader = new XmlTextReader(url, input, nt);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_10 = function (url, input, nt) {
            var xmlTextReader = new XmlTextReader(url, input, nt);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateSafeXmlTextReader_11 = function (xmlFragment, fragType, context) {
            var xmlTextReader = new XmlTextReader(xmlFragment, fragType, context);
            xmlTextReader.set_ProhibitDtd(true);
            xmlTextReader.set_XmlResolver(null);
            return xmlTextReader;
        };
        SafeXmlFactory.CreateXPathDocument = function (streamOrUriOrTextReaderOrReader, space) {
            if (arguments.length === 1 && (streamOrUriOrTextReaderOrReader === null || streamOrUriOrTextReaderOrReader instanceof Stream)) {
                return SafeXmlFactory.CreateXPathDocument_0(streamOrUriOrTextReaderOrReader);
            }
            if (arguments.length === 1 && (streamOrUriOrTextReaderOrReader === null || streamOrUriOrTextReaderOrReader.constructor === String)) {
                return SafeXmlFactory.CreateXPathDocument_1(streamOrUriOrTextReaderOrReader);
            }
            if (arguments.length === 1 && (streamOrUriOrTextReaderOrReader === null || streamOrUriOrTextReaderOrReader instanceof TextReader)) {
                return SafeXmlFactory.CreateXPathDocument_2(streamOrUriOrTextReaderOrReader);
            }
            if (arguments.length === 1 && (streamOrUriOrTextReaderOrReader === null || streamOrUriOrTextReaderOrReader instanceof XmlReader)) {
                return SafeXmlFactory.CreateXPathDocument_3(streamOrUriOrTextReaderOrReader);
            }
            if (arguments.length === 2 && (streamOrUriOrTextReaderOrReader === null || streamOrUriOrTextReaderOrReader.constructor === String) && (space === null || space instanceof XmlSpace)) {
                return SafeXmlFactory.CreateXPathDocument_4(streamOrUriOrTextReaderOrReader, space);
            }
            return SafeXmlFactory.CreateXPathDocument_5(streamOrUriOrTextReaderOrReader, space);
        };
        SafeXmlFactory.CreateXPathDocument_0 = function (stream) {
            var xmlReader = XmlReader.Create(stream, SafeXmlFactory.defaultSettings);
            var result;
            try {
                result = SafeXmlFactory.CreateXPathDocument(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlFactory.CreateXPathDocument_1 = function (uri) {
            var xmlReader = XmlReader.Create(uri, SafeXmlFactory.defaultSettings);
            var result;
            try {
                result = SafeXmlFactory.CreateXPathDocument(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlFactory.CreateXPathDocument_2 = function (textReader) {
            var xmlReader = XmlReader.Create(textReader, SafeXmlFactory.defaultSettings);
            var result;
            try {
                result = SafeXmlFactory.CreateXPathDocument(xmlReader);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlFactory.CreateXPathDocument_3 = function (reader) {
            if (reader.get_Settings() !== null && !reader.get_Settings().get_ProhibitDtd()) {
                throw new XmlDtdException();
            }
            return new XPathDocument(reader);
        };
        SafeXmlFactory.CreateXPathDocument_4 = function (uri, space) {
            var xmlReader = XmlReader.Create(uri, SafeXmlFactory.defaultSettings);
            var result;
            try {
                result = SafeXmlFactory.CreateXPathDocument(xmlReader, space);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlFactory.CreateXPathDocument_5 = function (reader, space) {
            if (reader.get_Settings() !== null && !reader.get_Settings().get_ProhibitDtd()) {
                throw new XmlDtdException();
            }
            return new XPathDocument(reader, space);
        };
        SafeXmlFactory.SafeXmlFactory_cctor = function () {
            // Note: this type is marked as 'beforefieldinit'.
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_XmlResolver(null);
            SafeXmlFactory.defaultSettings = xmlReaderSettings;
        };
        SafeXmlFactory.defaultSettings = null;
        return SafeXmlFactory;
    }());
    var SafeXmlSchema = (function (_super) {
        __extends(SafeXmlSchema, _super);
        function SafeXmlSchema() {
            _super.apply(this, arguments);
        }
        SafeXmlSchema.Read = function (streamOrReader, validationEventHandler) {
            if (arguments.length === 2 && (streamOrReader === null || streamOrReader instanceof Stream) && (validationEventHandler === null || validationEventHandler instanceof ValidationEventHandler)) {
                return SafeXmlSchema.Read_0(streamOrReader, validationEventHandler);
            }
            if (arguments.length === 2 && (streamOrReader === null || streamOrReader instanceof TextReader) && (validationEventHandler === null || validationEventHandler instanceof ValidationEventHandler)) {
                return SafeXmlSchema.Read_1(streamOrReader, validationEventHandler);
            }
            return SafeXmlSchema.Read_2(streamOrReader, validationEventHandler);
        };
        SafeXmlSchema.Read_0 = function (stream, validationEventHandler) {
            var xmlReader = XmlReader.Create(stream, SafeXmlSchema.defaultSettings);
            var result;
            try {
                result = XmlSchema.Read(xmlReader, validationEventHandler);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlSchema.Read_1 = function (reader, validationEventHandler) {
            var xmlReader = XmlReader.Create(reader, SafeXmlSchema.defaultSettings);
            var result;
            try {
                result = XmlSchema.Read(xmlReader, validationEventHandler);
            }
            finally {
                if (xmlReader !== null) {
                    xmlReader.Dispose();
                }
            }
            return result;
        };
        SafeXmlSchema.Read_2 = function (reader, validationEventHandler) {
            if (reader.get_Settings() !== null && !reader.get_Settings().get_ProhibitDtd()) {
                throw new XmlDtdException();
            }
            return XmlSchema.Read(reader, validationEventHandler);
        };
        SafeXmlSchema.SafeXmlSchema_cctor = function () {
            // Note: this type is marked as 'beforefieldinit'.
            var xmlReaderSettings = new XmlReaderSettings();
            xmlReaderSettings.set_ProhibitDtd(true);
            xmlReaderSettings.set_XmlResolver(null);
            SafeXmlSchema.defaultSettings = xmlReaderSettings;
        };
        SafeXmlSchema.defaultSettings = null;
        return SafeXmlSchema;
    }(XmlSchema));
    var XmlDtdException = (function (_super) {
        __extends(XmlDtdException, _super);
        function XmlDtdException() {
            _super.call(this);
        }
        Object.defineProperty(XmlDtdException.prototype, "Message", {
            get: function () {
                return "For security reasons DTD is prohibited in this XML document.";
            },
            enumerable: true,
            configurable: true
        });
        return XmlDtdException;
    }(XmlException));
    var Change = (function () {
        function Change() {
            this.changeType = 0;
            this.serviceObject = null;
            this.id = null;
            _super.call(this);
        }
        Object.defineProperty(Change.prototype, "ChangeType", {
            get: function () {
                return this.changeType;
            },
            set: function (value) {
                this.changeType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Change.prototype, "ServiceObject", {
            get: function () {
                return this.serviceObject;
            },
            set: function (value) {
                this.serviceObject = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Change.prototype, "Id", {
            get: function () {
                if (this.ServiceObject === null) {
                    return this.id;
                }
                return this.ServiceObject.GetId();
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        Change.prototype.CreateId = function () {
            throw new NotSupportedException();
        };
        return Change;
    }());
    var ChangeCollection = (function () {
        function ChangeCollection() {
            this.changes = new List();
            this.syncState = null;
            this.moreChangesAvailable = false;
            _super.call(this);
        }
        Object.defineProperty(ChangeCollection.prototype, "Count", {
            get: function () {
                return this.changes.Count;
            },
            enumerable: true,
            configurable: true
        });
        ChangeCollection.prototype.get_Item = function (index) {
            if (index < 0 || index >= this.Count) {
                throw new ArgumentOutOfRangeException("index", Strings.IndexIsOutOfRange);
            }
            return this.changes.get_Item(index);
        };
        Object.defineProperty(ChangeCollection.prototype, "SyncState", {
            get: function () {
                return this.syncState;
            },
            set: function (value) {
                this.syncState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ChangeCollection.prototype, "MoreChangesAvailable", {
            get: function () {
                return this.moreChangesAvailable;
            },
            set: function (value) {
                this.moreChangesAvailable = value;
            },
            enumerable: true,
            configurable: true
        });
        ChangeCollection.prototype.Add = function (change) {
            EwsUtilities.Assert(change !== null, "ChangeList.Add", "change is null");
            this.changes.Add(change);
        };
        ChangeCollection.prototype.GetEnumerator = function () {
            return this.changes.GetEnumerator();
        };
        return ChangeCollection;
    }());
    var FolderChange = (function (_super) {
        __extends(FolderChange, _super);
        function FolderChange() {
            _super.call(this);
        }
        Object.defineProperty(FolderChange.prototype, "Folder", {
            get: function () {
                return this.ServiceObject;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FolderChange.prototype, "FolderId", {
            get: function () {
                return this.Id;
            },
            enumerable: true,
            configurable: true
        });
        FolderChange.prototype.CreateId = function () {
            return new FolderId();
        };
        return FolderChange;
    }(Change));
    var ItemChange = (function (_super) {
        __extends(ItemChange, _super);
        function ItemChange() {
            _super.call(this);
            this.isRead = false;
        }
        Object.defineProperty(ItemChange.prototype, "Item", {
            get: function () {
                return this.ServiceObject;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ItemChange.prototype, "IsRead", {
            get: function () {
                return this.isRead;
            },
            set: function (value) {
                this.isRead = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ItemChange.prototype, "ItemId", {
            get: function () {
                return this.Id;
            },
            enumerable: true,
            configurable: true
        });
        ItemChange.prototype.CreateId = function () {
            return new ItemId();
        };
        return ItemChange;
    }(Change));
    var PhoneCall = (function (_super) {
        __extends(PhoneCall, _super);
        function PhoneCall(service, id) {
            _super.call(this);
            this.service = null;
            this.state = 0;
            this.connectionFailureCause = 0;
            this.sipResponseText = null;
            this.sipResponseCode = 0;
            this.id = null;
            if (arguments.length === 1 && (service === null || service instanceof ExchangeService)) {
                this.constructor_0(service);
                return;
            }
            this.constructor_1(service, id);
        }
        Object.defineProperty(PhoneCall.prototype, "State", {
            get: function () {
                return this.state;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhoneCall.prototype, "ConnectionFailureCause", {
            get: function () {
                return this.connectionFailureCause;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhoneCall.prototype, "SIPResponseText", {
            get: function () {
                return this.sipResponseText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PhoneCall.prototype, "SIPResponseCode", {
            get: function () {
                return this.sipResponseCode;
            },
            enumerable: true,
            configurable: true
        });
        PhoneCall.prototype.constructor_0 = function (service) {
            EwsUtilities.Assert(service !== null, "PhoneCall.ctor", "service is null");
            this.service = service;
            this.state = PhoneCallState.Connecting;
            this.connectionFailureCause = ConnectionFailureCause.None;
            this.sipResponseText = "OK";
            this.sipResponseCode = 200;
        };
        PhoneCall.prototype.constructor_1 = function (service, id) {
            this.constructor_0(service);
            this.id = id;
        };
        PhoneCall.prototype.Refresh = function () {
            var phoneCallInformation = this.service.UnifiedMessaging.GetPhoneCallInformation(this.id);
            this.state = phoneCallInformation.State;
            this.connectionFailureCause = phoneCallInformation.ConnectionFailureCause;
            this.sipResponseText = phoneCallInformation.SIPResponseText;
            this.sipResponseCode = phoneCallInformation.SIPResponseCode;
        };
        PhoneCall.prototype.Disconnect = function () {
            if (this.state === PhoneCallState.Disconnected) {
                throw new ServiceLocalException(Strings.PhoneCallAlreadyDisconnected);
            }
            this.service.UnifiedMessaging.DisconnectPhoneCall(this.id);
            this.state = PhoneCallState.Disconnected;
        };
        PhoneCall.prototype.TryReadElementFromXml = function (reader) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "PhoneCallState") {
                    this.state = reader.ReadElementValue();
                    return true;
                }
                if (localName === "ConnectionFailureCause") {
                    this.connectionFailureCause = reader.ReadElementValue();
                    return true;
                }
                if (localName === "SIPResponseText") {
                    this.sipResponseText = reader.ReadElementValue();
                    return true;
                }
                if (localName === "SIPResponseCode") {
                    this.sipResponseCode = reader.ReadElementValue();
                    return true;
                }
            }
            return false;
        };
        PhoneCall.prototype.LoadFromJson = function (jsonProperty, service) {
            var enumerator = jsonProperty.Keys.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var a;
                    if ((a = current) !== null) {
                        if (!(a === "PhoneCallState")) {
                            if (!(a === "ConnectionFailureCause")) {
                                if (!(a === "SIPResponseText")) {
                                    if (a === "SIPResponseCode") {
                                        this.sipResponseCode = jsonProperty.ReadAsInt(current);
                                    }
                                }
                                else {
                                    this.sipResponseText = jsonProperty.ReadAsString(current);
                                }
                            }
                            else {
                                this.connectionFailureCause = jsonProperty.ReadEnumValue(current);
                            }
                        }
                        else {
                            this.state = jsonProperty.ReadEnumValue(current);
                        }
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        PhoneCall.SuccessfulResponseText = "OK";
        PhoneCall.SuccessfulResponseCode = 200;
        return PhoneCall;
    }(ComplexProperty));
    var PhoneCallId = (function (_super) {
        __extends(PhoneCallId, _super);
        function PhoneCallId(id) {
            _super.call(this);
            this.id = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(id);
        }
        Object.defineProperty(PhoneCallId.prototype, "Id", {
            get: function () {
                return this.id;
            },
            set: function (value) {
                this.id = value;
            },
            enumerable: true,
            configurable: true
        });
        PhoneCallId.prototype.constructor_0 = function () {
        };
        PhoneCallId.prototype.constructor_1 = function (id) {
            this.id = id;
        };
        PhoneCallId.prototype.ReadAttributesFromXml = function (reader) {
            this.id = reader.ReadAttributeValue("Id");
        };
        PhoneCallId.prototype.LoadFromJson = function (jsonProperty, service) {
            this.id = jsonProperty.ReadAsString("Id");
        };
        PhoneCallId.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("Id", this.id);
        };
        PhoneCallId.prototype.WriteToXml = function (writer) {
            this.WriteToXml(writer, "PhoneCallId");
        };
        PhoneCallId.prototype.InternalToJson = function (service) {
            var jsonObject = new JsonObject();
            jsonObject.Add("Id", this.id);
            return jsonObject;
        };
        return PhoneCallId;
    }(ComplexProperty));
    var UnifiedMessaging = (function () {
        function UnifiedMessaging(service) {
            this.service = null;
            _super.call(this);
            this.service = service;
        }
        UnifiedMessaging.prototype.PlayOnPhone = function (itemId, dialString) {
            EwsUtilities.ValidateParam(itemId, "itemId");
            EwsUtilities.ValidateParam(dialString, "dialString");
            var playOnPhoneRequest = new PlayOnPhoneRequest(this.service);
            playOnPhoneRequest.DialString = dialString;
            playOnPhoneRequest.ItemId = itemId;
            var playOnPhoneResponse = playOnPhoneRequest.Execute();
            return new PhoneCall(this.service, playOnPhoneResponse.PhoneCallId);
        };
        UnifiedMessaging.prototype.GetPhoneCallInformation = function (id) {
            var getPhoneCallRequest = new GetPhoneCallRequest(this.service);
            getPhoneCallRequest.Id = id;
            var getPhoneCallResponse = getPhoneCallRequest.Execute();
            return getPhoneCallResponse.PhoneCall;
        };
        UnifiedMessaging.prototype.DisconnectPhoneCall = function (id) {
            var disconnectPhoneCallRequest = new DisconnectPhoneCallRequest(this.service);
            disconnectPhoneCallRequest.Id = id;
            disconnectPhoneCallRequest.Execute();
        };
        return UnifiedMessaging;
    }());
    var AlternateMailbox = (function () {
        function AlternateMailbox() {
            this.type = null;
            this.displayName = null;
            this.legacyDN = null;
            this.server = null;
            this.smtpAddress = null;
            this.ownerSmtpAddress = null;
            _super.call(this);
        }
        Object.defineProperty(AlternateMailbox.prototype, "Type", {
            get: function () {
                return this.type;
            },
            set: function (value) {
                this.type = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AlternateMailbox.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            set: function (value) {
                this.displayName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AlternateMailbox.prototype, "LegacyDN", {
            get: function () {
                return this.legacyDN;
            },
            set: function (value) {
                this.legacyDN = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AlternateMailbox.prototype, "Server", {
            get: function () {
                return this.server;
            },
            set: function (value) {
                this.server = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AlternateMailbox.prototype, "SmtpAddress", {
            get: function () {
                return this.smtpAddress;
            },
            set: function (value) {
                this.smtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AlternateMailbox.prototype, "OwnerSmtpAddress", {
            get: function () {
                return this.ownerSmtpAddress;
            },
            set: function (value) {
                this.ownerSmtpAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        AlternateMailbox.LoadFromXml = function (reader) {
            var alternateMailbox = new AlternateMailbox();
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (_PrivateImplementationDetails_) {
                        70549;
                        B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                    }
                    $$method0x600000c - 1 === null;
                    {
                        var expr_34 = new Dictionary(6);
                        expr_34.Add("Type", 0);
                        expr_34.Add("DisplayName", 1);
                        expr_34.Add("LegacyDN", 2);
                        expr_34.Add("Server", 3);
                        expr_34.Add("SmtpAddress", 4);
                        expr_34.Add("OwnerSmtpAddress", 5);
                        _PrivateImplementationDetails_;
                        {
                            70549;
                            B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                        }
                        $$method0x600000c - 1;
                        expr_34;
                    }
                    var num;
                    if ((function () {
                        var _p0 = [
                            num
                        ];
                        var _r = _PrivateImplementationDetails_, _a = (void 0)[70549], B87 = _a === void 0 ? -FCC0 - 4468 - A58C - F62EC848C70D : _a, $$method0x600000c = -1., TryGetValue = (localName, _p0);
                        num = _p0[0];
                        return _r;
                    })()) {
                        switch (num) {
                            case 0:
                                alternateMailbox.Type = reader.ReadElementValue();
                                break;
                            case 1:
                                alternateMailbox.DisplayName = reader.ReadElementValue();
                                break;
                            case 2:
                                alternateMailbox.LegacyDN = reader.ReadElementValue();
                                break;
                            case 3:
                                alternateMailbox.Server = reader.ReadElementValue();
                                break;
                            case 4:
                                alternateMailbox.SmtpAddress = reader.ReadElementValue();
                                break;
                            case 5:
                                alternateMailbox.OwnerSmtpAddress = reader.ReadElementValue();
                                break;
                        }
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "AlternateMailbox"));
            return alternateMailbox;
        };
        return AlternateMailbox;
    }());
    var AlternateMailboxCollection = (function () {
        function AlternateMailboxCollection() {
            this.Entries = null;
            _super.call(this);
            this.Entries = new List();
        }
        AlternateMailboxCollection.LoadFromXml = function (reader) {
            var alternateMailboxCollection = new AlternateMailboxCollection();
            do {
                reader.Read();
                if (reader.NodeType === 1 && reader.LocalName === "AlternateMailbox") {
                    alternateMailboxCollection.Entries.Add(AlternateMailbox.LoadFromXml(reader));
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "AlternateMailboxes"));
            return alternateMailboxCollection;
        };
        return AlternateMailboxCollection;
    }());
    var AutodiscoverDnsClient = (function () {
        function AutodiscoverDnsClient(service) {
            this.service = null;
            _super.call(this);
            this.service = service;
        }
        AutodiscoverDnsClient.prototype.FindAutodiscoverHostFromSrv = function (domain) {
            var domain2 = "_autodiscover._tcp." + domain;
            var dnsSrvRecord = this.FindBestMatchingSrvRecord(domain2);
            if (dnsSrvRecord === null || NString.IsNullOrEmpty(dnsSrvRecord.NameTarget)) {
                this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, "No appropriate SRV record was found.");
                return null;
            }
            this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("DNS query for SRV record for domain {0} found {1}", domain, dnsSrvRecord.NameTarget));
            return dnsSrvRecord.NameTarget;
        };
        AutodiscoverDnsClient.prototype.FindBestMatchingSrvRecord = function (domain) {
            var list;
            try {
                list = DnsClient.DnsQuery(domain, this.service.DnsServerAddress);
            }
            catch (ex) {
                if (ex instanceof DnsException) {
                    var logEntry = NString.Format("DnsQuery returned error error '{0}' error code 0x{1:X8}.", ex.Message, ex.NativeErrorCode);
                    this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, logEntry);
                    var result = null;
                    return result;
                }
                else if (ex instanceof SecurityException) {
                    this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("DnsQuery cannot be called. Security error: {0}.", ex2.Message));
                    var result = null;
                    return result;
                }
                else
                    throw ex;
            }
            this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("{0} SRV records were returned.", list.Count));
            var priority = -2147483648;
            var weight = -2147483648;
            var flag = false;
            var enumerator = list.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (current.Port === 443) {
                        priority = current.Priority;
                        weight = current.Weight;
                        flag = true;
                        break;
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (!flag) {
                this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, "No appropriate SRV records were found.");
                return null;
            }
            var list2 = list.FindAll(function (record) { return record.Port === 443 && record.Priority === priority && record.Weight === weight; });
            EwsUtilities.Assert(list.Count > 0, "AutodiscoverDnsClient.FindBestMatchingSrvRecord", "At least one DNS SRV record must match the criteria.");
            var num = (list2.Count > 1) ? AutodiscoverDnsClient.randomTieBreakerSelector.Next(list2.Count) : 0;
            var dnsSrvRecord = list2.get_Item(num);
            var logEntry2 = NString.Format("Returning SRV record {0} of {1} records. Target: {2}, Priority: {3}, Weight: {4}", [
                num, list.Count, dnsSrvRecord.NameTarget, dnsSrvRecord.Priority, dnsSrvRecord.Weight
            ]);
            this.service.TraceMessage(TraceFlags.AutodiscoverConfiguration, logEntry2);
            return dnsSrvRecord;
        };
        AutodiscoverDnsClient.AutoDiscoverSrvPrefix = "_autodiscover._tcp.";
        AutodiscoverDnsClient.SslPort = 443;
        AutodiscoverDnsClient.randomTieBreakerSelector = new Random();
        return AutodiscoverDnsClient;
    }());
    var AutodiscoverError = (function () {
        function AutodiscoverError() {
            this.time = null;
            this.id = null;
            this.errorCode = 0;
            this.message = null;
            this.debugData = null;
            _super.call(this);
        }
        Object.defineProperty(AutodiscoverError.prototype, "Time", {
            get: function () {
                return this.time;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverError.prototype, "Id", {
            get: function () {
                return this.id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverError.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverError.prototype, "Message", {
            get: function () {
                return this.message;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverError.prototype, "DebugData", {
            get: function () {
                return this.debugData;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverError.Parse = function (reader) {
            var autodiscoverError = new AutodiscoverError();
            autodiscoverError.time = reader.ReadAttributeValue("Time");
            autodiscoverError.id = reader.ReadAttributeValue("Id");
            do {
                var IL_9A = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                if ((localName = reader.LocalName) !== null) {
                                    if (localName === "ErrorCode") {
                                        autodiscoverError.errorCode = reader.ReadElementValue();
                                        _goto = IL_9A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "Message") {
                                        autodiscoverError.message = reader.ReadElementValue();
                                        _goto = IL_9A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "DebugData") {
                                        autodiscoverError.debugData = reader.ReadElementValue();
                                        _goto = IL_9A;
                                        continue _GOTO_LOOP;
                                    }
                                }
                                reader.SkipCurrentElement();
                            }
                            _goto = IL_9A;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, "Error"));
            return autodiscoverError;
        };
        return AutodiscoverError;
    }());
    var AutodiscoverResponse = (function () {
        function AutodiscoverResponse() {
            this.errorCode = 0;
            this.errorMessage = null;
            this.redirectionUrl = null;
            _super.call(this);
            this.errorCode = AutodiscoverErrorCode.NoError;
            this.errorMessage = Strings.NoError;
        }
        Object.defineProperty(AutodiscoverResponse.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            set: function (value) {
                this.errorCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverResponse.prototype, "ErrorMessage", {
            get: function () {
                return this.errorMessage;
            },
            set: function (value) {
                this.errorMessage = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverResponse.prototype, "RedirectionUrl", {
            get: function () {
                return this.redirectionUrl;
            },
            set: function (value) {
                this.redirectionUrl = value;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverResponse.prototype.LoadFromXml = function (reader, endElementName) {
            var localName;
            if ((localName = reader.LocalName) !== null) {
                if (localName === "ErrorCode") {
                    this.ErrorCode = reader.ReadElementValue();
                    return;
                }
                if (!(localName === "ErrorMessage")) {
                    return;
                }
                this.ErrorMessage = reader.ReadElementValue();
            }
        };
        return AutodiscoverResponse;
    }());
    var AutodiscoverResponseCollection = (function (_super) {
        __extends(AutodiscoverResponseCollection, _super);
        function AutodiscoverResponseCollection() {
            _super.call(this);
            this.responses = null;
            this.responses = new List();
        }
        Object.defineProperty(AutodiscoverResponseCollection.prototype, "Count", {
            get: function () {
                return this.responses.Count;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverResponseCollection.prototype.get_Item = function (index) {
            return this.responses.get_Item(index);
        };
        Object.defineProperty(AutodiscoverResponseCollection.prototype, "Responses", {
            get: function () {
                return this.responses;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverResponseCollection.prototype.LoadFromXml = function (reader, endElementName) {
            do {
                reader.Read();
                if (reader.NodeType === 1) {
                    if (reader.LocalName === this.GetResponseCollectionXmlElementName()) {
                        this.LoadResponseCollectionFromXml(reader);
                    }
                    else {
                        _super.prototype.LoadFromXml.call(this, reader, endElementName);
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, endElementName));
        };
        AutodiscoverResponseCollection.prototype.LoadResponseCollectionFromXml = function (reader) {
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === this.GetResponseInstanceXmlElementName()) {
                        var item = this.CreateResponseInstance();
                        item.LoadFromXml(reader, this.GetResponseInstanceXmlElementName());
                        this.Responses.Add(item);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Autodiscover, this.GetResponseCollectionXmlElementName()));
            }
        };
        AutodiscoverResponseCollection.prototype.GetResponseCollectionXmlElementName = function () {
            throw new NotSupportedException();
        };
        AutodiscoverResponseCollection.prototype.GetResponseInstanceXmlElementName = function () {
            throw new NotSupportedException();
        };
        AutodiscoverResponseCollection.prototype.CreateResponseInstance = function () {
            throw new NotSupportedException();
        };
        AutodiscoverResponseCollection.prototype.GetEnumerator = function () {
            return this.responses.GetEnumerator();
        };
        return AutodiscoverResponseCollection;
    }(AutodiscoverResponse));
    var ComparisonHelpers = (function () {
        function ComparisonHelpers() {
            _super.call(this);
        }
        ComparisonHelpers.CaseInsensitiveContains = function (collection, match) {
            var enumerator = collection.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var text = ((current instanceof string) ? current : null);
                    if (text !== null && NString.Compare(text, match, StringComparison.OrdinalIgnoreCase) === 0) {
                        return true;
                    }
                }
            }
            finally {
                var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                if (disposable !== null) {
                    disposable.Dispose();
                }
            }
            return false;
        };
        return ComparisonHelpers;
    }());
    var AutodiscoverService = (function (_super) {
        __extends(AutodiscoverService, _super);
        function AutodiscoverService(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain, requestedServerVersion) {
            _super.call(this, ExchangeVersion.Exchange2010);
            this.domain = null;
            this.isExternal = null;
            this.url = null;
            this.redirectionUrlValidationCallback = null;
            this.dnsClient = null;
            this.dnsServerAddress = null;
            this.enableScpLookup = false;
            this.GetScpUrlsForDomainCallback = null;
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            if (arguments.length === 1 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService.constructor === Number)) {
                this.constructor_1(requestedServerVersionOrDomainOrUrlOrService);
                return;
            }
            if (arguments.length === 1 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService.constructor === String)) {
                this.constructor_2(requestedServerVersionOrDomainOrUrlOrService);
                return;
            }
            if (arguments.length === 2 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService.constructor === String) && (requestedServerVersionOrDomain === null || requestedServerVersionOrDomain.constructor === Number)) {
                this.constructor_3(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain);
                return;
            }
            if (arguments.length === 1 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService instanceof Uri)) {
                this.constructor_4(requestedServerVersionOrDomainOrUrlOrService);
                return;
            }
            if (arguments.length === 2 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService instanceof Uri) && (requestedServerVersionOrDomain === null || requestedServerVersionOrDomain.constructor === Number)) {
                this.constructor_5(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain);
                return;
            }
            if (arguments.length === 2 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService instanceof Uri) && (requestedServerVersionOrDomain === null || requestedServerVersionOrDomain.constructor === String)) {
                this.constructor_6(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain);
                return;
            }
            if (arguments.length === 3 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService instanceof Uri) && (requestedServerVersionOrDomain === null || requestedServerVersionOrDomain.constructor === String) && (requestedServerVersion === null || requestedServerVersion.constructor === Number)) {
                this.constructor_7(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain, requestedServerVersion);
                return;
            }
            if (arguments.length === 2 && (requestedServerVersionOrDomainOrUrlOrService === null || requestedServerVersionOrDomainOrUrlOrService instanceof ExchangeServiceBase) && (requestedServerVersionOrDomain === null || requestedServerVersionOrDomain.constructor === Number)) {
                this.constructor_8(requestedServerVersionOrDomainOrUrlOrService, requestedServerVersionOrDomain);
                return;
            }
            this.constructor_9(requestedServerVersionOrDomainOrUrlOrService);
        }
        Object.defineProperty(AutodiscoverService.prototype, "Domain", {
            get: function () {
                return this.domain;
            },
            set: function (value) {
                EwsUtilities.ValidateDomainNameAllowNull(value, "Domain");
                if (value !== null) {
                    this.url = null;
                }
                this.domain = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverService.prototype, "Url", {
            get: function () {
                return this.url;
            },
            set: function (value) {
                if (Uri.op_Inequality(value, null)) {
                    this.domain = value.Host;
                }
                this.url = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverService.prototype, "IsExternal", {
            get: function () {
                return this.isExternal;
            },
            set: function (value) {
                this.isExternal = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverService.prototype, "RedirectionUrlValidationCallback", {
            get: function () {
                return this.redirectionUrlValidationCallback;
            },
            set: function (value) {
                this.redirectionUrlValidationCallback = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverService.prototype, "DnsServerAddress", {
            get: function () {
                return this.dnsServerAddress;
            },
            set: function (value) {
                this.dnsServerAddress = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverService.prototype, "EnableScpLookup", {
            get: function () {
                return this.enableScpLookup;
            },
            set: function (value) {
                this.enableScpLookup = value;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverService.prototype.DefaultAutodiscoverRedirectionUrlValidationCallback = function (redirectionUrl) {
            throw new AutodiscoverLocalException(NString.Format(Strings.AutodiscoverRedirectBlocked, redirectionUrl));
        };
        AutodiscoverService.prototype.GetLegacyUserSettingsAtUrl = function (emailAddress, url) {
            var _this = this;
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Trying to call Autodiscover for {0} on {1}.", emailAddress, url));
            var tSettings = Activator.CreateInstance();
            var ewsHttpWebRequest = this.PrepareHttpWebRequestForUrl(url);
            _super.prototype.TraceHttpRequestHeaders.call(this, TraceFlags.AutodiscoverRequestHttpHeaders, ewsHttpWebRequest);
            var requestStream = ewsHttpWebRequest.GetRequestStream();
            try {
                if (_super.prototype.IsTraceEnabledFor.call(this, TraceFlags.AutodiscoverRequest)) {
                    var memoryStream = new MemoryStream();
                    try {
                        var streamWriter = new StreamWriter(memoryStream);
                        try {
                            this.WriteLegacyAutodiscoverRequest(emailAddress, tSettings, streamWriter);
                            streamWriter.Flush();
                            _super.prototype.TraceXml.call(this, TraceFlags.AutodiscoverRequest, memoryStream);
                            EwsUtilities.CopyStream(memoryStream, requestStream);
                        }
                        finally {
                            if (streamWriter !== null) {
                                streamWriter.Dispose();
                            }
                        }
                        goto;
                        IL_B4;
                    }
                    finally {
                        if (memoryStream !== null) {
                            memoryStream.Dispose();
                        }
                    }
                }
                var streamWriter2 = new StreamWriter(requestStream);
                try {
                    this.WriteLegacyAutodiscoverRequest(emailAddress, tSettings, streamWriter2);
                }
                finally {
                    if (streamWriter2 !== null) {
                        streamWriter2.Dispose();
                    }
                }
                IL_B4: ;
            }
            finally {
                if (requestStream !== null) {
                    requestStream.Dispose();
                }
            }
            var response = ewsHttpWebRequest.GetResponse();
            var result;
            try {
                var redirectUrl;
                if ((function () {
                    var _p0 = [
                        redirectUrl
                    ];
                    var _r = _this.TryGetRedirectionResponse(response, _p0);
                    redirectUrl = _p0[0];
                    return _r;
                })()) {
                    tSettings.MakeRedirectionResponse(redirectUrl);
                    result = tSettings;
                }
                else {
                    var responseStream = response.GetResponseStream();
                    try {
                        if (_super.prototype.IsTraceEnabledFor.call(this, TraceFlags.AutodiscoverResponse)) {
                            var memoryStream2 = new MemoryStream();
                            try {
                                EwsUtilities.CopyStream(responseStream, memoryStream2);
                                memoryStream2.Position = 0;
                                this.TraceResponse(response, memoryStream2);
                                var ewsXmlReader = new EwsXmlReader(memoryStream2);
                                ewsXmlReader.Read(17);
                                tSettings.LoadFromXml(ewsXmlReader);
                                goto;
                                IL_172;
                            }
                            finally {
                                if (memoryStream2 !== null) {
                                    memoryStream2.Dispose();
                                }
                            }
                        }
                        var ewsXmlReader2 = new EwsXmlReader(responseStream);
                        ewsXmlReader2.Read(17);
                        tSettings.LoadFromXml(ewsXmlReader2);
                        IL_172: ;
                    }
                    finally {
                        if (responseStream !== null) {
                            responseStream.Dispose();
                        }
                    }
                    result = tSettings;
                }
            }
            finally {
                if (response !== null) {
                    response.Dispose();
                }
            }
            return result;
        };
        AutodiscoverService.prototype.WriteLegacyAutodiscoverRequest = function (emailAddress, settings, writer) {
            writer.Write(NString.Format("<Autodiscover xmlns=\"{0}\">", "http://schemas.microsoft.com/exchange/autodiscover/outlook/requestschema/2006"));
            writer.Write("<Request>");
            writer.Write(NString.Format("<EMailAddress>{0}</EMailAddress>", emailAddress));
            writer.Write(NString.Format("<AcceptableResponseSchema>{0}</AcceptableResponseSchema>", settings.GetNamespace()));
            writer.Write("</Request>");
            writer.Write("</Autodiscover>");
        };
        AutodiscoverService.prototype.GetRedirectUrl = function (domainName) {
            var _this = this;
            var text = NString.Format("http://{0}/autodiscover/autodiscover.xml", "autodiscover." + domainName);
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Trying to get Autodiscover redirection URL from {0}.", text));
            var ewsHttpWebRequest = this.HttpWebRequestFactory.CreateRequest(new Uri(text));
            ewsHttpWebRequest.Method = "GET";
            ewsHttpWebRequest.AllowAutoRedirect = false;
            ewsHttpWebRequest.PreAuthenticate = false;
            var ewsHttpWebResponse = null;
            try {
                ewsHttpWebResponse = ewsHttpWebRequest.GetResponse();
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Request error: {0}", ex.Message));
                    if (ex.Response !== null) {
                        ewsHttpWebResponse = this.HttpWebRequestFactory.CreateExceptionResponse(ex);
                    }
                }
                else if (ex instanceof IOException) {
                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("I/O error: {0}", ex2.Message));
                }
                else
                    throw ex;
            }
            if (ewsHttpWebResponse !== null) {
                var ewsHttpWebResponse2 = ewsHttpWebResponse;
                try {
                    var result;
                    if ((function () {
                        var _p0 = [
                            result
                        ];
                        var _r = _this.TryGetRedirectionResponse(ewsHttpWebResponse, _p0);
                        result = _p0[0];
                        return _r;
                    })()) {
                        return result;
                    }
                }
                finally {
                    if (ewsHttpWebResponse2 !== null) {
                        ewsHttpWebResponse2.Dispose();
                    }
                }
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, "No Autodiscover redirection URL was returned.");
            return null;
        };
        AutodiscoverService.prototype.TryGetRedirectionResponse = function (response, redirectUrl) {
            redirectUrl[0] = null;
            if (AutodiscoverRequest.IsRedirectionResponse(response)) {
                var text = response.Headers.get_Item(HttpResponseHeader.Location);
                if (!NString.IsNullOrEmpty(text)) {
                    try {
                        redirectUrl[0] = new Uri(response.ResponseUri, text);
                        var match = AutodiscoverService.LegacyPathRegex.Match(redirectUrl[0].AbsolutePath);
                        if (redirectUrl[0].Scheme === Uri.UriSchemeHttps && match.Success) {
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Redirection URL found: '{0}'", redirectUrl[0]));
                            var result = true;
                            return result;
                        }
                    }
                    catch (ex_7A) {
                        if (ex_7A instanceof UriFormatException) {
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Invalid redirection URL was returned: '{0}'", text));
                            var result = false;
                            return result;
                        }
                        else
                            throw ex_7A;
                    }
                    return false;
                }
            }
            return false;
        };
        AutodiscoverService.prototype.GetLegacyUserSettings = function (emailAddress) {
            var _this = this;
            if (Uri.op_Inequality(this.Url, null)) {
                var match = AutodiscoverService.LegacyPathRegex.Match(this.Url.AbsolutePath);
                if (match.Success) {
                    return this.GetLegacyUserSettingsAtUrl(emailAddress, this.Url);
                }
                var uri = new Uri(this.Url, "/autodiscover/autodiscover.xml");
                return this.GetLegacyUserSettingsAtUrl(emailAddress, uri);
            }
            else {
                if (!NString.IsNullOrEmpty(this.Domain)) {
                    var uri2 = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.xml", this.Domain));
                    return this.GetLegacyUserSettingsAtUrl(emailAddress, uri2);
                }
                var num = 1;
                var redirectionEmailAddresses = new List();
                return (function () {
                    var _p0 = [
                        num
                    ];
                    var _r = _this.InternalGetLegacyUserSettings(emailAddress, redirectionEmailAddresses, _p0);
                    num = _p0[0];
                    return _r;
                })();
            }
        };
        AutodiscoverService.prototype.InternalGetLegacyUserSettings = function (emailAddress, redirectionEmailAddressesOrRequestedSettings, currentHop) {
            if (arguments.length === 3 && (emailAddress === null || emailAddress.constructor === String) && (redirectionEmailAddressesOrRequestedSettings === null || redirectionEmailAddressesOrRequestedSettings instanceof List) && (currentHop[0] === null || currentHop[0] instanceof Array)) {
                return this.InternalGetLegacyUserSettings_0(emailAddress, redirectionEmailAddressesOrRequestedSettings, currentHop[0]);
            }
            return this.InternalGetLegacyUserSettings_1(emailAddress, redirectionEmailAddressesOrRequestedSettings);
        };
        AutodiscoverService.prototype.InternalGetLegacyUserSettings_0 = function (emailAddress, redirectionEmailAddresses, currentHop) {
            var _this = this;
            var domainName = EwsUtilities.DomainFromEmailAddress(emailAddress);
            var num;
            var autodiscoverServiceUrls = (function () {
                var _p0 = [
                    num
                ];
                var _r = _this.GetAutodiscoverServiceUrls(domainName, _p0);
                num = _p0[0];
                return _r;
            })();
            if (autodiscoverServiceUrls.Count === 0) {
                throw new ServiceValidationException(Strings.AutodiscoverServiceRequestRequiresDomainOrUrl);
            }
            this.isExternal = new Nullable(true);
            var num2 = 0;
            var ex = null;
            var tSettings = null;
            do {
                var uri = autodiscoverServiceUrls.get_Item(num2);
                var flag = num2 < num;
                try {
                    tSettings = this.GetLegacyUserSettingsAtUrl(emailAddress, uri);
                    switch (tSettings.ResponseType) {
                        case AutodiscoverResponseType.Error:
                            if (!flag) {
                                throw new AutodiscoverRemoteException(Strings.AutodiscoverError, tSettings.Error);
                            }
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, "Error returned by Autodiscover service found via SCP, treating as inconclusive.");
                            ex = new AutodiscoverRemoteException(Strings.AutodiscoverError, tSettings.Error);
                            num2 = num2 + 1;
                            break;
                        case AutodiscoverResponseType.RedirectUrl:
                            if (currentHop[0] >= 10) {
                                throw new AutodiscoverLocalException(Strings.MaximumRedirectionHopsExceeded);
                            }
                            currentHop[0] = currentHop[0] + 1;
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service returned redirection URL '{0}'.", tSettings.RedirectTarget));
                            autodiscoverServiceUrls.set_Item(num2, new Uri(tSettings.RedirectTarget));
                            break;
                        case AutodiscoverResponseType.RedirectAddress:
                            if (currentHop[0] < 10) {
                                currentHop[0] = currentHop[0] + 1;
                                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service returned redirection email address '{0}'.", tSettings.RedirectTarget));
                                this.DisableScpLookupIfDuplicateRedirection(tSettings.RedirectTarget, redirectionEmailAddresses);
                                var result = (function () {
                                    var _p0 = [
                                        currentHop[0]
                                    ];
                                    var _r = _this.InternalGetLegacyUserSettings(tSettings.RedirectTarget, redirectionEmailAddresses, _p0);
                                    currentHop[0] = _p0[0];
                                    return _r;
                                })();
                                return result;
                            }
                            throw new AutodiscoverLocalException(Strings.MaximumRedirectionHopsExceeded);
                        case AutodiscoverResponseType.Success:
                            {
                                if (flag) {
                                    this.IsExternal = new Nullable(false);
                                }
                                this.Url = uri;
                                var result = tSettings;
                                return result;
                            }
                        default:
                            EwsUtilities.Assert(false, "Autodiscover.GetConfigurationSettings", "An unexpected error has occured. This code path should never be reached.");
                            break;
                    }
                }
                catch (ex2) {
                    if (ex2 instanceof WebException) {
                        if (ex2.Response !== null) {
                            var ewsHttpWebResponse = this.HttpWebRequestFactory.CreateExceptionResponse(ex2);
                            var uri2;
                            if ((function () {
                                var _p0 = [
                                    uri2
                                ];
                                var _r = _this.TryGetRedirectionResponse(ewsHttpWebResponse, _p0);
                                uri2 = _p0[0];
                                return _r;
                            })()) {
                                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Host returned a redirection to url {0}", uri2));
                                currentHop[0] = currentHop[0] + 1;
                                autodiscoverServiceUrls.set_Item(num2, uri2);
                            }
                            else {
                                this.ProcessHttpErrorResponse(ewsHttpWebResponse, ex2);
                                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: {1} ({2})", this.url, ex2.GetType().Name, ex2.Message));
                                num2 = num2 + 1;
                            }
                        }
                        else {
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: {1} ({2})", this.url, ex2.GetType().Name, ex2.Message));
                            num2 = num2 + 1;
                        }
                    }
                    else if (ex2 instanceof XmlException) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: XML parsing error: {1}", this.url, ex3.Message));
                        num2 = num2 + 1;
                    }
                    else if (ex2 instanceof IOException) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: I/O error: {1}", this.url, ex4.Message));
                        num2 = num2 + 1;
                    }
                    else
                        throw ex2;
                }
            } while (num2 < autodiscoverServiceUrls.Count);
            var uri3 = this.GetRedirectUrl(domainName);
            if (Uri.op_Inequality(uri3, null) && (function () {
                var _p0 = [
                    tSettings
                ];
                var _r = _this.TryLastChanceHostRedirection(emailAddress, uri3, _p0);
                tSettings = _p0[0];
                return _r;
            })()) {
                return tSettings;
            }
            uri3 = this.GetRedirectionUrlFromDnsSrvRecord(domainName);
            if (Uri.op_Inequality(uri3, null) && (function () {
                var _p0 = [
                    tSettings
                ];
                var _r = _this.TryLastChanceHostRedirection(emailAddress, uri3, _p0);
                tSettings = _p0[0];
                return _r;
            })()) {
                return tSettings;
            }
            if (ex !== null) {
                throw ex;
            }
            throw new AutodiscoverLocalException(Strings.AutodiscoverCouldNotBeLocated);
        };
        AutodiscoverService.prototype.GetRedirectionUrlFromDnsSrvRecord = function (domainName) {
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Trying to get Autodiscover host from DNS SRV record for {0}.", domainName));
            var text = this.dnsClient.FindAutodiscoverHostFromSrv(domainName);
            if (!NString.IsNullOrEmpty(text)) {
                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Autodiscover host {0} was returned.", text));
                return new Uri(NString.Format("https://{0}/autodiscover/autodiscover.xml", text));
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, "No matching Autodiscover DNS SRV records were found.");
            return null;
        };
        AutodiscoverService.prototype.TryLastChanceHostRedirection = function (emailAddress, redirectionUrl, settings) {
            var _this = this;
            settings[0] = null;
            var redirectionEmailAddresses = new List();
            if (this.CallRedirectionUrlValidationCallback(redirectionUrl.ToString())) {
                for (var i = 0; i < 10; i = i + 1) {
                    var IL_1DE = 1;
                    var _goto = 0;
                    _GOTO_LOOP: while (true) {
                        switch (_goto) {
                            default:
                                try {
                                    settings[0] = this.GetLegacyUserSettingsAtUrl(emailAddress, redirectionUrl);
                                    var result;
                                    switch (settings[0].ResponseType) {
                                        case AutodiscoverResponseType.Error:
                                            throw new AutodiscoverRemoteException(Strings.AutodiscoverError, settings[0].Error);
                                        case AutodiscoverResponseType.RedirectUrl:
                                            try {
                                                redirectionUrl = new Uri(settings[0].RedirectTarget);
                                                _goto = IL_1DE;
                                                continue _GOTO_LOOP;
                                            }
                                            catch (ex_C1) {
                                                if (ex_C1 instanceof UriFormatException) {
                                                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Service returned invalid redirection URL {0}", settings[0].RedirectTarget));
                                                    result = false;
                                                    return result;
                                                }
                                                else
                                                    throw ex_C1;
                                            }
                                            break;
                                            _goto = IL_1DE;
                                            continue _GOTO_LOOP;
                                        case AutodiscoverResponseType.RedirectAddress:
                                            this.DisableScpLookupIfDuplicateRedirection(settings[0].RedirectTarget, redirectionEmailAddresses);
                                            settings[0] = (function () {
                                                var _p0 = [
                                                    i
                                                ];
                                                var _r = _this.InternalGetLegacyUserSettings(emailAddress, redirectionEmailAddresses, _p0);
                                                i = _p0[0];
                                                return _r;
                                            })();
                                            result = true;
                                            return result;
                                        case AutodiscoverResponseType.Success:
                                            result = true;
                                            return result;
                                    }
                                    var logEntry = NString.Format("Autodiscover call at {0} failed with error {1}, target {2}", redirectionUrl, settings[0].ResponseType, settings[0].RedirectTarget);
                                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, logEntry);
                                    result = false;
                                    return result;
                                }
                                catch (ex) {
                                    if (ex instanceof WebException) {
                                        if (ex.Response !== null) {
                                            var ewsHttpWebResponse = this.HttpWebRequestFactory.CreateExceptionResponse(ex);
                                            if ((function () {
                                                var _p0 = [
                                                    redirectionUrl
                                                ];
                                                var _r = _this.TryGetRedirectionResponse(ewsHttpWebResponse, _p0);
                                                redirectionUrl = _p0[0];
                                                return _r;
                                            })()) {
                                                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Host returned a redirection to url {0}", redirectionUrl));
                                                _goto = IL_1DE;
                                                continue _GOTO_LOOP;
                                            }
                                            this.ProcessHttpErrorResponse(ewsHttpWebResponse, ex);
                                        }
                                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: {1} ({2})", this.url, ex.GetType().Name, ex.Message));
                                        var result = false;
                                        return result;
                                    }
                                    else if (ex instanceof XmlException) {
                                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: XML parsing error: {1}", redirectionUrl, ex2.Message));
                                        var result = false;
                                        return result;
                                    }
                                    else if (ex instanceof IOException) {
                                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("{0} failed: I/O error: {1}", redirectionUrl, ex3.Message));
                                        var result = false;
                                        return result;
                                    }
                                    else
                                        throw ex;
                                }
                                _goto = IL_1DE;
                                continue _GOTO_LOOP;
                            case 1:
                                break _GOTO_LOOP;
                        }
                    }
                }
            }
            return false;
        };
        AutodiscoverService.prototype.DisableScpLookupIfDuplicateRedirection = function (emailAddress, redirectionEmailAddresses) {
            emailAddress = NString.ToLowerInvariant(emailAddress);
            if (redirectionEmailAddresses.Contains(emailAddress)) {
                this.EnableScpLookup = false;
                return;
            }
            redirectionEmailAddresses.Add(emailAddress);
        };
        AutodiscoverService.prototype.InternalGetLegacyUserSettings_1 = function (emailAddress, requestedSettings) {
            if (this.Credentials !== null && this.Credentials instanceof WSSecurityBasedCredentials) {
                throw new AutodiscoverLocalException(Strings.WLIDCredentialsCannotBeUsedWithLegacyAutodiscover);
            }
            var legacyUserSettings = this.GetLegacyUserSettings(emailAddress);
            return legacyUserSettings.ConvertSettings(emailAddress, requestedSettings);
        };
        AutodiscoverService.prototype.InternalGetSoapUserSettings = function (smtpAddress, requestedSettings) {
            var list = new List();
            list.Add(smtpAddress);
            var list2 = new List();
            list2.Add(NString.ToLowerInvariant(smtpAddress));
            for (var i = 0; i < 10; i = i + 1) {
                var getUserSettingsResponse = this.GetUserSettings(list, requestedSettings).get_Item(0);
                switch (getUserSettingsResponse.ErrorCode) {
                    case AutodiscoverErrorCode.NoError:
                        return getUserSettingsResponse;
                    case AutodiscoverErrorCode.RedirectAddress:
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service returned redirection email address '{0}'.", getUserSettingsResponse.RedirectTarget));
                        list.Clear();
                        list.Add(NString.ToLowerInvariant(getUserSettingsResponse.RedirectTarget));
                        this.Url = null;
                        this.Domain = null;
                        this.DisableScpLookupIfDuplicateRedirection(getUserSettingsResponse.RedirectTarget, list2);
                        break;
                    case AutodiscoverErrorCode.RedirectUrl:
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, NString.Format("Autodiscover service returned redirection URL '{0}'.", getUserSettingsResponse.RedirectTarget));
                        this.Url = this.Credentials.AdjustUrl(new Uri(getUserSettingsResponse.RedirectTarget));
                        break;
                    default:
                        return getUserSettingsResponse;
                }
            }
            throw new AutodiscoverLocalException(Strings.AutodiscoverCouldNotBeLocated);
        };
        AutodiscoverService.prototype.GetUserSettings = function (smtpAddressesOrUserSmtpAddress, settingsOrUserSettingNames) {
            if (arguments.length === 2 && (smtpAddressesOrUserSmtpAddress === null || smtpAddressesOrUserSmtpAddress instanceof List) && (settingsOrUserSettingNames === null || settingsOrUserSettingNames instanceof List)) {
                return this.GetUserSettings_0(smtpAddressesOrUserSmtpAddress, settingsOrUserSettingNames);
            }
            return this.GetUserSettings_1(smtpAddressesOrUserSmtpAddress, settingsOrUserSettingNames);
        };
        AutodiscoverService.prototype.GetUserSettings_0 = function (smtpAddresses, settings) {
            EwsUtilities.ValidateParam(smtpAddresses, "smtpAddresses");
            EwsUtilities.ValidateParam(settings, "settings");
            return this.GetSettings(smtpAddresses, settings, null, this.InternalGetUserSettings, function () { return EwsUtilities.DomainFromEmailAddress(smtpAddresses.get_Item(0)); });
        };
        AutodiscoverService.prototype.GetSettings = function (identities, settings, requestedVersion, getSettingsMethod, getDomainMethod) {
            var _this = this;
            if (this.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                throw new ServiceVersionException(NString.Format(Strings.AutodiscoverServiceIncompatibleWithRequestVersion, ExchangeVersion.Exchange2010));
            }
            if (Uri.op_Inequality(this.Url, null)) {
                var uri = this.Url;
                var result = (function () {
                    var _p0 = [
                        uri
                    ];
                    var _r = getSettingsMethod(identities, settings, requestedVersion, _p0);
                    uri = _p0[0];
                    return _r;
                })();
                this.Url = uri;
                return result;
            }
            if (!NString.IsNullOrEmpty(this.Domain)) {
                var autodiscoverEndpointUrl = this.GetAutodiscoverEndpointUrl(this.Domain);
                var result = (function () {
                    var _p0 = [
                        autodiscoverEndpointUrl
                    ];
                    var _r = getSettingsMethod(identities, settings, requestedVersion, _p0);
                    autodiscoverEndpointUrl = _p0[0];
                    return _r;
                })();
                this.Url = autodiscoverEndpointUrl;
                return result;
            }
            this.IsExternal = new Nullable(true);
            var domainName = getDomainMethod();
            var num;
            var autodiscoverServiceHosts = (function () {
                var _p0 = [
                    num
                ];
                var _r = _this.GetAutodiscoverServiceHosts(domainName, _p0);
                num = _p0[0];
                return _r;
            })();
            if (autodiscoverServiceHosts.Count === 0) {
                throw new ServiceValidationException(Strings.AutodiscoverServiceRequestRequiresDomainOrUrl);
            }
            var uri2;
            for (var i = 0; i < autodiscoverServiceHosts.Count; i = i + 1) {
                var host = autodiscoverServiceHosts.get_Item(i);
                var flag = i < num;
                if ((function () {
                    var _p0 = [
                        uri2
                    ];
                    var _r = _this.TryGetAutodiscoverEndpointUrl(host, _p0);
                    uri2 = _p0[0];
                    return _r;
                })()) {
                    try {
                        var result = (function () {
                            var _p0 = [
                                uri2
                            ];
                            var _r = getSettingsMethod(identities, settings, requestedVersion, _p0);
                            uri2 = _p0[0];
                            return _r;
                        })();
                        this.Url = uri2;
                        if (flag) {
                            this.IsExternal = new Nullable(false);
                        }
                        return result;
                    }
                    catch (ex_109) {
                        if (ex_109 instanceof AutodiscoverResponseException) {
                        }
                        else if (ex_109 instanceof ServiceRequestException) {
                        }
                        else
                            throw ex_109;
                    }
                }
            }
            uri2 = this.GetRedirectUrl(domainName);
            if (Uri.op_Inequality(uri2, null) && this.CallRedirectionUrlValidationCallback(uri2.ToString()) && (function () {
                var _p0 = [
                    uri2
                ];
                var _r = _this.TryGetAutodiscoverEndpointUrl(uri2.Host, _p0);
                uri2 = _p0[0];
                return _r;
            })()) {
                var result = (function () {
                    var _p0 = [
                        uri2
                    ];
                    var _r = getSettingsMethod(identities, settings, requestedVersion, _p0);
                    uri2 = _p0[0];
                    return _r;
                })();
                this.Url = uri2;
                return result;
            }
            uri2 = this.GetRedirectionUrlFromDnsSrvRecord(domainName);
            if (Uri.op_Inequality(uri2, null) && this.CallRedirectionUrlValidationCallback(uri2.ToString()) && (function () {
                var _p0 = [
                    uri2
                ];
                var _r = _this.TryGetAutodiscoverEndpointUrl(uri2.Host, _p0);
                uri2 = _p0[0];
                return _r;
            })()) {
                var result = (function () {
                    var _p0 = [
                        uri2
                    ];
                    var _r = getSettingsMethod(identities, settings, requestedVersion, _p0);
                    uri2 = _p0[0];
                    return _r;
                })();
                this.Url = uri2;
                return result;
            }
            throw new AutodiscoverLocalException(Strings.AutodiscoverCouldNotBeLocated);
        };
        AutodiscoverService.prototype.InternalGetUserSettings = function (smtpAddresses, settings, requestedVersion, autodiscoverUrl) {
            for (var i = 0; i < 10; i = i + 1) {
                var getUserSettingsRequest = new GetUserSettingsRequest(this, autodiscoverUrl[0]);
                getUserSettingsRequest.SmtpAddresses = smtpAddresses;
                getUserSettingsRequest.Settings = settings;
                var getUserSettingsResponseCollection = getUserSettingsRequest.Execute();
                if (getUserSettingsResponseCollection.ErrorCode !== AutodiscoverErrorCode.RedirectUrl || !Uri.op_Inequality(getUserSettingsResponseCollection.RedirectionUrl, null)) {
                    return getUserSettingsResponseCollection;
                }
                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Request to {0} returned redirection to {1}", autodiscoverUrl[0].ToString(), getUserSettingsResponseCollection.RedirectionUrl));
                autodiscoverUrl[0] = getUserSettingsResponseCollection.RedirectionUrl;
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Maximum number of redirection hops {0} exceeded", 10));
            throw new AutodiscoverLocalException(Strings.MaximumRedirectionHopsExceeded);
        };
        AutodiscoverService.prototype.GetDomainSettings = function (domainsOrDomain, settingsOrRequestedVersion, requestedVersionOrDomainSettingNames) {
            if (arguments.length === 3 && (domainsOrDomain === null || domainsOrDomain instanceof List) && (settingsOrRequestedVersion === null || settingsOrRequestedVersion instanceof List) && (requestedVersionOrDomainSettingNames === null || requestedVersionOrDomainSettingNames instanceof Array)) {
                return this.GetDomainSettings_0(domainsOrDomain, settingsOrRequestedVersion, requestedVersionOrDomainSettingNames);
            }
            if (arguments.length === 3 && (domainsOrDomain === null || domainsOrDomain.constructor === String) && (settingsOrRequestedVersion === null || settingsOrRequestedVersion instanceof Array) && (requestedVersionOrDomainSettingNames === null || requestedVersionOrDomainSettingNames instanceof Array)) {
                return this.GetDomainSettings_1(domainsOrDomain, settingsOrRequestedVersion, requestedVersionOrDomainSettingNames);
            }
            return this.GetDomainSettings_2(domainsOrDomain, settingsOrRequestedVersion, requestedVersionOrDomainSettingNames);
        };
        AutodiscoverService.prototype.GetDomainSettings_0 = function (domains, settings, requestedVersion) {
            EwsUtilities.ValidateParam(domains, "domains");
            EwsUtilities.ValidateParam(settings, "settings");
            return this.GetSettings(domains, settings, requestedVersion, this.InternalGetDomainSettings, function () { return domains.get_Item(0); });
        };
        AutodiscoverService.prototype.InternalGetDomainSettings = function (domains, settings, requestedVersion, autodiscoverUrl) {
            for (var i = 0; i < 10; i = i + 1) {
                var getDomainSettingsRequest = new GetDomainSettingsRequest(this, autodiscoverUrl[0]);
                getDomainSettingsRequest.Domains = domains;
                getDomainSettingsRequest.Settings = settings;
                getDomainSettingsRequest.RequestedVersion = requestedVersion;
                var getDomainSettingsResponseCollection = getDomainSettingsRequest.Execute();
                if (getDomainSettingsResponseCollection.ErrorCode !== AutodiscoverErrorCode.RedirectUrl || !Uri.op_Inequality(getDomainSettingsResponseCollection.RedirectionUrl, null)) {
                    return getDomainSettingsResponseCollection;
                }
                autodiscoverUrl[0] = getDomainSettingsResponseCollection.RedirectionUrl;
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Maximum number of redirection hops {0} exceeded", 10));
            throw new AutodiscoverLocalException(Strings.MaximumRedirectionHopsExceeded);
        };
        AutodiscoverService.prototype.GetAutodiscoverEndpointUrl = function (host) {
            var _this = this;
            var result;
            if ((function () {
                var _p0 = [
                    result
                ];
                var _r = _this.TryGetAutodiscoverEndpointUrl(host, _p0);
                result = _p0[0];
                return _r;
            })()) {
                return result;
            }
            throw new AutodiscoverLocalException(Strings.NoSoapOrWsSecurityEndpointAvailable);
        };
        AutodiscoverService.prototype.TryGetAutodiscoverEndpointUrl = function (host, url) {
            var _this = this;
            url[0] = null;
            var autodiscoverEndpoints;
            if (!(function () {
                var _p0 = [
                    host
                ];
                var _p1 = [
                    autodiscoverEndpoints
                ];
                var _r = _this.TryGetEnabledEndpointsForHost(_p0, _p1);
                host = _p0[0];
                autodiscoverEndpoints = _p1[0];
                return _r;
            })()) {
                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No Autodiscover endpoints are available for host {0}", host));
                return false;
            }
            url[0] = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.svc", host));
            if ((autodiscoverEndpoints & AutodiscoverEndpoints.Soap) !== AutodiscoverEndpoints.Soap && (autodiscoverEndpoints & AutodiscoverEndpoints.WsSecurity) !== AutodiscoverEndpoints.WsSecurity && (autodiscoverEndpoints & AutodiscoverEndpoints.WSSecuritySymmetricKey) !== AutodiscoverEndpoints.WSSecuritySymmetricKey && (autodiscoverEndpoints & AutodiscoverEndpoints.WSSecurityX509Cert) !== AutodiscoverEndpoints.WSSecurityX509Cert && (autodiscoverEndpoints & AutodiscoverEndpoints.OAuth) !== AutodiscoverEndpoints.OAuth) {
                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No Autodiscover endpoints are available  for host {0}", host));
                return false;
            }
            if (this.Credentials instanceof WindowsLiveCredentials) {
                if ((autodiscoverEndpoints & AutodiscoverEndpoints.WsSecurity) !== AutodiscoverEndpoints.WsSecurity) {
                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No Autodiscover WS-Security endpoint is available for host {0}", host));
                    return false;
                }
                url[0] = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.svc/wssecurity", host));
            }
            else {
                if (this.Credentials instanceof PartnerTokenCredentials) {
                    if ((autodiscoverEndpoints & AutodiscoverEndpoints.WSSecuritySymmetricKey) !== AutodiscoverEndpoints.WSSecuritySymmetricKey) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No Autodiscover WS-Security/SymmetricKey endpoint is available for host {0}", host));
                        return false;
                    }
                    url[0] = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.svc/wssecurity/symmetrickey", host));
                }
                else {
                    if (this.Credentials instanceof X509CertificateCredentials) {
                        if ((autodiscoverEndpoints & AutodiscoverEndpoints.WSSecurityX509Cert) !== AutodiscoverEndpoints.WSSecurityX509Cert) {
                            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("No Autodiscover WS-Security/X509Cert endpoint is available for host {0}", host));
                            return false;
                        }
                        url[0] = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.svc/wssecurity/x509cert", host));
                    }
                    else {
                        if (this.Credentials instanceof OAuthCredentials) {
                            url[0] = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.svc", host));
                        }
                    }
                }
            }
            return true;
        };
        AutodiscoverService.prototype.DefaultGetScpUrlsForDomain = function (domainName) {
            var directoryHelper = new DirectoryHelper(this);
            return directoryHelper.GetAutodiscoverScpUrlsForDomain(domainName);
        };
        AutodiscoverService.prototype.GetAutodiscoverServiceUrls = function (domainName, scpHostCount) {
            var list = new List();
            if (this.enableScpLookup) {
                var func = this.GetScpUrlsForDomainCallback || this.DefaultGetScpUrlsForDomain;
                var collection = func(domainName);
                var enumerator = collection.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        list.Add(new Uri(current));
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
            scpHostCount[0] = list.Count;
            list.Add(new Uri(NString.Format("https://{0}/autodiscover/autodiscover.xml", domainName)));
            list.Add(new Uri(NString.Format("https://{0}/autodiscover/autodiscover.xml", "autodiscover." + domainName)));
            return list;
        };
        AutodiscoverService.prototype.GetAutodiscoverServiceHosts = function (domainName, scpHostCount) {
            var _this = this;
            var list = new List();
            var enumerator = (function () {
                var _p0 = [
                    scpHostCount[0]
                ];
                var _r = _this.GetAutodiscoverServiceUrls(domainName, _p0);
                scpHostCount[0] = _p0[0];
                return _r;
            })().GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    list.Add(current.Host);
                }
            }
            finally {
                enumerator.Dispose();
            }
            return list;
        };
        AutodiscoverService.prototype.TryGetEnabledEndpointsForHost = function (host, endpoints) {
            var _this = this;
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Determining which endpoints are enabled for host {0}", host[0]));
            var i = 0;
            while (i < 10) {
                var uri = new Uri(NString.Format("https://{0}/autodiscover/autodiscover.xml", host[0]));
                endpoints[0] = AutodiscoverEndpoints.None;
                var ewsHttpWebRequest = this.HttpWebRequestFactory.CreateRequest(uri);
                ewsHttpWebRequest.Method = "GET";
                ewsHttpWebRequest.AllowAutoRedirect = false;
                ewsHttpWebRequest.PreAuthenticate = false;
                ewsHttpWebRequest.UseDefaultCredentials = false;
                var ewsHttpWebResponse = null;
                try {
                    ewsHttpWebResponse = ewsHttpWebRequest.GetResponse();
                }
                catch (ex) {
                    if (ex instanceof WebException) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Request error: {0}", ex.Message));
                        if (ex.Response !== null) {
                            ewsHttpWebResponse = this.HttpWebRequestFactory.CreateExceptionResponse(ex);
                        }
                    }
                    else if (ex instanceof IOException) {
                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("I/O error: {0}", ex2.Message));
                    }
                    else
                        throw ex;
                }
                if (ewsHttpWebResponse !== null) {
                    var IL_12A = 1;
                    var _goto = 0;
                    _GOTO_LOOP: while (true) {
                        switch (_goto) {
                            default:
                                var ewsHttpWebResponse2 = ewsHttpWebResponse;
                                try {
                                    var uri2;
                                    if ((function () {
                                        var _p0 = [
                                            uri2
                                        ];
                                        var _r = _this.TryGetRedirectionResponse(ewsHttpWebResponse, _p0);
                                        uri2 = _p0[0];
                                        return _r;
                                    })()) {
                                        _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Host returned redirection to host '{0}'", uri2.Host));
                                        host[0] = uri2.Host;
                                        _goto = IL_12A;
                                        continue _GOTO_LOOP;
                                    }
                                    endpoints[0] = this.GetEndpointsFromHttpWebResponse(ewsHttpWebResponse);
                                    _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Host returned enabled endpoint flags: {0}", endpoints[0]));
                                    return true;
                                }
                                finally {
                                    if (ewsHttpWebResponse2 !== null) {
                                        ewsHttpWebResponse2.Dispose();
                                    }
                                }
                                return false;
                            case 1:
                                i = i + 1;
                                continue;
                                break _GOTO_LOOP;
                        }
                    }
                }
                return false;
            }
            _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverConfiguration, NString.Format("Maximum number of redirection hops {0} exceeded", 10));
            throw new AutodiscoverLocalException(Strings.MaximumRedirectionHopsExceeded);
        };
        AutodiscoverService.prototype.GetEndpointsFromHttpWebResponse = function (response) {
            var autodiscoverEndpoints = AutodiscoverEndpoints.Legacy;
            if (!NString.IsNullOrEmpty(response.Headers.get_Item("X-SOAP-Enabled"))) {
                autodiscoverEndpoints = (autodiscoverEndpoints | AutodiscoverEndpoints.Soap);
            }
            if (!NString.IsNullOrEmpty(response.Headers.get_Item("X-WSSecurity-Enabled"))) {
                autodiscoverEndpoints = (autodiscoverEndpoints | AutodiscoverEndpoints.WsSecurity);
            }
            if (!NString.IsNullOrEmpty(response.Headers.get_Item("X-WSSecurity-SymmetricKey-Enabled"))) {
                autodiscoverEndpoints = (autodiscoverEndpoints | AutodiscoverEndpoints.WSSecuritySymmetricKey);
            }
            if (!NString.IsNullOrEmpty(response.Headers.get_Item("X-WSSecurity-X509Cert-Enabled"))) {
                autodiscoverEndpoints = (autodiscoverEndpoints | AutodiscoverEndpoints.WSSecurityX509Cert);
            }
            if (!NString.IsNullOrEmpty(response.Headers.get_Item("X-OAuth-Enabled"))) {
                autodiscoverEndpoints = (autodiscoverEndpoints | AutodiscoverEndpoints.OAuth);
            }
            return autodiscoverEndpoints;
        };
        AutodiscoverService.prototype.TraceResponse = function (response, memoryStream) {
            _super.prototype.ProcessHttpResponseHeaders.call(this, TraceFlags.AutodiscoverResponseHttpHeaders, response);
            if (this.TraceEnabled) {
                if (!NString.IsNullOrEmpty(response.ContentType) && (NString.StartsWith(response.ContentType, "text/", StringComparison.OrdinalIgnoreCase) || NString.StartsWith(response.ContentType, "application/soap", StringComparison.OrdinalIgnoreCase))) {
                    _super.prototype.TraceXml.call(this, TraceFlags.AutodiscoverResponse, memoryStream);
                    return;
                }
                _super.prototype.TraceMessage.call(this, TraceFlags.AutodiscoverResponse, "Non-textual response");
            }
        };
        AutodiscoverService.prototype.PrepareHttpWebRequestForUrl = function (url) {
            return _super.prototype.PrepareHttpWebRequestForUrl.call(this, url, false, false);
        };
        AutodiscoverService.prototype.CallRedirectionUrlValidationCallback = function (redirectionUrl) {
            var autodiscoverRedirectionUrlValidationCallback = (this.RedirectionUrlValidationCallback === null) ? this.DefaultAutodiscoverRedirectionUrlValidationCallback : this.RedirectionUrlValidationCallback;
            return autodiscoverRedirectionUrlValidationCallback(redirectionUrl);
        };
        AutodiscoverService.prototype.ProcessHttpErrorResponse = function (httpWebResponse, webException) {
            _super.prototype.InternalProcessHttpErrorResponse.call(this, httpWebResponse, webException, TraceFlags.AutodiscoverResponseHttpHeaders, TraceFlags.AutodiscoverResponse);
        };
        AutodiscoverService.prototype.constructor_0 = function () {
            this.constructor_1(ExchangeVersion.Exchange2010);
        };
        AutodiscoverService.prototype.constructor_1 = function (requestedServerVersion) {
            this.constructor_7(null, null, requestedServerVersion);
        };
        AutodiscoverService.prototype.constructor_2 = function (domain) {
            this.constructor_6(null, domain);
        };
        AutodiscoverService.prototype.constructor_3 = function (domain, requestedServerVersion) {
            this.constructor_7(null, domain, requestedServerVersion);
        };
        AutodiscoverService.prototype.constructor_4 = function (url) {
            this.constructor_6(url, url.Host);
        };
        AutodiscoverService.prototype.constructor_5 = function (url, requestedServerVersion) {
            this.constructor_7(url, url.Host, requestedServerVersion);
        };
        AutodiscoverService.prototype.constructor_6 = function (url, domain) {
            this.isExternal = new Nullable(true);
            this.enableScpLookup = true;
            _super.prototype..ctor();
            EwsUtilities.ValidateDomainNameAllowNull(domain, "domain");
            this.url = url;
            this.domain = domain;
            this.dnsClient = new AutodiscoverDnsClient(this);
        };
        AutodiscoverService.prototype.constructor_7 = function (url, domain, requestedServerVersion) {
            this.isExternal = new Nullable(true);
            this.enableScpLookup = true;
            _super.prototype..ctor(requestedServerVersion);
            EwsUtilities.ValidateDomainNameAllowNull(domain, "domain");
            this.url = url;
            this.domain = domain;
            this.dnsClient = new AutodiscoverDnsClient(this);
        };
        AutodiscoverService.prototype.constructor_8 = function (service, requestedServerVersion) {
            this.isExternal = new Nullable(true);
            this.enableScpLookup = true;
            _super.prototype..ctor(service, requestedServerVersion);
            this.dnsClient = new AutodiscoverDnsClient(this);
        };
        AutodiscoverService.prototype.constructor_9 = function (service) {
            this.constructor_8(service, service.RequestedServerVersion);
        };
        AutodiscoverService.prototype.GetUserSettings_1 = function (userSmtpAddress, userSettingNames) {
            var list = new List(userSettingNames);
            if (NString.IsNullOrEmpty(userSmtpAddress)) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverSmtpAddress);
            }
            if (list.Count === 0) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverSettingsCount);
            }
            if (this.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                return this.InternalGetLegacyUserSettings(userSmtpAddress, list);
            }
            return this.InternalGetSoapUserSettings(userSmtpAddress, list);
        };
        AutodiscoverService.prototype.GetUsersSettings = function (userSmtpAddresses, userSettingNames) {
            if (this.RequestedServerVersion < ExchangeVersion.Exchange2010) {
                throw new ServiceVersionException(NString.Format(Strings.AutodiscoverServiceIncompatibleWithRequestVersion, ExchangeVersion.Exchange2010));
            }
            var smtpAddresses = new List(userSmtpAddresses);
            var settings = new List(userSettingNames);
            return this.GetUserSettings(smtpAddresses, settings);
        };
        AutodiscoverService.prototype.GetDomainSettings_1 = function (domain, requestedVersion, domainSettingNames) {
            var list = new List(1);
            list.Add(domain);
            var settings = new List(domainSettingNames);
            return this.GetDomainSettings(list, settings, requestedVersion).get_Item(0);
        };
        AutodiscoverService.prototype.GetDomainSettings_2 = function (domains, requestedVersion, domainSettingNames) {
            var settings = new List(domainSettingNames);
            return this.GetDomainSettings(new List(domains), settings, requestedVersion);
        };
        AutodiscoverService.prototype.TryGetPartnerAccess = function (targetTenantDomain, partnerAccessCredentials, targetTenantAutodiscoverUrl) {
            EwsUtilities.ValidateNonBlankStringParam(targetTenantDomain, "targetTenantDomain");
            if (Uri.op_Equality(this.Url, null)) {
                throw new ServiceValidationException(Strings.PartnerTokenRequestRequiresUrl);
            }
            if (this.RequestedServerVersion < ExchangeVersion.Exchange2010_SP1) {
                throw new ServiceVersionException(NString.Format(Strings.PartnerTokenIncompatibleWithRequestVersion, ExchangeVersion.Exchange2010_SP1));
            }
            partnerAccessCredentials[0] = null;
            targetTenantAutodiscoverUrl[0] = null;
            var text = targetTenantDomain;
            if (!NString.Contains(text, "@")) {
                text = "SystemMailbox{e0dc1c29-89c3-4034-b678-e6c29d823ed9}@" + targetTenantDomain;
            }
            var getUserSettingsRequest = new GetUserSettingsRequest(this, this.Url, true);
            getUserSettingsRequest.SmtpAddresses = new List([
                text
            ]);
            getUserSettingsRequest.Settings = new List([
                UserSettingName.ExternalEwsUrl
            ]);
            var getUserSettingsResponseCollection = null;
            try {
                getUserSettingsResponseCollection = getUserSettingsRequest.Execute();
            }
            catch (ex_BC) {
                if (ex_BC instanceof ServiceRequestException) {
                    var result = false;
                    return result;
                }
                else if (ex_BC instanceof ServiceRemoteException) {
                    var result = false;
                    return result;
                }
                else
                    throw ex_BC;
            }
            if (NString.IsNullOrEmpty(getUserSettingsRequest.PartnerToken) || NString.IsNullOrEmpty(getUserSettingsRequest.PartnerTokenReference)) {
                return false;
            }
            if (getUserSettingsResponseCollection.ErrorCode === AutodiscoverErrorCode.NoError) {
                var getUserSettingsResponse = getUserSettingsResponseCollection.Responses.get_Item(0);
                if (getUserSettingsResponse.ErrorCode === AutodiscoverErrorCode.NoError) {
                    targetTenantAutodiscoverUrl[0] = this.Url;
                }
                else {
                    if (getUserSettingsResponse.ErrorCode !== AutodiscoverErrorCode.RedirectUrl) {
                        return false;
                    }
                    targetTenantAutodiscoverUrl[0] = new Uri(getUserSettingsResponse.RedirectTarget);
                }
                partnerAccessCredentials[0] = new PartnerTokenCredentials(getUserSettingsRequest.PartnerToken, getUserSettingsRequest.PartnerTokenReference);
                targetTenantAutodiscoverUrl[0] = partnerAccessCredentials[0].AdjustUrl(targetTenantAutodiscoverUrl[0]);
                return true;
            }
            return false;
        };
        AutodiscoverService.AutodiscoverLegacyPath = "/autodiscover/autodiscover.xml";
        AutodiscoverService.AutodiscoverLegacyUrl = "{0}://{1}/autodiscover/autodiscover.xml";
        AutodiscoverService.AutodiscoverLegacyHttpsUrl = "https://{0}/autodiscover/autodiscover.xml";
        AutodiscoverService.AutodiscoverLegacyHttpUrl = "http://{0}/autodiscover/autodiscover.xml";
        AutodiscoverService.AutodiscoverSoapHttpsUrl = "https://{0}/autodiscover/autodiscover.svc";
        AutodiscoverService.AutodiscoverSoapWsSecurityHttpsUrl = "https://{0}/autodiscover/autodiscover.svc/wssecurity";
        AutodiscoverService.AutodiscoverSoapWsSecuritySymmetricKeyHttpsUrl = "https://{0}/autodiscover/autodiscover.svc/wssecurity/symmetrickey";
        AutodiscoverService.AutodiscoverSoapWsSecurityX509CertHttpsUrl = "https://{0}/autodiscover/autodiscover.svc/wssecurity/x509cert";
        AutodiscoverService.AutodiscoverRequestNamespace = "http://schemas.microsoft.com/exchange/autodiscover/outlook/requestschema/2006";
        AutodiscoverService.AutodiscoverMaxRedirections = 10;
        AutodiscoverService.AutodiscoverSoapEnabledHeaderName = "X-SOAP-Enabled";
        AutodiscoverService.AutodiscoverWsSecurityEnabledHeaderName = "X-WSSecurity-Enabled";
        AutodiscoverService.AutodiscoverWsSecuritySymmetricKeyEnabledHeaderName = "X-WSSecurity-SymmetricKey-Enabled";
        AutodiscoverService.AutodiscoverWsSecurityX509CertEnabledHeaderName = "X-WSSecurity-X509Cert-Enabled";
        AutodiscoverService.AutodiscoverOAuthEnabledHeaderName = "X-OAuth-Enabled";
        AutodiscoverService.MinimumRequestVersionForAutoDiscoverSoapService = ExchangeVersion.Exchange2010;
        AutodiscoverService.LegacyPathRegex = new Regex("/autodiscover/([^/]+/)*autodiscover.xml", RegexOptions.IgnoreCase | RegexOptions.Compiled);
        return AutodiscoverService;
    }(ExchangeServiceBase));
    var DirectoryHelper = (function () {
        function DirectoryHelper(service) {
            this.service = null;
            _super.call(this);
            this.service = service;
        }
        Object.defineProperty(DirectoryHelper.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        DirectoryHelper.prototype.GetAutodiscoverScpUrlsForDomain = function (domainName) {
            var _this = this;
            var num = 10;
            var result;
            try {
                result = (function () {
                    var _p0 = [
                        num
                    ];
                    var _r = _this.GetScpUrlList(domainName, null, _p0);
                    num = _p0[0];
                    return _r;
                })();
            }
            catch (ex) {
                if (ex instanceof InvalidOperationException) {
                    this.TraceMessage(NString.Format("LDAP call failed, exception: {0}", ex.ToString()));
                    result = new List();
                }
                else if (ex instanceof NotSupportedException) {
                    this.TraceMessage(NString.Format("LDAP call failed, exception: {0}", ex2.ToString()));
                    result = new List();
                }
                else if (ex instanceof COMException) {
                    this.TraceMessage(NString.Format("LDAP call failed, exception: {0}", ex3.ToString()));
                    result = new List();
                }
                else
                    throw ex;
            }
            return result;
        };
        DirectoryHelper.prototype.GetScpUrlList = function (domainName, ldapPath, maxHops) {
            var _this = this;
            if (maxHops[0] <= 0) {
                throw new ServiceLocalException(Strings.MaxScpHopsExceeded);
            }
            maxHops[0] = maxHops[0] - 1;
            this.TraceMessage(NString.Format("Starting SCP lookup for domainName='{0}', root path='{1}'", domainName, ldapPath));
            var text = null;
            var text2 = null;
            var text3 = null;
            var list = new List();
            var text4 = (ldapPath === null) ? "LDAP://RootDSE" : (ldapPath + "/RootDSE");
            var directoryEntry = new DirectoryEntry(text4);
            try {
                text3 = (((directoryEntry.get_Properties().get_Item("configurationNamingContext").get_Value() instanceof string) ? directoryEntry.get_Properties().get_Item("configurationNamingContext").get_Value() : null));
            }
            finally {
                if (directoryEntry !== null) {
                    directoryEntry.Dispose();
                }
            }
            var searchResultCollection = null;
            try {
                var directoryEntry2 = new DirectoryEntry("LDAP://" + text3);
                try {
                    var directorySearcher = new DirectorySearcher(directoryEntry2);
                    try {
                        directorySearcher.set_Filter("(&(objectClass=serviceConnectionPoint)(|(keywords=67661d7F-8FC4-4fa7-BFAC-E1D7794C1F68)(keywords=77378F46-2C66-4aa9-A6A6-3E7A48B19596)))");
                        directorySearcher.get_PropertiesToLoad().Add("keywords");
                        directorySearcher.get_PropertiesToLoad().Add("serviceBindingInformation");
                        this.TraceMessage(NString.Format("Searching for SCP entries in {0}", directoryEntry2.get_Path()));
                        searchResultCollection = directorySearcher.FindAll();
                    }
                    finally {
                        if (directorySearcher !== null) {
                            directorySearcher.Dispose();
                        }
                    }
                }
                finally {
                    if (directoryEntry2 !== null) {
                        directoryEntry2.Dispose();
                    }
                }
                var text5 = "Domain=" + domainName;
                this.TraceMessage(NString.Format("Scanning for SCP pointers {0}", text5));
                var enumerator = searchResultCollection.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var searchResult = enumerator.Current;
                        var resultPropertyValueCollection = searchResult.get_Properties().get_Item("keywords");
                        if (ComparisonHelpers.CaseInsensitiveContains(resultPropertyValueCollection, "67661d7F-8FC4-4fa7-BFAC-E1D7794C1F68")) {
                            var text6 = ((searchResult.get_Properties().get_Item("serviceBindingInformation").get_Item(0) instanceof string) ? searchResult.get_Properties().get_Item("serviceBindingInformation").get_Item(0) : null);
                            if (ComparisonHelpers.CaseInsensitiveContains(resultPropertyValueCollection, text5)) {
                                this.TraceMessage(NString.Format("SCP pointer for '{0}' is found in '{1}', restarting seach in '{2}'", text5, searchResult.get_Path(), text6));
                                var scpUrlList = (function () {
                                    var _p0 = [
                                        maxHops[0]
                                    ];
                                    var _r = _this.GetScpUrlList(domainName, text6, _p0);
                                    maxHops[0] = _p0[0];
                                    return _r;
                                })();
                                return scpUrlList;
                            }
                            if (resultPropertyValueCollection.Count === 1 && NString.IsNullOrEmpty(text2)) {
                                text2 = text6;
                                this.TraceMessage(NString.Format("Fallback SCP pointer='{0}' for '{1}' is found in '{2}' and saved.", text2, text5, searchResult.get_Path()));
                            }
                        }
                    }
                }
                finally {
                    var disposable = ((enumerator instanceof IDisposable) ? enumerator : null);
                    if (disposable !== null) {
                        disposable.Dispose();
                    }
                }
                this.TraceMessage(NString.Format("No SCP pointers found for '{0}' in configPath='{1}'", text5, text3));
                var siteName = this.GetSiteName();
                if (!NString.IsNullOrEmpty(siteName)) {
                    var text7 = "Site=";
                    var text8 = text7 + siteName;
                    var list2 = new List();
                    this.TraceMessage(NString.Format("Scanning for SCP urls for the current computer {0}", text8));
                    var enumerator2 = searchResultCollection.GetEnumerator();
                    try {
                        while (enumerator2.MoveNext()) {
                            var searchResult2 = enumerator2.Current;
                            var resultPropertyValueCollection2 = searchResult2.get_Properties().get_Item("keywords");
                            if (ComparisonHelpers.CaseInsensitiveContains(resultPropertyValueCollection2, "77378F46-2C66-4aa9-A6A6-3E7A48B19596") && searchResult2.get_Properties().get_Item("serviceBindingInformation").Count > 0) {
                                text = (((searchResult2.get_Properties().get_Item("serviceBindingInformation").get_Item(0) instanceof string) ? searchResult2.get_Properties().get_Item("serviceBindingInformation").get_Item(0) : null));
                                if (ComparisonHelpers.CaseInsensitiveContains(resultPropertyValueCollection2, text8)) {
                                    if (!ComparisonHelpers.CaseInsensitiveContains(list, text)) {
                                        this.TraceMessage(NString.Format("Adding (prio 1) '{0}' for the '{1}' from '{2}' to the top of the list (exact match)", text, text8, searchResult2.get_Path()));
                                        list.Add(text);
                                    }
                                }
                                else {
                                    var flag = false;
                                    var enumerator3 = resultPropertyValueCollection2.GetEnumerator();
                                    try {
                                        while (enumerator3.MoveNext()) {
                                            var text9 = enumerator3.Current;
                                            flag = (flag || NString.StartsWith(text9, text7, StringComparison.OrdinalIgnoreCase));
                                        }
                                    }
                                    finally {
                                        var disposable2 = ((enumerator3 instanceof IDisposable) ? enumerator3 : null);
                                        if (disposable2 !== null) {
                                            disposable2.Dispose();
                                        }
                                    }
                                    if (!ComparisonHelpers.CaseInsensitiveContains(list2, text)) {
                                        if (!flag) {
                                            this.TraceMessage(NString.Format("Adding (prio 2) '{0}' from '{1}' to the middle of the list (wildcard)", text, searchResult2.get_Path()));
                                            list2.Insert(0, text);
                                        }
                                        else {
                                            this.TraceMessage(NString.Format("Adding (prio 3) '{0}' from '{1}' to the end of the list (site mismatch)", text, searchResult2.get_Path()));
                                            list2.Add(text);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    finally {
                        var disposable3 = ((enumerator2 instanceof IDisposable) ? enumerator2 : null);
                        if (disposable3 !== null) {
                            disposable3.Dispose();
                        }
                    }
                    if (list2.Count > 0) {
                        var enumerator4 = list2.GetEnumerator();
                        try {
                            while (enumerator4.MoveNext()) {
                                var current = enumerator4.Current;
                                if (!ComparisonHelpers.CaseInsensitiveContains(list, current)) {
                                    list.Add(current);
                                }
                            }
                        }
                        finally {
                            enumerator4.Dispose();
                        }
                    }
                }
            }
            finally {
                if (searchResultCollection !== null) {
                    searchResultCollection.Dispose();
                }
            }
            if (list.Count === 0 && !NString.IsNullOrEmpty(text2)) {
                this.TraceMessage(NString.Format("Restarting search for domain '{0}' in SCP fallback pointer '{1}'", domainName, text2));
                return (function () {
                    var _p0 = [
                        maxHops[0]
                    ];
                    var _r = _this.GetScpUrlList(domainName, text2, _p0);
                    maxHops[0] = _p0[0];
                    return _r;
                })();
            }
            return list;
        };
        DirectoryHelper.prototype.GetSiteName = function () {
            var result;
            try {
                var computerSite = ActiveDirectorySite.GetComputerSite();
                try {
                    result = computerSite.get_Name();
                }
                finally {
                    if (computerSite !== null) {
                        computerSite.Dispose();
                    }
                }
            }
            catch (ex_19) {
                if (ex_19 instanceof ActiveDirectoryObjectNotFoundException) {
                    result = null;
                }
                else if (ex_19 instanceof ActiveDirectoryOperationException) {
                    result = null;
                }
                else if (ex_19 instanceof ActiveDirectoryServerDownException) {
                    result = null;
                }
                else
                    throw ex_19;
            }
            return result;
        };
        DirectoryHelper.prototype.TraceMessage = function (message) {
            this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, message);
        };
        DirectoryHelper.AutodiscoverMaxScpHops = 10;
        DirectoryHelper.ScpUrlGuidString = "77378F46-2C66-4aa9-A6A6-3E7A48B19596";
        DirectoryHelper.ScpPtrGuidString = "67661d7F-8FC4-4fa7-BFAC-E1D7794C1F68";
        DirectoryHelper.ScpFilterString = "(&(objectClass=serviceConnectionPoint)(|(keywords=67661d7F-8FC4-4fa7-BFAC-E1D7794C1F68)(keywords=77378F46-2C66-4aa9-A6A6-3E7A48B19596)))";
        return DirectoryHelper;
    }());
    var DomainSettingError = (function () {
        function DomainSettingError() {
            this.errorCode = 0;
            this.errorMessage = null;
            this.settingName = null;
            _super.call(this);
        }
        Object.defineProperty(DomainSettingError.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DomainSettingError.prototype, "ErrorMessage", {
            get: function () {
                return this.errorMessage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DomainSettingError.prototype, "SettingName", {
            get: function () {
                return this.settingName;
            },
            enumerable: true,
            configurable: true
        });
        DomainSettingError.prototype.LoadFromXml = function (reader) {
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "ErrorCode")) {
                        if (!(localName === "ErrorMessage")) {
                            if (localName === "SettingName") {
                                this.settingName = reader.ReadElementValue();
                            }
                        }
                        else {
                            this.errorMessage = reader.ReadElementValue();
                        }
                    }
                    else {
                        this.errorCode = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DomainSettingError"));
        };
        return DomainSettingError;
    }());
    var ProtocolConnection = (function () {
        function ProtocolConnection(encryptionMethod, hostname, port) {
            this.encryptionMethod = null;
            this.hostname = null;
            this.port = 0;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(encryptionMethod, hostname, port);
        }
        Object.defineProperty(ProtocolConnection.prototype, "EncryptionMethod", {
            get: function () {
                return this.encryptionMethod;
            },
            set: function (value) {
                this.encryptionMethod = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProtocolConnection.prototype, "Hostname", {
            get: function () {
                return this.hostname;
            },
            set: function (value) {
                this.hostname = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProtocolConnection.prototype, "Port", {
            get: function () {
                return this.port;
            },
            set: function (value) {
                this.port = value;
            },
            enumerable: true,
            configurable: true
        });
        ProtocolConnection.prototype.constructor_0 = function () {
        };
        ProtocolConnection.LoadFromXml = function (reader) {
            var protocolConnection = new ProtocolConnection();
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "EncryptionMethod")) {
                        if (!(localName === "Hostname")) {
                            if (localName === "Port") {
                                protocolConnection.Port = reader.ReadElementValue();
                            }
                        }
                        else {
                            protocolConnection.Hostname = reader.ReadElementValue();
                        }
                    }
                    else {
                        protocolConnection.EncryptionMethod = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "ProtocolConnection"));
            return protocolConnection;
        };
        ProtocolConnection.prototype.constructor_1 = function (encryptionMethod, hostname, port) {
            this.encryptionMethod = encryptionMethod;
            this.hostname = hostname;
            this.port = port;
        };
        return ProtocolConnection;
    }());
    var ProtocolConnectionCollection = (function () {
        function ProtocolConnectionCollection() {
            this.connections = null;
            _super.call(this);
            this.connections = new List();
        }
        Object.defineProperty(ProtocolConnectionCollection.prototype, "Connections", {
            get: function () {
                return this.connections;
            },
            set: function (value) {
                this.connections = value;
            },
            enumerable: true,
            configurable: true
        });
        ProtocolConnectionCollection.LoadFromXml = function (reader) {
            var protocolConnectionCollection = new ProtocolConnectionCollection();
            do {
                reader.Read();
                if (reader.NodeType === 1 && reader.LocalName === "ProtocolConnection") {
                    var protocolConnection = ProtocolConnection.LoadFromXml(reader);
                    if (protocolConnection !== null) {
                        protocolConnectionCollection.Connections.Add(protocolConnection);
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "ProtocolConnections"));
            return protocolConnectionCollection;
        };
        return ProtocolConnectionCollection;
    }());
    var AutodiscoverRequest = (function () {
        function AutodiscoverRequest(service, url) {
            this.service = null;
            this.url = null;
            _super.call(this);
            this.service = service;
            this.url = url;
        }
        Object.defineProperty(AutodiscoverRequest.prototype, "Service", {
            get: function () {
                return this.service;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AutodiscoverRequest.prototype, "Url", {
            get: function () {
                return this.url;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverRequest.IsRedirectionResponse = function (httpWebResponse) {
            return httpWebResponse.StatusCode === HttpStatusCode.Found || httpWebResponse.StatusCode === HttpStatusCode.MovedPermanently || httpWebResponse.StatusCode === HttpStatusCode.TemporaryRedirect || httpWebResponse.StatusCode === HttpStatusCode.SeeOther;
        };
        AutodiscoverRequest.prototype.Validate = function () {
            this.Service.Validate();
        };
        AutodiscoverRequest.prototype.InternalExecute = function () {
            this.Validate();
            var result;
            try {
                var ewsHttpWebRequest = this.Service.PrepareHttpWebRequestForUrl(this.Url);
                this.Service.TraceHttpRequestHeaders(TraceFlags.AutodiscoverRequestHttpHeaders, ewsHttpWebRequest);
                var flag = this.Service.Credentials !== null && this.Service.Credentials.NeedSignature;
                var flag2 = this.Service.IsTraceEnabledFor(TraceFlags.AutodiscoverRequest);
                var requestStream = ewsHttpWebRequest.GetRequestStream();
                try {
                    var memoryStream = new MemoryStream();
                    try {
                        var ewsServiceXmlWriter = new EwsServiceXmlWriter(this.Service, memoryStream);
                        try {
                            ewsServiceXmlWriter.RequireWSSecurityUtilityNamespace = flag;
                            this.WriteSoapRequest(this.Url, ewsServiceXmlWriter);
                        }
                        finally {
                            if (ewsServiceXmlWriter !== null) {
                                ewsServiceXmlWriter.Dispose();
                            }
                        }
                        if (flag) {
                            this.service.Credentials.Sign(memoryStream);
                        }
                        if (flag2) {
                            memoryStream.Position = 0;
                            this.Service.TraceXml(TraceFlags.AutodiscoverRequest, memoryStream);
                        }
                        EwsUtilities.CopyStream(memoryStream, requestStream);
                    }
                    finally {
                        if (memoryStream !== null) {
                            memoryStream.Dispose();
                        }
                    }
                }
                finally {
                    if (requestStream !== null) {
                        requestStream.Dispose();
                    }
                }
                var response = ewsHttpWebRequest.GetResponse();
                try {
                    if (AutodiscoverRequest.IsRedirectionResponse(response)) {
                        var autodiscoverResponse = this.CreateRedirectionResponse(response);
                        if (autodiscoverResponse === null) {
                            throw new ServiceRemoteException(Strings.InvalidRedirectionResponseReturned);
                        }
                        result = autodiscoverResponse;
                    }
                    else {
                        var responseStream = AutodiscoverRequest.GetResponseStream(response);
                        try {
                            var memoryStream2 = new MemoryStream();
                            try {
                                EwsUtilities.CopyStream(responseStream, memoryStream2);
                                memoryStream2.Position = 0;
                                this.Service.TraceResponse(response, memoryStream2);
                                var ewsXmlReader = new EwsXmlReader(memoryStream2);
                                ewsXmlReader.Read();
                                if (ewsXmlReader.NodeType === 17) {
                                    ewsXmlReader.ReadStartElement(XmlNamespace.Soap, "Envelope");
                                }
                                else {
                                    if (ewsXmlReader.NodeType !== 1 || ewsXmlReader.LocalName !== "Envelope" || ewsXmlReader.NamespaceUri !== EwsUtilities.GetNamespaceUri(XmlNamespace.Soap)) {
                                        throw new ServiceXmlDeserializationException(Strings.InvalidAutodiscoverServiceResponse);
                                    }
                                }
                                this.ReadSoapHeaders(ewsXmlReader);
                                var autodiscoverResponse2 = this.ReadSoapBody(ewsXmlReader);
                                ewsXmlReader.ReadEndElement(XmlNamespace.Soap, "Envelope");
                                if (autodiscoverResponse2.ErrorCode !== AutodiscoverErrorCode.NoError) {
                                    throw new AutodiscoverResponseException(autodiscoverResponse2.ErrorCode, autodiscoverResponse2.ErrorMessage);
                                }
                                result = autodiscoverResponse2;
                            }
                            finally {
                                if (memoryStream2 !== null) {
                                    memoryStream2.Dispose();
                                }
                            }
                        }
                        finally {
                            if (responseStream !== null) {
                                responseStream.Dispose();
                            }
                        }
                    }
                }
                finally {
                    if (response !== null) {
                        response.Dispose();
                    }
                }
            }
            catch (ex) {
                if (ex instanceof WebException) {
                    if (ex.Status === WebExceptionStatus.ProtocolError && ex.Response !== null) {
                        var ewsHttpWebResponse = this.Service.HttpWebRequestFactory.CreateExceptionResponse(ex);
                        if (AutodiscoverRequest.IsRedirectionResponse(ewsHttpWebResponse)) {
                            this.Service.ProcessHttpResponseHeaders(TraceFlags.AutodiscoverResponseHttpHeaders, ewsHttpWebResponse);
                            var autodiscoverResponse3 = this.CreateRedirectionResponse(ewsHttpWebResponse);
                            if (autodiscoverResponse3 !== null) {
                                result = autodiscoverResponse3;
                                return result;
                            }
                        }
                        else {
                            this.ProcessWebException(ex);
                        }
                    }
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex.Message), ex);
                }
                else if (ex instanceof XmlException) {
                    this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("XML parsing error: {0}", ex2.Message));
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex2.Message), ex2);
                }
                else if (ex instanceof IOException) {
                    this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("I/O error: {0}", ex3.Message));
                    throw new ServiceRequestException(NString.Format(Strings.ServiceRequestFailed, ex3.Message), ex3);
                }
                else
                    throw ex;
            }
            return result;
        };
        AutodiscoverRequest.prototype.ProcessWebException = function (webException) {
            if (webException.Response !== null) {
                var ewsHttpWebResponse = this.Service.HttpWebRequestFactory.CreateExceptionResponse(webException);
                if (ewsHttpWebResponse.StatusCode === HttpStatusCode.InternalServerError) {
                    var IL_B6 = 1;
                    var _goto = 0;
                    _GOTO_LOOP: while (true) {
                        switch (_goto) {
                            default:
                                var soapFaultDetails;
                                if (this.Service.IsTraceEnabledFor(TraceFlags.AutodiscoverRequest)) {
                                    var memoryStream = new MemoryStream();
                                    try {
                                        var responseStream = AutodiscoverRequest.GetResponseStream(ewsHttpWebResponse);
                                        try {
                                            EwsUtilities.CopyStream(responseStream, memoryStream);
                                            memoryStream.Position = 0;
                                        }
                                        finally {
                                            if (responseStream !== null) {
                                                responseStream.Dispose();
                                            }
                                        }
                                        this.Service.TraceResponse(ewsHttpWebResponse, memoryStream);
                                        var reader = new EwsXmlReader(memoryStream);
                                        soapFaultDetails = this.ReadSoapFault(reader);
                                        _goto = IL_B6;
                                        continue _GOTO_LOOP;
                                    }
                                    finally {
                                        if (memoryStream !== null) {
                                            memoryStream.Dispose();
                                        }
                                    }
                                }
                                var responseStream2 = AutodiscoverRequest.GetResponseStream(ewsHttpWebResponse);
                                try {
                                    var reader2 = new EwsXmlReader(responseStream2);
                                    soapFaultDetails = this.ReadSoapFault(reader2);
                                }
                                finally {
                                    if (responseStream2 !== null) {
                                        responseStream2.Dispose();
                                    }
                                }
                                _goto = IL_B6;
                                continue _GOTO_LOOP;
                            case 1:
                                if (soapFaultDetails !== null) {
                                    throw new ServiceResponseException(new ServiceResponse(soapFaultDetails));
                                }
                                break _GOTO_LOOP;
                        }
                    }
                }
                else {
                    this.Service.ProcessHttpErrorResponse(ewsHttpWebResponse, webException);
                }
            }
        };
        AutodiscoverRequest.prototype.CreateRedirectionResponse = function (httpWebResponse) {
            var IL_AD = 1;
            var _goto = 0;
            _GOTO_LOOP: while (true) {
                switch (_goto) {
                    default:
                        var text = httpWebResponse.Headers.get_Item(HttpResponseHeader.Location);
                        if (!NString.IsNullOrEmpty(text)) {
                            try {
                                var uri = new Uri(this.Url, text);
                                if (uri.Scheme === Uri.UriSchemeHttp || uri.Scheme === Uri.UriSchemeHttps) {
                                    var autodiscoverResponse = this.CreateServiceResponse();
                                    autodiscoverResponse.ErrorCode = AutodiscoverErrorCode.RedirectUrl;
                                    autodiscoverResponse.RedirectionUrl = uri;
                                    return autodiscoverResponse;
                                }
                                this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("Invalid redirection URL '{0}' returned by Autodiscover service.", uri));
                                _goto = IL_AD;
                                continue _GOTO_LOOP;
                            }
                            catch (ex_7E) {
                                if (ex_7E instanceof UriFormatException) {
                                    this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, NString.Format("Invalid redirection location '{0}' returned by Autodiscover service.", text));
                                    _goto = IL_AD;
                                    continue _GOTO_LOOP;
                                }
                                else
                                    throw ex_7E;
                            }
                        }
                        this.Service.TraceMessage(TraceFlags.AutodiscoverConfiguration, "Redirection response returned by Autodiscover service without redirection location.");
                        _goto = IL_AD;
                        continue _GOTO_LOOP;
                    case 1:
                        return null;
                }
            }
        };
        AutodiscoverRequest.prototype.ReadSoapFault = function (reader) {
            var soapFaultDetails = null;
            try {
                reader.Read();
                if (reader.NodeType === 17) {
                    reader.Read();
                }
                if (!reader.IsStartElement() || reader.LocalName !== "Envelope") {
                    var result = soapFaultDetails;
                    return result;
                }
                var namespaceFromUri = EwsUtilities.GetNamespaceFromUri(reader.NamespaceUri);
                if (namespaceFromUri === XmlNamespace.NotSpecified) {
                    var result = soapFaultDetails;
                    return result;
                }
                reader.Read();
                if (reader.IsStartElement(namespaceFromUri, "Header")) {
                    do {
                        reader.Read();
                    } while (!reader.IsEndElement(namespaceFromUri, "Header"));
                    reader.Read();
                }
                if (reader.IsStartElement(namespaceFromUri, "Body")) {
                    do {
                        reader.Read();
                        if (reader.IsStartElement(namespaceFromUri, "Fault")) {
                            soapFaultDetails = SoapFaultDetails.Parse(reader, namespaceFromUri);
                        }
                    } while (!reader.IsEndElement(namespaceFromUri, "Body"));
                }
                reader.ReadEndElement(namespaceFromUri, "Envelope");
            }
            catch (ex_C0) {
                if (ex_C0 instanceof XmlException) {
                }
                else
                    throw ex_C0;
            }
            return soapFaultDetails;
        };
        AutodiscoverRequest.prototype.WriteSoapRequest = function (requestUrl, writer) {
            writer.WriteStartElement(XmlNamespace.Soap, "Envelope");
            writer.WriteAttributeValue("xmlns", "a", "http://schemas.microsoft.com/exchange/2010/Autodiscover");
            writer.WriteAttributeValue("xmlns", "wsa", "http://www.w3.org/2005/08/addressing");
            writer.WriteAttributeValue("xmlns", "xsi", "http://www.w3.org/2001/XMLSchema-instance");
            if (writer.RequireWSSecurityUtilityNamespace) {
                writer.WriteAttributeValue("xmlns", "wsu", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");
            }
            writer.WriteStartElement(XmlNamespace.Soap, "Header");
            if (this.Service.Credentials !== null) {
                this.Service.Credentials.EmitExtraSoapHeaderNamespaceAliases(writer.InternalWriter);
            }
            writer.WriteElementValue(XmlNamespace.Autodiscover, "RequestedServerVersion", ExchangeVersion[this.Service.RequestedServerVersion]);
            writer.WriteElementValue(XmlNamespace.WSAddressing, "Action", this.GetWsAddressingActionName());
            writer.WriteElementValue(XmlNamespace.WSAddressing, "To", requestUrl.AbsoluteUri);
            this.WriteExtraCustomSoapHeadersToXml(writer);
            if (this.Service.Credentials !== null) {
                this.Service.Credentials.SerializeWSSecurityHeaders(writer.InternalWriter);
            }
            this.Service.DoOnSerializeCustomSoapHeaders(writer.InternalWriter);
            writer.WriteEndElement();
            writer.WriteStartElement(XmlNamespace.Soap, "Body");
            this.WriteBodyToXml(writer);
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.Flush();
        };
        AutodiscoverRequest.prototype.WriteExtraCustomSoapHeadersToXml = function (writer) {
        };
        AutodiscoverRequest.prototype.WriteBodyToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Autodiscover, this.GetRequestXmlElementName());
            this.WriteAttributesToXml(writer);
            this.WriteElementsToXml(writer);
            writer.WriteEndElement();
        };
        AutodiscoverRequest.GetResponseStream = function (response) {
            var contentEncoding = response.ContentEncoding;
            var responseStream = response.GetResponseStream();
            if (NString.Contains(NString.ToLowerInvariant(contentEncoding), "gzip")) {
                return new GZipStream(responseStream, CompressionMode.Decompress);
            }
            if (NString.Contains(NString.ToLowerInvariant(contentEncoding), "deflate")) {
                return new DeflateStream(responseStream, CompressionMode.Decompress);
            }
            return responseStream;
        };
        AutodiscoverRequest.prototype.ReadSoapHeaders = function (reader) {
            reader.ReadStartElement(XmlNamespace.Soap, "Header");
            do {
                reader.Read();
                this.ReadSoapHeader(reader);
            } while (!reader.IsEndElement(XmlNamespace.Soap, "Header"));
        };
        AutodiscoverRequest.prototype.ReadSoapHeader = function (reader) {
            if (reader.IsStartElement(XmlNamespace.Autodiscover, "ServerVersionInfo")) {
                this.service.ServerInfo = this.ReadServerVersionInfo(reader);
            }
        };
        AutodiscoverRequest.prototype.ReadServerVersionInfo = function (reader) {
            var exchangeServerInfo = new ExchangeServerInfo();
            do {
                reader.Read();
                var localName;
                if (reader.IsStartElement() && (localName = reader.LocalName) !== null) {
                    if (!(localName === "MajorVersion")) {
                        if (!(localName === "MinorVersion")) {
                            if (!(localName === "MajorBuildNumber")) {
                                if (!(localName === "MinorBuildNumber")) {
                                    if (localName === "Version") {
                                        exchangeServerInfo.VersionString = reader.ReadElementValue();
                                    }
                                }
                                else {
                                    exchangeServerInfo.MinorBuildNumber = reader.ReadElementValue();
                                }
                            }
                            else {
                                exchangeServerInfo.MajorBuildNumber = reader.ReadElementValue();
                            }
                        }
                        else {
                            exchangeServerInfo.MinorVersion = reader.ReadElementValue();
                        }
                    }
                    else {
                        exchangeServerInfo.MajorVersion = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "ServerVersionInfo"));
            return exchangeServerInfo;
        };
        AutodiscoverRequest.prototype.ReadSoapBody = function (reader) {
            reader.ReadStartElement(XmlNamespace.Soap, "Body");
            var result = this.LoadFromXml(reader);
            reader.ReadEndElement(XmlNamespace.Soap, "Body");
            return result;
        };
        AutodiscoverRequest.prototype.LoadFromXml = function (reader) {
            var responseXmlElementName = this.GetResponseXmlElementName();
            reader.ReadStartElement(XmlNamespace.Autodiscover, responseXmlElementName);
            var autodiscoverResponse = this.CreateServiceResponse();
            autodiscoverResponse.LoadFromXml(reader, responseXmlElementName);
            return autodiscoverResponse;
        };
        AutodiscoverRequest.prototype.GetRequestXmlElementName = function () {
            throw new NotSupportedException();
        };
        AutodiscoverRequest.prototype.GetResponseXmlElementName = function () {
            throw new NotSupportedException();
        };
        AutodiscoverRequest.prototype.GetWsAddressingActionName = function () {
            throw new NotSupportedException();
        };
        AutodiscoverRequest.prototype.CreateServiceResponse = function () {
            throw new NotSupportedException();
        };
        AutodiscoverRequest.prototype.WriteAttributesToXml = function (writer) {
            throw new NotSupportedException();
        };
        AutodiscoverRequest.prototype.WriteElementsToXml = function (writer) {
            throw new NotSupportedException();
        };
        return AutodiscoverRequest;
    }());
    var GetDomainSettingsRequest = (function (_super) {
        __extends(GetDomainSettingsRequest, _super);
        function GetDomainSettingsRequest(service, url) {
            _super.call(this, service, url);
            this.domains = null;
            this.settings = null;
            this.requestedVersion = null;
        }
        Object.defineProperty(GetDomainSettingsRequest.prototype, "Domains", {
            get: function () {
                return this.domains;
            },
            set: function (value) {
                this.domains = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDomainSettingsRequest.prototype, "Settings", {
            get: function () {
                return this.settings;
            },
            set: function (value) {
                this.settings = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDomainSettingsRequest.prototype, "RequestedVersion", {
            get: function () {
                return this.requestedVersion;
            },
            set: function (value) {
                this.requestedVersion = value;
            },
            enumerable: true,
            configurable: true
        });
        GetDomainSettingsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.Domains, "domains");
            EwsUtilities.ValidateParam(this.Settings, "settings");
            if (this.Settings.Count === 0) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverSettingsCount);
            }
            if (this.domains.Count === 0) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverDomainsCount);
            }
            var enumerator = this.domains.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (NString.IsNullOrEmpty(current)) {
                        throw new ServiceValidationException(Strings.InvalidAutodiscoverDomain);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        GetDomainSettingsRequest.prototype.Execute = function () {
            var getDomainSettingsResponseCollection = _super.prototype.InternalExecute.call(this);
            if (getDomainSettingsResponseCollection.ErrorCode === AutodiscoverErrorCode.NoError) {
                this.PostProcessResponses(getDomainSettingsResponseCollection);
            }
            return getDomainSettingsResponseCollection;
        };
        GetDomainSettingsRequest.prototype.PostProcessResponses = function (responses) {
            for (var i = 0; i < responses.Count; i = i + 1) {
                responses.get_Item(i).Domain = this.Domains.get_Item(i);
            }
        };
        GetDomainSettingsRequest.prototype.GetRequestXmlElementName = function () {
            return "GetDomainSettingsRequestMessage";
        };
        GetDomainSettingsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetDomainSettingsResponseMessage";
        };
        GetDomainSettingsRequest.prototype.GetWsAddressingActionName = function () {
            return "http://schemas.microsoft.com/exchange/2010/Autodiscover/Autodiscover/GetDomainSettings";
        };
        GetDomainSettingsRequest.prototype.CreateServiceResponse = function () {
            return new GetDomainSettingsResponseCollection();
        };
        GetDomainSettingsRequest.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("xmlns", "a", "http://schemas.microsoft.com/exchange/2010/Autodiscover");
        };
        GetDomainSettingsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Autodiscover, "Request");
            writer.WriteStartElement(XmlNamespace.Autodiscover, "Domains");
            var enumerator = this.Domains.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (!NString.IsNullOrEmpty(current)) {
                        writer.WriteElementValue(XmlNamespace.Autodiscover, "Domain", current);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            writer.WriteStartElement(XmlNamespace.Autodiscover, "RequestedSettings");
            var enumerator2 = this.settings.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    writer.WriteElementValue(XmlNamespace.Autodiscover, "Setting", current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            writer.WriteEndElement();
            if (this.requestedVersion !== null) {
                writer.WriteElementValue(XmlNamespace.Autodiscover, "RequestedVersion", this.requestedVersion.Value);
            }
            writer.WriteEndElement();
        };
        GetDomainSettingsRequest.GetDomainSettingsActionUri = "http://schemas.microsoft.com/exchange/2010/Autodiscover/Autodiscover/GetDomainSettings";
        return GetDomainSettingsRequest;
    }(AutodiscoverRequest));
    var GetUserSettingsRequest = (function (_super) {
        __extends(GetUserSettingsRequest, _super);
        function GetUserSettingsRequest(service, url, expectPartnerToken) {
            _super.call(this, service, url);
            this.expectPartnerToken = false;
            this.SmtpAddresses = null;
            this.Settings = null;
            this.PartnerToken = null;
            this.PartnerTokenReference = null;
            if (arguments.length === 2 && (service === null || service instanceof AutodiscoverService) && (url === null || url instanceof Uri)) {
                this.constructor_0(service, url);
                return;
            }
            this.constructor_1(service, url, expectPartnerToken);
        }
        GetUserSettingsRequest.prototype.constructor_0 = function (service, url) {
            this.constructor_1(service, url, false);
        };
        GetUserSettingsRequest.prototype.constructor_1 = function (service, url, expectPartnerToken) {
            this.expectPartnerToken = expectPartnerToken;
            if (expectPartnerToken && !(url.Scheme === "https")) {
                throw new ServiceValidationException(Strings.HttpsIsRequired);
            }
        };
        GetUserSettingsRequest.prototype.Validate = function () {
            _super.prototype.Validate.call(this);
            EwsUtilities.ValidateParam(this.SmtpAddresses, "smtpAddresses");
            EwsUtilities.ValidateParam(this.Settings, "settings");
            if (this.Settings.Count === 0) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverSettingsCount);
            }
            if (this.SmtpAddresses.Count === 0) {
                throw new ServiceValidationException(Strings.InvalidAutodiscoverSmtpAddressesCount);
            }
            var enumerator = this.SmtpAddresses.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    if (NString.IsNullOrEmpty(current)) {
                        throw new ServiceValidationException(Strings.InvalidAutodiscoverSmtpAddress);
                    }
                }
            }
            finally {
                enumerator.Dispose();
            }
        };
        GetUserSettingsRequest.prototype.Execute = function () {
            var getUserSettingsResponseCollection = _super.prototype.InternalExecute.call(this);
            if (getUserSettingsResponseCollection.ErrorCode === AutodiscoverErrorCode.NoError) {
                this.PostProcessResponses(getUserSettingsResponseCollection);
            }
            return getUserSettingsResponseCollection;
        };
        GetUserSettingsRequest.prototype.PostProcessResponses = function (responses) {
            for (var i = 0; i < responses.Count; i = i + 1) {
                responses.get_Item(i).SmtpAddress = this.SmtpAddresses.get_Item(i);
            }
        };
        GetUserSettingsRequest.prototype.GetRequestXmlElementName = function () {
            return "GetUserSettingsRequestMessage";
        };
        GetUserSettingsRequest.prototype.GetResponseXmlElementName = function () {
            return "GetUserSettingsResponseMessage";
        };
        GetUserSettingsRequest.prototype.GetWsAddressingActionName = function () {
            return "http://schemas.microsoft.com/exchange/2010/Autodiscover/Autodiscover/GetUserSettings";
        };
        GetUserSettingsRequest.prototype.CreateServiceResponse = function () {
            return new GetUserSettingsResponseCollection();
        };
        GetUserSettingsRequest.prototype.WriteAttributesToXml = function (writer) {
            writer.WriteAttributeValue("xmlns", "a", "http://schemas.microsoft.com/exchange/2010/Autodiscover");
        };
        GetUserSettingsRequest.prototype.WriteExtraCustomSoapHeadersToXml = function (writer) {
            if (this.expectPartnerToken) {
                writer.WriteElementValue(XmlNamespace.Autodiscover, "BinarySecret", Convert.ToBase64String(ExchangeServiceBase.SessionKey));
            }
        };
        GetUserSettingsRequest.prototype.WriteElementsToXml = function (writer) {
            writer.WriteStartElement(XmlNamespace.Autodiscover, "Request");
            writer.WriteStartElement(XmlNamespace.Autodiscover, "Users");
            var enumerator = this.SmtpAddresses.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    writer.WriteStartElement(XmlNamespace.Autodiscover, "User");
                    if (!NString.IsNullOrEmpty(current)) {
                        writer.WriteElementValue(XmlNamespace.Autodiscover, "Mailbox", current);
                    }
                    writer.WriteEndElement();
                }
            }
            finally {
                enumerator.Dispose();
            }
            writer.WriteEndElement();
            writer.WriteStartElement(XmlNamespace.Autodiscover, "RequestedSettings");
            var enumerator2 = this.Settings.GetEnumerator();
            try {
                while (enumerator2.MoveNext()) {
                    var current2 = enumerator2.Current;
                    writer.WriteElementValue(XmlNamespace.Autodiscover, "Setting", current2);
                }
            }
            finally {
                enumerator2.Dispose();
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
        };
        GetUserSettingsRequest.prototype.ReadSoapHeader = function (reader) {
            _super.prototype.ReadSoapHeader.call(this, reader);
            if (this.expectPartnerToken) {
                if (reader.IsStartElement(XmlNamespace.Autodiscover, "PartnerToken")) {
                    this.PartnerToken = reader.ReadInnerXml();
                }
                if (reader.IsStartElement(XmlNamespace.Autodiscover, "PartnerTokenReference")) {
                    this.PartnerTokenReference = reader.ReadInnerXml();
                }
            }
        };
        GetUserSettingsRequest.GetUserSettingsActionUri = "http://schemas.microsoft.com/exchange/2010/Autodiscover/Autodiscover/GetUserSettings";
        return GetUserSettingsRequest;
    }(AutodiscoverRequest));
    var GetDomainSettingsResponse = (function (_super) {
        __extends(GetDomainSettingsResponse, _super);
        function GetDomainSettingsResponse() {
            _super.call(this);
            this.domain = null;
            this.redirectTarget = null;
            this.settings = null;
            this.domainSettingErrors = null;
            this.domain = NString.Empty;
            this.settings = new Dictionary();
            this.domainSettingErrors = new Collection();
        }
        Object.defineProperty(GetDomainSettingsResponse.prototype, "Domain", {
            get: function () {
                return this.domain;
            },
            set: function (value) {
                this.domain = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDomainSettingsResponse.prototype, "RedirectTarget", {
            get: function () {
                return this.redirectTarget;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDomainSettingsResponse.prototype, "Settings", {
            get: function () {
                return this.settings;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GetDomainSettingsResponse.prototype, "DomainSettingErrors", {
            get: function () {
                return this.domainSettingErrors;
            },
            enumerable: true,
            configurable: true
        });
        GetDomainSettingsResponse.prototype.LoadFromXml = function (reader, endElementName) {
            do {
                var IL_6A = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                if ((localName = reader.LocalName) !== null) {
                                    if (localName === "RedirectTarget") {
                                        this.redirectTarget = reader.ReadElementValue();
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "DomainSettingErrors") {
                                        this.LoadDomainSettingErrorsFromXml(reader);
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "DomainSettings") {
                                        this.LoadDomainSettingsFromXml(reader);
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                }
                                _super.prototype.LoadFromXml.call(this, reader, endElementName);
                            }
                            _goto = IL_6A;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, endElementName));
        };
        GetDomainSettingsResponse.prototype.LoadDomainSettingsFromXml = function (reader) {
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === "DomainSetting") {
                        var text = reader.ReadAttributeValue(XmlNamespace.XmlSchemaInstance, "type");
                        var a;
                        if ((a = text) !== null && a === "DomainStringSetting") {
                            this.ReadSettingFromXml(reader);
                        }
                        else {
                            EwsUtilities.Assert(false, "GetDomainSettingsResponse.LoadDomainSettingsFromXml", NString.Format("Invalid setting class '{0}' returned", text));
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DomainSettings"));
            }
        };
        GetDomainSettingsResponse.prototype.ReadSettingFromXml = function (reader) {
            var domainSettingName = new Nullable();
            var value = null;
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "Name")) {
                        if (localName === "Value") {
                            value = reader.ReadElementValue();
                        }
                    }
                    else {
                        domainSettingName = new Nullable(reader.ReadElementValue());
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DomainSetting"));
            EwsUtilities.Assert(domainSettingName !== null, "GetDomainSettingsResponse.ReadSettingFromXml", "Missing name element in domain setting");
            this.settings.Add(domainSettingName.Value, value);
        };
        GetDomainSettingsResponse.prototype.LoadDomainSettingErrorsFromXml = function (reader) {
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === "DomainSettingError") {
                        var domainSettingError = new DomainSettingError();
                        domainSettingError.LoadFromXml(reader);
                        this.domainSettingErrors.Add(domainSettingError);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DomainSettingErrors"));
            }
        };
        return GetDomainSettingsResponse;
    }(AutodiscoverResponse));
    var GetDomainSettingsResponseCollection = (function (_super) {
        __extends(GetDomainSettingsResponseCollection, _super);
        function GetDomainSettingsResponseCollection() {
            _super.call(this);
        }
        GetDomainSettingsResponseCollection.prototype.CreateResponseInstance = function () {
            return new GetDomainSettingsResponse();
        };
        GetDomainSettingsResponseCollection.prototype.GetResponseCollectionXmlElementName = function () {
            return "DomainResponses";
        };
        GetDomainSettingsResponseCollection.prototype.GetResponseInstanceXmlElementName = function () {
            return "DomainResponse";
        };
        return GetDomainSettingsResponseCollection;
    }(AutodiscoverResponseCollection));
    var GetUserSettingsResponse = (function (_super) {
        __extends(GetUserSettingsResponse, _super);
        function GetUserSettingsResponse() {
            _super.call(this);
            this.SmtpAddress = null;
            this.RedirectTarget = null;
            this.Settings = null;
            this.UserSettingErrors = null;
            this.SmtpAddress = NString.Empty;
            this.Settings = new Dictionary();
            this.UserSettingErrors = new Collection();
        }
        GetUserSettingsResponse.prototype.TryGetSettingValue = function (setting, value) {
            var _this = this;
            var obj;
            if ((function () {
                var _p0 = [
                    obj
                ];
                var _r = _this.Settings.TryGetValue(setting, _p0);
                obj = _p0[0];
                return _r;
            })()) {
                value[0] = obj;
                return true;
            }
            value[0] = null;
            return false;
        };
        GetUserSettingsResponse.prototype.LoadFromXml = function (reader, endElementName) {
            do {
                var IL_6A = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                if ((localName = reader.LocalName) !== null) {
                                    if (localName === "RedirectTarget") {
                                        this.RedirectTarget = reader.ReadElementValue();
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "UserSettingErrors") {
                                        this.LoadUserSettingErrorsFromXml(reader);
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "UserSettings") {
                                        this.LoadUserSettingsFromXml(reader);
                                        _goto = IL_6A;
                                        continue _GOTO_LOOP;
                                    }
                                }
                                _super.prototype.LoadFromXml.call(this, reader, endElementName);
                            }
                            _goto = IL_6A;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, endElementName));
        };
        GetUserSettingsResponse.prototype.LoadUserSettingsFromXml = function (reader) {
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === "UserSetting") {
                        var text = reader.ReadAttributeValue(XmlNamespace.XmlSchemaInstance, "type");
                        var a;
                        if ((a = text) !== null && (a === "StringSetting" || a === "WebClientUrlCollectionSetting" || a === "AlternateMailboxCollectionSetting" || a === "ProtocolConnectionCollectionSetting" || a === "DocumentSharingLocationCollectionSetting")) {
                            this.ReadSettingFromXml(reader);
                        }
                        else {
                            EwsUtilities.Assert(false, "GetUserSettingsResponse.LoadUserSettingsFromXml", NString.Format("Invalid setting class '{0}' returned", text));
                        }
                    }
                } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "UserSettings"));
            }
        };
        GetUserSettingsResponse.prototype.ReadSettingFromXml = function (reader) {
            var value = null;
            var value2 = null;
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "Name")) {
                        if (!(localName === "Value")) {
                            if (!(localName === "WebClientUrls")) {
                                if (!(localName === "ProtocolConnections")) {
                                    if (!(localName === "AlternateMailboxes")) {
                                        if (localName === "DocumentSharingLocations") {
                                            value2 = DocumentSharingLocationCollection.LoadFromXml(reader);
                                        }
                                    }
                                    else {
                                        value2 = AlternateMailboxCollection.LoadFromXml(reader);
                                    }
                                }
                                else {
                                    value2 = ProtocolConnectionCollection.LoadFromXml(reader);
                                }
                            }
                            else {
                                value2 = WebClientUrlCollection.LoadFromXml(reader);
                            }
                        }
                        else {
                            value2 = reader.ReadElementValue();
                        }
                    }
                    else {
                        value = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "UserSetting"));
            try {
                var key = EwsUtilities.Parse(value);
                this.Settings.Add(key, value2);
            }
            catch (ex_CF) {
                if (ex_CF instanceof ArgumentException) {
                    EwsUtilities.Assert(false, "GetUserSettingsResponse.ReadSettingFromXml", "Unexpected or empty name element in user setting");
                }
                else
                    throw ex_CF;
            }
        };
        GetUserSettingsResponse.prototype.LoadUserSettingErrorsFromXml = function (reader) {
            if (!reader.IsEmptyElement) {
                do {
                    reader.Read();
                    if (reader.NodeType === 1 && reader.LocalName === "UserSettingError") {
                        var userSettingError = new UserSettingError();
                        userSettingError.LoadFromXml(reader);
                        this.UserSettingErrors.Add(userSettingError);
                    }
                } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "UserSettingErrors"));
            }
        };
        return GetUserSettingsResponse;
    }(AutodiscoverResponse));
    var GetUserSettingsResponseCollection = (function (_super) {
        __extends(GetUserSettingsResponseCollection, _super);
        function GetUserSettingsResponseCollection() {
            _super.call(this);
        }
        GetUserSettingsResponseCollection.prototype.CreateResponseInstance = function () {
            return new GetUserSettingsResponse();
        };
        GetUserSettingsResponseCollection.prototype.GetResponseCollectionXmlElementName = function () {
            return "UserResponses";
        };
        GetUserSettingsResponseCollection.prototype.GetResponseInstanceXmlElementName = function () {
            return "UserResponse";
        };
        return GetUserSettingsResponseCollection;
    }(AutodiscoverResponseCollection));
    var DocumentSharingLocation = (function () {
        function DocumentSharingLocation() {
            this.serviceUrl = null;
            this.locationUrl = null;
            this.displayName = null;
            this.supportedFileExtensions = null;
            this.externalAccessAllowed = false;
            this.anonymousAccessAllowed = false;
            this.canModifyPermissions = false;
            this.isDefault = false;
            _super.call(this);
        }
        Object.defineProperty(DocumentSharingLocation.prototype, "ServiceUrl", {
            get: function () {
                return this.serviceUrl;
            },
            set: function (value) {
                this.serviceUrl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "LocationUrl", {
            get: function () {
                return this.locationUrl;
            },
            set: function (value) {
                this.locationUrl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "DisplayName", {
            get: function () {
                return this.displayName;
            },
            set: function (value) {
                this.displayName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "SupportedFileExtensions", {
            get: function () {
                return this.supportedFileExtensions;
            },
            set: function (value) {
                this.supportedFileExtensions = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "ExternalAccessAllowed", {
            get: function () {
                return this.externalAccessAllowed;
            },
            set: function (value) {
                this.externalAccessAllowed = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "AnonymousAccessAllowed", {
            get: function () {
                return this.anonymousAccessAllowed;
            },
            set: function (value) {
                this.anonymousAccessAllowed = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "CanModifyPermissions", {
            get: function () {
                return this.canModifyPermissions;
            },
            set: function (value) {
                this.canModifyPermissions = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocumentSharingLocation.prototype, "IsDefault", {
            get: function () {
                return this.isDefault;
            },
            set: function (value) {
                this.isDefault = value;
            },
            enumerable: true,
            configurable: true
        });
        DocumentSharingLocation.LoadFromXml = function (reader) {
            var documentSharingLocation = new DocumentSharingLocation();
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (_PrivateImplementationDetails_) {
                        70549;
                        B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                    }
                    $$method0x6000149 - 1 === null;
                    {
                        var expr_34 = new Dictionary(8);
                        expr_34.Add("ServiceUrl", 0);
                        expr_34.Add("LocationUrl", 1);
                        expr_34.Add("DisplayName", 2);
                        expr_34.Add("SupportedFileExtensions", 3);
                        expr_34.Add("ExternalAccessAllowed", 4);
                        expr_34.Add("AnonymousAccessAllowed", 5);
                        expr_34.Add("CanModifyPermissions", 6);
                        expr_34.Add("IsDefault", 7);
                        _PrivateImplementationDetails_;
                        {
                            70549;
                            B87 - FCC0 - 4468 - A58C - F62EC848C70D;
                        }
                        $$method0x6000149 - 1;
                        expr_34;
                    }
                    var num;
                    if ((function () {
                        var _p0 = [
                            num
                        ];
                        var _r = _PrivateImplementationDetails_, _a = (void 0)[70549], B87 = _a === void 0 ? -FCC0 - 4468 - A58C - F62EC848C70D : _a, $$method0x6000149 = -1., TryGetValue = (localName, _p0);
                        num = _p0[0];
                        return _r;
                    })()) {
                        switch (num) {
                            case 0:
                                documentSharingLocation.ServiceUrl = reader.ReadElementValue();
                                break;
                            case 1:
                                documentSharingLocation.LocationUrl = reader.ReadElementValue();
                                break;
                            case 2:
                                documentSharingLocation.DisplayName = reader.ReadElementValue();
                                break;
                            case 3:
                                {
                                    var list = new List();
                                    reader.Read();
                                    while (reader.IsStartElement(XmlNamespace.Autodiscover, "FileExtension")) {
                                        var item = reader.ReadElementValue();
                                        list.Add(item);
                                        reader.Read();
                                    }
                                    documentSharingLocation.SupportedFileExtensions = list;
                                    break;
                                }
                            case 4:
                                documentSharingLocation.ExternalAccessAllowed = reader.ReadElementValue();
                                break;
                            case 5:
                                documentSharingLocation.AnonymousAccessAllowed = reader.ReadElementValue();
                                break;
                            case 6:
                                documentSharingLocation.CanModifyPermissions = reader.ReadElementValue();
                                break;
                            case 7:
                                documentSharingLocation.IsDefault = reader.ReadElementValue();
                                break;
                        }
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DocumentSharingLocation"));
            return documentSharingLocation;
        };
        return DocumentSharingLocation;
    }());
    var DocumentSharingLocationCollection = (function () {
        function DocumentSharingLocationCollection() {
            this.Entries = null;
            _super.call(this);
            this.Entries = new List();
        }
        DocumentSharingLocationCollection.LoadFromXml = function (reader) {
            var documentSharingLocationCollection = new DocumentSharingLocationCollection();
            do {
                reader.Read();
                if (reader.NodeType === 1 && reader.LocalName === "DocumentSharingLocation") {
                    var item = DocumentSharingLocation.LoadFromXml(reader);
                    documentSharingLocationCollection.Entries.Add(item);
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "DocumentSharingLocations"));
            return documentSharingLocationCollection;
        };
        return DocumentSharingLocationCollection;
    }());
    var UserSettingError = (function () {
        function UserSettingError(errorCode, errorMessage, settingName) {
            this.ErrorCode = 0;
            this.ErrorMessage = null;
            this.SettingName = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(errorCode, errorMessage, settingName);
        }
        UserSettingError.prototype.constructor_0 = function () {
        };
        UserSettingError.prototype.constructor_1 = function (errorCode, errorMessage, settingName) {
            this.ErrorCode = errorCode;
            this.ErrorMessage = errorMessage;
            this.SettingName = settingName;
        };
        UserSettingError.prototype.LoadFromXml = function (reader) {
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "ErrorCode")) {
                        if (!(localName === "ErrorMessage")) {
                            if (localName === "SettingName") {
                                this.SettingName = reader.ReadElementValue();
                            }
                        }
                        else {
                            this.ErrorMessage = reader.ReadElementValue();
                        }
                    }
                    else {
                        this.ErrorCode = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "UserSettingError"));
        };
        return UserSettingError;
    }());
    var WebClientUrl = (function () {
        function WebClientUrl(authenticationMethods, url) {
            this.authenticationMethods = null;
            this.url = null;
            _super.call(this);
            if (arguments.length === 0) {
                this.constructor_0();
                return;
            }
            this.constructor_1(authenticationMethods, url);
        }
        Object.defineProperty(WebClientUrl.prototype, "AuthenticationMethods", {
            get: function () {
                return this.authenticationMethods;
            },
            set: function (value) {
                this.authenticationMethods = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebClientUrl.prototype, "Url", {
            get: function () {
                return this.url;
            },
            set: function (value) {
                this.url = value;
            },
            enumerable: true,
            configurable: true
        });
        WebClientUrl.prototype.constructor_0 = function () {
        };
        WebClientUrl.prototype.constructor_1 = function (authenticationMethods, url) {
            this.authenticationMethods = authenticationMethods;
            this.url = url;
        };
        WebClientUrl.LoadFromXml = function (reader) {
            var webClientUrl = new WebClientUrl();
            do {
                reader.Read();
                var localName;
                if (reader.NodeType === 1 && (localName = reader.LocalName) !== null) {
                    if (!(localName === "AuthenticationMethods")) {
                        if (localName === "Url") {
                            webClientUrl.Url = reader.ReadElementValue();
                        }
                    }
                    else {
                        webClientUrl.AuthenticationMethods = reader.ReadElementValue();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "WebClientUrl"));
            return webClientUrl;
        };
        return WebClientUrl;
    }());
    var WebClientUrlCollection = (function () {
        function WebClientUrlCollection() {
            this.urls = null;
            _super.call(this);
            this.urls = new List();
        }
        Object.defineProperty(WebClientUrlCollection.prototype, "Urls", {
            get: function () {
                return this.urls;
            },
            enumerable: true,
            configurable: true
        });
        WebClientUrlCollection.LoadFromXml = function (reader) {
            var webClientUrlCollection = new WebClientUrlCollection();
            do {
                reader.Read();
                if (reader.NodeType === 1 && reader.LocalName === "WebClientUrl") {
                    webClientUrlCollection.Urls.Add(WebClientUrl.LoadFromXml(reader));
                }
            } while (!reader.IsEndElement(XmlNamespace.Autodiscover, "WebClientUrls"));
            return webClientUrlCollection;
        };
        return WebClientUrlCollection;
    }());
    var ConfigurationSettingsBase = (function () {
        function ConfigurationSettingsBase() {
            this.error = null;
            this.ResponseType = 0;
            this.RedirectTarget = null;
            _super.call(this);
        }
        Object.defineProperty(ConfigurationSettingsBase.prototype, "Error", {
            get: function () {
                return this.error;
            },
            enumerable: true,
            configurable: true
        });
        ConfigurationSettingsBase.prototype.TryReadCurrentXmlElement = function (reader) {
            if (reader.LocalName === "Error") {
                this.error = AutodiscoverError.Parse(reader);
                return true;
            }
            return false;
        };
        ConfigurationSettingsBase.prototype.LoadFromXml = function (reader) {
            reader.ReadStartElement(XmlNamespace.NotSpecified, "Autodiscover");
            reader.ReadStartElement(XmlNamespace.NotSpecified, "Response");
            do {
                reader.Read();
                if (reader.IsStartElement() && !this.TryReadCurrentXmlElement(reader)) {
                    reader.SkipCurrentElement();
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, "Response"));
            reader.ReadEndElement(XmlNamespace.NotSpecified, "Autodiscover");
        };
        ConfigurationSettingsBase.prototype.GetNamespace = function () {
            throw new NotSupportedException();
        };
        ConfigurationSettingsBase.prototype.MakeRedirectionResponse = function (redirectUrl) {
            throw new NotSupportedException();
        };
        ConfigurationSettingsBase.prototype.ConvertSettings = function (smtpAddress, requestedSettings) {
            throw new NotSupportedException();
        };
        return ConfigurationSettingsBase;
    }());
    var OutlookAccount = (function () {
        function OutlookAccount() {
            this.protocols = null;
            this.alternateMailboxes = null;
            this.AccountType = null;
            this.ResponseType = 0;
            this.RedirectTarget = null;
            _super.call(this);
            this.protocols = new Dictionary();
            this.alternateMailboxes = new AlternateMailboxCollection();
        }
        OutlookAccount.prototype.LoadFromXml = function (reader) {
            while (true) {
                var IL_19B = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                switch (localName = reader.LocalName) {
                                    case "AccountType":
                                        this.AccountType = reader.ReadElementValue();
                                        _goto = IL_19B;
                                        continue _GOTO_LOOP;
                                    case "Action":
                                        var text = reader.ReadElementValue();
                                        var a;
                                        if ((a = text) !== null) {
                                            if (a === "settings") {
                                                this.ResponseType = AutodiscoverResponseType.Success;
                                                _goto = IL_19B;
                                                continue _GOTO_LOOP;
                                            }
                                            if (a === "redirectUrl") {
                                                this.ResponseType = AutodiscoverResponseType.RedirectUrl;
                                                _goto = IL_19B;
                                                continue _GOTO_LOOP;
                                            }
                                            if (a === "redirectAddr") {
                                                this.ResponseType = AutodiscoverResponseType.RedirectAddress;
                                                _goto = IL_19B;
                                                continue _GOTO_LOOP;
                                            }
                                        }
                                        this.ResponseType = AutodiscoverResponseType.Error;
                                        _goto = IL_19B;
                                        continue _GOTO_LOOP;
                                    case "Protocol":
                                        var outlookProtocol = new OutlookProtocol();
                                        outlookProtocol.LoadFromXml(reader);
                                        if (this.protocols.ContainsKey(outlookProtocol.ProtocolType)) {
                                            throw new ServiceLocalException(Strings.InvalidAutodiscoverServiceResponse);
                                        }
                                        this.protocols.Add(outlookProtocol.ProtocolType, outlookProtocol);
                                        _goto = IL_19B;
                                        continue _GOTO_LOOP;
                                    case "RedirectAddr":
                                    case "RedirectUrl":
                                        this.RedirectTarget = reader.ReadElementValue();
                                        _goto = IL_19B;
                                        continue _GOTO_LOOP;
                                    case "AlternateMailboxes":
                                        var item = AlternateMailbox.LoadFromXml(reader);
                                        this.alternateMailboxes.Entries.Add(item);
                                        _goto = IL_19B;
                                        continue _GOTO_LOOP;
                                }
                                reader.SkipCurrentElement();
                            }
                            _goto = IL_19B;
                            continue _GOTO_LOOP;
                        case 1:
                            if (reader.IsEndElement(XmlNamespace.NotSpecified, "Account")) {
                                return;
                            }
                            break _GOTO_LOOP;
                    }
                }
            }
            throw new ServiceLocalException(Strings.InvalidAutodiscoverServiceResponse);
        };
        OutlookAccount.prototype.ConvertToUserSettings = function (requestedSettings, response) {
            var enumerator = this.protocols.Values.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    current.ConvertToUserSettings(requestedSettings, response);
                }
            }
            finally {
                enumerator.Dispose();
            }
            if (requestedSettings.Contains(UserSettingName.AlternateMailboxes)) {
                response.Settings.set_Item(UserSettingName.AlternateMailboxes, this.alternateMailboxes);
            }
        };
        OutlookAccount.Settings = "settings";
        OutlookAccount.RedirectAddr = "redirectAddr";
        OutlookAccount.RedirectUrl = "redirectUrl";
        return OutlookAccount;
    }());
    var OutlookConfigurationSettings = (function (_super) {
        __extends(OutlookConfigurationSettings, _super);
        function OutlookConfigurationSettings() {
            _super.call(this);
            this.user = null;
            this.account = null;
            this.user = new OutlookUser();
            this.account = new OutlookAccount();
        }
        Object.defineProperty(OutlookConfigurationSettings.prototype, "ResponseType", {
            get: function () {
                if (this.account !== null) {
                    return this.account.ResponseType;
                }
                return AutodiscoverResponseType.Error;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OutlookConfigurationSettings.prototype, "RedirectTarget", {
            get: function () {
                return this.account.RedirectTarget;
            },
            enumerable: true,
            configurable: true
        });
        OutlookConfigurationSettings.IsAvailableUserSetting = function (setting) {
            return OutlookConfigurationSettings.allOutlookProviderSettings.Member.Contains(setting);
        };
        OutlookConfigurationSettings.prototype.GetNamespace = function () {
            return "http://schemas.microsoft.com/exchange/autodiscover/outlook/responseschema/2006a";
        };
        OutlookConfigurationSettings.prototype.MakeRedirectionResponse = function (redirectUrl) {
            var outlookAccount = new OutlookAccount();
            outlookAccount.RedirectTarget = redirectUrl.ToString();
            outlookAccount.ResponseType = AutodiscoverResponseType.RedirectUrl;
            this.account = outlookAccount;
        };
        OutlookConfigurationSettings.prototype.TryReadCurrentXmlElement = function (reader) {
            if (!_super.prototype.TryReadCurrentXmlElement.call(this, reader)) {
                var localName;
                if ((localName = reader.LocalName) !== null) {
                    if (localName === "User") {
                        this.user.LoadFromXml(reader);
                        return true;
                    }
                    if (localName === "Account") {
                        this.account.LoadFromXml(reader);
                        return true;
                    }
                }
                reader.SkipCurrentElement();
                return false;
            }
            return true;
        };
        OutlookConfigurationSettings.prototype.ConvertSettings = function (smtpAddress, requestedSettings) {
            var getUserSettingsResponse = new GetUserSettingsResponse();
            getUserSettingsResponse.SmtpAddress = smtpAddress;
            if (this.Error !== null) {
                getUserSettingsResponse.ErrorCode = AutodiscoverErrorCode.InternalServerError;
                getUserSettingsResponse.ErrorMessage = this.Error.Message;
            }
            else {
                switch (this.ResponseType) {
                    case AutodiscoverResponseType.Error:
                        getUserSettingsResponse.ErrorCode = AutodiscoverErrorCode.InternalServerError;
                        getUserSettingsResponse.ErrorMessage = Strings.InvalidAutodiscoverServiceResponse;
                        break;
                    case AutodiscoverResponseType.RedirectUrl:
                        getUserSettingsResponse.ErrorCode = AutodiscoverErrorCode.RedirectUrl;
                        getUserSettingsResponse.ErrorMessage = NString.Empty;
                        getUserSettingsResponse.RedirectTarget = this.RedirectTarget;
                        break;
                    case AutodiscoverResponseType.RedirectAddress:
                        getUserSettingsResponse.ErrorCode = AutodiscoverErrorCode.RedirectAddress;
                        getUserSettingsResponse.ErrorMessage = NString.Empty;
                        getUserSettingsResponse.RedirectTarget = this.RedirectTarget;
                        break;
                    case AutodiscoverResponseType.Success:
                        getUserSettingsResponse.ErrorCode = AutodiscoverErrorCode.NoError;
                        getUserSettingsResponse.ErrorMessage = NString.Empty;
                        this.user.ConvertToUserSettings(requestedSettings, getUserSettingsResponse);
                        this.account.ConvertToUserSettings(requestedSettings, getUserSettingsResponse);
                        this.ReportUnsupportedSettings(requestedSettings, getUserSettingsResponse);
                        break;
                    default:
                        EwsUtilities.Assert(false, "OutlookConfigurationSettings.ConvertSettings", "An unexpected error has occured. This code path should never be reached.");
                        break;
                }
            }
            return getUserSettingsResponse;
        };
        OutlookConfigurationSettings.prototype.ReportUnsupportedSettings = function (requestedSettings, response) {
            var enumerable = Enumerable.Where(requestedSettings, function (setting) { return !OutlookConfigurationSettings.IsAvailableUserSetting(setting); });
            var enumerator = enumerable.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var userSettingError = new UserSettingError();
                    userSettingError.ErrorCode = AutodiscoverErrorCode.InvalidSetting;
                    userSettingError.SettingName = UserSettingName[current];
                    userSettingError.ErrorMessage = NString.Format(Strings.AutodiscoverInvalidSettingForOutlookProvider, UserSettingName[current]);
                    var item = userSettingError;
                    response.UserSettingErrors.Add(item);
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        OutlookConfigurationSettings.allOutlookProviderSettings = new LazyMember(function () {
            var list = new List();
            list.AddRange(OutlookUser.AvailableUserSettings);
            list.AddRange(OutlookProtocol.AvailableUserSettings);
            list.Add(UserSettingName.AlternateMailboxes);
            return list;
        });
        return OutlookConfigurationSettings;
    }(ConfigurationSettingsBase));
    var OutlookProtocol = (function () {
        function OutlookProtocol() {
            this.activeDirectoryServer = null;
            this.authPackage = null;
            this.availabilityServiceUrl = null;
            this.ecpUrl = null;
            this.ecpUrlAggr = null;
            this.ecpUrlMt = null;
            this.ecpUrlPublish = null;
            this.ecpUrlPhoto = null;
            this.ecpUrlConnect = null;
            this.ecpUrlRet = null;
            this.ecpUrlSms = null;
            this.ecpUrlUm = null;
            this.ecpUrlTm = null;
            this.ecpUrlTmCreating = null;
            this.ecpUrlTmEditing = null;
            this.ecpUrlTmHiding = null;
            this.siteMailboxCreationURL = null;
            this.ecpUrlExtInstall = null;
            this.exchangeWebServicesUrl = null;
            this.exchangeManagementWebServicesUrl = null;
            this.mailboxDN = null;
            this.offlineAddressBookUrl = null;
            this.exchangeRpcUrl = null;
            this.exchangeWebServicesPartnerUrl = null;
            this.publicFolderServer = null;
            this.server = null;
            this.serverDN = null;
            this.unifiedMessagingUrl = null;
            this.sharingEnabled = false;
            this.sslEnabled = false;
            this.serverExclusiveConnect = false;
            this.certPrincipalName = null;
            this.groupingInformation = null;
            this.externalOutlookWebAccessUrls = null;
            this.internalOutlookWebAccessUrls = null;
            this.ProtocolType = 0;
            _super.call(this);
            this.internalOutlookWebAccessUrls = new WebClientUrlCollection();
            this.externalOutlookWebAccessUrls = new WebClientUrlCollection();
        }
        Object.defineProperty(OutlookProtocol.prototype, "ConverterDictionary", {
            get: function () {
                switch (this.ProtocolType) {
                    case OutlookProtocolType.Rpc:
                        return OutlookProtocol.internalProtocolConverterDictionary.Member;
                    case OutlookProtocolType.RpcOverHttp:
                        return OutlookProtocol.externalProtocolConverterDictionary.Member;
                    case OutlookProtocolType.Web:
                        return OutlookProtocol.webProtocolConverterDictionary.Member;
                    default:
                        return null;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OutlookProtocol, "AvailableUserSettings", {
            get: function () {
                return OutlookProtocol.availableUserSettings.Member;
            },
            enumerable: true,
            configurable: true
        });
        OutlookProtocol.prototype.LoadFromXml = function (reader) {
            do {
                var IL_572 = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                switch (localName = reader.LocalName) {
                                    case "Type":
                                        this.ProtocolType = OutlookProtocol.ProtocolNameToType(reader.ReadElementValue());
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "AuthPackage":
                                        this.authPackage = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "Server":
                                        this.server = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "ServerDN":
                                        this.serverDN = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "ServerVersion":
                                        reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "AD":
                                        this.activeDirectoryServer = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "MdbDN":
                                        this.mailboxDN = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EwsUrl":
                                        this.exchangeWebServicesUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EmwsUrl":
                                        this.exchangeManagementWebServicesUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "ASUrl":
                                        this.availabilityServiceUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "OOFUrl":
                                        reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "UMUrl":
                                        this.unifiedMessagingUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "OABUrl":
                                        this.offlineAddressBookUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "PublicFolderServer":
                                        this.publicFolderServer = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "Internal":
                                        OutlookProtocol.LoadWebClientUrlsFromXml(reader, this.internalOutlookWebAccessUrls, reader.LocalName);
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "External":
                                        OutlookProtocol.LoadWebClientUrlsFromXml(reader, this.externalOutlookWebAccessUrls, reader.LocalName);
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "SSL":
                                        {
                                            var text = reader.ReadElementValue();
                                            this.sslEnabled = (text === "On");
                                            _goto = IL_572;
                                            continue _GOTO_LOOP;
                                        }
                                    case "SharingUrl":
                                        this.sharingEnabled = (reader.ReadElementValue().length > 0);
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl":
                                        this.ecpUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-um":
                                        this.ecpUrlUm = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-aggr":
                                        this.ecpUrlAggr = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-sms":
                                        this.ecpUrlSms = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-mt":
                                        this.ecpUrlMt = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-ret":
                                        this.ecpUrlRet = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-publish":
                                        this.ecpUrlPublish = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-photo":
                                        this.ecpUrlPhoto = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "ExchangeRpcUrl":
                                        this.exchangeRpcUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EwsPartnerUrl":
                                        this.exchangeWebServicesPartnerUrl = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-connect":
                                        this.ecpUrlConnect = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-tm":
                                        this.ecpUrlTm = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-tmCreating":
                                        this.ecpUrlTmCreating = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-tmEditing":
                                        this.ecpUrlTmEditing = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-tmHiding":
                                        this.ecpUrlTmHiding = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "SiteMailboxCreationURL":
                                        this.siteMailboxCreationURL = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "EcpUrl-extinstall":
                                        this.ecpUrlExtInstall = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "ServerExclusiveConnect":
                                        {
                                            var text2 = reader.ReadElementValue();
                                            this.serverExclusiveConnect = (text2 === "On");
                                            _goto = IL_572;
                                            continue _GOTO_LOOP;
                                        }
                                    case "CertPrincipalName":
                                        this.certPrincipalName = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                    case "GroupingInformation":
                                        this.groupingInformation = reader.ReadElementValue();
                                        _goto = IL_572;
                                        continue _GOTO_LOOP;
                                }
                                reader.SkipCurrentElement();
                            }
                            _goto = IL_572;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, "Protocol"));
        };
        OutlookProtocol.ProtocolNameToType = function (protocolName) {
            var result;
            if (!(function () {
                var _p0 = [
                    result
                ];
                var _r = OutlookProtocol.protocolNameToTypeMap.Member.TryGetValue(protocolName, _p0);
                result = _p0[0];
                return _r;
            })()) {
                result = OutlookProtocolType.Unknown;
            }
            return result;
        };
        OutlookProtocol.LoadWebClientUrlsFromXml = function (reader, webClientUrls, elementName) {
            do {
                reader.Read();
                if (reader.NodeType === 1) {
                    var localName;
                    if ((localName = reader.LocalName) !== null && localName === "OWAUrl") {
                        var authenticationMethods = reader.ReadAttributeValue("AuthenticationMethod");
                        var url = reader.ReadElementValue();
                        var item = new WebClientUrl(authenticationMethods, url);
                        webClientUrls.Urls.Add(item);
                    }
                    else {
                        reader.SkipCurrentElement();
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, elementName));
        };
        OutlookProtocol.prototype.ConvertEcpFragmentToUrl = function (fragment) {
            if (!NString.IsNullOrEmpty(this.ecpUrl) && !NString.IsNullOrEmpty(fragment)) {
                return this.ecpUrl + fragment;
            }
            return null;
        };
        OutlookProtocol.prototype.ConvertToUserSettings = function (requestedSettings, response) {
            if (this.ConverterDictionary !== null) {
                var enumerable = Enumerable.Where(this.ConverterDictionary, function (converter) { return requestedSettings.Contains(converter.Key); });
                var enumerator = enumerable.GetEnumerator();
                try {
                    while (enumerator.MoveNext()) {
                        var current = enumerator.Current;
                        var obj = current.Value(this);
                        if (obj !== null) {
                            response.Settings.set_Item(current.Key, obj);
                        }
                    }
                }
                finally {
                    if (enumerator !== null) {
                        enumerator.Dispose();
                    }
                }
            }
        };
        OutlookProtocol.EXCH = "EXCH";
        OutlookProtocol.EXPR = "EXPR";
        OutlookProtocol.WEB = "WEB";
        OutlookProtocol.commonProtocolSettings = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(UserSettingName.EcpDeliveryReportUrlFragment, function (p) { return p.ecpUrlMt; });
            dictionary.Add(UserSettingName.EcpEmailSubscriptionsUrlFragment, function (p) { return p.ecpUrlAggr; });
            dictionary.Add(UserSettingName.EcpPublishingUrlFragment, function (p) { return p.ecpUrlPublish; });
            dictionary.Add(UserSettingName.EcpPhotoUrlFragment, function (p) { return p.ecpUrlPhoto; });
            dictionary.Add(UserSettingName.EcpRetentionPolicyTagsUrlFragment, function (p) { return p.ecpUrlRet; });
            dictionary.Add(UserSettingName.EcpTextMessagingUrlFragment, function (p) { return p.ecpUrlSms; });
            dictionary.Add(UserSettingName.EcpVoicemailUrlFragment, function (p) { return p.ecpUrlUm; });
            dictionary.Add(UserSettingName.EcpConnectUrlFragment, function (p) { return p.ecpUrlConnect; });
            dictionary.Add(UserSettingName.EcpTeamMailboxUrlFragment, function (p) { return p.ecpUrlTm; });
            dictionary.Add(UserSettingName.EcpTeamMailboxCreatingUrlFragment, function (p) { return p.ecpUrlTmCreating; });
            dictionary.Add(UserSettingName.EcpTeamMailboxEditingUrlFragment, function (p) { return p.ecpUrlTmEditing; });
            dictionary.Add(UserSettingName.EcpExtensionInstallationUrlFragment, function (p) { return p.ecpUrlExtInstall; });
            dictionary.Add(UserSettingName.SiteMailboxCreationURL, function (p) { return p.siteMailboxCreationURL; });
            return dictionary;
        });
        OutlookProtocol.internalProtocolSettings = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(UserSettingName.ActiveDirectoryServer, function (p) { return p.activeDirectoryServer; });
            dictionary.Add(UserSettingName.CrossOrganizationSharingEnabled, function (p) { return NBoolean.ToString(p.sharingEnabled); });
            dictionary.Add(UserSettingName.InternalEcpUrl, function (p) { return p.ecpUrl; });
            dictionary.Add(UserSettingName.InternalEcpDeliveryReportUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlMt); });
            dictionary.Add(UserSettingName.InternalEcpEmailSubscriptionsUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlAggr); });
            dictionary.Add(UserSettingName.InternalEcpPublishingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlPublish); });
            dictionary.Add(UserSettingName.InternalEcpPhotoUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlPhoto); });
            dictionary.Add(UserSettingName.InternalEcpRetentionPolicyTagsUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlRet); });
            dictionary.Add(UserSettingName.InternalEcpTextMessagingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlSms); });
            dictionary.Add(UserSettingName.InternalEcpVoicemailUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlUm); });
            dictionary.Add(UserSettingName.InternalEcpConnectUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlConnect); });
            dictionary.Add(UserSettingName.InternalEcpTeamMailboxUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTm); });
            dictionary.Add(UserSettingName.InternalEcpTeamMailboxCreatingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmCreating); });
            dictionary.Add(UserSettingName.InternalEcpTeamMailboxEditingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmEditing); });
            dictionary.Add(UserSettingName.InternalEcpTeamMailboxHidingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmHiding); });
            dictionary.Add(UserSettingName.InternalEcpExtensionInstallationUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlExtInstall); });
            dictionary.Add(UserSettingName.InternalEwsUrl, function (p) { return p.exchangeWebServicesUrl || p.availabilityServiceUrl; });
            dictionary.Add(UserSettingName.InternalEmwsUrl, function (p) { return p.exchangeManagementWebServicesUrl; });
            dictionary.Add(UserSettingName.InternalMailboxServerDN, function (p) { return p.serverDN; });
            dictionary.Add(UserSettingName.InternalRpcClientServer, function (p) { return p.server; });
            dictionary.Add(UserSettingName.InternalOABUrl, function (p) { return p.offlineAddressBookUrl; });
            dictionary.Add(UserSettingName.InternalUMUrl, function (p) { return p.unifiedMessagingUrl; });
            dictionary.Add(UserSettingName.MailboxDN, function (p) { return p.mailboxDN; });
            dictionary.Add(UserSettingName.PublicFolderServer, function (p) { return p.publicFolderServer; });
            dictionary.Add(UserSettingName.InternalServerExclusiveConnect, function (p) { return p.serverExclusiveConnect; });
            return dictionary;
        });
        OutlookProtocol.externalProtocolSettings = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(UserSettingName.ExternalEcpDeliveryReportUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlRet); });
            dictionary.Add(UserSettingName.ExternalEcpEmailSubscriptionsUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlAggr); });
            dictionary.Add(UserSettingName.ExternalEcpPublishingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlPublish); });
            dictionary.Add(UserSettingName.ExternalEcpPhotoUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlPhoto); });
            dictionary.Add(UserSettingName.ExternalEcpRetentionPolicyTagsUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlRet); });
            dictionary.Add(UserSettingName.ExternalEcpTextMessagingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlSms); });
            dictionary.Add(UserSettingName.ExternalEcpUrl, function (p) { return p.ecpUrl; });
            dictionary.Add(UserSettingName.ExternalEcpVoicemailUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlUm); });
            dictionary.Add(UserSettingName.ExternalEcpConnectUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlConnect); });
            dictionary.Add(UserSettingName.ExternalEcpTeamMailboxUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTm); });
            dictionary.Add(UserSettingName.ExternalEcpTeamMailboxCreatingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmCreating); });
            dictionary.Add(UserSettingName.ExternalEcpTeamMailboxEditingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmEditing); });
            dictionary.Add(UserSettingName.ExternalEcpTeamMailboxHidingUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlTmHiding); });
            dictionary.Add(UserSettingName.ExternalEcpExtensionInstallationUrl, function (p) { return p.ConvertEcpFragmentToUrl(p.ecpUrlExtInstall); });
            dictionary.Add(UserSettingName.ExternalEwsUrl, function (p) { return p.exchangeWebServicesUrl || p.availabilityServiceUrl; });
            dictionary.Add(UserSettingName.ExternalEmwsUrl, function (p) { return p.exchangeManagementWebServicesUrl; });
            dictionary.Add(UserSettingName.ExternalMailboxServer, function (p) { return p.server; });
            dictionary.Add(UserSettingName.ExternalMailboxServerAuthenticationMethods, function (p) { return p.authPackage; });
            dictionary.Add(UserSettingName.ExternalMailboxServerRequiresSSL, function (p) { return NBoolean.ToString(p.sslEnabled); });
            dictionary.Add(UserSettingName.ExternalOABUrl, function (p) { return p.offlineAddressBookUrl; });
            dictionary.Add(UserSettingName.ExternalUMUrl, function (p) { return p.unifiedMessagingUrl; });
            dictionary.Add(UserSettingName.ExchangeRpcUrl, function (p) { return p.exchangeRpcUrl; });
            dictionary.Add(UserSettingName.EwsPartnerUrl, function (p) { return p.exchangeWebServicesPartnerUrl; });
            dictionary.Add(UserSettingName.ExternalServerExclusiveConnect, function (p) { return NBoolean.ToString(p.serverExclusiveConnect); });
            dictionary.Add(UserSettingName.CertPrincipalName, function (p) { return p.certPrincipalName; });
            dictionary.Add(UserSettingName.GroupingInformation, function (p) { return p.groupingInformation; });
            return dictionary;
        });
        OutlookProtocol.internalProtocolConverterDictionary = new LazyMember(function () {
            var results = new Dictionary();
            Enumerable.ToList(OutlookProtocol.commonProtocolSettings.Member).ForEach(function (kv) {
                results.Add(kv.Key, kv.Value);
            });
            Enumerable.ToList(OutlookProtocol.internalProtocolSettings.Member).ForEach(function (kv) {
                results.Add(kv.Key, kv.Value);
            });
            return results;
        });
        OutlookProtocol.externalProtocolConverterDictionary = new LazyMember(function () {
            var results = new Dictionary();
            Enumerable.ToList(OutlookProtocol.commonProtocolSettings.Member).ForEach(function (kv) {
                results.Add(kv.Key, kv.Value);
            });
            Enumerable.ToList(OutlookProtocol.externalProtocolSettings.Member).ForEach(function (kv) {
                results.Add(kv.Key, kv.Value);
            });
            return results;
        });
        OutlookProtocol.webProtocolConverterDictionary = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(UserSettingName.InternalWebClientUrls, function (p) { return p.internalOutlookWebAccessUrls; });
            dictionary.Add(UserSettingName.ExternalWebClientUrls, function (p) { return p.externalOutlookWebAccessUrls; });
            return dictionary;
        });
        OutlookProtocol.availableUserSettings = new LazyMember(function () {
            var list = new List();
            list.AddRange(OutlookProtocol.commonProtocolSettings.Member.Keys);
            list.AddRange(OutlookProtocol.internalProtocolSettings.Member.Keys);
            list.AddRange(OutlookProtocol.externalProtocolSettings.Member.Keys);
            list.AddRange(OutlookProtocol.webProtocolConverterDictionary.Member.Keys);
            return list;
        });
        OutlookProtocol.protocolNameToTypeMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add("EXCH", OutlookProtocolType.Rpc);
            dictionary.Add("EXPR", OutlookProtocolType.RpcOverHttp);
            dictionary.Add("WEB", OutlookProtocolType.Web);
            return dictionary;
        });
        return OutlookProtocol;
    }());
    var OutlookUser = (function () {
        function OutlookUser() {
            this.displayName = null;
            this.legacyDN = null;
            this.deploymentId = null;
            this.autodiscoverAMTPAddress = null;
            _super.call(this);
        }
        Object.defineProperty(OutlookUser, "AvailableUserSettings", {
            get: function () {
                return OutlookUser.converterDictionary.Member.Keys;
            },
            enumerable: true,
            configurable: true
        });
        OutlookUser.prototype.LoadFromXml = function (reader) {
            do {
                var IL_8D = 1;
                var _goto = 0;
                _GOTO_LOOP: while (true) {
                    switch (_goto) {
                        default:
                            reader.Read();
                            if (reader.NodeType === 1) {
                                var localName;
                                if ((localName = reader.LocalName) !== null) {
                                    if (localName === "DisplayName") {
                                        this.displayName = reader.ReadElementValue();
                                        _goto = IL_8D;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "LegacyDN") {
                                        this.legacyDN = reader.ReadElementValue();
                                        _goto = IL_8D;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "DeploymentId") {
                                        this.deploymentId = reader.ReadElementValue();
                                        _goto = IL_8D;
                                        continue _GOTO_LOOP;
                                    }
                                    if (localName === "AutoDiscoverSMTPAddress") {
                                        this.autodiscoverAMTPAddress = reader.ReadElementValue();
                                        _goto = IL_8D;
                                        continue _GOTO_LOOP;
                                    }
                                }
                                reader.SkipCurrentElement();
                            }
                            _goto = IL_8D;
                            continue _GOTO_LOOP;
                        case 1:
                            break _GOTO_LOOP;
                    }
                }
            } while (!reader.IsEndElement(XmlNamespace.NotSpecified, "User"));
        };
        OutlookUser.prototype.ConvertToUserSettings = function (requestedSettings, response) {
            var enumerable = Enumerable.Where(OutlookUser.converterDictionary.Member, function (converter) { return requestedSettings.Contains(converter.Key); });
            var enumerator = enumerable.GetEnumerator();
            try {
                while (enumerator.MoveNext()) {
                    var current = enumerator.Current;
                    var value = current.Value(this);
                    if (!NString.IsNullOrEmpty(value)) {
                        response.Settings.set_Item(current.Key, value);
                    }
                }
            }
            finally {
                if (enumerator !== null) {
                    enumerator.Dispose();
                }
            }
        };
        OutlookUser.converterDictionary = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(UserSettingName.UserDisplayName, function (u) { return u.displayName; });
            dictionary.Add(UserSettingName.UserDN, function (u) { return u.legacyDN; });
            dictionary.Add(UserSettingName.UserDeploymentId, function (u) { return u.deploymentId; });
            dictionary.Add(UserSettingName.AutoDiscoverSMTPAddress, function (u) { return u.autodiscoverAMTPAddress; });
            return dictionary;
        });
        return OutlookUser;
    }());
    var AutodiscoverErrorCode;
    (function (AutodiscoverErrorCode) {
        AutodiscoverErrorCode[AutodiscoverErrorCode["NoError"] = 0] = "NoError";
        AutodiscoverErrorCode[AutodiscoverErrorCode["RedirectAddress"] = 1] = "RedirectAddress";
        AutodiscoverErrorCode[AutodiscoverErrorCode["RedirectUrl"] = 2] = "RedirectUrl";
        AutodiscoverErrorCode[AutodiscoverErrorCode["InvalidUser"] = 3] = "InvalidUser";
        AutodiscoverErrorCode[AutodiscoverErrorCode["InvalidRequest"] = 4] = "InvalidRequest";
        AutodiscoverErrorCode[AutodiscoverErrorCode["InvalidSetting"] = 5] = "InvalidSetting";
        AutodiscoverErrorCode[AutodiscoverErrorCode["SettingIsNotAvailable"] = 6] = "SettingIsNotAvailable";
        AutodiscoverErrorCode[AutodiscoverErrorCode["ServerBusy"] = 7] = "ServerBusy";
        AutodiscoverErrorCode[AutodiscoverErrorCode["InvalidDomain"] = 8] = "InvalidDomain";
        AutodiscoverErrorCode[AutodiscoverErrorCode["NotFederated"] = 9] = "NotFederated";
        AutodiscoverErrorCode[AutodiscoverErrorCode["InternalServerError"] = 10] = "InternalServerError";
    })(AutodiscoverErrorCode || (AutodiscoverErrorCode = {}));
    var AutodiscoverResponseType;
    (function (AutodiscoverResponseType) {
        AutodiscoverResponseType[AutodiscoverResponseType["Error"] = 0] = "Error";
        AutodiscoverResponseType[AutodiscoverResponseType["RedirectUrl"] = 1] = "RedirectUrl";
        AutodiscoverResponseType[AutodiscoverResponseType["RedirectAddress"] = 2] = "RedirectAddress";
        AutodiscoverResponseType[AutodiscoverResponseType["Success"] = 3] = "Success";
    })(AutodiscoverResponseType || (AutodiscoverResponseType = {}));
    var DomainSettingName;
    (function (DomainSettingName) {
        DomainSettingName[DomainSettingName["ExternalEwsUrl"] = 0] = "ExternalEwsUrl";
        DomainSettingName[DomainSettingName["ExternalEwsVersion"] = 1] = "ExternalEwsVersion";
    })(DomainSettingName || (DomainSettingName = {}));
    var OutlookProtocolType;
    (function (OutlookProtocolType) {
        OutlookProtocolType[OutlookProtocolType["Rpc"] = 0] = "Rpc";
        OutlookProtocolType[OutlookProtocolType["RpcOverHttp"] = 1] = "RpcOverHttp";
        OutlookProtocolType[OutlookProtocolType["Web"] = 2] = "Web";
        OutlookProtocolType[OutlookProtocolType["Unknown"] = 3] = "Unknown";
    })(OutlookProtocolType || (OutlookProtocolType = {}));
    var UserSettingName;
    (function (UserSettingName) {
        UserSettingName[UserSettingName["UserDisplayName"] = 0] = "UserDisplayName";
        UserSettingName[UserSettingName["UserDN"] = 1] = "UserDN";
        UserSettingName[UserSettingName["UserDeploymentId"] = 2] = "UserDeploymentId";
        UserSettingName[UserSettingName["InternalMailboxServer"] = 3] = "InternalMailboxServer";
        UserSettingName[UserSettingName["InternalRpcClientServer"] = 4] = "InternalRpcClientServer";
        UserSettingName[UserSettingName["InternalMailboxServerDN"] = 5] = "InternalMailboxServerDN";
        UserSettingName[UserSettingName["InternalEcpUrl"] = 6] = "InternalEcpUrl";
        UserSettingName[UserSettingName["InternalEcpVoicemailUrl"] = 7] = "InternalEcpVoicemailUrl";
        UserSettingName[UserSettingName["InternalEcpEmailSubscriptionsUrl"] = 8] = "InternalEcpEmailSubscriptionsUrl";
        UserSettingName[UserSettingName["InternalEcpTextMessagingUrl"] = 9] = "InternalEcpTextMessagingUrl";
        UserSettingName[UserSettingName["InternalEcpDeliveryReportUrl"] = 10] = "InternalEcpDeliveryReportUrl";
        UserSettingName[UserSettingName["InternalEcpRetentionPolicyTagsUrl"] = 11] = "InternalEcpRetentionPolicyTagsUrl";
        UserSettingName[UserSettingName["InternalEcpPublishingUrl"] = 12] = "InternalEcpPublishingUrl";
        UserSettingName[UserSettingName["InternalEcpPhotoUrl"] = 13] = "InternalEcpPhotoUrl";
        UserSettingName[UserSettingName["InternalEcpConnectUrl"] = 14] = "InternalEcpConnectUrl";
        UserSettingName[UserSettingName["InternalEcpTeamMailboxUrl"] = 15] = "InternalEcpTeamMailboxUrl";
        UserSettingName[UserSettingName["InternalEcpTeamMailboxCreatingUrl"] = 16] = "InternalEcpTeamMailboxCreatingUrl";
        UserSettingName[UserSettingName["InternalEcpTeamMailboxEditingUrl"] = 17] = "InternalEcpTeamMailboxEditingUrl";
        UserSettingName[UserSettingName["InternalEcpTeamMailboxHidingUrl"] = 18] = "InternalEcpTeamMailboxHidingUrl";
        UserSettingName[UserSettingName["InternalEcpExtensionInstallationUrl"] = 19] = "InternalEcpExtensionInstallationUrl";
        UserSettingName[UserSettingName["InternalEwsUrl"] = 20] = "InternalEwsUrl";
        UserSettingName[UserSettingName["InternalEmwsUrl"] = 21] = "InternalEmwsUrl";
        UserSettingName[UserSettingName["InternalOABUrl"] = 22] = "InternalOABUrl";
        UserSettingName[UserSettingName["InternalPhotosUrl"] = 23] = "InternalPhotosUrl";
        UserSettingName[UserSettingName["InternalUMUrl"] = 24] = "InternalUMUrl";
        UserSettingName[UserSettingName["InternalWebClientUrls"] = 25] = "InternalWebClientUrls";
        UserSettingName[UserSettingName["MailboxDN"] = 26] = "MailboxDN";
        UserSettingName[UserSettingName["PublicFolderServer"] = 27] = "PublicFolderServer";
        UserSettingName[UserSettingName["ActiveDirectoryServer"] = 28] = "ActiveDirectoryServer";
        UserSettingName[UserSettingName["ExternalMailboxServer"] = 29] = "ExternalMailboxServer";
        UserSettingName[UserSettingName["ExternalMailboxServerRequiresSSL"] = 30] = "ExternalMailboxServerRequiresSSL";
        UserSettingName[UserSettingName["ExternalMailboxServerAuthenticationMethods"] = 31] = "ExternalMailboxServerAuthenticationMethods";
        UserSettingName[UserSettingName["EcpVoicemailUrlFragment"] = 32] = "EcpVoicemailUrlFragment";
        UserSettingName[UserSettingName["EcpEmailSubscriptionsUrlFragment"] = 33] = "EcpEmailSubscriptionsUrlFragment";
        UserSettingName[UserSettingName["EcpTextMessagingUrlFragment"] = 34] = "EcpTextMessagingUrlFragment";
        UserSettingName[UserSettingName["EcpDeliveryReportUrlFragment"] = 35] = "EcpDeliveryReportUrlFragment";
        UserSettingName[UserSettingName["EcpRetentionPolicyTagsUrlFragment"] = 36] = "EcpRetentionPolicyTagsUrlFragment";
        UserSettingName[UserSettingName["EcpPublishingUrlFragment"] = 37] = "EcpPublishingUrlFragment";
        UserSettingName[UserSettingName["EcpPhotoUrlFragment"] = 38] = "EcpPhotoUrlFragment";
        UserSettingName[UserSettingName["EcpConnectUrlFragment"] = 39] = "EcpConnectUrlFragment";
        UserSettingName[UserSettingName["EcpTeamMailboxUrlFragment"] = 40] = "EcpTeamMailboxUrlFragment";
        UserSettingName[UserSettingName["EcpTeamMailboxCreatingUrlFragment"] = 41] = "EcpTeamMailboxCreatingUrlFragment";
        UserSettingName[UserSettingName["EcpTeamMailboxEditingUrlFragment"] = 42] = "EcpTeamMailboxEditingUrlFragment";
        UserSettingName[UserSettingName["EcpExtensionInstallationUrlFragment"] = 43] = "EcpExtensionInstallationUrlFragment";
        UserSettingName[UserSettingName["ExternalEcpUrl"] = 44] = "ExternalEcpUrl";
        UserSettingName[UserSettingName["ExternalEcpVoicemailUrl"] = 45] = "ExternalEcpVoicemailUrl";
        UserSettingName[UserSettingName["ExternalEcpEmailSubscriptionsUrl"] = 46] = "ExternalEcpEmailSubscriptionsUrl";
        UserSettingName[UserSettingName["ExternalEcpTextMessagingUrl"] = 47] = "ExternalEcpTextMessagingUrl";
        UserSettingName[UserSettingName["ExternalEcpDeliveryReportUrl"] = 48] = "ExternalEcpDeliveryReportUrl";
        UserSettingName[UserSettingName["ExternalEcpRetentionPolicyTagsUrl"] = 49] = "ExternalEcpRetentionPolicyTagsUrl";
        UserSettingName[UserSettingName["ExternalEcpPublishingUrl"] = 50] = "ExternalEcpPublishingUrl";
        UserSettingName[UserSettingName["ExternalEcpPhotoUrl"] = 51] = "ExternalEcpPhotoUrl";
        UserSettingName[UserSettingName["ExternalEcpConnectUrl"] = 52] = "ExternalEcpConnectUrl";
        UserSettingName[UserSettingName["ExternalEcpTeamMailboxUrl"] = 53] = "ExternalEcpTeamMailboxUrl";
        UserSettingName[UserSettingName["ExternalEcpTeamMailboxCreatingUrl"] = 54] = "ExternalEcpTeamMailboxCreatingUrl";
        UserSettingName[UserSettingName["ExternalEcpTeamMailboxEditingUrl"] = 55] = "ExternalEcpTeamMailboxEditingUrl";
        UserSettingName[UserSettingName["ExternalEcpTeamMailboxHidingUrl"] = 56] = "ExternalEcpTeamMailboxHidingUrl";
        UserSettingName[UserSettingName["ExternalEcpExtensionInstallationUrl"] = 57] = "ExternalEcpExtensionInstallationUrl";
        UserSettingName[UserSettingName["ExternalEwsUrl"] = 58] = "ExternalEwsUrl";
        UserSettingName[UserSettingName["ExternalEmwsUrl"] = 59] = "ExternalEmwsUrl";
        UserSettingName[UserSettingName["ExternalOABUrl"] = 60] = "ExternalOABUrl";
        UserSettingName[UserSettingName["ExternalPhotosUrl"] = 61] = "ExternalPhotosUrl";
        UserSettingName[UserSettingName["ExternalUMUrl"] = 62] = "ExternalUMUrl";
        UserSettingName[UserSettingName["ExternalWebClientUrls"] = 63] = "ExternalWebClientUrls";
        UserSettingName[UserSettingName["CrossOrganizationSharingEnabled"] = 64] = "CrossOrganizationSharingEnabled";
        UserSettingName[UserSettingName["AlternateMailboxes"] = 65] = "AlternateMailboxes";
        UserSettingName[UserSettingName["CasVersion"] = 66] = "CasVersion";
        UserSettingName[UserSettingName["EwsSupportedSchemas"] = 67] = "EwsSupportedSchemas";
        UserSettingName[UserSettingName["InternalPop3Connections"] = 68] = "InternalPop3Connections";
        UserSettingName[UserSettingName["ExternalPop3Connections"] = 69] = "ExternalPop3Connections";
        UserSettingName[UserSettingName["InternalImap4Connections"] = 70] = "InternalImap4Connections";
        UserSettingName[UserSettingName["ExternalImap4Connections"] = 71] = "ExternalImap4Connections";
        UserSettingName[UserSettingName["InternalSmtpConnections"] = 72] = "InternalSmtpConnections";
        UserSettingName[UserSettingName["ExternalSmtpConnections"] = 73] = "ExternalSmtpConnections";
        UserSettingName[UserSettingName["InternalServerExclusiveConnect"] = 74] = "InternalServerExclusiveConnect";
        UserSettingName[UserSettingName["ExternalEwsVersion"] = 75] = "ExternalEwsVersion";
        UserSettingName[UserSettingName["MobileMailboxPolicy"] = 76] = "MobileMailboxPolicy";
        UserSettingName[UserSettingName["DocumentSharingLocations"] = 77] = "DocumentSharingLocations";
        UserSettingName[UserSettingName["UserMSOnline"] = 78] = "UserMSOnline";
        UserSettingName[UserSettingName["InternalMailboxServerAuthenticationMethods"] = 79] = "InternalMailboxServerAuthenticationMethods";
        UserSettingName[UserSettingName["MailboxVersion"] = 80] = "MailboxVersion";
        UserSettingName[UserSettingName["SPMySiteHostURL"] = 81] = "SPMySiteHostURL";
        UserSettingName[UserSettingName["SiteMailboxCreationURL"] = 82] = "SiteMailboxCreationURL";
        UserSettingName[UserSettingName["InternalRpcHttpServer"] = 83] = "InternalRpcHttpServer";
        UserSettingName[UserSettingName["InternalRpcHttpConnectivityRequiresSsl"] = 84] = "InternalRpcHttpConnectivityRequiresSsl";
        UserSettingName[UserSettingName["InternalRpcHttpAuthenticationMethod"] = 85] = "InternalRpcHttpAuthenticationMethod";
        UserSettingName[UserSettingName["ExternalServerExclusiveConnect"] = 86] = "ExternalServerExclusiveConnect";
        UserSettingName[UserSettingName["ExchangeRpcUrl"] = 87] = "ExchangeRpcUrl";
        UserSettingName[UserSettingName["ShowGalAsDefaultView"] = 88] = "ShowGalAsDefaultView";
        UserSettingName[UserSettingName["AutoDiscoverSMTPAddress"] = 89] = "AutoDiscoverSMTPAddress";
        UserSettingName[UserSettingName["InteropExternalEwsUrl"] = 90] = "InteropExternalEwsUrl";
        UserSettingName[UserSettingName["InteropExternalEwsVersion"] = 91] = "InteropExternalEwsVersion";
        UserSettingName[UserSettingName["PublicFolderInformation"] = 92] = "PublicFolderInformation";
        UserSettingName[UserSettingName["RedirectUrl"] = 93] = "RedirectUrl";
        UserSettingName[UserSettingName["EwsPartnerUrl"] = 94] = "EwsPartnerUrl";
        UserSettingName[UserSettingName["CertPrincipalName"] = 95] = "CertPrincipalName";
        UserSettingName[UserSettingName["GroupingInformation"] = 96] = "GroupingInformation";
    })(UserSettingName || (UserSettingName = {}));
    var AutodiscoverRemoteException = (function (_super) {
        __extends(AutodiscoverRemoteException, _super);
        function AutodiscoverRemoteException(errorOrMessage, error, innerException) {
            _super.call(this);
            this.error = null;
            if (arguments.length === 1 && (errorOrMessage === null || errorOrMessage instanceof AutodiscoverError)) {
                this.constructor_0(errorOrMessage);
                return;
            }
            if (arguments.length === 2 && (errorOrMessage === null || errorOrMessage.constructor === String) && (error === null || error instanceof AutodiscoverError)) {
                this.constructor_1(errorOrMessage, error);
                return;
            }
            this.constructor_2(errorOrMessage, error, innerException);
        }
        Object.defineProperty(AutodiscoverRemoteException.prototype, "Error", {
            get: function () {
                return this.error;
            },
            enumerable: true,
            configurable: true
        });
        AutodiscoverRemoteException.prototype.constructor_0 = function (error) {
            this.error = error;
        };
        AutodiscoverRemoteException.prototype.constructor_1 = function (message, error) {
            this.error = error;
        };
        AutodiscoverRemoteException.prototype.constructor_2 = function (message, error, innerException) {
            this.error = error;
        };
        return AutodiscoverRemoteException;
    }(ServiceRemoteException));
    var AutodiscoverResponseException = (function (_super) {
        __extends(AutodiscoverResponseException, _super);
        function AutodiscoverResponseException(errorCode, message) {
            _super.call(this, message);
            this.errorCode = 0;
            this.errorCode = errorCode;
        }
        Object.defineProperty(AutodiscoverResponseException.prototype, "ErrorCode", {
            get: function () {
                return this.errorCode;
            },
            enumerable: true,
            configurable: true
        });
        return AutodiscoverResponseException;
    }(ServiceRemoteException));
    var DnsClient = (function () {
        function DnsClient() {
            _super.call(this);
        }
        DnsClient.DnsQuery = function (domain, dnsServerAddress) {
            var list = new List();
            var recordType = DnsClient.typeToDnsTypeMap.Member.get_Item(new Type("T"));
            var zero = number.Zero;
            try {
                var num = (function () {
                    var _p0 = [
                        zero
                    ];
                    var _r = DnsNativeMethods.DnsQuery(domain, dnsServerAddress, recordType, _p0);
                    zero = _p0[0];
                    return _r;
                })();
                if (num !== 0) {
                    throw new DnsException(num);
                }
                var intPtr = zero;
                while (!NObject.GenericEquals(intPtr, number.Zero)) {
                    var header = Marshal.PtrToStructure(intPtr, new Type("DnsRecordHeader"));
                    var item = Activator.CreateInstance();
                    if (header.RecordType === item.RecordType) {
                        item.Load(header, intPtr);
                        list.Add(item);
                    }
                    intPtr = header.NextRecord;
                }
            }
            finally {
                if (zero !== number.Zero) {
                    DnsNativeMethods.FreeDnsQueryResults(zero);
                }
            }
            return list;
        };
        DnsClient.Win32Success = 0;
        DnsClient.typeToDnsTypeMap = new LazyMember(function () {
            var dictionary = new Dictionary();
            dictionary.Add(new Type("DnsSrvRecord"), DnsRecordType.SRV);
            return dictionary;
        });
        return DnsClient;
    }());
    var DnsNativeMethods = (function () {
        function DnsNativeMethods() {
            _super.call(this);
        }
        DnsNativeMethods.DnsQuery = function (pszNameOrDomain, wTypeOrDnsServerAddress, optionsOrRecordType, aipServersOrPpQueryResults, ppQueryResults, pReserved) {
            if (arguments.length === 6 && (pszNameOrDomain === null || pszNameOrDomain.constructor === String) && (wTypeOrDnsServerAddress === null || wTypeOrDnsServerAddress.constructor === Number) && (optionsOrRecordType === null || optionsOrRecordType.constructor === Number) && (aipServersOrPpQueryResults === null || aipServersOrPpQueryResults.constructor === Number) && (ppQueryResults[0] === null || ppQueryResults[0] instanceof Array) && (pReserved === null || pReserved.constructor === Number)) {
                return DnsNativeMethods.DnsQuery_0(pszNameOrDomain, wTypeOrDnsServerAddress, optionsOrRecordType, aipServersOrPpQueryResults, ppQueryResults[0], pReserved);
            }
            return DnsNativeMethods.DnsQuery_1(pszNameOrDomain, wTypeOrDnsServerAddress, optionsOrRecordType, aipServersOrPpQueryResults);
        };
        DnsNativeMethods.DnsQuery_0 = function (pszName, wType, options, aipServers, ppQueryResults, pReserved) {
            throw new NotSupportedException();
        };
        DnsNativeMethods.DnsRecordListFree = function (ptrRecords, freeType) {
            throw new NotSupportedException();
        };
        DnsNativeMethods.AllocDnsServerList = function (dnsServerAddress) {
            var intPtr = number.Zero;
            if (dnsServerAddress !== null) {
                var serverAddress = BitConverter.ToInt32(dnsServerAddress.GetAddressBytes(), 0);
                var dnsServerList;
                dnsServerList.AddressCount = 1;
                dnsServerList.ServerAddress = serverAddress;
                intPtr = Marshal.AllocHGlobal(Marshal.SizeOf(dnsServerList));
                Marshal.StructureToPtr(dnsServerList, intPtr, false);
            }
            return intPtr;
        };
        DnsNativeMethods.DnsQuery_1 = function (domain, dnsServerAddress, recordType, ppQueryResults) {
            var intPtr = number.Zero;
            var result;
            try {
                intPtr = DnsNativeMethods.AllocDnsServerList(dnsServerAddress);
                result = (function () {
                    var _p0 = [
                        ppQueryResults[0]
                    ];
                    var _r = DnsNativeMethods.DnsQuery(domain, recordType, DnsNativeMethods_DnsQueryOptions.DNS_QUERY_STANDARD, intPtr, _p0, 0);
                    ppQueryResults[0] = _p0[0];
                    return _r;
                })();
            }
            finally {
                Marshal.FreeHGlobal(intPtr);
            }
            return result;
        };
        DnsNativeMethods.FreeDnsQueryResults = function (ptrRecords) {
            DnsNativeMethods.DnsRecordListFree(ptrRecords, DnsNativeMethods_FreeType.RecordList);
        };
        DnsNativeMethods.DNSAPI = "dnsapi.dll";
        return DnsNativeMethods;
    }());
    var DnsNativeMethods_DnsServerList = (function () {
        function DnsNativeMethods_DnsServerList() {
            this.AddressCount = 0;
            this.ServerAddress = 0;
            _super.call(this);
        }
        return DnsNativeMethods_DnsServerList;
    }());
    var DnsNativeMethods_DnsQueryOptions;
    (function (DnsNativeMethods_DnsQueryOptions) {
        DnsNativeMethods_DnsQueryOptions[DnsNativeMethods_DnsQueryOptions["DNS_QUERY_STANDARD"] = 0] = "DNS_QUERY_STANDARD";
    })(DnsNativeMethods_DnsQueryOptions || (DnsNativeMethods_DnsQueryOptions = {}));
    var DnsNativeMethods_FreeType;
    (function (DnsNativeMethods_FreeType) {
        DnsNativeMethods_FreeType[DnsNativeMethods_FreeType["RecordList"] = 1] = "RecordList";
    })(DnsNativeMethods_FreeType || (DnsNativeMethods_FreeType = {}));
    var DnsRecord = (function () {
        function DnsRecord() {
            this.name = null;
            this.timeToLive = 0;
            this.RecordType = 0;
            _super.call(this);
        }
        Object.defineProperty(DnsRecord.prototype, "Name", {
            get: function () {
                return this.name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DnsRecord.prototype, "TimeToLive", {
            get: function () {
                return TimeSpan.FromSeconds(this.timeToLive);
            },
            enumerable: true,
            configurable: true
        });
        DnsRecord.prototype.Load = function (header, dataPointer) {
            this.name = header.Name;
            this.timeToLive = Math.max(1, header.Ttl);
        };
        return DnsRecord;
    }());
    var DnsRecordHeader = (function () {
        function DnsRecordHeader() {
            this.NextRecord = null;
            this.Name = null;
            this.RecordType = 0;
            this.DataLength = 0;
            this.Flags = 0;
            this.Ttl = 0;
            this.Reserved = 0;
            _super.call(this);
        }
        return DnsRecordHeader;
    }());
    var DnsSrvRecord = (function (_super) {
        __extends(DnsSrvRecord, _super);
        function DnsSrvRecord() {
            _super.call(this);
            this.target = null;
            this.priority = 0;
            this.weight = 0;
            this.port = 0;
        }
        Object.defineProperty(DnsSrvRecord.prototype, "RecordType", {
            get: function () {
                return DnsRecordType.SRV;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DnsSrvRecord.prototype, "NameTarget", {
            get: function () {
                return this.target;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DnsSrvRecord.prototype, "Priority", {
            get: function () {
                return this.priority;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DnsSrvRecord.prototype, "Weight", {
            get: function () {
                return this.weight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DnsSrvRecord.prototype, "Port", {
            get: function () {
                return this.port;
            },
            enumerable: true,
            configurable: true
        });
        DnsSrvRecord.prototype.Load = function (header, dataPointer) {
            _super.prototype.Load.call(this, header, dataPointer);
            var win32DnsSrvRecord = Marshal.PtrToStructure(dataPointer, new Type("DnsSrvRecord_Win32DnsSrvRecord"));
            this.target = win32DnsSrvRecord.NameTarget;
            this.priority = win32DnsSrvRecord.Priority;
            this.weight = win32DnsSrvRecord.Weight;
            this.port = win32DnsSrvRecord.Port;
        };
        return DnsSrvRecord;
    }(DnsRecord));
    var DnsSrvRecord_Win32DnsSrvRecord = (function () {
        function DnsSrvRecord_Win32DnsSrvRecord() {
            this.Header = null;
            this.NameTarget = null;
            this.Priority = 0;
            this.Weight = 0;
            this.Port = 0;
            this.Pad = 0;
            _super.call(this);
        }
        return DnsSrvRecord_Win32DnsSrvRecord;
    }());
    var DnsRecordType;
    (function (DnsRecordType) {
        DnsRecordType[DnsRecordType["A"] = 1] = "A";
        DnsRecordType[DnsRecordType["CNAME"] = 5] = "CNAME";
        DnsRecordType[DnsRecordType["SOA"] = 6] = "SOA";
        DnsRecordType[DnsRecordType["PTR"] = 12] = "PTR";
        DnsRecordType[DnsRecordType["MX"] = 15] = "MX";
        DnsRecordType[DnsRecordType["TXT"] = 16] = "TXT";
        DnsRecordType[DnsRecordType["AAAA"] = 28] = "AAAA";
        DnsRecordType[DnsRecordType["SRV"] = 33] = "SRV";
    })(DnsRecordType || (DnsRecordType = {}));
    var DnsException = (function (_super) {
        __extends(DnsException, _super);
        function DnsException(errorCode) {
            _super.call(this, errorCode);
        }
        return DnsException;
    }(Win32Exception));
    var Strings = (function () {
        function Strings() {
        }
        Object.defineProperty(Strings, "CannotRemoveSubscriptionFromLiveConnection", {
            get: function () {
                return new LocalizedString("CannotRemoveSubscriptionFromLiveConnection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ReadAccessInvalidForNonCalendarFolder", {
            get: function () {
                return new LocalizedString("ReadAccessInvalidForNonCalendarFolder", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyDefinitionPropertyMustBeSet", {
            get: function () {
                return new LocalizedString("PropertyDefinitionPropertyMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ArgumentIsBlankString", {
            get: function () {
                return new LocalizedString("ArgumentIsBlankString", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverDomainsCount", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverDomainsCount", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MinutesMustBeBetween0And1439", {
            get: function () {
                return new LocalizedString("MinutesMustBeBetween0And1439", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DeleteInvalidForUnsavedUserConfiguration", {
            get: function () {
                return new LocalizedString("DeleteInvalidForUnsavedUserConfiguration", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PeriodNotFound", {
            get: function () {
                return new LocalizedString("PeriodNotFound", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverSmtpAddress", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverSmtpAddress", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidOAuthToken", {
            get: function () {
                return new LocalizedString("InvalidOAuthToken", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MaxScpHopsExceeded", {
            get: function () {
                return new LocalizedString("MaxScpHopsExceeded", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst", {
            get: function () {
                return new LocalizedString("ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CurrentPositionNotElementStart", {
            get: function () {
                return new LocalizedString("CurrentPositionNotElementStart", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotConvertBetweenTimeZones", {
            get: function () {
                return new LocalizedString("CannotConvertBetweenTimeZones", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FrequencyMustBeBetween1And1440", {
            get: function () {
                return new LocalizedString("FrequencyMustBeBetween1And1440", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotSetDelegateFolderPermissionLevelToCustom", {
            get: function () {
                return new LocalizedString("CannotSetDelegateFolderPermissionLevelToCustom", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PartnerTokenIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("PartnerTokenIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverRequest", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverRequest", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAsyncResult", {
            get: function () {
                return new LocalizedString("InvalidAsyncResult", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidMailboxType", {
            get: function () {
                return new LocalizedString("InvalidMailboxType", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AttachmentCollectionNotLoaded", {
            get: function () {
                return new LocalizedString("AttachmentCollectionNotLoaded", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ParameterIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("ParameterIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DayOfWeekIndexMustBeSpecifiedForRecurrencePattern", {
            get: function () {
                return new LocalizedString("DayOfWeekIndexMustBeSpecifiedForRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "WLIDCredentialsCannotBeUsedWithLegacyAutodiscover", {
            get: function () {
                return new LocalizedString("WLIDCredentialsCannotBeUsedWithLegacyAutodiscover", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyCannotBeUpdated", {
            get: function () {
                return new LocalizedString("PropertyCannotBeUpdated", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IncompatibleTypeForArray", {
            get: function () {
                return new LocalizedString("IncompatibleTypeForArray", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PercentCompleteMustBeBetween0And100", {
            get: function () {
                return new LocalizedString("PercentCompleteMustBeBetween0And100", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverServiceIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("AutodiscoverServiceIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverSmtpAddressesCount", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverSmtpAddressesCount", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServiceUrlMustBeSet", {
            get: function () {
                return new LocalizedString("ServiceUrlMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ItemTypeNotCompatible", {
            get: function () {
                return new LocalizedString("ItemTypeNotCompatible", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AttachmentItemTypeMismatch", {
            get: function () {
                return new LocalizedString("AttachmentItemTypeMismatch", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnsupportedWebProtocol", {
            get: function () {
                return new LocalizedString("UnsupportedWebProtocol", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "EnumValueIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("EnumValueIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnexpectedElement", {
            get: function () {
                return new LocalizedString("UnexpectedElement", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidOrderBy", {
            get: function () {
                return new LocalizedString("InvalidOrderBy", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NoAppropriateConstructorForItemClass", {
            get: function () {
                return new LocalizedString("NoAppropriateConstructorForItemClass", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "SearchFilterAtIndexIsInvalid", {
            get: function () {
                return new LocalizedString("SearchFilterAtIndexIsInvalid", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DeletingThisObjectTypeNotAuthorized", {
            get: function () {
                return new LocalizedString("DeletingThisObjectTypeNotAuthorized", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyCannotBeDeleted", {
            get: function () {
                return new LocalizedString("PropertyCannotBeDeleted", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValuePropertyMustBeSet", {
            get: function () {
                return new LocalizedString("ValuePropertyMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TagValueIsOutOfRange", {
            get: function () {
                return new LocalizedString("TagValueIsOutOfRange", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ItemToUpdateCannotBeNullOrNew", {
            get: function () {
                return new LocalizedString("ItemToUpdateCannotBeNullOrNew", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "SearchParametersRootFolderIdsEmpty", {
            get: function () {
                return new LocalizedString("SearchParametersRootFolderIdsEmpty", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MailboxQueriesParameterIsNotSpecified", {
            get: function () {
                return new LocalizedString("MailboxQueriesParameterIsNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FolderPermissionHasInvalidUserId", {
            get: function () {
                return new LocalizedString("FolderPermissionHasInvalidUserId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverDomain", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverDomain", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MailboxesParameterIsNotSpecified", {
            get: function () {
                return new LocalizedString("MailboxesParameterIsNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ParentFolderDoesNotHaveId", {
            get: function () {
                return new LocalizedString("ParentFolderDoesNotHaveId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DayOfMonthMustBeSpecifiedForRecurrencePattern", {
            get: function () {
                return new LocalizedString("DayOfMonthMustBeSpecifiedForRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ClassIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("ClassIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CertificateHasNoPrivateKey", {
            get: function () {
                return new LocalizedString("CertificateHasNoPrivateKey", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidOrUnsupportedTimeZoneDefinition", {
            get: function () {
                return new LocalizedString("InvalidOrUnsupportedTimeZoneDefinition", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "HourMustBeBetween0And23", {
            get: function () {
                return new LocalizedString("HourMustBeBetween0And23", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TimeoutMustBeBetween1And1440", {
            get: function () {
                return new LocalizedString("TimeoutMustBeBetween1And1440", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CredentialsRequired", {
            get: function () {
                return new LocalizedString("CredentialsRequired", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MustLoadOrAssignPropertyBeforeAccess", {
            get: function () {
                return new LocalizedString("MustLoadOrAssignPropertyBeforeAccess", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverServiceResponse", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverServiceResponse", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotCallConnectDuringLiveConnection", {
            get: function () {
                return new LocalizedString("CannotCallConnectDuringLiveConnection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ObjectDoesNotHaveId", {
            get: function () {
                return new LocalizedString("ObjectDoesNotHaveId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotAddSubscriptionToLiveConnection", {
            get: function () {
                return new LocalizedString("CannotAddSubscriptionToLiveConnection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MaxChangesMustBeBetween1And512", {
            get: function () {
                return new LocalizedString("MaxChangesMustBeBetween1And512", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AttributeValueCannotBeSerialized", {
            get: function () {
                return new LocalizedString("AttributeValueCannotBeSerialized", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "SearchFilterMustBeSet", {
            get: function () {
                return new LocalizedString("SearchFilterMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "EndDateMustBeGreaterThanStartDate", {
            get: function () {
                return new LocalizedString("EndDateMustBeGreaterThanStartDate", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidDateTime", {
            get: function () {
                return new LocalizedString("InvalidDateTime", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UpdateItemsDoesNotAllowAttachments", {
            get: function () {
                return new LocalizedString("UpdateItemsDoesNotAllowAttachments", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TimeoutMustBeGreaterThanZero", {
            get: function () {
                return new LocalizedString("TimeoutMustBeGreaterThanZero", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverInvalidSettingForOutlookProvider", {
            get: function () {
                return new LocalizedString("AutodiscoverInvalidSettingForOutlookProvider", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidRedirectionResponseReturned", {
            get: function () {
                return new LocalizedString("InvalidRedirectionResponseReturned", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ExpectedStartElement", {
            get: function () {
                return new LocalizedString("ExpectedStartElement", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DaysOfTheWeekNotSpecified", {
            get: function () {
                return new LocalizedString("DaysOfTheWeekNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FolderToUpdateCannotBeNullOrNew", {
            get: function () {
                return new LocalizedString("FolderToUpdateCannotBeNullOrNew", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PartnerTokenRequestRequiresUrl", {
            get: function () {
                return new LocalizedString("PartnerTokenRequestRequiresUrl", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NumberOfOccurrencesMustBeGreaterThanZero", {
            get: function () {
                return new LocalizedString("NumberOfOccurrencesMustBeGreaterThanZero", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "JsonSerializationNotImplemented", {
            get: function () {
                return new LocalizedString("JsonSerializationNotImplemented", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "StartTimeZoneRequired", {
            get: function () {
                return new LocalizedString("StartTimeZoneRequired", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyAlreadyExistsInOrderByCollection", {
            get: function () {
                return new LocalizedString("PropertyAlreadyExistsInOrderByCollection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ItemAttachmentMustBeNamed", {
            get: function () {
                return new LocalizedString("ItemAttachmentMustBeNamed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAutodiscoverSettingsCount", {
            get: function () {
                return new LocalizedString("InvalidAutodiscoverSettingsCount", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "LoadingThisObjectTypeNotSupported", {
            get: function () {
                return new LocalizedString("LoadingThisObjectTypeNotSupported", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UserIdForDelegateUserNotSpecified", {
            get: function () {
                return new LocalizedString("UserIdForDelegateUserNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PhoneCallAlreadyDisconnected", {
            get: function () {
                return new LocalizedString("PhoneCallAlreadyDisconnected", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "OperationDoesNotSupportAttachments", {
            get: function () {
                return new LocalizedString("OperationDoesNotSupportAttachments", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnsupportedTimeZonePeriodTransitionTarget", {
            get: function () {
                return new LocalizedString("UnsupportedTimeZonePeriodTransitionTarget", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IEnumerableDoesNotContainThatManyObject", {
            get: function () {
                return new LocalizedString("IEnumerableDoesNotContainThatManyObject", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UpdateItemsDoesNotSupportNewOrUnchangedItems", {
            get: function () {
                return new LocalizedString("UpdateItemsDoesNotSupportNewOrUnchangedItems", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValidationFailed", {
            get: function () {
                return new LocalizedString("ValidationFailed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidRecurrencePattern", {
            get: function () {
                return new LocalizedString("InvalidRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TimeWindowStartTimeMustBeGreaterThanEndTime", {
            get: function () {
                return new LocalizedString("TimeWindowStartTimeMustBeGreaterThanEndTime", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAttributeValue", {
            get: function () {
                return new LocalizedString("InvalidAttributeValue", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FileAttachmentContentIsNotSet", {
            get: function () {
                return new LocalizedString("FileAttachmentContentIsNotSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverDidNotReturnEwsUrl", {
            get: function () {
                return new LocalizedString("AutodiscoverDidNotReturnEwsUrl", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "RecurrencePatternMustHaveStartDate", {
            get: function () {
                return new LocalizedString("RecurrencePatternMustHaveStartDate", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "OccurrenceIndexMustBeGreaterThanZero", {
            get: function () {
                return new LocalizedString("OccurrenceIndexMustBeGreaterThanZero", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServiceResponseDoesNotContainXml", {
            get: function () {
                return new LocalizedString("ServiceResponseDoesNotContainXml", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ItemIsOutOfDate", {
            get: function () {
                return new LocalizedString("ItemIsOutOfDate", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MinuteMustBeBetween0And59", {
            get: function () {
                return new LocalizedString("MinuteMustBeBetween0And59", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NoSoapOrWsSecurityEndpointAvailable", {
            get: function () {
                return new LocalizedString("NoSoapOrWsSecurityEndpointAvailable", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ElementNotFound", {
            get: function () {
                return new LocalizedString("ElementNotFound", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IndexIsOutOfRange", {
            get: function () {
                return new LocalizedString("IndexIsOutOfRange", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyIsReadOnly", {
            get: function () {
                return new LocalizedString("PropertyIsReadOnly", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AttachmentCreationFailed", {
            get: function () {
                return new LocalizedString("AttachmentCreationFailed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DayOfMonthMustBeBetween1And31", {
            get: function () {
                return new LocalizedString("DayOfMonthMustBeBetween1And31", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServiceRequestFailed", {
            get: function () {
                return new LocalizedString("ServiceRequestFailed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DelegateUserHasInvalidUserId", {
            get: function () {
                return new LocalizedString("DelegateUserHasInvalidUserId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "SearchFilterComparisonValueTypeIsNotSupported", {
            get: function () {
                return new LocalizedString("SearchFilterComparisonValueTypeIsNotSupported", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ElementValueCannotBeSerialized", {
            get: function () {
                return new LocalizedString("ElementValueCannotBeSerialized", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyValueMustBeSpecifiedForRecurrencePattern", {
            get: function () {
                return new LocalizedString("PropertyValueMustBeSpecifiedForRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NonSummaryPropertyCannotBeUsed", {
            get: function () {
                return new LocalizedString("NonSummaryPropertyCannotBeUsed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "HoldIdParameterIsNotSpecified", {
            get: function () {
                return new LocalizedString("HoldIdParameterIsNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TransitionGroupNotFound", {
            get: function () {
                return new LocalizedString("TransitionGroupNotFound", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ObjectTypeNotSupported", {
            get: function () {
                return new LocalizedString("ObjectTypeNotSupported", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidTimeoutValue", {
            get: function () {
                return new LocalizedString("InvalidTimeoutValue", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverRedirectBlocked", {
            get: function () {
                return new LocalizedString("AutodiscoverRedirectBlocked", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertySetCannotBeModified", {
            get: function () {
                return new LocalizedString("PropertySetCannotBeModified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DayOfTheWeekMustBeSpecifiedForRecurrencePattern", {
            get: function () {
                return new LocalizedString("DayOfTheWeekMustBeSpecifiedForRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServiceObjectAlreadyHasId", {
            get: function () {
                return new LocalizedString("ServiceObjectAlreadyHasId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MethodIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("MethodIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "OperationNotSupportedForPropertyDefinitionType", {
            get: function () {
                return new LocalizedString("OperationNotSupportedForPropertyDefinitionType", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidElementStringValue", {
            get: function () {
                return new LocalizedString("InvalidElementStringValue", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CollectionIsEmpty", {
            get: function () {
                return new LocalizedString("CollectionIsEmpty", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidFrequencyValue", {
            get: function () {
                return new LocalizedString("InvalidFrequencyValue", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnexpectedEndOfXmlDocument", {
            get: function () {
                return new LocalizedString("UnexpectedEndOfXmlDocument", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FolderTypeNotCompatible", {
            get: function () {
                return new LocalizedString("FolderTypeNotCompatible", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "RequestIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("RequestIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyTypeIncompatibleWhenUpdatingCollection", {
            get: function () {
                return new LocalizedString("PropertyTypeIncompatibleWhenUpdatingCollection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServerVersionNotSupported", {
            get: function () {
                return new LocalizedString("ServerVersionNotSupported", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "DurationMustBeSpecifiedWhenScheduled", {
            get: function () {
                return new LocalizedString("DurationMustBeSpecifiedWhenScheduled", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NoError", {
            get: function () {
                return new LocalizedString("NoError", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotUpdateNewUserConfiguration", {
            get: function () {
                return new LocalizedString("CannotUpdateNewUserConfiguration", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ObjectTypeIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("ObjectTypeIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NullStringArrayElementInvalid", {
            get: function () {
                return new LocalizedString("NullStringArrayElementInvalid", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "HttpsIsRequired", {
            get: function () {
                return new LocalizedString("HttpsIsRequired", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MergedFreeBusyIntervalMustBeSmallerThanTimeWindow", {
            get: function () {
                return new LocalizedString("MergedFreeBusyIntervalMustBeSmallerThanTimeWindow", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "SecondMustBeBetween0And59", {
            get: function () {
                return new LocalizedString("SecondMustBeBetween0And59", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AtLeastOneAttachmentCouldNotBeDeleted", {
            get: function () {
                return new LocalizedString("AtLeastOneAttachmentCouldNotBeDeleted", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IdAlreadyInList", {
            get: function () {
                return new LocalizedString("IdAlreadyInList", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "BothSearchFilterAndQueryStringCannotBeSpecified", {
            get: function () {
                return new LocalizedString("BothSearchFilterAndQueryStringCannotBeSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AdditionalPropertyIsNull", {
            get: function () {
                return new LocalizedString("AdditionalPropertyIsNull", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidEmailAddress", {
            get: function () {
                return new LocalizedString("InvalidEmailAddress", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MaximumRedirectionHopsExceeded", {
            get: function () {
                return new LocalizedString("MaximumRedirectionHopsExceeded", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverCouldNotBeLocated", {
            get: function () {
                return new LocalizedString("AutodiscoverCouldNotBeLocated", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NoSubscriptionsOnConnection", {
            get: function () {
                return new LocalizedString("NoSubscriptionsOnConnection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PermissionLevelInvalidForNonCalendarFolder", {
            get: function () {
                return new LocalizedString("PermissionLevelInvalidForNonCalendarFolder", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidAuthScheme", {
            get: function () {
                return new LocalizedString("InvalidAuthScheme", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "JsonDeserializationNotImplemented", {
            get: function () {
                return new LocalizedString("JsonDeserializationNotImplemented", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValuePropertyNotLoaded", {
            get: function () {
                return new LocalizedString("ValuePropertyNotLoaded", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyIncompatibleWithRequestVersion", {
            get: function () {
                return new LocalizedString("PropertyIncompatibleWithRequestVersion", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "OffsetMustBeGreaterThanZero", {
            get: function () {
                return new LocalizedString("OffsetMustBeGreaterThanZero", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CreateItemsDoesNotAllowAttachments", {
            get: function () {
                return new LocalizedString("CreateItemsDoesNotAllowAttachments", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyDefinitionTypeMismatch", {
            get: function () {
                return new LocalizedString("PropertyDefinitionTypeMismatch", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IntervalMustBeGreaterOrEqualToOne", {
            get: function () {
                return new LocalizedString("IntervalMustBeGreaterOrEqualToOne", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotSetPermissionLevelToCustom", {
            get: function () {
                return new LocalizedString("CannotSetPermissionLevelToCustom", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotAddRequestHeader", {
            get: function () {
                return new LocalizedString("CannotAddRequestHeader", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ArrayMustHaveAtLeastOneElement", {
            get: function () {
                return new LocalizedString("ArrayMustHaveAtLeastOneElement", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MonthMustBeSpecifiedForRecurrencePattern", {
            get: function () {
                return new LocalizedString("MonthMustBeSpecifiedForRecurrencePattern", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValueOfTypeCannotBeConverted", {
            get: function () {
                return new LocalizedString("ValueOfTypeCannotBeConverted", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValueCannotBeConverted", {
            get: function () {
                return new LocalizedString("ValueCannotBeConverted", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServerErrorAndStackTraceDetails", {
            get: function () {
                return new LocalizedString("ServerErrorAndStackTraceDetails", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "FolderPermissionLevelMustBeSet", {
            get: function () {
                return new LocalizedString("FolderPermissionLevelMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverError", {
            get: function () {
                return new LocalizedString("AutodiscoverError", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ArrayMustHaveSingleDimension", {
            get: function () {
                return new LocalizedString("ArrayMustHaveSingleDimension", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidPropertyValueNotInRange", {
            get: function () {
                return new LocalizedString("InvalidPropertyValueNotInRange", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "RegenerationPatternsOnlyValidForTasks", {
            get: function () {
                return new LocalizedString("RegenerationPatternsOnlyValidForTasks", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ItemAttachmentCannotBeUpdated", {
            get: function () {
                return new LocalizedString("ItemAttachmentCannotBeUpdated", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "EqualityComparisonFilterIsInvalid", {
            get: function () {
                return new LocalizedString("EqualityComparisonFilterIsInvalid", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AutodiscoverServiceRequestRequiresDomainOrUrl", {
            get: function () {
                return new LocalizedString("AutodiscoverServiceRequestRequiresDomainOrUrl", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidUser", {
            get: function () {
                return new LocalizedString("InvalidUser", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AccountIsLocked", {
            get: function () {
                return new LocalizedString("AccountIsLocked", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidDomainName", {
            get: function () {
                return new LocalizedString("InvalidDomainName", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "TooFewServiceReponsesReturned", {
            get: function () {
                return new LocalizedString("TooFewServiceReponsesReturned", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotSubscribeToStatusEvents", {
            get: function () {
                return new LocalizedString("CannotSubscribeToStatusEvents", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidSortByPropertyForMailboxSearch", {
            get: function () {
                return new LocalizedString("InvalidSortByPropertyForMailboxSearch", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnexpectedElementType", {
            get: function () {
                return new LocalizedString("UnexpectedElementType", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValueMustBeGreaterThanZero", {
            get: function () {
                return new LocalizedString("ValueMustBeGreaterThanZero", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "AttachmentCannotBeUpdated", {
            get: function () {
                return new LocalizedString("AttachmentCannotBeUpdated", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CreateItemsDoesNotHandleExistingItems", {
            get: function () {
                return new LocalizedString("CreateItemsDoesNotHandleExistingItems", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "MultipleContactPhotosInAttachment", {
            get: function () {
                return new LocalizedString("MultipleContactPhotosInAttachment", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "InvalidRecurrenceRange", {
            get: function () {
                return new LocalizedString("InvalidRecurrenceRange", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotSetBothImpersonatedAndPrivilegedUser", {
            get: function () {
                return new LocalizedString("CannotSetBothImpersonatedAndPrivilegedUser", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "NewMessagesWithAttachmentsCannotBeSentDirectly", {
            get: function () {
                return new LocalizedString("NewMessagesWithAttachmentsCannotBeSentDirectly", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotCallDisconnectWithNoLiveConnection", {
            get: function () {
                return new LocalizedString("CannotCallDisconnectWithNoLiveConnection", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "IdPropertyMustBeSet", {
            get: function () {
                return new LocalizedString("IdPropertyMustBeSet", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ValuePropertyNotAssigned", {
            get: function () {
                return new LocalizedString("ValuePropertyNotAssigned", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ZeroLengthArrayInvalid", {
            get: function () {
                return new LocalizedString("ZeroLengthArrayInvalid", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "HoldMailboxesParameterIsNotSpecified", {
            get: function () {
                return new LocalizedString("HoldMailboxesParameterIsNotSpecified", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "CannotSaveNotNewUserConfiguration", {
            get: function () {
                return new LocalizedString("CannotSaveNotNewUserConfiguration", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "ServiceObjectDoesNotHaveId", {
            get: function () {
                return new LocalizedString("ServiceObjectDoesNotHaveId", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "PropertyCollectionSizeMismatch", {
            get: function () {
                return new LocalizedString("PropertyCollectionSizeMismatch", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "XsDurationCouldNotBeParsed", {
            get: function () {
                return new LocalizedString("XsDurationCouldNotBeParsed", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Strings, "UnknownTimeZonePeriodTransitionType", {
            get: function () {
                return new LocalizedString("UnknownTimeZonePeriodTransitionType", Strings.ResourceManager, new Array(0));
            },
            enumerable: true,
            configurable: true
        });
        Strings.Strings_cctor = function () {
            Strings.stringIDs = new Dictionary(192);
            Strings.ResourceManager = ExchangeResourceManager.GetResourceManager("Microsoft.Exchange.WebServices.Strings", new Type("Strings").Assembly);
            Strings.stringIDs.Add(1631423810, "CannotRemoveSubscriptionFromLiveConnection");
            Strings.stringIDs.Add(3355844483, "ReadAccessInvalidForNonCalendarFolder");
            Strings.stringIDs.Add(1413133863, "PropertyDefinitionPropertyMustBeSet");
            Strings.stringIDs.Add(2808916828, "ArgumentIsBlankString");
            Strings.stringIDs.Add(2110564001, "InvalidAutodiscoverDomainsCount");
            Strings.stringIDs.Add(3846446647, "MinutesMustBeBetween0And1439");
            Strings.stringIDs.Add(3725066606, "DeleteInvalidForUnsavedUserConfiguration");
            Strings.stringIDs.Add(732877372, "PeriodNotFound");
            Strings.stringIDs.Add(742945049, "InvalidAutodiscoverSmtpAddress");
            Strings.stringIDs.Add(2371807741, "InvalidOAuthToken");
            Strings.stringIDs.Add(540781291, "MaxScpHopsExceeded");
            Strings.stringIDs.Add(412932664, "ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst");
            Strings.stringIDs.Add(3932722495, "CurrentPositionNotElementStart");
            Strings.stringIDs.Add(1762296216, "CannotConvertBetweenTimeZones");
            Strings.stringIDs.Add(2947629837, "FrequencyMustBeBetween1And1440");
            Strings.stringIDs.Add(4255072555, "CannotSetDelegateFolderPermissionLevelToCustom");
            Strings.stringIDs.Add(231532733, "PartnerTokenIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(216906786, "InvalidAutodiscoverRequest");
            Strings.stringIDs.Add(2795977038, "InvalidAsyncResult");
            Strings.stringIDs.Add(1875536889, "InvalidMailboxType");
            Strings.stringIDs.Add(368467777, "AttachmentCollectionNotLoaded");
            Strings.stringIDs.Add(1937216341, "ParameterIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(814325722, "DayOfWeekIndexMustBeSpecifiedForRecurrencePattern");
            Strings.stringIDs.Add(365885070, "WLIDCredentialsCannotBeUsedWithLegacyAutodiscover");
            Strings.stringIDs.Add(2534953608, "PropertyCannotBeUpdated");
            Strings.stringIDs.Add(3820761979, "IncompatibleTypeForArray");
            Strings.stringIDs.Add(3936886128, "PercentCompleteMustBeBetween0And100");
            Strings.stringIDs.Add(460414997, "AutodiscoverServiceIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(1774410042, "InvalidAutodiscoverSmtpAddressesCount");
            Strings.stringIDs.Add(1922401890, "ServiceUrlMustBeSet");
            Strings.stringIDs.Add(4181025268, "ItemTypeNotCompatible");
            Strings.stringIDs.Add(1516841384, "AttachmentItemTypeMismatch");
            Strings.stringIDs.Add(3620572079, "UnsupportedWebProtocol");
            Strings.stringIDs.Add(777131942, "EnumValueIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(2080190431, "UnexpectedElement");
            Strings.stringIDs.Add(162617974, "InvalidOrderBy");
            Strings.stringIDs.Add(3730786468, "NoAppropriateConstructorForItemClass");
            Strings.stringIDs.Add(1334400254, "SearchFilterAtIndexIsInvalid");
            Strings.stringIDs.Add(3957228737, "DeletingThisObjectTypeNotAuthorized");
            Strings.stringIDs.Add(2011990502, "PropertyCannotBeDeleted");
            Strings.stringIDs.Add(49538054, "ValuePropertyMustBeSet");
            Strings.stringIDs.Add(4177209255, "TagValueIsOutOfRange");
            Strings.stringIDs.Add(893972063, "ItemToUpdateCannotBeNullOrNew");
            Strings.stringIDs.Add(2492696699, "SearchParametersRootFolderIdsEmpty");
            Strings.stringIDs.Add(2182404464, "MailboxQueriesParameterIsNotSpecified");
            Strings.stringIDs.Add(3079787672, "FolderPermissionHasInvalidUserId");
            Strings.stringIDs.Add(95137117, "InvalidAutodiscoverDomain");
            Strings.stringIDs.Add(1274908260, "MailboxesParameterIsNotSpecified");
            Strings.stringIDs.Add(3207115397, "ParentFolderDoesNotHaveId");
            Strings.stringIDs.Add(190140884, "DayOfMonthMustBeSpecifiedForRecurrencePattern");
            Strings.stringIDs.Add(886236812, "ClassIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(956539910, "CertificateHasNoPrivateKey");
            Strings.stringIDs.Add(2660350763, "InvalidOrUnsupportedTimeZoneDefinition");
            Strings.stringIDs.Add(980862610, "HourMustBeBetween0And23");
            Strings.stringIDs.Add(1864811546, "TimeoutMustBeBetween1And1440");
            Strings.stringIDs.Add(107509017, "CredentialsRequired");
            Strings.stringIDs.Add(1301287431, "MustLoadOrAssignPropertyBeforeAccess");
            Strings.stringIDs.Add(2421645987, "InvalidAutodiscoverServiceResponse");
            Strings.stringIDs.Add(3637880390, "CannotCallConnectDuringLiveConnection");
            Strings.stringIDs.Add(1990317298, "ObjectDoesNotHaveId");
            Strings.stringIDs.Add(2374077290, "CannotAddSubscriptionToLiveConnection");
            Strings.stringIDs.Add(3989266019, "MaxChangesMustBeBetween1And512");
            Strings.stringIDs.Add(3745271395, "AttributeValueCannotBeSerialized");
            Strings.stringIDs.Add(2182989540, "SearchFilterMustBeSet");
            Strings.stringIDs.Add(2696927076, "EndDateMustBeGreaterThanStartDate");
            Strings.stringIDs.Add(3410810540, "InvalidDateTime");
            Strings.stringIDs.Add(2505974152, "UpdateItemsDoesNotAllowAttachments");
            Strings.stringIDs.Add(3210574608, "TimeoutMustBeGreaterThanZero");
            Strings.stringIDs.Add(81925120, "AutodiscoverInvalidSettingForOutlookProvider");
            Strings.stringIDs.Add(706868687, "InvalidRedirectionResponseReturned");
            Strings.stringIDs.Add(3728006586, "ExpectedStartElement");
            Strings.stringIDs.Add(2925351706, "DaysOfTheWeekNotSpecified");
            Strings.stringIDs.Add(2887145506, "FolderToUpdateCannotBeNullOrNew");
            Strings.stringIDs.Add(1709653493, "PartnerTokenRequestRequiresUrl");
            Strings.stringIDs.Add(4020293177, "NumberOfOccurrencesMustBeGreaterThanZero");
            Strings.stringIDs.Add(537341821, "JsonSerializationNotImplemented");
            Strings.stringIDs.Add(263088904, "StartTimeZoneRequired");
            Strings.stringIDs.Add(2291792901, "PropertyAlreadyExistsInOrderByCollection");
            Strings.stringIDs.Add(2209938519, "ItemAttachmentMustBeNamed");
            Strings.stringIDs.Add(2688936715, "InvalidAutodiscoverSettingsCount");
            Strings.stringIDs.Add(1313605428, "LoadingThisObjectTypeNotSupported");
            Strings.stringIDs.Add(3460610998, "UserIdForDelegateUserNotSpecified");
            Strings.stringIDs.Add(2720737469, "PhoneCallAlreadyDisconnected");
            Strings.stringIDs.Add(1464025756, "OperationDoesNotSupportAttachments");
            Strings.stringIDs.Add(98512741, "UnsupportedTimeZonePeriodTransitionTarget");
            Strings.stringIDs.Add(474853648, "IEnumerableDoesNotContainThatManyObject");
            Strings.stringIDs.Add(953072612, "UpdateItemsDoesNotSupportNewOrUnchangedItems");
            Strings.stringIDs.Add(1341796948, "ValidationFailed");
            Strings.stringIDs.Add(3636462697, "InvalidRecurrencePattern");
            Strings.stringIDs.Add(4170253059, "TimeWindowStartTimeMustBeGreaterThanEndTime");
            Strings.stringIDs.Add(369811396, "InvalidAttributeValue");
            Strings.stringIDs.Add(2449142619, "FileAttachmentContentIsNotSet");
            Strings.stringIDs.Add(628121484, "AutodiscoverDidNotReturnEwsUrl");
            Strings.stringIDs.Add(423461609, "RecurrencePatternMustHaveStartDate");
            Strings.stringIDs.Add(1396112272, "OccurrenceIndexMustBeGreaterThanZero");
            Strings.stringIDs.Add(1981959699, "ServiceResponseDoesNotContainXml");
            Strings.stringIDs.Add(2560682386, "ItemIsOutOfDate");
            Strings.stringIDs.Add(3637133283, "MinuteMustBeBetween0And59");
            Strings.stringIDs.Add(3954825173, "NoSoapOrWsSecurityEndpointAvailable");
            Strings.stringIDs.Add(3189440097, "ElementNotFound");
            Strings.stringIDs.Add(4223767916, "IndexIsOutOfRange");
            Strings.stringIDs.Add(869119007, "PropertyIsReadOnly");
            Strings.stringIDs.Add(2817837707, "AttachmentCreationFailed");
            Strings.stringIDs.Add(3133762315, "DayOfMonthMustBeBetween1And31");
            Strings.stringIDs.Add(2091738407, "ServiceRequestFailed");
            Strings.stringIDs.Add(129422921, "DelegateUserHasInvalidUserId");
            Strings.stringIDs.Add(1069581653, "SearchFilterComparisonValueTypeIsNotSupported");
            Strings.stringIDs.Add(4258284629, "ElementValueCannotBeSerialized");
            Strings.stringIDs.Add(2924950297, "PropertyValueMustBeSpecifiedForRecurrencePattern");
            Strings.stringIDs.Add(2436895661, "NonSummaryPropertyCannotBeUsed");
            Strings.stringIDs.Add(134310332, "HoldIdParameterIsNotSpecified");
            Strings.stringIDs.Add(21384399, "TransitionGroupNotFound");
            Strings.stringIDs.Add(4144876524, "ObjectTypeNotSupported");
            Strings.stringIDs.Add(3454211069, "InvalidTimeoutValue");
            Strings.stringIDs.Add(3339063014, "AutodiscoverRedirectBlocked");
            Strings.stringIDs.Add(3717641032, "PropertySetCannotBeModified");
            Strings.stringIDs.Add(3877446129, "DayOfTheWeekMustBeSpecifiedForRecurrencePattern");
            Strings.stringIDs.Add(3918321785, "ServiceObjectAlreadyHasId");
            Strings.stringIDs.Add(4274338115, "MethodIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(2727810523, "OperationNotSupportedForPropertyDefinitionType");
            Strings.stringIDs.Add(3934659801, "InvalidElementStringValue");
            Strings.stringIDs.Add(500353177, "CollectionIsEmpty");
            Strings.stringIDs.Add(885177846, "InvalidFrequencyValue");
            Strings.stringIDs.Add(546825189, "UnexpectedEndOfXmlDocument");
            Strings.stringIDs.Add(3578997681, "FolderTypeNotCompatible");
            Strings.stringIDs.Add(3451337077, "RequestIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(4148083232, "PropertyTypeIncompatibleWhenUpdatingCollection");
            Strings.stringIDs.Add(603284986, "ServerVersionNotSupported");
            Strings.stringIDs.Add(666454105, "DurationMustBeSpecifiedWhenScheduled");
            Strings.stringIDs.Add(1005127777, "NoError");
            Strings.stringIDs.Add(3972010693, "CannotUpdateNewUserConfiguration");
            Strings.stringIDs.Add(2438108153, "ObjectTypeIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(3604837092, "NullStringArrayElementInvalid");
            Strings.stringIDs.Add(333950754, "HttpsIsRequired");
            Strings.stringIDs.Add(2480357954, "MergedFreeBusyIntervalMustBeSmallerThanTimeWindow");
            Strings.stringIDs.Add(328519365, "SecondMustBeBetween0And59");
            Strings.stringIDs.Add(3596957401, "AtLeastOneAttachmentCouldNotBeDeleted");
            Strings.stringIDs.Add(1233804470, "IdAlreadyInList");
            Strings.stringIDs.Add(3295662635, "BothSearchFilterAndQueryStringCannotBeSpecified");
            Strings.stringIDs.Add(3383788511, "AdditionalPropertyIsNull");
            Strings.stringIDs.Add(2316486059, "InvalidEmailAddress");
            Strings.stringIDs.Add(1588497945, "MaximumRedirectionHopsExceeded");
            Strings.stringIDs.Add(3097538091, "AutodiscoverCouldNotBeLocated");
            Strings.stringIDs.Add(2715578908, "NoSubscriptionsOnConnection");
            Strings.stringIDs.Add(1063351272, "PermissionLevelInvalidForNonCalendarFolder");
            Strings.stringIDs.Add(2845550636, "InvalidAuthScheme");
            Strings.stringIDs.Add(311071154, "JsonDeserializationNotImplemented");
            Strings.stringIDs.Add(2743202310, "ValuePropertyNotLoaded");
            Strings.stringIDs.Add(843308875, "PropertyIncompatibleWithRequestVersion");
            Strings.stringIDs.Add(2437116628, "OffsetMustBeGreaterThanZero");
            Strings.stringIDs.Add(690508625, "CreateItemsDoesNotAllowAttachments");
            Strings.stringIDs.Add(2445370550, "PropertyDefinitionTypeMismatch");
            Strings.stringIDs.Add(2129318611, "IntervalMustBeGreaterOrEqualToOne");
            Strings.stringIDs.Add(961741172, "CannotSetPermissionLevelToCustom");
            Strings.stringIDs.Add(2921139860, "CannotAddRequestHeader");
            Strings.stringIDs.Add(4264880578, "ArrayMustHaveAtLeastOneElement");
            Strings.stringIDs.Add(567828041, "MonthMustBeSpecifiedForRecurrencePattern");
            Strings.stringIDs.Add(3869807514, "ValueOfTypeCannotBeConverted");
            Strings.stringIDs.Add(788051255, "ValueCannotBeConverted");
            Strings.stringIDs.Add(1481761255, "ServerErrorAndStackTraceDetails");
            Strings.stringIDs.Add(2586079185, "FolderPermissionLevelMustBeSet");
            Strings.stringIDs.Add(4003396996, "AutodiscoverError");
            Strings.stringIDs.Add(3066801652, "ArrayMustHaveSingleDimension");
            Strings.stringIDs.Add(2233059550, "InvalidPropertyValueNotInRange");
            Strings.stringIDs.Add(1453973661, "RegenerationPatternsOnlyValidForTasks");
            Strings.stringIDs.Add(914733855, "ItemAttachmentCannotBeUpdated");
            Strings.stringIDs.Add(1467147488, "EqualityComparisonFilterIsInvalid");
            Strings.stringIDs.Add(2950491364, "AutodiscoverServiceRequestRequiresDomainOrUrl");
            Strings.stringIDs.Add(3929050450, "InvalidUser");
            Strings.stringIDs.Add(2901788841, "AccountIsLocked");
            Strings.stringIDs.Add(2762661174, "InvalidDomainName");
            Strings.stringIDs.Add(710118117, "TooFewServiceReponsesReturned");
            Strings.stringIDs.Add(463464377, "CannotSubscribeToStatusEvents");
            Strings.stringIDs.Add(1066736932, "InvalidSortByPropertyForMailboxSearch");
            Strings.stringIDs.Add(2100812591, "UnexpectedElementType");
            Strings.stringIDs.Add(691200302, "ValueMustBeGreaterThanZero");
            Strings.stringIDs.Add(2292458752, "AttachmentCannotBeUpdated");
            Strings.stringIDs.Add(3912371609, "CreateItemsDoesNotHandleExistingItems");
            Strings.stringIDs.Add(2967125165, "MultipleContactPhotosInAttachment");
            Strings.stringIDs.Add(3387532664, "InvalidRecurrenceRange");
            Strings.stringIDs.Add(4210899574, "CannotSetBothImpersonatedAndPrivilegedUser");
            Strings.stringIDs.Add(1565629292, "NewMessagesWithAttachmentsCannotBeSentDirectly");
            Strings.stringIDs.Add(3633425214, "CannotCallDisconnectWithNoLiveConnection");
            Strings.stringIDs.Add(3940556486, "IdPropertyMustBeSet");
            Strings.stringIDs.Add(1562822901, "ValuePropertyNotAssigned");
            Strings.stringIDs.Add(4061174908, "ZeroLengthArrayInvalid");
            Strings.stringIDs.Add(3345946933, "HoldMailboxesParameterIsNotSpecified");
            Strings.stringIDs.Add(2270311116, "CannotSaveNotNewUserConfiguration");
            Strings.stringIDs.Add(2111195463, "ServiceObjectDoesNotHaveId");
            Strings.stringIDs.Add(491519754, "PropertyCollectionSizeMismatch");
            Strings.stringIDs.Add(2861470707, "XsDurationCouldNotBeParsed");
            Strings.stringIDs.Add(2279096081, "UnknownTimeZonePeriodTransitionType");
        };
        Strings.GetLocalizedString = function (key) {
            return new LocalizedString(Strings.stringIDs.get_Item(key), Strings.ResourceManager, new Array(0));
        };
        Strings.stringIDs = null;
        Strings.ResourceManager = null;
        return Strings;
    }());
    var Strings_IDs;
    (function (Strings_IDs) {
        Strings_IDs[Strings_IDs["CannotRemoveSubscriptionFromLiveConnection"] = 1631423810] = "CannotRemoveSubscriptionFromLiveConnection";
        Strings_IDs[Strings_IDs["ReadAccessInvalidForNonCalendarFolder"] = 3355844483] = "ReadAccessInvalidForNonCalendarFolder";
        Strings_IDs[Strings_IDs["PropertyDefinitionPropertyMustBeSet"] = 1413133863] = "PropertyDefinitionPropertyMustBeSet";
        Strings_IDs[Strings_IDs["ArgumentIsBlankString"] = 2808916828] = "ArgumentIsBlankString";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverDomainsCount"] = 2110564001] = "InvalidAutodiscoverDomainsCount";
        Strings_IDs[Strings_IDs["MinutesMustBeBetween0And1439"] = 3846446647] = "MinutesMustBeBetween0And1439";
        Strings_IDs[Strings_IDs["DeleteInvalidForUnsavedUserConfiguration"] = 3725066606] = "DeleteInvalidForUnsavedUserConfiguration";
        Strings_IDs[Strings_IDs["PeriodNotFound"] = 732877372] = "PeriodNotFound";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverSmtpAddress"] = 742945049] = "InvalidAutodiscoverSmtpAddress";
        Strings_IDs[Strings_IDs["InvalidOAuthToken"] = 2371807741] = "InvalidOAuthToken";
        Strings_IDs[Strings_IDs["MaxScpHopsExceeded"] = 540781291] = "MaxScpHopsExceeded";
        Strings_IDs[Strings_IDs["ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst"] = 412932664] = "ContactGroupMemberCannotBeUpdatedWithoutBeingLoadedFirst";
        Strings_IDs[Strings_IDs["CurrentPositionNotElementStart"] = 3932722495] = "CurrentPositionNotElementStart";
        Strings_IDs[Strings_IDs["CannotConvertBetweenTimeZones"] = 1762296216] = "CannotConvertBetweenTimeZones";
        Strings_IDs[Strings_IDs["FrequencyMustBeBetween1And1440"] = 2947629837] = "FrequencyMustBeBetween1And1440";
        Strings_IDs[Strings_IDs["CannotSetDelegateFolderPermissionLevelToCustom"] = 4255072555] = "CannotSetDelegateFolderPermissionLevelToCustom";
        Strings_IDs[Strings_IDs["PartnerTokenIncompatibleWithRequestVersion"] = 231532733] = "PartnerTokenIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverRequest"] = 216906786] = "InvalidAutodiscoverRequest";
        Strings_IDs[Strings_IDs["InvalidAsyncResult"] = 2795977038] = "InvalidAsyncResult";
        Strings_IDs[Strings_IDs["InvalidMailboxType"] = 1875536889] = "InvalidMailboxType";
        Strings_IDs[Strings_IDs["AttachmentCollectionNotLoaded"] = 368467777] = "AttachmentCollectionNotLoaded";
        Strings_IDs[Strings_IDs["ParameterIncompatibleWithRequestVersion"] = 1937216341] = "ParameterIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["DayOfWeekIndexMustBeSpecifiedForRecurrencePattern"] = 814325722] = "DayOfWeekIndexMustBeSpecifiedForRecurrencePattern";
        Strings_IDs[Strings_IDs["WLIDCredentialsCannotBeUsedWithLegacyAutodiscover"] = 365885070] = "WLIDCredentialsCannotBeUsedWithLegacyAutodiscover";
        Strings_IDs[Strings_IDs["PropertyCannotBeUpdated"] = 2534953608] = "PropertyCannotBeUpdated";
        Strings_IDs[Strings_IDs["IncompatibleTypeForArray"] = 3820761979] = "IncompatibleTypeForArray";
        Strings_IDs[Strings_IDs["PercentCompleteMustBeBetween0And100"] = 3936886128] = "PercentCompleteMustBeBetween0And100";
        Strings_IDs[Strings_IDs["AutodiscoverServiceIncompatibleWithRequestVersion"] = 460414997] = "AutodiscoverServiceIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverSmtpAddressesCount"] = 1774410042] = "InvalidAutodiscoverSmtpAddressesCount";
        Strings_IDs[Strings_IDs["ServiceUrlMustBeSet"] = 1922401890] = "ServiceUrlMustBeSet";
        Strings_IDs[Strings_IDs["ItemTypeNotCompatible"] = 4181025268] = "ItemTypeNotCompatible";
        Strings_IDs[Strings_IDs["AttachmentItemTypeMismatch"] = 1516841384] = "AttachmentItemTypeMismatch";
        Strings_IDs[Strings_IDs["UnsupportedWebProtocol"] = 3620572079] = "UnsupportedWebProtocol";
        Strings_IDs[Strings_IDs["EnumValueIncompatibleWithRequestVersion"] = 777131942] = "EnumValueIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["UnexpectedElement"] = 2080190431] = "UnexpectedElement";
        Strings_IDs[Strings_IDs["InvalidOrderBy"] = 162617974] = "InvalidOrderBy";
        Strings_IDs[Strings_IDs["NoAppropriateConstructorForItemClass"] = 3730786468] = "NoAppropriateConstructorForItemClass";
        Strings_IDs[Strings_IDs["SearchFilterAtIndexIsInvalid"] = 1334400254] = "SearchFilterAtIndexIsInvalid";
        Strings_IDs[Strings_IDs["DeletingThisObjectTypeNotAuthorized"] = 3957228737] = "DeletingThisObjectTypeNotAuthorized";
        Strings_IDs[Strings_IDs["PropertyCannotBeDeleted"] = 2011990502] = "PropertyCannotBeDeleted";
        Strings_IDs[Strings_IDs["ValuePropertyMustBeSet"] = 49538054] = "ValuePropertyMustBeSet";
        Strings_IDs[Strings_IDs["TagValueIsOutOfRange"] = 4177209255] = "TagValueIsOutOfRange";
        Strings_IDs[Strings_IDs["ItemToUpdateCannotBeNullOrNew"] = 893972063] = "ItemToUpdateCannotBeNullOrNew";
        Strings_IDs[Strings_IDs["SearchParametersRootFolderIdsEmpty"] = 2492696699] = "SearchParametersRootFolderIdsEmpty";
        Strings_IDs[Strings_IDs["MailboxQueriesParameterIsNotSpecified"] = 2182404464] = "MailboxQueriesParameterIsNotSpecified";
        Strings_IDs[Strings_IDs["FolderPermissionHasInvalidUserId"] = 3079787672] = "FolderPermissionHasInvalidUserId";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverDomain"] = 95137117] = "InvalidAutodiscoverDomain";
        Strings_IDs[Strings_IDs["MailboxesParameterIsNotSpecified"] = 1274908260] = "MailboxesParameterIsNotSpecified";
        Strings_IDs[Strings_IDs["ParentFolderDoesNotHaveId"] = 3207115397] = "ParentFolderDoesNotHaveId";
        Strings_IDs[Strings_IDs["DayOfMonthMustBeSpecifiedForRecurrencePattern"] = 190140884] = "DayOfMonthMustBeSpecifiedForRecurrencePattern";
        Strings_IDs[Strings_IDs["ClassIncompatibleWithRequestVersion"] = 886236812] = "ClassIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["CertificateHasNoPrivateKey"] = 956539910] = "CertificateHasNoPrivateKey";
        Strings_IDs[Strings_IDs["InvalidOrUnsupportedTimeZoneDefinition"] = 2660350763] = "InvalidOrUnsupportedTimeZoneDefinition";
        Strings_IDs[Strings_IDs["HourMustBeBetween0And23"] = 980862610] = "HourMustBeBetween0And23";
        Strings_IDs[Strings_IDs["TimeoutMustBeBetween1And1440"] = 1864811546] = "TimeoutMustBeBetween1And1440";
        Strings_IDs[Strings_IDs["CredentialsRequired"] = 107509017] = "CredentialsRequired";
        Strings_IDs[Strings_IDs["MustLoadOrAssignPropertyBeforeAccess"] = 1301287431] = "MustLoadOrAssignPropertyBeforeAccess";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverServiceResponse"] = 2421645987] = "InvalidAutodiscoverServiceResponse";
        Strings_IDs[Strings_IDs["CannotCallConnectDuringLiveConnection"] = 3637880390] = "CannotCallConnectDuringLiveConnection";
        Strings_IDs[Strings_IDs["ObjectDoesNotHaveId"] = 1990317298] = "ObjectDoesNotHaveId";
        Strings_IDs[Strings_IDs["CannotAddSubscriptionToLiveConnection"] = 2374077290] = "CannotAddSubscriptionToLiveConnection";
        Strings_IDs[Strings_IDs["MaxChangesMustBeBetween1And512"] = 3989266019] = "MaxChangesMustBeBetween1And512";
        Strings_IDs[Strings_IDs["AttributeValueCannotBeSerialized"] = 3745271395] = "AttributeValueCannotBeSerialized";
        Strings_IDs[Strings_IDs["SearchFilterMustBeSet"] = 2182989540] = "SearchFilterMustBeSet";
        Strings_IDs[Strings_IDs["EndDateMustBeGreaterThanStartDate"] = 2696927076] = "EndDateMustBeGreaterThanStartDate";
        Strings_IDs[Strings_IDs["InvalidDateTime"] = 3410810540] = "InvalidDateTime";
        Strings_IDs[Strings_IDs["UpdateItemsDoesNotAllowAttachments"] = 2505974152] = "UpdateItemsDoesNotAllowAttachments";
        Strings_IDs[Strings_IDs["TimeoutMustBeGreaterThanZero"] = 3210574608] = "TimeoutMustBeGreaterThanZero";
        Strings_IDs[Strings_IDs["AutodiscoverInvalidSettingForOutlookProvider"] = 81925120] = "AutodiscoverInvalidSettingForOutlookProvider";
        Strings_IDs[Strings_IDs["InvalidRedirectionResponseReturned"] = 706868687] = "InvalidRedirectionResponseReturned";
        Strings_IDs[Strings_IDs["ExpectedStartElement"] = 3728006586] = "ExpectedStartElement";
        Strings_IDs[Strings_IDs["DaysOfTheWeekNotSpecified"] = 2925351706] = "DaysOfTheWeekNotSpecified";
        Strings_IDs[Strings_IDs["FolderToUpdateCannotBeNullOrNew"] = 2887145506] = "FolderToUpdateCannotBeNullOrNew";
        Strings_IDs[Strings_IDs["PartnerTokenRequestRequiresUrl"] = 1709653493] = "PartnerTokenRequestRequiresUrl";
        Strings_IDs[Strings_IDs["NumberOfOccurrencesMustBeGreaterThanZero"] = 4020293177] = "NumberOfOccurrencesMustBeGreaterThanZero";
        Strings_IDs[Strings_IDs["JsonSerializationNotImplemented"] = 537341821] = "JsonSerializationNotImplemented";
        Strings_IDs[Strings_IDs["StartTimeZoneRequired"] = 263088904] = "StartTimeZoneRequired";
        Strings_IDs[Strings_IDs["PropertyAlreadyExistsInOrderByCollection"] = 2291792901] = "PropertyAlreadyExistsInOrderByCollection";
        Strings_IDs[Strings_IDs["ItemAttachmentMustBeNamed"] = 2209938519] = "ItemAttachmentMustBeNamed";
        Strings_IDs[Strings_IDs["InvalidAutodiscoverSettingsCount"] = 2688936715] = "InvalidAutodiscoverSettingsCount";
        Strings_IDs[Strings_IDs["LoadingThisObjectTypeNotSupported"] = 1313605428] = "LoadingThisObjectTypeNotSupported";
        Strings_IDs[Strings_IDs["UserIdForDelegateUserNotSpecified"] = 3460610998] = "UserIdForDelegateUserNotSpecified";
        Strings_IDs[Strings_IDs["PhoneCallAlreadyDisconnected"] = 2720737469] = "PhoneCallAlreadyDisconnected";
        Strings_IDs[Strings_IDs["OperationDoesNotSupportAttachments"] = 1464025756] = "OperationDoesNotSupportAttachments";
        Strings_IDs[Strings_IDs["UnsupportedTimeZonePeriodTransitionTarget"] = 98512741] = "UnsupportedTimeZonePeriodTransitionTarget";
        Strings_IDs[Strings_IDs["IEnumerableDoesNotContainThatManyObject"] = 474853648] = "IEnumerableDoesNotContainThatManyObject";
        Strings_IDs[Strings_IDs["UpdateItemsDoesNotSupportNewOrUnchangedItems"] = 953072612] = "UpdateItemsDoesNotSupportNewOrUnchangedItems";
        Strings_IDs[Strings_IDs["ValidationFailed"] = 1341796948] = "ValidationFailed";
        Strings_IDs[Strings_IDs["InvalidRecurrencePattern"] = 3636462697] = "InvalidRecurrencePattern";
        Strings_IDs[Strings_IDs["TimeWindowStartTimeMustBeGreaterThanEndTime"] = 4170253059] = "TimeWindowStartTimeMustBeGreaterThanEndTime";
        Strings_IDs[Strings_IDs["InvalidAttributeValue"] = 369811396] = "InvalidAttributeValue";
        Strings_IDs[Strings_IDs["FileAttachmentContentIsNotSet"] = 2449142619] = "FileAttachmentContentIsNotSet";
        Strings_IDs[Strings_IDs["AutodiscoverDidNotReturnEwsUrl"] = 628121484] = "AutodiscoverDidNotReturnEwsUrl";
        Strings_IDs[Strings_IDs["RecurrencePatternMustHaveStartDate"] = 423461609] = "RecurrencePatternMustHaveStartDate";
        Strings_IDs[Strings_IDs["OccurrenceIndexMustBeGreaterThanZero"] = 1396112272] = "OccurrenceIndexMustBeGreaterThanZero";
        Strings_IDs[Strings_IDs["ServiceResponseDoesNotContainXml"] = 1981959699] = "ServiceResponseDoesNotContainXml";
        Strings_IDs[Strings_IDs["ItemIsOutOfDate"] = 2560682386] = "ItemIsOutOfDate";
        Strings_IDs[Strings_IDs["MinuteMustBeBetween0And59"] = 3637133283] = "MinuteMustBeBetween0And59";
        Strings_IDs[Strings_IDs["NoSoapOrWsSecurityEndpointAvailable"] = 3954825173] = "NoSoapOrWsSecurityEndpointAvailable";
        Strings_IDs[Strings_IDs["ElementNotFound"] = 3189440097] = "ElementNotFound";
        Strings_IDs[Strings_IDs["IndexIsOutOfRange"] = 4223767916] = "IndexIsOutOfRange";
        Strings_IDs[Strings_IDs["PropertyIsReadOnly"] = 869119007] = "PropertyIsReadOnly";
        Strings_IDs[Strings_IDs["AttachmentCreationFailed"] = 2817837707] = "AttachmentCreationFailed";
        Strings_IDs[Strings_IDs["DayOfMonthMustBeBetween1And31"] = 3133762315] = "DayOfMonthMustBeBetween1And31";
        Strings_IDs[Strings_IDs["ServiceRequestFailed"] = 2091738407] = "ServiceRequestFailed";
        Strings_IDs[Strings_IDs["DelegateUserHasInvalidUserId"] = 129422921] = "DelegateUserHasInvalidUserId";
        Strings_IDs[Strings_IDs["SearchFilterComparisonValueTypeIsNotSupported"] = 1069581653] = "SearchFilterComparisonValueTypeIsNotSupported";
        Strings_IDs[Strings_IDs["ElementValueCannotBeSerialized"] = 4258284629] = "ElementValueCannotBeSerialized";
        Strings_IDs[Strings_IDs["PropertyValueMustBeSpecifiedForRecurrencePattern"] = 2924950297] = "PropertyValueMustBeSpecifiedForRecurrencePattern";
        Strings_IDs[Strings_IDs["NonSummaryPropertyCannotBeUsed"] = 2436895661] = "NonSummaryPropertyCannotBeUsed";
        Strings_IDs[Strings_IDs["HoldIdParameterIsNotSpecified"] = 134310332] = "HoldIdParameterIsNotSpecified";
        Strings_IDs[Strings_IDs["TransitionGroupNotFound"] = 21384399] = "TransitionGroupNotFound";
        Strings_IDs[Strings_IDs["ObjectTypeNotSupported"] = 4144876524] = "ObjectTypeNotSupported";
        Strings_IDs[Strings_IDs["InvalidTimeoutValue"] = 3454211069] = "InvalidTimeoutValue";
        Strings_IDs[Strings_IDs["AutodiscoverRedirectBlocked"] = 3339063014] = "AutodiscoverRedirectBlocked";
        Strings_IDs[Strings_IDs["PropertySetCannotBeModified"] = 3717641032] = "PropertySetCannotBeModified";
        Strings_IDs[Strings_IDs["DayOfTheWeekMustBeSpecifiedForRecurrencePattern"] = 3877446129] = "DayOfTheWeekMustBeSpecifiedForRecurrencePattern";
        Strings_IDs[Strings_IDs["ServiceObjectAlreadyHasId"] = 3918321785] = "ServiceObjectAlreadyHasId";
        Strings_IDs[Strings_IDs["MethodIncompatibleWithRequestVersion"] = 4274338115] = "MethodIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["OperationNotSupportedForPropertyDefinitionType"] = 2727810523] = "OperationNotSupportedForPropertyDefinitionType";
        Strings_IDs[Strings_IDs["InvalidElementStringValue"] = 3934659801] = "InvalidElementStringValue";
        Strings_IDs[Strings_IDs["CollectionIsEmpty"] = 500353177] = "CollectionIsEmpty";
        Strings_IDs[Strings_IDs["InvalidFrequencyValue"] = 885177846] = "InvalidFrequencyValue";
        Strings_IDs[Strings_IDs["UnexpectedEndOfXmlDocument"] = 546825189] = "UnexpectedEndOfXmlDocument";
        Strings_IDs[Strings_IDs["FolderTypeNotCompatible"] = 3578997681] = "FolderTypeNotCompatible";
        Strings_IDs[Strings_IDs["RequestIncompatibleWithRequestVersion"] = 3451337077] = "RequestIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["PropertyTypeIncompatibleWhenUpdatingCollection"] = 4148083232] = "PropertyTypeIncompatibleWhenUpdatingCollection";
        Strings_IDs[Strings_IDs["ServerVersionNotSupported"] = 603284986] = "ServerVersionNotSupported";
        Strings_IDs[Strings_IDs["DurationMustBeSpecifiedWhenScheduled"] = 666454105] = "DurationMustBeSpecifiedWhenScheduled";
        Strings_IDs[Strings_IDs["NoError"] = 1005127777] = "NoError";
        Strings_IDs[Strings_IDs["CannotUpdateNewUserConfiguration"] = 3972010693] = "CannotUpdateNewUserConfiguration";
        Strings_IDs[Strings_IDs["ObjectTypeIncompatibleWithRequestVersion"] = 2438108153] = "ObjectTypeIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["NullStringArrayElementInvalid"] = 3604837092] = "NullStringArrayElementInvalid";
        Strings_IDs[Strings_IDs["HttpsIsRequired"] = 333950754] = "HttpsIsRequired";
        Strings_IDs[Strings_IDs["MergedFreeBusyIntervalMustBeSmallerThanTimeWindow"] = 2480357954] = "MergedFreeBusyIntervalMustBeSmallerThanTimeWindow";
        Strings_IDs[Strings_IDs["SecondMustBeBetween0And59"] = 328519365] = "SecondMustBeBetween0And59";
        Strings_IDs[Strings_IDs["AtLeastOneAttachmentCouldNotBeDeleted"] = 3596957401] = "AtLeastOneAttachmentCouldNotBeDeleted";
        Strings_IDs[Strings_IDs["IdAlreadyInList"] = 1233804470] = "IdAlreadyInList";
        Strings_IDs[Strings_IDs["BothSearchFilterAndQueryStringCannotBeSpecified"] = 3295662635] = "BothSearchFilterAndQueryStringCannotBeSpecified";
        Strings_IDs[Strings_IDs["AdditionalPropertyIsNull"] = 3383788511] = "AdditionalPropertyIsNull";
        Strings_IDs[Strings_IDs["InvalidEmailAddress"] = 2316486059] = "InvalidEmailAddress";
        Strings_IDs[Strings_IDs["MaximumRedirectionHopsExceeded"] = 1588497945] = "MaximumRedirectionHopsExceeded";
        Strings_IDs[Strings_IDs["AutodiscoverCouldNotBeLocated"] = 3097538091] = "AutodiscoverCouldNotBeLocated";
        Strings_IDs[Strings_IDs["NoSubscriptionsOnConnection"] = 2715578908] = "NoSubscriptionsOnConnection";
        Strings_IDs[Strings_IDs["PermissionLevelInvalidForNonCalendarFolder"] = 1063351272] = "PermissionLevelInvalidForNonCalendarFolder";
        Strings_IDs[Strings_IDs["InvalidAuthScheme"] = 2845550636] = "InvalidAuthScheme";
        Strings_IDs[Strings_IDs["JsonDeserializationNotImplemented"] = 311071154] = "JsonDeserializationNotImplemented";
        Strings_IDs[Strings_IDs["ValuePropertyNotLoaded"] = 2743202310] = "ValuePropertyNotLoaded";
        Strings_IDs[Strings_IDs["PropertyIncompatibleWithRequestVersion"] = 843308875] = "PropertyIncompatibleWithRequestVersion";
        Strings_IDs[Strings_IDs["OffsetMustBeGreaterThanZero"] = 2437116628] = "OffsetMustBeGreaterThanZero";
        Strings_IDs[Strings_IDs["CreateItemsDoesNotAllowAttachments"] = 690508625] = "CreateItemsDoesNotAllowAttachments";
        Strings_IDs[Strings_IDs["PropertyDefinitionTypeMismatch"] = 2445370550] = "PropertyDefinitionTypeMismatch";
        Strings_IDs[Strings_IDs["IntervalMustBeGreaterOrEqualToOne"] = 2129318611] = "IntervalMustBeGreaterOrEqualToOne";
        Strings_IDs[Strings_IDs["CannotSetPermissionLevelToCustom"] = 961741172] = "CannotSetPermissionLevelToCustom";
        Strings_IDs[Strings_IDs["CannotAddRequestHeader"] = 2921139860] = "CannotAddRequestHeader";
        Strings_IDs[Strings_IDs["ArrayMustHaveAtLeastOneElement"] = 4264880578] = "ArrayMustHaveAtLeastOneElement";
        Strings_IDs[Strings_IDs["MonthMustBeSpecifiedForRecurrencePattern"] = 567828041] = "MonthMustBeSpecifiedForRecurrencePattern";
        Strings_IDs[Strings_IDs["ValueOfTypeCannotBeConverted"] = 3869807514] = "ValueOfTypeCannotBeConverted";
        Strings_IDs[Strings_IDs["ValueCannotBeConverted"] = 788051255] = "ValueCannotBeConverted";
        Strings_IDs[Strings_IDs["ServerErrorAndStackTraceDetails"] = 1481761255] = "ServerErrorAndStackTraceDetails";
        Strings_IDs[Strings_IDs["FolderPermissionLevelMustBeSet"] = 2586079185] = "FolderPermissionLevelMustBeSet";
        Strings_IDs[Strings_IDs["AutodiscoverError"] = 4003396996] = "AutodiscoverError";
        Strings_IDs[Strings_IDs["ArrayMustHaveSingleDimension"] = 3066801652] = "ArrayMustHaveSingleDimension";
        Strings_IDs[Strings_IDs["InvalidPropertyValueNotInRange"] = 2233059550] = "InvalidPropertyValueNotInRange";
        Strings_IDs[Strings_IDs["RegenerationPatternsOnlyValidForTasks"] = 1453973661] = "RegenerationPatternsOnlyValidForTasks";
        Strings_IDs[Strings_IDs["ItemAttachmentCannotBeUpdated"] = 914733855] = "ItemAttachmentCannotBeUpdated";
        Strings_IDs[Strings_IDs["EqualityComparisonFilterIsInvalid"] = 1467147488] = "EqualityComparisonFilterIsInvalid";
        Strings_IDs[Strings_IDs["AutodiscoverServiceRequestRequiresDomainOrUrl"] = 2950491364] = "AutodiscoverServiceRequestRequiresDomainOrUrl";
        Strings_IDs[Strings_IDs["InvalidUser"] = 3929050450] = "InvalidUser";
        Strings_IDs[Strings_IDs["AccountIsLocked"] = 2901788841] = "AccountIsLocked";
        Strings_IDs[Strings_IDs["InvalidDomainName"] = 2762661174] = "InvalidDomainName";
        Strings_IDs[Strings_IDs["TooFewServiceReponsesReturned"] = 710118117] = "TooFewServiceReponsesReturned";
        Strings_IDs[Strings_IDs["CannotSubscribeToStatusEvents"] = 463464377] = "CannotSubscribeToStatusEvents";
        Strings_IDs[Strings_IDs["InvalidSortByPropertyForMailboxSearch"] = 1066736932] = "InvalidSortByPropertyForMailboxSearch";
        Strings_IDs[Strings_IDs["UnexpectedElementType"] = 2100812591] = "UnexpectedElementType";
        Strings_IDs[Strings_IDs["ValueMustBeGreaterThanZero"] = 691200302] = "ValueMustBeGreaterThanZero";
        Strings_IDs[Strings_IDs["AttachmentCannotBeUpdated"] = 2292458752] = "AttachmentCannotBeUpdated";
        Strings_IDs[Strings_IDs["CreateItemsDoesNotHandleExistingItems"] = 3912371609] = "CreateItemsDoesNotHandleExistingItems";
        Strings_IDs[Strings_IDs["MultipleContactPhotosInAttachment"] = 2967125165] = "MultipleContactPhotosInAttachment";
        Strings_IDs[Strings_IDs["InvalidRecurrenceRange"] = 3387532664] = "InvalidRecurrenceRange";
        Strings_IDs[Strings_IDs["CannotSetBothImpersonatedAndPrivilegedUser"] = 4210899574] = "CannotSetBothImpersonatedAndPrivilegedUser";
        Strings_IDs[Strings_IDs["NewMessagesWithAttachmentsCannotBeSentDirectly"] = 1565629292] = "NewMessagesWithAttachmentsCannotBeSentDirectly";
        Strings_IDs[Strings_IDs["CannotCallDisconnectWithNoLiveConnection"] = 3633425214] = "CannotCallDisconnectWithNoLiveConnection";
        Strings_IDs[Strings_IDs["IdPropertyMustBeSet"] = 3940556486] = "IdPropertyMustBeSet";
        Strings_IDs[Strings_IDs["ValuePropertyNotAssigned"] = 1562822901] = "ValuePropertyNotAssigned";
        Strings_IDs[Strings_IDs["ZeroLengthArrayInvalid"] = 4061174908] = "ZeroLengthArrayInvalid";
        Strings_IDs[Strings_IDs["HoldMailboxesParameterIsNotSpecified"] = 3345946933] = "HoldMailboxesParameterIsNotSpecified";
        Strings_IDs[Strings_IDs["CannotSaveNotNewUserConfiguration"] = 2270311116] = "CannotSaveNotNewUserConfiguration";
        Strings_IDs[Strings_IDs["ServiceObjectDoesNotHaveId"] = 2111195463] = "ServiceObjectDoesNotHaveId";
        Strings_IDs[Strings_IDs["PropertyCollectionSizeMismatch"] = 491519754] = "PropertyCollectionSizeMismatch";
        Strings_IDs[Strings_IDs["XsDurationCouldNotBeParsed"] = 2861470707] = "XsDurationCouldNotBeParsed";
        Strings_IDs[Strings_IDs["UnknownTimeZonePeriodTransitionType"] = 2279096081] = "UnknownTimeZonePeriodTransitionType";
    })(Strings_IDs || (Strings_IDs = {}));
    var dsajdgajdgasjdgja = (function () {
        function dsajdgajdgasjdgja() {
        }
        return dsajdgajdgasjdgja;
    }());
})(exclusion || (exclusion = {}));
